Package: gdalraster
Title: Bindings to 'GDAL'
Version: 2.6.1
Authors@R: c(
    person("Chris", "Toney", email = "jctoney@gmail.com",
            role = c("aut", "cre"), comment = c(ORCID = "0000-0001-5734-6510")),
    person("Michael D.","Sumner", role = c("aut"), comment = c(ORCID = "0000-0002-2471-7511")),
    person("Pepijn", "de Vries", role = c("ctb"), comment = c(ORCID = "0000-0002-7961-6646")),
    person("Frank", "Warmerdam",
            role = c("ctb", "cph"), comment = "GDAL API/documentation"),
    person("Even", "Rouault",
            role = c("ctb", "cph"), comment = "GDAL API/documentation"),
    person("Marius", "Appel",
            role = c("ctb", "cph"), comment = "configure.ac based on https://github.com/appelmar/gdalcubes"),
    person("Daniel", "James",
            role = c("ctb", "cph"), comment = "Boost combine hashes method in src/cmb_table.h"),
    person("Peter", "Dimov",
            role = c("ctb", "cph"), comment = "Boost combine hashes method in src/cmb_table.h"))
Description: API bindings to the Geospatial Data Abstraction Library ('GDAL',
    <https://gdal.org>). Implements the 'GDAL' Raster and Vector Data Models.
    Bindings are implemented with 'Rcpp' modules. Exposed C++ classes and
    stand-alone functions wrap much of the 'GDAL' API and provide additional
    functionality. Calling signatures resemble the native C, C++ and Python APIs
    provided by the 'GDAL' project. Class 'GDALRaster' encapsulates a
    'GDALDataset' and its raster band objects. Class 'GDALVector' encapsulates
    an 'OGRLayer' and the 'GDALDataset' that contains it. Initial bindings are
    provided to the unified 'gdal' command line interface added in 'GDAL' 3.11.
    C++ stand-alone functions provide bindings to most 'GDAL' "traditional"
    raster and vector utilities, including 'OGR' facilities for vector
    geoprocessing, several algorithms, as well as the Geometry API ('GEOS' via
    'GDAL' headers), the Spatial Reference Systems API, and methods for
    coordinate transformation. Bindings to the Virtual Systems Interface ('VSI')
    API implement standard file system operations abstracted for URLs, cloud
    storage services, 'Zip'/'GZip'/'7z'/'RAR', in-memory files, as well as
    regular local file systems. This provides a single interface for operating
    on file system objects that works the same for any storage backend. A custom
    raster calculator evaluates a user-defined R expression on a layer or stack
    of layers, with pixel x/y available as variables in the expression. Raster
    'combine()' identifies and counts unique pixel combinations across multiple
    input layers, with optional raster output of the pixel-level combination
    IDs. Basic plotting capability is provided for raster and vector display.
    'gdalraster' leans toward minimalism and the use of simple, lightweight
    objects for holding raw data. Currently, only minimal S3 class interfaces
    have been implemented for selected R objects that contain spatial data.
    'gdalraster' may be useful in applications that need scalable, low-level
    I/O, or prefer a direct 'GDAL' API.
License: MIT + file LICENSE
Copyright: See file inst/COPYRIGHTS for details.
URL: https://firelab.github.io/gdalraster/,
        https://github.com/firelab/gdalraster
BugReports: https://github.com/firelab/gdalraster/issues
Depends: R (>= 4.2.0)
Imports: bit64, cli, graphics, grDevices, methods, nanoarrow, Rcpp (>=
        1.0.7), stats, tools, utils, wk, xml2, yyjsonr
LinkingTo: cli, nanoarrow, Rcpp, RcppInt64
Suggests: glue (>= 1.6.0), gt, knitr, ltc, rmarkdown, scales, testthat
        (>= 3.0.0), vctrs (>= 0.3.0)
NeedsCompilation: yes
SystemRequirements: C++17, GDAL (>= 3.1.0, built against GEOS)
Encoding: UTF-8
VignetteBuilder: knitr
Config/testthat/edition: 3
Config/roxygen2/version: 8.0.0
Packaged: 2026-05-16 00:40:47 UTC; ctoney
Author: Chris Toney [aut, cre] (ORCID: <https://orcid.org/0000-0001-5734-6510>),
  Michael D. Sumner [aut] (ORCID:
    <https://orcid.org/0000-0002-2471-7511>),
  Pepijn de Vries [ctb] (ORCID: <https://orcid.org/0000-0002-7961-6646>),
  Frank Warmerdam [ctb, cph] (GDAL API/documentation),
  Even Rouault [ctb, cph] (GDAL API/documentation),
  Marius Appel [ctb, cph] (configure.ac based on
    https://github.com/appelmar/gdalcubes),
  Daniel James [ctb, cph] (Boost combine hashes method in
    src/cmb_table.h),
  Peter Dimov [ctb, cph] (Boost combine hashes method in src/cmb_table.h)
Maintainer: Chris Toney <jctoney@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-16 11:50:02 UTC
Built: R 4.5.2; aarch64-apple-darwin20; 2026-05-16 12:21:58 UTC; unix
Archs: gdalraster.so.dSYM

Package: gdalraster
Title: Bindings to 'GDAL'
Version: 2.6.1
Authors@R: c(
    person("Chris", "Toney", email = "jctoney@gmail.com",
            role = c("aut", "cre"), comment = c(ORCID = "0000-0001-5734-6510")),
    person("Michael D.","Sumner", role = c("aut"), comment = c(ORCID = "0000-0002-2471-7511")),
    person("Pepijn", "de Vries", role = c("ctb"), comment = c(ORCID = "0000-0002-7961-6646")),
    person("Frank", "Warmerdam",
            role = c("ctb", "cph"), comment = "GDAL API/documentation"),
    person("Even", "Rouault",
            role = c("ctb", "cph"), comment = "GDAL API/documentation"),
    person("Marius", "Appel",
            role = c("ctb", "cph"), comment = "configure.ac based on https://github.com/appelmar/gdalcubes"),
    person("Daniel", "James",
            role = c("ctb", "cph"), comment = "Boost combine hashes method in src/cmb_table.h"),
    person("Peter", "Dimov",
            role = c("ctb", "cph"), comment = "Boost combine hashes method in src/cmb_table.h"))
Description: API bindings to the Geospatial Data Abstraction Library ('GDAL',
    <https://gdal.org>). Implements the 'GDAL' Raster and Vector Data Models.
    Bindings are implemented with 'Rcpp' modules. Exposed C++ classes and
    stand-alone functions wrap much of the 'GDAL' API and provide additional
    functionality. Calling signatures resemble the native C, C++ and Python APIs
    provided by the 'GDAL' project. Class 'GDALRaster' encapsulates a
    'GDALDataset' and its raster band objects. Class 'GDALVector' encapsulates
    an 'OGRLayer' and the 'GDALDataset' that contains it. Initial bindings are
    provided to the unified 'gdal' command line interface added in 'GDAL' 3.11.
    C++ stand-alone functions provide bindings to most 'GDAL' "traditional"
    raster and vector utilities, including 'OGR' facilities for vector
    geoprocessing, several algorithms, as well as the Geometry API ('GEOS' via
    'GDAL' headers), the Spatial Reference Systems API, and methods for
    coordinate transformation. Bindings to the Virtual Systems Interface ('VSI')
    API implement standard file system operations abstracted for URLs, cloud
    storage services, 'Zip'/'GZip'/'7z'/'RAR', in-memory files, as well as
    regular local file systems. This provides a single interface for operating
    on file system objects that works the same for any storage backend. A custom
    raster calculator evaluates a user-defined R expression on a layer or stack
    of layers, with pixel x/y available as variables in the expression. Raster
    'combine()' identifies and counts unique pixel combinations across multiple
    input layers, with optional raster output of the pixel-level combination
    IDs. Basic plotting capability is provided for raster and vector display.
    'gdalraster' leans toward minimalism and the use of simple, lightweight
    objects for holding raw data. Currently, only minimal S3 class interfaces
    have been implemented for selected R objects that contain spatial data.
    'gdalraster' may be useful in applications that need scalable, low-level
    I/O, or prefer a direct 'GDAL' API.
License: MIT + file LICENSE
Copyright: See file inst/COPYRIGHTS for details.
URL: https://firelab.github.io/gdalraster/,
        https://github.com/firelab/gdalraster
BugReports: https://github.com/firelab/gdalraster/issues
Depends: R (>= 4.2.0)
Imports: bit64, cli, graphics, grDevices, methods, nanoarrow, Rcpp (>=
        1.0.7), stats, tools, utils, wk, xml2, yyjsonr
LinkingTo: cli, nanoarrow, Rcpp, RcppInt64
Suggests: glue (>= 1.6.0), gt, knitr, ltc, rmarkdown, scales, testthat
        (>= 3.0.0), vctrs (>= 0.3.0)
NeedsCompilation: yes
SystemRequirements: C++17, GDAL (>= 3.1.0, built against GEOS)
Encoding: UTF-8
VignetteBuilder: knitr
Config/testthat/edition: 3
Config/roxygen2/version: 8.0.0
Packaged: 2026-05-16 00:40:47 UTC; ctoney
Author: Chris Toney [aut, cre] (ORCID: <https://orcid.org/0000-0001-5734-6510>),
  Michael D. Sumner [aut] (ORCID:
    <https://orcid.org/0000-0002-2471-7511>),
  Pepijn de Vries [ctb] (ORCID: <https://orcid.org/0000-0002-7961-6646>),
  Frank Warmerdam [ctb, cph] (GDAL API/documentation),
  Even Rouault [ctb, cph] (GDAL API/documentation),
  Marius Appel [ctb, cph] (configure.ac based on
    https://github.com/appelmar/gdalcubes),
  Daniel James [ctb, cph] (Boost combine hashes method in
    src/cmb_table.h),
  Peter Dimov [ctb, cph] (Boost combine hashes method in src/cmb_table.h)
Maintainer: Chris Toney <jctoney@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-16 11:50:02 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-05-16 14:32:58 UTC; unix
Archs: gdalraster.so.dSYM

useDynLib(gdalraster, .registration=TRUE)
import(bit64, graphics, methods, nanoarrow, Rcpp, wk, xml2)
importFrom("cli", "cli_progress_bar", "cli_progress_update", "cli_progress_done")
importFrom("grDevices", "as.raster", "colorRamp", "dev.capabilities", "gray", "rgb")
importFrom("stats", "quantile")
importFrom("tools", "file_path_sans_ext")
importFrom("utils", "file_test", "setTxtProgressBar", "txtProgressBar")
importFrom("yyjsonr", "read_json_str")
exportPattern("^[[:alpha:]]+")
S3method(plot, OGRFeature)
S3method(plot, OGRFeatureSet)
S3method(print, OGRFeature)
S3method(print, OGRFeatureSet)

<!-- README.md is generated from README.Rmd. Please edit that file -->

# gdalraster

<!-- badges: start -->

[![R-CMD-check](https://github.com/firelab/gdalraster/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/firelab/gdalraster/actions/workflows/R-CMD-check.yaml)
[![codecov](https://codecov.io/gh/ctoney/gdalraster/branch/main/graph/badge.svg?token=MXIOPZQ2IU)](https://app.codecov.io/gh/ctoney/gdalraster)
[![R-hub](https://github.com/firelab/gdalraster/actions/workflows/rhub.yaml/badge.svg)](https://github.com/firelab/gdalraster/actions/workflows/rhub.yaml)
[![CRAN
status](https://www.r-pkg.org/badges/version/gdalraster)](https://CRAN.R-project.org/package=gdalraster)
[![r-universe
status](https://firelab.r-universe.dev/badges/gdalraster)](https://firelab.r-universe.dev/gdalraster)
[![Conda
Version](https://img.shields.io/conda/vn/conda-forge/r-gdalraster)](https://anaconda.org/conda-forge/r-gdalraster)
[![OpenSSF Best
Practices](https://www.bestpractices.dev/projects/9382/badge)](https://www.bestpractices.dev/projects/9382)
[![OpenSSF
Scorecard](https://api.scorecard.dev/projects/github.com/firelab/gdalraster/badge)](https://scorecard.dev/viewer/?uri=github.com/firelab/gdalraster)
<!-- badges: end -->

## Overview

**gdalraster** is an R interface to the Raster and Vector
[APIs](https://gdal.org/en/stable/api/index.html) of the Geospatial Data
Abstraction Library ([GDAL](https://gdal.org/en/stable/)).

API bindings are implemented in the exposed C++ classes
[`GDALRaster`](https://firelab.github.io/gdalraster/reference/GDALRaster-class.html)
and
[`GDALVector`](https://firelab.github.io/gdalraster/reference/GDALVector-class.html),
along with several [stand-alone
functions](https://firelab.github.io/gdalraster/reference/index.html#stand-alone-functions).
Initial bindings are provided to the `gdal` command line interface (CLI)
algorithms added in GDAL 3.11. Bindings to the GDAL Virtual Systems
Interface ([VSI](https://gdal.org/en/stable/api/cpl.html#cpl-vsi-h)) are
also included to support file system operations on URLs, cloud storage
services, Zip/GZip/7z/RAR, and in-memory files, as well as regular file
systems. Calling signatures resemble the native C, C++ and Python APIs
provided by the GDAL project.

The package supports:

- [using GDAL’s new CLI
  algorithms](https://firelab.github.io/gdalraster/articles/use-gdal-cli-from-r.html)
  from R when built against GDAL \>= 3.11.3
- manual creation of uninitialized raster and vector datasets
- vector layer creation and schema management
- read/set parameters and metadata for raster bands and vector layers
- low-level I/O
- build/read/set color tables and raster attribute tables
- virtual raster (VRT) for virtual cropping, resampling, kernel
  filtering, mosaicing
- [raster
  utilities](https://firelab.github.io/gdalraster/reference/index.html#raster-utilities)
- GDAL multidimensional raster
  ([`mdim_as_classic()`](https://firelab.github.io/gdalraster/reference/mdim_as_classic.html),
  [`mdim_info()`](https://firelab.github.io/gdalraster/reference/mdim_info.html),
  [`mdim_translate()`](https://firelab.github.io/gdalraster/reference/mdim_translate.html))
- coordinate transformation
- spatial reference systems
- [geometry
  API](https://firelab.github.io/gdalraster/reference/index.html#geometry)
  operating on raw vectors of WKB or WKT strings
- [vector
  utilities](https://firelab.github.io/gdalraster/reference/index.html#vector-utilities)
- GDAL facilities for [vector
  geoprocessing](https://firelab.github.io/gdalraster/reference/ogr_proc.html)
- [dataset
  management](https://firelab.github.io/gdalraster/reference/index.html#general-data-management)
  (inspect/copy files/rename/delete)
- create/append to Seek-Optimized ZIP
  ([SOZip](https://github.com/sozip/sozip-spec))
- abstraction of [file system
  operations](https://firelab.github.io/gdalraster/reference/index.html#virtual-file-systems)
  on URLs, cloud storage, in-memory files, etc.
- Standard C binary file I/O through VSI (class
  [`VSIFile`](https://firelab.github.io/gdalraster/reference/VSIFile-class.html))

Additional functionality includes:

- class
  [`RunningStats`](https://firelab.github.io/gdalraster/reference/RunningStats-class.html)
  calculates mean and variance in one pass, and tracks the min, max,
  sum, and count (i.e., summary statistics on a data stream). The input
  data values are not stored in memory, so this class can be used to
  compute statistics for very large data streams.
- class
  [`CmbTable`](https://firelab.github.io/gdalraster/reference/CmbTable-class.html)
  identifies and counts unique combinations of integer values using a
  hash table.
- [`combine()`](https://firelab.github.io/gdalraster/reference/combine.html)
  overlays multiple rasters so that a unique ID is assigned to each
  unique combination of input values. Pixel counts for each unique
  combination are obtained, and combination IDs are optionally written
  to an output raster.
- [`calc()`](https://firelab.github.io/gdalraster/reference/calc.html)
  evaluates an R expression for each pixel in a raster layer or stack of
  layers. Individual pixel coordinates are available as variables in the
  R expression, as either x/y in the raster projected coordinate system
  or inverse projected longitude/latitude.
- plot raster data, vector layers and WKB/WKT geometries

**gdalraster** may be useful in applications that need scalable,
low-level I/O, or prefer a direct GDAL API. Comprehensive
[documentation](#documentation) is provided in the package and online.

## Installation

### From CRAN

Install the released version from CRAN with:

``` r
install.packages("gdalraster")
```

CRAN provides pre-compiled binary packages for Windows and macOS. These
do not require any separate installation of external libraries for GDAL.

### From conda-forge

[Conda-forge](https://github.com/conda-forge/r-gdalraster-feedstock)
provides pre-compiled binary packages that track CRAN releases, for the
following platforms:

[![Conda
Platforms](https://img.shields.io/conda/pn/conda-forge/r-gdalraster.svg)](https://anaconda.org/conda-forge/r-gdalraster)

To install **gdalraster** into a particular conda environment with
[conda](https://docs.conda.io/projects/conda/en/stable/), in the
activated environment:

    conda install --channel conda-forge r-gdalraster

### From R-universe

[R-universe](https://firelab.r-universe.dev/gdalraster) provides
pre-compiled binary packages for Windows and macOS that track the
development version of **gdalraster**. New packages are built usually
within ~1 hour of the most recent commit in branch `main`.

``` r
# Install the development version from r-universe
install.packages("gdalraster", repos = c("https://firelab.r-universe.dev", "https://cran.r-project.org"))
```

### From source code

#### Linux

GDAL \>= 3.1.0 built with GEOS is required, but a more recent version is
recommended.

On Ubuntu, recent versions of geospatial libraries can be installed from
the [ubuntugis-unstable
PPA](https://launchpad.net/~ubuntugis/+archive/ubuntu/ubuntugis-unstable)
with the following commands. Note that libxml2 is required for the R
package **xml2** which is a dependency, so we go ahead and install it
here as well:

    sudo add-apt-repository ppa:ubuntugis/ubuntugis-unstable
    sudo apt update
    sudo apt install libgdal-dev libgeos-dev libxml2-dev

The versions in ubuntugis-unstable generally work well and are more
up-to-date, but less recent versions in the [ubuntugis-stable
PPA](https://launchpad.net/~ubuntugis/+archive/ubuntu/ppa) could be used
instead.

Package **sf** provides helpful
[instructions](https://github.com/r-spatial/sf#linux) for installing the
geospatial libraries on other Linux distributions.

With the dependent libraries available on the system, install from CRAN:

``` r
install.packages("gdalraster")
```

Or install the development version from GitHub using package
[remotes](https://remotes.r-lib.org/):

``` r
remotes::install_github("firelab/gdalraster")
```

#### Windows

[RTools](https://cran.r-project.org/bin/windows/Rtools/) is needed to
install from source on Windows. RTools since version 4.2 includes GDAL
and all other dependent libraries that are needed to compile
**gdalraster**. Note that CRAN release periodic revisions to RTools that
often include updates to the libraries as new versions become available.
[Release
6768](https://cran.r-project.org/bin/windows/Rtools/rtools45/news.html)
of RTools 4.5 contains GDAL 3.12.1, GEOS 3.14.1 and PROJ 9.7.1.

With RTools installed:

``` r
# Install the development version from GitHub
remotes::install_github("firelab/gdalraster")
```

#### macOS

GDAL can be installed with Homebrew:

    brew install gdal

then

``` r
# Install the development version from GitHub
remotes::install_github("firelab/gdalraster")
```

It is not recommended to mix source installations and installation of
macOS binaries from CRAN. Consider installing the development version
from R-universe instead.

### Docker

See <https://github.com/hypertidy/gdal-r-ci> (thanks to Michael Sumner):

    docker pull ghcr.io/hypertidy/gdal-r-full:latest

## Documentation

- [Reference Manual](https://firelab.github.io/gdalraster/reference/)
- [Raster API
  Tutorial](https://firelab.github.io/gdalraster/articles/raster-api-tutorial.html)
- [Vector API
  Overview](https://firelab.github.io/gdalraster/articles/vector-api-overview.html)
- [Using `gdal` CLI algorithms from
  R](https://firelab.github.io/gdalraster/articles/use-gdal-cli-from-r.html)
- [Raster Attribute
  Tables](https://firelab.github.io/gdalraster/articles/raster-attribute-tables.html)
- [Raster
  Display](https://firelab.github.io/gdalraster/articles/raster-display.html)
- [GDAL Block
  Caching](https://firelab.github.io/gdalraster/articles/gdal-block-cache.html)
- [GDAL Config Quick
  Ref](https://firelab.github.io/gdalraster/articles/gdal-config-quick-ref.html)
- [Vector Read
  Benchmarks](https://firelab.github.io/gdalraster/articles/vector-read-benchmarks.html)

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

library(gdalraster)
gdal_3_6_0_min <- (gdal_version_num() >= gdal_compute_version(3, 6, 0))
gdal_3_7_0_min <- (gdal_version_num() >= gdal_compute_version(3, 7, 0))

## -----------------------------------------------------------------------------
library(gdalraster)

# get path to the Yellowstone National Park sample dataset
f <- system.file("extdata/ynp_features.zip", package = "gdalraster")

# add the VSI prefix 
(zf <- file.path("/vsizip", f))

# list files in the zip archive
vsi_read_dir(zf)

# VSI path to the GPKG file
(zf_gpkg <- file.path(zf, "ynp_features.gpkg"))

## ----include = FALSE----------------------------------------------------------
# workaround for GDAL < 3.11.4:
#   https://github.com/OSGeo/gdal/issues/12934
#   GPKG driver: fix random crash in GetNextArrowArrayAsynchronous()
ogr_arrow_opt <- get_config_option("OGR2OGR_USE_ARROW_API")
set_config_option("OGR2OGR_USE_ARROW_API", "NO")
gpkg_stream_base_opt <- get_config_option("OGR_GPKG_STREAM_BASE_IMPL")
set_config_option("OGR_GPKG_STREAM_BASE_IMPL", "YES")

## -----------------------------------------------------------------------------
if (gdal_version_num() >= gdal_compute_version(3, 7, 0)) {
  cat("SOZip metadata for ynp_features.gpkg:\n")
  vsi_get_file_metadata(zf_gpkg, domain = "ZIP") |> print()
} else {
  cat("SOZip support requires GDAL >= 3.7\n")
}

## -----------------------------------------------------------------------------
inspectDataset(zf_gpkg)

## -----------------------------------------------------------------------------
# test for existence of a vector data source with at least read access
ogr_ds_exists(zf_gpkg)
# note that update of an existing zipped .gpkg file is not supported
ogr_ds_exists(zf_gpkg, with_update = TRUE)

# list the vector layers
ogr_ds_layer_names(zf_gpkg)

## ----eval=gdal_3_7_0_min------------------------------------------------------
# list the layers in a data source
ogrinfo(zf_gpkg)

# detailed information about a specific layer
ogrinfo(zf_gpkg, "ynp_bnd", cl_arg = c("-geom=SUMMARY", "-wkt_format", "WKT2"))

## -----------------------------------------------------------------------------
# copy ynp_features.gpkg from the zip file to an in-memory file
mem_gpkg <- "/vsimem/tmp/ynp_features.gpkg"
ogr2ogr(zf_gpkg, mem_gpkg)

vsi_read_dir("/vsimem/tmp")

# confirm it's writable
ogr_ds_exists(mem_gpkg, with_update = TRUE)

rd_layer <- "roads"

# rename a layer (requires GDAL >= 3.5)
if (gdal_version_num() < gdal_compute_version(3, 5, 0)) {
  message("ogr_layer_rename() requires GDAL >= 3.5")
} else if (ogr_layer_test_cap(mem_gpkg, rd_layer)$Rename) {
  ogr_layer_rename(mem_gpkg, rd_layer, "roads2")
  rd_layer <- "roads2"
} else {
  message("layer does not have 'Rename' capability")
}

ogr_ds_layer_names(mem_gpkg)

# delete a layer
if (ogr_ds_test_cap(mem_gpkg)$DeleteLayer) {
  ogr_layer_delete(mem_gpkg, rd_layer)
} else {
  message("dataset does not have 'DeleteLayer' capability")
}

ogr_ds_layer_names(mem_gpkg)

# manage fields on a layer
ogr_layer_field_names(mem_gpkg, "points_of_interest")

# delete a field
if (ogr_layer_test_cap(mem_gpkg, "points_of_interest")$DeleteField) {
  ogr_field_delete(mem_gpkg, "points_of_interest", "createdate")
} else {
  message("layer does not have 'DeleteField' capability")
}

# rename fields
if (ogr_layer_test_cap(mem_gpkg, "points_of_interest")$AlterFieldDefn) {
  ogr_field_rename(mem_gpkg, "points_of_interest", "poiname", "poi_name")
  ogr_field_rename(mem_gpkg, "points_of_interest", "poitype", "poi_type")
} else {
  message("layer does not have 'AlterFieldDefn' capability")
}

## -----------------------------------------------------------------------------
# create a new field
if (ogr_layer_test_cap(mem_gpkg, "points_of_interest")$CreateField) {
  ogr_field_create(mem_gpkg, "points_of_interest",
                   fld_name = "is_geothermal",
                   fld_type = "OFTInteger",
                   fld_subtype = "OFSTBoolean")
} else {
  message("layer does not have 'CreateField' capability")
}

# edit data with SQL
sql <- "UPDATE points_of_interest SET is_geothermal = 
          CASE
            WHEN poi_type IN ('Basin', 'Geyser') THEN TRUE
            ELSE FALSE
          END"
ogr_execute_sql(mem_gpkg, sql)

ogr_layer_field_names(mem_gpkg, "points_of_interest")

## ----fig.alt = "A plot of the Yellowstone National Park (YNP) boundary in geographic coordinate system showing point locations of geothermal features. The YNP boundary polygon has background R color 'wheat'. The locations of geothermal features are solid circles with R color 'steelblue1. The x-axis label is 'longitude' and the y-axis label is 'latitude'. The plot title is 'YNP Geothermal Features."----
# read and display the geothermal features
sql <- "SELECT poi_name, geom
          FROM points_of_interest
            WHERE is_geothermal = TRUE"
(lyr <- ogr_execute_sql(mem_gpkg, sql))

lyr$getFeatureCount()

# retrieve all features in the result set (cf. DBI::dbFetch())
feat_set <- lyr$fetch(-1)
head(feat_set)

# plot the park boundary
# the layer contains a single polygon feature which is piped directly to plot()
GDALVector$new(mem_gpkg, "ynp_bnd")$getNextFeature() |>
  plot(col = "wheat", xlab = "longitude", ylab = "latitude",
       main = "YNP Geothermal Features")

plot(feat_set, pch = 19, col = "steelblue1", add = TRUE)

## -----------------------------------------------------------------------------
lyr$close()

# delete a data source
vsi_unlink(mem_gpkg)  # delete a single file
# or, deleteDataset(mem_gpkg)

## -----------------------------------------------------------------------------
f <- system.file("extdata/ynp_features.zip", package = "gdalraster")
ynp_dsn <- file.path("/vsizip", f, "ynp_features.gpkg")

# the park boundary layer containing a single feature
(bnd <- new(GDALVector, ynp_dsn, "ynp_bnd"))

bnd$getFeatureCount()

# spatial reference definition as WKT string
bnd$getSpatialRef()

# xmin, ymin, xmax, ymax
bnd$bbox()

# structure of the layer definition (a.k.a. feature class definition)
bnd$getLayerDefn() |> str()

## -----------------------------------------------------------------------------
bnd_feat <- bnd$getNextFeature()
str(bnd_feat)

# no more features
bnd$getNextFeature()

bnd$close()

## ----fig.alt = "A plot of the Yellowstone National Park (YNP) boundary in geographic coordinate system showing public roads as LineString features. The YNP boundary polygon has background R color 'wheat', and the road features are shown as double-width lines with R color 'slategray'. The x-axis label is 'longitude' and the y-axis label is 'latitude'. The plot title is 'YNP Public Roads'."----
# SQL layer for public roads
sql <- "SELECT rdname, opentopubl, geom FROM roads WHERE opentopubl = 'Yes'"
(roads <- new(GDALVector, ynp_dsn, sql))

roads$getFeatureCount()

roads$getFieldNames()

roads_featset <- roads$fetch(-1)
nrow(roads_featset)

head(roads_featset)

plot(bnd_feat, col = "wheat", xlab = "longitude", ylab = "latitude",
     main = "YNP Public Roads")

plot(roads_featset, col = "slategray", lwd = 2, add = TRUE)

roads$close()

## -----------------------------------------------------------------------------
poi <- new(GDALVector, ynp_dsn, "points_of_interest")

poi$getFeatureCount()

# read progressively in batches
batch_size <- 500
batch <- 0
while (TRUE) {
    poi_featset <- poi$fetch(batch_size)
    if (nrow(poi_featset) == 0) break
    cat("batch", batch <- batch + 1, ":", nrow(poi_featset), "features\n")
    # process batch
    # ...
}

poi$close()

## ----eval=gdal_3_6_0_min, warning=FALSE---------------------------------------
# Expose an ArrowArrayStream (requires GDAL >= 3.6)

# re-open the roads layer with the required argument for type of access
roads$open(read_only = TRUE)
roads$resetReading()

# does the layer have a specialized implementation
roads$testCapability()$FastGetArrowStream

# optionally set ArrowStream options as character vector of "NAME=VALUE", e.g.,
roads$arrowStreamOptions <- "INCLUDE_FID=NO"
# the default batch size of 65,536 could also be configured with
# MAX_FEATURES_IN_BATCH=num

(stream <- roads$getArrowStream())

# get the array schema if needed
schema <- stream$get_schema()

# optionally read by batch, NULL is returned when no more features are available
# batch <- stream$get_next()
# if (!is.null(batch))
#   d_batch <- as.data.frame(batch)

# or, pull all the batches into a data frame
d <- as.data.frame(stream)
nrow(d)
head(d)

# release the stream when finished
stream$release()

# 'geom' is a list column of WKB raw vectors which can be passed to the
# Geometry API functions
geom_utm <- g_transform(d$geom,
                        srs_from = roads$getSpatialRef(),
                        srs_to = "EPSG:26912")

# add a column with road lengths in meters
d$rdlength <- g_length(geom_utm)
head(d)

roads$close()

## ----fig.alt = "A plot of the Yellowstone National Park (YNP) boundary in a projected coordinate system showing the perimeter of the 2016 Maple Fire, along with three points of interest located within the fire polygon. The YNP boundary polygon has background R color 'wheat'. The Maple Fire perimeter is shown as a filled polygon in R color 'orangered'. The three points of interest are shown as filled square symbols in R color 'royalblue'. The x-axis label is 'x' and the y-axis label is 'y'. The plot is untitled."----
# MTBS fire perimeters in Yellowstone National Park 1984-2022
f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")

# copy to a temporary writable file
mtbs_dsn <- "/vsimem/tmp/ynp_fires_1984_2022.gpkg"
ogr2ogr(f, mtbs_dsn)

(fires <- new(GDALVector, mtbs_dsn, "mtbs_perims"))

srs_mtsp <- fires$getSpatialRef()  # Montana state plane metric definition

# reproject the boundary in ynp_features.gpkg to match the MTBS layer,
# returning a GDALVector object on the output layer by default
(bnd <- ogr_reproject(src_dsn = ynp_dsn, src_layer = "ynp_bnd",
                      out_dsn = mtbs_dsn, out_srs = srs_mtsp))

(bnd_feat <- bnd$getNextFeature())

bnd$close()

# reproject points_of_interest
poi <- ogr_reproject(ynp_dsn, "points_of_interest", mtbs_dsn, srs_mtsp)

# set an attribute filter to select the Maple Fire
fires$setAttributeFilter("incid_name = 'MAPLE'")
fires$getFeatureCount()

maple_fire <- fires$getNextFeature()

# use the fire polygon as a spatial filter for points_of_interest
# setSpatialFilter() expects WKT input, so convert the WKB geometry
g_wk2wk(maple_fire$geom) |> poi$setSpatialFilter()
poi$getFeatureCount()

poi$setSelectedFields(c("poiname", "poitype", "geom"))
(maple_pois <- poi$fetch(-1))

plot(bnd_feat, col = "wheat")
plot(maple_fire, col = "orangered", border = NA, add = TRUE)
plot(maple_pois, pch = 15, col = "royalblue", add = TRUE)

fires$close()
poi$close()

## ----fig.alt = "A plot of the Yellowstone National Park (YNP) boundary in a projected coordinate system showing the centroid of the park boundary polygon as a single point. The YNP boundary polygon has background R color 'wheat'. The centroid point is shown as an R 'circle plus' symbol, a circle with a plus sign inside resembling crosshairs. The x-axis label is 'x' and the y-axis label is 'y'. The plot is untitled."----
# create a feature object for the YNP centroid as a point of interest
(bnd_centroid_xy <- g_centroid(bnd_feat$geom))

feat <- list()
feat$poiname <- "YNP centroid"
feat$poitype <- "Information"
feat$createdate <- Sys.Date()
feat$editdate <- Sys.Date()
feat$geom <- g_create("POINT", bnd_centroid_xy)

# re-open the "points_of_interest" layer with update access
poi$open(read_only = FALSE)
poi$testCapability()$SequentialWrite

# create and write the new feature on the layer
poi$createFeature(feat)

# be sure pending writes are flushed
poi$syncToDisk()

# read back
fid <- poi$getLastWriteFID()
(ynp_centroid <- poi$getFeature(fid))

plot(bnd_feat, col = "wheat")
plot(ynp_centroid, pch = 10, cex = 1.5, add = TRUE)

## -----------------------------------------------------------------------------
# rewrite a feature in the "point_of_interest" layer updating the feature name
# verify the layer has random write capability
poi$testCapability()$RandomWrite

# FID 3809 is missing the trailhead name
(feat <- poi$getFeature(3809))

# update the name field and the date of the edit
feat$poiname <- "Ice Lake Trailhead"
feat$editdate <- Sys.Date()

# rewrite the feature
poi$setFeature(feat)
poi$syncToDisk()

(feat <- poi$getFeature(3809))

## -----------------------------------------------------------------------------
# delete the "YNP centroid" feature that was created above
# verify the layer has delete feature capability
poi$testCapability()$DeleteFeature

# the feature ID was obtained above as: fid <- poi$getLastWriteFID()
poi$getFeature(fid)

poi$deleteFeature(fid)
poi$syncToDisk()

poi$getFeature(fid)

poi$close()

## -----------------------------------------------------------------------------
# create a layer definition for random_points
# the spatial ref was obtained above as: srs_mtsp <- fires$getSpatialRef()
defn <- ogr_def_layer("POINT", srs = srs_mtsp)
defn$pt_desc <- ogr_def_field("OFTString")
defn$create_time <- ogr_def_field("OFTDateTime")

ogr_layer_create(mtbs_dsn, "random_points", layer_defn = defn)

lyr <- new(GDALVector, mtbs_dsn, "random_points", read_only = FALSE)

bb <- g_wk2wk(bnd_feat$geom) |> bbox_from_wkt()

## -----------------------------------------------------------------------------
batch_size <- as.integer(1e5)

# create a batch of features
rndX <- sample((bb[1] + 1):(bb[3] - 1), batch_size, replace = TRUE)
rndY <- sample((bb[2] + 1):(bb[4] - 1), batch_size, replace = TRUE)
pts <- cbind(rndX, rndY)
pts_geom <- g_create("POINT", pts)
d <- data.frame(pt_desc = rep("random points batch 1", batch_size),
                create_time = rep(Sys.time(), batch_size))
d$geom <- pts_geom

# write the batch (no transaction)
system.time(res <- lyr$batchCreateFeature(d))

(all(res))

lyr$syncToDisk()

## -----------------------------------------------------------------------------
rndX <- sample((bb[1] + 1):(bb[3] - 1), batch_size, replace = TRUE)
rndY <- sample((bb[2] + 1):(bb[4] - 1), batch_size, replace = TRUE)
pts <- cbind(rndX, rndY)
pts_geom <- g_create("POINT", pts)
d <- data.frame(pt_desc = rep("random points batch 2", batch_size),
                create_time = rep(Sys.time(), batch_size))
d$geom <- pts_geom

# write the batch using a transaction
system.time({
  lyr$startTransaction()
  res2 <- lyr$batchCreateFeature(d)
  if (all(res2))
    lyr$commitTransaction()
  else
    lyr$rollbackTransaction()
})

(all(res2))

# check the output data
d_out <- lyr$fetch(-1)
(nrow(d_out) == batch_size * 2)

head(d_out)

tail(d_out)

lyr$close()

## -----------------------------------------------------------------------------
# write the Maple Fire AOI bounding box as GeoJSON in EPSG 3857
json_file <- file.path(tempdir(), "maple_fire_aoi.geojson")

lyr <- ogr_ds_create("GeoJSON", json_file, layer = "maple_fire_aoi",
                     geom_type = "POLYGON", srs = "EPSG:3857",
                     fld_name = "id", fld_type = "OFTString",
                     overwrite = TRUE, return_obj = TRUE)

# The Maple Fire feature object and spatial reference were obtained above in
# the section on "Reproject vector layers".
# Here we extend the minimum bounding box by 500 m in each direction.
feat <- list()
feat$id <- "dataDownloadBox"
feat$geom <- g_transform(maple_fire$geom, srs_from = srs_mtsp,
                         srs_to = "EPSG:3857", as_wkb = FALSE) |>
               bbox_from_wkt(extend_x = 500, extend_y = 500) |>
               bbox_to_wkt()

lyr$createFeature(feat)

lyr$close()

readLines(json_file) |> writeLines()

## ----fig.alt = "A plot of the 1988 North Fork fire perimeter showing areas within the North Fork burn scar that have subsequently re-burned as of 2022. The North Fork fire is shown as an unfilled polygon with black outline. Areas within the North Fork polygon that have re-burned are shown as filled polygons in R color 'orangered'. The x-axis label is 'x' and the y-axis label is 'y'. The plot title is '1988 North Fork fire perimeter showing re-burned areas in red'."----
# layer filtered to fires after 1988
lyr1 <- new(GDALVector, mtbs_dsn, "mtbs_perims")
lyr1$setAttributeFilter("ig_year > 1988")
lyr1$getFeatureCount()

# second layer for the 1988 North Fork fire perimeter
sql <- "SELECT incid_name, ig_year, geom FROM mtbs_perims
        WHERE incid_name = 'NORTH FORK'"
lyr2 <- new(GDALVector, mtbs_dsn, sql)
lyr2$getFeatureCount()

north_fork_feat <- lyr2$getNextFeature()

# set mode options for the intersection
opt <- c("INPUT_PREFIX=layer1_",
         "METHOD_PREFIX=layer2_",
         "PROMOTE_TO_MULTI=YES")

# intersect to obtain areas re-burned since 2000
lyr_out <- ogr_proc(mode = "Intersection",
                    input_lyr = lyr1,
                    method_lyr = lyr2,
                    out_dsn = mtbs_dsn,
                    out_lyr_name = "north_fork_reburned",
                    out_geom_type = "MULTIPOLYGON",
                    mode_opt = opt)

# the output layer has attributes of both the input and method layers
(reburn_feat_set <- lyr_out$fetch(-1))

plot(north_fork_feat)
plot(reburn_feat_set, col = "orangered", border = NA, add = TRUE,
     main = "1988 North Fork fire perimeter showing re-burned areas in red")

# clean up
lyr1$close()
lyr2$close()
lyr_out$close()

## ----include = FALSE----------------------------------------------------------
# clean up
unlink(json_file)
vsi_unlink(mtbs_dsn)
vsi_rmdir("/vsimem/tmp/")
set_config_option("OGR2OGR_USE_ARROW_API", ogr_arrow_opt)
set_config_option("OGR_GPKG_STREAM_BASE_IMPL", gpkg_stream_base_opt)

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## -----------------------------------------------------------------------------
library(gdalraster)

# LANDFIRE Existing Vegetation Type (EVT)
evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")

# make a copy to modify
f <- paste0(tempdir(), "/", "storml_evt_tmp.tif")
file.copy(evt_file,  f)
ds <- new(GDALRaster, f, read_only=FALSE)
ds$getDefaultRAT(band=1)

# get the full attribute table for LANDFIRE EVT from its CSV file
evt_csv <- system.file("extdata/LF20_EVT_220.csv", package="gdalraster")
evt_df <- read.csv(evt_csv)
nrow(evt_df)
head(evt_df)

# keep just the R, G, B fields (0-255) and drop RED, GREEN, BLUE
evt_df <- evt_df[,1:7]

# build a RAT for the EVT raster, attaching additional columns from evt_df
tbl <- buildRAT(ds,
                table_type = "thematic",
                na_value = -9999,
                join_df = evt_df)

nrow(tbl)
head(tbl)

# attributes on the returned data frame and its columns define RAT metadata
attr(tbl, "GDALRATTableType")
attributes(tbl$VALUE)     # GFU_MinMax for column of discrete pixel values
attributes(tbl$COUNT)     # pixel counts
attributes(tbl$EVT_NAME)  # the class names
attributes(tbl$EVT_LF)    # ancillary attribute
attributes(tbl$EVT_PHYS)  # ancillary attribute
attributes(tbl$R)         # red 0-255
attributes(tbl$G)         # green 0-255
attributes(tbl$B)         # blue 0-255

# set as default RAT on the EVT raster
ds$setDefaultRAT(band=1, tbl)
ds$flushCache()

# it can now be read from the raster dataset
rm(tbl)
tbl <- ds$getDefaultRAT(band=1)
nrow(tbl)

## ----fig.width=6, fig.height=4, dev="png"-------------------------------------
bb <- ds$bbox()
#| fig.alt: >
#|   A plot of LANDFIRE Existing Vegetation Type (EVT) for an area of interest
#|   named Storm Lake which is used for several example datasets in package
#|   gdalraster. A color map has been to the pixels using color values provided
#|   by LANDFIRE in the CSV attribute table for the EVT layer.
plot_raster(data = ds,
            col_tbl = tbl[,c(1,6:8)],
            maxColorValue = 255,
            interpolate = FALSE,
            main = "Storm Lake LANDFIRE EVT")

## ----eval = requireNamespace("gt")--------------------------------------------
displayRAT(tbl, title = "Raster Attribute Table for Storm Lake EVT")

## -----------------------------------------------------------------------------
ds$close()

## ----echo=FALSE, fig.cap="LANDFIRE EVT in the Raster Attribute Table QGIS Plugin", out.width = '90%'----
knitr::include_graphics("qgis_rat_classify.png")

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## -----------------------------------------------------------------------------
library(gdalraster)

tcc_file <- system.file("extdata/storml_tcc.tif", package="gdalraster")
ds <- new(GDALRaster, tcc_file, read_only = TRUE)

## -----------------------------------------------------------------------------
ds
str(ds)

## -----------------------------------------------------------------------------
gt <- ds$getGeoTransform()
gt[1]  # x-coordinate of upper-left corner of the upper-left pixel
gt[2]  # pixel width (w-e resolution)
gt[3]  # 0 for north-up
gt[4]  # y-coordinate of upper-left corner of the upper-left pixel
gt[5]  # 0 for north-up
gt[6]  # pixel height (n-s resolution, negative value)

## -----------------------------------------------------------------------------
ds$bbox()  # xmin, ymin, xmax, ymax
ds$res()   # pixel width, pixel height as positive values

## -----------------------------------------------------------------------------
# GDAL format driver
ds$getDriverShortName()
ds$getDriverLongName()

# raster size in pixels, number of bands
ds$getRasterXSize()
ds$getRasterYSize()
ds$getRasterCount()
ds$dim()

# coordinate reference system as WKT string
ds$getProjectionRef()

# origin and pixel size from the geotransform
print(paste("Origin:", gt[1], gt[4]))
print(paste("Pixel size:", gt[2], gt[6]))

## -----------------------------------------------------------------------------
# block	size
ds$getBlockSize(band = 1)

# data type
ds$getDataTypeName(band = 1)

# nodata value
ds$getNoDataValue(band = 1)

# min, max, mean, sd of pixel values in the band
ds$getStatistics(band = 1, approx_ok = FALSE, force = TRUE)

# does this band have overviews? (aka "pyramids")
ds$getOverviewCount(band = 1)

# does this band have a color table?
col_tbl <- ds$getColorTable(band = 1)
if (!is.null(col_tbl))
  head(col_tbl)

## -----------------------------------------------------------------------------
# read the first row of pixel values
ncols <- ds$getRasterXSize()
rowdata <- ds$read(band = 1,
                   xoff = 0,
                   yoff = 0,
                   xsize = ncols,
                   ysize = 1,
                   out_xsize = ncols,
                   out_ysize = 1)

length(rowdata)
typeof(rowdata)
head(rowdata)

## ----fig.width=6, fig.height=4, dev="png"-------------------------------------
plot_raster(ds, legend = TRUE, main = "Storm Lake Tree Canopy Cover (%)")

## -----------------------------------------------------------------------------
# close the dataset for proper cleanup
ds$close()

## -----------------------------------------------------------------------------
lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
tif_file <- file.path(tempdir(), "storml_lndscp.tif")
ds <- createCopy(format = "GTiff",
                 dst_filename = tif_file,
                 src_filename = lcp_file,
                 options = "COMPRESS=LZW",
                 return_obj = TRUE)

# band = 0 for dataset-level metadata:
ds$getMetadata(band = 0, domain = "IMAGE_STRUCTURE")

# set nodata value for all bands
for (band in 1:ds$getRasterCount())
  ds$setNoDataValue(band, -9999)

# band 2 of an LCP file is slope degrees
ds$getStatistics(band = 2, approx_ok = FALSE, force = TRUE)
ds$close()

vsi_stat(lcp_file, "size")
vsi_stat(tif_file, "size")

## -----------------------------------------------------------------------------
getCreationOptions("GTiff", "COMPRESS")

getCreationOptions("GTiff", "SPARSE_OK")

## -----------------------------------------------------------------------------
new_file <- file.path(tempdir(), "newdata.tif")
ds <- create(format = "GTiff",
             dst_filename = new_file,
             xsize = 143,
             ysize = 107,
             nbands = 1, 
             dataType = "Int16",
             return_obj = TRUE)

## -----------------------------------------------------------------------------
# EPSG:26912 - NAD83 / UTM zone 12N
ds$setProjection(epsg_to_wkt(26912))

gt <- c(323476.1, 30, 0, 5105082.0, 0, -30)
ds$setGeoTransform(gt)

ds$setNoDataValue(band = 1, -9999)
ds$fillRaster(band = 1, -9999, 0)

# ...

# close the dataset when done
ds$close()

# R interface to GDALCreate() and GDALCreateCopy(), via the wrapper functions
# in src/gdal_exp.cpp.

#' Create a new uninitialized raster
#'
#' `create()` makes an empty raster in the specified format.
#'
#' @param format Character string giving a raster format short name
#' (e.g., `"GTiff"`).
#' @param dst_filename Character string giving the filename to create.
#' @param xsize Integer width of raster in pixels.
#' @param ysize Integer height of raster in pixels.
#' @param nbands Integer number of bands.
#' @param dataType Character string containing the data type name.
#' (e.g., common data types include Byte (or UInt8 in GDAL >=3.13), Int16,
#' UInt16, Int32, Float32).
#' @param options Optional list of format-specific creation options in a
#' character vector of `"NAME=VALUE"` pairs
#' (e.g., \code{options = c("COMPRESS=LZW")} to set LZW
#' compression during creation of a GTiff file).
#' The APPEND_SUBDATASET=YES option can be
#' specified to avoid prior destruction of existing dataset.
#' @param return_obj Logical scalar. If `TRUE`, an object of class
#' [`GDALRaster`][GDALRaster] opened on the newly created dataset will be
#' returned, otherwise returns a logical value. Defaults to `FALSE`.
#' @returns By default, returns a logical value indicating success (invisible
#' \code{TRUE}, output written to `dst_filename`). An error is raised if the
#' operation fails. An object of class [`GDALRaster`][GDALRaster] open on the
#' output dataset will be returned if `return_obj = TRUE`.
#' @note
#' `dst_filename` may be an empty string (`""`) with `format = "MEM"` and
#' `return_obj = TRUE` to create an In-memory Raster
#' (\url{https://gdal.org/en/stable/drivers/raster/mem.html}).
#' @seealso
#' [`GDALRaster-class`][GDALRaster], [createCopy()], [getCreationOptions()],
#' [rasterFromRaster()]
#' @examples
#' new_file <- file.path(tempdir(), "newdata.tif")
#' ds <- create(format = "GTiff",
#'              dst_filename = new_file,
#'              xsize = 143,
#'              ysize = 107,
#'              nbands = 1,
#'              dataType = "Int16",
#'              return_obj = TRUE)
#'
#' # EPSG:26912 - NAD83 / UTM zone 12N
#' ds$setProjection(epsg_to_wkt(26912))
#'
#' gt <- c(323476, 30, 0, 5105082, 0, -30)
#' ds$setGeoTransform(gt)
#'
#' ds$setNoDataValue(band = 1, -9999)
#' ds$fillRaster(band = 1, -9999, 0)
#'
#' # ...
#'
#' # close the dataset when done
#' ds$close()
#' \dontshow{deleteDataset(new_file)}
#' @export
create <- function(format, dst_filename, xsize, ysize, nbands, dataType,
                   options = NULL, return_obj = FALSE) {

    if (missing(format) || is.null(format) || all(is.na(format)))
        stop("'format' is required", call. = FALSE)
    if (!(is.character(format) && length(format) == 1))
        stop("'format' must be a character string", call. = FALSE)

    if (missing(dst_filename) || is.null(dst_filename) ||
        all(is.na(dst_filename))) {

        stop("'dst_filename' is required", call. = FALSE)
    }
    if (!(is.character(dst_filename) && length(dst_filename) == 1))
        stop("'dst_filename' must be a character string", call. = FALSE)

    if (missing(xsize) || is.null(xsize) || all(is.na(xsize)))
        stop("'xsize' is required", call. = FALSE)
    if (!(is.numeric(xsize) && length(xsize) == 1))
        stop("'xsize' must be numeric", call. = FALSE)

    if (missing(ysize) || is.null(ysize) || all(is.na(ysize)))
        stop("'ysize' is required", call. = FALSE)
    if (!(is.numeric(ysize) && length(ysize) == 1))
        stop("'ysize' must be numeric", call. = FALSE)

    if (missing(dataType) || is.null(dataType) || all(is.na(dataType)))
        stop("'dataType' is required", call. = FALSE)
    if (!(is.character(dataType) && length(dataType) == 1))
        stop("'dataType' must be a character string", call. = FALSE)

    if (!is.null(options) && !is.character(options))
        stop("'options' must be a character vector or NULL", call. = FALSE)

    if (is.null(return_obj) || is.na(return_obj))
        stop("'return_obj' must be TRUE or FALSE", call. = FALSE)

    if (!is.logical(return_obj) || length(return_obj) > 1)
        stop("'return_obj' must be a logical value", call. = FALSE)

    # signature for create() object factory
    ds <- new(GDALRaster, format, dst_filename, xsize, ysize, nbands, dataType,
              options)

    if (return_obj) {
        return(ds)
    } else {
        ds$close()
        return(TRUE)
    }
}


#' Create a copy of a raster
#'
#' `createCopy()` copies a raster dataset, optionally changing the format.
#' The extent, cell size, number of bands, data type, projection, and
#' geotransform are all copied from the source raster.
#'
#' @param format Character string giving the format short name for the
#' output raster (e.g., `"GTiff"`).
#' @param dst_filename Character string giving the filename to create.
#' @param src_filename Either a character string giving the filename of the
#' source raster, or object of class `GDALRaster` for the source.
#' @param strict Logical. `TRUE` if the copy must be strictly equivalent,
#' or more normally `FALSE` (the default) indicating that the copy may adapt
#' as needed for the output format.
#' @param options Optional list of format-specific creation options in a
#' vector of `"NAME=VALUE"` pairs
#' (e.g., \code{options = c("COMPRESS=LZW")} to set \code{LZW}
#' compression during creation of a GTiff file).
#' The APPEND_SUBDATASET=YES option can be
#' specified to avoid prior destruction of existing dataset.
#' @param quiet Logical scalar. If `TRUE`, a progress bar will be not be
#' displayed. Defaults to `FALSE`.
#' @param return_obj Logical scalar. If `TRUE`, an object of class
#' [`GDALRaster`][GDALRaster] opened on the newly created dataset will be
#' returned. Defaults to `FALSE`.
#' @returns By default, returns a logical value indicating success (invisible
#' \code{TRUE}, output written to `dst_filename`). An error is raised if the
#' operation fails. An object of class [`GDALRaster`][GDALRaster] open on the
#' output dataset will be returned if `return_obj = TRUE`.
#' @note
#' `dst_filename` may be an empty string (`""`) with `format = "MEM"` and
#' `return_obj = TRUE` to create an In-memory Raster
#' (\url{https://gdal.org/en/stable/drivers/raster/mem.html}).
#' @seealso
#' [`GDALRaster-class`][GDALRaster], [create()], [getCreationOptions()],
#' [rasterFromRaster()], [translate()]
#' @examples
#' lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
#' tif_file <- file.path(tempdir(), "storml_lndscp.tif")
#' ds <- createCopy(format = "GTiff",
#'                  dst_filename = tif_file,
#'                  src_filename = lcp_file,
#'                  options = "COMPRESS=LZW",
#'                  return_obj = TRUE)
#'
#' ds$getMetadata(band = 0, domain = "IMAGE_STRUCTURE")
#'
#' for (band in 1:ds$getRasterCount())
#'     ds$setNoDataValue(band, -9999)
#' ds$getStatistics(band = 1, approx_ok = FALSE, force = TRUE)
#'
#' ds$close()
#' \dontshow{deleteDataset(tif_file)}
#' @export
createCopy <- function(format, dst_filename, src_filename, strict = FALSE,
                       options = NULL, quiet = FALSE, return_obj = FALSE) {

    if (missing(format) || is.null(format) || all(is.na(format)))
        stop("'format' is required", call. = FALSE)
    if (!(is.character(format) && length(format) == 1))
        stop("'format' must be a character string", call. = FALSE)

    if (missing(dst_filename) || is.null(dst_filename) ||
        all(is.na(dst_filename))) {

        stop("'dst_filename' is required", call. = FALSE)
    }
    if (!(is.character(dst_filename) && length(dst_filename) == 1))
        stop("'dst_filename' must be a character string", call. = FALSE)

    if (missing(src_filename) || is.null(src_filename))
        stop("'src_filename' is required", call. = FALSE)
    if (!(is.character(src_filename) && length(src_filename) == 1 &&
          any(is.na(src_filename)) == FALSE) &&
        !is(src_filename, "Rcpp_GDALRaster")) {

        stop("'src_filename' must be a character string or GDALRaster object",
             call. = FALSE)
    }

    src_ds <- NULL
    if (is(src_filename, "Rcpp_GDALRaster")) {
        src_ds <- src_filename
        if (!src_ds$isOpen())
            stop("source dataset is not open", call. = FALSE)
    } else if (is.character(src_filename) && length(src_filename) == 1) {
        src_ds <- new(GDALRaster, src_filename)
    } else {
        stop("'src_filename' must be a character string or 'GDALRaster' object",
             call. = FALSE)
    }

    if (is.null(strict) || is.na(strict))
        stop("'strict' must be TRUE or FALSE", call. = FALSE)

    if (!is.logical(strict) || length(strict) > 1)
        stop("'strict' must be a logical value", call. = FALSE)

    if (!is.null(options) && !is.character(options))
        stop("'options' must be a character vector or NULL", call. = FALSE)

    if (is.null(quiet) || is.na(quiet))
        stop("'quiet' must be TRUE or FALSE", call. = FALSE)

    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a logical value", call. = FALSE)

    if (is.null(return_obj) || is.na(return_obj))
        stop("'return_obj' must be TRUE or FALSE", call. = FALSE)

    if (!is.logical(return_obj) || length(return_obj) > 1)
        stop("'return_obj' must be a logical value", call. = FALSE)

    # signature for createCopy() object factory
    ds <- new(GDALRaster, format, dst_filename, src_ds, strict, options, quiet)

    if (return_obj) {
        return(ds)
    } else {
        ds$close()
        return(TRUE)
    }
}

# test the R interface to GDALCreate() and GDALCreateCopy() via the wrapper
# functions in src/gdal_exp.cpp, with tests also in test-gdal_exp.R

test_that("create and createCopy R public interface works", {

    ## createCopy
    f <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    f2 <- paste0(tempdir(), "/", "storml_elev2.tif")

    ds <- new(GDALRaster, f)
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])

    expect_no_error(ds2 <- createCopy(format = "GTiff",
                                      dst_filename = f2,
                                      src_filename = ds,
                                      return_obj = TRUE))

    expect_true(is(ds2, "Rcpp_GDALRaster"))
    dm2 <- ds2$dim()
    chk2 <- ds2$getChecksum(1, 0, 0, dm2[1], dm2[2])

    expect_equal(dm, dm2)

    ds$close()
    ds2$close()
    expect_true(deleteDataset(f2))

    # errors
    expect_error(createCopy(format = NULL,
                            dst_filename = f2,
                            src_filename = f))

    expect_error(createCopy(format = "GTiff",
                            dst_filename = NULL,
                            src_filename = f))

    expect_error(createCopy(format = "GTiff",
                            dst_filename = f2,
                            src_filename = NULL))

    expect_error(createCopy(format = "GTiff",
                            dst_filename = f2,
                            src_filename = f,
                            strict = NA))

    expect_error(createCopy(format = "GTiff",
                            dst_filename = f2,
                            src_filename = f,
                            options = NA))

    expect_error(createCopy(format = "GTiff",
                            dst_filename = f2,
                            src_filename = f,
                            quiet = NULL))

    expect_error(createCopy(format = "GTiff",
                            dst_filename = f2,
                            src_filename = ds),
                 regexp = "source dataset is not open",
                 fixed = TRUE)

    expect_error(createCopy(format = "GTiff",
                            dst_filename = f2,
                            src_filename = NULL),
                 regexp = "'src_filename' is required",
                 fixed = TRUE)

    expect_error(createCopy(format = "GTiff",
                            dst_filename = f2,
                            src_filename = f,
                            return_obj = NULL),
                 regexp = "'return_obj' must be TRUE or FALSE",
                 fixed = TRUE)

    expect_error(createCopy(format = "GTiff",
                            dst_filename = f2,
                            src_filename = f,
                            return_obj = NA),
                 regexp = "'return_obj' must be TRUE or FALSE",
                 fixed = TRUE)

    expect_error(createCopy(format = "GTiff",
                            dst_filename = f2,
                            src_filename = f,
                            return_obj = "TRUE"),
                 regexp = "'return_obj' must be a logical value",
                 fixed = TRUE)


    ## create
    f3 <- tempfile(fileext = ".tif")
    expect_no_error(ds3 <- create(format = "GTiff", dst_filename = f3,
                                  xsize = 10, ysize = 10, nbands = 1,
                                  dataType = "Int32", return_obj = TRUE))

    ds3$close()
    deleteDataset(f3)

    # errors
    expect_error(create(format = NULL, dst_filename = f3,
                        xsize = 10, ysize = 10, nbands = 1,
                        dataType = "Int32"))

    expect_error(create(format = "GTiff", dst_filename = NULL,
                        xsize = 10, ysize = 10, nbands = 1,
                        dataType = "Int32"))

    expect_error(create(format = "GTiff", dst_filename = f3,
                        xsize = NULL, ysize = 10, nbands = 1,
                        dataType = "Int32"))

    expect_error(create(format = "GTiff", dst_filename = f3,
                        xsize = 10, ysize = NULL, nbands = 1,
                        dataType = "Int32"))

    expect_error(create(format = "GTiff", dst_filename = f3,
                        xsize = 10, ysize = 10, nbands = NULL,
                        dataType = "Int32"))

    expect_error(create(format = "GTiff", dst_filename = f3,
                        xsize = 10, ysize = 10, nbands = 1,
                        dataType = NULL))

    expect_error(create(format = "GTiff", dst_filename = f3,
                        xsize = 10, ysize = 10, nbands = 1,
                        dataType = "Int32", options = NA))

    expect_error(create(format = "GTiff", dst_filename = f3,
                        xsize = 10, ysize = 10, nbands = 1,
                        dataType = "Int32", return_obj = NULL),
                 regexp = "'return_obj' must be TRUE or FALSE",
                 fixed = TRUE)

    expect_error(create(format = "GTiff", dst_filename = f3,
                        xsize = 10, ysize = 10, nbands = 1,
                        dataType = "Int32", return_obj = NA),
                 regexp = "'return_obj' must be TRUE or FALSE",
                 fixed = TRUE)

    expect_error(create(format = "GTiff", dst_filename = f3,
                        xsize = 10, ysize = 10, nbands = 1,
                        dataType = "Int32", return_obj = "TRUE"),
                 regexp = "'return_obj' must be a logical value",
                 fixed = TRUE)
})

#' @name GDALRaster-class
#'
#' @aliases
#' Rcpp_GDALRaster Rcpp_GDALRaster-class GDALRaster
#'
#' @title Class encapsulating a raster dataset and associated band objects
#'
#' @description
#' `GDALRaster` provides an interface for accessing a raster dataset via GDAL
#' and calling methods on the underlying `GDALDataset`, `GDALDriver` and
#' `GDALRasterBand` objects. See \url{https://gdal.org/en/stable/api/index.html}
#' for details of the GDAL Raster API.
#'
#' `GDALRaster` is a C++ class exposed directly to \R (via
#' `RCPP_EXPOSED_CLASS`). Fields and methods of the class are accessed using
#' the `$` operator. **Note that all arguments to class methods are required
#' and must be given in the order documented.** Naming the arguments is
#' optional but may be preferred for readability.
#'
#' @param filename Character string containing the file name of a raster
#' dataset to open, as full path or relative to the current working directory.
#' In some cases, `filename` may not refer to a local file system, but instead
#' contain format-specific information on how to access a dataset such
#' as database connection string, URL, /vsiPREFIX/, etc. (see GDAL
#' raster format descriptions:
#' \url{https://gdal.org/en/stable/drivers/raster/index.html}).
#' @param read_only Logical. `TRUE` to open the dataset read-only (the default),
#' or `FALSE` to open with write access.
#' @param open_options Optional character vector of `NAME=VALUE` pairs
#' specifying dataset open options.
#' @param shared Logical. `FALSE` to open the dataset without using shared
#' mode. Default is `TRUE` (see Note).
#' @param allowed_drivers Optional character vector of driver short names that
#' must be considered. By default, all known raster drivers are considered.
#' @returns An object of class `GDALRaster`, which contains a pointer to the
#' opened dataset.
#' Class methods that operate on the dataset are described in Details, along
#' with a set of writable fields for per-object settings. Values may be
#' assigned to the class fields as needed during the lifetime of the object
#' (i.e., by regular \code{<-} or \code{=} assignment).
#'
#' @section Usage (see Details):
#' ```
#' ## Constructors
#' # read-only by default:
#' ds <- new(GDALRaster, filename)
#' # for update access:
#' ds <- new(GDALRaster, filename, read_only = FALSE)
#' # to specify dataset open options:
#' ds <- new(GDALRaster, filename, read_only = TRUE|FALSE, open_options)
#' # to open without using shared mode:
#' new(GDALRaster, filename, read_only, open_options, shared = FALSE)
#' # to specify certain allowed driver(s):
#' new(GDALRaster, filename, read_only, open_options, shared, allowed_drivers)
#'
#' ## Read/write fields (per-object settings)
#' ds$infoOptions
#' ds$quiet
#' ds$readByteAsRaw
#'
#' ## Methods
#' ds$getFilename()
#' ds$setFilename(filename)
#' ds$open(read_only)
#' ds$isOpen()
#' ds$isReadOnly()
#' ds$getFileList()
#'
#' ds$info()
#' ds$infoAsJSON()
#'
#' ds$getDriverShortName()
#' ds$getDriverLongName()
#'
#' ds$getRasterXSize()
#' ds$getRasterYSize()
#' ds$getRasterCount()
#'
#' ds$addBand(dataType, options)
#'
#' ds$getGeoTransform()
#' ds$setGeoTransform(transform)
#'
#' ds$getProjection()
#' ds$getProjectionRef()
#' ds$getSpatialRef()
#' ds$setProjection(projection)
#'
#' ds$bbox()
#' ds$res()
#' ds$dim()
#' ds$setBbox(bbox)
#'
#' ds$apply_geotransform(col_row)
#' ds$get_pixel_line(xy)
#'
#' ds$get_block_indexing(band)
#' ds$make_chunk_index(band, max_pixels)
#'
#' ds$getDescription(band)
#' ds$setDescription(band, desc)
#' ds$getBlockSize(band)
#' ds$getActualBlockSize(band, xblockoff, yblockoff)
#' ds$getOverviewCount(band)
#' ds$buildOverviews(resampling, levels, bands)
#' ds$getDataTypeName(band)
#' ds$getNoDataValue(band)
#' ds$setNoDataValue(band, nodata_value)
#' ds$deleteNoDataValue(band)
#' ds$getMaskFlags(band)
#' ds$getMaskBand(band)
#' ds$getUnitType(band)
#' ds$setUnitType(band, unit_type)
#' ds$getScale(band)
#' ds$setScale(band, scale)
#' ds$getOffset(band)
#' ds$setOffset(band, offset)
#' ds$getRasterColorInterp(band)
#' ds$setRasterColorInterp(band, col_interp)
#'
#' ds$getMinMax(band, approx_ok)
#' ds$getMinMaxLocation(band)
#' ds$getStatistics(band, approx_ok, force)
#' ds$clearStatistics()
#'
#' ds$getHistogram(band, min, max, num_buckets, incl_out_of_range, approx_ok)
#' ds$getDefaultHistogram(band, force)
#'
#' ds$getInterBandCovMatrix(bands, approx_ok, force, write_in_metadata,
#'                          df_correction)
#'
#' ds$getMetadata(band, domain)
#' ds$setMetadata(band, metadata, domain)
#' ds$getMetadataItem(band, mdi_name, domain)
#' ds$setMetadataItem(band, mdi_name, mdi_value, domain)
#' ds$getMetadataDomainList(band)
#'
#' ds$read(band, xoff, yoff, xsize, ysize, out_xsize, out_ysize)
#' ds$readBlock(band, xblockoff, yblockoff)
#' ds$readChunk(band, chunk_def)
#' ds$readToNativeRaster(xoff, yoff, xsize, ysize, out_xsize, out_ysize)
#'
#' ds$write(band, xoff, yoff, xsize, ysize, rasterData)
#' ds$writeBlock(band, xblockoff, yblockoff, rasterData)
#' ds$writeChunk(band, chunk_def, rasterData)
#' ds$fillRaster(band, value, ivalue)
#'
#' ds$getColorTable(band)
#' ds$getPaletteInterp(band)
#' ds$setColorTable(band, col_tbl, palette_interp)
#' ds$clearColorTable(band)
#'
#' ds$getDefaultRAT(band)
#' ds$setDefaultRAT(band, df)
#'
#' ds$flushCache()
#'
#' ds$getChecksum(band, xoff, yoff, xsize, ysize)
#'
#' ds$close()
#' ```
#' @section Details:
#' ## Constructors
#'
#' \code{new(GDALRaster, filename, read_only)}\cr
#' Returns an object of class `GDALRaster`. The `read_only` argument defaults
#' to `TRUE` if not specified.
#'
#' \code{new(GDALRaster, filename, read_only, open_options)}\cr
#' Alternate constructor for passing dataset `open_options`, a character
#' vector of `NAME=VALUE` pairs.
#' `read_only` is required for this form of the constructor, `TRUE` for
#' read-only access, or `FALSE` to open with write access.
#' Returns an object of class `GDALRaster`.
#'
#' \code{new(GDALRaster, filename, read_only, open_options, shared)}\cr
#' Alternate constructor for specifying the `shared` mode for dataset opening.
#' The `shared` argument defaults to `TRUE` but can be set to `FALSE` with this
#' constructor (see Note).
#' All arguments are required with this form of the constructor, but
#' `open_options` can be `NULL`. Returns an object of class `GDALRaster`.
#'
#' \code{new(GDALRaster, filename, read_only, open_options, shared, allowed_drivers)}\cr
#' Alternate constructor for specifying the driver(s) allowed for dataset
#' opening as a character vector of driver short names.
#' All arguments are required with this form of the constructor, but
#' `open_options` and/or `allowed_drivers` can be `NULL`. Returns an object of class
#' `GDALRaster`.
#'
#' ## Read/write fields
#'
#' \code{$infoOptions}\cr
#' A character vector of command-line arguments to control the output of
#' \code{$info()} and \code{$infoAsJSON()} (see below).
#' Defaults to `character(0)`. Can be set to a vector of strings specifying
#' arguments to the \command{gdalinfo} command-line utility, e.g.,
#' `c("-nomd", "-norat", "-noct")`.
#' Restore the default by setting to empty string (`""`) or `character(0)`.
#'
#' \code{$quiet}\cr
#' A logical value, `FALSE` by default. This field can be set to `TRUE` which
#' will suppress various messages as well as progress reporting for potentially
#' long-running processes such as building overviews and computation of
#' statistics and histograms.
#'
#' \code{$readByteAsRaw}\cr
#' A logical value, `FALSE` by default. This field can be set to `TRUE` which
#' will affect the data type returned by the \code{$read()} method and the
#' [read_ds()] convenience function. When the underlying band data type is
#' Byte/UInt8 and `readByteAsRaw` is `TRUE` the output type will be raw rather
#' than integer. See also the `as_raw` argument to [read_ds()] to control this
#' in a non-persistent setting. If the underlying band data type is not
#' Byte/UInt8 setting has no effect. (Note Byte = UInt8 in GDAL >= 3.13.)
#'
#' ## Methods
#'
#' \code{$getFilename()}\cr
#' Returns a character string containing the `filename` associated with this
#' `GDALRaster` object (`filename` originally used to open the dataset). May
#' be a regular filename, database connection string, URL, etc.
#'
#' \code{$setFilename(filename)}\cr
#' Sets the `filename` if the underlying dataset does not already have an
#' associated filename. Explicitly setting the filename is an advanced
#' setting that should only be used when the user has determined that it is
#' needed. Writing certain virtual datasets to file is one potential use case
#' (e.g., a dataset returned by `autoCreateWarpedVRT()`).
#'
#' \code{$open(read_only)}\cr
#' (Re-)opens the raster dataset on the existing filename. Use this method to
#' open a dataset that has been closed using \code{$close()}. May be used to
#' re-open a dataset with a different read/write access (`read_only` set to
#' `TRUE` or `FALSE`). The method will first close an open dataset, so it is
#' not required to call \code{$close()} explicitly in this case.
#' No return value, called for side effects.
#'
#' \code{$isOpen()}\cr
#' Returns a logical value, `TRUE` if the raster dataset is open.
#'
#' \code{$isReadOnly()}\cr
#' Returns a logical value, `TRUE` if the raster dataset has read-only access
#' or `FALSE` if it is writable.
#'
#' \code{$getFileList()}\cr
#' Returns a character vector of files believed to be part of this dataset.
#' If it returns an empty string (`""`) it means there is believed to be no
#' local file system files associated with the dataset (e.g., a virtual file
#' system). The returned filenames will normally be relative or absolute
#' paths depending on the path used to originally open the dataset.
#'
#' \code{$info()}\cr
#' Prints various information about the raster dataset to the console (no
#' return value, called for that side effect only).
#' Equivalent to the output of the \command{gdalinfo} command-line utility
#' (\command{gdalinfo filename}, if using the default `infoOptions`).
#' See the field \code{$infoOptions} above for setting the arguments to
#' `gdalinfo`.
#'
#' \code{$infoAsJSON()}\cr
#' Returns information about the raster dataset as a JSON-formatted string.
#' Equivalent to the output of the \command{gdalinfo} command-line utility
#' (\command{gdalinfo -json filename}, if using the default `infoOptions`).
#' See the field \code{$infoOptions} above for setting the arguments to
#' `gdalinfo`.
#'
#' \code{$getDriverShortName()}\cr
#' Returns the short name of the raster format driver.
#'
#' \code{$getDriverLongName()}\cr
#' Returns the long name of the raster format driver.
#'
#' \code{$getRasterXSize()}\cr
#' Returns the number of pixels along the x dimension.
#'
#' \code{$getRasterYSize()}\cr
#' Returns the number of pixels along the y dimension.
#'
#' \code{$getRasterCount()}\cr
#' Returns the number of raster bands on this dataset. For the methods
#' described below that operate on individual bands, the \code{band}
#' argument is the integer band number (1-based).
#'
#' \code{$addBand(dataType, options)}\cr
#' Adds a band to a dataset if the underlying format supports this action.
#' Most formats do not, but MEM and VRT are notable exceptions that support
#' adding bands. The added band will always be the last band.
#' `dataType` is a character string containing the data type name
#' (e.g., `"Byte"`, `"UInt8"` (GDAL >= 3.13), `"Int16"`, `"UInt16"`, `"Int32"`,
#' `"Float32"`, etc).
#' The `options` argument is a character vector of format specific `NAME=VALUE`
#' strings (may be `NULL`). For a MEM dataset, `options` can also be a vector
#' of `"numeric"`, `"integer"`, `"raw"` or `"complex"` values to be exposed as
#' a MEM band. In that case, the vector must have length equal to the raster
#' `xsize * ysize`, with values in left to right, top to bottom pixel order.
#' See also `rvector_to_MEM()`. Returns logical \code{TRUE} on success or
#' \code{FALSE} if a band could not be added.
#'
#' \code{$getGeoTransform()}\cr
#' Returns the affine transformation coefficients for transforming between
#' pixel/line raster space (column/row) and projection coordinate space
#' (geospatial x/y). The return value is a numeric vector of length six.
#' See \url{https://gdal.org/en/stable/tutorials/geotransforms_tut.html}
#' for details of the affine transformation. \emph{With 1-based indexing
#' in \R}, the geotransform vector contains (in map units of the raster spatial
#' reference system):
#' \tabular{rl}{
#' GT\[1\] \tab x-coordinate of upper-left corner of the upper-left pixel\cr
#' GT\[2\] \tab x-component of pixel width\cr
#' GT\[3\] \tab row rotation (zero for north-up raster)\cr
#' GT\[4\] \tab y-coordinate of upper-left corner of the upper-left pixel\cr
#' GT\[5\] \tab column rotation (zero for north-up raster)\cr
#' GT\[6\] \tab y-component of pixel height (negative for north-up raster)
#'}
#'
#' \code{$setGeoTransform(transform)}\cr
#' Sets the affine transformation coefficients on this dataset.
#' \code{transform} is a numeric vector of length six.
#' Returns logical \code{TRUE} on success or \code{FALSE} if the geotransform
#' could not be set.
#'
#' \code{$getProjection()}\cr
#' Returns the coordinate reference system of the raster as an OGC WKT
#' format string. Equivalent to \code{ds$getProjectionRef()}.
#'
#' \code{$getProjectionRef()}\cr
#' Returns the coordinate reference system of the raster as an OGC WKT
#' format string.
#' An empty string is returned when a projection definition is not available.
#'
#' \code{$setProjection(projection)}\cr
#' Sets the projection reference for this dataset.
#' \code{projection} is a string in OGC WKT format.
#' Returns logical \code{TRUE} on success or \code{FALSE} if the projection
#' could not be set.
#'
#' \code{$getSpatialRef()}\cr
#' Returns the coordinate reference system of the raster as an OGC WKT
#' format string. Equivalent to \code{ds$getProjectionRef()}.
#'
#' \code{$bbox()}\cr
#' Returns a numeric vector of length four containing the bounding box
#' (xmin, ymin, xmax, ymax).
#'
#' \code{$setBbox(bbox)}\cr
#' Sets the bounding box on this dataset.
#' \code{bbox} is a numeric vector of length four.
#' Returns logical \code{TRUE} on success or \code{FALSE} if the bbox
#' could not be set.
#'
#' \code{$res()}\cr
#' Returns a numeric vector of length two containing the resolution
#' (pixel width, pixel height as positive values) for a non-rotated raster.
#' A warning is emitted and `NA` values returned if the raster has a rotated
#' geotransform (see method \code{$getGeoTransform()} above).
#'
#' \code{$dim()}\cr
#' Returns an integer vector of length three containing the raster dimensions
#' (xsize, ysize, number of bands).
#' Equivalent to:
#' ```
#' c(ds$getRasterXSize(), ds$getRasterYSize(), ds$getRasterCount())
#' ```
#'
#' \code{$apply_geotransform(col_row)}\cr
#' Applies geotransform coefficients to raster coordinates in pixel/line space
#' (column/row), converting into georeferenced (x/y) coordinates.
#' `col_row` is a numeric matrix of raster col/row coordinates (or two-column
#' data frame that will be coerced to numeric matrix).
#' Returns a numeric matrix of geospatial x/y coordinates.
#' See the stand-alone function of the same name ([apply_geotransform()]) for
#' more info and examples.
#'
#' \code{$get_pixel_line(xy)}\cr
#' Converts geospatial coordinates to pixel/line (raster column/row numbers).
#' `xy` is a numeric matrix of geospatial x,y coordinates in the same spatial
#' reference system as the raster (or two-column data frame that will be
#' coerced to numeric matrix). Returns an integer matrix of raster pixel/line.
#' See the stand-alone function of the same name ([get_pixel_line()]) for more
#' info and examples.
#'
#' \code{$get_block_indexing(band)}\cr
#' Helper method returning a numeric matrix with named columns: `xblockoff`,
#' `yblockoff`, `xoff`, `yoff`, `xsize`, `ysize`, `xmin`, `xmax`, `ymin`,
#' `ymax`. This method provides indexing values for the block layout of the
#' given `band` number. See also the class methods:
#' \code{$getBlockSize()}, \code{$getActualBlockSize()} and \code{$read()}.
#' The returned matrix has number of rows equal to the number of blocks for the
#' given `band` number, with blocks ordered left to right, top to bottom. All
#' offsets are zero-based. The `xoff`/`yoff` values are pixel offsets to the
#' start of a block. The `xsize`/`ysize` values give the actual block sizes
#' accounting for potentially incomplete blocks along the right and bottom
#' edges. The columns `xmin`, `xmax`, `ymin` and `ymax` give the extent of each
#' block in geospatial coordinates.
#'
#' \code{$make_chunk_index(band, max_pixels)}\cr
#' Helper method returning a numeric matrix with named columns: `xchunkoff`,
#' `ychunkoff`, `xoff`, `yoff`, `xsize`, `ysize`, `xmin`, `xmax`, `ymin`,
#' `ymax`. This method generates indexing information (offsets, sizes and
#' geospatial bounding boxes) for potentially multi-block chunks, defined on
#' block boundaries for efficient I/O. The output of this method can be used
#' with the \code{$readChunk()}/\code{$writeChunk()} methods to iterate I/O
#' operations conveniently on user-defined chunk sizes. The chunks will contain
#' at most `max_pixels` given as a numeric value optionally carrying the
#' `bit64::integer64` class attribute (numeric values will be coerced to 64-bit
#' integer internally by truncation). A value of `max_pixels = 0` (or any value
#' less than raster block xsize * block ysize, see \code{$getBlockSize()}
#' below), will return output equivalent to \code{$get_block_indexing()}.
#' The returned matrix has number of rows equal to the number of chunks for the
#' given `band` number, with chunks ordered left to right, top to bottom. All
#' offsets are zero-based. The `xoff`/`yoff` values are pixel offsets to the
#' start of a chunk. The `xsize`/`ysize` values give the actual chunk sizes
#' accounting for potentially incomplete chunks along the right and bottom
#' edges. The columns `xmin`, `xmax`, `ymin` and `ymax` give the extent of each
#' chunk in geospatial coordinates.
#'
#' \code{$getDescription(band)}\cr
#' Returns a string containing the description for \code{band}. An empty
#' string is returned if no description is set for the band.
#' Passing `band = 0` will return the dataset-level description.
#'
#' \code{$setDescription(band, desc)}\cr
#' Sets a description for \code{band}. \code{desc} is the character string
#' to set. No return value. (Passing `band = 0` can be used to set the
#' dataset-level description. Note that the dataset description is generally
#' the filename that was used to open the dataset. It usually should not be
#' changed by calling this method on an existing dataset.)
#'
#' \code{$getBlockSize(band)}\cr
#' Returns a numeric vector of length two (xsize, ysize) containing the
#' "natural" block size of \code{band}. GDAL has a concept of the natural block
#' size of rasters so that applications can organize data access efficiently
#' for some file formats. The natural block size is the block size that is
#' most efficient for accessing the format. For many formats this is simply a
#' whole row in which case block xsize is the same as \code{$getRasterXSize()}
#' and block ysize is 1. However, for tiled images block size will typically
#' be the tile size. Note that the X and Y block sizes don't have to divide
#' the image size evenly, meaning that right and bottom edge blocks may be
#' incomplete.
#'
#' \code{$getActualBlockSize(band, xblockoff, yblockoff)}\cr
#' Returns a numeric vector of length two (xvalid, yvalid) containing the
#' actual block size for a given block offset in \code{band}. Handles partial
#' blocks at the edges of the raster and returns the true number of pixels.
#' `xblockoff` is an integer value, the horizontal block offset for which to
#' calculate the number of valid pixels, with zero indicating the left most
#' block, 1 the next block, etc. `yblockoff` is likewise the vertical block
#' offset, with zero indicating the top most block, 1 the next block, etc.
#'
#' \code{$getOverviewCount(band)}\cr
#' Returns the number of overview layers (a.k.a. pyramids) available for
#' \code{band}.
#'
#' \code{$buildOverviews(resampling, levels, bands)}\cr
#' Build one or more raster overview images using the specified downsampling
#' algorithm.
#' \code{resampling} is a character string, one of `AVERAGE`,
#' `AVERAGE_MAGPHASE`, `RMS`, `BILINEAR`, `CUBIC`, `CUBICSPLINE`, `GAUSS`,
#' `LANCZOS`, `MODE`, `NEAREST` or `NONE`.
#' \code{levels} is an integer vector giving the list of overview decimation
#' factors to build (e.g., `c(2, 4, 8)`), or `0` to delete all overviews
#' (at least for external overviews (.ovr) and GTiff internal overviews).
#' \code{bands} is an integer vector giving a list of band numbers to build
#' overviews for, or `0` to build for all bands.
#' Note that for GTiff, overviews will be created internally if the dataset is
#' open in update mode, while external overviews (.ovr) will be created if the
#' dataset is open read-only.
#' External overviews created in GTiff format may be compressed using the
#' `COMPRESS_OVERVIEW` configuration option. All compression methods supported
#' by the GTiff driver are available
#' (e.g., `set_config_option("COMPRESS_OVERVIEW", "LZW")`).
#' Since GDAL 3.6, `COMPRESS_OVERVIEW` is honored when creating internal
#' overviews of GTiff files. The [GDAL documentation for
#' `gdaladdo`](https://gdal.org/en/stable/programs/gdaladdo.html) command-line
#' utility describes additional configuration for overview building.
#' See also [set_config_option()]. No return value, called for side effects.
#'
#' \code{$getDataTypeName(band)}\cr
#' Returns the name of the pixel data type for \code{band}. The possible data
#' types are:
#' \tabular{rl}{
#'  Unknown   \tab  Unknown or unspecified type\cr
#'  Byte      \tab  8-bit unsigned integer\cr
#'  Int8      \tab  8-bit signed integer (GDAL >= 3.7)\cr
#'  UInt16    \tab  16-bit unsigned integer\cr
#'  Int16     \tab  16-bit signed integer\cr
#'  UInt32    \tab  32-bit unsigned integer\cr
#'  Int32     \tab  32-bit signed integer\cr
#'  UInt64    \tab  64-bit unsigned integer (GDAL >= 3.5)\cr
#'  Int64     \tab  64-bit signed integer (GDAL >= 3.5)\cr
#'  Float32   \tab  32-bit floating point\cr
#'  Float64   \tab  64-bit floating point\cr
#'  CInt16    \tab  Complex Int16\cr
#'  CInt32    \tab  Complex Int32\cr
#'  CFloat32  \tab  Complex Float32\cr
#'  CFloat64  \tab  Complex Float64
#' }
#' Some raster formats including GeoTIFF ("GTiff") and Erdas Imagine .img
#' ("HFA") support sub-byte data types. Rasters can be created with these
#' data types by specifying the "NBITS=n" creation option where n=1...7 for
#' GTiff or n=1/2/4 for HFA. In these cases, \code{$getDataTypeName()} reports
#' the apparent type `"Byte"`. GTiff also supports n=9...15 (UInt16 type) and
#' n=17...31 (UInt32 type), and n=16 is accepted for Float32 to generate
#' half-precision floating point values.
#'
#' \code{$getNoDataValue(band)}\cr
#' Returns the nodata value for \code{band} if one exists.
#' This is generally a special value defined to mark pixels that are not
#' valid data. \code{NA} is returned if a nodata value is not defined for
#' \code{band}. Not all raster formats support a designated nodata value.
#'
#' \code{$setNoDataValue(band, nodata_value)}\cr
#' Sets the nodata value for \code{band}.
#' \code{nodata_value} is a numeric value to be defined as the nodata marker.
#' Depending on the format, changing the nodata value may or may not have an
#' effect on the pixel values of a raster that has just been created (often
#' not). It is thus advised to call \code{$fillRaster()} explicitly if the
#' intent is to initialize the raster to the nodata value. In any case,
#' changing an existing nodata value, when one already exists on an initialized
#' dataset, has no effect on the pixels whose values matched the previous
#' nodata value.
#' Returns logical \code{TRUE} on success or \code{FALSE} if the nodata value
#' could not be set.
#'
#' \code{$deleteNoDataValue(band)}\cr
#' Removes the nodata value for \code{band}.
#' This affects only the definition of the nodata value for raster formats
#' that support one (does not modify pixel values). No return value.
#' An error is raised if the nodata value cannot be removed.
#'
#' \code{$getMaskFlags(band)}\cr
#' Returns the status flags of the mask band associated with \code{band}.
#' Masks are represented as Byte bands with a value of zero indicating nodata
#' and non-zero values indicating valid data. Normally the value `255` will be
#' used for valid data pixels. GDAL supports external (.msk) mask bands, and
#' normal Byte alpha (transparency) band as mask (any value other than `0` to
#' be treated as valid data). But masks may not be regular raster bands on the
#' datasource, such as an implied mask from a band nodata value or the
#' `ALL_VALID` mask. See RFC 15: Band Masks for more details
#' (\url{https://gdal.org/en/stable/development/rfc/rfc15_nodatabitmask.html}.
#'
#' Returns a named list of GDAL mask flags and their logical values, with the
#' following definitions:
#' * `ALL_VALID`: There are no invalid pixels, all mask values will be `255`.
#' When used this will normally be the only flag set.
#' * `PER_DATASET`: The mask band is shared between all bands on the dataset.
#' * `ALPHA`: The mask band is actually an alpha band and may have values other
#' than `0` and `255`.
#' * `NODATA`: Indicates the mask is actually being generated from nodata
#' values (mutually exclusive of `ALPHA`).
#'
#' \code{$getMaskBand(band)}\cr
#' Returns the mask filename and band number associated with \code{band}.
#' The return value is a named list with two elements. The `MaskFile` element
#' gives the filename where the mask band is located, e.g., a file with the
#' same name as the main dataset but suffixed with .msk in the case of a GDAL
#' external mask file. `MaskFile` will be an empty string for the derived
#' `ALL_VALID` and `NODATA` masks, which internally are freestanding bands not
#' considered to be a part of a dataset. The `MaskBand` element gives the band
#' number for a mask that is a regular alpha band in the main dataset or
#' external mask file. `BandNumber` will be `0` for the `ALL_VALID` and `NODATA`
#' masks.
#'
#' \code{$getUnitType(band)}\cr
#' Returns the name of the unit type of the pixel values for \code{band}
#' (e.g., "m" or "ft").
#' An empty string (`""`) is returned if no units are available.
#'
#' \code{$setUnitType(band, unit_type)}\cr
#' Sets the name of the unit type of the pixel values for \code{band}.
#' `unit_type` should be one of empty string `""` (the default indicating it is
#' unknown), "m" indicating meters, or "ft" indicating feet, though other
#' nonstandard values are allowed.
#' Returns logical \code{TRUE} on success or \code{FALSE} if the unit type
#' could not be set.
#'
#' \code{$getScale(band)}\cr
#' Returns the pixel value scale (units value = (raw value * scale) + offset)
#' for \code{band}.
#' This value (in combination with the \code{$getOffset()} value) can be used to
#' transform raw pixel values into the units returned by \code{$getUnitType()}.
#' Returns \code{NA} if a scale value is not defined for this \code{band}.
#'
#' \code{$setScale(band, scale)}\cr
#' Sets the pixel value scale (units value = (raw value * scale) + offset)
#' for \code{band}. Many raster formats do not implement this method.
#' Returns logical \code{TRUE} on success or \code{FALSE} if the scale could
#' not be set.
#'
#' \code{$getOffset(band)}\cr
#' Returns the pixel value offset (units value = (raw value * scale) + offset)
#' for \code{band}.
#' This value (in combination with the \code{$getScale()} value) can be used to
#' transform raw pixel values into the units returned by \code{$getUnitType()}.
#' Returns \code{NA} if an offset value is not defined for this \code{band}.
#'
#' \code{$setOffset(band, offset)}\cr
#' Sets the pixel value offset (units value = (raw value * scale) + offset)
#' for \code{band}. Many raster formats do not implement this method.
#' Returns logical \code{TRUE} on success or \code{FALSE} if the offset could
#' not be set.
#'
#' \code{$getRasterColorInterp(band)}\cr
#' Returns a string describing the color interpretation for \code{band}.
#' The color interpretation values and their meanings, with several additions
#' in GDAL 3.10:
#' \tabular{ll}{
#'  Undefined  \tab Undefined\cr
#'  Gray       \tab Grayscale\cr
#'  Palette    \tab Paletted (see associated color table)\cr
#'  Red        \tab Red band of RGBA image\cr
#'  Green      \tab Green band of RGBA image\cr
#'  Blue       \tab Blue band of RGBA image\cr
#'  Alpha      \tab Alpha (0 = transparent, 255 = opaque)\cr
#'  Hue        \tab Hue band of HLS image\cr
#'  Saturation \tab Saturation band of HLS image\cr
#'  Lightness  \tab Lightness band of HLS image\cr
#'  Cyan       \tab Cyan band of CMYK image\cr
#'  Magenta    \tab Magenta band of CMYK image\cr
#'  Yellow     \tab Yellow band of CMYK image\cr
#'  Black      \tab Black band of CMYK image\cr
#'  YCbCr_Y    \tab Y Luminance\cr
#'  YCbCr_Cb   \tab Cb Chroma\cr
#'  YCbCr_Cr   \tab Cr Chroma\cr
#'  _GDAL >= 3.10_: \tab \cr
#'  PanBand    \tab Panchromatic band (0.40 - 1.00 micrometre)\cr
#'  CoastalBand \tab Coastal band (0.40 - 0.45 micrometre)\cr
#'  RedEdgeBand \tab Red-edge band (0.69 - 0.79 micrometre)\cr
#'  NIRBand    \tab Near-InfraRed (NIR) band (0.75 - 1.40 micrometre)\cr
#'  SWIRBand   \tab Short-Wavelength InfraRed (SWIR) band (1.40 - 3.00 micrometres)\cr
#'  MWIRBand   \tab Mid-Wavelength InfraRed (MWIR) band (3.00 - 8.00 micrometres)\cr
#'  LWIRBand   \tab Long-Wavelength InfraRed (LWIR) band (8.00 - 15 micrometres)\cr
#'  TIRBand    \tab Thermal InfraRed (TIR) band (MWIR or LWIR) (3 - 15 micrometres)\cr
#'  OtherIRBand \tab Other infrared band (0.75 - 1000 micrometres)\cr
#'  SAR_Ka_Band \tab SAR Ka band (0.8 - 1.1 cm / 27 - 40 GHz)\cr
#'  SAR_K_Band  \tab SAR K band (1.1 - 1.7 cm / 18 - 27 GHz)\cr
#'  SAR_Ku_Band \tab SAR Ku band (1.7 - 2.4 cm / 12 - 18 GHz)\cr
#'  SAR_X_Band  \tab SAR X band (2.4 - 3.8 cm / 8 - 12 GHz)\cr
#'  SAR_C_Band  \tab SAR C band (3.8 - 7.5 cm / 4 - 8 GHz)\cr
#'  SAR_S_Band  \tab SAR S band (7.5 - 15 cm / 2 - 4 GHz)\cr
#'  SAR_L_Band  \tab SAR L band (15 - 30 cm / 1 - 2 GHz)\cr
#'  SAR_P_Band  \tab SAR P band (30 - 100 cm / 0.3 - 1 GHz)
#' }
#'
#' \code{$setRasterColorInterp(band, col_interp)}\cr
#' Sets the color interpretation for \code{band}. See above for the list of
#' valid values for \code{col_interp} (passed as a string).
#'
#' \code{$getMinMax(band, approx_ok)}\cr
#' Returns a numeric vector of length two containing the min/max values for
#' \code{band}. If \code{approx_ok} is `TRUE` and the raster format knows these
#' values intrinsically then those values will be returned. If that doesn't
#' work, a subsample of blocks will be read to get an approximate min/max. If
#' the band has a nodata value it will be excluded from the minimum and
#' maximum. If \code{approx_ok} is `FALSE`, then all pixels will be read and
#' used to compute an exact range.
#'
#' \code{$getMinMaxLocation(band)}\cr
#' Computes the min/max values for a band, and their locations. Pixels with
#' value matching the nodata value or masked by the mask band are ignored. If
#' the minimum or maximum value is hit in several locations, it is not
#' specified which location will be returned. The locations are returned as
#' column/row number (0-based), geospatial x/y in the coordinate system of the
#' raster, and WGS84 longitude/latitude. Returns a numeric vector with the
#' following named values: `min`, `min_col`, `min_row`, `min_geo_x`,
#' `min_geo_y`, `min_wgs84_lon`, `min_wgs84_lat`, `max`, `max_col`, `max_row`,
#' `max_geo_x`, `max_geo_y`, `max_wgs84_lon`, `max_wgs84_lat`. This method wraps
#' `GDALComputeRasterMinMaxLocation()` in the GDAL C API requiring GDAL >= 3.11.
#'
#' \code{$getStatistics(band, approx_ok, force)}\cr
#' Returns a numeric vector of length four containing the minimum, maximum,
#' mean and standard deviation of pixel values in \code{band} (excluding
#' nodata pixels). Some raster formats will cache statistics allowing fast
#' retrieval after the first request.
#'
#' \code{approx_ok}:
#'   * `TRUE`: Approximate statistics are sufficient, in which case overviews
#'   or a subset of raster tiles may be used in computing the statistics.
#'   * `FALSE`: All pixels will be read and used to compute statistics (if
#'   computation is forced).
#'
#' \code{force}:
#'   * `TRUE`: The raster will be scanned to compute statistics. Once computed,
#'   statistics will generally be "set" back on the raster band if the format
#'   supports caching statistics.
#'   (Note: `ComputeStatistics()` in the GDAL API is called automatically here.
#'   This is a change in the behavior of `GetStatistics()` in the API, to a
#'   definitive `force`.)
#'   * `FALSE`: Results will only be returned if it can be done quickly (i.e.,
#'   without scanning the raster, typically by using pre-existing
#'   STATISTICS_xxx metadata items). \code{NA}s will be returned if statistics
#'   cannot be obtained quickly.
#'
#' \code{$clearStatistics()}\cr
#' Clear statistics. Only implemented for now in PAM supported datasets
#' (Persistable Auxiliary Metadata via .aux.xml file). GDAL >= 3.2.
#'
#' \code{$getHistogram(band, min, max, num_buckets, incl_out_of_range, approx_ok)}\cr
#' Computes raster histogram for \code{band}. \code{min} is the lower bound of
#' the histogram. \code{max} is the upper bound of the histogram.
#' \code{num_buckets} is the number of buckets to use (bucket size is
#' \code{(max - min) / num_buckets}).
#' \code{incl_out_of_range} is a logical scalar: if `TRUE` values below the
#' histogram range will be mapped into the first bucket and values above will
#' be mapped into the last bucket, if `FALSE` out of range values are discarded.
#' \code{approx_ok} is a logical scalar: `TRUE` if an approximate histogram is
#' OK (generally faster), or `FALSE` for an exactly computed histogram.
#' Returns the histogram as a numeric vector of length \code{num_buckets}.
#'
#' \code{$getDefaultHistogram(band, force)}\cr
#' Returns a default raster histogram for \code{band}. In the GDAL API, this
#' method is overridden by derived classes (such as GDALPamRasterBand,
#' VRTDataset, HFADataset...) that may be able to fetch efficiently an already
#' stored histogram. \code{force} is a logical scalar: `TRUE` to force the
#' computation of a default histogram; or if `FALSE` and no default histogram
#' is available, a warning is emitted and the returned list has a 0-length
#' histogram vector.
#' Returns a list of length four containing named elements `min` (lower
#' bound), `max` (upper bound), `num_buckets` (number of buckets), and
#'`histogram` (a numeric vector of length `num_buckets`).
#'
#' \code{$getInterBandCovMatrix(bands, approx_ok, force, write_in_metadata,
#'                              df_correction)}\cr
#' Fetch or compute the covariance matrix between bands of this dataset. The
#' covariance indicates the level to which two bands vary together. Requires
#' GDAL >= 3.13. See `GDALDatasetGetInterBandCovarianceMatrix()` in:
#' \url{https://gdal.org/en/latest/api/raster_c_api.html}. Returns a square
#' matrix with dimension equal to the number of bands. `bands` may be given as
#' `0` meaning all bands, or may be an integer vector of specific band numbers.
#' `approx_ok` specifies whether it is acceptable to use a subsample of values
#' (`TRUE`), or all pixel values should be used (`FALSE`).
#'
#' \code{force}:
#'   * `TRUE`: The raster will be scanned to compute covariances.
#'   (Note: `ComputeInterBandCovarianceMatrix()` in the GDAL API is called
#'   automatically here. This is a change in the behavior of
#'   `GetInterBandCovarianceMatrix()` in the API, to a definitive `force`.)
#'   * `FALSE`: Results will only be returned if it can be done quickly (i.e.,
#'   without scanning the raster, by using pre-existing
#'   `STATISTICS_COVARIANCES` metadata items). \code{NA} will be returned if
#'   inter-band covariances cannot be obtained quickly.
#'
#' `write_in_metadata` specifies whether `STATISTICS_COVARIANCES` band metadata
#' items should be written if covariances are computed new. `df_correction`
#' specifies a correction term to subtract in the final averaging phase of the
#' covariance computation, often will be `1`. A value of `df_correction = 1`
#' will return an unbiased estimate if the pixels in bands are considered to be
#' a sample of the whole population. Otherwise a value of `df_correction = 0`
#' can be used if they are considered to be the whole population.
#'
#' \code{$getMetadata(band, domain)}\cr
#' Returns a character vector of all metadata `NAME=VALUE` pairs that exist in
#' the specified \code{domain}, or empty string (`""`) if there are no
#' metadata items in \code{domain} (metadata in the context of the GDAL
#' Raster Data Model
#' \url{https://gdal.org/en/stable/user/raster_data_model.html}).
#' Set \code{band = 0} to retrieve dataset-level metadata, or to an integer
#' band number to retrieve band-level metadata.
#' Set \code{domain = ""} (empty string) to retrieve metadata in the
#' default domain.
#'
#' \code{$setMetadata(band, metadata, domain)}\cr
#' Sets metadata in the specified \code{domain}. The \code{metadata} argument
#' is given as a character vector of `NAME=VALUE` pairs.
#' Pass \code{band = 0} to set dataset-level metadata, or pass an integer
#' band number to set band-level metadata.
#' Use \code{domain = ""} (empty string) to set an item in the default domain.
#' Returns logical \code{TRUE} on success or \code{FALSE} if metadata could
#' not be set.
#'
#' \code{$getMetadataItem(band, mdi_name, domain)}\cr
#' Returns the value of a specific metadata item named \code{mdi_name} in the
#' specified \code{domain}, or empty string (`""`) if no matching item
#' is found.
#' Set \code{band = 0} to retrieve dataset-level metadata, or to an integer
#' band number to retrieve band-level metadata.
#' Set \code{domain = ""} (empty string) to retrieve an item in the
#' default domain.
#'
#' \code{$setMetadataItem(band, mdi_name, mdi_value, domain)}\cr
#' Sets the value (\code{mdi_value}) of a specific metadata item named
#' \code{mdi_name} in the specified \code{domain}.
#' Pass \code{band = 0} to set dataset-level metadata, or pass an integer
#' band number to set band-level metadata.
#' Use \code{domain = ""} (empty string) to set an item in the default domain.
#' Returns logical \code{TRUE} on success or \code{FALSE} if metadata could
#' not be set.
#'
#' \code{$getMetadataDomainList(band)}\cr
#' Returns a character vector of metadata domains or empty string (`""`).
#' Set \code{band = 0} to retrieve dataset-level domains, or to an integer
#' band number to retrieve band-level domains.
#'
#' \code{$read(band, xoff, yoff, xsize, ysize, out_xsize, out_ysize)}\cr
#' Reads a region of raster data from \code{band}. The method takes care of
#' pixel decimation / replication if the output size
#' (\code{out_xsize * out_ysize}) is different than the size of the region
#' being accessed (\code{xsize * ysize}).
#' \code{xoff} is the pixel (column) offset to the top left corner of the
#' region of the band to be accessed (zero to start from the left side).
#' \code{yoff} is the line (row) offset to the top left corner of the region of
#' the band to be accessed (zero to start from the top).
#' \emph{Note that raster row/column offsets use 0-based indexing.}
#' \code{xsize} is the width in pixels of the region to be accessed.
#' \code{ysize} is the height in pixels of the region to be accessed.
#' \code{out_xsize} is the width of the output array into which the desired
#' region will be read (typically the same value as xsize).
#' \code{out_ysize} is the height of the output array into which the desired
#' region will be read (typically the same value as ysize).
#' Returns a numeric or complex vector containing the values that were read.
#' It is organized in left to right, top to bottom pixel order.
#' \code{NA} will be returned in place of the nodata value if the
#' raster dataset has a nodata value defined for this band.
#' Data are read as \R integer type when possible for the raster data type
#' (`Byte`, `Int8`, `Int16`, `UInt16`, `Int32`), otherwise as type double
#' (`UInt32`, `Float32`, `Float64`).
#' No rescaling of the data is performed (see \code{$getScale()} and
#' \code{$getOffset()} above).
#' An error is raised if the read operation fails. See also the setting
#' \code{$readByteAsRaw} above.
#'
#' \code{$readBlock(band, xblockoff, yblockoff)}\cr
#' Reads a block of raster data, without resampling. See the class methods
#' \code{$getBlockSize()} and \code{$getActualBlockSize()} above for a
#' description of raster blocks. This is a convenience method to read by block
#' offsets. Returns a vector of pixel values with length equal to the actual
#' block `xsize * ysize`, otherwise as described above for \code{$read()}.
#'
#' \code{$readChunk(band, chunk_def)}\cr
#' Reads a potentially multi-block chunk of raster data, without resampling.
#' This is a convenience method that can be used with the output of
#' \code{$make_chunk_index()} (see above). The matrix of chunk offsets and sizes
#' returned by \code{$make_chunk_index()} (or \code{$get_block_indexing()} to
#' operate on blocks) can be used to iterate I/O over the raster in user-defined
#' chunk sizes, i.e., a row of that matrix can be passed for the `chunk_def`
#' argument. `chunk_def` can also be given as an numeric vector of length 4
#' containing the 0-based pixel offsets and pixel sizes for a chunk (xoff, yoff,
#' xsize, ysize). Returns a vector of pixel values with length equal to the
#' chunk `xsize * ysize`, otherwise as described above for \code{$read()}.
#'
#' \code{$readToNativeRaster(xoff, yoff, xsize, ysize, out_xsize, out_ysize)}\cr
#' Reads a region of raster data from \code{band}. The method takes care of
#' pixel decimation / replication if the output size
#' (\code{out_xsize * out_ysize}) is different than the size of the region
#' being accessed (\code{xsize * ysize}).
#' \code{xoff} is the pixel (column) offset to the top left corner of the
#' region of the band to be accessed (zero to start from the left side).
#' \code{yoff} is the line (row) offset to the top left corner of the region of
#' the band to be accessed (zero to start from the top).
#' \emph{Note that raster row/column offsets use 0-based indexing.}
#' \code{xsize} is the width in pixels of the region to be accessed.
#' \code{ysize} is the height in pixels of the region to be accessed.
#' \code{out_xsize} is the width of the output array into which the desired
#' region will be read (typically the same value as xsize).
#' \code{out_ysize} is the height of the output array into which the desired
#' region will be read (typically the same value as ysize).
#' Returns an object of class `nativeRaster` with attributes 'dim', and
#' 'channels'  containing the values that were read in R's native RGB/A encoding.
#'
#' \code{$write(band, xoff, yoff, xsize, ysize, rasterData)}\cr
#' Writes a region of raster data to \code{band}.
#' \code{xoff} is the pixel (column) offset to the top left corner of the
#' region of the band to be accessed (zero to start from the left side).
#' \code{yoff} is the line (row) offset to the top left corner of the region of
#' the band to be accessed (zero to start from the top).
#' \emph{Note that raster row/column offsets use 0-based indexing.}
#' \code{xsize} is the width in pixels of the region to write.
#' \code{ysize} is the height in pixels of the region to write.
#' \code{rasterData} is a numeric or complex vector containing values to write.
#' It is organized in left to right, top to bottom pixel order. \code{NA} in
#' \code{rasterData} should be replaced with a suitable nodata value prior to
#' writing (see \code{$getNoDataValue()} and \code{$setNoDataValue()} above).
#' An error is raised if the operation fails (no return value).
#'
#' \code{$writeBlock(band, xblockoff, yblockoff, rasterData)}\cr
#' Writes a block of raster data. See the class methods \code{$getBlockSize()}
#' and \code{$getActualBlockSize()} above for a description of raster blocks.
#' This is a convenience method to write by block offsets.. Otherwise, this
#' method operates like \code{$write()}. The length of `rasterData` must be the
#' same as the actual `xsize * ysize` of the destination block.
#'
#' \code{$writeChunk(band, chunk_def, rasterData)}\cr
#' Writes a potentially multi-block chunk of raster data. This is a convenience
#' method that can be used to iterate I/O over the raster in user-defined chunk
#' sizes, see method \code{$readChunk()} above. Otherwise, this method operates
#' like \code{$write()}. The length of `rasterData` must be the same as
#' `xsize * ysize` of the destination chunk.
#'
#' \code{$fillRaster(band, value, ivalue)}\cr
#' Fills `band` with a constant value. GDAL makes no guarantees about what
#' values the pixels in newly created files are set to, so this method can be
#' used to clear a band to a specified "default" value. The fill `value` is
#' passed as `numeric`, but this will be converted to the underlying raster
#' data type before writing to the file. The `ivalue` argument allows setting
#' the imaginary component of a complex value. Note that `ivalue` is a required
#' argument but can be set to `0` for real data types. No return value. An
#' error is raised if the operation fails.
#'
#' \code{$getColorTable(band)}\cr
#' Returns the color table associated with \code{band}, or \code{NULL} if
#' there is no associated color table. The color table is returned as an
#' integer matrix with five columns. To associate a color with a raster pixel,
#' the pixel value is used as a subscript into the color table. This means that
#' the colors are always applied starting at zero and ascending
#' (see
#' \href{https://gdal.org/en/stable/user/raster_data_model.html#color-table}{GDAL Color Table}).
#' Column 1 contains the pixel values. Interpretation of columns 2:5 depends
#' on the value of \code{$getPaletteInterp()} (see below).
#' For "RGB", columns 2:5 contain red, green, blue, alpha as 0-255 integer
#' values.
#'
#' \code{$getPaletteInterp(band)}\cr
#' If \code{band} has an associated color table, this method returns a
#' character string with the palette interpretation for columns 2:5 of the
#' table. An empty string (\code{""}) is returned if \code{band} does not have
#' an associated color table. The palette interpretation values and their
#' meanings are:
#' * Gray: column 2 contains grayscale values (columns 3:5 unused)
#' * RGB: columns 2:5 contain red, green, blue, alpha
#' * CMYK: columns 2:5 contain cyan, magenta, yellow, black
#' * HLS: columns 2:4 contain hue, lightness, saturation (column 5 unused)
#'
#' \code{$setColorTable(band, col_tbl, palette_interp)}\cr
#' Sets the raster color table for \code{band}.
#' \code{col_tbl} is an integer matrix or data frame with either four or five
#' columns (see \code{$getColorTable()} above). Column 1 contains the pixel
#' values. Valid values are integers 0 and larger (note that GTiff format
#' supports color tables only for Byte and UInt16 bands). Negative values
#' will be skipped with a warning emitted. Interpretation of columns 2:5
#' depends on the value of \code{$getPaletteInterp()} (see above). For RGB,
#' columns 2:4 contain red, green, blue as 0-255 integer values, and an
#' optional column 5 contains alpha transparency values (defaults to 255
#' opaque).
#' \code{palette_interp} is a string, one of `Gray`, `RGB`, `CMYK` or `HLS`
#' (see \code{$getPaletteInterp()} above).
#' Returns logical \code{TRUE} on success or \code{FALSE} if the color table
#' could not be set.
#'
#' \code{$clearColorTable(band)}\cr
#' Clears the raster color table for \code{band}.
#' Returns logical \code{TRUE} on success or \code{FALSE} if the color table
#' could not be cleared, e.g., if this action is not supported by the driver.
#'
#' \code{$getDefaultRAT(band)}\cr
#' Returns the Raster Attribute Table for \code{band} as a data frame,
#' or \code{NULL} if there is no associated Raster Attribute Table. See the
#' stand-alone function [buildRAT()] for details of the Raster Attribute Table
#' format.
#'
#' \code{$setDefaultRAT(band, df)}\cr
#' Sets a default Raster Attribute Table for \code{band} from data frame `df`.
#' The input data frame will be checked for attribute `"GDALRATTableType"`
#' which can have values of `"thematic"` or `"athematic"` (for continuous data).
#' Columns of the data frame will be checked for attribute `"GFU"` (for "GDAL
#' field usage"). If the `"GFU"` attribute is missing, a value of `"Generic"`
#' will be used (corresponding to `GFU_Generic` in the GDAL API, for general
#' purpose field). Columns with other, specific field usage values should
#' generally be present in `df`, such as fields containing the set of unique
#' (discrete) pixel values (GFU `"MinMax"`), pixel counts (GFU `"PixelCount"`),
#' class names (GFU `"Name"`), color values (GFUs `"Red"`, "`Green"`, `"Blue"`),
#' etc. The data frame will also be checked for attributes `"Row0Min"` and
#' `"BinSize"` which can have numeric values that describe linear binning.
#' See the stand-alone function [buildRAT()] for details of the GDAL Raster
#' Attribute Table format and its representation as data frame.
#'
#' \code{$flushCache()}\cr
#' Flush all write cached data to disk. Any raster data written via GDAL calls,
#' but buffered internally will be written to disk. Using this method does not
#' preclude calling \code{$close()} to properly close the dataset and ensure
#' that important data not addressed by \code{$flushCache()} is written in the
#' file (see also \code{$open()} above). No return value, called for side
#' effects.
#'
#' \code{$getChecksum(band, xoff, yoff, xsize, ysize)}\cr
#' Returns a 16-bit integer (0-65535) checksum from a region of raster data
#' on `band`.
#' Floating point data are converted to 32-bit integer so decimal portions of
#' such raster data will not affect the checksum. Real and imaginary
#' components of complex bands influence the result.
#' \code{xoff} is the pixel (column) offset of the window to read.
#' \code{yoff} is the line (row) offset of the window to read.
#' \emph{Raster row/column offsets use 0-based indexing.}
#' \code{xsize} is the width in pixels of the window to read.
#' \code{ysize} is the height in pixels of the window to read.
#'
#' \code{$close()}\cr
#' Closes the GDAL dataset (no return value, called for side effects).
#' Calling \code{$close()} results in proper cleanup, and flushing of any
#' pending writes. Forgetting to close a dataset opened in update mode on some
#' formats such as GTiff could result in being unable to open it afterwards.
#' The `GDALRaster` object is still available after calling \code{$close()}.
#' The dataset can be re-opened on the existing \code{filename} with
#' \code{$open(read_only=TRUE)} or \code{$open(read_only=FALSE)}.
#'
#' @note
#' If a dataset object is opened with update access (`read_only = FALSE`), it
#' is not recommended to open a new dataset on the same underlying `filename`.
#'
#' Datasets are opened in shared mode by default. This allows the sharing of
#' `GDALDataset` handles for a dataset with other callers that open shared on
#' the same `filename`, if the dataset is opened from the same thread.
#' Functions in `gdalraster` that do processing will open input datasets in
#' shared mode. This provides potential efficiency for cases when an object of
#' class `GDALRaster` is already open in read-only mode on the same `filename`
#' (avoids overhead associated with initial dataset opening by using the
#' existing handle, and potentially makes use of existing data in the GDAL
#' block cache). Opening in shared mode can be disabled by specifying the
#' optional `shared` parameter in the class constructor.
#'
#' The \code{$read()} method will perform automatic resampling if the
#' specified output size (`out_xsize * out_ysize`) is different than
#' the size of the region being read (`xsize * ysize`). In that case, the
#' `GDAL_RASTERIO_RESAMPLING` configuration option could also be set to
#' override the default resampling to one of `BILINEAR`, `CUBIC`,
#' `CUBICSPLINE`, `LANCZOS`, `AVERAGE` or `MODE` (see [set_config_option()]).
#'
#' @seealso
#' Package overview in [`help("gdalraster-package")`][gdalraster-package]
#'
#' `vignette("raster-api-tutorial")`
#'
#' [read_ds()] is a convenience wrapper for `GDALRaster$read()`
#'
#' @examples
#' lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
#' ds <- new(GDALRaster, lcp_file)
#' ds
#'
#' ## print information about the dataset to the console
#' ds$info()
#'
#' ## retrieve the raster format name
#' ds$getDriverShortName()
#' ds$getDriverLongName()
#'
#' ## retrieve a list of files composing the dataset
#' ds$getFileList()
#'
#' ## retrieve dataset parameters
#' ds$getRasterXSize()
#' ds$getRasterYSize()
#' ds$getGeoTransform()
#' ds$getProjection()
#' ds$getRasterCount()
#' ds$bbox()
#' ds$res()
#' ds$dim()
#'
#' ## retrieve some band-level parameters
#' ds$getDescription(band = 1)
#' ds$getBlockSize(band = 1)
#' ds$getOverviewCount(band = 1)
#' ds$getDataTypeName(band = 1)
#' # LCP format does not support an intrinsic nodata value so this returns NA:
#' ds$getNoDataValue(band = 1)
#'
#' ## LCP driver reports several dataset- and band-level metadata
#' ## (format description at https://gdal.org/en/stable/drivers/raster/lcp.html)
#' ## set band = 0 to retrieve dataset-level metadata
#' ## set domain = "" (empty string) for the default metadata domain
#' ds$getMetadata(band = 0, domain = "")
#'
#' ## retrieve metadata for a band as a vector of name=value pairs
#' ds$getMetadata(band = 4, domain = "")
#'
#' ## retrieve the value of a specific metadata item
#' ds$getMetadataItem(band = 2, mdi_name = "SLOPE_UNIT_NAME", domain = "")
#'
#' ## read one row of pixel values from band 1 (elevation)
#' ## raster row/column index are 0-based
#' ## the upper left corner is the origin
#' ## read the tenth row:
#' ncols <- ds$getRasterXSize()
#' rowdata <- ds$read(band = 1, xoff = 0, yoff = 9,
#'                    xsize = ncols, ysize = 1,
#'                    out_xsize = ncols, out_ysize = 1)
#' head(rowdata)
#'
#' ds$close()
#'
#' ## create a new raster using lcp_file as a template
#' new_file <- file.path(tempdir(), "storml_newdata.tif")
#' rasterFromRaster(srcfile = lcp_file,
#'                  dstfile = new_file,
#'                  nbands = 1,
#'                  dtName = "Byte",
#'                  init = -9999)
#'
#' ds_new <- new(GDALRaster, new_file, read_only = FALSE)
#'
#' ## write random values to all pixels
#' set.seed(42)
#' ncols <- ds_new$getRasterXSize()
#' nrows <- ds_new$getRasterYSize()
#' for (row in 0:(nrows - 1)) {
#'     rowdata <- round(runif(ncols, 0, 100))
#'     ds_new$write(band = 1,
#'                  xoff = 0,
#'                  yoff = row,
#'                  xsize = ncols,
#'                  ysize = 1,
#'                  rowdata)
#' }
#'
#' ## re-open in read-only mode when done writing
#' ## this will ensure flushing of any pending writes (implicit $close)
#' ds_new$open(read_only = TRUE)
#'
#' ## getStatistics returns min, max, mean, sd, and sets stats in the metadata
#' ds_new$getStatistics(band = 1, approx_ok = FALSE, force = TRUE)
#' ds_new$getMetadataItem(band = 1, "STATISTICS_MEAN", "")
#'
#' ## close the dataset for proper cleanup
#' ds_new$close()
#' \dontshow{deleteDataset(new_file)}
#' \donttest{
#' ## using a GDAL Virtual File System handler '/vsicurl/'
#' ## see: https://gdal.org/en/stable/user/virtual_file_systems.html
#' url <- "/vsicurl/https://raw.githubusercontent.com/"
#' url <- paste0(url, "firelab/gdalraster/main/sample-data/")
#' url <- paste0(url, "lf_elev_220_mt_hood_utm.tif")
#'
#' set_config_option("GDAL_HTTP_CONNECTTIMEOUT", "20")
#' set_config_option("GDAL_HTTP_TIMEOUT", "20")
#' if (http_enabled() && vsi_stat(url)) {
#'   ds <- new(GDALRaster, url)
#'   plot_raster(ds, legend = TRUE, main = "Mount Hood elevation (m)")
#'   ds$close()
#' }
#' set_config_option("GDAL_HTTP_CONNECTTIMEOUT", "")
#' set_config_option("GDAL_HTTP_TIMEOUT", "")
#' }
NULL

Rcpp::loadModule("mod_GDALRaster", TRUE)

# GDAL Multidimensional Raster functions
# public interface to src/gdal_mdim.cpp
# Chris Toney <jctoney at gmail.com>

#' Return a view of an MDArray as a "classic" GDALDataset (i.e., 2D)
#'
#' `mdim_as_classic()` returns a 2D raster view on an MDArray in a GDAL
#' Multidimensional Raster dataset, as an object of class `GDALRaster`. Only 2D
#' or more arrays are supported. In the case of > 2D arrays, additional
#' dimensions will be represented as raster bands. Requires GDAL >= 3.2.
#'
#' @param dsn Character string giving the data source name of the
#' multidimensional raster (e.g., file, VSI path).
#' @param array_name Character string giving the name of the MDarray in
#' `dsn`.
#' @param idx_xdim Integer value giving the index of the dimension that will be
#' used as the X/width axis (0-based).
#' @param idx_ydim Integer value giving the index of the dimension that will be
#' used as the Y/height axis (0-based).
#' @param read_only Logical value, `TRUE` to open the dataset in read-only mode
#' (the default).
#' @param group_name Optional character string giving the fully qualified name
#' of a group containing `array_name`.
#' @param view_expr Optional character string giving an expression for basic
#' array slicing and indexing, or field access (see section `View Expressions`).
#' @param allowed_drivers Optional character vector of driver short names that
#' must be considered. By default, all known multidimensional raster drivers are
#' considered.
#' @param open_options Optional character vector of format-specific dataset open
#' options as `"NAME=VALUE"` pairs.
#' @returns An object of class `GDALRaster`.
#'
#' @section View Expressions:
#' A character string can be passed in argument `view_expr` to specify array
#' slicing or field access. The slice expression uses the same syntax as NumPy
#' basic slicing and indexing (0-based), or it can use field access by name.
#' See \url{https://numpy.org/doc/stable/user/basics.indexing.html}.
#'
#' GDAL support for view expression on an MDArray is documented for
#' `GDALMDArray::GetView()` (see
#' \url{https://gdal.org/en/stable/api/gdalmdarray_cpp.html}) and copied here:
#'
#' Multiple [] bracket elements can be concatenated, with a slice expression or
#' field name inside each.
#'
#' For basic slicing and indexing, inside each [] bracket element, a list of
#' indexes that apply to successive source dimensions, can be specified, using
#' integer indexing (e.g. 1), range indexing (start:stop:step), ellipsis (...)
#' or newaxis, using a comma separator.
#'
#' Example expressions with a 2-dimensional array whose content is
#' `[[0,1,2,3],[4,5,6,7]]`.
#' * `"[1][2]"`: returns a 0-dimensional/scalar array with the value at
#' index 1 in the first dimension, and index 2 in the second dimension from the
#' source array. That is, `5`.
#' * `"[1,2]"`: same as above, but a bit more performant.
#' * `"[1]"`: returns a 1-dimensional array, sliced at index `1` in the
#' first dimension. That is `[4,5,6,7]`.
#' * `"[:,2]"`: returns a 1-dimensional array, sliced at index `2` in the
#' second dimension. That is `[2,6]`.
#' * `"[:,2:3:]"`: returns a 2-dimensional array, sliced at index `2` in
#' the second dimension. That is `[[2],[6]]`.
#' * `"[::,2]"`: Same as above.
#' * `"[...,2]"`: same as above, in that case, since the ellipsis only
#' expands to one dimension here.
#' * `"[:,::2]"`: returns a 2-dimensional array, with even-indexed
#' elements of the second dimension. That is `[[0,2],[4,6]]`.
#' * `"[:,1::2]"`: returns a 2-dimensional array, with odd-indexed
#' elements of the second dimension. That is `[[1,3],[5,7]]`.
#' * `"[:,1:3:]"`: returns a 2-dimensional array, with elements of the
#' second dimension with index in the range `[1,3]`. That is `[[1,2],[5,6]]`.
#' * `"[::-1,:]"`: returns a 2-dimensional array, with the values in
#' first dimension reversed. That is `[[4,5,6,7],[0,1,2,3]]`.
#' * `"[newaxis,...]"`: returns a 3-dimensional array, with an additional
#' dimension of size `1` put at the beginning. That is
#' `[[[0,1,2,3],[4,5,6,7]]]`.
#'
#' One difference with NumPy behavior is that ranges that would result in zero
#' elements are not allowed (dimensions of size 0 not being allowed in the GDAL
#' multidimensional model).
#'
#' For field access, the syntax to use is `"['field_name']"`. Multiple field
#' specification is not supported currently. Both type of access can be
#' combined, e.g. `"[1]['field_name']"`.
#'
#' @note
#' The indexing of array dimensions is 0-based consistent with the
#' `<ARRAY-SPEC>` notation that may be used with GDAL CLI commands, e.g.,
#' `gdal_usage("mdim convert")` (CLI bindings require GDAL > 3.11.3).
#' See \url{https://gdal.org/en/stable/programs/gdal_mdim_convert.html}.
#'
#' Once the returned `GDALRaster` object has been closed, it cannot be re-opened
#' with its `$open()` method.
#'
#' @seealso
#' [`GDALRaster-class`][GDALRaster], [mdim_info()], [mdim_translate()]
#'
#' @examplesIf gdal_version_num() >= gdal_compute_version(3, 2, 0) && isTRUE(gdal_formats("netCDF")$multidim_raster)
#' f <- system.file("extdata/byte.nc", package="gdalraster")
#' # mdim_info(f)
#'
#' (ds <- mdim_as_classic(f, "Band1", 1, 0))
#'
#' plot_raster(ds, interpolate = FALSE, legend = TRUE, main = "Band1")
#'
#' ds$close()
#' @export
mdim_as_classic <- function(dsn, array_name, idx_xdim, idx_ydim,
                            read_only = TRUE, group_name = NULL,
                            view_expr = NULL, allowed_drivers = NULL,
                            open_options = NULL) {

    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a character string", call. = FALSE)

    if (missing(array_name) || is.null(array_name) || all(is.na(array_name)))
        stop("'array_name' is required", call. = FALSE)
    if (!(is.character(array_name) && length(array_name) == 1))
        stop("'array_name' must be a character string", call. = FALSE)

    if (missing(idx_xdim) || is.null(idx_xdim) || all(is.na(idx_xdim)))
        stop("'idx_xdim' is required", call. = FALSE)
    if (!(is.numeric(idx_xdim) && length(idx_xdim) == 1))
        stop("'idx_xdim' must be a numeric value (integer)", call. = FALSE)

    if (missing(idx_ydim) || is.null(idx_ydim) || all(is.na(idx_ydim)))
        stop("'idx_ydim' is required", call. = FALSE)
    if (!(is.numeric(idx_ydim) && length(idx_ydim) == 1))
        stop("'idx_ydim' must be a numeric value (integer)", call. = FALSE)

    if (missing(read_only) || is.null(read_only) || all(is.na(read_only)))
        read_only <- TRUE
    if (!(is.logical(read_only) && length(read_only) == 1))
        stop("'read_only' must be a logical value", call. = FALSE)

    if (missing(group_name) || is.null(group_name) || all(is.na(group_name)))
        group_name <- ""
    if (!(is.character(group_name) && length(group_name) == 1))
        stop("'group_name' must be a character string", call. = FALSE)

    if (missing(view_expr) || is.null(view_expr) || all(is.na(view_expr)))
        view_expr <- ""
    if (!(is.character(view_expr) && length(view_expr) == 1))
        stop("'view_expr' must be a character string", call. = FALSE)

    if (missing(allowed_drivers) || all(is.na(allowed_drivers)))
        allowed_drivers <- NULL
    if (!is.null(allowed_drivers)) {
        if (!is.character(allowed_drivers))
            stop("'allowed_drivers' must be a character vector", call. = FALSE)
    }

    if (missing(open_options) || all(is.na(open_options)))
        open_options <- NULL
    if (!is.null(open_options)) {
        if (!is.character(open_options))
            stop("'open_options' must be a character vector", call. = FALSE)
    }

    # signature for mdim_as_classic() object factory
    ds <- new(GDALRaster, dsn, array_name, idx_xdim, idx_ydim, read_only,
              group_name, view_expr, allowed_drivers, open_options)

    return(ds);
}

.gdalraster_env <- new.env()

.gdalraster_finalizer <- function(env) {
    # clean-up for /vsicurl/ and related file systems
    push_error_handler("quiet")
    .cpl_http_cleanup()
    pop_error_handler()
}

.onLoad <- function(libname, pkgname) {
    # set environment variables on Windows
    if (dir.exists(system.file("proj", package="gdalraster"))) {
        gdalraster_proj <- system.file("proj", package="gdalraster")
        proj_path_set <- FALSE
        path_api <- proj_search_paths(gdalraster_proj)
        if (normalizePath(path_api) == normalizePath(gdalraster_proj))
            proj_path_set <- TRUE
        if (!proj_path_set) {
            assign(".orig_proj_lib", Sys.getenv("PROJ_LIB"),
                   envir=.gdalraster_env)
            Sys.setenv("PROJ_LIB" = gdalraster_proj)
        }
    }
    if (dir.exists(system.file("gdal", package="gdalraster"))) {
        assign(".orig_gdal_data", Sys.getenv("GDAL_DATA"),
               envir=.gdalraster_env)
        Sys.setenv("GDAL_DATA" = system.file("gdal", package="gdalraster"))
    }

    # register a finalizer for cleanup at the end of an R session
    reg.finalizer(.gdalraster_env, .gdalraster_finalizer, onexit = TRUE)
}

.onAttach <- function(libname, pkgname) {
    gdal_date <- as.character(as.Date(gdal_version()[3], format = "%Y%m%d"))
    msg <- paste0("GDAL ", gdal_version()[4], " (released ", gdal_date, ")")
    if (!is.na(geos_version()$name))
        geos_ver <- geos_version()$name
    else
        geos_ver <- "(version NA)"
    msg <- paste0(msg, ", GEOS ", geos_ver)
    if (!is.na(proj_version()$name))
        proj_ver <- proj_version()$name
    else
        proj_ver <- "(version NA)"
    msg <- paste0(msg, ", PROJ ", proj_ver)
    packageStartupMessage(msg)
}

.onUnload <- function(libname, pkgname) {
    # reset env variables to original values on Windows
    if (dir.exists(system.file("proj", package="gdalraster"))) {
        if (exists(".orig_proj_lib", where=.gdalraster_env))
            Sys.setenv("PROJ_LIB"=get(".orig_proj_lib", envir=.gdalraster_env))
    }
    if (dir.exists(system.file("gdal", package="gdalraster"))) {
        Sys.setenv("GDAL_DATA"=get(".orig_gdal_data", envir=.gdalraster_env))
    }
    .gdalraster_finalizer(.gdalraster_env)
}

# Display raster data using base graphics

#' @noRd
.normalize <- function(x, minmax=NULL) {
    # Normalize to a range of [0,1].
    # Normalize to the full range of the input data by default.
    # Optionally normalize to a user-defined range in terms of the input.

    if (is.null(minmax)) {
        xn <- (x - min(x,na.rm=TRUE)) / (max(x,na.rm=TRUE) - min(x,na.rm=TRUE))
    } else {
        xn <- (x - minmax[1]) / (minmax[2] - minmax[1])
        xn[xn < 0] <- 0
        xn[xn > 1] <- 1
    }

    return(xn)
}

#' @noRd
.as_raster <- function(a,
                       col_tbl=NULL,
                       maxColorValue=1,
                       normalize=TRUE,
                       minmax_def=NULL,
                       minmax_pct_cut=NULL,
                       col_map_fn=NULL,
                       na_col=rgb(0,0,0,0),
                       ...) {

    # Create an object of class "raster", a matrix of color values representing
    # a bitmap image for input to graphics::rasterImage(). Input is an array of
    # pixel values with dimensions xsize, ysize, nbands.

    nbands <- dim(a)[3]

    if (!(nbands %in% c(1, 3)))
        stop("number of bands must be 1 or 3", call.=FALSE)

    r <- array()

    if (!is.null(col_tbl)) {
        # map to a color table
        if (nbands != 1)
            stop("color table can only be used with single-band data",
                 call.=FALSE)

        ct <- as.data.frame(col_tbl)
        if (ncol(ct) < 4 || ncol(ct) > 5)
            stop("color table must have four or five columns", call.=FALSE)

        if (ncol(ct) == 4) # add alpha channel
            ct[, 5] <- rep(maxColorValue, nrow(ct))
        ct[, 6] <- rgb(ct[, 2], ct[, 3], ct[, 4], ct[, 5],
                       maxColorValue=maxColorValue)
        names(ct) <- c("value", "r", "g", "b", "a", "rgb")
        r <- ct$rgb[match(as.vector(a), ct$value)]

        if (anyNA(r))
            r[is.na(r)] <- na_col
        dim(r) <- dim(a)[2:1]
        class(r) <- "raster"

    } else {
        # gray/rgb color scaling
        if (normalize) {
            if (!is.null(minmax_def)) {
                for (b in 1:nbands) {
                    a[,,b] <- .normalize(a[,,b], minmax_def[c(b, b+nbands)])
                }
            } else if (!is.null(minmax_pct_cut)) {
                for (b in 1:nbands) {
                    q <- stats::quantile(a[,,b],
                                         probs=c(minmax_pct_cut[1] / 100,
                                                 minmax_pct_cut[2] / 100),
                                         na.rm = TRUE,
                                         names = FALSE)
                    a[,,b] <- .normalize(a[,,b], q)
                }
            } else {
                for (b in 1:nbands) {
                    a[,,b] <- .normalize(a[,,b])
                }
            }
        }

        if (is.null(col_map_fn))
            col_map_fn <- ifelse(nbands==1, grDevices::gray, grDevices::rgb)

        has_na <- FALSE
        nas <- array()
        if (anyNA(a)) {
            has_na <- TRUE
            nas <- is.na(a)
            a[nas] <- 0
            if (dim(nas)[3] == 3)
                nas <- nas[,,1] | nas[,,2] | nas[,,3]
            dim(nas) <- dim(nas)[1:2]
            nas <- t(nas)
        }

        if (nbands == 1) {
            # grayscale
            dim(a) <- dim(a)[1:2]
            r <- col_map_fn(a)
            dim(r) <- dim(a)[2:1]
            class(r) <- "raster"
        } else {
            # rgb
            r <- col_map_fn(a[,,1], a[,,2], a[,,3])
            dim(r) <- dim(a)[2:1]
            class(r) <- "raster"
        }

        if (has_na)
            r[nas] <- na_col
    }

    return(r)
}

#' Display raster data
#'
#' `plot_raster()` displays raster data using base `graphics`.
#'
#' @details
#' By default, contrast enhancement by stretch to min/max is applied when
#' the input data are single-band grayscale with any raster data type, or
#' three-band RGB with raster data type larger than Byte (=UInt8 in
#' GDAL >= 3.13). The minimum/maximum of the input data are used by default
#' (i.e., no outlier removal). No stretch is applied by default when the input
#' is an RGB byte raster. These defaults can be overridden by specifying either
#' the `minmax_def` argument (user-defined min/max per band), or the
#' `minmax_pct_cut` argument (ignore outlier pixels based on a percentile range
#' per band). These settings (and the `normalize` argument) are ignored if a
#' color table is used.
#'
#' @param data Either a `GDALRaster` object from which data will be read, or
#' a numeric vector of pixel values arranged in left to right, top to
#' bottom order, or a list of band vectors. If input is vector or list,
#' the information in attribute `gis` will be used if present (see [read_ds()]),
#' potentially ignoring values below for `xsize`, `ysize`, `nbands`.
#' @param xsize The number of pixels along the x dimension in `data`. If `data`
#' is a `GDALRaster` object, specifies the size at which the raster will be
#' read (used for argument `out_xsize` in `GDALRaster$read()`). By default,
#' the entire raster will be read at full resolution.
#' @param ysize The number of pixels along the y dimension in `data`. If `data`
#' is a `GDALRaster` object, specifies the size at which the raster will be
#' read (used for argument `out_ysize` in `GDALRaster$read()`). By default,
#' the entire raster will be read at full resolution.
#' @param nbands The number of bands in `data`. Must be either 1 (grayscale) or
#' 3 (RGB). For RGB, `data` are interleaved by band. If `nbands` is `NULL` (the
#' default), then `nbands = 3` is assumed if the input data contain 3 bands,
#' otherwise band 1 is used.
#' @param max_pixels The maximum number of pixels that the function will
#' attempt to display (per band). An error is raised if `(xsize * ysize)`
#' exceeds this value. Setting to `NULL` turns off this check.
#' @param col_tbl A color table as a matrix or data frame with four or five
#' columns. Column 1 contains the numeric pixel values. Columns 2:4 contain
#' the intensities of the red, green and blue primaries (`0:1` by default,
#' or use integer `0:255` by setting `maxColorValue = 255`).
#' An optional column 5 may contain alpha transparency values, `0` for fully
#' transparent to `1` (or `maxColorValue`) for opaque (the default if column 5
#' is missing). If `data` is a `GDALRaster` object, a built-in color table will
#' be used automatically if one exists in the dataset.
#' @param maxColorValue A number giving the maximum of the color values range
#' in `col_tbl` (see above). The default is `1`.
#' @param normalize Logical. `TRUE` to rescale pixel values so that their
#' range is `[0,1]`, normalized to the full range of the pixel data by default
#' (`min(data)`, `max(data)`, per band). Ignored if `col_tbl` is used.
#' Set `normalize` to `FALSE` if a color map function is used that
#' operates on raw pixel values (see `col_map_fn` below).
#' @param minmax_def Normalize to user-defined min/max values (in terms of
#' the pixel data, per band). For single-band grayscale, a numeric vector of
#' length two containing min, max. For 3-band RGB, a numeric vector of length
#' six containing b1_min, b2_min, b3_min, b1_max, b2_max, b3_max.
#' @param minmax_pct_cut Normalize to a truncated range of the pixel data using
#' percentile cutoffs (removes outliers). A numeric vector of length two giving
#' the percentiles to use (e.g., `c(2, 98)`). Applied per band. Ignored if
#' `minmax_def` is used.
#' @param col_map_fn An optional color map function that maps input pixel values
#' to colors in "#RRGGBB" (or "#RRGGBBAA") character form (default is
#' `grDevices::gray` for single-band data or `grDevices::rgb` for 3-band).
#' Ignored if `col_tbl` is used. Set `normalize = FALSE` if using a color
#' map function that operates on raw pixel values. This argument can also be
#' given as a color palette, in which case a color-ramp function is assumed.
#' The color palette can be a character vector of `"#RRGGBB"` or `"#RRGGBBAA"`,
#' color names from `grDevices::colors()`, or a positive integer that indexes
#' into `grDevices::palette()` (i.e., must be a valid argument to
#' `grDevices::col2rgb()`).
#' @param pixel_fn An optional function that will be applied to the input
#' pixel data. Must accept vector input and return a numeric vector of the same
#' length as its input.
#' @param xlim Numeric vector of length two giving the x coordinate range.
#' If `data` is a `GDALRaster` object, the default is the raster xmin, xmax in
#' georeferenced coordinates, otherwise the default uses pixel/line
#' coordinates (`c(0, xsize)`).
#' @param ylim Numeric vector of length two giving the y coordinate range.
#' If `data` is a `GDALRaster` object, the default is the raster ymin, ymax in
#' georeferenced coordinates, otherwise the default uses pixel/line
#' coordinates (`c(ysize, 0)`).
#' @param xlab Title for the x axis (see `?title`).
#' @param ylab Title for the y axis (see `?title`).
#' @param interpolate Logical indicating whether to apply linear interpolation
#' to the image when drawing (default `TRUE`).
#' @param asp Numeric. The aspect ratio y/x (see `?plot.window`).
#' @param xaxs The style of axis interval calculation to be used for the x axis
#' (see `?par`).
#' @param yaxs The style of axis interval calculation to be used for the y axis
#' (see `?par`).
#' @param axes Logical. `TRUE` to draw axes (the default).
#' @param main The main title (on top).
#' @param legend Logical indicating whether to include a legend on the plot.
#' Currently, legends are only supported for continuous data. A color table
#' will be used if one is specified or the raster has a built-in color table,
#' otherwise the value for `col_map_fn` will be used.
#' @param digits The number of digits to display after the decimal point in
#' the legend labels when raster data are floating point.
#' @param na_col Color to use for `NA` as a 7- or 9-character hexadecimal code.
#' The default is transparent (`"#00000000"`, the return value of
#' `rgb(0,0,0,0)`).
#' @param ... Other parameters to be passed to `plot.default()`.
#'
#' @note
#' `plot_raster()` uses the function `graphics::rasterImage()` for plotting
#' which is not supported on some devices (see `?rasterImage`).
#'
#' If `data` is an object of class `GDALRaster`, then `plot_raster()` will
#' attempt to read the entire raster into memory by default (unless the number
#' of pixels per band would exceed `max_pixels`).
#' A reduced resolution overview can be read by setting `xsize`, `ysize`
#' smaller than the raster size on disk.
#' (If `data` is instead specified as a vector of pixel values, a reduced
#' resolution overview would be read by setting `out_xsize` and `out_ysize`
#' smaller than the raster region defined by `xsize`, `ysize` in a call to
#' `GDALRaster$read()`).
#' The GDAL_RASTERIO_RESAMPLING configuration option can be
#' defined to override the default resampling (NEAREST) to one of BILINEAR,
#' CUBIC, CUBICSPLINE, LANCZOS, AVERAGE or MODE, for example:
#' \preformatted{
#' set_config_option("GDAL_RASTERIO_RESAMPLING", "BILINEAR")
#' }
#'
#' @seealso
#' [`GDALRaster$read()`][GDALRaster], [read_ds()], [set_config_option()]
#'
#' @examples
#' ## Elevation
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' ds <- new(GDALRaster, elev_file)
#'
#' # all other arguments are optional when passing a GDALRaster object
#' # grayscale
#' plot_raster(ds, legend = TRUE, main = "Storm Lake elevation (m)")
#'
#' # color ramp from a user-defined palette: the `col_map_fn` can optionally
#' # be given as a color palette, for which a color ramp function is assumed
#' pal <- c("#00A60E", "#63C600", "#E6E600", "#E9BD3B", "#ECB176", "#EFC2B3",
#'          "#F2F2F2")
#'
#' plot_raster(ds, col_map_fn = pal, legend = TRUE,
#'             main = "Storm Lake elevation (m)")
#'
#' ds$close()
#'
#' ## Landsat band combination
#' b4_file <- system.file("extdata/sr_b4_20200829.tif", package="gdalraster")
#' b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
#' b6_file <- system.file("extdata/sr_b6_20200829.tif", package="gdalraster")
#' band_files <- c(b6_file, b5_file, b4_file)
#'
#' vrt_file <- file.path(tempdir(), "storml_b6_b5_b4.vrt")
#' buildVRT(vrt_file, band_files, cl_arg = "-separate")
#'
#' ds <- new(GDALRaster, vrt_file)
#'
#' plot_raster(ds, main = "Landsat 6-5-4 (vegetative analysis)")
#'
#' ds$close()
#' \dontshow{vsi_unlink(vrt_file)}
#'
#' ## LANDFIRE Existing Vegetation Cover (EVC) with color map
#' evc_file <- system.file("extdata/storml_evc.tif", package="gdalraster")
#'
#' # colors from the CSV attribute table distributed by LANDFIRE
#' evc_csv <- system.file("extdata/LF20_EVC_220.csv", package="gdalraster")
#' vat <- read.csv(evc_csv)
#' head(vat)
#' vat <- vat[, c(1, 6:8)]
#'
#' ds <- new(GDALRaster, evc_file)
#' plot_raster(ds, col_tbl = vat, interpolate = FALSE,
#'             main = "Storm Lake LANDFIRE EVC")
#'
#' ds$close()
#'
#' ## Apply a pixel function
#' if (requireNamespace("scales")) {
#'   f <- system.file("extdata/complex.tif", package="gdalraster")
#'   ds <- new(GDALRaster, f)
#'   ds$getDataTypeName(band = 1)  # complex floating point
#'
#'   plot_raster(ds,
#'               pixel_fn = Arg,
#'               col_map_fn = scales::pal_viridis(option = "plasma")(6),
#'               interpolate = FALSE,
#'               legend = TRUE,
#'               main = "Arg(complex.tif)")
#'
#'   ds$close()
#' }
#' @export
plot_raster <- function(data, xsize=NULL, ysize=NULL, nbands=NULL,
                        max_pixels=2.5e7, col_tbl=NULL, maxColorValue=1,
                        normalize=TRUE, minmax_def=NULL, minmax_pct_cut=NULL,
                        col_map_fn=NULL, pixel_fn=NULL, xlim=NULL, ylim=NULL,
                        interpolate=TRUE, asp=1, axes=TRUE, main="",
                        xlab="x", ylab="y", xaxs="i", yaxs="i",
                        legend=FALSE, digits=2, na_col=rgb(0,0,0,0), ...) {

    if (isTRUE((grDevices::dev.capabilities()$rasterImage == "no"))) {
        message("device does not support 'rasterImage()'")
        return()
    }

    if (!is.null(nbands)) {
        if (!(nbands %in% c(1, 3)))
            stop("number of bands must be 1 or 3", call. = FALSE)
    }

    if (is.null(max_pixels))
        max_pixels <- Inf

    if (!is.null(col_map_fn)) {
        if (!is.function(col_map_fn)) {
            # assume a palette was given for implied color ramp function
            pal <- col_map_fn
            # use `colour_ramp()` from suggested package {scales} if available,
            # else fall back to built-in {grDevices}
            if (requireNamespace("scales", quietly = TRUE)) {
                col_map_fn <- scales::colour_ramp(pal, alpha = FALSE)
            } else {
                col_map_fn <- function(x) {
                    ramp <- grDevices::colorRamp(pal)
                    return(ramp(x) |> grDevices::rgb(maxColorValue = 255))
                }
            }
        }
    }

    if (!is.null(pixel_fn)) {
        if (!is.function(pixel_fn))
            stop("'pixel_fn' must be a function", call. = FALSE)
    }

    data_in <- NULL
    is_byte_raster <- TRUE
    south_up <- FALSE

    if (is(data, "Rcpp_GDALRaster")) {
        dm <- as.numeric(data$dim()) ## prevent integer overflow

        if (is.null(xsize))
            xsize <- out_xsize <- dm[1]
        else
            out_xsize <- trunc(xsize)

        if (is.null(ysize))
            ysize <- out_ysize <- dm[2]
        else
            out_ysize <- trunc(ysize)

        if ((out_xsize*out_ysize) > max_pixels)
            stop("'xsize * ysize' exceeds 'max_pixels'", call.=FALSE)

        if (is.null(nbands)) {
            if (data$getRasterCount() == 3)
                nbands <- 3
            else
                nbands <- 1
        }

        for (b in 1:nbands) {
            # GDALGetDataTypeName() still returns "Byte" for GDT_UInt8, not
            # changing to "UInt8" until GDAL 4 possibly
            if (data$getDataTypeName(b) != "Byte")
                is_byte_raster <- FALSE
        }

        data_in <- read_ds(data, bands=1:nbands, xoff=0, yoff=0,
                           xsize=dm[1], ysize=dm[2],
                           out_xsize=out_xsize, out_ysize=out_ysize)

        if (nbands==1 && is.null(col_tbl) && is.null(col_map_fn)) {
            # check for a built-in color table
            if (!is.null(data$getColorTable(band=1)) &&
                data$getPaletteInterp(band=1)=="RGB") {

                col_tbl <- data$getColorTable(band=1)
                maxColorValue <- 255
            }
        }

        gt <- data$getGeoTransform()
        if (is.null(xlim))
            xlim <- c(gt[1], gt[1] + gt[2] * dm[1])
        if (is.null(ylim)) {
            ylim <- c(gt[4] + gt[6] * dm[2], gt[4])
            if (gt[6] > 0) {
                south_up <- TRUE
                ylim <- rev(ylim)
            }
        }

    } else if (!is.null(attr(data, "gis"))) {
        gis <- attr(data, "gis")

        if (is.list(data))
            data_in <- unlist(data, use.names=FALSE)
        else
            data_in <- data

        xlim <- c(gis$bbox[1], gis$bbox[3])
        ylim <- c(gis$bbox[2], gis$bbox[4])
        xsize <- gis$dim[1]
        ysize <- gis$dim[2]

        if ((xsize*ysize) > max_pixels)
            stop("'xsize * ysize' exceeds 'max_pixels'", call.=FALSE)

        if (is.null(nbands)) {
            if (gis$dim[3] == 1)
                nbands <- 1
            else if (gis$dim[3] == 3)
                nbands <- 3
            else
                stop("'nbands' must be 1 or 3", call.=FALSE)
        } else {
            if (nbands != gis$dim[3]) {
                stop("'nbands' does not match the input data", call. = FALSE)
            }
        }

        if (is.list(data)) {
            if (nbands != length(data))
                stop("'nbands' is not equal to 'length(data)'", call.=FALSE)
        }

        for (b in 1:nbands) {
            # in case we get "UInt8" possibly in the gis attributes GDAL >= 3.13
            if (gis$datatype[b] != "Byte" && gis$datatype[b] != "UInt8")
                is_byte_raster <- FALSE
        }

    } else {
        if (is.null(nbands))
            stop("'nbands' cannot be determined from 'data'", call.=FALSE)

        if (is.null(xsize) || is.null(ysize))
            stop("'xsize' and 'ysize' of data must be specified", call.=FALSE)

        if ((xsize*ysize) > max_pixels)
            stop("'xsize * ysize' exceeds 'max_pixels'", call.=FALSE)

        if (is.list(data))
            data_in <- unlist(data, use.names=FALSE)
        else
            data_in <- data

        if (is.null(xlim))
            xlim <- c(0, xsize)
        if (is.null(ylim))
            ylim <- c(ysize, 0)

        is_byte_raster <- FALSE  # unknown
    }

    if (nbands == 3 && is_byte_raster && normalize &&
            is.null(minmax_def) && is.null(minmax_pct_cut)) {

        # default to no stretch for RGB Byte raster
        minmax_def <- c(0, 0, 0, 255, 255, 255)
    }

    if (typeof(data_in) == "raw") {
        data_in <- as.integer(data_in)
    }

    if (!is.null(pixel_fn)) {
        data_in <- pixel_fn(data_in)
    }

    if (typeof(data_in) == "complex") {
        stop("specify 'pixel_fn' when plotting complex data types",
             call. = FALSE)
    }

    if (south_up)
        data_in <- .flip_vertical(data_in, xsize, ysize, nbands)

    a <- array(data_in, dim = c(xsize, ysize, nbands))
    r <- .as_raster(a,
                    col_tbl=col_tbl,
                    maxColorValue=maxColorValue,
                    normalize=normalize,
                    minmax_def=minmax_def,
                    minmax_pct_cut=minmax_pct_cut,
                    col_map_fn=col_map_fn,
                    na_col=na_col)

    if (legend && nbands != 1) {
        message("legend is not supported for RGB plot")
        legend <- FALSE
    }

    ##
    ## NOTE: change scope of the initial par() call if it is used for other
    ##       than the legend
    if (legend) {
        if (is.null(col_map_fn))
            col_map_fn <- grDevices::gray
        op <- graphics::par(no.readonly = TRUE)
        on.exit(graphics::par(op))
        graphics::layout(matrix(1:2, ncol=2), width=c(6,1), height=c(1,1))
        graphics::par(mar=c(5, 4, 4, 0.5) + 0.1)
    }

    graphics::plot.new()
    graphics::plot.window(xlim=xlim, ylim=ylim, asp=asp,
                          xaxs=xaxs, yaxs=yaxs, ...)
    graphics::rasterImage(r, xlim[1], ylim[1], xlim[2], ylim[2],
                          interpolate=interpolate)

    if (axes) {
        graphics::title(main=main, xlab=xlab, ylab=ylab)
        graphics::axis(1)
        graphics::axis(2)
    } else {
        graphics::title(main=main)
    }

    if (legend) {
        mm <- NULL # define legend min/max
        if (!is.null(minmax_def))
            mm <- minmax_def
        else if (!is.null(minmax_pct_cut))
            mm <- stats::quantile(data_in,
                                  probs=c(minmax_pct_cut[1] / 100,
                                          minmax_pct_cut[2] / 100),
                                  na.rm = TRUE,
                                  names=FALSE)
        else
            mm <- c(min(data_in, na.rm=TRUE), max(data_in, na.rm=TRUE))

        if (is.null(col_tbl)) {
            # continuous data with col_map_fn (the default)
            leg_data <- seq(mm[1], mm[2], length.out=256)
            if (normalize)
                leg_data <- .normalize(leg_data, mm)
            leg_data <- sort(leg_data, decreasing=TRUE)
            leg_data <- col_map_fn(leg_data)
            leg_img <- grDevices::as.raster(matrix(leg_data, ncol=1))

        } else {
            # continuous data with col_tbl
            leg_data <- sort(seq(mm[1], mm[2], by=1), decreasing=TRUE)
            leg_data <- array(leg_data, dim=c(1, length(leg_data), 1))
            leg_img <- .as_raster(leg_data,
                                  col_tbl=col_tbl,
                                  maxColorValue=maxColorValue,
                                  na_col=na_col)
        }

        graphics::par(mar=c(6, 0.5, 6, 2) + 0.1)
        graphics::plot(c(0,2), c(0,1), type="n", axes=FALSE,
                       xlab="", ylab="", main="")

        if (is(data_in, "integer"))
            leg_lab <- formatC(seq(mm[1], mm[2], length.out=5), format="d")
        else
            leg_lab <- formatC(seq(mm[1], mm[2], length.out=5), format="f",
                               digits=digits)

        graphics::text(x=1.5,
                       y=seq(0, 1, length.out=5),
                       labels=leg_lab,
                       adj=c(0, NA),
                       xpd=TRUE)
        graphics::rasterImage(leg_img, 0, 0, 1, 1)
    }

    invisible()
}

#' Plot WKT or WKB geometries
#'
#' `plot_geom()` plots one or more geometries given as either WKT or WKB raw
#' vectors, using `wk::wk_plot()`.
#'
#' @param x Either a character vector containing one or more WKT strings, a raw
#' vector of WKB, or a list of WKB raw vectors.
#' @param xlab Title for the x axis.
#' @param ylab Title for the y axis.
#' @param main The main title (on top).
#' @param ... Optional arguments passed to `wk::wk_plot()`.
#' @return The input, invisibly.
#'
#' @examples
#' # a Delaunay triangulation of 10 random points
#' set.seed(4)
#' x <- sample.int(100, 10)
#' y <- sample.int(100, 10)
#'
#' g <- g_create("MULTIPOINT", cbind(x, y))
#' g_wk2wk(g)
#'
#' plot_geom(g)
#'
#' g2 <- g_delaunay_triangulation(g)
#' g_wk2wk(g2)
#'
#' plot_geom(g2, add = TRUE)
#' @export
plot_geom <- function(x, xlab = "x", ylab = "y",  main = "", ...) {
     if (!requireNamespace("vctrs", quietly = TRUE))
        cat("wk::wk_plot() requires suggested package 'vctrs'\n")

    geom_in <- NULL
    if (is.raw(x)) {
        geom_in <- list(x)
    } else if (is.list(x) && length(x) > 0 && is.raw(x[[1]])) {
        geom_in <- x
    } else if (is.character(x)) {
        if (length(x) == 1)
            geom_in <- list(g_wk2wk(x))
        else
            geom_in <- g_wk2wk(x)
    } else {
        stop("'x' must be a character vector, raw vector or list",
             call. = FALSE)
    }

    wk_obj <- wk::wkb(geom_in)
    wk::wk_plot(wk_obj, ..., xlab = xlab, ylab = ylab)
    graphics::title(main = main)

    invisible(x)
}

test_that("plot_raster works", {
    if (.Platform$OS.type == "unix" && !grepl("^darwin", R.version$os))
        skip_if_not(capabilities("X11"))

    # grayscale
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    ds <- new(GDALRaster, elev_file)
    expect_silent(plot_raster(ds, legend = TRUE))
    # giving a color palette for col_map_fn (implied ramp function)
    pal <- c("#00A60E", "#63C600", "#E6E600", "#E9BD3B", "#ECB176", "#EFC2B3",
             "#F2F2F2")
    expect_silent(plot_raster(ds, col_map_fn = pal, legend = TRUE))
    ds$close()

    # rgb
    b4_file <- system.file("extdata/sr_b4_20200829.tif", package="gdalraster")
    b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
    b6_file <- system.file("extdata/sr_b6_20200829.tif", package="gdalraster")
    band_files <- c(b6_file, b5_file, b4_file)
    ds <- new(GDALRaster, b5_file)
    dm <- ds$dim()
    ds$close()
    r <- vector("integer")
    for (f in band_files) {
        ds <- new(GDALRaster, f)
        r <- c(r, read_ds(ds))
        ds$close()
    }
    expect_silent(plot_raster(r, xsize = dm[1], ysize = dm[2], nbands = 3,
                              minmax_def = c(7551,7679,7585,14842,24997,12451)))
    expect_silent(plot_raster(r, xsize = dm[1], ysize = dm[2], nbands = 3,
                              minmax_pct_cut = c(2,98)))

    # color table
    evc_file <- system.file("extdata/storml_evc.tif", package="gdalraster")
    evc_vat <- system.file("extdata/LF20_EVC_220.csv", package="gdalraster")
    vat <- read.csv(evc_vat)
    vat <- vat[, c(1,6:8)]
    ds <- new(GDALRaster, evc_file)
    # dm <- ds$dim()
    r <- read_ds(ds)
    ds$close()
    expect_silent(plot_raster(r, col_tbl = vat, interpolate = FALSE))

    # as_list
    ds$open(TRUE)
    r <- read_ds(ds, as_list = TRUE)
    ds$close()
    expect_silent(plot_raster(r, col_tbl = vat, interpolate = FALSE))

    # built-in color table
    tcc_file <- system.file("extdata/storml_tcc.tif", package="gdalraster")
    ds <- new(GDALRaster, tcc_file)
    expect_silent(plot_raster(ds, legend = TRUE))
    ds$close()

    # complex data type
    f <- system.file("extdata/complex.tif", package="gdalraster")
    ds <- new(GDALRaster, f)
    expect_error(plot_raster(ds))
    # with pixel function
    expect_silent(plot_raster(ds, pixel_fn = Arg, interpolate = FALSE))
    ds$close()
})

test_that("plot_geom works", {
    if (.Platform$OS.type == "unix" && !grepl("^darwin", R.version$os))
        skip_if_not(capabilities("X11"))

    # wk suggested package vctrs is required for wk::wk_plot()
    skip_if(!requireNamespace("vctrs", quietly = TRUE))

    x <- sample.int(100, 10)
    y <- sample.int(100, 10)
    g <- g_create("MULTIPOINT", cbind(x, y))
    expect_identical(plot_geom(g), g)
})

#' @name CmbTable-class
#'
#' @aliases
#' Rcpp_CmbTable Rcpp_CmbTable-class CmbTable
#'
#' @title Class for counting unique combinations of integers
#'
#' @description
#' `CmbTable` implements a hash table having a vector of integers as the key,
#' and the count of occurrences of each unique integer combination as the
#' value. A unique ID is assigned to each unique combination of input values.
#'
#' `CmbTable` is a C++ class exposed directly to \R (via `RCPP_EXPOSED_CLASS`).
#' Methods of the class are accessed using the `$` operator. **Note that all
#' arguments to class methods are required and must be given in the
#' order documented.** Naming the arguments is optional but may be preferred
#' for readability.
#'
#' @param keyLen The number of integer values comprising each combination.
#' @param varNames Optional character vector of names for the variables in the
#' combination.
#' @returns An object of class `CmbTable`. Contains a hash table having a
#' vector of `keyLen` integers as the key, and the count of occurrences of each
#' unique integer combination as the value. Class methods that operate on the
#' hash table are described in Details.
#'
#' @section Usage (see Details):
#' ```
#' ## Constructors
#' cmb <- new(CmbTable, keyLen)
#' # or, giving the variable names:
#' cmb <- new(CmbTable, keyLen, varNames)
#'
#' ## Methods
#' cmb$update(int_cmb, incr)
#' cmb$updateFromMatrix(int_cmbs, incr)
#' cmb$updateFromMatrixByRow(int_cmbs, incr)
#' cmb$asDataFrame()
#' cmb$asMatrix()
#' ```
#'
#' @section Details:
#' ## Constructors
#'
#' \code{new(CmbTable, keyLen)}\cr
#' Default variable names will be assigned as `V1`, `V2`, ....
#' Returns an object of class `CmbTable`.
#'
#' \code{new(CmbTable, keyLen, varNames)}\cr
#' Alternate constructor to specify variable names.
#' Returns an object of class `CmbTable`.
#'
#' ## Methods
#'
#' \code{$update(int_cmb, incr)}\cr
#' Updates the hash table for the integer combination in the numeric vector
#' `int_cmb` (will be coerced to integer by truncation).
#' If this combination exists in the table, its count will be
#' incremented by `incr`. If the combination is not found in the table,
#' it will be inserted with count set to `incr`. The caller should ensure that
#' the length of the input vector is equal to the key length (`keyLen`) when
#' using this method. Returns the unique ID assigned to this combination.
#' Combination IDs are sequential whole numbers starting at `1`.
#'
#' \code{$updateFromMatrix(int_cmbs, incr)}\cr
#' This method is the same as \code{$update()} but for a numeric matrix of
#' integer combinations `int_cmbs` (coerced to integer by truncation).
#' The matrix is arranged with each column vector forming an integer
#' combination. For example, the rows of the matrix could be
#' one row each from a set of `keyLen` rasters all read at the
#' same extent and pixel resolution (i.e., row-by-row raster overlay).
#' The method calls \code{$update()} on each combination (each column of
#' `int_cmbs`), incrementing count by `incr` for existing
#' combinations, or inserting new combinations with count set to `incr`.
#' Returns a numeric vector of length `ncol(int_cmbs)` containing the
#' IDs assigned to the combinations.
#'
#' \code{$updateFromMatrixByRow(int_cmbs, incr)}\cr
#' This method is the same as \code{$updateFromMatrix()} above except the
#' integer combinations are in rows of the matrix `int_cmbs` (columns
#' are the variables).
#' The method calls \code{$update()} on each combination (each row of
#' `int_cmbs`), incrementing count by `incr` for existing
#' combinations, or inserting new combinations with count set to `incr`.
#' Returns a numeric vector of length `nrow(int_cmbs)` containing the
#' IDs assigned to the combinations.
#'
#' \code{$asDataFrame()}\cr
#' Returns the `CmbTable` as a data frame with column `cmbid` containing
#' the unique combination IDs, column `count` containing the counts of
#' occurrences, and `keyLen` columns (with names from `varNames`) containing
#' the integer values comprising each unique combination.
#'
#' \code{$asMatrix()}\cr
#' Returns the `CmbTable` as a matrix with column `1` (`cmbid`)
#' containing the unique combination IDs, column `2` (`count`)
#' containing the counts of occurrences, and columns `3:keyLen+2`
#' (with names from `varNames`) containing the integer values comprising each
#' unique combination.
#'
#' @examples
#' m <- matrix(c(1,2,3,1,2,3,4,5,6,1,3,2,4,5,6,1,1,1), 3, 6, byrow = FALSE)
#' rownames(m) <- c("layer1", "layer2", "layer3")
#' print(m)
#'
#' cmb <- new(CmbTable, 3, rownames(m))
#' cmb
#'
#' cmb$updateFromMatrix(m, 1)
#' cmb$asDataFrame()
#'
#' cmb$update(c(4,5,6), 1)
#' cmb$update(c(1,3,5), 1)
#' cmb$asDataFrame()
#'
#' # same as above but matrix arranged with integer combinations in the rows
#' m <- matrix(c(1,2,3,1,2,3,4,5,6,1,3,2,4,5,6,1,1,1), 6, 3, byrow = TRUE)
#' colnames(m) <- c("V1", "V2", "V3")
#' print(m)
#'
#' cmb <- new(CmbTable, 3)
#' cmb$updateFromMatrixByRow(m, 1)
#' cmb$asDataFrame()
#'
#' cmb$update(c(4,5,6), 1)
#' cmb$update(c(1,3,5), 1)
#' cmb$asDataFrame()
NULL

Rcpp::loadModule("mod_cmb_table", TRUE)

#' @name GDALVector-class
#'
#' @aliases
#' Rcpp_GDALVector Rcpp_GDALVector-class GDALVector
#'
#' @title Class encapsulating a vector layer in a GDAL dataset
#'
#' @description
#' `GDALVector` provides an interface for accessing a vector layer in a GDAL
#' dataset and calling methods on the underlying `OGRLayer` object.
#' An object of class `GDALVector` persists an open connection to the dataset,
#' and exposes methods to:
#' * retrieve layer information
#' * set attribute and spatial filters
#' * set a list of ignored or selected columns
#' * traverse and read feature data by traditional row-based cursor, including
#' an analog of `DBI::dbFetch()`
#' * read via column-oriented Arrow Array stream
#' * write new features in a layer
#' * edit/overwrite existing features
#' * upsert
#' * delete features
#' * perform data manipulation within transactions.
#'
#' `GDALVector` is a C++ class exposed directly to \R (via `RCPP_EXPOSED_CLASS`).
#' Fields and methods of the class are accessed using the `$` operator. **Note
#' that all arguments to class methods are required and must be given in the
#' order documented.** Most `GDALVector` methods take zero or one argument, so
#' this is usually not an issue. Class constructors are the main exception.
#' Naming the arguments is optional but may be preferred for readability.
#'
#' @param dsn Character string containing the data source name (DSN), usually a
#' filename or database connection string.
#' @param layer Character string containing the name of a layer within the
#' data source. May also be given as an SQL SELECT statement to be executed
#' against the data source, defining a layer as the result set.
#' @param read_only Logical scalar. `TRUE` to open the layer read-only (the
#' default), or `FALSE` to open with write access.
#' @param open_options Optional character vector of `NAME=VALUE` pairs
#' specifying dataset open options.
#' @param spatial_filter Optional character string containing a geometry in
#' Well Known Text (WKT) format which represents a spatial filter.
#' @param dialect Optional character string to control the statement dialect
#' when SQL is used to define the layer. By default, the OGR SQL engine will
#' be used, except for RDBMS drivers that will use their dedicated SQL engine,
#' unless `"OGRSQL"` is explicitly passed as the dialect. The `"SQLITE"`
#' dialect can also be used.
#' @returns An object of class `GDALVector`, which contains pointers to the
#' opened layer and the GDAL dataset that owns it. Class methods that operate
#' on the layer are described in Details, along with a set of writable fields
#' for per-object settings. Values may be assigned to the class fields as
#' needed during the lifetime of the object (i.e., by regular \code{<-} or
#' \code{=} assignment).
#'
#' @section Usage (see Details):
#' ```
#' ## Constructors
#' # for single-layer file formats such as shapefile
#' lyr <- new(GDALVector, dsn)
#' # specifying the layer name, or SQL statement defining the layer
#' lyr <- new(GDALVector, dsn, layer)
#' # for update access
#' lyr <- new(GDALVector, dsn, layer, read_only = FALSE)
#' # using dataset open options
#' lyr <- new(GDALVector, dsn, layer, read_only, open_options)
#' # setting a spatial filter and/or specifying the SQL dialect
#' lyr <- new(GDALVector, dsn, layer, read_only, open_options, spatial_filter, dialect)
#'
#' ## Read/write fields (per-object settings)
#' lyr$defaultGeomColName
#' lyr$returnGeomAs
#' lyr$promoteToMulti
#' lyr$convertToLinear
#' lyr$wkbByteOrder
#' lyr$arrowStreamOptions
#' lyr$quiet
#' lyr$transactionsForce
#'
#' ## Methods
#' lyr$open(read_only)
#' lyr$isOpen()
#' lyr$isReadOnly()
#' lyr$getDsn()
#' lyr$getFileList()
#' lyr$info()
#' lyr$getDriverShortName()
#' lyr$getDriverLongName()
#'
#' lyr$getName()
#' lyr$getFieldNames()
#' lyr$testCapability()
#' lyr$getFIDColumn()
#' lyr$getGeomType()
#' lyr$getGeometryColumn()
#' lyr$getSpatialRef()
#' lyr$bbox()
#' lyr$getLayerDefn()
#' lyr$getFieldDomain(domain_name)
#'
#' lyr$setAttributeFilter(query)
#' lyr$getAttributeFilter()
#' lyr$setIgnoredFields(fields)
#' lyr$setSelectedFields(fields)
#' lyr$getIgnoredFields()
#'
#' lyr$setSpatialFilter(wkt)
#' lyr$setSpatialFilterRect(bbox)
#' lyr$getSpatialFilter()
#' lyr$clearSpatialFilter()
#'
#' lyr$getFeatureCount()
#' lyr$getNextFeature()
#' lyr$setNextByIndex(i)
#' lyr$getFeature(fid)
#' lyr$resetReading()
#' lyr$fetch(n)
#'
#' lyr$getArrowStream()
#' lyr$releaseArrowStream()
#'
#' lyr$setFeature(feature)
#' lyr$createFeature(feature)
#' lyr$batchCreateFeature(feature_set)
#' lyr$upsertFeature(feature)
#' lyr$getLastWriteFID()
#' lyr$deleteFeature(fid)
#' lyr$syncToDisk()
#'
#' lyr$startTransaction()
#' lyr$commitTransaction()
#' lyr$rollbackTransaction()
#'
#' lyr$getMetadata()
#' lyr$setMetadata(metadata)
#' lyr$getMetadataItem(mdi_name)
#'
#' lyr$close()
#' ```
#' @section Details:
#' ## Constructors
#'
#' \code{new(GDALVector, dsn)}\cr
#' The first layer by index is assumed if the `layer` argument is omitted, so
#' this form of the constructor might be used for single-layer formats like
#' shapefile.
#'
#' \code{new(GDALVector, dsn, layer)}\cr
#' Constructor specifying the name of a layer to open. The `layer` argument
#' may also be given as an SQL SELECT statement to define a layer as the result
#' set.
#'
#' \code{new(GDALVector, dsn, layer, read_only)}\cr
#' Constructor specifying read/write access (`read_only = TRUE|FALSE`).
#' The `layer` argument is required in this form of the constructor, but may be
#' given as empty string (`""`), in which case the first layer by index will be
#' assumed.
#'
#' \code{new(GDALVector, dsn, layer, read_only, open_options)}\cr
#' Constructor specifying dataset open options as a character vector of
#' `NAME=VALUE` pairs.
#'
#' \code{new(GDALVector, dsn, layer, read_only, open_options, spatial_filter, dialect))}\cr
#' Constructor to specify a spatial filter and/or SQL dialect. All arguments
#' are required in this form of the constructor, but `open_options` may be
#' `NULL`, and `spatial_filter` or `dialect` may be an empty string (`""`).
#'
#' ## Read/write fields
#'
#' \code{$defaultGeomColName}\cr
#' Character string specifying a name to use for returned columns when the
#' geometry column name in the source layer is empty, like with shapefiles etc.
#' Defaults to `"geom"`.
#'
#' \code{$returnGeomAs}\cr
#' Character string specifying the return format of feature geometries.
#' Must be one of `WKB` (the default), `WKB_ISO`, `WKT`, `WKT_ISO`, `BBOX`, or
#' `NONE`.
#' Using `WKB`/`WKT` exports as 99-402 extended dimension (Z) types for Point,
#' LineString, Polygon, MultiPoint, MultiLineString, MultiPolygon and
#' GeometryCollection. For other geometry types, it is equivalent to using
#' `WKB_ISO`/`WKT_ISO` (see \url{https://libgeos.org/specifications/wkb/}).
#' Using `BBOX` exports as a list of numeric vectors, each of length 4 with
#' values `xmin, ymin, xmax, ymax`. If an empty geometry is encountered these
#' values will be `NA_real_` in the corresponding location.
#' Using `NONE` will result in no geometry value being present in the feature
#' returned.
#'
#' \code{$promoteToMulti}\cr
#' A logical value specifying whether to automatically promote geometries from
#' Polygon to MultiPolygon, Point to MultiPoint, or LineString to
#' MultiLineString during read operations (i.e., with methods
#' \code{$getFeature()}, \code{$getNextFeature()}, \code{$fetch()}).
#' Defaults to `FALSE`. Setting to `TRUE` may be useful when reading from
#' layers such as shapefiles that mix Polygons and MultiPolygons.
#'
#' \code{$convertToLinear}\cr
#' A logical value specifying whether to convert non-linear geometry types into
#' linear geometry types by approximating them (i.e., during read operations
#' with methods \code{$getFeature()}, \code{$getNextFeature()},
#' \code{$fetch()}). Defaults to `FALSE`. If set to `TRUE`, handled conversions
#' are:
#' * wkbCurvePolygon -> wkbPolygon
#' * wkbCircularString -> wkbLineString
#' * wkbCompoundCurve -> wkbLineString
#' * wkbMultiSurface -> wkbMultiPolygon
#' * wkbMultiCurve -> wkbMultiLineString
#'
#' \code{$wkbByteOrder}\cr
#' Character string specifying the byte order for WKB geometries.
#' Must be either `LSB` (Least Significant Byte first, the default) or
#' `MSB` (Most Significant Byte first).
#'
#' \code{$arrowStreamOptions}\cr
#' Character vector of `"NAME=VALUE"` pairs giving options used by the
#' \code{$getArrowStream()} method (see below). The available options may be
#' driver and GDAL version specific. Options available as of GDAL 3.8 are
#' listed below. For more information about options for Arrow stream, see
#' the GDAL API documentation for
#' [OGR_L_GetArrowStream()](https://gdal.org/en/stable/api/vector_c_api.html#_CPPv420OGR_L_GetArrowStream9OGRLayerHP16ArrowArrayStreamPPc).
#' * INCLUDE_FID=YES/NO. Defaults to YES.
#' * MAX_FEATURES_IN_BATCH=integer. Maximum number of features to retrieve in
#' an ArrowArray batch. Defaults to 65536.
#' * TIMEZONE=unknown/UTC/(+|:)HH:MM or any other value supported by
#' Arrow (GDAL >= 3.8).
#' * GEOMETRY_METADATA_ENCODING=OGC/GEOARROW (GDAL >= 3.8). The GDAL default is
#' OGC if not specified.
#' * GEOMETRY_ENCODING=WKB (Arrow/Parquet drivers). To force a fallback to the
#' generic implementation when the native geometry encoding is not WKB.
#' Otherwise the geometry will be returned with its native Arrow encoding
#' (possibly using GeoArrow encoding).
#'
#' \code{$quiet}\cr
#' A logical value, `FALSE` by default. Set to `TRUE` to suppress various
#' messages and warnings.
#'
#' \code{$transactionsForce}\cr
#' A logical value, `FALSE` by default. Affects the behavior of attempted
#' transactions on the layer (see the \code{$startTransaction()} method below).
#' By default, only "efficient" transactions will be attempted. Some drivers
#' may offer an emulation of transactions, but sometimes with significant
#' overhead, in which case the user must explicitly allow for such an
#' emulation by first setting \code{$transactionsForce <- TRUE}.
#'
#' ## Methods
#'
#' \code{$open(read_only)}\cr
#' (Re-)opens the vector layer on the existing DSN. Use this method to
#' open a layer that has been closed using \code{$close()}. May be used to
#' re-open a layer with a different read/write access (`read_only` set to
#' `TRUE` or `FALSE`). The method will first close an open dataset, so it is
#' not required to call \code{$close()} explicitly in this case.
#' No return value, called for side effects.
#'
#' \code{$isOpen()}\cr
#' Returns a `logical` value indicating whether the vector dataset is open.
#'
#' \code{$isReadOnly()}\cr
#' Returns a logical value, `TRUE` if the vector dataset has read-only access
#' or `FALSE` if it is writable.
#'
#' \code{$getDsn()}\cr
#' Returns a character string containing the `dsn` associated with this
#' `GDALVector` object (`dsn` originally used to open the layer).
#'
#' \code{$getFileList()}\cr
#' Returns a character vector of files believed to be part of the data source.
#' If it returns an empty string (`""`) it means there is believed to be no
#' local file system files associated with the dataset (e.g., a virtual file
#' system). The returned filenames will normally be relative or absolute
#' paths depending on the path used to originally open the dataset.
#'
#' \code{$info()}\cr
#' Prints information about the vector layer to the console (no
#' return value, called for that side effect only).
#' For non-SQL DSN/layer, calls [ogrinfo()] passing the command options
#' `cl_arg = c("-so", "-nomd")`, and for layers open with a SQL statement,
#' calls [ogrinfo()] passing the command options
#' `cl_arg = c("-so", "-nomd", "-sql", <statement>)`.
#'
#' \code{$getDriverShortName()}\cr
#' Returns the short name of the vector format driver.
#'
#' \code{$getDriverLongName()}\cr
#' Returns the long name of the vector format driver.
#'
#' \code{$getName()}\cr
#' Returns the layer name.
#'
#' \code{$getFieldNames()}\cr
#' Returns a character vector of the layer's field names.
#'
#' \code{$testCapability()}\cr
#' Tests whether the layer supports named capabilities based on the current
#' read/write access. Returns a list of capabilities with values `TRUE` or
#' `FALSE`. The returned list contains the following named elements:
#' `RandomRead`, `SequentialWrite`, `RandomWrite`, `UpsertFeature`,
#' `FastSpatialFilter`, `FastFeatureCount`, `FastGetExtent`,
#' `FastSetNextByIndex`, `FastGetArrowStream`, `FastWriteArrowBatch`,
#' `CreateField`, `CreateGeomField`, `DeleteField`, `ReorderFields`,
#' `AlterFieldDefn`, `AlterGeomFieldDefn`, `DeleteFeature`, `StringsAsUTF8`,
#' `Transactions`, `CurveGeometries`.
#' Note that some layer capabilities are GDAL version dependent and may not
#' be listed if not supported by the GDAL version currently in use.
#' (See the GDAL documentation for
#' [`OGR_L_TestCapability()`](https://gdal.org/en/stable/api/vector_c_api.html#_CPPv420OGR_L_TestCapability9OGRLayerHPKc).)
#'
#' \code{$getFIDColumn()}\cr
#' Returns the name of the underlying database column being used as the FID
#' column, or empty string (`""`) if not supported.
#'
#' \code{$getGeomType()}\cr
#' Returns the well known name of the layer geometry type as character string.
#' For layers with multiple geometry fields, this method only returns the
#' geometry type of the first geometry column. For other columns, use
#' \code{$getLayerDefn()}. For layers without any geometry field, this method
#' returns `"NONE"`.
#'
#' \code{$getGeometryColumn()}\cr
#' Returns he name of the underlying database column being used as the geometry
#' column, or an empty string (`""`) if not supported.
#' For layers with multiple geometry fields, this method only returns the
#' name of the first geometry column. For other columns, use method
#' \code{$getLayerDefn()}.
#'
#' \code{$getSpatialRef()}\cr
#' Returns a WKT string containing the spatial reference system for this layer,
#' or empty string (`""`) if no spatial reference exists.
#'
#' \code{$bbox()}\cr
#' Returns a numeric vector of length four containing the bounding box
#' for this layer (xmin, ymin, xmax, ymax). Note that `bForce = true` is set in
#' the underlying API call to `OGR_L_GetExtent()`, so the entire layer may be
#' scanned to compute a minimum bounding rectangle (see `FastGetExtent` in the
#' list returned by \code{$testCapability()}). Depending on the format driver,
#' a spatial filter may or may not be taken into account, so it is safer to
#' call \code{$bbox()} without setting a spatial filter.
#'
#' \code{$getLayerDefn()}\cr
#' Returns a list containing the OGR feature class definition for this layer
#' (a.k.a. layer definition). The list contains zero or more attribute field
#' definitions, along with one or more geometry field definitions.
#' See [ogr_define] for details of the field and feature class definitions.
#'
#' \code{$getFieldDomain(domain_name)}\cr
#' Returns a list containing the definition of the OGR field domain with the
#' passed `domain_name`, or `NULL` if `domain_name` is not found.
#' See [ogr_define] for specification of the list containing a field domain
#' definition.
#' Some formats support the use of field domains which describe the valid values
#' that can be stored in a given attribute field, e.g., coded values that are
#' present in a specified enumeration, values constrained to a specified
#' range, or values that must match a specified pattern.
#' See
#' \url{https://gdal.org/en/stable/user/vector_data_model.html#field-domains}.
#' Requires GDAL >= 3.3.
#'
#' \code{$setAttributeFilter(query)}\cr
#' Sets an attribute query string to be used when fetching features via the
#' \code{$getNextFeature()} or \code{$fetch()} methods.
#' Only features for which `query` evaluates as true will be returned.
#' The query string should be in the format of an SQL WHERE clause, described
#' in the ["WHERE"](https://gdal.org/en/stable/user/ogr_sql_dialect.html#where)
#' section of the OGR SQL dialect documentation (e.g.,
#' `"population > 1000000 and population < 5000000"`, where `population` is an
#' attribute in the layer).
#' In some cases (RDBMS backed drivers, SQLite, GeoPackage) the native
#' capabilities of the database may be used to to interpret the WHERE clause,
#' in which case the capabilities will be broader than those of OGR SQL.
#' Note that installing a query string will generally result in resetting the
#' current reading position (as with \code{$resetReading()} described below).
#' The `query` parameter may be set to empty string (`""`) to clear the current
#' attribute filter.
#'
#' \code{$getAttributeFilter()}\cr
#' Returns the attribute query string currently in use, or empty string (`""`)
#' if an attribute filter is not set.
#'
#' \code{$setIgnoredFields(fields)}\cr
#' Set which fields can be omitted when retrieving features from the layer.
#' The `fields` argument is a character vector of field names. Passing an
#' empty string (`""`) for `fields` will reset to no ignored fields.
#' If the format driver supports this functionality (testable using
#' \code{$testCapability()$IgnoreFields}), it will not fetch the specified
#' fields in subsequent calls to \code{$getFeature()} / \code{$getNextFeature()}
#' / \code{$fetch()}, and thus save some processing time and/or bandwidth.
#' Besides field names of the layer, the following special fields can be passed:
#' `"OGR_GEOMETRY"` to ignore geometry and `"OGR_STYLE"` to ignore layer style.
#' By default, no fields are ignored. Note that fields that are used in an
#' attribute filter should generally not be set as ignored fields, as most
#' drivers (such as those relying on the OGR SQL engine) will be unable to
#' correctly evaluate the attribute filter. No return value, called for side
#' effects.
#'
#' \code{$setSelectedFields(fields)}\cr
#' Set which fields will be included when retrieving features from the layer.
#' The `fields` argument is a character vector of field names. Passing an
#' empty string (`""`) for `fields` will reset to no ignored fields.
#' See the \code{$setIgnoredFields()} method above for more information. The
#' data source must provide IgnoreFields capability in order to set selected
#' fields. Note that geometry fields, if desired, must be specified when setting
#' selected fields, either by including named geometry field(s) or the special
#' field `"OGR_GEOMETRY"` in the `fields` argument.
#' No return value, called for side effects.
#'
#' \code{$getIgnoredFields()}\cr
#' Returns a character vector containing the list of currently ignored fields,
#' or an empty vector (`character(0)`) if no fields are currently set to
#' ignored (or if the format driver does not support ignored fields).
#'
#' \code{$setSpatialFilter(wkt)}\cr
#' Sets a new spatial filter from a geometry in WKT format. This method sets
#' the geometry to be used as a spatial filter when fetching features via the
#' \code{$getNextFeature()} or \code{$fetch()} methods. Only features that
#' geometrically intersect the filter geometry will be returned. Currently this
#' test may be inaccurately implemented (depending on the vector format driver),
#' but it is guaranteed that all features whose envelope overlaps the envelope
#' of the spatial filter will be returned. This can result in more shapes being
#' returned that should strictly be the case.
#' `wkt` is a character string containing a WKT geometry in the same coordinate
#' system as the layer. An empty string (`""`) may be passed indicating that
#' the current spatial filter should be cleared, but no new one instituted.
#'
#' \code{$setSpatialFilterRect(bbox)}\cr
#' Sets a new rectangular spatial filter. This method sets a rectangle to be
#' used as a spatial filter when fetching features via the
#' \code{$getNextFeature()} or \code{$fetch()} methods.
#' Only features that geometrically intersect the given rectangle will be
#' returned.
#' `bbox` is a numeric vector of length four containing xmin, ymin, xmax, ymax
#' in the same coordinate system as the layer as a whole (as returned by
#' \code{$getSpatialRef()}).
#'
#' \code{$getSpatialFilter()}\cr
#' Returns the current spatial filter geometry as a WKT string, or empty string
#' (`""`) if a spatial filter is not set.
#'
#' \code{$clearSpatialFilter()}\cr
#' Clears a spatial filter that was set with \code{$setSpatialFilterRect()}.
#' No return value, called for that side effect.
#'
#' \code{$getFeatureCount()}\cr
#' Returns the number of features in the layer. For dynamic databases the count
#' may not be exact. This method forces a count in the underlying API call
#' (i.e., `bForce = TRUE` in the call to `OGR_L_GetFeatureCount()`). Note that
#' some vector drivers will actually scan the entire layer once to count
#' features. The `FastFeatureCount` element in the list returned by
#' the \code{$testCapability()} method can be checked if this might be a
#' concern.
#' The number of features returned takes into account the spatial and/or
#' attribute filters. Some driver implementations of this method may alter the
#' read cursor of the layer.
#'
#' \code{$getNextFeature()}\cr
#' Fetch the next available feature from this layer. Only features matching the
#' current spatial and/or attribute filter (if defined) will be returned.
#' This method implements sequential access to the features of a layer.
#' The \code{$resetReading()} method can be used to start at the beginning
#' again.
#' Returns a list with the unique feature identifier (FID), the attribute and
#' geometry field names, and their values. The returned list carries the
#' `OGRFeature` class attribute with S3 methods for for `print()` and `plot()`.
#' `NULL` is returned if no more features are available.
#'
#' \code{$setNextByIndex(i)}\cr
#' Moves the read cursor to feature `i` in the current result set
#' (with 0-based indexing).
#' This method allows positioning of a layer such that a call to
#' \code{$getNextFeature()} or \code{$fetch()} will read the requested
#' feature(s), where `i` is an absolute index into the current result set.
#' So, setting `i = 3` would mean the next feature read with
#' \code{$getNextFeature()} would have been the fourth feature read if
#' sequential reading took place from the beginning of the layer, including
#' accounting for spatial and attribute filters.
#' This method is not implemented efficiently by all vector format drivers. The
#' default implementation simply resets reading to the beginning and then calls
#' `GetNextFeature()` `i` times.
#' To determine if fast seeking is available on the current layer, check
#' the `FastSetNextByIndex` element in the list returned by the
#' \code{$testCapability()} method. No return value, called for side effect.
#'
#' \code{$getFeature(fid)}\cr
#' Returns a feature by its identifier. The value of `fid` must be a numeric
#' value, optionally carrying the `bit64::integer64` class attribute.
#' Success or failure of this operation is unaffected by any spatial or
#' attribute filters that may be in effect.
#' The `RandomRead` element in the list returned by \code{$testCapability()} can
#' be checked to establish if this layer supports efficient random access
#' reading; however, the call should always work if the feature exists since a
#' fallback implementation just scans all the features in the layer looking for
#' the desired feature. Returns a list with the unique feature identifier (FID),
#' the attribute and geometry field names, and their values, or `NULL` on
#' failure. Note that sequential reads (with \code{$getNextFeature()}) are
#' generally considered interrupted by a call to \code{$getFeature()}.
#'
#' \code{$resetReading()}\cr
#' Reset feature reading to start on the first feature. No return value, called
#' for that side effect.
#'
#' \code{$fetch(n)}\cr
#' Fetches the next `n` features from the layer and returns them as a data
#' frame. This allows retrieving the entire set of features, one page of
#' features at a time, or the remaining features (from the current cursor
#' position). Returns a data frame with as many rows as features were fetched,
#' and as many columns as attribute plus geometry fields in the result set,
#' even if the result is a single value or has one or zero rows.
#' The returned data frame carries the `OGRFeatureSet` class attribute with S3
#' methods for for `print()` and `plot()`.
#'
#' This method is an analog of
#' [`DBI::dbFetch()`](https://dbi.r-dbi.org/reference/dbFetch.html).
#'
#' The `n` argument is the maximum number of features to retrieve per fetch
#' given as `integer` or `numeric` but assumed to be a whole number (will
#' be truncated). Use `n = -1` or `n = Inf` to retrieve all pending features
#' (resets reading to the first feature).
#' Otherwise, \code{$fetch()} can be called multiple times to perform forward
#' paging from the current cursor position. Passing `n = NA` is also supported
#' and returns the remaining features.
#' Fetching zero features is possible to retrieve the structure of the feature
#' set as a data frame (columns fully typed).
#'
#' OGR field types are returned as the following \R types (type-specific `NA`
#' for OGR NULL values):
#' * **OFTInteger**: `integer` value
#' * **OFTInteger subtype OFSTBoolean**: `logical` value
#' * **OFTIntegerList**: vector of `integer` (list column)
#' * **OFTInteger64**: `numeric` value carrying the `"integer64"` class
#' attribute
#' * **OFTInteger64 subtype OFSTBoolean**: `logical` value
#' * **OFTInteger64List**: vector of `bit64::integer64` (list column)
#' * **OFTReal**: `numeric` value
#' * **OFTRealList**: vector of `numeric` (list column)
#' * **OFTString**: `character` string
#' * **OFTStringList**: vector of `character` strings (list column)
#' * **OFTDate**: `numeric` value of class `"Date"`
#' * **OFTDateTime**: `numeric` value of class `"POSIXct"` (millisecond
#' accuracy)
#' * **OFTTime**: `character` string (`"HH:MM:SS"`)
#' * **OFTBinary**: `raw` vector (list column, `NULL` entries for OGR NULL
#' values)
#'
#' Geometries are not returned if the field `returnGeomAs` is set to `NONE`.
#' Omitting the geometries may be beneficial for performance and memory usage
#' when access only to feature attributes is needed. Geometries are returned
#' as `raw` vectors in a data frame list column when `returnGeomAs` is set to
#' `WKB` (the default) or `WKB_ISO`, or as `character` strings when
#' `returnGeomAs` is set to one of `WKT` or `WKT_ISO`.
#'
#' Note that \code{$getFeatureCount()} is called internally when fetching the
#' full feature set or all remaining features (but not for a page of features).
#'
#' \code{$getArrowStream()}\cr
#' Returns a `nanoarrow_array_stream` object exposing an Arrow C stream on the
#' layer (requires GDAL >= 3.6).
#' The writable field \code{$arrowStreamOptions} can be used to set options
#' before calling this method (see above). An error is raised if an array stream
#' on the layer cannot be obtained.
#' Generally, only one ArrowArrayStream can be active at a time on a given
#' layer (i.e., the last active one must be explicitly released before a next
#' one is asked). Changing attribute or spatial filters, ignored columns,
#' modifying the schema or using \code{$resetReading()} /
#' \code{$getNextFeature()} while using an ArrowArrayStream is strongly
#' discouraged and may lead to unexpected results. As a rule of thumb, no
#' OGRLayer methods that affect the state of a layer should be called on the
#' layer while an ArrowArrayStream on it is active. Methods available on the
#' stream object are: \code{$get_schema()}, \code{$get_next()} and
#' \code{$release()} (see Examples).
#'
#' The stream should be released once reading is complete. Calling the release
#' method as soon as you can after consuming a stream is recommended by the
#' \pkg{nanoarrow} documentation.
#'
#' See also the \code{$testCapability()} method above to check whether the
#' format driver provides a specialized implementation (`FastGetArrowStream`),
#' as opposed to the (slower) default implementation. Note however that
#' specialized implementations may fallback to the default when attribute or
#' spatial filters are in use.
#' (See the GDAL documentation for
#' [`OGR_L_GetArrowStream()`](https://gdal.org/en/stable/api/vector_c_api.html#_CPPv420OGR_L_GetArrowStream9OGRLayerHP16ArrowArrayStreamPPc).)
#'
#' \code{$releaseArrowStream()}\cr
#' Releases the Arrow C stream returned by \code{$getArrowStream()} and clears
#' the `nanoarrow_array_stream` object (if GDAL >= 3.6, otherwise does nothing).
#' This is equivalent to calling the \code{$release()} method on the
#' `nanoarrow_array_stream` object. No return value, called for side effects.
#'
#' \code{$setFeature(feature)}\cr
#' Rewrites/replaces an existing feature. This method writes a feature based on
#' the feature id within the input feature. The `feature` argument is a named
#' list of fields and their values, and must include a `FID` element
#' referencing the existing feature to rewrite. The `RandomWrite` element in
#' the list returned by \code{$testCapability()} can be checked to establish if
#' this layer supports random access writing via \code{$setFeature()}.
#' The way omitted fields in the passed `feature` are processed is driver
#' dependent:
#' * SQL-based drivers which implement set feature through SQL UPDATE will skip
#'   unset fields, and thus the content of the existing feature will be
#'   preserved.
#' * The shapefile driver will write a NULL value in the DBF file.
#' * The GeoJSON driver will take into account unset fields to remove the
#'   corresponding JSON member.
#'
#' Returns logical `TRUE` upon successful completion, or `FALSE` if setting the
#' feature did not succeed. The FID of the last feature written to the layer
#' may be obtained with the method \code{$getLastWriteFID()} (see below).
#' To set a feature, but create it if it doesn't exist see the
#' \code{$upsertFeature()} method.
#'
#' \code{$createFeature(feature)}\cr
#' Creates and writes a new feature within the layer. The `feature` argument is
#' a named list of fields and their values (might be one row of a data frame).
#' The passed feature is written to the layer as a new feature, rather than
#' overwriting an existing one. If the feature has a `FID` element with other
#' than `NA` (i.e., a numeric value, optionally carrying the `bit64::integer64`
#' class attribute and assumed to be a whole number), then the format
#' driver may use that as the feature id of the new feature, but not
#' necessarily. The FID of the last feature written to the layer may be
#' obtained with the method \code{$getLastWriteFID()} (see below).
#' Returns logical `TRUE` upon successful completion, or `FALSE` if creating
#' the feature did not succeed. To create a feature, but set it if it already
#' exists see the \code{$upsertFeature()} method.
#'
#' \code{$batchCreateFeature(feature_set)}\cr
#' Batch version of \code{$createFeature()}. Creates and writes a batch of new
#' features within the layer from input passed as a data frame in the
#' `feature_set` argument. Column names in the data frame must match field
#' names of the layer and have compatible data types. The specifications
#' listed above under the \code{$fetch()} method generally apply to input data
#' types for writing, but integers may be passed as 'numeric', and
#' the 'integer64' class attribute is not strictly required on 'numeric'
#' input if it is not needed for the data being passed to an OFTInteger64
#' field.
#' Returns a logical vector of length equal to the number of input features
#' (rows of the data frame), with `TRUE` indicating success for the feature at
#' that row index, or `FALSE` if writing the feature failed.
#' It is recommended to use transactions when batch writing features to a
#' layer (see \code{$startTransaction()} below). This will generally give large
#' performance benefit with data sources that provide efficient transaction
#' support (e.g., RDBMS-based sources such as GeoPackage and PostGIS). In
#' addition, the return value of \code{$batchCreateFeature()} can be checked,
#' and the transaction optionally committed or rolled back based on results of
#' the operation across the full set of input features.
#'
#' \code{$upsertFeature(feature)}\cr
#' Rewrites/replaces an existing feature or creates a new feature within the
#' layer. This method will write a feature to the layer, based on the feature
#' id within the input feature. The `feature` argument is a named list of
#' fields and their values (might be one row of a data frame), potentially
#' including a `FID` element referencing an existing feature to rewrite. If
#' the feature id doesn't exist a new feature will be written. Otherwise, the
#' existing feature will be rewritten.
#' The `UpsertFeature` element in the list returned by \code{$testCapability()}
#' can be checked to determine if this layer supports upsert writing. See
#' \code{$setFeature()} above for a description of how omitted fields in the
#' passed feature are processed.
#' Returns logical `TRUE` upon successful completion, or `FALSE` if upsert did
#' not succeed. Requires GDAL >= 3.6.
#'
#' \code{$getLastWriteFID()}\cr
#' Returns the FID of the last feature written (either newly created or updated
#' existing). `NULL` is returned if no features have been written in the layer.
#' Note that OGRNullFID (`-1`) may be returned after writing a feature in some
#' formats. This is the case if a FID has not been assigned yet, and generally
#' does not indicate an error (e.g., formats that do not store a persistent FID
#' and assign FIDs upon a sequential read operation). The returned FID is a
#' numeric value carrying the `bit64::integer64` class attribute.
#'
#' \code{$deleteFeature(fid)}\cr
#' Deletes a feature from the layer. The feature with the indicated feature ID
#' is deleted from the layer if supported by the format driver. The value of
#' `fid` must be a numeric value, optionally carrying the `bit64::integer64`
#' class attribute (should be a whole number, will be truncated).
#' The `DeleteFeature` element in the list returned by \code{$testCapability()}
#' can be checked to establish if this layer has delete feature capability.
#' Returns logical `TRUE` if the operation succeeds, or `FALSE` on failure.
#'
#' \code{$syncToDisk()}\cr
#' Flushes pending changes to disk. This call is intended to force the layer to
#' flush any pending writes to disk, and leave the disk file in a consistent
#' state. It would not normally have any effect on read-only datasources. Some
#' formats do not implement this method, and will still return no error. An
#' error is only returned if an error occurs while attempting to flush to disk.
#' In any event, you should always close any opened datasource with
#' \code{$close()} which will ensure all data is correctly flushed. Returns
#' logical `TRUE` if no error occurs (even if nothing is done) or `FALSE` on
#' error.
#'
#' \code{$startTransaction()}\cr
#' Creates a transaction if supported by the vector data source. By default,
#' only "efficient" transactions will be attempted. See the writable field
#' \code{$transactionsForce} above, which must be set to `TRUE` to allow for
#' emulated transactions. These are supported by some drivers but with
#' potentially significant overhead. The function `ogr_ds_test_cap()` can be
#' used to determine whether a vector data source supports efficient or
#' emulated transactions.
#'
#' All changes done after the start of the transaction are definitely applied
#' in the data source if \code{$commitTransaction()} is called. They can be
#' canceled by calling \code{$rollbackTransaction()} instead.
#' Nested transactions are not supported. Transactions are implemented at the
#' dataset level, so multiple `GDALVector` objects using the same data source
#' should not have transactions active at the same time.
#'
#' In case \code{$startTransaction()} fails, neither \code{$commitTransaction()}
#' nor \code{$rollbackTransaction()} should be called.
#' If an error occurs after a successful \code{$startTransaction()}, the whole
#' transaction may or may not be implicitly canceled, depending on the format
#' driver (e.g., the PostGIS driver will cancel it, SQLite/GPKG will not). In
#' any case, in the event of an error, an explicit call to
#' \code{$rollbackTransaction()} should be done to keep things balanced.
#'
#' Returns logical `TRUE` if the transaction is created, or `FALSE` on failure.
#'
#' \code{$commitTransaction()}\cr
#' Commits a transaction if supported by the vector data source.
#' Returns a logical value, `TRUE` if the transaction is successfully committed.
#' Returns `FALSE` if no transaction is active, or the rollback fails, or if the
#' data source does not support transactions.
#' Depending on the format driver, this may or may not abort layer sequential
#' reading that may be active.
#'
#' \code{$rollbackTransaction()}\cr
#' Rolls back a data source to its state before the start of the current
#' transaction, if transactions are supported by the data source.
#' Returns a logical value, `TRUE` if the transaction is successfully rolled
#' back. Returns `FALSE` if no transaction is active, or the rollback fails,
#' or if the data source does not support transactions.
#'
#' \code{$getMetadata()}\cr
#' Returns a character vector of all metadata `NAME=VALUE` pairs for the
#' layer or empty string (`""`) if there are no metadata items.
#'
#' \code{$setMetadata(metadata)}\cr
#' Sets metadata on the layer if the format supports it. The \code{metadata}
#' argument is given as a character vector of `NAME=VALUE` pairs.
#' Returns logical \code{TRUE} on success or \code{FALSE} if metadata could
#' not be set.
#'
#' \code{$getMetadataItem(mdi_name)}\cr
#' Returns the value of a specific metadata item named \code{mdi_name}, or empty
#' string (`""`) if no matching item is found.
#'
#' \code{$close()}\cr
#' Closes the vector dataset (no return value, called for side effects).
#' Calling \code{$close()} results in proper cleanup, and flushing of any
#' pending writes.
#' The `GDALVector` object is still available after calling \code{$close()}.
#' The layer can be re-opened on the existing \code{dsn} with
#' \code{$open(read_only = TRUE|FALSE)}.
#'
#' @seealso
#' [ogr_define], [ogr_manage], [ogr2ogr()], [ogrinfo()]
#'
#' GDAL vector format descriptions:\cr
#' \url{https://gdal.org/en/stable/drivers/vector/index.html}
#'
#' GDAL-supported SQL dialects:\cr
#' \url{https://gdal.org/en/stable/user/ogr_sql_sqlite_dialect.html}
#'
#' GDAL Vector API documentation:\cr
#' \url{https://gdal.org/en/stable/api/index.html}
#'
#' @examples
#' ## MTBS fire perimeters in Yellowstone National Park 1984-2022
#' f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
#'
#' ## copy to a temporary file that is writeable
#' dsn <- file.path(tempdir(), basename(f))
#' file.copy(f, dsn)
#'
#' (lyr <- new(GDALVector, dsn, "mtbs_perims"))
#'
#' str(lyr)
#'
#' ## dataset info
#' lyr$getDriverShortName()
#' lyr$getDriverLongName()
#' lyr$getFileList()
#'
#' ## layer info
#' lyr$getName()
#' lyr$getGeomType()
#' lyr$getGeometryColumn()
#' lyr$getFIDColumn()
#' lyr$getSpatialRef()
#' lyr$bbox()
#'
#' ## layer capabilities
#' lyr$testCapability()
#'
#' ## re-open with write access
#' lyr$open(read_only = FALSE)
#' lyr$testCapability()$SequentialWrite
#' lyr$testCapability()$RandomWrite
#'
#' ## feature class definition - a list of field names and their definitions
#' defn <- lyr$getLayerDefn()
#' names(defn)
#' str(defn)
#'
#' ## default value of the read/write field 'returnGeomAs'
#' lyr$returnGeomAs
#'
#' lyr$getFeatureCount()
#'
#' ## sequential read cursor
#' # a single feature returned as a named list of fields and their values:
#' (feat <- lyr$getNextFeature())
#'
#' ## set an attribute filter
#' lyr$setAttributeFilter("ig_year = 2020")
#' lyr$getFeatureCount()
#'
#' feat <- lyr$getNextFeature()
#' plot(feat)
#'
#' ## NULL when no more features are available
#' lyr$getNextFeature()
#'
#' ## reset reading to the start
#' lyr$resetReading()
#' lyr$getNextFeature()
#'
#' ## clear the attribute filter
#' lyr$setAttributeFilter("")
#' lyr$getFeatureCount()
#'
#' ## set a spatial filter
#' ## get the bounding box of the largest 1988 fire and use as spatial filter
#' ## first set a temporary attribute filter to do the lookup
#' lyr$setAttributeFilter("ig_year = 1988 ORDER BY burn_bnd_ac DESC")
#' (feat <- lyr$getNextFeature())
#'
#' bbox <- g_wk2wk(feat$geom) |> bbox_from_wkt()
#'
#' ## set spatial filter on the full layer
#' lyr$setAttributeFilter("")  # clears the attribute filter
#' lyr$setSpatialFilterRect(bbox)
#' lyr$getFeatureCount()
#'
#' ## fetch in chunks and return as data frame (class OGRFeatureSet)
#' feat_set <- lyr$fetch(20)
#' head(feat_set)
#' plot(feat_set)
#'
#' ## the next chunk
#' feat_set <- lyr$fetch(20)
#' nrow(feat_set)
#'
#' ## no features remaining
#' feat_set <- lyr$fetch(20)
#' nrow(feat_set)
#' str(feat_set)  # 0-row data frame with columns fully typed
#'
#' ## or, fetch all pending features from the beginning
#' feat_set <- lyr$fetch(-1)  # resets reading to the first feature
#' nrow(feat_set)
#' plot(feat_set)
#'
#' lyr$clearSpatialFilter()
#' lyr$getFeatureCount()
#'
#' lyr$close()
#'
#' ## simple example of feature write methods showing use of various data types
#' ## create and write to a new layer in a GeoPackage data source
#' dsn2 <- tempfile(fileext = ".gpkg")
#'
#' ## define a feature class
#' defn <- ogr_def_layer("POINT", srs = epsg_to_wkt(4326))
#'
#' ## add field definitions
#' defn$unique_int <- ogr_def_field("OFTInteger", is_nullable = FALSE,
#'                                  is_unique = TRUE)
#' defn$bool_data <- ogr_def_field("OFTInteger", fld_subtype = "OFSTBoolean")
#' defn$large_ints <- ogr_def_field("OFTInteger64")
#' defn$doubles <- ogr_def_field("OFTReal")
#' defn$strings <- ogr_def_field("OFTString", fld_width = 50)
#' defn$dates <- ogr_def_field("OFTDate")
#' defn$dt_modified <- ogr_def_field("OFTDateTime",
#'                                   default_value = "CURRENT_TIMESTAMP")
#' defn$blobs <- ogr_def_field("OFTBinary")
#'
#' lyr <- ogr_ds_create("GPKG", dsn2, "test_layer", layer_defn = defn,
#'                      return_obj = TRUE)
#'
#' # lyr$getLayerDefn() |> str()
#'
#' ## define a feature to write
#' feat1 <- list()
#' # $FID is omitted since it is assigned when written (could also be NA)
#' # $dt_modified is omitted since a default timestamp is defined on the field
#' feat1$unique_int <- 1001
#' feat1$bool_data <- TRUE
#' # pass a string to as.integer64() since the value is too large to be
#' # represented exactly as an R numeric value (i.e., double)
#' feat1$large_ints <- bit64::as.integer64("90071992547409910")
#' feat1$doubles <- 1.234
#' feat1$strings <- "A test string"
#' feat1$dates <- as.Date("2025-01-01")
#' feat1$blobs <- charToRaw("A binary object")
#' feat1$geom <- "POINT (1 1)"  # can be a WKT string or raw vector of WKB
#'
#' ## create as a new feature in the layer
#' lyr$createFeature(feat1)
#'
#' ## get the assigned FID
#' lyr$getLastWriteFID()
#'
#' ## attempt to re-write the same feature fails due to the unique constraint
#' lyr$createFeature(feat1)
#'
#' feat2 <- list()
#' feat2$unique_int <- 1002
#' feat2$bool_data <- FALSE
#' feat2$large_ints <- bit64::as.integer64("90071992547409920")
#' feat2$doubles <- 2.345
#' feat2$strings <- "A test string 2"
#' feat2$dates <- as.Date("2024-01-02")
#' feat2$blobs <- charToRaw("A binary object 2")
#' feat2$geom <- "POINT (2 2)"
#'
#' lyr$createFeature(feat2)
#' lyr$getLastWriteFID()
#'
#' ## close and re-open as a read-only layer
#' lyr$open(read_only = TRUE)
#'
#' lyr$getFeatureCount()
#' feat_set <- lyr$fetch(-1)  # -1 to fetch all features from the beginning
#' str(feat_set)
#'
#' ## edit an existing feature, e.g., feat <- lyr$getFeature(2)
#' ## here we copy a row of the data frame returned by lyr$fetch() above
#' feat <- feat_set[2,]
#' str(feat)
#'
#' Sys.sleep(1)  # to ensure a timestamp difference
#'
#' feat$bool_data <- TRUE
#' feat$strings <- paste(feat$strings, "- edited")
#' feat$dt_modified <- Sys.time()
#' feat$geom <- "POINT (2.001 2.001)"
#'
#' lyr$open(read_only = FALSE)
#'
#' ## lyr$setFeature() re-writes the feature identified by the $FID element
#' lyr$setFeature(feat)
#'
#' lyr$open(read_only = TRUE)
#' lyr$getFeatureCount()
#'
#' lyr$returnGeomAs <- "WKT"
#' feat_set <- lyr$fetch(-1)
#' str(feat_set)
#'
#' lyr$close()
#'
#' ## Arrow array stream exposed as a nanoarrow_array_stream object
#' ## requires GDAL >= 3.6
#' if (gdal_version_num() >= gdal_compute_version(3, 6, 0)) {
#'
#'   sql <- "SELECT incid_name, geom from mtbs_perims LIMIT 5"
#'   lyr <- new(GDALVector, dsn, sql)
#'
#'   stream <- lyr$getArrowStream()
#'
#'   # disable a warning for the example that can be safely ignored here
#'   options(nanoarrow.warn_unregistered_extension = FALSE)
#'
#'   # pull all the batches into a data frame
#'   d <- as.data.frame(stream)
#'
#'   # the geometry column is a list column of WKB raw vectors, which can be
#'   # passed to the Geometry API g_*() functions, e.g.,
#'   g_centroid(d$geom) |> print()
#'
#'   # release the stream when finished
#'   stream$release()
#'
#'   lyr$close()
#' }
#' \dontshow{unlink(dsn)}
#' \dontshow{unlink(dsn2)}
NULL

Rcpp::loadModule("mod_GDALVector", TRUE)

#' Bounding box from dimensions and geotransform
#'
#' `bbox_from_dim_gt()` computes the bounding box from raster dimensions and
#' geotransform coefficients. For rotated rasters, returns the axis-aligned
#' envelope of the four corner coordinates.
#'
#' @param dm Integer vector of length two containing the raster dimensions
#' (xsize, ysize) in pixels.
#' @param gt Numeric vector of length six containing the geotransform
#' coefficients.
#' @returns Numeric vector of length four containing the bounding box
#' (xmin, ymin, xmax, ymax) in georeferenced coordinates.
#' @seealso [`GDALRaster$getGeoTransform()`][GDALRaster],
#' [`GDALRaster$bbox()`][GDALRaster], [gt_from_dim_bbox()],
#' [inv_geotransform()]
#' @examples
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' ds <- new(GDALRaster, elev_file)
#' gt <- ds$getGeoTransform()
#' dm <- ds$dim()
#'
#' # should match ds$bbox()
#' bbox_from_dim_gt(dm, gt)
#' ds$bbox()
#'
#' ds$close()
#' @export
bbox_from_dim_gt <- function(dm, gt) {
    .bbox_grid_to_geo(gt, 0, dm[1L], 0, dm[2L])
}

#' Geotransform from dimensions and bounding box
#'
#' `gt_from_dim_bbox()` computes geotransform coefficients from raster
#' dimensions and a bounding box. The resulting geotransform will always be
#' north-up (no rotation).
#'
#' @param dm Integer vector of length two containing the raster dimensions
#' (xsize, ysize) in pixels.
#' @param bbox Numeric vector of length four containing the bounding box
#' (xmin, ymin, xmax, ymax) in georeferenced coordinates.
#' @returns Numeric vector of length six containing the geotransform
#' coefficients.
#' @seealso [`GDALRaster$getGeoTransform()`][GDALRaster],
#' [`GDALRaster$setGeoTransform()`][GDALRaster],
#' [`GDALRaster$setBbox()`][GDALRaster], [bbox_from_dim_gt()],
#' [inv_geotransform()]
#' @examples
#' # 1-degree global grid
#' (gt <- gt_from_dim_bbox(c(360, 180), c(-180, -90, 180, 90)))
#'
#' # verify round-trip
#' bbox_from_dim_gt(c(360, 180), gt)
#' @export
gt_from_dim_bbox <- function(dm, bbox) {
    .gt_from_dim_bbox(dm, bbox)
}

test_that("gt_from_dim_bbox produces correct geotransform", {
  # global extent
  
  gt <- gt_from_dim_bbox(c(360, 180), c(-180, -90, 180, 90))
  expect_equal(gt[1], -180)
  expect_equal(gt[2], 1)
  expect_equal(gt[3], 0)
  expect_equal(gt[4], 90)
  expect_equal(gt[5], 0)
  expect_equal(gt[6], -1)
  
  
  # arbitrary case
  gt <- gt_from_dim_bbox(c(143, 107), c(0, 1, 5, 10))
  expect_equal(gt[1], 0)
  expect_equal(gt[2], 5/143)
  expect_equal(gt[4], 10)
  expect_equal(gt[6], -9/107)
})

test_that("gt_from_dim_bbox rejects invalid bbox",
          {
            expect_error(gt_from_dim_bbox(c(100, 100), c(10, 0, 5, 10)),
                         "xmax must be greater than xmin")
            expect_error(gt_from_dim_bbox(c(100, 100), c(0, 10, 5, 5)),
                         "ymax must be greater than ymin")
          })

test_that("bbox_from_dim_gt produces correct bbox", {
  gt <- c(-180, 1, 0, 90, 0, -1)
  bbox <- bbox_from_dim_gt(c(360, 180), gt)
  expect_equal(bbox, c(-180, -90, 180, 90))
})

test_that("bbox_from_dim_gt is correct from rotated geotransform", {
  gt_rotated <- c(0, 1, 0.5, 0, 0.5, -1)
  expect_equal(bbox_from_dim_gt(c(100, 100), gt_rotated),
               c(0, -100,  150,   50))

})

test_that("gt and bbox round-trip correctly", {
  dim <- c(500, 300)
  bbox <- c(100, 200, 600, 800)
  
  gt <- gt_from_dim_bbox(dim, bbox)
  bbox_back <- bbox_from_dim_gt(dim, gt)
  expect_equal(bbox_back, bbox)
})


test_that("bbox_from_dim_gt and gt_from_dim_bbox correct and consistent", {
  elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
  ds <- new(GDALRaster, elev_file, read_only=TRUE)
  gt <- ds$getGeoTransform()
  bb <- ds$bbox()
  dm <- ds$dim()
  expect_error(ds$setBbox(c(0, 0, 1, 1)), "dataset is read-only")
  ds$close()
  expect_equal(bbox_from_dim_gt(dm, gt), bb)
  expect_equal(gt_from_dim_bbox(dm, bb), gt)
})

test_that("$setBbox() is correct and consistent", {
  lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
  tif_file <- paste0(tempdir(), "/", "storml_lndscp.tif")
  createCopy(format="GTiff", dst_filename=tif_file, src_filename=lcp_file)
  ds <- new(GDALRaster, tif_file, read_only=FALSE)
  on.exit(deleteDataset(tif_file))
  expect_error(ds$setBbox(c(5, 0, 1, 1)), "invalid bbox: xmax must be greater than xmin")
  expect_error(ds$setBbox(c(0, 5, 1, 1)), "invalid bbox: ymax must be greater than ymin")
  expect_true(ds$setBbox(c(0, 0, 1, 1)))
  ds$close()
})

# Functions for working with GDAL Raster Attribute Tables
# Chris Toney <chris.toney at usda.gov>


#' Build a GDAL Raster Attribute Table with VALUE, COUNT
#'
#' @description
#' `buildRAT()` reads all pixels of an input raster to obtain the set of
#' unique values and their counts. The result is returned as a data frame
#' suitable for use with the class method `GDALRaster$setDefaultRAT()`. The
#' returned data frame might be further modified before setting as a Raster
#' Attribute Table in a dataset, for example, by adding columns containing
#' class names, color values, or other information (see Details).
#' An optional input data frame containing such attributes may be given, in
#' which case `buildRAT()` will attempt to join the additional columns and
#' automatically assign the appropriate metadata on the output data frame
#' (i.e., assign R attributes on the data frame and its columns that define
#' usage in a GDAL Raster Attribute Table).
#'
#' @details
#' A GDAL Raster Attribute Table (or RAT) provides attribute information about
#' pixel values. Raster attribute tables can be used to represent histograms,
#' color tables, and classification information. Each row in the table applies
#' to either a single pixel value or a range of values, and might have
#' attributes such as the histogram count for that value (or range), the color
#' that pixels of that value (or range) should be displayed, names of classes,
#' or various other information.
#'
#' Each column in a raster attribute table has a name, a type (Integer,
#' Double, String, and with GDAL >= 3.12, Boolean, DateTime, or WKBGeometry),
#' and a `GDALRATFieldUsage`. The usage distinguishes columns with particular
#' understood purposes (such as color, histogram count, class name), and
#' columns that have other purposes not understood by the library (long labels,
#' ancillary attributes, etc).
#'
#' In the general case, each row has a field indicating the minimum pixel
#' value falling into that category, and a field indicating the maximum pixel
#' value. In the GDAL API, these are indicated with usage values of `GFU_Min`
#' and `GFU_Max`. In the common case where each row is a discrete pixel value,
#' a single column with usage `GFU_MinMax` would be used instead.
#' In R, the table is represented as a data frame with column attribute `"GFU"`
#' containing the field usage as a string, e.g., `"Max"`, `"Min"` or `"MinMax"`
#' (case-sensitive).
#' The full set of possible field usage descriptors is:
#' \tabular{lll}{
#'  GFU attr       \tab GDAL enum        \tab Description\cr
#'	`"Generic"`    \tab `GFU_Generic`    \tab General purpose field\cr
#'	`"PixelCount"` \tab `GFU_PixelCount` \tab Histogram pixel count\cr
#'	`"Name"`       \tab `GFU_Name`       \tab Class name\cr
#'	`"Min"`        \tab `GFU_Min`        \tab Class range minimum\cr
#'	`"Max"`        \tab `GFU_Max`        \tab Class range maximum\cr
#'	`"MinMax"`     \tab `GFU_MinMax`     \tab Class value (min=max)\cr
#'	`"Red"`        \tab `GFU_Red`        \tab Red class color (0-255)\cr
#'	`"Green"`      \tab `GFU_Green`      \tab Green class color (0-255)\cr
#'	`"Blue"`       \tab `GFU_Blue`       \tab Blue class color (0-255)\cr
#'	`"Alpha"`      \tab `GFU_Alpha`      \tab Alpha transparency (0-255)\cr
#'	`"RedMin"`     \tab `GFU_RedMin`     \tab Color range red minimum\cr
#'	`"GreenMin"`   \tab `GFU_GreenMin`   \tab Color range green minimum\cr
#'	`"BlueMin"`    \tab `GFU_BlueMin`    \tab Color range blue minimum\cr
#'	`"AlphaMin"`   \tab `GFU_AlphaMin`   \tab Color range alpha minimum\cr
#'	`"RedMax"`     \tab `GFU_RedMax`     \tab Color range red maximum\cr
#'	`"GreenMax"`   \tab `GFU_GreenMax`   \tab Color range green maximum\cr
#'	`"BlueMax"`    \tab `GFU_BlueMax`    \tab Color range blue maximum\cr
#'	`"AlphaMax"`   \tab `GFU_AlphaMax`   \tab Color range alpha maximum
#' }
#'
#' `buildRAT()` assigns GFU `"MinMax"` on the column of pixel values (named
#' `"VALUE"` by default) and GFU `"PixelCount"` on the column of counts (named
#' `"COUNT"` by default).
#' If `join_df` is given, the additional columns that result from joining will
#' have GFU assigned automatically based on the column names (_ignoring case_).
#' First, the additional column names are checked for containing
#' the string `"name"` (e.g., `"classname"`, `"TypeName"`, `"EVT_NAME"`, etc).
#' The first matching column (if any) will be assigned a GFU of `"Name"`
#' (=`GFU_Name`, the field usage descriptor for class names). Next, columns
#' named `"R"` or `"Red"` will be assigned GFU `"Red"`, columns named `"G"` or
#' `"Green"` will be assigned GFU `"Green"`, columns named `"B"` or `"Blue"`
#' will be assigned GFU `"Blue"`, and columns named `"A"` or `"Alpha"` will be
#' assigned GFU `"Alpha"`. Finally, any remaining columns that have not been
#' assigned a GFU will be assigned `"Generic"`.
#'
#' In a variation of RAT, all the categories are of equal size and regularly
#' spaced, and the categorization can be determined by knowing the value at
#' which the categories start and the size of a category. This is called
#' "Linear Binning" and the information is kept specially on the raster
#' attribute table as a whole. In \R, a RAT that uses linear binning would
#' have the following attributes set on the data frame:
#' attribute `"Row0Min"` = the numeric lower bound (pixel value) of the first
#' category, and attribute `"BinSize"` = the numeric width of each category (in
#' pixel value units). `buildRAT()` does not create tables with linear binning,
#' but one could be created manually based on the specifications above, and
#' applied to a raster with the class method `GDALRaster$setDefaultRAT()`.
#'
#' A raster attribute table is thematic or athematic (continuous). In \R, this
#' is defined by an attribute on the data frame named `"GDALRATTableType"` with
#' value of either `"thematic"` or `"athematic"`.
#'
#' @note
#' The full raster will be scanned.
#'
#' If `na_value` is not specified, then an `NA` pixel value (if present)
#' will not be recoded in the output data frame. This may have implications
#' if joining to other data (`NA` will not match), or when using the returned
#' data frame to set a default RAT on a dataset (`NA` will be interpreted
#' as the value that \R uses internally to represent it for the type, e.g.,
#' -2147483648 for `NA_integer_`). In some cases, removing the row in the output
#' data frame with value `NA`, rather than recoding, may be desirable (i.e., by
#' removing manually or by side effect of joining via `merge()`, for example).
#' Users should consider what is appropriate for a particular case.
#'
#' @param raster Either a `GDALRaster` object, or a character string containing
#' the file name of a raster dataset to open.
#' @param band Integer scalar, band number to read (default `1L`).
#' @param col_names Character vector of length two containing names to use for
#' column 1 (pixel values) and column 2 (pixel counts) in the output data
#' frame (defaults are `c("VALUE", "COUNT")`).
#' @param table_type Character string describing the type of the attribute
#' table. One of either `"thematic"`, or `"athematic"` for continuous data
#' (the default).
#' @param na_value Numeric scalar. If the set of unique pixel values has an
#' `NA`, it will be recoded to `na_value` in the returned data frame.
#' If `NULL` (the default), `NA` will not be recoded.
#' @param join_df Optional data frame for joining additional attributes. Must
#' have a column of unique values with the same name as `col_names[1]`
#' (`"VALUE"` by default).
#' @param quiet Logical scalar. If `TRUE``, a progress bar will not be
#' displayed. Defaults to `FALSE``.
#' @returns A data frame with at least two columns containing the set of unique
#' pixel values and their counts. These columns have attribute `"GFU"` set to
#' `"MinMax"` for the values, and `"PixelCount"` for the counts. If `join_df` is
#' given, the returned data frame will have additional columns that result from
#' `merge()`. The `"GFU"` attribute of the additional columns will be assigned
#' automatically based on the column names (_case-insensitive_ matching, see
#' Details). The returned data frame has attribute `"GDALRATTableType"` set to
#' `table_type`.
#'
#' @seealso
#' [`GDALRaster$getDefaultRAT()`][GDALRaster],
#' [`GDALRaster$setDefaultRAT()`][GDALRaster],
#' [displayRAT()]
#'
#' `vignette("raster-attribute-tables")`
#'
#' @examples
#' evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
#' # make a copy to modify
#' f <- file.path(tempdir(), "storml_evt_tmp.tif")
#' file.copy(evt_file,  f)
#'
#' ds <- new(GDALRaster, f, read_only=FALSE)
#' ds$getDefaultRAT(band = 1) # NULL
#'
#' # get the full attribute table for LANDFIRE EVT from the CSV file
#' evt_csv <- system.file("extdata/LF20_EVT_220.csv", package="gdalraster")
#' evt_df <- read.csv(evt_csv)
#' nrow(evt_df)
#' head(evt_df)
#' evt_df <- evt_df[,1:7]
#'
#' tbl <- buildRAT(ds,
#'                 table_type = "thematic",
#'                 na_value = -9999,
#'                 join_df = evt_df)
#'
#' nrow(tbl)
#' head(tbl)
#'
#' # attributes on the data frame and its columns define usage in a GDAL RAT
#' attributes(tbl)
#' attributes(tbl$VALUE)
#' attributes(tbl$COUNT)
#' attributes(tbl$EVT_NAME)
#' attributes(tbl$EVT_LF)
#' attributes(tbl$EVT_PHYS)
#' attributes(tbl$R)
#' attributes(tbl$G)
#' attributes(tbl$B)
#'
#' ds$setDefaultRAT(band = 1, tbl)
#' ds$flushCache()
#'
#' tbl2 <- ds$getDefaultRAT(band = 1)
#' nrow(tbl2)
#' head(tbl2)
#'
#' ds$close()
#' \dontshow{deleteDataset(f)}
#'
#' ## Display
#' # requires suggested package "gt"
#' if (requireNamespace("gt", quietly = TRUE)) {
#'   evt_gt <- displayRAT(tbl2, title = "Storm Lake EVT Raster Attribute Table")
#'   class(evt_gt)  # an object of class "gt_tbl" from package gt
#' }
#' # To show the table:
#' # evt_gt
#' # or simply call `displayRAT()` as above but without assignment
#' # `vignette("raster-attribute-tables")` has example output
#' @export
buildRAT <- function(raster,
                     band = 1L,
                     col_names = c("VALUE", "COUNT"),
                     table_type = "athematic",
                     na_value = NULL,
                     join_df = NULL,
                     quiet = FALSE) {

    if (length(raster) != 1)
        stop("'raster' argument must have length 1", call. = FALSE)

    ds <- NULL
    close_ds <- FALSE
    if (is(raster, "Rcpp_GDALRaster")) {
        ds <- raster
    } else if (is(raster, "character")) {
        ds <- new(GDALRaster, raster)
        close_ds <- TRUE
    } else {
        stop("'raster' must be a 'GDALRaster' object or a filename",
             call. = FALSE)
    }

    if (length(band) != 1)
        stop("'band' must be an integer scalar", call. = FALSE)
    else
        band <- as.integer(band)

    if (length(col_names) != 2)
        stop("'col_names' must have length 2", call. = FALSE)

    if (length(table_type) != 1 || !is(table_type, "character"))
        stop("'table_type' must be a character string", call. = FALSE)

    join <- FALSE
    if (!is.null(join_df)) {
        join <- TRUE
        if (!is.data.frame(join_df))
            stop("'join_df' must be a data frame", call. = FALSE)
        if (!(col_names[1] %in% names(join_df)))
            stop("'names(join_df)' must contain 'col_names[1]'",
                 call. = FALSE)
        if (col_names[2] %in% names(join_df))
            stop("'names(join_df)' cannot contain 'col_names[2]'",
                 call. = FALSE)
    }

    d <- .value_count(ds, band, quiet)
    if (close_ds)
        ds$close()
    names(d) <- col_names
    if (!is.null(na_value))
        d[is.na(d[, 1]), 1] <- na_value
    if (join) {
        if (anyNA(d[, 1])) {
            cli::cli_alert_warning(
                "row with {.val {NA}} value will be dropped in join")
        }
        n_before <- nrow(d)
        d <- merge(d, join_df)
        if (n_before != nrow(d)) {
            cli::cli_alert_info(
                paste0("rows before join: {.val {n_before}}, ",
                       "rows after: {.val {nrow(d)}}"))
        }
    }
    d <- d[order(d[, col_names[1]]), ]
    row.names(d) <- NULL
    attr(d[, col_names[1]], "GFU") <- "MinMax"
    attr(d[, col_names[2]], "GFU") <- "PixelCount"
    if (join) {
        for (nm in setdiff(names(join_df), col_names)) {
            if (regexpr("name", tolower(nm), fixed=TRUE) > 0) {
                attr(d[, nm], "GFU") <- "Name"
                break
            }
        }
        hasRed <- FALSE
        hasGreen <- FALSE
        hasBlue <- FALSE
        hasAlpha <- FALSE
        for (nm in setdiff(names(join_df), col_names)) {
            if (tolower(nm) == "r" || tolower(nm) == "red") {
                if (!hasRed) {
                    attr(d[, nm], "GFU") <- "Red"
                    hasRed <- TRUE
                }
            } else if (tolower(nm) == "g" || tolower(nm) == "green") {
                if (!hasGreen) {
                    attr(d[, nm], "GFU") <- "Green"
                    hasGreen <- TRUE
                }
            } else if (tolower(nm) == "b" || tolower(nm) == "blue") {
                if (!hasBlue) {
                    attr(d[, nm], "GFU") <- "Blue"
                    hasBlue <- TRUE
                }
            } else if (tolower(nm) == "a" || tolower(nm) == "alpha") {
                if (!hasAlpha) {
                    attr(d[, nm], "GFU") <- "Alpha"
                    hasAlpha <- TRUE
                }
            }
            if (is.null(attr(d[, nm], "GFU"))) {
                attr(d[, nm], "GFU") <- "Generic"
            }
        }
    }
    attr(d, "GDALRATTableType") <- table_type
    return(d)
}


#' Display a GDAL Raster Attribute Table
#'
#' @description
#' `displayRAT()` generates a presentation table. Colors are shown if the
#' Raster Attribute Table contains RGB columns.
#' This function requires package `gt`.
#'
#' @param tbl A data frame formatted as a GDAL RAT (e.g., as returned by
#' `buildRAT()` or `GDALRaster$getDefaultRAT()`).
#' @param title Character string to be used in the table title.
#' @returns An object of class `"gt_tbl"` (i.e., a table created with
#' `gt::gt()`).
#'
#' @seealso
#' [buildRAT()], [`GDALRaster$getDefaultRAT()`][GDALRaster]
#'
#' `vignette("raster-attribute-tables")`
#'
#' @examples
#' # see examples for `buildRAT()`
#' @export
displayRAT <- function(tbl, title = "Raster Attribute Table") {

    if (!requireNamespace("gt", quietly = TRUE))
        stop("displayRAT() requires package 'gt'", call. = FALSE)

    if (!is.data.frame(tbl))
        stop("'tbl' must be a data frame", call. = FALSE)

    if (is.null(attr(tbl, "GDALRATTableType"))) {
        cli::cli_alert_danger(
            "input data frame is missing attribute {.val 'GDALRATTableType'}")
        stop("'tbl' must be formatted as a GDAL RAT",
             call.=FALSE)
    }

    if (length(title) != 1 || !is(title, "character"))
        stop("'title' must be a character string", call. = FALSE)

    col_red <- NULL
    col_green <- NULL
    col_blue <- NULL
    col_alpha <- NULL
    hasRGB <- FALSE
    for (nm in names(tbl)) {
        if (attr(tbl[, nm], "GFU") == "Red") {
            col_red <- nm
        } else if (attr(tbl[, nm], "GFU") == "Green") {
            col_green <- nm
        } else if (attr(tbl[, nm], "GFU") == "Blue") {
            col_blue <- nm
        } else if (attr(tbl[, nm], "GFU") == "Alpha") {
            col_alpha <- nm
        }
    }
    if (!is.null(col_red) && !is.null(col_green) && !is.null(col_blue)) {
        hasRGB <- TRUE
        if (!is.null(col_alpha)) {
            tbl$Color <- rgb(tbl[, col_red],
                             tbl[, col_green],
                             tbl[, col_blue],
                             tbl[, col_alpha],
                             maxColorValue=255)
        } else {
            tbl$Color <- rgb(tbl[, col_red],
                             tbl[, col_green],
                             tbl[, col_blue],
                             maxColorValue=255)
        }
    }

    gt_tbl <- gt::gt(tbl)
    if (hasRGB) {
        f <- function(x) { tbl$Color[match(x, tbl$Color)] }
        gt_tbl <- gt::data_color(gt_tbl, columns="Color", fn=f)
        gt_tbl <- gt::cols_move_to_start(gt_tbl, columns="Color")
    }
    gt_tbl <- gt::tab_header(gt_tbl, title=title)

    return(gt_tbl)
}

test_that("buildRAT/displayRAT work", {
    evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
    evt_csv <- system.file("extdata/LF20_EVT_220.csv", package="gdalraster")
    evt_tbl <- read.csv(evt_csv)
    evt_tbl <- evt_tbl[,1:7]
    rat <- buildRAT(evt_file, table_type="thematic", na_value=-9999,
                    join_df=evt_tbl)
    expect_equal(nrow(rat), 24)
    expect_equal(ncol(rat), 8)
    expect_equal(attr(rat, "GDALRATTableType"), "thematic")
    expect_equal(attr(rat$VALUE, "GFU"), "MinMax")
    expect_equal(attr(rat$COUNT, "GFU"), "PixelCount")
    expect_equal(sum(rat$COUNT), 15301)
    if (requireNamespace("gt", quietly = TRUE)) {
        tbl <- displayRAT(rat)
        expect_true(is(tbl, "gt_tbl"))
    }

    # with alpha
    rat$A <- 255
    attr(rat$A, "GFU") <- "Alpha"
    if (requireNamespace("gt", quietly = TRUE)) {
        tbl <- displayRAT(rat)
        expect_true(is(tbl, "gt_tbl"))
    }

    # pass as an object of class GDALRaster
    rat <- NULL
    ds <- new(GDALRaster, evt_file)
    rat <- buildRAT(ds, table_type="thematic", na_value=-9999,
                    join_df=evt_tbl)
    expect_equal(nrow(rat), 24)
    expect_equal(ncol(rat), 8)
    expect_equal(sum(rat$COUNT), 15301)
    ds$close()

    # uint32 raster
    lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
    rasterfiles <- c(lcp_file, lcp_file)
    bands <- c(4, 5)
    var.names <- c("fbfm", "tree_cov")
    cmb_file <- paste0(tempdir(), "/", "cmb_uint32.tif")
    d <- combine(rasterfiles, var.names, bands, cmb_file)
    tbl <- buildRAT(cmb_file)
    expect_equal(nrow(tbl), nrow(d))
    expect_equal(sum(tbl$COUNT), sum(d$count))
    deleteDataset(cmb_file)
})

# This file contains the R interface for src/ogr_util.h.
# Chris Toney <chris.toney at usda.gov>

#' Utility functions for managing vector data sources
#'
#' This set of functions can be used to create new vector datasets,
#' test existence of dataset/layer/field, test dataset and layer capabilities,
#' create new layers in an existing dataset, get the names of field domains
#' stored in a dataset, write field domains in a dataset, delete layers, create
#' new attribute and geometry fields on an existing layer, rename and delete
#' fields, and edit data with SQL statements.
#'
#' @name ogr_manage
#' @details
#' These functions are complementary to `ogrinfo()` and `ogr2ogr()` for
#' vector data management. Bindings to OGR wrap portions of the GDAL
#' Vector API (ogr_core.h and ogr_api.h,
#' \url{https://gdal.org/en/stable/api/vector_c_api.html}).
#'
#' `ogr_ds_exists()` tests whether a vector dataset can be opened from the
#' given data source name (DSN), potentially testing for update access.
#' Returns a logical value.
#'
#' `ogr_ds_format()` returns a character string containing the short name of
#' the format driver for a given DSN, or `NULL` if the dataset cannot be
#' opened as a vector source.
#'
#' `ogr_ds_test_cap()` tests the capabilities of a vector data source,
#' attempting to open it with update access by default.
#' Returns a list of capabilities with values `TRUE` or `FALSE`, or `NULL` is
#' returned if `dsn` cannot be opened with the requested access.
#' Wrapper of `GDALDatasetTestCapability()` in the GDAL API.
#' The returned list contains the following named elements:
#' * `CreateLayer`: `TRUE` if this dataset can create new layers
#' * `DeleteLayer`: `TRUE` if this dataset can delete existing layers
#' * `CreateGeomFieldAfterCreateLayer`: `TRUE` if the layers of this
#' dataset supports geometry field creation just after layer creation
#' * `CurveGeometries`: `TRUE` if this dataset supports curve geometries
#' * `Transactions`: `TRUE` if this dataset supports (efficient)
#' transactions
#' * `EmulatedTransactions`: `TRUE` if this dataset supports transactions
#' through emulation
#' * `RandomLayerRead`: `TRUE` if this dataset has a dedicated
#' `GetNextFeature()` implementation, potentially returning features from
#' layers in a non-sequential way
#' * `RandomLayerWrite`: `TRUE` if this dataset supports calling
#' `CreateFeature()` on layers in a non-sequential way
#' * `AddFieldDomain`: `TRUE` if this dataset supports adding field domains
#' (GDAL >= 3.3)
#' * `DeleteFieldDomain`: `TRUE` if this dataset supports deleting field
#' domains (GDAL >= 3.5)
#' `UpdateFieldDomain`: `TRUE` if this dataset supports updating a an existing
#' field domain by replacing its definition (GDAL >= 3.5)
#'
#' `ogr_ds_create()` creates a new vector dataset, optionally also creating
#' a layer, and optionally creating one or more fields on the layer.
#' The attribute fields and geometry field(s) to create can be specified as a
#' feature class definition (`layer_defn` as list, see [ogr_define]), or
#' alternatively, by giving the `geom_type` and `srs`, optionally along with
#' one `fld_name` and `fld_type` to be created in the layer.
#' By default, returns logical `TRUE` indicating success (output written to
#' `dst_filename`), or an object of class [`GDALVector`][GDALVector] for the
#' output layer will be returned if `return_obj = TRUE`. An error is raised if
#' the operation fails.
#'
#' `ogr_ds_layer_count()` returns the number of layers in a vector dataset.
#'
#' `ogr_ds_layer_names()` returns a character vector of layer names in a
#' vector dataset, or `NULL` if no layers are found.
#'
#' `ogr_ds_field_domain_names()` returns a character vector with the names of
#' all field domains stored in the dataset. Returns `NULL` and emits a warning
#' if an error occurs or if the format does not support reading field domains.
#' Returns a character vector of length 0 (`character(0)`) if the format
#' supports field domains but none are present in the dataset.
#' Requires GDAL >= 3.5. See [ogr_define] for information on field domains.
#'
#' `ogr_ds_add_field_domain()` adds a field domain to a vector dataset. Only a
#' few drivers will support this operation, and some of them might only support
#' it only for some types of field domains. GeoPackage and OpenFileGDB drivers
#' support this operation. A dataset having at least some support should report
#' the `AddFieldDomain` dataset capability (see `ogr_ds_test_cap()`above).
#' Returns a logical value, `TRUE` indicating success. Requires GDAL >= 3.3.
#'
#' `ogr_ds_delete_field_domain()` deletes a field domain from a vector dataset
#' if supported (see `ogr_ds_test_cap()`above for the `DeleteFieldDomain`
#' dataset capability). Returns a logical value, `TRUE` indicating success.
#' Requires GDAL >= 3.5.
#'
#' `ogr_layer_exists()` tests whether a layer can be accessed by name in a
#' given vector dataset. Returns a logical value
#'
#' `ogr_layer_test_cap()` tests whether a layer supports named capabilities,
#' attempting to open the dataset with update access by default.
#' Returns a list of capabilities with values `TRUE` or `FALSE`. `NULL` is
#' returned if `dsn` cannot be opened with the requested access, or `layer`
#' cannot be found. The returned list contains the following named elements:
#' `RandomRead`, `SequentialWrite`, `RandomWrite`, `UpsertFeature`,
#' `FastSpatialFilter`, `FastFeatureCount`, `FastGetExtent`,
#' `FastSetNextByIndex`, `CreateField`, `CreateGeomField`, `DeleteField`,
#' `ReorderFields`, `AlterFieldDefn`, `AlterGeomFieldDefn`, `IgnoreFields`,
#' `DeleteFeature`, `Rename`, `StringsAsUTF8`, `CurveGeometries`.
#' See the GDAL documentation for
#' [`OGR_L_TestCapability()`](https://gdal.org/en/stable/api/vector_c_api.html#_CPPv420OGR_L_TestCapability9OGRLayerHPKc).
#'
#' `ogr_layer_create()` creates a new layer in an existing vector data source,
#' with a specified geometry type and spatial reference definition.
#' This function also accepts a feature class definition given as a list of
#' field names and their definitions (see [ogr_define]).
#' (Note: use `ogr_ds_create()` to create single-layer formats such as "ESRI
#' Shapefile", "FlatGeobuf", "GeoJSON", etc.)
#' By default, returns logical `TRUE` indicating success, or an object of class
#' [`GDALVector`][GDALVector] will be returned if `return_obj = TRUE`.
#' An error is raised if the operation fails.
#'
#' `ogr_layer_field_names()` returns a character vector of field names on a
#' layer, or `NULL` if no fields are found. The first layer by index is opened
#' if `NULL` is given for the `layer` argument.
#'
#' `ogr_layer_rename()` renames a layer in a vector dataset. This operation is
#' implemented only by layers that expose the `Rename` capability (see
#' `ogr_layer_test_cap()` above). This operation will fail if a layer with the
#' new name already exists. Returns a logical value, `TRUE` indicating success.
#' Requires GDAL >= 3.5.
#'
#' `ogr_layer_delete()` deletes an existing layer in a vector dataset.
#' Returns a logical value, `TRUE` indicating success.
#'
#' `ogr_field_index()` tests for existence of an attribute field by name.
#' Returns the field index on the layer (0-based), or `-1` if the field does
#' not exist.
#'
#' `ogr_field_create()` creates a new attribute field of specified data type in
#' a given DSN/layer. Several optional field properties can be specified in
#' addition to the type. Returns a logical value, `TRUE` indicating success.
#'
#' `ogr_geom_field_create()` creates a new geometry field of specified type in
#' a given DSN/layer. Returns a logical value, `TRUE` indicating success.
#'
#' `ogr_field_rename()` renames an existing field on a vector layer.
#' Not all format drivers support this function. Some drivers may only support
#' renaming a field while there are still no features in the layer.
#' `AlterFieldDefn` is the relevant layer capability to check.
#' Returns a logical value, `TRUE` indicating success.
#'
#' `ogr_field_set_domain_name()` sets the field domain name for an existing
#' attribute field on a vector layer. `AlterFieldDefn` layer capability is
#' required. Returns a logical value, `TRUE` indicating success.
#' Requires GDAL >= 3.3.
#'
#' `ogr_field_delete()` deletes an existing field on a vector layer.
#' Not all format drivers support this function. Some drivers may only support
#' deleting a field while there are still no features in the layer.
#' Returns a logical value, `TRUE` indicating success.
#'
#' `ogr_execute_sql()` executes an SQL statement against the data store.
#' This function can be used to modify the schema or edit data using SQL
#' (e.g., `ALTER TABLE`, `DROP TABLE`, `CREATE INDEX`, `DROP INDEX`, `INSERT`,
#' `UPDATE`, `DELETE`), or to execute a query (i.e., `SELECT`).
#' Returns `NULL` (invisibly) for statements that are in error, or that have no
#' results set, or an object of class `GDALVector` representing a results set
#' from the query. Wrapper of `GDALDatasetExecuteSQL()` in the GDAL API.
#'
#' @param dsn Character string. The vector data source name, e.g., a filename
#' or database connection string.
#' @param with_update Logical value. `TRUE` to request update access when
#' opening the dataset, or `FALSE` to open read-only.
#' @param format GDAL short name of the vector format as character string.
#' Examples of some common output formats include: `"GPKG"`, `"FlatGeobuf"`,
#' `"ESRI Shapefile"`, `"SQLite"`.
#' @param layer Character string for a layer name in a vector dataset.
#' The `layer` argument may be given as empty string (`""`) in which case the
#' first layer by index will be opened (except with `ogr_layer_delete()` and
#' `ogr_layer_rename()` for which a layer name must be specified).
#' @param layer_defn A feature class definition for `layer` as a list of
#' zero or more attribute field definitions, and at least one geometry field
#' definition (see [ogr_define]).
#' Each field definition is a list with named elements containing values for
#' the field `type` element and other properties.
#' If `layer_defn` is given, it will be used and any additional parameters
#' passed that relate to the feature class definition will be ignored (i.e.,
#' `geom_type` and `srs`, as well as `fld_name` and `fld_type` in
#' `ogr_ds_create()`).
#' The first geometry field definition in `layer_defn` defines the
#' geometry type and spatial reference system for the layer (the geom field
#' definition must contain `type`, and should also contain `srs` when
#' creating a layer from a feature class definition).
#' @param geom_type Character string specifying a geometry type (see Details).
#' @param srs Character string containing a spatial reference system definition
#' as OGC WKT or other well-known format (e.g., the input formats usable with
#' [srs_to_wkt()]).
#' @param fld_name Character string containing the name of an attribute field
#' in `layer`.
#' @param fld_defn A field definition as list (see [ogr_def_field()]).
#' Additional arguments in `ogr_field_create()` will be ignored if a `fld_defn`
#' is given.
#' @param fld_type Character string containing the name of a field data type
#' (e.g., `"OFTInteger"`, `"OFTInteger64"`, `"OFTReal"`, `"OFTString"`, ...).
#' @param fld_subtype Character string containing the name of a field subtype.
#' One of `"OFSTNone"` (the default), `"OFSTBoolean"`, `"OFSTInt16"`,
#' `"OFSTFloat32"`, `"OFSTJSON"`, `"OFSTUUID"`.
#' @param fld_width Optional integer value specifying max number of characters.
#' @param fld_precision Optional integer value specifying number of digits
#' after the decimal point.
#' @param is_nullable Optional NOT NULL field constraint (logical value).
#' Defaults to `TRUE`.
#' @param is_unique Optional UNIQUE constraint on the field (logical value).
#' Defaults to `FALSE`.
#' @param default_value Optional default value for the field as a character
#' string.
#' @param domain_name Character string specifying the name of the field domain.
#' @param geom_fld_defn A geometry field definition as list (see
#' [ogr_def_geom_field()]). Additional arguments in `ogr_geom_field_create()`
#' will be ignored if a `geom_fld_defn` is given.
#' @param new_name Character string containing a new name to assign.
#' @param dsco Optional character vector of format-specific creation options
#' for `dsn` (`"NAME=VALUE"` pairs).
#' @param lco Optional character vector of format-specific creation options
#' for `layer` (`"NAME=VALUE"` pairs).
#' @param fld_dom_defn A field domain definition, i.e., a list generated with
#' [ogr_def_field_domain()].
#' @param sql Character string containing an SQL statement (see Note).
#' @param spatial_filter Either a numeric vector of length four containing a
#' bounding box (xmin, ymin, xmax, ymax), or a character string containing a
#' geometry as OGC WKT, representing a spatial filter.
#' @param dialect Character string specifying the SQL dialect to use.
#' The OGR SQL engine (`"OGRSQL"`) will be used by default if a value is not
#' given. The `"SQLite"` dialect can also be used (see Note).
#' @param overwrite Logical value. `TRUE` to overwrite `dsn` if it already
#' exists when calling `ogr_ds_create()`. Default is `FALSE`.
#' @param return_obj Logical value. If `TRUE`, an object of class
#' [`GDALVector`][GDALVector] open on the newly created layer will be
#' returned. Defaults to `FALSE`. Must be used with either the `layer` or
#' `layer_defn` arguments.
#'
#' @note
#' The OGR SQL document linked under **See Also** contains information on the
#' SQL dialect supported internally by GDAL/OGR. Some format drivers (e.g.,
#' PostGIS) pass the SQL directly through to the underlying RDBMS (unless
#' `OGRSQL` is explicitly passed as the dialect). The SQLite dialect can also
#' be requested with the `SQLite` string passed as the `dialect` argument of
#' `ogr_execute_sql()`. This assumes that GDAL/OGR is built with support for
#' SQLite, and preferably also with Spatialite support to benefit from spatial
#' functions. The GDAL document for SQLite dialect has detailed information.
#'
#' Other SQL dialects may also be present for some vector formats.
#' For example, the `"INDIRECT_SQLITE"` dialect might potentially be used with
#' GeoPackage format (\url{https://gdal.org/en/stable/drivers/vector/gpkg.html#sql}).
#'
#' The function [ogrinfo()] can also be used to edit data with SQL statements
#' (GDAL >= 3.7).
#'
#' The name of the geometry column of a layer is empty (`""`) with some formats
#' such as ESRI Shapefile and FlatGeobuf. Implications for SQL may depend on the
#' dialect used. See the GDAL documentation for the "OGR SQL" and "SQLite"
#' dialects for details.
#'
#' @seealso
#  [ogr_define], [ogrinfo()], [ogr2ogr()]
#'
#' OGR SQL dialect and SQLite SQL dialect:\cr
#' \url{https://gdal.org/en/stable/user/ogr_sql_sqlite_dialect.html}
#'
#' @examples
#' ## Create GeoPackage and manage schema
#' dsn <- file.path(tempdir(), "test1.gpkg")
#' ogr_ds_create("GPKG", dsn)
#' ogr_ds_exists(dsn, with_update = TRUE)
#' # dataset capabilities
#' ogr_ds_test_cap(dsn)
#'
#' ogr_layer_create(dsn, layer = "layer1", geom_type = "Polygon",
#'                  srs = "EPSG:5070")
#'
#' ogr_field_create(dsn, layer = "layer1",
#'                  fld_name = "field1",
#'                  fld_type = "OFTInteger64",
#'                  is_nullable = FALSE)
#' ogr_field_create(dsn, layer = "layer1",
#'                  fld_name = "field2",
#'                  fld_type = "OFTString")
#'
#' ogr_ds_layer_count(dsn)
#' ogr_ds_layer_names(dsn)
#' ogr_layer_field_names(dsn, layer = "layer1")
#'
#' # delete a field
#' if (ogr_layer_test_cap(dsn, "layer1")$DeleteField) {
#'   ogr_field_delete(dsn, layer = "layer1", fld_name = "field2")
#' }
#'
#' ogr_layer_field_names(dsn, "layer1")
#'
#' # define a feature class and create layer
#' defn <- ogr_def_layer("Point", srs = epsg_to_wkt(4326))
#' # add the attribute fields
#' defn$id_field <- ogr_def_field(fld_type = "OFTInteger64",
#'                                is_nullable = FALSE,
#'                                is_unique = TRUE)
#' defn$str_field <- ogr_def_field(fld_type = "OFTString",
#'                                 fld_width = 25,
#'                                 is_nullable = FALSE,
#'                                 default_value = "'a default string'")
#' defn$numeric_field <- ogr_def_field(fld_type = "OFTReal",
#'                                     default_value = "0.0")
#'
#' ogr_layer_create(dsn, layer = "layer2", layer_defn = defn)
#' ogr_ds_layer_names(dsn)
#' ogr_layer_field_names(dsn, layer = "layer2")
#'
#' # add a field using SQL instead
#' ogr_execute_sql(dsn, sql = "ALTER TABLE layer2 ADD field4 float")
#'
#' # rename a field
#' if (ogr_layer_test_cap(dsn, "layer1")$AlterFieldDefn) {
#'   ogr_field_rename(dsn, layer = "layer2",
#'                    fld_name = "field4",
#'                    new_name = "renamed_field")
#' }
#' ogr_layer_field_names(dsn, layer = "layer2")
#'
#' # GDAL >= 3.7
#' if (gdal_version_num() >= gdal_compute_version(3, 7, 0))
#'   ogrinfo(dsn, "layer2")
#'
#' \dontshow{deleteDataset(dsn)}
#' ## Edit data using SQL
#' src <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
#' perims_shp <- file.path(tempdir(), "mtbs_perims.shp")
#' ogr2ogr(src_dsn = src, dst_dsn = perims_shp, src_layers = "mtbs_perims")
#' ogr_ds_format(dsn = perims_shp)
#' ogr_ds_layer_names(dsn = perims_shp)
#' ogr_layer_field_names(dsn = perims_shp, layer = "mtbs_perims")
#'
#' alt_tbl <- "ALTER TABLE mtbs_perims ADD burn_bnd_ha float"
#' ogr_execute_sql(dsn = perims_shp, sql = alt_tbl)
#'
#' upd <- "UPDATE mtbs_perims SET burn_bnd_ha = (burn_bnd_ac / 2.471)"
#' ogr_execute_sql(dsn = perims_shp, sql = upd, dialect = "SQLite")
#' ogr_layer_field_names(dsn = perims_shp, layer = "mtbs_perims")
#'
#' # if GDAL >= 3.7:
#' #   ogrinfo(dsn = perims_shp, layer = "mtbs_perims")
#' # or, for output incl. the feature data (omit the default "-so" arg):
#' #   ogrinfo(dsn = perims_shp, layer = "mtbs_perims", cl_arg = "-nomd")
#' \dontshow{deleteDataset(perims_shp)}
#' @export
ogr_ds_exists <- function(dsn, with_update = FALSE) {
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)

    if (is.null(with_update) || all(is.na(with_update)))
        with_update <- FALSE
    if (!is.logical(with_update) || length(with_update) > 1)
        stop("'with_update' must be a single logical value", call. = FALSE)

    return(.ogr_ds_exists(dsn, with_update))
}

#' @name ogr_manage
#' @export
ogr_ds_format <- function(dsn) {
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)

    ret <- .ogr_ds_format(dsn)
    if (ret == "")
        return(NULL)
    else
        return(ret)
}

#' @name ogr_manage
#' @export
ogr_ds_test_cap <- function(dsn, with_update = TRUE) {
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)

    if (is.null(with_update) || all(is.na(with_update)))
        with_update <- FALSE
    if (!is.logical(with_update) || length(with_update) > 1)
        stop("'with_update' must be a single logical value", call. = FALSE)

    return(.ogr_ds_test_cap(dsn, with_update))
}

#' @name ogr_manage
#' @export
ogr_ds_create <- function(format, dsn, layer = NULL, layer_defn = NULL,
                          geom_type = NULL, srs = NULL, fld_name = NULL,
                          fld_type = NULL, dsco = NULL, lco = NULL,
                          overwrite = FALSE, return_obj = FALSE) {

    # format
    if (missing(format) || is.null(format) || all(is.na(format)))
        stop("'format' is required", call. = FALSE)
    if (!(is.character(format) && length(format) == 1))
        stop("'format' must be a length-1 character vector", call. = FALSE)
    # dsn
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)
    if (vsi_stat(dsn) && !overwrite)
        stop("'dsn' exists but 'overwrite' is `FALSE`", call. = FALSE)
    # layer
    if (missing(layer) || is.null(layer) || all(is.na(layer)))
        layer <- ""
    if (!(is.character(layer) && length(layer) == 1))
        stop("'layer' must be a length-1 character vector", call. = FALSE)
    # layer_defn
    if (!is.null(layer_defn)) {
        if (!is.list(layer_defn) || is.data.frame(layer_defn)) {
            stop("'layer_defn' must be a list object", call. = FALSE)
        }
    }
    # geom_type
    if (missing(geom_type) || is.null(geom_type) || all(is.na(geom_type)))
        geom_type <- "UNKNOWN"
    if (!(is.character(geom_type) && length(geom_type) == 1))
        stop("'geom_type' must be a length-1 character vector", call. = FALSE)
    # srs
    if (missing(srs) || is.null(srs) || all(is.na(srs)))
        srs <- ""
    if (!(is.character(srs) && length(srs) == 1))
        stop("'srs' must be a length-1 character vector", call. = FALSE)
    # fld_name
    if (missing(fld_name) || is.null(fld_name) || all(is.na(fld_name)))
        fld_name <- ""
    if (!(is.character(fld_name) && length(fld_name) == 1))
        stop("'fld_name' must be a length-1 character vector", call. = FALSE)
    # fld_type
    if (missing(fld_type) || is.null(fld_type) || all(is.na(fld_type)))
        fld_type <- ""
    if (!(is.character(fld_type) && length(fld_type) == 1))
        stop("'fld_type' must be a length-1 character vector", call. = FALSE)
    # dsco
    if (!is.null(dsco)) {
        if (!is.character(dsco))
            stop("'dsco' must be a character vector", call. = FALSE)
    }
    # lco
    if (!is.null(lco)) {
        if (!is.character(lco))
            stop("'lco' must be a character vector", call. = FALSE)
    }
    # overwrite
    if (missing(overwrite) || is.null(overwrite) || all(is.na(overwrite)))
        overwrite <- FALSE
    if (!is.logical(overwrite) || length(overwrite) > 1)
        stop("'overwrite' must be a single logical value", call. = FALSE)
    # return_obj
    if (missing(return_obj) || is.null(return_obj) || all(is.na(return_obj)))
        return_obj <- FALSE
    if (!is.logical(return_obj) || length(return_obj) > 1)
        stop("'return_obj' must be a single logical value", call. = FALSE)
    if (return_obj && layer == "" && is.null(layer_defn)) {
        stop("'layer' or 'layer_defn' must be given with 'return_obj = TRUE'",
             call. = FALSE)
    }

    if (is.null(layer_defn)) {
        # signature for create_ogr() object factory
        lyr <- new(GDALVector, format, dsn, layer, geom_type, srs, fld_name,
                   fld_type, dsco, lco, NULL)

    } else {
        # signature for create_ogr() object factory
        lyr <- new(GDALVector, format, dsn, layer = layer, geom_type = "",
                   srs = "", fld_name = "", fld_type = "", dsco = dsco,
                   lco = lco, layer_defn = layer_defn)
    }

    if (return_obj) {
        return(lyr)
    } else {
        lyr$close()
        return(TRUE)
    }
}

#' @name ogr_manage
#' @export
ogr_ds_layer_count <- function(dsn) {
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)

    return(.ogr_ds_layer_count(dsn))
}

#' @name ogr_manage
#' @export
ogr_ds_layer_names <- function(dsn) {
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)

    return(.ogr_ds_layer_names(dsn))
}

#' @name ogr_manage
#' @export
ogr_ds_field_domain_names <- function(dsn) {
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)

    return(.ogr_ds_field_domain_names(dsn))
}

#' @name ogr_manage
#' @export
ogr_ds_add_field_domain <- function(dsn, fld_dom_defn) {
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)

    if (!is.list(fld_dom_defn) || is.data.frame(fld_dom_defn))
        stop("'fld_dom_defn' must be a list object", call. = FALSE)

    if (ogr_ds_test_cap(dsn)$AddFieldDomain) {
        return(.ogr_ds_add_field_domain(dsn, fld_dom_defn))
    } else {
        cli::cli_alert_danger("dataset does not support AddFieldDomain")
        return(FALSE)
    }
}

#' @name ogr_manage
#' @export
ogr_ds_delete_field_domain <- function(dsn, domain_name) {
    if (gdal_version_num() < gdal_compute_version(3, 5, 0))
        stop("ogr_ds_delete_field_domain() requires GDAL >= 3.5", call. = FALSE)

    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)

    if (!(is.character(domain_name) && length(domain_name) == 1))
        stop("'domain_name' must be a length-1 character vector", call. = FALSE)

    if (ogr_ds_test_cap(dsn)$DeleteFieldDomain) {
        return(.ogr_ds_delete_field_domain(dsn, domain_name))
    } else {
        cli::cli_alert_danger("dataset does not support DeleteFieldDomain")
        return(FALSE)
    }
}

#' @name ogr_manage
#' @export
ogr_layer_exists <- function(dsn, layer) {
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)

    if (missing(layer) || is.null(layer) || all(is.na(layer)))
        layer <- ""
    if (!(is.character(layer) && length(layer) == 1))
        stop("'layer' must be a length-1 character vector", call. = FALSE)

    return(.ogr_layer_exists(dsn, layer))
}

#' @name ogr_manage
#' @export
ogr_layer_test_cap <- function(dsn, layer = NULL, with_update = TRUE) {
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)

    if (missing(layer) || is.null(layer) || all(is.na(layer)))
        layer <- ""
    if (!(is.character(layer) && length(layer) == 1))
        stop("'layer' must be a length-1 character vector", call. = FALSE)

    if (is.null(with_update) || all(is.na(with_update)))
        with_update <- TRUE
    if (!is.logical(with_update) || length(with_update) > 1)
        stop("'with_update' must be a single logical value", call. = FALSE)

    return(.ogr_layer_test_cap(dsn, layer, with_update))
}

#' @name ogr_manage
#' @export
ogr_layer_create <- function(dsn, layer, layer_defn = NULL, geom_type = NULL,
                             srs = NULL, lco = NULL, return_obj = FALSE) {

    # dsn
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)
    if (!ogr_ds_exists(dsn, with_update = TRUE))
        stop("'dsn' does not exist, or no update access", call. = FALSE)
    # layer
    if (missing(layer) || is.null(layer) || all(is.na(layer)) || layer == "")
        stop("'layer' is required", call. = FALSE)
    if (!(is.character(layer) && length(layer) == 1))
        stop("'layer' must be a length-1 character vector", call. = FALSE)
    if (ogr_layer_exists(dsn, layer))
        stop("'layer' already exists", call. = FALSE)
    # layer_defn
    if (!is.null(layer_defn)) {
        if (!is.list(layer_defn) || is.data.frame(layer_defn)) {
            stop("'layer_defn' must be a list object", call. = FALSE)
        }
    }

    if (!is.null(layer_defn)) {
        # using layer_defn so get geom_type and srs from the geom field defn
        has_geom_fld_defn <- FALSE
        for (nm in names(layer_defn)) {
            if (!is.list(layer_defn[[nm]]))
                stop("field definition must be a list", call. = FALSE)

            if (is.null(layer_defn[[nm]]$is_geom) ||
                    !is.logical(layer_defn[[nm]]$is_geom)) {
                stop("field definitions must contain `is_geom = TRUE|FALSE`",
                     call. = FALSE)
            }

            if (layer_defn[[nm]]$is_geom) {
                geom_type <- layer_defn[[nm]]$type
                srs <- layer_defn[[nm]]$srs
                has_geom_fld_defn <- TRUE
                break
            }
        }
        if (!has_geom_fld_defn) {
            stop("'layer_defn' is missing a geometry field definition",
                 call. = FALSE)
        }
    }

    # geom_type
    if (missing(geom_type) || is.null(geom_type) || all(is.na(geom_type))) {
        warning("geometry type not specified, using 'UNKNOWN'", call. = FALSE)
        geom_type <- "UNKNOWN"
    }
    if (!(is.character(geom_type) && length(geom_type) == 1))
        stop("'geom_type' must be a length-1 character vector", call. = FALSE)
    # srs
    if (missing(srs) || is.null(srs) || all(is.na(srs)))
        srs <- ""
    if (!(is.character(srs) && length(srs) == 1))
        stop("'srs' must be a length-1 character vector", call. = FALSE)
    # lco
    if (!is.null(lco)) {
        if (!is.character(lco))
            stop("'lco' must be a character vector", call. = FALSE)
    }
    # return_obj
    if (missing(return_obj) || is.null(return_obj) || all(is.na(return_obj)))
        return_obj <- FALSE
    if (!is.logical(return_obj) || length(return_obj) > 1)
        stop("'return_obj' must be a single logical value", call. = FALSE)

    # signature for ogr_layer_create() object factory
    lyr <- new(GDALVector, dsn, layer, layer_defn, geom_type, srs, lco, TRUE)

    if (return_obj) {
        return(lyr)
    } else {
        lyr$close()
        return(TRUE)
    }
}

#' @name ogr_manage
#' @export
ogr_layer_field_names <- function(dsn, layer = NULL) {
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)

    if (missing(layer) || is.null(layer) || all(is.na(layer)))
        layer <- ""
    if (!(is.character(layer) && length(layer) == 1))
        stop("'layer' must be a length-1 character vector", call. = FALSE)


    return(.ogr_layer_field_names(dsn, layer))
}

#' @name ogr_manage
#' @export
ogr_layer_rename <- function(dsn, layer, new_name) {
    # dsn
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)
    if (!ogr_ds_exists(dsn, with_update = TRUE))
        stop("'dsn' does not exist, or no update access", call. = FALSE)
    # layer
    if (missing(layer) || is.null(layer) || all(is.na(layer)) || layer == "")
        stop("'layer' is required", call. = FALSE)
    if (!(is.character(layer) && length(layer) == 1))
        stop("'layer' must be a length-1 character vector", call. = FALSE)
    # new_name
    if (missing(new_name) || is.null(new_name) || all(is.na(new_name)) ||
        new_name == "") {

        stop("'new_name' is required", call. = FALSE)
    }
    if (!(is.character(new_name) && length(new_name) == 1))
        stop("'new_name' must be a length-1 character vector", call. = FALSE)

    return(.ogr_layer_rename(dsn, layer, new_name))
}

#' @name ogr_manage
#' @export
ogr_layer_delete <- function(dsn, layer) {
    # dsn
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)
    if (!ogr_ds_exists(dsn, with_update = TRUE))
        stop("'dsn' does not exist, or no update access", call. = FALSE)
    # layer
    if (missing(layer) || is.null(layer) || all(is.na(layer)) || layer == "")
        stop("'layer' is required", call. = FALSE)
    if (!(is.character(layer) && length(layer) == 1))
        stop("'layer' must be a length-1 character vector", call. = FALSE)

    return(.ogr_layer_delete(dsn, layer))
}

#' @name ogr_manage
#' @export
ogr_field_index <- function(dsn, layer, fld_name) {
    # dsn
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)
    # layer
    if (missing(layer) || is.null(layer) || all(is.na(layer)))
        layer <- ""
    if (!(is.character(layer) && length(layer) == 1))
        stop("'layer' must be a length-1 character vector", call. = FALSE)
    # fld_name
    if (missing(fld_name) || is.null(fld_name) || all(is.na(fld_name)) ||
        fld_name == "") {

        stop("'fld_name' is required", call. = FALSE)
    }
    if (!(is.character(fld_name) && length(fld_name) == 1))
        stop("'fld_name' must be a length-1 character vector", call. = FALSE)

    return(.ogr_field_index(dsn, layer, fld_name))
}

#' @name ogr_manage
#' @export
ogr_field_create <- function(dsn, layer, fld_name,
                             fld_defn = NULL,
                             fld_type = "OFTInteger",
                             fld_subtype = "OFSTNone",
                             fld_width = 0L,
                             fld_precision = 0L,
                             is_nullable = TRUE,
                             is_unique = FALSE,
                             default_value = "",
                             domain_name = NULL) {

    # dsn
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)
    if (!ogr_ds_exists(dsn, with_update = TRUE))
        stop("'dsn' does not exist, or no update access", call. = FALSE)
    # layer
    if (missing(layer) || is.null(layer) || all(is.na(layer)))
        layer <- ""
    if (!(is.character(layer) && length(layer) == 1))
        stop("'layer' must be a length-1 character vector", call. = FALSE)
    if (!ogr_layer_exists(dsn, layer))
        stop("'layer' does not exist", call. = FALSE)
    # fld_name
    if (missing(fld_name) || is.null(fld_name) || all(is.na(fld_name)) ||
        fld_name == "") {

        stop("'fld_name' is required", call. = FALSE)
    }
    if (!(is.character(fld_name) && length(fld_name) == 1))
        stop("'fld_name' must be a length-1 character vector", call. = FALSE)
    # default_value
    if (is.null(default_value) || all(is.na(default_value)))
        default_value <- ""
    else
        default_value <- as.character(default_value)
    if (!(length(default_value) == 1))
        stop("'default_value' must be a length-1 character vector",
             call. = FALSE)
    # domain_name
    if (is.null(domain_name) || all(is.na(domain_name)))
        domain_name <- ""
    if (!(is.character(domain_name) && length(domain_name) == 1))
        stop("'domain_name' must be a length-1 character vector",
             call. = FALSE)

    # use field definition if given
    if (!is.null(fld_defn)) {
        if (!is.list(fld_defn))
            stop("'fld_defn' must be a list", call. = FALSE)

        if (is.null(fld_defn$type))
            stop("'fld_defn$type' is required", call. = FALSE)
        else
            fld_type <- fld_defn$type

        if (!is.null(fld_defn$subtype))
            fld_subtype <- fld_defn$subtype
        else
            fld_subtype <- "OFSTNone"

        if (!is.null(fld_defn$width))
            fld_width <- fld_defn$width
        else
            fld_width <- 0

        if (!is.null(fld_defn$precision))
            fld_precision <- fld_defn$precision
        else
            fld_precision <- 0

        if (!is.null(fld_defn$is_nullable))
            is_nullable <- fld_defn$is_nullable
        else
            is_nullable <- TRUE

        if (!is.null(fld_defn$is_unique))
            is_unique <- fld_defn$is_unique
        else
            is_unique <- FALSE

        if (!is.null(fld_defn$default))
            default_value <- fld_defn$default
        else
            default_value <- ""

        if (!is.null(fld_defn$domain))
            domain_name <- fld_defn$domain
        else
            domain_name <- ""
    }

    return(.ogr_field_create(dsn, layer, fld_name, fld_type, fld_subtype,
                             fld_width, fld_precision, is_nullable, is_unique,
                             default_value, domain_name))
}

#' @name ogr_manage
#' @export
ogr_geom_field_create <- function(dsn, layer, fld_name,
                                  geom_fld_defn = NULL,
                                  geom_type = NULL,
                                  srs = NULL,
                                  is_nullable = TRUE) {

    # dsn
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)
    if (!ogr_ds_exists(dsn, with_update = TRUE))
        stop("'dsn' does not exist, or no update access", call. = FALSE)
    # layer
    if (missing(layer) || is.null(layer) || all(is.na(layer)))
        layer <- ""
    if (!(is.character(layer) && length(layer) == 1))
        stop("'layer' must be a length-1 character vector", call. = FALSE)
    if (!ogr_layer_exists(dsn, layer))
        stop("'layer' does not exist", call. = FALSE)
    # fld_name
    if (missing(fld_name) || is.null(fld_name) || all(is.na(fld_name)) ||
        fld_name == "") {

        stop("'fld_name' is required", call. = FALSE)
    }
    if (!(is.character(fld_name) && length(fld_name) == 1))
        stop("'fld_name' must be a length-1 character vector", call. = FALSE)
    # geom_type
    if (is.null(geom_type) || all(is.na(geom_type)))
        geom_type <- "UNKNOWN"
    else if (!(is.character(geom_type) && length(geom_type) == 1))
        stop("'geom_type' must be a length-1 character vector", call. = FALSE)
    # srs
    if (is.null(srs) || all(is.na(srs)))
        srs <- ""
    else if (!(is.character(srs) && length(srs) == 1))
        stop("'srs' must be a length-1 character vector", call. = FALSE)
    # is_nullable
    if (missing(is_nullable) || is.null(is_nullable) || all(is.na(is_nullable)))
        is_nullable <- TRUE
    if (!is.logical(is_nullable) || length(is_nullable) > 1)
        stop("'is_nullable' must be a single logical value", call. = FALSE)

    # use field definition if given
    if (!is.null(geom_fld_defn)) {
        if (!is.list(geom_fld_defn))
            stop("'geom_fld_defn' must be a list", call. = FALSE)

        if (is.null(geom_fld_defn$type))
            stop("'geom_fld_defn$type' is required", call. = FALSE)
        else
            geom_type <- geom_fld_defn$type

        if (is.null(geom_fld_defn$srs))
            srs <- ""
        else
            srs <- geom_fld_defn$srs

        if (!is.null(geom_fld_defn$is_nullable))
            is_nullable <- geom_fld_defn$is_nullable
        else
            is_nullable <- TRUE
    }

    return(.ogr_geom_field_create(dsn, layer, fld_name, geom_type, srs,
                                  is_nullable))
}

#' @name ogr_manage
#' @export
ogr_field_rename <- function(dsn, layer, fld_name, new_name) {
    # dsn
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)
    if (!ogr_ds_exists(dsn, with_update = TRUE))
        stop("'dsn' does not exist, or no update access", call. = FALSE)
    # layer
    if (missing(layer) || is.null(layer) || all(is.na(layer)))
        layer <- ""
    if (!(is.character(layer) && length(layer) == 1))
        stop("'layer' must be a length-1 character vector", call. = FALSE)
    if (!ogr_layer_exists(dsn, layer))
        stop("'layer' does not exist", call. = FALSE)
    # fld_name
    if (missing(fld_name) || is.null(fld_name) || all(is.na(fld_name)) ||
        fld_name == "") {

        stop("'fld_name' is required", call. = FALSE)
    }
    if (!(is.character(fld_name) && length(fld_name) == 1))
        stop("'fld_name' must be a length-1 character vector", call. = FALSE)
    # new_name
    if (missing(new_name) || is.null(new_name) || all(is.na(new_name)) ||
        new_name == "") {

        stop("'new_name' is required", call. = FALSE)
    }
    if (!(is.character(new_name) && length(new_name) == 1))
        stop("'new_name' must be a length-1 character vector", call. = FALSE)

    return(.ogr_field_rename(dsn, layer, fld_name, new_name))
}

#' @name ogr_manage
#' @export
ogr_field_set_domain_name <- function(dsn, layer, fld_name, domain_name) {
    # dsn
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)
    if (!ogr_ds_exists(dsn, with_update = TRUE))
        stop("'dsn' does not exist, or no update access", call. = FALSE)
    # layer
    if (missing(layer) || is.null(layer) || all(is.na(layer)))
        layer <- ""
    if (!(is.character(layer) && length(layer) == 1))
        stop("'layer' must be a length-1 character vector", call. = FALSE)
    if (!ogr_layer_exists(dsn, layer))
        stop("'layer' does not exist", call. = FALSE)
    # fld_name
    if (missing(fld_name) || is.null(fld_name) || all(is.na(fld_name)) ||
        fld_name == "") {

        stop("'fld_name' is required", call. = FALSE)
    }
    if (!(is.character(fld_name) && length(fld_name) == 1))
        stop("'fld_name' must be a length-1 character vector", call. = FALSE)
    # domain_name
    if (missing(domain_name) || is.null(domain_name) || all(is.na(domain_name)))
        stop("'domain_name' is required", call. = FALSE)
    if (!(is.character(domain_name) && length(domain_name) == 1))
        stop("'domain_name' must be a length-1 character vector", call. = FALSE)

    return(.ogr_field_set_domain_name(dsn, layer, fld_name, domain_name))
}

#' @name ogr_manage
#' @export
ogr_field_delete <- function(dsn, layer, fld_name) {
    # dsn
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)
    if (!ogr_ds_exists(dsn, with_update = TRUE))
        stop("'dsn' does not exist, or no update access", call. = FALSE)
    # layer
    if (missing(layer) || is.null(layer) || all(is.na(layer)))
        layer <- ""
    if (!(is.character(layer) && length(layer) == 1))
        stop("'layer' must be a length-1 character vector", call. = FALSE)
    if (!ogr_layer_exists(dsn, layer))
        stop("'layer' does not exist", call. = FALSE)
    # fld_name
    if (missing(fld_name) || is.null(fld_name) || all(is.na(fld_name)) ||
        fld_name == "") {

        stop("'fld_name' is required", call. = FALSE)
    }
    if (!(is.character(fld_name) && length(fld_name) == 1))
        stop("'fld_name' must be a length-1 character vector", call. = FALSE)

    return(.ogr_field_delete(dsn, layer, fld_name))
}

#' @name ogr_manage
#' @export
ogr_execute_sql <- function(dsn, sql, spatial_filter = NULL, dialect = NULL) {
    # dsn
    if (missing(dsn) || is.null(dsn) || all(is.na(dsn)))
        stop("'dsn' is required", call. = FALSE)
    if (!(is.character(dsn) && length(dsn) == 1))
        stop("'dsn' must be a length-1 character vector", call. = FALSE)
    # sql
    if (missing(sql) || is.null(sql) || all(is.na(sql)) || sql == "")
        stop("'sql' is required", call. = FALSE)
    if (!(is.character(sql) && length(sql) == 1))
        stop("'sql' must be a length-1 character vector", call. = FALSE)
    # spatial_filter
    if (!is.null(spatial_filter)) {
        if (is.numeric(spatial_filter) && length(spatial_filter) == 4)
            spatial_filter <- bbox_to_wkt(spatial_filter)
        if (!(is.character(spatial_filter) && length(spatial_filter) == 1))
            stop("spatial_filter must be length-4 numeric, or WKT string",
                 call. = FALSE)
    } else {
        spatial_filter <- ""
    }
    # dialect
    if (!is.null(dialect)) {
        if (!(is.character(dialect) && length(dialect) == 1))
            stop("'dialect' must be a length-1 character vector", call. = FALSE)
    } else {
        dialect <- ""
    }

    if (startsWith(toupper(sql), "SELECT ")) {
        return(new(GDALVector, dsn, sql, read_only = TRUE,
                   open_options = NULL, spatial_filter = spatial_filter,
                   dialect = dialect))
    } else {
        return(.ogr_execute_sql(dsn, sql, spatial_filter, dialect))
    }
}

test_that("OGR management utilities work", {
    # these tests assume GDAL was built with libsqlite3 which is optional
    # this should be a safe assumption since PROJ requires libsqlite3

    ## GPKG
    dsn <- tempfile(fileext = ".gpkg")
    expect_false(ogr_ds_exists(dsn))
    expect_true(ogr_ds_create("GPKG", dsn, "test_layer", geom_type = "POLYGON"))
    expect_true(ogr_ds_exists(dsn, with_update=TRUE))
    expect_true(ogr_layer_exists(dsn, "test_layer"))
    # default for 'overwrite' is FALSE
    expect_error(ogr_ds_create("GPKG", dsn, "test_layer",
                               geom_type = "POLYGON"))
    expect_true(ogr_ds_create("GPKG", dsn, "test_layer", geom_type = "POLYGON",
                              overwrite = TRUE))
    expect_true(ogr_ds_exists(dsn, with_update=TRUE))
    expect_true(ogr_layer_exists(dsn, "test_layer"))
    expect_false(ogr_layer_exists(dsn, "test_layer_2"))
    expect_true(ogr_ds_test_cap(dsn)$CreateLayer)
    lco <- "DESCRIPTION=test layer2"
    expect_true(ogr_layer_create(dsn, "test_layer_2", NULL, "POLYGON",
                                 "EPSG:5070", lco))
    expect_true(ogr_layer_exists(dsn, "test_layer_2"))
    expect_equal(ogr_ds_layer_count(dsn), 2)
    expect_equal(ogr_ds_layer_names(dsn), c("test_layer", "test_layer_2"))
    expect_equal(ogr_field_index(dsn, "test_layer_2", "DN"), -1)
    expect_true(ogr_layer_test_cap(dsn, "test_layer_2")$CreateField)
    expect_true(ogr_field_create(dsn, "test_layer_2", "DN",
                                 fld_type = "OFTInteger"))
    expect_equal(ogr_field_index(dsn, "test_layer_2", "DN"), 0)
    expect_equal(ogr_layer_field_names(dsn, "test_layer_2"), c("DN", "geom"))
    expect_true(ogr_ds_test_cap(dsn)$DeleteLayer)
    expect_true(ogr_layer_delete(dsn, "test_layer"))
    expect_equal(ogr_ds_layer_count(dsn), 1)
    expect_false(ogr_layer_delete(dsn, "test_layer_nonexist"))
    expect_true(ogr_layer_test_cap(dsn, "test_layer_2")$AlterFieldDefn)
    expect_true(ogr_field_rename(dsn, "test_layer_2", "DN", "renamed"))
    expect_equal(ogr_layer_field_names(dsn, "test_layer_2"),
                 c("renamed", "geom"))
    expect_true(ogr_layer_test_cap(dsn, "test_layer_2")$DeleteField)
    expect_true(ogr_field_delete(dsn, "test_layer_2", "renamed"))
    expect_equal(ogr_layer_field_names(dsn, "test_layer_2"), "geom")
    expect_true(ogr_layer_delete(dsn, "test_layer_2"))
    expect_equal(ogr_ds_layer_count(dsn), 0)

    defn <- ogr_def_layer("Point", srs = epsg_to_wkt(4326))
    defn$field1 <- ogr_def_field("OFTInteger64",
                                 is_nullable = FALSE,
                                 is_unique = TRUE)
    defn$field2 <- ogr_def_field("OFTString",
                                 fld_width = 25,
                                 is_nullable = FALSE,
                                 default_value = "'a default string'")
    defn$field3 <- ogr_def_field("OFTReal")
    expect_true(ogr_layer_create(dsn, "test_layer3", layer_defn = defn))
    expect_equal(ogr_ds_layer_names(dsn), "test_layer3")
    expect_equal(ogr_layer_field_names(dsn, "test_layer3"),
                 c("field1", "field2", "field3", "geom"))

    fld4_defn <- ogr_def_field("OFTReal",
                               default_value = "0.0")
    expect_true(ogr_field_create(dsn, "test_layer3", "field4",
                                 fld_defn = fld4_defn))
    fld5_defn <- ogr_def_field("OFTString",
                               fld_width = 25,
                               is_nullable = FALSE,
                               default_value = "'a default string'")
    expect_true(ogr_field_create(dsn, "test_layer3", "field5",
                                 fld_defn = fld5_defn))
    fld6_defn <- ogr_def_field("OFTInteger", fld_subtype = "OFSTBoolean")
    expect_true(ogr_field_create(dsn, "test_layer3", "field6",
                                 fld_defn = fld6_defn))
    expect_equal(ogr_layer_field_names(dsn, "test_layer3"),
                 c("field1", "field2", "field3", "field4", "field5", "field6",
                   "geom"))

    # only one geom field is supported by GPKG
    geomfld2_defn <- ogr_def_geom_field("Polygon", srs = epsg_to_wkt(4326))
    expect_false(ogr_geom_field_create(dsn, "test_layer3", "geom2",
                                       geom_fld_defn = geomfld2_defn))
    expect_equal(ogr_layer_field_names(dsn, "test_layer3"),
                 c("field1", "field2", "field3", "field4", "field5", "field6",
                   "geom"))

    # rename layer
    if (gdal_version_num() >= gdal_compute_version(3, 5, 0)) {
        expect_true(ogr_layer_test_cap(dsn, "test_layer3")$Rename)
        expect_true(ogr_layer_rename(dsn, "test_layer3", "test_new_name"))
        expect_equal(ogr_layer_field_names(dsn, "test_new_name"),
                     c("field1", "field2", "field3", "field4", "field5",
                       "field6", "geom"))
    }

    # test input validation
    # ogr_ds_exists
    expect_error(ogr_ds_exists(NULL))
    expect_error(ogr_ds_exists(rep(dsn, 2)))
    expect_no_error(ogr_ds_exists(dsn, with_update = NA))
    expect_error(ogr_ds_exists(dsn, with_update = "TRUE"))
    # ogr_ds_format
    expect_error(ogr_ds_format(NULL))
    expect_error(ogr_ds_format(rep(dsn, 2)))
    # ogr_ds_test_cap
    expect_error(ogr_ds_test_cap(NULL))
    expect_error(ogr_ds_test_cap(rep(dsn, 2)))
    expect_no_error(ogr_ds_test_cap(dsn, with_update = NA))
    expect_error(ogr_ds_test_cap(dsn, with_update = "TRUE"))
    # ogr_ds_create
    expect_error(ogr_ds_create(NULL, dsn, "test_layer_0",
                               geom_type = "POLYGON",
                               overwrite = TRUE))
    expect_error(ogr_ds_create(0, dsn, "test_layer_0",
                               geom_type = "POLYGON",
                               overwrite = TRUE))
    expect_error(ogr_ds_create("GPKG", NULL, "test_layer_0",
                               geom_type = "POLYGON",
                               overwrite = TRUE))
    expect_error(ogr_ds_create("GPKG", 0, "test_layer_0",
                               geom_type = "POLYGON",
                               overwrite = TRUE))
    expect_no_error(ogr_ds_create("GPKG", dsn, NULL,
                                  geom_type = "POLYGON",
                                  overwrite = TRUE))
    expect_error(ogr_ds_create("GPKG", dsn, 0,
                               geom_type = "POLYGON",
                               overwrite = TRUE))
    expect_error(ogr_ds_create("GPKG", dsn, "test_layer_0",
                               layer_defn = NA,
                               overwrite = TRUE))
    expect_no_error(ogr_ds_create("GPKG", dsn, "test_layer_0",
                                  geom_type = NULL,
                                  overwrite = TRUE))
    expect_error(ogr_ds_create("GPKG", dsn, "test_layer_0",
                               geom_type = 0,
                               overwrite = TRUE))
    expect_no_error(ogr_ds_create("GPKG", dsn, "test_layer_0",
                                  geom_type = "POLYGON",
                                  srs = NULL,
                                  overwrite = TRUE))
    expect_error(ogr_ds_create("GPKG", dsn, "test_layer_0",
                               geom_type = "POLYGON",
                               srs = 0,
                               overwrite = TRUE))
    expect_no_error(ogr_ds_create("GPKG", dsn, "test_layer_0",
                                  geom_type = "POLYGON",
                                  fld_name = NULL,
                                  overwrite = TRUE))
    expect_error(ogr_ds_create("GPKG", dsn, "test_layer_0",
                               geom_type = "POLYGON",
                               fld_name = 0,
                               overwrite = TRUE))
    expect_error(ogr_ds_create("GPKG", dsn, "test_layer_0",
                               geom_type = "POLYGON",
                               fld_name = "test_fld_0",
                               fld_type = NULL,
                               overwrite = TRUE))
    expect_error(ogr_ds_create("GPKG", dsn, "test_layer_0",
                               geom_type = "POLYGON",
                               fld_name = "test_fld_0",
                               fld_type = 0,
                               overwrite = TRUE))
    expect_error(ogr_ds_create("GPKG", dsn, "test_layer_0",
                               geom_type = "POLYGON",
                               dsco = 0,
                               overwrite = TRUE))
    expect_error(ogr_ds_create("GPKG", dsn, "test_layer_0",
                               geom_type = "POLYGON",
                               lco = 0,
                               overwrite = TRUE))
    # 'overwrite' defaults to FALSE so this should fail if 'dsn' exists:
    expect_error(ogr_ds_create("GPKG", dsn, "test_layer_0",
                               geom_type = "POLYGON",
                               overwrite = NULL))
    expect_error(ogr_ds_create("GPKG", dsn, "test_layer_0",
                               geom_type = "POLYGON",
                               overwrite = 0))
    expect_no_error(ogr_ds_create("GPKG", dsn, "test_layer_0",
                                  geom_type = "POLYGON",
                                  overwrite = TRUE,
                                  return_obj = NULL))
    expect_error(ogr_ds_create("GPKG", dsn, "test_layer_0",
                               geom_type = "POLYGON",
                               overwrite = TRUE,
                               return_obj = 0))
    expect_error(ogr_ds_create("GPKG", dsn, "",
                               geom_type = "POLYGON",
                               overwrite = TRUE,
                               return_obj = TRUE))
    # ogr_ds_layer_count
    expect_error(ogr_ds_layer_count(NULL))
    expect_error(ogr_ds_layer_count(rep(dsn, 2)))
    # ogr_ds_layer_names
    expect_error(ogr_ds_layer_names(NULL))
    expect_error(ogr_ds_layer_names(rep(dsn, 2)))
    # field domain functions are also tested in test-GDALVector-class.R
    # ogr_ds_field_domain_names
    expect_error(ogr_ds_field_domain_names(NULL))
    expect_error(ogr_ds_field_domain_names(rep(dsn, 2)))
    # ogr_ds_add_field_domain
    expect_error(ogr_ds_add_field_domain(NULL, list(1)))
    expect_error(ogr_ds_add_field_domain(rep(dsn, 2), list(1)))
    expect_error(ogr_ds_add_field_domain(dsn, 0))
    # ogr_layer_exists
    expect_error(ogr_layer_exists(NULL, "test_layer_0"))
    expect_error(ogr_layer_exists(rep(dsn, 2), "test_layer_0"))
    expect_no_error(ogr_layer_exists(dsn, ""))
    expect_error(ogr_layer_exists(dsn, 0))
    # ogr_layer_test_cap
    expect_error(ogr_layer_test_cap(NULL, "test_layer_0"))
    expect_error(ogr_layer_test_cap(rep(dsn, 2), "test_layer_0"))
    expect_no_error(ogr_layer_test_cap(dsn, ""))
    expect_error(ogr_layer_test_cap(dsn, 0))
    expect_no_error(ogr_layer_test_cap(dsn, "", with_update = NA))
    expect_error(ogr_layer_test_cap(dsn, "", with_update = "TRUE"))
    # ogr_layer_create
    expect_error(ogr_layer_create(NULL, "test_layer_0"))
    expect_error(ogr_layer_create(rep(dsn, 2), "test_layer_0"))
    expect_error(ogr_layer_create(dsn, ""))
    expect_error(ogr_layer_create(dsn, 1))
    expect_warning(ogr_layer_create(dsn, "test_layer_000"))
    # already exists:
    expect_error(ogr_layer_create(dsn, "test_layer_000"))
    expect_error(ogr_layer_create(dsn, "test_layer_001", layer_defn = 0))
    expect_error(ogr_layer_create(dsn, "test_layer_001", geom_type = 0))
    expect_warning(ogr_layer_create(dsn, "test_layer_001", geom_type = NULL))
    expect_warning(ogr_layer_create(dsn, "test_layer_002", srs = NULL))
    expect_error(ogr_layer_create(dsn, "test_layer_002", srs = 0))
    expect_error(ogr_layer_create(dsn, "test_layer_002", lco = 0))
    expect_error(ogr_layer_create(dsn, "test_layer_002", return_obj = NULL))
    expect_error(ogr_layer_create(dsn, "test_layer_002", return_obj = 0))
    # ogr_layer_field_names
    expect_error(ogr_layer_field_names(NULL, "test_layer_0"))
    expect_error(ogr_layer_field_names(rep(dsn, 2), "test_layer_0"))
    expect_no_error(ogr_layer_field_names(dsn, NULL))
    expect_error(ogr_layer_field_names(dsn, 0))
    # ogr_layer_rename
    if (gdal_version_num() >= gdal_compute_version(3, 5, 0)) {
        expect_error(ogr_layer_field_names(NULL, "test_layer_0", "new"))
        expect_error(ogr_layer_field_names(rep(dsn, 2), "test_layer_0", "new"))
        expect_error(ogr_layer_field_names(dsn, "", "new"))
        expect_error(ogr_layer_field_names(dsn, 0, "new"))
        expect_error(ogr_layer_field_names(dsn, "test_layer_0", ""))
        expect_error(ogr_layer_field_names(dsn, "test_layer_0", 0))
    }
    # ogr_layer_delete
    expect_error(ogr_layer_delete(NULL, "test_layer_0"))
    expect_error(ogr_layer_delete(rep(dsn, 2), "test_layer_0"))
    expect_error(ogr_layer_delete(dsn, NULL))
    expect_error(ogr_layer_delete(dsn, 0))
    # ogr_field_index
    expect_error(ogr_layer_delete(NULL, "test_layer_0", "field0"))
    expect_error(ogr_layer_delete(rep(dsn, 2), "test_layer_0", "field0"))
    expect_error(ogr_layer_delete(dsn, 0, "field0"))
    expect_error(ogr_layer_delete(dsn, "test_layer_0", NA))
    expect_error(ogr_layer_delete(dsn, "test_layer_0", 0))
    # ogr_field_create
    fld_defn_0 <- ogr_def_field("OFTReal")
    expect_true(ogr_layer_exists(dsn, "test_layer_0"))
    expect_error(ogr_field_create(NULL, "test_layer_0", "field0", fld_defn_0))
    expect_error(ogr_field_create(0, "test_layer_0", "field0", fld_defn_0))
    expect_error(ogr_field_create(dsn, 0, "field0", fld_defn_0))
    expect_error(ogr_field_create(dsn, "invalid", "field0", fld_defn_0))
    expect_error(ogr_field_create(dsn, "test_layer_0", NULL, fld_defn_0))
    expect_error(ogr_field_create(dsn, "test_layer_0", 0, fld_defn_0))
    expect_error(ogr_field_create(dsn, "test_layer_0", "field0",
                                  fld_type = "OFTReal",
                                  default_value = c(0, 1)))
    expect_error(ogr_field_create(dsn, "test_layer_0", "field0",
                                  fld_type = "OFTReal",
                                  domain_name = 0))
    expect_true(ogr_field_create(dsn, "test_layer_0", "field0", fld_defn_0))
    # already exists:
    expect_false(ogr_field_create(dsn, "test_layer_0", "field0", fld_defn_0))
    # ogr_field_rename
    expect_error(ogr_field_rename(NULL, "test_layer_0", "field0", "new0"))
    expect_error(ogr_field_rename(0, "test_layer_0", "field0", "new0"))
    expect_error(ogr_field_rename(dsn, 0, "field0", "new0"))
    expect_error(ogr_field_rename(dsn, "invalid", "field0", "new0"))
    expect_error(ogr_field_rename(dsn, "test_layer_0", NA, "new0"))
    expect_error(ogr_field_rename(dsn, "test_layer_0", 0, "new0"))
    expect_false(ogr_field_rename(dsn, "test_layer_0", "invalid", "new0"))
    expect_error(ogr_field_rename(dsn, "test_layer_0", "field0", ""))
    expect_error(ogr_field_rename(dsn, "test_layer_0", "field0", 0))
    expect_no_error(ogr_field_rename(dsn, "test_layer_0", "field0", "new0"))
    # ogr_field_set_domain_name
    expect_error(ogr_field_set_domain_name(NULL, "test_layer_0", "new0",
                                           "domain0"))
    expect_error(ogr_field_set_domain_name(0, "test_layer_0", "new0",
                                           "domain0"))
    expect_error(ogr_field_set_domain_name(dsn, 0, "new0",
                                           "domain0"))
    expect_error(ogr_field_set_domain_name(dsn, "invalid", "new0",
                                           "domain0"))
    expect_error(ogr_field_set_domain_name(dsn, "test_layer_0", NULL,
                                           "domain0"))
    expect_error(ogr_field_set_domain_name(dsn, "test_layer_0", 0,
                                           "domain0"))
    expect_false(ogr_field_set_domain_name(dsn, "test_layer_0", "invalid",
                                           "domain0"))
    expect_error(ogr_field_set_domain_name(dsn, "test_layer_0", "new0",
                                           NULL))
    expect_error(ogr_field_set_domain_name(dsn, "test_layer_0", "new0",
                                           character(0)))
    # ogr_field_delete
    expect_error(ogr_field_delete(NULL, "test_layer_0", "new0"))
    expect_error(ogr_field_delete(0, "test_layer_0", "new0"))
    expect_error(ogr_field_delete(dsn, 0, "new0"))
    expect_error(ogr_field_delete(dsn, "invalid", "new0"))
    expect_error(ogr_field_delete(dsn, "test_layer_0", ""))
    expect_error(ogr_field_delete(dsn, "test_layer_0", 0))
    # ogr_execute_sql
    sql <- "SELECT * FROM test_layer_0"
    expect_error(ogr_execute_sql(NULL, sql))
    expect_error(ogr_execute_sql(0, sql))
    expect_error(ogr_execute_sql(dsn, NULL))
    expect_error(ogr_execute_sql(dsn, character(0)))
    expect_error(ogr_execute_sql(dsn, sql, spatial_filter = numeric(0)))
    expect_error(ogr_execute_sql(dsn, sql, dialect = character(0)))
    expect_no_error(ogr_execute_sql(dsn, sql))

    deleteDataset(dsn)

    ## SQLite
    dsn <- tempfile(fileext = "sqlite")
    defn <- ogr_def_layer("Point", srs = epsg_to_wkt(4326))
    defn$field1 <- ogr_def_field("OFTInteger64",
                                 is_nullable = FALSE,
                                 is_unique = TRUE)
    defn$field2 <- ogr_def_field("OFTString",
                                 fld_width = 25,
                                 default_value = "'a default string'")
    defn$field3 <- ogr_def_field("OFTReal")
    ds_opt <- NULL
    if (has_spatialite())
        ds_opt <- "SPATIALITE=YES"
    expect_true(ogr_ds_create("SQLite", dsn, "layer1",
                              layer_defn = defn,
                              dsco = ds_opt,
                              lco = "GEOMETRY_NAME=geom1"))
    expect_equal(ogr_layer_field_names(dsn, "layer1"),
                 c("field1", "field2", "field3", "geom1"))

    # multiple geom fields supported by SQLite
    geomfld2_defn <- ogr_def_geom_field("Polygon", srs = epsg_to_wkt(4326))
    expect_true(ogr_geom_field_create(dsn, "layer1", "geom2",
                                      geom_fld_defn = geomfld2_defn))
    expect_equal(ogr_layer_field_names(dsn, "layer1"),
                 c("field1", "field2", "field3", "geom1", "geom2"))

    # input errors for ogr_geom_field_create()
    geomfld3_defn <- ogr_def_geom_field("Polygon", srs = epsg_to_wkt(4326))
    expect_error(ogr_geom_field_create(NULL, "layer1", "geom3",
                                       geom_fld_defn = geomfld3_defn))
    expect_error(ogr_geom_field_create(0, "layer1", "geom3",
                                       geom_fld_defn = geomfld3_defn))
    expect_error(ogr_geom_field_create(dsn, 0, "geom3",
                                       geom_fld_defn = geomfld3_defn))
    expect_error(ogr_geom_field_create(dsn, "invalid", "geom3",
                                       geom_fld_defn = geomfld3_defn))
    expect_error(ogr_geom_field_create(dsn, "layer1", NULL,
                                       geom_fld_defn = geomfld3_defn))
    expect_error(ogr_geom_field_create(dsn, "layer1", 0,
                                       geom_fld_defn = geomfld3_defn))
    expect_error(ogr_geom_field_create(dsn, "layer1", "geom3",
                                       geom_type = 0))
    expect_error(ogr_geom_field_create(dsn, "layer1", "geom3",
                                       geom_type = "Polygon",
                                       srs = 0))
    expect_error(ogr_geom_field_create(dsn, "layer1", "geom3",
                                       geom_type = "Polygon",
                                       is_nullable = 0))

    deleteDataset(dsn)

    # create with two geom fields initially with geom2 nullable
    dsn <- tempfile(fileext = "sqlite")
    defn$geom2 <- ogr_def_geom_field("Polygon", srs = epsg_to_wkt(4326),
                                     is_nullable = TRUE)
    expect_true(ogr_ds_create("SQLite", dsn, "layer1",
                              layer_defn = defn))
    expect_equal(ogr_layer_field_names(dsn, "layer1"),
                 c("field1", "field2", "field3", "GEOMETRY", "geom2"))

    deleteDataset(dsn)

    ## single-layer format, layer argument may be NULL or ""
    dsn <- system.file("extdata/poly_multipoly.shp", package="gdalraster")
    expect_equal(ogr_layer_field_names(dsn),
                 c("Event_ID", "Map_ID", "Ig_Date",  ""))

})

test_that("create MEM format works", {
    skip_if(gdal_version_num() < gdal_compute_version(3, 11, 0))

    defn <- ogr_def_layer("Point", srs = epsg_to_wkt(4269))
    defn$int_field <- ogr_def_field("OFTInteger")
    defn$str_field <- ogr_def_field("OFTString")
    defn$real_field <- ogr_def_field("OFTReal")
    defn$dt_field <- ogr_def_field("OFTDateTime")

    expect_no_error(lyr <- ogr_ds_create("MEM", "", "mem_layer",
                                         layer_defn = defn,
                                         lco = "FID=custom_fid",
                                         overwrite = TRUE,
                                         return_obj = TRUE))

    expect_equal(lyr$getDriverShortName(), "MEM")
    expect_equal(lyr$getFieldNames() |> length(), 5)

    lyr$close()
})

test_that("edit data using SQL works on shapefile", {
    src <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
    perims_shp <- paste0(tempdir(), "/", "mtbs_perims.shp")
    ogr2ogr(src, perims_shp, src_layers = "mtbs_perims")
    expect_equal(ogr_ds_layer_names(perims_shp), "mtbs_perims")
    num_fields <- length(ogr_layer_field_names(perims_shp, "mtbs_perims"))
    expect_true(num_fields > 2)
    expect_true(ogr_layer_test_cap(perims_shp, "mtbs_perims")$CreateField)
    # adjust field names for shapefile limitation on length
    sql <- "ALTER TABLE mtbs_perims ADD burn_bnd_h float"
    expect_true(is.null(ogr_execute_sql(perims_shp, sql)))
    sql <- "UPDATE mtbs_perims SET burn_bnd_h = (burn_bnd_a / 2.471)"
    ogr_execute_sql(perims_shp, sql, dialect = "SQLite")
    expect_length(ogr_layer_field_names(perims_shp, "mtbs_perims"),
                  num_fields + 1)

    # spatial filter
    # this should filter to 40 features from 61
    sql <- "SELECT * FROM mtbs_perims"
    bb <- c(469685.97, 11442.45, 544069.63, 85508.15)
    expect_no_error(lyr <- ogr_execute_sql(perims_shp, sql,
                                           spatial_filter = bb))
    expect_true(is(lyr, "Rcpp_GDALVector"))
    expect_equal(lyr$getFeatureCount(), 40)
    feat <- lyr$getNextFeature()
    expect_equal(feat$burn_bnd_h, (feat$burn_bnd_a / 2.471), tolerance = 0.1)
    lyr$close()

    bb_wkt <- bbox_to_wkt(bb)
    expect_no_error(lyr <- ogr_execute_sql(perims_shp, sql,
                                           spatial_filter = bb_wkt))
    expect_true(is(lyr, "Rcpp_GDALVector"))
    expect_equal(lyr$getFeatureCount(), 40)
    lyr$close()

    # error for invalid bb
    bb_invalid <- c(469685.97, 11442.45)
    expect_error(is.null(ogr_execute_sql(perims_shp, sql,
                                         spatial_filter = bb_invalid)))

    deleteDataset(perims_shp)
})

test_that("ogr_execute_sql returns results set for SELECT", {
    dsn <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
    sql <- "SELECT FID, * FROM mtbs_perims WHERE ig_year >= 2000 ORDER BY mtbs_perims.ig_year"
    lyr <- ogr_execute_sql(dsn, sql)
    expect_equal(lyr$getFeatureCount(), 40)
    lyr$close()

    sql <- "SELECT * FROM mtbs_perims"
    lyr2 <- ogr_execute_sql(dsn, sql, spatial_filter = c(469685.97, 11442.45, 544069.63, 85508.15))
    expect_equal(lyr2$getFeatureCount(), 40)
    lyr2$close()

    lyr3 <- ogr_execute_sql(dsn, sql)
    expect_equal(lyr3$getFeatureCount(), 61)
    lyr3$close()
})

test_that("GeoJSON layer and field names are correct", {
    dsn <- system.file("extdata/test.geojson", package="gdalraster")
    expect_true(ogr_ds_exists(dsn))
    dsn2 <- file.path(tempdir(TRUE), "test.geojson")
    file.copy(dsn, dsn2)
    expect_true(ogr_ds_exists(dsn2, with_update = TRUE))
    expect_equal(ogr_ds_format(dsn2), "GeoJSON")
    expect_equal(ogr_ds_layer_count(dsn2), 1)
    expect_equal(ogr_ds_layer_names(dsn2), "test")
    expect_equal(ogr_layer_field_names(dsn2, "test"),
                 c("int", "string", "double", "int2", ""))

    deleteDataset(dsn2)
})

#' Constants for VSIFile$seek()
#'
#' These are package global constants for convenience in calling
#' `VSIFile$seek()`.
#'
#' @name vsi_constants
#' @export
SEEK_SET <- "SEEK_SET"
#' @name vsi_constants
#' @export
SEEK_CUR <- "SEEK_CUR"
#' @name vsi_constants
#' @export
SEEK_END <- "SEEK_END"

#' @name VSIFile-class
#'
#' @aliases
#' Rcpp_VSIFile Rcpp_VSIFile-class VSIFile
#'
#' @title Class wrapping the GDAL VSIVirtualHandle API for binary file I/O
#' @description
#' `VSIFile` provides bindings to the GDAL VSIVirtualHandle API. Encapsulates a
#' `VSIVirtualHandle`
#' (\url{https://gdal.org/en/stable/api/cpl_cpp.html#_CPPv416VSIVirtualHandle}).
#' This API abstracts binary file I/O across "regular" file systems, URLs,
#' cloud storage services, Zip/GZip/7z/RAR, and in-memory files.
#' It provides analogs of several Standard C file I/O functions, allowing
#' virtualization of disk I/O so that non-file data sources can be made to
#' appear as files.
#'
#' `VSIFile` is a C++ class exposed directly to \R (via `RCPP_EXPOSED_CLASS`).
#' Fields and methods of the class are accessed using the `$` operator.
#'
#' @param filename Character string containing the filename to open. It may be
#' a file in a regular local filesystem, or a filename with a GDAL /vsiPREFIX/
#' (see \url{https://gdal.org/en/stable/user/virtual_file_systems.html}).
#' @param access Character string containing the access requested (i.e., `"r"`,
#' `"r+"`, `"w"`, `"w+`). Defaults to `"r"`. Binary access is always implied
#' and the "b" does not need to be included in `access`.
#' \tabular{lll}{
#'  **Access** \tab **Explanation**             \tab **If file exists**\cr
#'  `"r"`      \tab open file for reading       \tab read from start\cr
#'  `"r+"`     \tab open file for read/write    \tab read from start\cr
#'  `"w"`      \tab create file for writing     \tab destroy contents\cr
#'  `"w+"`     \tab create file for read/write  \tab destroy contents
#' }
#' @param options Optional character vector of `NAME=VALUE` pairs specifying
#' filesystem-dependent options. These are the options provided by
#' `VSIFOpenEx2L()` in the GDAL API (GDAL >= 3.3, see Details).
#' @returns An object of class `VSIFile` which contains a pointer to a
#' `VSIVirtualHandle`. Class methods are described in Details, along with a set
#' of writable fields for per-object settings.
#'
#' @section Usage (see Details):
#' ```
#' ## Constructors
#' vf <- new(VSIFile, filename)
#' # specifying access:
#' vf <- new(VSIFile, filename, access)
#' # specifying access and options (both required):
#' vf <- new(VSIFile, filename, access, options)
#'
#' ## Read/write fields (per-object settings)
#' vf$reportVSIFErrorAsEof
#'
#' ## Methods
#' vf$seek(offset, origin)
#' vf$tell()
#' vf$rewind()
#' vf$read(nbytes)
#' vf$write(object)
#' vf$eof()
#' vf$truncate(new_size)
#' vf$flush()
#' vf$ingest(max_size)
#'
#' vf$close()
#' vf$open()
#' vf$get_filename()
#' vf$get_access()
#' vf$set_access(access)
#' ```
#' @section Details:
#' ## Constructors
#'
#' \code{new(VSIFile, filename)}\cr
#' Returns an object of class `VSIFile`, or an error is raised if a file
#' handle cannot be obtained.
#'
#' \code{new(VSIFile, filename, access)}\cr
#' Alternate constructor for passing `access` as a character string
#' (e.g., `"r"`, `"r+"`, `"w"`, `"w+"`).
#' Returns an object of class `VSIFile` with an open file handle, or an error
#' is raised if a file handle cannot be obtained.
#'
#' \code{new(VSIFile, filename, access, options)}\cr
#' Alternate constructor for passing `access` as a character string, and
#' `options` as a character vector of "NAME=VALUE" pairs (all arguments
#' required, GDAL >= 3.3 required for `options` support).
#'
#' The `options` argument is highly file system dependent. Supported options
#' as of GDAL 3.10 include:
#' * MIME headers such as Content-Type and Content-Encoding are supported for
#' the /vsis3/, /vsigs/, /vsiaz/, /vsiadls/ file systems.
#' * DISABLE_READDIR_ON_OPEN=YES/NO (GDAL >= 3.6) for /vsicurl/ and other
#' network-based file systems. By default, directory file listing is done,
#' unless YES is specified.
#' * WRITE_THROUGH=YES (GDAL >= 3.8) for Windows regular files to set the
#' FILE_FLAG_WRITE_THROUGH flag to the `CreateFile()` function. In that mode,
#' the data are written to the system cache but are flushed to disk without
#' delay.
#'
#' Options specific to /vsis3/, /vsigs/, /vsioss/ and /vsiaz/:
#' * CACHE=YES/NO (GDAL >= 3.10) whether file metadata and content that is read
#' from the network should be kept cached in memory, after file handle closing.
#' Default is YES, unless the filename is set in CPL_VSIL_CURL_NON_CACHED.
#' * CHUNK_SIZE=val in MiB (GDAL >= 3.10) for "w" mode. Size of a block. Default
#' is 50 MiB. For /vsis3/, /vsigz/, /vsioss/, it can be up to 5000 MiB.
#' For /vsiaz/, only taken into account when BLOB_TYPE=BLOCK. It can be up to
#' 4000 MiB.
#'
#' Options specific to /vsiaz/ in "w" mode:
#' * BLOB_TYPE=APPEND/BLOCK (GDAL >= 3.10) type of blob. Defaults to APPEND.
#' Append blocks are limited to 195 GiB (however if the file size is below
#' 4 MiB, a block blob will be created in a single PUT operation).
#'
#' See the GDAL documentation for `VSIFOpenEx2L()` for the most current set of
#' available options (\url{https://gdal.org/en/stable/api/cpl.html}).
#'
#' ## Read/write fields (per-object settings)
#'
#' \code{$reportVSIFErrorAsEof}\cr
#' A logical value, `TRUE` (the default) to report a VSI error condition,
#' as indicated by `VSIFErrorL()` in GDAL >= 3.10, as `TRUE` in a call to the
#' \code{$eof()} method (see below). Since GDAL 3.10, some virtual file systems
#' that used to report errors through `VSIFEofL` now do so through `VSIFErrorL`.
#' Code testing \code{$eof()} to potentially end read loops should also test
#' for an error condition, which this setting enables by default.
#' Ignored if GDAL < 3.10.
#'
#' ## Methods
#'
#' \code{$seek(offset, origin)}\cr
#' Seek to a requested `offset` in the file.
#' `offset` is given as a positive numeric scalar, optionally as
#' `bit64::integer64` type.
#' `origin` is given as a character string, one of `SEEK_SET`, `SEEK_CUR` or
#' `SEEK_END`. Package global constants are defined for convenience, so these
#' can be passed unquoted. Note that `offset` is an unsigned type, so `SEEK_CUR`
#' can only be used for positive seek. If negative seek is needed, use:
#' ```
#' vf$seek(vf$tell() + negative_offset, SEEK_SET)
#' ```
#' Returns `0` on success or `-1` on failure.
#'
#' \code{$tell()}\cr
#' Returns the current file read/write offset in bytes from the beginning of
#' the file. The return value is a numeric scalar carrying the `integer64`
#' class attribute.
#'
#' \code{$rewind()}\cr
#' Rewind the file pointer to the beginning of the file. This is equivalent to
#' `vf$seek(0, SEEK_SET)`. No return value, called for that side effect.
#'
#' \code{$read(nbytes)}\cr
#' Read `nbytes` bytes from the file at the current offset. Returns an \R `raw`
#' vector, or `NULL` if the operation fails.
#'
#' \code{$write(object)}\cr
#' Write bytes to the file at the current offset. `object` is a `raw` vector.
#' Returns the number of bytes successfully written, as numeric scalar
#' carrying the `integer64` class attribute.
#' See also base \R `charToRaw()` / `rawToChar()`, convert to or from raw
#' vectors, and `readBin()` / `writeBin()` which read binary data from or write
#' binary data to a raw vector.
#'
#' \code{$eof()}\cr
#' Test for end of file. Returns `TRUE` if an end-of-file condition occurred
#' during the previous read operation. The end-of-file flag is cleared by a
#' successful call to \code{$seek()}.
#'
#' \code{$truncate(new_size)}\cr
#' Truncate/expand the file to the specified `new_size`, given as a positive
#' numeric scalar, optionally as `bit64::integer64` type.
#' Returns `0` on success.
#'
#' \code{$flush()}\cr
#' Flush pending writes to disk. For files in write or update mode and on
#' file system types where it is applicable, all pending output on the file is
#' flushed to the physical disk.
#' On Windows regular files, this method does nothing, unless the
#' `VSI_FLUSH=YES` configuration option is set (and only when the file has not
#' been opened with the `WRITE_THROUGH` option).
#' Returns `0` on success or `-1` on error.
#'
#' \code{$ingest(max_size)}\cr
#' Ingest a file into memory. Read the whole content of the file into a `raw`
#' vector.
#' `max_size` is the maximum size of file allowed, given as a numeric scalar,
#' optionally as `bit64::integer64` type. If no limit, set to a negative value.
#' Returns a `raw` vector, or `NULL` if the operation fails.
#'
#' \code{$close()}\cr
#' Closes the file. The file should always be closed when I/O has been
#' completed. Returns `0` on success or `-1` on error.
#'
#' \code{$open()}\cr
#' This method can be used to re-open the file after it has been closed, using
#' the same `filename`, and same `options` if any are set. The file will be
#' opened using `access` as currently set. The \code{$set_access()} method can
#' be called to change the requested access while the file is closed.
#' No return value. An error is raised if a file handle cannot be obtained.
#'
#' \code{$get_filename()}\cr
#' Returns a character string containing the `filename` associated with this
#' `VSIFile` object (the `filename` originally used to create the object).
#'
#' \code{$get_access()}\cr
#' Returns a character string containing the `access` as currently set on this
#' `VSIFile` object.
#'
#' \code{$set_access(access)}\cr
#' Sets the requested read/write access on this `VSIFile` object, given as a
#' character string (i.e., `"r"`, `"r+"`, `"w"`, `"w+"`). The access can be
#' changed only while the `VSIFile` object is closed, and will apply when it is
#' re-opened with a call to \code{$open()}.
#' Returns `0` on success or `-1` on error.
#'
#' @note
#' File offsets are given as \R `numeric` (i.e., `double` type), optionally
#' carrying the `bit64::integer64` class attribute. They are returned as
#' `numeric` with the `integer64` class attribute attached. The `integer64`
#' type is signed, so the maximum file offset supported by this interface
#' is `9223372036854775807` (the value of `bit64::lim.integer64()[2]`).
#'
#' Some virtual file systems allow only sequential write, so no seeks or read
#' operations are then allowed (e.g., AWS S3 files with /vsis3/).
#' Starting with GDAL 3.2, a configuration option can be set with:
#' ```
#' set_config_option("CPL_VSIL_USE_TEMP_FILE_FOR_RANDOM_WRITE", "YES")
#' ````
#' in which case random-write access is possible (involves the creation of a
#' temporary local file, whose location is controlled by the `CPL_TMPDIR`
#' configuration option). In this case, setting `access` to `"w+"` may be
#' needed for writing with seek and read operations (if creating a new file,
#' otherwise, `"r+"` to open an existing file), while `"w"` access would
#' allow sequential write only.
#'
#' @seealso
#' GDAL Virtual File Systems (compressed, network hosted, etc...):\cr
#' /vsimem, /vsizip, /vsitar, /vsicurl, ...\cr
#' \url{https://gdal.org/en/stable/user/virtual_file_systems.html}
#'
#' [vsi_copy_file()], [vsi_read_dir()], [vsi_stat()], [vsi_unlink()]
#'
#' @examples
#' # The examples make use of the FARSITE LCP format specification at:
#' # https://gdal.org/en/stable/drivers/raster/lcp.html
#' # An LCP file is a raw format with a 7,316-byte header. The format
#' # specification gives byte offets and data types for fields in the header.
#'
#' lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
#'
#' # identify a FARSITE v.4 LCP file
#' # function to check if the first three fields have valid data
#' # input is the first twelve raw bytes in the file
#' is_lcp <- function(bytes) {
#'   values <- readBin(bytes, "integer", n = 3)
#'   if ((values[1] == 20 || values[1] == 21) &&
#'       (values[2] == 20 || values[2] == 21) &&
#'       (values[3] >= -90 && values[3] <= 90)) {
#'
#'     return(TRUE)
#'   } else {
#'     return(FALSE)
#'   }
#' }
#'
#' vf <- new(VSIFile, lcp_file)
#' vf
#'
#' vf$read(12) |> is_lcp()
#'
#' vf$tell()
#'
#' # read the whole file into memory
#' bytes <- vf$ingest(-1)
#' vf$close()
#'
#' # write to a VSI in-memory file
#' mem_file <- "/vsimem/storml_copy.lcp"
#' vf <- new(VSIFile, mem_file, "w+")
#' vf$write(bytes)
#'
#' vf$tell()
#' vf$rewind()
#' vf$tell()
#'
#' vf$seek(0, SEEK_END)
#' (vf$tell() == vsi_stat(lcp_file, "size"))  # TRUE
#'
#' vf$rewind()
#' vf$read(12) |> is_lcp()
#'
#' # read/write an integer field
#' # write invalid data for the Latitude field and then set back
#' # save the original first
#' vf$seek(8, SEEK_SET)
#' lat_orig <- vf$read(4)
#' readBin(lat_orig, "integer")  # 46
#' # latitude -99 out of range
#' vf$seek(8, SEEK_SET)
#' writeBin(-99L, raw()) |> vf$write()
#' vf$rewind()
#' vf$read(12) |> is_lcp()  # FALSE
#' vf$seek(8, SEEK_SET)
#' vf$read(4) |> readBin("integer")  # -99
#' # set back to original
#' vf$seek(8, SEEK_SET)
#' vf$write(lat_orig)
#' vf$rewind()
#' vf$read(12) |> is_lcp()  # TRUE
#'
#' # read a vector of doubles - xmax, xmin, ymax, ymin
#' # 327766.1, 323476.1, 5105082.0, 5101872.0
#' vf$seek(4172, SEEK_SET)
#' vf$read(32) |> readBin("double", n = 4)
#'
#' # read a short int, the canopy cover units
#' vf$seek(4232, SEEK_SET)
#' vf$read(2) |> readBin("integer", size = 2)  # 1 = "percent"
#'
#' # read the Description field
#' vf$seek(6804, SEEK_SET)
#' bytes <- vf$read(512)
#' rawToChar(bytes)
#'
#' # edit the Description
#' desc <- paste(rawToChar(bytes),
#'               "Storm Lake AOI,",
#'               "Beaverhead-Deerlodge National Forest, Montana.")
#'
#' vf$seek(6804, SEEK_SET)
#' charToRaw(desc) |> vf$write()
#' vf$close()
#'
#' # verify the file as a raster dataset
#' ds <- new(GDALRaster, mem_file)
#' ds$info()
#'
#' # retrieve Description from the metadata
#' # band = 0 for dataset-level metadata, domain = "" for default domain
#' ds$getMetadata(band = 0, domain = "")
#' ds$getMetadataItem(band = 0, mdi_name = "DESCRIPTION", domain = "")
#'
#' ds$close()
#' \dontshow{vsi_unlink(mem_file)}
NULL

Rcpp::loadModule("mod_VSIFile", TRUE)

# Documentation and helper functions for OGR feature class definition
# Chris Toney <chris.toney at usda.gov>

#' OGR feature class definition for vector data
#'
#' This topic contains documentation and helper functions for defining an
#' OGR feature class.
#' A named list containing zero or more attribute field definitions, along with
#' one or more geometry field definitions, comprise an OGR feature class
#' definition (a.k.a. layer definition). `ogr_def_layer()` initializes such a
#' list with the geometry type and (optionally) a spatial reference system.
#' Attribute fields may then be added to the layer definition.
#' `ogr_def_field()` creates an attribute field definition, a list
#' containing the field's data type and potentially other optional field
#' properties.
#' `ogr_def_geom_field()` similarly creates a geometry field definition. This
#' might be used with certain vector formats that support multiple geometry
#' columns (e.g., PostGIS).
#' `ogr_def_field_domain()` creates a field domain definition. A field domain
#' is a set of constraints that apply to one or several fields. This is a
#' concept found, e.g., in ESRI File Geodatabase and in GeoPackage via the
#' Schema extension (see \url{https://github.com/OSGeo/gdal/pull/3638}).
#' GDAL >= 3.3 supports reading and writing field domains with certain drivers
#' (e.g., GPKG and OpenFileGDB).
#'
#' @name ogr_define
#' @details
#' All features in an OGR Layer share a common schema (feature class), modeled
#' in GDAL by its `OGRFeatureDefn` class. A feature class definition includes
#' the set of attribute fields and their data types and the geometry field(s).
#' In \R, a feature class definition is represented as a named list, with names
#' being the attribute/geometry field names, and each list element holding an
#' attribute or geometry field definition.
#'
#' The definition for an attribute field is a named list with elements:
#' ```
#' $type       : OGR Field Type ("OFTReal", "OFTString" etc.)
#' $subtype    : optional ("OFSTBoolean", ...)
#' $width      : optional max number of characters
#' $precision  : optional number of digits after the decimal point
#' $is_nullable: optional NOT NULL constraint (logical value)
#' $is_unique  : optional UNIQUE constraint (logical value)
#' $default    : optional default value as character string
#' $domain     : optional field domain name
#' $is_geom    : FALSE (the default) for attribute fields
#' ```
#'
#' An OGR field type is specified as a character string with possible values:
#' `OFTInteger`, `OFTIntegerList`, `OFTReal`, `OFTRealList`, `OFTString`,
#' `OFTStringList`, `OFTBinary`,  `OFTDate`, `OFTTime`, `OFTDateTime`,
#' `OFTInteger64`, `OFTInteger64List`.
#'
#' An optional field subtype is specified as a character string with possible
#' values:
#' `OFSTNone`, `OFSTBoolean`, `OFSTInt16`, `OFSTFloat32`, `OFSTJSON`,
#' `OFSTUUID`.
#'
#' By default, fields are nullable and have no unique constraint. Not-null and
#' unique constraints are not supported by all format drivers.
#'
#' A default field value is taken into account by format drivers (generally
#' those with a SQL interface) that support it at field creation time.
#' If given in the field definition, `default` must be a character string.
#' The accepted values are `"NULL"`, a numeric value (e.g., `"0"`), a literal
#' value enclosed between single quote characters (e.g., `"'a default value'"`,
#' with any inner single quote characters escaped by repetition of the single
#' quote character), `"CURRENT_TIMESTAMP"`, `"CURRENT_TIME"`, `"CURRENT_DATE"`
#' or a driver-specific expression (that might be ignored by other drivers).
#' For a datetime literal value, format should be
#' `"'YYYY/MM/DD HH:MM:SS[.sss]'"` (considered as UTC time).
#'
#' The definition for a geometry field is a named list with elements:
#' ```
#' $type       : geom type ("Point", "Polygon", etc.)
#' $srs        : optional spatial reference as WKT string
#' $is_nullable: optional NOT NULL constraint (logical value)
#' $is_geom    : TRUE (required) for geometry fields
#' ```
#'
#' Typically, there is one geometry field on a layer, but some formats support
#' more than one geometry column per table (e.g., "PostgreSQL / PostGIS" and
#' "SQLite / Spatialite RDBMS").
#'
#' Geometry types are specified as a character string containing OGC WKT.
#' Common types include: `Point`, `LineString`, `Polygon`, `MultiPoint`,
#' `MultiLineString`, `MultiPolygon`. See the GDAL documentation for a list
#' of all supported geometry types:\cr
#' \url{https://gdal.org/en/stable/api/vector_c_api.html#_CPPv418OGRwkbGeometryType}
#'
#' Format drivers may or may not support not-null constraints on attribute and
#' geometry fields. If they support creating fields with not-null constraints,
#' this is generally before creating any features to the layer. In some cases,
#' a not-null constraint may be available as a layer creation option. For
#' example, GeoPackage format has a layer creation option
#' `GEOMETRY_NULLABLE=[YES/NO]`.
#'
#' The definition for a field domain is a named list with elements:
#' ```
#' $type             : domain type ("Coded", "Range", "RangeDateTime", "GLOB")
#' $domain_name      : name of the field domain (character string)
#' $description      : optional domain description (character string)
#' $field_type       : OGR Field Type (see attribute field definitions above)
#' $field_subtype    : optional OGR Field Subtype ("OFSTBoolean", ...)
#' $split_policy     : split policy of the field domain (see below)
#' $merge_policy     : merge policy of the field domain (see below)
#' $coded_values     : vector of allowed codes, or data frame of (codes, values)
#' $min_value        : minimum value (data type compatible with $field_type)
#' $min_is_inclusive : whether the minimum value is included in the range
#' $max_value        : maximum value (data type compatible with $field_type)
#' $max_is_inclusive : whether the maximum value is included in the range
#' $glob             : GLOB expression (character string)
#' ```
#'
#' A field domain can be one of three types:
#' * `Coded`: an enumerated list of allowed codes with their descriptive values
#' * `Range`: a range constraint (min, max)
#' * `GLOB`: a GLOB expression (matching expression like `"*[a-z][0-1]?"`)
#'
#' `type` can also be specified as `"RangeDateTime"`, a range constraint for
#' `OFTDateTime` fields with `min_value` and `max_value` given as
#' `"POSIXct"` DateTimes.
#'
#' Split and merge policies are supported by ESRI File Geodatabase format via
#' OpenFileGDB driver (or FileGDB driver dependent on FileGDB API library).
#' When a feature is split in two, `split_policy` defines how the value of
#' attributes following the domain are computed. Possible values are
#' `"DEFAULT_VALUE"` (default value), `"DUPLICATE"` (duplicate), and
#' `"GEOMETRY_RATIO"` (new values are computed by the ratio of their
#' area/length compared to the area/length of the original feature).
#' When a feature is built by merging two features, `merge_policy` defines
#' how the value of attributes following the domain are computed. Possible
#' values are `"DEFAULT_VALUE"` (default value), `"SUM"` (sum), and
#' `"GEOMETRY_WEIGHTED"` (new values are computed as the weighted average of
#' the source values).
#'
#' @param geom_type Character string specifying a geometry type (see Details).
#' @param geom_fld_name Character string specifying a geometry field name
#' Defaults to `"geom"`.
#' @param srs Character string containing a spatial reference system definition
#' as OGC WKT or other well-known format (e.g., the input formats usable with
#' [srs_to_wkt()]).
#' @param fld_type Character string containing the name of a field data type
#' (e.g., `"OFTInteger"`, `"OFTInteger64"`, `"OFTReal"`, `"OFTString"`, ...).
#' @param fld_subtype Character string containing the name of a field subtype.
#' One of `"OFSTNone"` (the default), `"OFSTBoolean"`, `"OFSTInt16"`,
#' `"OFSTFloat32"`, `"OFSTJSON"`, `"OFSTUUID"`.
#' @param fld_width Optional integer value specifying max number of characters.
#' @param fld_precision Optional integer value specifying number of digits
#' after the decimal point.
#' @param is_nullable Optional NOT NULL field constraint (logical value).
#' Defaults to `TRUE`.
#' @param is_unique Optional UNIQUE constraint on the field (logical value).
#' Defaults to `FALSE`.
#' @param default_value Optional default value for the field given as a
#' character string.
#' @param domain_type Character string specifying a field domain type (see
#' Details). Must be one of `"Coded"`, `"Range"`, `"RangeDateTime"`, `"GLOB"`
#' (case-insensitive).
#' @param domain_name Character string specifying the name of the field domain.
#' Optional for `ogr_def_field()`, required for `ogr_def_field_domain()`.
#' @param description Optional character string giving a description of the
#' field domain.
#' @param split_policy Character string specifying the split policy of the
#' field domain. One of `"DEFAULT_VALUE"`, `"DUPLICATE"`, `"GEOMETRY_RATIO"`
#' (supported by ESRI File Geodatabase format via OpenFileGDB driver).
#' @param merge_policy Character string specifying the merge policy of the
#' field domain. One of `"DEFAULT_VALUE"`, `"SUM"`, `"GEOMETRY_WEIGHTED"`
#' (supported by ESRI File Geodatabase format via OpenFileGDB driver).
#' @param coded_values Either a vector of the allowed codes, or character
#' vector of `"CODE=VALUE"` pairs (the expanded "value" associated with a code
#' is optional), or a two-column data frame with (codes, values).
#' If data frame, the second column of values must be character type (i.e.,
#' the descriptive text for each code). This argument is required if
#' `domain_type = "Coded"`. Each code should appear only once, but it is the
#' responsibility of the user to check it.
#' @param range_min Minimum value in a Range or RangeDateTime field domain (can
#' be NULL). The data type must be consistent with with the field type given in
#' the `fld_type` argument.
#' @param min_is_inclusive = Logical value, whether the minimum value is
#' included in the range. Defaults to `TRUE`. Required argument if
#' `domain_type` is `"Range"` or `"RangeDateTime"`.
#' @param range_max Maximum value in a Range or RangeDateTime field domain (can
#' be NULL). The data type must be consistent with with the field type given in
#' the `fld_type` argument.
#' @param max_is_inclusive = Logical value, whether the maximum value is
#' included in the range. Defaults to `TRUE`. Required argument if
#' `domain_type` is `"Range"` or `"RangeDateTime"`.
#' @param glob Character string containing the GLOB expression. Required if
#' `domain_type` is `"GLOB"`.
#'
#' @note
#' The feature id (FID) is a special property of a feature and not treated as
#' an attribute of the feature. Additional information is given in the GDAL
#' documentation for the
#' [OGR SQL](https://gdal.org/en/stable/user/ogr_sql_dialect.html#feature-id-fid) and
#' [SQLite](https://gdal.org/en/stable/user/sql_sqlite_dialect.html#feature-id-fid)
#' SQL dialects. Implications for SQL statements and result sets may depend
#' on the dialect used.
#'
#' Some vector formats do not support schema definition prior to creating
#' features. For example, with GeoJSON only the *Feature* object has a member
#' with name *properties*. The specification does not require all *Feature*
#' objects in a collection to have the same schema of properties, nor does
#' it require all *Feature* objects in a collection to have geometry of the
#' same type (\url{https://geojson.org/}).
#'
#' @seealso
#' [ogr_ds_create()], [ogr_layer_create()], [ogr_field_create()]
#'
#' WKT representation of geometry:\cr
#' \url{https://en.wikipedia.org/wiki/Well-known_text_representation_of_geometry}
#'
#' Field domains:\cr
#' \url{https://desktop.arcgis.com/en/arcmap/latest/manage-data/geodatabases/an-overview-of-attribute-domains.htm}\cr
#' \url{https://www.geopackage.org/spec/#extension_schema}\cr
#' \url{https://gdal.org/en/stable/doxygen/classOGRFieldDomain.html#details}
#'
#' @examples
#' # create a SQLite data source, with SpatiaLite extensions if available
#' dsn <- file.path(tempdir(), "test.sqlite")
#' opt <- NULL
#' if (has_spatialite()) {
#'   opt <- "SPATIALITE=YES"
#' }
#'
#' # This creates an empty data source. Note that we could also create a layer
#' # at the same time in this function call, but for this example we do that
#' # separately, to show creation of a layer on an existing data source.
#' ogr_ds_create("SQLite", dsn, dsco = opt)
#'
#' # define a layer
#' defn <- ogr_def_layer("Point", srs = "EPSG:4326")
#' defn$my_id <- ogr_def_field("OFTInteger64")
#' defn$my_description <- ogr_def_field("OFTString")
#'
#' # create a layer in the existing data source
#' ogr_ds_test_cap(dsn)$CreateLayer  # TRUE
#'
#' ogr_layer_create(dsn, "layer1", layer_defn = defn)
#'
#' ogr_ds_layer_names(dsn)
#'
#' ogr_layer_field_names(dsn, "layer1")
#'
#' deleteDataset(dsn)
#' @export
ogr_def_layer <- function(geom_type, geom_fld_name = "geom", srs = NULL) {

    defn <- list()

    if (missing(srs) || is.null(srs))
        srs <- ""

    if (missing(geom_fld_name) || is.null(geom_fld_name))
        geom_fld_name <- "geom"

    if (!(is.character(geom_fld_name) && length(geom_fld_name) == 1))
        stop("'geom_fld_name' must be a length-1 character vector",
             call. = FALSE)
    else
        defn[[geom_fld_name]] <- ogr_def_geom_field(geom_type, srs)

    return(defn)
}

#' @name ogr_define
#' @export
ogr_def_field <- function(fld_type, fld_subtype = NULL, fld_width = NULL,
                          fld_precision = NULL, is_nullable = NULL,
                          is_unique = NULL, default_value = NULL,
                          domain_name = NULL) {

    defn <- list()

    if (!(is.character(fld_type) && length(fld_type) == 1))
        stop("'fld_type' must be a length-1 character vector", call. = FALSE)
    else
        defn$type <- fld_type

    if (!is.null(fld_subtype)) {
        if (!(is.character(fld_subtype) && length(fld_subtype) == 1))
            stop("'fld_subtype' must be a length-1 character vector",
                 call. = FALSE)
        else
            defn$subtype <- fld_subtype
    }

    if (!is.null(fld_width)) {
        if (!(is.numeric(fld_width) && length(fld_width) == 1))
            stop("'fld_width' must be an integer scalar", call. = FALSE)
        else
            defn$width <- fld_width
    }

    if (!is.null(fld_precision)) {
        if (!(is.numeric(fld_precision) && length(fld_precision) == 1))
            stop("'fld_precision' must be an integer scalar", call. = FALSE)
        else
            defn$precision <- fld_precision
    }

    if (!is.null(is_nullable)) {
        if (!(is.logical(is_nullable) && length(is_nullable) == 1))
            stop("'is_nullable' must be a single logical value", call. = FALSE)
        else
            defn$is_nullable <- is_nullable
    }

    if (!is.null(is_unique)) {
        if (!(is.logical(is_unique) && length(is_unique) == 1))
            stop("'is_unique' must be a single logical value", call. = FALSE)
        else
            defn$is_unique <- is_unique
    }

    if (!is.null(default_value)) {
        default_value <- as.character(default_value)
        if (!(length(default_value) == 1))
            stop("'default_value' must be a length-1 character vector",
                 call. = FALSE)
        else
            defn$default <- default_value
    }

    if (!is.null(domain_name)) {
        if (!(is.character(domain_name) && length(domain_name) == 1))
            stop("'domain_name' must be a length-1 character vector",
                 call. = FALSE)
        else
            defn$domain <- domain_name
    }

    defn$is_geom <- FALSE

    return(defn)
}

#' @name ogr_define
#' @export
ogr_def_geom_field <- function(geom_type, srs = NULL, is_nullable = NULL) {

    defn <- list()

    if (!(is.character(geom_type) && length(geom_type) == 1))
        stop("'geom_type' must be a length-1 character vector", call. = FALSE)
    else
        defn$type <- geom_type

    if (missing(srs) || is.null(srs))
        srs <- ""

    if (!(is.character(srs) && length(srs) == 1))
        stop("'srs' must be a length-1 character vector", call. = FALSE)
    else
        defn$srs <- srs


    if (!is.null(is_nullable)) {
        if (!(is.logical(is_nullable) && length(is_nullable) == 1))
            stop("'is_nullable' must be a logical value", call. = FALSE)
        else
            defn$is_nullable <- is_nullable
    }

    defn$is_geom <- TRUE

    return(defn)
}

#' @name ogr_define
#' @export
ogr_def_field_domain <- function(domain_type, domain_name, description = NULL,
                                 fld_type = NULL, fld_subtype = "OFSTNone",
                                 split_policy = "DEFAULT_VALUE",
                                 merge_policy = "DEFAULT_VALUE",
                                 coded_values = NULL,
                                 range_min = NULL, min_is_inclusive = TRUE,
                                 range_max = NULL, max_is_inclusive = TRUE,
                                 glob = "") {

    if (gdal_version_num() <= gdal_compute_version(3, 3, 0)) {
        cli::cli_alert_warning(
            "GDAL >= 3.3 is required for writing field domains.")
    }

    defn <- list()

    if (!(is.character(domain_type) && length(domain_type) == 1)) {
        stop("'domain_type' must be a length-1 character vector", call. = FALSE)
    }
    if (is.na(domain_type) || !nzchar(domain_type)) {
        stop("'domain_type' is required", call. = FALSE)
    }
    if (!(tolower(domain_type) %in%
            c("coded", "range", "rangedatetime", "glob"))) {

        cli::cli_alert(paste0("Valid domain types: {.str Coded}, ",
                              "{.str Range}, {.str RangeDateTime}, ",
                              "{.str GLOB}"))
        stop("invalid 'domain_type'", call. = FALSE)
    }
    defn$type <- domain_type

    if (!(is.character(domain_name) && length(domain_name) == 1)) {
        stop("'domain_name' must be a length-1 character vector", call. = FALSE)
    }
    if (is.na(domain_name) || !nzchar(domain_name)) {
        stop("'domain_name' is required", call. = FALSE)
    }
    defn$domain_name <- domain_name

    if (missing(description) || is.null(description) || is.na(description)) {
        description <- ""
    } else if (!(is.character(description) && length(description) == 1)) {
        stop("'description' must be a length-1 character vector", call. = FALSE)
    }
    defn$description <- description

    if (missing(fld_type) || is.null(fld_type) || is.na(fld_type)) {
        stop("'fld_type' is required", call. = FALSE)
    }
    if (!(is.character(fld_type) && length(fld_type) == 1)) {
        stop("'fld_type' must be a length-1 character vector", call. = FALSE)
    }
    defn$field_type <- fld_type

    if (missing(fld_subtype) || is.null(fld_subtype) || is.na(fld_subtype)) {
        fld_subtype <- "OFSTNone"
    } else if (!(is.character(fld_subtype) && length(fld_subtype) == 1)) {
        stop("'fld_subtype' must be a length-1 character vector",
             call. = FALSE)
    }
    defn$field_subtype <- fld_subtype

    if (!(is.character(split_policy) && length(split_policy) == 1)) {
        stop("'split_policy' must be a length-1 character vector",
             call. = FALSE)
    }
    if (is.na(split_policy) || !nzchar(split_policy)) {
        split_policy <- "DEFAULT_VALUE"
    }
    if (!(toupper(split_policy) %in%
            c("DEFAULT_VALUE", "DUPLICATE", "GEOMETRY_RATIO"))) {

        cli::cli_alert(paste0("Valid split policies: {.str DEFAULT_VALUE} ",
                              "{.str DUPLICATE}, {.str GEOMETRY_RATIO}"))
        stop("invalid 'split_policy'", call. = FALSE)
    }
    defn$split_policy <- toupper(split_policy)

    if (!(is.character(merge_policy) && length(merge_policy) == 1)) {
        stop("'merge_policy' must be a length-1 character vector",
             call. = FALSE)
    }
    if (is.na(merge_policy) || !nzchar(merge_policy)) {
        merge_policy <- "DEFAULT_VALUE"
    }
    if (!(toupper(merge_policy) %in%
            c("DEFAULT_VALUE", "SUM", "GEOMETRY_WEIGHTED"))) {

        cli::cli_alert(paste0("Valid merge policies: {.str DEFAULT_VALUE}, ",
                              "{.str SUM}, {.str GEOMETRY_WEIGHTED}"))
        stop("invalid 'merge_policy'", call. = FALSE)
    }
    defn$merge_policy <- toupper(merge_policy)

    defn["coded_values"] <- list(NULL)
    defn["min_value"] <- list(NULL)
    defn$min_is_inclusive <- TRUE
    defn["max_value"] <- list(NULL)
    defn$max_is_inclusive <- TRUE
    defn$glob <- ""

    if (tolower(domain_type) == "coded") {
        if (missing(coded_values) || is.null(coded_values)) {
            stop("'coded_values' is required for Coded domain type",
                 call. = FALSE)
        }
        if (is.data.frame(coded_values)) {
            # as two-column data frame of codes, values
            if (ncol(coded_values) != 2) {
                stop("'coded_values' data frame must have two columns",
                     call. = FALSE)
            }
            if (nrow(coded_values) == 0) {
                stop("'coded_values' is empty",
                     call. = FALSE)
            }
            if (any(is.na(coded_values[, 1]))) {
                stop("'coded_values' cannot contain NA codes", call. = FALSE)
            }
            coded_values[, 1] <- as.character(coded_values[, 1])
            coded_values[, 2] <- as.character(coded_values[, 2])
        } else {
            # as vector of codes, or "CODE=VALUE" pairs
            coded_values <- as.character(coded_values)
            if (length(coded_values) == 0) {
                stop("'coded_values' is empty", call. = FALSE)
            }
            if (any(is.na(coded_values))) {
                stop("'coded_values' cannot contain NA codes", call. = FALSE)
            }
        }
        defn$coded_values <- coded_values

    } else if (tolower(domain_type) == "range") {
        if (!is.null(range_min) && !all(is.na(range_min))) {
            if (!(is.numeric(range_min) && length(range_min) == 1)) {
                stop("'range_min' must be a single numeric value or NULL",
                     call. = FALSE)
            } else {
                defn$min_value <- range_min
            }
        }
        if (!(is.logical(min_is_inclusive) && length(min_is_inclusive) == 1)) {
            stop("'min_is_inclusive' must be a single logical value",
                 call. = FALSE)
        } else {
            defn$min_is_inclusive <- min_is_inclusive
        }
        if (!is.null(range_max) && !all(is.na(range_max))) {
            if (!(is.numeric(range_max) && length(range_max) == 1)) {
                stop("'range_max' must be a single numeric value or NULL",
                     call. = FALSE)
            } else {
                defn$max_value <- range_max
            }
        }
        if (!(is.logical(max_is_inclusive) && length(max_is_inclusive) == 1)) {
            stop("'max_is_inclusive' must be a single logical value",
                 call. = FALSE)
        } else {
            defn$max_is_inclusive <- max_is_inclusive
        }

    } else if (tolower(domain_type) == "rangedatetime") {
        if (!is.null(range_min) && !all(is.na(range_min))) {
            if (!(is(range_min, "POSIXct") && length(range_min) == 1)) {
                stop("'range_min' must be a single POSIXct value or NULL",
                     call. = FALSE)
            } else {
                defn$min_value <- range_min
            }
        }
        if (!(is.logical(min_is_inclusive) && length(min_is_inclusive) == 1)) {
            stop("'min_is_inclusive' must be a single logical value",
                 call. = FALSE)
        } else {
            defn$min_is_inclusive <- min_is_inclusive
        }
        if (!is.null(range_max) && !all(is.na(range_max))) {
            if (!(is(range_max, "POSIXct") && length(range_max) == 1)) {
                stop("'range_max' must be a single POSIXct value or NULL",
                     call. = FALSE)
            } else {
                defn$max_value <- range_max
            }
        }
        if (!(is.logical(max_is_inclusive) && length(max_is_inclusive) == 1)) {
            stop("'max_is_inclusive' must be a single logical value",
                 call. = FALSE)
        } else {
            defn$max_is_inclusive <- max_is_inclusive
        }

    } else if (tolower(domain_type) == "glob") {
        if (missing(glob) || is.null(glob)) {
            stop("'glob' is required", call. = FALSE)
        }
        if (!(is.character(glob) && length(glob) == 1)) {
            stop("'glob' must be a length-1 character vector", call. = FALSE)
        }
        if (is.na(glob) || !nzchar(glob)) {
            stop("'glob' is required", call. = FALSE)
        }
        defn$glob <- glob

    } else {
        stop("'domain_type' not recognized", call. = FALSE)
    }

    return(defn)
}

# R interface to GDAL utils via the wrapper functions in src/gdal_exp.cpp


#' Convert raster data between different formats
#'
#' `translate()` is a wrapper of the \command{gdal_translate} command-line
#' utility (see \url{https://gdal.org/en/stable/programs/gdal_translate.html}).
#' The function can be used to convert raster data between different
#' formats, potentially performing some operations like subsetting,
#' resampling, and rescaling pixels in the process. Refer to the GDAL
#' documentation at the URL above for a list of command-line arguments that
#' can be passed in `cl_arg`.
#'
#' @param src_filename Either a character string giving the filename of the
#' source raster, or an object of class `GDALRaster` for the source.
#' @param dst_filename Character string. Filename of the output raster.
#' @param cl_arg Optional character vector of command-line arguments for
#' \code{gdal_translate} (see URL above).
#' @param quiet Logical scalar. If `TRUE`, a progress bar will not be
#' displayed. Defaults to `FALSE`.
#' @returns Logical indicating success (invisible \code{TRUE}).
#' An error is raised if the operation fails.
#'
#' @seealso
#' [`GDALRaster-class`][GDALRaster], [rasterFromRaster()], [warp()]
#'
#' [ogr2ogr()] for vector data
#'
#' @examples
#' # convert the elevation raster to Erdas Imagine format and resample to 90m
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' img_file <- file.path(tempdir(), "storml_elev_90m.img")
#'
#' # command-line arguments for gdal_translate
#' args <- c("-tr", "90", "90", "-r", "average")
#' args <- c(args, "-of", "HFA", "-co", "COMPRESSED=YES")
#'
#' translate(elev_file, img_file, args)
#'
#' ds <- new(GDALRaster, img_file)
#' ds$info()
#'
#' ds$close()
#' \dontshow{deleteDataset(img_file)}
#' @export
translate <- function(src_filename, dst_filename, cl_arg = NULL,
                      quiet = FALSE) {

    src_ds <- NULL
    close_src_ds <- FALSE
    if (is(src_filename, "Rcpp_GDALRaster")) {
        src_ds <- src_filename
        if (!src_ds$isOpen()) {
            stop("source dataset is not open", call. = FALSE)
        }
    } else if (is.character(src_filename) && length(src_filename) == 1) {
        src_ds <- new(GDALRaster, src_filename)
        close_src_ds <- TRUE
    } else {
        stop("'src_filename' must be a character string or 'GDALRaster' object",
             call. = FALSE)
    }

    if (!(is.character(dst_filename) && length(dst_filename) == 1))
        stop("'dst_filename' must be a character string", call. = FALSE)

    if (!is.null(cl_arg) && !is.character(cl_arg))
        stop("'cl_arg' must be a character vector", call. = FALSE)

    if (!is.null(quiet)) {
        if (!(is.logical(quiet) && length(quiet) == 1))
            stop("'quiet' must be a logical scalar", call. = FALSE)
    }

    ret <- .translate(src_ds, dst_filename, cl_arg, quiet)

    if (close_src_ds)
        src_ds$close()

    if (!ret) {
        stop("translate raster failed", call. = FALSE)
    } else {
        return(invisible(TRUE))
    }
}

#' Raster reprojection and mosaicing
#'
#' `warp()` is a wrapper of the \command{gdalwarp} command-line utility for
#' raster reprojection and warping
#' (see \url{https://gdal.org/en/stable/programs/gdalwarp.html}).
#' The function can reproject to any supported spatial reference system (SRS).
#' It can also be used to crop, mosaic, resample, and optionally write output
#' to a different raster format. See Details for a list of commonly used
#' processing options that can be passed as arguments to `warp()`.
#'
#' @details
#' Several processing options can be performed in one call to `warp()` by
#' passing the necessary command-line arguments. The following list describes
#' several commonly used arguments. Note that `gdalwarp` supports a large
#' number of arguments that enable a variety of different processing options.
#' Users are encouraged to review the original source documentation provided
#' by the GDAL project at the URL above for the full list.
#'
#'   * `-te <xmin> <ymin> <xmax> <ymax>`\cr
#'   Georeferenced extents of output file to be created (in target SRS by
#'   default).
#'   * `-te_srs <srs_def>`\cr
#'   SRS in which to interpret the coordinates given with `-te`
#'   (if different than `t_srs`).
#'   * `-tr <xres> <yres>`\cr
#'   Output pixel resolution (in target georeferenced units).
#'   * `-tap`\cr
#'   (target aligned pixels) align the coordinates of the extent of the output
#'   file to the values of the `-tr`, such that the aligned extent includes
#'   the minimum extent. Alignment means that xmin / resx, ymin / resy,
#'   xmax / resx and ymax / resy are integer values.
#'   * `-ovr <level>|AUTO|AUTO-<n>|NONE`\cr
#'   Specify which overview level of source files must be used. The default
#'   choice, `AUTO`, will select the overview level whose resolution is the
#'   closest to the target resolution. Specify an integer value (0-based,
#'   i.e., 0=1st overview level) to select a particular level. Specify
#'   `AUTO-n` where `n` is an integer greater or equal to `1`, to select an
#'   overview level below the `AUTO` one. Or specify `NONE` to force the base
#'   resolution to be used (can be useful if overviews have been generated
#'   with a low quality resampling method, and the warping is done using a
#'   higher quality resampling method).
#'   * `-wo <NAME>=<VALUE>`\cr
#'   Set a warp option as described in the GDAL documentation for
#'   [`GDALWarpOptions`](https://gdal.org/en/stable/api/gdalwarp_cpp.html#_CPPv415GDALWarpOptions)
#'   Multiple `-wo` may be given. See also `-multi` below.
#'   * `-ot <type>`\cr
#'   Force the output raster bands to have a specific data type supported by
#'   the format, which may be one of the following: `Byte`, `UInt8`
#'   (GDAL >= 3.13), `Int8`, `UInt16`, `Int16`, `UInt32`, `Int32`, `UInt64`,
#'   `Int64`, `Float32`, `Float64`, `CInt16`, `CInt32`, `CFloat32` or
#'   `CFloat64`.
#'   * `-r <resampling_method>`\cr
#'   Resampling method to use. Available methods are: `near` (nearest
#'   neighbour, the default), `bilinear`, `cubic`, `cubicspline`, `lanczos`,
#'   `average`, `rms` (root mean square, GDAL >= 3.3), `mode`, `max`, `min`,
#'   `med`, `q1` (first quartile), `q3` (third quartile), `sum` (GDAL >= 3.1).
#'   * `-srcnodata "<value>[ <value>]..."`\cr
#'   Set nodata masking values for input bands (different values can be
#'   supplied for each band). If more than one value is supplied all values
#'   should be quoted to keep them together as a single operating system
#'   argument. Masked values will not be used in interpolation. Use a value of
#'   `None` to ignore intrinsic nodata settings on the source dataset.
#'   If `-srcnodata` is not explicitly set, but the source dataset has nodata
#'   values, they will be taken into account by default.
#'   * `-dstnodata "<value>[ <value>]..."`\cr
#'   Set nodata values for output bands (different values can be supplied for
#'   each band). If more than one value is supplied all values should be
#'   quoted to keep them together as a single operating system argument. New
#'   files will be initialized to this value and if possible the nodata value
#'   will be recorded in the output file. Use a value of `"None"` to ensure
#'   that nodata is not defined. If this argument is not used then nodata
#'   values will be copied from the source dataset.
#'   * `-srcband <n>`\cr
#'   (GDAL >= 3.7) Specify an input band number to warp (between 1 and the
#'   number of bands of the source dataset). This option is used to warp a
#'   subset of the input bands. All input bands are used when it is not
#'   specified. This option may be repeated multiple times to select several
#'   input bands. The order in which bands are specified will be the order in
#'   which they appear in the output dataset (unless `-dstband` is specified).
#'   The alpha band should not be specified in the list, as it will be
#'   automatically retrieved (unless `-nosrcalpha` is specified).
#'   * `-dstband <n>`\cr
#'   (GDAL >= 3.7) Specify the output band number in which to warp. In
#'   practice, this option is only useful when updating an existing dataset,
#'   e.g to warp one band at at time. If `-srcband` is specified, there must be
#'   as many occurrences of `-dstband` as there are of `-srcband`.\cr
#'   If `-dstband` is not specified, then:\cr
#'   `c("-dstband", "1", "-dstband", "2", ... "-dstband", "N")`\cr
#'   is assumed where N is the number of input bands (implicitly, or specified
#'   explicitly with `-srcband`). The alpha band should not be specified in the
#'   list, as it will be automatically retrieved (unless `-nosrcalpha` is
#'   specified).
#'   * `-wm <memory_in_mb>`\cr
#'   Set the amount of memory that the warp API is allowed to use for caching.
#'   The value is interpreted as being in megabytes if the value is <10000.
#'   For values >=10000, this is interpreted as bytes. The warper will
#'   total up the memory required to hold the input and output image arrays
#'   and any auxiliary masking arrays and if they are larger than the
#'   "warp memory" allowed it will subdivide the chunk into smaller chunks and
#'   try again. If the `-wm` value is very small there is some extra overhead
#'   in doing many small chunks so setting it larger is better but it is a
#'   matter of diminishing returns.
#'   * `-multi`\cr
#'   Use multithreaded warping implementation. Two threads will be used to
#'   process chunks of image and perform input/output operation
#'   simultaneously. Note that computation is not multithreaded itself. To do
#'   that, you can use the `-wo NUM_THREADS=val/ALL_CPUS` option, which can be
#'   combined with `-multi`.
#'   * `-of <format>`
#'   Set the output raster format. Will be guessed from the extension if not
#'   specified. Use the short format name (e.g., `"GTiff"`).
#'   * `-co <NAME>=<VALUE>`\cr
#'   Set one or more format specific creation options for the output dataset.
#'   For example, the GeoTIFF driver supports creation options to control
#'   compression, and whether the file should be tiled.
#'   [getCreationOptions()] can be used to look up available creation options,
#'   but the GDAL [Raster drivers](https://gdal.org/en/stable/drivers/raster/index.html)
#'   documentation is the definitive reference for format specific options.
#'   Multiple `-co` may be given, e.g.,
#'   \preformatted{ c("-co", "COMPRESS=LZW", "-co", "BIGTIFF=YES") }
#'   * `-overwrite`\cr
#'   Overwrite the target dataset if it already exists. Overwriting means
#'   deleting and recreating the file from scratch. Note that if this option
#'   is not specified and the output file already exists, it will be updated
#'   in place.
#'
#' The documentation for [`gdalwarp`](https://gdal.org/en/stable/programs/gdalwarp.html)
#' describes additional command-line options related to spatial reference
#' systems, alpha bands, masking with polygon cutlines including blending,
#' and more.
#'
#' Mosaicing into an existing output file is supported if the output file
#' already exists. The spatial extent of the existing file will not be
#' modified to accommodate new data, so you may have to remove it in that
#' case, or use the `-overwrite` option.
#'
#' Command-line options are passed to `warp()` as a character vector. The
#' elements of the vector are the individual options followed by their
#' individual values, e.g.,
#' \preformatted{
#' cl_arg = c("-tr", "30", "30", "-r", "bilinear"))
#' }
#' to set the target pixel resolution to 30 x 30 in target georeferenced
#' units and use bilinear resampling.
#'
#' @param src_files Either a character vector of source filenames(s) to be
#' reprojected, or a `GDALRaster` object or list of `GDALRaster` objects for
#' the source data.
#' @param dst_filename Either a character string giving the filename of the
#' output dataset, or an object of class `GDALRaster` for the output.
#' @param t_srs Character string. Target spatial reference system. Usually an
#' EPSG code ("EPSG:#####") or a well known text (WKT) SRS definition.
#' Can be set to empty string `""` and the spatial reference of `src_files[1]`
#' will be used unless the destination raster already exists (see Note).
#' @param cl_arg Optional character vector of command-line arguments to
#' \code{gdalwarp} in addition to `-t_srs` (see Details).
#' @param quiet Logical scalar. If `TRUE`, a progress bar will not be
#' displayed. Defaults to `FALSE`.
#' @returns Logical indicating success (invisible \code{TRUE}).
#' An error is raised if the operation fails.
#'
#' @note
#' `warp()` can be used to reproject and also perform other processing such
#' as crop, resample, and mosaic.
#' This processing is generally done with a single function call by passing
#' arguments for the output ("target") pixel resolution, extent, resampling
#' method, nodata value, format, and so forth.
#'
#' If `warp()` is called with `t_srs = ""` and the output raster does not
#' already exist, the target spatial reference will be set to that of
#' `src_files[1]`. In that case, the processing options given in `cl_arg` will
#' be performed without reprojecting (if there is one source raster or multiple
#' sources that all use the same spatial reference system, otherwise would
#' reproject inputs to the SRS of `src_files[1]` where they are different).
#' If `t_srs = ""` and the destination raster already exists, the output SRS
#' will be the projection of the destination dataset.
#'
#' @seealso
#' [`GDALRaster-class`][GDALRaster], [srs_to_wkt()], [translate()]
#'
#' @examples
#' # reproject the elevation raster to NAD83 / CONUS Albers (EPSG:5070)
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#'
#' # command-line arguments for gdalwarp
#' # resample to 90-m resolution and keep pixels aligned:
#' args <- c("-tr", "90", "90", "-r", "cubic", "-tap")
#' # write to Erdas Imagine format (HFA) with compression:
#' args <- c(args, "-of", "HFA", "-co", "COMPRESSED=YES")
#'
#' alb83_file <- file.path(tempdir(), "storml_elev_alb83.img")
#' warp(elev_file, alb83_file, t_srs = "EPSG:5070", cl_arg = args)
#'
#' ds <- new(GDALRaster, alb83_file)
#' ds$getDriverLongName()
#' ds$getProjectionRef()
#' ds$res()
#' ds$getStatistics(band=1, approx_ok=FALSE, force=TRUE)
#' ds$close()
#' \dontshow{deleteDataset(alb83_file)}
#' @export
warp <- function(src_files,
                 dst_filename,
                 t_srs,
                 cl_arg = NULL,
                 quiet = FALSE) {

    if (!(is.character(t_srs) && length(t_srs) == 1))
        stop("'t_srs' must be a character string", call. = FALSE)

    if (!is.null(cl_arg) && !is.character(cl_arg))
        stop("'cl_arg' must be a character vector", call. = FALSE)

    if (!is.null(quiet)) {
        if (!(is.logical(quiet) && length(quiet) == 1))
            stop("'quiet' must be a logical scalar", call. = FALSE)
    }

    dst_ds <- NULL
    if (is(dst_filename, "Rcpp_GDALRaster")) {
        dst_ds <- dst_filename
        if (!dst_ds$isOpen()) {
            stop("destination dataset is not open", call. = FALSE)
        }
        if (t_srs == "") {
            t_srs <- dst_ds$getProjection()
        }
    } else if (!(is.character(dst_filename) && length(dst_filename) == 1)) {
        stop("'dst_filename' must be a character string or GDALRaster object",
             call. = FALSE)
    } else {
        push_error_handler("quiet")
        ds <- try(new(GDALRaster, dst_filename), silent = TRUE)
        pop_error_handler()
        if (is(ds, "Rcpp_GDALRaster") && t_srs == "") {
            t_srs <- ds$getProjection()
            ds$close()
        }
    }

    src_datasets <- list()
    have_error <- FALSE
    close_datasets <- FALSE

    if (is(src_files, "Rcpp_GDALRaster"))
        src_files <- list(src_files)

    if (is.list(src_files)) {
        for (i in seq_along(src_files)) {
            if (!is(src_files[[i]], "Rcpp_GDALRaster")) {
                stop("'src_files' as list must contain 'GDALRaster' objects",
                     call. = FALSE)
            } else if (!src_files[[i]]$isOpen()) {
                stop("source dataset ", i, " is not open", call. = FALSE)
            }
        }
        src_datasets <- src_files
    } else if (is.character(src_files)) {
        for (i in seq_along(src_files)) {
            src_datasets[[i]] <- try(new(GDALRaster, src_files[i]))
            if (!is(src_datasets[[i]], "Rcpp_GDALRaster")) {
                have_error <- TRUE
            }
        }
        close_datasets <- TRUE
    } else {
        stop("'src_files' must be a character vector or list",
             call. = FALSE)
    }

    if (have_error) {
        for (i in seq_along(src_datasets)) {
            if (is(src_datasets[[i]], "Rcpp_GDALRaster")) {
                src_datasets[[i]]$close()
            }
        }
        stop("could not open one or more source datasets", call. = FALSE)
    }

    if (!is.null(dst_ds)) {
        ret <- .warp(src_datasets, "", list(dst_ds), t_srs, cl_arg, quiet)
    } else {
        ret <- .warp(src_datasets, dst_filename, list(), t_srs, cl_arg, quiet)
    }

    if (close_datasets) {
        for (i in seq_along(src_datasets)) {
            src_datasets[[i]]$close()
        }
    }

    if (!ret) {
        stop("warp raster failed", call. = FALSE)
    } else {
        return(invisible(TRUE))
    }
}

#' Create a virtual warped dataset automatically
#'
#' `autoCreateWarpedVRT()` creates a warped virtual dataset representing the
#' input raster warped into a target coordinate system. The output virtual
#' dataset will be "north-up" in the target coordinate system. GDAL
#' automatically determines the bounds and resolution of the output virtual
#' raster which should be large enough to include all the input raster.
#' Wrapper of `GDALAutoCreateWarpedVRT()` in the GDAL Warper API.
#'
#' @param src_ds An object of class `GDALRaster` for the source dataset.
#' @param dst_wkt WKT string specifying the coordinate system to convert to.
#' If empty string (`""`) no change of coordinate system will take place.
#' @param resample_alg Character string specifying the sampling method to use.
#' One of NearestNeighbour, Bilinear, Cubic, CubicSpline, Lanczos, Average,
#' RMS or Mode.
#' @param src_wkt WKT string specifying the coordinate system of the source
#' raster. If empty string it will be read from the source raster (the
#' default).
#' @param max_err Numeric scalar specifying the maximum error measured in
#' input pixels that is allowed in approximating the transformation (`0.0` for
#' exact calculations, the default).
#' @param alpha_band Logical scalar, `TRUE` to create an alpha band if the
#' source dataset has none. Defaults to `FALSE`.
#'
#' @returns An object of class `GDALRaster` for the new virtual dataset. An
#' error is raised if the operation fails.
#'
#' @note
#' The returned dataset will have no associated filename for itself. If you
#' want to write the virtual dataset to a VRT file, use the
#' \code{$setFilename()} method on the returned `GDALRaster` object to assign a
#' filename before it is closed.
#'
#' @examples
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' ds <- new(GDALRaster, elev_file)
#'
#' ds2 <- autoCreateWarpedVRT(ds, epsg_to_wkt(5070), "Bilinear")
#' ds2$info()
#'
#' ## set filename before close if a VRT file is needed for the virtual dataset
#' # ds2$setFilename("/path/to/file.vrt")
#'
#' ds2$close()
#' ds$close()
#' @export
autoCreateWarpedVRT <- function(src_ds, dst_wkt, resample_alg, src_wkt = "",
                                max_err = 0.0, alpha_band = FALSE) {

    if (is(src_ds, "Rcpp_GDALRaster")) {
        if (!src_ds$isOpen()) {
            stop("source dataset is not open", call. = FALSE)
        }
    } else {
        stop("'src_ds' must be a 'GDALRaster' object",
             call. = FALSE)
    }

    if (is.null(dst_wkt))
        stop("'dst_wkt' cannot be NULL", call. = FALSE)
    if (!(is.character(dst_wkt) && length(dst_wkt) == 1))
        stop("'dst_wkt' must be a character string", call. = FALSE)

    if (is.null(resample_alg))
        stop("'resample_alg' cannot be NULL", call. = FALSE)
    if (!(is.character(resample_alg) && length(resample_alg) == 1))
        stop("'resample_alg' must be a character string", call. = FALSE)

    if (is.null(src_wkt))
        stop("'src_wkt' cannot be NULL", call. = FALSE)
    if (!(is.character(src_wkt) && length(src_wkt) == 1))
        stop("'src_wkt' must be a character string", call. = FALSE)

    if (is.null(max_err))
        stop("'max_err' cannot be NULL", call. = FALSE)
    if (!(is.numeric(max_err) && length(max_err) == 1))
        stop("'max_err' must be a numeric value", call. = FALSE)

    if (is.null(alpha_band))
        stop("'alpha_band' cannot be NULL", call. = FALSE)
    if (!(is.logical(alpha_band) && length(alpha_band) == 1))
        stop("'alpha_band' must be a logical value", call. = FALSE)

    # signature for autoCreateWarpedVRT() object factory
    ds <- new(GDALRaster, src_ds, dst_wkt, resample_alg, src_wkt, max_err,
              alpha_band, TRUE, TRUE)

    return(ds)
}

#' Print an `OGRFeature` object
#'
#' @param x An `OGRFeature` object.
#' @param ... Optional arguments passed to `base::print()`.
#' @return The input, invisibly.
#' @export
#' @method print OGRFeature
print.OGRFeature <- function(x, ...) {
    geom_column <- attr(x, "gis")$geom_column
    geom_format <- toupper(attr(x, "gis")$geom_format)

    if (geom_format == "NONE" || length(geom_column) == 0)
        cat("OGR feature (attributes)\n")
    else
        cat("OGR feature\n")

    if (geom_format == "WKB" || geom_format == "WKB_ISO") {
        y <- unclass(x)
        for (i in seq_along(geom_column)) {
            if (.is_raw_or_null(x[[geom_column[i]]])) {
                wkb <- x[[geom_column[i]]]
                geom_name <- g_name(wkb)
                if (is.na(geom_name))
                    geom_name <- "NULL geometry"
            } else if (.is_raw_or_null(x[[geom_column[i]]][[1]])) {
                # in case of nested list, i.e., from a data frame list column
                wkb <- x[[geom_column[i]]][[1]]
                geom_name <- g_name(wkb)
                if (is.na(geom_name))
                    geom_name <- "NULL geometry"
            } else {
                wkb <- "error"
                geom_name <- "unknown"
            }
            wkb_starts_with <- paste(wkb[1:4], collapse = " ")
            y[[geom_column[i]]] <- paste0(geom_format, " ",
                                          geom_name, ": raw ",
                                          wkb_starts_with, " ...")
        }
        attr(y, "gis") <- NULL
        print(y, quote = FALSE, ...)

    } else if (geom_format == "WKT" || geom_format == "WKT_ISO") {
        y <- unclass(x)
        for (i in seq_along(geom_column)) {
            wkt <- x[[geom_column[i]]]
            if (is.na(wkt))
                geom_format <- "WKT NULL geometry"
            wkt_starts_with <- substring(wkt, 1, 28)
            y[[geom_column[i]]] <- paste0(geom_format, ": chr \"",
                                          wkt_starts_with, " ...\"")
        }
        attr(y, "gis") <- NULL
        print(y, quote = FALSE, ...)

    } else {
        print(x[seq_along(x)], quote = FALSE, ...)
    }

    invisible(x)
}

#' Print an `OGRFeatureSet`
#'
#' @param x An `OGRFeatureSet`.
#' @param ... Optional arguments passed to `base::print.data.frame()`.
#' @return The input, invisibly.
#' @export
#' @method print OGRFeatureSet
print.OGRFeatureSet <- function(x, ...) {
    geom_column <- attr(x, "gis")$geom_column
    geom_format <- toupper(attr(x, "gis")$geom_format)

    if (geom_format == "NONE" || length(geom_column) == 0)
        cat("OGR feature set (attribute table)\n")
    else
        cat("OGR feature set\n")

    if (nrow(x) == 0) {
        print.data.frame(x[seq_along(x)], right = FALSE, ...)

    } else if (geom_format == "WKB" || geom_format == "WKB_ISO") {
        y <- x
        for (i in seq_along(geom_column)) {
            geom_name <- g_name(x[, geom_column[i]])
            geom_name[is.na(geom_name)] <- "NULL geometry"
            wkb_starts_with <- sapply(x[, geom_column[i]],
                                      function(g) paste(g[1:4], collapse = " "))

            geom_col_print <- paste0(geom_format, " ",
                                     geom_name, ": ", "raw ",
                                     wkb_starts_with, " ...")
            y[geom_column[i]] <- geom_col_print
        }
        attr(y, "gis") <- NULL
        print.data.frame(y, ...)

    } else if (geom_format == "WKT" || geom_format == "WKT_ISO") {
        y <- x
        for (i in seq_along(geom_column)) {
            wkt <- x[[geom_column[i]]]
            wkt_starts_with <- substring(wkt, 1, 28)
            y[geom_column[i]] <- paste0(geom_format, ": chr \"",
                                        wkt_starts_with, " ...\"")
            y[is.na(wkt), geom_column[i]] <- paste0("WKT NULL geometry",
                                                    ": chr \"",
                                                    wkt_starts_with,
                                                    " ...\"")
        }
        attr(y, "gis") <- NULL
        print.data.frame(y, ...)

    } else {
        print.data.frame(x[seq_along(x)], right = FALSE, ...)
    }

    invisible(x)
}

#' Plot the geometry of an `OGRFeature` object
#'
#' @param x An `OGRFeature` object.
#' @param xlab Title for the x axis.
#' @param ylab Title for the y axis.
#' @param main The main title (on top).
#' @param ... Optional arguments passed to `wk::wk_plot()`.
#' @return The input, invisibly.
#' @export
#' @method plot OGRFeature
plot.OGRFeature <- function(x, xlab = "x", ylab = "y",  main = "", ...) {
     if (!requireNamespace("vctrs", quietly = TRUE))
        cli::cli_alert_warning(
            "{.fn wk::wk_plot} requires suggested package {.pkg vctrs}")

    geom_column <- NULL
    if (length(attr(x, "gis")$geom_column) == 0)
        stop("no geometry column")
    else
        geom_column <- attr(x, "gis")$geom_column[1]

    geom_format <- ""
    if (length(attr(x, "gis")$geom_format) == 0)
        stop("missing geometry format")
    else
        geom_format <- toupper(attr(x, "gis")$geom_format)

    if (!geom_format %in% c("WKB", "WKB_ISO", "WKT", "WKT_ISO", "BBOX"))
        stop("no supported geometry format for plot")

    srs <- attr(x, "gis")$geom_col_srs[1]

    if (geom_format == "BBOX") {
        bb <- x[[geom_column]]
        wk_obj <- wk::rct(bb[1], bb[2], bb[3], bb[4], crs = srs)
    } else if (startsWith(geom_format, "WKB")) {
        wk_obj <- wk::wkb(list(x[[geom_column]]), crs = srs)
    } else {
        wk_obj <- wk::wkt(x[[geom_column]], crs = srs)
    }

    wk::wk_plot(wk_obj, ..., xlab = xlab, ylab = ylab)
    graphics::title(main = main)

    invisible(x)
}

#' Plot the geometry column of an `OGRFeatureSet`
#'
#' @param x An `OGRFeatureSet`.
#' @param xlab Title for the x axis.
#' @param ylab Title for the y axis.
#' @param main The main title (on top).
#' @param ... Optional arguments passed to `wk::wk_plot()`.
#' @return The input, invisibly.
#' @export
#' @method plot OGRFeatureSet
plot.OGRFeatureSet <- function(x, xlab = "x", ylab = "y", main = "", ...) {
     if (!requireNamespace("vctrs", quietly = TRUE))
        cli::cli_alert_warning(
            "{.fn wk::wk_plot} requires suggested package {.pkg vctrs}")

    if (length(attr(x, "gis")$geom_column) == 0)
        stop("no geometry column")
    else
        geom_column <- attr(x, "gis")$geom_column[1]

    geom_format <- toupper(attr(x, "gis")$geom_format)
    if (!geom_format %in% c("WKB", "WKB_ISO", "WKT", "WKT_ISO", "BBOX"))
        stop("no supported geometry format for plot")

    srs <- attr(x, "gis")$geom_col_srs[1]

    if (geom_format == "BBOX") {
        wk_obj <- matrix(unlist(x[[geom_column]]), ncol = 4, byrow = TRUE) |>
            wk::as_rct()
    } else if (startsWith(geom_format, "WKB")) {
        wk_obj <- wk::wkb(x[[geom_column]], crs = srs)
    } else {
        wk_obj <- wk::wkt(x[[geom_column]], crs = srs)
    }

    wk::wk_plot(wk_obj, ..., xlab = xlab, ylab = ylab)
    graphics::title(main = main)

    invisible(x)
}

# R wrappers for PROJ utility functions (via GDAL headers)
# Chris Toney <chris.toney at usda.gov>

#' Get PROJ version
#'
#' @description
#' `proj_version()` returns version information for the PROJ library in use by
#' GDAL.
#'
#' @returns A list of length four containing:
#'   * `name` - a string formatted as "major.minor.patch"
#'   * `major` - major version as integer
#'   * `minor` - minor version as integer
#'   * `patch` - patch version as integer
#'
#' @seealso
#' [gdal_version()], [geos_version()], [proj_search_paths()],
#' [proj_networking()]
#'
#' @examples
#' proj_version()
#' @export
proj_version <- function() {
    ver <- .getPROJVersion()
    pv <- list()
    if (anyNA(ver))
        pv$name <- NA_character_
    else
        pv$name <- paste(ver, collapse=".")
    pv$major <- ver[1]
    pv$minor <- ver[2]
    pv$patch <- ver[3]
    return(pv)
}

#' Get or set search path(s) for PROJ resource files
#'
#' @description
#' `proj_search_paths()` returns the search path(s) for PROJ resource files,
#' optionally setting them first.
#'
#' @param paths Optional character vector containing one or more directory
#' paths to set.
#' @returns A character vector containing the currently used search path(s) for
#' PROJ resource files. An empty string (`""`) is returned if no search paths
#' are returned by the function `OSRGetPROJSearchPaths()` in the GDAL Spatial
#' Reference System C API.
#'
#' @seealso
#' [proj_version()], [proj_networking()]
#'
#' @examples
#' proj_search_paths()
#' @export
proj_search_paths <- function(paths=NULL) {
    if (!is.null(paths))
        .setPROJSearchPaths(paths)
    return(.getPROJSearchPaths())
}

#' Check, enable or disable PROJ networking capabilities
#'
#' @description
#' `proj_networking()` returns the status of PROJ networking capabilities,
#' optionally enabling or disabling first. Requires GDAL 3.4 or later and
#' PROJ 7 or later.
#'
#' @param enabled Optional logical scalar. Set to `TRUE` to enable networking
#' capabilities or `FALSE` to disable.
#' @returns Logical `TRUE` if PROJ networking capabilities are enabled (as
#' indicated by the return value of `OSRGetPROJEnableNetwork()` in the GDAL
#' Spatial Reference System C API). Logical `NA` is returned if GDAL < 3.4.
#'
#' @seealso
#' [proj_version()], [proj_search_paths()]
#'
#' \href{https://github.com/OSGeo/PROJ-data}{PROJ-data on GitHub},
#' \href{https://cdn.proj.org/}{PROJ Content Delivery Network}
#'
#' @examples
#' proj_networking()
#' @export
proj_networking <- function(enabled=NULL) {
    if (!is.null(enabled)) {
        if (!is.logical(enabled) || length(enabled) > 1)
            stop("'enabled' must be a logical scalar", call.=FALSE)
        .setPROJEnableNetwork(enabled)
    }
    return(.getPROJEnableNetwork())
}

test_that("PROJ utility functions run", {
    expect_length(proj_version(), 4)
    expect_no_error(proj_search_paths())
    expect_no_error(proj_networking(TRUE))
    expect_no_error(proj_networking(FALSE))
    if (as.integer(gdal_version()[2]) >= 3000300) {
        proj_paths <- proj_search_paths()
        expect_no_error(proj_search_paths(proj_paths))
    }
})

# Miscellaneous helper functions for working with the GDAL API
# Chris Toney <chris.toney at usda.gov>

#' @noRd
#' @export
.get_crs_name <- function(wkt) {
    # name of form "<srs name> [(EPSG:####[, confidence ##])]"
    # include EPSG code if confidence > 50
    # include the confidence value if < 100

    crs_name <- srs_get_name(wkt)
    epsg <- srs_find_epsg(wkt, all_matches = TRUE)
    if (!is.null(epsg)) {
        if (nrow(epsg) >= 1 && epsg$confidence[1] > 50) {
            crs_name <- paste0(crs_name, " (", epsg$authority_name[1], ":",
                               epsg$authority_code[1])
            if (epsg$confidence[1] < 100) {
                crs_name <- paste0(crs_name, ", confidence ",
                                   epsg$confidence[1])
            }
            crs_name <- paste0(crs_name, ")")
        }
    }
    return(crs_name)
}


#' Compute a GDAL integer version number from major, minor, revision
#'
#' `gdal_compute_version()` computes a full integer version number
#' (GDAL_VERSION_NUM) from individual components (major, minor, revision).
#' Convenience function for checking a GDAL version requirement using
#' `gdal_version_num()`.
#'
#' @param maj Numeric value, major version component (coerced to integer by
#' truncation).
#' @param min Numeric value, min version component (coerced to integer by
#' truncation).
#' @param rev Numeric value, revision version component (coerced to integer by
#' truncation).
#' @returns Integer version number compatible with `gdal_version_num()`.
#'
#' @seealso
#' [gdal_version_num()]
#'
#' @examples
#' (gdal_version_num() >= gdal_compute_version(3, 7, 0))
#' @export
gdal_compute_version <- function(maj, min, rev) {
    if (!is.numeric(maj) || length(maj) != 1)
        stop("'maj' must be a single numeric value", call. = FALSE)
    else
        maj <- as.integer(maj)
    if (!is.numeric(min) || length(min) != 1)
        stop("'min' must be a single numeric value", call. = FALSE)
    else
        min <- as.integer(min)
    if (!is.numeric(rev) || length(rev) != 1)
        stop("'rev' must be a single numeric value", call. = FALSE)
    else
        rev <- as.integer(rev)

    return(as.integer(maj * 1000000 + min * 10000 + rev * 100))
}


#' Return library version information for GDAL and its dependencies
#'
#' `lib_versions()` returns a named list of library version information for
#' GDAL and its major dependencies, currently PROJ and GEOS. It provides library
#' versions in a consistent format, as an alternative to the separate
#' `gdal_version()`, `proj_version()` and `geos_version()`.
#'
#' @returns
#' A named list with elements `"gdal"`, `"proj"` and `"geos"`, each
#' containing a named list with the following elements:
#' * `"name"`: character string version as `"major.minor.patch"`
#' * `"major"`: integer major version number
#' * `"minor"`: integer minor version number
#' * `"patch"`: integer patch version number
#'
#' @seealso
#' [gdal_version()], [proj_version()], [geos_version()]
#'
#' @examples
#' lib_versions()
#' @export
lib_versions <- function() {
    out <- vector("list", 3)
    names(out) <- c("gdal", "proj", "geos")

    gdal_parts <- gdal_version()[4] |> strsplit(".", fixed = TRUE) |> unlist()
    out$gdal <- list(name = gdal_version()[4],
                     major = as.integer(gdal_parts[1]),
                     minor = as.integer(gdal_parts[2]),
                     patch = as.integer(gdal_parts[3]))
    out$proj <- proj_version()
    out$geos <- geos_version()

    return(out)
}


#' Create/append to a potentially Seek-Optimized ZIP file (SOZip)
#'
#' `addFilesInZip()` will create new or open existing ZIP file, and
#' add one or more compressed files potentially using the seek optimization
#' extension. This function is basically a wrapper for `CPLAddFileInZip()`
#' in the GDAL Common Portability Library, but optionally creates a new ZIP
#' file first (with `CPLCreateZip()`). It provides a subset of functionality
#' in the GDAL `sozip` command-line utility
#' (\url{https://gdal.org/en/stable/programs/sozip.html}). Requires GDAL >= 3.7.
#'
#' @details
#' A Seek-Optimized ZIP file (SOZip) contains one or more compressed files
#' organized and annotated such that a SOZip-aware reader can perform very
#' fast random access within the .zip file
#' (see \url{https://github.com/sozip/sozip-spec}).
#' Large compressed files can be accessed directly from SOZip without prior
#' decompression. The .zip file is otherwise fully backward compatible.
#'
#' If `sozip_enabled="AUTO"` (the default), a file is seek-optimized only if
#' its size is above the values of `sozip_min_file_size` (default 1 MB) and
#' `sozip_chunk_size` (default `32768`).
#' In `"YES"` mode, all input files will be seek-optimized. In `"NO"` mode, no
#' input files will be seek-optimized. The default can be changed with the
#' `CPL_SOZIP_ENABLED` configuration option.
#'
#' @param zip_file Filename of the ZIP file. Will be created if it does not
#' exist or if `overwrite = TRUE`. Otherwise will append to an existing file.
#' @param add_files Character vector of one or more input filenames to add.
#' @param overwrite Logical scalar. Overwrite the target zip file if it already
#' exists.
#' @param full_paths Logical scalar. By default, the full path will be stored
#' (relative to the current directory). `FALSE` to store just the name of a
#' saved file (drop the path).
#' @param sozip_enabled String. Whether to generate a SOZip index for the file.
#' One of `"AUTO"` (the default), `"YES"` or `"NO"` (see Details).
#' @param sozip_chunk_size The chunk size for a seek-optimized file.
#' Defaults to 32768 bytes. The value is specified in bytes, or K and M
#' suffix can be used respectively to specify a value in kilo-bytes or
#' mega-bytes. Will be coerced to string.
#' @param sozip_min_file_size The minimum file size to decide if a file
#' should be seek-optimized, in `sozip_enabled="AUTO"` mode. Defaults to
#' 1 MB byte. The value is specified in bytes, or K, M or G suffix can be used
#' respectively to specify a value in kilo-bytes, mega-bytes or giga-bytes.
#' Will be coerced to string.
#' @param num_threads Number of threads used for SOZip generation. Defaults to
#' `"ALL_CPUS"` or specify an integer value (coerced to string).
#' @param content_type String Content-Type value for the file. This is stored
#' as a key-value pair in the extra field extension 'KV' (0x564b) dedicated to
#' storing key-value pair metadata.
#' @param quiet Logical scalar. `TRUE` for quiet mode, no progress messages
#' emitted. Defaults to `FALSE`.
#' @returns Logical indicating success (invisible \code{TRUE}).
#' An error is raised if the operation fails.
#'
#' @note
#' The `GDAL_NUM_THREADS` configuration option can be set to `ALL_CPUS` or an
#' integer value to specify the number of threads to use for SOZip-compressed
#' files (see [set_config_option()]).
#'
#' SOZip can be validated with:
#' ```
#' vsi_get_file_metadata(zip_file, domain="ZIP")
#' ```
#'
#' where `zip_file` uses the /vsizip/ prefix.
#'
#' @seealso
#' [vsi_get_file_metadata()]
#'
#' @examples
#' f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
#' zip_file <- file.path(tempdir(), "ynp_fires.zip")
#'
#' # Requires GDAL >= 3.7
#' if (gdal_version_num() >= gdal_compute_version(3, 7, 0)) {
#'   addFilesInZip(zip_file, f, full_paths = FALSE, sozip_enabled = "YES",
#'                 num_threads = 1)
#'
#'   print("Files in zip archive:")
#'   print(unzip(zip_file, list = TRUE))
#'
#'   # Open with GDAL using Virtual File System handler '/vsizip/'
#'   # https://gdal.org/en/stable/user/virtual_file_systems.html#vsizip-zip-archives
#'   vsi_f <- file.path("/vsizip", zip_file, "ynp_fires_1984_2022.gpkg")
#'   print("SOZip metadata:")
#'   print(vsi_get_file_metadata(vsi_f, domain = "ZIP"))
#'
#'   lyr <- new(GDALVector, vsi_f)
#'   lyr$info()
#'   lyr$close()
#'   \dontshow{vsi_unlink(zip_file)}
#' }
#' @export
addFilesInZip <- function(
        zip_file,
        add_files,
        overwrite = FALSE,
        full_paths = TRUE,
        sozip_enabled = NULL,
        sozip_chunk_size = NULL,
        sozip_min_file_size = NULL,
        num_threads = NULL,
        content_type = NULL,
        quiet = FALSE) {

    if (gdal_version_num() < gdal_compute_version(3, 7, 0))
        stop("addFilesInZip() requires GDAL >= 3.7", call. = FALSE)

    if (!is.character(zip_file) || length(zip_file) > 1)
        stop("'zip_file' must be a single character string", call. = FALSE)
    else
        zip_file <- .check_gdal_filename(zip_file)

    if (!is.character(add_files))
        stop("'add_files' must be a character vector of filenames",
             call. = FALSE)

    if (!is.null(overwrite)) {
        if (!is.logical(overwrite) || length(overwrite) > 1)
            stop("'overwrite' must be a logical scalar", call. = FALSE)
    } else {
        overwrite <- FALSE
    }

    if (!is.null(full_paths)) {
        if (!is.logical(full_paths) || length(full_paths) > 1)
            stop("'full_paths' must be a logical scalar", call. = FALSE)
    } else {
        full_paths <- FALSE
    }

    if (!is.null(quiet)) {
        if (!is.logical(quiet) || length(quiet) > 1)
            stop("'quiet' must be a logical scalar", call. = FALSE)
    } else {
        quiet <- FALSE
    }

    opt <- NULL
    if (!is.null(sozip_enabled)) {
        if (!is.character(sozip_enabled) || length(sozip_enabled) > 1) {
            stop("'sozip_enabled' must be a single character string",
                 call. = FALSE)
        }
        sozip_enabled <- toupper(sozip_enabled)
        if (!(sozip_enabled %in% c("AUTO", "YES", "NO"))) {
            stop("'sozip_enabled' must be one of \"AUTO\", \"YES\" or \"NO\"",
                 call. = FALSE)
        } else {
            opt <- c(opt, paste0("SOZIP_ENABLED=", sozip_enabled))
        }
    }
    if (!is.null(sozip_chunk_size)) {
        if (length(sozip_chunk_size) > 1)
            stop("'sozip_chunk_size' must be a single value", call. = FALSE)
        opt <- c(opt, paste0("SOZIP_CHUNK_SIZE=", sozip_chunk_size))
    }
    if (!is.null(sozip_min_file_size)) {
        if (length(sozip_min_file_size) > 1)
            stop("'sozip_min_file_size' must be a single value", call. = FALSE)
        opt <- c(opt, paste0("SOZIP_MIN_FILE_SIZE=", sozip_min_file_size))
    }
    if (!is.null(num_threads)) {
        if (length(num_threads) > 1)
            stop("'num_threads' must be a single value", call. = FALSE)
        opt <- c(opt, paste0("NUM_THREADS=", num_threads))
    }
    if (!is.null(content_type)) {
        if (!is.character(content_type) || length(content_type) > 1) {
            stop("'content_type' must be a single character string",
                 call. = FALSE)
        }
        opt <- c(opt, paste0("CONTENT_TYPE=", content_type))
    }

    if (overwrite) {
        if (vsi_stat_exists(zip_file) && vsi_unlink(zip_file) != 0)
            stop("cannot overwrite: ", zip_file, call. = FALSE)
    }

    ret <- FALSE
    for (f in add_files) {
        if (!(vsi_stat_exists(f) && vsi_stat_type(f) == "file"))
            stop("file not found: ", f, call. = FALSE)

        archive_fname <- f
        if (!full_paths || substr(f, 1, 4) == "/vsi") {
            archive_fname <- .cpl_get_filename(f)
        } else if (substr(f, 1, 1) == "/") {
            archive_fname <- substring(f, 2)
        } else if (nchar(f) > 3 && substr(f, 2, 2) == ":" &&
                   (substr(f, 3, 3) == "/" || substr(f, 3, 3) == "\\")) {
            archive_fname <- substring(f, 4)
        }
        archive_fname <- .check_gdal_filename(archive_fname)

        if (!quiet) {
            cli::cli_progress_step(
                "Adding {.val {archive_fname}}",
                msg_failed = "Failed to add {.val {archive_fname}}")
        }

        if (!.addFileInZip(zip_file,
                           overwrite = FALSE,
                           archive_fname,
                           f,
                           opt,
                           quiet = TRUE)) {
            ret <- FALSE
            if (!quiet)
                cli::cli_progress_done("failed")
            break
        } else {
            ret <- TRUE
        }
        if (!quiet)
            cli::cli_progress_done()
    }

    if (!ret)
        stop("failed to add file, error from CPLAddFileInZip()",
             call. = FALSE)

    return(invisible(ret))
}


#' Return the list of creation options for a GDAL driver
#'
#' `getCreationOptions()` returns the list of creation options supported by a
#' GDAL format driver.
#' This function is a wrapper of `GDALGetDriverCreationOptionList()` in the
#' GDAL API, parsing its XML output into a named list.
#'
#' @details
#' The output is a nested list with names matching the creation option names.
#' The information for each creation option is a named list with the following
#' elements:
#' * `type`: a character string describing the data type, e.g., `"int"`,
#' `"float"`, `"string"`. The type `"string-select"` denotes a list of allowed
#' string values which are returned as a character vector in the `values`
#' element (see below).
#' * `description`: a character string describing the option, or `NA` if no
#' description is provided by the GDAL driver.
#' * `default`: the default value of the option as either a character string
#' or numeric value, or `NA` if no description is provided by the GDAL driver.
#' * `values`: a character vector of allowed string values for the creation
#' option if `type` is `"string-select"`, otherwise `NULL` if the option is
#' not a `"string-select"` type.
#' * `min`: (GDAL >= 3.11) the minimum value of the valid range for the
#' option, or `NA` if not provided by the GDAL driver or the option is not a
#' numeric type.
#' * `max`: (GDAL >= 3.11) the maximum value of the valid range for the
#' option, or `NA` if not provided by the GDAL driver or the option is not a
#' numeric type.
#'
#' @param format Format short name (e.g., `"GTiff"`).
#' @param filter Optional character vector of creation option names.
#' @returns A named list with names matching the creation option names, and
#' each element a named list with elements `type`, `description`, `default`
#' and `values` (see Details).
#'
#' @seealso
#' [create()], [createCopy()], [translate()], [validateCreationOptions()],
#' [warp()]
#'
#' @examples
#' opt <- getCreationOptions("GTiff", "COMPRESS")
#' names(opt)
#'
#' (opt$COMPRESS$type == "string-select")  # TRUE
#' opt$COMPRESS$values
#'
#' all_opt <- getCreationOptions("GTiff")
#' names(all_opt)
#'
#' # $description and $default will be NA if no value is provided by the driver
#' # $values will be NULL if the option is not a 'string-select' type
#'
#' all_opt$PREDICTOR
#'
#' all_opt$BIGTIFF
#' @export
getCreationOptions <- function(format, filter = NULL) {

    if (!is.character(format) || length(format) > 1)
        stop("'format' must be a character string", call. = FALSE)

    if (is.null(filter) || filter == "") {
        filter <- "_all_"
    } else {
        filter <- toupper(filter)
    }

    if (.getCreationOptions(format) == "") {
        cli::cli_alert_warning("no creation options found for {.val {format}}")
        return(NULL)
    }

    xml <- xml2::read_xml(.getCreationOptions(format))
    el <- xml2::xml_children(xml)
    out <- list()
    if (length(el) == 0) {
        return(NULL)
    } else {
        for (i in seq_along(el)) {
            a <- xml_attrs(el[[i]])
            if (filter[1] == "_all_" || toupper(a["name"]) %in% filter) {
                type_name <- unname(a["type"])
                str_values <- xml_children(el[[i]]) |> as_list() |> unlist()
                default_val <- unname(a["default"])
                if (toupper(type_name) %in% c("INT", "INTEGER", "UNSIGNED INT",
                                              "FLOAT")) {
                    default_val <- as.numeric(default_val)
                }

                # The XML returned by GDAL < 3.11 does not include the
                # min/max attributes even though they are populated in the
                # driver code that builds the XML string.
                # (https://github.com/OSGeo/gdal/issues/11967)
                if (gdal_version_num() < 3110000) {
                    out[[unname(a["name"])]] <- list(
                        type = type_name,
                        description = unname(a["description"]),
                        default = default_val,
                        values = str_values)
                } else {
                    out[[unname(a["name"])]] <- list(
                        type = type_name,
                        description = unname(a["description"]),
                        default = default_val,
                        values = str_values,
                        min = as.numeric(unname(a["min"])),
                        max = as.numeric(unname(a["max"])))
                }
            }
        }
    }

    return(out)
}


#' Return the list of options associated with a virtual file system handler
#'
#' `vsi_get_fs_options()` returns the list of options associated with a virtual
#' file system handler. Those options may be set as configuration options with
#' `set_config_option()`.
#' Wrapper for `VSIGetFileSystemOptions()` in the GDAL API.
#'
#' @param filename Filename, or prefix of a virtual file system handler.
#' @param as_list Logical scalar. If `TRUE` (the default), the XML string
#' returned by GDAL will be coerced to list. `FALSE` to return the configuration
#' options as a serialized XML string.
#' @returns An XML string, or empty string (`""`) if no options are declared.
#' If `as_list = TRUE` (the default), the XML string will be coerced to list
#' with `xml2::as_list()`.
#'
#' @seealso
#' [set_config_option()], [vsi_get_fs_prefixes()]
#'
#' \url{https://gdal.org/en/stable/user/virtual_file_systems.html}
#'
#' @examples
#' vsi_get_fs_options("/vsimem/")
#'
#' vsi_get_fs_options("/vsizip/")
#'
#' vsi_get_fs_options("/vsizip/", as_list = FALSE)
#' @export
vsi_get_fs_options <- function(filename, as_list = TRUE) {

    if (!is.character(filename) || length(filename) > 1)
        stop("'filename' must be a length-1 character vector.", call.=FALSE)

    opts <- .vsi_get_fs_options(filename)

    if (opts == "")
        return(opts)
    else if (as_list)
        return(xml2::read_xml(opts) |> xml2::as_list())
    else
        return(opts)
}


#' Apply geotransform (raster column/row to geospatial x/y)
#'
#' `apply_geotransform()` applies geotransform coefficients to raster
#' coordinates in pixel/line space (column/row), converting into
#' georeferenced (x/y) coordinates. Wrapper of `GDALApplyGeoTransform()` in
#' the GDAL API, operating on matrix input.
#'
#' @param col_row Numeric matrix of raster column, row (pixel/line) coordinates
#' (or two-column data frame that will be coerced to numeric matrix, or a
#' vector of column, row for one coordinate).
#' @param gt Either a numeric vector of length six containing the affine
#' geotransform for the raster, or an object of class `GDALRaster` from
#' which the geotransform will be obtained.
#' @returns Numeric matrix of geospatial x/y coordinates.
#'
#' @note
#' Bounds checking on the input coordinates is done if `gt` is obtained from an
#' object of class `GDALRaster`. See Note for [get_pixel_line()].
#'
#' @seealso [`GDALRaster$getGeoTransform()`][GDALRaster], [get_pixel_line()]
#'
#' @examples
#' raster_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
#' ds <- new(GDALRaster, raster_file)
#'
#' # compute some raster coordinates in column/row space
#' set.seed(42)
#' col_coords <- runif(10, min = 0, max = ds$getRasterXSize() - 0.00001)
#' row_coords <- runif(10, min = 0, max = ds$getRasterYSize() - 0.00001)
#' col_row <- cbind(col_coords, row_coords)
#'
#' # convert to geospatial x/y coordinates
#' gt <- ds$getGeoTransform()
#' apply_geotransform(col_row, gt)
#'
#' # or, using the class method
#' ds$apply_geotransform(col_row)
#'
#' # bounds checking
#' col_row <- rbind(col_row, c(ds$getRasterXSize(), ds$getRasterYSize()))
#' ds$apply_geotransform(col_row)
#'
#' ds$close()
#' @export
apply_geotransform <- function(col_row, gt) {
    if (!(is.vector(col_row) || is.matrix(col_row) || is.data.frame(col_row)))
        stop("'col_row' must be a data frame or numeric matrix", call. = FALSE)

    if ((is.matrix(col_row) || is.data.frame(col_row)) && ncol(col_row) != 2)
        stop("'col_row' must have 2 columns", call. = FALSE)
    else if (is.vector(col_row) && length(col_row) != 2)
        stop("'col_row' as vector must have length 2", call. = FALSE)

    # allow for c(NA, NA) which is logical type, NA input should return NA out
    if ((is.vector(xy) || is.matrix(xy)) && !is.numeric(xy) && !is.logical(xy))
        stop("'col_row' must be numeric", call. = FALSE)

    if (is(gt, "Rcpp_GDALRaster")) {
        return(.apply_geotransform_ds(col_row, gt))
    } else if (is.numeric(gt) && length(gt) == 6) {
        return(.apply_geotransform_gt(col_row, gt))
    } else {
        stop("'gt' must be a numeric vector of length 6, or GDALRaster object",
             call. = FALSE)
    }
}


#' Raster pixel/line from geospatial x,y coordinates
#'
#' `get_pixel_line()` converts geospatial coordinates to pixel/line (raster
#' column, row numbers).
#' The upper left corner pixel is the raster origin (0,0) with column, row
#' increasing left to right, top to bottom.
#'
#' @param xy Numeric matrix of geospatial x, y coordinates in the same spatial
#' reference system as \code{gt} (or two-column data frame that will be coerced
#' to numeric matrix, or a vector x, y for one coordinate).
#' @param gt Either a numeric vector of length six containing the affine
#' geotransform for the raster, or an object of class `GDALRaster` from
#' which the geotransform will be obtained (see Note).
#' @returns Integer matrix of raster pixel/line.
#'
#' @note
#' This function applies the inverse geotransform to the input points. If `gt`
#' is given as the numeric vector, no bounds checking is done (i.e., min
#' pixel/line could be less than zero and max pixel/line could be greater than
#' the raster x/y size). If `gt` is obtained from an object of class
#' `GDALRaster`, then `NA` is returned for points that fall outside the
#' raster extent and a warning emitted giving the number points that were
#' outside. This latter case is equivalent to calling the
#' \code{$get_pixel_line()} class method on the `GDALRaster` object (see
#' Examples).
#'
#' @seealso [`GDALRaster$getGeoTransform()`][GDALRaster], [inv_geotransform()]
#'
#' @examples
#' pt_file <- system.file("extdata/storml_pts.csv", package="gdalraster")
#' # id, x, y in NAD83 / UTM zone 12N
#' pts <- read.csv(pt_file)
#' print(pts)
#'
#' raster_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
#' ds <- new(GDALRaster, raster_file)
#' gt <- ds$getGeoTransform()
#' get_pixel_line(pts[, -1], gt)
#'
#' # or, using the class method
#' ds$get_pixel_line(pts[, -1])
#'
#' # add a point outside the raster extent
#' pts[11, ] <- c(11, 323318, 5105104)
#' get_pixel_line(pts[, -1], gt)
#'
#' # with bounds checking on the raster extent
#' ds$get_pixel_line(pts[, -1])
#'
#' ds$close()
#' @export
get_pixel_line <- function(xy, gt) {
    if (!(is.vector(xy) || is.matrix(xy) || is.data.frame(xy)))
        stop("'xy' must be a data frame or numeric matrix", call. = FALSE)

    if ((is.matrix(xy) || is.data.frame(xy)) && ncol(xy) != 2)
        stop("'xy' must have 2 columns", call. = FALSE)
    else if (is.vector(xy) && length(xy) != 2)
        stop("'xy' as vector must have length 2", call. = FALSE)

    # allow for c(NA, NA) which is logical type, NA input should return NA out
    if ((is.vector(xy) || is.matrix(xy)) && !is.numeric(xy) && !is.logical(xy))
        stop("'xy' must be numeric", call. = FALSE)

    if (is(gt, "Rcpp_GDALRaster")) {
        return(.get_pixel_line_ds(xy, gt))
    } else if (is.numeric(gt) && length(gt) == 6) {
        return(.get_pixel_line_gt(xy, gt))
    } else {
        stop("'gt' must be a numeric vector of length 6, or GDALRaster object",
             call. = FALSE)
    }
}


#' Report open datasets
#'
#' `dump_open_datasets()` dumps a list of all open datasets (shared or not) to
#' the console. This function is primarily intended to assist in debugging
#' "dataset leaks" and reference counting issues. The information reported
#' includes the dataset name, referenced count, shared status, driver name,
#' size, and band count. This a wrapper for `GDALDumpOpenDatasets()` with
#' output to the console.
#'
#' @returns Number of open datasets.
#'
#' @examples
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' ds <- new(GDALRaster, elev_file)
#' dump_open_datasets()
#' ds2 <- new(GDALRaster, elev_file)
#' dump_open_datasets()
#' # open without using shared mode
#' ds3 <- new(GDALRaster, elev_file, read_only = TRUE,
#'            open_options = NULL, shared = FALSE)
#' dump_open_datasets()
#' ds$close()
#' dump_open_datasets()
#' ds2$close()
#' dump_open_datasets()
#' ds3$close()
#' dump_open_datasets()
#' @export
dump_open_datasets <- function() {
    f <- tempfile(fileext = ".txt")
    nopen <- .dump_open_datasets(f)
    if (nopen < 0)
        stop("failed to obtain the list of open datasets", call. = FALSE)

    out <- readLines(f)
    unlink(f)
    writeLines(out)
    return(nopen)
}


#' Obtain information about a GDAL raster or vector dataset
#'
#' `inspectDataset()` returns information about the format and content
#' of a dataset. The function first calls `identifyDriver()`, and then opens
#' the dataset as raster and/or vector to obtain information about its content.
#' The return value is a list with named elements.
#'
#' @param filename Character string containing the name of the file to access.
#' This may not refer to a physical file, but instead contain information for
#' the driver on how to access a dataset (e.g., connection string, URL, etc.)
#' @param ... Additional arguments passed to `identifyDriver()`.
#'
#' @returns
#' A list with the following named elements:
#' * `format`: character string, the format short name
#' * `supports_raster`: logical, `TRUE` if the format supports raster data
#' * `contains_raster`: logical, `TRUE` if this is a raster dataset or the
#' source contains raster subdatasets
#' * `supports_subdatasets`: logical, `TRUE` if the format supports raster
#' subdatasets
#' * `contains_subdatasets`: logical, `TRUE` if the source contains subdatasets
#' * `subdataset_names`: character vector containing the subdataset names, or
#' empty vector if subdatasets are not supported or not present
#' * `supports_vector`: logical, `TRUE` if the format supports vector data
#' * `contains_vector`: logical, `TRUE` if the source contains one or more
#' vector layers
#' * `layer_names`: character vector containing the vector layer names, or
#' empty vector if the format does not support vector or the source does not
#' contain any vector layers
#'
#'@note
#' Subdataset names are the character strings that can be used to
#' instantiate `GDALRaster` objects.
#' See https://gdal.org/en/stable/en/latest/user/raster_data_model.html#subdatasets-domain.
#'
#' PostgreSQL / PostGISRaster are handled as a special case. If additional
#' arguments `raster` or `vector` are not given for `identifyDriver()`, then
#' `raster = FALSE` is assumed.
#'
#' @seealso
#' [gdal_formats()], [identifyDriver()]
#'
#' @examples
#' f <- system.file("extdata/ynp_features.zip", package = "gdalraster")
#' ynp_dsn <- file.path("/vsizip", f, "ynp_features.gpkg")
#'
#' inspectDataset(ynp_dsn)
#' @export
inspectDataset <- function(filename, ...) {
    if (!is.character(filename))
        stop("'filename' must be a character string", call. = FALSE)

    filename_in <- .check_gdal_filename(filename)
    fmt <- identifyDriver(filename = filename_in, ...)
    if (is.null(fmt)) {
        warning("failed to identify a format driver", call. = FALSE)
        return(NULL)
    }

    if (!hasArg("raster") && !hasArg("vector")) {
        # check for possibly two different drivers
        fmt_rast <- identifyDriver(filename = filename_in, vector = FALSE, ...)
        fmt_vect <- identifyDriver(filename = filename_in, raster = FALSE, ...)
        if (!is.null(fmt_rast) && !is.null(fmt_vect)) {
            if (fmt_rast != fmt_vect) {
                if (fmt_vect == "PostgreSQL") {
                    # for PostGISRaster / PostgreSQL, assume vector is intended
                    fmt <- fmt_vect
                } else {
                    message("identified separate raster and vector drivers: ",
                            fmt_rast, ", ", fmt_vect)
                    stop("need additional arguments for `identifyDriver()`",
                         call. = FALSE)
                }
            }
        }
    }

    out <- list()
    out$format <- fmt
    fmt_info <- gdal_formats(fmt)
    if (nrow(fmt_info) == 0) {
        stop("failed to obtain format information", call. = FALSE)
    }

    out$supports_raster <- fmt_info$raster
    out$contains_raster <- FALSE
    if (out$supports_raster) {
        push_error_handler("quiet")
        ds <- try(new(GDALRaster, filename_in), silent = TRUE)
        pop_error_handler()
        if (is(ds, "Rcpp_GDALRaster"))
            out$contains_raster <- TRUE
    }

    out$supports_subdatasets <- fmt_info$subdatasets
    out$contains_subdatasets <- FALSE
    out$subdataset_names <- character(0)
    if (out$contains_raster) {
        md <- ds$getMetadata(band = 0, domain = "SUBDATASETS")
        if (length(md) > 1) {
            out$contains_subdatasets <- TRUE
            Encoding(md) <- "UTF-8"
            for (i in seq_along(md)) {
                mdi <- strsplit(md[i], "=", fixed = TRUE)
                if (grepl("_NAME", mdi[[1]][1], ignore.case = TRUE)) {
                    out$subdataset_names <- c(out$subdataset_names, mdi[[1]][2])
                }
            }
        }
    }

    if (out$supports_raster && is(ds, "Rcpp_GDALRaster")) {
        ds$close()
    }

    out$supports_vector <- fmt_info$vector
    out$contains_vector <- FALSE
    out$layer_names <- character(0)
    if (out$supports_vector) {
        if (ogr_ds_layer_count(filename_in) > 0) {
            out$contains_vector <- TRUE
            out$layer_names <- ogr_ds_layer_names(filename_in)
        }
    }

    return(out)
}


#' Generate an index of chunk offsets and sizes for iterating a raster
#'
#' `make_chunk_index()` returns a matrix of `xchunkoff`, `ychunkoff`, `xoff`,
#' `yoff`, `xsize`, `ysize`, `xmin`, `xmax`, `ymin` and `ymax`, i.e., indexing
#' of potentially multi-block chunks defined on block boundaries for iterating
#' I/O operations over a raster. The last four columns are geospatial
#' coordinates of the bounding box. Note that class `GDALRaster` provides a
#' method of the same name that is more convenient to use with a dataset object.
#'
#' @details
#' The stand-alone function here supports the general case of chunking/tiling a
#' raster layout without using a dataset object. If the `max_pixels` argument
#' is set to zero, the chunks are raster blocks (the internal tiles in the case
#' of a tiled format). Otherwise, chunks are defined as the maximum number of
#' consecutive whole blocks containing `<= max_pixels`, that may span one or
#' multiple whole rows of blocks.
#'
#' @param raster_xsize Integer value giving the number of raster columns.
#' @param raster_ysize Integer value giving the number of raster rows.
#' @param block_xsize Integer value giving the horizontal size of a raster block
#' in number of pixels.
#' @param block_ysize Integer value giving the vertical size of a raster block
#' in number of pixels.
#' @param gt A numeric vector of length six containing the affine geotransform
#' for the raster (defaults to `c(0, 1, 0, 0, 0, 1)`). Required only if
#' geospatial bounding boxes of the chunks are needed in the output.
#' @param max_pixels Numeric value (a whole number), optionally carrying the
#' `bit64::integer64` class attribute. Specifies the maximum number of pixels
#' per chunk. Can be set to zero to define chunks as the blocks.
#' @return A numeric matrix with number of rows equal to the number of chunks,
#' and named columns: `xchunkoff`, `ychunkoff`, `xoff`, `yoff`, `xsize`,
#' `ysize`, `xmin`, `xmax`, `ymin`, `ymax`. Offsets are 0-based.
#'
#' @seealso
#' Methods \code{make_chunk_index()}, \code{readChunk()} and
#' \code{writeChunk()} in class [GDALRaster].
#'
#' Usage example in the web article
#' [GDAL Block Cache](https://firelab.github.io/gdalraster/articles/gdal-block-cache.html).
#'
#' @examples
#' ## chunk as one block
#' blocks <- make_chunk_index(raster_xsize = 156335, raster_ysize = 101538,
#'                            block_xsize = 256, block_ysize = 256,
#'                            gt = c(-2362395, 30, 0, 3267405, 0, -30),
#'                            max_pixels = 0)
#'
#' nrow(blocks)
#'
#' head(blocks)
#'
#' tail(blocks)
#'
#' ## chunk as 16 consecutive blocks
#' chunks <- make_chunk_index(raster_xsize = 156335, raster_ysize = 101538,
#'                            block_xsize = 256, block_ysize = 256,
#'                            gt = c(-2362395, 30, 0, 3267405, 0, -30),
#'                            max_pixels = 256 * 256 * 16)
#'
#' nrow(chunks)
#'
#' head(chunks)
#'
#' tail(chunks)
#' @export
make_chunk_index <- function(raster_xsize, raster_ysize,
                             block_xsize, block_ysize,
                             gt = c(0, 1, 0, 0, 0, 1),
                             max_pixels = 0) {

    return(.make_chunk_index(raster_xsize, raster_ysize, block_xsize,
                             block_ysize, gt, max_pixels))
}


#' Create a GDAL in-memory dataset from R data without copying
#'
#' `rvector_to_MEM()` creates a GDAL MEM dataset that references pixel data in
#' an existing R vector. It returns an object of class `GDALRaster` for a
#' writable in-memory dataset without copying the source data. The underlying
#' R object is protected from garbage collection until the returned dataset is
#' closed. GDAL MEM datasets support most kinds of auxiliary information
#' including metadata, coordinate systems, georeferencing, color interpretation,
#' nodata, color tables and all pixel data types (see Details).
#'
#' @details
#' The returned dataset is open with write access. Methods of the `GDALRaster`
#' object can be called to modify dataset and band properties, e.g., to set
#' nodata values, metadata items, band descriptions, color tables, etc. The
#' original R vector will be modified in place if the object's `$write()`
#' method is used.
#'
#' The MEM dataset will have a GDAL data type matching the type of the
#' input vector:
#' \tabular{rl}{
#' **R vector type**  \tab  **GDAL raster type**\cr
#' double             \tab  Float64\cr
#' integer            \tab  Int32\cr
#' raw                \tab  UInt8 (Byte in GDAL < 3.13)\cr
#' complex            \tab  CFloat64
#' }
#'
#' `vector_to_MEM()` is an alias of `rvector_to_MEM()` for backward
#' compatibility. It is a deprecated name of the function that will be removed
#' in a future version. Please use `rvector_to_MEM()` instead.
#'
#' @param data An R vector of type `"double"`, `"integer"`, `"raw"` or
#' `"complex"`, containing pixel values to be exposed as a GDAL in-memory
#' raster. The pixels must be arranged in left-to-right, top-to-bottom order
#' interleaved by band. `length(data)` must equal `xsize * ysize * nbands`.
#' @param xsize Integer value giving the number of raster columns.
#' @param ysize Integer value giving the number of raster rows.
#' @param nbands Integer value giving the number of raster bands.
#' @param gt A numeric vector of length six containing the affine geotransform
#' for the raster. Defaults to `c(0, 1, 0, 0, 0, 1)` if neither `gt` nor `bbox`
#' are given.
#' @param bbox A numeric vector of length four containing the raster bounding
#' box geospatial coordinates (`c(xmin, ymin, xmax, ymax)`). Ignored if `gt` is
#' given.
#' @param srs Optional character string containing the raster spatial reference
#' coordinate system as a WKT string. [epsg_to_wkt()] or [srs_to_wkt()] can be
#' used to convert from other formats to WKT if necessary.
#' @return An object of class `GDALRaster` providing a GDAL MEM dataset with
#' write access pointing to the underlying C array for `data`. The R object
#' referenced by `data` is protected from garbage collection during the lifetime
#' of the returned dataset, i.e., until its `$close()` is called or the dataset
#' object itself is garbage collected. An error is raised if creation of the
#' MEM dataset fails.
#'
#' @note
#' MEM datasets also support `addBand()` from existing R data without copying
#' (see Examples).
#'
#' The `$close()` method should be called when the `GDALRaster` object is no
#' longer needed so that resources can be freed. MEM datasets cannot be
#' re-opened once the object's `$close()` method has been called.
#'
#' `vector_to_MEM()` is a deprecated name for the function, currently set as
#' an alias of `rvector_to_MEM()`. _The `vector_to_MEM()` alias will be removed
#' in a future version_.
#'
#' @seealso
#' [`GDALRaster-class`][GDALRaster]
#'
#' @examples
#' v <- sample(0:255, 20, replace = TRUE)
#' (ds_mem <- rvector_to_MEM(v, xsize = 5, ysize = 4))
#'
#' all((ds_mem$read(1, 0, 0, 5, 4, 5, 4) == v))
#'
#' ds_mem$write(1, 0, 0, 5, 4, (v * -1))
#' print(v)
#'
#' ds_mem$close()
#'
#' # MEM also supports no-copy addBand() from R data
#' xsize <- 400
#' ysize <- 300
#' r <- sample(0:255, xsize * ysize, replace = TRUE) |> as.raw()
#' ds_mem <- rvector_to_MEM(r, xsize, ysize)
#' ds_mem$setRasterColorInterp(1, "Red")
#'
#' g <- sample(0:255, xsize * ysize, replace = TRUE) |> as.raw()
#' ds_mem$addBand("Byte", g)
#' ds_mem$setRasterColorInterp(2, "Green")
#'
#' b <- sample(0:255, xsize * ysize, replace = TRUE) |> as.raw()
#' ds_mem$addBand("Byte", b)
#' ds_mem$setRasterColorInterp(3, "Blue")
#'
#' ds_mem$info()
#'
#' plot_raster(ds_mem, main = "random RGB")
#' ds_mem$close()
#' @export
#' @rdname rvector_to_MEM
rvector_to_MEM <- function(data, xsize, ysize, nbands = 1L, gt = NULL,
                           bbox = NULL, srs = NULL) {

    if (!is.vector(data) && !is.numeric(data) && !is.raw(data) &&
        !is.complex(data)) {

        stop("'data' must be a vector of raw, integer, double or complex",
             call. = FALSE)
    }

    if (!(is.numeric(xsize) && length(xsize) == 1))
        stop("'xsize' must be a single integer value", call. = FALSE)

    if (!(is.numeric(ysize) && length(ysize) == 1))
        stop("'ysize' must be a single integer value", call. = FALSE)

    if (!(is.numeric(nbands) && length(nbands) == 1))
        stop("'nbands' must be a single integer value", call. = FALSE)

    if (length(data) != as.double(xsize) * ysize * nbands) {
        stop("length of 'data' must equal 'xsize' * 'ysize' * 'nbands'",
             call. = FALSE)
    }

    if (!is.null(gt)) {
        if (!(is.numeric(gt) && length(gt) == 6))
            stop("'gt' must be a numeric vector of length 6", call. = FALSE)
    }

    if (!is.null(bbox)) {
        if (!is.null(gt))
            message("NOTE: 'bbox' ignored since 'gt' was given")
        else if (!(is.numeric(bbox) && length(bbox) == 4))
            stop("'bbox' must be a numeric vector of length 4", call. = FALSE)
    }

    if (is.null(gt)) {
        if (!is.null(bbox))
            gt <- gt_from_dim_bbox(c(xsize, ysize), bbox)
        else
            gt <- c(0, 1, 0, 0, 0, 1)
    }

    if (!is.null(srs)) {
        if (!(is.character(srs) && length(srs) == 1))
            stop("'srs' must be a single character string", call. = FALSE)
    }

    dt <- "Unknown"
    if (is.double(data)) {
        dt <- "Float64"
    } else if (is.integer(data)) {
        dt <- "Int32"
    } else if (is.raw(data)) {
        if (gdal_version_num() < gdal_compute_version(3, 13, 0))
            dt <- "Byte"
        else
            dt <- "UInt8"
    } else if (is.complex(data)) {
        dt <- "CFloat64"
    } else {
        stop("failed to determine a raster data type for 'data'", call. = FALSE)
    }

    gt_str <- paste(gt, collapse = "/")
    band_offset <- as.double(xsize) * ysize * dt_size(dt)
    ptr <- .get_data_ptr(data)

    dsn_fmt <- "MEM:::DATAPOINTER=%s,PIXELS=%d,LINES=%d,BANDS=%d,DATATYPE=%s,GEOTRANSFORM=%s,BANDOFFSET=%d"
    dsn <- sprintf(dsn_fmt, ptr, xsize, ysize, nbands, dt, gt_str, band_offset)

    orig_opt <- ""
    reset_opt <- FALSE
    if (gdal_version_num() >= gdal_compute_version(3, 10, 0)) {
        reset_opt <- TRUE
        orig_opt <- get_config_option("GDAL_MEM_ENABLE_OPEN")
        set_config_option("GDAL_MEM_ENABLE_OPEN", "YES")
    }

    ds_mem <- new(GDALRaster, dsn, FALSE)

    if (!ds_mem$preserveRObject_(data)) {
        ds_mem$close()
        stop("failed to preserve the R object", call. = FALSE)
    }

    if (!is.null(srs)) {
        if (!ds_mem$setProjection(srs)) {
            warning("failed to set projection on the MEM dataset",
                    call. = FALSE)
        }
    }

    if (reset_opt)
        set_config_option("GDAL_MEM_ENABLE_OPEN", orig_opt)

    return(ds_mem)
}

#' @export
#' @rdname rvector_to_MEM
vector_to_MEM <- rvector_to_MEM

#' Clear progress bar
#'
#' `progress_bar_clear()` terminates any active \pkg{cli} progress bars and
#' resets the global progress bar in C++. Generally not needed unless a process
#' using a progress bar terminates abnormally, or with ctrl-c interrupt, and
#' a progress bar display anomaly results.
#'
#' @return
#' No return value, call for side effects.
progress_bar_clear <- function() {
    cli::cli_progress_cleanup()
    cli::cli_progress_message("")
    .progress_bar_cleanup()
}

# apply_geotransform() and get_pixel_line() tests are in test-gdal_exp.R

test_that("gdal_compute_version works", {
    expect_equal(gdal_compute_version(3, 7, 0), 3070000L)
    expect_error(gdal_compute_version("3", 7, 0))
    expect_error(gdal_compute_version(3, "7", 0))
    expect_error(gdal_compute_version(3, 7, NULL))
})

test_that("lib_versions works", {
    expect_true(is.list(lib_versions()))
    expect_equal(length(lib_versions()), 3)

    gdal_parts <- gdal_version()[4] |> strsplit(".", fixed = TRUE) |> unlist()
    gdal_ver <- list(name = gdal_version()[4],
                     major = as.integer(gdal_parts[1]),
                     minor = as.integer(gdal_parts[2]),
                     patch = as.integer(gdal_parts[3]))

    expect_equal(lib_versions()$gdal, gdal_ver)
    expect_equal(lib_versions()$proj, proj_version())
    expect_equal(lib_versions()$geos, geos_version())
})

test_that("addFilesInZip works", {
    # requires GDAL >= 3.7
    skip_if(as.integer(gdal_version()[2]) < 3070000)

    evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
    evc_file <- system.file("extdata/storml_evc.tif", package="gdalraster")
    evh_file <- system.file("extdata/storml_evh.tif", package="gdalraster")
    files_to_add <- c(evt_file, evc_file, evh_file)
    zip_file <- paste0(tempdir(), "/", "storml.zip")
    addFilesInZip(
            zip_file,
            files_to_add,
            full_paths=FALSE,
            sozip_enabled="YES",
            sozip_chunk_size=16384,
            sozip_min_file_size=1024,
            content_type="TEST",
            num_threads=1)
    d <- unzip(zip_file, list=TRUE)
    expect_equal(nrow(d), 3)
    unlink(zip_file)
})

test_that("getCreationOptions works", {
    opt <- getCreationOptions("GTiff", "COMPRESS")
    expect_true(is.list(opt))
    expect_equal(names(opt), "COMPRESS")
    expect_equal(opt$COMPRESS$type, "string-select")
    expect_vector(opt$COMPRESS$values, ptype = character())
    all_opt <- getCreationOptions("GTiff")
    expect_true(is.list(all_opt))
    expect_true(length(names(all_opt)) > 10)
    expect_true(is.list(all_opt$TILED))
    expect_message(getCreationOptions("AIG"))
    expect_true(is.null(getCreationOptions("AIG")))
    expect_error(getCreationOptions("invalid format name"))
    expect_error(getCreationOptions(NA))
})

test_that("dump_open_datasets works", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    ds <- new(GDALRaster, elev_file)
    expect_output(dump_open_datasets())
    expect_true(dump_open_datasets() > 0)
    ds$close()
})

test_that("inspectDataset works", {
    # GPKG with subdatasets
    # https://download.osgeo.org/gdal/data/geopackage/small_world_and_byte.gpkg
    src <-  system.file("extdata/small_world_and_byte.gpkg", package="gdalraster")
    dsinfo <- inspectDataset(src)
    expect_equal(dsinfo$format, "GPKG")
    expect_true(dsinfo$supports_raster)
    expect_true(dsinfo$contains_raster)
    expect_true(dsinfo$supports_subdatasets)
    expect_true(dsinfo$contains_subdatasets)
    expect_no_error(ds <- new(GDALRaster, dsinfo$subdataset_names[1]))
    expect_no_error(ds$close())
    expect_no_error(ds <- new(GDALRaster, dsinfo$subdataset_names[2]))
    expect_no_error(ds$close())
    expect_true(dsinfo$supports_vector)
    expect_false(dsinfo$contains_vector)
    expect_vector(dsinfo$layer_names, ptype = character(), size = 0)

    # GPKG with vector
    src <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
    dsinfo <- inspectDataset(src)
    expect_false(dsinfo$contains_raster)
    expect_false(dsinfo$contains_subdatasets)
    expect_vector(dsinfo$subdataset_names, ptype = character(), size = 0)
    expect_true(dsinfo$contains_vector)
    expect_equal(dsinfo$layer_names, "mtbs_perims")

    # shapefile
    src <- system.file("extdata/poly_multipoly.shp", package="gdalraster")
    dsinfo <- inspectDataset(src)
    expect_equal(dsinfo$format, "ESRI Shapefile")
    expect_false(dsinfo$supports_raster)
    expect_false(dsinfo$contains_raster)
    expect_false(dsinfo$supports_subdatasets)
    expect_false(dsinfo$contains_subdatasets)
    expect_true(dsinfo$supports_vector)
    expect_true(dsinfo$contains_vector)
    expect_vector(dsinfo$layer_names, ptype = character(), size = 1)

    # GTiff
    src <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    dsinfo <- inspectDataset(src)
    expect_equal(dsinfo$format, "GTiff")
    expect_true(dsinfo$supports_raster)
    expect_true(dsinfo$contains_raster)
    expect_true(dsinfo$supports_subdatasets)
    expect_false(dsinfo$contains_subdatasets)
    expect_false(dsinfo$supports_vector)
    expect_false(dsinfo$contains_vector)
    expect_vector(dsinfo$layer_names, ptype = character(), size = 0)

    # PostGISRaster / PostgreSQL
    skip_if(nrow(gdal_formats("PostgreSQL")) == 0 ||
            nrow(gdal_formats("PostGISRaster")) == 0)

    dsn <- "PG:dbname='testdb', host='127.0.0.1' port='5444' user='user'
            password='pwd'"
    dsinfo <- inspectDataset(dsn)
    expect_equal(dsinfo$format, "PostgreSQL")
    expect_false(dsinfo$supports_raster)
    expect_false(dsinfo$contains_raster)
    expect_false(dsinfo$supports_subdatasets)
    expect_false(dsinfo$contains_subdatasets)
    expect_true(dsinfo$supports_vector)
    expect_false(dsinfo$contains_vector)
    expect_vector(dsinfo$layer_names, ptype = character(), size = 0)

    dsn <- "PG:dbname='testdb', host='127.0.0.1' port='5444' table='raster_tbl'
            column='raster_col' user='user' password='pwd'"
    dsinfo <- inspectDataset(dsn, vector = FALSE)
    expect_equal(dsinfo$format, "PostGISRaster")
    expect_true(dsinfo$supports_raster)
    expect_false(dsinfo$contains_raster)
    expect_true(dsinfo$supports_subdatasets)
    expect_false(dsinfo$contains_subdatasets)
    expect_false(dsinfo$supports_vector)
    expect_false(dsinfo$contains_vector)
    expect_vector(dsinfo$layer_names, ptype = character(), size = 0)
})

test_that("make_chunk_index works", {
    # the internal C++ function being called is tested in
    # tests/testthat/test-GDALRaster-class.R

    chunks <- make_chunk_index(raster_xsize = 156335, raster_ysize = 101538,
                               block_xsize = 256, block_ysize = 256,
                               gt = c(-2362395, 30, 0, 3267405, 0, -30),
                               max_pixels = 256 * 256 * 16)

    expect_equal(nrow(chunks), 15483)
})

test_that("rvector_to_MEM basic functionality works", {
    xsize <- 10L
    ysize <- 10L

    ## raw -> Byte / UInt8
    v <- sample(0:255, xsize * ysize, replace = TRUE)
    v_raw <- as.raw(v)
    expect_no_error(ds_mem <- rvector_to_MEM(v_raw, xsize, ysize))
    dt <- ds_mem$getDataTypeName(1)
    expect_true(dt == "Byte" || dt == "UInt8")
    res <- ds_mem$read(1, 0, 0, xsize, ysize, xsize, ysize)
    expect_equal(res, v)
    ds_mem$readByteAsRaw <- TRUE
    res <- ds_mem$read(1, 0, 0, xsize, ysize, xsize, ysize)
    expect_equal(res, v_raw)
    ds_mem$close()
    # multi-band
    expect_no_error(ds_mem <- rvector_to_MEM(v_raw, 5, 10, nbands = 2))
    res1 <- ds_mem$read(1, 0, 0, 5, 10, 5, 10)
    expect_equal(res1, v[1:50])
    res2 <- ds_mem$read(2, 0, 0, 5, 10, 5, 10)
    expect_equal(res2, v[51:100])
    ds_mem$close()

    ## integer -> Int32
    v_int <- sample(-32767:32767, xsize * ysize, replace = TRUE)
    expect_no_error(ds_mem <- rvector_to_MEM(v_int, xsize, ysize))
    dt <- ds_mem$getDataTypeName(1)
    expect_true(dt == "Int32")
    res <- ds_mem$read(1, 0, 0, xsize, ysize, xsize, ysize)
    expect_equal(res, v_int)
    ds_mem$close()

    ## double -> Float64
    v_dbl <- v_int + 0.5
    expect_no_error(ds_mem <- rvector_to_MEM(v_dbl, xsize, ysize))
    dt <- ds_mem$getDataTypeName(1)
    expect_true(dt == "Float64")
    res <- ds_mem$read(1, 0, 0, xsize, ysize, xsize, ysize)
    expect_equal(res, v_dbl, tolerance = 1e4)
    ds_mem$close()

    ## complex -> CFloat64
    z <- complex(real = stats::rnorm(100), imaginary = stats::rnorm(100))
    ds_mem <- rvector_to_MEM(z, xsize, ysize)
    dt <- ds_mem$getDataTypeName(1)
    expect_true(dt == "CFloat64")
    res <- ds_mem$read(1, 0, 0, xsize, ysize, xsize, ysize)
    expect_equal(res, z, tolerance = 1e4)
    ds_mem$close()

    ## with arguments for gt, bbox, srs
    f <- system.file("extdata/storml_elev.tif", package = "gdalraster")
    ds <- new(GDALRaster, f)
    dm <- ds$dim()
    xsize = as.integer(dm[1])
    ysize = as.integer(dm[2])
    v_elev <- ds$read(1, 0, 0, xsize, ysize, xsize, ysize)

    expect_no_error(ds_mem <- rvector_to_MEM(v_elev, xsize, ysize,
                                             gt = ds$getGeoTransform(),
                                             srs = ds$getProjection()))

    expect_equal(ds_mem$bbox(), ds$bbox(), tolerance = 0.1)
    expect_true(srs_is_same(ds_mem$getProjection(), ds$getProjection()))
    ds_mem$close()

    expect_no_error(ds_mem <- rvector_to_MEM(v_elev, xsize, ysize,
                                             bbox = ds$bbox(),
                                             srs = ds$getProjection()))

    expect_equal(ds_mem$getGeoTransform(), ds$getGeoTransform(),
                 tolerance = 0.1)
    expect_true(srs_is_same(ds_mem$getProjection(), ds$getProjection()))
    ds_mem$close()

    expect_warning(ds_mem <- rvector_to_MEM(v_elev, xsize, ysize,
                                            gt = ds$getGeoTransform(),
                                            srs = "invalid"))

    ## write to the MEM dataset
    expect_true(ds_mem$setProjection(ds$getProjection()))
    expect_true(srs_is_same(ds_mem$getProjection(), ds$getProjection()))
    v_seq <- seq_len(xsize * ysize)
    expect_no_error(ds_mem$write(1, 0, 0, xsize, ysize, v_seq))
    # original vector v_elev is modified in place
    expect_equal(v_elev, v_seq)

    ds_mem$close()
    ds$close()

    ## errors / input validation
    expect_error(ds_mem <- rvector_to_MEM(rep("1", 100), xsize, ysize))
    expect_error(ds_mem <- rvector_to_MEM(v_elev, c(10, 10), ysize))
    expect_error(ds_mem <- rvector_to_MEM(v_elev, xsize, c(10, 10)))
    expect_error(ds_mem <- rvector_to_MEM(v_elev, xsize, ysize,
                 nbands = c(1,2)))
    expect_error(ds_mem <- rvector_to_MEM(v_elev, xsize, ysize, nbands = 2))
    expect_error(ds_mem <- rvector_to_MEM(v_elev, xsize, ysize,
                 gt = c(1, 2, 3, 4, 5)))
    expect_error(ds_mem <- rvector_to_MEM(v_elev, xsize, ysize,
                 bbox = c(1, 2, 3)))
    expect_error(ds_mem <- rvector_to_MEM(v_elev, xsize, ysize,
                 srs = 4326))

})

test_that("rvector_to_MEM works with object dereference and garbage collect", {
    # test with
    #   - R object dereferenced and garbage collected
    #   - GDALRaster object garbage collected without explicit close()

    xsize <- 10L
    ysize <- 10L

    ## R object dereferenced and garbage collected
    v <- sample(-32767:32767, xsize * ysize, replace = TRUE)
    expect_no_error(ds_mem <- rvector_to_MEM(v, xsize, ysize))
    res <- ds_mem$read(1, 0, 0, xsize, ysize, xsize, ysize)
    expect_equal(res, v)
    rm(v)
    gc()
    expect_equal(ds_mem$read(1, 0, 0, xsize, ysize, xsize, ysize), res)
    ds_mem$close()
    rm(ds_mem)
    rm(res)
    gc()

    v2 <- stats::rnorm(100)
    expect_no_error(ds_mem <- rvector_to_MEM(v2, xsize, ysize))
    res <- ds_mem$read(1, 0, 0, xsize, ysize, xsize, ysize)
    expect_equal(res, v2)
    rm(v2)
    gc()
    expect_equal(ds_mem$read(1, 0, 0, xsize, ysize, xsize, ysize), res)
    ds_mem$close()
    rm(ds_mem)
    rm(res)
    gc()

    ## GDALRaster object garbage collected without explicit close()
    v3 <- sample(0:255, xsize * ysize, replace = TRUE)
    expect_no_error(ds_mem <- rvector_to_MEM(v3, xsize, ysize))
    res <- ds_mem$read(1, 0, 0, xsize, ysize, xsize, ysize)
    expect_equal(res, v3)
    rm(v3)
    rm(ds_mem)
    gc()
})

test_that("progress_bar_clear runs without error", {
    expect_no_error(progress_bar_clear())
})

#' @name RunningStats-class
#'
#' @aliases
#' Rcpp_RunningStats Rcpp_RunningStats-class RunningStats
#'
#' @title Class to calculate mean and variance in one pass
#'
#' @description
#' `RunningStats` computes summary statistics on a data stream efficiently.
#' Mean and variance are calculated with Welford's online algorithm
#' (\url{https://en.wikipedia.org/wiki/Algorithms_for_calculating_variance}).
#' The min, max, sum and count are also tracked. The input data values are not
#' stored in memory, so this class can be used to compute statistics for very
#' large data streams.
#'
#' `RunningStats` is a C++ class exposed directly to \R (via
#' `RCPP_EXPOSED_CLASS`). Methods of the class are accessed using the `$`
#' operator.
#'
#' @param na_rm Logical scalar. `TRUE` to remove `NA` from the input data (the
#' default) or `FALSE` to retain `NA`.
#' @returns An object of class `RunningStats`. A `RunningStats` object
#' maintains the current minimum, maximum, mean, variance, sum and count of
#' values that have been read from the stream. It can be updated repeatedly
#' with new values (i.e., chunks of data read from the input stream), but its
#' memory footprint is negligible. Class methods for updating with new values,
#' and retrieving the current values of statistics, are described in Details.
#'
#' @note
#' The intended use is computing summary statistics for specific subsets or
#' zones of a raster that could be defined in various ways and are generally
#' not contiguous. The algorithm as implemented here incurs the cost of
#' floating point division for each new value updated (i.e., per pixel), but is
#' reasonably efficient for the use case. Note that GDAL internally uses an
#' optimized version of Welford's algorithm to compute raster statistics as
#' described in detail by Rouault, 2016
#' (\url{https://github.com/OSGeo/gdal/blob/master/gcore/statistics.txt}).
#' The class method `GDALRaster$getStatistics()` is a GDAL API wrapper that
#' computes statistics for a whole raster band.
#'
#' @section Usage (see Details):
#' ```
#' ## Constructor
#' rs <- new(RunningStats, na_rm)
#'
#' ## Methods
#' rs$update(newvalues)
#' rs$get_count()
#' rs$get_mean()
#' rs$get_min()
#' rs$get_max()
#' rs$get_sum()
#' rs$get_var()
#' rs$get_sd()
#' rs$reset()
#' ```
#'
#' @section Details:
#' ## Constructor
#'
#' \code{new(RunningStats, na_rm)}\cr
#' Returns an object of class \code{RunningStats}. The `na_rm` argument
#' defaults to `TRUE` if omitted.
#'
#' ## Methods
#'
#' \code{$update(newvalues)}\cr
#' Updates the `RunningStats` object with a numeric vector of `newvalues`
#' (i.e., a chunk of values from the data stream). No return value, called
#' for side effects.
#'
#' \code{$get_count()}\cr
#' Returns the count of values received from the data stream.
#'
#' \code{$get_mean()}\cr
#' Returns the mean of values received from the data stream.
#'
#' \code{$get_min()}\cr
#' Returns the minimum value received from the data stream.
#'
#' \code{$get_max()}\cr
#' Returns the maximum value received from the data stream.
#'
#' \code{$get_sum()}\cr
#' Returns the sum of values received from the data stream.
#'
#' \code{$get_var()}\cr
#' Returns the variance of values from the data stream
#' (denominator n - 1).
#'
#' \code{$get_sd()}\cr
#' Returns the standard deviation of values from the data stream
#' (denominator n - 1).
#'
#' \code{$reset()}\cr
#' Clears the \code{RunningStats} object to its initialized state (count = 0).
#' No return value, called for side effects.
#'
#' @examples
#' set.seed(42)
#' (rs <- new(RunningStats, na_rm = TRUE))
#'
#' chunk <- runif(1000)
#' rs$update(chunk)
#' object.size(rs)
#'
#' rs$get_count()
#' length(chunk)
#'
#' rs$get_mean()
#' mean(chunk)
#'
#' rs$get_min()
#' min(chunk)
#'
#' rs$get_max()
#' max(chunk)
#'
#' rs$get_var()
#' var(chunk)
#'
#' rs$get_sd()
#' sd(chunk)
#'
#' \donttest{
#' ## 10^9 values read in 10,000 chunks
#' ## should take under 1 minute on most PC hardware
#' for (i in 1:1e4) {
#'   chunk <- runif(1e5)
#'   rs$update(chunk)
#' }
#' rs$get_count()
#' rs$get_mean()
#' rs$get_var()
#'
#' object.size(rs)
#' }
NULL

Rcpp::loadModule("mod_running_stats", TRUE)

# R interface to the GDAL CLI algorithms
# functions for using exposed class `GDALAlg`
# see R/gdalalg.R and src/gdalalg.h
# Chris Toney <jctoney at gmail.com>

#' Functions for using GDAL CLI algorithms
#'
#' @name gdal_cli
#' @description
#' This set of functions can be used to access and run `gdal` command line
#' interface (CLI) algorithms.
#'
#' **Requires GDAL >= 3.11.3**
#'
#' **Experimental** (see the section `Development Status` below)
#'
#' @details
#' These functions provide an interface to GDAL CLI algorithms by way of the
#' C++ exposed class [`GDALAlg`][GDALAlg]. See the class documentation for
#' additional information (`?GDALAlg`).
#'
#' `gdal_commands()` prints a list of commands and their descriptions to the
#' console, and returns (invisibly) a data frame with columns `command`,
#' `description`, `URL`. The `contains` argument can be used to filter the
#' output, e.g., `gdal_commands("vector")` to return only commands for working
#' with vector inputs.
#'
#' `gdal_usage()` prints a help message to the console for a given command, or
#' for the root `gdal` entry point if called with no argument. No return value,
#' called for that side effect only.
#'
#' `gdal_run()` executes a GDAL CLI algorithm and returns it as an object of
#' class [`GDALAlg`][GDALAlg]. A list containing algorithm output(s) can be
#' accessed by calling the \code{$outputs()} method (plural) on the returned
#' object, or, more conveniently in most cases, by calling \code{$output()}
#' (singular) to return the the single output value when there is only one.
#' After assigning the output, or otherwise completing work with the `GDALAlg`
#' object, its \code{$release()} method can be called to close datasets and
#' free resources.
#'
#' `gdal_run_piped()` is a variation of `gdal_run()`. It is suitable for use
#' with the R native pipe operator (`|>`), but may be useful stand-alone when
#' it is desirable to obtain the output of the algorithm directly, and access
#' to the `GDALAlg` object itself is not needed. The first argument to this
#' function is passed to the `"input"` (or `"dataset"` or `"source"`) argument
#' of the algorithm (i.e., as input to the GDAL command specified in `cmd`). The
#' function returns (invisibly) the output of the CLI algorithm if it has one.
#' If the algorithm has multiple outputs, the first by index is returned by
#' default but this can be controlled by the `output_index` argument (numeric
#' index or character name of the desired output). Logical `TRUE` is returned
#' invisibly if the algorithm has no output and no error was reported by the
#' `run()` method of the algorithm object. Logical `FALSE` is returned invisibly
#' but a message printed if an error occurs. The algorithm object used
#' internally is always finalized before return.
#'
#' `gdal_alg()` instantiates and returns an object of class [`GDALAlg`][GDALAlg]
#' without running it. Passing argument values to the requested CLI algorithm is
#' optional. This function may be useful (with or without argument values) for
#' obtaining algorithm properties with the returned object's \code{$info()}
#' method, obtaining properties of algorithm arguments
#' (\code{$argInfo(arg_name)}), or obtaining algorithm usage as a
#' JSON-formatted string (\code{$usageAsJSON()}).
#' This function is simply an alternative to calling the `new()` constructor
#' for class `GDALAlg`. Executing the returned algorithm is optional by calling
#' the object's \code{$run()} method (assuming argument values were given).
#'
#' `gdal_global_reg_names()` returns a character vector containing the names of
#' the algorithms in the GDAL global algorithm registry. These are the
#' top-level nodes (`raster`, `vector`, etc.) known to GDAL. Potentially code
#' external to GDAL could register a new command available for CLI use in a
#' GDAL plugin. This function may be useful in certain troubleshooting
#' scenarios. It will return a vector of length zero if no names are returned
#' from the global registry.
#'
#' @param contains Optional character string for filtering output to certain
#' commands, e.g., `gdal_commands("vector")`.
#' @param recurse Logical value, `TRUE` to include all subcommands recursively
#' (the default). Set to `FALSE` to include only the top-level `gdal` commands
#' (i.e., `raster`, `vector`, etc.)
#' @param cout Logical value, `TRUE` to print a list of commands along with
#' their descriptions and help URLS to the console (the default).
#' @param cmd A character string or character vector containing the path to the
#' algorithm, e.g., `"raster reproject"` or `c("raster", "reproject")`.
#' Defaults to `"gdal"`, the main entry point to CLI commands.
#' @param args Either a character vector or a named list containing input
#' arguments of the algorithm (see section `Algorithm Argument Syntax` below).
#' @param close Logical value, `FALSE` by default. Set to `TRUE` to finalize
#' the algorithm immediately after it is run, which completes any pending
#' actions such as closing output datasets. This is useful if you do not need to
#' access the output as objects, e.g., when only generating file output for
#' later use. See `GDALAlg$close()`.
#' @param quiet Logical value, `FALSE` by default. Set to `TRUE` to suppress
#' progress reporting along with various messages and warnings. Sets the value
#' of `GDALAlg$quiet`.
#' @param setVectorArgsFromObject Logical value, `TRUE` to set algorithm
#' arguments automatically when the `"input"` argument or the `"like"` argument
#' is an object of class `GDALVector` (the default). Can be set to `FALSE` to
#' disable automatically setting algorithm arguments from `GDALVector` input
#' (see Note).
#' @param input Value passed as input to the GDAL algorithm specified in `cmd`
#' (i.e., the `"input"`, `"dataset"` or `"source"` argument for the command).
#' Typically this is a dataset name (e.g., file or database connection string),
#' or an object of class `GDALRaster` or `GDALVector`.
#' @param output Value passed for the `"output"` (or `"destination"`) argument
#' of `cmd`. Typically this is a filename for commands that generate a raster
#' or vector dataset or other file output. May be `NULL` or empty string (`""`)
#' if `output_format` is `"MEM"` (in-memory dataset).
#' @param output_format Optional character string specifying the output format,
#' e.g., a format driver short name when output is a raster or vector dataset.
#' Will be passed to the algorithm's optional `"output-format"` argument.
#' @param other_args Either a character vector or a named list containing other
#' input arguments of the algorithm (i.e., other than those already specified
#' via `input`, `output` and `output_format` above, see also the section
#' `Algorithm Argument Syntax` below).
#' @param output_index Optional numeric value or character string giving the
#' list index or output argument name for an algorithm with more than one
#' output. Defaults to `1`.
#' @param outputLayerNameForOpen Optional character string specifying a layer
#' name to open when obtaining algorithm output as an object of class
#' `GDALVector` (see the class method [GDALAlg$output()][GDALAlg]). Defaults to
#' empty string (`""`) in which case the first layer by index is opened.
#' Ignored if output is not a vector dataset.
#' @param parse Logical value, `TRUE` to attempt parsing `args` if they are
#' given in `gdal_alg()` (the default). Set to `FALSE` to instantiate the
#' algorithm without parsing arguments. The \code{$parseCommandLineArgs()}
#' method on the returned object can be called to parse arguments and obtain
#' the result of that, with potentially useful error messages.
#'
#' @section Algorithm Argument Syntax:
#' Arguments are given in \R as a character vector or named list, but
#' otherwise syntax basically matches the GDAL specification for arguments as
#' they are given on the command line. Those specifications are listed here
#' along with some amendments regarding the character vector and named list
#' formats. Programmatic usage also allows passing and receiving datasets as
#' objects (i.e., `GDALRaster` or `GDALVector`), in addition to dataset names
#' (e.g., filename, URL, database connection string).
#' * Commands accept one or several positional arguments, typically for dataset
#' names (or in \R as `GDALRaster` or `GDALVector` datasets). The order is
#' input(s) first, output last. Positional arguments can also be specified as
#' named arguments, if preferred to avoid any ambiguity.
#' * Named arguments have:
#'   * at least one "long" name, preceded by two dash characters
#'   * optionally, auxiliary long names (i.e., aliases),
#'   * and optionally a one-letter short name, preceded by a single dash
#'   character, e.g., \code{-f, --of, --format, --output-format <OUTPUT-FORMAT>}
#' * Boolean arguments are specified by just specifying the argument name in
#' character vector format. In \R `list` format, the named element must be
#' assigned a value of logical `TRUE`.
#' * Arguments that require a value are specified like:
#'   * \code{-f VALUE} for one-letter short names
#'   * \code{--format VALUE} or \code{--format=VALUE} for long names
#'   * in a named list, this might look like: \code{args$format <- VALUE}
#' * Some arguments can be multi-valued. Some of them require all values to be
#' packed together and separated with comma. This is, e.g., the case of:\cr
#' \code{--bbox <BBOX> Clipping bounding box as xmin,ymin,xmax,ymax} \cr
#' e.g., \code{--bbox=2.1,49.1,2.9,49.9}
#' * Others accept each value to be preceded by a new mention of the argument
#' name, e.g., \code{c("--co", "COMPRESS=LZW", "--co", "TILED=YES")}. For that
#' one, if the value of the argument does not contain commas, the packed form
#' is also accepted: \code{--co COMPRESS=LZW,TILED=YES}. Note that repeated
#' mentions of an argument are possible in the character vector format for
#' argument input, whereas arguments given in named list format must use
#' argument long names as the list element names, and the packed format for the
#' values (which can be a character vector or numeric vector of values).
#' * Named arguments can be placed before or after positional arguments.
#'
#' @section Development Status:
#' The GDAL Command Line Interface Modernization was first introduced in the
#' [GDAL 3.11.0 release](https://github.com/OSGeo/gdal/releases/tag/v3.11.0)
#' (2025-05-09). The GDAL project provides warning that the new CLI "is
#' provisionally provided as an alternative interface to GDAL and OGR command
#' line utilities. The project reserves the right to modify, rename,
#' reorganize, and change the behavior until it is officially frozen via PSC
#' vote in a future major GDAL release. The utility needs time to mature,
#' benefit from incremental feedback, and explore enhancements without carrying
#' the burden of full backward compatibility. Your usage of it should have no
#' expectation of compatibility until that time."
#' (\url{https://gdal.org/en/latest/programs/#gdal-application})
#'
#' Initial bindings to enable programmatic use of the CLI algorithms from \R
#' were added in \pkg{gdalraster} 2.2.0, and will evolve over future releases.
#' *The bindings are considered experimental until the upstream API is declared
#' stable*. Breaking changes in minor version releases are possible until then.
#' Please use with those cautions in mind. Bug reports may be filed at:
#' \url{https://github.com/firelab/gdalraster/issues}.
#'
#' @note
#' Commands do not require the leading `"gdal"` root node. They may begin
#' with a top-level command (e.g., `"raster"`, `"vector"`, etc.).
#'
#' When using argument names as the element names of a list, the underscore
#' character can be substituted for the dash characters that are used in some
#' names. This avoids having to surround names in backticks when they are used
#' to access list elements in the form \code{args$arg_name} (the form
#' \code{args[["arg-name"]]} also works).
#'
#' When `setVectorArgsFromObject` is `TRUE` (the default) and the `"input"` or
#' `"like"` argument for an algorithm is given as a `GDALVector` object,
#' corresponding algorithm arguments will be set automatically based on
#' properties of the object (when the argument is available to the algorithm):
#' * `"input-format"`: set to the `GDALVector` object's driver short name
#' * `"input-layer"`: set to the `GDALVector` layer name if it is not a SQL
#' layer
#' * `"sql"`: set to the SQL statement if the `GDALVector` layer is defined by
#' one
#' * `"dialect"`: set to the SQL dialect if one is specified for a SQL layer
#' * `"like-layer"`: set to the `GDALVector` layer name if it is not a SQL
#' layer
#' * `"like-sql"`: set to the SQL statement if the `GDALVector` layer is
#' defined by one
#'
#' Argument values specified explicitly will override the automatic setting (as
#' long as they result in a parsable set of arguments). If
#' `setVectorArgsFromObject` is `FALSE`, then only the vector dataset is passed
#' to the algorithm, i.e., without automatically passing any layer
#' specifications.
#'
#' @seealso
#' [`GDALAlg-class`][GDALAlg]
#'
#' `gdal` Command Line Interface (CLI) \cr
#' \url{https://gdal.org/en/stable/programs/index.html}
#'
#' Using `gdal` CLI algorithms from R\cr
#' \url{https://firelab.github.io/gdalraster/articles/use-gdal-cli-from-r.html}
#'
#' @examplesIf length(gdal_global_reg_names()) > 0
#' ## top-level commands
#' gdal_commands(recurse = FALSE)
#'
#' ## convert storml_elev.tif to GeoPackage raster
#' gdal_commands("convert")
#'
#' gdal_usage("raster convert")
#'
#' f_tif <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' f_gpkg <- file.path(tempdir(), "storml_elev.gpkg")
#' args <- c("--overwrite", f_tif, f_gpkg)
#'
#' # finalize the algorithm immediately after it is run if only generating
#' # file output for later use:
#' # gdal_run("raster convert", args, close = TRUE)
#'
#' # or, assign to a variable and access algorithm output as a dataset object
#' (alg <- gdal_run("raster convert", args))
#'
#' (ds <- alg$output())
#'
#' alg$release()
#'
#' plot_raster(ds, legend = TRUE)
#'
#' ds$close()
#' unlink(f_gpkg)
#'
#' ## use the R native pipe operator
#'
#' if (requireNamespace("ltc")) {
#'   # make a of plot of 'terrain ruggedness index' (TRI) for Storm Lake AOI
#'   system.file("extdata/storml_elev.tif", package="gdalraster") |>
#'     gdal_run_piped("raster tri", "", "MEM") |>
#'     plot_raster(legend = TRUE,
#'                 minmax_pct_cut = c(0, 99),
#'                 col_map_fn = rev(ltc::ltc("heatmap3")),
#'                 main = "Storm Lake AOI: terrain ruggedness index")
#' }
#'
#' ## get help for vector commands
#' gdal_usage("vector")
#'
#' ## clip a vector layer by a bounding box
#' gdal_usage("vector clip")
#'
#' f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
#' f_clip <- file.path(tempdir(), "ynp_fires_clip.gpkg")
#'
#' # some multi-valued arguments require all values packed and comma separated
#' # e.g., --bbox <BBOX>
#' bb <- c(469686, 11442, 544070, 85508)
#' bb <- paste(bb, collapse = ",")
#'
#' args <- c("--bbox", bb, "--overwrite", f, f_clip)
#' (alg <- gdal_run("vector clip", args))
#'
#' (lyr <- alg$output())
#'
#' lyr$bbox()
#'
#' lyr$getFeatureCount()
#'
#' lyr$close()
#' alg$release()
#' unlink(f_clip)
#'
#' ## rasterize a vector layer and return output as a GDALRaster object
#' gdal_usage("vector rasterize")
#'
#' f_out = file.path(tempdir(), "ynp_fire_year.tif")
#'
#' # arguments in list format
#' args <- list(input = f,
#'              sql = "SELECT * FROM mtbs_perims ORDER BY ig_year",
#'              attribute_name = "ig_year",
#'              output = f_out,
#'              overwrite = TRUE,
#'              creation_option = c("TILED=YES", "COMPRESS=DEFLATE"),
#'              resolution = c(90, 90),
#'              output_data_type = "Int16",
#'              init = -32767,
#'              nodata = -32767)
#'
#' (alg <- gdal_run("vector rasterize", args))
#'
#' (ds <- alg$output())
#'
#' alg$release()
#'
#' if (requireNamespace("scales")) {
#'   pal <- scales::viridis_pal(end = 0.8, direction = -1)(6)
#'   ramp <- scales::colour_ramp(pal)
#'   plot_raster(ds, legend = TRUE, col_map_fn = ramp, na_col = "#d9d9d9",
#'               main = "YNP Fires 1984-2022 - Most Recent Burn Year")
#' }
#'
#' ds$close()
#' deleteDataset(f_out)
#'
#' ## GDAL CLI pipeline syntax
#' # "raster pipeline" example 2 from:
#' # https://gdal.org/en/latest/programs/gdal_raster_pipeline.html
#' # serialize the command to reproject a GTiff file into GDALG format, and
#' # then later read the GDALG file
#' # GDAL Streamed Algorithm format:
#' # https://gdal.org/en/stable/drivers/raster/gdalg.html
#'
#' gdal_usage("raster pipeline")
#'
#' f_tif <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' f_out <- file.path(tempdir(), "storml_elev_epsg_32100.gdalg.json")
#'
#' args <- c("read", "--input", f_tif, "!",
#'           "reproject", "--dst-crs=EPSG:32100", "!",
#'           "write", "--output", f_out, "--overwrite")
#'
#' alg <- gdal_run("raster pipeline", args)
#' alg$release()
#'
#' # content of the .gdalg.json file
#' readLines(f_out, warn = FALSE) |> writeLines()
#'
#' (ds <- new(GDALRaster, f_out))
#'
#' plot_raster(ds, legend = TRUE)
#'
#' ds$close()
#' unlink(f_out)
#' @export
gdal_commands <- function(contains = NULL, recurse = TRUE, cout = TRUE) {
    if (gdal_version_num() < gdal_compute_version(3, 11, 3)) {
        stop("gdal_commands() requires GDAL >= 3.11.3", call. = FALSE)
    }

    if (missing(contains) || is.null(contains) || all(is.na(contains)))
        contains <- ""
    if (!is.character(contains))
        stop("'contains' must be a character string", call. = FALSE)
    else if (length(contains) > 1)
        contains <- paste(contains, collapse = " ")

    if (missing(recurse) || is.null(recurse) || all(is.na(recurse)))
        recurse <- TRUE
    if (!(is.logical(recurse) && length(recurse) == 1))
        stop("'recurse' must be a length-1 logical vector", call. = FALSE)

    if (missing(cout) || is.null(cout) || all(is.na(cout)))
        cout <- TRUE
    if (!(is.logical(cout) && length(cout) == 1))
        stop("'cout' must be a length-1 logical vector", call. = FALSE)

    return(invisible(.gdal_commands(contains, recurse, cout)))
}

#' @name gdal_cli
#' @export
gdal_usage <- function(cmd = NULL) {
    if (gdal_version_num() < gdal_compute_version(3, 11, 3)) {
        stop("gdal_usage() requires GDAL >= 3.11.3", call. = FALSE)
    }

    alg <- gdal_alg(cmd)
    alg$usage()
    alg$release()
}

#' @name gdal_cli
#' @export
gdal_run <- function(cmd, args, close = FALSE, quiet = FALSE,
                     setVectorArgsFromObject = TRUE) {

    if (gdal_version_num() < gdal_compute_version(3, 11, 3)) {
        stop("gdal_run() requires GDAL >= 3.11.3", call. = FALSE)
    }

    if (missing(cmd) || is.null(cmd) || all(is.na(cmd)))
        stop("'cmd' is required", call. = FALSE)
    if (!is.character(cmd))
        stop("'cmd' must be a character vector", call. = FALSE)

    if (missing(args) || is.null(args) || all(is.na(args)))
        stop("'args' is required", call. = FALSE)
    if (!is.character(args) && !is.list(args))
        stop("'args' must be a character vector or named list", call. = FALSE)

    if (is.null(close) || all(is.na(close)))
        close <- FALSE
    if (!is.logical(close) || length(close) != 1)
        stop("'close' must be a single logical value", call. = FALSE)

    if (is.null(quiet) || all(is.na(quiet)))
        quiet <- TRUE
    if (!is.logical(quiet) || length(quiet) != 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    if (is.null(setVectorArgsFromObject) ||
        all(is.na(setVectorArgsFromObject))) {

        setVectorArgsFromObject <- TRUE
    }
    if (!is.logical(setVectorArgsFromObject) ||
        length(setVectorArgsFromObject) != 1) {

        stop("'setVectorArgsFromObject' must be a single logical value",
             call. = FALSE)
    }

    alg <- new(GDALAlg, cmd, args)
    alg$quiet <- quiet
    alg$setVectorArgsFromObject <- setVectorArgsFromObject

    if (!alg$parseCommandLineArgs()) {
        alg$release()
        stop("failed to parse algorithm arguments and set their values",
             call. = FALSE)
    }

    if (!alg$run()) {
        alg$release()
        stop("failed to execute the command", call. = FALSE)
    }

    if (close) {
        res <- alg$close()
        if (!res && !quiet)
            cli::cli_alert_warning("Error reported during algorithm finalize.")
    }

    if (quiet)
        return(invisible(alg))
    else
        return(alg)
}

#' @name gdal_cli
#' @export
gdal_run_piped <- function(input, cmd, output = NULL, output_format = NULL,
                           other_args = NULL, output_index = 1,
                           outputLayerNameForOpen = NULL) {

    if (gdal_version_num() < gdal_compute_version(3, 11, 3)) {
        stop("gdal_run_piped() requires GDAL >= 3.11.3", call. = FALSE)
    }

    if (missing(cmd) || is.null(cmd) || all(is.na(cmd)))
        stop("'cmd' is required", call. = FALSE)
    if (!is.character(cmd))
        stop("'cmd' must be a character vector", call. = FALSE)

    if (missing(output) || is.null(output) || all(is.na(output))) {
        output <- ""
    } else if (!(is.character(output) && length(output) == 1)) {
        stop("'output' must be a single character string", call. = FALSE)
    }

    if (is.null(output_format) || all(is.na(output_format))) {
        output_format <- NULL
    } else if (!(is.character(output_format) && length(output_format) == 1)) {
        stop("'output_format' must be a single character string", call. = FALSE)
    }

    if (is.null(output_index) || all(is.na(output_index))) {
        output_index <- 1
    } else if (!((is.character(output_index) || is.numeric(output_index))
                 && length(output_index) == 1)) {
        stop(
            "'output_index' must be a single numeric value or character string",
            call. = FALSE)
    } else if (is.numeric(output_index) && output_index < 1) {
        stop("'output_index' must be greater than or equal to 1", call. = FALSE)
    }

    if (!is.null(other_args)) {
        if (!is.character(other_args) && !is.list(other_args)) {
            stop("'other_args' must be a character vector or named list",
                 call. = FALSE)
        }
    }

    if (missing(outputLayerNameForOpen) ||
        is.null(outputLayerNameForOpen) ||
        all(is.na(outputLayerNameForOpen))) {

        outputLayerNameForOpen <- ""
    }

    alg <- new(GDALAlg, cmd, other_args)
    alg$quiet <- TRUE
    alg$outputLayerNameForOpen <- outputLayerNameForOpen

    input_arg_name <- "input"
    alg_info <- alg$info()
    # TODO:
    # should it check for other input argument names here
    # or use any positional one that exists
    if (!("input" %in% alg_info$arg_names)) {
        if ("dataset" %in% alg_info$arg_names) {
            input_arg_name <- "dataset"
        } else if ("source" %in% alg_info$arg_names) {
            input_arg_name <- "source"
        } else {
            cli::cli_alert_danger(paste0(
                "Algorithm does not have an {.arg input}, {.arg dataset} or ",
                "{.arg source} argument"))
            return(invisible(FALSE))
        }
    }

    if (!alg$setArg(input_arg_name, input)) {
        alg$release()
        cli::cli_alert_danger("Failed to set the input argument.")
        return(invisible(FALSE))
    }

    output_arg_name <- "output"
    alg_has_output_or_destination <- TRUE
    if (!("output" %in% alg_info$arg_names)) {
        if ("destination" %in% alg_info$arg_names) {
            output_arg_name <- "destination"
        }
        else {
            alg_has_output_or_destination <- FALSE
        }
    }
    if (alg_has_output_or_destination) {
        if (!alg$setArg(output_arg_name, output)) {
            cli::cli_alert_warning(
                "Failed to set {.arg {output_arg_name}} argument.")
        }
    }

    if (!is.null(output_format)) {
        if (!alg$setArg("output-format", output_format)) {
            cli::cli_alert_warning("Failed to set 'output-format'.")
        }
    }

    if (!alg$parseCommandLineArgs()) {
        alg$release()
        cli::cli_alert_danger(
            "Failed to parse algorithm arguments and set their values.")
        return(invisible(FALSE))
    }

    if (!alg$run()) {
        alg$release()
        cli::cli_alert_danger("Failed to execute {.str {cmd}}")
        return(invisible(FALSE))
    }

    out <- TRUE
    if (length(alg$outputs()) != 0) {
        if (is.numeric(output_index)) {
            if (output_index > length(alg$outputs())) {
                cli::cli_alert_danger(paste0(
                    "{.arg output_index = {output_index}} is greater than the ",
                    "number of outputs ({length(alg$outputs())})."))
                out <- FALSE
            }
        } else {
            if (!(output_index %in% names(alg$outputs()))) {
                cli::cli_alert_danger(paste0(
                    "{.arg output_index = {output_index}} is not an element name ",
                    "in the algorithm output list"))
                out <- FALSE
            }
        }

        if (out)
            out <- alg$outputs()[[output_index]]
    }

    if (!alg$close()) {
        warning(cli::format_warning(
            "Error reported during algorithm finalize."), call. = FALSE)
    }

    alg$release()

    invisible(out)
}

#' @name gdal_cli
#' @export
gdal_alg <- function(cmd = NULL, args = NULL, parse = TRUE) {
    if (gdal_version_num() < gdal_compute_version(3, 11, 3)) {
        stop("gdal_alg() requires GDAL >= 3.11.3", call. = FALSE)
    }

    if (missing(cmd) || is.null(cmd) || all(is.na(cmd)))
        cmd <- "gdal"
    if (!is.character(cmd))
        stop("'cmd' must be a character vector", call. = FALSE)

    if (missing(parse) || is.null(parse) || all(is.na(parse)))
        parse <- TRUE
    if (!(is.logical(parse) && length(parse) == 1))
        stop("'parse' must be a length-1 logical vector", call. = FALSE)

    has_args <- FALSE
    if (!is.null(args)) {
        if (!is.character(args) && !is.list(args)) {
            stop("'args' must be a character vector or named list",
                 call. = FALSE)
        } else {
            has_args <- TRUE
        }
    }

    alg <- new(GDALAlg, cmd, args)

    if (has_args && parse) {
        if (!alg$parseCommandLineArgs()) {
            alg$release()
            stop("failed to parse arguments and set their values",
                 call. = FALSE)
        }
    }

    return(alg)
}

#' @name gdal_cli
#' @export
gdal_global_reg_names <- function() {
    return(.gdal_global_reg_names())
}

# helper function to print usage to the console
# called from GDALAlg::usage() in src/gdalalg.cpp
#' @noRd
#' @export
.print_alg_usage <- function(cmd) {
    alg <- new(GDALAlg, cmd)
    alginfo <- alg$info()

    has_non_positionals <- FALSE
    positional_args <- character()
    for (nm in alginfo$arg_names) {
        arginfo <- alg$argInfo(nm)
        if (gdal_version_num() < gdal_compute_version(3, 12, 0)) {
            # GDAL < 3.12 use `is_only_for_cli`
            if (!arginfo$is_only_for_cli && !arginfo$is_positional) {
                has_non_positionals <- TRUE
            } else if (!arginfo$is_only_for_cli && arginfo$is_positional) {
                positional_args <- append(positional_args, nm)
            }
        } else {
            # GDAL >= 3.12 use `is_hidden_for_api` instead
            if (!arginfo$is_hidden_for_api && !arginfo$is_positional) {
                has_non_positionals <- TRUE
            } else if (!arginfo$is_hidden_for_api && arginfo$is_positional) {
                positional_args <- append(positional_args, nm)
            }
        }
    }

    cli::cat_line()
    cat(cli::format_inline("{.strong Usage}: "), cmd, sep = "")

    if (alginfo$has_subalgorithms) {
        cat(" <SUBCOMMAND>")
        if (has_non_positionals) {
            cat(" [OPTIONS]")
        }
        cat("\nwhere <SUBCOMMAND> is one of:\n")

        max_name_len <- 0
        for (nm in alginfo$subalgorithm_names) {
            if (nchar(nm) > max_name_len)
                max_name_len <- nchar(nm)
        }
        for (nm in alginfo$subalgorithm_names) {
            num_add_spaces <- max_name_len - nchar(nm)
            cat("  - ", nm, rep_len(" ", num_add_spaces + 1), sep = "")
            cat(": ")
            sub_alg <- new(GDALAlg, c(cmd, nm))
            cat(sub_alg$info()$description)
            cat("\n")
            sub_alg$release()
        }
        cat("\n")
    } else {
        if (length(alginfo$arg_names) > 0) {
            if (has_non_positionals && alginfo$name != "pipeline") {
                cat(" [OPTIONS]")
            }
            for (arg_nm in positional_args) {
                arginfo <- alg$argInfo(arg_nm)
                optional <- (!arginfo$is_required &&
                                !(alginfo$name == "pipeline" &&
                                  arginfo$name == "pipeline"))

                cat(" ")
                if (optional)
                    cat("[")
                if (arginfo$meta_var != "") {
                    if (startsWith(arginfo$meta_var, "<")) {
                        cat(arginfo$meta_var)
                    } else {
                        cat("<", arginfo$meta_var, ">", sep = "")
                    }
                }
                if (arginfo$type == "DATASET_LIST" && arginfo$max_count > 1)
                    cat("...")
                if (optional)
                    cat("]")
            }
        }

        cat("\n\n")
        cat(alginfo$description, "\n\n")
    }

    print_arg <- function(arg_name) {
        this_arg <- alg$argInfo(arg_name)

        cat("  ")
        if (this_arg$short_name != "")
            cat("-", this_arg$short_name, ", ", sep = "")
        if (length(this_arg$aliases) > 0) {
            for (nm in this_arg$aliases) {
                if (nchar(nm) == 1) {
                    cat("-", nm, ", ", sep = "")
                } else {
                    cat("--", nm, ", ", sep = "")
                }
            }
        }
        if (this_arg$name != "")
            cat("--", this_arg$name, sep = "")
        if (this_arg$meta_var != "") {
            cat(" ")
            if (startsWith(this_arg$meta_var, "<")) {
                cat(this_arg$meta_var)
            } else {
                cat("<", this_arg$meta_var, ">", sep = "")
            }
        }
        cat("\n")

        cat("    ")
        cat(this_arg$description)
        cat("\n")

        if (length(this_arg$choices)) {
            cat("    ")
            cat("[", paste(this_arg$choices, collapse = "|"), "]", sep = "")
            cat("\n")
        }

        if (this_arg$type == "DATASET" || this_arg$type == "DATASET_LIST") {
            if (all(this_arg$dataset_input_flags == "NAME") &&
                    all(this_arg$dataset_output_flags == "OBJECT")) {

                cat("    [created by algorithm]\n")
            }
        }

        if (this_arg$has_default_value) {
            cat("    [default: ")
            cat(paste(this_arg$default_value, collapse = ", "))
            cat("]\n")
        }

        if (endsWith(this_arg$type, "LIST")) {
            if (this_arg$min_count > 0 &&
                this_arg$min_count == this_arg$max_count) {

                if (this_arg$min_count != 1)
                    cat("    [", this_arg$max_count, " values]\n", sep = "")

            } else if (this_arg$min_count >= 0 &&
                       this_arg$max_count < .Machine$integer.max) {

                cat("    [", this_arg$min_count, "..", this_arg$max_count,
                    " values]\n", sep = "")

            } else if (this_arg$min_count >= 0) {
                cat("    [", this_arg$min_count, " or more values]\n", sep = "")
            }

            if (this_arg$max_count > 1) {
                if (this_arg$packed_values_allowed &&
                    this_arg$repeated_arg_allowed) {
                    cat("    [packed values allowed, repeated arg allowed]")
                } else if (!this_arg$packed_values_allowed &&
                           this_arg$repeated_arg_allowed) {
                    cat("    [packed values not allowed, repeated arg allowed]")
                } else if (this_arg$packed_values_allowed &&
                           !this_arg$repeated_arg_allowed) {
                    cat("    [packed values allowed, repeated arg not allowed]")
                }
                cat("\n")
            }
        }

        if (this_arg$is_required) {
            cat("    [", cli::format_inline("{.emph required}"), "]\n",
                sep = "")
        }

        if (nzchar(this_arg$mutual_exclusion_group)) {
            other_args <- character()
            for (nm in alginfo$arg_names) {
                other_arg <- alg$argInfo(nm)
                if (gdal_version_num() < gdal_compute_version(3, 12, 0)) {
                    # GDAL < 3.12 use `is_only_for_cli`
                    if (other_arg$is_only_for_cli || this_arg$name == nm)
                        next
                } else {
                    # GDAL >= 3.12 use `is_hidden_for_api` instead
                    if (other_arg$is_hidden_for_api || this_arg$name == nm)
                        next
                }
                if (other_arg$mutual_exclusion_group ==
                        this_arg$mutual_exclusion_group) {

                    other_args <- append(other_args,
                                         paste0("--", other_arg$name))
                }
            }
            if (length(other_args) > 0) {
                cat("    [mutually exclusive with ")
                cat(paste(other_args, collapse = ", "))
                cat("]\n")
            }
        }
    }

    if (length(positional_args) > 0) {
        cat("Positional arguments:\n")
        for (arg_nm in positional_args) {
            print_arg(arg_nm)
        }
        cat("\n")
    }

    if (alginfo$name == "pipeline") {
        cat("<PIPELINE> is of the form: ")
        if (isTRUE(grepl("vector", cmd, ignore.case = TRUE)))
            str_out <- "read|concat [READ-OPTIONS] ( ! <STEP-NAME> [STEP-OPTIONS] )* ! write [WRITE-OPTIONS]\n"
        else
            str_out <- "read [READ-OPTIONS] ( ! <STEP-NAME> [STEP-OPTIONS] )* ! write [WRITE-OPTIONS]\n"

        cat(str_out)
        cat("\n")
    }

    # non-positional args by category
    common_args <- character()
    base_args <- character()
    advanced_args <- character()
    esoteric_args <- character()
    for (nm in alginfo$arg_names) {
        arginfo <- alg$argInfo(nm)
        if ((isTRUE(!as.logical(arginfo$is_only_for_cli)) ||  # GDAL < 3.12
            isTRUE(!as.logical(arginfo$is_hidden_for_api)))  # GDAL >= 3.12
                && !arginfo$is_positional) {

            if (tolower(arginfo$category) == "common")
                common_args <- append(common_args, nm)
            else if (tolower(arginfo$category) == "base")
                base_args <- append(base_args, nm)
            else if (tolower(arginfo$category) == "advanced")
                advanced_args <- append(advanced_args, nm)
            else if (tolower(arginfo$category) == "esoteric")
                esoteric_args <- append(esoteric_args, nm)
        }
    }

    if (length(common_args) > 0) {
        cat("Common options:\n")
        for (arg_nm in common_args) {
            print_arg(arg_nm)
        }
        cat("\n")
    }

    if (length(base_args) > 0) {
        if (alginfo$name == "pipeline")
            cat("Options for read input/write output:\n")
        else
            cat("Options:\n")

        for (arg_nm in base_args) {
            print_arg(arg_nm)
        }
        cat("\n")
    }

    if (length(advanced_args) > 0) {
        if (alginfo$name == "pipeline")
            cat("Advanced options for read input/write output:\n")
        else
            cat("Advanced options:\n")

        for (arg_nm in advanced_args) {
            print_arg(arg_nm)
        }
        cat("\n")
    }

    if (length(esoteric_args) > 0) {
        if (alginfo$name == "pipeline")
            cat("Esoteric options for read input/write output:\n")
        else
            cat("Esoteric options:\n")

        for (arg_nm in esoteric_args) {
            print_arg(arg_nm)
        }
        cat("\n")
    }

    if (alginfo$name == "pipeline") {
        # workaround for non-standard Infinity value in GDAL JSON
        x <- gsub("Infinity", '"Infinity"', alg$usageAsJSON(), fixed = TRUE) |>
            yyjsonr::read_json_str()

        if (!is.null(x$pipeline_algorithms) &&
            is.data.frame(x$pipeline_algorithms) &&
            nrow(x$pipeline_algorithms) > 0) {

            cat("Potential steps are:\n")
            for (i in seq_len(nrow(x$pipeline_algorithms))) {
                if (x$pipeline_algorithms[i, "name"] != "read" &&
                    x$pipeline_algorithms[i, "name"] != "write") {

                cat("  ", x$pipeline_algorithms[i, "name"], "\n    ",
                    x$pipeline_algorithms[i, "description"], "\n", sep = "")
                }
            }
            cat("\n")
        } else {
            cat("See `gdal_usage(\"raster pipeline\")` or `gdal_usage(\"vector pipeline\")`\n")
            cat("\n")
        }
    } else if (alginfo$long_description != "") {
        cat(alginfo$long_description, "\n", sep = "")
        cat("\n")
    }

    if (alginfo$URL != "") {
        cat("For more details: ", cli::format_inline("{.url {alginfo$URL}}"),
            "\n", sep = "")
    }

    alg$release()
}

# skip on CRAN while dev status of CLI bindings is "experimental"
skip_on_cran()
skip_if(gdal_version_num() < gdal_compute_version(3, 11, 3))

test_that("gdal_commands works", {
    expect_output(cmds <- gdal_commands())
    expect_true(is.data.frame(cmds))
    expect_true(nrow(cmds) > 10)
    expect_equal(colnames(cmds), c("command", "description", "URL"))

    expect_invisible(gdal_commands("raster info", cout = FALSE))
    expect_silent(cmds <- gdal_commands("raster info", cout = FALSE))
    expect_true(is.data.frame(cmds))
    expect_equal(nrow(cmds), 1)

    expect_no_error(cmds <- gdal_commands(recurse = FALSE, cout = FALSE))
    expect_equal(nrow(cmds[cmds$command_string == "raster info", ]), 0)

    expect_no_error(gdal_commands(NULL))
    expect_no_error(gdal_commands(c("raster", "info")))
    expect_error(gdal_commands(0))
    expect_error(gdal_commands(recurse = "invalid"))
    expect_error(gdal_commands(cout = "invalid"))
})

test_that("gdal_run works", {
    ## raster output
    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
    f_out = file.path(tempdir(), "ynp_fire_year.tif")
    on.exit(deleteDataset(f_out), add = TRUE)

    args <- list()
    args$input <- f
    args$sql <- "SELECT * FROM mtbs_perims ORDER BY mtbs_perims.ig_year"
    args$attribute_name <- "ig_year"
    args$output <- f_out
    args$overwrite <- TRUE
    args$creation_option <- c("TILED=YES", "COMPRESS=DEFLATE")
    args$resolution <- c(90, 90)
    args$output_data_type <- "Int16"
    args$init <- -32767
    args$nodata <- -32767

    expect_no_error(alg <- gdal_run("vector rasterize", args))

    ds <- alg$output()
    expect_true(is(ds, "Rcpp_GDALRaster"))
    expect_equal(ds$res(), c(90, 90))
    expect_equal(ds$getDataTypeName(band = 1), "Int16")
    expect_equal(ds$getNoDataValue(band = 1), -32767)

    ds$close()
    expect_true(alg$close())
    alg$release()

    # with close
    deleteDataset(f_out)

    expect_no_error(
        gdal_run("vector rasterize", args, close = TRUE, quiet = TRUE))

    expect_true(vsi_stat_size(f_out) > 0)
    expect_no_error(ds <- GDALRaster$new(f_out))
    expect_equal(ds$res(), c(90, 90))
    expect_equal(ds$getDataTypeName(band = 1), "Int16")
    expect_equal(ds$getNoDataValue(band = 1), -32767)

    ds$close()

    ## vector output
    f_shp <- system.file("extdata/poly_multipoly.shp", package="gdalraster")
    f_gpkg <- file.path(tempdir(), "polygons_test.gpkg")
    on.exit(deleteDataset(f_gpkg), add = TRUE)

    args <- c("--input", f_shp, "--output", f_gpkg, "--overwrite")

    expect_no_error(alg <- gdal_run("vector convert", args))

    lyr <- alg$output()
    expect_true(is(lyr, "Rcpp_GDALVector"))
    expect_equal(lyr$getDriverShortName(), "GPKG")

    lyr$close()
    expect_true(alg$close())
    alg$release()

    # errors
    expect_error(gdal_run(NULL))
    expect_error(gdal_run(0))
    expect_error(gdal_run("raster info"))  # no args so alg$run() fails
    expect_error(gdal_run("raster info", 0))
    expect_error(gdal_run("raster info", "--invalid=0"))  # parse fails
    # invalid input for setVectorArgsFromObject:
    args <- c("--input", f_shp, "--output", f_gpkg, "--overwrite")
    expect_error(gdal_run("vector convert", args, "invalid"))

})

test_that("gdal_run_piped works", {
    # "size" is passed to "raster resize" here since the "resolution" argument
    # was added later in GDAL 3.12, so this test will work with GDAL >= 3.11.
    # This will generate an output raster with _roughly_ 90-m pixel resolution.
    ds_mem <- system.file("extdata/storml_elev.tif", package="gdalraster") |>
        gdal_run_piped("raster resize", "", "MEM", list(
            size = c(48, 36), resampling = "bilinear")
        ) |>
        gdal_run_piped("raster tpi", "", "MEM")

    expect_true(is(ds_mem, "Rcpp_GDALRaster"))
    expect_equal(ds_mem$dim(), c(48, 36, 1))
    expect_true(all(ds_mem$res() >= 89))
    ds_mem$close()

    f_zip <- system.file("extdata/ynp_features.zip", package = "gdalraster")

    # output_index
    out_str <- file.path("/vsizip", f_zip, "ynp_features.gpkg") |>
	    gdal_run_piped("vector info", output_format = "text",
                       other_args = list(layer = "ynp_bnd"),
                       output_index = "output_string")

    expect_true(is.character(out_str))
    expect_true(grepl("Layer name: ynp_bnd", out_str, ignore.case = TRUE))

    # input validation error: output_index < 1
    out_str <- ""
    expect_error(
        out_str <- file.path("/vsizip", f_zip, "ynp_features.gpkg") |>
            gdal_run_piped("vector info", output_format = "text",
                           other_args = list(layer = "ynp_bnd"),
                           output_index = 0)
    )

    # output_index > the number of outputs
    out_str <- ""
    expect_no_error(
        out_str <- file.path("/vsizip", f_zip, "ynp_features.gpkg") |>
            gdal_run_piped("vector info", output_format = "text",
                           other_args = list(layer = "ynp_bnd"),
                           output_index = 2)
    )
    expect_false(out_str)

    # output_index not a valid list element name
    out_str <- ""
    expect_no_error(
        out_str <- file.path("/vsizip", f_zip, "ynp_features.gpkg") |>
            gdal_run_piped("vector info", output_format = "text",
                           other_args = list(layer = "ynp_bnd"),
                           output_index = "invalid")
    )
    expect_false(out_str)

    # outputLayerNameForOpen
    lyr_mem <- file.path("/vsizip", f_zip, "ynp_features.gpkg") |>
        gdal_run_piped("vector reproject", "", "MEM", c("-d", "EPSG:5070"),
            outputLayerNameForOpen = "points_of_interest")

    expect_true(is(lyr_mem, "Rcpp_GDALVector"))
    expect_equal(lyr_mem$getName(), "points_of_interest")
    expect_equal(lyr_mem$getFeatureCount(), 1399)
    lyr_mem$close()
})

test_that("gdal_alg works", {
    expect_no_error(alg <- gdal_alg())
    expect_true(is(alg, "Rcpp_GDALAlg"))
    expect_equal(alg$info()$name, "gdal")
    alg$release()

    expect_no_error(alg <- gdal_alg("raster"))
    expect_true(is(alg, "Rcpp_GDALAlg"))
    alg$release()

    expect_no_error(alg <- gdal_alg("vector"))
    expect_true(is(alg, "Rcpp_GDALAlg"))
    alg$release()

    f <- system.file("extdata/storml_elev.tif", package="gdalraster")

    # character vector args
    args <- c("--format=text", f)
    expect_no_error(alg <- gdal_alg("raster info", args))
    expect_error(alg$output())
    expect_true(alg$run())
    expect_true(nchar(alg$output()) > 1000)
    alg$release()

    # parse = FALSE
    args <- c("--format=text", f)
    expect_no_error(alg <- gdal_alg("raster info", args, FALSE))
    expect_error(alg$output())
    expect_true(alg$parseCommandLineArgs())
    expect_true(alg$run())
    expect_true(nchar(alg$output()) > 1000)
    alg$release()

    # list args
    args <- list()
    args$input <- f
    args$output_format <- "text"
    expect_no_error(alg <- gdal_alg("raster info", args))
    expect_true(alg$run())
    expect_true(nchar(alg$output()) > 1000)
    alg$release()

    # input as object
    ds <- new(GDALRaster, f)
    args <- list()
    args$input <- ds
    args$output_format <- "text"
    expect_no_error(alg <- gdal_alg("raster info", args))
    expect_true(alg$run())
    expect_true(nchar(alg$output()) > 1000)
    expect_true(alg$close())
    alg$release()

    # errors
    expect_error(gdal_alg(0))
    expect_error(gdal_alg("raster info", FALSE))
    expect_error(gdal_alg("raster info", args, parse = "invalid"))
    args$invalid <- "invalid arg name"
    expect_error(gdal_alg("raster info", args))

    ds$close()
})

test_that("gdal_usage works", {
    cmd <- "raster reproject"
    expect_output(gdal_usage(cmd), "Usage:")
    expect_output(gdal_usage(cmd), "Positional arguments:")
    expect_output(gdal_usage(cmd), "Options:")
    expect_output(gdal_usage(cmd), "Advanced options:")
    expect_output(gdal_usage(cmd), "For more details:")

    expect_no_error(gdal_usage("pipeline"))
})

test_that("gdal_global_reg_names returns a character vector", {
    expect_vector(gdal_global_reg_names(), character())
})

test_that("raster pipeline works", {
    ## test raster pipeline algorithms
    skip_if(gdal_version_num() < gdal_compute_version(3, 12, 1))

    ## with a nested input pipeline
    f <- system.file("extdata/storml_elev.tif", package="gdalraster")
    f_elev <- tempfile(fileext = ".tif")
    file.copy(f, f_elev)
    on.exit(deleteDataset(f_elev), add = TRUE)
    f_pal <- system.file("extdata/storml_elev_pal.txt", package="gdalraster")
    f_out <- file.path(tempdir(), "storml_col_relief.tif")
    on.exit(deleteDataset(f_out), add = TRUE)

    args <- paste(
        "read --input", f_elev,
        "! color-map --color-map", f_pal,
        "! blend --overlay [ read --input", f_elev, "! hillshade -z 1.5 ]",
            "--operator=hsv-value",
        "! write --output", f_out, "--overwrite")

    expect_no_error(alg <- gdal_run("raster pipeline", args))
    expect_true(is.list(alg$outputs()))
    ds <- alg$outputs()$output
    expect_true(is(ds, "Rcpp_GDALRaster"))
    expect_equal(ds$res(), c(30, 30))
    expect_equal(ds$dim(), c(143, 107, 3))

    ds$close()
    expect_true(alg$close())
    alg$release()
})

# Public R wrappers for the internal functions defined in src/transform.h
# Chris Toney <chris.toney at usda.gov>

#' Transform geospatial x/y coordinates
#'
#' `transform_xy()` transforms geospatial x, y coordinates to a new
#' projection. The input points may optionally have z vertices (x, y, z) or
#' time values (x, y, z, t).
#' Wrapper for `OGRCoordinateTransformation::Transform()` in the GDAL Spatial
#' Reference System C++ API.
#'
#' @param pts A data frame or numeric matrix containing geospatial point
#' coordinates, or point geometries as a list of WKB raw vectors or character
#' vector of WKT strings. If data frame or matrix, the number of columns must
#' be either two (x, y), three (x, y, z) or four (x, y, z, t).
#' May be also be given as a numeric vector for one point (xy, xyz, or xyzt).
#' @param srs_from Character string specifying the spatial reference system
#' for `pts`. May be in WKT format or any of the formats supported by
#' [srs_to_wkt()].
#' @param srs_to Character string specifying the output spatial reference
#' system. May be in WKT format or any of the formats supported by
#' [srs_to_wkt()].
#' @returns Numeric matrix of geospatial (x, y) coordinates in the projection
#' specified by `srs_to` (potentially also with z, or z and t columns).
#'
#' @note
#' `transform_xy()` uses traditional GIS order for the input and output xy
#' (i.e., longitude/latitude ordered for geographic coordinates).
#'
#' Input points that contain missing values (`NA`) will be assigned `NA` in
#' the output and a warning emitted. Input points that fail to transform
#' with the GDAL API call will also be assigned `NA` in the output with a
#' specific warning indicating that case.
#'
#' @seealso
#' [srs_to_wkt()], [inv_project()]
#' @examples
#' pt_file <- system.file("extdata/storml_pts.csv", package="gdalraster")
#' pts <- read.csv(pt_file)
#' print(pts)
#' # id, x, y in NAD83 / UTM zone 12N
#' # transform to NAD83 / CONUS Albers
#' transform_xy(pts = pts[, -1], srs_from = "EPSG:26912", srs_to = "EPSG:5070")
#' @export
transform_xy <- function(pts, srs_from, srs_to) {
    if (missing(srs_from) || is.null(srs_from))
        stop("'srs_from' is required", call. = FALSE)
    if (!is.character(srs_from) || length(srs_from) > 1)
        stop("'srs_from' must be a character string", call. = FALSE)
    if (missing(srs_to) || is.null(srs_to))
        stop("'srs_to' is required", call. = FALSE)
    if (!is.character(srs_to) || length(srs_to) > 1)
        stop("'srs_to' must be a character string", call. = FALSE)

    if (missing(pts) || is.null(pts))
        stop("'pts' is required", call. = FALSE)

    pts_in <- NULL
    if (is.raw(pts) || (is.list(pts) && is.raw(pts[[1]]) ||
        is.character(pts))) {

        if (is.raw(pts)) {
            geom_type <- g_name(pts)
        } else {
            geom_type <- g_name(pts[[1]])
        }
        if (toupper(geom_type) != "POINT")
            stop("'pts' does not contain POINT geometry type", call. = FALSE)

        coords <- g_coords(pts)
        if (!is.null(coords$m)) {
            pts_in <- coords[, c("x", "y", "z", "m")]
        } else if (!is.null(coords$z)) {
            pts_in <- coords[, c("x", "y", "z")]
        } else {
            pts_in <- coords[, c("x", "y")]
        }
    } else if (is.data.frame(pts) || is.matrix(pts) || is.vector(pts)) {
        pts_in <- pts
    } else {
        stop("'pts' is not a valid input type", call. = FALSE)
    }

    return(.transform_xy(pts_in, srs_from, srs_to))
}

#' Inverse project geospatial x/y coordinates to longitude/latitude
#'
#' `inv_project()` transforms geospatial x/y coordinates to
#' longitude/latitude in the same geographic coordinate system used by the
#' given projected spatial reference system. The output long/lat can
#' optionally be set to a specific geographic coordinate system by specifying
#' a well known name (see Details).
#'
#' @details
#' By default, the geographic coordinate system of the projection specified
#' by `srs` will be used. If a specific geographic coordinate system is
#' desired, then `well_known_gcs` can be set to one of the values below:
#' \tabular{rl}{
#'  EPSG:n \tab where n is the code of a geographic coordinate system\cr
#'  WGS84  \tab same as EPSG:4326\cr
#'  WGS72  \tab same as EPSG:4322\cr
#'  NAD83  \tab same as EPSG:4269\cr
#'  NAD27  \tab same as EPSG:4267\cr
#'  CRS84  \tab same as WGS84\cr
#'  CRS72  \tab same as WGS72\cr
#'  CRS27  \tab same as NAD27
#' }
#' The coordinates returned by `inv_project()`will always be in longitude,
#' latitude order (traditional GIS order) regardless of the axis order defined
#' for the GCS names above.
#'
#' @param pts A data frame or numeric matrix containing geospatial point
#' coordinates, or point geometries as a list of WKB raw vectors or character
#' vector of WKT strings. If data frame or matrix, the number of columns must
#' be either two (x, y), three (x, y, z) or four (x, y, z, t).
#' May be also be given as a numeric vector for one point (xy, xyz, or xyzt).
#' @param srs Character string specifying the projected spatial reference
#' system for `pts`. May be in WKT format or any of the formats supported by
#' [srs_to_wkt()].
#' @param well_known_gcs Optional character string containing a supported
#' well known name of a geographic coordinate system (see Details for
#' supported values).
#' @returns Numeric matrix of longitude, latitude (potentially also with z,
#' or z and t columns).
#'
#' @note
#' Input points that contain missing values (`NA`) will be assigned `NA` in
#' the output and a warning emitted. Input points that fail to transform
#' with the GDAL API call will also be assigned `NA` in the output with a
#' specific warning indicating that case.
#'
#' @seealso
#' [transform_xy()]
#' @examples
#' pt_file <- system.file("extdata/storml_pts.csv", package="gdalraster")
#' # id, x, y in NAD83 / UTM zone 12N
#' pts <- read.csv(pt_file)
#' print(pts)
#' inv_project(pts[,-1], "EPSG:26912")
#' @export
inv_project <- function(pts, srs, well_known_gcs = NULL) {
    if (missing(srs) || is.null(srs))
        stop("'srs' is required", call. = FALSE)
    if (!is.character(srs) || length(srs) > 1)
        stop("'srs' must be a character string", call. = FALSE)

    if (missing(well_known_gcs) || is.null(well_known_gcs))
        well_known_gcs <- ""
    if (!is.character(well_known_gcs) || length(well_known_gcs) > 1)
        stop("'well_known_gcs' must be a character string", call. = FALSE)

    pts_in <- NULL
    if (is.raw(pts) || (is.list(pts) && is.raw(pts[[1]]) ||
        is.character(pts))) {

        if (is.raw(pts)) {
            geom_type <- g_name(pts)
        } else {
            geom_type <- g_name(pts[[1]])
        }
        if (toupper(geom_type) != "POINT")
            stop("'pts' does not contain POINT geometry type", call. = FALSE)

        coords <- g_coords(pts)
        if (!is.null(coords$m)) {
            pts_in <- coords[, c("x", "y", "z", "m")]
        } else if (!is.null(coords$z)) {
            pts_in <- coords[, c("x", "y", "z")]
        } else {
            pts_in <- coords[, c("x", "y")]
        }
    } else if (is.data.frame(pts) || is.matrix(pts) || is.vector(pts)) {
        pts_in <- pts
    } else {
        stop("'pts' is not a valid input type", call. = FALSE)
    }

    return(.inv_project(pts_in, srs, well_known_gcs))
}

# Convenience function for using the reprojection capability of ogr2ogr().
# Supports basic reprojection capabilities applied to one input layer.
# `add_cl_arg` allows also passing additional command-line arguments for
# access to more advanced geometry and SRS related options of ogr2ogr.
# Chris Toney <chris.toney at usda.gov>

#' Reproject a vector layer
#'
#' @description
#' `ogr_reproject()` reprojects the features of a vector layer to a different
#' spatial reference system and writes the new layer to a specified output
#' dataset. The output may be in a different vector file format than the input
#' dataset. A source SRS definition must be available in the source layer
#' for reprojection to occur.
#'
#' @details
#' `ogr_reproject()` is a convenience wrapper to perform vector reprojection
#' via `ogr2ogr()`, which in turn is an API binding to GDAL's `ogr2ogr`
#' command-line utility.
#'
#' @param src_dsn Character string. The filename or database connection string
#' specifying the vector data source containing the input layer.
#' @param src_layer Character string. The name of the input layer in `src_dsn`
#' to reproject. Optionally can be given as an SQL SELECT statement to be
#' executed against `src_dsn`, defining the source layer as the result set.
#' May also be given as empty string (`""`), in which case the first layer by
#' index will be used (mainly useful for single-layer file formats such as
#' ESRI Shapefile).
#' @param out_dsn Character string. The filename or database connection string
#' specifying the vector data source to which the output layer will be written.
#' @param out_srs Character string specifying the output spatial reference
#' system. May be in WKT format or any of the formats supported by
#' [srs_to_wkt()].
#' @param out_fmt Optional character string giving the GDAL short name
#' of the output dataset format. Only used if `out_dsn` needs to be created.
#' Generally can be `NULL` in which case the format will be guessed from the
#' file extension.
#' @param overwrite Logical value. `TRUE` to overwrite the output layer if it
#' already exists. Defaults to `FALSE`.
#' @param append Logical value. `TRUE` to append to the output layer if it
#' already exists. Defaults to `FALSE`.
#' @param nln Optional character string giving an alternate name to assign the
#' new layer. By default, `src_layer` is used, but `nln` is required if
#' `src_layer`is a SQL SELECT statement.
#' @param nlt Optional character string to define the geometry type for the
#' output layer. Mainly useful when `nlt = PROMOTE_TO_MULTI` might be given to
#' automatically promote layers that mix polygon / multipolygons to
#' multipolygons, and layers that mix linestrings / multilinestrings to
#' multilinestrings. Can be useful when converting shapefiles to PostGIS and
#' other output formats that implement strict checks for geometry types.
#' @param dsco Optional character vector of format-specific creation options
#' for `out_dsn` (`"NAME=VALUE"` pairs). Should only be used if `out_dsn` does
#' not already exist.
#' @param lco Optional character vector of format-specific creation options
#' for the output layer (`"NAME=VALUE"` pairs). Should not be used if appending
#' to an existing layer.
#' @param dialect Optional character string specifying the SQL dialect to use.
#' The OGR SQL engine (`"OGRSQL"`) will be used by default if a value is not
#' given. The `"SQLite"` dialect can also be use. Only relevant if `src_layer`
#' is given as a SQL SELECT statement.
#' @param spat_bbox Optional numeric vector of length four specifying a spatial
#' bounding box (xmin, ymin, xmax, ymax), *in the SRS of the source layer*.
#' Only features whose geometry intersects `spat_bbox` will be selected for
#' reprojection.
#' @param src_open_options Optional character vector of dataset open options
#' for `src_dsn` (format-specific `"NAME=VALUE"` pairs).
#' @param progress Logical value, `TRUE` to display progress on the terminal.
#' Defaults to `FALSE`. Only works if the input layer has "fast feature count"
#' capability.
#' @param add_cl_arg Optional character vector of additional command-line
#' arguments to be passed to `ogr2ogr()` (see Note).
#' @param return_obj Logical value, `TRUE` to return an object of class
#' [`GDALVector`][GDALVector] open on the output layer (the default).
#' @return
#' Upon successful completion, an object of class [`GDALVector`][GDALVector] is
#' returned by default (if `return_obj = TRUE`), or logical `TRUE` is returned
#' (invisibly) if `return_obj = FALSE`. An error is raised if reprojection
#' fails.
#'
#' @note
#' For advanced use, additional command-line arguments may be passed to
#' `ogr2ogr()` in `add_cl_arg` (e.g., advanced geometry and SRS related
#' options). Users should be aware of possible implications and
#' compatibility with the arguments already implied by the parameterization
#' of `ogr_reproject()`.
#'
#' The function will attempt to create the output datasource if it does not
#' already exist. Some formats (e.g., PostgreSQL) do not support creation of
#' new datasets (i.e., a database within PostgreSQL), but output layers can be
#' written to an existing database.
#'
#' @seealso
#' [ogr2ogr()]
#'
#' GDAL documentation for `ogr2ogr`:\cr
#' \url{https://gdal.org/en/stable/programs/ogr2ogr.html}
#'
#' [warp()] for raster reprojection
#'
#' @examples
#' # for GDAL < 3.11.4 (see https://github.com/OSGeo/gdal/issues/12934)
#' save_opt <- get_config_option("OGR2OGR_USE_ARROW_API")
#' set_config_option("OGR2OGR_USE_ARROW_API", "NO")
#'
#' # MTBS fire perimeters
#' f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
#' (mtbs <- new(GDALVector, f, "mtbs_perims"))
#'
#' mtbs$getSpatialRef() |> srs_is_projected()  # TRUE
#'
#' # YNP boundary
#' f <- system.file("extdata/ynp_features.zip", package = "gdalraster")
#' unzip(f, files = "ynp_features.gpkg", exdir = tempdir())
#' ynp_dsn <- file.path(tempdir(), "ynp_features.gpkg")
#'
#' (bnd <- new(GDALVector, ynp_dsn, "ynp_bnd"))
#'
#' bnd$getSpatialRef() |> srs_is_projected()  # FALSE
#'
#' # project the boundary to match the MTBS layer
#' out_dsn <- tempfile(fileext = ".gpkg")
#' (bnd_mtsp <- ogr_reproject(ynp_dsn, "ynp_bnd", out_dsn, mtbs$getSpatialRef()))
#'
#' bnd_mtsp$getFeatureCount()
#'
#' plot(bnd_mtsp$getNextFeature(), col = "wheat")
#'
#' mtbs$setAttributeFilter("incid_name = 'MAPLE'")
#' mtbs$getFeatureCount()  # 1
#'
#' (feat <- mtbs$getNextFeature())
#'
#' plot(feat, col = "red", border = NA, add = TRUE)
#'
#' mtbs$close()
#' bnd$close()
#' bnd_mtsp$close()
#'
#' # reset config option to original
#' set_config_option("OGR2OGR_USE_ARROW_API", save_opt)
#' \dontshow{unlink(out_dsn)}
#' \dontshow{unlink(ynp_dsn)}
#' \dontshow{set_config_option("OGR2OGR_USE_ARROW_API", "")}
#' @export
ogr_reproject <- function(src_dsn, src_layer, out_dsn, out_srs,
                          out_fmt = NULL, overwrite = FALSE,
                          append = FALSE, nln = NULL, nlt = NULL,
                          dsco = NULL, lco = NULL,
                          dialect = NULL, spat_bbox = NULL,
                          src_open_options = NULL, progress = FALSE,
                          add_cl_arg = NULL, return_obj = TRUE) {

    if (!(is.character(src_dsn) && length(src_dsn) == 1))
        stop("'src_dsn' must be a length-1 character vector", call. = FALSE)
    if (!(is.character(src_layer) && length(src_layer) == 1))
        stop("'src_layer' must be a length-1 character vector", call. = FALSE)
    if (!(is.character(out_dsn) && length(out_dsn) == 1))
        stop("'out_dsn' must be a length-1 character vector", call. = FALSE)
    if (!(is.character(out_srs) && length(out_srs) == 1))
        stop("'out_srs' must be a length-1 character vector", call. = FALSE)
    if (!is.null(out_fmt)) {
        if (!(is.character(out_fmt) && length(out_fmt) == 1)) {
            stop("'out_fmt' must be a length-1 character vector",
                 call. = FALSE)
        }
    }
    if (!(is.logical(overwrite) && length(overwrite) == 1))
        stop("'overwrite' must be a single logical value", call. = FALSE)
    if (!(is.logical(append) && length(append) == 1))
        stop("'append' must be a single logical value", call. = FALSE)
    if (!is.null(nln)) {
        if (!(is.character(nln) && length(nln) == 1))
            stop("'nln' must be a length-1 character vector", call. = FALSE)
    }
    if (!is.null(nlt)) {
        if (!(is.character(nlt) && length(nlt) == 1))
            stop("'nlt' must be a length-1 character vector", call. = FALSE)
    }
    if (!is.null(dsco)) {
        if (!is.character(dsco))
            stop("'dsco' must be a character vector", call. = FALSE)
    }
    if (!is.null(lco)) {
        if (!is.character(lco))
            stop("'lco' must be a character vector", call. = FALSE)
    }
    if (!is.null(dialect)) {
        if (!(is.character(dialect) && length(dialect) == 1)) {
            stop("'dialect' must be a length-1 character vector",
                 call. = FALSE)
        }
    }
    if (!is.null(spat_bbox)) {
        if (!(is.numeric(spat_bbox) && length(spat_bbox) == 4)) {
            stop("'spat_bbox' must be a numeric vector of length 4",
                 call. = FALSE)
        }
    }
    if (!is.null(src_open_options)) {
        if (!is.character(src_open_options)) {
            stop("'src_open_options' must be a character vector",
                 call. = FALSE)
        }
    }
    if (!(is.logical(progress) && length(progress) == 1))
        stop("'progress' must be a single logical value", call. = FALSE)
    if (!is.null(add_cl_arg)) {
        if (!is.character(add_cl_arg)) {
            stop("'add_cl_arg' must be a character vector",
                 call. = FALSE)
        }
    }

    out_layer_name <- src_layer

    # special case for shapefile
    chk_fmt <- .getOGRformat(out_dsn)
    if (!is.null(chk_fmt)) {
        if (chk_fmt == "ESRI Shapefile")
            out_layer_name <- tools::file_path_sans_ext(basename(out_dsn))
    } else {
        chk_fmt <- "_unknown_"
    }

    args <- c("-t_srs", out_srs)

    if (!is.null(out_fmt))
        args <- c(args, c("-of", out_fmt))

    is_sql_layer <- FALSE
    if (toupper(substr(src_layer, 1, 7)) == "SELECT ") {
        args <- c(args, "-sql", src_layer)
        is_sql_layer <- TRUE
        if (!is.null(dialect))
            args <- c(args, c("-dialect", dialect))
    }

    if (!is.null(nln)) {
        args <- c(args, c("-nln", nln))
        out_layer_name <- nln
    } else if (chk_fmt == "ESRI Shapefile") {
        args <- c(args, c("-nln", out_layer_name))
    } else if (is_sql_layer) {
        stop("SQL layer requires the 'nln' argument for an output layer name",
             call. = FALSE)
    }

    if (!is.null(nlt))
        args <- c(args, c("-nlt", nlt))

    if (!ogr_ds_exists(out_dsn, with_update = TRUE)) {
        if (ogr_ds_exists(out_dsn) && !overwrite) {
            cli::cli_alert_danger(
                paste0("{.arg out_dsn} exists but cannot be updated. You ",
                       "may need to remove it first, or use ",
                       "{.code overwrite = TRUE}."))
            stop("cannot update the output data source", call. = FALSE)
        }
    }

    if (ogr_ds_exists(out_dsn, with_update = TRUE) && !overwrite) {
        args <- c(args, "-update")
        if (ogr_layer_exists(out_dsn, out_layer_name) && append)
            args <- c(args, "-append")
    } else if (ogr_ds_exists(out_dsn, with_update = TRUE) && overwrite) {
        args <- c(args, "-update", "-overwrite")
    }

    if (!is.null(dsco)) {
        for (opt in dsco) {
            args <- c(args, c("-dsco", opt))
        }
    }

    if (!is.null(lco)) {
        for (opt in lco) {
            args <- c(args, c("-lco", opt))
        }
    }

    if (!is.null(spat_bbox))
        args <- c(args, c("-spat", spat_bbox))

    if (progress)
        args <- c(args, "-progress")

    if (!is.null(add_cl_arg))
        args <- c(args, add_cl_arg)

    src_layers <- NULL
    if (src_layer == "") {
        ds_layers <- ogr_ds_layer_names(src_dsn)
        if (is.null(ds_layers)) {
            stop("no layers found in 'src_dsn'", call. = FALSE)
        } else {
            src_layer <- ds_layers[1]
            if (out_layer_name == "")
                out_layer_name <- src_layer
        }
    }
    if (!is_sql_layer)
        src_layers <- src_layer

    ret <- ogr2ogr(src_dsn, out_dsn, src_layers, cl_arg = args,
                   open_options = src_open_options)

    if (ret && return_obj) {
        return(new(GDALVector, out_dsn, out_layer_name))
    } else {
        return(invisible(ret))
    }
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' Helper functions for GDAL raster data types
#'
#' These are convenience functions that return information about a raster
#' data type, return the smallest data type that can fully express two input
#' data types, or find the smallest data type able to support specified
#' requirements.
#'
#' @name data_type_helpers
#'
#' @details
#' `dt_size()` returns the data type size in bytes by default, optionally in
#' bits (returns zero if `dt` is not recognized).
#'
#' `dt_is_complex()` returns `TRUE` if the passed type is complex (one of
#' CInt16, CInt32, CFloat32 or CFloat64), i.e., if it consists of a real and
#' imaginary component.
#'
#' `dt_is_integer()` returns `TRUE` if the passed type is integer (one of
#' Byte, UInt8 (GDAL >= 3.13), Int16, UInt16, Int32, UInt32, CInt16, CInt32).
#'
#' `dt_is_floating()` returns `TRUE` if the passed type is floating (one of
#' Float32, Float16, Float64, CFloat16, CFloat32, CFloat64).
#'
#' `dt_is_signed()` returns `TRUE` if the passed type is signed.
#'
#' `dt_union()` returns the smallest data type that can fully express both
#' input data types (returns a data type name as character string).
#'
#' `dt_union_with_value()` unions a data type with the data type found for a
#' given value, and returns the resulting data type name as character string.
#'
#' `dt_find()` finds the smallest data type able to support the given
#' requirements (returns a data type name as character string).
#'
#' `dt_find_for_value()` finds the smallest data type able to support the
#' given `value` (returns a data type name as character string).
#'
#' @param dt Character string containing a GDAL data type name (e.g.,
#' `"Byte"`, `"UInt8"` (GDAL >= 3.13), `"Int16"`, `"UInt16"`, `"Int32"`,
#' `"UInt32"`, `"Float32"`, `"Float64"`, etc.)
#' @param as_bytes Logical value, `TRUE` to return data type size in bytes
#' (the default), `FALSE` to return the size in bits.
#' @param dt_other Character string containing a GDAL data type name.
#' @param value Numeric value for which to find a data type (passing the real
#' part if `is_complex = TRUE`).
#' @param is_complex Logical value, `TRUE` if `value` is complex (default is
#' `FALSE`), or if complex values are necessary in `dt_find()`.
#' @param bits Integer value specifying the number of bits necessary.
#' @param is_signed Logical value, `TRUE` if negative values are necessary.
#' @param is_floating Logical value, `TRUE` if non-integer values are
#' necessary.
#'
#' @seealso
#' [`GDALRaster$getDataTypeName()`][GDALRaster]
#'
#' @examples
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' ds <- new(GDALRaster, elev_file)
#'
#' ds$getDataTypeName(band = 1) |> dt_size()
#' ds$getDataTypeName(band = 1) |> dt_size(as_bytes = FALSE)
#' ds$getDataTypeName(band = 1) |> dt_is_complex()
#' ds$getDataTypeName(band = 1) |> dt_is_integer()
#' ds$getDataTypeName(band = 1) |> dt_is_floating()
#' ds$getDataTypeName(band = 1) |> dt_is_signed()
#'
#' ds$close()
#'
#' f <- system.file("extdata/complex.tif", package="gdalraster")
#' ds <- new(GDALRaster, f)
#'
#' ds$getDataTypeName(band = 1) |> dt_size()
#' ds$getDataTypeName(band = 1) |> dt_size(as_bytes = FALSE)
#' ds$getDataTypeName(band = 1) |> dt_is_complex()
#' ds$getDataTypeName(band = 1) |> dt_is_integer()
#' ds$getDataTypeName(band = 1) |> dt_is_floating()
#' ds$getDataTypeName(band = 1) |> dt_is_signed()
#'
#' ds$close()
#'
#' dt_union("Byte", "Int16")
#' dt_union_with_value("Byte", -1)
#' dt_union_with_value("Byte", 256)
#'
#' dt_find(bits = 32, is_signed = FALSE, is_floating = FALSE)
#' dt_find_for_value(0)
#' dt_find_for_value(-1)
#' dt_find_for_value(NaN)
#' dt_find_for_value(.Machine$integer.max)
dt_size <- function(dt, as_bytes = TRUE) {
    .Call(`_gdalraster_dt_size`, dt, as_bytes)
}

#' @rdname data_type_helpers
dt_is_complex <- function(dt) {
    .Call(`_gdalraster_dt_is_complex`, dt)
}

#' @rdname data_type_helpers
dt_is_integer <- function(dt) {
    .Call(`_gdalraster_dt_is_integer`, dt)
}

#' @rdname data_type_helpers
dt_is_floating <- function(dt) {
    .Call(`_gdalraster_dt_is_floating`, dt)
}

#' @rdname data_type_helpers
dt_is_signed <- function(dt) {
    .Call(`_gdalraster_dt_is_signed`, dt)
}

#' @rdname data_type_helpers
dt_union <- function(dt, dt_other) {
    .Call(`_gdalraster_dt_union`, dt, dt_other)
}

#' @rdname data_type_helpers
dt_union_with_value <- function(dt, value, is_complex = FALSE) {
    .Call(`_gdalraster_dt_union_with_value`, dt, value, is_complex)
}

#' @rdname data_type_helpers
dt_find <- function(bits, is_signed, is_floating, is_complex = FALSE) {
    .Call(`_gdalraster_dt_find`, bits, is_signed, is_floating, is_complex)
}

#' @rdname data_type_helpers
dt_find_for_value <- function(value, is_complex = FALSE) {
    .Call(`_gdalraster_dt_find_for_value`, value, is_complex)
}

#' Get GDAL version
#'
#' `gdal_version()` returns a character vector of GDAL runtime version
#' information. `gdal_version_num()` returns only the full version number
#' (`gdal_version()[2]`) as an integer value.
#'
#' @name gdal_version
#'
#' @returns
#' `gdal_version()` returns a character vector of length four containing:
#'   * "-version" - one line version message, e.g., "GDAL 3.6.3, released
#'   2023/03/12"
#'   * "GDAL_VERSION_NUM" - formatted as a string, e.g., "3060300" for
#'   GDAL 3.6.3.0
#'   * "GDAL_RELEASE_DATE" - formatted as a string, e.g., "20230312"
#'   * "GDAL_RELEASE_NAME" - e.g., "3.6.3"
#'
#' `gdal_version_num()` returns `as.integer(gdal_version()[2])`
#' @examples
#' gdal_version()
#'
#' gdal_version_num()
gdal_version <- function() {
    .Call(`_gdalraster_gdal_version`)
}

#' @rdname gdal_version
gdal_version_num <- function() {
    .Call(`_gdalraster_gdal_version_num`)
}

#' Retrieve information on GDAL format drivers for raster and vector
#'
#' `gdal_formats()` returns a table of the supported raster and vector
#' formats, with information about the capabilities of each format driver.
#'
#' @param format A character string containing a driver short name. By default,
#' information for all configured raster and vector format drivers will be
#' returned.
#' @returns A data frame containing:
#' * the format short name
#' * file extension(s) if applicable (space-delimited string), or empty string
#' (`""`)
#' * supports raster (logical)
#' * supports multidimensional raster (logical)
#' * supports vector (logical)
#' * supports geography network (logical)
#' * read/write flags (concatenated string, `ro` is read-only, `w` supports
#' CreateCopy, `w+` supports Create, and `u` supports Update is reported if
#' GDAL >= 3.11)
#' * supports virtual I/O e.g. /vsimem/ (logical)
#' * supports subdatasets (logical)
#' * supported SQL dialects reported if GDAL >= 3.6 (e.g.,
#' `"NATIVE OGRSQL SQLITE"`)
#' * creation raster data types (e.g., `"Byte Int16 UInt16 Float32"` etc.)
#' * creation vector field types (e.g.,
#' `"Integer Integer64 Real String Date DateTime Binary"` etc.)
#' * creation field sub-types (e.g., `"Boolean Int16 Float32 JSON"` etc.)
#' * supports multiple vector layers reported if GDAL >= 3.4 (logical)
#' * supports reading field domains if GDAL >= 3.5 (logical)
#' * creation field domain types if GDAL >= 3.5 (supported values are `Coded`,
#' `Range` and `Glob`)
#'
#' @note
#' Virtual I/O refers to operations on GDAL Virtual File Systems. See
#' \url{https://gdal.org/en/stable/user/virtual_file_systems.html#virtual-file-systems}.
#'
#' @examples
#' gdal_formats() |> str()
#'
#' gdal_formats("GPKG")
gdal_formats <- function(format = "") {
    .Call(`_gdalraster_gdal_formats`, format)
}

#' Get GDAL configuration option
#'
#' `get_config_option()` gets the value of GDAL runtime configuration option.
#' Configuration options are essentially global variables the user can set.
#' They are used to alter the default behavior of certain raster format
#' drivers, and in some cases the GDAL core. For a full description and
#' listing of available options see
#' \url{https://gdal.org/en/stable/user/configoptions.html}.
#'
#' @param key Character name of a configuration option.
#' @returns Character. The value of a (key, value) option previously set with
#' `set_config_option()`. An empty string (`""`) is returned if `key` is not
#' found.
#'
#' @seealso
#' [set_config_option()]
#'
#' `vignette("gdal-config-quick-ref")`
#'
#' @examples
#' ## this option is set during initialization of the gdalraster package
#' get_config_option("OGR_CT_FORCE_TRADITIONAL_GIS_ORDER")
get_config_option <- function(key) {
    .Call(`_gdalraster_get_config_option`, key)
}

#' Set GDAL configuration option
#'
#' `set_config_option()` sets a GDAL runtime configuration option.
#' Configuration options are essentially global variables the user can set.
#' They are used to alter the default behavior of certain raster format
#' drivers, and in some cases the GDAL core. For a full description and
#' listing of available options see
#' \url{https://gdal.org/en/stable/user/configoptions.html}.
#'
#' @param key Character name of a configuration option.
#' @param value Character value to set for the option.
#' `value = ""` (empty string) will unset a value previously set by
#' `set_config_option()`.
#' @returns No return value, called for side effects.
#'
#' @note
#' The configuration option `"CPL_LOG_ERRORS"` can be set to `"OFF"` to disable
#' printing error massages to the console by GDAL. This only affects messages
#' printed by GDAL, and does not disable errors, warnings or other messages
#' emitted by \pkg{gdalraster}. The latter can generally be configured using a
#' function argument or object-level setting in most cases.
#'
#' @seealso
#' [get_config_option()]
#'
#' `vignette("gdal-config-quick-ref")`
#'
#' @examples
#' set_config_option("CPL_LOG_ERRORS", "OFF")
#' get_config_option("CPL_LOG_ERRORS")
#' ## unset to default:
#' set_config_option("CPL_LOG_ERRORS", "")
set_config_option <- function(key, value) {
    invisible(.Call(`_gdalraster_set_config_option`, key, value))
}

#' Get the maximum memory size available for the GDAL block cache
#'
#' `get_cache_max()` returns the maximum amount of memory available to the
#' GDALRasterBlock caching system for caching raster read/write data. Wrapper
#' of `GDALGetCacheMax64()` with return value in MB by default.
#'
#' @details
#' The first time this function is called, it will read the `GDAL_CACHEMAX`
#' configuration option to initialize the maximum cache memory. The value of
#' the configuration option can be expressed as x% of the usable physical RAM
#' (which may potentially be used by other processes). Otherwise it is
#' expected to be a value in MB.
#' As of GDAL 3.10, the default value, if `GDAL_CACHEMAX` has not been set
#' explicitly, is 5% of usable physical RAM.
#'
#' @param units Character string specifying units for the return value. One of
#' `"MB"` (the default), `"GB"`, `"KB"` or `"bytes"` (values of `"byte"`,
#' `"B"` and empty string `""` are also recognized to mean bytes).
#' @returns A numeric value carrying the `integer64` class attribute. Maximum
#' cache memory available in the requested units.
#'
#' @note
#' The value of the `GDAL_CACHEMAX` configuration option is only consulted the
#' first time the cache size is requested (i.e., it must be set as a
#' configuration option prior to any raster I/O during the current session).
#' To change this value programmatically during operation of the program it is
#' better to use [set_cache_max()] (in which case, always given in bytes).
#'
#' @seealso
#' [GDAL_CACHEMAX configuration option](https://gdal.org/en/stable/user/configoptions.html#performance-and-caching)
#'
#' [get_config_option()], [set_config_option()], [get_usable_physical_ram()],
#' [get_cache_used()], [set_cache_max()]
#'
#' @examples
#' get_cache_max()
get_cache_max <- function(units = "MB") {
    .Call(`_gdalraster_get_cache_max`, units)
}

#' Get the size of memory in use by the GDAL block cache
#'
#' `get_cache_used()` returns the amount of memory currently in use for
#' GDAL block caching. Wrapper of `GDALGetCacheUsed64()` with return
#' value in MB by default.
#'
#' @param units Character string specifying units for the return value. One of
#' `"MB"` (the default), `"GB"`, `"KB"` or `"bytes"` (values of `"byte"`,
#' `"B"` and empty string `""` are also recognized to mean bytes).
#' @returns A numeric value carrying the `integer64` class attribute. Amount
#' of the available cache memory currently in use in the requested units.
#'
#' @seealso
#' [GDAL Block Cache](https://firelab.github.io/gdalraster/articles/gdal-block-cache.html)
#'
#' [get_cache_max()], [set_cache_max()]
#'
#' @examples
#' get_cache_used()
get_cache_used <- function(units = "MB") {
    .Call(`_gdalraster_get_cache_used`, units)
}

#' Set the maximum memory size for the GDAL block cache
#'
#' `set_cache_max()` sets the maximum amount of memory that GDAL is permitted
#' to use for GDALRasterBlock caching.
#' *The unit of the value to set is bytes.* Wrapper of `GDALSetCacheMax64()`.
#'
#' @param nbytes A numeric value optionally carrying the `integer64` class
#' attribute (assumed to be a whole number, will be coerced to integer by
#' truncation). Specifies the new cache size in bytes (maximum number of bytes
#' for caching).
#' @returns No return value, called for side effects.
#'
#' @note
#' **This function will not make any attempt to check the consistency of the
#' passed value with the effective capabilities of the OS.**
#'
#' It is recommended to consult the documentation for `get_cache_max()` and
#' `get_cache_used()` before using this function.
#'
#' [get_cache_max()], [get_cache_used()]
#'
#' @examples
#' (cachemax <- get_cache_max("bytes"))
#'
#' set_cache_max(1e8)
#' get_cache_max()  # returns in MB by default
#'
#' # reset to original
#' set_cache_max(cachemax)
#' get_cache_max()
set_cache_max <- function(nbytes) {
    invisible(.Call(`_gdalraster_set_cache_max`, nbytes))
}

#' @noRd
.dump_open_datasets <- function(outfile) {
    .Call(`_gdalraster_dump_open_datasets`, outfile)
}

#' Push a new GDAL CPLError handler
#'
#' `push_error_handler()` is a wrapper for
#' `CPLPushErrorHandler()` in the GDAL Common Portability
#' Library.
#' This pushes a new error handler on the thread-local error handler stack.
#' This handler will be used until removed with `pop_error_handler()`.
#' A typical use is to temporarily set `CPLQuietErrorHandler()` which doesn't
#' make any attempt to report passed error or warning messages, but will
#' process debug messages via `CPLDefaultErrorHandler`.
#'
#' @param handler Character name of the error handler to push.
#' One of `quiet`, `logging` or `default`.
#' @returns No return value, called for side effects.
#'
#' @note
#' This function is for advanced use cases. It is intended for setting a
#' _temporary_ error handler in a limited segment of code. A global error
#' handler specific to the R environment is in use by default.
#'
#' Setting `handler = "logging"` will use `CPLLoggingErrorHandler()`, error
#' handler that logs into the file defined by the `"CPL_LOG"` configuration
#' option. Be sure that option is set when using this error handler.
#'
#' This only affects error reporting from GDAL.
#'
#' Also note that the configuration option `"CPL_LOG_ERRORS"` can be set to
#' `"OFF"` to disable globally the printing of error massages to the console
#' by GDAL.
#'
#' @seealso
#' [pop_error_handler()], [set_config_option()]
#'
#' @examples
#' push_error_handler("quiet")
#' # ...
#' pop_error_handler()
push_error_handler <- function(handler) {
    invisible(.Call(`_gdalraster_push_error_handler`, handler))
}

#' Pop error handler off stack
#'
#' `pop_error_handler()` is a wrapper for `CPLPopErrorHandler()` in the GDAL
#' Common Portability Library.
#' Discards the current error handler on the error handler stack, and restores
#' the one in use before the last `push_error_handler()` call. This method has
#' no effect if there are no error handlers on the current thread's error
#' handler stack.
#'
#' @returns No return value, called for side effects.
#'
#' @seealso
#' [push_error_handler()]
#'
#' @examples
#' push_error_handler("quiet")
#' # ...
#' pop_error_handler()
pop_error_handler <- function() {
    invisible(.Call(`_gdalraster_pop_error_handler`))
}

#' Check a filename before passing to GDAL and potentially fix.
#' 'filename' may be a physical file, URL, connection string, filename with
#' additional parameters, etc.
#' Currently, only checks for leading tilde and does path expansion in that
#' case. Returns the filename in UTF-8 encoding if possible using R enc2utf8.
#'
#' @noRd
.check_gdal_filename <- function(filename) {
    .Call(`_gdalraster_check_gdal_filename`, filename)
}

#' Get the number of processors detected by GDAL
#'
#' `get_num_cpus()` returns the number of processors detected by GDAL.
#' Wrapper of `CPLGetNumCPUs()` in the GDAL Common Portability Library.
#'
#' @return Integer scalar, number of CPUs.
#'
#' @examples
#' get_num_cpus()
get_num_cpus <- function() {
    .Call(`_gdalraster_get_num_cpus`)
}

#' Get usable physical RAM reported by GDAL
#'
#' `get_usable_physical_ram()` returns the total physical RAM, usable by a
#' process, in bytes. It will limit to 2 GB for 32 bit processes. Starting
#' with GDAL 2.4.0, it will also take into account resource limits (virtual
#' memory) on Posix systems. Starting with GDAL 3.6.1, it will also take into
#' account RLIMIT_RSS on Linux. Wrapper of `CPLGetUsablePhysicalRAM()` in the
#' GDAL Common Portability Library.
#'
#' @return Numeric scalar, number of bytes as `bit64::integer64` type (or 0 in
#' case of failure).
#'
#' @note
#' This memory may already be partly used by other processes.
#'
#' @examples
#' get_usable_physical_ram()
get_usable_physical_ram <- function() {
    .Call(`_gdalraster_get_usable_physical_ram`)
}

#' Is SpatiaLite available?
#'
#' `has_spatialite()` returns a logical value indicating whether GDAL was
#' built with support for the SpatiaLite library. SpatiaLite extends the
#' SQLite core to support full Spatial SQL capabilities.
#'
#' @details
#' GDAL supports executing SQL statements against a datasource. For most file
#' formats (e.g. Shapefiles, GeoJSON, FlatGeobuf files), the built-in OGR SQL
#' dialect will be used by default. It is also possible to request the
#' alternate `"SQLite"`  dialect, which will use the SQLite engine to evaluate
#' commands on GDAL datasets. This assumes that GDAL is built with support for
#' SQLite, and preferably with Spatialite support too to benefit from spatial
#' functions.
#'
#' @return Logical scalar. `TRUE` if SpatiaLite is available to GDAL.
#'
#' @note
#' All GDAL/OGR drivers for database systems, e.g., PostgreSQL / PostGIS,
#' Oracle Spatial, SQLite / Spatialite RDBMS, GeoPackage, etc., override the
#' `GDALDataset::ExecuteSQL()` function with a dedicated implementation and, by
#' default, pass the SQL statements directly to the underlying RDBMS. In these
#' cases the SQL syntax varies in some particulars from OGR SQL. Also, anything
#' possible in SQL can then be accomplished for these particular databases. For
#' those drivers, it is also possible to explicitly request the `OGRSQL` or
#' `SQLite` dialects, although performance will generally be much less than the
#' native SQL engine of those database systems.
#'
#' @seealso
#' [ogrinfo()], [ogr_execute_sql()]
#'
#' OGR SQL dialect and SQLITE SQL dialect:\cr
#' \url{https://gdal.org/en/stable/user/ogr_sql_sqlite_dialect.html}
#'
#' @examples
#' has_spatialite()
has_spatialite <- function() {
    .Call(`_gdalraster_has_spatialite`)
}

#' Check if GDAL CPLHTTP services can be useful (libcurl)
#'
#' `http_enabled()` returns `TRUE` if `libcurl` support is enabled.
#' Wrapper of `CPLHTTPEnabled()` in the GDAL Common Portability Library.
#'
#' @return Logical scalar, `TRUE` if GDAL was built with `libcurl` support.
#'
#' @examples
#' http_enabled()
http_enabled <- function() {
    .Call(`_gdalraster_http_enabled`)
}

#' @noRd
.cpl_get_filename <- function(full_filename) {
    .Call(`_gdalraster_cpl_get_filename`, full_filename)
}

#' @noRd
.cpl_get_path <- function(full_filename) {
    .Call(`_gdalraster_cpl_get_path`, full_filename)
}

#' @noRd
.cpl_get_dirname <- function(full_filename) {
    .Call(`_gdalraster_cpl_get_dirname`, full_filename)
}

#' @noRd
.cpl_get_basename <- function(full_filename) {
    .Call(`_gdalraster_cpl_get_basename`, full_filename)
}

#' @noRd
.cpl_get_extension <- function(full_filename) {
    .Call(`_gdalraster_cpl_get_extension`, full_filename)
}

#' @noRd
.cpl_launder_for_filename <- function(full_filename) {
    .Call(`_gdalraster_cpl_launder_for_filename`, full_filename)
}

#' @noRd
.cpl_http_cleanup <- function() {
    invisible(.Call(`_gdalraster_cpl_http_cleanup`))
}

#' Apply geotransform - internal wrapper of GDALApplyGeoTransform()
#'
#' `apply_geotransform_()` applies geotransform coefficients to a raster
#' coordinate in pixel/line space (colum/row), converting into a
#' georeferenced (x, y) coordinate.
#'
#' @param gt Numeric vector of length six containing the geotransform to
#' apply.
#' @param pixel Numeric scalar. A raster pixel (column) coordinate.
#' @param line Numeric scalar. A raster line (row) coordinate.
#' @returns Numeric vector of length two containing a geospatial x/y
#' coordinate (spatial reference system of `gt`).
#' @seealso [`GDALRaster$getGeoTransform()`][GDALRaster], [get_pixel_line()],
#' [inv_geotransform()]
#' @noRd
.apply_geotransform <- function(gt, pixel, line) {
    .Call(`_gdalraster_apply_geotransform_`, gt, pixel, line)
}

#' Apply geotransform (raster column/row to geospatial x/y)
#' input as geotransform vector, no bounds checking on col/row
#' @noRd
.apply_geotransform_gt <- function(col_row, gt) {
    .Call(`_gdalraster_apply_geotransform_gt`, col_row, gt)
}

#' Apply geotransform (raster column/row to geospatial x/y)
#' alternate version for GDALRaster input, with bounds checking
#' @noRd
.apply_geotransform_ds <- function(col_row, ds) {
    .Call(`_gdalraster_apply_geotransform_ds`, col_row, ds)
}

#' Invert geotransform
#'
#' `inv_geotransform()` inverts a vector of geotransform coefficients. This
#' converts the equation from being:\cr
#' raster pixel/line (column/row) -> geospatial x/y coordinate\cr
#' to:\cr
#' geospatial x/y coordinate -> raster pixel/line (column/row)
#'
#' @param gt Numeric vector of length six containing the geotransform to
#' invert.
#' @returns Numeric vector of length six containing the inverted
#' geotransform. The output vector will contain NAs if the input geotransform
#' is uninvertable.
#' @seealso [`GDALRaster$getGeoTransform()`][GDALRaster], [get_pixel_line()]
#' @examples
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' ds <- new(GDALRaster, elev_file)
#' invgt <- ds$getGeoTransform() |> inv_geotransform()
#' ds$close()
#'
#' ptX = 324181.7
#' ptY = 5103901.4
#'
#' ## for a point x, y in the spatial reference system of elev_file
#' ## raster pixel (column number):
#' pixel <- floor(invgt[1] +
#'                invgt[2] * ptX +
#'                invgt[3] * ptY)
#'
#' ## raster line (row number):
#' line <- floor(invgt[4] +
#'               invgt[5] * ptX +
#'               invgt[6] * ptY)
#'
#' ## get_pixel_line() applies this conversion
inv_geotransform <- function(gt) {
    .Call(`_gdalraster_inv_geotransform`, gt)
}

#' Raster pixel/line from geospatial x,y coordinates
#' input is gt vector, no bounds checking done on output
#' @noRd
.get_pixel_line_gt <- function(xy, gt) {
    .Call(`_gdalraster_get_pixel_line_gt`, xy, gt)
}

#' Raster pixel/line from geospatial x,y coordinates
#' alternate version for GDALRaster input, with bounds checking
#' @noRd
.get_pixel_line_ds <- function(xy, ds) {
    .Call(`_gdalraster_get_pixel_line_ds`, xy, ds)
}

#' Returns bbox geospatial x,y coordinates (xmin, ymin, xmax, ymax) from
#' inputs of geotransform vector and the grid pixel/line extent
#' @noRd
.bbox_grid_to_geo <- function(gt, grid_xmin, grid_xmax, grid_ymin, grid_ymax) {
    .Call(`_gdalraster_bbox_grid_to_geo_`, gt, grid_xmin, grid_xmax, grid_ymin, grid_ymax)
}

#' Returns a matrix of xchunkoff, ychunkoff, xoff, yoff, xsize, ysize, xmin,
#' xmax, ymin, ymax (i.e., indexing of potentially multi-block chunks defined
#' on block boundaries for iterating I/O operations over a raster).
#' If max_pixels == 0, or any value less than block_xsize * block_ysize, then
#' the chunks are the same as raster blocks.
#' 'max_pixels' is a scalar value, but NumericVector is used so it can
#' optionally carry the bit64::integer64 class attribute.
#' @noRd
.make_chunk_index <- function(raster_xsize, raster_ysize, block_xsize, block_ysize, gt, max_pixels) {
    .Call(`_gdalraster_make_chunk_index_`, raster_xsize, raster_ysize, block_xsize, block_ysize, gt, max_pixels)
}

#' Flip raster data vertically
#' @noRd
.flip_vertical <- function(v, xsize, ysize, nbands) {
    .Call(`_gdalraster_flip_vertical`, v, xsize, ysize, nbands)
}

#' Build a GDAL virtual raster from a list of datasets
#'
#' `buildVRT()` is a wrapper of the \command{gdalbuildvrt} command-line
#' utility for building a VRT (Virtual Dataset) that is a mosaic of the list
#' of input GDAL datasets
#' (see \url{https://gdal.org/en/stable/programs/gdalbuildvrt.html}).
#'
#' @details
#' Several command-line options are described in the GDAL documentation at the
#' URL above. By default, the input files are considered as tiles of a larger
#' mosaic and the VRT file has as many bands as one of the input files.
#' Alternatively, the `-separate` argument can be used to put each input
#' raster into a separate band in the VRT dataset.
#'
#' Some amount of checks are done to assure that all files that will be put in
#' the resulting VRT have similar characteristics: number of bands,
#' projection, color interpretation.... If not, files that do not match the
#' common characteristics will be skipped. (This is true in the default
#' mode for virtual mosaicing, and not when using the `-separate` option).
#'
#' In a virtual mosaic, if there is spatial overlap between
#' input rasters then the order of files appearing in the list of
#' sources matter: files that are listed at the end are the ones
#' from which the data will be fetched. Note that nodata will be taken into
#' account to potentially fetch data from less priority datasets.
#'
#' @param vrt_filename Character string. Filename of the output VRT.
#' @param input_rasters Character vector of input raster filenames.
#' @param cl_arg Optional character vector of command-line arguments to
#' \code{gdalbuildvrt}.
#' @param quiet Logical scalar. If `TRUE`, a progress bar will not be
#' displayed. Defaults to `FALSE`.
#' @returns Logical indicating success (invisible \code{TRUE}).
#' An error is raised if the operation fails.
#'
#' @seealso
#' [rasterToVRT()]
#'
#' @examples
#' # build a virtual 3-band RGB raster from individual Landsat band files
#' b4_file <- system.file("extdata/sr_b4_20200829.tif", package="gdalraster")
#' b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
#' b6_file <- system.file("extdata/sr_b6_20200829.tif", package="gdalraster")
#' band_files <- c(b6_file, b5_file, b4_file)
#' vrt_file <- file.path(tempdir(), "storml_b6_b5_b4.vrt")
#' buildVRT(vrt_file, band_files, cl_arg = "-separate")
#' ds <- new(GDALRaster, vrt_file)
#' ds$getRasterCount()
#' plot_raster(ds, nbands = 3, main = "Landsat 6-5-4 (vegetative analysis)")
#' ds$close()
#' \dontshow{vsi_unlink(vrt_file)}
buildVRT <- function(vrt_filename, input_rasters, cl_arg = NULL, quiet = FALSE) {
    invisible(.Call(`_gdalraster_buildVRT`, vrt_filename, input_rasters, cl_arg, quiet))
}

#' Raster overlay for unique combinations
#'
#' @description
#' `combine()` overlays multiple rasters so that a unique ID is assigned to
#' each unique combination of input values. The input raster layers
#' typically have integer data types (floating point will be coerced to
#' integer by truncation), and must have the same projection, extent and cell
#' size. Pixel counts for each unique combination are obtained, and
#' combination IDs are optionally written to an output raster.
#'
#' Called from and documented in R/gdalraster_proc.R
#' @noRd
.combine <- function(src_files, var_names, bands, dst_filename, fmt, dataType, options, quiet) {
    .Call(`_gdalraster_combine`, src_files, var_names, bands, dst_filename, fmt, dataType, options, quiet)
}

#' Compute for a raster band the set of unique pixel values and their counts
#'
#' @noRd
.value_count <- function(src_ds, band = 1L, quiet = FALSE) {
    .Call(`_gdalraster_value_count`, src_ds, band, quiet)
}

#' Wrapper for GDALDEMProcessing in the GDAL Algorithms C API
#'
#' Called from and documented in R/gdalraster_proc.R
#' @noRd
.dem_proc <- function(mode, src_filename, dst_filename, cl_arg = NULL, col_file = NULL, quiet = FALSE) {
    .Call(`_gdalraster_dem_proc`, mode, src_filename, dst_filename, cl_arg, col_file, quiet)
}

#' Fill selected pixels by interpolation from surrounding areas
#'
#' `fillNodata()` is a wrapper for `GDALFillNodata()` in the GDAL Algorithms
#' API. This algorithm will interpolate values for all designated nodata
#' pixels (pixels having an intrinsic nodata value, or marked by zero-valued
#' pixels in the optional raster specified in `mask_file`). For each nodata
#' pixel, a four direction conic search is done to find values to interpolate
#' from (using inverse distance weighting).
#' Once all values are interpolated, zero or more smoothing iterations
#' (3x3 average filters on interpolated pixels) are applied to smooth out
#' artifacts.
#'
#' @note
#' The input raster will be modified in place. It should not be open in a
#' `GDALRaster` object while processing with `fillNodata()`.
#'
#' @param filename Filename of input raster in which to fill nodata pixels.
#' @param band Integer band number to modify in place.
#' @param mask_file Optional filename of raster to use as a validity mask
#' (band 1 is used, zero marks nodata pixels, non-zero marks valid pixels).
#' @param max_dist Maximum distance (in pixels) that the algorithm
#' will search out for values to interpolate (100 pixels by default).
#' @param smooth_iterations The number of 3x3 average filter smoothing
#' iterations to run after the interpolation to dampen artifacts
#' (0 by default).
#' @param quiet Logical scalar. If `TRUE`, a progress bar will not be
#' displayed. Defaults to `FALSE`.
#' @returns Logical indicating success (invisible \code{TRUE}).
#' An error is raised if the operation fails.
#' @examples
#' ## fill nodata edge pixels
#' f <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
#'
#' ## get count of nodata
#' tbl <- buildRAT(f)
#' head(tbl)
#' tbl[is.na(tbl$VALUE),]
#'
#' ds <- new(GDALRaster, f)
#' plot_raster(ds, legend = TRUE)
#' ds$close()
#'
#' ## make a copy that will be modified
#' mod_file <- file.path(tempdir(), "storml_elev_fill.tif")
#' file.copy(f,  mod_file)
#'
#' fillNodata(mod_file, band = 1)
#'
#' mod_tbl = buildRAT(mod_file)
#' head(mod_tbl)
#' mod_tbl[is.na(mod_tbl$VALUE),]
#'
#' ds <- new(GDALRaster, mod_file)
#' plot_raster(ds, legend = TRUE)
#' ds$close()
#' \dontshow{deleteDataset(mod_file)}
fillNodata <- function(filename, band, mask_file = "", max_dist = 100, smooth_iterations = 0L, quiet = FALSE) {
    invisible(.Call(`_gdalraster_fillNodata`, filename, band, mask_file, max_dist, smooth_iterations, quiet))
}

#' Compute footprint of a raster
#'
#' `footprint()` is a wrapper of the \command{gdal_footprint} command-line
#' utility (see \url{https://gdal.org/en/stable/programs/gdal_footprint.html}).
#' The function can be used to compute the footprint of a raster file, taking
#' into account nodata values (or more generally the mask band attached to
#' the raster bands), and generating polygons/multipolygons corresponding to
#' areas where pixels are valid, and write to an output vector file.
#' Refer to the GDAL documentation at the URL above for a list of command-line
#' arguments that can be passed in `cl_arg`. Requires GDAL >= 3.8.
#'
#' @details
#' Post-vectorization geometric operations are applied in the following order:
#' * optional splitting (`-split_polys`)
#' * optional densification (`-densify`)
#' * optional reprojection (`-t_srs`)
#' * optional filtering by minimum ring area (`-min_ring_area`)
#' * optional application of convex hull (`-convex_hull`)
#' * optional simplification (`-simplify`)
#' * limitation of number of points (`-max_points`)
#'
#' @param src_filename Character string. Filename of the source raster.
#' @param dst_filename Character string. Filename of the destination vector.
#' If the file and the output layer exist, the new footprint is appended to
#' them, unless the `-overwrite` command-line argument is used.
#' @param cl_arg Optional character vector of command-line arguments for
#' \code{gdal_footprint}.
#' @returns Logical indicating success (invisible \code{TRUE}).
#' An error is raised if the operation fails.
#'
#' @seealso
#' [polygonize()]
#'
#' @examples
#' evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
#' out_file <- file.path(tempdir(), "storml.geojson")
#'
#' # Requires GDAL >= 3.8
#' if (gdal_version_num() >= gdal_compute_version(3, 8, 0)) {
#'   # command-line arguments for gdal_footprint
#'   args <- c("-t_srs", "EPSG:4326")
#'   footprint(evt_file, out_file, args)
#'   \dontshow{deleteDataset(out_file)}
#' }
footprint <- function(src_filename, dst_filename, cl_arg = NULL) {
    invisible(.Call(`_gdalraster_footprint`, src_filename, dst_filename, cl_arg))
}

#' Check Line of Sight between pairs of points
#'
#' Interface to GDALIsLineOfSightVisible() in GDAL >= 3.9
#'
#' see also https://github.com/OSGeo/gdal/issues/12458:
#' GDALIsLineOfSightVisible(): points exactly on the DEM surface are never
#' visible
#'
#' Called from and documented in R/gdalraster_proc.R
#'
#' @noRd
.isLineOfSightVisible <- function(ds, band, ptsA, srsA, ZinterpA, ptsB, srsB, ZinterpB, quiet) {
    .Call(`_gdalraster_isLineOfSightVisible`, ds, band, ptsA, srsA, ZinterpA, ptsB, srsB, ZinterpB, quiet)
}

#' Convert vector data between different formats
#'
#' `ogr2ogr()` is a wrapper of the \command{ogr2ogr} command-line
#' utility (see \url{https://gdal.org/en/stable/programs/ogr2ogr.html}).
#' This function can be used to convert simple features data between file
#' formats. It can also perform various operations during the process, such
#' as spatial or attribute selection, reducing the set of attributes, setting
#' the output coordinate system or even reprojecting the features during
#' translation.
#' Refer to the GDAL documentation at the URL above for a description of
#' command-line arguments that can be passed in `cl_arg`.
#'
#' @param src_dsn Character string. Data source name of the source vector
#' dataset.
#' @param dst_dsn Character string. Data source name of the destination vector
#' dataset.
#' @param src_layers Optional character vector of layer names in the source
#' dataset. Defaults to all layers.
#' @param cl_arg Optional character vector of command-line arguments for
#' the GDAL \code{ogr2ogr} command-line utility (see URL above).
#' @param open_options Optional character vector of dataset open options.
#' @returns Logical indicating success (invisible \code{TRUE}).
#' An error is raised if the operation fails.
#'
#' @note
#' For progress reporting, see command-line argument `-progress`: Display
#' progress on terminal. Only works if input layers have the "fast feature
#' count" capability.
#'
#' @seealso
#' [ogrinfo()], the [ogr_manage] utilities
#'
#' [translate()] for raster data
#'
#' @examples
#' src <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
#'
#' # Convert GeoPackage to Shapefile
#' ynp_shp <- file.path(tempdir(), "ynp_fires.shp")
#' ogr2ogr(src, ynp_shp, src_layers = "mtbs_perims")
#'
#' # Reproject to WGS84
#' ynp_gpkg <- file.path(tempdir(), "ynp_fires.gpkg")
#' args <- c("-t_srs", "EPSG:4326", "-nln", "fires_wgs84")
#' ogr2ogr(src, ynp_gpkg, cl_arg = args)
#'
#' # Clip to a bounding box (xmin, ymin, xmax, ymax in the source SRS)
#' # This will select features whose geometry intersects the bounding box.
#' # The geometries themselves will not be clipped unless "-clipsrc" is
#' # specified.
#' # The source SRS can be overridden with "-spat_srs" "<srs_def>"
#' # Using -update mode to write a new layer in the existing DSN
#' bb <- c(469685.97, 11442.45, 544069.63, 85508.15)
#' args <- c("-update", "-nln", "fires_clip", "-spat", bb)
#' ogr2ogr(src, ynp_gpkg, cl_arg = args)
#'
#' # Filter features by a -where clause
#' sql <- "ig_year >= 2000 ORDER BY ig_year"
#' args <- c("-update", "-nln", "fires_2000-2020", "-where", sql)
#' ogr2ogr(src, ynp_gpkg, src_layers = "mtbs_perims", cl_arg = args)
#'
#' # Dissolve features based on a shared attribute value
#' if (has_spatialite()) {
#'     sql <- "SELECT ig_year, ST_Union(geom) AS geom
#'               FROM mtbs_perims GROUP BY ig_year"
#'     args <- c("-update", "-sql", sql, "-dialect", "SQLITE")
#'     args <- c(args, "-nlt", "MULTIPOLYGON", "-nln", "dissolved_on_year")
#'     ogr2ogr(src, ynp_gpkg, cl_arg = args)
#' }
#' \dontshow{deleteDataset(ynp_shp)}
#' \dontshow{deleteDataset(ynp_gpkg)}
ogr2ogr <- function(src_dsn, dst_dsn, src_layers = NULL, cl_arg = NULL, open_options = NULL) {
    invisible(.Call(`_gdalraster_ogr2ogr`, src_dsn, dst_dsn, src_layers, cl_arg, open_options))
}

#' Retrieve information about a vector data source
#'
#' `ogrinfo()` is a wrapper of the \command{ogrinfo} command-line
#' utility (see \url{https://gdal.org/en/stable/programs/ogrinfo.html}).
#' This function lists information about an OGR-supported data source.
#' It is also possible to edit data with SQL statements.
#' Refer to the GDAL documentation at the URL above for a description of
#' command-line arguments that can be passed in `cl_arg`.
#' Requires GDAL >= 3.7.
#'
#' @param dsn Character string. Data source name (e.g., filename, database
#' connection string, etc.)
#' @param layers Optional character vector of layer names in the source
#' dataset.
#' @param cl_arg Optional character vector of command-line arguments for
#' the \code{ogrinfo} command-line utility in GDAL (see URL above for
#' reference). The default is `c("-so", "-nomd")` (see Note).
#' @param open_options Optional character vector of dataset open options.
#' @param read_only Logical scalar. `TRUE` to open the data source read-only
#' (the default), or `FALSE` to open with write access.
#' @param cout Logical scalar. `TRUE` to write info to the standard C output
#' stream (the default). `FALSE` to suppress console output.
#' @returns Invisibly, a character string containing information about the
#' vector dataset, or empty string (`""`) in case of error.
#'
#' @note
#' The command-line argument `-so` provides a summary only, i.e., does not
#' include details about every single feature of a layer.
#' `-nomd` suppresses metadata printing. Some datasets may contain a lot of
#' metadata strings.
#'
#' @seealso
#' [ogr2ogr()], [ogr_manage]
#'
#' @examplesIf gdal_version_num() >= gdal_compute_version(3, 7, 0)
#' src <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
#'
#' # Get the names of the layers in a GeoPackage file
#' ogrinfo(src)
#'
#' # Summary of a layer
#' ogrinfo(src, "mtbs_perims")
#'
#' # Query an attribute to restrict the output of the features in a layer
#' args <- c("-ro", "-nomd", "-where", "ig_year = 2020")
#' ogrinfo(src, "mtbs_perims", args)
#'
#' # Copy to a temporary in-memory file that is writeable
#' src_mem <- paste0("/vsimem/", basename(src))
#' vsi_copy_file(src, src_mem)
#'
#' # Add a column to a layer
#' args <- c("-sql", "ALTER TABLE mtbs_perims ADD burn_bnd_ha float")
#' ogrinfo(src_mem, cl_arg = args, read_only = FALSE)
#'
#' # Update values of the column with SQL and specify a dialect
#' sql <- "UPDATE mtbs_perims SET burn_bnd_ha = (burn_bnd_ac / 2.471)"
#' args <- c("-dialect", "sqlite", "-sql", sql)
#' ogrinfo(src_mem, cl_arg = args, read_only = FALSE)
ogrinfo <- function(dsn, layers = NULL, cl_arg = as.character( c("-so", "-nomd")), open_options = NULL, read_only = TRUE, cout = TRUE) {
    invisible(.Call(`_gdalraster_ogrinfo`, dsn, layers, cl_arg, open_options, read_only, cout))
}

#' Wrapper for GDALPolygonize in the GDAL Algorithms C API
#'
#' Called from and documented in R/gdalraster_proc.R
#' @noRd
.polygonize <- function(src_filename, src_band, out_dsn, out_layer, fld_name, mask_file = "", nomask = FALSE, connectedness = 4L, quiet = FALSE) {
    .Call(`_gdalraster_polygonize`, src_filename, src_band, out_dsn, out_layer, fld_name, mask_file, nomask, connectedness, quiet)
}

#' Wrapper for GDALRasterize in the GDAL Algorithms C API
#'
#' Called from and documented in R/gdalraster_proc.R
#' @noRd
.rasterize <- function(src_dsn, dst_filename, dst_dataset, cl_arg, quiet = FALSE) {
    .Call(`_gdalraster_rasterize`, src_dsn, dst_filename, dst_dataset, cl_arg, quiet)
}

#' Remove small raster polygons
#'
#' `sieveFilter()` is a wrapper for `GDALSieveFilter()` in the GDAL Algorithms
#' API. It removes raster polygons smaller than a provided threshold size
#' (in pixels) and replaces them with the pixel value of the largest neighbour
#' polygon.
#'
#' @details
#' Polygons are determined as regions of the raster where the pixels all have
#' the same value, and that are contiguous (connected).
#' Pixels determined to be "nodata" per the mask band will not be
#' treated as part of a polygon regardless of their pixel values. Nodata areas
#' will never be changed nor affect polygon sizes. Polygons smaller than the
#' threshold with no neighbours that are as large as the threshold will not be
#' altered. Polygons surrounded by nodata areas will therefore not be altered.
#'
#' The algorithm makes three passes over the input file to enumerate the
#' polygons and collect limited information about them. Memory use is
#' proportional to the number of polygons (roughly 24 bytes per polygon), but
#' is not directly related to the size of the raster. So very large raster
#' files can be processed effectively if there aren't too many polygons. But
#' extremely noisy rasters with many one pixel polygons will end up being
#' expensive (in memory) to process.
#'
#' The input dataset is read as integer data which means that floating point
#' values are rounded to integers.
#'
#' @param src_filename Filename of the source raster to be processed.
#' @param src_band Band number in the source raster to be processed.
#' @param dst_filename Filename of the output raster. It may be the same as
#' `src_filename` to update the source file in place.
#' @param dst_band Band number in `dst_filename` to write output. It may be
#' the same as `src_band` to update the source raster in place.
#' @param size_threshold Integer. Raster polygons with sizes (in pixels)
#' smaller than this value will be merged into their largest neighbour.
#' @param connectedness Integer. Either `4` indicating that diagonal pixels
#' are not considered directly adjacent for polygon membership purposes, or
#' `8` indicating they are.
#' @param mask_filename Optional filename of raster to use as a mask.
#' @param mask_band Band number in `mask_filename` to use as a mask. All
#' pixels in the mask band with a value other than zero will be considered
#' suitable for inclusion in polygons.
#' @param options Algorithm options as a character vector of name=value pairs.
#' None currently supported.
#' @param quiet Logical scalar. If `TRUE`, a progress bar will not be
#' displayed. Defaults to `FALSE`.
#' @returns Logical indicating success (invisible \code{TRUE}).
#' An error is raised if the operation fails.
#'
#' @examples
#' ## remove single-pixel polygons from the vegetation type layer (EVT)
#' evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
#'
#' # create a blank raster to hold the output
#' evt_mmu_file <- file.path(tempdir(), "storml_evt_mmu2.tif")
#' rasterFromRaster(srcfile = evt_file,
#'                  dstfile = evt_mmu_file,
#'                  init = 32767)
#'
#' # create a mask to exclude water pixels from the algorithm
#' # recode water (7292) to 0
#' expr <- "ifelse(EVT == 7292, 0, EVT)"
#' mask_file <- calc(expr = expr,
#'                   rasterfiles = evt_file,
#'                   var.names = "EVT")
#'
#' # create a version of EVT with two-pixel minimum mapping unit
#' sieveFilter(src_filename = evt_file,
#'             src_band = 1,
#'             dst_filename = evt_mmu_file,
#'             dst_band = 1,
#'             size_threshold = 2,
#'             connectedness = 8,
#'             mask_filename = mask_file,
#'             mask_band = 1)
#' \dontshow{deleteDataset(mask_file)}
#' \dontshow{deleteDataset(evt_mmu_file)}
sieveFilter <- function(src_filename, src_band, dst_filename, dst_band, size_threshold, connectedness, mask_filename = "", mask_band = 0L, options = NULL, quiet = FALSE) {
    invisible(.Call(`_gdalraster_sieveFilter`, src_filename, src_band, dst_filename, dst_band, size_threshold, connectedness, mask_filename, mask_band, options, quiet))
}

#' Convert raster data between different formats
#'
#' `translate()` is a wrapper of the \command{gdal_translate} command-line
#' utility (see \url{https://gdal.org/en/stable/programs/gdal_translate.html}).
#'
#' Called from and documented in R/gdal_util.R
#'
#' @noRd
.translate <- function(src_ds, dst_filename, cl_arg = NULL, quiet = FALSE) {
    .Call(`_gdalraster_translate`, src_ds, dst_filename, cl_arg, quiet)
}

#' Raster reprojection and mosaicing
#'
#' `warp()` is a wrapper of the \command{gdalwarp} command-line utility for
#' raster mosaicing, reprojection and warping
#' (see \url{https://gdal.org/en/stable/programs/gdalwarp.html}).
#'
#' Called from and documented in R/gdal_util.R
#'
#' Destination raster is specified here as either:
#' dst_filename - the destination dataset path or ""
#' dst_dataset - list of length 1 containg a GDALRaster object or empty list
#'               (workaround for a nullable dataset argument)
#'
#' @noRd
.warp <- function(src_datasets, dst_filename, dst_dataset, t_srs, cl_arg, quiet) {
    .Call(`_gdalraster_warp`, src_datasets, dst_filename, dst_dataset, t_srs, cl_arg, quiet)
}

#' Create a color ramp
#'
#' `createColorRamp()` is a wrapper for `GDALCreateColorRamp()` in the GDAL
#' API. It automatically creates a color ramp from one color entry to another.
#' Output is an integer matrix in color table format for use with
#' [`GDALRaster$setColorTable()`][GDALRaster].
#'
#' @note
#' `createColorRamp()` could be called several times, using `rbind()` to
#' combine multiple ramps into the same color table. Possible duplicate rows
#' in the resulting table are not a problem when used in
#' `GDALRaster$setColorTable()` (i.e., when `end_color` of one ramp is the
#' same as `start_color` of the next ramp).
#'
#' @param start_index Integer start index (raster value).
#' @param start_color Integer vector of length three or four.
#' A color entry value to start the ramp (e.g., RGB values).
#' @param end_index Integer end index (raster value).
#' @param end_color Integer vector of length three or four.
#' A color entry value to end the ramp (e.g., RGB values).
#' @param palette_interp One of "Gray", "RGB" (the default), "CMYK" or "HLS"
#' describing interpretation of `start_color` and `end_color` values
#' (see \href{https://gdal.org/en/stable/user/raster_data_model.html#color-table}{GDAL
#' Color Table}).
#' @returns Integer matrix with five columns containing the color ramp from
#' `start_index` to `end_index`, with raster index values in column 1 and
#' color entries in columns 2:5).
#'
#' @seealso
#' [`GDALRaster$getColorTable()`][GDALRaster],
#' [`GDALRaster$getPaletteInterp()`][GDALRaster]
#'
#' @examples
#' # create a color ramp for tree canopy cover percent
#' # band 5 of an LCP file contains canopy cover
#' lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
#' ds <- new(GDALRaster, lcp_file)
#' ds$getDescription(band=5)
#' ds$getMetadata(band=5, domain="")
#' ds$close()
#'
#' # create a GTiff file with Byte data type for the canopy cover band
#' # recode nodata -9999 to 255
#' tcc_file <- calc(expr = "ifelse(CANCOV == -9999, 255, CANCOV)",
#'                  rasterfiles = lcp_file,
#'                  bands = 5,
#'                  var.names = "CANCOV",
#'                  fmt = "GTiff",
#'                  dtName = "Byte",
#'                  nodata_value = 255,
#'                  setRasterNodataValue = TRUE)
#'
#' ds_tcc <- new(GDALRaster, tcc_file, read_only=FALSE)
#'
#' # create a color ramp from 0 to 100 and set as the color table
#' colors <- createColorRamp(start_index = 0,
#'                           start_color = c(211, 211, 211),
#'                           end_index = 100,
#'                           end_color = c(0, 100, 0))
#'
#' print(colors)
#' ds_tcc$setColorTable(band=1, col_tbl=colors, palette_interp = "RGB")
#' ds_tcc$setRasterColorInterp(band = 1, col_interp = "Palette")
#'
#' # close and re-open the dataset in read_only mode
#' ds_tcc$open(read_only=TRUE)
#'
#' plot_raster(ds_tcc, interpolate = FALSE, legend = TRUE,
#'             main = "Storm Lake Tree Canopy Cover (%)")
#' ds_tcc$close()
#' \dontshow{deleteDataset(tcc_file)}
createColorRamp <- function(start_index, start_color, end_index, end_color, palette_interp = "RGB") {
    .Call(`_gdalraster_createColorRamp`, start_index, start_color, end_index, end_color, palette_interp)
}

#' Copy a whole raster band efficiently
#'
#' `bandCopyWholeRaster()` copies the complete raster contents of one band to
#' another similarly configured band. The source and destination bands must
#' have the same xsize and ysize. The bands do not have to have the same data
#' type. It implements efficient copying, in particular "chunking" the copy in
#' substantial blocks. This is a wrapper for `GDALRasterBandCopyWholeRaster()`
#' in the GDAL API.
#'
#' @param src_filename Filename of the source raster.
#' @param src_band Band number in the source raster to be copied.
#' @param dst_filename Filename of the destination raster.
#' @param dst_band Band number in the destination raster to copy into.
#' @param options Optional list of transfer hints in a vector of `"NAME=VALUE"`
#' pairs. The currently supported `options` are:
#'   * `"COMPRESSED=YES"` to force alignment on target dataset block sizes to
#'   achieve best compression.
#'    * `"SKIP_HOLES=YES"` to skip chunks that contain only empty blocks.
#'    Empty blocks are blocks that are generally not physically present in the
#'    file, and when read through GDAL, contain only pixels whose value is the
#'    nodata value when it is set, or whose value is 0 when the nodata value is
#'    not set. The query is done in an efficient way without reading the actual
#'    pixel values (if implemented by the raster format driver, otherwise will
#'    not be skipped).
#' @param quiet Logical scalar. If `TRUE`, a progress bar will not be
#' displayed. Defaults to `FALSE`.
#' @returns Logical indicating success (invisible \code{TRUE}).
#' An error is raised if the operation fails.
#'
#' @seealso
#' [`GDALRaster-class`][GDALRaster], [create()], [createCopy()],
#' [rasterFromRaster()]
#'
#' @examples
#' ## copy Landsat data from a single-band file to a new multi-band image
#' b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
#' dst_file <- file.path(tempdir(), "sr_multi.tif")
#' rasterFromRaster(b5_file, dst_file, nbands = 7, init = 0)
#' opt <- c("COMPRESSED=YES", "SKIP_HOLES=YES")
#' bandCopyWholeRaster(b5_file, 1, dst_file, 5, options = opt)
#' ds <- new(GDALRaster, dst_file)
#' ds$getStatistics(band = 5, approx_ok = FALSE, force = TRUE)
#' ds$close()
#' \dontshow{deleteDataset(dst_file)}
bandCopyWholeRaster <- function(src_filename, src_band, dst_filename, dst_band, options = NULL, quiet = FALSE) {
    invisible(.Call(`_gdalraster_bandCopyWholeRaster`, src_filename, src_band, dst_filename, dst_band, options, quiet))
}

#' Delete named dataset
#'
#' `deleteDataset()` will attempt to delete the named dataset in a format
#' specific fashion. Full featured drivers will delete all associated files,
#' database objects, or whatever is appropriate. The default behavior when no
#' format specific behavior is provided is to attempt to delete all the files
#' that would be returned by `GDALRaster$getFileList()` on the dataset.
#' The named dataset should not be open in any existing `GDALRaster` objects
#' when `deleteDataset()` is called. Wrapper for `GDALDeleteDataset()` in the
#' GDAL API.
#'
#' @note
#' If `format` is set to an empty string `""` (the default) then the function
#' will try to identify the driver from `filename`. This is done internally in
#' GDAL by invoking the `Identify` method of each registered `GDALDriver` in
#' turn. The first driver that successful identifies the file name will be
#' returned. An error is raised if a format cannot be determined from the
#' passed file name.
#'
#' @param filename Filename to delete (should not be open in a `GDALRaster`
#' object).
#' @param format Raster format short name (e.g., "GTiff"). If set to empty
#' string `""` (the default), will attempt to guess the raster format from
#' `filename`.
#' @returns Logical `TRUE` if no error or `FALSE` on failure.
#'
#' @seealso
#' [`GDALRaster-class`][GDALRaster], [create()], [createCopy()],
#' [copyDatasetFiles()], [renameDataset()]
#'
#' @examples
#' b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
#' b5_tmp <- file.path(tempdir(), "b5_tmp.tif")
#' file.copy(b5_file,  b5_tmp)
#'
#' ds <- new(GDALRaster, b5_tmp)
#' ds$buildOverviews("BILINEAR", levels = c(2, 4, 8), bands = c(1))
#' files <- ds$getFileList()
#' print(files)
#' ds$close()
#' file.exists(files)
#' deleteDataset(b5_tmp)
#' file.exists(files)
deleteDataset <- function(filename, format = "") {
    .Call(`_gdalraster_deleteDataset`, filename, format)
}

#' Rename a dataset
#'
#' `renameDataset()` renames a dataset in a format-specific way (e.g.,
#' rename associated files as appropriate). This could include moving the
#' dataset to a new directory or even a new filesystem.
#' The dataset should not be open in any existing `GDALRaster` objects
#' when `renameDataset()` is called. Wrapper for `GDALRenameDataset()` in the
#' GDAL API.
#'
#' @note
#' If `format` is set to an empty string `""` (the default) then the function
#' will try to identify the driver from `old_filename`. This is done
#' internally in GDAL by invoking the `Identify` method of each registered
#' `GDALDriver` in turn. The first driver that successful identifies the file
#' name will be returned. An error is raised if a format cannot be determined
#' from the passed file name.
#'
#' @param new_filename New name for the dataset.
#' @param old_filename Old name for the dataset (should not be open in a
#' `GDALRaster` object).
#' @param format Raster format short name (e.g., "GTiff"). If set to empty
#' string `""` (the default), will attempt to guess the raster format from
#' `old_filename`.
#' @returns Logical `TRUE` if no error or `FALSE` on failure.
#'
#' @seealso
#' [`GDALRaster-class`][GDALRaster], [create()], [createCopy()],
#' [deleteDataset()], [copyDatasetFiles()]
#'
#' @examples
#' b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
#' b5_tmp <- file.path(tempdir(), "b5_tmp.tif")
#' file.copy(b5_file,  b5_tmp)
#'
#' ds <- new(GDALRaster, b5_tmp)
#' ds$buildOverviews("BILINEAR", levels = c(2, 4, 8), bands = c(1))
#' ds$getFileList()
#' ds$close()
#' b5_tmp2 <- file.path(tempdir(), "b5_tmp_renamed.tif")
#' renameDataset(b5_tmp2, b5_tmp)
#' ds <- new(GDALRaster, b5_tmp2)
#' ds$getFileList()
#' ds$close()
#'
#' deleteDataset(b5_tmp2)
renameDataset <- function(new_filename, old_filename, format = "") {
    .Call(`_gdalraster_renameDataset`, new_filename, old_filename, format)
}

#' Copy the files of a dataset
#'
#' `copyDatasetFiles()` copies all the files associated with a dataset.
#' Wrapper for `GDALCopyDatasetFiles()` in the GDAL API.
#'
#' @note
#' If `format` is set to an empty string `""` (the default) then the function
#' will try to identify the driver from `old_filename`. This is done
#' internally in GDAL by invoking the `Identify` method of each registered
#' `GDALDriver` in turn. The first driver that successful identifies the file
#' name will be returned. An error is raised if a format cannot be determined
#' from the passed file name.
#'
#' @param new_filename New name for the dataset (copied to).
#' @param old_filename Old name for the dataset (copied from).
#' @param format Raster format short name (e.g., "GTiff"). If set to empty
#' string `""` (the default), will attempt to guess the raster format from
#' `old_filename`.
#' @returns Logical `TRUE` if no error or `FALSE` on failure.
#'
#' @seealso
#' [`GDALRaster-class`][GDALRaster], [create()], [createCopy()],
#' [deleteDataset()], [renameDataset()], [vsi_copy_file()]
#'
#' @examples
#' lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
#' ds <- new(GDALRaster, lcp_file)
#' ds$getFileList()
#' ds$close()
#'
#' lcp_tmp <- file.path(tempdir(), "storm_lake_copy.lcp")
#' copyDatasetFiles(lcp_tmp, lcp_file)
#' ds_copy <- new(GDALRaster, lcp_tmp)
#' ds_copy$getFileList()
#' ds_copy$close()
#'
#' deleteDataset(lcp_tmp)
copyDatasetFiles <- function(new_filename, old_filename, format = "") {
    .Call(`_gdalraster_copyDatasetFiles`, new_filename, old_filename, format)
}

#' Identify the GDAL driver that can open a dataset
#'
#' `identifyDriver()` will try to identify the driver that can open the passed
#' file name by invoking the Identify method of each registered GDALDriver in
#' turn. The short name of the first driver that successfully identifies the
#' file name will be returned as a character string. If all drivers fail then
#' `NULL` is returned.
#' Wrapper of `GDALIdentifyDriverEx()` in the GDAL C API.
#'
#' @note
#' In order to reduce the need for such searches to touch the file system
#' machinery of the operating system, it is possible to give an optional list
#' of files. This is the list of all files at the same level in the file
#' system as the target file, including the target file. The filenames should
#' not include any path components. If the target object does not have
#' filesystem semantics then the file list should be `NULL`.
#'
#' At least one of the `raster` or `vector` arguments must be `TRUE`.
#'
#' @param filename Character string containing the name of the file to access.
#' This may not refer to a physical file, but instead contain information for
#' the driver on how to access a dataset (e.g., connection string, URL, etc.)
#' @param raster Logical value indicating whether to include raster format
#' drivers in the search, `TRUE` by default. May be set to `FALSE` to include
#' only vector drivers.
#' @param vector Logical value indicating whether to include vector format
#' drivers in the search, `TRUE` by default. May be set to `FALSE` to include
#' only raster drivers.
#' @param allowed_drivers Optional character vector of driver short names
#' that must be considered. Set to `NULL` to consider all candidate drivers
#' (the default).
#' @param file_list Optional character vector of filenames, including those
#' that are auxiliary to the main filename (see Note). May contain the input
#' `filename` but this is not required. Defaults to `NULL`.
#' @returns A character string with the short name of the first driver that
#' successfully identifies the input file name, or `NULL` on failure.
#'
#' @seealso
#' [gdal_formats()]
#'
#' @examples
#' src <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
#'
#' identifyDriver(src) |> gdal_formats()
identifyDriver <- function(filename, raster = TRUE, vector = TRUE, allowed_drivers = NULL, file_list = NULL) {
    .Call(`_gdalraster_identifyDriver`, filename, raster, vector, allowed_drivers, file_list)
}

#' Return the list of creation options of a GDAL driver as XML string
#'
#' Called from and documented in R/gdal_helpers.R
#' @noRd
.getCreationOptions <- function(format) {
    .Call(`_gdalraster_getCreationOptions`, format)
}

#' Validate the list of creation options that are handled by a driver
#'
#' `validateCreationOptions()` is a helper function primarily used by GDAL's
#' Create() and CreateCopy() to validate that the passed-in list of creation
#' options is compatible with the GDAL_DMD_CREATIONOPTIONLIST metadata item
#' defined by some drivers. If the GDAL_DMD_CREATIONOPTIONLIST metadata item
#' is not defined, this function will return `TRUE`. Otherwise it will check
#' that the keys and values in the list of creation options are compatible
#' with the capabilities declared by the GDAL_DMD_CREATIONOPTIONLIST metadata
#' item. In case of incompatibility a message will be emitted and `FALSE` will
#' be returned. Wrapper of `GDALValidateCreationOptions()` in the GDAL API.
#'
#' @param format Character string giving a format driver short name
#' (e.g., `"GTiff"`).
#' @param options A character vector of format-specific creation options as
#' `"NAME=VALUE"` pairs.
#' @returns A logical value, `TRUE` if the given creation options are
#' compatible with the capabilities declared by the GDAL_DMD_CREATIONOPTIONLIST
#' metadata item for the specified format driver (or if the
#' GDAL_DMD_CREATIONOPTIONLIST metadata item is not defined for this driver),
#' otherwise `FALSE`.
#'
#' @seealso
#' [getCreationOptions()], [create()], [createCopy()]
#'
#' @examples
#' validateCreationOptions("GTiff", c("COMPRESS=LZW", "TILED=YES"))
validateCreationOptions <- function(format, options) {
    .Call(`_gdalraster_validateCreationOptions`, format, options)
}

#' Get metadata for a GDAL format driver
#'
#' `gdal_get_driver_md()` returns metadata for a driver.
#'
#' @param format Character string giving a format driver short name
#' (e.g., `"GTiff"`).
#' @param mdi_name Optional character string giving the name of a specific
#' metadata item. Defaults to empty string (`""`) meaning fetch all metadata
#' items.
#' @returns Either a named list of metadata items and their values as character
#' strings, or a single character string if `mdi_name` is specified. Returns
#' `NULL` if no metadata items are found for the given inputs.
#'
#' @seealso
#' [getCreationOptions()]
#'
#' @examples
#' dmd <- gdal_get_driver_md("GTiff")
#' str(dmd)
gdal_get_driver_md <- function(format, mdi_name = "") {
    .Call(`_gdalraster_gdal_get_driver_md`, format, mdi_name)
}

#' Add a file inside a new or existing ZIP file
#' Mainly for create/append to Seek-Optimized ZIP
#'
#' @noRd
.addFileInZip <- function(zip_filename, overwrite, archive_filename, in_filename, options, quiet) {
    .Call(`_gdalraster_addFileInZip`, zip_filename, overwrite, archive_filename, in_filename, options, quiet)
}

.gt_from_dim_bbox <- function(dim, bbox) {
    .Call(`_gdalraster_gt_from_dim_bbox_`, dim, bbox)
}

#' Report structure and content of a multidimensional dataset
#'
#' `mdim_info()` is an interface to the \command{gdalmdiminfo} command-line
#' utility (see \url{https://gdal.org/en/stable/programs/gdalmdiminfo.html}).
#' This function lists various information about a GDAL supported
#' multidimensional raster dataset as JSON output. Requires GDAL >= 3.2.
#'
#' @param dsn Character string giving the data source name of the
#' multidimensional raster (e.g., file, VSI path).
#' @param array_name Character string giving the name of the MDarray in
#' `dsn`.
#' @param pretty Logical value, `FALSE` to output a single line without any
#' indentation. Defaults to `TRUE`.
#' @param detailed Logical value, `TRUE` for verbose output. Report attribute
#' data types and array values. Defaults to `FALSE`.
#' @param limit Integer value. Number of values in each dimension that is used
#' to limit the display of array values. By default, unlimited. Only taken into
#' account if used with `detailed = TRUE`. Set to a positive integer to enable.
#' @param stats Logical value, `TRUE` to read and display array statistics.
#' Forces computation if no statistics are stored in an array. Defaults to
#' `FALSE`.
#' @param array_options Optional character vector of `"NAME=VALUE"` pairs to
#' filter reported arrays. Such option is format specific. Consult driver
#' documentation (passed to `GDALGroup::GetMDArrayNames()`).
#' @param allowed_drivers Optional character vector of driver short names that
#' must be considered when opening `dsn`. It is generally not necessary to
#' specify it, but it can be used to skip automatic driver detection, when it
#' fails to select the appropriate driver.
#' @param open_options Optional character vector of format-specific dataset
#' openoptions as `"NAME=VALUE"` pairs.
#' @param cout Logical value, `TRUE` to print info to the console (the
#' default), or `FALSE` to suppress console output.
#' @returns Invisibly, a JSON string containing information about the
#' multidimensional raster dataset. By default, the info string is also printed
#' to the console unless `cout` is set to `FALSE`.
#'
#' @seealso
#' [mdim_as_classic()], [mdim_translate()]
#'
#' @examplesIf gdal_version_num() >= gdal_compute_version(3, 2, 0) && isTRUE(gdal_formats("netCDF")$multidim_raster)
#' f <- system.file("extdata/byte.nc", package="gdalraster")
#' mdim_info(f)
mdim_info <- function(dsn, array_name = "", pretty = TRUE, detailed = FALSE, limit = -1L, stats = FALSE, array_options = NULL, allowed_drivers = NULL, open_options = NULL, cout = TRUE) {
    invisible(.Call(`_gdalraster_mdim_info`, dsn, array_name, pretty, detailed, limit, stats, array_options, allowed_drivers, open_options, cout))
}

#' Convert multidimensional data between different formats, and subset
#'
#' `mdim_translate()` is an interface to the \command{gdalmdimtranslate}
#' command-line utility (see
#' \url{https://gdal.org/en/stable/programs/gdalmdimtranslate.html}).
#' This function converts multidimensional data between different formats and
#' performs subsetting. Requires GDAL >= 3.2.
#'
#' @details
#' \subsection{Array creation options}{
#' Array creation options must be prefixed with `ARRAY:`. The scope may be
#' further restricted to arrays of a certain dimension by adding
#' `IF(DIM={ndims}):` after `ARRAY:`. For example,
#' `"ARRAY:IF(DIM=2):BLOCKSIZE=256,256"` will restrict `BLOCKSIZE=256,256` to
#' arrays of dimension 2. Restriction to arrays of a given name is done with
#' adding `IF(NAME={name}):` after `ARRAY:`. `{name}` can also be a fully
#' qualified name. A non-driver specific array option, `"AUTOSCALE=YES"` can
#' be used to ask (non indexing) variables of type `Float32` or `Float64` to be
#' scaled to `UInt16` with scale and offset values being computed from the
#' minimum and maximum of the source array. The integer data type used can be
#' set with `"AUTOSCALE_DATA_TYPE=Byte|UInt16|Int16|UInt32|Int32"`.
#' }
#'
#' \subsection{`array_specs`}{
#' Instead of converting the whole dataset, select one or more arrays, and
#' possibly perform operations on them. One or more array specifications can
#' be given as elements of a character vector.
#'
#' An array specification may be just an array name, potentially using a fully
#' qualified syntax (`"/group/subgroup/array_name"`). Or it can be a
#' combination of options with the syntax:
#' ```
#' "name={src_array_name}[,dstname={dst_array_name}][,resample=yes][,transpose=[{axis1},{axis2},...][,view={view_expr}]"
#' ```
#' The following options are processed in that order:
#'
#' * `resample=yes` asks for the array to run through
#'   `GDALMDArray::GetResampled()`.
#' * \code{[{axis1},{axis2},...]} is the argument of
#'   `GDALMDArray::Transpose()`. For example, `transpose=[1,0]` switches the
#'   axis order of a 2D array.
#' * `{view_expr}` is the value of the `viewExpr` argument of
#'   `GDALMDArray::GetView()`. When specifying a `view_expr` that performs a
#'   slicing or subsetting on a dimension, the equivalent operation will be
#'   applied to the corresponding indexing variable. See `?mdim_as_classic` for
#'   details on view expressions.
#' }
#'
#' \subsection{`group_specs`}{
#' Instead of converting the whole dataset, select one or more groups, and
#' possibly perform operations on them. One or more group specifications can
#' be given in a character vector, to operate on different groups. If only one
#' group is specified, its content will be copied directly to the target root
#' group. If several are specified, they are copied under the target root
#' group.
#'
#' A group specification may be just a group name, potentially using a fully
#' qualified syntax (`"/group/subgroup/subsubgroup_name"`). Or it can be a
#' combination of options with the syntax:
#' ```
#' "name={src_group_name}[,dstname={dst_group_name}][,recursive=no]"
#' ```
#' }
#'
#' \subsection{`subset_specs`}{
#' Perform subsetting (trimming or slicing) operations along dimensions,
#' provided that the dimension is indexed by a 1D variable of numeric or string
#' data type, and whose values are monotonically sorted. One or more subset
#' specifications can be given in a character vector. A subset specification
#' string follows exactly the OGC WCS 2.0 KVP encoding for subsetting.
#'
#' Syntax is `"dim_name(min_val,max_val)"` or `"dim_name(sliced_val)"`. The
#' first syntax will subset the dimension dim_name to values in the
#' \code{[min_val,max_val]} range. The second syntax will slice the dimension
#' `dim_name` to value `sliced_val` (and this dimension will be removed from
#' the arrays that reference to it)
#'
#' Using a subset specification is incompatible with specifying a view option
#' in `array_specs`.
#' }
#'
#' \subsection{`scaleaxes_specs`}{
#' Applies an integral scale factor to one or several dimensions, i.e., extract
#' 1 value every N values (without resampling). A scale-axes specification
#' string follows exactly the syntax of the KVP encoding of the SCALEAXES
#' parameter of OGC WCS 2.0 Scaling Extension, but limited to integer scale
#' factors.
#'
#' Syntax is a character string of the form:
#' ```
#' "<dim1_name>(<scale_factor>)[,<dim2_name>(<scale_factor>)]..."
#' ```
#'
#' Using a scale-axes specification is incompatible with specifying a view
#' option in `array_specs`.
#' }
#'
#' @param src_dsn Character string giving the name of the source
#' multidimensional raster dataset (e.g., file, VSI path).
#' @param dst_dsn Character string giving the name of the destination
#' multidimensional raster dataset (e.g., file, VSI path).
#' @param output_format Character string giving the output format (driver short
#' name). This can be a format that supports multidimensional output (such as
#' NetCDF: Network Common Data Form, Multidimensional VRT), or a "classic" 2D
#' format, if only one single 2D array results from the other specified
#' conversion operations. When this option is not specified (i.e., empty string
#' `""`), the format is guessed when possible from the extension of `dst_dsn`.
#' @param creation_options Optional character vector of format-specific
#' creation options as `"NAME=VALUE"` pairs. A list of options supported for a
#' format can be obtained with `getCreationOptions()`, but the documentation
#' for the format is the definitive source of information on driver creation
#' options (see \url{https://gdal.org/en/stable/drivers/raster/index.html}).
#' Array-level creation options may be passed by prefixing them with `ARRAY:`
#' (see Details).
#' @param array_specs Optional character vector of one or more array
#' specifications, instead of converting the whole dataset (see Details).
#' @param group_specs Optional character vector of one or more array
#' specifications, instead of converting the whole dataset (see Details).
#' @param subset_specs Optional character vector of one or more subset
#' specifications, that perform trimming or slicing along a dimension, provided
#' that it is indexed by a 1D variable of numeric or string data type, and
#' whose values are monotonically sorted (see Details).
#' @param scaleaxes_specs Optional character string for a scale-axes
#' specification, that apply an integral scale factor to one or several
#' dimensions, i.e., extract 1 value every N values (without resampling) (see
#' Details).
#' @param allowed_drivers Optional character vector of driver short names that
#' must be considered when opening `src_dsn`. It is generally not necessary to
#' specify it, but it can be used to skip automatic driver detection, when it
#' fails to select the appropriate driver.
#' @param open_options Optional character vector of format-specific dataset
#' open options for `src_dsn` as `"NAME=VALUE"` pairs.
#' @param strict Logical value, `FALSE` (the default) some failures during the
#' translation are tolerated, such as not being able to write group attributes.
#' If set to `TRUE`, such failures will cause the process to fail.
#' @param quiet Logical value, set to `TRUE` to disable progress reporting.
#' Defaults to `FALSE`.
#' @returns Logical value indicating success (invisible `TRUE`, output written
#' to `dst_dsn`). An error is raised if the operation fails.
#'
#' @seealso
#' [mdim_as_classic()], [mdim_info()]
#'
#' @examplesIf gdal_version_num() >= gdal_compute_version(3, 2, 0) && isTRUE(gdal_formats("netCDF")$multidim_raster)
#' f_src <- system.file("extdata/byte.nc", package="gdalraster")
#'
#' ## COMPRESS option for MDArray creation
#' opt <- NULL
#' if (isTRUE(gdal_get_driver_md("netCDF")$NETCDF_HAS_NC4 == "YES")) {
#'   # 4 x 4 is for illustration only, the sample dataset is only 20 x 20
#'   opt <- c("ARRAY:IF(DIM=2):BLOCKSIZE=4,4",
#'            "ARRAY:IF(NAME=Band1):COMPRESS=DEFLATE",
#'            "ARRAY:ZLEVEL=6")
#' }
#'
#' f_dst <- tempfile(fileext = ".nc")
#' mdim_translate(f_src, f_dst, creation_options = opt)
#' info <- mdim_info(f_dst, cout = FALSE) |> yyjsonr::read_json_str()
#' # str(info)
#' info$structural_info
#' info$arrays$Band1$block_size
#' info$arrays$Band1$structural_info
#'
#' (ds <- mdim_as_classic(f_dst, "Band1", 1, 0))
#'
#' plot_raster(ds, interpolate = FALSE, legend = TRUE, main = "Band1")
#'
#' ds$close()
#'
#' ## slice along the Y axis with array view
#' f_dst2 <- tempfile(fileext = ".nc")
#' mdim_translate(f_src, f_dst2, array_specs = "name=Band1,view=[10:20,...]")
#' (ds <- mdim_as_classic(f_dst2, "Band1", 1, 0))
#'
#' plot_raster(ds, interpolate = FALSE, legend = TRUE,
#'             main = "Band1[10:20,...]")
#'
#' ds$close()
#'
#' ## trim X and Y by subsetting
#' f_dst3 <- tempfile(fileext = ".nc")
#' subsets <- c("x(441000,441800)", "y(3750400,3751000)")
#' mdim_translate(f_src, f_dst3, subset_specs = subsets)
#' (ds <- mdim_as_classic(f_dst3, "Band1", 1, 0))
#'
#' plot_raster(ds, interpolate = FALSE, legend = TRUE,
#'             main = "Band1 trimmed")
#'
#' ds$close()
#'
#' ## subsample along X and Y
#' f_dst4 <- tempfile(fileext = ".nc")
#' mdim_translate(f_src, f_dst4, scaleaxes_specs = "x(2),y(2)")
#' (ds <- mdim_as_classic(f_dst4, "Band1", 1, 0))
#'
#' plot_raster(ds, interpolate = FALSE, legend = TRUE,
#'             main = "Band1 subsampled")
#'
#' ds$close()
#' \dontshow{deleteDataset(f_dst)}
#' \dontshow{deleteDataset(f_dst2)}
#' \dontshow{deleteDataset(f_dst3)}
#' \dontshow{deleteDataset(f_dst4)}
mdim_translate <- function(src_dsn, dst_dsn, output_format = "", creation_options = NULL, array_specs = NULL, group_specs = NULL, subset_specs = NULL, scaleaxes_specs = NULL, allowed_drivers = NULL, open_options = NULL, strict = FALSE, quiet = FALSE) {
    invisible(.Call(`_gdalraster_mdim_translate`, src_dsn, dst_dsn, output_format, creation_options, array_specs, group_specs, subset_specs, scaleaxes_specs, allowed_drivers, open_options, strict, quiet))
}

#' Copy a source file to a target filename
#'
#' `vsi_copy_file()` is a wrapper for `VSICopyFile()` in the GDAL Common
#' Portability Library. The GDAL VSI functions allow virtualization of disk
#' I/O so that non file data sources can be made to appear as files.
#' See \url{https://gdal.org/en/stable/user/virtual_file_systems.html}.
#' Requires GDAL >= 3.7.
#'
#' @details
#' The following copies are made fully on the target server, without local
#' download from source and upload to target:
#' * /vsis3/ -> /vsis3/
#' * /vsigs/ -> /vsigs/
#' * /vsiaz/ -> /vsiaz/
#' * /vsiadls/ -> /vsiadls/
#' * any of the above or /vsicurl/ -> /vsiaz/ (starting with GDAL 3.8)
#'
#' @param src_file Character string. Filename of the source file.
#' @param target_file Character string. Filename of the target file.
#' @param show_progress Logical scalar. If `TRUE`, a progress bar will be
#' displayed (the size of `src_file` will be retrieved in GDAL with
#' `VSIStatL()`). Default is `FALSE`.
#' @returns `0` on success or `-1` on an error.
#'
#' @note
#' If `target_file` has the form /vsizip/foo.zip/bar, the default options
#' described for the function `addFilesInZip()` will be in effect.
#'
#' @seealso
#' [copyDatasetFiles()], [vsi_stat()], [vsi_sync()]
#'
#' @examples
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' tmp_file <- "/vsimem/elev_temp.tif"
#'
#' # Requires GDAL >= 3.7
#' if (gdal_version_num() >= gdal_compute_version(3, 7, 0)) {
#'   result <- vsi_copy_file(elev_file, tmp_file)
#'   (result == 0)
#'   print(vsi_stat(tmp_file, "size"))
#'
#'   vsi_unlink(tmp_file)
#' }
vsi_copy_file <- function(src_file, target_file, show_progress = FALSE) {
    .Call(`_gdalraster_vsi_copy_file`, src_file, target_file, show_progress)
}

#' Clean cache associated with /vsicurl/ and related file systems
#'
#' `vsi_curl_clear_cache()` cleans the local cache associated with /vsicurl/
#' (and related file systems). This function is a wrapper for
#' `VSICurlClearCache()` and `VSICurlPartialClearCache()` in the GDAL Common
#' Portability Library. See Details for the GDAL documentation.
#'
#' @details
#' /vsicurl/ (and related file systems like /vsis3/, /vsigs/, /vsiaz/,
#' /vsioss/, /vsiswift/) cache a number of metadata and data for faster
#' execution in read-only scenarios. But when the content on the server-side
#' may change during the same process, those mechanisms can prevent opening
#' new files, or give an outdated version of them.
#' If `partial = TRUE`, cleans the local cache associated for a given filename
#' (and its subfiles and subdirectories if it is a directory).
#'
#' @param partial Logical scalar. Whether to clear the cache only for a given
#' filename (see Details).
#' @param file_prefix Character string. Filename prefix to use if
#' `partial = TRUE`.
#' @param quiet Logical scalar. `TRUE` (the default) to wrap the API call in
#' a quiet error handler, or `FALSE` to print any potential error messages to
#' the console.
#' @returns No return value, called for side effects.
#'
#' @examples
#' vsi_curl_clear_cache()
vsi_curl_clear_cache <- function(partial = FALSE, file_prefix = "", quiet = TRUE) {
    invisible(.Call(`_gdalraster_vsi_curl_clear_cache`, partial, file_prefix, quiet))
}

#' Read names in a directory
#'
#' `vsi_read_dir()` abstracts access to directory contents. It returns a
#' character vector containing the names of files and directories in this
#' directory. With `recursive = TRUE`, reads the list of entries in the
#' directory and subdirectories.
#' This function is a wrapper for `VSIReadDirEx()` and `VSIReadDirRecursive()`
#' in the GDAL Common Portability Library.
#'
#' @param path Character string. The relative or absolute path of a
#' directory to read.
#' @param max_files Integer scalar. The maximum number of files after which to
#' stop, or 0 for no limit (see Note). Ignored if `recursive = TRUE`.
#' @param recursive Logical scalar. `TRUE` to read the directory and its
#' subdirectories. Defaults to `FALSE`.
#' @param all_files Logical scalar. If `FALSE` (the default), only the names
#' of visible files are returned (following Unix-style visibility, that is
#' files whose name does not start with a dot). If `TRUE`, all file names
#' will be returned.
#' @returns A character vector containing the names of files and directories
#' in the directory given by `path` (may be an empty vector `character(0)`).
#' The listing is in alphabetical order, and does not include the special
#' entries '.' and '..' even if they are present in the directory. An empty
#' vector (`character(0)`) is returned if `path` does not exist.
#'
#' @note
#' If `max_files` is set to a positive number, directory listing will stop
#' after that limit has been reached. Note that to indicate truncation, at
#' least one element more than the `max_files` limit will be returned. If the
#' length of the returned character vector is lesser or equal to `max_files`,
#' then no truncation occurred. The `max_files` parameter is ignored when
#' `recursive = TRUE`.
#'
#' @seealso
#' [vsi_glob()], [vsi_mkdir()], [vsi_rmdir()], [vsi_stat()], [vsi_sync()]
#'
#' @examples
#' # regular file system for illustration
#' data_dir <- system.file("extdata", package="gdalraster")
#' vsi_read_dir(data_dir)
vsi_read_dir <- function(path, max_files = 0L, recursive = FALSE, all_files = FALSE) {
    .Call(`_gdalraster_vsi_read_dir`, path, max_files, recursive, all_files)
}

#' Get file and directory names matching a pattern that may contain wildcards
#'
#' `vsi_glob()` returns a character vector of file and directory names matching
#' a pattern that can contain wildcards. This function has similar behavior to
#' the POSIX `glob()` function. Wrapper of `VSIGlob()` in the GDAL Common
#' Portability Library. Requires GDAL >= 3.11.
#'
#' @details
#' The following wildcards are supported
#'   * `*`: match any string
#'   * `?`: match any single character
#'   * `[`: match character class or range, with `!` immediately after `[` to
#'   indicate negation
#'
#' Refer to to the `glob()` man page for more details
#' (\url{https://man7.org/linux/man-pages/man7/glob.7.html}).
#' It also supports the `**` recursive wildcard, behaving similarly to Python
#' `glob.glob()` with `recursive = True`. Be careful of the amount of memory
#' and time required when using the recursive wildcard on directories with a
#' large amount of files and subdirectories.
#'
#' Examples, given a file hierarchy:
#'   * `one.tif`
#'   * `my_subdir/two.tif`
#'   * `my_subdir/subsubdir/three.tif`
#'
#' ```
#' vsi_glob("one.tif")
#'   # returns ("one.tif")
#' vsi_glob("*.tif")
#'   # returns ("one.tif")
#' vsi_glob("on?.tif")
#'   # returns ("one.tif")
#' vsi_glob("on[a-z].tif")
#'   # returns ("one.tif")
#' vsi_glob("on[ef].tif")
#'   # returns ("one.tif")
#' vsi_glob("on[!e].tif")
#'   # returns empty vector character()
#' vsi_glob("my_subdir/*.tif")
#'   # returns ("my_subdir/two.tif")
#' vsi_glob("**/*.tif") returns
#'   # returns ("one.tif", "my_subdir/two.tif", "my_subdir/subsubdir/three.tif")
#' ```
#'
#' In the current implementation, matching is done based on the assumption that
#' a character fits into a single byte, which will not work properly on
#' non-ASCII UTF-8 filenames.
#'
#' @param pattern Character string. The relative or absolute path of a
#' directory to read, potentially containing wildcards, assumed to be UTF-8
#' encoded (see Details).
#' @param show_progress Logical scalar. If `TRUE`, a progress bar will be
#' displayed. Default is `FALSE`.
#' @returns A character vector containing the matching names of files and
#' directories.
#'
#' @note
#' GDAL's `VSIGlob()` works with any virtual file systems supported by GDAL,
#' including network file systems such as /vsis3/, /vsigs/, /vsiaz/, etc. But
#' note that for those, the pattern is not passed to the remote server, and
#' thus a large amount of filenames can be transferred from the remote server
#' to the host where the filtering is done.
#'
#' @seealso
#' [vsi_read_dir()]
#'
#' @examplesIf gdal_version_num() >= gdal_compute_version(3, 11, 0)
#' # Requires GDAL >= 3.11
#' data_dir <- system.file("extdata", package="gdalraster")
#' vsi_glob(file.path(data_dir, "ynp*"))
vsi_glob <- function(pattern, show_progress = FALSE) {
    .Call(`_gdalraster_vsi_glob`, pattern, show_progress)
}

#' Synchronize a source file/directory with a target file/directory
#'
#' `vsi_sync()` is a wrapper for `VSISync()` in the GDAL Common Portability
#' Library. The GDAL documentation is given in Details.
#'
#' @details
#' `VSISync()` is an analog of the Linux `rsync` utility. In the current
#' implementation, `rsync` would be more efficient for local file copying,
#' but `VSISync()` main interest is when the source or target is a remote
#' file system like /vsis3/ or /vsigs/, in which case it can take into account
#' the timestamps of the files (or optionally the ETag/MD5Sum) to avoid
#' unneeded copy operations.
#' This is only implemented efficiently for:
#' * local filesystem <--> remote filesystem
#' * remote filesystem <--> remote filesystem (starting with GDAL 3.1)\cr
#' Where the source and target remote filesystems are the same and one of
#' /vsis3/, /vsigs/ or /vsiaz/. Or when the target is /vsiaz/ and the source
#' is /vsis3/, /vsigs/, /vsiadls/ or /vsicurl/ (starting with GDAL 3.8)
#'
#' Similarly to `rsync` behavior, if the source filename ends with a slash, it
#' means that the content of the directory must be copied, but not the
#' directory name. For example, assuming "/home/even/foo" contains a file
#' "bar", `VSISync("/home/even/foo/", "/mnt/media", ...)` will create a
#' "/mnt/media/bar" file.
#' Whereas `VSISync("/home/even/foo", "/mnt/media", ...)` will create a
#' "/mnt/media/foo" directory which contains a bar file.
#'
#' The `options` argument accepts a character vector of name=value pairs.
#' Currently accepted options are:\cr
#' * `RECURSIVE=NO` (the default is `YES`)
#' * `SYNC_STRATEGY=TIMESTAMP/ETAG/OVERWRITE`. Determines which criterion is
#' used to determine if a target file must be replaced when it already exists
#' and has the same file size as the source. Only applies for a source or
#' target being a network filesystem.
#' The default is `TIMESTAMP` (similarly to how 'aws s3 sync' works), that is
#' to say that for an upload operation, a remote file is replaced if it has a
#' different size or if it is older than the source. For a download operation,
#' a local file is replaced if it has a different size or if it is newer than
#' the remote file.
#' The `ETAG` strategy assumes that the ETag metadata of the remote file is
#' the MD5Sum of the file content, which is only true in the case of /vsis3/
#' for files not using KMS server side encryption and uploaded in a single PUT
#' operation (so smaller than 50 MB given the default used by GDAL). Only to
#' be used for /vsis3/, /vsigs/ or other filesystems using a MD5Sum as ETAG.
#' The `OVERWRITE` strategy (GDAL >= 3.2) will always overwrite the target
#' file with the source one.\cr
#' * `NUM_THREADS=integer`. Number of threads to use for parallel file
#' copying. Only use for when /vsis3/, /vsigs/, /vsiaz/ or /vsiadls/ is
#' in source or target. The default is 10 since GDAL 3.3.\cr
#' * `CHUNK_SIZE=integer`. Maximum size of chunk (in bytes) to use to split
#' large objects when downloading them from /vsis3/, /vsigs/, /vsiaz/
#' or /vsiadls/ to local file system, or for upload to /vsis3/, /vsiaz/ or
#' /vsiadls/ from local file system. Only used if `NUM_THREADS > 1`.
#' For upload to /vsis3/, this chunk size must be set at least to 5 MB. The
#' default is 8 MB since GDAL 3.3.\cr
#' * `x-amz-KEY=value`. (GDAL >= 3.5) MIME header to pass during creation of a
#' /vsis3/ object.\cr
#' * `x-goog-KEY=value`. (GDAL >= 3.5) MIME header to pass during creation of a
#' /vsigs/ object.\cr
#' * `x-ms-KEY=value`. (GDAL >= 3.5) MIME header to pass during creation of a
#' /vsiaz/ or /vsiadls/ object.
#'
#' @param src Character string. Source file or directory.
#' @param target Character string. Target file or directory.
#' @param show_progress Logical scalar. If `TRUE`, a progress bar will be
#' displayed. Defaults to `FALSE`.
#' @param options Character vector of `NAME=VALUE` pairs (see Details).
#' @returns Logical scalar, `TRUE` on success or `FALSE` on an error.
#'
#' @seealso
#' [copyDatasetFiles()], [vsi_copy_file()]
#'
#' @examples
#' \dontrun{
#' # sample-data is a directory in the git repository for gdalraster that is
#' # not included in the R package:
#' # https://github.com/firelab/gdalraster/tree/main/sample-data
#' # A copy of sample-data in an AWS S3 bucket, and a partial copy in an
#' # Azure Blob container, were used to generate the example below.
#'
#' src <- "/vsis3/gdalraster-sample-data/"
#' # s3://gdalraster-sample-data is not public, set credentials
#' set_config_option("AWS_ACCESS_KEY_ID", "xxxxxxxxxxxxxx")
#' set_config_option("AWS_SECRET_ACCESS_KEY", "xxxxxxxxxxxxxxxxxxxxxxxxxxxxx")
#' vsi_read_dir(src)
#' #> [1] "README.md"
#' #> [2] "bl_mrbl_ng_jul2004_rgb_720x360.tif"
#' #> [3] "blue_marble_ng_neo_metadata.xml"
#' #> [4] "landsat_c2ard_sr_mt_hood_jul2022_utm.json"
#' #> [5] "landsat_c2ard_sr_mt_hood_jul2022_utm.tif"
#' #> [6] "lf_elev_220_metadata.html"
#' #> [7] "lf_elev_220_mt_hood_utm.tif"
#' #> [8] "lf_fbfm40_220_metadata.html"
#' #> [9] "lf_fbfm40_220_mt_hood_utm.tif"
#'
#' dst <- "/vsiaz/sampledata"
#' set_config_option("AZURE_STORAGE_CONNECTION_STRING",
#'                   "<connection_string_for_gdalraster_account>")
#' vsi_read_dir(dst)
#' #> [1] "lf_elev_220_metadata.html"   "lf_elev_220_mt_hood_utm.tif"
#'
#' # GDAL VSISync() supports direct copy for /vsis3/ -> /vsiaz/ (GDAL >= 3.8)
#' result <- vsi_sync(src, dst, show_progress = TRUE)
#' #> 0...10...20...30...40...50...60...70...80...90...100 - done.
#' print(result)
#' #> [1] TRUE
#' vsi_read_dir(dst)
#' #> [1] "README.md"
#' #> [2] "bl_mrbl_ng_jul2004_rgb_720x360.tif"
#' #> [3] "blue_marble_ng_neo_metadata.xml"
#' #> [4] "landsat_c2ard_sr_mt_hood_jul2022_utm.json"
#' #> [5] "landsat_c2ard_sr_mt_hood_jul2022_utm.tif"
#' #> [6] "lf_elev_220_metadata.html"
#' #> [7] "lf_elev_220_mt_hood_utm.tif"
#' #> [8] "lf_fbfm40_220_metadata.html"
#' #> [9] "lf_fbfm40_220_mt_hood_utm.tif"
#' }
vsi_sync <- function(src, target, show_progress = FALSE, options = NULL) {
    .Call(`_gdalraster_vsi_sync`, src, target, show_progress, options)
}

#' Create a directory
#'
#' `vsi_mkdir()` creates a new directory with the indicated mode.
#' For POSIX-style systems, the mode is modified by the file creation mask
#' (umask). However, some file systems and platforms may not use umask, or
#' they may ignore the mode completely. So a reasonable cross-platform
#' default mode value is `0755`.
#' With `recursive = TRUE`, creates a directory and all its ancestors.
#' This function is a wrapper for `VSIMkdir()` and `VSIMkdirRecursive()` in
#' the GDAL Common Portability Library.
#'
#' @param path Character string. The path to the directory to create.
#' @param mode Character string. The permissions mode in octal with prefix
#' `0`, e.g., `"0755"` (the default).
#' @param recursive Logical scalar. `TRUE` to create the directory and its
#' ancestors. Defaults to `FALSE`.
#' @returns `0` on success or `-1` on an error.
#'
#' @seealso
#' [vsi_read_dir()], [vsi_rmdir()]
#'
#' @examples
#' new_dir <- file.path(tempdir(), "newdir")
#' vsi_mkdir(new_dir)
#' vsi_stat(new_dir, "type")
#' vsi_rmdir(new_dir)
vsi_mkdir <- function(path, mode = "0755", recursive = FALSE) {
    .Call(`_gdalraster_vsi_mkdir`, path, mode, recursive)
}

#' Delete a directory
#'
#' `vsi_rmdir()` deletes a directory object from the file system. On some
#' systems the directory must be empty before it can be deleted.
#' With `recursive = TRUE`, deletes a directory object and its content from
#' the file system.
#' This function goes through the GDAL `VSIFileHandler` virtualization and may
#' work on unusual filesystems such as in memory.
#' It is a wrapper for `VSIRmdir()` and `VSIRmdirRecursive()` in the GDAL
#' Common Portability Library.
#'
#' @param path Character string. The path to the directory to be deleted.
#' @param recursive Logical scalar. `TRUE` to delete the directory and its
#' content. Defaults to `FALSE`.
#' @returns `0` on success or `-1` on an error.
#'
#' @note
#' /vsis3/ has an efficient implementation for deleting recursively. Starting
#' with GDAL 3.4, /vsigs/ has an efficient implementation for deleting
#' recursively, provided that OAuth2 authentication is used.
#'
#' @seealso
#' [deleteDataset()], [vsi_mkdir()], [vsi_read_dir()], [vsi_unlink()]
#'
#' @examples
#' new_dir <- file.path(tempdir(), "newdir")
#' vsi_mkdir(new_dir)
#' vsi_rmdir(new_dir)
vsi_rmdir <- function(path, recursive = FALSE) {
    .Call(`_gdalraster_vsi_rmdir`, path, recursive)
}

#' Delete a file
#'
#' `vsi_unlink()` deletes a file object from the file system.
#' This function goes through the GDAL `VSIFileHandler` virtualization and may
#' work on unusual filesystems such as in memory.
#' It is a wrapper for `VSIUnlink()` in the GDAL Common Portability Library.
#' Analog of the POSIX `unlink()` function.
#'
#' @param filename Character string. The path of the file to be deleted.
#' @returns `0` on success or `-1` on an error.
#'
#' @seealso
#' [deleteDataset()], [vsi_rmdir()], [vsi_unlink_batch()]
#'
#' @examples
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' mem_file <- file.path("/vsimem", "tmp.tif")
#' copyDatasetFiles(mem_file, elev_file)
#' vsi_read_dir("/vsimem")
#' vsi_unlink(mem_file)
#' vsi_read_dir("/vsimem")
vsi_unlink <- function(filename) {
    .Call(`_gdalraster_vsi_unlink`, filename)
}

#' Delete several files in a batch
#'
#' `vsi_unlink_batch()` deletes a list of files passed in a character vector.
#' All files should belong to the same file system handler.
#' This is implemented efficiently for /vsis3/ and /vsigs/ (provided for
#' /vsigs/ that OAuth2 authentication is used).
#' This function is a wrapper for `VSIUnlinkBatch()` in the GDAL Common
#' Portability Library.
#'
#' @param filenames Character vector. The list of files to delete.
#' @returns Logical vector of `length(filenames)` with values depending
#' on the success of deletion of the corresponding file.
#' `NULL` might be returned in case of a more general error (for example,
#' files belonging to different file system handlers).
#'
#' @seealso
#' [deleteDataset()], [vsi_rmdir()], [vsi_unlink()]
#'
#' @examples
#' # regular file system for illustration
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' tcc_file <- system.file("extdata/storml_tcc.tif", package="gdalraster")
#'
#' tmp_elev <- file.path(tempdir(), "tmp_elev.tif")
#' file.copy(elev_file, tmp_elev)
#' tmp_tcc <- file.path(tempdir(), "tmp_tcc.tif")
#' file.copy(tcc_file, tmp_tcc)
#' vsi_unlink_batch(c(tmp_elev, tmp_tcc))
vsi_unlink_batch <- function(filenames) {
    .Call(`_gdalraster_vsi_unlink_batch`, filenames)
}

#' Get filesystem object info
#'
#' These functions work on GDAL virtual file systems such as in-memory
#' (/vsimem/), URLs (/vsicurl/), cloud storage services (e.g., /vsis3/,
#' /vsigs/, /vsiaz/, etc.), compressed archives (e.g., /vsizip, /vsitar/,
#' /vsi7z/, /vsigzip/, etc.), and others including "standard" file systems.
#' See \url{https://gdal.org/en/stable/user/virtual_file_systems.html}.
#'
#' @name vsi_stat
#'
#' @details
#' `vsi_stat()` fetches status information about a single filesystem object
#' (file, directory, etc). It is a wrapper for `VSIStatExL()` in the GDAL
#' Common Portability Library. Analog of the POSIX `stat()` function.
#'
#' `vsi_stat_exists()`, `vsi_stat_type()` and `vsi_stat_size()` are
#' specializations operating on a vector of potentially multiple file system
#' object names, returning, respectfully, a logical vector, a character vector,
#' and a numeric vector carrying the `bit64::integer64` class attribute.
#'
#' @param filename Character string. The path of the filesystem object to be
#' queried.
#' @param info Character string. The type of information to fetch, one of
#' `"exists"` (the default), `"type"` or `"size"`.
#' @param filenames Character vector of filesystem objects to query.
#' @returns
#' If `info = "exists"`, `vsi_stat()` returns logical `TRUE` if the file system
#' object exists, otherwise `FALSE`. If `info = "type"`, returns a character
#' string with one of `"file"` (regular file), `"dir"` (directory),
#' `"symlink"` (symbolic link), or empty string (`""`). If `info = "size"`,
#' returns the file size in bytes (as `bit64::integer64` type), or `-1` if an
#' error occurs.
#' `vsi_stat_exists()` returns a logical vector. `vsi_stat_type()` returns a
#' character vector. `vsi_stat_size()` returns a numeric vector carrying the
#' `bit64::integer64` class attribute.
#'
#' @note
#' For portability, `vsi_stat()` supports a subset of `stat()`-type
#' information for filesystem objects. This function is primarily intended
#' for use with GDAL virtual file systems (e.g., URLs, cloud storage systems,
#' ZIP/GZip/7z/RAR archives, in-memory files), but can also be used on
#' "standard" file systems (e.g., in the / hierarchy on Unix-like systems or
#' in C:, D:, etc. drives on Windows).
#'
#' @seealso
#' GDAL Virtual File Systems:\cr
#' \url{https://gdal.org/en/stable/user/virtual_file_systems.html}
#'
#' @examples
#' data_dir <- system.file("extdata", package="gdalraster")
#' vsi_stat(data_dir)
#' vsi_stat(data_dir, "type")
#' # stat() on a directory doesn't return the sum of the file sizes in it,
#' # but rather how much space is used by the directory entry
#' vsi_stat(data_dir, "size")
#'
#' elev_file <- file.path(data_dir, "storml_elev.tif")
#' vsi_stat(elev_file)
#' vsi_stat(elev_file, "type")
#' vsi_stat(elev_file, "size")
#'
#' nonexistent <- file.path(data_dir, "nonexistent.tif")
#' vsi_stat(nonexistent)
#' vsi_stat(nonexistent, "type")
#' vsi_stat(nonexistent, "size")
#'
#' fs_objects <- c(data_dir, elev_file, nonexistent)
#' vsi_stat_exists(fs_objects)
#' vsi_stat_type(fs_objects)
#' vsi_stat_size(fs_objects)
#'
#' # /vsicurl/ file system handler
#' base_url <- "https://raw.githubusercontent.com/firelab/"
#' f <- "gdalraster/main/sample-data/landsat_c2ard_sr_mt_hood_jul2022_utm.tif"
#' url_file <- paste0("/vsicurl/", base_url, f)
#'
#' # try to be CRAN-compliant for the example:
#' set_config_option("GDAL_HTTP_CONNECTTIMEOUT", "10")
#' set_config_option("GDAL_HTTP_TIMEOUT", "10")
#'
#' vsi_stat(url_file)
#' vsi_stat(url_file, "type")
#' vsi_stat(url_file, "size")
vsi_stat <- function(filename, info = "exists") {
    .Call(`_gdalraster_vsi_stat`, filename, info)
}

#' @rdname vsi_stat
vsi_stat_exists <- function(filenames) {
    .Call(`_gdalraster_vsi_stat_exists`, filenames)
}

#' @rdname vsi_stat
vsi_stat_type <- function(filenames) {
    .Call(`_gdalraster_vsi_stat_type`, filenames)
}

#' @rdname vsi_stat
vsi_stat_size <- function(filenames) {
    .Call(`_gdalraster_vsi_stat_size`, filenames)
}

#' Rename a file
#'
#' `vsi_rename()` renames a file object in the file system. The GDAL
#' documentation states it should be possible to rename a file onto a new
#' filesystem, but it is safest if this function is only used to rename files
#' that remain in the same directory.
#' This function goes through the GDAL `VSIFileHandler` virtualization and may
#' work on unusual filesystems such as in memory.
#' It is a wrapper for `VSIRename()` in the GDAL Common Portability Library.
#' Analog of the POSIX `rename()` function.
#'
#' @param oldpath Character string. The name of the file to be renamed.
#' @param newpath Character string. The name the file should be given.
#' @returns `0` on success or `-1` on an error.
#'
#' @seealso
#' [renameDataset()], [vsi_copy_file()]
#'
#' @examples
#' # regular file system for illustration
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' tmp_file <- tempfile(fileext = ".tif")
#' file.copy(elev_file, tmp_file)
#' new_file <- file.path(dirname(tmp_file), "storml_elev_copy.tif")
#' vsi_rename(tmp_file, new_file)
#' vsi_stat(new_file)
#' vsi_unlink(new_file)
vsi_rename <- function(oldpath, newpath) {
    .Call(`_gdalraster_vsi_rename`, oldpath, newpath)
}

#' Return the list of virtual file system handlers currently registered
#'
#' `vsi_get_fs_prefixes()` returns the list of prefixes for virtual file
#' system handlers currently registered (e.g., `"/vsimem/"`, `"/vsicurl/"`,
#' etc). Wrapper for `VSIGetFileSystemsPrefixes()` in the GDAL API.
#'
#' @returns Character vector containing prefixes of the virtual file system
#' handlers.
#'
#' @seealso
#' [vsi_get_fs_options()]
#'
#' \url{https://gdal.org/en/stable/user/virtual_file_systems.html}
#'
#' @examples
#' vsi_get_fs_prefixes()
vsi_get_fs_prefixes <- function() {
    .Call(`_gdalraster_vsi_get_fs_prefixes`)
}

#' Return the list of options associated with a virtual file system handler
#' as a serialized XML string.
#'
#' Called from and documented in R/gdal_helpers.R
#' @noRd
.vsi_get_fs_options <- function(filename) {
    .Call(`_gdalraster_vsi_get_fs_options_`, filename)
}

#' Return whether the filesystem supports sequential write
#'
#' `vsi_supports_seq_write()` returns whether the filesystem supports
#' sequential write.
#' Wrapper for `VSISupportsSequentialWrite()` in the GDAL API.
#'
#' @param filename Character string. The path of the filesystem object to be
#' tested.
#' @param allow_local_tmpfile Logical scalar. `TRUE` if the filesystem is
#' allowed to use a local temporary file before uploading to the target
#' location.
#' @returns Logical scalar. `TRUE` if sequential write is supported.
#'
#' @note
#' The location GDAL uses for temporary files can be forced via the
#' `CPL_TMPDIR` configuration option.
#'
#' @seealso
#' [vsi_supports_rnd_write()]
#'
#' @examples
#' # Requires GDAL >= 3.6
#' if (gdal_version_num() >= gdal_compute_version(3, 6, 0))
#'   vsi_supports_seq_write("/vsimem/test-mem-file.gpkg", TRUE)
vsi_supports_seq_write <- function(filename, allow_local_tmpfile) {
    .Call(`_gdalraster_vsi_supports_seq_write`, filename, allow_local_tmpfile)
}

#' Return whether the filesystem supports random write
#'
#' `vsi_supports_rnd_write()` returns whether the filesystem supports
#' random write.
#' Wrapper for `VSISupportsRandomWrite()` in the GDAL API.
#'
#' @param filename Character string. The path of the filesystem object to be
#' tested.
#' @param allow_local_tmpfile Logical scalar. `TRUE` if the filesystem is
#' allowed to use a local temporary file before uploading to the target
#' location.
#' @returns Logical scalar. `TRUE` if random write is supported.
#'
#' @note
#' The location GDAL uses for temporary files can be forced via the
#' `CPL_TMPDIR` configuration option.
#'
#' @seealso
#' [vsi_supports_seq_write()]
#'
#' @examples
#' # Requires GDAL >= 3.6
#' if (gdal_version_num() >= gdal_compute_version(3, 6, 0))
#'   vsi_supports_rnd_write("/vsimem/test-mem-file.gpkg", TRUE)
vsi_supports_rnd_write <- function(filename, allow_local_tmpfile) {
    .Call(`_gdalraster_vsi_supports_rnd_write`, filename, allow_local_tmpfile)
}

#' Return free disk space available on the filesystem
#'
#' `vsi_get_disk_free_space()` returns the free disk space available on the
#' filesystem. Wrapper for `VSIGetDiskFreeSpace()` in the GDAL Common
#' Portability Library.
#'
#' @param path Character string. A directory of the filesystem to query.
#' @returns Numeric scalar. The free space in bytes (as `bit64::integer64`
#' type), or `-1` in case of error.
#'
#' @examples
#' tmp_dir <- file.path("/vsimem", "tmpdir")
#' vsi_mkdir(tmp_dir)
#' vsi_get_disk_free_space(tmp_dir)
#' vsi_rmdir(tmp_dir)
vsi_get_disk_free_space <- function(path) {
    .Call(`_gdalraster_vsi_get_disk_free_space`, path)
}

#' Set a path specific option for a given path prefix
#'
#' `vsi_set_path_option()` sets a path specific option for a given path
#' prefix. Such an option is typically, but not limited to, setting
#' credentials for a virtual file system.
#' Wrapper for `VSISetPathSpecificOption()` in the GDAL Common Portability
#' Library. Requires GDAL >= 3.6.
#'
#' @details
#' Options may also be set with `set_config_option()`, but
#' `vsi_set_path_option()` allows specifying them with a granularity at the
#' level of a file path. This makes it easier if using the same virtual file
#' system but with different credentials (e.g., different credentials for
#' buckets "/vsis3/foo" and "/vsis3/bar"). This is supported for the following
#' virtual file systems: /vsis3/, /vsigs/, /vsiaz/, /vsioss/, /vsiwebhdfs,
#' /vsiswift.
#'
#' @param path_prefix Character string. A path prefix of a virtual file system
#' handler. Typically of the form `/vsiXXX/bucket`.
#' @param key Character string. Option key.
#' @param value Character string. Option value. Passing `value = ""` (empty
#' string) will unset a value previously set by `vsi_set_path_option()`.
#' @returns No return value, called for side effect.
#'
#' @note
#' Setting options for a path starting with /vsiXXX/ will also apply for
#' /vsiXXX_streaming/ requests.
#'
#' No particular care is taken to store options in RAM in a secure way.
#' So they might accidentally hit persistent storage if swapping occurs,
#' or someone with access to the memory allocated by the process may be
#' able to read them.
#'
#' @seealso
#' [set_config_option()], [vsi_clear_path_options()]
vsi_set_path_option <- function(path_prefix, key, value) {
    invisible(.Call(`_gdalraster_vsi_set_path_option`, path_prefix, key, value))
}

#' Clear path specific configuration options
#'
#' `vsi_clear_path_options()` clears path specific options previously set
#' with `vsi_set_path_option()`.
#' Wrapper for `VSIClearPathSpecificOptions()` in the GDAL Common Portability
#' Library. Requires GDAL >= 3.6.
#'
#' @param path_prefix Character string. If set to `""` (empty string), all
#' path specific options are cleared. If set to a path prefix, only those
#' options set with `vsi_set_path_option(path_prefix, ...)` will be cleared.
#' @returns No return value, called for side effect.
#'
#' @note
#' No particular care is taken to remove options from RAM in a secure way.
#'
#' @seealso
#' [vsi_set_path_option()]
vsi_clear_path_options <- function(path_prefix) {
    invisible(.Call(`_gdalraster_vsi_clear_path_options`, path_prefix))
}

#' Get metadata on files
#'
#' `vsi_get_file_metadata()` returns metadata for file system objects.
#' Implemented for network-like filesystems. Starting with GDAL 3.7,
#' implemented for /vsizip/ with SOZip metadata.
#' Wrapper of `VSIGetFileMetadata()` in the GDAL Common Portability Library.
#'
#' @details
#' The metadata available depends on the file system. The following are
#' supported as of GDAL 3.9:
#'   * HEADERS: to get HTTP headers for network-like filesystems (/vsicurl/,
#'     /vsis3/, /vsgis/, etc).
#'   * TAGS: for /vsis3/, to get S3 Object tagging information. For /vsiaz/,
#'     to get blob tags.
#'   * STATUS: specific to /vsiadls/: returns all system-defined properties
#'     for a path (seems in practice to be a subset of HEADERS).
#'   * ACL: specific to /vsiadls/ and /vsigs/: returns the access control list
#'     for a path. For /vsigs/, a single `XML=xml_content` string is returned.
#'   * METADATA: specific to /vsiaz/: blob metadata (this will be a subset of
#'     what `domain=HEADERS` returns).
#'   * ZIP: specific to /vsizip/: to obtain ZIP specific metadata, in
#'     particular if a file is SOZIP-enabled (`SOZIP_VALID=YES`).
#'
#' @param filename Character string. The path of the file system object to be
#' queried.
#' @param domain Character string. Metadata domain to query. Depends on the
#' file system, see Details.
#' @returns A named list of values, or `NULL` in case of error or empty list.
#'
#' @seealso
#' [vsi_stat()], [addFilesInZip()]
#'
#' @examplesIf gdal_version_num() >= gdal_compute_version(3, 7, 0)
#' # validate an SOZip-enabled file
#' # Requires GDAL >= 3.7
#' f <- system.file("extdata/ynp_features.zip", package = "gdalraster")
#'
#' zf <- file.path("/vsizip", f)
#' # files in zip archive
#' vsi_read_dir(zf)
#'
#' # SOZip metadata for ynp_features.gpkg
#' zf_gpkg <- file.path(zf, "ynp_features.gpkg")
#' vsi_get_file_metadata(zf_gpkg, domain = "ZIP")
vsi_get_file_metadata <- function(filename, domain) {
    .Call(`_gdalraster_vsi_get_file_metadata`, filename, domain)
}

#' Returns the actual URL of a supplied VSI filename
#'
#' `vsi_get_actual_url()` returns the actual URL of a supplied filename.
#' Currently only returns a non-NULL value for network-based virtual file
#' systems. For example "/vsis3/bucket/filename" will be expanded as
#' "https://bucket.s3.amazon.com/filename".
#' Wrapper for `VSIGetActualURL()` in the GDAL API.
#'
#' @param filename Character string containing a /vsiPREFIX/ filename.
#' @returns Character string containing the actual URL, or `NULL` if
#' `filename` is not a network-based virtual file system.
#'
#' @seealso
#' [vsi_get_signed_url()]
#'
#' @examples
#' \dontrun{
#' f <- "/vsiaz/items/io-lulc-9-class.parquet"
#' set_config_option("AZURE_STORAGE_ACCOUNT", "pcstacitems")
#' # token obtained from:
#' # https://planetarycomputer.microsoft.com/api/sas/v1/token/pcstacitems/items
#' set_config_option("AZURE_STORAGE_SAS_TOKEN","<token>")
#' vsi_get_actual_url(f)
#' #> [1] "https://pcstacitems.blob.core.windows.net/items/io-lulc-9-class.parquet"
#' vsi_get_signed_url(f)
#' #> [1] "https://pcstacitems.blob.core.windows.net/items/io-lulc-9-class.parquet?<token>"
#' }
vsi_get_actual_url <- function(filename) {
    .Call(`_gdalraster_vsi_get_actual_url`, filename)
}

#' Returns a signed URL for a supplied VSI filename
#'
#' `vsi_get_signed_url()` Returns a signed URL of a supplied filename.
#' Currently only returns a non-NULL value for /vsis3/, /vsigs/, /vsiaz/ and
#' /vsioss/ For example "/vsis3/bucket/filename" will be expanded as
#' "https://bucket.s3.amazon.com/filename?X-Amz-Algorithm=AWS4-HMAC-SHA256..."
#' Configuration options that apply for file opening (typically to provide
#' credentials), and are returned by `vsi_get_fs_options()`, are also valid
#' in that context.
#' Wrapper for `VSIGetSignedURL()` in the GDAL API.
#'
#' @details
#' The `options` argument accepts a character vector of name=value pairs.
#' For /vsis3/, /vsigs/, /vsiaz/ and /vsioss/, the following options are
#' supported:
#' * `START_DATE=YYMMDDTHHMMSSZ`: date and time in UTC following ISO 8601
#'   standard, corresponding to the start of validity of the URL. If not
#'   specified, current date time.
#' * `EXPIRATION_DELAY=number_of_seconds`: number between 1 and 604800 (seven
#'   days) for the validity of the signed URL. Defaults to 3600 (one hour).
#' * `VERB=GET/HEAD/DELETE/PUT/POST`: HTTP VERB for which the request will be
#'   used. Defaults to `GET`.
#'
#' /vsiaz/ supports additional options:
#' * `SIGNEDIDENTIFIER=value`: to relate the given shared access signature to
#'   a corresponding stored access policy.
#' * `SIGNEDPERMISSIONS=r|w`: permissions associated with the shared access
#'   signature. Normally deduced from `VERB`.
#'
#' @param filename Character string containing a /vsiPREFIX/ filename.
#' @param options Character vector of `NAME=VALUE` pairs (see Details).
#' @returns Character string containing the signed URL, or `NULL` if
#' `filename` is not a network-based virtual file system.
#'
#' @seealso
#' [vsi_get_actual_url()]
#'
#' @examples
#' \dontrun{
#' f <- "/vsiaz/items/io-lulc-9-class.parquet"
#' set_config_option("AZURE_STORAGE_ACCOUNT", "pcstacitems")
#' # token obtained from:
#' # https://planetarycomputer.microsoft.com/api/sas/v1/token/pcstacitems/items
#' set_config_option("AZURE_STORAGE_SAS_TOKEN", "<token>")
#' vsi_get_actual_url(f)
#' #> [1] "https://pcstacitems.blob.core.windows.net/items/io-lulc-9-class.parquet"
#' vsi_get_signed_url(f)
#' #> [1] "https://pcstacitems.blob.core.windows.net/items/io-lulc-9-class.parquet?<token>"
#' }
vsi_get_signed_url <- function(filename, options = NULL) {
    .Call(`_gdalraster_vsi_get_signed_url`, filename, options)
}

#' Returns if the file/filesystem is "local".
#'
#' `vsi_is_local()` returns whether the file/filesystem is "local".
#' Wrapper for `VSIIsLocal()` in the GDAL API. Requires GDAL >= 3.6.
#'
#' @param filename Character string. The path of the filesystem object to be
#' tested.
#' @returns Logical scalar. `TRUE` if if the input file path is local.
#'
#' @note
#' The concept of local is mostly by opposition with a network / remote file
#' system whose access time can be long.
#'
#' /vsimem/ is considered to be a local file system, although a
#' non-persistent one.
#'
#' @examples
#' # Requires GDAL >= 3.6
#' if (gdal_version_num() >= gdal_compute_version(3, 6, 0))
#'   print(vsi_is_local("/vsimem/test-mem-file.tif"))
vsi_is_local <- function(filename) {
    .Call(`_gdalraster_vsi_is_local`, filename)
}

#' Return VSI compatible paths from URIs / URLs
#'
#' `vsi_uri_to_vsi_path()` substitutes URIs / URLs starting with `s3://`,
#' `gs://`, etc. by their VSI prefix equivalents. If no known substitution is
#' found, the input string is returned unmodified.
#' Wrapper of `VSIURIToVSIPath()` in the GDAL API. Requires GDAL >= 3.12.
#'
#' @param uris Character vector of input URI strings.
#' @returns Character vector of VSI paths.
#'
#' @examplesIf gdal_version_num() >= gdal_compute_version(3, 12, 0)
#' # Requires GDAL >= 3.12
#' vsi_uri_to_vsi_path("gs://cmip6/")
vsi_uri_to_vsi_path <- function(uris) {
    .Call(`_gdalraster_vsi_uri_to_vsi_path`, uris)
}

#' @noRd
.gdal_commands <- function(contains, recurse, console_out) {
    .Call(`_gdalraster_gdal_commands`, contains, recurse, console_out)
}

#' @noRd
.gdal_global_reg_names <- function() {
    .Call(`_gdalraster_gdal_global_reg_names`)
}

#' get GEOS version
#' @noRd
.getGEOSVersion <- function() {
    .Call(`_gdalraster_getGEOSVersion`)
}

#' Is GEOS available?
#'
#' `has_geos()` returns a logical value indicating whether GDAL was built
#' against the GEOS library. GDAL built with GEOS is a system requirement
#' as of `gdalraster` 1.10.0, so this function will always return `TRUE`
#' (may be removed in a future version).
#'
#' @return Logical. `TRUE` if GEOS is available, otherwise `FALSE`.
#'
#' @examples
#' has_geos()
has_geos <- function() {
    .Call(`_gdalraster_has_geos`)
}

#' @noRd
.g_wkb2wkt <- function(geom, as_iso = FALSE) {
    .Call(`_gdalraster_g_wkb2wkt`, geom, as_iso)
}

#' @noRd
.g_wkb_list2wkt <- function(geom, as_iso = FALSE) {
    .Call(`_gdalraster_g_wkb_list2wkt`, geom, as_iso)
}

#' @noRd
.g_wkt2wkb <- function(geom, as_iso = FALSE, byte_order = "LSB") {
    .Call(`_gdalraster_g_wkt2wkb`, geom, as_iso, byte_order)
}

#' @noRd
.g_wkt_vector2wkb <- function(geom, as_iso = FALSE, byte_order = "LSB") {
    .Call(`_gdalraster_g_wkt_vector2wkb`, geom, as_iso, byte_order)
}

#' @noRd
.g_create <- function(geom_type, pts, as_iso = FALSE, byte_order = "LSB") {
    .Call(`_gdalraster_g_create`, geom_type, pts, as_iso, byte_order)
}

#' @noRd
.g_add_geom <- function(sub_geom, container, as_iso = FALSE, byte_order = "LSB") {
    .Call(`_gdalraster_g_add_geom`, sub_geom, container, as_iso, byte_order)
}

#' @noRd
.g_geom_count <- function(geom, quiet = FALSE) {
    .Call(`_gdalraster_g_geom_count`, geom, quiet)
}

#' @noRd
.g_get_geom <- function(container, sub_geom_idx, as_iso, byte_order) {
    .Call(`_gdalraster_g_get_geom`, container, sub_geom_idx, as_iso, byte_order)
}

#' @noRd
.g_build_collection <- function(geoms, coll_type, as_iso, byte_order) {
    .Call(`_gdalraster_g_build_collection`, geoms, coll_type, as_iso, byte_order)
}

#' @noRd
.g_build_polygon_from_edges <- function(lines, auto_close, tolerance, as_iso, byte_order) {
    .Call(`_gdalraster_g_build_polygon_from_edges`, lines, auto_close, tolerance, as_iso, byte_order)
}

#' @noRd
.g_is_valid <- function(geom, quiet = FALSE) {
    .Call(`_gdalraster_g_is_valid`, geom, quiet)
}

#' @noRd
.g_invalid_reason <- function(geom, quiet = FALSE) {
    .Call(`_gdalraster_g_invalid_reason`, geom, quiet)
}

#' @noRd
.g_make_valid <- function(geom, method = "LINEWORK", keep_collapsed = FALSE, as_iso = FALSE, byte_order = "LSB", quiet = FALSE) {
    .Call(`_gdalraster_g_make_valid`, geom, method, keep_collapsed, as_iso, byte_order, quiet)
}

#' @noRd
.g_normalize <- function(geom, as_iso, byte_order, quiet) {
    .Call(`_gdalraster_g_normalize`, geom, as_iso, byte_order, quiet)
}

#' @noRd
.g_set_3D <- function(geom, is_3d, as_iso, byte_order, quiet) {
    .Call(`_gdalraster_g_set_3D`, geom, is_3d, as_iso, byte_order, quiet)
}

#' @noRd
.g_set_measured <- function(geom, is_measured, as_iso, byte_order, quiet) {
    .Call(`_gdalraster_g_set_measured`, geom, is_measured, as_iso, byte_order, quiet)
}

#' @noRd
.g_swap_xy <- function(geom, as_iso = FALSE, byte_order = "LSB", quiet = FALSE) {
    .Call(`_gdalraster_g_swap_xy`, geom, as_iso, byte_order, quiet)
}

#' @noRd
.g_is_empty <- function(geom, quiet = FALSE) {
    .Call(`_gdalraster_g_is_empty`, geom, quiet)
}

#' @noRd
.g_is_3D <- function(geom, quiet = FALSE) {
    .Call(`_gdalraster_g_is_3D`, geom, quiet)
}

#' @noRd
.g_is_measured <- function(geom, quiet = FALSE) {
    .Call(`_gdalraster_g_is_measured`, geom, quiet)
}

#' @noRd
.g_is_ring <- function(geom, quiet = FALSE) {
    .Call(`_gdalraster_g_is_ring`, geom, quiet)
}

#' @noRd
.g_name <- function(geom, quiet = FALSE) {
    .Call(`_gdalraster_g_name`, geom, quiet)
}

#' @noRd
.g_summary <- function(geom, quiet = FALSE) {
    .Call(`_gdalraster_g_summary`, geom, quiet)
}

#' @noRd
.g_envelope <- function(geom, as_3d = FALSE, quiet = FALSE) {
    .Call(`_gdalraster_g_envelope`, geom, as_3d, quiet)
}

#' @noRd
.g_intersects <- function(this_geom, other_geom, quiet = FALSE) {
    .Call(`_gdalraster_g_intersects`, this_geom, other_geom, quiet)
}

#' @noRd
.g_equals <- function(this_geom, other_geom, quiet = FALSE) {
    .Call(`_gdalraster_g_equals`, this_geom, other_geom, quiet)
}

#' @noRd
.g_disjoint <- function(this_geom, other_geom, quiet = FALSE) {
    .Call(`_gdalraster_g_disjoint`, this_geom, other_geom, quiet)
}

#' @noRd
.g_touches <- function(this_geom, other_geom, quiet = FALSE) {
    .Call(`_gdalraster_g_touches`, this_geom, other_geom, quiet)
}

#' @noRd
.g_contains <- function(this_geom, other_geom, quiet = FALSE) {
    .Call(`_gdalraster_g_contains`, this_geom, other_geom, quiet)
}

#' @noRd
.g_within <- function(this_geom, other_geom, quiet = FALSE) {
    .Call(`_gdalraster_g_within`, this_geom, other_geom, quiet)
}

#' @noRd
.g_crosses <- function(this_geom, other_geom, quiet = FALSE) {
    .Call(`_gdalraster_g_crosses`, this_geom, other_geom, quiet)
}

#' @noRd
.g_overlaps <- function(this_geom, other_geom, quiet = FALSE) {
    .Call(`_gdalraster_g_overlaps`, this_geom, other_geom, quiet)
}

#' @noRd
.g_boundary <- function(geom, as_iso, byte_order, quiet) {
    .Call(`_gdalraster_g_boundary`, geom, as_iso, byte_order, quiet)
}

#' @noRd
.g_buffer <- function(geom, dist, quad_segs = 30L, as_iso = FALSE, byte_order = "LSB", quiet = FALSE) {
    .Call(`_gdalraster_g_buffer`, geom, dist, quad_segs, as_iso, byte_order, quiet)
}

#' @noRd
.g_convex_hull <- function(geom, as_iso, byte_order, quiet) {
    .Call(`_gdalraster_g_convex_hull`, geom, as_iso, byte_order, quiet)
}

#' @noRd
.g_concave_hull <- function(geom, ratio, allow_holes, as_iso, byte_order, quiet) {
    .Call(`_gdalraster_g_concave_hull`, geom, ratio, allow_holes, as_iso, byte_order, quiet)
}

#' @noRd
.g_delaunay_triangulation <- function(geom, constrained = FALSE, tolerance = 0.0, only_edges = FALSE, as_iso = FALSE, byte_order = "LSB", quiet = FALSE) {
    .Call(`_gdalraster_g_delaunay_triangulation`, geom, constrained, tolerance, only_edges, as_iso, byte_order, quiet)
}

#' @noRd
.g_segmentize <- function(geom, max_length, as_iso, byte_order, quiet) {
    .Call(`_gdalraster_g_segmentize`, geom, max_length, as_iso, byte_order, quiet)
}

#' @noRd
.g_simplify <- function(geom, tolerance, preserve_topology = TRUE, as_iso = FALSE, byte_order = "LSB", quiet = FALSE) {
    .Call(`_gdalraster_g_simplify`, geom, tolerance, preserve_topology, as_iso, byte_order, quiet)
}

#' @noRd
.g_unary_union <- function(geom, as_iso, byte_order, quiet) {
    .Call(`_gdalraster_g_unary_union`, geom, as_iso, byte_order, quiet)
}

#' @noRd
.g_intersection <- function(this_geom, other_geom, as_iso = FALSE, byte_order = "LSB", quiet = FALSE) {
    .Call(`_gdalraster_g_intersection`, this_geom, other_geom, as_iso, byte_order, quiet)
}

#' @noRd
.g_union <- function(this_geom, other_geom, as_iso = FALSE, byte_order = "LSB", quiet = FALSE) {
    .Call(`_gdalraster_g_union`, this_geom, other_geom, as_iso, byte_order, quiet)
}

#' @noRd
.g_difference <- function(this_geom, other_geom, as_iso = FALSE, byte_order = "LSB", quiet = FALSE) {
    .Call(`_gdalraster_g_difference`, this_geom, other_geom, as_iso, byte_order, quiet)
}

#' @noRd
.g_sym_difference <- function(this_geom, other_geom, as_iso = FALSE, byte_order = "LSB", quiet = FALSE) {
    .Call(`_gdalraster_g_sym_difference`, this_geom, other_geom, as_iso, byte_order, quiet)
}

#' @noRd
.g_distance <- function(this_geom, other_geom, quiet = FALSE) {
    .Call(`_gdalraster_g_distance`, this_geom, other_geom, quiet)
}

#' @noRd
.g_length <- function(geom, quiet = FALSE) {
    .Call(`_gdalraster_g_length`, geom, quiet)
}

#' @noRd
.g_area <- function(geom, quiet = FALSE) {
    .Call(`_gdalraster_g_area`, geom, quiet)
}

#' @noRd
.g_geodesic_area <- function(geom, srs, traditional_gis_order = TRUE, quiet = FALSE) {
    .Call(`_gdalraster_g_geodesic_area`, geom, srs, traditional_gis_order, quiet)
}

#' @noRd
.g_geodesic_length <- function(geom, srs, traditional_gis_order = TRUE, quiet = FALSE) {
    .Call(`_gdalraster_g_geodesic_length`, geom, srs, traditional_gis_order, quiet)
}

#' @noRd
.g_centroid <- function(geom, quiet = FALSE) {
    .Call(`_gdalraster_g_centroid`, geom, quiet)
}

#' @noRd
.g_transform <- function(geom, srs_from, srs_to, wrap_date_line = FALSE, date_line_offset = 10L, traditional_gis_order = TRUE, as_iso = FALSE, byte_order = "LSB", quiet = FALSE) {
    .Call(`_gdalraster_g_transform`, geom, srs_from, srs_to, wrap_date_line, date_line_offset, traditional_gis_order, as_iso, byte_order, quiet)
}

#' Get the bounding box of a geometry specified in OGC WKT format
#'
#' `bbox_from_wkt()` returns the bounding box of a WKT 2D geometry
#' (e.g., LINE, POLYGON, MULTIPOLYGON).
#'
#' @param wkt Character. OGC WKT string for a simple feature 2D geometry.
#' @param extend_x Numeric scalar. Distance to extend the output bounding box
#' in both directions along the x-axis
#' (results in `xmin = bbox[1] - extend_x`, `xmax = bbox[3] + extend_x`).
#' @param extend_y Numeric scalar. Distance to extend the output bounding box
#' in both directions along the y-axis
#' (results in `ymin = bbox[2] - extend_y`, `ymax = bbox[4] + extend_y`).
#' @return Numeric vector of length four containing the xmin, ymin,
#' xmax, ymax of the geometry specified by `wkt` (possibly extended by values
#' in `extend_x`, `extend_y`).
#'
#' @seealso
#' [bbox_to_wkt()]
#'
#' @examples
#' bnd <- "POLYGON ((324467.3 5104814.2, 323909.4 5104365.4, 323794.2
#' 5103455.8, 324970.7 5102885.8, 326420.0 5103595.3, 326389.6 5104747.5,
#' 325298.1 5104929.4, 325298.1 5104929.4, 324467.3 5104814.2))"
#' bbox_from_wkt(bnd, 100, 100)
bbox_from_wkt <- function(wkt, extend_x = 0, extend_y = 0) {
    .Call(`_gdalraster_bbox_from_wkt`, wkt, extend_x, extend_y)
}

#' Convert a bounding box to POLYGON in OGC WKT format
#'
#' `bbox_to_wkt()` returns a WKT POLYGON string for the given bounding box.
#'
#' @param bbox Numeric vector of length four containing xmin, ymin,
#' xmax, ymax.
#' @param extend_x Numeric scalar. Distance in units of `bbox` to extend the
#' rectangle in both directions along the x-axis
#' (results in `xmin = bbox[1] - extend_x`, `xmax = bbox[3] + extend_x`).
#' @param extend_y Numeric scalar. Distance in units of `bbox` to extend the
#' rectangle in both directions along the y-axis
#' (results in `ymin = bbox[2] - extend_y`, `ymax = bbox[4] + extend_y`).
#' @return Character string for an OGC WKT polygon.
#'
#' @seealso
#' [bbox_from_wkt()], [g_buffer()]
#'
#' @examples
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' ds <- new(GDALRaster, elev_file, read_only=TRUE)
#' bbox_to_wkt(ds$bbox())
#' ds$close()
bbox_to_wkt <- function(bbox, extend_x = 0, extend_y = 0) {
    .Call(`_gdalraster_bbox_to_wkt`, bbox, extend_x, extend_y)
}

#' Does vector dataset exist
#'
#' @noRd
.ogr_ds_exists <- function(dsn, with_update = FALSE) {
    .Call(`_gdalraster_ogr_ds_exists`, dsn, with_update)
}

#' Get the format driver short name for a vector dataset
#'
#' @noRd
.ogr_ds_format <- function(dsn) {
    .Call(`_gdalraster_ogr_ds_format`, dsn)
}

#' Test if capabilities are available for a vector dataset
#'
#' @noRd
.ogr_ds_test_cap <- function(dsn, with_update = TRUE) {
    .Call(`_gdalraster_ogr_ds_test_cap`, dsn, with_update)
}

#' Get number of layers in a dataset
#'
#' @noRd
.ogr_ds_layer_count <- function(dsn) {
    .Call(`_gdalraster_ogr_ds_layer_count`, dsn)
}

#' Get names of layers in a dataset
#'
#' @noRd
.ogr_ds_layer_names <- function(dsn) {
    .Call(`_gdalraster_ogr_ds_layer_names`, dsn)
}

#' Return a list of the names of all field domains stored in the dataset
#'
#' @noRd
.ogr_ds_field_domain_names <- function(dsn) {
    .Call(`_gdalraster_ogr_ds_field_domain_names`, dsn)
}

#' Add a field domain to a dataset
#'
#' @noRd
.ogr_ds_add_field_domain <- function(dsn, fld_dom_defn) {
    .Call(`_gdalraster_ogr_ds_add_field_domain`, dsn, fld_dom_defn)
}

#' Delete a field domain from a dataset
#'
#' @noRd
.ogr_ds_delete_field_domain <- function(dsn, domain_name) {
    .Call(`_gdalraster_ogr_ds_delete_field_domain`, dsn, domain_name)
}

#' Does layer exist
#'
#' @noRd
.ogr_layer_exists <- function(dsn, layer) {
    .Call(`_gdalraster_ogr_layer_exists`, dsn, layer)
}

#' Test if capabilities are available for a vector layer
#'
#' @noRd
.ogr_layer_test_cap <- function(dsn, layer, with_update = TRUE) {
    .Call(`_gdalraster_ogr_layer_test_cap`, dsn, layer, with_update)
}

#' Rename a layer in a vector dataset
#'
#' @noRd
.ogr_layer_rename <- function(dsn, layer, new_name) {
    .Call(`_gdalraster_ogr_layer_rename`, dsn, layer, new_name)
}

#' Delete a layer in a vector dataset
#'
#' @noRd
.ogr_layer_delete <- function(dsn, layer) {
    .Call(`_gdalraster_ogr_layer_delete`, dsn, layer)
}

#' Get names of fields on a layer
#'
#' @noRd
.ogr_layer_field_names <- function(dsn, layer) {
    .Call(`_gdalraster_ogr_layer_field_names`, dsn, layer)
}

#' Get field index or -1 if fld_name not found
#'
#' @noRd
.ogr_field_index <- function(dsn, layer, fld_name) {
    .Call(`_gdalraster_ogr_field_index`, dsn, layer, fld_name)
}

#' Create a new field on layer
#'
#' @noRd
.ogr_field_create <- function(dsn, layer, fld_name, fld_type, fld_subtype = "OFSTNone", fld_width = 0L, fld_precision = 0L, is_nullable = TRUE, is_unique = FALSE, default_value = "", domain_name = "") {
    .Call(`_gdalraster_ogr_field_create`, dsn, layer, fld_name, fld_type, fld_subtype, fld_width, fld_precision, is_nullable, is_unique, default_value, domain_name)
}

#' Create a new geom field on layer
#'
#' @noRd
.ogr_geom_field_create <- function(dsn, layer, fld_name, geom_type, srs = "", is_nullable = TRUE) {
    .Call(`_gdalraster_ogr_geom_field_create`, dsn, layer, fld_name, geom_type, srs, is_nullable)
}

#' Rename an attribute field on a vector layer
#'
#' @noRd
.ogr_field_rename <- function(dsn, layer, fld_name, new_name) {
    .Call(`_gdalraster_ogr_field_rename`, dsn, layer, fld_name, new_name)
}

#' Set the field domain of an existing attribute field on a vector layer
#'
#' @noRd
.ogr_field_set_domain_name <- function(dsn, layer, fld_name, domain_name) {
    .Call(`_gdalraster_ogr_field_set_domain_name`, dsn, layer, fld_name, domain_name)
}

#' Delete an attribute field on a vector layer
#'
#' @noRd
.ogr_field_delete <- function(dsn, layer, fld_name) {
    .Call(`_gdalraster_ogr_field_delete`, dsn, layer, fld_name)
}

#' Execute an SQL statement against the data store
#'
#' @noRd
.ogr_execute_sql <- function(dsn, sql, spatial_filter = "", dialect = "") {
    invisible(.Call(`_gdalraster_ogr_execute_sql`, dsn, sql, spatial_filter, dialect))
}

#' @noRd
.progress_bar_cleanup <- function() {
    invisible(.Call(`_gdalraster_progress_bar_cleanup`))
}

#' Rasterize one polygon
#'
#' @noRd
.rasterize_polygon <- function(rasterXsize, rasterYsize, part_sizes, polygonX, polygonY, fnRasterIO, burn_value, attr_value = NA_character_) {
    .Call(`_gdalraster_rasterize_polygon`, rasterXsize, rasterYsize, part_sizes, polygonX, polygonY, fnRasterIO, burn_value, attr_value)
}

#' Get pointer address of R data as a character string
#'
#' @param x Vector of type numeric, integer, raw or complex.
#' @returns Character string pointer address with format suitable as
#' DATAPOINTER for a GDAL MEM dataset.
#' @noRd
.get_data_ptr <- function(x) {
    .Call(`_gdalraster_get_data_ptr`, x)
}

#' @noRd
NULL

#' Convert spatial reference definitions to OGC WKT or PROJJSON
#'
#' These functions convert various spatial reference formats to Well Known
#' Text (WKT) or PROJJSON.
#'
#' @name srs_convert
#'
#' @details
#' `epsg_to_wkt()` exports the spatial reference for an EPSG code to
#' WKT format.
#' Wrapper for `OSRImportFromEPSG()` in the GDAL Spatial Reference System API
#' with output to WKT.
#'
#' `srs_to_wkt()` converts a spatial reference system (SRS) definition
#' in various text formats to WKT. The function will examine the input SRS,
#' try to deduce the format, and then export it to WKT.
#' Wrapper for `OSRSetFromUserInput()` in the GDAL Spatial Reference System
#' API with output to WKT.
#'
#' `srs_to_projjson()` accepts a spatial reference system (SRS) definition in
#' any of the formats supported by `srs_to_wkt()`, and converts into PROJJSON
#' format. Wrapper for `OSRExportToPROJJSON()` in the GDAL Spatial Reference
#' System API.
#'
#' The input SRS may take the following forms:
#'   * WKT - to convert WKT versions (see below)
#'   * EPSG:n - EPSG code n
#'   * AUTO:proj_id,unit_id,lon0,lat0 - WMS auto projections
#'   * urn:ogc:def:crs:EPSG::n - OGC URNs
#'   * PROJ.4 definitions
#'   * filename - file to read for WKT, XML or PROJ.4 definition
#'   * well known name such as NAD27, NAD83, WGS84 or WGS72
#'   * IGNF:xxxx, ESRI:xxxx - definitions from the PROJ database
#'   * PROJJSON (PROJ >= 6.2)
#'
#' `srs_to_wkt()` is intended to be flexible, but by its nature it is
#' imprecise as it must guess information about the format intended.
#' [epsg_to_wkt()] could be used instead for EPSG codes.
#'
#' As of GDAL 3.0, the default format for WKT export is OGC WKT 1.
#' The WKT version can be overridden by using the OSR_WKT_FORMAT
#' configuration option (see [set_config_option()]).
#' Valid values are one of: SFSQL, WKT1_SIMPLE, WKT1, WKT1_GDAL,
#' WKT1_ESRI, WKT2_2015, WKT2_2018, WKT2, DEFAULT.
#' If SFSQL, a WKT1 string without AXIS, TOWGS84, AUTHORITY or
#' EXTENSION node is returned. If WKT1_SIMPLE, a WKT1 string without
#' AXIS, AUTHORITY or EXTENSION node is returned. WKT1 is an alias of
#' WKT1_GDAL. WKT2 will default to the latest revision implemented
#' (currently WKT2_2018). WKT2_2019 can be used as an alias of
#' WKT2_2018 since GDAL 3.2
#'
#' @param epsg Integer EPSG code.
#' @param srs Character string containing an SRS definition in various
#' formats (see Details).
#' @param pretty Logical value. `TRUE` to return a nicely formatted WKT string
#' for display to a person. `FALSE` for a regular WKT string (the default).
#' @return Character string containing OGC WKT.
#' @param gcs_only Logical value. `TRUE` to return only the definition of the
#' GEOGCS node of the input `srs`. Defaults to `FALSE` (see Note).
#' @param multiline Logical value. `TRUE` for PROJJSON multiline output (the
#' default).
#' @param indent_width Integer value. Defaults to `2`. Only used if
#' `multiline = TRUE` for PROJJSON output.
#' @param schema Character string containing URL to PROJJSON schema. Can be
#' set to empty string to disable it.
#'
#' @note
#' Setting `gcs_only = TRUE` in `srs_to_wkt()` is a wrapper of
#' `OSRCloneGeogCS()` in the GDAL API. The returned WKT will be for the GEOGCS
#' node of the input `srs`.
#'
#' @seealso
#' [srs_query]
#'
#' @examples
#' epsg_to_wkt(5070)
#' writeLines(epsg_to_wkt(5070, pretty = TRUE))
#'
#' srs_to_wkt("NAD83")
#' writeLines(srs_to_wkt("NAD83", pretty = TRUE))
#' set_config_option("OSR_WKT_FORMAT", "WKT2")
#' writeLines(srs_to_wkt("NAD83", pretty = TRUE))
#' set_config_option("OSR_WKT_FORMAT", "")
#'
#' srs_to_wkt("EPSG:5070", gcs_only = TRUE)
#'
#' srs_to_projjson("NAD83") |> writeLines()
epsg_to_wkt <- function(epsg, pretty = FALSE) {
    .Call(`_gdalraster_epsg_to_wkt`, epsg, pretty)
}

#' @rdname srs_convert
srs_to_wkt <- function(srs, pretty = FALSE, gcs_only = FALSE) {
    .Call(`_gdalraster_srs_to_wkt`, srs, pretty, gcs_only)
}

#' @rdname srs_convert
srs_to_projjson <- function(srs, multiline = TRUE, indent_width = 2L, schema = NA_character_) {
    .Call(`_gdalraster_srs_to_projjson`, srs, multiline, indent_width, schema)
}

#' Obtain information about a spatial reference system
#'
#' Bindings to a subset of the GDAL Spatial Reference System API
#' (\url{https://gdal.org/en/stable/api/ogr_srs_api.html}).
#' These functions return various information about a spatial reference
#' system passed as text in any of the formats supported by [srs_to_wkt()].
#'
#' @name srs_query
#'
#' @details
#' `srs_find_epsg()` tries to find a matching EPSG code.
#' Matching may be partial, or may fail. If `all_matches = TRUE`, returns a
#' data frame with entries sorted by decreasing match confidence (first
#' entry has the highest match confidence); the default is `FALSE` which
#' returns a character string in the form "EPSG:####" for the first match
#' (highest confidence). Wrapper of `OSRFindMatches()` in the GDAL SRS API.
#'
#' `srs_get_name()` returns the SRS name.
#' Wrapper of `OSRGetName()` in the GDAL API.
#'
#' `srs_is_geographic()` returns `TRUE`  if the root is a GEOGCS node.
#' Wrapper of `OSRIsGeographic()` in the GDAL API.
#'
#' `srs_is_derived_gcs()` returns `TRUE` if the SRS is a derived geographic
#' coordinate system (for example a rotated long/lat grid).
#' Wrapper of `OSRIsDerivedGeographic()` in the GDAL API.
#'
#' `srs_is_local()` returns `TRUE` if the SRS is a local coordinate system
#' (the root is a LOCAL_CS node).
#' Wrapper of `OSRIsLocal()` in the GDAL API.
#'
#' `srs_is_projected()` returns `TRUE` if the SRS contains a PROJCS node
#' indicating a it is a projected coordinate system.
#' Wrapper of `OSRIsProjected()` in the GDAL API.
#'
#' `srs_is_compound()` returns `TRUE` if the SRS is compound.
#' Wrapper of `OSRIsCompound()` in the GDAL API.
#'
#' `srs_is_geocentric()` returns `TRUE` if the SRS is a geocentric coordinate
#' system.
#' Wrapper of `OSRIsGeocentric()` in the GDAL API.
#'
#' `srs_is_vertical()` returns `TRUE` if the SRS is a vertical coordinate
#' system.
#' Wrapper of `OSRIsVertical()` in the GDAL API.
#'
#' `srs_is_dynamic()` returns `TRUE` if the SRS is is a dynamic coordinate
#' system (relies on a dynamic datum, i.e., a datum that is not plate-fixed).
#' Wrapper of `OSRIsDynamic()` in the GDAL API. Requires GDAL >= 3.4.
#'
#' `srs_is_same()` returns `TRUE` if two spatial references describe
#' the same system.
#' Wrapper of `OSRIsSame()` in the GDAL API.
#'
#' `srs_get_angular_units()` fetches the angular geographic coordinate system
#' units. Returns a list of length two: the first element contains the unit
#' name as a character string, and the second element contains a numeric value
#' to multiply by angular distances to transform them to radians.
#' Wrapper of `OSRGetAngularUnits()` in the GDAL API.
#'
#' `srs_get_linear_units()` fetches the linear projection units.
#' Returns a list of length two: the first element contains the unit
#' name as a character string, and the second element contains a numeric value
#' to multiply by linear distances to transform them to meters.
#' If no units are available, values of "Meters" and 1.0 will be assumed.
#' Wrapper of `OSRGetLinearUnits()` in the GDAL API.
#'
#' `srs_get_coord_epoch()` returns the coordinate epoch, as decimal year
#' (e.g. 2021.3), or `0` if not set or not relevant.
#' Wrapper of `OSRGetCoordinateEpoch()` in the GDAL API. Requires GDAL >= 3.4.
#'
#' `srs_get_utm_zone()` returns the UTM zone number or zero if `srs` isn't a
#' UTM definition. A positive value indicates northern hemisphere; a negative
#' value is in the southern hemisphere.
#' Wrapper of `OSRGetUTMZone()` in the GDAL API.
#'
#' `srs_get_axis_mapping_strategy()` returns the data axis to CRS axis mapping
#' strategy as a character string, one of:
#' * `OAMS_TRADITIONAL_GIS_ORDER`: for geographic CRS with lat/long order, the
#' data will still be long/lat ordered. Similarly for a projected CRS with
#' northing/easting order, the data will still be easting/northing ordered.
#' * `OAMS_AUTHORITY_COMPLIANT`: the data axis will be identical to the CRS
#' axis.
#' * `OAMS_CUSTOM`: custom-defined data axis
#'
#' `srs_get_area_of_use()` is a wrapper of `OSRGetAreaOfUse()` in the GDAL API.
#' Returns a named list containing the following elements (or returns `NULL` if
#' the API call does not succeed):
#' * `AreaName`: the area of use
#' * `WestLongitudeDeg`: the western-most longitude expressed in degree, or
#' `NA` if the bounding box is unknown
#' * `SouthLatitudeDeg`: the southern-most latitude expressed in degree, or
#' `NA` if the bounding box is unknown
#' * `EastLongitudeDeg`: the eastern-most longitude expressed in degree, or
#' `NA` if the bounding box is unknown
#' * `NorthLatitudeDeg`: the northern-most latitude expressed in degree, or
#' `NA` if the bounding box is unknown
#'
#' `srs_get_axes_count()` returns the integer number of axes of the coordinate
#' system of the SRS. Wrapper of `OSRGetAxesCount()` in the GDAL API.
#'
#' `srs_get_axes()` returns a named list of the axis names and their
#' orientations. Wrapper of `OSRGetAxis()` in the GDAL API.
#'
#' `srs_epsg_treats_as_lat_long()` returns `TRUE` if this geographic coordinate
#' system should be treated as having latitude/longitude coordinate ordering.
#' Wrapper of `OSREPSGTreatsAsLatLong()` in the GDAL API.
#'
#' `srs_epsg_treats_as_northing_easting()` returns `TRUE` if this geographic
#' coordinate system should be treated as having northing/easting coordinate
#' ordering. Wrapper of `OSREPSGTreatsAsNorthingEasting()` in the GDAL API.
#'
#' `srs_get_celestial_body_name()` returns the name of the celestial body of
#' the SRS, e.g., `"Earth"` for an Earth SRS. Wrapper of
#' `OSRGetCelestialBodyName()` in the GDAL API. Requires GDAL >= 3.12 and
#' PROJ >= 8.1.
#'
#' @param srs Character string containing an SRS definition in various
#' formats (e.g., WKT, PROJ.4 string, well known name such as NAD27, NAD83,
#' WGS84, etc., see [srs_to_wkt()]).
#' @param srs_other Character string containing an SRS definition in various
#' formats(see above).
#' @param criterion Character string. One of `STRICT`, `EQUIVALENT`,
#' `EQUIVALENT_EXCEPT_AXIS_ORDER_GEOGCRS`.
#' Defaults to `EQUIVALENT_EXCEPT_AXIS_ORDER_GEOGCRS`.
#' @param ignore_axis_mapping Logical scalar. If `TRUE`, sets
#' `IGNORE_DATA_AXIS_TO_SRS_AXIS_MAPPING=YES` in the call to `OSRIsSameEx()`
#' in the GDAL Spatial Reference System API. Defaults to `NO`.
#' @param ignore_coord_epoch Logical scalar. If `TRUE`, sets
#' `IGNORE_COORDINATE_EPOCH=YES` in the call to `OSRIsSameEx()`
#' in the GDAL Spatial Reference System API. Defaults to `NO`.
#' @param all_matches Logical scalar. `TRUE` to return all identified matches
#' in a data frame, including a confidence value (0-100) for each match. The
#' default is `FALSE` which returns a character string in the form
#' `"EPSG:<code>"` for the first match (highest confidence).
#' @param target_key Optional character string giving the coordinate system
#' part to query, either `"PROJCS"` or `"GEOGCS"` (case-insensitive)
#'
#' @seealso
#' [srs_convert]
#'
#' @examples
#' wkt <- 'PROJCS["ETRS89 / UTM zone 32N (N-E)",
#'         GEOGCS["ETRS89",
#'             DATUM["European_Terrestrial_Reference_System_1989",
#'                 SPHEROID["GRS 1980",6378137,298.257222101,
#'                     AUTHORITY["EPSG","7019"]],
#'                 TOWGS84[0,0,0,0,0,0,0],
#'                 AUTHORITY["EPSG","6258"]],
#'             PRIMEM["Greenwich",0,
#'                 AUTHORITY["EPSG","8901"]],
#'             UNIT["degree",0.0174532925199433,
#'                 AUTHORITY["EPSG","9122"]],
#'             AUTHORITY["EPSG","4258"]],
#'         PROJECTION["Transverse_Mercator"],
#'         PARAMETER["latitude_of_origin",0],
#'         PARAMETER["central_meridian",9],
#'         PARAMETER["scale_factor",0.9996],
#'         PARAMETER["false_easting",500000],
#'         PARAMETER["false_northing",0],
#'         UNIT["metre",1,
#'             AUTHORITY["EPSG","9001"]],
#'         AXIS["Northing",NORTH],
#'         AXIS["Easting",EAST]]'
#'
#' srs_find_epsg(wkt)
#'
#' srs_find_epsg(wkt, all_matches = TRUE)
#'
#' srs_get_name("EPSG:5070")
#'
#' srs_is_geographic("EPSG:5070")
#' srs_is_geographic("EPSG:4326")
#'
#' srs_is_derived_gcs("WGS84")
#'
#' srs_is_projected("EPSG:5070")
#' srs_is_projected("EPSG:4326")
#'
#' srs_is_compound("EPSG:4326")
#'
#' srs_is_geocentric("EPSG:7789")
#'
#' srs_is_vertical("EPSG:5705")
#'
#' srs_get_area_of_use("EPSG:3976")
#'
#' srs_get_axes_count("EPSG:4326")
#' srs_get_axes_count("EPSG:4979")
#'
#' # ordered list of axis names and their orientation
#' srs_get_axes("EPSG:4326+5773")
#'
#' srs_epsg_treats_as_lat_long("WGS84")
#'
#' # NAD83 / Conus Albers:
#' srs_epsg_treats_as_northing_easting("EPSG:5070")
#' # WGS 84 / UPS North (N,E):
#' srs_epsg_treats_as_northing_easting("EPSG:32661")
#' # WGS 84 / UPS South (N,E):
#' srs_epsg_treats_as_northing_easting("EPSG:32761")
#'
#' ## Requires GDAL >= 3.12 and PROJ >= 8.1
#' # srs_get_celestial_body_name("EPSG:4326")
#' #> [1] "Earth"
#' # srs_get_celestial_body_name("IAU_2015:30100")
#' #> [1] "Moon"
#'
#' f <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' ds <- new(GDALRaster, f)
#'
#' ds$getProjection() |> srs_is_projected()
#' ds$getProjection() |> srs_get_utm_zone()
#' ds$getProjection() |> srs_get_angular_units()
#' ds$getProjection() |> srs_get_linear_units()
#' ds$getProjection() |> srs_get_axis_mapping_strategy()
#'
#' ds$getProjection() |> srs_is_same("EPSG:26912")
#' ds$getProjection() |> srs_is_same("NAD83")
#'
#' ds$close()
#'
#' ## Requires GDAL >= 3.4
#' if (gdal_version_num() >= gdal_compute_version(3, 4, 0)) {
#'   if (srs_is_dynamic("WGS84"))
#'     print("WGS84 is dynamic")
#'
#'   if (!srs_is_dynamic("NAD83"))
#'     print("NAD83 is not dynamic")
#' }
srs_get_name <- function(srs) {
    .Call(`_gdalraster_srs_get_name`, srs)
}

#' @rdname srs_query
srs_find_epsg <- function(srs, all_matches = FALSE) {
    .Call(`_gdalraster_srs_find_epsg`, srs, all_matches)
}

#' @rdname srs_query
srs_is_geographic <- function(srs) {
    .Call(`_gdalraster_srs_is_geographic`, srs)
}

#' @rdname srs_query
srs_is_derived_gcs <- function(srs) {
    .Call(`_gdalraster_srs_is_derived_gcs`, srs)
}

#' @rdname srs_query
srs_is_local <- function(srs) {
    .Call(`_gdalraster_srs_is_local`, srs)
}

#' @rdname srs_query
srs_is_projected <- function(srs) {
    .Call(`_gdalraster_srs_is_projected`, srs)
}

#' @rdname srs_query
srs_is_compound <- function(srs) {
    .Call(`_gdalraster_srs_is_compound`, srs)
}

#' @rdname srs_query
srs_is_geocentric <- function(srs) {
    .Call(`_gdalraster_srs_is_geocentric`, srs)
}

#' @rdname srs_query
srs_is_vertical <- function(srs) {
    .Call(`_gdalraster_srs_is_vertical`, srs)
}

#' @rdname srs_query
srs_is_dynamic <- function(srs) {
    .Call(`_gdalraster_srs_is_dynamic`, srs)
}

#' @rdname srs_query
srs_is_same <- function(srs, srs_other, criterion = "", ignore_axis_mapping = FALSE, ignore_coord_epoch = FALSE) {
    .Call(`_gdalraster_srs_is_same`, srs, srs_other, criterion, ignore_axis_mapping, ignore_coord_epoch)
}

#' @rdname srs_query
srs_get_angular_units <- function(srs) {
    .Call(`_gdalraster_srs_get_angular_units`, srs)
}

#' @rdname srs_query
srs_get_linear_units <- function(srs) {
    .Call(`_gdalraster_srs_get_linear_units`, srs)
}

#' @rdname srs_query
srs_get_coord_epoch <- function(srs) {
    .Call(`_gdalraster_srs_get_coord_epoch`, srs)
}

#' @rdname srs_query
srs_get_utm_zone <- function(srs) {
    .Call(`_gdalraster_srs_get_utm_zone`, srs)
}

#' @rdname srs_query
srs_get_axis_mapping_strategy <- function(srs) {
    .Call(`_gdalraster_srs_get_axis_mapping_strategy`, srs)
}

#' @rdname srs_query
srs_get_area_of_use <- function(srs) {
    .Call(`_gdalraster_srs_get_area_of_use`, srs)
}

#' @rdname srs_query
srs_get_axes_count <- function(srs) {
    .Call(`_gdalraster_srs_get_axes_count`, srs)
}

#' @rdname srs_query
srs_get_axes <- function(srs, target_key = NULL) {
    .Call(`_gdalraster_srs_get_axes`, srs, target_key)
}

#' @rdname srs_query
srs_epsg_treats_as_lat_long <- function(srs) {
    .Call(`_gdalraster_srs_epsg_treats_as_lat_long`, srs)
}

#' @rdname srs_query
srs_epsg_treats_as_northing_easting <- function(srs) {
    .Call(`_gdalraster_srs_epsg_treats_as_northing_easting`, srs)
}

#' @rdname srs_query
srs_get_celestial_body_name <- function(srs) {
    .Call(`_gdalraster_srs_get_celestial_body_name`, srs)
}

#' Obtain information about coordinate reference systems in the PROJ DB
#'
#' `srs_info_from_db()` returns a data frame containing descriptive information
#' about spatial coordinate reference systems in the PROJ database. Wrapper of
#' `OSRGetCRSInfoListFromDatabase()` in the GDAL SRS API.
#'
#' @details
#' The returned information includes the authority name, object code, object
#' name, object type (e.g., Geographic 2D CRS, Geographic 3D CRS, Projected
#' CRS, etc.), whether the object is deprecated, whether the bounding box
#' values for the area of use are valid, the bounding box values in longitude
#' and latitude degrees, the name of the area of use, the name of the
#' projection method for a projected CRS, and the name of the celestial body of
#' the CRS (e.g., "Earth", populated only if GDAL >= 3.12 and PROJ >= 8.1).
#'
#' @param auth_name Character string containing an authority name used to
#' restrict the search, or empty string (`""`) for all authorities (the
#' default).
#' @returns
#' A data frame (will contain `0` rows if no objects are found that match the
#' search criterion).
#'
#' @seealso
#' [srs_query]
#'
#' @examples
#' epsg <- srs_info_from_db("EPSG")
#' str(epsg)
#'
#' iau <- srs_info_from_db("IAU_2015")
#' str(iau)
srs_info_from_db <- function(auth_name = "") {
    .Call(`_gdalraster_srs_info_from_db`, auth_name)
}

#' get PROJ version
#' @noRd
.getPROJVersion <- function() {
    .Call(`_gdalraster_getPROJVersion`)
}

#' get search path(s) for PROJ resource files
#' @noRd
.getPROJSearchPaths <- function() {
    .Call(`_gdalraster_getPROJSearchPaths`)
}

#' set search path(s) for PROJ resource files
#' @noRd
.setPROJSearchPaths <- function(paths) {
    invisible(.Call(`_gdalraster_setPROJSearchPaths`, paths))
}

#' get whether PROJ networking capabilities are enabled
#' returns logical NA if GDAL < 3.4
#' @noRd
.getPROJEnableNetwork <- function() {
    .Call(`_gdalraster_getPROJEnableNetwork`)
}

#' enable or disable PROJ networking capabilities
#' @noRd
.setPROJEnableNetwork <- function(enabled) {
    invisible(.Call(`_gdalraster_setPROJEnableNetwork`, enabled))
}

#' Inverse project geospatial x/y coordinates to longitude/latitude
#'
#' public wrapper in R/transform.R
#' @noRd
.inv_project <- function(pts, srs, well_known_gcs = "") {
    .Call(`_gdalraster_inv_project`, pts, srs, well_known_gcs)
}

#' Transform geospatial x/y coordinates
#'
#' public wrapper in R/transform.R
#' @noRd
.transform_xy <- function(pts, srs_from, srs_to) {
    .Call(`_gdalraster_transform_xy`, pts, srs_from, srs_to)
}

#' Transform boundary
#'
#' `transform_bounds()` transforms a bounding box, densifying the edges to
#' account for nonlinear transformations along these edges and extracting
#' the outermost bounds. Multiple bounding boxes may be given as rows of a
#' numeric matrix or data frame. Wrapper of `OCTTransformBounds()` in the GDAL
#' Spatial Reference System API. Requires GDAL >= 3.4.
#'
#' @details
#' The following refer to the *output* values `xmin`, `ymin`, `xmax`, `ymax`:
#'
#' If the destination CRS is geographic, the first axis is longitude, and
#' `xmax < xmin` then the bounds crossed the antimeridian. In this scenario
#' there are two polygons, one on each side of the antimeridian. The first
#' polygon should be constructed with `(xmin, ymin, 180, ymax)` and the second
#' with `(-180, ymin, xmax, ymax)`.
#'
#' If the destination CRS is geographic, the first axis is latitude, and
#' `ymax < ymin` then the bounds crossed the antimeridian. In this scenario
#' there are two polygons, one on each side of the antimeridian. The first
#' polygon should be constructed with `(ymin, xmin, ymax, 180)` and the second
#' with `(ymin, -180, ymax, xmax)`.
#'
#' @param bbox Either a numeric vector of length four containing the input
#' bounding box (xmin, ymin, xmax, ymax), or a four-column numeric matrix
#' of bounding boxes (or data frame that can be coerced to a four-column
#' numeric matrix).
#' @param srs_from Character string specifying the spatial reference system
#' for `pts`. May be in WKT format or any of the formats supported by
#' [srs_to_wkt()].
#' @param srs_to Character string specifying the output spatial reference
#' system. May be in WKT format or any of the formats supported by
#' [srs_to_wkt()].
#' @param densify_pts Integer value giving the number of points to use to
#' densify the bounding polygon in the transformation. Recommended to use `21`
#' (the default).
#' @param traditional_gis_order Logical value, `TRUE` to use traditional GIS
#' order of axis mapping (the default) or `FALSE` to use authority compliant
#' axis order (see Note).
#'
#' @returns
#' For a single input bounding box, a numeric vector of length four containing
#' the transformed bounding box in the output spatial reference system
#' (xmin, ymin, xmax, ymax). For input of multiple bounding boxes,
#' a four-column numeric matrix with each row containing the corresponding
#' transformed bounding box (xmin, ymin, xmax, ymax).
#'
#' @note
#' `traditional_gis_order = TRUE` (the default) means that for geographic CRS
#' with lat/long order, the data will still be long/lat ordered. Similarly for
#' a projected CRS with northing/easting order, the data will still be
#' easting/northing ordered (GDAL's OAMS_TRADITIONAL_GIS_ORDER).
#'
#' `traditional_gis_order = FALSE` means that the data axis will be identical
#'  to the CRS axis (GDAL's OAMS_AUTHORITY_COMPLIANT).
#'
#' See
#' \url{https://gdal.org/en/stable/tutorials/osr_api_tut.html#crs-and-axis-order}.
#'
#' @examples
#' bb <- c(-1405880.71737, -1371213.76254, 5405880.71737, 5371213.76254)
#'
#' # traditional GIS axis ordering by  default (lon, lat)
#' transform_bounds(bb, "EPSG:32761", "EPSG:4326")
#'
#' # authority compliant axis ordering
#' transform_bounds(bb, "EPSG:32761", "EPSG:4326",
#'                  traditional_gis_order = FALSE)
transform_bounds <- function(bbox, srs_from, srs_to, densify_pts = 21L, traditional_gis_order = TRUE) {
    .Call(`_gdalraster_transform_bounds`, bbox, srs_from, srs_to, densify_pts, traditional_gis_order)
}

test_that("ogr_reproject works", {

    # The Arrow code path in gdal/apps/ogr2ogr_lib.cpp has known bugs in older
    # GDAL versions.
    # cf. https://gdal.org/en/stable/programs/ogr2ogr.html#known-issues

    # Perform only basic tests across all GDAL versions, and limit additional
    # tests to GDAL >= 3.11.4.

    # Workaround for GDAL < 3.11.4:
    #   https://github.com/OSGeo/gdal/issues/12934
    #   GPKG driver: fix random crash in GetNextArrowArrayAsynchronous()
    set_config_option("OGR2OGR_USE_ARROW_API", "NO")
    on.exit(set_config_option("OGR2OGR_USE_ARROW_API", ""), add = TRUE)
    set_config_option("OGR_GPKG_STREAM_BASE_IMPL", "YES")
    on.exit(set_config_option("OGR_GPKG_STREAM_BASE_IMPL", ""), add = TRUE)

    f <- system.file("extdata/ynp_features.zip", package = "gdalraster")
    # ynp_dsn <- file.path("/vsizip", f, "ynp_features.gpkg")
    unzip(f, files = "ynp_features.gpkg", exdir = tempdir())
    ynp_dsn <- file.path(tempdir(), "ynp_features.gpkg")
    on.exit(unlink(ynp_dsn), add = TRUE)

    out_gpkg <- tempfile(fileext = ".gpkg")
    on.exit(unlink(out_gpkg), add = TRUE)
    ## create a new output dsn, append to existing, and overwrite
    # create new
    expect_no_error(lyr <- ogr_reproject(ynp_dsn, "ynp_bnd",
                                         out_gpkg, "EPSG:32100"))
    expect_equal(lyr$getFeatureCount(), 1)
    lyr$close()
    # append or overwrite is required for an existing layer
    expect_error(lyr <- ogr_reproject(ynp_dsn, "ynp_bnd",
                                      out_gpkg, "EPSG:32100"))
    expect_no_error(lyr <- ogr_reproject(ynp_dsn, "ynp_bnd",
                                         out_gpkg, "EPSG:32100",
                                         append = TRUE))
    expect_equal(lyr$getFeatureCount(), 2)
    lyr$close()
    expect_no_error(lyr <- ogr_reproject(ynp_dsn, "ynp_bnd",
                                         out_gpkg, "EPSG:32100",
                                         overwrite = TRUE))
    expect_equal(lyr$getFeatureCount(), 1)
    lyr$close()

    # see notes above
    skip_if(gdal_version_num() < gdal_compute_version(3, 11, 4))

    ## spat_bbox
    bb <- c(-111.18, 44.78, -111.03, 45.07)
    expect_no_error(lyr <- ogr_reproject(ynp_dsn, "roads",
                                         out_gpkg, "EPSG:32100",
                                         spat_bbox = bb))
    expect_equal(lyr$getFeatureCount(), 11)
    lyr$close()

    ## add_cl_arg
    expect_no_error(lyr <- ogr_reproject(ynp_dsn, "points_of_interest",
                                         out_gpkg, "EPSG:32100",
                                         add_cl_arg = c("-limit", "10")))
    expect_equal(lyr$getFeatureCount(), 10)
    lyr$close()

    ## output to shapefile
    out_shp <- tempfile(fileext = ".shp")
    on.exit(deleteDataset(out_shp), add = TRUE)
    expect_no_error(lyr <- ogr_reproject(ynp_dsn, "ynp_bnd",
                                         out_shp, "EPSG:32100"))
    expect_equal(lyr$getFeatureCount(), 1)
    lyr$close()
    expect_error(lyr <- ogr_reproject(ynp_dsn, "ynp_bnd",
                                      out_shp, "EPSG:32100"))
    expect_no_error(lyr <- ogr_reproject(ynp_dsn, "ynp_bnd",
                                         out_shp, "EPSG:32100",
                                         append = TRUE))
    expect_equal(lyr$getFeatureCount(), 2)
    lyr$close()
    expect_no_error(lyr <- ogr_reproject(ynp_dsn, "ynp_bnd",
                                         out_shp, "EPSG:32100",
                                         overwrite = TRUE))
    expect_equal(lyr$getFeatureCount(), 1)
    lyr$close()

    ## SQL layer with output to GeoJSON WGS84
    out_json <- tempfile(fileext = ".geojson")
    on.exit(unlink(out_json), add = TRUE)
    sql <- "SELECT poiname, geom FROM points_of_interest
            WHERE poitype = 'Ranger Station'"
    # nln required for SQL layer
    expect_error(lyr <- ogr_reproject(ynp_dsn, sql,
                                      out_json, "WGS84"))
    expect_no_error(lyr <- ogr_reproject(ynp_dsn, sql,
                                         out_json, "WGS84",
                                         nln = "ynp_ranger_stations"))
    expect_equal(lyr$getFeatureCount(), 14)
    feat <- lyr$getNextFeature()
    expect_equal(g_coords(feat$geom)[1, "x"], -110.7005, tolerance = 1e-3)
    expect_equal(g_coords(feat$geom)[1, "y"], 44.97703, tolerance = 1e-3)
    lyr$close()
    # with dialect
    if (has_spatialite()) {
        sql <- "SELECT poiname, ST_X(geometry) as x, ST_Y(geometry) as y
                FROM ynp_ranger_stations"
        # reading back from the GeoJSON file, no change in coordinate system
        expect_no_error(lyr <- ogr_reproject(out_json, sql,
                                             out_gpkg, "WGS84",
                                             nln = "ynp_ranger_stations",
                                             dialect = "SQLite"))
        expect_equal(lyr$getFeatureCount(), 14)
        feat <- lyr$getNextFeature()
        expect_equal(feat$x, -110.7005, tolerance = 1e-3)
        expect_equal(feat$y, 44.97703, tolerance = 1e-3)
        lyr$close()
    }

    ## shapefile source
    shp_dsn <- system.file("extdata/poly_multipoly.shp", package="gdalraster")
    expect_no_error(lyr <- ogr_reproject(shp_dsn, "", out_gpkg, "EPSG:32100",
                                         nlt = "PROMOTE_TO_MULTI"))
    expect_equal(lyr$getName(), "poly_multipoly")
    expect_equal(lyr$getFeatureCount(), 4)
    expect_equal(lyr$getGeomType(), "MULTIPOLYGON")
    expect_true(srs_is_same(lyr$getSpatialRef(), "EPSG:32100"))
    lyr$close()

    ## errors
    out_gpkg2 <- tempfile(fileext = ".gpkg")
    on.exit(unlink(out_gpkg2), add = TRUE)
    expect_error(ogr_reproject(c(ynp_dsn, shp_dsn), "ynp_bnd",
                               out_gpkg2, "EPSG:32100"))
    expect_error(ogr_reproject(ynp_dsn, c("ynp_bnd", "roads"),
                               out_gpkg2, "EPSG:32100"))
    expect_error(ogr_reproject(ynp_dsn, "ynp_bnd",
                               NULL, "EPSG:32100"))
    expect_error(ogr_reproject(ynp_dsn, "ynp_bnd",
                               out_gpkg2, NULL))
    expect_error(ogr_reproject(ynp_dsn, "ynp_bnd",
                               out_gpkg, "EPSG:32100",
                               out_fmt = 1))
    expect_error(ogr_reproject(ynp_dsn, "ynp_bnd",
                               out_gpkg, "EPSG:32100",
                               overwrite = NULL))
    expect_error(ogr_reproject(ynp_dsn, "ynp_bnd",
                               out_gpkg, "EPSG:32100",
                               append = NULL))
    expect_error(ogr_reproject(ynp_dsn, "ynp_bnd",
                               out_gpkg, "EPSG:32100",
                               nln = 1))
    expect_error(ogr_reproject(ynp_dsn, "ynp_bnd",
                               out_gpkg, "EPSG:32100",
                               dsco = 1))
    expect_error(ogr_reproject(ynp_dsn, "ynp_bnd",
                               out_gpkg, "EPSG:32100",
                               lco = 1))
    expect_error(ogr_reproject(ynp_dsn, "ynp_bnd",
                               out_gpkg, "EPSG:32100",
                               dialect = 1))
    expect_error(ogr_reproject(ynp_dsn, "ynp_bnd",
                               out_gpkg, "EPSG:32100",
                               spat_bbox = 1))
    expect_error(ogr_reproject(ynp_dsn, "ynp_bnd",
                               out_gpkg, "EPSG:32100",
                               src_open_options = 1))
    expect_error(ogr_reproject(ynp_dsn, "ynp_bnd",
                               out_gpkg, "EPSG:32100",
                               progress = 1))
    expect_error(ogr_reproject(ynp_dsn, "ynp_bnd",
                               out_gpkg, "EPSG:32100",
                               add_cl_arg = 1))

})

# Tests for src/gdal_exp.cpp - Exported stand-alone functions for gdalraster
# Some functions in gdal_exp.cpp are called by gdalraster_proc.R and
# tested there.
test_that("gdal_version returns vector", {
    expect_length(gdal_version(), 4)
})

test_that("gdal_formats returns a data frame", {
    x <- gdal_formats()
    expect_s3_class(x, "data.frame")
    expect_true(nrow(x) > 1)
})

test_that(".check_gdal_filename works", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
    expect_error(.check_gdal_filename(c(elev_file, b5_file)))
    vsifn <- paste0("/vsi/", b5_file)
    expect_equal(vsifn, .check_gdal_filename(vsifn))
    fn <- "~/_r82jRwnT.test"
    fn_out <- .check_gdal_filename(fn)
    expect_equal(basename(fn_out), basename(fn))
})

test_that("get/set_config_option work", {
    co <- get_config_option("GDAL_CACHEMAX")
    set_config_option("GDAL_CACHEMAX", "10%")
    expect_equal(get_config_option("GDAL_CACHEMAX"), "10%")
    set_config_option("GDAL_CACHEMAX", co)

    set_config_option("CPL_LOG_ERRORS", "OFF")
    expect_equal(get_config_option("CPL_LOG_ERRORS"), "OFF")
    set_config_option("CPL_LOG_ERRORS", "")
    expect_equal(get_config_option("CPL_LOG_ERRORS"), "")
})

test_that("get_cache_used returns integer64", {
    expect_s3_class(get_cache_used(), "integer64")
    expect_s3_class(get_cache_used("GB"), "integer64")
    expect_s3_class(get_cache_used("KB"), "integer64")
    expect_s3_class(get_cache_used(""), "integer64")
    expect_s3_class(get_cache_used("bytes"), "integer64")
    expect_error(get_cache_used("MiB"))
})

test_that("get_cache_max returns integer64", {
    expect_s3_class(get_cache_max(), "integer64")
    expect_s3_class(get_cache_max("GB"), "integer64")
    expect_s3_class(get_cache_max("KB"), "integer64")
    expect_s3_class(get_cache_max(""), "integer64")
    expect_s3_class(get_cache_max("bytes"), "integer64")
    expect_error(get_cache_max("MiB"))
})

test_that("set_cache_max works", {
    cachemax <- get_cache_max("bytes")
    set_cache_max(1e8)
    expect_equal(get_cache_max("bytes"), as.integer64(1e8))
    # reset to original
    set_cache_max(cachemax)
    expect_equal(get_cache_max("bytes"), cachemax)
})

test_that("get_num_cpus returns integer", {
    expect_type(get_num_cpus(), "integer")
})

test_that("get_usable_physical_ram returns integer64", {
    expect_s3_class(get_usable_physical_ram(), "integer64")
})

test_that("has_spatialite returns logical", {
    expect_type(has_spatialite(), "logical")
})

test_that("http_enabled returns logical", {
    expect_type(http_enabled(), "logical")
})

test_that(".cpl_http_cleanup runs without error", {
    expect_no_error(.cpl_http_cleanup())
})

test_that("wrappers for CPL path manipulation functions work", {
    f <- "/vsizip//vsicurl/https://raw.githubusercontent.com/OSGeo/gdal/master/autotest/ogr/data/shp/poly.zip"

    expect_equal(.cpl_get_filename(f),  "poly.zip")

    expect_equal(.cpl_get_path(f),
                 "/vsizip//vsicurl/https://raw.githubusercontent.com/OSGeo/gdal/master/autotest/ogr/data/shp")

    expect_equal(.cpl_get_filename(f) |> .cpl_get_path(),  "")

    expect_equal(.cpl_get_dirname(f),
                 "/vsizip//vsicurl/https://raw.githubusercontent.com/OSGeo/gdal/master/autotest/ogr/data/shp")

    expect_equal(.cpl_get_filename(f) |> .cpl_get_dirname(),  ".")

    expect_equal(.cpl_get_basename(f), "poly")
    expect_equal(.cpl_get_extension(f), "zip")

    expect_true(.cpl_get_filename(f) |> .cpl_launder_for_filename() ==
                .cpl_get_filename(f))

    expect_false(.cpl_launder_for_filename(f) == f)
})

test_that("createCopy writes correct output", {
    lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
    tif_file <- paste0(tempdir(), "/", "storml_lndscp.tif")
    options <- c("COMPRESS=LZW")
    createCopy(format="GTiff", dst_filename=tif_file, src_filename=lcp_file,
               options=options)
    ds <- new(GDALRaster, tif_file, read_only=FALSE)
    on.exit(deleteDataset(tif_file))
    md <- ds$getMetadata(band=0, domain="IMAGE_STRUCTURE")
    expect_equal(md, c("COMPRESSION=LZW", "INTERLEAVE=PIXEL"))
    for (band in 1:ds$getRasterCount())
         ds$setNoDataValue(band, -9999)
    stats <- ds$getStatistics(band=1, approx_ok=FALSE, force=TRUE)
    expect_equal(round(stats), round(c(2438.0, 3046.0, 2675.9713, 133.0185)))
    dm <- ds$dim()
    chk <- ds$getChecksum(5, 0, 0, dm[1], dm[2])
    expect_equal(chk, 64107)
    ds$close()
})

test_that("internal apply_geotransform gives correct result", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    ds <- new(GDALRaster, elev_file, read_only=TRUE)
    gt <- ds$getGeoTransform()
    ds$close()
    expect_equal(.apply_geotransform(gt, 1, 1), c(323506.1, 5105052.0))
})

test_that("apply_geotransform gives correct results", {
    raster_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    ds <- new(GDALRaster, raster_file)

    # compute some raster coordinates in column/row space
    set.seed(1)
    col_coords <- runif(10, min = 0, max = ds$getRasterXSize() - 0.00001)
    row_coords <- runif(10, min = 0, max = ds$getRasterYSize() - 0.00001)
    col_row <- cbind(col_coords, row_coords)
    dimnames(col_row) <- NULL

    x_expected <- c(324615.1, 325072.5, 325933.6, 327372.3, 324341.3, 327330.2,
                    327528.7, 326310.9, 326175.0, 323741.1)
    y_expected <- c(5104421, 5104515, 5102877, 5103849, 5102611, 5103484,
                    5102778, 5101898, 5103862, 5102586)
    xy_expected <- cbind(x_expected, y_expected)
    dimnames(xy_expected) <- NULL

    gt <- ds$getGeoTransform()
    expect_equal(apply_geotransform(col_row, gt), xy_expected, tolerance = 0.1)

    # or, using the class method
    expect_equal(ds$apply_geotransform(col_row), xy_expected, tolerance = 0.1)

    expect_equal(ds$apply_geotransform(col_row) |> ds$get_pixel_line(),
                 trunc(col_row))

    # one coordinate as vector input
    res <- ds$apply_geotransform(c(col_coords[1], row_coords[1]))
    dim(res) <- NULL
    expect_equal(res, xy_expected[1, ], tolerance = 0.1)

    # NA input
    res <- ds$apply_geotransform(c(NA, NA))
    expect_true(all(is.na(res)))

    res <- apply_geotransform(c(NA, NA), gt)
    expect_true(all(is.na(res)))

    ds$close()
})

test_that("get_pixel_line gives correct results", {
    pt_file <- system.file("extdata/storml_pts.csv", package="gdalraster")
    pts <- read.csv(pt_file)
    pix_line <- c(39, 23, 1, 58, 74, 94, 68, 92, 141, 23, 57, 68, 58, 52, 90,
                  38, 31, 85, 20, 39)
    raster_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
    ds <- new(GDALRaster, raster_file, read_only=TRUE)
    gt <- ds$getGeoTransform()
    res <- get_pixel_line(as.matrix(pts[, -1]), gt)
    expect_equal(as.vector(res), pix_line)

    # or, using the class method and data frame input
    res <- ds$get_pixel_line(pts[, -1])
    expect_equal(as.vector(res), pix_line)

    pts[11, ] <- c(11, 323318, 5105104)
    expect_warning(res2 <- ds$get_pixel_line(pts[, -1]))
    res <- rbind(res, c(NA, NA))
    expect_equal(res2, res)

    # one coordinate as vector input
    res <- get_pixel_line(c(pts[1, 2], pts[1, 3]), gt)  # col 2 x, col 3 y
    expect_equal(as.vector(res), c(pix_line[1], pix_line[11]))

    # NA input
    res <- get_pixel_line(c(NA, NA), gt)
    expect_true(all(is.na(res)))

    res <- ds$get_pixel_line(c(NA, NA))
    expect_true(all(is.na(res)))

    ds$close()
})

test_that("fillNodata writes correct output", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    mod_file <- paste0(tempdir(), "/", "storml_elev_fill.tif")
    file.copy(elev_file,  mod_file)
    fillNodata(mod_file, band=1)
    ds <- new(GDALRaster, mod_file, read_only=TRUE)
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 49103)

    # invalid band
    expect_error(fillNodata(mod_file, band=2))
    # incorrect mask file
    expect_error(fillNodata(mod_file, band=1, mask_file="_err_"))

    # clean up
    deleteDataset(mod_file)
})

test_that("sieveFilter runs without error", {
    evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
    evt_mmu_file <- paste0(tempdir(), "/", "storml_evt_mmu2.tif")
    rasterFromRaster(srcfile=evt_file, dstfile=evt_mmu_file, init=32767)
    expr <- "ifelse(EVT == 7292, 0, EVT)"
    mask_file <- calc(expr, rasterfiles=evt_file, var.names="EVT")
    expect_true(sieveFilter(evt_file, 1, evt_mmu_file, 1, 2, 8, mask_file, 1))

    # invalid source band
    expect_error(sieveFilter(evt_file, 2, evt_mmu_file, 1, 2, 8, mask_file, 1))
    # incorrect destination file
    expect_error(sieveFilter(evt_file, 1, "_err_", 1, 2, 8, mask_file, 1))
    # invalid destination band
    expect_error(sieveFilter(evt_file, 1, evt_mmu_file, 2, 2, 8, mask_file, 1))
    # incorrect mask file
    expect_error(sieveFilter(evt_file, 1, evt_mmu_file, 1, 2, 8, "_err_", 1))
    # invalid mask band
    expect_error(sieveFilter(evt_file, 1, evt_mmu_file, 1, 2, 8, mask_file, 2))

    # clean up
    deleteDataset(evt_mmu_file)
    deleteDataset(mask_file)
})

test_that("createColorRamp works", {
    colors <- createColorRamp(start_index = 0,
                              start_color = c(211, 211, 211),
                              end_index = 100,
                              end_color = c(0, 100, 0))
    expect_equal(nrow(colors), 101)
    # non-zero start_index
    colors = createColorRamp(109, c(254, 231, 152), 127, c(254, 254, 189))
    expect_equal(nrow(colors), 19)
})

test_that("bandCopyWholeRaster writes correct output", {
    b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
    # make a copy since getStatistics will try to write a .xml file
    b5_tmp <- paste0(tempdir(), "/", "b5_tmp.tif")
    file.copy(b5_file,  b5_tmp)
    dst_file <- paste0(tempdir(), "/", "sr_multi.tif")
    rasterFromRaster(b5_tmp, dst_file, nbands=7, init=0)
    opt <- c("COMPRESSED=YES", "SKIP_HOLES=YES")
    bandCopyWholeRaster(b5_tmp, 1, dst_file, 5, options=opt)
    ds <- new(GDALRaster, b5_tmp, read_only=TRUE)
    on.exit(deleteDataset(b5_tmp))
    src_stats <- ds$getStatistics(band=1, approx_ok=FALSE, force=TRUE)
    ds$close()
    ds <- new(GDALRaster, dst_file, read_only=TRUE)
    on.exit(deleteDataset(dst_file), add=TRUE)
    dst_stats <- ds$getStatistics(band=5, approx_ok=FALSE, force=TRUE)
    ds$close()
    expect_equal(src_stats, dst_stats)

    push_error_handler("quiet")
    # invalid source band
    expect_false(bandCopyWholeRaster(b5_tmp, 2, dst_file, 5, options=opt))
    # incorrect destination file
    expect_false(bandCopyWholeRaster(b5_tmp, 1, "_err_", 5, options=opt))
    # invalid destination band
    expect_false(bandCopyWholeRaster(b5_tmp, 1, dst_file, 8, options=opt))
    pop_error_handler()
})

test_that("deleteDataset works", {
    b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
    b5_tmp <- paste0(tempdir(), "/", "b5_tmp.tif")
    file.copy(b5_file,  b5_tmp)
    ds <- new(GDALRaster, b5_tmp, read_only=TRUE)
    ds$buildOverviews("BILINEAR", levels = c(2, 4, 8), bands = c(1))
    files <- ds$getFileList()
    ds$close()
    expect_true(all(file.exists(files)))
    deleteDataset(b5_tmp)
    expect_false(any(file.exists(files)))
    ds = NULL

    # with format argument
    b5_tmp2 <- paste0(tempdir(), "/", "b5_tmp2.tif")
    file.copy(b5_file,  b5_tmp2)
    ds2 <- new(GDALRaster, b5_tmp2, read_only=TRUE)
    ds2$buildOverviews("BILINEAR", levels = c(2, 4, 8), bands = c(1))
    files <- ds2$getFileList()
    ds2$close()
    deleteDataset(b5_tmp2, "GTiff")
    expect_false(any(file.exists(files)))
})

test_that("renameDataset works", {
    b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
    b5_tmp <- paste0(tempdir(), "/", "b5_tmp.tif")
    file.copy(b5_file,  b5_tmp)
    ds <- new(GDALRaster, b5_tmp, read_only=TRUE)
    ds$buildOverviews("BILINEAR", levels = c(2, 4, 8), bands = c(1))
    ds$close()
    b5_tmp2 <- paste0(tempdir(), "/", "b5_tmp_renamed.tif")
    renameDataset(b5_tmp2, b5_tmp)
    ds <- new(GDALRaster, b5_tmp2, read_only=TRUE)
    expect_length(ds$getFileList(), 2)
    ds$close()

    # with format argument
    b5_tmp3 <- paste0(tempdir(), "/", "b5_tmp3.tif")
    renameDataset(b5_tmp3, b5_tmp2)
    ds <- new(GDALRaster, b5_tmp3, read_only=TRUE)
    expect_length(ds$getFileList(), 2)
    ds$close()

    deleteDataset(b5_tmp3)
})

test_that("copyDatasetFiles works", {
    lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
    ds <- new(GDALRaster, lcp_file, read_only=TRUE)
    num_files <- length(ds$getFileList())
    ds$close()
    lcp_tmp <- paste0(tempdir(), "/", "storm_lake_copy.lcp")
    copyDatasetFiles(lcp_tmp, lcp_file)
    ds_copy <- new(GDALRaster, lcp_tmp, read_only=TRUE)
    expect_equal(length(ds_copy$getFileList()), num_files)
    ds_copy$close()
    deleteDataset(lcp_tmp)

    # with format argument
    lcp_tmp2 <- paste0(tempdir(), "/", "storm_lake_copy2.lcp")
    copyDatasetFiles(lcp_tmp2, lcp_file)
    ds_copy2 <- new(GDALRaster, lcp_tmp2, read_only=TRUE)
    expect_equal(length(ds_copy2$getFileList()), num_files)
    ds_copy2$close()
    deleteDataset(lcp_tmp2)
})

test_that("buildVRT works", {
    b4_file <- system.file("extdata/sr_b4_20200829.tif", package="gdalraster")
    b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
    b6_file <- system.file("extdata/sr_b6_20200829.tif", package="gdalraster")
    band_files <- c(b6_file, b5_file, b4_file)
    vrt_file <- paste0(tempdir(), "/", "storml_b6_b5_b4.vrt")
    buildVRT(vrt_file, band_files, cl_arg="-separate")
    ds <- new(GDALRaster, vrt_file, read_only=TRUE)
    expect_equal(ds$getRasterCount(), 3)
    ds$close()
    deleteDataset(vrt_file)
})

test_that("footprint runs without error", {
    skip_if(gdal_version_num() < 3080000)

    evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
    args <- c("-t_srs", "EPSG:4326")
    out_file <- paste0(tempdir(), "/", "storml.geojson")
    expect_true(footprint(evt_file, out_file, args))
    deleteDataset(out_file)
})

test_that("ogr2ogr works", {
    # this may be removed in the future
    # https://gdal.org/en/stable/programs/ogr2ogr.html#known-issues
    # https://github.com/OSGeo/gdal/issues/12934
    #   GPKG driver: fix random crash in GetNextArrowArrayAsynchronous()
    set_config_option("OGR2OGR_USE_ARROW_API", "NO")
    on.exit(set_config_option("OGR2OGR_USE_ARROW_API", ""))
    set_config_option("OGR_GPKG_STREAM_BASE_IMPL", "YES")
    on.exit(set_config_option("OGR_GPKG_STREAM_BASE_IMPL", ""), add = TRUE)

    src <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")

    # convert GeoPackage to Shapefile
    shp_file <- file.path(tempdir(), "ynp_fires.shp")
    ogr2ogr(src, shp_file, src_layers = "mtbs_perims")
    fld_idx <- .ogr_field_index(shp_file, "ynp_fires", "ig_year")
    expect_equal(fld_idx, 8)
    deleteDataset(shp_file)
    fld_idx <- -1

    # reproject to WGS84
    ynp_wgs84 <- file.path(tempdir(), "ynp_fires_wgs84.gpkg")
    args <- c("-t_srs", "EPSG:4326")
    ogr2ogr(src, ynp_wgs84, cl_arg = args)
    fld_idx <- .ogr_field_index(ynp_wgs84, "mtbs_perims", "ig_year")
    expect_equal(fld_idx, 8)
    deleteDataset(ynp_wgs84)
    fld_idx <- -1

    # with open_options
    vsi_curl_clear_cache()
    ogr2ogr(src, ynp_wgs84, cl_arg = args, open_options = "LIST_ALL_TABLES=NO")
    fld_idx <- .ogr_field_index(ynp_wgs84, "mtbs_perims", "ig_year")
    expect_equal(fld_idx, 8)
    deleteDataset(ynp_wgs84)
    fld_idx <- -1

    # clip to a bounding box (xmin, ymin, xmax, ymax)
    ynp_clip <- file.path(tempdir(), "ynp_fires_aoi_clip.gpkg")
    bb <- c(469685.97, 11442.45, 544069.63, 85508.15)
    args <- c("-spat", bb)
    ogr2ogr(src, ynp_clip, cl_arg = args)
    fld_idx <- .ogr_field_index(ynp_clip, "mtbs_perims", "ig_year")
    expect_equal(fld_idx, 8)
    deleteDataset(ynp_clip)
    fld_idx <- -1

    # filter features by a -where clause
    ynp_filtered <- file.path(tempdir(), "ynp_fires_2000_2022.gpkg")
    sql <- "ig_year >= 2000 ORDER BY ig_year"
    args <- c("-where", sql)
    ogr2ogr(src, ynp_filtered, src_layers = "mtbs_perims", cl_arg = args)
    fld_idx <- .ogr_field_index(ynp_filtered, "mtbs_perims", "ig_year")
    expect_equal(fld_idx, 8)
    deleteDataset(ynp_filtered)
})

test_that("ogrinfo works", {
    skip_if(gdal_version_num() < 3070000)

    src <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")

    info <- ogrinfo(src)
    expect_vector(info, ptype = character(), size = 1)
    expect_false(info[1] == "")

    json <- ogrinfo(src, "mtbs_perims", cl_arg = c("-json", "-so", "-nomd"))
    expect_true(nchar(json) > 1000)

    src_mem <- paste0("/vsimem/", basename(src))
    vsi_copy_file(src, src_mem)

    args <- c("-sql", "ALTER TABLE mtbs_perims ADD burn_bnd_ha float")
    ogrinfo(src_mem, cl_arg = args, read_only = FALSE)
    idx <- .ogr_field_index(src_mem, "mtbs_perims", "burn_bnd_ha")
    expect_equal(idx, 9)

    vsi_unlink(src_mem)
})

test_that("autoCreateWarpedVRT works", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    ds <- new(GDALRaster, elev_file)

    expect_no_error(ds2 <- autoCreateWarpedVRT(ds, epsg_to_wkt(5070),
                                               "Bilinear"))
    expect_equal(ds2$getProjection(), epsg_to_wkt(5070))
    ds2$close()

    # with creation of alpha band
    expect_no_error(ds3 <- autoCreateWarpedVRT(ds, epsg_to_wkt(5070),
                                               "Cubic", alpha_band = TRUE))
    expect_equal(ds3$getRasterCount(), 2)
    ds3$close()

    # errors
    expect_error(ds4 <- autoCreateWarpedVRT(ds, epsg_to_wkt(5070),
                                            resample_alg = "invalid"))

    ds$close()
})

test_that("identifyDriver works", {
    src <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")

    expect_equal(identifyDriver(src), "GPKG")
    expect_equal(identifyDriver(src, raster = FALSE), "GPKG")
    expect_equal(identifyDriver(src, vector = FALSE), "GPKG")
    expect_equal(identifyDriver(src, allowed_drivers = c("GPKG", "GTiff")), "GPKG")
    expect_true(is.null(identifyDriver(src, allowed_drivers = c("GTiff", "GeoJSON"))))
    expect_equal(identifyDriver(src, file_list = "ynp_fires_1984_2022.gpkg"), "GPKG")

    # PostGISRaster vs. PostgreSQL
    skip_if((nrow(gdal_formats("PostgreSQL")) == 1 && is.na(gdal_formats("PostgreSQL")$short_name)) ||
            (nrow(gdal_formats("PostGISRaster")) == 1 && is.na(gdal_formats("PostGISRaster")$short_name)))

    dsn <- "PG:dbname='testdb', host='127.0.0.1' port='5444' user='user' password='pwd'"
    expect_equal(identifyDriver(dsn), "PostGISRaster")
    expect_equal(identifyDriver(dsn, raster = FALSE), "PostgreSQL")
})

test_that("flip_vertical works", {
    v <- seq_len(9)
    v_flip <- .flip_vertical(v, 3, 3, 1)
    expect_equal(v_flip, c(7, 8, 9, 4, 5, 6, 1, 2, 3))

    expect_error(.flip_vertical(v, 5, 5, 1))
    expect_error(.flip_vertical(v, -3, -3, 1))
})

test_that("validateCreationOptions works", {
    expect_true(validateCreationOptions("GTiff", c("COMPRESS=LZW",
                                                   "TILED=YES")))
    expect_false(validateCreationOptions("GTiff", "COMPRESS=invalid"))
})

test_that("gdal_get_driver_md works", {
    expect_no_error(md <- gdal_get_driver_md("GTiff"))
    expect_true(is.list(md))
    expect_equal(md$DMD_LONGNAME, "GeoTIFF")

    expect_no_error(mdi <- gdal_get_driver_md("GTiff", "DCAP_RASTER"))
    expect_equal(mdi, "YES")

    expect_true(is.null(gdal_get_driver_md("GTiff", "invalid")))
})

test_that("is_los_visible works", {
    skip_if(gdal_version_num() < gdal_compute_version(3, 9, 0))

    dem <- system.file("extdata/storml_elev.tif", package="gdalraster")
    pts_b_dsn <- system.file("extdata/storml_los_pts_b.geojson", package="gdalraster")

    # one-to-many, matrix input
    ptA <- c(324625.0, 5104724.0, 1.7)
    ptsB <-c(324803.0, 5104517.0, 10,
             325286.0, 5102923.0, 10,
             323847.0, 5104538.0, 10)
    ptsB <- matrix(ptsB, nrow = 3, ncol = 3, byrow = TRUE)

    expected <- c(TRUE, TRUE, FALSE)

    res <- is_los_visible(dem, ptA, ptsB)
    expect_equal(res, expected)

    # one-to-many, ptsB as data frame
    res <- is_los_visible(dem, ptA, as.data.frame(ptsB))
    expect_equal(res, expected)

    # one-to-many, ptA using actual height not relative to DEM
    ptA_actual <- c(324625.0, 5104724.0, 2496.7)
    res <- is_los_visible(dem, ptA_actual, ptsB, ZinterpA = "ACTUAL")
    expect_equal(res, expected)

    # one-to-many, ptA and ptsB using actual height not relative to DEM
    ptsB_actual <-c(324803.0, 5104517.0, 2505,
                    325286.0, 5102923.0, 2853,
                    323847.0, 5104538.0, 2627)
    ptsB_actual <- matrix(ptsB_actual, nrow = 3, ncol = 3, byrow = TRUE)
    res <- is_los_visible(dem, ptA_actual, ptsB_actual, ZinterpA = "ACTUAL",
                          ZinterpB = "ACTUAL")
    expect_equal(res, expected)

    # one-to-many, ptsB from layer as WKB and reproject
    lyr <- new(GDALVector, pts_b_dsn)
    on.exit(lyr$close(), add = TRUE)
    feat <- lyr$fetch(-1)
    res <- is_los_visible(dem, ptA, feat$geom, srsB = lyr$getSpatialRef(),
                          ZinterpB = "ACTUAL")
    expect_equal(res, expected)

    # one-to-many, ptsB as WKT and reproject
    res <- is_los_visible(dem, ptA, g_wk2wk(feat$geom),
                          srsB = lyr$getSpatialRef(), ZinterpB = "ACTUAL")
    expect_equal(res, expected)

    # pairwise, ptA location is fixed with varying height
    ptsA <- c(324625.0, 5104724.0, 1,
              324625.0, 5104724.0, 10,
              324625.0, 5104724.0, 100)
    ptsA <- matrix(ptsA, nrow = 3, ncol = 3, byrow = TRUE)

    expected <- c(TRUE, TRUE, FALSE)

    res <- is_los_visible(dem, ptsA, ptsB)
    expect_equal(res, expected)

    ptsA <- c(324625.0, 5104724.0, 1,
              324625.0, 5104724.0, 10,
              324625.0, 5104724.0, 1000)
    ptsA <- matrix(ptsA, nrow = 3, ncol = 3, byrow = TRUE)

    expected <- c(TRUE, TRUE, TRUE)

    res <- is_los_visible(dem, ptsA, ptsB)
    expect_equal(res, expected)

    # pairwise, ptsA as WKB
    ptsA_wkb <- g_create("POINT", ptsA)
    res <- is_los_visible(dem, ptsA_wkb, ptsB)
    expect_equal(res, expected)

    # pairwise, ptsA as WKT
    res <- is_los_visible(dem, g_wk2wk(ptsA_wkb), ptsB)
    expect_equal(res, expected)

    # pairwise, DEM given as a dataset object, ptsA as WKB and reproject
    ds <- new(GDALRaster, dem)
    on.exit(ds$close(), add = TRUE)
    ptsA_wkb_wgs84 <- g_transform(ptsA_wkb, ds$getSpatialRef(), "WGS84")
    res <- is_los_visible(ds, ptsA_wkb_wgs84, ptsB, srsA = "WGS84")
    expect_equal(res, expected)

    # pairwise, ptsB with actual height, vertical CRS and reproject
    expect_true(srs_is_vertical("EPSG:4326+5773"))
    ptsB_wkb_wgs84_egm96 <- g_transform(feat$geom, lyr$getSpatialRef(),
                                        "EPSG:4326+5773")
    res <- is_los_visible(ds, ptsA_wkb, ptsB_wkb_wgs84_egm96,
                          srsB = "EPSG:4326+5773", ZinterpB = "ACTUAL")
    expect_equal(res, expected)

    # pairwise, ptsB with relative height, vertical CRS and reproject
    # error
    ptsB_wkb <- g_create("POINT", ptsB)
    ptsB_wkb_wgs84_egm96 <- g_transform(ptsB_wkb, lyr$getSpatialRef(),
                                        "EPSG:4326+5773")
    expect_error(is_los_visible(ds, ptsA_wkb, ptsB_wkb_wgs84_egm96,
                                srsB = "EPSG:4326+5773"))

    # input validation
    expect_no_error(is_los_visible(ds, ptsA, ptsB, band = 1,
                    srsA = NULL, srsB = NULL,
                    ZinterpA = "RELATIVE_TO_DEM", ZinterpB = "RELATIVE_TO_DEM",
                    quiet = FALSE))
    expect_error(is_los_visible(NULL, ptsA, ptsB, band = 1,
                 srsA = NULL, srsB = NULL,
                 ZinterpA = "RELATIVE_TO_DEM", ZinterpB = "RELATIVE_TO_DEM",
                 quiet = FALSE))
    expect_error(is_los_visible(ds, NULL, ptsB, band = 1,
                 srsA = NULL, srsB = NULL,
                 ZinterpA = "RELATIVE_TO_DEM", ZinterpB = "RELATIVE_TO_DEM",
                 quiet = FALSE))
    expect_error(is_los_visible(ds, ptsA, NULL, band = 1,
                 srsA = NULL, srsB = NULL,
                 ZinterpA = "RELATIVE_TO_DEM", ZinterpB = "RELATIVE_TO_DEM",
                 quiet = FALSE))
    expect_error(is_los_visible(ds, ptsA, ptsB, band = c(1, 2, 3),
                 srsA = NULL, srsB = NULL,
                 ZinterpA = "RELATIVE_TO_DEM", ZinterpB = "RELATIVE_TO_DEM",
                 quiet = FALSE))
    expect_error(is_los_visible(ds, ptsA, ptsB, band = 1,
                 srsA = 4326, srsB = NULL,
                 ZinterpA = "RELATIVE_TO_DEM", ZinterpB = "RELATIVE_TO_DEM",
                 quiet = FALSE))
    expect_error(is_los_visible(ds, ptsA, ptsB, band = 1,
                 srsA = NULL, srsB = 4326,
                 ZinterpA = "RELATIVE_TO_DEM", ZinterpB = "RELATIVE_TO_DEM",
                 quiet = FALSE))
    expect_error(is_los_visible(ds, ptsA, ptsB, band = 1,
                 srsA = NULL, srsB = NULL,
                 ZinterpA = "invalid", ZinterpB = "RELATIVE_TO_DEM",
                 quiet = FALSE))
    expect_error(is_los_visible(ds, ptsA, ptsB, band = 1,
                 srsA = NULL, srsB = NULL,
                 ZinterpA = FALSE, ZinterpB = "RELATIVE_TO_DEM",
                 quiet = FALSE))
    expect_no_error(is_los_visible(ds, ptsA, ptsB, band = 1,
                    srsA = NULL, srsB = NULL,
                    ZinterpA = NULL, ZinterpB = "RELATIVE_TO_DEM",
                    quiet = FALSE))
    expect_error(is_los_visible(ds, ptsA, ptsB, band = 1,
                 srsA = NULL, srsB = NULL,
                 ZinterpA = "RELATIVE_TO_DEM", ZinterpB = "invalid",
                 quiet = FALSE))
    expect_error(is_los_visible(ds, ptsA, ptsB, band = 1,
                 srsA = NULL, srsB = NULL,
                 ZinterpA = "RELATIVE_TO_DEM", ZinterpB = FALSE,
                 quiet = FALSE))
    expect_no_error(is_los_visible(ds, ptsA, ptsB, band = 1,
                    srsA = NULL, srsB = NULL,
                    ZinterpA = "RELATIVE_TO_DEM", ZinterpB = NULL,
                    quiet = FALSE))
    expect_error(is_los_visible(ds, ptsA, ptsB, band = 1,
                 srsA = NULL, srsB = NULL,
                 ZinterpA = "RELATIVE_TO_DEM", ZinterpB = "invalid",
                 quiet = FALSE))
    expect_error(is_los_visible(ds, ptsA, ptsB, band = 1,
                 srsA = NULL, srsB = NULL,
                 ZinterpA = "RELATIVE_TO_DEM", ZinterpB = "RELATIVE_TO_DEM",
                 quiet = "invalid"))
    expect_no_error(is_los_visible(ds, ptsA, ptsB, band = 1,
                    srsA = NULL, srsB = NULL,
                    ZinterpA = "RELATIVE_TO_DEM", ZinterpB = "RELATIVE_TO_DEM",
                    quiet = NULL))
})

test_that("translate runs without error", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    args <- c("-tr", "90", "90", "-r", "average")
    args <- c(args, "-of", "HFA", "-co", "COMPRESSED=YES")
    img_file <- paste0(tempdir(), "/", "storml_elev_90m.img")
    expect_true(translate(elev_file, img_file, args))
    deleteDataset(img_file)
})

test_that("warp runs without error", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    args <- c("-tr", "90", "90", "-r", "cubic", "-tap")
    args <- c(args, "-of", "HFA", "-co", "COMPRESSED=YES")
    alb83_file <- file.path(tempdir(), "storml_elev_alb83.img")
    expect_true(warp(elev_file, alb83_file, t_srs="EPSG:5070", cl_arg = args))
    ds <- new(GDALRaster, alb83_file)
    expect_true(srs_is_same(ds$getProjection(), srs_to_wkt("EPSG:5070")))
    expect_false(any(is.na(ds$getGeoTransform())))
    ds$close()
    unlink(alb83_file)

    # source as GDALRaster object
    src_ds <- new(GDALRaster, elev_file)
    expect_true(warp(src_ds, alb83_file, t_srs="EPSG:5070", cl_arg = args))
    ds <- new(GDALRaster, alb83_file)
    expect_true(srs_is_same(ds$getProjection(), srs_to_wkt("EPSG:5070")))
    expect_false(any(is.na(ds$getGeoTransform())))
    src_ds$close()
    ds$close()
    unlink(alb83_file)

    # invalid source files
    expect_error(warp(c(elev_file, "_err_"), alb83_file, t_srs="EPSG:5070",
                      cl_arg = args))

    # src_ds not open
    expect_error(warp(src_ds, alb83_file, t_srs="EPSG:5070", cl_arg = args))

    # invalid source list
    src_ds$open(read_only = TRUE)
    src_list <- list(src_ds, "_err_")
    expect_error(warp(src_list, alb83_file, t_srs="EPSG:5070", cl_arg = args))
    src_ds$close()

    # source andd destination as GDALRaster objects
    src_ds <- create("MEM", "", 20, 10, 1, "Byte", return_obj = TRUE)
    src_ds$setProjection(epsg_to_wkt(4326))
    src_ds$setGeoTransform(c(-180, 18, 0, 90, 0, -18))
    src_ds$fillRaster(1, 255, 0)

    dst_ds <- create("MEM", "", 20, 20, 1, "Byte", return_obj = TRUE)
    dst_ds$setProjection(epsg_to_wkt(3857))
    dst_ds$setGeoTransform(c(-2e6, 200000, 0, 2e6, 0, -200000))

    expect_true(warp(src_ds, dst_ds, t_srs = ""))
    expect_true(srs_is_same(dst_ds$getProjection(), srs_to_wkt("EPSG:3857")))
    r <- read_ds(dst_ds)
    attributes(r) <- NULL
    expect_equal(r, rep(255, 20 * 20))
    dst_ds$close()
    src_ds$close()

    # process without reproject
    resample_file <- file.path(tempdir(), "storml_elev_90m.img")
    expect_true(warp(elev_file, resample_file, t_srs="", cl_arg = args))
    ds1 <- new(GDALRaster, elev_file, read_only=TRUE)
    srs1 <- ds1$getProjectionRef()
    ds1$close()
    ds2 <- new(GDALRaster, resample_file, read_only=TRUE)
    srs2 <- ds2$getProjectionRef()
    ds2$close()
    expect_true(srs_is_same(srs1, srs2))

    # clean up
    deleteDataset(alb83_file)
    deleteDataset(resample_file)
})

# Tests for src/transform.cpp

test_that("transform/inv_project give correct results", {
    ## transform_xy
    pt_file <- system.file("extdata/storml_pts.csv", package="gdalraster")
    pts <- read.csv(pt_file)
    xy_alb83 <- c(-1330885, -1331408, -1331994, -1330297, -1329991, -1329167,
                  -1329903, -1329432, -1327683, -1331265,  2684892,  2684660,
                   2685048,  2684967,  2683777,  2685212,  2685550,  2683821,
                   2685541,  2685514)

    xy_test <- transform_xy(pts = pts[,-1],
                            srs_from = epsg_to_wkt(26912),
                            srs_to = epsg_to_wkt(5070))
    expect_equal(as.vector(xy_test), xy_alb83, tolerance=0.1)

    # as matrix
    xy_test <- transform_xy(pts = as.matrix(pts[,-1]),
                            srs_from = epsg_to_wkt(26912),
                            srs_to = epsg_to_wkt(5070))
    expect_equal(as.vector(xy_test), xy_alb83, tolerance=0.1)

    # with NA
    pts[11, ] <- c(11, NA, NA)
    expect_warning(xy_test <- transform_xy(pts = pts[,-1],
                                           srs_from = epsg_to_wkt(26912),
                                           srs_to = epsg_to_wkt(5070)))
    expect_equal(as.vector(xy_test[1:10, ]), xy_alb83, tolerance=0.1)
    expect_true(is.na(xy_test[11, 1]) && is.na(xy_test[11, 2]))
    pts <- pts[-11, ]

    # as vector for one point
    xy_test <- transform_xy(pts = c(pts[1, 2], pts[1, 3]),
                            srs_from = epsg_to_wkt(26912),
                            srs_to = epsg_to_wkt(5070))
    expect_equal(as.vector(xy_test), c(xy_alb83[1], xy_alb83[11]),
                 tolerance=0.1)

    # as WKB/WKT geometries
    m <- as.matrix(pts[, -1])
    pts_wkb <- lapply(seq_len(nrow(m)), function(i) g_create("POINT", m[i, ]))
    pts_wkt <- g_wk2wk(pts_wkb)
    xy_test <- transform_xy(pts = pts_wkb,
                            srs_from = epsg_to_wkt(26912),
                            srs_to = epsg_to_wkt(5070))
    expect_equal(as.vector(xy_test), xy_alb83, tolerance=0.1)
    xy_test <- transform_xy(pts = pts_wkt,
                            srs_from = epsg_to_wkt(26912),
                            srs_to = epsg_to_wkt(5070))
    expect_equal(as.vector(xy_test), xy_alb83, tolerance=0.1)

    # errors
    expect_error(transform_xy(pts = pts[,-1],
                              srs_from = "invalid",
                              srs_to = epsg_to_wkt(5070)))
    expect_error(transform_xy(pts = pts[,-1],
                              srs_from = epsg_to_wkt(26912),
                              srs_to = "invalid"))
    # transform error
    pts[11, ] <- c(11, Inf, Inf)
    expect_warning(xy_test <- transform_xy(pts = pts[,-1],
                                           srs_from = epsg_to_wkt(26912),
                                           srs_to = epsg_to_wkt(5070)))
    expect_equal(as.vector(xy_test[1:10, ]), xy_alb83, tolerance=0.1)
    expect_true(is.na(xy_test[11, 1]) && is.na(xy_test[11, 2]))
    pts <- pts[-11, ]

    # invalid geometry type
    g <- "POLYGON ((0 0, 10 10, 10 0, 0 0))"
    expect_error(transform_xy(pts = g,
                              srs_from = epsg_to_wkt(26912),
                              srs_to = epsg_to_wkt(5070)))


    ## inv_project
    xy_wgs84 <- c(-113.26707, -113.27315, -113.28150, -113.25978, -113.25312,
                  -113.24600, -113.25613, -113.24613, -113.22794, -113.27334,
                  46.06118, 46.05827, 46.06076, 46.06280, 46.05276, 46.06682,
                  46.06862, 46.05405, 46.07214, 46.06607)

    inv_test <- inv_project(pts = pts[,-1],
                            srs = epsg_to_wkt(26912),
                            well_known_gcs = "WGS84")
    expect_equal(as.vector(inv_test), xy_wgs84, tolerance = 0.001)

    # as matrix
    inv_test <- inv_project(pts = as.matrix(pts[,-1]),
                            srs = epsg_to_wkt(26912),
                            well_known_gcs = "WGS84")
    expect_equal(as.vector(inv_test), xy_wgs84, tolerance = 0.001)

    # as vector for one point
    inv_test <- inv_project(pts = c(pts[1, 2], pts[1, 3]),
                            srs = epsg_to_wkt(26912),
                            well_known_gcs = "WGS84")
    expect_equal(as.vector(inv_test), c(xy_wgs84[1], xy_wgs84[11]),
                 tolerance=0.001)

    # as WKB/WKT geometries
    inv_test <- inv_project(pts = pts_wkb,
                            srs = epsg_to_wkt(26912),
                            well_known_gcs = "WGS84")
    expect_equal(as.vector(inv_test), xy_wgs84, tolerance = 0.001)
    inv_test <- inv_project(pts = pts_wkt,
                            srs = epsg_to_wkt(26912),
                            well_known_gcs = "WGS84")
    expect_equal(as.vector(inv_test), xy_wgs84, tolerance = 0.001)

    # warnings
    if (gdal_version_num() < gdal_compute_version(3, 11, 0)) {
        # behavior change at GDAL 3.11 https://github.com/OSGeo/gdal/pull/11819
        expect_warning(inv_project(pts = c(Inf, Inf),
                                   srs = epsg_to_wkt(26912),
                                   well_known_gcs = "WGS84"))
    }
    expect_warning(ret <- inv_project(matrix(c(Inf, -1330885, Inf, 2684892),
                                             ncol = 2),
                                      srs = epsg_to_wkt(26912),
                                      well_known_gcs = "WGS84"))
    expect_false(all(is.na(ret)))
    expect_true(any(is.na(ret)))

    # errors
    if (gdal_version_num() >= gdal_compute_version(3, 11, 0)) {
        # behavior change at GDAL 3.11 https://github.com/OSGeo/gdal/pull/11819
        expect_error(inv_project(pts = c(Inf, Inf),
                                 srs = epsg_to_wkt(26912),
                                 well_known_gcs = "WGS84"))
    }
    expect_error(inv_project(pts = as.vector(pts[,-1]),
                             srs = epsg_to_wkt(26912),
                             well_known_gcs = "WGS84"))
    expect_error(inv_project(pts = as.matrix(pts[,-1]),
                             srs = "invalid",
                             well_known_gcs = "WGS84"))
    expect_error(inv_project(pts = as.matrix(pts[,-1]),
                             srs = epsg_to_wkt(26912),
                             well_known_gcs = "invalid"))
    # transform error
    pts[11, ] <- c(11, Inf, Inf)
    expect_warning(inv_test <- inv_project(pts = pts[,-1],
                                           srs = epsg_to_wkt(26912),
                                           well_known_gcs = "WGS84"))
    expect_equal(as.vector(inv_test[1:10, ]), xy_wgs84, tolerance=0.001)
    expect_true(is.na(inv_test[11, 1]) && is.na(inv_test[11, 2]))
    pts <- pts[-11, ]

    # invalid geom type
    g <- "POLYGON ((0 0, 10 10, 10 0, 0 0))"
    expect_error(inv_project(pts = g,
                             srs = epsg_to_wkt(26912),
                             well_known_gcs = "WGS84"))


    ## with xyz/xyzt 3 or 4 column input
    # lon/lat to UTM zone 11N (EPSG:32611)
    m_xyz <- matrix(c(-117.5, 32.0, 0.0, -117.5, 32.0, 10.0),
                    ncol = 3, byrow = TRUE)

    res <- transform_xy(m_xyz, "WGS84", "EPSG:32611")
    expect_equal(nrow(res), 2)
    expect_equal(ncol(res), 3)
    expect_equal(res[2, 1], 452772.1, tolerance = 0.01)
    expect_equal(res[2, 2], 3540545, tolerance = 0.01)
    expect_equal(res[2, 3], 10)

    # inverse
    m_xyz <- matrix(c(452772.1, 3540545, 0.0, 452772.1, 3540545, 10.0),
                    ncol = 3, byrow = TRUE)
    res <- inv_project(m_xyz, "EPSG:32611", "WGS84")
    expect_equal(nrow(res), 2)
    expect_equal(ncol(res), 3)
    expect_equal(res[2, 1], -117.5, tolerance = 0.1)
    expect_equal(res[2, 2], 32.0, tolerance = 0.1)
    expect_equal(res[2, 3], 10)

    # with time values
    m_xyzt <- matrix(c(-117.5, 32.0, 0.0, 2000, -117.5, 32.0, 10.0, 2000),
                     ncol = 4, byrow = TRUE)

    res <- transform_xy(m_xyzt, "WGS84", "EPSG:32611")
    expect_equal(nrow(res), 2)
    expect_equal(ncol(res), 4)
    expect_equal(res[2, 1], 452772.1, tolerance = 0.01)
    expect_equal(res[2, 2], 3540545, tolerance = 0.01)
    expect_equal(res[2, 3], 10)
    expect_equal(res[2, 4], 2000)

    # inverse
    m_xyzt <- matrix(c(452772.1, 3540545, 0.0, 2000, 452772.1, 3540545, 10.0, 2000),
                     ncol = 4, byrow = TRUE)
    res <- inv_project(m_xyzt, "EPSG:32611", "WGS84")
    expect_equal(nrow(res), 2)
    expect_equal(ncol(res), 4)
    expect_equal(res[2, 1], -117.5, tolerance = 0.1)
    expect_equal(res[2, 2], 32.0, tolerance = 0.1)
    expect_equal(res[2, 3], 10)
    expect_equal(res[2, 4], 2000)
})

test_that("transform_bounds gives correct results", {
    skip_if(gdal_version_num() < 3040000)

    # south pole
    bb <- c(-1405880.717371, -1371213.762543, 5405880.717371, 5371213.762543)
    res <- transform_bounds(bb, "EPSG:32761", "EPSG:4326",
                            traditional_gis_order = FALSE)
    expected <- c(-90.0, -180.0, -48.65641, 180.0)
    expect_equal(res, expected, tolerance = 1e-4)
    # lon/lat axis ordering by default
    res <- transform_bounds(bb, "EPSG:32761", "EPSG:4326")
    expected <- c(-180.0, -90.0, 180.0, -48.65641)
    expect_equal(res, expected, tolerance = 1e-4)

    # antimeridian, normalized axis ordering
    bb <- c(160.6, -55.95, -171.2, -25.88)
    res <- transform_bounds(bb, "EPSG:4167", "EPSG:3851")
    expected <- c(1722483.900174921, 5228058.6143420935,
                  4624385.494808555, 8692574.544944234)
    expect_equal(res, expected, tolerance = 1e-4)
    # matrix input
    bb_mat <- matrix(c(bb, bb), nrow = 2, ncol = 4, byrow = TRUE)
    res <- transform_bounds(bb_mat, "EPSG:4167", "EPSG:3851")
    expected <- matrix(c(1722483.900174921, 5228058.6143420935,
                         4624385.494808555, 8692574.544944234,
                         1722483.900174921, 5228058.6143420935,
                         4624385.494808555, 8692574.544944234),
                       nrow = 2, ncol = 4, byrow = TRUE)
    expect_equal(res, expected, tolerance = 1e-4)
    # data frame input
    res <- transform_bounds(as.data.frame(bb_mat), "EPSG:4167", "EPSG:3851")
    expect_equal(res, expected, tolerance = 1e-4)
    # authority compliant axis ordering
    bb <- c(-55.95, 160.6, -25.88, -171.2)
    res <- transform_bounds(bb, "EPSG:4167", "EPSG:3851",
                            traditional_gis_order = FALSE)
    expected <- c(5228058.6143420935, 1722483.900174921,
                  8692574.544944234, 4624385.494808555)
    expect_equal(res, expected, tolerance = 1e-4)


    ## input validation
    # NULL bbox
    expect_true(is.null(transform_bounds(NULL, "EPSG:4167", "EPSG:3851")))

    # vector length != 4
    bb <- c(160.6, -55.95, -171.2, -25.88)
    expect_no_error(transform_bounds(bb, "EPSG:4167", "EPSG:3851"))
    expect_error(transform_bounds(bb[1:2], "EPSG:4167", "EPSG:3851"))

    # matrix columns != 4
    bb_mat <- matrix(c(bb, bb), nrow = 4, ncol = 2)
    expect_error(transform_bounds(bb_mat, "EPSG:4167", "EPSG:3851"))

    # no error for 1-row matrix, output as vector (no dim)
    bb_mat <- matrix(bb, nrow = 1, ncol = 4, byrow = TRUE)
    expect_no_error(res <- transform_bounds(bb_mat, "EPSG:4167", "EPSG:3851"))
    expected <- c(1722483.900174921, 5228058.6143420935,
                  4624385.494808555, 8692574.544944234)
    expect_equal(res, expected, tolerance = 1e-4)

    # input is not a numeric vector or matrix
    bb_char_mat <- as.character(bb_mat)
    expect_error(transform_bounds(bb_char_mat, "EPSG:4167", "EPSG:3851"))

    # 0-row matrix
    bb_mat_0 <- matrix(numeric(0), nrow = 0, ncol = 4, byrow = TRUE)
    expect_error(transform_bounds(bb_mat_0, "EPSG:4167", "EPSG:3851"))

    # input bbox contains NA
    bb_na <- rep(NA_real_, 4)
    expect_warning(res <- transform_bounds(bb_na, "EPSG:4167", "EPSG:3851"))
    expect_equal(res, rep(NA_real_, 4))

    # matrix input with NA
    bb_mat_na <- matrix(c(bb, rep(NA_real_, 4)), nrow = 2, ncol = 4,
                        byrow = TRUE)
    expect_warning(res <- transform_bounds(bb_mat_na, "EPSG:4167", "EPSG:3851"))
    expected <- matrix(c(1722483.900174921, 5228058.6143420935,
                         4624385.494808555, 8692574.544944234,
                         NA_real_, NA_real_, NA_real_, NA_real_),
                       nrow = 2, ncol = 4, byrow = TRUE)
    expect_equal(res, expected, tolerance = 1e-4)

    # invalid srs_from or srs_to
    bb <- c(160.6, -55.95, -171.2, -25.88)
    expect_error(transform_bounds(bb, "invalid", "EPSG:3851"))
    expect_error(transform_bounds(bb, "EPSG:4167", "invalid"))
})

test_that("VSIFile constructors work", {
    lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")

    # default constructor, no file
    expect_no_error(vf <- new(VSIFile))
    expect_true(is(vf, "Rcpp_VSIFile"))
    expect_no_error(show(vf))
    expect_equal(vf$close(), -1)
    # filename
    expect_no_error(vf <- new(VSIFile, lcp_file))
    expect_true(is(vf, "Rcpp_VSIFile"))
    expect_equal(vf$close(), 0)
    expect_true(vf$reportVSIFErrorAsEof)
    expect_no_error(vf$reportVSIFErrorAsEof <- FALSE)
    expect_false(vf$reportVSIFErrorAsEof)
    # filename, access
    expect_no_error(vf <- new(VSIFile, lcp_file, "r"))
    expect_true(is(vf, "Rcpp_VSIFile"))
    expect_equal(vf$close(), 0)
    # filename, r+ access
    tmp_file <- tempfile(fileext = ".lcp")
    file.copy(lcp_file, tmp_file, overwrite = TRUE)
    expect_no_error(vf <- new(VSIFile, tmp_file, "r+"))
    vf$seek(0, SEEK_END)
    expect_equal(vf$tell(), vsi_stat(lcp_file, "size"))
    expect_equal(vf$close(), 0)
    # filename, w access
    expect_no_error(vf <- new(VSIFile, tmp_file, "w"))
    vf$seek(0, SEEK_END)
    expect_equal(vf$tell(), as.integer64(0))
    expect_equal(vf$close(), 0)
    vsi_unlink(tmp_file)
    # testing options depends on GDAL version, and needs internet access
    # so only testing with an empty vector for now
    expect_no_error(vf <- new(VSIFile, lcp_file, "r", character(0)))
    expect_true(is(vf, "Rcpp_VSIFile"))
    expect_equal(vf$close(), 0)
    # error on invalid options or GDAL < 3.3
    # invalid options do not seem to raise an error
    # url <- "/vsicurl/https://raw.githubusercontent.com/"
    # url <- paste0(url, "firelab/gdalraster/main/sample-data/")
    # url <- paste0(url, "lf_elev_220_mt_hood_utm.tif")
    # expect_error(vf <- new(VSIFile, url, "r", "INAVLID_OPTION=YES"))

    # at least test that passing options does not crash to avoid the issue in:
    # https://github.com/firelab/gdalraster/issues/883

    skip_if(gdal_version_num() < gdal_compute_version(3, 10, 0))
    skip_on_cran()

    f_invalid <- "/vsis3/eodata/Sentinel-1/_invalid-file-name_.tif"
    opt <- c("DISABLE_READDIR_ON_OPEN=YES", "CACHE=NO")
    expect_error(vf <- new(VSIFile, f_invalid, "r", opt))
})

test_that("VSIFile methods work", {
    lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")

    # function to identify an LCP file
    is_lcp <- function(bytes) {
        values <- readBin(bytes, "integer", 3)
        if ((values[1] == 20 || values[1] == 21) &&
                (values[2] == 20 || values[2] == 21) &&
                (values[3] >= -90 && values[3] <= 90)) {

            return(TRUE)
        } else {
            return(FALSE)
        }
    }

    vf <- new(VSIFile, lcp_file)
    bytes <- vf$read(12)
    expect_vector(bytes, ptype = raw(), size = 12)
    expect_true(is_lcp(bytes))
    expect_equal(vf$tell(), as.integer64(12))
    expect_false(vf$eof())
    expect_silent(vf$rewind())
    expect_equal(vf$tell(), as.integer64(0))

    bytes <- vf$ingest(-1)
    expect_vector(bytes, raw())
    vf$close()
    # if the file is not open
    expect_equal(vf$close(), -1)

    # write to an in-memory file
    lcp_size <- vsi_stat(lcp_file, "size")
    mem_file <- "/vsimem/storml_copy.lcp"
    vf <- new(VSIFile, mem_file, "w+")
    expect_equal(vf$write(bytes), as.integer64(lcp_size))
    expect_equal(vf$flush(), 0)
    expect_equal(vf$tell(), as.integer64(lcp_size))
    expect_equal(vf$seek(0, SEEK_SET), 0)
    expect_equal(vf$tell(), as.integer64(0))
    expect_equal(vf$seek(0, SEEK_END), 0)
    expect_equal(vf$tell(), as.integer64(lcp_size))
    vf$rewind()
    expect_true(is_lcp(vf$read(12)))

    # read/write an integer field
    # write invalid data for the Latitude field and then set back
    # save original
    vf$seek(8, SEEK_SET)
    lat_orig <- vf$read(4)
    # latitude -99 out of range
    bytes <- writeBin(-99L, raw())
    # giving offset as integer64 type
    vf$seek(as.integer64(8), SEEK_SET)
    vf$write(bytes)
    vf$rewind()
    expect_false(is_lcp(vf$read(12)))
    vf$seek(8, SEEK_SET)
    expect_equal(readBin(vf$read(4), "integer"), -99L)
    # set back to original
    vf$seek(8, SEEK_SET)
    vf$write(lat_orig)
    vf$rewind()
    expect_true(is_lcp(vf$read(12)))

    # read double - min X coord
    vf$seek(4180, SEEK_SET)
    expect_equal(readBin(vf$read(8), "double"), 323476.071970863151364)

    # read short int - canopy cover units, 1 = percent
    vf$seek(4232, SEEK_SET)
    expect_equal(readBin(vf$read(2), "integer", size = 2), 1L)

    # read the Description field
    vf$seek(6804, SEEK_SET)
    # read should accept integer64 input
    bytes <- vf$read(as.integer64(512))
    expect_equal(rawToChar(bytes), "LCP file created by GDAL.")

    # edit the Description
    desc <- paste(rawToChar(bytes),
                  "Storm Lake AOI,",
                  "Beaverhead-Deerlodge National Forest, Montana.")

    vf$seek(6804, SEEK_SET)
    expect_equal(vf$write(charToRaw(desc)), as.integer64(nchar(desc)))
    vf$close()

    # be sure it works as a raster dataset
    ds <- new(GDALRaster, mem_file)
    desc_mdi <- ds$getMetadataItem(band = 0,
                                   mdi_name = "DESCRIPTION",
                                   domain = "")
    expect_equal(desc_mdi, desc)
    ds$close()

    # re-open and test eof
    expect_equal(vf$get_filename(), mem_file)
    expect_equal(vf$get_access(), "w+")
    expect_equal(vf$set_access("r+"), 0)
    expect_no_error(vf$open())
    vf$seek(0, SEEK_END)
    expect_equal(vf$tell(), as.integer64(lcp_size))
    expect_true(is.null(vf$read(1)))
    expect_true(vf$eof())
    vf$seek(0, SEEK_SET)
    expect_false(vf$eof())

    # expand the file, giving new_size as integer64 type
    lcp_size_x2 <- as.integer64(lcp_size * 2)
    expect_equal(vf$truncate(lcp_size_x2), 0)
    vf$close()
    expect_equal(as.integer(vsi_stat(mem_file, "size")),
                 as.integer(lcp_size_x2))

    # truncate back to original size
    vf$open()
    expect_equal(vf$truncate(lcp_size), 0)
    vf$rewind()
    expect_true(is_lcp(vf$read(12)))
    vf$close()

    # verify it still works as a raster dataset
    ds$open(TRUE)
    expect_equal(ds$dim(), c(143, 107, 8))
    ncols <- ds$getRasterXSize()
    rowdata <- ds$read(band=1, xoff=0, yoff=9,
                       xsize=ncols, ysize=1,
                       out_xsize=ncols, out_ysize=1)
    expect_equal(head(rowdata), c(-9999, -9999, -9999, 2456, 2466, 2479))
    ds$close()

    # errors
    expect_error(vf$seek(0, SEEK_SET))
    expect_error(vf$tell())
    expect_error(vf$rewind())
    expect_error(vf$read(1))
    expect_error(vf$write(bytes))
    expect_error(vf$eof())
    expect_error(vf$truncate(100))
    expect_error(vf$flush())
    expect_error(vf$ingest(-1))

    expect_no_error(vf$open())
    expect_error(vf$seek(c(0, 10), SEEK_SET))
    expect_error(vf$seek(-1, SEEK_SET))
    expect_error(vf$seek(0, "invalid_origin"))
    expect_true(is.null((vf$read(0))))
    expect_error(vf$truncate(-1))
    expect_error(vf$truncate(as.integer64(-1)))
    expect_true(is.null(vf$ingest(as.integer64(1))))
    expect_equal(vf$set_access("r"), -1)
    expect_no_error(vf$close())
    expect_equal(vf$set_access("string_too_long"), -1)

    vsi_unlink(mem_file)
    expect_error(vf <- new(VSIFile, mem_file, "r"))

    # test /vsizip/ SOZip for read access only
    skip_if(as.integer(gdal_version()[2]) < 3070000)

    zip_file <- file.path(tempdir(), "storml_lcp.zip")
    addFilesInZip(zip_file, lcp_file, overwrite = TRUE, full_paths = FALSE,
                  sozip_enabled = "YES", num_threads = 1)

    lcp_in_zip <- file.path("/vsizip", zip_file, "storm_lake.lcp")
    expect_no_error(vf <- new(VSIFile, lcp_in_zip, "r"))
    expect_true(vf$read(12) |> is_lcp())
    # read the Description field
    vf$seek(6804, SEEK_SET)
    bytes <- vf$read(512)
    expect_equal(rawToChar(bytes), "LCP file created by GDAL.")

    vf$close()
    vsi_unlink(zip_file)
})

# Tests for src/gdalraster.cpp
test_that("class constructors work as expected", {
    # TODO: constructors are tested throughout, but add systematic tests here
    # ...

    # not recognized as being in a supported file format
    f <- system.file("extdata/doctype.xml", package="gdalraster")
    expect_error(ds <- new(GDALRaster, f))

    # allowed drivers
    evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
    expect_no_error(ds <- new(GDALRaster, evt_file, TRUE, NULL, TRUE, "GTiff"))
    ds$close()

    # changes in GDAL 3.10.0 affect reliability of identify driver with allowed
    # skip_if(gdal_version_num() < gdal_compute_version(3, 10, 0))
    # expect_error(ds <- new(GDALRaster, evt_file, TRUE, NULL, TRUE, "HFA"))
})

test_that("info() prints output to the console", {
    evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
    ds <- new(GDALRaster, evt_file, TRUE)
    # check S4 show here also, needs snapshot test for {cli} formatting
    expect_no_error(show(ds))
    expect_output(ds$info())
    # with args
    ds$infoOptions <- c("-nomd", "-norat", "-noct")
    expect_output(ds$info())
    # with invalid arg
    ds$infoOptions <- "--invalid_arg"
    expect_error(ds$info())
    # restore default
    ds$infoOptions <- ""
    expect_output(ds$info())
    ds$close()
})

test_that("infoAsJSON() returns string output", {
    evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
    tmp_file <- paste0(tempdir(), "/", "storml_evt_tmp.tif")
    file.copy(evt_file,  tmp_file)
    ds <- new(GDALRaster, tmp_file, TRUE)
    expect_vector(ds$infoAsJSON(), character(), size = 1)
    expect_true(nchar(ds$infoAsJSON()) > 100)
    # test passing extra `-json`
    ds$infoOptions <- "-json"
    expect_vector(ds$infoAsJSON(), character(), size = 1)
    expect_true(nchar(ds$infoAsJSON()) > 100)

    files <- ds$getFileList()
    on.exit(unlink(files))
    ds$close()
})

test_that("dataset parameters are correct", {
    evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
    ds <- new(GDALRaster, evt_file)
    expect_length(ds$getFileList(), 1)
    expect_equal(ds$getDriverShortName(), "GTiff")
    expect_equal(ds$getDriverLongName(), "GeoTIFF")
    expect_equal(ds$getRasterXSize(), 143)
    expect_equal(ds$getRasterYSize(), 107)
    expect_equal(ds$getGeoTransform(),
                 c(323476.1,30.0,0.0,5105082.0,0.0,-30.0))
    expect_equal(ds$bbox(), c(323476.1,5101872.0,327766.1,5105082.0))
    expect_equal(ds$res(), c(30,30))
    expect_equal(ds$dim(), c(143,107,1))
    ds$close()

    # using dataset open options
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    oo <- "NUM_THREADS=2"
    ds_oo <- new(GDALRaster, elev_file, TRUE, oo)
    expect_equal(ds_oo$getDriverShortName(), "GTiff")
    expect_equal(ds_oo$getDriverLongName(), "GeoTIFF")
    expect_equal(ds_oo$getRasterXSize(), 143)
    expect_equal(ds_oo$getRasterYSize(), 107)
    expect_equal(ds_oo$getGeoTransform(),
                 c(323476.1,30.0,0.0,5105082.0,0.0,-30.0))
    expect_equal(ds_oo$bbox(), c(323476.1,5101872.0,327766.1,5105082.0))
    expect_equal(ds_oo$res(), c(30,30))
    expect_equal(ds_oo$dim(), c(143,107,1))
    ds_oo$close()

    # without using shared mode
    ds_ns <- new(GDALRaster, elev_file, TRUE, NULL, FALSE)
    expect_equal(ds_ns$getDriverShortName(), "GTiff")
    ds_ns$close()

    # south-up raster bbox()
    f <- system.file("extdata/south-up.tif", package="gdalraster")
    ds <- new(GDALRaster, f)
    expect_equal(ds$bbox(), c(-119.55, 36.55, -118.43, 37.45), tolerance = 1e-6)
    ds$close()

    # rotated raster res()
    f <- system.file("extdata/geomatrix.tif", package="gdalraster")
    ds <- new(GDALRaster, f)
    expect_warning(cellsize <- ds$res())
    expect_equal(cellsize, c(NA_real_, NA_real_))
    ds$close()
})

test_that("band-level parameters are correct", {
    evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
    ds <- new(GDALRaster, evt_file, TRUE)
    expect_equal(ds$getBlockSize(1), c(143,28))
    expect_equal(ds$getActualBlockSize(1, 0, 0), c(143,28))
    expect_equal(ds$getOverviewCount(1), 0)
    expect_equal(ds$getDataTypeName(1), "Int16")
    expect_equal(ds$getNoDataValue(1), 32767)
    flags <- ds$getMaskFlags(band = 1)
    expect_true(is.list(flags))
    expect_false(flags$ALL_VALID)
    expect_false(flags$PER_DATASET)
    expect_false(flags$ALPHA)
    expect_true(flags$NODATA)
    mask_band <- ds$getMaskBand(band = 1)
    expect_true(mask_band$MaskFile == "")
    expect_true(mask_band$BandNumber == 0)
    expect_equal(ds$getUnitType(1), "")
    expect_true(is.na(ds$getScale(1)))
    expect_true(is.na(ds$getOffset(1)))
    expect_equal(ds$getDescription(1), "")
    ds$close()
})

test_that("get/set metadata works", {
    evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
    ds <- new(GDALRaster, evt_file, TRUE)
    expect_equal(ds$getMetadata(band=0, domain=""), "AREA_OR_POINT=Area")
    expect_equal(ds$getMetadata(band=1, domain=""),
                 "RepresentationType=ATHEMATIC")
    expect_equal(ds$getMetadata(band=0, domain="IMAGE_STRUCTURE"),
                 "INTERLEAVE=BAND")
    expect_equal(ds$getMetadata(band=1, domain="IMAGE_STRUCTURE"), "")
    expect_equal(ds$getMetadataItem(band=0, mdi_name="AREA_OR_POINT",
                                    domain=""),
                 "Area")
    expect_equal(ds$getMetadataItem(band=0, "INTERLEAVE",
                                    domain="IMAGE_STRUCTURE"),
                 "BAND")
    expect_equal(ds$getMetadataItem(band=1, mdi_name="COMPRESSION",
                                    domain="IMAGE_STRUCTURE"),
                 "")
    expect_equal(length(ds$getMetadataDomainList(band=0)), 3)
    expect_equal(length(ds$getMetadataDomainList(band=1)), 1)

    f <- tempfile(fileext = ".tif")
    ds2 <- create(format="GTiff", dst_filename=f, xsize=10, ysize=10,
                  nbands=1, dataType="Int32", return_obj = TRUE)

    srs <- ds$getProjection()
    expect_equal(ds$getProjectionRef(), srs)
    expect_equal(ds$getSpatialRef(), srs)
    ds2$setProjection(srs)
    gt <- ds$getGeoTransform()
    ds2$setGeoTransform(gt)
    md <- ds$getMetadata(band=0, domain="")
    expect_true(ds2$setMetadata(band=0, metadata=md, domain=""))

    expect_true(ds2$setMetadataItem(band=1, mdi_name="RepresentationType",
                                    mdi_value="THEMATIC", domain=""))
    ds2$close()
    ds2$open(read_only = TRUE)
    expect_equal(ds2$getMetadata(band=0, domain=""), "AREA_OR_POINT=Area")
    expect_equal(ds2$getMetadata(band=1, domain=""),
                 "RepresentationType=THEMATIC")

    ds$close()
    ds2$close()
    deleteDataset(f)
})

test_that("open/close/re-open works", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    ds <- new(GDALRaster, elev_file)
    dm <- ds$dim()
    r <- read_ds(ds)
    ds$close()
    mod_file <- paste0(tempdir(), "/", "storml_elev_mod.tif")
    rasterFromRaster(srcfile = elev_file,
                     dstfile = mod_file,
                     nbands = 1,
                     dtName = "UInt32",
                     init = DEFAULT_NODATA[["UInt32"]])
    ds <- new(GDALRaster, mod_file)
    expect_true(ds$isOpen())
    expect_true(ds$isReadOnly())
    expect_true(all(is.na(read_ds(ds))))
    ds$close()
    expect_false(ds$isOpen())
    expect_equal(ds$getFilename(), .check_gdal_filename(mod_file))
    ds$open(read_only = FALSE)
    expect_true(ds$isOpen())
    expect_false(ds$isReadOnly())
    ds$setDescription(band = 1, "test")
    expect_equal(ds$getDescription(band = 1), "test")
    r[is.na(r)] <- DEFAULT_NODATA[["UInt32"]]
    ds$write(band=1, 0, 0, dm[1], dm[2], r)
    expect_silent(ds$flushCache())
    expect_false(all(is.na(read_ds(ds))))
    expect_true(any(is.na(read_ds(ds))))
    files <- ds$getFileList()
    on.exit(unlink(files))
    ds$close()

    ds <- new(GDALRaster)
    ds$setFilename(elev_file)
    ds$open(TRUE)
    expect_equal(ds$dim(), dm)
    ds$close()
})

test_that("statistics are correct", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    mod_file <- paste0(tempdir(), "/", "storml_elev_mod.tif")
    file.copy(elev_file,  mod_file)
    ds <- new(GDALRaster, mod_file, read_only=FALSE)
    expect_equal(ds$getMinMax(band=1, approx_ok=FALSE), c(2438, 3046))
    stats <- round(ds$getStatistics(band=1, approx_ok=FALSE, force=TRUE))
    expect_equal(stats, c(2438, 3046, 2676, 133))
    if (as.integer(gdal_version()[2]) >= 3020000) {
        ds$flushCache()
        ds$clearStatistics()
        ds$flushCache()
        stats <- round(ds$getStatistics(band=1, approx_ok=TRUE, force=FALSE))
        expect_true(all(is.na(stats)))
    }

    # quiet
    stats <- NULL
    ds$quiet <- TRUE
    expect_silent(stats <- ds$getStatistics(band=1, approx_ok=FALSE,
                                            force=TRUE))
    expect_equal(round(stats), c(2438, 3046, 2676, 133))

    files <- ds$getFileList()
    on.exit(unlink(files))
    ds$close()
})

test_that("get histogram works", {
    tcc_file <- system.file("extdata/storml_tcc.tif", package="gdalraster")
    f <- paste0(tempdir(), "/", "storml_tcc_test.tif")
    file.copy(tcc_file,  f)
    ds <- new(GDALRaster, f, read_only=TRUE)
    num_bins <- length(ds$getHistogram(1, -0.5, 100.5, 101, FALSE, FALSE))
    expect_equal(num_bins, 101)
    num_pixels <- sum(ds$getHistogram(1, -0.5, 100.5, 101, FALSE, FALSE))
    expect_equal(num_pixels, 15301)
    # quiet
    num_pixels <- 0
    ds$quiet <- TRUE
    expect_silent(num_pixels <- sum(ds$getHistogram(1, -0.5, 100.5, 101,
                                                    FALSE, FALSE)))
    expect_equal(num_pixels, 15301)

    ds$close()
    deleteDataset(f)

    # default histogram
    f2 <- paste0(tempdir(), "/", "storml_tcc_test2.tif")
    file.copy(tcc_file,  f2)
    ds <- new(GDALRaster, f2, read_only=TRUE)
    expect_warning(ds$getDefaultHistogram(1, FALSE))
    expect_length(ds$getDefaultHistogram(1, TRUE), 4)
    ds$close()
    deleteDataset(f2)
})

test_that("getInterBandCovMatrix works", {
    skip_if(gdal_version_num() < gdal_compute_version(3, 13, 0))

    # https://github.com/OSGeo/gdal/blob/master/autotest/gcore/gdal_stats.py

    f <- system.file("extdata/rgbsmall.tif", package="gdalraster")
    f_tmp <- tempfile(fileext = ".tif")
    expect_true(file.copy(f, f_tmp))
    f_tmp_aux <- paste0(f_tmp, ".aux.xml")

    ds <- new(GDALRaster, f_tmp)
    on.exit(ds$close(), add = TRUE)
    on.exit(deleteDataset(f_tmp), add = TRUE)

    x <- c(2241.7045363745387, 2898.8196128051163, 1009.979953581434,
           2898.8196128051163, 3900.269159023618, 1248.65396718687,
           1009.979953581434, 1248.65396718687, 602.4703641456648)

    expected_cov_matrix <- matrix(x, 3, 3, byrow = TRUE)

    cov_matrix <- ds$getInterBandCovMatrix(0, FALSE, TRUE, FALSE, 1)
    ds$flushCache()

    expect_equal(cov_matrix, expected_cov_matrix, tolerance = 1e4)
    expect_false(vsi_stat_exists(f_tmp_aux))

    # write in metadata
    cov_matrix <- ds$getInterBandCovMatrix(0, FALSE, TRUE, TRUE, 1)
    ds$flushCache()

    expect_equal(cov_matrix, expected_cov_matrix, tolerance = 1e4)
    expect_true(vsi_stat_exists(f_tmp_aux))

    # retrieve from metadata
    cov_matrix <- ds$getInterBandCovMatrix(0, FALSE, FALSE, FALSE, 1)
    expect_equal(cov_matrix, expected_cov_matrix, tolerance = 1e4)

    # with band list
    cov_matrix <- ds$getInterBandCovMatrix(c(1, 2, 3), FALSE, FALSE, FALSE, 1)
    expect_equal(cov_matrix, expected_cov_matrix, tolerance = 1e4)

    # invalid bands
    expect_error(ds$getInterBandCovMatrix(c(0, 1, 2), FALSE, FALSE, FALSE, 1))
    expect_error(ds$getInterBandCovMatrix(c(1, 2, 4), FALSE, FALSE, FALSE, 1))
})

test_that("floating point I/O works", {
    f <- paste0(tempdir(), "/", "testfloat.tif")
    create(format="GTiff", dst_filename=f, xsize=10, ysize=10,
           nbands=1, dataType="Float32")
    ds <- new(GDALRaster, f, read_only=FALSE)
    set.seed(42)
    z <- runif(10*10)
    ds$write(band=1, xoff=0, yoff=0, xsize=10, ysize=10, z)
    ds$open(read_only=TRUE)
    expect_warning(r <- read_ds(ds))
    attributes(r) <- NULL
    expect_equal(round(r,5), round(z,5))
    ds$open(read_only=FALSE)
    ds$setNoDataValue(band=1, -99999)
    ds$write(band=1, xoff=0, yoff=0, xsize=10, ysize=10, rep(-99999, 100))
    ds$open(read_only=TRUE)
    expect_warning(r <- read_ds(ds))
    expect_true(all(is.na(r)))
    ds$open(read_only=FALSE)
    ds$deleteNoDataValue(band=1)
    ds$open(read_only=TRUE)
    expect_warning(r <- read_ds(ds))
    attributes(r) <- NULL
    expect_equal(r, rep(-99999, 100))
    files <- ds$getFileList()
    on.exit(unlink(files))
    ds$close()
})

test_that("complex I/O works", {
    f <- paste0(tempdir(), "/", "testcomplex.tif")
    create(format="GTiff", dst_filename=f, xsize=10, ysize=10,
           nbands=1, dataType="CFloat32")
    ds <- new(GDALRaster, f, read_only=FALSE)
    set.seed(42)
    z <- complex(real = stats::rnorm(100), imaginary = stats::rnorm(100))
    ds$write(band=1, xoff=0, yoff=0, xsize=10, ysize=10, z)
    ds$open(read_only=TRUE)
    expect_warning(r <- read_ds(ds))
    attributes(r) <- NULL
    expect_vector(r, ptype=complex(0), size=100)
    files <- ds$getFileList()
    on.exit(unlink(files))
    ds$close()
})

test_that("Byte I/O works", {
    f <- paste0(tempdir(), "/", "testbyte.tif")
    create(format="GTiff", dst_filename=f, xsize=10, ysize=10,
           nbands=1, dataType="Byte")
    ds <- new(GDALRaster, f, read_only=FALSE)
    set.seed(42)
    z <- as.raw(sample(100, 100))
    ds$write(band=1, xoff=0, yoff=0, xsize=10, ysize=10, z)

    ds$open(read_only=TRUE)
    expect_false(ds$readByteAsRaw)
    ## read as raw with the temporary setting
    expect_warning(r_raw <- read_ds(ds, as_raw = TRUE))
    ## read with to-integer conversion (as default, not affected by 'as_raw')
    expect_warning(r_int <- read_ds(ds))
    ## set and read as raw via field
    ds$readByteAsRaw <- TRUE
    expect_warning(r_raw1 <- read_ds(ds, as_raw = TRUE))

    ## read as raw via field only (no as_raw argument)
    ds$readByteAsRaw <- TRUE
    expect_warning(r_raw2 <- read_ds(ds))
    expect_type(r_raw2, "raw")
    ds$readByteAsRaw <- FALSE

    deleteDataset(f)

    expect_type(r_int, "integer")
    expect_type(r_raw, "raw")
    expect_type(r_raw1, "raw")
    attributes(r_raw) <- NULL
    expect_equal(r_raw, z)

    ds$close()
})

test_that("Byte I/O: warn when data type not compatible", {
    ## expect a warning when data type is not Byte
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    ds <- new(GDALRaster, elev_file)
    expect_warning(read_ds(ds, 1L, 0L, 0L, 2L, 3L, 2L, 3L, as_raw = TRUE))
    ds$close()
})

test_that("set nodata value, unit type, scale and offset works", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    mod_file <- paste0(tempdir(), "/", "storml_elev_mod.tif")
    file.copy(elev_file,  mod_file)
    ds <- new(GDALRaster, mod_file, read_only=FALSE)
    ds$setNoDataValue(1, -9999)
    ds$setUnitType(1, "m")
    ds$setScale(1, 1)
    ds$setOffset(1, 0)
    expect_equal(ds$getNoDataValue(1), -9999)
    expect_equal(ds$getUnitType(1), "m")
    expect_equal(ds$getScale(1), 1)
    expect_equal(ds$getOffset(1), 0)

    expect_false(ds$setNoDataValue(1, NA))
    expect_false(ds$setScale(1, NA))
    expect_false(ds$setOffset(1, NA))

    files <- ds$getFileList()
    on.exit(unlink(files))
    ds$close()
})

test_that("build overviews runs without error", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    mod_file <- paste0(tempdir(), "/", "storml_elev_orig.tif")
    file.copy(elev_file,  mod_file)
    ds <- new(GDALRaster, mod_file, read_only=FALSE)
    expect_no_error(ds$buildOverviews("BILINEAR", c(2,4,8), 0))
    expect_no_error(ds$buildOverviews("NONE", 0, 0))
    # quiet
    ds$quiet <- TRUE
    expect_silent(ds$buildOverviews("BILINEAR", c(2,4,8), 0))
    expect_silent(ds$buildOverviews("NONE", 0, 0))

    files <- ds$getFileList()
    on.exit(unlink(files))
    ds$close()
})

test_that("get/set color table works", {
    f <- system.file("extdata/storml_evc.tif", package="gdalraster")
    f2 <- tempfile("storml_evc_ct", fileext = ".tif")
    on.exit(deleteDataset(f2), add = TRUE)
    calc("A", f, dstfile = f2, dtName = "UInt16", nodata_value = 65535,
         setRasterNodataValue = TRUE)
    ds <- new(GDALRaster, f2, read_only = FALSE)
    evc_csv <- system.file("extdata/LF20_EVC_220.csv", package="gdalraster")
    vat <- read.csv(evc_csv)
    ct <- vat[, c(1, 3:5)]
    expect_warning(ds$setColorTable(1, ct, "RGB"))
    # close and re-open flushes the write cache
    ds$open(read_only = TRUE)
    evc_ct <- ds$getColorTable(1)
    expect_equal(nrow(evc_ct), 65536)
    expect_equal(ds$getPaletteInterp(1), "RGB")
    ds$open(read_only = FALSE)
    expect_true(ds$clearColorTable(1))
    ds$close()
})

test_that("get/set band color interpretation works", {
    f <- paste0(tempdir(), "/", "test_col_interp.tif")
    create(format="GTiff", dst_filename=f, xsize=10, ysize=10,
            nbands=1, dataType="Byte")
    ds <- new(GDALRaster, f, read_only=FALSE)
    expect_equal(ds$getRasterColorInterp(1), "Gray")
    ds$setRasterColorInterp(1, "Palette")
    expect_equal(ds$getRasterColorInterp(1), "Palette")
    ds$setRasterColorInterp(1, "Red")
    expect_equal(ds$getRasterColorInterp(1), "Red")
    ds$setRasterColorInterp(1, "Green")
    expect_equal(ds$getRasterColorInterp(1), "Green")
    ds$setRasterColorInterp(1, "Blue")
    expect_equal(ds$getRasterColorInterp(1), "Blue")
    ds$setRasterColorInterp(1, "Alpha")
    expect_equal(ds$getRasterColorInterp(1), "Alpha")
    ds$setRasterColorInterp(1, "Hue")
    expect_equal(ds$getRasterColorInterp(1), "Hue")
    ds$setRasterColorInterp(1, "Saturation")
    expect_equal(ds$getRasterColorInterp(1), "Saturation")
    ds$setRasterColorInterp(1, "Lightness")
    expect_equal(ds$getRasterColorInterp(1), "Lightness")
    ds$setRasterColorInterp(1, "Cyan")
    expect_equal(ds$getRasterColorInterp(1), "Cyan")
    ds$setRasterColorInterp(1, "Magenta")
    expect_equal(ds$getRasterColorInterp(1), "Magenta")
    ds$setRasterColorInterp(1, "Yellow")
    expect_equal(ds$getRasterColorInterp(1), "Yellow")
    ds$setRasterColorInterp(1, "Black")
    expect_equal(ds$getRasterColorInterp(1), "Black")
    ds$setRasterColorInterp(1, "YCbCr_Y")
    expect_equal(ds$getRasterColorInterp(1), "YCbCr_Y")
    ds$setRasterColorInterp(1, "YCbCr_Cb")
    expect_equal(ds$getRasterColorInterp(1), "YCbCr_Cb")
    ds$setRasterColorInterp(1, "YCbCr_Cr")
    expect_equal(ds$getRasterColorInterp(1), "YCbCr_Cr")
    ds$setRasterColorInterp(1, "Gray")
    expect_equal(ds$getRasterColorInterp(1), "Gray")
    files <- ds$getFileList()
    on.exit(unlink(files))
    ds$close()
})

test_that("Int64 data type is detected", {
    skip_if(as.integer(gdal_version()[2]) < 3050000)

    f <- system.file("extdata/int64.tif", package="gdalraster")
    expect_warning(ds <- new(GDALRaster, f, TRUE))
    expect_equal(ds$getDataTypeName(1), "Int64")
    ds$close()
})

test_that("get/set default RAT works", {
    evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
    f <- tempfile(fileext=".tif")
    file.copy(evt_file,  f)
    ds <- new(GDALRaster, f, read_only=FALSE)
    expect_true(is.null(ds$getDefaultRAT(band=1)))
    evt_csv <- system.file("extdata/LF20_EVT_220.csv", package="gdalraster")
    evt_tbl <- read.csv(evt_csv)
    evt_tbl <- evt_tbl[,1:7]
    rat <- buildRAT(ds, table_type="thematic", na_value=-9999, join_df=evt_tbl)
    ds$setDefaultRAT(band=1, rat)
    ds$flushCache()
    rat2 <- ds$getDefaultRAT(band=1)
    expect_equal(nrow(rat2), 24)
    expect_equal(ncol(rat2), 8)
    expect_equal(attr(rat2, "GDALRATTableType"), "thematic")
    expect_equal(attr(rat2$VALUE, "GFU"), "MinMax")
    expect_equal(attr(rat2$COUNT, "GFU"), "PixelCount")
    expect_equal(attr(rat2$EVT_NAME, "GFU"), "Name")
    expect_equal(attr(rat2$EVT_LF, "GFU"), "Generic")
    expect_equal(attr(rat2$B, "GFU"), "Blue")

    # quiet
    ds$close()
    ds$open(TRUE)
    ds$quiet <- TRUE
    expect_silent(rat3 <- ds$getDefaultRAT(band=1))
    expect_equal(nrow(rat2), 24)

    ds$close()
    deleteDataset(f)

    ## test read/write RAT with new field types GFT_Boolean, GFT_DateTime and
    ## and GFT_WKBGeometry with GDAL >= 3.12
    skip_if(gdal_version_num() < gdal_compute_version(3, 12, 0))

    # adapted from GDAL autotest/gcore/tiff_write.py
    # https://github.com/OSGeo/gdal/blob/2327638e4a399ac1e902623bfda68a03956288b6/autotest/gcore/tiff_write.py#L12490
    f <- tempfile(fileext = ".tif")
    on.exit(deleteDataset(f), add = TRUE)

    set_config_option("GTIFF_WRITE_RAT_TO_PAM", "")

    ds <- create(format = "GTiff", dst_filename = f, xsize = 1, ysize = 1,
                 nbands = 1, dataType = "Byte", return_obj = TRUE)

    tbl <- data.frame(v_int = as.integer(123))
    tbl$v_dbl <- 45.5
    tbl$v_str <- "str"
    tbl$v_bool <- TRUE
    tbl$v_dt <- as.POSIXct("2025-12-31 23:58:59.500 GMT", tz = "UTC")
    tbl$v_wkb <- list(g_wk2wk("POINT (1.0 2)"))

    expect_true(ds$setDefaultRAT(band=1, tbl))
    ds$flushCache()

    pam_file <- paste0(f, ".aux.xml")
    expect_false(vsi_stat(pam_file))

    tbl2 <- ds$getDefaultRAT(band=1)
    ignored_attrs <- c("waldo_opts", "GFU", "tzone")
    expect_equal(nrow(tbl2), nrow(tbl))
    expect_equal(ncol(tbl2), ncol(tbl))
    expect_equal(tbl2$v_int, tbl$v_int, ignore_attr = ignored_attrs)
    expect_equal(tbl2$v_dbl, tbl$v_dbl, ignore_attr = ignored_attrs)
    expect_equal(tbl2$v_bool, tbl$v_bool, ignore_attr = ignored_attrs)
    expect_equal(tbl2$v_dt, tbl$v_dt, ignore_attr = ignored_attrs)
    expect_equal(tbl2$v_wkb, tbl$v_wkb, ignore_attr = ignored_attrs)

    rm(tbl2)
    ds$close()

    f2 <- tempfile(fileext = ".tif")
    on.exit(deleteDataset(f2), add = TRUE)
    ds2 <- createCopy("GTiff", f2, f, return_obj = TRUE)
    # repeat on the copied dataset
    tbl2 <- ds2$getDefaultRAT(band=1)
    expect_equal(nrow(tbl2), nrow(tbl))
    expect_equal(ncol(tbl2), ncol(tbl))
    expect_equal(tbl2$v_int, tbl$v_int, ignore_attr = ignored_attrs)
    expect_equal(tbl2$v_dbl, tbl$v_dbl, ignore_attr = ignored_attrs)
    expect_equal(tbl2$v_bool, tbl$v_bool, ignore_attr = ignored_attrs)
    expect_equal(tbl2$v_dt, tbl$v_dt, ignore_attr = ignored_attrs)
    expect_equal(tbl2$v_wkb, tbl$v_wkb, ignore_attr = ignored_attrs)

    ds2$close()
})

test_that("add band works", {
    ds_mem <- create(format="MEM", dst_filename="", xsize=20, ysize=10,
                     nbands=1, dataType="Byte", return_obj = TRUE)

    on.exit(ds_mem$close(), add = TRUE)

    ds_mem$setProjection(epsg_to_wkt(4326))
    ds_mem$setGeoTransform(c(-180, 18, 0, 90, 0, -18))
    ds_mem$fillRaster(1, 255, 0)
    expect_true(ds_mem$addBand("Byte", NULL))
    expect_no_error(ds_mem$fillRaster(2, 255, 0))
    expect_equal(ds_mem$getRasterCount(), 2)
    expect_true(all(ds_mem$read(2, 0, 0, 20, 10, 20, 10) == 255))

    ## add bands from pointers to R data without copy
    v <- sample(0:255, 200, replace = TRUE)

    # raw vector as Byte/UInt8 band
    expect_true(ds_mem$addBand("Byte", as.raw(v)))
    expect_equal(ds_mem$getRasterCount(), 3)
    # make the data type check robust to Byte/UInt8 name change at GDAL 3.13:
    expect_equal(dt_size(ds_mem$getDataTypeName(3), as_bytes = FALSE), 8)
    expect_false(dt_is_signed(ds_mem$getDataTypeName(3)))
    # by default, it is read as Int32 (R integer)
    expect_equal(ds_mem$read(3, 0, 0, 20, 10, 20, 10), v)
    # read as Byte/UInt8 (R raw bytes)
    ds_mem$readByteAsRaw <- TRUE
    expect_equal(ds_mem$read(3, 0, 0, 20, 10, 20, 10), as.raw(v))
    ds_mem$readByteAsRaw <- FALSE

    # integer vector as Int32 band
    expect_true(ds_mem$addBand("Int32", v))
    expect_equal(ds_mem$getRasterCount(), 4)
    expect_equal(ds_mem$getDataTypeName(4), "Int32")
    v_chk <- ds_mem$read(4, 0, 0, 20, 10, 20, 10)
    expect_equal(v_chk, v)

    # "numeric" (double) vector as Float64 band
    v_dbl <- v + 0.5
    expect_true(ds_mem$addBand("Float64", v_dbl))
    expect_equal(ds_mem$getRasterCount(), 5)
    expect_equal(ds_mem$getDataTypeName(5), "Float64")
    v_dbl_chk <- ds_mem$read(5, 0, 0, 20, 10, 20, 10)
    expect_equal(v_dbl_chk, v_dbl, tolerance = 1e4)

    # complex vector as CFloat64 band
    z <- complex(real = stats::rnorm(200), imaginary = stats::rnorm(200))
    expect_true(ds_mem$addBand("CFloat64", z))
    expect_equal(ds_mem$getRasterCount(), 6)
    expect_equal(ds_mem$getDataTypeName(6), "CFloat64")
    z_chk <- ds_mem$read(6, 0, 0, 20, 10, 20, 10)
    expect_equal(z_chk, z, tolerance = 1e4)

    # test that the underlying data objects are preserved from garbage collect
    rm(v)
    rm(v_dbl)
    rm(z)
    gc()
    expect_equal(ds_mem$read(4, 0, 0, 20, 10, 20, 10), v_chk)
    expect_equal(ds_mem$read(5, 0, 0, 20, 10, 20, 10), v_dbl_chk,
                 tolerance = 1e4)
    expect_equal(ds_mem$read(6, 0, 0, 20, 10, 20, 10), z_chk, tolerance = 1e4)

    ## input validation
    # unknown data type
    expect_false(ds_mem$addBand("invalid", NULL))

    # invalid size of vector
    v <- integer(201)
    expect_false(ds_mem$addBand("Byte", as.raw(v)))
    expect_false(ds_mem$addBand("Int32", v))
    v_dbl <- v + 0.5
    expect_false(ds_mem$addBand("Float64", v_dbl))
    z <- complex(real = stats::rnorm(201), imaginary = stats::rnorm(201))
    expect_false(ds_mem$addBand("CFloat64", z))
    expect_equal(ds_mem$getRasterCount(), 6)

    # invalid object type
    v_list <- vector("list", 200)
    v_list[1:200] <- 0L
    expect_false(ds_mem$addBand("Int32", v_list))

    ## specified data type should be overridden when adding a MEM band from
    ## datapointer if specified type is not compatible with the underlying
    ## array
    v <- integer(200)

    # raw vector as Byte/UInt8 band
    expect_true(ds_mem$addBand("Int32", as.raw(v)))
    expect_equal(ds_mem$getRasterCount(), 7)
    # make the data type check robust to Byte/UInt8 name change at GDAL 3.13:
    expect_equal(dt_size(ds_mem$getDataTypeName(7), as_bytes = FALSE), 8)
    expect_false(dt_is_signed(ds_mem$getDataTypeName(7)))
    # by default, it is read as Int32 (R integer)
    expect_equal(ds_mem$read(7, 0, 0, 20, 10, 20, 10), v)
    # read as Byte/UInt8 (R raw bytes)
    ds_mem$readByteAsRaw <- TRUE
    expect_equal(ds_mem$read(7, 0, 0, 20, 10, 20, 10), as.raw(v))
    ds_mem$readByteAsRaw <- FALSE

    # integer vector as Int32 band
    expect_true(ds_mem$addBand("Byte", v))
    expect_equal(ds_mem$getRasterCount(), 8)
    expect_equal(ds_mem$getDataTypeName(8), "Int32")
    expect_equal(ds_mem$read(8, 0, 0, 20, 10, 20, 10), v)

    # "numeric" (double) vector as Float64 band
    v_dbl <- v + 0.5
    expect_true(ds_mem$addBand("Float32", v_dbl))
    expect_equal(ds_mem$getRasterCount(), 9)
    expect_equal(ds_mem$getDataTypeName(9), "Float64")
    expect_equal(ds_mem$read(9, 0, 0, 20, 10, 20, 10), v_dbl, tolerance = 1e4)

    # complex vector as CFloat64 band
    z <- complex(real = stats::rnorm(200), imaginary = stats::rnorm(200))
    expect_true(ds_mem$addBand("Float64", z))
    expect_equal(ds_mem$getRasterCount(), 10)
    expect_equal(ds_mem$getDataTypeName(10), "CFloat64")
    expect_equal(ds_mem$read(10, 0, 0, 20, 10, 20, 10), z, tolerance = 1e4)
})

test_that("pixel extract internal class method returns correct data", {
    # Several of these tests were adapted from:
    #    gdal/autotest/gcore/interpolateatpoint.py
    #    Copyright (c) 2024, Javier Jimenez Shaw <j1@jimenezshaw.com>
    #    SPDX-License-Identifier: MIT

    ## basic tests, 1 point
    f <- system.file("extdata/byte.tif", package="gdalraster")
    ds <- new(GDALRaster, f)
    # GDALRaster::pixel_extract() accepts geospatial xy
    # convert grid xy (10, 12) to geospatial xy
    geo_xy <- ds$apply_geotransform(matrix(c(10 ,12), ncol = 2))
    # geo_xy
    #>        [,1]    [,2]
    #> [1,] 441320 3750600

    extr_nearest <- ds$pixel_extract(xy = geo_xy,
                                     bands = 1,
                                     interp_method = "near",
                                     krnl_dim = 1,
                                     xy_srs = "")

    expect_equal(extr_nearest[1], 173)

    # as vector of x, y
    geo_xy <- c(441320, 3750600)
    extr_nearest <- ds$pixel_extract(xy = geo_xy,
                                     bands = 1,
                                     interp_method = "near",
                                     krnl_dim = 1,
                                     xy_srs = "")

    expect_equal(extr_nearest[1], 173)

    # point exactly on right edge
    # see https://github.com/OSGeo/gdal/pull/12087
    bb <- ds$bbox()
    extr_nearest <- ds$pixel_extract(xy = c(bb[3], (bb[2] + 200)),
                                     bands = 1,
                                     interp_method = "near",
                                     krnl_dim = 1,
                                     xy_srs = "")

    expect_equal(extr_nearest[1], 132)

    # exactly bottom right corner
    bb <- ds$bbox()
    extr_nearest <- ds$pixel_extract(xy = c(bb[3], bb[2]),
                                     bands = 1,
                                     interp_method = "near",
                                     krnl_dim = 1,
                                     xy_srs = "")

    expect_equal(extr_nearest[1], 107)

    # as data frame
    geo_xy <- data.frame(geo_xy[1], geo_xy[2])
    extr_nearest <- ds$pixel_extract(xy = geo_xy,
                                     bands = 1,
                                     interp_method = "near",
                                     krnl_dim = 1,
                                     xy_srs = "")

    expect_equal(extr_nearest[1], 173)

    # krnl_dim ignored with bilinear but a required arg for the internal method
    extr_bilinear <- ds$pixel_extract(xy = geo_xy,
                                      bands = 1,
                                      interp_method = "bilinear",
                                      krnl_dim = 2,
                                      xy_srs = "")

    expect_equal(extr_bilinear[1], 139.75, tolerance = 1e-6)

    # errors
    expect_error(ds$pixel_extract(xy = 441320,
                                  bands = 1,
                                  interp_method = "near",
                                  krnl_dim = 1,
                                  xy_srs = ""))
    expect_error(ds$pixel_extract(xy = matrix(numeric(), nrow = 0),
                                  bands = 1,
                                  interp_method = "near",
                                  krnl_dim = 1,
                                  xy_srs = ""))
    expect_error(ds$pixel_extract(xy = geo_xy,
                                  bands = 1,
                                  interp_method = "invalid",
                                  krnl_dim = 1,
                                  xy_srs = ""))
    # only one band at a time supported for NxN kernel extract
    expect_error(ds$pixel_extract(xy = geo_xy,
                                  bands = c(1, 2),
                                  interp_method = "near",
                                  krnl_dim = 3,
                                  xy_srs = ""))
    # three columns
    geo_xy$new_variable <- 0
    expect_error(ds$pixel_extract(geo_xy,
                                  bands = 1,
                                  interp_method = "near",
                                  krnl_dim = 1,
                                  xy_srs = ""))

    # out of range
    geo_xy <- matrix(c(10000000, 3750600), ncol = 2)
    expect_warning(extr_bilinear <- ds$pixel_extract(xy = geo_xy,
                                                     bands = 1,
                                                     interp_method = "bilinear",
                                                     krnl_dim = 2,
                                                     xy_srs = ""))

    expect_true(is.na(extr_bilinear[1]))

    geo_xy <- matrix(c(441320, 10000000), ncol = 2)
    expect_warning(extr_bilinear <- ds$pixel_extract(xy = geo_xy,
                                                     bands = 1,
                                                     interp_method = "bilinear",
                                                     krnl_dim = 2,
                                                     xy_srs = ""))

    expect_true(is.na(extr_bilinear[1]))

    ds$close()

    ## nodata
    ds <- create(format="MEM", dst_filename="", xsize=2, ysize=2,
                 nbands=1, dataType="Byte", return_obj=TRUE)

    raster_data <- c(255, 0, 0, 0)
    ds$write(band = 1, xoff = 0, yoff = 0, xsize = 2, ysize = 2, raster_data)
    ds$setNoDataValue(band = 1, 255)

    geo_xy <- matrix(c(0, 0), ncol = 2)

    # warning for no geotransform
    expect_warning(extr_nodata <- ds$pixel_extract(xy = geo_xy,
                                                   bands = 0,
                                                   interp_method = "near",
                                                   krnl_dim = 1,
                                                   xy_srs = ""))

    expect_true(length(extr_nodata) == 1)
    expect_true(is.na(extr_nodata))

    ds$close()

    ## bilinear interpolation - 2 bands
    ds <- create(format="MEM", dst_filename="", xsize=2, ysize=2,
                 nbands=2, dataType="Float32", return_obj=TRUE)

    # band 1
    raster_data_1 <- c(10.5, 1.3, 2.4, 3.8)
    ds$write(band = 1, xoff = 0, yoff = 0, xsize = 2, ysize = 2, raster_data_1)
    # also with negative - band 2
    raster_data_2 <- c(10.5, 1.3, -2.4, 3.8)
    ds$write(band = 2, xoff = 0, yoff = 0, xsize = 2, ysize = 2, raster_data_2)

    geo_xy <- matrix(c(1, -1), ncol = 2)
    # bands = 0 for all bands
    # krnl_dim ignored with bilinear but a required arg for the internal method
    # warning for no geotransform
    expect_warning(extr_bilinear <- ds$pixel_extract(xy = geo_xy,
                                                     bands = 0,
                                                     interp_method = "bilinear",
                                                     krnl_dim = 2,
                                                     xy_srs = ""))

    expect_true(is.matrix(extr_bilinear))
    expect_equal(dim(extr_bilinear), c(1, 2))
    expect_equal(colnames(extr_bilinear), c("b1", "b2"))
    colnames(extr_bilinear) <- NULL
    expect_equal(extr_bilinear[1, 1], sum(raster_data_1) / 4, tolerance = 1e-6)
    expect_equal(extr_bilinear[1, 2], sum(raster_data_2) / 4, tolerance = 1e-6)

    ds$close()


    ## bilinear - several points
    ds <- create(format="MEM", dst_filename="", xsize=3, ysize=2,
                 nbands=1, dataType="Float32", return_obj=TRUE)

    raster_data <- c(10.5, 1.3, 0.5,
                     2.4, 3.8, -1.0)
    ds$write(band = 1, xoff = 0, yoff = 0, xsize = 3, ysize = 2, raster_data)

    geo_xy <- matrix(c(0.5, 1.5, 2, -0.5, -1.5, -1), nrow = 3, ncol = 2)
    # krnl_dim ignored with bilinear but a required arg for the internal method
    ds$quiet <- TRUE
    expect_no_warning(
        extr_bilinear <- ds$pixel_extract(xy = geo_xy,
                                          bands = 1,
                                          interp_method = "bilinear",
                                          krnl_dim = 2,
                                          xy_srs = "")
    )

    expect_true(is.matrix(extr_bilinear))
    expect_equal(dim(extr_bilinear), c(3, 1))
    expect_equal(colnames(extr_bilinear), "b1")
    colnames(extr_bilinear) <- NULL
    expect_equal(extr_bilinear[1, 1], 10.5, tolerance = 1e-6)
    expect_equal(extr_bilinear[2, 1], 3.8, tolerance = 1e-6)
    expect_equal(extr_bilinear[3, 1], (1.3 + 0.5 + 3.8 - 1) / 4, tolerance = 1e-6)

    ds$close()
})

test_that("pixel extract interpolate near borders", {
    # Bilinear interp along the edge pixels should match results from
    # GDALRasterInterpolateAtPoint(), as described in
    # https://github.com/OSGeo/gdal/pull/10506.
    # It is currently implemented differently in gdalraster (i.e., not
    # generalized beyond bilinear, but not dependent on GDAL >= 3.10), but we
    # check using tests adapted from:
    #    gdal/autotest/gcore/interpolateatpoint.py
    #    Copyright (c) 2024, Javier Jimenez Shaw <j1@jimenezshaw.com>
    #    SPDX-License-Identifier: MIT

    ds <- create(format="MEM", dst_filename="", xsize=6, ysize=5,
                 nbands=1, dataType="Float32", return_obj=TRUE)

    raster_data <- c(1, 2, 4, 4, 5, 6,
                     9, 8, 7, 6, 3, 4,
                     4, 7, 6, 2, 1, 3,
                     7, 8, 9, 6, 2, 1,
                     2, 5, 2, 1, 7, 8)

    ds$write(band = 1, xoff = 0, yoff = 0, xsize = 6, ysize = 5, raster_data)

    ds$quiet <- TRUE

    geo_xy <- matrix(c(0, 0), ncol = 2)
    extr_bilinear <- ds$pixel_extract(geo_xy, 1, "bilinear", 2, "")
    expect_equal(extr_bilinear[1], 1.0, tolerance = 1e-6)

    geo_xy <- matrix(c(1, 0), ncol = 2)
    extr_bilinear <- ds$pixel_extract(geo_xy, 1, "bilinear", 2,"")
    expect_equal(extr_bilinear[1], 1.5, tolerance = 1e-6)

    geo_xy <- matrix(c(0, -1), ncol = 2)
    extr_bilinear <- ds$pixel_extract(geo_xy, 1, "bilinear", 2, "")
    expect_equal(extr_bilinear[1], 5.0, tolerance = 1e-6)

    geo_xy <- matrix(c(0, -2), ncol = 2)
    extr_bilinear <- ds$pixel_extract(geo_xy, 1, "bilinear", 2, "")
    expect_equal(extr_bilinear[1], 6.5, tolerance = 1e-6)

    geo_xy <- matrix(c(6, 0), ncol = 2)
    extr_bilinear <- ds$pixel_extract(geo_xy, 1, "bilinear", 2, "")
    expect_equal(extr_bilinear[1], 6.0, tolerance = 1e-6)

    geo_xy <- matrix(c(3, -5), ncol = 2)
    extr_bilinear <- ds$pixel_extract(geo_xy, 1, "bilinear", 2, "")
    expect_equal(extr_bilinear[1], 1.5, tolerance = 1e-6)

    geo_xy <- matrix(c(3, -4.6), ncol = 2)
    extr_bilinear <- ds$pixel_extract(geo_xy, 1, "bilinear", 2, "")
    expect_equal(extr_bilinear[1], 1.5, tolerance = 1e-6)

    ds$close()
})

test_that("pixel extract internal class method - all pixels in a kernel", {
    ds <- create(format="MEM", dst_filename="", xsize=6, ysize=5,
                 nbands=1, dataType="Float32", return_obj=TRUE)

    raster_data <- c(1, 2, 4, 4, 5, 6,
                     9, 8, 7, 6, 3, 4,
                     4, 7, 6, 2, 1, 3,
                     7, 8, 9, 6, 2, 1,
                     2, 5, 2, 1, 7, 8)

    ds$write(band = 1, xoff = 0, yoff = 0, xsize = 6, ysize = 5, raster_data)

    ds$quiet <- TRUE

    geo_xy <- matrix(c(1.5, -1.5), ncol = 2)
    extr_krnl <- ds$pixel_extract(geo_xy, 1, "near", 3, "")
    expected_names <- c("b1_p1", "b1_p2", "b1_p3", "b1_p4", "b1_p5", "b1_p6",
                        "b1_p7", "b1_p8", "b1_p9")
    expected_values <- c(1, 2, 4, 9, 8, 7, 4, 7, 6)
    expect_true(is.matrix(extr_krnl))
    expect_equal(dim(extr_krnl), c(1, 9))
    expect_equal(colnames(extr_krnl), expected_names)
    colnames(extr_krnl) <- NULL
    dim(extr_krnl) <- NULL
    expect_equal(extr_krnl, expected_values)

    geo_xy <- matrix(c(4.6, -3.5), ncol = 2)
    extr_krnl <- ds$pixel_extract(geo_xy, 1, "near", 3, "")
    expected_values <- c(2, 1, 3, 6, 2, 1, 1, 7, 8)
    colnames(extr_krnl) <- NULL
    dim(extr_krnl) <- NULL
    expect_equal(extr_krnl, expected_values)

    # portion of kernel outside the raster extent
    # note that the public wrapper in gdalraster_proc.R handles this case
    # with additional tests in test-gdalraster_proc.R
    geo_xy <- matrix(c(0, 0), ncol = 2)
    extr_krnl <- ds$pixel_extract(geo_xy, 1, "near", 3, "")
    colnames(extr_krnl) <- NULL
    expect_true(all(is.na(extr_krnl)))

    geo_xy <- matrix(c(5, -3.5), ncol = 2)
    extr_krnl <- ds$pixel_extract(geo_xy, 1, "near", 3, "")
    colnames(extr_krnl) <- NULL
    expect_true(all(is.na(extr_krnl)))

    ds$close()
})

test_that("pixel extract cubic/cublicspline interpolation", {
    # Requires GDAL >= 3.10
    # Tests adapted from:
    #    gdal/autotest/gcore/interpolateatpoint.py
    #    Copyright (c) 2024, Javier Jimenez Shaw <j1@jimenezshaw.com>
    #    SPDX-License-Identifier: MIT

    skip_if(gdal_version_num() < 3100000)

    ds <- create(format="MEM", dst_filename="", xsize=4, ysize=4,
                 nbands=1, dataType="Float32", return_obj=TRUE)

    raster_data <- c(1.0, 2.0, 1.5, -0.3,
                     1.0, 2.0, 1.5, -0.3,
                     1.0, 2.0, 1.5, -0.3,
                     1.0, 2.0, 1.5, -0.3)

    ds$write(band = 1, xoff = 0, yoff = 0, xsize = 4, ysize = 4, raster_data)

    ds$quiet <- TRUE

    geo_xy <- matrix(c(1.5, -1.5), ncol = 2)
    extr_cubicspline <- ds$pixel_extract(geo_xy, 1, "cubicspline", 4, "")
    expect_equal(extr_cubicspline[1], 1.75, tolerance = 1e-6)

    extr_cubic <- ds$pixel_extract(geo_xy, 1, "cubic", 4, "")
    expect_equal(extr_cubic[1], 2.0, tolerance = 1e-6)

    geo_xy <- matrix(c(2.0, -2.0), ncol = 2)
    extr_cubicspline <- ds$pixel_extract(geo_xy, 1, "cubicspline", 4, "")
    expect_equal(extr_cubicspline[1], 1.6916666, tolerance = 1e-6)

    extr_cubic <- ds$pixel_extract(geo_xy, 1, "cubic", 4, "")
    expect_equal(extr_cubic[1], 1.925, tolerance = 1e-6)

    # cubic may exceed the highest value
    geo_xy <- matrix(c(1.6, -1.5), ncol = 2)
    extr_cubic <- ds$pixel_extract(geo_xy, 1, "cubic", 4, "")
    expect_equal(extr_cubic[1], 2.0166, tolerance = 1e-6)

    ds$close()
})

test_that("raster dimensions multiply without int overflow", {
    f <- "/vsimem/file.tif"
    ds <- create("GTiff", f, 86400, 43200, nbands = 1, dataType = "Byte",
                 options = c("SPARSE_OK=YES"), return_obj = TRUE)

    dm <- ds$dim()
    expect_no_warning(dm[1] * dm[2])  # no warning for NAs produced by overflow
    expect_equal(dm[1] * dm[2], 3732480000)

    xsize <- ds$getRasterXSize()
    ysize <- ds$getRasterYSize()
    expect_no_warning(xsize * ysize)
    expect_equal(xsize * ysize, 3732480000)

    ds$close()
    vsi_unlink(f)
})

test_that("get block indexing works", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    ds <- new(GDALRaster, elev_file)

    values_expected <- read_ds(ds)
    attributes(values_expected) <- NULL

    blocks <- ds$get_block_indexing(1)
    values <- integer()
    for (i in seq_len(nrow(blocks))) {
        values <- c(values, ds$read(1, blocks[i, "xoff"], blocks[i, "yoff"],
                                    blocks[i, "xsize"], blocks[i, "ysize"],
                                    blocks[i, "xsize"], blocks[i, "ysize"]))
    }
    expect_equal(values, values_expected)

    ds$close()

    f <- tempfile(fileext = ".tif")
    on.exit(deleteDataset(f), add = TRUE)
    opt <- c("TILED=YES", "BLOCKXSIZE=128", "BLOCKYSIZE=128", "COMPRESS=LZW")
    ds2 <- create(format = "GTiff", dst_filename = f, xsize = 671, ysize = 528,
                  nbands = 1, dataType = "Byte", options = opt,
                  return_obj = TRUE)
    ds2$setGeoTransform(c(0.0, 5.0, 0.0, 5.0, 0.0, -5.0))
    blocks <- ds2$get_block_indexing(1)
    expect_equal(nrow(blocks), 30)
    colnames(blocks) <- NULL
    expect_equal(blocks[1, ], c(0, 0, 0, 0, 128, 128, 0, 640, -635, 5))
    expect_equal(blocks[30, ], c(5, 4, 640, 512, 31, 16, 3200, 3355, -2635, -2555))

    ds2$close()
})

test_that("readBlock/writeBlock work", {
    f <- tempfile(fileext = ".tif")
    on.exit(deleteDataset(f), add = TRUE)
    opt <- c("TILED=YES", "BLOCKXSIZE=32", "BLOCKYSIZE=32", "COMPRESS=LZW")
    ds <- create(format = "GTiff", dst_filename = f, xsize = 90, ysize = 80,
                 nbands = 1, dataType = "Byte", options = opt,
                 return_obj = TRUE)
    ds$setGeoTransform(c(0.0, 5.0, 0.0, 5.0, 0.0, -5.0))

    # fill with 1
    ds$fillRaster(band = 1, 1, 0)
    ds$flushCache()

    ## read back
    # first block of first row
    values <- ds$readBlock(band = 1, xblockoff = 0, yblockoff = 0)
    expect_equal(length(values), 32 * 32)
    expect_true(all(values == 1))

    # right edge of first row
    values <- ds$readBlock(band = 1, xblockoff = 2, yblockoff = 0)
    expect_equal(length(values), 26 * 32)
    expect_true(all(values == 1))

    # bottom right corner
    values <- ds$readBlock(band = 1, xblockoff = 2, yblockoff = 2)
    expect_equal(length(values), 26 * 16)
    expect_true(all(values == 1))

    ## write blocks
    # second block of first row
    values <- rep(10, 32 * 32)
    expect_no_error(ds$writeBlock(band = 1, xblockoff = 1, yblockoff = 0,
                                  values))
    # right edge of second row
    values <- rep(20, 26 * 32)
    expect_no_error(ds$writeBlock(band = 1, xblockoff = 2, yblockoff = 1,
                                  values))
    # bottom right corner
    values <- rep(30, 26 * 16)
    expect_no_error(ds$writeBlock(band = 1, xblockoff = 2, yblockoff = 2,
                                  values))

    ds$close()

    ## expect errors on closed dataset
    expect_error(ds$writeBlock(band = 1, xblockoff = 2, yblockoff = 2,
                               values))
    expect_error(ds$readBlock(band = 1, xblockoff = 0, yblockoff = 0))

    ## open a new dataset on the file and read back
    ds2 <- new(GDALRaster, f)

    # first block of first row, unchanged
    values <- ds2$readBlock(band = 1, xblockoff = 0, yblockoff = 0)
    expect_equal(length(values), 32 * 32)
    expect_true(all(values == 1))

    # second block of first row
    values <- ds2$readBlock(band = 1, xblockoff = 1, yblockoff = 0)
    expect_equal(length(values), 32 * 32)
    expect_true(all(values == 10))

    # right edge of first row, unchanged
    values <- ds2$readBlock(band = 1, xblockoff = 2, yblockoff = 0)
    expect_equal(length(values), 26 * 32)
    expect_true(all(values == 1))

    # right edge of second row
    values <- ds2$readBlock(band = 1, xblockoff = 2, yblockoff = 1)
    expect_equal(length(values), 26 * 32)
    expect_true(all(values == 20))

    # bottom right corner
    values <- ds2$readBlock(band = 1, xblockoff = 2, yblockoff = 2)
    expect_equal(length(values), 26 * 16)
    expect_true(all(values == 30))

    ## test input validation
    expect_error(ds2$readBlock(band = 5, xblockoff = 0, yblockoff = 0))
    expect_error(ds2$readBlock(band = 1, xblockoff = -1, yblockoff = 0))
    expect_error(ds2$readBlock(band = 1, xblockoff = 0, yblockoff = -1))

    ds2$open(read_only = FALSE)

    values <- rep(10, 32 * 32)
    expect_error(ds2$writeBlock(band = 5, xblockoff = 0, yblockoff = 0,
                                values))
    expect_error(ds2$writeBlock(band = 1, xblockoff = -1, yblockoff = 0,
                                values))
    expect_error(ds2$writeBlock(band = 1, xblockoff = 0, yblockoff = -1,
                                values))

    # size of input pixel data
    expect_no_error(ds2$writeBlock(band = 1, xblockoff = 0, yblockoff = 0,
                                   values))
    values <- rep(10, 26 * 32)
    expect_error(ds2$writeBlock(band = 1, xblockoff = 0, yblockoff = 0,
                                values))

    ds2$close()
})

test_that("make_chunk_index/readChunk/writeChunk work", {
    f <- tempfile(fileext = ".tif")
    on.exit(deleteDataset(f), add = TRUE)
    opt <- c("TILED=YES", "BLOCKXSIZE=32", "BLOCKYSIZE=32", "COMPRESS=LZW")
    ds <- create(format = "GTiff", dst_filename = f, xsize = 90, ysize = 80,
                 nbands = 1, dataType = "Byte", options = opt,
                 return_obj = TRUE)
    ds$setGeoTransform(c(0.0, 5.0, 0.0, 5.0, 0.0, -5.0))

    # fill with 1
    ds$fillRaster(band = 1, 1, 0)
    ds$flushCache()

    bb <- ds$bbox()

    ## index for a chunk size of two consecutive blocks (< blocks_per_row)
    chunks <- ds$make_chunk_index(band = 1, max_pixels = 2 * 32 * 32)
    expect_true(is.matrix(chunks))
    expect_equal(ncol(chunks), 10)
    expect_equal(nrow(chunks), 6)
    # upper left corner chunk
    expect_equal(unname(chunks[1, 1:4]), c(0 ,0, 0, 0))
    expect_equal(unname(chunks[1, "xsize"]), 64)
    expect_equal(unname(chunks[1, "ysize"]), 32)
    expect_equal(unname(chunks[1, "xmin"]), bb[1])
    expect_equal(unname(chunks[1, "ymax"]), bb[4])
    # lower right corner chunk
    expect_equal(unname(chunks[6, 1:4]), c(1, 2, 64, 64))
    expect_equal(unname(chunks[6, "xsize"]), 26)
    expect_equal(unname(chunks[6, "ysize"]), 16)
    expect_equal(unname(chunks[6, "xmax"]), bb[3])
    expect_equal(unname(chunks[6, "ymin"]), bb[2])

    ## index for a chunk size of three consecutive blocks (> blocks_per_row)
    chunks <- ds$make_chunk_index(band = 1, max_pixels = 3 * 32 * 32)
    expect_true(is.matrix(chunks))
    expect_equal(ncol(chunks), 10)
    expect_equal(nrow(chunks), 3)
    # upper left corner chunk
    expect_equal(unname(chunks[1, "xmin"]), bb[1])
    expect_equal(unname(chunks[1, "ymax"]), bb[4])
    # lower right corner chunk
    expect_equal(unname(chunks[3, "xmax"]), bb[3])
    expect_equal(unname(chunks[3, "ymin"]), bb[2])

    expected_names <- c("xchunkoff", "ychunkoff", "xoff", "yoff", "xsize",
                        "ysize", "xmin", "xmax", "ymin", "ymax")
    expect_equal(colnames(chunks), expected_names)

    expected_values <- c(0, 0, 0,  0, 90, 32, 0, 450, -155,    5,
                         0, 1, 0, 32, 90, 32, 0, 450, -315, -155,
                         0, 2, 0, 64, 90, 16, 0, 450, -395, -315)
    expected_values <- matrix(expected_values, nrow = 3, ncol = 10,
                              byrow = TRUE)
    expect_equal(unname(chunks), unname(expected_values))

    ## read back
    values <- ds$readChunk(band = 1, chunks[1, ])
    expect_equal(length(values), 90 * 32)
    expect_true(all(values == 1))
    values <- ds$readChunk(band = 1, chunks[2, ])
    expect_equal(length(values), 90 * 32)
    expect_true(all(values == 1))
    values <- ds$readChunk(band = 1, chunks[3, ])
    expect_equal(length(values), 90 * 16)
    expect_true(all(values == 1))

    ## write chunks
    values <- rep(10, 90 * 32)
    expect_no_error(ds$writeChunk(band = 1, chunks[1, ], values))
    values <- rep(20, 90 * 32)
    expect_no_error(ds$writeChunk(band = 1, chunks[2, ], values))
    values <- rep(30, 90 * 16)
    expect_no_error(ds$writeChunk(band = 1, chunks[3, ], values))

    ds$close()

    ## expect errors on closed dataset
    expect_error(ds$writeChunk(band = 1, chunks[3, ], values))
    expect_error(ds$readChunk(band = 1, chunks[1, ]))

    ## open a new dataset on the file and read back
    ds2 <- new(GDALRaster, f)

    values <- ds2$readChunk(band = 1, chunks[1, ])
    expect_equal(length(values), 90 * 32)
    expect_true(all(values == 10))
    values <- ds2$readChunk(band = 1, chunks[2, ])
    expect_equal(length(values), 90 * 32)
    expect_true(all(values == 20))
    values <- ds2$readChunk(band = 1, chunks[3, ])
    expect_equal(length(values), 90 * 16)
    expect_true(all(values == 30))

    # chunk_def as length-4 vector of xoff, yoff, xsize, ysize
    values <- 0
    expect_no_error(values <- ds2$readChunk(band = 1, chunks[1, 3:6]))
    expect_equal(length(values), 90 * 32)
    expect_true(all(values == 10))
    values <- 0
    expect_no_error(values <- ds2$readChunk(band = 1, c(0, 32, 90, 32)))
    expect_equal(length(values), 90 * 32)
    expect_true(all(values == 20))

    ## test input validation
    expect_error(ds2$readChunk(band = 5, chunks[1, ]))
    expect_error(ds2$readChunk(band = 1, matrix(numeric(0))))
    expect_error(ds2$readChunk(band = 1, chunks[1, 1:2]))
    expect_error(ds2$readChunk(band = 1, chunks[1, 1:5]))

    ds2$open(read_only = FALSE)

    values <- rep(10, 90 * 32)
    expect_error(ds2$writeChunk(band = 5, chunks[1, ], values))
    expect_error(ds2$writeChunk(band = 1, matrix(numeric(0)), values))
    expect_error(ds2$writeChunk(band = 1, chunks[1, 1:2], values))
    expect_error(ds2$writeChunk(band = 1, chunks[1, 1:5], values))

    # size of input pixel data
    expect_no_error(ds2$writeChunk(band = 1, chunks[1, ], values))
    values <- rep(10, 90 * 16)
    expect_error(ds2$writeChunk(band = 1, chunks[1, ], values))

    ds2$close()
})

test_that("getMinMaxLocation works", {
    skip_if(gdal_version_num() < gdal_compute_version(3, 11, 0))

    f <- system.file("extdata/byte.tif", package="gdalraster")
    ds <- new(GDALRaster, f)

    ret <- ds$getMinMaxLocation(band = 1)
    expected <- c(74, 9, 17, 441290.0, 3750270.0, -117.63581, 33.89293,
                  255, 2, 18, 440870.0, 3750210.0, -117.64035, 33.89237)
    expect_equal(unname(ret), expected, tolerance = 0.01)

    ds$close()

    ds <- create(format = "MEM", dst_filename = "", xsize = 2, ysize = 2,
                 nbands = 1, dataType = "Float32", return_obj = TRUE)
    ds$fillRaster(1, NaN, 0)

    ret <- ds$getMinMaxLocation(band = 1)
    expect_true(all(is.na(ret)))

    ds$close()
})

test_that("read to nativeRaster works", {
    gray_file <- system.file("extdata/geomatrix.tif", package="gdalraster")
    ds <- new(GDALRaster, gray_file)
    r1 <- ds$readToNativeRaster(0, 0, 10, 12, 20, 24)
    r1_1 <- read_to_nativeRaster(ds, xsize = 10, ysize = 12, out_xsize = 20,
                                 out_ysize =  24)
    expect_true(identical(r1, r1_1))

    expect_true(all(dim(r1) == c(24, 20)))
    expect_s3_class(r1, "nativeRaster")
    expect_true(attr(r1, "channels") == 3)
    r2 <- ds$readToNativeRaster(0, 0, ds$getRasterXSize(), ds$getRasterYSize(),
                                ds$getRasterXSize(), ds$getRasterYSize())
    r2_2 <- read_to_nativeRaster(ds)
    expect_true(identical(r2, r2_2))

    expect_true(unique(dim(r2)) == 20)
    expect_s3_class(r2, "nativeRaster")
    expect_true(attr(r2, "channels") == 3)

    ds$close()

    ## we are >= 3.1.0 so we can assume vrt://...?bands=
    ds <- new(GDALRaster, sprintf("vrt://%s?bands=1,1,1", gray_file))
    r3 <- ds$readToNativeRaster(0, 0, 20, 20, 20, 20)
    expect_true(attr(r3, "channels") == 3)
    r4 <- read_to_nativeRaster(ds)
    expect_true(attr(r4, "channels") == 3)
    ds$close()
})

test_that("/vsistdout/ redirection works", {
    f <- system.file("extdata/ynp_features.zip", package = "gdalraster")
    zf_gpkg <- file.path("/vsizip", f, "ynp_features.gpkg")

    expected_output <- 'X,Y,poiname,poitype,createdate,editdate
-110.692921344,44.7390491040001,Norris Campground Loop C Comfort Station,Flush Toilet,2024/02/23,2024/02/23
-110.157825952,44.4784871940001,Sylvan Lake Picnic Area Vault Toilet,Vault Toilet,2024/02/23,2024/02/23
-110.182290061,44.324319185,"5E1",Campsite,2015/12/30,2018/06/13
-110.386556517,44.8907427240001,Tower Fall Parking Area Northern End Vault Toilet,Vault Toilet,2024/02/23,2024/02/23
-110.826393985,44.5316894210001,,Parking Lot,2016/02/22,2020/09/21
-110.570605761,44.41759791,Big Cone,Geyser,2016/02/17,2018/06/13
-110.450915693,44.948928046,,Parking Lot,2016/02/22,2020/09/21
-110.860329219,44.61843165,Firehole Canyon Swimming Area Vault Toilet,Vault Toilet,2024/02/23,2024/02/23
-110.800428191,44.535760318,Surprise Pool,Geyser,2016/09/13,2018/06/13
-110.235181696,44.6354910580001,The Mudkettles,Geyser,2015/11/27,2018/06/13'

    expect_output(
        ogr2ogr(zf_gpkg, "/vsistdout/", "points_of_interest",
                c("-f", "CSV", "-lco", "GEOMETRY=AS_XY", "-limit", 10)),
        expected_output)

    skip_if(gdal_version_num() < gdal_compute_version(3, 11, 3))
    skip_if(length(gdal_global_reg_names()) == 0)  # GDAL CLI bindings availability

    expected_output <- 'admn_type,state_fips,state_name,sub_region
"Park, monument, etc.",56,Wyoming,Mtn'

    expect_output(
        gdal_run_piped(zf_gpkg, "vector sql", "/vsistdout/", "CSV",
                       list(sql = "SELECT * FROM ynp_bnd")),
        expected_output)
})

test_that("ogr_proc works", {
    dsn <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")

    lyr <- new(GDALVector, dsn, "mtbs_perims")
    lyr$setAttributeFilter("ig_year >= 2000")

    lyr2 <- new(GDALVector, dsn, "mtbs_perims")
    lyr2$setAttributeFilter("incid_name = 'NORTH FORK'")

    dsn_tmp <- tempfile(fileext = ".gpkg")

    opt <- c("INPUT_PREFIX=input_",
             "METHOD_PREFIX=method_",
             "PROMOTE_TO_MULTI=YES")

    # intersection
    test_lyr_name <- "intersect_test"

    expect_no_error(lyr_out <- ogr_proc(mode = "Intersection",
                                        input_lyr = lyr,
                                        method_lyr = lyr2,
                                        out_dsn = dsn_tmp,
                                        out_lyr_name = test_lyr_name,
                                        out_geom_type = "MULTIPOLYGON",
                                        mode_opt = opt))

    expect_true(is(lyr_out, "Rcpp_GDALVector"))
    expect_equal(lyr_out$getGeomType(), "MULTIPOLYGON")
    expect_true(srs_is_same(lyr$getSpatialRef(), lyr_out$getSpatialRef()))
    lyr_out$returnGeomAs <- "WKT"
    d <- lyr_out$fetch(-1)
    expect_equal(nrow(d), 5)
    expect_equal(ncol(d), 20)
    expect_equal(min(d$input_ig_date), as.Date("2010-09-14"))
    expect_equal(max(d$input_ig_date), as.Date("2016-08-26"))
    # burn_bnd_ac is an int64 field
    expect_equal(sum(d$input_burn_bnd_ac), bit64::as.integer64(116770))
    expect_equal(unique(d$method_incid_name), "NORTH FORK")
    expect_equal(unique(d$method_ig_year), 1988)
    expect_equal(sum(sapply(d$geom, g_area)), 223994493)

    lyr_out$close()
    rm(lyr_out)
    rm(d)

    # append
    expect_no_error(lyr_out <- ogr_proc(mode = "Intersection",
                                        input_lyr = lyr,
                                        method_lyr = lyr2,
                                        out_dsn = dsn_tmp,
                                        out_lyr_name = test_lyr_name,
                                        out_geom_type = "MULTIPOLYGON",
                                        mode_opt = opt))

    lyr_out$returnGeomAs <- "WKT"
    d <- lyr_out$fetch(-1)
    expect_equal(nrow(d), 10)
    expect_equal(ncol(d), 20)
    expect_equal(sum(sapply(d$geom, g_area)), 223994493 * 2)

    lyr_out$close()
    rm(lyr_out)
    rm(d)

    # overwrite
    expect_no_error(lyr_out <- ogr_proc(mode = "Intersection",
                                        input_lyr = lyr,
                                        method_lyr = lyr2,
                                        out_dsn = dsn_tmp,
                                        out_lyr_name = test_lyr_name,
                                        out_geom_type = "MULTIPOLYGON",
                                        mode_opt = opt,
                                        overwrite = TRUE))

    lyr_out$returnGeomAs <- "WKT"
    d <- lyr_out$fetch(-1)
    expect_equal(nrow(d), 5)
    expect_equal(ncol(d), 20)
    expect_equal(sum(sapply(d$geom, g_area)), 223994493)

    lyr_out$close()
    rm(lyr_out)
    rm(d)

    # union
    test_lyr_name <- "union_test"
    expect_no_error(lyr_out <- ogr_proc(mode = "Union",
                                        input_lyr = lyr,
                                        method_lyr = lyr2,
                                        out_dsn = dsn_tmp,
                                        out_lyr_name = test_lyr_name,
                                        out_geom_type = "MULTIPOLYGON",
                                        mode_opt = opt))

    expect_equal(lyr_out$getFeatureCount(), 46)
    lyr_out$close()
    rm(lyr_out)

    # symdifference
    test_lyr_name <- "symdiff_test"
    expect_no_error(lyr_out <- ogr_proc(mode = "SymDifference",
                                        input_lyr = lyr,
                                        method_lyr = lyr2,
                                        out_dsn = dsn_tmp,
                                        out_lyr_name = test_lyr_name,
                                        out_geom_type = "MULTIPOLYGON",
                                        mode_opt = opt))

    expect_equal(lyr_out$getFeatureCount(), 41)
    lyr_out$close()
    rm(lyr_out)

    # erase
    test_lyr_name <- "erase_test"
    expect_no_error(lyr_out <- ogr_proc(mode = "Erase",
                                        input_lyr = lyr,
                                        method_lyr = lyr2,
                                        out_dsn = dsn_tmp,
                                        out_lyr_name = test_lyr_name,
                                        out_geom_type = "MULTIPOLYGON",
                                        mode_opt = opt))

    expect_equal(lyr_out$getFeatureCount(), 40)
    lyr_out$close()
    rm(lyr_out)

    # clip
    test_lyr_name <- "clip_test"
    expect_no_error(lyr_out <- ogr_proc(mode = "Clip",
                                        input_lyr = lyr,
                                        method_lyr = lyr2,
                                        out_dsn = dsn_tmp,
                                        out_lyr_name = test_lyr_name,
                                        out_geom_type = "MULTIPOLYGON",
                                        mode_opt = opt))

    expect_equal(lyr_out$getFeatureCount(), 5)
    lyr_out$close()
    rm(lyr_out)

    # identity
    test_lyr_name <- "identity_test"
    expect_no_error(lyr_out <- ogr_proc(mode = "Identity",
                                        input_lyr = lyr,
                                        method_lyr = lyr2,
                                        out_dsn = dsn_tmp,
                                        out_lyr_name = test_lyr_name,
                                        out_geom_type = "MULTIPOLYGON",
                                        mode_opt = opt))

    expect_equal(lyr_out$getFeatureCount(), 45)
    lyr_out$close()
    rm(lyr_out)

    # update
    test_lyr_name <- "update_test"
    expect_no_error(lyr_out <- ogr_proc(mode = "Update",
                                        input_lyr = lyr,
                                        method_lyr = lyr2,
                                        out_dsn = dsn_tmp,
                                        out_lyr_name = test_lyr_name,
                                        out_geom_type = "MULTIPOLYGON",
                                        mode_opt = "PROMOTE_TO_MULTI=YES"))

    expect_equal(lyr_out$getFeatureCount(), 41)
    lyr_out$close()
    rm(lyr_out)

    # shapefile output
    shp_tmp <- tempfile(fileext = ".shp")
    expect_no_error(lyr_out <- ogr_proc(mode = "Intersection",
                                        input_lyr = lyr,
                                        method_lyr = lyr2,
                                        out_dsn = shp_tmp,
                                        out_geom_type = "MULTIPOLYGON",
                                        mode_opt = opt))

    # SHPT_POLYGON shapefiles, reported as layers of type wkbPolygon
    expect_equal(lyr_out$getGeomType(), "POLYGON")
    expect_true(srs_is_same(lyr$getSpatialRef(), lyr_out$getSpatialRef()))
    lyr_out$returnGeomAs <- "WKT"
    d <- lyr_out$fetch(-1)
    expect_equal(nrow(d), 5)
    expect_equal(ncol(d), 20)
    expect_equal(sum(sapply(d$geom, g_area)), 223994493)

    lyr_out$close()
    rm(lyr_out)
    rm(d)

    # overwrite shapefile
    expect_no_error(lyr_out <- ogr_proc(mode = "Intersection",
                                        input_lyr = lyr,
                                        method_lyr = lyr2,
                                        out_dsn = shp_tmp,
                                        out_geom_type = "MULTIPOLYGON",
                                        mode_opt = opt,
                                        overwrite = TRUE))

    lyr_out$returnGeomAs <- "WKT"
    d <- lyr_out$fetch(-1)
    expect_equal(nrow(d), 5)
    expect_equal(ncol(d), 20)
    expect_equal(sum(sapply(d$geom, g_area)), 223994493)

    lyr_out$close()
    rm(lyr_out)
    rm(d)

    lyr$close()
    lyr2$close()
    deleteDataset(dsn_tmp)
    deleteDataset(shp_tmp)
})

# Tests for src/gdal_vsi.cpp - VSI wrapper functions for virtual file systems

test_that("vsi_stat works", {
    data_dir <- system.file("extdata", package="gdalraster")
    expect_true(vsi_stat(data_dir))
    expect_equal(vsi_stat(data_dir, "type"), "dir")
    elev_file <- file.path(data_dir, "storml_elev_orig.tif")
    expect_true(vsi_stat(elev_file))
    expect_equal(vsi_stat(elev_file, "type"), "file")
    expect_equal(vsi_stat(elev_file, "size"), bit64::as.integer64(31152))
    nonexistent <- file.path(data_dir, "wrong_filename.tif")
    expect_false(vsi_stat(nonexistent))
    expect_equal(vsi_stat(nonexistent, "type"), "unknown")
    expect_equal(vsi_stat(nonexistent, "size"), bit64::as.integer64(-1))
    expect_true(is.null(vsi_stat(elev_file, "invalid")))

    fs_objects <- c(data_dir, elev_file, nonexistent)
    expect_equal(vsi_stat_exists(fs_objects), c(TRUE, TRUE, FALSE))
    expect_equal(vsi_stat_type(fs_objects), c("dir", "file", "unknown"))
    expect_vector(vsi_stat_size(fs_objects), ptype = bit64::integer64(),
                  size = 3)
})

test_that("vsi_read_dir works", {
    data_dir <- system.file("extdata", package="gdalraster")
    dir_list <- vsi_read_dir(data_dir)
    expect_type(dir_list, "character")
    expect_true(length(dir_list) > 5)

    skip_if(gdal_version_num() < gdal_compute_version(3, 6, 0))

    mem_dir <- "/vsimem/_000testtemp"
    expect_true(vsi_mkdir(mem_dir) == 0)
    on.exit(vsi_rmdir(mem_dir, recursive = TRUE), add = TRUE)
    expect_vector(vsi_read_dir(mem_dir), ptype = character(), size = 0)

    expect_true(copyDatasetFiles(file.path(mem_dir, "byte.tif"),
                                 file.path(data_dir, "byte.tif")))
    expect_true(copyDatasetFiles(file.path(mem_dir, ".byte.tif"),
                                 file.path(data_dir, "byte.tif")))

    expect_vector(vsi_read_dir(mem_dir), ptype = character(), size = 1)
    expect_vector(vsi_read_dir(mem_dir, all_files = TRUE), ptype = character(),
                  size = 2)

    mem_sub_dir <- file.path(mem_dir, "_000testsubdir")
    expect_true(vsi_mkdir(mem_sub_dir) == 0)
    expect_vector(vsi_read_dir(mem_sub_dir), ptype = character(), size = 0)
    expect_true(copyDatasetFiles(file.path(mem_sub_dir, "int64.tif"),
                                 file.path(data_dir, "int64.tif")))

    expect_vector(vsi_read_dir(mem_dir), ptype = character(), size = 2)
    expect_vector(vsi_read_dir(mem_dir, recursive = TRUE),
                  ptype = character(), size = 3)
    expect_vector(vsi_read_dir(mem_dir, recursive = TRUE, all_files = TRUE),
                  ptype = character(), size = 4)
})

test_that("vsi_glob works", {
    skip_if(gdal_version_num() < gdal_compute_version(3, 11, 0))

    data_dir <- system.file("extdata", package="gdalraster")
    ynp_files <- vsi_glob(file.path(data_dir, "ynp*"))
    expect_true(length(ynp_files) >= 2)
})

test_that("vsi_copy_file works", {
    skip_if(gdal_version_num() < gdal_compute_version(3, 7, 0))

    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    tmp_file <- tempfile(fileext = ".tif")
    expect_equal(vsi_copy_file(elev_file, tmp_file), 0)
    expect_equal(vsi_unlink(tmp_file), 0)
})

test_that("vsi_unlink works", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    tmp_file <- paste0(tempdir(), "/", "tmp.tif")
    file.copy(elev_file, tmp_file)
    expect_equal(vsi_unlink(tmp_file), 0)
})

test_that("vsi_unlink_batch works", {
    skip_if(as.integer(gdal_version()[2]) < 3010000)

    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    tcc_file <- system.file("extdata/storml_tcc.tif", package="gdalraster")
    tmp_elev <- paste0(tempdir(), "/", "tmp_elev.tif")
    file.copy(elev_file,  tmp_elev)
    tmp_tcc <- paste0(tempdir(), "/", "tmp_tcc.tif")
    file.copy(tcc_file,  tmp_tcc)
    expect_true(all(vsi_unlink_batch(c(tmp_elev, tmp_tcc))))
    expect_false(all(vsi_unlink_batch(c(tmp_elev, tmp_tcc))))
    expect_vector(vsi_unlink_batch(c(tmp_elev, tmp_tcc)), logical(), 2)
})

test_that("vsi_mkdir and vsi_rmdir work", {
    new_dir <- file.path(tempdir(), "newdir")
    expect_equal(vsi_mkdir(new_dir), 0)
    expect_equal(vsi_rmdir(new_dir), 0)

    # recursive
    top_dir <- file.path(tempdir(), "topdir")
    sub_dir <- file.path(top_dir, "subdir")
    expect_equal(vsi_mkdir(sub_dir), -1)
    expect_equal(vsi_mkdir(sub_dir, recursive = TRUE), 0)
    expect_equal(vsi_rmdir(top_dir, recursive = TRUE), 0)
})

test_that("vsi_sync works", {
    src_dir <- file.path(system.file("extdata", package="gdalraster"), "/")
    target_dir <- file.path(tempdir(), "syncdir")
    if (as.integer(gdal_version()[2]) < 3010000) {
        expect_true(vsi_sync(src_dir, target_dir))
    }
    else {
        opt <- "NUM_THREADS=1"
        expect_true(vsi_sync(src_dir, target_dir, options=opt))
    }
    expect_true(length(vsi_read_dir(target_dir)) > 1)
    lapply(vsi_read_dir(target_dir),
           function(f) {f <- file.path(target_dir, f); vsi_unlink(f)})
    expect_equal(vsi_rmdir(target_dir, recursive = TRUE), 0)
})

test_that("vsi_curl_clear_cache runs without error", {
    expect_no_error(vsi_curl_clear_cache())
    expect_no_error(vsi_curl_clear_cache(partial=TRUE, file_prefix="test"))
})

test_that("vsi_rename works", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    tmp_file <- tempfile(fileext = ".tif")
    file.copy(elev_file, tmp_file)
    new_file <- file.path(dirname(tmp_file), "storml_elev_copy.tif")
    expect_equal(vsi_rename(tmp_file, new_file), 0)
})

test_that("vsi_get_fs_prefixes works", {
    x <- vsi_get_fs_prefixes()
    expect_vector(x, ptype = character())
    expect_true(length(x) > 1)
})

test_that("vsi_get_fs_options works", {
    x <- vsi_get_fs_options("/vsizip/", as_list = FALSE)
    expect_vector(x, ptype = character(), size = 1)

    x <- vsi_get_fs_options("/vsizip/")
    expect_type(x, "list")
})

test_that("vsi_supports_seq_write and vsi_supports_rnd_write work", {
    skip_if(as.integer(gdal_version()[2]) < 3060000)

    expect_true(vsi_supports_seq_write("/vsimem/test-mem-file.gpkg", TRUE))
    expect_true(vsi_supports_rnd_write("/vsimem/test-mem-file.gpkg", TRUE))
})

test_that("vsi_get_disk_free_space returns length-1 numeric vector", {
    tmp_dir <- file.path(tempdir(), "tmpdir")
    vsi_mkdir(tmp_dir)
    x <- vsi_get_disk_free_space(tmp_dir)
    expect_vector(x, ptype = bit64::integer64(), 1)
    vsi_rmdir(tmp_dir)
})

test_that("vsi path specific options can be set/unset", {
    skip_if(as.integer(gdal_version()[2]) < 3060000)

    prefix <- "/vsiaz/sampledata"
    expect_no_error(vsi_set_path_option(prefix,
                                        "AZURE_STORAGE_CONNECTION_STRING",
                                        "connection_string_for_gdalraster"))
    expect_no_error(vsi_clear_path_options(prefix))
})

test_that("vsi_get_file_metadata works", {
    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
    expect_no_error(vsi_get_file_metadata(f, domain=""))

    skip_if(as.integer(gdal_version()[2]) < 3070000)

    zip_file <- tempfile(fileext=".zip")
    addFilesInZip(zip_file, f, full_paths=FALSE, sozip_enabled="YES")
    zip_vsi <- file.path("/vsizip", zip_file)
    expect_no_error(md <- vsi_get_file_metadata(zip_vsi, domain="ZIP"))
    expect_type(md, "list")
    expect_equal(md$SOZIP_VALID, "YES")
})

test_that("get URL functions work", {
    # currently not tested using network access
    # only checking the null return value for now
    expect_null(vsi_get_actual_url("/vsimem/test.tif"))
    opt <- "EXPIRATION_DELAY=604800"
    expect_null(vsi_get_signed_url("/vsimem/test.tif", opt))
})

test_that("vsi_is_local works", {
    skip_if(as.integer(gdal_version()[2]) < 3060000)

    expect_true(vsi_is_local("/vsimem/test-mem-file.tif"))
})

test_that("vsi_uri_to_vsi_path works", {
    skip_if(gdal_version_num() < gdal_compute_version(3, 12, 0))

    expect_true(startsWith(vsi_uri_to_vsi_path("gs://cmip6/"), "/vsigs"))
})

# Tests for src/gdalvector.cpp
test_that("class constructors work", {
    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
    dsn <- file.path(tempdir(), basename(f))
    file.copy(f, dsn, overwrite = TRUE)

    expect_no_error(lyr <- new(GDALVector, dsn))
    expect_equal(normalizePath(lyr$getDsn()), normalizePath(dsn))
    expect_equal(lyr$getName(), "mtbs_perims")
    expect_type(lyr$getFeature(1), "list")
    lyr$close()
    expect_false(lyr$isOpen())

    expect_no_error(lyr <- new(GDALVector, dsn, "mtbs_perims"))
    expect_equal(lyr$bbox(), c(469685.73, -12917.76, 573531.72, 96577.34))
    lyr$close()

    expect_no_error(lyr <- new(GDALVector, dsn, "mtbs_perims",
                               read_only = FALSE))
    expect_true(lyr$testCapability()$RandomWrite)
    lyr$close()

    # open option
    expect_no_error(lyr <- new(GDALVector, dsn, "mtbs_perims", read_only = TRUE,
                               "LIST_ALL_TABLES=NO"))
    expect_false(lyr$testCapability()$RandomWrite)
    lyr$close()

    bb <- c(469685.97, 11442.45, 544069.63, 85508.15)

    # spatial filter with SQL layer
    sql <- "SELECT FID, * FROM mtbs_perims"
    expect_no_error(lyr <- new(GDALVector, dsn, sql, read_only = TRUE,
                               open_options = NULL,
                               spatial_filter = bbox_to_wkt(bb)))
    expect_equal(lyr$getFeatureCount(), 40)
    # re-open a SQL layer (implicit close/open)
    lyr$open(read_only = TRUE)
    expect_equal(lyr$getFeatureCount(), 40)
    lyr$close()

    # add empty dialect
    expect_no_error(lyr <- new(GDALVector, dsn, sql, read_only = TRUE,
                               open_options = NULL,
                               spatial_filter = bbox_to_wkt(bb),
                               dialect = ""))
    expect_equal(lyr$getFeatureCount(), 40)
    lyr$close()

    # OGRSQL instead of native dialect
    expect_no_error(lyr <- new(GDALVector, dsn, sql, read_only = TRUE,
                               open_options = NULL,
                               spatial_filter = "",
                               dialect = "OGRSQL"))
    expect_equal(lyr$m_dialect, "OGRSQL")
    expect_equal(lyr$getFeatureCount(), 61)
    lyr$close()

    # invalid layer name
    expect_error(lyr <- new(GDALVector, dsn, "invalid_layer_name"))

    # spatial filter error
    expect_error(lyr <- new(GDALVector, dsn, sql, read_only = TRUE,
                            open_options = NULL,
                            spatial_filter = "invalid WKT",
                            dialect = ""))


    unlink(dsn)

    # default construstrctor with no arguments should not error
    expect_no_error(lyr <- new(GDALVector))

    # not recognized as being in a supported file format
    f <- system.file("extdata/doctype.xml", package="gdalraster")
    expect_error(lyr <- new(GDALVector, f))
})

test_that("class basic interface works", {
    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
    dsn <- file.path(tempdir(), basename(f))
    file.copy(f, dsn, overwrite = TRUE)

    lyr <- new(GDALVector, dsn, "mtbs_perims")

    expect_true(is(lyr, "Rcpp_GDALVector"))
    expect_no_error(show(lyr))

    expect_true(lyr$isReadOnly())
    expect_equal(lyr$getDriverShortName(), "GPKG")
    expect_equal(lyr$getDriverLongName(), "GeoPackage")
    expect_length(lyr$getFileList(), 1)
    expect_equal(lyr$getName(), "mtbs_perims")
    expect_equal(lyr$getGeomType(), "MULTIPOLYGON")
    expect_equal(lyr$getGeometryColumn(), "geom")
    expect_equal(lyr$getFIDColumn(), "fid")
    expect_true(lyr$getSpatialRef() |> srs_is_projected())
    expect_equal(lyr$bbox(), c(469685.73, -12917.76, 573531.72, 96577.34))

    expect_no_error(cap <- lyr$testCapability())
    expect_true(cap$RandomRead)
    expect_false(cap$SequentialWrite)
    expect_false(cap$RandomWrite)
    # re-open with write access
    lyr$open(read_only = FALSE)
    expect_false(lyr$isReadOnly())
    expect_true(lyr$testCapability()$SequentialWrite)
    expect_true(lyr$testCapability()$RandomWrite)

    expect_no_error(defn <- lyr$getLayerDefn())
    fld_names <- c("event_id", "incid_name", "incid_type", "map_id",
                   "burn_bnd_ac", "burn_bnd_lat", "burn_bnd_lon", "ig_date",
                   "ig_year", "geom")
    expect_equal(names(defn), fld_names)

    expect_equal(lyr$returnGeomAs, "WKB")
    expect_equal(lyr$getFeatureCount(), 61)
    expect_no_error(feat <- lyr$getNextFeature())
    expect_true(!is.null(feat))

    # set an attribute filter
    expect_no_error(lyr$setAttributeFilter("ig_year = 2020"))
    expect_equal(lyr$getFeatureCount(), 1)
    expect_no_error(feat <- lyr$getNextFeature())
    expect_false(is.null(feat))
    expect_no_error(feat <- lyr$getNextFeature())
    expect_true(is.null(feat))
    # reset reading to the start and return geometries as WKT
    expect_no_error(lyr$resetReading())
    lyr$returnGeomAs <- "WKT"
    expect_false(is.null(lyr$getNextFeature()))
    # clear the attribute filter
    expect_no_error(lyr$setAttributeFilter(""))
    expect_equal(lyr$getFeatureCount(), 61)

    # set a spatial filter
    #  get the bounding box of the largest 1988 fire and use as spatial filter
    #  first set a temporary attribute filter to do the lookup
    lyr$setAttributeFilter("ig_year = 1988 ORDER BY burn_bnd_ac DESC")
    feat <- lyr$getNextFeature()
    bbox <- bbox_from_wkt(feat$geom)
    expect_equal(bbox, c(469685.97, 11442.45, 544069.63, 85508.15))
    # set spatial filter on the full layer
    lyr$setAttributeFilter("")
    expect_no_error(lyr$setSpatialFilterRect(bbox))
    expect_equal(lyr$getFeatureCount(), 40)
    # test spatial filter errors
    expect_error(lyr$setSpatialFilterRect(NULL))
    expect_error(lyr$setSpatialFilterRect(rep(NA_real_, 4)))
    expect_true(lyr$getSpatialFilter() != "")

    # fetch in chunks and return as data frame
    expect_no_error(d <- lyr$fetch(20))
    expect_true(is.data.frame(d))
    expect_equal(nrow(d), 20)
    # the next chunk
    expect_no_error(d <- lyr$fetch(20))
    expect_true(is.data.frame(d))
    expect_equal(nrow(d), 20)
    # no features remaining
    expect_no_error(d <- lyr$fetch(20))
    expect_equal(nrow(d), 0)

    # fetch all pending features with geometries as WKB
    lyr$returnGeomAs <- "WKB"
    expect_no_error(d <- lyr$fetch(-1))
    expect_equal(nrow(d), 40)

    # request more features than are available
    lyr$resetReading()
    expect_no_error(d2 <- lyr$fetch(100))
    expect_true(is.data.frame(d2))
    expect_equal(nrow(d2), 40)
    expect_equal(d, d2)
    # further fetch should return 0-row data frame
    expect_no_error(d2 <- lyr$fetch(20))
    expect_equal(nrow(d2), 0)

    expect_no_error(lyr$clearSpatialFilter())
    expect_equal(lyr$getFeatureCount(), 61)

    # fetch all remaining features from current position
    lyr$resetReading()
    expect_no_error(f <- lyr$getNextFeature())
    expect_no_error(d <- lyr$fetch(NA))
    expect_equal(nrow(d), 60)

    # fetch errors
    lyr$resetReading()
    expect_error(lyr$fetch(9007199254740992))
    lyr$returnGeomAs <- "invalid"
    expect_error(lyr$fetch(-1))
    lyr$wkbByteOrder <- "invalid"
    expect_error(lyr$fetch(-1))

    lyr$close()

    # SQL layer
    sql_lyr <- new(GDALVector, dsn, "SELECT * FROM mtbs_perims LIMIT 10")
    expect_true(is(sql_lyr, "Rcpp_GDALVector"))
    expect_no_error(show(sql_lyr))
    expect_equal(sql_lyr$getFeatureCount(), 10)
    sql_lyr$close()

    unlink(dsn)

    # test certain errors on a GeoJSON file with NULL geometries
    f <- system.file("extdata/test_ogr_geojson_mixed_timezone.geojson",
                     package = "gdalraster")
    lyr <- new(GDALVector, f, "test")
    expect_error(lyr$bbox(), "extent of the layer cannot be determined")
    expect_error(lyr$setAttributeFilter("invalid_field = 1"),
                 "error setting attribute filter")
    expect_true(is.null(lyr$getFeature(NA)))
    expect_error(lyr$getFeature(c(1,2)), "must be a length-1")
    expect_false(lyr$startTransaction())
    lyr$transactionsForce <- TRUE
    expect_false(lyr$startTransaction())

    lyr$close()
})

test_that("set ignored/selected fields works", {
    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
    dsn <- file.path(tempdir(), basename(f))
    file.copy(f, dsn, overwrite = TRUE)

    lyr <- new(GDALVector, dsn, "mtbs_perims")

    # set ignored, no geom
    expect_vector(lyr$getIgnoredFields(), ptype = character(), size = 0)
    lyr$returnGeomAs <- "NONE"
    expect_true(lyr$testCapability()$IgnoreFields)
    feat <- lyr$getNextFeature()
    expect_length(feat, 10)
    lyr$setIgnoredFields("event_id")
    feat <- lyr$getNextFeature()
    expect_length(feat, 9)
    expect_true(is.null(feat$event_id))
    expect_false(is.null(feat$incid_name))
    expect_equal(lyr$getIgnoredFields(), "event_id")
    lyr$setIgnoredFields("")
    feat <- lyr$getNextFeature()
    expect_length(feat, 10)
    expect_vector(lyr$getIgnoredFields(), ptype = character(), size = 0)
    lyr$setIgnoredFields(c("event_id", "map_id", "ig_year"))
    feat <- lyr$getNextFeature()
    expect_length(feat, 7)
    expect_equal(lyr$getIgnoredFields(), c("event_id", "map_id", "ig_year"))
    lyr$setIgnoredFields("")
    feat <- lyr$getNextFeature()
    expect_length(feat, 10)

    # set selected, no geom
    # FID is always included, so expected number of fields is +1
    lyr$returnGeomAs <- "NONE"
    lyr$setSelectedFields("event_id")
    feat <- lyr$getNextFeature()
    expect_length(feat, 2)
    expect_true(is.character(feat$event_id))
    expect_true(length(lyr$getIgnoredFields()) > 1)
    lyr$setSelectedFields("")
    feat <- lyr$getNextFeature()
    expect_length(feat, 10)
    lyr$setSelectedFields(c("event_id", "map_id", "ig_year"))
    feat <- lyr$getNextFeature()
    expect_length(feat, 4)
    lyr$setSelectedFields("")
    feat <- lyr$getNextFeature()
    expect_length(feat, 10)
    expect_true(length(lyr$getIgnoredFields()) == 0)

    # geometry
    # ignoring "OGR_GEOMETRY" is redundant with returnGeomAs = "NONE"
    # make sure we can repeat "OGR_GEOMETRY" in the ignore list
    lyr$returnGeomAs <- "NONE"
    lyr$setIgnoredFields("OGR_GEOMETRY")
    expect_equal(lyr$getIgnoredFields(), "OGR_GEOMETRY")
    feat <- lyr$getNextFeature()
    expect_length(feat, 10)
    expect_true(is.null(feat$geom))
    lyr$returnGeomAs <- "WKT"
    lyr$setIgnoredFields("")
    feat <- lyr$getNextFeature()
    expect_length(feat, 11)
    lyr$setIgnoredFields("OGR_GEOMETRY")
    feat <- lyr$getNextFeature()
    expect_length(feat, 10)
    expect_true(is.null(feat$geom))
    lyr$setIgnoredFields(c("event_id", "OGR_GEOMETRY"))
    expect_equal(lyr$getIgnoredFields(), c("event_id", "OGR_GEOMETRY"))
    feat <- lyr$getNextFeature()
    expect_length(feat, 9)
    lyr$setIgnoredFields("")
    expect_true(length(lyr$getIgnoredFields()) == 0)
    feat <- lyr$getNextFeature()
    expect_length(feat, 11)
    # selected
    lyr$returnGeomAs <- "WKT"
    lyr$setSelectedFields(c("event_id", "OGR_GEOMETRY"))
    feat <- lyr$getNextFeature()
    expect_length(feat, 3)
    expect_false(is.null(feat$geom))
    expect_true(length(lyr$getIgnoredFields()) > 1)

    # test fetch past end with ignored fields does not crash
    # https://github.com/firelab/gdalraster/issues/539
    lyr$returnGeomAs <- "WKB"
    lyr$setSelectedFields(c("incid_name", "ig_year", "OGR_GEOMETRY"))
    lyr$setAttributeFilter("ig_year >= 2018")
    expect_equal(lyr$getFeatureCount(), 3)
    expect_s3_class(lyr$getNextFeature(), "OGRFeature")
    expect_s3_class(lyr$getNextFeature(), "OGRFeature")
    expect_s3_class(lyr$getNextFeature(), "OGRFeature")
    expect_true(is.null(lyr$getNextFeature()))

    # field names not resolved
    expect_no_error(lyr$setIgnoredFields(""))
    expect_error(lyr$setIgnoredFields(c("event_id", "invalid_field")),
                 "not all field names could be resolved")
    expect_no_error(lyr$setIgnoredFields(""))
    expect_output(lyr$setSelectedFields(c("event_id", "invalid_field")),
                  "invalid_field")
    expect_false("event_id" %in% lyr$getIgnoredFields())
    expect_no_error(lyr$setSelectedFields(""))
    expect_error(lyr$setSelectedFields("invalid_field"),
                 "none of the input field names could be resolved")

    # errors if input is not a character vector
    expect_error(lyr$setIgnoredFields(NULL))
    expect_error(lyr$setSelectedFields(NULL))

    lyr$close()
    unlink(dsn)

    # layer does not support ignored fields
    dsn_json <- system.file("extdata/test.geojson", package="gdalraster")
    lyr <- new(GDALVector, dsn_json)
    expect_true(("int2" %in% lyr$getFieldNames()))
    expect_error(lyr$setIgnoredFields("int2"),
                 "layer does not have IgnoreFields capability")
    expect_length(lyr$getIgnoredFields(), 0)
    expect_error(lyr$setSelectedFields("int2"),
                 "layer does not have IgnoreFields capability")
    expect_length(lyr$getIgnoredFields(), 0)
    lyr$close()

})

test_that("read methods work correctly", {
    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
    dsn <- file.path(tempdir(), basename(f))
    file.copy(f, dsn, overwrite = TRUE)

    lyr <- new(GDALVector, dsn, "mtbs_perims")

    field_names <- c("event_id", "incid_name", "incid_type", "map_id",
                     "burn_bnd_ac", "burn_bnd_lat", "burn_bnd_lon",
                     "ig_date", "ig_year", "geom")
    expect_equal(lyr$getFieldNames(), field_names)

    # attribute filter
    filter = "ig_year = 2020"
    expect_no_error(lyr$setAttributeFilter(filter))
    expect_equal(lyr$getFeatureCount(), 1)
    expect_equal(lyr$getAttributeFilter(), filter)
    # clear
    expect_no_error(lyr$setAttributeFilter(""))

    # spatial filter as WKT
    bbox <- c(469685.97, 11442.45, 544069.63, 85508.15)
    expect_no_error(lyr$setSpatialFilter(bbox_to_wkt(bbox)))
    expect_equal(lyr$getFeatureCount(), 40)
    expect_true(g_equals(lyr$getSpatialFilter(), bbox_to_wkt(bbox)))
    # test getFeature() with spatial filter in effect
    expect_equal(lyr$getFeature(10)$FID, as.integer64(10))
    expect_equal(lyr$getFeatureCount(), 40)
    expect_true(g_equals(lyr$getSpatialFilter(), bbox_to_wkt(bbox)))
    # clear
    expect_no_error(lyr$clearSpatialFilter())
    expect_equal(lyr$getFeatureCount(), 61)
    # invalid WKT geom
    expect_error(lyr$setSpatialFilter("POLYGON invalid"))

    # cursor positioning
    expect_equal(lyr$getFeatureCount(), 61)
    expect_equal(lyr$getNextFeature()$FID, as.integer64(1))
    expect_equal(lyr$getNextFeature()$FID, as.integer64(2))
    lyr$resetReading()
    expect_equal(lyr$getNextFeature()$FID, as.integer64(1))
    lyr$setNextByIndex(3)
    expect_equal(lyr$getNextFeature()$FID, as.integer64(4))
    lyr$setNextByIndex(3.5)
    expect_equal(lyr$getNextFeature()$FID, as.integer64(4))
    lyr$setNextByIndex(0)
    expect_equal(lyr$getNextFeature()$FID, as.integer64(1))

    expect_equal(lyr$getFeature(10)$FID, as.integer64(10))

    expect_error(lyr$setNextByIndex(NA))
    expect_error(lyr$setNextByIndex(-1))
    expect_error(lyr$setNextByIndex(Inf))
    expect_error(lyr$setNextByIndex(9007199254740993))

    lyr$close()
    unlink(dsn)
    rm(lyr)
    rm(dsn)

    # promoteToMulti
    dsn <- system.file("extdata/poly_multipoly.shp", package="gdalraster")
    lyr <- new(GDALVector, dsn)
    lyr$returnGeomAs <- "TYPE_NAME"
    lyr$promoteToMulti <- FALSE
    geom_fld <-lyr$defaultGeomColName
    d <- lyr$fetch(-1)
    expect_true("POLYGON" %in% d[, geom_fld])
    expect_true("MULTIPOLYGON" %in% d[, geom_fld])
    lyr$promoteToMulti <- TRUE
    d <- lyr$fetch(-1)
    expect_false("POLYGON" %in% d[, geom_fld])
    expected_geoms <- rep("MULTIPOLYGON", lyr$getFeatureCount())
    expect_equal(d[, geom_fld], expected_geoms)
    expect_equal(attr(d, "gis")$geom_col_type, "MULTIPOLYGON")
    rm(d)

    # returnGeomAs
    lyr$returnGeomAs <- "WKB"
    f <- lyr$getFeature(1)
    expect_true(is.raw(f[[geom_fld]]))
    f <- NULL
    lyr$returnGeomAs <- "WKB_ISO"
    f <- lyr$getFeature(1)
    expect_true(is.raw(f[[geom_fld]]))
    f <- NULL
    lyr$returnGeomAs <- "WKT"
    f <- lyr$getFeature(1)
    expect_true(is.character(f[[geom_fld]]))
    f <- NULL
    lyr$returnGeomAs <- "WKT_ISO"
    f <- lyr$getFeature(1)
    expect_true(is.character(f[[geom_fld]]))
    f <- NULL
    lyr$returnGeomAs <- "TYPE_NAME"
    f <- lyr$getFeature(1)
    expect_true(is.character(f[[geom_fld]]))
    f <- NULL
    lyr$returnGeomAs <- "SUMMARY"
    f <- lyr$getFeature(1)
    expect_true(is.character(f[[geom_fld]]))
    f <- NULL
    lyr$returnGeomAs <- "NONE"
    f <- lyr$getFeature(1)
    expect_true(is.null(f[[geom_fld]]))
    f <- NULL
    lyr$returnGeomAs <- "BBOX"
    f <- lyr$getFeature(1)
    expect_true(is.numeric(f[[geom_fld]]))
    expect_true(all(diff(f[[geom_fld]])[c(1, 3)] > 0))
    f <- NULL
    lyr$close()
    rm(lyr)

    # convertToLinear
    dsn <- system.file("extdata/multisurface.zip", package="gdalraster")
    dsn <- file.path("/vsizip", dsn, "multisurface.gpkg")
    lyr <- new(GDALVector, dsn, "multisurface_test")
    g1 <- lyr$fetch(-1)
    expect_equal(attr(g1, "gis")$geom_col_type, "MULTISURFACE")
    expect_equal(g_name(g1$geom), rep("MULTISURFACE", 5))
    lyr$convertToLinear <- TRUE
    g2 <- lyr$fetch(-1)
    expect_equal(attr(g2, "gis")$geom_col_type, "MULTIPOLYGON")
    expect_equal(g_name(g2$geom), rep("MULTIPOLYGON", 5))
    diff <- g_difference(g1$geom, g2$geom)
    expect_true(all(g_is_empty(diff)))
    lyr$close()

    # GeoJSON DateTime field with mixed time zones
    # adapted from:
    # https://github.com/OSGeo/gdal/blob/master/autotest/ogr/ogr_geojson.py
    # "test_ogr_geojson_arrow_stream_pyarrow_mixed_timezone"
    f <- system.file("extdata/test_ogr_geojson_mixed_timezone.geojson",
                     package = "gdalraster")
    lyr <- new(GDALVector, f, "test")
    d <- lyr$fetch(-1)
    res <- as.numeric(d$datetime)
    expected_values <- c(NA, 1654000496.789, NA, 1653996896.789, 1654004096.789)
    expect_equal(res, expected_values, tolerance = 0.001)
    lyr$close()
})

test_that("delete feature works", {
    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
    dsn <- file.path(tempdir(), basename(f))
    file.copy(f, dsn, overwrite = TRUE)

    lyr <- new(GDALVector, dsn, "mtbs_perims", read_only = FALSE)
    num_feat <- lyr$getFeatureCount()
    expect_true(lyr$deleteFeature(1))
    expect_true(lyr$deleteFeature(bit64::as.integer64(2)))

    expect_error(lyr$deleteFeature(NULL))
    expect_error(lyr$deleteFeature(c(10, 11)))

    lyr$open(read_only = TRUE)
    expect_equal(lyr$getFeatureCount(), num_feat - 2)
    expect_false(lyr$deleteFeature(2))
    expect_equal(lyr$getFeatureCount(), num_feat - 2)

    # transaction
    lyr$open(read_only = FALSE)
    num_feat <- lyr$getFeatureCount()

    expect_false(lyr$commitTransaction())
    expect_false(lyr$rollbackTransaction())

    expect_true(lyr$startTransaction())
    lyr$deleteFeature(10)
    expect_true(lyr$commitTransaction())
    expect_equal(lyr$getFeatureCount(), num_feat - 1)
    lyr$startTransaction()
    lyr$deleteFeature(11)
    expect_true(lyr$rollbackTransaction())
    expect_equal(lyr$getFeatureCount(), num_feat - 1)

    lyr$close()
    unlink(dsn)
})

test_that("feature write methods work", {
    ## tests on an existing data source with real data
    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
    dsn <- file.path(tempdir(), basename(f))
    file.copy(f, dsn, overwrite = TRUE)

    lyr <- new(GDALVector, dsn, "mtbs_perims", read_only = FALSE)
    start_count <- lyr$getFeatureCount()
    lyr$returnGeomAs <- "WKB"

    # create and write a new feature
    # new feature is a modified copy of existing FID 1 with same geom
    feat <- lyr$getNextFeature()
    test1_orig_fid <- feat$FID
    feat$FID <- NULL
    feat$event_id <- "ZZ01"
    feat$incid_name <- "TEST 1"
    feat$map_id <- 999991
    feat$ig_date <- as.Date("9999-01-01")
    feat$ig_year <- 9999
    expect_true(lyr$createFeature(feat))
    expect_equal(lyr$getFeatureCount(), start_count + 1)

    # edit an existing feature and set
    feat <- NULL
    feat <- lyr$getNextFeature()
    feat$event_id <- "ZZ02"
    feat$incid_name <- "TEST 2"
    feat$map_id <- 999992
    feat$ig_date <- as.Date("9999-01-02")
    feat$ig_year <- 9999
    expect_true(lyr$setFeature(feat))
    expect_equal(lyr$getFeatureCount(), start_count + 1)

    if(gdal_version_num() > 3060000) {
        # edit an existing feature and upsert with existing FID
        feat <- NULL
        feat <- lyr$getNextFeature()
        feat$event_id <- "ZZ03"
        feat$incid_name <- "TEST 3"
        feat$map_id <- 999993
        feat$ig_date <- as.Date("9999-01-03")
        feat$ig_year <- 9999
        expect_true(lyr$upsertFeature(feat))
        expect_equal(lyr$getFeatureCount(), start_count + 1)

        # edit an existing feature and upsert with new non-existing FID
        feat <- NULL
        feat <- lyr$getNextFeature()
        test4_orig_fid <- feat$FID
        feat$FID <- as.integer64(9999999999999994)
        feat$event_id <- "ZZ04"
        feat$incid_name <- "TEST 4"
        feat$map_id <- 999994
        feat$ig_date <- as.Date("9999-01-04")
        feat$ig_year <- 9999
        expect_true(lyr$upsertFeature(feat))
        expect_equal(lyr$getFeatureCount(), start_count + 2)
    }

    # read back
    lyr$open(read_only = TRUE)
    lyr$returnGeomAs <- "WKT"

    lyr$setAttributeFilter("event_id = 'ZZ01'")
    test1_feat <- lyr$getNextFeature()
    expect_false(is.null(test1_feat))
    expect_equal(test1_feat$incid_name, "TEST 1")
    expect_equal(test1_feat$map_id, as.integer64(999991))
    expect_equal(test1_feat$ig_date, as.Date("9999-01-01"))
    test1_orig_feat <- lyr$getFeature(test1_orig_fid)
    geom_fld <- lyr$getGeometryColumn()
    expect_true(g_equals(test1_feat[[geom_fld]], test1_orig_feat[[geom_fld]]))
    test1_feat <- NULL

    lyr$setAttributeFilter("event_id = 'ZZ02'")
    test2_feat <- lyr$getNextFeature()
    expect_false(is.null(test2_feat))
    expect_equal(test2_feat$incid_name, "TEST 2")
    expect_equal(test2_feat$map_id, as.integer64(999992))
    expect_equal(test2_feat$ig_date, as.Date("9999-01-02"))
    expect_equal(test2_feat$ig_year, 9999)
    test2_feat <- NULL

    if(gdal_version_num() > 3060000) {
        lyr$setAttributeFilter("event_id = 'ZZ03'")
        test3_feat <- lyr$getNextFeature()
        expect_false(is.null(test3_feat))
        expect_equal(test3_feat$incid_name, "TEST 3")
        expect_equal(test3_feat$map_id, as.integer64(999993))
        expect_equal(test3_feat$ig_date, as.Date("9999-01-03"))
        expect_equal(test3_feat$ig_year, 9999)
        test3_feat <- NULL

        lyr$setAttributeFilter("event_id = 'ZZ04'")
        test4_feat <- lyr$getNextFeature()
        expect_false(is.null(test4_feat))
        expect_equal(test4_feat$incid_name, "TEST 4")
        expect_equal(test4_feat$map_id, as.integer64(999994))
        expect_equal(test4_feat$ig_date, as.Date("9999-01-04"))
        test4_orig_feat <- lyr$getFeature(test4_orig_fid)
        geom_fld <- lyr$getGeometryColumn()
        expect_true(g_equals(test4_feat[[geom_fld]],
                             test4_orig_feat[[geom_fld]]))
        test4_feat <- NULL
    }

    lyr$close()
    deleteDataset(dsn)
    rm(dsn)
    rm(lyr)


    ## tests for field types supported by GPKG
    ## (does not inlcude OGR list field types)
    dsn2 <- tempfile(fileext = ".gpkg")
    defn <- ogr_def_layer("Point", srs = epsg_to_wkt(4326))
    defn$int_fld <- ogr_def_field("OFTInteger")
    defn$bool_fld <- ogr_def_field("OFTInteger", fld_subtype = "OFSTBoolean")
    defn$int64_fld <- ogr_def_field("OFTInteger64")
    defn$real_fld <- ogr_def_field("OFTReal")
    defn$str_fld <- ogr_def_field("OFTString", fld_width = 100)
    defn$date_fld <- ogr_def_field("OFTDate")
    defn$datetime_fld <- ogr_def_field("OFTDateTime")
    defn$time_fld <- ogr_def_field("OFTTime")
    defn$binary_fld <- ogr_def_field("OFTBinary")

    expect_true(ogr_ds_create("GPKG", dsn2, "test_layer", layer_defn = defn))

    lyr <- new(GDALVector, dsn2, "test_layer", read_only = FALSE)
    expect_equal(lyr$getFeatureCount(), 0)

    geom_fld <- lyr$getGeometryColumn()

    feat1 <- list()
    feat1$int_fld <- 1
    feat1$bool_fld <- TRUE
    feat1$int64_fld <- as.integer64(11)
    feat1$real_fld <- 1.1
    feat1$str_fld <- "string 1"
    feat1$date_fld <- as.Date("2000-01-01")
    feat1$datetime_fld <- as.POSIXct("2000-01-01 13:01:01.123 GMT", tz = "UTC")
    feat1$time_fld <- "01:02:03"
    feat1$binary_fld <- as.raw(c(1, 1, 1))
    feat1[[geom_fld]] <- "POINT (1 1)"

    expect_true(lyr$createFeature(feat1))
    test1_fid <- lyr$getLastWriteFID()
    expect_false(is.null(test1_fid))

    expect_true(lyr$createFeature(feat1))
    test2_fid <- lyr$getLastWriteFID()
    expect_false(is.null(test2_fid))

    lyr$open(read_only = TRUE)
    expect_equal(lyr$getFeatureCount(), 2)

    lyr$open(read_only = FALSE)

    # edit feature 2
    feat2 <- list()
    feat2$FID <- test2_fid
    feat2$int_fld <- 2
    feat2$bool_fld <- FALSE
    feat2$int64_fld <- as.integer64(22)
    feat2$real_fld <- 2.2
    feat2$str_fld <- "string 2"
    feat2$date_fld <- as.Date("2000-01-02")
    feat2$datetime_fld <- as.POSIXct("2000-01-02 14:02.234 GMT", tz = "UTC")
    feat2$time_fld <- "02:03:04"
    feat2$binary_fld <- as.raw(c(2, 2, 2))
    feat2[[geom_fld]] <- "POINT (2 2)"

    expect_true(lyr$setFeature(feat2))
    expect_equal(lyr$getLastWriteFID(), test2_fid)

    # read back
    lyr$open(read_only = TRUE)
    expect_equal(lyr$getFeatureCount(), 2)

    lyr$returnGeomAs <- "WKT"

    feat1_check <- lyr$getFeature(test1_fid)
    feat1_check$FID <- NULL
    class(feat1_check) <- "list"
    attr(feat1_check, "gis") <- NULL
    expect_equal(feat1_check, feat1)

    feat2_check <- lyr$getFeature(test2_fid)
    class(feat2_check) <- "list"
    attr(feat2_check, "gis") <- NULL
    expect_equal(feat2_check, feat2)

    lyr$open(read_only = FALSE)

    # NULL geometry
    # as NA
    feat3 <- list()
    feat3$int_fld <- 3
    feat3$bool_fld <- TRUE
    feat3$int64_fld <- as.integer64(33)
    feat3$real_fld <- 3.3
    feat3$str_fld <- "string 3"
    feat3$date_fld <- as.Date("2000-01-03")
    feat3$datetime_fld <- as.POSIXct("2000-01-03 13:01:01.123 GMT", tz = "UTC")
    feat3$time_fld <- "03:04:05"
    feat3$binary_fld <- as.raw(c(3, 3, 3))
    feat3[[geom_fld]] <- NA

    expect_true(lyr$createFeature(feat3))
    test3_fid <- lyr$getLastWriteFID()
    expect_false(is.null(test3_fid))

    # as NULL
    feat4 <- list()
    feat4$int_fld <- 4
    feat4$bool_fld <- TRUE
    feat4$int64_fld <- as.integer64(44)
    feat4$real_fld <- 4.4
    feat4$str_fld <- "string 4"
    feat4$date_fld <- as.Date("2000-01-04")
    feat4$datetime_fld <- as.POSIXct("2000-01-04 13:01:01.123 GMT", tz = "UTC")
    feat4$time_fld <- "04:05:06"
    feat4$binary_fld <- as.raw(c(4, 4, 4))
    feat4[[geom_fld]] <- list(NULL)

    expect_true(lyr$createFeature(feat4))
    test4_fid <- lyr$getLastWriteFID()
    expect_false(is.null(test4_fid))

    # read back
    lyr$open(read_only = TRUE)
    expect_equal(lyr$getFeatureCount(), 4)

    lyr$returnGeomAs <- "WKB"

    feat3_check <- lyr$getFeature(test3_fid)
    expect_true(is.null(feat3_check[[geom_fld]]))

    feat4_check <- lyr$getFeature(test4_fid)
    expect_true(is.null(feat4_check[[geom_fld]]))

    lyr$open(read_only = FALSE)

    # NULL attribute fields
    # as NA
    feat5 <- list()
    feat5$int_fld <- NA
    feat5$bool_fld <- NA
    feat5$int64_fld <- NA
    feat5$real_fld <- NA
    feat5$str_fld <- NA
    feat5$date_fld <- NA
    feat5$datetime_fld <- NA
    feat5$time_fld <- NA
    feat5$binary_fld <- raw()
    feat5[[geom_fld]] <- "POINT (5 5)"

    expect_true(lyr$createFeature(feat5))
    test5_fid <- lyr$getLastWriteFID()
    expect_false(is.null(test5_fid))

    # as typed NA and with NA FID
    feat6 <- list()
    feat5$FID <- NA_real_
    feat6$int_fld <- NA_integer_
    feat6$bool_fld <- NA
    feat6$int64_fld <- NA_integer64_
    feat6$real_fld <- NA_real_
    feat6$str_fld <- NA_character_
    feat6$date_fld <- as.Date(NA_real_)
    feat6$datetime_fld <- as.POSIXct(NA_real_)
    feat6$time_fld <- NA_character_
    feat6$binary_fld <- raw(0)
    feat6[[geom_fld]] <- "POINT (6 6)"

    expect_true(lyr$createFeature(feat6))
    test6_fid <- lyr$getLastWriteFID()
    expect_false(is.null(test6_fid))

    # as NULL
    feat7 <- list()
    feat7$int_fld <- list(NULL)
    feat7$bool_fld <- list(NULL)
    feat7$int64_fld <- list(NULL)
    feat7$real_fld <- list(NULL)
    feat7$str_fld <- list(NULL)
    feat7$date_fld <- list(NULL)
    feat7$datetime_fld <- list(NULL)
    feat7$time_fld <- list(NULL)
    feat7$binary_fld <- list(NULL)
    feat7[[geom_fld]] <- "POINT (7 7)"

    expect_true(lyr$createFeature(feat7))
    test7_fid <- lyr$getLastWriteFID()
    expect_false(is.null(test7_fid))

    # read back
    lyr$open(read_only = TRUE)
    lyr$returnGeomAs <- "WKT"

    feat5_check <- lyr$getFeature(test5_fid)
    expect_true(is.na(feat5_check$int_fld ))
    expect_true(is.na(feat5_check$bool_fld))
    expect_true(is.na(feat5_check$int64_fld))
    expect_true(is.na(feat5_check$real_fld))
    expect_true(is.na(feat5_check$str_fld))
    expect_true(is.na(feat5_check$date_fld))
    expect_true(is.na(feat5_check$datetime_fld))
    expect_true(is.null(feat5_check$binary_fld))
    expect_equal(feat5_check[[geom_fld]], "POINT (5 5)")

    feat6_check <- lyr$getFeature(test6_fid)
    expect_true(is.na(feat6_check$int_fld ))
    expect_true(is.na(feat6_check$bool_fld))
    expect_true(is.na(feat6_check$int64_fld))
    expect_true(is.na(feat6_check$real_fld))
    expect_true(is.na(feat6_check$str_fld))
    expect_true(is.na(feat6_check$date_fld))
    expect_true(is.na(feat6_check$datetime_fld))
    expect_true(is.null(feat6_check$binary_fld))
    expect_equal(feat6_check[[geom_fld]], "POINT (6 6)")

    feat7_check <- lyr$getFeature(test7_fid)
    expect_true(is.na(feat7_check$int_fld ))
    expect_true(is.na(feat7_check$bool_fld))
    expect_true(is.na(feat7_check$int64_fld))
    expect_true(is.na(feat7_check$real_fld))
    expect_true(is.na(feat7_check$str_fld))
    expect_true(is.na(feat7_check$date_fld))
    expect_true(is.na(feat7_check$datetime_fld))
    expect_true(is.null(feat7_check$binary_fld))
    expect_equal(feat7_check[[geom_fld]], "POINT (7 7)")

    ## test input errors
    lyr$open(read_only = FALSE)

    # NULL feature
    expect_error(lyr$createFeature(NULL))
    expect_error(lyr$setFeature(NULL))

    # feature not a list
    feat <- c(1, 2)
    expect_error(lyr$setFeature(feat))
    feat <- c("1", "2")
    expect_error(lyr$setFeature(feat))

    # no element names
    feat <- lyr$getFeature(1)
    names(feat) <- NULL
    expect_error(lyr$setFeature(feat))

    # a name does not match the layer schema
    feat <- lyr$getFeature(1)
    feat$nonexistent_fld <- 1
    expect_error(lyr$setFeature(feat))

    feat <- lyr$getFeature(1)

    # character for OFTInteger
    orig <- feat$int_fld
    feat$int_fld <- "1"
    expect_error(lyr$setFeature(feat))
    feat$int_fld <- orig

    # character for OFTInteger64
    orig <- feat$int64_fld
    feat$int64_fld <- "1"
    expect_error(lyr$setFeature(feat))
    feat$int64_fld <- orig

    # character for OFTReal
    orig <- feat$real_fld
    feat$real_fld <- "1"
    expect_error(lyr$setFeature(feat))
    feat$real_fld <- orig

    # numeric for OFTString
    orig <- feat$str_fld
    feat$str_fld <- 1
    expect_error(lyr$setFeature(feat))
    feat$str_fld <- orig

    # missing Date class for OFTDate
    orig <- feat$date_fld
    feat$date_fld <- as.numeric(as.Date("9999-01-04"))
    expect_error(lyr$setFeature(feat))
    feat$date_fld <- orig

    # character string for OFTDate
    orig <- feat$date_fld
    feat$date_fld <- "2000-01-01"
    expect_error(lyr$setFeature(feat))
    feat$date_fld <- orig

    # missing POSIXct class for OFTDateTime
    orig <- feat$datetime_fld
    feat$datetime_fld <- as.numeric(as.Date("9999-01-04"))
    expect_error(lyr$setFeature(feat))
    feat$datetime_fld <- orig

    # character string for OFTDateTime
    orig <- feat$datetime_fld
    feat$datetime_fld <- "2000-01-02 14:02.234 GMT"
    expect_error(lyr$setFeature(feat))
    feat$datetime_fld <- orig

    # other than raw vector for OFTBinary
    orig <- feat$binary_fld
    feat$binary_fld <- integer(10)
    expect_error(lyr$setFeature(feat))
    feat$binary_fld <- orig

    orig <- feat$binary_fld
    feat$binary_fld <- numeric(10)
    expect_error(lyr$setFeature(feat))
    feat$binary_fld <- orig

    orig <- feat$binary_fld
    feat$binary_fld <- character(10)
    expect_error(lyr$setFeature(feat))
    feat$binary_fld <- orig

    # other than raw vector for OFTBinary, in list
    orig <- feat$binary_fld
    feat$binary_fld <- list(integer(10))
    expect_error(lyr$setFeature(feat))
    feat$binary_fld <- orig

    # not character or raw vector for geom field
    orig <- feat[[geom_fld]]
    feat[[geom_fld]] <- integer(10)
    expect_false(lyr$setFeature(feat))
    feat[[geom_fld]] <- orig

    # not character or raw vector for geom field, in list
    orig <- feat[[geom_fld]]
    feat[[geom_fld]] <- list(numeric(10))
    expect_false(lyr$setFeature(feat))
    feat[[geom_fld]] <- orig

    # multi-row data frame
    feat <- lyr$fetch(-1)
    expect_true(nrow(feat) > 1)
    expect_error(lyr$setFeature(feat))

    lyr$close()
    deleteDataset(dsn2)
    rm(lyr)
    rm(dsn2)


    ## tests for OGR list field types with the CSV driver
    dsn3 <- file.path(tempdir(), "test_list.csv")

    defn <- ogr_def_layer("Point", srs = epsg_to_wkt(4326))
    defn$id <- ogr_def_field("OFTInteger")
    defn$real_fld <- ogr_def_field("OFTReal")
    defn$str_fld <- ogr_def_field("OFTString")
    defn$int_list_fld <- ogr_def_field("OFTIntegerList", "JSonIntegerList")
    defn$int64_list_fld <- ogr_def_field("OFTInteger64List", "JSonInteger64List")
    defn$real_list_fld <- ogr_def_field("OFTRealList", "JSonRealList")
    defn$str_list_fld <- ogr_def_field("OFTStringList", "JSonStringList")

    lyr_opt <- c("GEOMETRY=AS_WKT", "CREATE_CSVT=YES")
    expect_true(ogr_ds_create("CSV", dsn3, "test_list", layer_defn = defn,
                              lco = lyr_opt, overwrite = TRUE))

    lyr <- new(GDALVector, dsn3, "test_list", read_only = FALSE)

    geom_fld <- lyr$getGeometryColumn()

    feat1 <- list()
    feat1$id <- 1
    feat1$real_fld <- 1.1
    feat1$str_fld <- "string 1"
    feat1$int_list_fld <- c(1, 1, 1)
    feat1$int64_list_fld <- as.integer64(c(9999999999999991, 9999999999999991, 9999999999999991))
    feat1$real_list_fld <- c(1.1, 1.1, 1.1)
    feat1$str_list_fld <- c("str 1", "str 1", "str 1")
    feat1[[geom_fld]] <- "POINT (1 1)"

    expect_true(lyr$createFeature(feat1))

    expect_true(lyr$syncToDisk())

    # close and re-open
    lyr$open(read_only = TRUE)
    lyr$returnGeomAs <- "WKT"

    f <- lyr$getNextFeature()
    expect_equal(f$id, feat1$id)
    expect_equal(f$real_fld, feat1$real_fld)
    expect_equal(f$str_fld, feat1$str_fld)
    expect_equal(f$int_list_fld, feat1$int_list_fld)
    expect_equal(f$int64_list_fld, feat1$int64_list_fld)
    expect_equal(f$real_list_fld, feat1$real_list_fld)
    expect_equal(f$str_list_fld, feat1$str_list_fld)
    # this fails with GDAL < 3.5 due to change in geom column naming?
    # expect_true(g_equals(f$WKT, feat1[[geom_fld]]))

    lyr$close()
    deleteDataset(dsn3)
    rm(lyr)
    rm(dsn3)


    ## test ESRI Shapefile for supported field types, Polygon geom, no SRS set
    dsn4 <- tempfile(fileext = ".shp")

    defn <- ogr_def_layer("Polygon")
    defn$id <- ogr_def_field("OFTInteger")
    defn$real_fld <- ogr_def_field("OFTReal")
    defn$str_fld <- ogr_def_field("OFTString")
    defn$date_fld <- ogr_def_field("OFTDate")

    expect_true(ogr_ds_create("ESRI Shapefile", dsn4, "", layer_defn = defn,
                              overwrite = TRUE))

    lyr <- new(GDALVector, dsn4, "", read_only = FALSE)
    expect_equal(lyr$getFeatureCount(), 0)

    feat1 <- list()
    feat1$id <- 100
    feat1$real_fld <- 0.123
    feat1$str_fld <- "test string"
    feat1$date_fld <- as.Date("2100-01-01")
    feat1$geom <- "POLYGON ((0 0,0 10,10 10,0 0),(0.25 0.5,1 1,0.5 1,0.25 0.5))"

    test1_fid <- NULL
    expect_true(lyr$createFeature(feat1))
    test1_fid <- lyr$getLastWriteFID()
    expect_false(is.null(test1_fid))

    # close and re-open
    lyr$open(read_only = TRUE)
    lyr$returnGeomAs <- "WKT"
    f <- lyr$getNextFeature()
    expect_equal(f$FID, test1_fid)
    expect_equal(f$id, feat1$id)
    expect_equal(f$real_fld, feat1$real_fld)
    expect_equal(f$str_fld, feat1$str_fld)
    expect_equal(f$date_fld, feat1$date_fld)
    expect_true(g_equals(f$geom, feat1$geom))

    lyr$close()

    # read as SQL layer with SQLITE dialect
    layer_name <- tools::file_path_sans_ext(basename(dsn4))
    sql <- paste0("SELECT id, GEOMETRY as geom FROM ", layer_name)
    expect_no_error(lyr <- new(GDALVector, dsn4, sql, read_only = TRUE,
                               open_options = NULL, spatial_filter = "",
                               dialect = "SQLITE"))
    lyr$returnGeomAs <- "WKT"
    expect_equal(lyr$m_dialect, "SQLITE")
    expect_no_error(f <- lyr$getFeature(test1_fid))
    expect_equal(f$id, feat1$id)
    expect_true(g_equals(f$geom, feat1$geom))

    lyr$close()

    deleteDataset(dsn4)
    rm(lyr)
    rm(dsn4)

    ## test GeoJSON write, Point with SRS
    # include test of OFTTime field type here
    dsn5 <- tempfile(fileext = ".geojson")

    defn <- ogr_def_layer("Point", srs = epsg_to_wkt(4322))
    defn$real_field <- ogr_def_field("OFTReal")
    defn$str_field <- ogr_def_field("OFTString")
    defn$time_field <- ogr_def_field("OFTTime")

    expect_no_error(lyr <- ogr_ds_create("GeoJSON", dsn5, "test_layer",
                                         layer_defn = defn,
                                         lco = "WRITE_BBOX=YES",
                                         overwrite = TRUE,
                                         return_obj = TRUE))

    feat1 <- list()
    feat1$real_field <- 0.123
    feat1$str_field <- "test string 1"
    feat1$time_field <- "12:00:00"
    feat1$geom <- "POINT (1 10)"
    expect_true(lyr$createFeature(feat1))

    feat2 <- list()
    feat2$real_field <- 0.234
    feat2$str_field <- "test string 2"
    feat2$time_field <- "13:00:00"
    feat2$geom <- "POINT (2 20)"
    expect_true(lyr$createFeature(feat2))

    feat3 <- list()
    feat3$real_field <- 0.345
    feat3$str_field <- "test string 3"
    feat3$time_field <- Sys.time()
    feat3$geom <- "POINT (3 20)"
    expect_error(lyr$createFeature(feat3))

    # close and re-open
    lyr$open(read_only = TRUE)

    expect_equal(lyr$getFeatureCount(), 2)
    expect_equal(lyr$bbox(), c(1, 10, 2, 20))
    expect_true(srs_is_same(lyr$getSpatialRef(), epsg_to_wkt(4322)))

    f <- lyr$getNextFeature()
    expect_equal(f$real_field, feat1$real_field, tolerance = .001)
    expect_equal(f$str_field, feat1$str_field)
    expect_equal(f$time_field, feat1$time_field)

    lyr$close()
    unlink(dsn5)
    rm(lyr)
    rm(dsn5)

    ## test GeoJSON write, geom only, no SRS
    dsn6 <- tempfile(fileext = ".geojson")
    lyr <- ogr_ds_create("GeoJSON", dsn6, "box", geom_type = "POLYGON",
                         return_obj = TRUE)
    pts <-  matrix(c(0.25, 0.25, 0.75, 0.25, 0.75, 0.75, 0.25, 0.75,
                     0.25, 0.25), ncol = 2, byrow = TRUE)
    feat <- list()
    feat$geom <- g_create("POLYGON", pts)
    expect_true(lyr$createFeature(feat))
    lyr$open(read_only = TRUE)
    expect_equal(lyr$getFeatureCount(), 1)
    feat_chk <- lyr$getNextFeature()
    expect_true(g_equals(feat$geom, feat_chk$geom))

    lyr$close()
    unlink(dsn6)
    rm(lyr)
    rm(dsn6)
})

test_that("OGRFeatureFromList_dumpReadble runs without error", {
    # undocumented internal method GDALVector::OGRFeatureFromList_dumpReadble()
    skip_if(gdal_version_num() < gdal_compute_version(3, 8, 0))

    dsn <- tempfile(fileext = ".geojson")

    defn <- ogr_def_layer("Point", srs = epsg_to_wkt(4322))
    defn$real_field <- ogr_def_field("OFTReal")
    defn$str_field <- ogr_def_field("OFTString")

    lyr <- ogr_ds_create("GeoJSON", dsn, "test_layer",
                         layer_defn = defn,
                         lco = "WRITE_BBOX=YES",
                         overwrite = TRUE,
                         return_obj = TRUE)

    feat1 <- list()
    feat1$real_field <- 0.123
    feat1$str_field <- "test string 1"
    feat1$geom <- "POINT (1 10)"

    expect_no_error(lyr$OGRFeatureFromList_dumpReadble(feat1))

    lyr$close()
    unlink(dsn)
})

test_that("feature batch writing works", {
    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
    dsn <- file.path(tempdir(), basename(f))
    file.copy(f, dsn, overwrite = TRUE)

    sql <- "SELECT incid_name, burn_bnd_ac, ig_date, geom
            FROM mtbs_perims WHERE ig_year > 2010"
    lyr <- new(GDALVector, dsn, sql)

    # define new layer by modifying the source definition
    defn <- lyr$getLayerDefn()
    # define new attribute field
    defn$burn_bnd_ha <- ogr_def_field("OFTInteger64")
    # redefine geom field
    defn$geom <- ogr_def_geom_field("POINT", srs = defn$geom$srs)

    dst_dsn <- tempfile(fileext = ".gpkg")
    new_lyr <- ogr_ds_create("GPKG", dst_dsn, "mtbs_centroids",
                             layer_defn = defn, overwrite = TRUE,
                             return_obj = TRUE)

    d <- lyr$fetch(-1)
    # create a new data frame of point features
    d_new <- data.frame(d[, c("FID", "incid_name", "burn_bnd_ac", "ig_date")])
    # add new calculated attribute field
    d_new$burn_bnd_ha <- d_new$burn_bnd_ac / 2.471
    # add a geom field with the centroids
    perim_centroids <- g_centroid(d$geom)
    d_new$geom <- g_create("POINT", perim_centroids)

    # batch write
    expect_no_error(ret <- new_lyr$batchCreateFeature(d_new))
    expect_vector(ret, logical(), size = 15)
    expect_true(all(ret))

    # read back
    new_lyr$open(read_only = TRUE)
    expect_equal(new_lyr$getName(), "mtbs_centroids")
    d_new_out <- new_lyr$fetch(-1)
    expect_equal(nrow(d_new_out), 15)
    expect_equal(d_new_out$incid_name, d$incid_name)
    expect_equal(d_new_out$ig_date, d$ig_date)
    expect_equal(sum(d_new_out$burn_bnd_ha - (d$burn_bnd_ac / 2.471)), 0,
                 tolerance = 0.01)

    pt_coords <- g_coords(d_new_out$geom)
    expect_equal(cbind(pt_coords$x, pt_coords$y), perim_centroids,
                 ignore_attr = TRUE)

    lyr$close()
    unlink(dsn)
    new_lyr$close()
    unlink(dst_dsn)
})

test_that("get/set metadata works", {
    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
    dsn <- file.path(tempdir(), basename(f))
    file.copy(f, dsn, overwrite = TRUE)

    lyr <- new(GDALVector, dsn, "mtbs_perims", read_only = FALSE)

    expect_no_error(lyr$getMetadata())
    expect_equal(lyr$getMetadataItem(mdi_name = "DESCRIPTION"),
                 "MTBS fire perims 1984-2022 clipped to YNP bbox")

    # write metadata
    md <- c("TEST_ITEM_1=test 1 string", "TEST_ITEM_2=test 2 string")
    expect_true(lyr$setMetadata(md))

    # close and re-open
    lyr$open(read_only = TRUE)
    expect_equal(lyr$getMetadataItem(mdi_name = "TEST_ITEM_1"), "test 1 string")
    expect_equal(lyr$getMetadataItem(mdi_name = "TEST_ITEM_2"), "test 2 string")

    lyr$close()
    deleteDataset(dsn)
})

test_that("field domain specifications are returned correctly", {
    skip_if(gdal_version_num() < gdal_compute_version(3, 3, 0))

    f <- system.file("extdata/domains.gpkg", package="gdalraster")
    dsn <- file.path(tempdir(), basename(f))
    file.copy(f, dsn, overwrite = TRUE)

    lyr <- new(GDALVector, dsn)

    # integer range domain
    fld_dom <- lyr$getFieldDomain("range_domain_int")
    expect_true(!is.null(fld_dom))
    expect_equal(fld_dom$type, "Range")
    expect_equal(fld_dom$field_type, "OFTInteger")
    expect_equal(fld_dom$split_policy, "DEFAULT_VALUE")
    expect_equal(fld_dom$merge_policy, "DEFAULT_VALUE")
    expect_equal(fld_dom$min_value, 1)
    expect_true(fld_dom$min_is_inclusive)
    expect_equal(fld_dom$max_value, 2)
    expect_false(fld_dom$max_is_inclusive)
    rm(fld_dom)

    # integer64 range domain
    fld_dom <- lyr$getFieldDomain("range_domain_int64")
    expect_true(!is.null(fld_dom))
    expect_equal(fld_dom$type, "Range")
    expect_equal(fld_dom$field_type, "OFTInteger64")
    expect_equal(fld_dom$split_policy, "DEFAULT_VALUE")
    expect_equal(fld_dom$merge_policy, "DEFAULT_VALUE")
    expect_equal(fld_dom$min_value, as.integer64(-1234567890123))
    expect_false(fld_dom$min_is_inclusive)
    expect_equal(fld_dom$max_value, as.integer64(1234567890123))
    expect_true(fld_dom$max_is_inclusive)
    rm(fld_dom)

    # real range domain
    fld_dom <- lyr$getFieldDomain("range_domain_real")
    expect_true(!is.null(fld_dom))
    expect_equal(fld_dom$type, "Range")
    expect_equal(fld_dom$field_type, "OFTReal")
    expect_equal(fld_dom$split_policy, "DEFAULT_VALUE")
    expect_equal(fld_dom$merge_policy, "DEFAULT_VALUE")
    expect_equal(fld_dom$min_value, 1.5)
    expect_true(fld_dom$min_is_inclusive)
    expect_equal(fld_dom$max_value, 2.5)
    expect_true(fld_dom$max_is_inclusive)
    rm(fld_dom)

    # real range domain inf
    fld_dom <- lyr$getFieldDomain("range_domain_real_inf")
    expect_true(!is.null(fld_dom))
    expect_equal(fld_dom$type, "Range")
    expect_equal(fld_dom$field_type, "OFTReal")
    expect_equal(fld_dom$split_policy, "DEFAULT_VALUE")
    expect_equal(fld_dom$merge_policy, "DEFAULT_VALUE")
    expect_true(is.null(fld_dom$min_value))
    expect_true(is.null(fld_dom$max_value))
    rm(fld_dom)

    # coded values domain
    fld_dom <- lyr$getFieldDomain("enum_domain")
    expect_true(!is.null(fld_dom))
    expect_equal(fld_dom$type, "Coded")
    expect_equal(fld_dom$field_type, "OFTInteger")
    expect_equal(fld_dom$split_policy, "DEFAULT_VALUE")
    expect_equal(fld_dom$merge_policy, "DEFAULT_VALUE")
    expect_equal(fld_dom$coded_values$codes, c(1, 2))
    expect_equal(fld_dom$coded_values$values, c("one", NA))
    rm(fld_dom)

    # glob domain
    fld_dom <- lyr$getFieldDomain("glob_domain")
    expect_true(!is.null(fld_dom))
    expect_equal(fld_dom$type, "GLOB")
    expect_equal(fld_dom$field_type, "OFTString")
    expect_equal(fld_dom$split_policy, "DEFAULT_VALUE")
    expect_equal(fld_dom$merge_policy, "DEFAULT_VALUE")
    expect_equal(fld_dom$glob, "*")
    rm(fld_dom)

    lyr$close()
    deleteDataset(dsn)


    # get a list of field domain names defined in a dataset
    # GDALDatasetGetFieldDomainNames() was added at GDAL >= 3.5
    skip_if(gdal_version_num() < gdal_compute_version(3, 5, 0))

    f <- system.file("extdata/domains.gpkg", package="gdalraster")
    dsn <- file.path(tempdir(), basename(f))
    file.copy(f, dsn, overwrite = TRUE)

    fld_dom_names <- ogr_ds_field_domain_names(dsn)
    expected_names <- c("enum_domain", "glob_domain", "range_domain_int",
                        "range_domain_int64", "range_domain_real",
                        "range_domain_real_inf")
    expect_equal(fld_dom_names, expected_names)
    deleteDataset(dsn)

    # format supports field domains but none are present
    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
    dsn <- file.path(tempdir(), basename(f))
    file.copy(f, dsn, overwrite = TRUE)
    expect_equal(ogr_ds_field_domain_names(dsn), character(0))
    deleteDataset(dsn)

    # format does not support field domains
    f <- system.file("extdata/poly_multipoly.shp", package="gdalraster")
    expect_warning(fld_dom_names <- ogr_ds_field_domain_names(f))
    expect_true(is.null(fld_dom_names))


    # OpenFileGDB with DateTime range domain
    # support for DateTime field domains in OpenFileGDB was added at GDAL 3.8.0
    skip_if(gdal_version_num() < gdal_compute_version(3, 8, 0))

    f <- system.file("extdata/domains.gdb.zip", package="gdalraster")
    lyr <- new(GDALVector, f, "test")

    fld_dom <- lyr$getFieldDomain("datetime_range")
    expect_true(!is.null(fld_dom))
    expect_equal(fld_dom$description, "datetime_range_desc")
    expect_equal(fld_dom$type, "RangeDateTime")
    expect_equal(fld_dom$field_type, "OFTDateTime")
    expect_equal(fld_dom$split_policy, "DEFAULT_VALUE")
    expect_equal(fld_dom$merge_policy, "DEFAULT_VALUE")
    expect_equal(fld_dom$min_value, as.POSIXct("2000-01-01T00:00:00",
                                               tz = "UTC"))
    expect_true(fld_dom$min_is_inclusive)
    expect_equal(fld_dom$max_value, as.POSIXct("2100-01-01T00:00:00",
                                               tz = "UTC"))
    expect_true(fld_dom$max_is_inclusive)

    lyr$close()
})

test_that("field domain write functions work", {
    skip_if(gdal_version_num() < gdal_compute_version(3, 3, 0))

    ## test Range, Coded and GLOB with GPKG
    f <- system.file("extdata/domains.gpkg", package="gdalraster")
    dsn <- file.path(tempdir(), basename(f))
    file.copy(f, dsn, overwrite = TRUE)


    # Range field domain for OFTInteger
    defn <- ogr_def_field_domain("Range", "range1", "range domain test 1",
                                 fld_type = "OFTInteger", range_min = 0,
                                 range_max = 100)
    expect_true(is.list(defn))
    expect_true(ogr_ds_add_field_domain(dsn, defn))

    # add a field using the "range1" domain
    field1_defn <- ogr_def_field("OFTInteger", domain_name = "range1")
    expect_true(ogr_field_create(dsn, "test", "range_field1",
                                 fld_defn = field1_defn))

    # Range field domain for OFTInteger64
    defn <- ogr_def_field_domain("Range", "range2", "range domain test 2",
                                 fld_type = "OFTInteger64", range_min = 0,
                                 range_max = as.integer64("9007199254740992"),
                                 max_is_inclusive = FALSE)
    expect_true(ogr_ds_add_field_domain(dsn, defn))

    # add a field using the "range2" domain
    field2_defn <- ogr_def_field("OFTInteger64", domain_name = "range2")
    expect_true(ogr_field_create(dsn, "test", "range_field2",
                                 fld_defn = field2_defn))

    # Range field domain for Real
    defn <- ogr_def_field_domain("Range", "range3", "range domain test 3",
                                 fld_type = "OFTReal", range_min = 0.0,
                                 min_is_inclusive = FALSE,
                                 range_max = 1.0)
    expect_true(ogr_ds_add_field_domain(dsn, defn))

    # Range field domain for Real (inf)
    defn <- ogr_def_field_domain("Range", "range4", "range domain test 4",
                                 fld_type = "OFTReal")
    expect_true(ogr_ds_add_field_domain(dsn, defn))


    # Range domain input errors
    # min/max must be a single numeric value if not NULL
    expect_error(ogr_def_field_domain("Range", "range_err", "desc: error",
                                      fld_type = "OFTInteger",
                                      range_min = "A",
                                      range_max = 100))
    expect_error(ogr_def_field_domain("Range", "range_err", "desc: error",
                                      fld_type = "OFTInteger",
                                      range_min = 0,
                                      range_max = "Z"))
    expect_error(ogr_def_field_domain("Range", "range_err", "desc: error",
                                      fld_type = "OFTInteger",
                                      range_min = c(0, 1),
                                      range_max = 100))
    expect_error(ogr_def_field_domain("Range", "range_err", "desc: error",
                                      fld_type = "OFTInteger",
                                      range_min = 0,
                                      range_max = c(0, 100)))
    # min/max as NA is okay, treated the same as NULL
    expect_no_error(ogr_def_field_domain("Range", "range_no_err",
                                         description = "desc: no error",
                                         fld_type = "OFTInteger",
                                         range_min = NA,
                                         range_max = 100))
    expect_no_error(ogr_def_field_domain("Range", "range_no_err",
                                         description = "desc: no error",
                                         fld_type = "OFTInteger",
                                         range_min = 0,
                                         range_max = NA))
    # min_is_inclusive/max_is_inclusive must be a single logical value
    expect_error(ogr_def_field_domain("Range", "range_err", "desc: error",
                                      fld_type = "OFTInteger",
                                      range_min = 0,
                                      min_is_inclusive = NULL,
                                      range_max = 100))
    expect_error(ogr_def_field_domain("Range", "range_err", "desc: error",
                                      fld_type = "OFTInteger",
                                      range_min = 0,
                                      range_max = 100,
                                      max_is_inclusive = NULL))

    # test the internal C++ function .ogr_ds_add_field_domain(),
    # which should also handle the above input errors.
    # construct a valid field domain definition and then alter it for each
    # invalid input.
    expect_no_error(defn <- ogr_def_field_domain("Range", "range_err",
                                                 fld_type = "OFTInteger",
                                                 range_min = NULL,
                                                 range_max = NULL))

    # min/max must be a single numeric value if not NULL
    defn$min_value <- "A"
    expect_error(.ogr_ds_add_field_domain(dsn, defn))

    defn$min_value <- 0
    defn$max_value <- "Z"
    expect_error(.ogr_ds_add_field_domain(dsn, defn))

    defn$min_value <- c(0, 1)
    defn$max_value <- 100
    expect_error(.ogr_ds_add_field_domain(dsn, defn))

    defn$min_value <- 0
    defn$max_value <- c(0, 100)
    expect_error(.ogr_ds_add_field_domain(dsn, defn))

    # min/max as NA is okay, treated the same as NULL
    defn$min_value <- NA
    defn$max_value <- 100
    expect_no_error(.ogr_ds_add_field_domain(dsn, defn))

    # same with OFTInteger64
    expect_no_error(defn <- ogr_def_field_domain("Range", "range_err_int64",
                                                 fld_type = "OFTInteger64",
                                                 range_min = NULL,
                                                 range_max = NULL))

    # min/max must be a single numeric value if not NULL
    defn$min_value <- "A"
    expect_error(.ogr_ds_add_field_domain(dsn, defn))

    defn$min_value <- bit64::as.integer64(0)
    defn$max_value <- "Z"
    expect_error(.ogr_ds_add_field_domain(dsn, defn))

    # min/max as NA is okay, treated the same as NULL
    defn$min_value <- NA_integer64_
    defn$max_value <- 100
    expect_no_error(.ogr_ds_add_field_domain(dsn, defn))


    # Coded values domain
    defn <- ogr_def_field_domain("Coded", "coded1", "coded values domain test",
                                 fld_type = "OFTInteger",
                                 coded_values = c("1=one", "2=two", "3"))
    expect_true(ogr_ds_add_field_domain(dsn, defn))

    # add a field using the "coded1" domain
    expect_true(ogr_field_create(dsn, "test", "coded_field1",
                                 fld_type = "OFTInteger", default_value = 1,
                                 domain_name = "coded1"))

    # Coded values domain, input as data frame
    codes <- c(1, 2, 3)
    values <- c("one", "two", NA)
    codes_values_df <- data.frame(codes = codes, values = values)
    defn <- ogr_def_field_domain("Coded", "coded2",
                                 description = "coded values domain test 2",
                                 fld_type = "OFTInteger",
                                 coded_values = codes_values_df)
    expect_true(ogr_ds_add_field_domain(dsn, defn))

    # add a field using the "coded2" domain
    expect_true(ogr_field_create(dsn, "test", "coded_field2",
                                 fld_type = "OFTInteger",
                                 domain_name = "coded2"))

    # Coded values domain, input as data frame with integer64 codes
    codes <- bit64::as.integer64(c(1, 2, "9007199254740992"))
    values <- c("one", "two", "large value")
    codes_values_df <- data.frame(codes = codes, values = values)
    defn <- ogr_def_field_domain("Coded", "coded3",
                                 description = "coded values domain test 3",
                                 fld_type = "OFTInteger64",
                                 coded_values = codes_values_df)
    expect_true(ogr_ds_add_field_domain(dsn, defn))

    # add a field using the "coded3" domain
    expect_true(ogr_field_create(dsn, "test", "coded_field3",
                                 fld_type = "OFTInteger64",
                                 domain_name = "coded3"))


    # Coded values input errors
    # cannot have NA codes (values can be NA)
    codes <- c(1, 2, NA)
    values <- c("one", "two", NA)
    expect_error(ogr_def_field_domain("Coded", "coded_err",
                                      fld_type = "OFTInteger",
                                      coded_values = codes))

    codes_values_df <- data.frame(codes = codes, values = values)
    expect_error(ogr_def_field_domain("Coded", "coded_err",
                                      fld_type = "OFTInteger",
                                      coded_values = codes_values_df))
    # cannot be empty
    expect_error(ogr_def_field_domain("Coded", "coded_err",
                                      fld_type = "OFTInteger",
                                      coded_values = character(0)))

    codes_values_df <- data.frame(codes = character(0), values = character(0))
    expect_error(ogr_def_field_domain("Coded", "coded_err",
                                      fld_type = "OFTInteger",
                                      coded_values = codes_values_df))
    # data frame input must have two columns
    codes <- c(1, 2, 3)
    values <- c("one", "two", "")

    codes_values_df <- data.frame(codes = codes)
    expect_error(ogr_def_field_domain("Coded", "coded_err",
                                      fld_type = "OFTInteger",
                                      coded_values = codes_values_df))

    codes_values_df <- data.frame(codes = codes, values = values,
                                  v3 = c(1, 1, 1))
    expect_error(ogr_def_field_domain("Coded", "coded_err",
                                      fld_type = "OFTInteger",
                                      coded_values = codes_values_df))

    # test the internal C++ function .ogr_ds_add_field_domain(),
    # which should also handle the above input errors.
    # construct a valid field domain definition and then alter it for each
    # invalid input.
    # cannot have NA codes
    codes <- c(1, 2, 3)
    values <- c("one", "two", "three")

    expect_no_error(defn <- ogr_def_field_domain("Coded", "coded_err",
                                                 fld_type = "OFTInteger",
                                                 coded_values = codes))

    defn$coded_values <- c(1, 2, NA)
    expect_error(.ogr_ds_add_field_domain(dsn, defn))

    defn$coded_values <- data.frame(codes = c(1, 2, NA), values = values)
    expect_error(.ogr_ds_add_field_domain(dsn, defn))

    # cannot be empty
    defn$coded_values <- character(0)
    expect_error(.ogr_ds_add_field_domain(dsn, defn))

    defn$coded_values <- data.frame(codes = character(0), values = character(0))
    expect_error(.ogr_ds_add_field_domain(dsn, defn))

    # data frame input must have two columns
    defn$coded_values <- data.frame(codes = codes)
    expect_error(.ogr_ds_add_field_domain(dsn, defn))

    defn$coded_values <- data.frame(codes = codes, values = values,
                                    v3 = c(1, 1, 1))
    expect_error(.ogr_ds_add_field_domain(dsn, defn))


    # GLOB domain
    defn <- ogr_def_field_domain("GLOB", "glob1", "glob domain test",
                                 fld_type = "OFTString", glob = "*")
    expect_true(ogr_ds_add_field_domain(dsn, defn))

    # GLOB input errors
    expect_error(ogr_def_field_domain("GLOB", "glob_err", "desc: error",
                                      fld_type = "OFTString", glob = NULL))
    expect_error(ogr_def_field_domain("GLOB", "glob1", "glob domain test",
                                      fld_type = "OFTString", glob = NA))
    expect_error(ogr_def_field_domain("GLOB", "glob1", "glob domain test",
                                      fld_type = "OFTString", glob = ""))
    expect_error(ogr_def_field_domain("GLOB", "glob1", "glob domain test",
                                      fld_type = "OFTString",
                                      glob = c("*", "?")))
    # test the internal C++ function .ogr_ds_add_field_domain(),
    # which should also handle the above input errors.
    # construct a valid field domain definition and then alter it for each
    # invalid input.
    expect_no_error(defn <- ogr_def_field_domain("GLOB", "glob_err",
                                                 fld_type = "OFTString",
                                                 glob = "*"))

    defn$field_type <- "OFTInteger"
    expect_error(.ogr_ds_add_field_domain(dsn, defn))

    defn$field_type <- "OFTString"
    defn$glob <- list(NULL)
    expect_error(.ogr_ds_add_field_domain(dsn, defn))

    defn$glob <- 1.0
    expect_error(.ogr_ds_add_field_domain(dsn, defn))


    # test setting a domain name on an existing field
    ogr_field_create(dsn, "test", "range_field3", fld_type = "OFTReal")
    expect_true(ogr_field_set_domain_name(dsn, "test",
                                          fld_name = "range_field3",
                                          domain_name = "range3"))


    # read back
    lyr <- new(GDALVector, dsn, "test")

    # range1 read back
    fld_dom <- lyr$getFieldDomain("range1")
    expect_true(!is.null(fld_dom))
    expect_equal(fld_dom$type, "Range")
    expect_equal(fld_dom$description, "range domain test 1")
    expect_equal(fld_dom$field_type, "OFTInteger")
    expect_equal(fld_dom$min_value, 0)
    expect_true(fld_dom$min_is_inclusive)
    expect_equal(fld_dom$max_value, 100)
    expect_true(fld_dom$max_is_inclusive)
    rm(fld_dom)

    lyr_defn <- lyr$getLayerDefn()
    expect_equal(lyr_defn$range_field1$domain, "range1")

    # range2 read back
    fld_dom <- lyr$getFieldDomain("range2")
    expect_true(!is.null(fld_dom))
    expect_equal(fld_dom$type, "Range")
    expect_equal(fld_dom$description, "range domain test 2")
    expect_equal(fld_dom$field_type, "OFTInteger64")
    expect_equal(fld_dom$min_value, as.integer64(0))
    expect_true(fld_dom$min_is_inclusive)
    expect_equal(fld_dom$max_value, as.integer64("9007199254740992"))
    expect_false(fld_dom$max_is_inclusive)
    rm(fld_dom)

    expect_equal(lyr_defn$range_field2$domain, "range2")

    # range3 read back
    fld_dom <- lyr$getFieldDomain("range3")
    expect_true(!is.null(fld_dom))
    expect_equal(fld_dom$type, "Range")
    expect_equal(fld_dom$description, "range domain test 3")
    expect_equal(fld_dom$field_type, "OFTReal")
    expect_equal(fld_dom$min_value, 0.0)
    expect_false(fld_dom$min_is_inclusive)
    expect_equal(fld_dom$max_value, 1.0)
    expect_true(fld_dom$max_is_inclusive)
    rm(fld_dom)

    # range4 read back
    fld_dom <- lyr$getFieldDomain("range4")
    expect_true(!is.null(fld_dom))
    expect_equal(fld_dom$type, "Range")
    expect_equal(fld_dom$description, "range domain test 4")
    expect_equal(fld_dom$field_type, "OFTReal")
    expect_true(is.null(fld_dom$min_value))
    expect_true(is.null(fld_dom$max_value))
    rm(fld_dom)

    # coded1 read back
    fld_dom <- lyr$getFieldDomain("coded1")
    expect_true(!is.null(fld_dom))
    expect_equal(fld_dom$type, "Coded")
    expect_equal(fld_dom$description, "coded values domain test")
    expect_equal(fld_dom$field_type, "OFTInteger")
    expect_equal(fld_dom$coded_values$codes, c(1, 2, 3))
    expect_equal(fld_dom$coded_values$values, c("one", "two", NA))
    rm(fld_dom)

    expect_equal(lyr_defn$coded_field1$domain, "coded1")

    # coded2 read back
    fld_dom <- lyr$getFieldDomain("coded2")
    expect_equal(fld_dom$coded_values$codes, c(1, 2, 3))
    expect_equal(fld_dom$coded_values$values, c("one", "two", NA))
    rm(fld_dom)

    expect_equal(lyr_defn$coded_field2$domain, "coded2")

    # coded3 read back
    fld_dom <- lyr$getFieldDomain("coded3")
    expect_equal(fld_dom$coded_values$codes,
                 bit64::as.integer64(c(1, 2, "9007199254740992")))
    expect_equal(fld_dom$coded_values$values, c("one", "two", "large value"))
    rm(fld_dom)

    expect_equal(lyr_defn$coded_field3$domain, "coded3")

    # glob1 read back
    fld_dom <- lyr$getFieldDomain("glob1")
    expect_true(!is.null(fld_dom))
    expect_equal(fld_dom$type, "GLOB")
    expect_equal(fld_dom$description, "glob domain test")
    expect_equal(fld_dom$field_type, "OFTString")
    expect_equal(fld_dom$glob, "*")
    rm(fld_dom)

    # domain name was set on existing field with ogr_field_set_domain_name()
    expect_equal(lyr_defn$range_field3$domain, "range3")

    lyr$close()
    deleteDataset(dsn)


    # test RangeDateTime with ESRI File Geodatabase
    # support for DateTime field domains in OpenFileGDB was added at GDAL 3.8.0
    skip_if(gdal_version_num() < gdal_compute_version(3, 8, 0))

    # create a test dataset
    dsn <- file.path(tempdir(), "domains.gdb")
    ogr_ds_create("OpenFileGDB", dsn, overwrite = TRUE)
    ogr_layer_create(dsn, layer = "test", geom_type = "POINT",
                     srs = "WGS84")
    ogr_field_create(dsn, "test", "dt_fld1", fld_type = "OFTDateTime")

    # create and add a field domain
    defn <- ogr_def_field_domain("RangeDateTime", "dt_range1",
                                 description = "rangedatetime domain test 1",
                                 fld_type = "OFTDateTime",
                                 range_min = as.POSIXct("2000-01-01T00:00:00",
                                                        tz = "UTC"),
                                 range_max = as.POSIXct("2100-01-01T00:00:00",
                                                        tz = "UTC"))

    expect_true(ogr_ds_add_field_domain(dsn, defn))

    expect_true(ogr_field_set_domain_name(dsn, "test",
                                          fld_name = "dt_fld1",
                                          domain_name = "dt_range1"))

    # read back
    lyr <- new(GDALVector, dsn, "test")

    fld_dom <- lyr$getFieldDomain("dt_range1")
    expect_true(!is.null(fld_dom))
    expect_equal(fld_dom$description, "rangedatetime domain test 1")
    expect_equal(fld_dom$type, "RangeDateTime")
    expect_equal(fld_dom$field_type, "OFTDateTime")
    expect_equal(fld_dom$min_value, as.POSIXct("2000-01-01T00:00:00",
                                               tz = "UTC"))
    expect_true(fld_dom$min_is_inclusive)
    expect_equal(fld_dom$max_value, as.POSIXct("2100-01-01T00:00:00",
                                               tz = "UTC"))
    expect_true(fld_dom$max_is_inclusive)
    rm(fld_dom)

    lyr$close()
    vsi_rmdir(dsn, recursive = TRUE)
})

test_that("delete field domain works", {
    skip_if(gdal_version_num() < gdal_compute_version(3, 5, 0))

    f <- system.file("extdata/domains.gpkg", package="gdalraster")
    dsn <- file.path(tempdir(), basename(f))
    file.copy(f, dsn, overwrite = TRUE)
    on.exit(unlink(dsn), add = TRUE)

    # delete field domains supported for GPKG as of GDAL 3.12
    if (gdal_version_num() < gdal_compute_version(3, 12, 0)) {
        expect_false(ogr_ds_test_cap(dsn)$DeleteFieldDomain)
        expect_false(ogr_ds_delete_field_domain(dsn, "glob_domain"))
    } else {
        expect_true(ogr_ds_test_cap(dsn)$DeleteFieldDomain)
        expect_true(ogr_ds_delete_field_domain(dsn, "glob_domain"))
    }

    # TODO: test on OpenFileGDB
})

test_that("info() prints output to the console", {
    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
    dsn <- file.path(tempdir(), basename(f))
    file.copy(f, dsn)

    lyr <- new(GDALVector, dsn, "mtbs_perims")
    if (gdal_version_num() >= gdal_compute_version(3, 7, 0))
        expect_output(lyr$info())
    else
        expect_no_error(lyr$info())
    lyr$close()

    lyr <- new(GDALVector, dsn, "SELECT * FROM mtbs_perims LIMIT 10")
    if (gdal_version_num() >= 3070000) {
        expect_output(lyr$info(), "Feature Count: 10")
    } else {
        # we only get the fallback minimal info
        expect_no_error(lyr$info())
    }
    lyr$close()

    # default layer first by index
    lyr <- new(GDALVector, dsn)
    if (gdal_version_num() >= 3070000) {
        expect_output(lyr$info(), "Feature Count: 61")
    } else {
        # we only get the fallback minimal info
        expect_no_error(lyr$info())
    }
    lyr$close()

    unlink(dsn)

    skip_if_not(gdal_version_num() >= 3070000)

    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
    dsn <- file.path(tempdir(), basename(f))
    file.copy(f, dsn)

    lyr <- new(GDALVector, dsn, "mtbs_perims")
    lyr$setAttributeFilter("ig_year = 2020")
    expect_output(lyr$info(), "Feature Count: 1")
    lyr$setAttributeFilter("")
    expect_output(lyr$info(), "Feature Count: 61")

    lyr$resetReading()
    lyr$setAttributeFilter("ig_year = 1988 ORDER BY burn_bnd_ac DESC")
    feat <- lyr$getNextFeature()
    bbox <- g_wk2wk(feat$geom) |> bbox_from_wkt()
    lyr$setAttributeFilter("")
    lyr$setSpatialFilterRect(bbox)
    expect_output(lyr$info(), "Feature Count: 40")

    lyr$close()
    unlink(dsn)

    skip_if_not(has_spatialite())

    dsn <- system.file("extdata/poly_multipoly.shp", package="gdalraster")
    sql <- "SELECT 1 As ID, ST_Union(geometry) As geom FROM poly_multipoly GROUP BY ID"
    lyr <- new(GDALVector, dsn, sql, TRUE, NULL, "", "SQLite")
    expect_output(lyr$info(), "Feature Count: 1")
    lyr$close()
})

test_that("ArrowArrayStream is readable", {
    skip_if(gdal_version_num() < 3060000)

    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
    dsn <- file.path(tempfile(fileext = ".tif"))
    file.copy(f, dsn, overwrite = TRUE)
    on.exit(deleteDataset(dsn))

    lyr <- new(GDALVector, dsn, "mtbs_perims")

    expect_no_error(stream <- lyr$getArrowStream())
    expect_s3_class(stream, "nanoarrow_array_stream")

    schema <- stream$get_schema()
    expect_s3_class(schema, "nanoarrow_schema")
    expect_equal(length(schema$children), 11)

    batch <- stream$get_next()
    expect_s3_class(batch, "nanoarrow_array")
    expect_equal(batch$children$fid$length, 61)

    expect_no_error(stream$release())

    # with options
    lyr$arrowStreamOptions <- "INCLUDE_FID=NO"
    expect_no_error(stream2 <- lyr$getArrowStream())

    schema2 <- stream2$get_schema()
    expect_equal(length(schema2$children), 10)
    expect_true(is.null(schema2$children$fid))
    expect_no_error(stream2$release())

    lyr$close()
})

test_that("nanoarrow_array_stream implicit release works", {
    skip_if(gdal_version_num() < 3060000)

    # dataset/layer closed without explicit release
    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
    dsn <- file.path(tempfile(fileext = ".gpkg"))
    file.copy(f, dsn, overwrite = TRUE)

    lyr <- new(GDALVector, dsn, "mtbs_perims")

    lyr$open(read_only = TRUE)
    expect_no_error(stream3 <- lyr$getArrowStream())
    expect_s3_class(stream3, "nanoarrow_array_stream")
    lyr$close()
    expect_error(stream3$get_next())

    unlink(dsn)

    # stream garbage collected without explicit release
    dsn2 <- file.path(tempfile(fileext = ".gpkg"))
    file.copy(f, dsn2, overwrite = TRUE)

    lyr2 <- new(GDALVector, dsn2, "mtbs_perims")
    expect_no_error(stream4 <- lyr2$getArrowStream())
    expect_s3_class(stream4, "nanoarrow_array_stream")
    rm(stream4)
    gc()
    # released implicitly so a new stream should be available
    expect_no_error(stream5 <- lyr2$getArrowStream())
    expect_s3_class(stream5, "nanoarrow_array_stream")

    lyr2$close()
    unlink(dsn2)
})

test_that("srs functions work", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    ds <- new(GDALRaster, elev_file, read_only=TRUE)
    srs <- ds$getProjectionRef()
    ds$close()

    expect_false(srs_is_geographic(srs))
    expect_true(srs_is_projected(srs))
    # EPSG:26912 - NAD83 / UTM zone 12N
    utm <- epsg_to_wkt(26912)
    expect_true(srs_is_same(srs, utm))

    expect_true(srs_is_same(srs_to_wkt("EPSG:4326"),
                            srs_to_wkt("OGC:CRS84")))

    expect_true(srs_is_same(srs_to_wkt("EPSG:4326"),
                            srs_to_wkt("OGC:CRS84"),
                            ignore_axis_mapping=TRUE))

    expect_true(srs_is_same(srs_to_wkt("EPSG:4326"),
                            srs_to_wkt("OGC:CRS84"),
                            ignore_coord_epoch=TRUE))

    expect_false(srs_is_same(srs_to_wkt("EPSG:4326"),
                             srs_to_wkt("OGC:CRS84"),
                             ignore_axis_mapping=TRUE,
                             criterion="STRICT"))

    expect_equal(srs_to_wkt("NAD83"), epsg_to_wkt(4269))
    expect_equal(srs_to_wkt("NAD83", pretty=TRUE),
                 epsg_to_wkt(4269, pretty=TRUE))
    expect_true(srs_to_wkt("EPSG:5070", gcs_only = TRUE) |> srs_is_geographic())

    expect_true(srs_to_projjson("WGS84") != "")
    expect_true(srs_to_projjson("WGS84", multiline = FALSE) != "")
    expect_true(srs_to_projjson("WGS84", indent_width = 4) != "")
    expect_true(srs_to_projjson("WGS84", schema = "") != "")

    expect_equal(srs_find_epsg("WGS84"), "EPSG:4326")
    df_matches <- srs_find_epsg("WGS84", all_matches = TRUE)
    expect_true(is.data.frame(df_matches))

    expect_true(nzchar(srs_get_name("EPSG:5070")))

    wkt <- 'GEOGCRS["Coordinate System imported from GRIB file",BASEGEOGCRS["Coordinate System imported from GRIB file",DATUM["unnamed",ELLIPSOID["Sphere",6367470,0,LENGTHUNIT["metre",1,ID["EPSG",9001]]]],PRIMEM["Greenwich",0,ANGLEUNIT["degree",0.0174532925199433,ID["EPSG",9122]]]],DERIVINGCONVERSION["Pole rotation (GRIB convention)",METHOD["Pole rotation (GRIB convention)"],PARAMETER["Latitude of the southern pole (GRIB convention)",-30,ANGLEUNIT["degree",0.0174532925199433,ID["EPSG",9122]]],PARAMETER["Longitude of the southern pole (GRIB convention)",-15,ANGLEUNIT["degree",0.0174532925199433,ID["EPSG",9122]]],PARAMETER["Axis rotation (GRIB convention)",0,ANGLEUNIT["degree",0.0174532925199433,ID["EPSG",9122]]]],CS[ellipsoidal,2],AXIS["latitude",north,ORDER[1],ANGLEUNIT["degree",0.0174532925199433,ID["EPSG",9122]]],AXIS["longitude",east,ORDER[2],ANGLEUNIT["degree",0.0174532925199433,ID["EPSG",9122]]]]'
    expect_true(srs_is_derived_gcs(wkt))
    expect_false(srs_is_compound(wkt))

    wkt <- 'COMPD_CS["COMPD_CS_name",LOCAL_CS["None",LOCAL_DATUM["None",32767],UNIT["Foot_US",0.304800609601219],AXIS["None",OTHER]],VERT_CS["VERT_CS_Name",VERT_DATUM["Local",2005],UNIT["Meter",1,AUTHORITY["EPSG","9001"]],AXIS["Gravity-related height",UP]]]'
    expect_true(srs_is_compound(wkt))

    expect_true(srs_is_geocentric("EPSG:7789"))

    expect_true(srs_is_vertical("EPSG:5705"))

    angular <- srs_get_angular_units("EPSG:4326")
    expect_equal(tolower(angular$unit_name), "degree")
    expect_true(is.numeric(angular$to_radians))

    linear <- srs_get_linear_units("EPSG:5070")
    expect_equal(tolower(linear$unit_name), "metre")
    expect_equal(linear$to_meters, 1.0)

    expect_equal(srs_get_utm_zone("EPSG:26912"), 12)
    expect_equal(srs_get_utm_zone("EPSG:32701"), -1)

    expect_equal(srs_get_axis_mapping_strategy("WGS84"),
                 "OAMS_AUTHORITY_COMPLIANT")

    aou <- srs_get_area_of_use("EPSG:3976")
    expect_true(is.list(aou))
    expect_equal(length(aou), 5)
    expect_true(is.character(aou$AreaName))
    expect_equal(aou$WestLongitudeDeg, -180)
    expect_equal(aou$SouthLatitudeDeg, -90)
    expect_equal(aou$EastLongitudeDeg, 180)
    expect_equal(aou$NorthLatitudeDeg, -60)

    expect_equal(srs_get_axes_count("EPSG:4326"), 2)
    expect_equal(srs_get_axes_count("EPSG:4979"), 3)

    ax <- srs_get_axes("EPSG:4326", "GEOGCS")
    expect_equal(names(ax), c("Geodetic_latitude", "Geodetic_longitude"))
    expect_equal(ax[[1]], "north")
    expect_equal(ax[[2]], "east")

    ax <- srs_get_axes("EPSG:4326+5773")
    expect_equal(names(ax), c("Geodetic_latitude", "Geodetic_longitude",
                              "Gravity-related_height"))
    expect_equal(ax[[1]], "north")
    expect_equal(ax[[2]], "east")
    expect_equal(ax[[3]], "up")

    expect_true(srs_epsg_treats_as_lat_long("WGS84"))

    # NAD83 / Conus Albers:
    expect_false(srs_epsg_treats_as_northing_easting("EPSG:5070"))
    # WGS 84 / UPS North (N,E):
    expect_true(srs_epsg_treats_as_northing_easting("EPSG:32661"))

    epsg <- srs_info_from_db("EPSG")
    expect_true(is.data.frame(epsg))
    expect_true(nrow(epsg) > 1000)
    # if none found, should return a 0-row data frame
    df <- srs_info_from_db("_invalid_")
    expect_true(is.data.frame(df))
    expect_equal(nrow(df), 0)

    # errors
    expect_error(epsg_to_wkt(-1))
    expect_equal(srs_to_wkt(""), "")
    expect_error(srs_to_wkt("invalid"))
    expect_error(srs_is_geographic("invalid"))
    expect_error(srs_is_derived_gcs("invalid"))
    expect_error(srs_is_projected("invalid"))
    expect_error(srs_is_compound("invalid"))
    expect_error(srs_is_geocentric("invalid"))
    expect_error(srs_is_vertical("invalid"))
    expect_error(srs_is_same("invalid", "invalid"))
    expect_error(srs_is_same(srs, "invalid"))
    expect_true(is.null(srs_get_angular_units("")))
    expect_true(is.null(srs_get_linear_units("")))
    expect_error(srs_get_angular_units("invalid"))
    expect_error(srs_get_linear_units("invalid"))
    expect_error(srs_get_utm_zone("invalid"))
    expect_error(srs_get_axis_mapping_strategy("invalid"))
    expect_error(srs_get_area_of_use("invalid"))
    expect_true(is.null(srs_get_area_of_use("")))
    expect_error(srs_get_axes_count("invalid"))
    expect_true(is.na(srs_get_axes_count("")))
    expect_error(srs_get_axes("invalid"))
    expect_error(srs_get_axes("EPSG:4326", "invalid"))
    expect_true(is.null(srs_get_axes("")))
    expect_false(srs_epsg_treats_as_lat_long(""))
    expect_error(srs_epsg_treats_as_lat_long("invalid"))
    expect_false(srs_epsg_treats_as_northing_easting(""))
    expect_error(srs_epsg_treats_as_northing_easting("invalid"))

    # dynamic srs GDAL >= 3.4
    skip_if(gdal_version_num() < gdal_compute_version(3, 4, 0))

    expect_true(srs_is_dynamic("EPSG:4326"))
    expect_false(srs_is_dynamic("EPSG:4171"))
    expect_error(srs_is_dynamic("invalid"))
    expect_equal(srs_get_coord_epoch("WGS84"), 0.0)
    expect_error(srs_get_coord_epoch("invalid"))

    # celestial body name GDAL >= 3.12, PROJ >= 8.1
    skip_if(gdal_version_num() < gdal_compute_version(3, 12, 0))
    pv <- proj_version()
    skip_if(pv$major < 8 || (pv$major == 8 && pv$minor < 1))
    expect_equal(srs_get_celestial_body_name("EPSG:4326"), "Earth")
    expect_error(srs_get_celestial_body_name("invalid"))
    expect_equal(srs_get_celestial_body_name(""), "")
})

skip_if(gdal_version_num() < gdal_compute_version(3, 2, 0))
skip_if(nrow(gdal_formats("netCDF")) == 0 ||
            isFALSE(gdal_formats("netCDF")$multidim_raster))

test_that("mdim_as_classic works", {
    f <- system.file("extdata/byte.nc", package="gdalraster")

    ds <- mdim_as_classic(f, "Band1", 1, 0)
    expect_false(is.null(ds))
    expect_equal(ds$dim(), c(20, 20, 1))
    expect_equal(ds$getGeoTransform(),
                 c(440720.0, 60.0, 0.0, 3750120.0, 0.0, 60.0))

    # matches checksum from GDAL autotest:
    #   autotest/gdrivers/data/vrt/arraysource_array.vrt on byte.nc
    #   https://github.com/OSGeo/gdal/blob/a8f0531cc90bc1fb554da9f6a94d059dbb995f81/autotest/gdrivers/vrtmultidim.py#L1417
    #       ds = gdal.Open("data/vrt/arraysource_array.vrt")
    #       assert ds.GetRasterBand(1).Checksum() == 4855
    # and Python:
    #   from osgeo import gdal
    #   f = 'byte.nc'
    #   ds = gdal.OpenEx(f, gdal.OF_MULTIDIM_RASTER)
    #   rg = ds.GetRootGroup()
    #   ar = rg.OpenMDArray("Band1")
    #   classic_ds = ar.AsClassicDataset(1, 0)
    #   classic_ds.GetRasterBand(1).Checksum()
    #   # 4855
    expect_equal(ds$getChecksum(1, 0, 0, 20, 20), 4855)

    ds$close()
    # filename is not set / driver-less dataset:
    expect_error(ds$open(read_only = TRUE))

    # view expressions
    f2 <- tempfile(fileext = ".nc")
    on.exit(unlink(f2), add = TRUE)
    file.copy(f, f2, overwrite = TRUE)

    ds <- mdim_as_classic(f2, "Band1", 1, 0, read_only = FALSE,
                          view_expr = "[0:10,...]")

    # https://github.com/OSGeo/gdal/blob/2b1c4d1fdb9377b62d821d70d022e7426940aec6/autotest/gdrivers/netcdf_multidim.py#L4036
    expect_equal(ds$getStatistics(1, FALSE, TRUE),
                 c(74.0, 255.0, 126.82, 26.729713803182),
                 tolerance = 0.01)

    ds$close()

    ds <- mdim_as_classic(f2, "Band1", 1, 0, read_only = FALSE,
                          view_expr = "[10:20,...]")

    # https://github.com/OSGeo/gdal/blob/2b1c4d1fdb9377b62d821d70d022e7426940aec6/autotest/gdrivers/netcdf_multidim.py#L4042
    expect_equal(ds$getStatistics(1, FALSE, TRUE),
                 c(99.0, 206.0, 126.71, 18.356086184152),
                 tolerance = 0.01)

    ds$close()
})

test_that("mdim_info works", {
    f <- system.file("extdata/byte.nc", package="gdalraster")

    expect_output(mdim_info(f))
    expect_silent(mdim_info(f, cout = FALSE))
    
    expect_no_error(info <- mdim_info(f, array_options = "SHOW_ALL=YES"))
    expect_vector(info, ptype = character(), size = 1)
    expect_true(startsWith(info, "{"))
    expect_true(nchar(info) > 1000)

    expect_no_error(
        info <- mdim_info(f, "Band1", pretty = FALSE, detailed = TRUE,
                          limit = 5, allowed_drivers = "netCDF",
                          open_options = "HONOUR_VALID_RANGE=NO"))

    expect_vector(info, ptype = character(), size = 1)
    expect_true(startsWith(info, "{"))
    expect_true(nchar(info) > 1000)
})

test_that("mdim_translate works", {
    skip_if(gdal_version_num() < gdal_compute_version(3, 8, 0))

    f <- system.file("extdata/byte.nc", package="gdalraster")

    f2 <- tempfile(fileext = ".nc")
    on.exit(deleteDataset(f2), add = TRUE)

    opt <- NULL
    if (isTRUE(gdal_get_driver_md("netCDF")$NETCDF_HAS_HDF4 == "YES"))
        opt <- "ARRAY:IF(NAME=Band1):COMPRESS=DEFLATE"

    ar <- "name=Band1,view=[10:20,...]"
    expect_true(res <- mdim_translate(f, f2,
                                      creation_options = opt,
                                      array_specs = ar,
                                      allowed_drivers = c("HDF5", "netCDF"),
                                      open_options = "HONOUR_VALID_RANGE=NO",
                                      quiet = TRUE))

    ds <- mdim_as_classic(f2, "Band1", 1, 0, read_only = FALSE)
    expect_equal(ds$dim(), c(20, 10, 1))

    ds$close()

    f3 <- tempfile(fileext = ".nc")
    on.exit(deleteDataset(f3), add = TRUE)

    expect_true(mdim_translate(f, f3, group_specs = "name=/"))

    ds <- mdim_as_classic(f3, "Band1", 1, 0)
    expect_equal(ds$dim(), c(20, 20, 1))

    ds$close()

    f4 <- tempfile(fileext = ".nc")
    on.exit(deleteDataset(f4), add = TRUE)

    subsets <- c("x(441000,441800)", "y(3750400,3751000)")
    expect_true(mdim_translate(f, f4, subset_specs = subsets))

    ds <- mdim_as_classic(f4, "Band1", 1, 0)
    expect_equal(ds$dim(), c(13, 10, 1))

    ds$close()

    f5 <- tempfile(fileext = ".nc")
    on.exit(deleteDataset(f5), add = TRUE)

    expect_true(mdim_translate(f, f5, scaleaxes_specs = "x(2),y(2)"))

    ds <- mdim_as_classic(f5, "Band1", 1, 0)
    expect_equal(ds$dim(), c(10, 10, 1))

    ds$close()
})

test_that("data type convenience functions work", {
    dt <- "Byte"
    expect_equal(dt_size(dt), 1)
    expect_equal(dt_size(dt, FALSE), 8)
    expect_false(dt_is_complex(dt))
    expect_true(dt_is_integer(dt))
    expect_false(dt_is_floating(dt))
    expect_false(dt_is_signed(dt))

    # GDT_UInt8 in GDAL >= 3.13 tested below (skip if GDAL < 3.13)

    dt <- "int16"  # case-insensitive
    expect_equal(dt_size(dt), 2)
    expect_equal(dt_size(dt, FALSE), 16)
    expect_false(dt_is_complex(dt))
    expect_true(dt_is_integer(dt))
    expect_false(dt_is_floating(dt))
    expect_true(dt_is_signed(dt))

    dt <- "UInt32"
    expect_equal(dt_size(dt), 4)
    expect_equal(dt_size(dt, FALSE), 32)
    expect_false(dt_is_complex(dt))
    expect_true(dt_is_integer(dt))
    expect_false(dt_is_floating(dt))
    expect_false(dt_is_signed(dt))

    dt <- "Float64"
    expect_equal(dt_size(dt), 8)
    expect_equal(dt_size(dt, FALSE), 64)
    expect_false(dt_is_complex(dt))
    expect_false(dt_is_integer(dt))
    expect_true(dt_is_floating(dt))
    expect_true(dt_is_signed(dt))

    dt <- "CFloat32"
    expect_equal(dt_size(dt), 8)
    expect_equal(dt_size(dt, FALSE), 64)
    expect_true(dt_is_complex(dt))
    expect_false(dt_is_integer(dt))
    expect_true(dt_is_floating(dt))
    expect_true(dt_is_signed(dt))

    dt <- "dt_unknown"
    expect_equal(dt_size(dt), 0)
    expect_equal(dt_size(dt, FALSE), 0)
    expect_false(dt_is_complex(dt))
    expect_false(dt_is_integer(dt))
    expect_false(dt_is_floating(dt))
    # fails on macos with GDAL 3.5.3:
    # expect_false(dt_is_signed(dt))

    expect_equal(dt_union("Byte", "Int16"), "Int16")
    expect_equal(dt_union_with_value("Byte", -1), "Int16")
    expect_equal(dt_union_with_value("Byte", 256), "UInt16")
    expect_equal(dt_union_with_value("Float32", -99999.9876), "Float64")

    expect_equal(dt_find(bits = 32, is_signed = FALSE, is_floating = FALSE),
                 "UInt32")

    expect_equal(dt_find_for_value(0), "Byte")
    expect_equal(dt_find_for_value(NaN), "Float64")
    expect_equal(dt_find_for_value(.Machine$integer.max), "UInt32")
    expect_equal(dt_find_for_value(0.5), "Float32")
    expect_equal(dt_find_for_value(-99999.9876), "Float64")
    expect_equal(dt_find_for_value(-99999.9876, is_complex = TRUE), "CFloat64")

    skip_if(gdal_version_num() < gdal_compute_version(3, 13, 0))
    # GDT_UInt8 in GDAL >= 3.13
    dt <- "UInt8"
    expect_equal(dt_size(dt), 1)
    expect_equal(dt_size(dt, FALSE), 8)
    expect_false(dt_is_complex(dt))
    expect_true(dt_is_integer(dt))
    expect_false(dt_is_floating(dt))
    expect_false(dt_is_signed(dt))

    expect_equal(dt_union("UInt8", "Int16"), "Int16")
    expect_equal(dt_union_with_value("UInt8", -1), "Int16")
    expect_equal(dt_union_with_value("UInt8", 256), "UInt16")
})

# Tests for src/gdalalg.cpp
# skip on CRAN while dev status of CLI bindings is "experimental"
skip_on_cran()
skip_if(gdal_version_num() < gdal_compute_version(3, 11, 3))

test_that("class constructors work", {
    # default constructor
    alg <- GDALAlg$new()
    expect_equal(alg$info()$name, "gdal")
    expect_no_error(print(alg))
    alg$release()

    # no args
    alg <- new(GDALAlg, "vector")
    alginfo <- alg$info()
    expect_true(alginfo$has_subalgorithms)
    expect_true(length(alginfo$subalgorithm_names) > 5)
    # expect_output(print(alg))
    alg$release()

    # full path in a character string
    alg <- new(GDALAlg, "vector convert")
    alginfo <- alg$info()
    expect_false(alginfo$has_subalgorithms)
    # expect_output(print(alg))
    alg$release()

    # cmd path as a character vector
    alg <- new(GDALAlg, c("vector", "convert"))
    alginfo <- alg$info()
    expect_false(alginfo$has_subalgorithms)
    # expect_output(print(alg))
    alg$release()

    # args in a character vector
    f <- system.file("extdata/storml_elev.tif", package="gdalraster")
    args <- c("--format=text", "--no-md", f)
    expect_no_error(alg <- new(GDALAlg, "raster info", args))
    expect_true(alg$run())
    expect_true(length(nchar(alg$output())) == 1 && nchar(alg$output()) > 100)
    alg$release()

    # args in a list
    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
    f_out = file.path(tempdir(), "ynp_fire_year.tif")

    args <- list()
    args$input <- f
    args$sql <- "SELECT * FROM mtbs_perims ORDER BY mtbs_perims.ig_year"
    args$attribute_name <- "ig_year"
    args$output <- f_out
    args$overwrite <- TRUE
    args$creation_option <- c("TILED=YES", "COMPRESS=DEFLATE")
    args$resolution <- c(90, 90)
    args$output_data_type <- "Int16"
    args$init <- -32767
    args$nodata <- -32767

    expect_no_error(alg <- new(GDALAlg, "vector rasterize", args))
    expect_no_error(print(alg))
    expect_true(alg$parseCommandLineArgs())
    expect_true(alg$run())
    ds <- alg$output()
    expect_true(is(ds, "Rcpp_GDALRaster"))
    expect_true(alg$close())
    alg$release()

    expect_true(ds$isOpen())
    expect_true(length(ds$bbox()) == 4)
    expect_true(!any(is.na(ds$bbox())))
    ds$close()
    unlink(f_out)

    # errors
    expect_error(alg <- new(GDALAlg, ""), "empty")
    expect_error(alg <- new(GDALAlg, NA), "empty")
    expect_error(alg <- new(GDALAlg, c("raster", NA_character_)), "NA values")
    expect_error(alg <- new(GDALAlg, rep("gdal", 10)), "number of elements")
    expect_error(alg <- new(GDALAlg, "invalid"), "failed")
    expect_error(alg <- new(GDALAlg, "invalid info"), "failed")
    expect_error(alg <- new(GDALAlg, "raster invalid"), "failed")
})

test_that("algorithm and argument properties are returned correctly", {
    f <- system.file("extdata/storml_elev.tif", package="gdalraster")

    args <- list()
    args$input <- f
    f_clip <- file.path(tempdir(), "elev_clip.tif")
    on.exit(deleteDataset(f_clip))
    args$output <- f_clip
    args$overwrite <- TRUE
    args$bbox <- c(323776.1, 5102172.0,  327466.1, 5104782.0)

    expect_no_error(alg <- new(GDALAlg, "raster clip", args))

    # before arguments parsed or algorithm run
    alginfo <- alg$info()
    expect_true(is.list(alginfo))
    expect_equal(alginfo$name, "clip")
    expect_true(nchar(alginfo$description) > 10)
    expect_vector(alginfo$subalgorithm_names, character(), 0)
    expect_vector(alginfo$arg_names, character())

    arginfo <- alg$argInfo("bbox")
    expect_true(is.list(arginfo))
    expect_equal(arginfo$type, "REAL_LIST")
    expect_false(arginfo$is_explicitly_set)
    rm(arginfo)

    arginfo <- alg$argInfo("output")
    expect_true(is.list(arginfo))
    expect_equal(arginfo$type, "DATASET")
    expect_true(arginfo$is_required)
    expect_false(arginfo$is_explicitly_set)
    expect_equal(arginfo$dataset_type_flags, "RASTER")
    expect_equal(arginfo$dataset_output_flags, "OBJECT")

    expect_true(is.list(alg$getExplicitlySetArgs()))
    expect_equal(length(alg$getExplicitlySetArgs()), 0)

    rm(alginfo)
    rm(arginfo)

    # after args parsed (actual algorithm instantiated)
    expect_true(alg$parseCommandLineArgs())
    alginfo <- alg$info()
    expect_true(is.list(alginfo))
    expect_equal(alginfo$name, "clip")

    arginfo <- alg$argInfo("bbox")
    expect_true(is.list(arginfo))
    expect_equal(arginfo$type, "REAL_LIST")
    expect_true(arginfo$is_explicitly_set)
    rm(arginfo)

    arginfo <- alg$argInfo("output")
    expect_true(is.list(arginfo))
    expect_equal(arginfo$type, "DATASET")
    expect_true(arginfo$is_required)
    expect_true(arginfo$is_explicitly_set)
    expect_equal(arginfo$dataset_type_flags, "RASTER")
    expect_equal(arginfo$dataset_output_flags, "OBJECT")

    set_args <- alg$getExplicitlySetArgs()
    expect_true(is.list(set_args))
    expect_equal(length(set_args), 4)
    expect_true(startsWith(set_args$input, "<raster dataset object:") ||
                startsWith(set_args$input, "<list of dataset objects"))
    expect_true(startsWith(set_args$output, "<raster dataset object:"))

    rm(alginfo)
    rm(arginfo)

    # after actual algorithm has run
    expect_true(alg$run())
    alginfo <- alg$info()
    expect_true(is.list(alginfo))
    expect_equal(alginfo$name, "clip")

    arginfo <- alg$argInfo("bbox")
    expect_true(is.list(arginfo))
    expect_equal(arginfo$type, "REAL_LIST")
    expect_true(arginfo$is_explicitly_set)
    rm(arginfo)

    arginfo <- alg$argInfo("output")
    expect_true(is.list(arginfo))
    expect_equal(arginfo$type, "DATASET")
    expect_true(arginfo$is_required)
    expect_true(arginfo$is_explicitly_set)
    expect_equal(arginfo$dataset_type_flags, "RASTER")
    expect_equal(arginfo$dataset_output_flags, "OBJECT")

    rm(alginfo)
    rm(arginfo)

    expect_error(alg$argInfo(""), "required")
    expect_error(alg$argInfo("invalid"), "failed")

    expect_true(alg$close())
    alg$release()

    expect_error(alg$info(), "algorithm not instantiated")
    expect_error(alg$argInfo("output"), "algorithm not instantiated")
})

test_that("algorithm usage is returned", {
    expect_no_error(alg <- new(GDALAlg, "raster info"))

    expect_output(alg$usage(), "Usage:")

    expect_no_error(json <- alg$usageAsJSON())
    expect_true(is.character(json) && length(json) == 1)
    expect_true(nchar(json) > 50)

    alg$release()

    expect_error(alg$usageAsJSON(), "not instantiated")
})

test_that("GDALAlg S4 show() works", {
    expect_no_error(alg <- new(GDALAlg, "raster info"))

    # expect_output(print(alg), "Description")
    # TODO: a snapshot test is required since output is now formatted with {cli}
    expect_no_error(print(alg))

    alg$release()
})

test_that("algorithm run/output/outputs work", {
    f <- system.file("extdata/storml_elev.tif", package="gdalraster")

    ## basic test with a few different arg types
    f_clip <- file.path(tempdir(), "elev_clip.tif")

    args <- list()
    args$input <- f
    on.exit(deleteDataset(f_clip), add = TRUE)
    args$output <- f_clip
    args$overwrite <- TRUE
    args$bbox <- c(323776.1, 5102172.0,  327466.1, 5104782.0)

    expect_no_error(alg <- new(GDALAlg, "raster clip", args))
    expect_true(alg$run())

    # get the single output
    expect_no_error(ds <- alg$output())
    expect_true(is(ds, "Rcpp_GDALRaster"))
    ds$close()

    # get the output list (containing a single element in this case)
    expect_no_error(list_out <- alg$outputs())
    expect_true(is.list(list_out))
    expect_equal(length(list_out), 1)
    ds <- list_out$output
    expect_true(is(ds, "Rcpp_GDALRaster"))
    ds$close()

    expect_true(alg$close())
    alg$release()

    ## DATASET_LIST arg as vector of filenames and REAL_LIST arg
    b4_file <- system.file("extdata/sr_b4_20200829.tif", package="gdalraster")
    b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
    b6_file <- system.file("extdata/sr_b6_20200829.tif", package="gdalraster")
    band_files <- c(b6_file, b5_file, b4_file)

    f_vrt <- file.path(tempdir(), "stack_test.vrt")
    on.exit(deleteDataset(f_vrt), add = TRUE)

    args <- c("--dst-nodata=1,2,3", "--overwrite", band_files, f_vrt)
    alg <- new(GDALAlg, "raster stack", args)
    expect_true(alg$run())

    ds_stack <- alg$output()
    expect_true(is(ds_stack, "Rcpp_GDALRaster"))
    expect_equal(ds_stack$dim(),  c(149, 112, 3))
    expect_equal(ds_stack$getNoDataValue(band = 1), 1)
    expect_equal(ds_stack$getNoDataValue(band = 2), 2)
    expect_equal(ds_stack$getNoDataValue(band = 3), 3)

    ds_stack$close()
    expect_true(alg$close())
    alg$release()

    ## DATASET_LIST arg as objects and REAL_LIST as numeric vector
    ds_list <- list(new(GDALRaster, b6_file),
                    new(GDALRaster, b5_file),
                    new(GDALRaster, b4_file))

    f_vrt2 <- file.path(tempdir(), "stack_test2.vrt")
    on.exit(deleteDataset(f_vrt2), add = TRUE)

    args <- list("input" = ds_list,
                 "output" = f_vrt2,
                 "overwrite" = TRUE,
                 "dst_nodata" = c(1, 2, 3))

    alg <- new(GDALAlg, "raster stack", args)
    expect_true(alg$run())

    ds_stack <- alg$output()
    expect_true(is(ds_stack, "Rcpp_GDALRaster"))
    expect_equal(ds_stack$dim(),  c(149, 112, 3))
    expect_equal(ds_stack$getNoDataValue(band = 1), 1)
    expect_equal(ds_stack$getNoDataValue(band = 2), 2)
    expect_equal(ds_stack$getNoDataValue(band = 3), 3)

    ds_stack$close()
    for (i in seq_along(ds_list))
        ds_list[[i]]$close()
    alg$release()

    ## STRING_LIST arg (--src-nodata and --dst-nodata are STRING_LIST in
    ## "raster reproject")
    args <- c("--output", "", "--format", "MEM", "--size=2,1", "--band-count=2",
              "--datatype=Float32")
    alg <- gdal_run("raster create", args)
    ds <- alg$output()
    alg$release()
    expect_true(ds$setGeoTransform(c(0, 1, 0, 0, 0, -1)))
    ds$write(1, 0, 0, 2, 1, c(-999, 1))
    ds$write(2, 0, 0, 2, 1, c(NaN, 2))

    args <- list("input" = ds,
                 "output" = "",
                 "format" = "MEM",
                 "src-nodata" = c("-999", "nan"),
                 "dst-nodata" = c("0", "0"))
    alg <- gdal_run("raster reproject", args)
    out_ds <- alg$output()
    alg$release()
    expect_equal(out_ds$read(1, 0, 0, 2, 1, 2, 1), c(NA_real_, 1))
    expect_equal(out_ds$read(2, 0, 0, 2, 1, 2, 1), c(NA_real_, 2))
    out_ds$deleteNoDataValue(band = 1)
    out_ds$deleteNoDataValue(band = 2)
    expect_equal(out_ds$read(1, 0, 0, 2, 1, 2, 1), c(0, 1))
    expect_equal(out_ds$read(2, 0, 0, 2, 1, 2, 1), c(0, 2))

    out_ds$close()
    ds$close()
})

test_that("`setVectorArgsFromObject` and `outputLayerNameForOpen` work", {
    f <- system.file("extdata/ynp_features.zip", package = "gdalraster")
    ynp_dsn <- file.path("/vsizip", f, "ynp_features.gpkg")

    ## auto set "input-format", "input-layer"
    poi <- new(GDALVector, ynp_dsn, "points_of_interest")
    poi$setAttributeFilter("poiname = 'Abyss Pool'")

    f_out <- file.path(tempdir(), "filter_test.gpkg")
    on.exit(unlink(f_out), add = TRUE)

    args <- list()
    args$input <- poi
    args$output <- f_out
    args$overwrite <- TRUE

    expect_no_error(alg <- new(GDALAlg, "vector filter", args))
    expect_true(alg$setVectorArgsFromObject)  # the default
    expect_false(alg$argInfo("input-format")$is_explicitly_set)
    expect_false(alg$argInfo("input-layer")$is_explicitly_set)
    expect_true(alg$parseCommandLineArgs())
    expect_true(alg$argInfo("input-format")$is_explicitly_set)
    expect_true(alg$argInfo("input-layer")$is_explicitly_set)
    expect_true(alg$run())

    expect_true(ogr_ds_layer_count(f_out) == 1)
    lyr <- alg$output()
    expect_true(is(lyr, "Rcpp_GDALVector"))
    expect_equal(lyr$getName(), "points_of_interest")
    expect_equal(lyr$getFeatureCount(), 1)
    feat <- lyr$getNextFeature()
    expect_equal(feat$poiname, "Abyss Pool")

    alg$release()
    lyr$close()

    # with `setVectorArgsFromObject` disabled
    f2_out <- file.path(tempdir(), "filter_test_2.gpkg")
    on.exit(unlink(f2_out), add = TRUE)

    args <- list()
    args$input <- poi
    args$output <- f2_out
    args$overwrite <- TRUE

    alg <- new(GDALAlg, "vector filter", args)
    alg$setVectorArgsFromObject <- FALSE
    expect_false(alg$setVectorArgsFromObject)
    expect_false(alg$argInfo("input-format")$is_explicitly_set)
    expect_false(alg$argInfo("input-layer")$is_explicitly_set)
    expect_true(alg$parseCommandLineArgs())
    expect_false(alg$argInfo("input-format")$is_explicitly_set)
    expect_false(alg$argInfo("input-layer")$is_explicitly_set)
    expect_true(alg$run())

    # all layers in the dataset are processed and present in the output dataset
    expect_true(ogr_ds_layer_count(f2_out) > 1)
    # set the output layer name to open
    alg$outputLayerNameForOpen <- "points_of_interest"
    lyr <- alg$output()
    expect_true(is(lyr, "Rcpp_GDALVector"))
    expect_equal(lyr$getName(), "points_of_interest")

    # This gives feature count of 1, i.e., the attribute filter defined on
    # the layer via the GDALVector object is still honored when the layer is
    # referenced via the dataset ref acquired by the algorithm object.
    # "where" argument was not given explicitly:
    expect_false(alg$argInfo("where")$is_explicitly_set)
    expect_equal(lyr$getFeatureCount(), 1)
    feat <- lyr$getNextFeature()
    expect_equal(feat$poiname, "Abyss Pool")

    alg$release()
    lyr$close()
    poi$close()

    ## auto set "sql"
    sql <- "SELECT * FROM points_of_interest WHERE poiname = 'Abyss Pool'"
    poi_abyss <- new(GDALVector, ynp_dsn, sql)

    alg <- new(GDALAlg, "vector info", list("input" = poi_abyss))
    expect_false(alg$argInfo("sql")$is_explicitly_set)
    expect_true(alg$parseCommandLineArgs())
    expect_true(alg$argInfo("sql")$is_explicitly_set)
    # "vector info" should use "input-layer" instead
    # cf. https://github.com/OSGeo/gdal/issues/12903
    expect_false(alg$argInfo("layer")$is_explicitly_set)
    expect_true(alg$run())

    json <- alg$output()
    expect_true(startsWith(json, "{"))
    expect_true(nchar(json) > 2000)
    expect_true(grepl("name\":\"SELECT\"", json, ignore.case = TRUE))
    expect_true(grepl("featureCount\":1", json, ignore.case = TRUE))

    alg$release()
    poi_abyss$close()

    ## auto set "sql" with "dialect"
    shp_dsn <- system.file("extdata/poly_multipoly.shp", package = "gdalraster")
    sql <- "SELECT rowid AS fid, ST_Centroid(geometry) As geom
            FROM poly_multipoly"
    if (has_spatialite()) {
        lyr_in <- new(GDALVector, shp_dsn, sql, TRUE, NULL, "", "SQLite")

        f_sql_out <- file.path(tempdir(), "spatialite_test.gpkg")
        on.exit(unlink(f_sql_out), add = TRUE)

        args <- list()
        args$input <- lyr_in
        args$output <- f_sql_out
        args$overwrite <- TRUE

        expect_no_error(alg <- new(GDALAlg, "vector sql", args))
        expect_true(alg$setVectorArgsFromObject)  # the default
        expect_false(alg$argInfo("input-format")$is_explicitly_set)
        expect_false(alg$argInfo("sql")$is_explicitly_set)
        expect_false(alg$argInfo("dialect")$is_explicitly_set)
        expect_true(alg$parseCommandLineArgs())
        expect_true(alg$argInfo("input-format")$is_explicitly_set)
        expect_true(alg$argInfo("sql")$is_explicitly_set)
        expect_true(alg$argInfo("dialect")$is_explicitly_set)
        expect_true(alg$run())

        expect_true(ogr_ds_layer_count(f_sql_out) == 1)
        lyr_out <- alg$output()
        expect_true(is(lyr_out, "Rcpp_GDALVector"))
        expect_equal(toupper(lyr_out$getName()), "SELECT")
        expect_equal(lyr_out$getFeatureCount(), 4)
        feat <- lyr_out$getNextFeature()
        expect_equal(toupper(g_name(feat$geom)), "POINT")

        alg$release()
        lyr_out$close()
        lyr_in$close()
    }

    ## manually set SQL with input of GDALVector open on a regular layer
    lyr_in <- new(GDALVector, shp_dsn)

    f2_sql_out <- file.path(tempdir(), "sql_test.shp")
    on.exit(deleteDataset(f2_sql_out), add = TRUE)

    args <- list()
    args$input <- lyr_in
    args$sql <- "SELECT FID, '_ogr_geometry_' FROM poly_multipoly LIMIT 1"
    args$output <- f2_sql_out
    args$overwrite <- TRUE

    expect_no_error(alg <- new(GDALAlg, "vector sql", args))
    expect_true(alg$setVectorArgsFromObject)  # the default
    expect_false(alg$argInfo("sql")$is_explicitly_set)
    expect_false(alg$argInfo("dialect")$is_explicitly_set)
    expect_true(alg$parseCommandLineArgs())
    expect_true(alg$argInfo("sql")$is_explicitly_set)
    expect_false(alg$argInfo("dialect")$is_explicitly_set)
    expect_true(alg$run())

    lyr_out <- alg$output()
    expect_true(is(lyr_out, "Rcpp_GDALVector"))
    expect_equal(toupper(lyr_out$getName()), "SQL_TEST")
    expect_equal(lyr_out$getFeatureCount(), 1)
    feat <- lyr_out$getNextFeature()
    expect_equal(toupper(g_name(feat$geom)), "POLYGON")

    alg$release()
    lyr_out$close()
    lyr_in$close()

    # the following tests require fixes added in GDAL 3.12
    # e.g., gdal raster clip: fix bbox check
    # https://github.com/OSGeo/gdal/pull/12814
    skip_if(gdal_version_num() < gdal_compute_version(3, 12, 0))

    ## auto set "like-layer
    elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
    ds <- new(GDALRaster, elev_file)

    bnd_1 <- "POLYGON ((324467.3 5104814.2,
                    323909.4 5104365.4,
                    323794.2 5103455.8,
                    324970.7 5102885.8,
                    326420.0 5103595.3,
                    326389.6 5104747.5,
                    325298.1 5104929.4,
                    325298.1 5104929.4,
                    324467.3 5104814.2))"

    f_temp_poly <- file.path(tempdir(), "storml_test_poly.gpkg")
    on.exit(unlink(f_temp_poly), add = TRUE)
    lyr <- ogr_ds_create("GPKG", f_temp_poly, layer = "test_poly",
                        geom_type = "POLYGON", srs = ds$getProjection(),
                        fld_name = "poly_name", fld_type = "OFTString",
                        overwrite = TRUE, return_obj = TRUE)

    lyr$createFeature(list(poly_name = "bnd_1", geom = bnd_1))
    lyr$createFeature(list(poly_name = "bnd_2", geom = g_buffer(bnd_1, 90)))
    lyr$syncToDisk()

    f_clip_bnd_1_2 <- file.path(tempdir(), "elev_clip_bnd_1_2.tif")
    on.exit(deleteDataset(f_clip_bnd_1_2), add = TRUE)

    args <- list()
    args$input <- ds
    args$output <- f_clip_bnd_1_2
    args$overwrite <- TRUE
    args$like <- lyr

    expect_no_error(alg <- new(GDALAlg, "raster clip", args))
    expect_false(alg$argInfo("like-layer")$is_explicitly_set)
    expect_true(alg$parseCommandLineArgs())
    expect_true(alg$argInfo("like-layer")$is_explicitly_set)
    expect_true(alg$run())

    ds_out <- alg$output()
    expect_true(is(ds_out, "Rcpp_GDALRaster"))
    expect_equal(ds_out$bbox(), c(323686.1, 5102772.0, 326536.1, 5105022.0),
                 tolerance = 0.1)

    alg$release()
    ds_out$close()
    lyr$close()

    ## auto set "like-sql"
    sql <- "SELECT * FROM test_poly WHERE poly_name = 'bnd_1'"
    lyr <- new(GDALVector, f_temp_poly, sql)

    f_clip_bnd_1 <- file.path(tempdir(), "elev_clip_bnd_1.tif")
    on.exit(deleteDataset(f_clip_bnd_1), add = TRUE)

    args <- list()
    args$input <- ds
    args$output <- f_clip_bnd_1
    args$overwrite <- TRUE
    args$like <- lyr

    expect_no_error(alg <- new(GDALAlg, "raster clip", args))
    expect_false(alg$argInfo("like-layer")$is_explicitly_set)
    expect_false(alg$argInfo("like-sql")$is_explicitly_set)
    expect_true(alg$parseCommandLineArgs())
    expect_false(alg$argInfo("like-layer")$is_explicitly_set)
    expect_true(alg$argInfo("like-sql")$is_explicitly_set)
    expect_true(alg$run())

    ds_out <- alg$output()
    expect_true(is(ds_out, "Rcpp_GDALRaster"))
    expect_equal(ds_out$bbox(), c(323776.1, 5102862.0, 326446.1, 5104932.0),
                 tolerance = 0.1)

    alg$release()
    ds_out$close()
    lyr$close()
})

test_that("setArg works", {
    ## set args individually by API
    f_dem <- system.file("extdata/storml_elev.tif", package="gdalraster")
    ds <- new(GDALRaster, f_dem)

    f_aspect <- file.path(tempdir(), "aspect_test.tif")
    on.exit(deleteDataset(f_aspect), add = TRUE)

    alg <- new(GDALAlg, "raster aspect")
    expect_true(alg$setArg("input", ds))
    expect_true(alg$setArg("output", f_aspect))
    expect_true(alg$setArg("creation-option", "COMPRESS=DEFLATE"))
    expect_true(alg$setArg("overwrite", TRUE))
    expect_true(alg$setArg("zero-for-flat", TRUE))
    expect_true(alg$run())

    ds_aspect <- alg$output()
    expect_true(is(ds_aspect, "Rcpp_GDALRaster"))
    minmax <- ds_aspect$getMinMax(band = 1, approx_ok = FALSE)
    expect_equal(minmax[1], 0)
    expect_true(minmax[2] >= 359 && minmax[2] <= 360)
    compression <- ds_aspect$getMetadataItem(band = 0, "COMPRESSION",
                                             "IMAGE_STRUCTURE")
    expect_equal(compression, "DEFLATE")
    ds_aspect$close()
    expect_true(alg$close())
    alg$release()

    ## instantiate with args, then set additional args individually
    f_slpp <- file.path(tempdir(), "slpp_test.tif")
    on.exit(deleteDataset(f_slpp), add = TRUE)

    args <- list()
    args$input <- ds
    args$output <- f_slpp
    args$creation_option <- "COMPRESS=DEFLATE"
    args$overwrite <- TRUE
    alg <- new(GDALAlg, "raster slope", args)
    expect_true(alg$setArg("unit", "percent"))
    expect_true(alg$run())

    ds_slpp <- alg$output()
    expect_true(is(ds_slpp, "Rcpp_GDALRaster"))
    minmax <- ds_slpp$getMinMax(band = 1, approx_ok = FALSE)
    expect_equal(minmax[1], 0)
    expect_true(minmax[2] > 100 && minmax[2] < 200)
    compression <- ds_slpp$getMetadataItem(band = 0, "COMPRESSION",
                                           "IMAGE_STRUCTURE")
    expect_equal(compression, "DEFLATE")
    ds_slpp$close()
    expect_true(alg$close())
    alg$release()

    ## instantiate with args, then set additional args individually after
    ## parsing command-line arguments (which also instantiates the actual
    ## algorithm internally)
    f_clip <- file.path(tempdir(), "clip_test.tif")
    on.exit(deleteDataset(f_clip), add = TRUE)

    args <- list()
    args$input <- ds
    args$output <- f_clip
    args$overwrite <- TRUE
    alg <- new(GDALAlg, "raster clip", args)
    expect_true(alg$parseCommandLineArgs())
    expect_true(
        alg$setArg("bbox", c(323776.1, 5102172.0,  327466.1, 5104782.0)))
    expect_true(alg$setArg("creation-option", "COMPRESS=DEFLATE"))
    set_args <- alg$getExplicitlySetArgs()
    expect_equal(set_args$bbox, c(323776.1, 5102172.0,  327466.1, 5104782.0),
                 tolerance = 1e-5)
    expect_equal(set_args$creation_option, "COMPRESS=DEFLATE")
    expect_true(alg$run())

    ds_clip <- alg$output()
    expect_true(is(ds_clip, "Rcpp_GDALRaster"))
    expect_equal(ds_clip$dim(), c(123, 87, 1))
    compression <- ds_clip$getMetadataItem(band = 0, "COMPRESSION",
                                           "IMAGE_STRUCTURE")
    expect_equal(compression, "DEFLATE")
    ds_clip$close()
    expect_true(alg$close())
    alg$release()

    ds$close()

    ## DATASET_LIST arg as charcter vector and REAL_LIST as numeric vector
    b4_file <- system.file("extdata/sr_b4_20200829.tif", package="gdalraster")
    b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
    b6_file <- system.file("extdata/sr_b6_20200829.tif", package="gdalraster")
    band_files <- c(b6_file, b5_file, b4_file)

    f_vrt <- file.path(tempdir(), "stack_test.vrt")
    on.exit(deleteDataset(f_vrt), add = TRUE)

    alg <- new(GDALAlg, "raster stack")
    expect_true(alg$setArg("input", band_files))
    expect_true(alg$setArg("output", f_vrt))
    expect_true(alg$setArg("overwrite", TRUE))
    expect_true(alg$setArg("dst-nodata", c(1, 2, 3)))
    expect_true(alg$run())

    ds_stack <- alg$output()
    expect_true(is(ds_stack, "Rcpp_GDALRaster"))
    expect_equal(ds_stack$dim(),  c(149, 112, 3))
    expect_equal(ds_stack$getNoDataValue(band = 1), 1)
    expect_equal(ds_stack$getNoDataValue(band = 2), 2)
    expect_equal(ds_stack$getNoDataValue(band = 3), 3)

    ds_stack$close()
    alg$release()

    ## DATASET_LIST arg as list of objects
    ds_list <- list(new(GDALRaster, b6_file),
                    new(GDALRaster, b5_file),
                    new(GDALRaster, b4_file))

    f_vrt2 <- file.path(tempdir(), "stack_test2.vrt")
    on.exit(deleteDataset(f_vrt2), add = TRUE)

    alg <- new(GDALAlg, "raster stack")
    expect_true(alg$setArg("input", ds_list))
    expect_true(alg$setArg("output", f_vrt2))
    expect_true(alg$setArg("overwrite", TRUE))
    expect_true(alg$run())

    ds_stack <- alg$output()
    expect_true(is(ds_stack, "Rcpp_GDALRaster"))
    expect_equal(ds_stack$dim(),  c(149, 112, 3))
    expect_equal(ds_stack$getNoDataValue(band = 1), 0)
    expect_equal(ds_stack$getNoDataValue(band = 2), 0)
    expect_equal(ds_stack$getNoDataValue(band = 3), 0)

    ds_stack$close()
    for (i in seq_along(ds_list))
        ds_list[[i]]$close()
    alg$release()

    ## INTEGER_LIST (--size in "raster create")
    ## STRING_LIST (--src-nodata and --dst-nodata in "raster reproject")
    args <- c("--output", "", "--format", "MEM")
    alg <- gdal_alg("raster create", args)
    expect_true(alg$setArg("size", c(2, 1)))
    expect_true(alg$setArg("band-count", 2))
    expect_true(alg$setArg("datatype", "Float32"))
    expect_true(alg$run())

    ds <- alg$output()
    alg$release()
    expect_true(ds$setGeoTransform(c(0, 1, 0, 0, 0, -1)))
    ds$write(1, 0, 0, 2, 1, c(-999, 1))
    ds$write(2, 0, 0, 2, 1, c(NaN, 2))

    args <- list("input" = ds,
                 "output" = "",
                 "format" = "MEM")
    alg <- gdal_alg("raster reproject", args)
    expect_true(alg$setArg("src-nodata", c("-999", "nan")))
    expect_true(alg$setArg("dst-nodata", c("0", "0")))
    expect_true(alg$run())

    out_ds <- alg$output()
    alg$release()
    expect_equal(out_ds$read(1, 0, 0, 2, 1, 2, 1), c(NA_real_, 1))
    expect_equal(out_ds$read(2, 0, 0, 2, 1, 2, 1), c(NA_real_, 2))
    out_ds$deleteNoDataValue(band = 1)
    out_ds$deleteNoDataValue(band = 2)
    expect_equal(out_ds$read(1, 0, 0, 2, 1, 2, 1), c(0, 1))
    expect_equal(out_ds$read(2, 0, 0, 2, 1, 2, 1), c(0, 2))

    out_ds$close()
    ds$close()
})

test_that("raster compare works", {
    # test an algorithm with an atypical argument name for an input dataset
    skip_if(gdal_version_num() < gdal_compute_version(3, 12, 0))

    f_ref <- system.file("extdata/storml_elev.tif", package="gdalraster")
    f2 <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    ds_ref <- new(GDALRaster, f_ref)
    on.exit(ds_ref$close(), add = TRUE)
    ds2 <- new(GDALRaster, f2)
    on.exit(ds2$close(), add = TRUE)
    args <- list(reference = ds_ref, input = ds2)
    alg <- new(GDALAlg, "raster compare", args)
    expect_true(alg$run())
    expect_true(
        grepl("pixels differing", alg$outputs()$output_string, fixed = TRUE))

    alg$release()

    ds_mem <- createCopy("MEM", "", f_ref, return_obj = TRUE)
    on.exit(ds_mem$close(), add = TRUE)
    args <- list(reference = ds_ref, input = ds_mem, skip_binary = TRUE)
    alg <- new(GDALAlg, "raster compare", args)
    expect_true(alg$run())
    expect_equal(alg$outputs()$output_string, "")

    alg$release()
})

# R functions for various processing with gdalraster
# Chris Toney <chris.toney at usda.gov>


#' List of default nodata values by raster data type
#'
#' These values are currently used in `gdalraster` when a nodata value is
#' needed but has not been specified:
#' \preformatted{
#'     list("Byte" = 255, "UInt8" = 255, "Int8" = -128,
#'          "UInt16" = 65535, "Int16" = -32767,
#'          "UInt32" = 4294967293, "Int32" = -2147483647,
#'          "Float32" = -99999.0, "Float64" = NaN)
#' }
#' @export
DEFAULT_NODATA <- list(
    "Byte" = 255, "UInt8" = 255, "Int8" = -128,
    "UInt16" = 65535, "Int16" = -32767,
    "UInt32" = 4294967293, "Int32" = -2147483647,
    "Float32" = -99999.0, "Float64" = NaN)


#' List of default DEM processing options
#'
#' These values are used in `dem_proc()` as the default processing options:
#' \preformatted{
#'     list(
#'          "hillshade" =    c("-z", "1", "-s", "1", "-az", "315",
#'                             "-alt", "45", "-alg", "Horn",
#'                             "-combined", "-compute_edges"),
#'          "slope" =        c("-s", "1", "-alg", "Horn", "-compute_edges"),
#'          "aspect" =       c("-alg", "Horn", "-compute_edges"),
#'          "color-relief" = character(),
#'          "TRI" =          c("-alg", "Riley", "-compute_edges"),
#'          "TPI" =          c("-compute_edges"),
#'          "roughness" =    c("-compute_edges"))
#' }
#' @seealso
#' [dem_proc()]
#'
#' \url{https://gdal.org/en/stable/programs/gdaldem.html} for a description of all
#' available command-line options for each processing mode
#' @export
DEFAULT_DEM_PROC <- list(
    "hillshade" = c("-z", "1", "-s", "1", "-az", "315",
                    "-alt", "45", "-alg", "Horn",
                    "-combined", "-compute_edges"),
    "slope" = c("-s", "1", "-alg", "Horn", "-compute_edges"),
    "aspect" = c("-alg", "Horn", "-compute_edges"),
    "color-relief" = character(),
    "TRI" = c("-alg", "Riley", "-compute_edges"),
    "TPI" = c("-compute_edges"),
    "roughness" = c("-compute_edges"))


#' @noRd
.getGDALformat <- function(file) {
    # Only for guessing common output formats
    file <- as.character(file)
    if (endsWith(tolower(file), ".tif")) {
        return("GTiff")
    }
    if (endsWith(tolower(file), ".vrt")) {
        return("VRT")
    }
    if (endsWith(tolower(file), ".img")) {
        return("HFA")
    }
    return(NULL)
}


#' @noRd
.getOGRformat <- function(file) {
    # Only for guessing common output formats
    file <- as.character(file)
    if (startsWith(file, "PG:")) {
        return("PostgreSQL")
    }
    if (endsWith(tolower(file), ".gpkg")) {
        return("GPKG")
    }
    if (endsWith(tolower(file), ".shp")) {
        return("ESRI Shapefile")
    }
    if (endsWith(tolower(file), ".sqlite")) {
        return("SQLite")
    }
    if (endsWith(tolower(file), ".fgb")) {
        return("FlatGeobuf")
    }
    if (endsWith(tolower(file), ".geojson") ||
        endsWith(tolower(file), ".json")) {

        return("GeoJSON")
    }
    return(NULL)
}


#' Get a pixel or line offset for a north-up raster
#' @param coord A georeferenced x or y
#' @param origin Raster xmin or ymax
#' @param gt_pixel_size Geotransform pixel x or y size (negative for y)
#' @returns pixel (column) or line (row) offset for coord x or y
#' @noRd
.getOffset <- function(coord, origin, gt_pixel_size) {
    (coord-origin)/gt_pixel_size
}


#' Convenience wrapper for `GDALRaster$read()`
#'
#' @description
#' `read_ds()` will read from a raster dataset that is already open in a
#' `GDALRaster` object. By default, it attempts to read the full raster
#' extent from all bands at full resolution. `read_ds()` is sometimes more
#' convenient than `GDALRaster$read()`, e.g., to read specific multiple bands
#' for display with [plot_raster()], or simply for the default arguments that
#' read an entire raster into memory (see Note).
#'
#' @details
#' `NA` will be returned in place of the nodata value if the raster dataset has
#' a nodata value defined for the band. Data are read as R `integer` type when
#' possible for the raster data type (Byte/UInt8, Int8, Int16, UInt16, Int32),
#' otherwise as type `double` (UInt32, Float32, Float64).
#'
#' The output object has attribute `gis`, a list containing:
#' \preformatted{
#'   $type = "raster"
#'   $bbox = c(xmin, ymin, xmax, ymax)
#'   $dim = c(xsize, ysize, nbands)
#'   $srs = <projection as WKT2 string>
#'   $datatype = <character vector of data type name by band>
#' }
#' The WKT version used for the projection string can be overridden by setting
#' the `OSR_WKT_FORMAT` configuration option. See [srs_to_wkt()] for a list of
#' supported values.
#'
#' @param ds An object of class `GDALRaster` in open state.
#' @param bands Integer vector of band numbers to read. By default all bands
#' will be read.
#' @param xoff Integer. The pixel (column) offset to the top left corner of the
#' raster region to be read (zero to start from the left side).
#' @param yoff Integer. The line (row) offset to the top left corner of the
#' raster region to be read (zero to start from the top).
#' @param xsize Integer. The width in pixels of the region to be read.
#' @param ysize Integer. The height in pixels of the region to be read.
#' @param out_xsize Integer. The width in pixels of the output buffer into
#' which the desired region will be read (e.g., to read a reduced resolution
#' overview).
#' @param out_ysize Integer. The height in pixels of the output buffer into
#' which the desired region will be read (e.g., to read a reduced resolution
#' overview).
#' @param as_list Logical. If `TRUE`, return output as a list of band vectors.
#' If `FALSE` (the default), output is a vector of pixel data interleaved by
#' band.
#' @param as_raw Logical. If `TRUE` and the underlying data type is Byte (or
#' UInt8 in GDAL >= 3.13), return output as \R `raw` vector type. This maps to
#' the setting \code{$readByteAsRaw} on the `GDALRaster` object, which will be
#' temporarily updated in this function. To control this behavior in a
#' persistent way on a dataset object see \code{$readByteAsRaw} in
#' [`GDALRaster-class`][GDALRaster].
#' @returns If `as_list = FALSE` (the default), a vector of `raw`, `integer`,
#' `double` or `complex` containing the values that were read. It is organized
#' in left to right, top to bottom pixel order, interleaved by band.
#' If `as_list = TRUE`, a list with number of elements equal to the number of
#' bands read. Each element contains a vector of `raw`, `integer`, `double` or
#' `complex` containing the pixel values that were read for the band.
#'
#' @note
#' There is small overhead in calling `read_ds()` compared with
#' calling `GDALRaster$read()` directly. This would only matter if calling
#' the function repeatedly to read a raster in chunks. For the case of reading
#' a large raster in many chunks, it will be optimal performance-wise to call
#' `GDALRaster$read()` directly.
#'
#' By default, this function will attempt to read the full raster into memory.
#' It generally should not be called on large raster datasets using the default
#' argument values. The memory size in bytes of the returned vector will be,
#' e.g., (xsize * ysize * number of bands * 4) for data read as
#' `integer`, or (xsize * ysize * number of bands * 8) for data read as
#' `double` (plus small object overhead for the vector).
#'
#' @seealso
#' [`GDALRaster$read()`][GDALRaster]
#'
#' @examples
#' # read three bands from a multi-band dataset
#' lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
#' ds <- new(GDALRaster, lcp_file)
#'
#' # as a vector of pixel data interleaved by band
#' r <- read_ds(ds, bands = c(6,5,4))
#' typeof(r)
#' length(r)
#' object.size(r)
#'
#' # as a list of band vectors
#' r <- read_ds(ds, bands = c(6,5,4), as_list = TRUE)
#' typeof(r)
#' length(r)
#' object.size(r)
#'
#' # gis attributes
#' attr(r, "gis")
#'
#' ds$close()
#' @export
read_ds <- function(ds, bands = NULL, xoff = 0, yoff = 0,
                    xsize = ds$getRasterXSize(), ysize = ds$getRasterYSize(),
                    out_xsize = xsize, out_ysize = ysize,
                    as_list = FALSE, as_raw = FALSE) {

    if (!is(ds, "Rcpp_GDALRaster")) {
        stop("'ds' must be an object of class GDALRaster", call. = FALSE)
    }
    if (is.null(bands)) {
        bands <- seq_len(ds$getRasterCount())
    } else if (!is.numeric(bands)) {
        stop("'bands' must be a numeric vector", call. = FALSE)
    }
    if (is.null(xoff) || !(is.numeric(xoff) && length(xoff) == 1)) {
        stop("'xoff' must be a numeric value", call. = FALSE)
    }
    if (is.null(yoff) || !(is.numeric(yoff) && length(yoff) == 1)) {
        stop("'yoff' must be a numeric value", call. = FALSE)
    }
    if (is.null(xsize) || !(is.numeric(xsize) && length(xsize) == 1)) {
        stop("'xsize' must be a numeric value", call. = FALSE)
    }
    if (is.null(ysize) || !(is.numeric(ysize) && length(ysize) == 1)) {
        stop("'ysize' must be a numeric value", call. = FALSE)
    }
    if (is.null(out_xsize) ||
        !(is.numeric(out_xsize) && length(out_xsize) == 1)) {

        stop("'out_xsize' must be a numeric value", call. = FALSE)
    }
    if (is.null(out_ysize) ||
        !(is.numeric(out_ysize) && length(out_ysize) == 1)) {

        stop("'out_ysize' must be a numeric value", call. = FALSE)
    }
    if (is.null(as_list)) {
        as_list <- FALSE
    } else if (!(is.logical(as_list) && length(as_list) == 1)) {
        stop("'as_list' must be a logical value", call. = FALSE)
    }
    if (is.null(as_raw)) {
        as_raw <- FALSE
    } else if (!(is.logical(as_raw) && length(as_raw) == 1)) {
        stop("'as_raw' must be a logical value", call. = FALSE)
    }

    # get the unioned data type across all bands
    dtype <- "Byte"
    for (b in bands) {
        dtype <- dt_union(dtype, ds$getDataTypeName(b))
    }
    # sync as_raw with object property for Byte data
    if (!as_raw && ds$readByteAsRaw && dtype == "Byte") {
      as_raw <- TRUE
    }

    if (as_list) {
        r <- list()
    } else {
        # pre-allocate the output vector
        dtype_size <- dt_size(dtype)
        if (as_raw && dtype == "Byte") {
            r <- raw(out_xsize * out_ysize * length(bands))
        } else if (dt_is_complex(dtype)) {
            r <- complex(out_xsize * out_ysize * length(bands))
        } else if (dt_is_floating(dtype) || dtype_size > 4) {
            r <- numeric(out_xsize * out_ysize * length(bands))
        } else if (dtype_size == 4 && !dt_is_signed(dtype)) {
            r <- numeric(out_xsize * out_ysize * length(bands))
        } else {
            r <- integer(out_xsize * out_ysize * length(bands))
        }
    }

    readByteAsRaw <- ds$readByteAsRaw
    if (as_raw) {
        ds$readByteAsRaw <- TRUE
        if (dtype != "Byte") {
            warning("'as_raw = TRUE' only affects read for band type 'Byte'",
                    call. = FALSE)
        }
    }

    dtype <- character()
    i <- 1
    for (b in bands) {
        dtype <- c(dtype, ds$getDataTypeName(b))
        if (as_list) {
            r[[i]] <- ds$read(b, xoff, yoff, xsize, ysize,
                              out_xsize, out_ysize)
        } else {
            i_begin <- 1 + (i - 1) * out_xsize * out_ysize
            i_end <- i_begin + out_xsize * out_ysize - 1
            r[i_begin:i_end] <- ds$read(b, xoff, yoff, xsize, ysize,
                                        out_xsize, out_ysize)
        }
        i <- i + 1
    }

    ## restore the field, note that it may have had no impact
    ds$readByteAsRaw <- readByteAsRaw

    gt <- ds$getGeoTransform()
    ulxy <- .apply_geotransform(gt, xoff, yoff)
    urxy <- .apply_geotransform(gt, (xoff + xsize), yoff)
    lrxy <- .apply_geotransform(gt, (xoff + xsize), (yoff + ysize))
    llxy <- .apply_geotransform(gt, xoff, (yoff + ysize))
    corners_x <- c(ulxy[1], urxy[1], lrxy[1], llxy[1])
    corners_y <- c(ulxy[2], urxy[2], lrxy[2], llxy[2])
    bb <- c(min(corners_x), min(corners_y), max(corners_x), max(corners_y))

    # gis: a list with the bbox, dimensions, projection, nbands, datatype
    wkt_fmt_config <- get_config_option("OSR_WKT_FORMAT")
    if (wkt_fmt_config == "")
        set_config_option("OSR_WKT_FORMAT", "WKT2")
    attr(r, "gis") <- list(type = "raster",
                           bbox = bb,
                           dim = c(out_xsize, out_ysize, length(bands)),
                           srs = ds$getProjectionRef(),
                           datatype = dtype)
    set_config_option("OSR_WKT_FORMAT", wkt_fmt_config)

    return(r)
}


#' Create a raster from an existing raster as template
#'
#' @description
#' `rasterFromRaster()` creates a new raster with spatial reference,
#' extent and resolution taken from a template raster, without copying data.
#' Optionally changes the format, number of bands, data type and nodata value,
#' sets driver-specific dataset creation options, and initializes to a value.
#'
#' @param srcfile Source raster filename.
#' @param dstfile Output raster filename.
#' @param fmt Output raster format name (e.g., "GTiff" or "HFA"). Will attempt
#' to guess from the output filename if \code{fmt} is not specified.
#' @param nbands Number of output bands.
#' @param dtName Output raster data type name. Commonly used types include
#' `"Byte"` (or `"UInt8"` in GDAL >= 3.13), `"Int16"`, `"UInt16"`, `"Int32"`
#' and `"Float32"`.
#' @param options Optional list of format-specific creation options in a
#' vector of "NAME=VALUE" pairs
#' (e.g., \code{options = c("COMPRESS=LZW")} to set LZW compression
#' during creation of a GTiff file).
#' @param init Numeric value to initialize all pixels in the output raster.
#' @param dstnodata Numeric nodata value for the output raster.
#' @param quiet Logical value, `TRUE` to suppress informational messages.
#' @returns Returns the destination filename invisibly.
#'
#' @seealso
#' [`GDALRaster-class`][GDALRaster], [create()], [createCopy()],
#' [bandCopyWholeRaster()], [translate()]
#'
#' @examples
#' # band 2 in a FARSITE landscape file has slope degrees
#' # convert slope degrees to slope percent in a new raster
#' lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
#' ds_lcp <- new(GDALRaster, lcp_file)
#' ds_lcp$getMetadata(band = 2, domain = "")
#'
#' slpp_file <- file.path(tempdir(), "storml_slpp.tif")
#' opt = c("COMPRESS=LZW")
#' rasterFromRaster(srcfile = lcp_file,
#'                  dstfile = slpp_file,
#'                  nbands = 1,
#'                  dtName = "Int16",
#'                  options = opt,
#'                  init = -32767)
#' ds_slp <- new(GDALRaster, slpp_file, read_only = FALSE)
#'
#' # slpp_file is initialized to -32767 and nodata value set
#' ds_slp$getNoDataValue(band=1)
#'
#' # extent and cell size are the same as lcp_file
#' ds_lcp$bbox()
#' ds_lcp$res()
#' ds_slp$bbox()
#' ds_slp$res()
#'
#' # convert slope degrees in lcp_file band 2 to slope percent in slpp_file
#' # bring through LCP nodata -9999 to the output nodata value
#' ncols <- ds_slp$getRasterXSize()
#' nrows <- ds_slp$getRasterYSize()
#' for (row in 0:(nrows-1)) {
#'     rowdata <- ds_lcp$read(band = 2,
#'                            xoff = 0, yoff = row,
#'                            xsize = ncols, ysize = 1,
#'                            out_xsize = ncols, out_ysize = 1)
#'     rowslpp <- tan(rowdata*pi/180) * 100
#'     rowslpp[rowdata==-9999] <- -32767
#'     dim(rowslpp) <- c(1, ncols)
#'     ds_slp$write(band = 1, xoff = 0, yoff = row,
#'                  xsize = ncols, ysize = 1,
#'                  rasterData = rowslpp)
#' }
#'
#' # min, max, mean, sd
#' ds_slp$getStatistics(band = 1, approx_ok = FALSE, force = TRUE)
#'
#' ds_slp$close()
#' ds_lcp$close()
#' \dontshow{deleteDataset(slpp_file)}
#' @export
rasterFromRaster <- function(srcfile, dstfile, fmt=NULL, nbands=NULL,
                             dtName=NULL, options=NULL, init=NULL,
                             dstnodata=init, quiet=FALSE) {

    if (is.null(fmt)) {
        fmt <- .getGDALformat(dstfile)
        if (is.null(fmt)) {
            stop("use 'fmt' to specify a GDAL raster format name",
                 call. = FALSE)
        }
    }

    if (!is.null(init)) {
        if (!(is.numeric(init) && length(init) == 1))
            stop("'init' must be a single numeric value", call. = FALSE)
    }

    src_ds <- new(GDALRaster, srcfile, read.only=TRUE)
    if (is.null(nbands)) {
        nbands <- src_ds$getRasterCount()
    }
    nrows <- src_ds$getRasterYSize()
    ncols <- src_ds$getRasterXSize()
    gt <- src_ds$getGeoTransform()
    if (is.null(dtName))
        dtName <- src_ds$getDataTypeName(1)
    srs <- src_ds$getProjectionRef()
    src_ds$close()

    create(fmt, dstfile, ncols, nrows, nbands, dtName, options)
    dst_ds <- new(GDALRaster, dstfile, FALSE)
    dst_ds$setGeoTransform(gt)
    dst_ds$setProjection(srs)
    if (!is.null(dstnodata)) {
        for (b in 1:nbands) {
            dst_ds$setNoDataValue(b, dstnodata)
        }
    }

    if (!is.null(init)) {
        if (!quiet) {
            cli::cli_progress_step(
                "initializing destination raster...",
                msg_done = "done")
        }
        for (b in 1:nbands) {
            dst_ds$fillRaster(b, init, 0)
        }
    }

    dst_ds$close()
    return(invisible(dstfile))
}


#' Create a GDAL virtual raster derived from one source dataset
#'
#' @description
#' `rasterToVRT()` creates a virtual raster dataset (VRT format) derived from
#' one source dataset with options for virtual subsetting, virtually resampling
#' the source data at a different pixel resolution, or applying a virtual
#' kernel filter. (See [buildVRT()] for virtual mosaicing.)
#'
#' @details
#' `rasterToVRT()` can be used to virtually clip and pixel-align
#' various raster layers with each other or in relation to vector
#' polygon boundaries. It also supports VRT kernel filtering.
#'
#' A VRT dataset is saved as a plain-text file with extension .vrt. This file
#' contains a description of the dataset in an XML format. The description
#' includes the source raster filename which can be a full path
#' (`relativeToVRT = FALSE`) or relative path (`relativeToVRT = TRUE`).
#' For relative path, `rasterToVRT()` assumes that the .vrt file will be in
#' the same directory as the source file and uses `basename(srcfile)`. The
#' elements of the XML schema describe how the source data will be read, along
#' with algorithms potentially applied and so forth. Documentation of the XML
#' format for .vrt is at:
#' \url{https://gdal.org/en/stable/drivers/raster/vrt.html}.
#'
#' Since .vrt is a small plain-text file it is fast to write and requires
#' little storage space. Read performance is not degraded for certain simple
#' operations (e.g., virtual clip without resampling). Reading will be
#' slower for virtual resampling to a different pixel resolution or virtual
#' kernel filtering since the operations are performed on-the-fly (but .vrt
#' does not require the up front writing of a resampled or kernel-filtered
#' raster to a regular format). VRT is sometimes useful as an intermediate
#' raster in a series of processing steps, e.g., as a `tempfile` (the
#' default).
#'
#' GDAL VRT format has several capabilities and uses beyond those
#' covered by `rasterToVRT()`. See the URL above for a full discussion.
#'
#' @note
#' Pixel alignment is specified in terms of the source raster pixels (i.e.,
#' `srcfile` of the virtual raster). The use case in mind is virtually
#' clipping a raster to the bounding box of a vector polygon and keeping
#' pixels aligned with `srcfile` (`src_align = TRUE`). `src_align` would be
#' set to `FALSE` if the intent is "target alignment". For example, if
#' `subwindow` is the bounding box of another raster with a different layout,
#' then also setting `resolution` to the pixel resolution of the target raster
#' and `src_align = FALSE` will result in a virtual raster pixel-aligned with
#' the target (i.e., pixels in the virtual raster are no longer aligned with
#' its `srcfile`). Resampling defaults to `nearest` if not specified.
#' Examples for both cases of `src_align` are given below.
#'
#' `rasterToVRT()` assumes `srcfile` is a north-up raster.
#'
#' @param srcfile Source raster filename.
#' @param relativeToVRT Logical. Indicates whether the source filename should
#' be interpreted as relative to the .vrt file (`TRUE`) or not relative
#' to the .vrt file (`FALSE`, the default). If `TRUE`, the .vrt
#' file is assumed to be in the same directory as `srcfile` and
#' `basename(srcfile)` is used in the .vrt file. Use `TRUE` if the .vrt file
#' will always be stored in the same directory with `srcfile`.
#' @param vrtfile Output VRT filename.
#' @param resolution A numeric vector of length two (xres, yres). The pixel
#' size must be expressed in georeferenced units. Both must be positive values.
#' The source pixel size is used if `resolution` is not specified.
#' @param subwindow A numeric vector of length four (xmin, ymin, xmax, ymax).
#' Selects `subwindow` of the source raster with corners given in
#' georeferenced coordinates (in the source CRS).
#' If not given, the upper left corner of the VRT will be the
#' same as source, and the VRT extent will be the same or larger than source
#' depending on `resolution`.
#' @param src_align Logical.
#'   * `TRUE`: the upper left corner of the VRT extent will be set to the
#'   upper left corner of the source pixel that contains `subwindow` xmin, ymax.
#'   The VRT will be pixel-aligned with source if the VRT `resolution` is the
#'   same as the source pixel size, otherwise VRT extent will be the minimum
#'   rectangle that contains `subwindow` for the given pixel size.
#'   Often, `src_align=TRUE` when selecting a raster minimum bounding box
#'   for a vector polygon.
#'   * `FALSE`: the VRT upper left corner will be exactly `subwindow`
#'   xmin, ymax, and the VRT extent will be the minimum rectangle that contains
#'   `subwindow` for the given pixel size. If `subwindow` is not given, the
#'   source raster extent is used in which case `src_align=FALSE` has no effect.
#'   Use `src_align=FALSE` to pixel-align two rasters of different sizes, i.e.,
#'   when the intent is target alignment.
#' @param resampling The resampling method to use if xsize, ysize of the VRT is
#' different than the size of the underlying source rectangle (in number of
#' pixels). The values allowed are nearest, bilinear, cubic, cubicspline,
#' lanczos, average and mode (as character).
#' @param krnl A filtering kernel specified as pixel coefficients.
#' `krnl` is a array with dimensions (size, size), where
#' size must be an odd number. `krnl` can also be given as a vector with
#' length size x size. For example, a 3x3 average filter is given by:
#' \preformatted{
#' krnl <- c(0.11111, 0.11111, 0.11111,
#'           0.11111, 0.11111, 0.11111,
#'           0.11111, 0.11111, 0.11111)
#' }
#' A kernel cannot be applied to sub-sampled or over-sampled data.
#' @param normalized Logical. Indicates whether the kernel is normalized.
#' Defaults to `TRUE`.
#' @param krnl_fn Character string specifying a function to compute on the
#' given `krnl`. Must be one of `"min"`, `"max"`, `"stddev"`, `"median"` or
#' `"mode"`. _Requires GDAL >= 3.12_. E.g., to compute the median value in a
#' 3x3 neighborhood around each pixel:
#' \preformatted{
#' krnl <- c(1, 1, 1,
#'           1, 1, 1,
#'           1, 1, 1)
#'
#' krnl_fn <- "median"
#' }
#' @returns Returns the VRT filename invisibly.
#'
#' @seealso
#' [`GDALRaster-class`][GDALRaster], [bbox_from_wkt()], [buildVRT()]
#'
#' [warp()] can write VRT for virtual reprojection
#'
#' @examples
#' ## resample
#'
#' evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
#' ds <- new(GDALRaster, evt_file)
#' ds$res()
#' ds$bbox()
#' ds$close()
#'
#' # table of the unique pixel values and their counts
#' tbl <- buildRAT(evt_file)
#' print(tbl)
#' sum(tbl$COUNT)
#'
#' # resample at 90-m resolution
#' # EVT is thematic vegetation type so use a majority value
#' vrt_file <- rasterToVRT(evt_file,
#'                         resolution = c(90, 90),
#'                         resampling = "mode")
#'
#' # .vrt is a small xml file pointing to the source raster
#' file.size(vrt_file)
#'
#' tbl90m <- buildRAT(vrt_file)
#' print(tbl90m)
#' sum(tbl90m$COUNT)
#'
#' ds <- new(GDALRaster, vrt_file)
#' ds$res()
#' ds$bbox()
#' ds$close()
#' \dontshow{vsi_unlink(vrt_file)}
#'
#' ## clip
#'
#' evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
#' ds_evt <- new(GDALRaster, evt_file)
#' ds_evt$bbox()
#'
#' # WKT string for a boundary within the EVT extent
#' bnd = "POLYGON ((324467.3 5104814.2, 323909.4 5104365.4, 323794.2
#' 5103455.8, 324970.7 5102885.8, 326420.0 5103595.3, 326389.6 5104747.5,
#' 325298.1 5104929.4, 325298.1 5104929.4, 324467.3 5104814.2))"
#'
#' # src_align = TRUE
#' vrt_file <- rasterToVRT(evt_file,
#'                         subwindow = bbox_from_wkt(bnd),
#'                         src_align = TRUE)
#' ds_vrt <- new(GDALRaster, vrt_file)
#'
#' # VRT is a virtual clip, pixel-aligned with the EVT raster
#' bbox_from_wkt(bnd)
#' ds_vrt$bbox()
#' ds_vrt$res()
#' ds_vrt$close()
#' \dontshow{vsi_unlink(vrt_file)}
#'
#' # src_align = FALSE
#' vrt_file <- rasterToVRT(evt_file,
#'                         subwindow = bbox_from_wkt(bnd),
#'                         src_align = FALSE)
#' ds_vrt_noalign <- new(GDALRaster, vrt_file)
#'
#' # VRT upper left corner (xmin, ymax) is exactly bnd xmin, ymax
#' ds_vrt_noalign$bbox()
#' ds_vrt_noalign$res()
#'
#' ds_vrt_noalign$close()
#' ds_evt$close()
#' \dontshow{vsi_unlink(vrt_file)}
#'
#'
#' ## subset and pixel align two rasters
#'
#' # FARSITE landscape file for the Storm Lake area
#' lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
#' ds_lcp <- new(GDALRaster, lcp_file)
#'
#' # Landsat band 5 file covering the Storm Lake area
#' b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
#' ds_b5 <- new(GDALRaster, b5_file)
#'
#' ds_lcp$bbox()  # 323476.1 5101872.0  327766.1 5105082.0
#' ds_lcp$res()   # 30 30
#'
#' ds_b5$bbox()   # 323400.9 5101815.8  327870.9 5105175.8
#' ds_b5$res()    # 30 30
#'
#' # src_align = FALSE because we need target alignment in this case:
#' vrt_file <- rasterToVRT(b5_file,
#'                         resolution = ds_lcp$res(),
#'                         subwindow = ds_lcp$bbox(),
#'                         src_align = FALSE)
#' ds_b5vrt <- new(GDALRaster, vrt_file)
#'
#' ds_b5vrt$bbox() # 323476.1 5101872.0  327766.1 5105082.0
#' ds_b5vrt$res()  # 30 30
#'
#' # read the the Landsat file pixel-aligned with the LCP file
#' # summarize band 5 reflectance where FBFM = 165
#' # LCP band 4 contains FBFM (a classification of fuel beds):
#' ds_lcp$getMetadata(band = 4, domain = "")
#'
#' # verify Landsat nodata (0):
#' ds_b5vrt$getNoDataValue(band=1)
#' # will be read as NA and omitted from stats
#' rs <- new(RunningStats, na_rm = TRUE)
#'
#' ncols <- ds_lcp$getRasterXSize()
#' nrows <- ds_lcp$getRasterYSize()
#' for (row in 0:(nrows-1)) {
#'     row_fbfm <- ds_lcp$read(band = 4, xoff = 0, yoff = row,
#'                             xsize = ncols, ysize = 1,
#'                             out_xsize = ncols, out_ysize = 1)
#'     row_b5 <- ds_b5vrt$read(band = 1, xoff = 0, yoff = row,
#'                             xsize = ncols, ysize = 1,
#'                             out_xsize = ncols, out_ysize = 1)
#' 	   rs$update(row_b5[row_fbfm == 165])
#' }
#' rs$get_count()
#' rs$get_mean()
#' rs$get_min()
#' rs$get_max()
#' rs$get_sum()
#' rs$get_var()
#' rs$get_sd()
#'
#' ds_b5vrt$close()
#' ds_lcp$close()
#' ds_b5$close()
#' \dontshow{vsi_unlink(vrt_file)}
#' @export
rasterToVRT <- function(srcfile,
                        relativeToVRT = FALSE,
                        vrtfile = tempfile("tmprast", fileext=".vrt"),
                        resolution = NULL,
                        subwindow = NULL,
                        src_align = TRUE,
                        resampling = "nearest",
                        krnl = NULL,
                        normalized = TRUE,
                        krnl_fn = NULL) {

    if (relativeToVRT) relativeToVRT <- 1 else relativeToVRT <- 0
    if (normalized) normalized <- 1 else normalized <- 0

    src_ds <- new(GDALRaster, srcfile)
    src_gt <- src_ds$getGeoTransform()
    src_bbox <- src_ds$bbox()
    src_xmin <- src_bbox[1]
    src_ymin <- src_bbox[2]
    src_xmax <- src_bbox[3]
    src_ymax <- src_bbox[4]
    src_xres <- src_gt[2]
    src_yres <- src_gt[6]
    src_bands <- src_ds$getRasterCount()
    src_ds$close()

    if (!is.null(resolution) && !is.null(krnl)) {
        if (src_xres != resolution[1] || src_yres != resolution[2])
            stop("cannot apply a kernel to sub-sampled or over-sampled data",
                 call. = FALSE)
    }

    if (!is.null(krnl)) {
        if ((length(krnl) %% 2) == 0)
            stop("kernel size must be an odd number", call. = FALSE)
    }

    if (!is.null(krnl_fn)) {
        if (gdal_version_num() < gdal_compute_version(3, 12, 0)) {
            stop("'krnl_fn' requires GDAL >= 3.12", call. = FALSE)
        }
        if (!(is.character(krnl_fn) && length(krnl_fn) == 1)) {
            stop("'krnl_fn' must be a character string", call. = FALSE)
        }
        if (!(tolower(krnl_fn) %in%
                c("min", "max", "stddev", "median", "mode"))) {
            stop("'krnl_fn' not recognized", call. = FALSE)
        }
    }

    tmp_vrtfile <- tempfile("src", fileext = ".vrt")
    createCopy("VRT", tmp_vrtfile, srcfile)

    if (is.null(resolution)) {
        vrt_xres <- src_xres
        vrt_yres <- src_yres
    } else {
        vrt_xres <- resolution[1]
        vrt_yres <- -resolution[2]
    }

    # src offsets
    if (is.null(subwindow)) {
        subwindow <- c(src_xmin, src_ymin, src_xmax, src_ymax)
    } else {
        if (subwindow[1] < src_xmin || subwindow[3] > src_xmax ||
                subwindow[2] < src_ymin || subwindow[4] > src_ymax) {

            stop("'subwindow' is not within source raster extent",
                 call. = FALSE)
        }
    }
    src_xoff <- floor(.getOffset(subwindow[1], src_xmin, src_xres))
    src_yoff <- floor(.getOffset(subwindow[4], src_ymax, src_yres))

    #get vrt geotransform and size (assuming a north-up raster)
    if (src_align) {
        #lay out the vrt raster so it is aligned with ul corner
        #of ul src pixel
        vrt_xmin <- src_xmin + src_xoff * src_xres
        vrt_ymax <- src_ymax + src_yoff * src_yres
    } else {
        #lay out the vrt raster with origin at the subwindow origin
        vrt_xmin <- subwindow[1]
        vrt_ymax <- subwindow[4]
    }
    vrt_ncols <- ceiling(.getOffset(subwindow[3], vrt_xmin, vrt_xres))
    vrt_xmax <- (vrt_xmin + vrt_ncols * vrt_xres)
    vrt_nrows <- ceiling(.getOffset(subwindow[2], vrt_ymax, vrt_yres))
    vrt_ymin <- (vrt_ymax + vrt_nrows * vrt_yres)
    vrt_gt <- c(vrt_xmin, vrt_xres, 0, vrt_ymax, 0, vrt_yres)
    srcwin_xsize <- ceiling(.getOffset(vrt_xmax, vrt_xmin, src_xres))
    srcwin_ysize <- ceiling(.getOffset(vrt_ymin, vrt_ymax, src_yres))

    x <- xml2::read_xml(tmp_vrtfile)

    xds <- xml2::xml_find_first(x, "/VRTDataset")
    xml2::xml_attrs(xds) <- c("rasterXSize" = as.character(vrt_ncols),
                              "rasterYSize" = as.character(vrt_nrows))

    xgt <- xml2::xml_find_first(x, "/VRTDataset/GeoTransform")
    xml2::xml_text(xgt) <- paste(vrt_gt, collapse=", ")

    xpath <- "/VRTDataset/VRTRasterBand/SimpleSource/SrcRect"
    xsrcrect <- xml2::xml_find_all(x, xpath)
    xml2::xml_attrs(xsrcrect) <- c("xOff" = as.character(src_xoff),
                                   "yOff" = as.character(src_yoff),
                                   "xSize" = as.character(srcwin_xsize),
                                   "ySize" = as.character(srcwin_ysize))

    xpath <- "/VRTDataset/VRTRasterBand/SimpleSource/DstRect"
    xdstrect <- xml2::xml_find_all(x, xpath)
    xml2::xml_attrs(xdstrect) <- c("xOff" = "0",
                                   "yOff" = "0",
                                   "xSize" = as.character(vrt_ncols),
                                   "ySize" = as.character(vrt_nrows))

    if (vrt_ncols != srcwin_xsize || vrt_nrows != srcwin_ysize) {
        xpath <- "/VRTDataset/VRTRasterBand/SimpleSource"
        xssrc <- xml2::xml_find_all(x, xpath)
        xml2::xml_attr(xssrc, "resampling") <- resampling
    }

    xpath <- "/VRTDataset/VRTRasterBand/SimpleSource/SourceFilename"
    xfn <- xml2::xml_find_all(x, xpath)
    if (relativeToVRT) {
        #this assumes the VRT file will be in the same directory as source file
        xml2::xml_attr(xfn, "relativeToVRT") <- "1"
        xml2::xml_text(xfn) <- basename(srcfile)
    } else {
        xml2::xml_attr(xfn, "relativeToVRT") <- "0"
        xml2::xml_text(xfn) <- srcfile
    }

    # clear statistics metadata if present
    xsrcstats <- xml2::xml_find_all(x,
                                    "//MDI[starts-with(@key, 'STATISTICS_')]")
    if (length(xsrcstats) != 0) {
        xml2::xml_text(xsrcstats) <- rep("", length(xsrcstats))
    }

    xml2::write_xml(x, vrtfile, options = c("format", "no_declaration"))

    if (!is.null(krnl)) {
        vrt_kernel_template <- paste0(
            "<KernelFilteredSource>\n",
            "  <SourceFilename relativeToVRT=\"%d\">%s</SourceFilename>\n",
            "  <SourceBand>%d</SourceBand>\n",
            "  <SrcRect xOff=\"%d\" yOff=\"%d\" xSize=\"%d\" ySize=\"%d\"/>\n",
            "  <DstRect xOff=\"0\" yOff=\"0\" xSize=\"%d\" ySize=\"%d\"/>\n",
            "  <Kernel normalized=\"%d\">\n",
            "    <Size>%d</Size>\n",
            "    <Coefs>%s</Coefs>\n",
            "  </Kernel>\n")

        if (!is.null(krnl_fn)) {
            # Function element as child of KernelFilteredSource in GDAL >= 3.12
            vrt_kernel_template <- paste0(
                vrt_kernel_template,
                "  <Function>_fn_</Function>\n")
        }

        vrt_kernel_template <- paste0(
            vrt_kernel_template,
            "</KernelFilteredSource>\n")

        vrt_ds <- new(GDALRaster, vrtfile, read_only = FALSE)
        if (relativeToVRT) srcfile <- basename(srcfile)
        for (band in seq_len(src_bands)) {
            krnl_xml <- enc2utf8(sprintf(vrt_kernel_template,
                                         relativeToVRT,
                                         srcfile,
                                         band,
                                         src_xoff,
                                         src_yoff,
                                         srcwin_xsize,
                                         srcwin_ysize,
                                         vrt_ncols,
                                         vrt_nrows,
                                         normalized,
                                         sqrt(length(krnl)),
                                         paste(krnl, collapse = " ")))

            if (!is.null(krnl_fn)) {
                krnl_xml <- gsub("_fn_", krnl_fn, krnl_xml, fixed = TRUE)
            }
            vrt_ds$setMetadataItem(band, "source_0", krnl_xml, "vrt_sources")
        }
        vrt_ds$close()
    }

    return(invisible(vrtfile))
}


#' Raster calculation
#'
#' @description
#' `calc()` evaluates an \R expression for each pixel in a raster layer or
#' stack of layers. Each layer is defined by a raster filename or dataset
#' object, band number, and a variable name to use in the \R expression. If not
#' specified, band defaults to `1` for each input raster. Variable names
#' default to `LETTERS` if not specified (`A` (layer 1), `B` (layer 2), ...).
#' All of the input layers must have the same extent and cell size.
#' The projection will be read from the first raster in the list of inputs.
#' Individual pixel coordinates are also available as variables in the
#' \R expression, as either x/y in the raster projected coordinate system or
#' inverse projected longitude/latitude.
#' Multi-band output is supported as of gdalraster 1.11.0.
#'
#' @details
#' The variables in `expr` are vectors of length raster xsize (i.e., row
#' vectors of the input raster layer(s), with length the number of raster
#' columns). The expression should return a vector also of length raster xsize
#' (an output row). Four special variable names are available in `expr`:
#' `pixelX` and `pixelY` provide pixel center coordinates in projection units.
#' `pixelLon` and `pixelLat` can also be used, in which case the pixel x/y
#' coordinates will be inverse projected to longitude/latitude
#' (in the same geographic coordinate system used by the input projection,
#' which is read from the first input raster). Note that inverse projection
#' adds computation time.
#'
#' To refer to specific bands in a multi-band input file, repeat the filename
#' or dataset object in `rasterfiles` and specify corresponding band numbers in
#' `bands`, along with optional variable names in `var.names`, e.g.,
#' \preformatted{
#' rasterfiles = c("multiband.tif", "multiband.tif")
#' bands = c(4, 5)
#' var.names = c("B4", "B5")
#' }
#'
#' Output will be written to `dstfile`. To update a file that already
#' exists, set `write_mode = "update"` and set `out_band` to an existing
#' band number(s) in `dstfile` (new bands cannot be created in `dstfile`).
#' `dstfile` can optionally be given as an object of class `GDALRaster` open
#' for write access.
#'
#' To write multi-band output, `expr` must return a vector of values
#' interleaved by band. This is equivalent to, and can also be returned as,
#' a matrix `m` with `nrow(m)` equal to `length()` of an input vector, and
#' `ncol(m)` equal to the number of output bands. In matrix form, each column
#' contains a vector of output values for a band.
#' `length(m)` must be equal to the `length()` of an input vector multiplied by
#' `length(out_band)`. The dimensions described above are assumed and not
#' read from the return value of `expr`.
#'
#' @param expr An \R expression as a character string (e.g., `"A + B"`).
#' @param rasterfiles Input rasters, either a character vector of filenames,
#' or a list with each element either a filename as character string or an
#' object of class `GDALRaster` (must be an open dataset for the latter).
#' @param bands Integer vector of band numbers to use for each raster layer.
#' @param var.names Character vector of variable names to use for each raster
#' layer.
#' @param dstfile Either a character string with the output raster filename, or
#' an object of class `GDALRaster` with which to write output. If given as an
#' object, the dataset must be open for write access, and the arguments below
#' related to raster creation are ignored (i.e., `fmt`, `dtName`, `options`,
#' `setRasterNodataValue`). The `write_mode` must be set to `"update"` for
#' writing with an existing dataset object.
#' @param fmt Output raster format name (e.g., "GTiff" or "HFA"). Will attempt
#' to guess from the output filename if not specified.
#' @param dtName Character name of output data type (e.g., Byte, UInt8
#' (GDAL >= 3.13), Int16, UInt16, Int32, UInt32, Float32).
#' @param out_band Integer band number(s) in `dstfile` for writing output.
#' Defaults to `1L`. Multi-band output is supported as of gdalraster 1.11.0,
#' in which case `out_band` would be a vector of band numbers.
#' @param options Optional list of format-specific creation options in a
#' vector of "NAME=VALUE" pairs
#' (e.g., \code{options = c("TILED=YES", "COMPRESS=LZW")} to set LZW compression
#' during creation of a tiled GTiff file).
#' @param nodata_value Numeric value to assign if `expr` returns `NA`.
#' @param setRasterNodataValue Logical value. `TRUE` will attempt to set the
#' raster format nodata value to `nodata_value`, or `FALSE` not to set a raster
#' nodata value on the output dataset.
#' @param write_mode Character string. Name of the file write mode for output.
#' One of:
#'   * `safe` - execution stops if `dstfile` already exists (no output written)
#'   * `overwrite` - if `dstfile` exists it will be overwritten with a new file
#'   * `update` - if `dstfile` exists, will attempt to open in update mode, or
#'   write to the existing dataset if `dstfile` is given as an object
#' @param quiet Logical value. If `TRUE`, a progress bar and informational
#' messages will not be displayed. Defaults to `FALSE`.
#' @param return_obj Logical value. If `TRUE`, an object of class
#' [`GDALRaster`][GDALRaster] opened on the newly created dataset will be
#' returned. The default is `FALSE`.
#' @param ... Additional arguments, none currently supported.
#' @returns By default, returns the output filename invisibly. An object of
#' class [`GDALRaster`][GDALRaster] open on the output dataset will be returned
#' if `return_obj = TRUE`.
#'
#' @seealso
#' [`GDALRaster-class`][GDALRaster], [combine()], [rasterToVRT()]
#'
#' @examples
#' ## Using pixel longitude/latitude
#'
#' # Hopkins bioclimatic index (HI) as described in:
#' # Bechtold, 2004, West. J. Appl. For. 19(4):245-251.
#' # Integrates elevation, latitude and longitude into an index of the
#' # phenological occurrence of springtime. Here it is relativized to
#' # mean values for an eight-state region in the western US.
#' # Positive HI means spring is delayed by that number of days relative
#' # to the reference position, while negative values indicate spring is
#' # advanced. The original equation had elevation units as feet, so
#' # converting m to ft in `expr`.
#'
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#'
#' # expression to calculate HI
#' expr <- "round( ((ELEV_M * 3.281 - 5449) / 100) +
#'                 ((pixelLat - 42.16) * 4) +
#'                 ((-116.39 - pixelLon) * 1.25) )"
#'
#' # calc() writes to a tempfile by default
#' hi_file <- calc(expr = expr,
#'                 rasterfiles = elev_file,
#'                 var.names = "ELEV_M",
#'                 dtName = "Int16",
#'                 nodata_value = -32767,
#'                 setRasterNodataValue = TRUE)
#'
#' ds <- new(GDALRaster, hi_file)
#' # min, max, mean, sd
#' ds$getStatistics(band = 1, approx_ok = FALSE, force = TRUE)
#' ds$close()
#' \dontshow{deleteDataset(hi_file)}
#'
#' ## Calculate normalized difference vegetation index (NDVI)
#' ## input rasters given as dataset objects
#' ## output to an in-memory raster (MEM format)
#'
#' # Landast band 4 (red) and band 5 (near infrared):
#' b4_file <- system.file("extdata/sr_b4_20200829.tif", package="gdalraster")
#' b4 <- new(GDALRaster, b4_file)
#' b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
#' b5 <- new(GDALRaster, b5_file)
#'
#' expr <- "((B5 * 0.0000275 - 0.2) - (B4 * 0.0000275 - 0.2)) /
#'          ((B5 * 0.0000275 - 0.2) + (B4 * 0.0000275 - 0.2))"
#'
#' (ndvi <- calc(expr, list(b4, b5), var.names = c("B4", "B5"), fmt = "MEM",
#'               dtName = "Float32", setRasterNodataValue = TRUE,
#'               return_obj = TRUE))
#'
#' plot_raster(ndvi, legend = TRUE,
#'             col_map_fn = c("#7b3294", "#c2a5cf", "#a6dba0", "#008837"),
#'             main = "Storm Lake NDVI 2020-08-29")
#'
#' ndvi$close()
#' b4$close()
#' b5$close()
#'
#' ## Reclassify a variable by rule set
#'
#' # Combine two raster layers and look for specific combinations. Then
#' # recode to a new value by rule set.
#' #
#' # Based on example in:
#' #   Stratton, R.D. 2009. Guidebook on LANDFIRE fuels data acquisition,
#' #   critique, modification, maintenance, and model calibration.
#' #   Gen. Tech. Rep. RMRS-GTR-220. U.S. Department of Agriculture,
#' #   Forest Service, Rocky Mountain Research Station. 54 p.
#' # Context: Refine national-scale fuels data to improve fire simulation
#' #   results in localized applications.
#' # Issue: Areas with steep slopes (40+ degrees) were mapped as
#' #   GR1 (101; short, sparse dry climate grass) and
#' #   GR2 (102; low load, dry climate grass) but were not carrying fire.
#' # Resolution: After viewing these areas in Google Earth,
#' #   NB9 (99; bare ground) was selected as the replacement fuel model.
#'
#' # look for combinations of slope >= 40 and FBFM 101 or 102
#' lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
#' rasterfiles <- c(lcp_file, lcp_file)
#' var.names <- c("SLP", "FBFM")
#' bands <- c(2, 4)
#' tbl <- combine(rasterfiles, var.names, bands)
#' nrow(tbl)
#' tbl_subset <- subset(tbl, SLP >= 40 & FBFM %in% c(101,102))
#' print(tbl_subset)       # twelve combinations meet the criteria
#' sum(tbl_subset$count)   # 85 total pixels
#'
#' # recode these pixels to 99 (bare ground)
#' # the LCP driver does not support in-place write so make a copy as GTiff
#' tif_file <- file.path(tempdir(), "storml_lndscp.tif")
#' createCopy("GTiff", tif_file, lcp_file)
#'
#' expr <- "ifelse( SLP >= 40 & FBFM %in% c(101,102), 99, FBFM)"
#' calc(expr = expr,
#'      rasterfiles = c(lcp_file, lcp_file),
#'      bands = c(2, 4),
#'      var.names = c("SLP", "FBFM"),
#'      dstfile = tif_file,
#'      out_band = 4,
#'      write_mode = "update")
#'
#' # verify the ouput
#' rasterfiles <- c(tif_file, tif_file)
#' tbl <- combine(rasterfiles, var.names, bands)
#' tbl_subset <- subset(tbl, SLP >= 40 & FBFM %in% c(101,102))
#' print(tbl_subset)
#' sum(tbl_subset$count)
#'
#' # if LCP file format is needed:
#' # createCopy("LCP", "storml_edited.lcp", tif_file)
#' \dontshow{deleteDataset(tif_file)}
#' @export
calc <- function(expr,
                 rasterfiles,
                 bands = NULL,
                 var.names = NULL,
                 dstfile = tempfile("rastcalc", fileext = ".tif"),
                 fmt = NULL,
                 dtName = "Int16",
                 out_band = 1L,
                 options = NULL,
                 nodata_value = NULL,
                 setRasterNodataValue = FALSE,
                 write_mode = "safe",
                 quiet = FALSE,
                 return_obj = FALSE,
                 ...) {

    calc_expr <- parse(text = expr)

    dstfile_exists <- TRUE
    dstfile_is_object <- FALSE
    output_name <- ""

    if (is(dstfile, "Rcpp_GDALRaster")) {
        dstfile_is_object <- TRUE
        if (!dstfile$isOpen() || dstfile$isReadOnly()) {
            stop("'dstfile' as dataset object must be open with write access",
                 call. = FALSE)
        }
        output_name <- dstfile$getDescription(0)
        fmt <- dstfile$getDriverShortName()
    } else if (is.character(dstfile) && length(dstfile) == 1) {
        output_name <- dstfile
        if (!vsi_stat_exists(dstfile))
            dstfile_exists <- FALSE
    } else {
        stop("'dstfile' must be a character string or GDALRaster object",
             call. = FALSE)
    }

    if (write_mode == "safe" && dstfile_exists)
        stop("'dstfile' already exists and 'write_mode' is \"safe\"",
             call. = FALSE)

    if (write_mode == "update" && is.null(out_band))
        stop("'out_band' must be specified for \"update\" mode",
             call. = FALSE)

    if (write_mode == "update") {
        update_mode <- TRUE
    } else if (write_mode == "safe" || write_mode == "overwrite") {
        update_mode <- FALSE
        if (is.null(out_band))
            out_band <- 1L
    } else {
        stop("unknown 'write_mode'", call. = FALSE)
    }

    nrasters <- length(rasterfiles)
    if (nrasters == 0)
        stop("'rasterfiles' is empty", call. = FALSE)

    if (!is.null(bands)) {
        if (length(bands) != nrasters) {
            stop("'bands' must have the same length as 'rasterfiles'",
                 call. = FALSE)
        }
    } else {
        bands <- rep(1L, nrasters)
    }

    if (!is.null(var.names)) {
        if (length(var.names) != nrasters) {
            stop("'var.names' must have the same length as 'rasterfiles'",
                 call. = FALSE)
        }
    } else {
        var.names <- LETTERS[1:nrasters]
    }

    for (nm in var.names) {
        if (!length(grep(nm, expr, fixed = TRUE)))
            stop("variable name '", nm, "' not in 'expr'", call. = FALSE)
    }

    if (is.null(fmt) && !dstfile_is_object) {
        fmt <- .getGDALformat(output_name)
        if (is.null(fmt)) {
            stop("use 'fmt' to specify the short name of a GDAL raster format",
                 call. = FALSE)
        }
    }
    fmt <- toupper(fmt)
    if (fmt == "MEM" && !return_obj) {
        stop("'return_obj' must be TRUE for \"MEM\" format", call. = FALSE)
    } else if (fmt == "MEM") {
        # by default, dstfile is a temporary .tif
        if (endsWith(dstfile, ".tif")) {
            # make a temp name for the MEM dataset
            f_tmp <- tempfile()
            suf <- substr(f_tmp, nchar(f_tmp) - 12 + 1, nchar(f_tmp))
            output_name <- paste0("calc", suf)
        }
    }

    if (is.null(nodata_value)) {
        nodata_value <- DEFAULT_NODATA[[dtName]]
        if (is.null(nodata_value)) {
            stop("a default nodata value is unknown for the given 'dtName'",
                 call. = FALSE)
        }
    }
    if (!(is.numeric(nodata_value) && length(nodata_value) == 1))
        stop("'nodata_value' must be a single numeric value", call. = FALSE)

    in_raster_is_object <- rep(FALSE, nrasters)
    if (is.list(rasterfiles)) {
        for (i in seq_along(rasterfiles)) {
            if (is(rasterfiles[[i]], "Rcpp_GDALRaster")) {
                if (!rasterfiles[[i]]$isOpen()) {
                    stop("'rasterfiles[[", i, "]]:' dataset is not open",
                         call. = FALSE)
                }
                in_raster_is_object[i] <- TRUE
            }
            else if (!is.character(rasterfiles[[i]])) {
                stop("'rasterfiles[[", i, "]]' is not a valid input type",
                     call. = FALSE)
            }
        }
    } else if (!is.character(rasterfiles)) {
        stop("'rasterfiles' must be a list or character vector", call. = FALSE)
    }

    # use first raster as reference
    if (in_raster_is_object[1])
        ref <- rasterfiles[[1]]
    else
        ref <- new(GDALRaster, rasterfiles[[1]])
    nrows <- as.integer(ref$getRasterYSize())
    ncols <- as.integer(ref$getRasterXSize())
    cellsizeX <- ref$res()[1]
    cellsizeY <- ref$res()[2]
    bb <- ref$bbox()
    xmin <- bb[1]
    ymax <- bb[4]
    gt <- ref$getGeoTransform()
    srs <- ref$getProjection()
    if (!in_raster_is_object[1])
        ref$close()

    if (nrasters > 1) {
        # currently only checking that raster dims are the same
        for (i in seq_along(rasterfiles[2:length(rasterfiles)])) {
            if (in_raster_is_object[i])
                ds <- rasterfiles[[i]]
            else
                ds <- new(GDALRaster, rasterfiles[[i]])

            dm <- ds$dim()
            fname <- ds$getDescription(0)

            if (!in_raster_is_object[i])
                ds$close()

            if (dm[1] != ncols || dm[2] != nrows) {
                cli::cli_alert_danger("incompatible dimension: {.val {fname}}")
                stop("all input rasters must have the same X size, Y size",
                     call. = FALSE)
            }
        }
    }

    if (update_mode) {
        # write to an existing raster
        if (dstfile_is_object)
            dst_ds <- dstfile
        else
            dst_ds <- new(GDALRaster, output_name, read_only = FALSE)

        dm <- dst_ds$dim()
        if (dm[2] != nrows || dm[1] != ncols) {
            if (!dstfile_is_object)
                dst_ds$close()
            stop("'dstfile' must have the same extent as the input rasters",
                 call. = FALSE)
        }

    } else {
        # create the output raster
        out_band <- as.integer(out_band)
        if (isFALSE(all.equal(out_band, seq_along(out_band)))) {
            stop("raster create: 'out_band' must be sequential starting at 1",
                 call. = FALSE)
        }

        dst_ds <- create(fmt, output_name, ncols, nrows, length(out_band),
                         dtName, options, TRUE)

        dst_ds$setGeoTransform(gt)
        dst_ds$setProjection(srs)
        if (setRasterNodataValue) {
            for (band in out_band) {
                dst_ds$setNoDataValue(band, nodata_value)
            }
        }
    }

    # list of GDALRaster objects for each raster layer
    ds_list <- vector("list", nrasters)
    for (i in seq_len(nrasters)) {
        if (in_raster_is_object[i])
            ds_list[[i]] <- rasterfiles[[i]]
        else
            ds_list[[i]] <- new(GDALRaster, rasterfiles[[i]])
    }

    # are pixel coordinates being used
    usePixelX <- FALSE
    usePixelY <- FALSE
    usePixelLonLat <- FALSE
    if (length(grep("pixelX", expr, fixed = TRUE)))
        usePixelX <- TRUE

    if (length(grep("pixelY", expr, fixed = TRUE)))
        usePixelY <- TRUE

    if (length(grep("pixelLon", expr, fixed = TRUE)) ||
            length(grep("pixelLat", expr, fixed = TRUE)))
        usePixelLonLat <- TRUE

    if (usePixelLonLat) {
        usePixelX <- TRUE
        usePixelY <- TRUE
    }

    if (usePixelX) {
        x <- seq(from = xmin + (cellsizeX / 2),
                 by = cellsizeX,
                 length.out = ncols)
        assign("pixelX", x)
    }

    # expected size of vector returned by expr
    num_out_bands <- length(out_band)
    expect_outrow_len <- ncols * num_out_bands

    process_row <- function(row) {
        if (usePixelY) {
            y <- rep((ymax - (cellsizeY / 2) - (cellsizeY * row)), ncols)
            assign("pixelY", y)
        }

        if (usePixelLonLat) {
            lonlat <- inv_project(cbind(x, y), srs)
            assign("pixelLon", lonlat[, 1])
            assign("pixelLat", lonlat[, 2])
        }

        for (i in seq_len(nrasters)) {
            inrow <- ds_list[[i]]$read(bands[i], 0, row, ncols, 1, ncols, 1)
            assign(var.names[i], inrow)
        }

        outrow <- eval(calc_expr)

        if (length(outrow) != expect_outrow_len) {
            if (!dstfile_is_object)
                dst_ds$close()
            for (i in seq_len(nrasters)) {
                if (!in_raster_is_object[i])
                    ds_list[[i]]$close()
            }
            stop("result vector is the wrong size", call. = FALSE)
        }

        outrow[is.na(outrow)] <- nodata_value
        dim(outrow) <- c(ncols, num_out_bands)
        i <- 1L
        for (b in out_band) {
            dst_ds$write(b, 0, row, ncols, 1, outrow[, i])
            i <- i + 1L
        }

        return()
    }

    # process by rows
    if (!quiet) {
        cli::cli_progress_bar(
            "Calculating...",
            format_done =
                "{cli::col_green(cli::symbol$tick)} Done ({cli::pb_elapsed})",
            total = nrows,
            clear = FALSE)
    }

    for (i in seq.int(0L, (nrows - 1L), 1L)) {
        process_row(i)
        if (!quiet)
            cli::cli_progress_update()
    }

    if (!quiet)
        cli::cli_progress_done()

    dst_ds$flushCache()
    if (!quiet)
        cli::cli_alert_info("output written to: {.val {output_name}}")

    for (i in seq_len(nrasters)) {
        if (!in_raster_is_object[i])
            ds_list[[i]]$close()
    }

    if (return_obj) {
        return(dst_ds)
    } else {
        if (!dstfile_is_object)
            dst_ds$close()
        return(invisible(output_name))
    }
}


#' Raster overlay for unique combinations
#'
#' @description
#' `combine()` overlays multiple rasters so that a unique ID is assigned to
#' each unique combination of input values. The input raster layers
#' typically have integer data types (floating point will be coerced to
#' integer by truncation), and must have the same projection, extent and cell
#' size. Pixel counts for each unique combination are obtained, and
#' combination IDs are optionally written to an output raster.
#'
#' @details
#' To specify input raster layers that are bands of a multi-band
#' raster file, repeat the filename in `rasterfiles` and provide the
#' corresponding band numbers in `bands`. For example:
#' \preformatted{
#' rasterfiles <- c("multi-band.tif", "multi-band.tif", "other.tif")
#' bands <- c(4, 5, 1)
#' var.names <- c("multi_b4", "multi_b5", "other")
#' }
#'
#' [rasterToVRT()] provides options for virtual clipping, resampling and pixel
#' alignment, which may be helpful here if the input rasters are not already
#' aligned on a common extent and cell size.
#'
#' If an output raster of combination IDs is written, the user should verify
#' that the number of combinations obtained did not exceed the range of the
#' output data type. Combination IDs are sequential integers starting at 1.
#' Typical output data types are the unsigned types:
#' Byte (`0` to `255`), UInt16 (`0` to `65535`) and UInt32 (the default, `0` to
#' `4294967295`).
#'
#' @param rasterfiles Character vector of raster filenames to combine.
#' @param var.names Character vector of `length(rasterfiles)` containing
#' variable names for each raster layer. Defaults will be assigned if
#' `var.names` are omitted.
#' @param bands Numeric vector of `length(rasterfiles)` containing the band
#' number to use for each raster in `rasterfiles`. Band 1 will be used for
#' each input raster if `bands` are not specified.
#' @param dstfile Character. Optional output raster filename for writing the
#' per-pixel combination IDs. The output raster will be created (and
#' overwritten if it already exists).
#' @param fmt Character. Output raster format name (e.g., "GTiff" or "HFA").
#' @param dtName Character. Output raster data type name. Combination IDs are
#' sequential integers starting at 1. The data type for the output raster
#' should be large enough to accommodate the potential number of unique
#' combinations of the input values
#' (e.g., "UInt16" or the default "UInt32").
#' @param options Optional list of format-specific creation options in a
#' vector of "NAME=VALUE" pairs
#' (e.g., \code{options = c("COMPRESS=LZW")} to set LZW compression
#' during creation of a GTiff file).
#' @param quiet Logical scalar. If `TRUE`, progress bar and messages will be
#' suppressed. Defaults to `FALSE`.
#' @returns A data frame with column `cmbid` containing the combination IDs,
#' column `count` containing the pixel counts for each combination,
#' and `length(rasterfiles)` columns named `var.names` containing the integer
#' values comprising each unique combination.
#'
#' @seealso
#' [`CmbTable-class`][CmbTable], [`GDALRaster-class`][GDALRaster], [calc()],
#' [rasterToVRT()]
#'
#' [buildRAT()] to compute a table of the unique pixel values and their counts
#' for a single raster layer
#'
#' @examples
#' evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
#' evc_file <- system.file("extdata/storml_evc.tif", package="gdalraster")
#' evh_file <- system.file("extdata/storml_evh.tif", package="gdalraster")
#' rasterfiles <- c(evt_file, evc_file, evh_file)
#' var.names <- c("veg_type", "veg_cov", "veg_ht")
#' tbl <- combine(rasterfiles, var.names)
#' nrow(tbl)
#' tbl <- tbl[order(-tbl$count),]
#' head(tbl, n = 20)
#'
#' # combine two bands from a multi-band file and write the combination IDs
#' # to an output raster
#' lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
#' rasterfiles <- c(lcp_file, lcp_file)
#' bands <- c(4, 5)
#' var.names <- c("fbfm", "tree_cov")
#' cmb_file <- file.path(tempdir(), "fbfm_cov_cmbid.tif")
#' opt <- c("COMPRESS=LZW")
#' tbl <- combine(rasterfiles, var.names, bands, cmb_file, options = opt)
#' head(tbl)
#' ds <- new(GDALRaster, cmb_file)
#' ds$info()
#' ds$close()
#' \dontshow{deleteDataset(cmb_file)}
#' @export
combine <- function(rasterfiles, var.names=NULL, bands=NULL,
                    dstfile=NULL, fmt=NULL, dtName="UInt32",
                    options=NULL, quiet=FALSE) {

    if ((!is.null(dstfile)) && (is.null(fmt))) {
        fmt <- .getGDALformat(dstfile)
        if (is.null(fmt)) {
            stop("use 'fmt' to specify a GDAL raster format name",
                 call. = FALSE)
        }
    }

    if (!is.null(options)) {
        if (!is.character(options))
            stop("'options' must be a character vector", call. = FALSE)
    }

    if (is.null(dstfile))
        dstfile <- ""

    if (is.null(fmt))
        fmt <- ""

    nrasters <- length(rasterfiles)
    if (is.null(var.names)) {
        for (n in 1:nrasters) {
            var.names[n] <- tools::file_path_sans_ext(basename(rasterfiles[n]))
        }
    }

    if (is.null(bands)) {
        bands <- rep(1, nrasters)
    }

    ref_ds <- new(GDALRaster, rasterfiles[1], read.only=TRUE)
    ref_nrows <- ref_ds$getRasterYSize()
    ref_ncols <- ref_ds$getRasterXSize()
    ref_res <- ref_ds$res()
    ref_ds$close()

    if (nrasters > 1) {
        for (i in 2:length(rasterfiles)) {
            ds <- new(GDALRaster, rasterfiles[i], read.only=TRUE)
            if ((ds$getRasterYSize() != ref_nrows) ||
                    (ds$getRasterXSize() != ref_ncols))
                stop("all input rasters must have the same extent/cell size",
                     call. = FALSE)
            if (!all(ds$res() == ref_res))
                stop("all input rasters must have the same extent/cell size",
                     call. = FALSE)
            ds$close()
        }
    }

    d <- .combine(rasterfiles, var.names, bands, dstfile, fmt, dtName,
                  options, quiet)

    return(d)
}


#' GDAL DEM processing
#'
#' @description
#' `dem_proc()` generates DEM derivatives from an input elevation raster. This
#' function is a wrapper for the \command{gdaldem} command-line utility.
#' See \url{https://gdal.org/en/stable/programs/gdaldem.html} for details.
#'
#' @param mode Character. Name of the DEM processing mode. One of hillshade,
#' slope, aspect, color-relief, TRI, TPI or roughness.
#' @param srcfile Filename of the source elevation raster.
#' @param dstfile Filename of the output raster.
#' @param mode_options An optional character vector of command-line options
#' (see [DEFAULT_DEM_PROC] for default values).
#' @param color_file Filename of a text file containing lines formatted as:
#' "elevation_value red green blue". Only used when `mode = "color-relief"`.
#' @param quiet Logical scalar. If `TRUE`, a progress bar will not be
#' displayed. Defaults to `FALSE`.
#' @returns Logical indicating success (invisible `TRUE`).
#' An error is raised if the operation fails.
#'
#' @note
#' Band 1 of the source elevation raster is read by default, but this can be
#' changed by including a `-b` command-line argument in `mode_options`.
#' See the \href{https://gdal.org/en/stable/programs/gdaldem.html}{documentation for
#' `gdaldem`} for a description of all available options for each processing
#' mode.
#'
#' @examples
#' ## hillshade
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' out_file <- file.path(tempdir(), "storml_hillshade.tif")
#' dem_proc("hillshade", elev_file, out_file)
#'
#' ds <- new(GDALRaster, out_file)
#' plot_raster(ds)
#'
#' ds$close()
#' \dontshow{deleteDataset(out_file)}
#' @export
dem_proc <- function(mode,
                     srcfile,
                     dstfile,
                     mode_options = DEFAULT_DEM_PROC[[mode]],
                     color_file = NULL,
                     quiet = FALSE) {

    if (is.null(DEFAULT_DEM_PROC[[mode]]))
        stop("DEM processing 'mode' not recognized", call.=FALSE)

    return(invisible(.dem_proc(mode,
                               srcfile,
                               dstfile,
                               mode_options,
                               color_file,
                               quiet)))
}


#' Check line of sight between pairs of point locations
#'
#' @description
#' `is_los_visible()` is an interface to GDAL's line-of-sight algorithm
#' implemented by `GDALIsLineOfSightVisible()` in the Algorithms C API
#' (\url{https://gdal.org/en/stable/api/gdal_alg.html}). It checks line of sight
#' across a DEM surface using a Bresenham algorithm. The function can operate
#' pairwise on sets of input points, or one-to-many. Requires GDAL >= 3.9.
#'
#' @param dem Either a character string giving the filename of the DEM
#' raster, or an object of class `GDALRaster` for the DEM.
#' @param ptsA A data frame or numeric matrix containing geospatial point
#' coordinates, or point geometries (with Z values) as a list of WKB raw vectors
#' or character vector of WKT strings. If data frame or matrix, the number of
#' columns must be three (x, y, z). May be also be given as a numeric vector for
#' one point (`c(x, y, z)`). If this argument contains a single point, then
#' line of sight will be checked between it and each point in `ptsB`, otherwise
#' `length(ptsA)` must equal `length(ptsB)`, and line of sight will be checked
#' pairwise.
#' @param ptsB The second set of points, as described above for `ptsA`.
#' @param band An integer value specifying the band number in `dem` to use.
#' Defaults to `1L`.
#' @param srsA An optional character string specifying the spatial reference
#' system for `ptsA`. May be in WKT format or any of the formats supported by
#' [srs_to_wkt()]. If this argument is `NULL` (the default), then `ptsA` are
#' assumed to be in the same coordinate reference system as `dem`. Otherwise,
#' `ptsA` will be reprojected from `srsA` to the spatial reference of `dem`.
#' @param srsB An optional character string specifying the spatial reference
#' system for `ptsB` (see above). Defaults to `NULL`. If not `NULL`, `ptsB` will
#' be reprojected from `srsB` to the spatial reference of `dem`.
#' @param ZinterpA A character string specifying the interpretation of the Z
#' values for `ptsA`. The default is `"RELATIVE_TO_DEM"`, in which case the
#' location heights of `ptsA` are obtained by querying the DEM surface and
#' adding the Z value given in `ptsA`. Alternatively, the Z values can be
#' interpreted as absolute heights to be used unmodified by setting this
#' argument to `"ACTUAL"`.
#' @param ZinterpB A character string specifying the interpretation of the Z
#' values for `ptsB`. See the description above for `ZinterpA`.
#' @param quiet A logical value with default of `FALSE`. If set to `TRUE`, will
#' suppress a progress bar and informational messages.
#' @returns A logical vector of `length(ptsB)`, `TRUE` for each pair of points
#' that are within line of sight, otherwise `FALSE`.
#' The checks are done pairwise if `(length(ptsA) == length(ptsB))`, or
#' one-to-many if `length(ptsA) == 1` and multiple points are given in `ptsB`.
#'
#' @note
#' Input coordinates must be within the raster bounds. `NA` will be returned if
#' either coordinate is outside the raster extent, or is missing a Z value.
#'
#' The GDAL documentation notes that line of sight is computed in raster
#' coordinate space, and thus may not be appropriate for some applications. For
#' example, datasets referenced against geographic coordinates at high latitudes
#' may have issues.
#'
#' In GDAL 3.9 through 3.12, a point exactly on the surface of the DEM is never
#' visible with `GDALIsLineOfSightVisible()`, even if viewed from a point
#' directly above. For a detailed description, see
#' \url{https://github.com/OSGeo/gdal/issues/12458}. A workaround for that case
#' is to set a small but negligible positive Z value (if using
#' `"RELATIVE_TO_DEM"`) for points that are intended to be on the DEM surface,
#' if appropriate for the use case. GDAL as of version 3.13 treats a point
#' exactly on the surface as visible
#' (\url{https://github.com/OSGeo/gdal/pull/14237}).
#'
#' @references
#' Roberto de Beauclair Seixas, Maur Riguette Mediano and Marcelo Gattass. 1999.
#' Efficient Line-of-Sight Algorithms for Real Terrain Data.
#'
#' @examplesIf gdal_version_num() >= gdal_compute_version(3, 9, 0)
#' dem <- system.file("extdata/storml_elev.tif", package="gdalraster")
#'
#' ## no reprojection, the point coordinates are in the same projection as DEM
#'
#' ## one-to-many
#' ptA <- c(324625.0, 5104724.0, 1.7)
#' ptsB <-c(324803.0, 5104517.0, 10,
#'          325286.0, 5102923.0, 10,
#'          323847.0, 5104538.0, 10)
#' ptsB <- matrix(ptsB, nrow = 3, ncol = 3, byrow = TRUE)
#'
#' is_los_visible(dem, ptA, ptsB)
#'
#' ## pairwise, same ptA location with varying height
#' ptsA <- c(324625.0, 5104724.0, 1,
#'           324625.0, 5104724.0, 10,
#'           324625.0, 5104724.0, 1000)
#' ptsA <- matrix(ptsA, nrow = 3, ncol = 3, byrow = TRUE)
#'
#' is_los_visible(dem, ptsA, ptsB)
#'
#' ## WKB points
#' (ptsA_wkb <- g_create("POINT", ptsA))
#'
#' # as WKT
#' g_wk2wk(ptsA_wkb)
#'
#' # or as ISO WKT
#' g_wk2wk(ptsA_wkb, as_iso = TRUE)
#'
#' is_los_visible(dem, ptsA_wkb, ptsB)
#'
#' ## reprojecting ptsA, and the DEM given as a dataset object
#' (ds <- new(GDALRaster, dem))
#'
#' ptsA_wkb_wgs84 <- g_transform(ptsA_wkb, ds$getSpatialRef(), "WGS84")
#' g_wk2wk(ptsA_wkb_wgs84)
#'
#' is_los_visible(ds, ptsA_wkb_wgs84, ptsB, srsA = "WGS84")
#'
#' ## read ptsB from a vector dataset, use original ptA
#'
#' dsn <- system.file("extdata/storml_los_pts_b.geojson", package="gdalraster")
#' (lyr <- new(GDALVector, dsn))
#'
#' (features <- lyr$fetch(-1))
#'
#' is_los_visible(ds, ptA, features$geom, srsB = lyr$getSpatialRef(),
#'                ZinterpB = "ACTUAL")
#'
#' ds$close()
#' lyr$close()
#' @export
is_los_visible <- function(dem, ptsA, ptsB, band = 1L,
                           srsA = NULL, srsB = NULL,
                           ZinterpA = "RELATIVE_TO_DEM",
                           ZinterpB = "RELATIVE_TO_DEM",
                           quiet = FALSE) {

    if (gdal_version_num() < gdal_compute_version(3, 9, 0))
        stop("is_los_visible() requires GDAL >= 3.9", call. = FALSE)

    ds <- NULL
    close_ds <- FALSE
    if (is(dem, "Rcpp_GDALRaster")) {
        ds <- dem
        if (!ds$isOpen()) {
            stop("raster dataset is not open", call. = FALSE)
        }
    } else if (is.character(dem) && length(dem) == 1) {
        ds <- new(GDALRaster, dem)
        close_ds <- TRUE
    } else {
        stop("'dem' must be a character string or GDALRaster object",
             call. = FALSE)
    }

    if (is.null(band))
        band <- 1L
    if (!(is.numeric(band) && length(band == 1)))
        stop("'band' must be a single numeric value", call. = FALSE)

    if (missing(ptsA) || is.null(ptsA))
        stop("'ptsA' is required", call. = FALSE)

    if (missing(ptsB) || is.null(ptsB))
        stop("'ptsB' is required", call. = FALSE)

    if (is.null(srsA))
        srsA <- ""
    else if (!is.character(srsA) || length(srsA) > 1)
        stop("'srsA' must be a character string", call. = FALSE)

    if (is.null(srsB))
        srsB <- ""
    else if (!is.character(srsB) || length(srsB) > 1)
        stop("'srsB' must be a character string", call. = FALSE)

    if (is.null(ZinterpA))
        ZinterpA <- "RELATIVE_TO_DEM"
    else if (!is.character(ZinterpA) || length(ZinterpA) > 1)
        stop("'ZinterpA' must be a character string", call. = FALSE)
    if (!(toupper(ZinterpA) %in% c("ACTUAL", "RELATIVE_TO_DEM"))) {
        stop("'ZinterpA' must be one of \"ACTUAL\" or \"RELATIVE_TO_DEM\"",
             call. = FALSE)
    }

    if (is.null(ZinterpB))
        ZinterpB <- "RELATIVE_TO_DEM"
    else if (!is.character(ZinterpB) || length(ZinterpB) > 1)
        stop("'ZinterpB' must be a character string", call. = FALSE)
    if (!(toupper(ZinterpB) %in% c("ACTUAL", "RELATIVE_TO_DEM"))) {
        stop("'ZinterpB' must be one of \"ACTUAL\" or \"RELATIVE_TO_DEM\"",
             call. = FALSE)
    }

    ptsA_in <- NULL
    if (is.raw(ptsA) || (is.list(ptsA) && is.raw(ptsA[[1]]) ||
        is.character(ptsA))) {

        if (is.character(ptsA))
            ptsA <- g_wk2wk(ptsA)

        if (is.raw(ptsA)) {
            geom_type <- g_name(ptsA)
        } else {
            geom_type <- g_name(ptsA[[1]])
        }
        if (!startsWith(geom_type, "POINT"))
            stop("'ptsA' does not contain a POINT geometry type", call. = FALSE)

        coords <- g_coords(ptsA)
        if (!is.null(coords$z)) {
            ptsA_in <- coords[, c("x", "y", "z")]
        } else {
            stop("'ptsA' does not contain Z values", call. = FALSE)
        }
    } else if (is.data.frame(ptsA) || is.matrix(ptsA) || is.vector(ptsA)) {
        ptsA_in <- ptsA
    } else {
        stop("'ptsA' is not a valid input type", call. = FALSE)
    }

    ptsB_in <- NULL
    if (is.raw(ptsB) || (is.list(ptsB) && is.raw(ptsB[[1]]) ||
        is.character(ptsB))) {

        if (is.character(ptsB))
            ptsB <- g_wk2wk(ptsB)

        if (is.raw(ptsB)) {
            geom_type <- g_name(ptsB)
        } else {
            geom_type <- g_name(ptsB[[1]])
        }
        if (!startsWith(geom_type, "POINT"))
            stop("'ptsB' does not contain a POINT geometry type", call. = FALSE)

        coords <- g_coords(ptsB)
        if (!is.null(coords$z)) {
            ptsB_in <- coords[, c("x", "y", "z")]
        } else {
            stop("'ptsB' does not contain Z values", call. = FALSE)
        }
    } else if (is.data.frame(ptsB) || is.matrix(ptsB) || is.vector(ptsB)) {
        ptsB_in <- ptsB
    } else {
        stop("'ptsB' is not a valid input type", call. = FALSE)
    }

    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    ret <- .isLineOfSightVisible(ds, band, ptsA_in, srsA, ZinterpA,
                                 ptsB_in, srsB, ZinterpB, quiet)

    if (close_ds)
        ds$close()

    return(ret)
}


#' Extract pixel values at geospatial point locations
#'
#' @description
#' `pixel_extract()` returns raster pixel values for a set of geospatial
#' point locations. The coordinates are given as a two-column matrix of x/y
#' values in the same spatial reference system as the input raster (unless
#' `xy_srs` is specified). Coordinates can also be given in a data frame with
#' an optional column of point IDs.
#' Values are extracted from all bands of the raster by default, or specific
#' band numbers may be given. An optional interpolation method may be specified
#' for bilinear (2 x 2 kernel), cubic convolution (4 x 4 kernel, GDAL >= 3.10),
#' or cubic spline (4 x 4 kernel, GDAL >= 3.10). Alternatively, an optional
#' kernel dimension `N` may be given to extract values of the individual pixels
#' within an `N x N` kernel centered on the pixel containing the point location.
#' If `xy_srs` is given, the function will attempt to transform the input points
#' to the projection of the raster with a call to `transform_xy()`.
#'
#' @param raster Either a character string giving the filename of a raster, or
#' an object of class `GDALRaster` for the source dataset.
#' @param xy A two-column numeric matrix or two-column data frame of geospatial
#' coordinates (x, y), or a vector for a single point (x, y), in the same
#' spatial reference system as `raster`. Can also be given as a data frame with
#' three or more columns, in which the first column must be a vector of point
#' IDs (`character` or `numeric`), and the second and third columns must contain
#' the geospatial coordinates (x, y).
#' @param bands Optional numeric vector of band numbers. All bands in `raster`
#' will be processed by default if not specified, or if `0` is given.
#' @param interp Optional character string specifying an interpolation method.
#' Must be one of `"bilinear"`, `"cubic"`, `"cubicspline"`, or `"nearest"` (the
#' default if not specified, i.e., no interpolation).
#' GDAL >= 3.10 is required for `"cubic"` and `"cubicspline"`.
#' @param krnl_dim Optional numeric value specifying the dimension `N` pixels
#' of an `N x N` kernel for which all individual pixel values will be returned.
#' Should be a positive whole number (will be coerced to integer by truncation).
#' Currently only supported when extracting from a single raster band. Ignored
#' if `interp` is specified as other than `"nearest"` (i.e., the kernel implied
#' by the interpolation method will always be used).
#' @param xy_srs Optional character string specifying the spatial reference
#' system for `xy`. May be in WKT format or any of the formats supported by
#' [srs_to_wkt()].
#' @param max_ram Numeric value giving the maximum amount of RAM (in MB) to
#' use for potentially copying a remote raster into memory for processing
#' (see Note). Defaults to 300 MB. Set to zero to disable potential copy of
#' remote files into memory.
#' @param as_data_frame Logical value, `TRUE` to return output as a data frame.
#' The default is to return a numeric matrix unless point IDs are present in
#' the first column of `xy` given as a data frame. In that latter case, the
#' output will always be a data frame with the point IDs in the first column.
#' @returns A numeric matrix or data frame of pixel values with number of rows
#' equal to the number of rows in `xy`. The number of columns is equal to the
#' number of `bands` (plus optional point ID column), or if `krnl_dim = N`
#' is used, number of columns is equal to `N * N` (plus optional point ID
#' column). Output is always a data frame if `xy` is given as a data frame with
#' a column of point IDs (`as_data_frame` will be ignored in that case).
#' Named columns indicate the band, e.g., `"b1"`. If `krnl_dim` is used, named
#' columns indicate band and pixel, e.g., `"b1_p1"`, `"b1_p2"`, ..., `"b1_p9"`
#' if `krnl_dim = 3`. Pixels are in left-to-right, top-to-bottom order in the
#' kernel.
#'
#' @note
#' Depending on the number of input points, extracting from a raster on a
#' remote filesystem may require a large number of HTTP range requests which
#' may be slow (i.e., URLs/remote VSI filesystems). In that case, it may be
#' faster to copy the raster into memory first (either as MEM format or to a
#' /vsimem/ filesystem).
#' `pixel_extract()` will attempt to automate that process if the total size
#' of file(s) that would be copied does not exceed the threshold given by
#' `max_ram`, and `nrow(xy) > 10` (requires GDAL >= 3.6).
#'
#' For alternative workflows that involve copying to local storage, the data
#' management functions (e.g., [copyDatasetFiles()]) and the VSI filesystem
#' functions (e.g., [vsi_is_local()], [vsi_stat()], [vsi_copy_file()]) may be
#' of interest.
#'
#' @examples
#' pt_file <- system.file("extdata/storml_pts.csv", package="gdalraster")
#' # id, x, y in NAD83 / UTM zone 12N, same as the raster
#' pts <- read.csv(pt_file)
#' print(pts)
#'
#' raster_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#'
#' pixel_extract(raster_file, pts)
#'
#' # or as GDALRaster object
#' ds <- new(GDALRaster, raster_file)
#' # optionally suppress progress reporting
#' # ds$quiet <- TRUE
#' pixel_extract(ds, pts)
#'
#' # interpolated values
#' pixel_extract(raster_file, pts, interp = "bilinear")
#'
#' # individual pixel values within a kernel
#' pixel_extract(raster_file, pts, krnl_dim = 3)
#'
#' # lont/lat xy
#' pts_wgs84 <- transform_xy(pts[-1], srs_from = ds$getProjection(),
#'                           srs_to = "WGS84")
#'
#' # transform the input xy
#' pixel_extract(ds, xy = pts_wgs84, xy_srs = "WGS84")
#'
#' ds$close()
pixel_extract <- function(raster, xy, bands = NULL, interp = NULL,
                          krnl_dim = NULL, xy_srs = NULL, max_ram = 300,
                          as_data_frame = NULL) {

    if (missing(xy) || is.null(xy))
        stop("'xy' is required", call. = FALSE)

    if (is.null(as_data_frame) || any(is.na(as_data_frame)))
        as_data_frame <- FALSE
    else if (!is.logical(as_data_frame) || length(as_data_frame) > 1)
        stop("'as_data_frame' must be a single logical value", call. = FALSE)

    return_df <- as_data_frame
    pt_ids <- NULL
    pt_id_name <- "ptid"
    xy_in <- NULL
    if (is.data.frame(xy)) {
        if (ncol(xy) >= 3) {
            if (!(is.character(xy[, 1]) || is.numeric(xy[, 1])) ||
                !is.numeric(xy[, 2]) || !is.numeric(xy[, 3])) {

                cat("xy[1:3] must have types: character or numeric, numeric, numeric\n")
                stop("the first three columns of 'xy' must contain point ID, x, y",
                     call. = FALSE)
            } else {
                return_df <- TRUE
                pt_ids <- xy[, 1]
                pt_id_name <- names(xy)[1]
                xy_in <- xy[, 2:3]
            }
        } else {
            if (ncol(xy) !=2 || !is.numeric(xy[, 1]) || !is.numeric(xy[, 2])) {
                stop("'xy' must have at least two numeric columns of x, y",
                     call. = FALSE)
            } else {
                xy_in <- xy
            }
        }
    } else if (!is.numeric(xy)) {
        stop("'xy' must be a numeric matrix or data frame", call. = FALSE)
    } else {
        xy_in <- xy
    }

    if (is.null(bands))
        bands <- 0
    else if (!is.numeric(bands) || any(is.na(bands))) {
        stop("'bands' must be a numeric vector of valid band numbers",
             call. = FALSE)
    }

    if (is.null(interp) || all(is.na(interp)))
        interp <- "nearest"
    else if (!is.character(interp) || length(interp) > 1)
        stop("'interp' must be a character string", call. = FALSE)

    if (is.null(krnl_dim) || all(is.na(krnl_dim)))
        krnl_dim <- 1L
    else if (!is.numeric(krnl_dim) || length(krnl_dim) > 1)
        stop("'krnl_dim' must be a numeric (integer) scalar", call. = FALSE)
    else
        krnl_dim <- trunc(krnl_dim)

    if (is.null(xy_srs) || all(is.na(xy_srs)))
        xy_srs <- ""
    else if (!is.character(xy_srs) || length(xy_srs) > 1)
        stop("'xy_srs' must be a character string", call. = FALSE)

    if (is.null(max_ram) || all(is.na(max_ram)))
        max_ram <- 0
    else if (!is.numeric(max_ram) || length(max_ram) > 1)
        stop("'max_ram' must be a numeric scalar", call. = FALSE)

    if (max_ram > (get_usable_physical_ram() / 1e6))
        stop("'max_ram' exceeds usable physical RAM", call. = FALSE)

    ds <- NULL
    if (is(raster, "Rcpp_GDALRaster")) {
        ds <- raster
        if (!ds$isOpen()) {
            stop("raster dataset is not open", call. = FALSE)
        }
    } else if (is.character(raster) && length(raster) == 1) {
        ds <- new(GDALRaster, raster)
        on.exit(ds$close(), add = TRUE)
    } else {
        stop("'raster' must be a character string or GDALRaster object",
             call. = FALSE)
    }

    # potentially copy to memory
    use_mem <- FALSE
    ds_mem <- NULL
    mem_dir <- ""
    f_mem <- ""
    f_in <- ds$getDescription(band = 0)
    if (max_ram > 0 && nrow(xy_in) > 10 &&
        gdal_version_num() >= gdal_compute_version(3, 6, 0) &&
        !vsi_is_local(f_in)) {

        # use MEM dataset if possible
        dm <- ds$dim()
        num_pixels <- dm[1] * dm[2] * dm[3]
        bytes_per_pixel <- 1
        for (b in seq_len(ds$getRasterCount())) {
            if (dt_size(ds$getDataTypeName(b)) > bytes_per_pixel) {
                bytes_per_pixel <- dt_size(ds$getDataTypeName(b))
            }
        }
        raw_size <- num_pixels * bytes_per_pixel
        if ((raw_size / 1e6) < max_ram) {
            if (!ds$quiet) {
                cli::cli_alert_info("copying to MEM dataset...")
            }
            ds_mem <- try(createCopy("MEM", "", f_in, return_obj = TRUE),
                          silent = ds$quiet)
            if (!is(ds_mem, "Rcpp_GDALRaster")) {
                if (!ds$quiet) {
                    cli::cli_alert_warning("copy to MEM failed")
                }
            } else {
                if (!ds$quiet) {
                    cli::cli_alert_success("using in-memory raster")
                }
                use_mem <- TRUE
                on.exit(ds_mem$close(), add = TRUE)
            }
        } else {

            # try copying to /vsimem instead
            f_size <- 0
            for (f in ds$getFileList()) {
                this_f_size <- vsi_stat(f, "size")
                if (this_f_size == -1) {
                    f_size <- -1
                    if (!ds$quiet) {
                        cli::cli_alert_warning("failed to get file size")
                    }
                    break
                }
                f_size <- f_size + this_f_size
            }
            if (f_size > 0 && (f_size / 1e6) < max_ram) {
                f_nopath <- .cpl_get_filename(f_in)
                mem_dir <- file.path("/vsimem", tempdir() |>
                    .cpl_get_basename())

                f_mem <- file.path(mem_dir, f_nopath)
                if (!ds$quiet) {
                    cli::cli_alert_info(
                        "copying remote file(s) to /vsimem/...")
                }

                res <- copyDatasetFiles(new_filename = f_mem,
                                        old_filename = f_in)

                if (!res) {
                    vsi_rmdir(mem_dir, recursive = TRUE)
                    if (!ds$quiet) {
                        cli::cli_alert_warning("copy to {.val {f_mem}} failed")
                    }
                } else {
                    ds_mem <- try(new(GDALRaster, f_mem), silent = TRUE)
                    if (!is(ds_mem, "Rcpp_GDALRaster")) {
                        vsi_rmdir(mem_dir, recursive = TRUE)
                        if (!ds$quiet) {
                            cli::cli_alert_warning("open {.val {f_mem}} failed")
                        }
                    } else {
                        use_mem <- TRUE
                        on.exit(ds_mem$close(), add = TRUE)
                        on.exit(res <- deleteDataset(f_mem), add = TRUE)
                        on.exit(res <- vsi_rmdir(mem_dir, recursive = TRUE),
                                add = TRUE)

                        if (!ds$quiet) {
                            cli::cli_alert_success("using in-memory raster")
                        }
                    }
                }
            }
        }

        if (!ds$quiet && !use_mem) {
            cli::cli_alert_info(
                "not using in-memory raster, processing remote file...")
        }
    }

    if (krnl_dim > 1 && (tolower(interp) == "nearest" ||
                         tolower(interp) == "near")) {

        # extend with VRT to handle krnl_dim > 1 along raster edges
        bb <- ds$bbox()
        res <- ds$res()
        xmin <- bb[1] - krnl_dim * res[1]
        ymin <- bb[2] - krnl_dim * res[2]
        xmax <- bb[3] + krnl_dim * res[1]
        ymax <- bb[4] + krnl_dim * res[2]

        args <- c("-of", "VRT", "-ot", "Float64", "-dstnodata", "NaN")
        args <- c(args, "-te", xmin, ymin, xmax, ymax)
        args <- c(args, "-tr", res[1], res[2])
        args <- c(args, "-ovr", "NONE")

        vrt_file <- tempfile(fileext = ".vrt")

        if (use_mem)
            warp(ds_mem, vrt_file, t_srs = "", cl_arg = args, quiet = TRUE)
        else
            warp(ds, vrt_file, t_srs = "", cl_arg = args, quiet = TRUE)

        ds_vrt <- new(GDALRaster, vrt_file)
        ret <- ds_vrt$pixel_extract(xy_in, bands, interp, krnl_dim, xy_srs)

        ds_vrt$close()
        vsi_unlink(vrt_file)

    } else {
        if (use_mem)
            ret <- ds_mem$pixel_extract(xy_in, bands, interp, krnl_dim, xy_srs)
        else
            ret <- ds$pixel_extract(xy_in, bands, interp, krnl_dim, xy_srs)
    }

    col_names <- colnames(ret)
    band_nums <- NULL
    if (bands[1] == 0)
        band_nums <- seq_len(ds$getRasterCount())
    else
        band_nums <- bands

    if (!((tolower(interp) %in% c("near", "nearest")) && krnl_dim > 1L)) {
        if (length(col_names) != length(band_nums)) {
            # should not be possible
            warning("number of output columns does not match number of bands",
                    call. = FALSE)
            cat("matrix output of GDALRaster::pixel_extract() returned\n")
            return(ret)
        }
        i <- 1
        ds_name <- tools::file_path_sans_ext(basename(ds$getDescription(0)))
        for (b in band_nums) {
            band_desc <- ds$getDescription(b)
            if (all(nzchar(band_desc))) {
                if (length(band_nums) > 1)
                    col_names[i] <- paste0(col_names[i], "_", band_desc)
                else
                    col_names[i] <- band_desc
            } else if (all(nzchar(ds_name))) {
                if (length(band_nums) > 1)
                    col_names[i] <- paste0(ds_name, "_", col_names[i])
                else
                    col_names[i] <- ds_name
            }
            i <- i + 1
        }
    }

    if (return_df) {
        if (is.null(pt_ids))
            pt_ids <- seq_len(nrow(ret))
        ret <- data.frame(pt_ids, ret)
        names(ret) <- make.names(c(pt_id_name, col_names), unique = TRUE)
    } else {
        colnames(ret) <- make.names(col_names, unique = TRUE)
    }

    return(ret)
}


#' Create a polygon feature layer from raster data
#'
#' @description
#' `polygonize()` creates vector polygons for all connected regions of pixels
#' in a source raster sharing a common pixel value. Each polygon is created
#' with an attribute indicating the pixel value of that polygon. A raster mask
#' may also be provided to determine which pixels are eligible for processing.
#' The function will create the output vector layer if it does not already
#' exist, otherwise it will try to append to an existing one.
#' This function is a wrapper of `GDALPolygonize` in the GDAL Algorithms API.
#' It provides essentially the same functionality as the `gdal_polygonize.py`
#' command-line program
#' (\url{https://gdal.org/en/stable/programs/gdal_polygonize.html}).
#'
#' @details
#' Polygon features will be created on the output layer, with polygon
#' geometries representing the polygons. The polygon geometries will be in the
#' georeferenced coordinate system of the raster (based on the geotransform of
#' the source dataset). It is acceptable for the output layer to already have
#' features. If the output layer does not already exist, it will be created
#' with coordinate system matching the source raster.
#'
#' The algorithm attempts to minimize memory use so that very large rasters can
#' be processed. However, if the raster has many polygons or very large/complex
#' polygons, the memory use for holding polygon enumerations and active polygon
#' geometries may grow to be quite large.
#'
#' The algorithm will generally produce very dense polygon geometries, with
#' edges that follow exactly on pixel boundaries for all non-interior pixels.
#' For non-thematic raster data (such as satellite images) the result will
#' essentially be one small polygon per pixel, and memory and output layer
#' sizes will be substantial. The algorithm is primarily intended for
#' relatively simple thematic rasters, masks, and classification results.
#'
#' @param raster_file Filename of the source raster.
#' @param out_dsn The destination vector filename to which the polygons will be
#' written (or database connection string).
#' @param out_layer Name of the layer for writing the polygon features. For
#' single-layer file formats such as `"ESRI Shapefile"`, the layer name is the
#' same as the filename without the path or extension (e.g., `out_dsn =
#' "path_to_file/polygon_output.shp"`, the layer name is `"polygon_output"`).
#' @param fld_name Name of an integer attribute field in `out_layer` to which
#' the pixel values will be written. Will be created if necessary when using an
#' existing layer.
#' @param out_fmt GDAL short name of the output vector format. If unspecified,
#' the function will attempt to guess the format from the filename/connection
#' string.
#' @param connectedness Integer scalar. Must be either `4` or `8`. For the
#' default 4-connectedness, pixels with the same value are considered connected
#' only if they touch along one of the four sides, while 8-connectedness
#' also includes pixels that touch at one of the corners.
#' @param src_band The band on `raster_file` to build the polygons from
#' (default is `1`).
#' @param mask_file Use the first band of the specified raster as a
#' validity mask (zero is invalid, non-zero is valid). If not specified, the
#' default validity mask for the input band (such as nodata, or alpha masks)
#' will be used (unless `nomask` is set to `TRUE`).
#' @param nomask Logical scalar. If `TRUE`, do not use the default validity
#' mask for the input band (such as nodata, or alpha masks).
#' Default is `FALSE`.
#' @param overwrite Logical scalar. If `TRUE`, overwrite `out_layer` if it
#' already exists. Default is `FALSE`.
#' @param dsco Optional character vector of format-specific creation options
#' for `out_dsn` (`"NAME=VALUE"` pairs).
#' @param lco Optional character vector of format-specific creation options
#' for `out_layer` (`"NAME=VALUE"` pairs).
#' @param quiet Logical scalar. If `TRUE`, a progress bar will not be
#' displayed. Defaults to `FALSE`.
#'
#' @note
#' The source pixel band values are read into a signed 64-bit integer buffer
#' (`Int64`) by `GDALPolygonize`, so floating point or complex bands will be
#' implicitly truncated before processing.
#'
#' When 8-connectedness is used, many of the resulting polygons will likely be
#' invalid due to ring self-intersection (in the strict OGC definition of
#' polygon validity). See `g_is_valid()` / `g_make_valid()` (single polygons
#' can become MultiPolygon' in the case of self-intersections).
#'
#' If writing to a SQLite database format as either `GPKG` (GeoPackage
#' vector) or `SQLite` (Spatialite vector), setting the
#' `SQLITE_USE_OGR_VFS` and `OGR_SQLITE_JOURNAL` configuration options may
#' increase performance substantially. If writing to `PostgreSQL`
#' (PostGIS vector), setting `PG_USE_COPY=YES` is faster:
#' ```
#' # SQLite: GPKG (.gpkg) and Spatialite (.sqlite)
#' # enable extra buffering/caching by the GDAL/OGR I/O layer
#' set_config_option("SQLITE_USE_OGR_VFS", "YES")
#' # set the journal mode for the SQLite database to MEMORY
#' set_config_option("OGR_SQLITE_JOURNAL", "MEMORY")
#'
#' # PostgreSQL / PostGIS
#' # use COPY for inserting data rather than INSERT
#' set_config_option("PG_USE_COPY", "YES")
#' ```
#'
#' @seealso
#' [rasterize()]
#'
#' `vignette("gdal-config-quick-ref")`
#'
#' @examples
#' evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
#' dsn <- file.path(tempdir(), "storm_lake.gpkg")
#' layer <- "lf_evt"
#' fld <- "evt_value"
#' set_config_option("SQLITE_USE_OGR_VFS", "YES")
#' set_config_option("OGR_SQLITE_JOURNAL", "MEMORY")
#' polygonize(evt_file, dsn, layer, fld)
#' set_config_option("SQLITE_USE_OGR_VFS", "")
#' set_config_option("OGR_SQLITE_JOURNAL", "")
#' \dontshow{deleteDataset(dsn)}
#' @export
polygonize <- function(raster_file,
                       out_dsn,
                       out_layer,
                       fld_name = "DN",
                       out_fmt = NULL,
                       connectedness = 4,
                       src_band = 1,
                       mask_file = NULL,
                       nomask = FALSE,
                       overwrite = FALSE,
                       dsco = NULL,
                       lco = NULL,
                       quiet = FALSE) {

    if (connectedness !=4 && connectedness != 8)
        stop("'connectedness' must be either 4 or 8", call. = FALSE)

    ds <- new(GDALRaster, raster_file, TRUE)
    srs <- ds$getProjectionRef()
    ds$close()

    if (!is.null(mask_file)) {
        ds <- new(GDALRaster, mask_file, TRUE)
        ds$close()
    } else {
        mask_file <- ""
    }

    if (!ogr_ds_exists(out_dsn, with_update = TRUE)) {
        if (ogr_ds_exists(out_dsn) && !overwrite) {
            msg <- "'out_dsn' exists but cannot be updated.\n"
            msg <- paste0(msg, "You may need to remove it first, ")
            msg <- paste0(msg, "or use 'overwrite = TRUE'.")
            stop(msg, call. = FALSE)
        }
    }

    if (ogr_ds_exists(out_dsn, with_update = TRUE) && overwrite) {
        deleted <- FALSE
        if (ogr_layer_exists(out_dsn, out_layer)) {
            deleted <- ogr_layer_delete(out_dsn, out_layer)
        }
        if (!deleted) {
            if (ogr_ds_layer_count(out_dsn) == 1) {
                if (vsi_stat(out_dsn, "type") == "file")
                    deleted <- deleteDataset(out_dsn)
            }
        }
        if (!deleted) {
            stop("cannot overwrite 'out_layer'", call. = FALSE)
        }
    }

    if (ogr_layer_exists(out_dsn, out_layer)) {
        if (!is.null(lco)) {
            warning("'lco' ignored since the layer already exists",
                    call. = FALSE)
        }
    }

    if (!ogr_ds_exists(out_dsn, with_update = TRUE)) {
        if (is.null(out_fmt))
            out_fmt <- .getOGRformat(out_dsn)
        if (is.null(out_fmt)) {
            cli::cli_alert_danger(
                "format driver cannot be determined for: {.val {out_dsn}}")
            stop("specify 'out_fmt' to create a new dataset", call. = FALSE)
        }
        if (!ogr_ds_create(out_fmt, out_dsn, out_layer, geom_type = "POLYGON",
                           srs = srs, fld_name = fld_name,
                           fld_type = "OFTInteger", dsco= dsco, lco = lco)) {

            stop("failed to create 'out_dsn'", call. = FALSE)
        }
    }

    if (!ogr_layer_exists(out_dsn, out_layer)) {
        res <- ogr_layer_create(out_dsn, out_layer, NULL, "POLYGON", srs, lco)
        if (!res)
            stop("failed to create 'out_layer'", call. = FALSE)
        if (fld_name != "") {
            res <- ogr_field_create(out_dsn, out_layer, fld_name = fld_name,
                                    fld_type = "OFTInteger")
            if (!res)
                stop("failed to create the output field", call. = FALSE)
        }
    }

    return(invisible(.polygonize(raster_file, src_band, out_dsn, out_layer,
                                 fld_name, mask_file, nomask, connectedness,
                                 quiet)))
}


#' Burn vector geometries into a raster
#'
#' @description
#' `rasterize()` burns vector geometries (points, lines, or polygons) into
#' the band(s) of a raster dataset. Vectors are read from any GDAL
#' OGR-supported vector format.
#' This function is a wrapper for the \command{gdal_rasterize} command-line
#' utility (\url{https://gdal.org/en/stable/programs/gdal_rasterize.html}).
#'
#' @param src_dsn Data source name for the input vector layer (filename or
#' connection string).
#' @param dstfile Either a character string giving the filename of the
#' output raster dataset, or an object of class `GDALRaster` for the output.
#' Must support update mode access. If given as a filename, this file will
#' be created (or overwritten if it already exists - see Note).
#' If given as a `GDALRaster` object for an existing dataset, then the affected
#' pixels are updated in-place (object must be open with write access).
#' @param band Numeric vector. The band(s) to burn values into (for existing
#' `dstfile`). The default is to burn into band 1. Not used when creating a
#' new raster.
#' @param layer Character vector of layer names(s) from `src_dsn`  that will be
#' used for input features. At least one layer name or a `sql` option must be
#' specified.
#' @param where An optional SQL WHERE style query string to select features to
#' burn in from the input `layer`(s).
#' @param sql An SQL statement to be evaluated against `src_dsn` to produce a
#' virtual layer of features to be burned in (alternative to `layer`).
#' @param burn_value A fixed numeric value to burn into a band for all
#' features. A numeric vector can be supplied, one burn value per band being
#' written to.
#' @param burn_attr Character string. Name of an attribute field on the
#' features to be used for a burn-in value. The value will be burned into all
#' output bands.
#' @param invert Logical scalar. `TRUE` to invert rasterization. Burn the fixed
#' burn value, or the burn value associated with the first feature, into all
#' parts of the raster not inside the provided polygon.
#' @param te Numeric vector of length four. Sets the output raster extent. The
#' values must be expressed in georeferenced units. If not specified, the
#' extent of the output raster will be the extent of the vector layer.
#' @param tr Numeric vector of length two. Sets the target pixel resolution.
#' The values must be expressed in georeferenced units. Both must be positive.
#' @param tap Logical scalar. (target aligned pixels) Align the coordinates of
#' the extent of the output raster to the values of `tr`, such that the
#' aligned extent includes the minimum extent. Alignment means that
#' xmin / resx, ymin / resy, xmax / resx and ymax / resy are integer values.
#' @param ts Numeric vector of length two. Sets the output raster size in
#' pixels (xsize, ysize). Note that `ts` cannot be used with `tr`.
#' @param dtName Character name of output raster data type, e.g., `Byte`,
#' `UInt8` (GDAL >= 3.13), `Int16`, `UInt16`, `Int32`, `UInt32`, `Float32`,
#' `Float64`. Defaults to `Float64`.
#' @param dstnodata	Numeric scalar. Assign a nodata value to output bands.
#' @param init Numeric vector. Pre-initialize the output raster band(s) with
#' these value(s). However, it is not marked as the nodata value in the output
#' file. If only one value is given, the same value is used in all the bands.
#' @param fmt Output raster format short name (e.g., `"GTiff"`). Will attempt
#' to guess from the output filename if `fmt` is not specified.
#' @param co Optional list of format-specific creation options for the output
#' raster in a vector of "NAME=VALUE" pairs
#' (e.g., \code{options = c("TILED=YES","COMPRESS=LZW")} to set LZW compression
#' during creation of a tiled GTiff file).
#' @param add_options An optional character vector of additional command-line
#' options to `gdal_rasterize` (see the `gdal_rasterize` documentation at the
#' URL above for all available options).
#' @param quiet Logical scalar. If `TRUE`, a progress bar will not be
#' displayed. Defaults to `FALSE`.
#' @returns Logical indicating success (invisible `TRUE`).
#' An error is raised if the operation fails.
#'
#' @note
#' `rasterize()` creates a new target raster when `dstfile` is given as a
#' filename (character string). In that case, some combination of the `fmt`,
#' `dstnodata`, `init`, `co`, `te`, `tr`, `tap`, `ts`, and `dtName` arguments
#' will be used. The resolution or size must be specified using either the `tr`
#' or `ts` argument for all new rasters. The target raster will be overwritten
#' if it already exists and any of these creation-related options are used.
#'
#' To update an existing raster in-place, an object of class `GDALRaster` may
#' be given for the `dstfile` argument. The `GDALRaster` object should be open
#' for write access.
#'
#' @seealso
#' [polygonize()]
#'
#' @examples
#' # MTBS fire perimeters for Yellowstone National Park 1984-2022
#' dsn <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
#' sql <- "SELECT * FROM mtbs_perims ORDER BY mtbs_perims.ig_year"
#' out_file <- file.path(tempdir(), "ynp_fires_1984_2022.tif")
#'
#' rasterize(src_dsn = dsn,
#'           dstfile = out_file,
#'           sql = sql,
#'           burn_attr = "ig_year",
#'           tr = c(90,90),
#'           tap = TRUE,
#'           dtName = "Int16",
#'           dstnodata = -9999,
#'           init = -9999,
#'           co = c("TILED=YES", "COMPRESS=LZW"))
#'
#' (ds <- new(GDALRaster, out_file))
#'
#' if (requireNamespace("scales")) {
#'   pal <- scales::viridis_pal(end = 0.8, direction = -1)(6)
#'   ramp <- scales::colour_ramp(pal)
#'   plot_raster(ds, legend = TRUE, col_map_fn = ramp, na_col = "#d9d9d9",
#'               main = "YNP Fires 1984-2022 - Most Recent Burn Year")
#' }
#'
#' ds$close()
#' \dontshow{deleteDataset(out_file)}
#' @export
rasterize <- function(src_dsn,
                      dstfile,
                      band = NULL,
                      layer = NULL,
                      where = NULL,
                      sql = NULL,
                      burn_value = NULL,
                      burn_attr = NULL,
                      invert = NULL,
                      te = NULL,
                      tr = NULL,
                      tap = NULL,
                      ts = NULL,
                      dtName = NULL,
                      dstnodata = NULL,
                      init = NULL,
                      fmt = NULL,
                      co = NULL,
                      add_options = NULL,
                      quiet = FALSE) {

    src_dsn <- .check_gdal_filename(src_dsn)

    dst_ds <- NULL
    if (is(dstfile, "Rcpp_GDALRaster")) {
        dst_ds <- dstfile
        if (!dst_ds$isOpen()) {
            stop("destination dataset is not open", call. = FALSE)
        }
    } else if (!(is.character(dstfile) && length(dstfile) == 1)) {
        stop("'dstfile' must be a character string or GDALRaster object",
             call. = FALSE)
    } else {
        dstfile <- .check_gdal_filename(dstfile)
    }

    argv <- character(0)

    if (!is.null(band)) {
        if (!is.numeric(band))
            stop("'band' must be numeric", call. = FALSE)
        for (b in band) {
            argv <- c(argv, "-b", b)
        }
    }

    if (!is.null(layer)) {
        if (!is.character(layer) || length(layer) > 1)
            stop("'layer' must be a length-1 character vector", call. = FALSE)
        for (l in layer) {
            argv <- c(argv, "-l", l)
        }
    }

    if (!is.null(where)) {
        if (is.character(where) && length(where) == 1)
            argv <- c(argv, "-where", where)
        else
            stop("'where' must be a length-1 character vector", call. = FALSE)
    }

    if (!is.null(sql)) {
        if (is.character(sql) && length(sql) == 1)
            argv <- c(argv, "-sql", sql)
        else
            stop("'sql' must be a length-1 character vector", call. = FALSE)
    }

    if (!is.null(burn_value)) {
        if (!is.numeric(burn_value))
            stop("'burn_value' must be numeric", call. = FALSE)
        for (value in burn_value) {
            argv <- c(argv, "-burn", value)
        }
    }

    if (!is.null(burn_attr)) {
        if (is.character(burn_attr) && length(burn_attr) == 1)
            argv <- c(argv, "-a", burn_attr)
        else
            stop("'burn_attr' must be a length-1 character vector",
                 call. = FALSE)
    }

    if (!is.null(invert)) {
        if (is.logical(invert) && length(invert) == 1) {
            if (invert)
                argv <- c(argv, "-i")
        } else {
            stop("'invert' must be a logical scalar", call. = FALSE)
        }
    }

    if (!is.null(te)) {
        if (is.numeric(te) && length(te) == 4)
            argv <- c(argv, "-te", te)
        else
            stop("'te' must be a numeric vector of length 4", call. = FALSE)
    }

    if (!is.null(tr)) {
        if (is.numeric(tr) && length(tr) == 2)
            argv <- c(argv, "-tr", tr)
        else
            stop("'tr' must be a numeric vector of length 2", call. = FALSE)
    }

    if (!is.null(tap)) {
        if (is.logical(tap) && length(tap) == 1) {
            if (tap)
                argv <- c(argv, "-tap")
        } else {
            stop("'tap' must be a logical scalar", call. = FALSE)
        }
    }

    if (!is.null(ts)) {
        if (!is.null(tr))
            stop("'ts' cannot be used with 'tr'", call. = FALSE)
        if (is.numeric(ts) && length(ts) == 2)
            argv <- c(argv, "-ts", ts)
        else
            stop("'ts' must be a numeric vector of length 2", call. = FALSE)
    }

    if (!is.null(dtName)) {
        if (is.character(dtName) && length(dtName) == 1)
            argv <- c(argv, "-ot", dtName)
        else
            stop("'dtName' must be a length-1 character vector",
                 call. = FALSE)
    }

    if (!is.null(dstnodata)) {
        if (is.numeric(dstnodata) && length(dstnodata) == 1)
            argv <- c(argv, "-a_nodata", dstnodata)
        else
            stop("'dstnodata' must be a numeric scalar", call. = FALSE)
    }

    if (!is.null(init)) {
        if (!is.numeric(init))
            stop("'init' must be numeric", call. = FALSE)
        for (value in init) {
            argv <- c(argv, "-init", value)
        }
    }

    if (!is.null(fmt)) {
        if (is.character(fmt) && length(fmt) == 1)
            argv <- c(argv, "-of", fmt)
        else
            stop("'fmt' must be a length-1 character vector",
                 call. = FALSE)
    }

    if (!is.null(co)) {
        if (!is.character(co))
            stop("'co' must be a character vector", call. = FALSE)
        for (name_value in co) {
            argv <- c(argv, "-co", name_value)
        }
    }

    if (!is.null(add_options)) {
        if (!is.character(add_options))
            stop("'add_options' must be a character vector", call. = FALSE)
        else
            argv <- c(argv, add_options)
    }

    if (!is.null(dst_ds)) {
        ret <- .rasterize(src_dsn, "", list(dst_ds), argv, quiet)
    } else {
        ret <- .rasterize(src_dsn, dstfile, list(), argv, quiet)
    }

    return(invisible(ret))
}


#' Read raster data as nativeRaster
#'
#' @description
#' `read_to_nativeRaster()` will read from a raster dataset that is already open
#' in a `GDALRaster` object and return a `nativeRaster` object suitable for fast
#' rendering. By default, it attempts to read the full raster extent at full
#' resolution.
#'
#' @details
#' The dataset must have 1, 3, or 4 bands of Byte/UInt8 data type. For 1-band
#' (grayscale) data, the value is replicated across RGB channels. For 3-band
#' data, bands are interpreted as RGB. For 4-band data, bands are interpreted
#' as RGBA.
#'
#' @param ds An object of class `GDALRaster` in open state, with 1, 3, or 4
#' bands of Byte/UInt8 data type.
#' @param xoff Integer. The pixel (column) offset to the top left corner of the
#' raster region to be read (zero to start from the left side).
#' @param yoff Integer. The line (row) offset to the top left corner of the
#' raster region to be read (zero to start from the top).
#' @param xsize Integer. The width in pixels of the region to be read.
#' @param ysize Integer. The height in pixels of the region to be read.
#' @param out_xsize Integer. The width in pixels of the output buffer into
#' which the desired region will be read (e.g., to read a reduced resolution
#' overview).
#' @param out_ysize Integer. The height in pixels of the output buffer into
#' which the desired region will be read (e.g., to read a reduced resolution
#' overview).
#' @returns An object of class `nativeRaster`.
#'
#' @note
#' By default, this function will attempt to read the full raster into memory.
#' It generally should not be called on large raster datasets using the default
#' argument values. Use `out_xsize` and `out_ysize` for quick setting to smallish values,
#' such as 1024.
#'
#' @seealso
#' [read_ds()], [`GDALRaster$readToNativeRaster()`][GDALRaster]
#'
#' @examples
#' # read an RGB image as nativeRaster
#' img_file <- system.file("help/figures/logo.png", package="survival")
#' if (file.exists(img_file)) {
#' ds <- new(GDALRaster, img_file)
#' r <- read_to_nativeRaster(ds)
#' bb <- ds$bbox()  ## will warn for non-spatial image but is harmless
#' ds$close()
#' plot(NA, xlab = "", ylab = "", asp = 1, xlim = bb[c(1, 3)], ylim = bb[c(2, 4)])
#' rasterImage(r, bb[1], bb[2], bb[3], bb[4])
#' }
#' @export
read_to_nativeRaster <- function(ds, xoff = 0, yoff = 0,
                                 xsize = ds$getRasterXSize(),
                                 ysize = ds$getRasterYSize(),
                                 out_xsize = xsize, out_ysize = ysize) {

  if (!is(ds, "Rcpp_GDALRaster")) {
    stop("'ds' must be an object of class GDALRaster", call. = FALSE)
  }
  if (is.null(xoff) || !(is.numeric(xoff) && length(xoff) == 1)) {
    stop("'xoff' must be a numeric value", call. = FALSE)
  }
  if (is.null(yoff) || !(is.numeric(yoff) && length(yoff) == 1)) {
    stop("'yoff' must be a numeric value", call. = FALSE)
  }
  if (is.null(xsize) || !(is.numeric(xsize) && length(xsize) == 1)) {
    stop("'xsize' must be a numeric value", call. = FALSE)
  }
  if (is.null(ysize) || !(is.numeric(ysize) && length(ysize) == 1)) {
    stop("'ysize' must be a numeric value", call. = FALSE)
  }
  if (is.null(out_xsize) ||
      !(is.numeric(out_xsize) && length(out_xsize) == 1)) {

    stop("'out_xsize' must be a numeric value", call. = FALSE)
  }
  if (is.null(out_ysize) ||
      !(is.numeric(out_ysize) && length(out_ysize) == 1)) {

    stop("'out_ysize' must be a numeric value", call. = FALSE)
  }

  ds$readToNativeRaster(xoff, yoff, xsize, ysize, out_xsize, out_ysize)
}

test_that(".getGDALformat works", {
    expect_equal(.getGDALformat("test.tif"), "GTiff")
    expect_equal(.getGDALformat("test.TIF"), "GTiff")
    expect_equal(.getGDALformat("test.img"), "HFA")
    expect_equal(.getGDALformat("test.vrt"), "VRT")
    expect_equal(.getGDALformat("test.VRT"), "VRT")
    expect_null(.getGDALformat("test.unknown"))
})

test_that("calc writes correct results", {
    # bioclimatic index
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    expr <- "round( ((ELEV_M * 3.281 - 5449) / 100) +
                ((pixelLat - 42.16) * 4) +
                ((-116.39 - pixelLon) * 1.25) )"
    hi_file <- calc(expr = expr,
                    rasterfiles = elev_file,
                    var.names = "ELEV_M",
                    dtName = "Int16",
                    setRasterNodataValue = TRUE)
    on.exit(deleteDataset(hi_file), add = TRUE)
    ds <- new(GDALRaster, hi_file)
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 2978)

    # NDVI, with return_obj = TRUE
    b4_file <- system.file("extdata/sr_b4_20200829.tif", package="gdalraster")
    b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
    expr <- "((B5 - B4) / (B5 + B4)) * 1000"  # rescale for checksum
    ndvi_file <- tempfile("ndvi", fileext = ".tif")
    on.exit(deleteDataset(ndvi_file), add = TRUE)
    ds <- calc(expr = expr,
               rasterfiles = c(b4_file, b5_file),
               var.names = c("B4", "B5"),
               dstfile = ndvi_file,
               dtName = "Float32",
               nodata_value = -32767,
               setRasterNodataValue = TRUE,
               quiet = TRUE,
               return_obj = TRUE)
    expect_true(is(ds, "Rcpp_GDALRaster"))
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 63632)

    # NDVI, output to MEM raster
    rm(ds)
    ds <- calc(expr = expr,
               rasterfiles = c(b4_file, b5_file),
               var.names = c("B4", "B5"),
               dstfile = "test_mem",
               fmt = "MEM",
               dtName = "Float32",
               nodata_value = -32767,
               setRasterNodataValue = TRUE,
               quiet = TRUE,
               return_obj = TRUE)
    expect_true(is(ds, "Rcpp_GDALRaster"))
    expect_equal(ds$getDescription(0), "test_mem")
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 63632)

    # NDVI, existing dataset object for dstfile
    rm(ds)
    ndvi_file <- tempfile("ndvi", fileext = ".tif")
    on.exit(deleteDataset(ndvi_file), add = TRUE)
    rasterFromRaster(b4_file, ndvi_file, dtName = "Float32",
                     dstnodata = -32767)
    ds <- new(GDALRaster, ndvi_file, read_only = FALSE)
    res <- calc(expr = expr,
                rasterfiles = c(b4_file, b5_file),
                var.names = c("B4", "B5"),
                dstfile = ds,
                write_mode = "update",
                quiet = TRUE)
    expect_true(is(ds, "Rcpp_GDALRaster"))
    expect_true(ds$isOpen())
    expect_equal(res, ds$getDescription(band = 0))
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 63632)

    # NDVI, both input rasters as dataset objects
    rm(ds)
    ds_b4 <- new(GDALRaster, b4_file)
    on.exit(ds_b4$close(), add = TRUE)
    ds_b5 <- new(GDALRaster, b5_file)
    on.exit(ds_b5$close(), add = TRUE)
    ds <- calc(expr = expr,
               rasterfiles = list(ds_b4, ds_b5),
               var.names = c("B4", "B5"),
               fmt = "MEM",
               dtName = "Float32",
               nodata_value = -32767,
               setRasterNodataValue = TRUE,
               quiet = TRUE,
               return_obj = TRUE)
    expect_true(is(ds, "Rcpp_GDALRaster"))
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 63632)

    # NDVI, rasters as a combination of filename and dataset object
    rm(ds)
    ds <- calc(expr = expr,
               rasterfiles = list(ds_b4, b5_file),
               var.names = c("B4", "B5"),
               fmt = "MEM",
               dtName = "Float32",
               nodata_value = -32767,
               setRasterNodataValue = TRUE,
               quiet = TRUE,
               return_obj = TRUE)
    expect_true(is(ds, "Rcpp_GDALRaster"))
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 63632)

    # recode
    lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
    tif_file <- tempfile("storml_lndscp", fileext = ".tif")
    on.exit(deleteDataset(tif_file), add = TRUE)
    createCopy("GTiff", tif_file, lcp_file)
    expr <- "ifelse( SLP >= 40 & FBFM %in% c(101,102), 99, FBFM)"
    calc(expr = expr,
         rasterfiles = c(lcp_file, lcp_file),
         bands = c(2, 4),
         var.names = c("SLP", "FBFM"),
         dstfile = tif_file,
         out_band = 4,
         write_mode = "update",
         quiet = TRUE)
    ds <- new(GDALRaster, tif_file)
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 28017)

    # multi-band output
    # https://github.com/firelab/gdalraster/issues/319
    # The user-defined function is included in `expr` here only for the
    # {testthat} special environment. Normally it could be defined in the
    # global environment and then referenced in `expr`.
    expr <- "to_terrainrgb <- function(dtm) {
               startingvalue <- 10000
               precision <- 0.1
               rfactor <- 256 * 256 * precision
               gfactor <- 256 * precision

               r <- floor((startingvalue + dtm) * (1 / precision) / 256 / 256)
               g <- floor((startingvalue + dtm - r * rfactor) *
                          (1 / precision) / 256)
               b <- floor((startingvalue + dtm - r * rfactor - g * gfactor) *
                          (1 / precision))

               return(c(r, g, b))
             }
             to_terrainrgb(ELEV)"

    out_file <- "/vsimem/multiband-calc.tif"
    on.exit(deleteDataset(out_file), add = TRUE)
    result <- calc(expr = expr,
                   rasterfiles = elev_file,
                   var.names = "ELEV",
                   dstfile = out_file,
                   dtName = "Byte",
                   out_band = 1:3,
                   nodata_value = 0,
                   quiet = TRUE)
    expect_equal(result, out_file)

    # revert out_file using `from_terrainrgb()`
    # The user-defined function is included in `expr` here only for the
    # {testthat} special environment. Normally it could be defined in the
    # global environment and then referenced in `expr`.
    expr <- "from_terrainrgb <- function(R, G, B) {
               elevation <- -10000 + ((R * 256 * 256 + G * 256 + B) * 0.1)
               return(elevation)
             }
             from_terrainrgb(R, G, B)"

    revert_file <- "/vsimem/multiband-calc-revert.tif"
    on.exit(deleteDataset(revert_file), add = TRUE)
    result <- calc(expr = expr,
                   rasterfiles = c(out_file, out_file, out_file),
                   bands = c(1, 2, 3),
                   var.names = c("R", "G", "B"),
                   dstfile = revert_file,
                   dtName = "Int16",
                   nodata_value = -10000,
                   setRasterNodataValue = TRUE,
                   quiet = TRUE)
    expect_equal(result, revert_file)
    # compare revert_file with the original elev_file
    ds <- new(GDALRaster, elev_file)
    orig_elev_values <- read_ds(ds)
    attributes(orig_elev_values) <- NULL
    ds$close()
    ds2 <- new(GDALRaster, revert_file)
    revert_elev_values <- read_ds(ds2)
    attributes(revert_elev_values) <- NULL
    ds2$close()
    expect_equal(revert_elev_values, orig_elev_values)
    expect_equal(mean(revert_elev_values, na.rm = TRUE),
                 mean(orig_elev_values, na.rm = TRUE))

    # test errors from input validation
    expr <- "((B5 - B4) / (B5 + B4))"
    # test with output file already existing using `revert_file` from above:
    expect_error(calc(expr = expr,
                      rasterfiles = c(b4_file, b5_file),
                      var.names = c("B4", "B5"),
                      dstfile = revert_file,
                      dtName = "Float32",
                      nodata_value = -32767,
                      setRasterNodataValue = TRUE))
    # with overwrite
    expect_no_error(calc(expr = expr,
                         rasterfiles = c(b4_file, b5_file),
                         var.names = c("B4", "B5"),
                         dstfile = revert_file,
                         dtName = "Float32",
                         nodata_value = -32767,
                         setRasterNodataValue = TRUE,
                         write_mode = "overwrite",
                         quiet = TRUE))

    expect_error(calc(expr = expr,
                      rasterfiles = c(b4_file, b5_file),
                      bands = 1,
                      var.names = c("B4", "B5"),
                      dtName = "Float32",
                      nodata_value = -32767,
                      setRasterNodataValue = TRUE))

    expect_error(calc(expr = expr,
                      rasterfiles = c(b4_file, b5_file),
                      var.names = c("B4", "B5", "err"),
                      dtName = "Float32",
                      nodata_value = -32767,
                      setRasterNodataValue = TRUE))

    expect_error(calc(expr = expr,
                      rasterfiles = c(b4_file, b5_file),
                      dtName = "Float32",
                      nodata_value = -32767,
                      setRasterNodataValue = TRUE))

    expect_error(calc(expr = expr,
                      rasterfiles = c(b4_file, b5_file),
                      var.names = c("B4", "B5"),
                      dstfile = "unknown_file_type.err",
                      dtName = "Float32",
                      nodata_value = -32767,
                      setRasterNodataValue = TRUE))

    expect_error(calc(expr = expr,
                      rasterfiles = c(b4_file, b5_file),
                      var.names = c("B4", "B5"),
                      dtName = "Int64",
                      setRasterNodataValue = TRUE))

    expect_error(calc(expr = expr,
                      rasterfiles = c(b4_file, elev_file),
                      var.names = c("B4", "B5"),
                      dtName = "Float32",
                      nodata_value = -32767,
                      setRasterNodataValue = TRUE))
})

test_that("combine writes correct output", {
    lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
    rasterfiles <- c(lcp_file, lcp_file)
    bands <- c(4, 5)
    var.names <- c("fbfm", "tree_cov")
    cmb_file <- paste0(tempdir(), "/", "fbfm_cov_cmbid.tif")
    on.exit(deleteDataset(cmb_file))
    df <- combine(rasterfiles, var.names, bands, cmb_file)
    expect_equal(nrow(df), 29)
    df <- NULL
    ds <- new(GDALRaster, cmb_file, TRUE)
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 43024)

    evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
    df <- combine(evt_file)
    expect_equal(nrow(df), 24)
})

test_that("rasterFromRaster works", {
    lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
    slpp_file <- paste0(tempdir(), "/", "storml_slpp.tif")
    on.exit(deleteDataset(slpp_file), add=TRUE)
    options = c("COMPRESS=LZW")
    rasterFromRaster(srcfile = lcp_file,
                     dstfile = slpp_file,
                     nbands = 1,
                     dtName = "Int16",
                     options = options,
                     init = -32767)
    ds <- new(GDALRaster, slpp_file, read_only=TRUE)
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 47771)

    slpp_file_img <- paste0(tempdir(), "/", "storml_slpp.img")
    on.exit(deleteDataset(slpp_file_img), add=TRUE)
    options = c("COMPRESSED=YES")
    rasterFromRaster(srcfile = lcp_file,
                     dstfile = slpp_file_img,
                     nbands = 1,
                     dtName = "Int16",
                     options = options,
                     init = -32767)
    ds <- new(GDALRaster, slpp_file, read_only=TRUE)
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 47771)

    slpp_file_envi <- paste0(tempdir(), "/", "storml_slpp")
    on.exit(deleteDataset(slpp_file_envi), add=TRUE)
    # error on unknown file format:
    expect_error(rasterFromRaster(srcfile = lcp_file,
                                  dstfile = slpp_file_envi,
                                  nbands = 1,
                                  dtName = "Int16",
                                  init = -32767))
    rasterFromRaster(srcfile = lcp_file,
                     dstfile = slpp_file_envi,
                     fmt = "ENVI",
                     nbands = 1,
                     dtName = "Int16",
                     init = -32767)
    ds <- new(GDALRaster, slpp_file_envi, read_only=TRUE)
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 47771)
})

test_that("rasterToVRT works", {
    ## resample
    evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
    vrt_file <- rasterToVRT(evt_file,
                            resolution = c(90,90),
                            resampling = "mode")
    on.exit(deleteDataset(vrt_file), add = TRUE)
    ds <- new(GDALRaster, vrt_file)
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 23684)

    ## clip raster to polygon extent
    bnd = "POLYGON ((324467.3 5104814.2, 323909.4 5104365.4, 323794.2
    5103455.8, 324970.7 5102885.8, 326420.0 5103595.3, 326389.6 5104747.5,
    325298.1 5104929.4, 325298.1 5104929.4, 324467.3 5104814.2))"

    # src_align = TRUE
    vrt_file <- rasterToVRT(evt_file,
                            subwindow = bbox_from_wkt(bnd),
                            src_align = TRUE)
    on.exit(deleteDataset(vrt_file), add = TRUE)
    ds <- new(GDALRaster, vrt_file)
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 18148)

    # src_align = FALSE
    vrt_file <- rasterToVRT(evt_file,
                            subwindow = bbox_from_wkt(bnd),
                            src_align = FALSE)
    on.exit(deleteDataset(vrt_file), add = TRUE)
    ds <- new(GDALRaster, vrt_file)
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 17631)

    # subwindow outside raster extent
    expect_error(rasterToVRT(evt_file,
                             subwindow = bbox_from_wkt(g_buffer(bnd, 10000)),
                             src_align = TRUE))

    ## subset and pixel align two rasters
    lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
    ds_lcp <- new(GDALRaster, lcp_file)
    b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
    vrt_file <- rasterToVRT(b5_file,
                            resolution = ds_lcp$res(),
                            subwindow = ds_lcp$bbox(),
                            src_align = FALSE)
    on.exit(deleteDataset(vrt_file), add = TRUE)
    ds_lcp$close()
    ds <- new(GDALRaster, vrt_file)
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 49589)

    ## kernel filter
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    krnl <- c(0.11111, 0.11111, 0.11111,
              0.11111, 0.11111, 0.11111,
              0.11111, 0.11111, 0.11111)
    vrt_file <- rasterToVRT(elev_file, krnl = krnl)
    on.exit(deleteDataset(vrt_file), add = TRUE)
    ds <- new(GDALRaster, vrt_file)
    dm <- ds$dim()
    chk <- ds$getChecksum(1, 0, 0, dm[1], dm[2])
    ds$close()
    expect_equal(chk, 46590)

    expect_error(rasterToVRT(elev_file, resolution = c(90,90), krnl = krnl))

    ## VRT kernel function GDAL >= 3.12
    skip_if(gdal_version_num() < gdal_compute_version(3, 12, 0))

    f <- tempfile(fileext = ".tif")
    on.exit(deleteDataset(f), add = TRUE)
    ds <- create(format = "GTiff", dst_filename = f, xsize = 3, ysize = 3,
                 nbands = 1, dataType = "Byte", return_obj = TRUE)
    ds$setGeoTransform(c(0.0, 5.0, 0.0, 5.0, 0.0, -5.0))
    v <- c(1, 2, 3, 4, 5, 6, 7, 8, 9)
    ds$write(1, 0, 0, 3, 3, v)
    ds$close()

    krnl <- c(1, 1, 1,
              1, 1, 1,
              1, 1, 1)

    vrt_min <- rasterToVRT(f, krnl = krnl, krnl_fn = "min")
    on.exit(deleteDataset(vrt_min), add = TRUE)
    ds <- new(GDALRaster, vrt_min)
    x <- ds$read(1, 1, 1, 1, 1, 1, 1)
    expect_equal(x, 1)
    ds$close()

    vrt_max <- rasterToVRT(f, krnl = krnl, krnl_fn = "max")
    on.exit(deleteDataset(vrt_max), add = TRUE)
    ds <- new(GDALRaster, vrt_max)
    x <- ds$read(1, 1, 1, 1, 1, 1, 1)
    expect_equal(x, 9)
    ds$close()

    vrt_median <- rasterToVRT(f, krnl = krnl, krnl_fn = "median")
    on.exit(deleteDataset(vrt_median), add = TRUE)
    ds <- new(GDALRaster, vrt_median)
    x <- ds$read(1, 1, 1, 1, 1, 1, 1)
    expect_equal(x, 5)
    ds$close()

    vrt_sd <- rasterToVRT(f, krnl = krnl, krnl_fn = "stddev")
    on.exit(deleteDataset(vrt_sd), add = TRUE)
    ds <- new(GDALRaster, vrt_sd)
    x <- ds$read(1, 1, 1, 1, 1, 1, 1)
    expect_equal(x, sd(v), tolerance = 0.1)
    ds$close()

    ds <- new(GDALRaster, f, read_only = FALSE)
    v <- c(1, 2, 3, 4, 5, 6, 7, 8, 8)
    ds$write(1, 0, 0, 3, 3, v)
    ds$close()

    vrt_mode <- rasterToVRT(f, krnl = krnl, krnl_fn = "mode")
    on.exit(deleteDataset(vrt_mode), add = TRUE)
    ds <- new(GDALRaster, vrt_mode)
    x <- ds$read(1, 1, 1, 1, 1, 1, 1)
    expect_equal(x, 8)
    ds$close()
})

test_that("dem_proc runs without error", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    hs_file <- paste0(tempdir(), "/", "storml_hillshade.tif")
    on.exit(deleteDataset(hs_file), add=TRUE)
    expect_true(dem_proc("hillshade", elev_file, hs_file))

    sq <- seq(2400, 3100, by = 100)
    col <- col2rgb(hcl.colors(length(sq)))
    pal <- tempfile(fileext = ".txt")
    on.exit(unlink(pal), add=TRUE)
    writeLines(paste(sq, col[1, ], col[2, ], col[3, ]), pal)
    cr_file <- tempfile(fileext = ".tif")
    on.exit(deleteDataset(cr_file), add=TRUE)
    expect_true(dem_proc("color-relief", elev_file, cr_file, color_file = pal))
})

test_that("polygonize runs without error", {
    evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
    dsn <- paste0(tempdir(), "/", "storml_evt.shp")
    layer <- "storml_evt"
    fld <- "evt_value"
    expect_true(polygonize(evt_file, dsn, layer, fld))

    # overwrite
    expect_true(polygonize(evt_file, dsn, layer, fld, connectedness=8,
                           overwrite=TRUE))

    # with mask_file
    expr <- "ifelse(EVT == -9999, 0, 1)"
    mask_file <- calc(expr, rasterfiles=evt_file, var.names="EVT")
    expect_true(polygonize(evt_file, dsn, layer, fld, mask_file=mask_file,
                           overwrite=TRUE))

    # nomask
    expect_true(polygonize(evt_file, dsn, layer, fld, nomask=TRUE,
                           overwrite=TRUE))

    # append: layer already exists so expect warning if lco given
    expect_warning(polygonize(evt_file, dsn, layer, fld, connectedness=8,
                              lco="SPATIAL_INDEX=YES"))

    deleteDataset(dsn)
    deleteDataset(mask_file)

    # GPKG
    set_config_option("SQLITE_USE_OGR_VFS", "YES")
    set_config_option("OGR_SQLITE_JOURNAL", "MEMORY")
    dsn <- paste0(tempdir(), "/", "storml_evt.gpkg")
    layer <- "lf_evt"
    opt <- "VERSION=1.3"
    expect_true(polygonize(evt_file, dsn, layer, fld, dsco=opt))

    # existing out_dsn, but create a new layer
    layer <- "lf_evt_8connect"
    opt <- c("GEOMETRY_NULLABLE=NO","DESCRIPTION=LF EVT 8-connected polygons")
    expect_true(polygonize(evt_file,dsn,layer,fld,connectedness=8,lco=opt))

    set_config_option("SQLITE_USE_OGR_VFS", "")
    set_config_option("OGR_SQLITE_JOURNAL", "")
    deleteDataset(dsn)

    # unrecognized output format
    dsn <- paste0(tempdir(), "/", "storml_evt.txt")
    expect_error(polygonize(evt_file, dsn, layer, fld))
})

test_that("rasterize runs without error", {
    # layer from sql query
    dsn <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
    sql <- "SELECT * FROM mtbs_perims ORDER BY mtbs_perims.ig_year"
    out_file <- paste0(tempdir(), "/", "ynp_fires_1984_2022.tif")

    res <- rasterize(src_dsn = dsn,
                     dstfile = out_file,
                     sql = sql,
                     burn_attr = "ig_year",
                     tr = c(90,90),
                     tap = TRUE,
                     dtName = "Int16",
                     dstnodata = -9999,
                     init = -9999,
                     co = c("TILED=YES","COMPRESS=LZW"))
    expect_true(res)
    ds <- new(GDALRaster, out_file, TRUE)
    bbox <- ds$bbox()
    dm <- ds$dim()
    ds$close()
    deleteDataset(out_file)

    # layer with where clause
    out_file <- paste0(tempdir(), "/", "ynp_fires_1988.tif")
    layer <- "mtbs_perims"
    where <- "ig_year = 1988"

    res <- rasterize(src_dsn = dsn,
                     dstfile = out_file,
                     layer = layer,
                     where = where,
                     burn_value = 1,
                     te = bbox,
                     ts = dm[1:2],
                     dtName = "Byte",
                     init = 0,
                     fmt = "GTiff",
                     co = c("TILED=YES","COMPRESS=LZW"),
                     add_options = "-q")
    expect_true(res)
    deleteDataset(out_file)

    # update existing raster in-place
    # create the vector layer
    dsn <- tempfile(fileext = ".geojson")
    lyr <- ogr_ds_create("GeoJSON", dsn, "OGRGeoJSON", geom_type = "POLYGON",
                         return_obj = TRUE)
    pts <-  matrix(c(0.25, 0.25, 0.75, 0.25, 0.75, 0.75, 0.25, 0.75, 0.25, 0.25),
                   ncol = 2, byrow = TRUE)
    feat <- list()
    feat$geometry <- g_create("POLYGON", pts)
    lyr$createFeature(feat)
    lyr$close()
    # create the destination raster
    ds <- create("GTiff", "/vsimem/test.tif", xsize = 100, ysize = 100,
                 nbands = 1, dataType = "Byte", options = "COMPRESS=DEFLATE",
                 return_obj = TRUE)
    ds$setGeoTransform(c(0.0, 0.01, 0.0, 1.0, 0.0, -0.01))
    ds$setProjection(epsg_to_wkt(4326))
    ds$fillRaster(1, 0, 0)
    # update the destination pixels in-place
    res <- rasterize(dsn, ds, burn_value = 1)
    expect_true(res)
    r <- read_ds(ds)
    expect_equal(sum(r), 2500)

    unlink(dsn)
    ds$close()
    vsi_unlink("/vsimem/test.tif")
})

test_that("pixel_extract wrapper returns correct data", {
    # the C++ class method GDALRaster::pixel_extract() is tested in
    # test-GDALRaster-class.R

    pt_file <- system.file("extdata/storml_pts.csv", package="gdalraster")
    pts <- read.csv(pt_file)
    raster_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")

    # single pixel (1x1) extract on matrix input
    extr <- pixel_extract(raster_file, pts[-1])
    colnames(extr) <- NULL
    dim(extr) <- NULL
    expected_values <- c(2648, 2865, 2717, 2560, 2916,
                         2633, 2548, 2801, 2475, 2822)
    expect_equal(extr, expected_values)
    rm(extr)
    # data frame input
    extr <- pixel_extract(raster_file, pts)
    expect_equal(extr[, 2], expected_values)
    expect_equal(names(extr), c("id", "storml_elev_orig"))
    rm(extr)
    # as_data_frame from matrix input, so no input point IDs
    extr <- pixel_extract(raster_file, pts[-1], as_data_frame = TRUE)
    expect_true(is.data.frame(extr))
    expect_equal(names(extr), c("ptid", "storml_elev_orig"))
    expect_equal(extr[, 2], expected_values)
    expect_equal(extr[, 1], seq_len(nrow(extr)))
    rm(extr)

    # raster as a GDALRaster object
    ds <- new(GDALRaster, raster_file)
    extr_ds <- pixel_extract(ds, pts)
    expect_equal(extr_ds[, 2], expected_values)
    expect_equal(names(extr_ds), c("id", "storml_elev_orig"))
    # with missing values in the input
    pts_na <- rbind(pts, c(11, NA_real_, NA_real_))
    extr_na <- pixel_extract(ds, pts_na)
    expect_na <- c(expected_values, NA_real_)
    expect_equal(extr_na[, 2], expect_na)
    # with NaN in the input
    pts_nan <- rbind(pts, c(11, NaN, NaN))
    extr_nan <- pixel_extract(ds, pts_na)
    expect_nan <- c(expected_values, NA_real_)
    expect_equal(extr_nan[, 2], expect_nan)

    # MEM dataset with band names
    ds_mem <- create("MEM", "", 10, 10, 3, "Int16", return_obj = TRUE)
    expect_true(is(ds_mem, "Rcpp_GDALRaster"))
    ds_mem$setDescription(1, "elev")
    ds_mem$setDescription(2, "asp")
    ds_mem$setDescription(3, "slpp")
    ds_mem$fillRaster(1, 1000, 0)
    ds_mem$fillRaster(2, 100, 0)
    ds_mem$fillRaster(3, 10, 0)
    geo_xy <- matrix(c(5, -8, 0, -1), nrow = 2, ncol = 2, byrow = TRUE)
    # warning for no geotransform
    expect_warning(extr_mem <- pixel_extract(ds_mem, geo_xy,
                                             as_data_frame = TRUE))
    expect_true(is.data.frame(extr_mem))
    expect_equal(names(extr_mem), c("ptid", "b1_elev", "b2_asp", "b3_slpp"))
    expect_equal(extr_mem[, 2], c(1000, 1000))
    expect_equal(extr_mem[, 3], c(100, 100))
    expect_equal(extr_mem[, 4], c(10, 10))
    rm(extr_mem)
    # subset of bands, re-ordered
    expect_warning(extr_mem <- pixel_extract(ds_mem, geo_xy,
                                             bands = c(3, 2),
                                             as_data_frame = TRUE))
    expect_true(is.data.frame(extr_mem))
    expect_equal(names(extr_mem), c("ptid", "b3_slpp", "b2_asp"))
    expect_equal(extr_mem[, 2], c(10, 10))
    expect_equal(extr_mem[, 3], c(100, 100))
    rm(extr_mem)

    # GTiff without band names
    ds_mem$setDescription(1, "")
    ds_mem$setDescription(2, "")
    ds_mem$setDescription(3, "")
    tif_file <- tempfile(fileext = ".tif")
    ds_tif <- createCopy("GTiff", tif_file, ds_mem,
                         return_obj = TRUE)
    expect_true(is(ds_tif, "Rcpp_GDALRaster"))
    expect_warning(ds_tif$setGeoTransform(ds_mem$getGeoTransform()))
    extr_tif <- pixel_extract(ds_tif, geo_xy, as_data_frame = TRUE)
    expect_true(is.data.frame(extr_tif))
    ds_name <- tools::file_path_sans_ext(basename(ds_tif$getDescription(0)))
    expected_names <- c("ptid", paste0(rep(ds_name, 3), c("_b1", "_b2", "_b3")))
    expect_equal(names(extr_tif), expected_names)
    expect_equal(extr_tif[, 2], c(1000, 1000))
    expect_equal(extr_tif[, 3], c(100, 100))
    expect_equal(extr_tif[, 4], c(10, 10))
    rm(extr_tif)
    # subset of bands, re-ordered
    extr_tif <- pixel_extract(ds_tif, geo_xy,
                              bands = c(3, 2),
                              as_data_frame = TRUE)
    expect_true(is.data.frame(extr_tif))
    expected_names <- c("ptid", paste0(rep(ds_name, 2), c("_b3", "_b2")))
    expect_equal(names(extr_tif), expected_names)
    expect_equal(extr_tif[, 2], c(10, 10))
    expect_equal(extr_tif[, 3], c(100, 100))

    ds_mem$close()
    ds_tif$close()
    deleteDataset(tif_file)

    # interpolated values
    extr_bilinear <- pixel_extract(ds, pts, interp = "bilinear")
    expected_values <- c(2649.217, 2881.799, 2716.290, 2558.797, 2920.404,
                         2629.495, 2548.250, 2810.543, 2478.609, 2819.776)
    expect_equal(extr_bilinear[, 2], expected_values, tolerance = 1e-4)

    # kernel values
    extr_3x3 <- pixel_extract(ds, pts[-1], krnl_dim = 3)
    expect_equal(colnames(extr_3x3), c("b1_p1", "b1_p2", "b1_p3",
                                       "b1_p4", "b1_p5", "b1_p6",
                                       "b1_p7", "b1_p8", "b1_p9"))
    colnames(extr_3x3) <- NULL
    dimnames(extr_3x3) <- NULL
    expected_values <- c(
        2660,     2654, 2651,     2652, 2648, 2646,     2653, 2647, 2645,
        2924,     2895, 2901,     2893, 2865, 2869,     2863, 2838, 2841,
        NA_real_, 2709, 2704, NA_real_, 2717, 2717, NA_real_, 2725, 2728,
        2554,     2558, 2562,     2557, 2560, 2564,     2559, 2562, 2566,
        2932,     2920, 2908,     2927, 2916, 2903,     2923, 2911, 2899,
        2633,     2642, 2650,     2627, 2633, 2640,     2619, 2624, 2630,
        2548,     2548, 2550,     2549, 2548, 2550,     2550, 2548, 2550,
        2785,     2777, 2776,     2807, 2801, 2803,     2833, 2825, 2827,
        2489,     2482, 2475,     2479, 2475, 2470,     2474, 2471, 2468,
        2832,     2810, 2789,     2839, 2822, 2800,     2833, 2811, 2788)
    expected_values <- matrix(expected_values, nrow = 10, ncol = 9,
                              byrow = TRUE)
    expect_equal(extr_3x3, expected_values)

    # transform the xy
    pts_nad83 <- transform_xy(pts[-1], ds$getProjection(), "NAD83")
    extr <- pixel_extract(raster_file, pts_nad83, xy_srs = "NAD83")
    colnames(extr) <- NULL
    dim(extr) <- NULL
    expected_values <- c(2648, 2865, 2717, 2560, 2916,
                         2633, 2548, 2801, 2475, 2822)
    expect_equal(extr, expected_values)
    ds$close()
    rm(extr)


    # input validation
    expect_error(pixel_extract(ds, pts[-1]))  # ds closed
    expect_error(pixel_extract(NULL, pts[-1]))
    expect_error(pixel_extract(raster_file))
    expect_error(pixel_extract(raster_file, as.character(pts[-1])))
    expect_error(pixel_extract(raster_file, pts[, 2]))
    expect_error(pixel_extract(raster_file, pts, bands = c(1, 2, NA)))
    expect_no_error(pixel_extract(raster_file, pts, bands = 1.1))
    expect_error(pixel_extract(raster_file, pts,
                               interp = c("bilinear", "cubic")))
    expect_error(pixel_extract(raster_file, pts, krnl_dim = c(1, 1, 1)))
    expect_error(pixel_extract(raster_file, pts, xy_srs = 4326))
    expect_error(pixel_extract(raster_file, pts, max_ram = "invalid"))
    pts[, 2] <- as.character(pts[, 1])
    expect_error(pixel_extract(raster_file, pts))


    # test copy of remote raster to an in-memory dataset if not on CRAN
    skip_on_cran()
    skip_if(gdal_version_num() < gdal_compute_version(3, 6, 0))

    f <- "/vsicurl/https://raw.githubusercontent.com/firelab/gdalraster/main/sample-data/lf_fbfm40_220_mt_hood_utm.tif"
    pts <- c(604450.6, 5023283,
             611437.6, 5021571,
             591824.6, 5030855,
             613802.6, 5014220,
             600267.6, 5035648,
             613158.6, 5019868,
             616192.6, 5025546,
             597588.6, 5034797,
             595511.6, 5024383,
             591099.6, 5032626,
             600548.6, 5020417,
             598620.6, 5028004,
             599306.6, 5034376,
             612222.6, 5022980,
             604734.6, 5031885,
             601311.6, 5016818,
             611955.6, 5015290,
             605232.6, 5032306,
             615538.6, 5014872,
             600952.6, 5028567)
    pts <- matrix(pts, nrow = 20, ncol = 2, byrow = TRUE)
    expect_message(extr <- pixel_extract(f, pts), "copying to MEM")
    colnames(extr) <- NULL
    dim(extr) <- NULL
    expected_values <- c(99, 188, 185, 185, 185, 185, 185, 185, 162, 165, 162,
                         185, 185, 165, 185, 185, 165, 185, 165, 161)
    expect_equal(extr, expected_values)
    rm(extr)

    # force to use /vsimem/ instead
    expect_message(extr <- pixel_extract(f, pts, max_ram = 1),
                   "copying remote file")
    colnames(extr) <- NULL
    dim(extr) <- NULL
    expected_values <- c(99, 188, 185, 185, 185, 185, 185, 185, 162, 165, 162,
                         185, 185, 165, 185, 185, 165, 185, 165, 161)
    expect_equal(extr, expected_values)
    rm(extr)
})

# R interface to OGR vector geoprocessing
# Chris Toney <chris.toney at usda.gov>

#' GDAL OGR facilities for vector geoprocessing
#'
#' @description
#' `ogr_proc()` performs GIS overlay operations on vector layers
#' (\url{https://en.wikipedia.org/wiki/Vector_overlay}). It provides
#' an interface to the GDAL API methods for these operations
#' (`OGRLayer::Intersection()`, `OGRLayer::Union()`, etc).
#' Inputs are given as objects of class [`GDALVector`][GDALVector], which
#' may have spatial and/or attribute filters applied.
#' The output layer will be created if it does not exist, but output can also
#' be appended to an existing layer, or written to an existing empty layer that
#' has a custom schema defined.
#' `ogr_proc()` is basically a port of the
#' [`ogr_layer_algebra`](https://gdal.org/en/stable/programs/ogr_layer_algebra.html#ogr-layer-algebra)
#' utility in the GDAL Python bindings.
#'
#' @details
#' Seven processing modes are available:
#' * `Intersection`: The output layer contains features whose geometries
#' represent areas that are common between features in the input layer and in
#' the method layer. The features in the output layer have attributes from
#' both input and method layers.
#' * `Union`: The output layer contains features whose geometries represent
#' areas that are either in the input layer, in the method layer, or in
#' both. The features in the output layer have attributes from both input and
#' method layers. For features which represent areas that are only in the
#' input layer or only in the method layer the respective attributes have
#' undefined values.
#' * `SymDifference`: The output layer contains features whose geometries
#' represent areas that are in either in the input layer or in the method layer
#' but not in both. The features in the output layer have attributes from both
#' input and method layers. For features which represent areas that are only in
#' the input or only in the method layer the respective attributes have
#' undefined values.
#' * `Identity`: Identifies the features of the input layer with the ones from
#' the method layer. The output layer contains features whose geometries
#' represent areas that are in the input layer. The features in the output layer
#' have attributes from both the input and method layers.
#' * `Update`: The update method creates a layer which adds features into the
#' input layer from the method layer, possibly cutting features in the input
#' layer. The features in the output layer have areas of the features of the
#' method layer or those areas of the features of the input layer that are not
#' covered by the method layer. The features of the output layer get their
#' attributes from the input layer.
#' * `Clip`: The clip method creates a layer which has features from the input
#' layer clipped to the areas of the features in the method layer. By default
#' the output layer has attributes of the input layer.
#' * `Erase`: The erase method creates a layer which has features from the input
#' layer whose areas are erased by the features in the method layer. By default,
#' the output layer has attributes of the input layer.
#'
#' By default, `ogr_proc()` will create the output layer with an empty schema.
#' It will be initialized by GDAL to contain all fields in the input layer, or
#' depending on the operation, all fields in both the input and method layers.
#' In the latter case, the prefixes `"input_"` and `"method_"` will be added to
#' the output field names by default. The default prefixes can be overridden in
#' the `mode_opt` argument as described below.
#'
#' Alternatively, the functions in the [`ogr_manage`][ogr_manage] interface
#' could be used to create an empty layer with user-defined schema (e.g.,
#' [ogr_ds_create()], [ogr_layer_create()] and [ogr_field_create()]). If the
#' schema of the output layer is set by the user and contains fields that have
#' the same name as a field in both the input and method layers, then the
#' attribute for an output feature will get the value from the feature of the
#' method layer.
#'
#' Options that affect processing can be set as NAME=VALUE pairs passed in the
#' `mode_opt` argument. Some options are specific to certain processing modes
#' as noted below:
#' * SKIP_FAILURES=YES/NO. Set it to YES to go on, even when a feature could
#' not be inserted or a GEOS call failed.
#' * PROMOTE_TO_MULTI=YES/NO. Set to YES to convert Polygons into MultiPolygons,
#' LineStrings to MultiLineStrings or Points to MultiPoints (only since GDAL
#' 3.9.2 for the latter).
#' * INPUT_PREFIX=string. Set a prefix for the field names that will be created
#' from the fields of the input layer.
#' * METHOD_PREFIX=string. Set a prefix for the field names that will be created
#' from the fields of the method layer.
#' * USE_PREPARED_GEOMETRIES=YES/NO. Set to NO to not use prepared geometries to
#' pretest intersection of features of method layer with features of input
#' layer. Applies to `Intersection`, `Union`, `Identity`.
#' * PRETEST_CONTAINMENT=YES/NO. Set to YES to pretest the containment of
#' features of method layer within the features of input layer. This will speed
#' up the operation significantly in some cases. Requires that the prepared
#' geometries are in effect. Applies to `Intersection`.
#' * KEEP_LOWER_DIMENSION_GEOMETRIES=YES/NO. Set to NO to skip result features
#' with lower dimension geometry that would otherwise be added to the output
#' layer. The default is YES, to add features with lower dimension geometry, but
#' only if the result output has an UNKNOWN geometry type. Applies to
#' `Intersection`, `Union`, `Identity`.
#'
#' The input and method layers should have the same spatial reference system. No
#' on-the-fly reprojection is done. When an output layer is created it will have
#' the SRS of `input_lyr`.
#'
#' @param mode Character string specifying the operation to perform. One of
#' `Intersection`, `Union`, `SymDifference`, `Identity`, `Update`, `Clip` or
#' `Erase` (see Details).
#' @param input_lyr An object of class [`GDALVector`][GDALVector] to use as the
#' input layer. For overlay operations, this is the first layer in the
#' operation.
#' @param method_lyr An object of class [`GDALVector`][GDALVector] to use as the
#' method layer. This is the conditional layer supplied to an operation (e.g.,
#' Clip, Erase, Update), or the second layer in overlay operations (e.g., Union,
#' Intersection, SymDifference).
#' @param out_dsn The destination vector filename or database connection string
#' to which the output layer will be written.
#' @param out_lyr_name Layer name where the output vector will be written. May
#' be `NULL` (e.g., shapefile), but typically must be specified.
#' @param out_geom_type Character string specifying the geometry type of the
#' output layer. One of NONE, GEOMETRY, POINT, LINESTRING, POLYGON,
#' GEOMETRYCOLLECTION, MULTIPOINT, MULTIPOLYGON, GEOMETRY25D, POINT25D,
#' LINESTRING25D, POLYGON25D, GEOMETRYCOLLECTION25D, MULTIPOINT25D,
#' MULTIPOLYGON25D. Defaults to UNKNOWN if not specified.
#' @param out_fmt GDAL short name of the output vector format. If unspecified,
#' the function will attempt to guess the format from the value of `out_dsn`.
#' @param dsco Optional character vector of format-specific creation options
#' for `out_dsn` (`"NAME=VALUE"` pairs).
#' @param lco Optional character vector of format-specific creation options
#' for `out_layer` (`"NAME=VALUE"` pairs).
#' @param mode_opt Optional character vector of `"NAME=VALUE"` pairs that
#' specify processing options. Available options depend on the value of `mode`
#' (see Details).
#' @param overwrite Logical value. `TRUE` to overwrite the output layer if it
#' already exists. Defaults to `FALSE`.
#' @param quiet Logical value. If `TRUE`, a progress bar will not be
#' displayed. Defaults to `FALSE`.
#' @param return_obj Logical value. If `TRUE` (the default), an object of
#' class [`GDALVector`][GDALVector] opened on the output layer will be returned,
#' otherwise the function returns a logical value.
#'
#' @returns Upon successful completion, an object of class
#' [`GDALVector`][GDALVector] is returned by default (`return_obj = TRUE`), or
#' logical `TRUE` is returned if `return_obj = FALSE`.
#' Logical `FALSE` is returned if an error occurs during processing.
#'
#' @note
#' The first geometry field on a layer is always used.
#'
#' For best performance use the minimum amount of features in the method layer
#' and copy into a memory layer.
#'
#' @seealso
#' [`GDALVector-class`][GDALVector], [`ogr_define`][ogr_define],
#' [`ogr_manage`][ogr_manage]
#'
#' Vector overlay operators:\cr
#' \url{https://en.wikipedia.org/wiki/Vector_overlay}
#'
#' @examples
#' # MTBS fires in Yellowstone National Park 1984-2022
#' dsn <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
#'
#' # layer filtered to fires after 1988
#' lyr1 <- new(GDALVector, dsn, "mtbs_perims")
#' lyr1$setAttributeFilter("ig_year > 1988")
#' lyr1$getFeatureCount()
#'
#' # second layer for the 1988 North Fork fire perimeter
#' sql <- "SELECT incid_name, ig_year, geom FROM mtbs_perims
#'         WHERE incid_name = 'NORTH FORK'"
#' lyr2 <- new(GDALVector, dsn, sql)
#' lyr2$getFeatureCount()
#'
#' # intersect to obtain areas in the North Fork perimeter that have re-burned
#' tmp_dsn <- tempfile(fileext = ".gpkg")
#' opt <- c("INPUT_PREFIX=layer1_",
#'          "METHOD_PREFIX=layer2_",
#'          "PROMOTE_TO_MULTI=YES")
#'
#' lyr_out <- ogr_proc(mode = "Intersection",
#'                     input_lyr = lyr1,
#'                     method_lyr = lyr2,
#'                     out_dsn = tmp_dsn,
#'                     out_lyr_name = "north_fork_reburned",
#'                     out_geom_type = "MULTIPOLYGON",
#'                     mode_opt = opt)
#'
#' # the output layer has attributes of both the input and method layers
#' (d <- lyr_out$fetch(-1))
#'
#' # clean up
#' lyr1$close()
#' lyr2$close()
#' lyr_out$close()
#' \dontshow{deleteDataset(tmp_dsn)}
#' @export
ogr_proc <- function(mode,
                     input_lyr,
                     method_lyr,
                     out_dsn,
                     out_lyr_name = NULL,
                     out_geom_type = NULL,
                     out_fmt = NULL,
                     dsco = NULL,
                     lco = NULL,
                     mode_opt = NULL,
                     overwrite = FALSE,
                     quiet = FALSE,
                     return_obj = TRUE) {

    if (is(input_lyr, "Rcpp_GDALVector")) {
        if (!input_lyr$isOpen()) {
            stop("'input_lyr' is not open", call. = FALSE)
        }
    } else {
        stop("'input_lyr' must be an object of class 'GDALVector'",
             call. = FALSE)
    }

    if (is(method_lyr, "Rcpp_GDALVector")) {
        if (!method_lyr$isOpen()) {
            stop("'method_lyr' is not open", call. = FALSE)
        }
    } else {
        stop("'method_lyr' must be an object of class 'GDALVector'",
             call. = FALSE)
    }

    input_srs <- input_lyr$getSpatialRef()
    method_srs <- method_lyr$getSpatialRef()
    if (input_srs == "" && method_srs != "") {
        warning("input layer has no SRS defined, but method layer has one")
    }
    if (input_srs != "" && method_srs == "") {
        warning("input layer has an SRS defined, but method layer does not")
    }
    if (input_srs != "" && method_srs != "" &&
            !srs_is_same(input_srs, method_srs)) {

            warning("input and method layers do not have identical SRS, and no on-the-fly reprojection will be done",
                    call. = FALSE)
    }

    if (!(is.logical(overwrite) && length(overwrite) == 1))
        stop("'overwrite' must be logical type with length 1", call. = FALSE)

    if (!(is.logical(quiet) && length(quiet) == 1))
        stop("'quiet' must be logical type with length 1", call. = FALSE)

    if (!ogr_ds_exists(out_dsn, with_update = TRUE)) {
        if (ogr_ds_exists(out_dsn) && !overwrite) {
            cli::cli_alert_danger(
                paste0("{.arg out_dsn} exists but cannot be updated. You ",
                       "may need to remove it first, or use ",
                       "{.code overwrite = TRUE}."))
            stop("cannot update the output data source", call. = FALSE)
        }
    }

    if (is.null(out_fmt))
        out_fmt <- .getOGRformat(out_dsn)
    if (is.null(out_fmt)) {
        message("format driver cannot be determined for: ", out_dsn)
        stop("specify 'out_fmt' to create a new dataset", call. = FALSE)
    }

    if (is.null(out_lyr_name)) {
        if (out_fmt == "ESRI Shapefile")
            out_lyr_name <- tools::file_path_sans_ext(basename(out_dsn))
        if (is.null(out_lyr_name))
            stop("'out_lyr_name' must be specified", call. = FALSE)
    }

    if (is.null(out_geom_type))
        out_geom_type <- "UNKNOWN"

    if (ogr_ds_exists(out_dsn, with_update = TRUE) && overwrite) {
        deleted <- FALSE
        if (ogr_layer_exists(out_dsn, out_lyr_name)) {
            deleted <- ogr_layer_delete(out_dsn, out_lyr_name)
        }
        if (!deleted) {
            if (ogr_ds_layer_count(out_dsn) == 1) {
                if (vsi_stat(out_dsn, "type") == "file")
                    deleted <- deleteDataset(out_dsn)
            }
        }
        if (!deleted) {
            stop("failed to overwrite the output layer", call. = FALSE)
        }
    }

    if (!ogr_ds_exists(out_dsn, with_update = TRUE)) {
        if (!ogr_ds_create(format = out_fmt,
                           dsn = out_dsn,
                           layer = out_lyr_name,
                           geom_type = out_geom_type,
                           srs = input_srs,
                           dsco = dsco,
                           lco = lco)) {

            stop("failed to create 'out_dsn'", call. = FALSE)
        }
    }

    if (!ogr_layer_exists(out_dsn, out_lyr_name)) {
        res <- ogr_layer_create(out_dsn, out_lyr_name, layer_defn = NULL,
                                geom_type = out_geom_type, srs = input_srs,
                                lco = lco)
        if (!res)
            stop("failed to create the output layer", call. = FALSE)
    }

    out_lyr <- new(GDALVector, out_dsn, out_lyr_name, read_only = FALSE)
    mode <- tolower(mode)
    ret <- FALSE

    if (mode == "intersection") {
        ret <- input_lyr$layerIntersection(method_lyr, out_lyr, quiet = quiet,
                                           options = mode_opt)

    } else if (mode == "union") {
        ret <- input_lyr$layerUnion(method_lyr, out_lyr, quiet = quiet,
                                    options = mode_opt)

    } else if (mode == "symdifference") {
        ret <- input_lyr$layerSymDifference(method_lyr, out_lyr, quiet = quiet,
                                            options = mode_opt)

    } else if (mode == "identity") {
        ret <- input_lyr$layerIdentity(method_lyr, out_lyr, quiet = quiet,
                                       options = mode_opt)

    } else if (mode == "update") {
        ret <- input_lyr$layerUpdate(method_lyr, out_lyr, quiet = quiet,
                                     options = mode_opt)

    } else if (mode == "clip") {
        ret <- input_lyr$layerClip(method_lyr, out_lyr, quiet = quiet,
                                   options = mode_opt)

    } else if (mode == "erase") {
        ret <- input_lyr$layerErase(method_lyr, out_lyr, quiet = quiet,
                                    options = mode_opt)

    } else {
        stop("invalid 'mode'", call. = FALSE)
    }

    if (ret && return_obj) {
        out_lyr$open(read_only = TRUE)
        return(out_lyr)
    } else {
        out_lyr$close()
        return(ret)
    }
}

# R interface for the GEOS functions defined in src/geom_api.h
# Chris Toney <chris.toney at usda.gov>


#' @noRd
#' @export
.is_raw_or_null <- function(x) {
    if (is.raw(x) || is.null(x))
        return(TRUE)
    else
        return(FALSE)
}

#' Get GEOS version
#'
#' @description
#' `geos_version()` returns version information for the GEOS library in use by
#' GDAL. Requires GDAL >= 3.4.
#'
#' @returns A list of length four containing:
#'   * `name` - a string formatted as "major.minor.patch"
#'   * `major` - major version as integer
#'   * `minor` - minor version as integer
#'   * `patch` - patch version as integer
#'
#' List elements will be `NA` if GDAL < 3.4.
#'
#' @seealso
#' [gdal_version()], [proj_version()]
#'
#' @examples
#' geos_version()
#' @export
geos_version <- function() {
    ver <- .getGEOSVersion()
    gv <- list()
    if (anyNA(ver))
        gv$name <- NA_character_
    else
        gv$name <- paste(ver, collapse=".")
    gv$major <- ver[1]
    gv$minor <- ver[2]
    gv$patch <- ver[3]
    return(gv)
}

#' Bounding box intersection / union
#'
#' @description
#' `bbox_intersect()` returns the bounding box intersection, and
#' `bbox_union()` returns the bounding box union, for input of
#' either raster file names or list of bounding boxes. All of the inputs
#' must be in the same projected coordinate system.
#'
#' @param x Either a character vector of raster file names, or a list with
#' each element a bounding box numeric vector (xmin, ymin, xmax, ymax).
#' @param as_wkt Logical. `TRUE` to return the bounding box as a polygon
#' in OGC WKT format, or `FALSE` to return as a numeric vector.
#' @return The intersection (`bbox_intersect()`) or union (`bbox_union()`)
#' of inputs.
#' If `as_wkt = FALSE`, a numeric vector of length four containing
#' xmin, ymin, xmax, ymax. If `as_wkt = TRUE`, a character string
#' containing OGC WKT for the bbox as POLYGON.
#'
#' @seealso
#' [bbox_from_wkt()], [bbox_to_wkt()]
#'
#' @examples
#' bbox_list <-list()
#'
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' ds <- new(GDALRaster, elev_file)
#' bbox_list[[1]] <- ds$bbox()
#' ds$close()
#'
#' b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
#' ds <- new(GDALRaster, b5_file)
#' bbox_list[[2]] <- ds$bbox()
#' ds$close()
#'
#' bnd <- "POLYGON ((324467.3 5104814.2, 323909.4 5104365.4, 323794.2
#' 5103455.8, 324970.7 5102885.8, 326420.0 5103595.3, 326389.6 5104747.5,
#' 325298.1 5104929.4, 325298.1 5104929.4, 324467.3 5104814.2))"
#' bbox_list[[3]] <- bbox_from_wkt(bnd)
#'
#' print(bbox_list)
#' bbox_intersect(bbox_list)
#' bbox_union(bbox_list)
#' @export
bbox_intersect <- function(x, as_wkt = FALSE) {
    n <- length(x)
    this_bbox <- ""

    if (is.character(x)) {
        ds <- new(GDALRaster, x[1], read_only=TRUE)
        this_bbox <- bbox_to_wkt(ds$bbox())
        ds$close()
    } else if (is.list(x)) {
        this_bbox <- bbox_to_wkt(x[[1]])
    } else {
        stop("input must be a list or character vector", call. = FALSE)
    }

    i <- 2
    while (i <= n) {
        if (is.character(x)) {
            ds <- new(GDALRaster, x[i], read_only=TRUE)
            this_bbox <- g_intersection(this_bbox, bbox_to_wkt(ds$bbox()),
                                        as_wkb = FALSE)
            ds$close()
        } else {
            this_bbox <- g_intersection(this_bbox, bbox_to_wkt(x[[i]]),
                                        as_wkb = FALSE)
        }
        i <- i + 1
    }

    if (as_wkt)
        return(this_bbox)
    else
        return(bbox_from_wkt(this_bbox))
}

#' @rdname bbox_intersect
#' @export
bbox_union <- function(x, as_wkt = FALSE) {
    n <- length(x)
    this_bbox <- ""

    if (is.character(x)) {
        ds <- new(GDALRaster, x[1], read_only=TRUE)
        this_bbox <- bbox_to_wkt(ds$bbox())
        ds$close()
    } else if (is.list(x)) {
        this_bbox <- bbox_to_wkt(x[[1]])
    } else {
        stop("input must be a list or character vector", call. = FALSE)
    }

    i <- 2
    while (i <= n) {
        if (is.character(x)) {
            ds <- new(GDALRaster, x[i], read_only=TRUE)
            this_bbox <- g_union(this_bbox, bbox_to_wkt(ds$bbox()),
                                 as_wkb = FALSE)
            ds$close()
        } else {
            this_bbox <- g_union(this_bbox, bbox_to_wkt(x[[i]]), as_wkb = FALSE)
        }
        i <- i + 1
    }

    if (as_wkt)
        return(this_bbox)
    else
        return(bbox_from_wkt(this_bbox))
}

#' Transform a bounding box to a different projection
#'
#' `bbox_transform()` is a convenience function to transform the coordinates
#' of a boundary from their current spatial reference system to a new target
#' spatial reference system.
#'
#' @details
#' With `use_transform_bounds = TRUE` (the default) this function returns:
#' ```
#' # requires GDAL >= 3.4
#' transform_bounds(bbox, srs_from, srs_to)
#' ```
#'
#' See Details for [transform_bounds()] for cases where the bounds crossed the
#' antimeridian.
#'
#' With `use_transform_bounds = FALSE`, this function returns:
#' ```
#' bbox_to_wkt(bbox) |>
#'   g_transform(srs_from, srs_to) |>
#'   bbox_from_wkt()
#' ```
#'
#' See the Note for [g_transform()] for cases where the bounds crossed the
#' antimeridian.
#'
#' @param bbox Numeric vector of length four containing a bounding box
#' (xmin, ymin, xmax, ymax) to transform.
#' @param srs_from Character string specifying the spatial reference system
#' for `pts`. May be in WKT format or any of the formats supported by
#' [srs_to_wkt()].
#' @param srs_to Character string specifying the output spatial reference
#' system. May be in WKT format or any of the formats supported by
#' [srs_to_wkt()].
#' @param use_transform_bounds Logical value, `TRUE` to use
#' `transform_bounds()` (the default, requires GDAL >= 3.4). If `FALSE`,
#' transformation is done with `g_transform()`.
#' @return Numeric vector of length four containing a transformed bounding box
#' (xmin, ymin, xmax, ymax).
#'
#' @seealso
#' [bbox_from_wkt()], [g_transform()], [transform_bounds()]
#'
#' @examples
#' bb <- c(-1405880.72, -1371213.76, 5405880.72, 5371213.76)
#'
#' # the default assumes GDAL >= 3.4
#' if (gdal_version_num() >= gdal_compute_version(3, 4, 0)) {
#'   bb_wgs84 <- bbox_transform(bb, "EPSG:32661", "EPSG:4326")
#' } else {
#'   bb_wgs84 <- bbox_transform(bb, "EPSG:32661", "EPSG:4326",
#'                              use_transform_bounds = FALSE)
#' }
#'
#' print(bb_wgs84)
#' @export
bbox_transform <- function(bbox, srs_from, srs_to,
                           use_transform_bounds = TRUE) {

    if (!(is.numeric(bbox) && length(bbox) == 4))
        stop("'bbox' must be a length-4 numeric vector", call. = FALSE)
    if (!(is.character(srs_from) && length(srs_from) == 1))
        stop("'srs_from' must be a character string", call. = FALSE)
    if (!(is.character(srs_to) && length(srs_to) == 1))
        stop("'srs_to' must be a character string", call. = FALSE)

    if (use_transform_bounds) {
        return(transform_bounds(bbox, srs_from, srs_to))
    } else {
        return(
            bbox_to_wkt(bbox) |>
                g_transform(srs_from, srs_to, as_wkb = FALSE) |>
                bbox_from_wkt()
        )
    }
}

#' Geometry WKB/WKT conversion
#'
#' `g_wk2wk()` converts geometries between Well Known Binary (WKB) and
#' Well Known Text (WKT) formats. A geometry given as a raw vector of WKB will
#' be converted to a WKT string, while a geometry given as a WKT string will be
#' converted to a WKB raw vector. Input may also be a list of WKB raw vectors
#' or a character vector of WKT strings.
#'
#' @param geom Either a raw vector of WKB or list of raw vectors to convert
#' to WKT, or a character vector containing one or more WKT strings to
#' convert to WKB.
#' @param as_iso Logical value, `TRUE` to export as ISO WKB/WKT (ISO 13249
#' SQL/MM Part 3), or `FALSE` (the default) to export as "Extended WKB/WKT"
#' (see Note).
#' @param byte_order Character string specifying the byte order when converting
#' to WKB. One of `"LSB"` (the default) or `"MSB"` (uncommon).
#' @return
#' For input of a WKB raw vector or list of raw vectors, returns a character
#' vector of WKT strings, with length of the returned vector equal to the
#' number of input raw vectors. For input of a single WKT string, returns a raw
#' vector of WKB. For input of a character vector containing more than one WKT
#' string, returns a list of WKB raw vectors, with length of the returned list
#' equal to the number of input strings.
#'
#' @note
#' With `as_iso = FALSE` (the default), geometries are exported as extended
#' dimension (Z) WKB/WKT for types `Point`, `LineString`, `Polygon`,
#' `MultiPoint`, `MultiLineString`, `MultiPolygon` and `GeometryCollection`.
#' For other geometry types, it is equivalent to ISO.
#'
#' When the return value is a list of WKB raw vectors, an element in the
#' returned list will contain `NULL` (and a warning emitted) if the
#' corresponding input string was `NA` or empty (`""`).
#'
#' When input is a list of WKB raw vectors, a corresponding element in the
#' returned character vector will be `NA` if the input was a raw vector of
#' length `0` (i.e., `raw(0)`). If an input list element is not a raw vector,
#' then the corresponding element in the returned character vector will also
#' be `NA`. A warning is emitted in each case.
#'
#' @seealso
#' GEOS reference for geometry formats:\cr
#' \url{https://libgeos.org/specifications/}
#'
#' @examples
#' wkt <- "POINT (-114 47)"
#' wkb <- g_wk2wk(wkt)
#' str(wkb)
#' g_wk2wk(wkb)
#' @export
g_wk2wk <- function(geom, as_iso = FALSE, byte_order = "LSB") {
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)

    if (is.character(geom)) {
        if (length(geom) == 1) {
            if (is.na(geom)) {
                return(NULL)
            } else {
                return(.g_wkt2wkb(geom, as_iso, byte_order))
            }
        } else {
            return(.g_wkt_vector2wkb(geom, as_iso, byte_order))
        }
    } else if (is.raw(geom)) {
        return(.g_wkb2wkt(geom, as_iso))
    } else if (is.list(geom)) {
        return(.g_wkb_list2wkt(geom, as_iso))
    } else if (is.null(geom)) {
        return(NA_character_)
    } else if (is.na(geom)) {
        return(NULL)
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }
}

#' Geometry factory functions
#'
#' These functions create WKB/WKT geometries from input vertices or arcs, and
#' build container geometry types from sub-geometries.
#' @name g_factory
#' @details
#' These functions use the GEOS library via GDAL headers.
#'
#' `g_create()` creates a geometry object from the given point(s) and returns
#' a raw vector of WKB (the default) or a character string of WKT. Currently
#' supports creating `Point`, `MultiPoint`, `LineString`, and `Polygon`
#' (including `25D`, `Z`, `M`, `ZM` variants).
#' If multiple input points are given for creating `Point`, then multiple
#' geometries will be returned as a list of WKB raw vectors, or character
#' vector of WKT strings if `as_wkb = FALSE`. Otherwise, a single geometry
#' is created from the input points. Only an empty `GeometryCollection` /
#' `MultiLineString` / `MultiPolygon` can be created with this function (for
#' subsequent use with `g_add_geom()`).
#'
#' `g_add_geom()` adds a geometry to a geometry container, e.g.,
#' `Polygon` to `Polygon` (to add an interior ring), `Point` to `MultiPoint`,
#' `LineString` to `MultiLineString`, `Polygon` to `MultiPolygon`, or mixed
#' geometry types to a `GeometryCollection`. Returns a new geometry, i.e,
#' the container geometry is not modified.
#'
#' `g_get_geom()` fetches a geometry from a geometry container (1-based
#' indexing). For a polygon, requesting the first sub-geometry returns the
#' exterior ring (`sub_geom_idx = 1`), and the interior rings are returned for
#' `sub_geom_idx > 1`.
#'
#' `g_build_collection()` builds a collection / container type geometry, e.g.,
#' `GeometryCollection`, `MultiPoint`, `MultiLineString`, `MultiPolygon`, from
#' a set of input geometries given as a list of WKB raw vectors or a character
#' vector of WKT strings.
#'
#' `g_build_polygon_from_edges()` builds a polygon from a set of arcs given
#' in a `GeometryCollection`, `MultiLineString`, list of WKB raw vectors, or
#' character vector of WKT strings.
#'
#' @param geom_type Character string (case-insensitive), one of `"POINT"`,
#' `"MULTIPOINT"`, `"LINESTRING"`, `"POLYGON"` (see Note) or
#' `"GEOMETRYCOLLECTION"`.
#' @param pts Numeric matrix of points (x, y, z, m), or `NULL` to create an
#' empty geometry. The points can be given as (x, y), (x, y, z) or
#' (x, y, z, m), so the input must have two, three or four columns.
#' Data frame input will be coerced to numeric matrix. Rings for polygon
#' geometries should be closed.
#' @param as_wkb Logical value, `TRUE` to return the output geometry in WKB
#' format (the default), or `FALSE` to return a WKT string.
#' @param as_iso Logical value, `TRUE` to export as ISO WKB/WKT (ISO 13249
#' SQL/MM Part 3), or `FALSE` (the default) to export as "Extended WKB/WKT".
#' @param byte_order Character string specifying the byte order when output is
#' WKB. One of `"LSB"` (the default) or `"MSB"` (uncommon).
#' @param sub_geom Either a raw vector of WKB or a character string of WKT.
#' @param container Either a raw vector of WKB or a character string of WKT for
#' a container geometry type.
#' @param sub_geom_idx An integer value giving the 1-based index of a
#' sub-geometry (numeric values will be coerced to integer by truncation).
#' @param geoms Either a list of WKB raw vectors or character vector of WKT
#' strings.
#' @param coll_type A character string specifying a geometry collection type,
#' e.g., `"GEOMETRYCOLLECTION"` (the default), `"MULTIPOINT"`,
#' `"MULTILINESTRING"`, `"MULTIPOLYGON".`
#' @param lines Either a raw vector of WKB or a character string of WKT
#' specifying a `GeometryCollection` or `MultiLineString`, or a list of WKB raw
#' vectors for `LineString`s, or a character vector of WKT strings.
#' @param auto_close A logical value, `TRUE` (the default) if the polygon should
#' be closed when first and last points of the ring are the same.
#' @param tolerance A numeric value giving the tolerance into which two arcs are
#' considered close enough to be joined.
#' @return
#' A geometry as WKB raw vector by default, or a WKT string if
#' `as_wkb = FALSE`. In the case of multiple input points for creating `Point``
#' geometry type, a list of WKB raw vectors or character vector of WKT strings
#' will be returned. `NULL` is returned with a warning if the an error occurs
#' in the geometry operation.
#'
#' @note
#' A `POLYGON` can be created for a single ring which will be the
#' exterior ring. Additional `POLYGON`s can be created and added to an
#' existing `POLYGON` with `g_add_geom()`. These will become interior rings.
#' Alternatively, an empty polygon can be created with `g_create("POLYGON")`,
#' followed by creation and addition of `POLYGON`s as sub-geometries. In that
#' case, the first added `POLYGON` will be the exterior ring. The next ones will
#' be the interior rings.
#'
#' Only an empty `GeometryCollection` can be created with `g_create()`, which
#' can then be used as a container with `g_add_geom()`. If given, input points
#' will be ignored by `g_create()` if `geom_type = "GEOMETRYCOLLECTION"`.
#'
#' @examples
#' # raw vector of WKB by default
#' g_create("POINT", c(1, 2))
#'
#' # as WKT
#' g_create("POINT", c(1, 2), as_wkb = FALSE)
#'
#' # or convert in either direction
#' g_create("POINT", c(1, 2)) |> g_wk2wk()
#' g_create("POINT", c(1, 2), as_wkb = FALSE) |> g_wk2wk()
#'
#' # create MultiPoint from a matrix of xyz points
#' x <- c(9, 1)
#' y <- c(1, 9)
#' z <- c(0, 10)
#' pts <- cbind(x, y, z)
#' mp <- g_create("MULTIPOINT", pts)
#' g_wk2wk(mp)
#' g_wk2wk(mp, as_iso = TRUE)
#'
#' # create an empty container and add sub-geometries
#' mp2 <- g_create("MULTIPOINT")
#' mp2 <- g_create("POINT", c(11, 2)) |> g_add_geom(mp2)
#' mp2 <- g_create("POINT", c(12, 3)) |> g_add_geom(mp2)
#' g_wk2wk(mp2)
#'
#' # or build a container/collection type geometry from WKB list or WKT vector
#' lines <- c("LINESTRING (0 0,3 0)",
#'            "LINESTRING (3 0,3 4)",
#'            "LINESTRING (3 4,0 0)")
#' (multi_line <- g_build_collection(lines, "MULTILINESTRING", as_wkb = FALSE))
#'
#' # get sub-geometry from container
#' g_get_geom(multi_line, 2, as_wkb = FALSE)
#'
#' # build a polygon from a set of arcs
#' (poly <- g_build_polygon_from_edges(lines, as_wkb = FALSE))
#'
#' # plot a vector of WKT strings or list of WKB raw vectors
#' plot_geom(poly)
#' @export
g_create <- function(geom_type, pts = NULL, as_wkb = TRUE, as_iso = FALSE,
                     byte_order = "LSB") {

    # geom_type
    if (!(is.character(geom_type) && length(geom_type) == 1))
        stop("'geom_type' must be a character string", call. = FALSE)
    # pts
    if (!(is.numeric(pts) || is.data.frame(pts) || is.null(pts)))
        stop("'pts' must be a numeric matrix of xy[zm]", call. = FALSE)
    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)

    wkb <- NULL
    if (toupper(geom_type) == "POINT" && (is.matrix(pts) ||
        is.data.frame(pts))) {

        wkb <- lapply(seq_len(nrow(pts)),
                      function(i) {
                          .g_create("POINT", pts[i, ], as_iso, byte_order)
                      })
    } else {
        wkb <- .g_create(geom_type, pts, as_iso, byte_order)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_factory
#' @export
g_add_geom <- function(sub_geom, container, as_wkb = TRUE, as_iso = FALSE,
                       byte_order = "LSB") {

    if ((is.character(sub_geom) || is.list(sub_geom)) && length(sub_geom) > 1)
        stop("'sub_geom' must be a single geometry", call. = FALSE)
    if (is.character(sub_geom))
        sub_geom <- g_wk2wk(sub_geom)
    if (!is.raw(sub_geom)) {
        stop("'sub_geom' must be a raw vector or character string",
             call. = FALSE)
    }

    if ((is.character(container) || is.list(container))
        && length(container) > 1) {

        stop("'sub_geom' must be a single geometry", call. = FALSE)
    }
    if (is.character(container))
        container <- g_wk2wk(container)
    if (!is.raw(container)) {
        stop("'container' must be a raw vector or character string",
             call. = FALSE)
    }

    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)

    wkb <- .g_add_geom(sub_geom, container, as_iso, byte_order)

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))

}

#' @name g_factory
#' @export
g_get_geom <- function(container, sub_geom_idx, as_wkb = TRUE, as_iso = FALSE,
                       byte_order = "LSB") {

    if ((is.character(container) || is.list(container))
        && length(container) > 1) {

        stop("'sub_geom' must be a single geometry", call. = FALSE)
    }
    if (is.character(container))
        container <- g_wk2wk(container)
    if (!is.raw(container)) {
        stop("'container' must be a raw vector or character string",
             call. = FALSE)
    }

    if (!(is.numeric(sub_geom_idx) && length(sub_geom_idx) == 1))
        stop("'sub_geom_idx' must be a single numeric value", call. = FALSE)

    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)

    wkb <- .g_get_geom(container, sub_geom_idx - 1, as_iso, byte_order)

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_factory
#' @export
g_build_collection <- function(geoms, coll_type = "GEOMETRYCOLLECTION",
                               as_wkb = TRUE, as_iso = FALSE,
                               byte_order = "LSB") {

    if (!(is.character(geoms) || is.list(geoms)))
        stop("'geoms' must be a list or character vector", call. = FALSE)

    if (is.character(geoms))
        geoms <- g_wk2wk(geoms)

    # coll_type
    if (is.null(coll_type))
        coll_type <- "GEOMETRYCOLLECTION"
    if (!is.character(coll_type) || length(coll_type) > 1)
        stop("'coll_type' must be a character string", call. = FALSE)
    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)

    wkb <- .g_build_collection(geoms, coll_type, as_iso, byte_order)

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_factory
#' @export
g_build_polygon_from_edges <- function(lines, auto_close = TRUE,
                                       tolerance = 0.0, as_wkb = TRUE,
                                       as_iso = FALSE, byte_order = "LSB") {

    if (!(is.character(lines) || is.list(lines) || is.raw(lines))) {
        stop("'lines' must be a character vector, list, or raw vector",
             call. = FALSE)
    }

    if ((is.character(lines) || is.list(lines))
        && length(lines) > 1) {

        lines <- g_build_collection(lines)
    }

    if (is.character(lines))
        lines <- g_wk2wk(lines)

    if (is.list(lines)) {
        if (!is.raw(lines[[1]])) {
            stop("'lines' as list input must be a WKB raw vector",
                 call. = FALSE)
        } else {
            lines <- lines[[1]]
        }
    }

    # auto_close
    if (is.null(auto_close))
        auto_close <- TRUE
    if (!is.logical(auto_close) || length(auto_close) > 1)
        stop("'auto_close' must be a single logical value", call. = FALSE)
    # tolerance
    if (is.null(tolerance))
        tolerance <- 0.0
    if (!(is.numeric(tolerance) && length(tolerance) == 1))
        stop("'tolerance' must be a single numeric value", call. = FALSE)
    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)

    wkb <- .g_build_polygon_from_edges(lines, auto_close, tolerance, as_iso,
                                       byte_order)

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' Obtain information about WKB/WKT geometries
#'
#' These functions return information about WKB/WKT geometries. The input
#' geometries may be given as a single raw vector of WKB, a list of WKB raw
#' vectors, or a character vector containing one or more WKT strings.
#'
#' @name g_query
#' @details
#' `g_is_empty()` tests whether a geometry has no points. Returns a logical
#' vector of the same length as the number of input geometries containing
#' `TRUE` for the corresponding geometries that are empty or `FALSE` for
#' non-empty geometries.
#'
#' `g_is_valid()` tests whether a geometry is valid. Returns a logical vector
#' analogous to the above for `g_is_empty()`.
#'
#' `g_invalid_reason()` tests if a geometry is valid and, if not, returns the
#' invalidity reason as a character string. `NA` is returned for valid
#' geometries. Requires GDAL >= 3.13.
#'
#' `g_is_3D()` checks whether a geometry has Z coordinates. Returns a logical
#' vector analogous to the above for `g_is_empty()`.
#'
#' `g_is_measured()` checks whether a geometry is measured (has M values).
#' Returns a logical vector analogous to the above for `g_is_empty()`.
#'
#' `g_is_ring()` tests whether a geometry is a ring, `TRUE` if the
#' coordinates of the geometry form a ring by checking length and closure
#' (self-intersection is not checked), otherwise `FALSE`.
#' Returns a logical vector analogous to the above for `g_is_empty()`.
#'
#' `g_name()` returns the WKT type names of the input geometries in a character
#' vector of the same length as the number of input geometries.
#'
#' `g_summary()` returns text summaries of WKB/WKT geometries in a
#' character vector of the same length as the number of input
#' geometries. Requires GDAL >= 3.7.
#'
#' `g_geom_count()` returns the number of elements in a geometry or number of
#' geometries in container. Only geometries of type `Polygon[25D]`,
#' `MultiPoint[25D]`, `MultiLineString[25D]`, `MultiPolygon[25D]` or
#' `GeometryCollection[25D]` may return a valid value. Other geometry types will
#' silently return `0`.
#'
#' @param geom Either a raw vector of WKB or list of raw vectors, or a
#' character vector containing one or more WKT strings.
#' @param quiet Logical value, `TRUE` to suppress warnings. Defaults to `FALSE`.
#'
#' @seealso
#' [g_make_valid()], [g_set_3D()], [g_set_measured()]
#'
#' @examples
#' g1 <- "POLYGON ((0 0, 10 10, 10 0, 0 0))"
#' g2 <- "POLYGON ((5 1, 9 5, 9 1, 5 1))"
#' g_difference(g2, g1) |> g_is_empty()
#'
#' g1 <- "POLYGON ((0 0, 10 10, 10 0, 0 0))"
#' g2 <- "POLYGON ((0 0, 10 10, 10 0))"
#' g3 <- "POLYGON ((0 0, 10 10, 10 0, 0 1))"
#' g_is_valid(c(g1, g2, g3))
#'
#' # g_invalid_reason() requires GDAL >= 3.13
#' if (gdal_version_num() >= gdal_compute_version(3, 13, 0)) {
#'   g_invalid_reason("LINESTRING(0 0)") |> print()
#'
#'   g_invalid_reason("LINESTRING(0 0, 1 1)") |> print()
#' }
#'
#' g_is_3D(g1)
#' g_is_measured(g1)
#'
#' pt_xyz <- g_create("POINT", c(1, 9, 100))
#' g_is_3D(pt_xyz)
#' g_is_measured(pt_xyz)
#'
#' pt_xyzm <- g_create("POINT", c(1, 9, 100, 2000))
#' g_is_3D(pt_xyzm)
#' g_is_measured(pt_xyzm)
#'
#' f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
#' lyr <- new(GDALVector, f, "mtbs_perims")
#'
#' feat <- lyr$getNextFeature()
#' g_name(feat$geom)
#'
#' # g_summary() requires GDAL >= 3.7
#' if (gdal_version_num() >= gdal_compute_version(3, 7, 0)) {
#'   feat <- lyr$getNextFeature()
#'   g_summary(feat$geom) |> print()
#'
#'   feat_set <- lyr$fetch(5)
#'   g_summary(feat_set$geom) |> print()
#' }
#'
#' g_geom_count(feat$geom)
#'
#' lyr$close()
#' @export
g_is_empty <- function(geom, quiet = FALSE) {
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    ret <- NULL
    if (.is_raw_or_null(geom)) {
        ret <- .g_is_empty(geom, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        ret <- sapply(geom, .g_is_empty, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            ret <- .g_is_empty(g_wk2wk(geom), quiet)
        } else {
            ret <- sapply(g_wk2wk(geom), .g_is_empty, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_query
#' @export
g_is_valid <- function(geom, quiet = FALSE) {
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    ret <- NULL
    if (.is_raw_or_null(geom)) {
        ret <- .g_is_valid(geom, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        ret <- sapply(geom, .g_is_valid, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            ret <- .g_is_valid(g_wk2wk(geom), quiet)
        } else {
            ret <- sapply(g_wk2wk(geom), .g_is_valid, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_query
#' @export
g_invalid_reason <- function(geom, quiet = FALSE) {
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    ret <- NULL
    if (.is_raw_or_null(geom)) {
        ret <- .g_invalid_reason(geom, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        ret <- sapply(geom, .g_invalid_reason, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            ret <- .g_invalid_reason(g_wk2wk(geom), quiet)
        } else {
            ret <- sapply(g_wk2wk(geom), .g_invalid_reason, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_query
#' @export
g_is_3D <- function(geom, quiet = FALSE) {
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    ret <- NULL
    if (.is_raw_or_null(geom)) {
        ret <- .g_is_3D(geom, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        ret <- sapply(geom, .g_is_3D, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            ret <- .g_is_3D(g_wk2wk(geom), quiet)
        } else {
            ret <- sapply(g_wk2wk(geom), .g_is_3D, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_query
#' @export
g_is_measured <- function(geom, quiet = FALSE) {
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    ret <- NULL
    if (.is_raw_or_null(geom)) {
        ret <- .g_is_measured(geom, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        ret <- sapply(geom, .g_is_measured, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            ret <- .g_is_measured(g_wk2wk(geom), quiet)
        } else {
            ret <- sapply(g_wk2wk(geom), .g_is_measured, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_query
#' @export
g_is_ring <- function(geom, quiet = FALSE) {
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    ret <- NULL
    if (.is_raw_or_null(geom)) {
        ret <- .g_is_ring(geom, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        ret <- sapply(geom, .g_is_ring, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            ret <- .g_is_ring(g_wk2wk(geom), quiet)
        } else {
            ret <- sapply(g_wk2wk(geom), .g_is_ring, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_query
#' @export
g_name <- function(geom, quiet = FALSE) {
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    ret <- NULL
    if (.is_raw_or_null(geom)) {
        ret <- .g_name(geom, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        ret <- sapply(geom, .g_name, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            ret <- .g_name(g_wk2wk(geom), quiet)
        } else {
            ret <- sapply(g_wk2wk(geom), .g_name, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_query
#' @export
g_summary <- function(geom, quiet = FALSE) {
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    ret <- NULL
    if (.is_raw_or_null(geom)) {
        ret <- .g_summary(geom, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        ret <- sapply(geom, .g_summary, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            ret <- .g_summary(g_wk2wk(geom), quiet)
        } else {
            ret <- sapply(g_wk2wk(geom), .g_summary, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_query
#' @export
g_geom_count <- function(geom, quiet = FALSE) {
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    ret <- NULL
    if (.is_raw_or_null(geom)) {
        ret <- .g_geom_count(geom, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        ret <- sapply(geom, .g_geom_count, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            ret <- .g_geom_count(g_wk2wk(geom), quiet)
        } else {
            ret <- sapply(g_wk2wk(geom), .g_geom_count, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    return(ret)
}

#' Geometry utility functions operating on WKB or WKT
#'
#' These functions operate on input geometries in OGC WKB or WKT format to
#' perform various manipulations for utility purposes.
#' @name g_util
#' @details
#' These functions use the GEOS library via GDAL headers.
#'
#' `g_make_valid()` attempts to make an invalid geometry valid without losing
#' vertices. Already-valid geometries are cloned without further intervention.
#' Wrapper of `OGR_G_MakeValidEx()` in the GDAL API.
#' Requires GEOS >= 3.8 library. If GDAL is built without GEOS >= 3.8, this
#' function will return a clone of the input geometry if it is valid, or `NULL`
#' (`as_wkb = TRUE`) / `NA` (`as_wkb = FALSE`) if it is invalid. For detailed
#' explanations of geometry validity checking and repair, see
#' \url{https://gdal.org/en/latest/user/geometry_validity.html}.
#'
#' * `"LINEWORK"` is the default method, which combines all rings into a set
#' of noded lines and then extracts valid polygons from that linework
#' (requires GEOS >= 3.10 and GDAL >= 3.4). The `"STRUCTURE"` method first
#' makes all rings valid, then merges shells and subtracts holes from shells to
#' generate a valid result. Assumes that holes and shells are correctly
#' categorized.
#'
#' * `keep_collapsed` only applies to the `"STRUCTURE"` method:
#'   * `FALSE` (the default): collapses are converted to empty geometries
#'   * `TRUE`: collapses are converted to a valid geometry of lower dimension
#'
#' `g_normalize()` organizes the elements, rings, and coordinate order of
#' geometries in a consistent way, so that geometries that represent the same
#' object can be easily compared. Wrapper of `OGR_G_Normalize()` in the GDAL
#' API. Requires GDAL >= 3.3. Normalization ensures the following:
#'
#' * Lines are oriented to have smallest coordinate first (apart from duplicate
#' endpoints)
#' * Rings start with their smallest coordinate (using XY ordering)
#' * Polygon shell rings are oriented clockwise, and holes counter-clockwise
#' * Collection elements are sorted by their first coordinate
#'
#' `g_set_3D()` adds or removes the explicit Z coordinate dimension. Removing
#' the Z coordinate dimension of a geometry will remove any existing Z values.
#' Adding the Z dimension to a geometry collection, a compound curve, a
#' polygon, etc. will affect the children geometries.
#' Wrapper of `OGR_G_Set3D()` in the GDAL API.
#'
#' `g_set_measured()` adds or removes the explicit M coordinate dimension.
#' Removing the M coordinate dimension of a geometry will remove any existing M
#' values. Adding the M dimension to a geometry collection, a compound curve, a
#' polygon, etc. will affect the children geometries.
#' Wrapper of `OGR_G_SetMeasured()` in the GDAL API.
#'
#' `g_swap_xy()` swaps x and y coordinates of the input geometry.
#' Wrapper of `OGR_G_SwapXY()` in the GDAL API.
#'
#' @param geom Either a raw vector of WKB or list of raw vectors, or a
#' character vector containing one or more WKT strings.
#' @param method Character string. One of `"LINEWORK"` (the default) or
#' `"STRUCTURE"` (requires GEOS >= 3.10 and GDAL >= 3.4). See Details.
#' @param keep_collapsed Logical value, applies only to the STRUCTURE method.
#' Defaults to `FALSE`. See Details.
#' @param is_3d Logical value, `TRUE` if the input geometries should have a Z
#' dimension, or `FALSE` to remove the Z dimension.
#' @param is_measured Logical value, `TRUE` if the input geometries should have
#' a M dimension, or `FALSE` to remove the M dimension.
#' @param as_wkb Logical value, `TRUE` to return the output geometry in WKB
#' format (the default), or `FALSE` to return as WKT.
#' @param as_iso Logical value, `TRUE` to export as ISO WKB/WKT (ISO 13249
#' SQL/MM Part 3), or `FALSE` (the default) to export as "Extended WKB/WKT".
#' @param byte_order Character string specifying the byte order when output is
#' WKB. One of `"LSB"` (the default) or `"MSB"` (uncommon).
#' @param quiet Logical value, `TRUE` to suppress warnings. Defaults to `FALSE`.
#' @return
#' A geometry as WKB raw vector or WKT string, or a list/character vector of
#' geometries as WKB/WKT with length equal to `length(geom)`. `NULL` is returned
#' with a warning if WKB input cannot be converted into an OGR geometry object,
#' or if an error occurs in the call to the underlying OGR API (see Note).
#'
#' @seealso
#' [g_is_valid()], [g_is_3D()], [g_is_measured()]\cr\cr
#'
#' GDAL documentation on geometry validity and repair:
#' \url{https://gdal.org/en/latest/user/geometry_validity.html}
#'
#' @note
#' `MakeValid()` in GDAL >= 3.13: Certain geometries cannot be read using GEOS,
#' e.g., if Polygon rings are not closed or do not contain enough vertices. If
#' a geometry cannot be read by GEOS, `NULL` will be returned. Starting with
#' GDAL 3.13, GDAL will attempt to modify these geometries such that they can
#' be read and repaired by GEOS.
#'
#' @examples
#' ## g_make_valid() requires GEOS >= 3.8, otherwise is only a validity test
#' geos_version()
#'
#' # valid
#' wkt <- "POINT (0 0)"
#' g_make_valid(wkt, as_wkb = FALSE)
#'
#' # invalid to valid
#' wkt <- "POLYGON ((0 0,10 10,0 10,10 0,0 0))"
#' g_make_valid(wkt, as_wkb = FALSE)
#'
#' # invalid, note that GDAL >= 3.13 will modify to valid in this case
#' wkt <- "LINESTRING (0 0)"
#' # NULL if GDAL < 3.13, or "POINT (0 0)" with GDAL >= 3.13:
#' g_make_valid(wkt)
#'
#' ## g_normalize() requires GDAL >= 3.3
#' if (gdal_version_num() >= gdal_compute_version(3, 3, 0)) {
#'   g <- "POLYGON ((0 1,1 1,1 0,0 0,0 1))"
#'   g_normalize(g) |> g_wk2wk()
#' }
#'
#' ## set 3D / set measured
#' pt_xyzm <- g_create("POINT", c(1, 9, 100, 2000))
#'
#' g_wk2wk(pt_xyzm, as_iso = TRUE)
#'
#' g_set_3D(pt_xyzm, is_3d = FALSE) |> g_wk2wk(as_iso = TRUE)
#'
#' g_set_measured(pt_xyzm, is_measured = FALSE) |> g_wk2wk(as_iso = TRUE)
#'
#' ## swap XY
#' g <- "GEOMETRYCOLLECTION(POINT(1 2),
#'                          LINESTRING(1 2,2 3),
#'                          POLYGON((0 0,0 1,1 1,0 0)))"
#'
#' g_swap_xy(g, as_wkb = FALSE)
#' @export
g_make_valid <- function(geom, method = "LINEWORK", keep_collapsed = FALSE,
                         as_wkb = TRUE, as_iso = FALSE, byte_order = "LSB",
                         quiet = FALSE) {

    # method
    if (is.null(method))
        method <- "LINEWORK"
    if (!is.character(method) || length(method) > 1)
        stop("'method' must be a character string", call. = FALSE)
    # keep_collapsed
    if (is.null(keep_collapsed))
        keep_collapsed <- FALSE
    if (!is.logical(keep_collapsed) || length(keep_collapsed) > 1)
        stop("'keep_collapsed' must be a single logical value", call. = FALSE)
    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(geom)) {
        wkb <- .g_make_valid(geom, method, keep_collapsed, as_iso,
                             byte_order, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        wkb <- lapply(geom, .g_make_valid, method, keep_collapsed, as_iso,
                      byte_order, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            wkb <- .g_make_valid(g_wk2wk(geom), method, keep_collapsed, as_iso,
                                 byte_order, quiet)
        } else {
            wkb <- lapply(g_wk2wk(geom), .g_make_valid, method, keep_collapsed,
                          as_iso, byte_order, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_util
#' @export
g_normalize <- function(geom, as_wkb = TRUE, as_iso = FALSE, byte_order = "LSB",
                        quiet = FALSE) {

    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(geom)) {
        wkb <- .g_normalize(geom, as_iso, byte_order, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        wkb <- lapply(geom, .g_normalize, as_iso, byte_order, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            wkb <- .g_normalize(g_wk2wk(geom), as_iso, byte_order, quiet)
        } else {
            wkb <- lapply(g_wk2wk(geom), .g_normalize, as_iso, byte_order, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_util
#' @export
g_set_3D <- function(geom, is_3d, as_wkb = TRUE, as_iso = FALSE,
                     byte_order = "LSB", quiet = FALSE) {

    # is_3d
    if (missing(is_3d) || is.null(is_3d) || is.na(is_3d))
        stop("'is_3d' is required", call. = FALSE)
    if (!is.logical(is_3d) || length(is_3d) > 1)
        stop("'is_3d' must be a single logical value", call. = FALSE)
    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(geom)) {
        wkb <- .g_set_3D(geom, is_3d, as_iso, byte_order, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        wkb <- lapply(geom, .g_set_3D, is_3d, as_iso, byte_order, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            wkb <- .g_set_3D(g_wk2wk(geom), is_3d, as_iso, byte_order, quiet)
        } else {
            wkb <- lapply(g_wk2wk(geom), .g_set_3D, is_3d, as_iso, byte_order,
                          quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_util
#' @export
g_set_measured <- function(geom, is_measured, as_wkb = TRUE, as_iso = FALSE,
                           byte_order = "LSB", quiet = FALSE) {

    # is_measured
    if (missing(is_measured) || is.null(is_measured) || is.na(is_measured))
        stop("'is_measured' is required", call. = FALSE)
    if (!is.logical(is_measured) || length(is_measured) > 1)
        stop("'is_measured' must be a single logical value", call. = FALSE)
    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(geom)) {
        wkb <- .g_set_measured(geom, is_measured, as_iso, byte_order, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        wkb <- lapply(geom, .g_set_measured, is_measured, as_iso, byte_order,
                      quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            wkb <- .g_set_measured(g_wk2wk(geom), is_measured, as_iso,
                                   byte_order, quiet)
        } else {
            wkb <- lapply(g_wk2wk(geom), .g_set_measured, is_measured, as_iso,
                          byte_order, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_util
#' @export
g_swap_xy <- function(geom, as_wkb = TRUE, as_iso = FALSE, byte_order = "LSB",
                      quiet = FALSE) {

    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(geom)) {
        wkb <- .g_swap_xy(geom, as_iso, byte_order, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        wkb <- lapply(geom, .g_swap_xy, as_iso, byte_order, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            wkb <- .g_swap_xy(g_wk2wk(geom), as_iso, byte_order, quiet)
        } else {
            wkb <- lapply(g_wk2wk(geom), .g_swap_xy, as_iso, byte_order, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' Obtain the 2D or 3D bounding envelope for input geometries
#'
#' `g_envelope()` computes and returns the bounding envelope(s) for the input
#' geometries. Wrapper of `OGR_G_GetEnvelope()` / `OGR_G_GetEnvelope3D()` in
#' the GDAL Geometry API.
#'
#' @param geom Either a raw vector of WKB or list of raw vectors, or a
#' character vector containing one or more WKT strings.
#' @param as_3d Logical value. `TRUE` to return the 3D bounding envelope.
#' The 2D envelope is returned by default (`as_3d = FALSE`).
#' @param quiet Logical value, `TRUE` to suppress warnings. Defaults to `FALSE`.
#' @return Either a numeric vector of length `4` containing the 2D envelope
#' `(xmin, xmax, ymin, ymax)` or of length `6` containing the 3D envelope
#' `(xmin, xmax, ymin, ymax, zmin, zmax)`, or a four-column or six-column
#' numeric matrix with number of rows equal to the number of input geometries
#' and column names `("xmin", "xmax", "ymin", "ymax")`, or
#' `("xmin", "xmax", "ymin", "ymax", "zmin", "zmax")` for the 3D case.
#' @export
g_envelope <- function(geom, as_3d = FALSE, quiet = FALSE) {
    # as_3d
    if (is.null(as_3d))
        as_3d <- FALSE
    if (!is.logical(as_3d) || length(as_3d) > 1)
        stop("'as_3d' must be a single logical value", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    ret <- 0
    if (.is_raw_or_null(geom)) {
        ret <- .g_envelope(geom, as_3d, quiet)
        if (as_3d)
            names(ret) <- c("xmin", "xmax", "ymin", "ymax", "zmin", "zmax")
        else
            names(ret) <- c("xmin", "xmax", "ymin", "ymax")
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        ret <- t(sapply(geom, .g_envelope, as_3d, quiet))
        if (as_3d)
            colnames(ret) <- c("xmin", "xmax", "ymin", "ymax", "zmin", "zmax")
        else
            colnames(ret) <- c("xmin", "xmax", "ymin", "ymax")
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            ret <- .g_envelope(g_wk2wk(geom), as_3d, quiet)
        if (as_3d)
            names(ret) <- c("xmin", "xmax", "ymin", "ymax", "zmin", "zmax")
        else
            names(ret) <- c("xmin", "xmax", "ymin", "ymax")
        } else {
            ret <- t(sapply(g_wk2wk(geom), .g_envelope, as_3d, quiet))
        if (as_3d)
            colnames(ret) <- c("xmin", "xmax", "ymin", "ymax", "zmin", "zmax")
        else
            colnames(ret) <- c("xmin", "xmax", "ymin", "ymax")
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    return(ret)
}

#' Geometry binary predicates operating on WKB or WKT
#'
#' These functions implement tests for pairs of geometries in OGC WKB or
#' WKT format.
#' @name g_binary_pred
#' @details
#' These functions use the GEOS library via GDAL headers.
#'
#' `g_intersects()` tests whether two geometries intersect.
#'
#' `g_disjoint()` tests if this geometry and the other geometry are disjoint.
#'
#' `g_touches()` tests if this geometry and the other geometry are touching.
#'
#' `g_contains()` tests if this geometry contains the other geometry.
#'
#' `g_within()` tests if this geometry is within the other geometry.
#'
#' `g_crosses()` tests if this geometry and the other geometry are crossing.
#'
#' `g_overlaps()` tests if this geometry and the other geometry overlap, that
#' is, their intersection has a non-zero area (they have some but not all
#' points in common).
#'
#' `g_equals()` tests whether two geometries are equivalent.
#' The GDAL documentation says: "This operation implements the SQL/MM
#' `ST_OrderingEquals()` operation. The comparison is done in a structural way,
#' that is to say that the geometry types must be identical, as well as the
#' number and ordering of sub-geometries and vertices. Or equivalently, two
#' geometries are considered equal by this method if their WKT/WKB
#' representation is equal. Note: this must be distinguished from equality in
#' a spatial way."
#'
#' @param this_geom Either a raw vector of WKB or list of raw vectors, or a
#' character vector containing one or more WKT strings.
#' @param other_geom Either a raw vector of WKB or list of raw vectors, or a
#' character vector containing one or more WKT strings. Must contain the same
#' number of geometries as `this_geom`, unless `this_geom` contains a single
#' geometry in which case pairwise tests will be performed for one-to-many if
#' `other_geom` contains multiple geometries (i.e., "this-to-others").
#' @param quiet Logical value, `TRUE` to suppress warnings. Defaults to `FALSE`.
#' @return Logical vector with length equal to the number of input geometry
#' pairs.
#'
#' @seealso
#' \url{https://en.wikipedia.org/wiki/DE-9IM}
#'
#' @note
#' `this_geom` and `other_geom` are assumed to be in the same coordinate
#' reference system.
#'
#' If `this_geom`is a single geometry and `other_geom` is a list or vector of
#' multiple geometries, then `this_geom` will be tested against each geometry
#' in `other_geom` (otherwise no recycling is done).
#'
#' Geometry validity is not checked. In case you are unsure of the validity
#' of the input geometries, call `g_is_valid()` before, otherwise the result
#' might be wrong.
#' @export
g_intersects <- function(this_geom, other_geom, quiet = FALSE) {
    if (is.character(this_geom))
        this_geom <- g_wk2wk(this_geom)

    if (!(.is_raw_or_null(this_geom) || (is.list(this_geom) &&
                                         .is_raw_or_null(this_geom[[1]])))) {

        stop("'this_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.character(other_geom))
        other_geom <- g_wk2wk(other_geom)

    if (!(.is_raw_or_null(other_geom) || (is.list(other_geom) &&
                                          .is_raw_or_null(other_geom[[1]])))) {

        stop("'other_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    if (!is.list(this_geom))
        this_geom <- list(this_geom)

    if (!is.list(other_geom))
        other_geom <- list(other_geom)

    return(.g_intersects(this_geom, other_geom, quiet))
}

#' @name g_binary_pred
#' @export
g_disjoint <- function(this_geom, other_geom, quiet = FALSE) {
    if (is.character(this_geom))
        this_geom <- g_wk2wk(this_geom)
    if (!(.is_raw_or_null(this_geom) || (is.list(this_geom) &&
                                         .is_raw_or_null(this_geom[[1]])))) {

        stop("'this_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.character(other_geom))
        other_geom <- g_wk2wk(other_geom)
    if (!(.is_raw_or_null(other_geom) || (is.list(other_geom) &&
                                          .is_raw_or_null(other_geom[[1]])))) {

        stop("'other_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    if (is.list(this_geom) && length(this_geom) == 1)
        this_geom <- this_geom[[1]]
    if (is.list(other_geom) && length(other_geom) == 1)
        other_geom <- other_geom[[1]]

    ret <- NULL
    one_to_many <- FALSE
    if (.is_raw_or_null(this_geom) && .is_raw_or_null(other_geom)) {
        ret <- .g_disjoint(this_geom, other_geom, quiet)
    } else if ((.is_raw_or_null(this_geom) || is.list(this_geom)) &&
               is.list(other_geom)) {

        if (.is_raw_or_null(this_geom) && is.list(other_geom)) {
            one_to_many <- TRUE

        } else if (is.list(this_geom) &&
                   length(this_geom) != length(other_geom)) {

            stop("many-to-many input must contain equal numbers of geometries",
                 call. = FALSE)
        }

        ret <- rep(NA, length(other_geom))
        for (i in seq_along(other_geom)) {
            if (one_to_many)
                ret[i] <- .g_disjoint(this_geom, other_geom[[i]], quiet)
            else
                ret[i] <- .g_disjoint(this_geom[[i]], other_geom[[i]], quiet)
        }

    } else {
        stop("inputs must contain equal number of geometries, or one-to-many",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_binary_pred
#' @export
g_touches <- function(this_geom, other_geom, quiet = FALSE) {
    if (is.character(this_geom))
        this_geom <- g_wk2wk(this_geom)
    if (!(.is_raw_or_null(this_geom) || (is.list(this_geom) &&
                                         .is_raw_or_null(this_geom[[1]])))) {

        stop("'this_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.character(other_geom))
        other_geom <- g_wk2wk(other_geom)
    if (!(.is_raw_or_null(other_geom) || (is.list(other_geom) &&
                                          .is_raw_or_null(other_geom[[1]])))) {

        stop("'other_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    if (is.list(this_geom) && length(this_geom) == 1)
        this_geom <- this_geom[[1]]
    if (is.list(other_geom) && length(other_geom) == 1)
        other_geom <- other_geom[[1]]

    ret <- NULL
    one_to_many <- FALSE
    if (.is_raw_or_null(this_geom) && .is_raw_or_null(other_geom)) {
        ret <- .g_touches(this_geom, other_geom, quiet)
    } else if ((.is_raw_or_null(this_geom) || is.list(this_geom)) &&
               is.list(other_geom)) {

        if (.is_raw_or_null(this_geom) && is.list(other_geom)) {
            one_to_many <- TRUE

        } else if (is.list(this_geom) &&
                   length(this_geom) != length(other_geom)) {

            stop("many-to-many input must contain equal numbers of geometries",
                 call. = FALSE)
        }

        ret <- rep(NA, length(other_geom))
        for (i in seq_along(other_geom)) {
            if (one_to_many)
                ret[i] <- .g_touches(this_geom, other_geom[[i]], quiet)
            else
                ret[i] <- .g_touches(this_geom[[i]], other_geom[[i]], quiet)
        }

    } else {
        stop("inputs must contain equal number of geometries, or one-to-many",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_binary_pred
#' @export
g_contains <- function(this_geom, other_geom, quiet = FALSE) {
    if (is.character(this_geom))
        this_geom <- g_wk2wk(this_geom)
    if (!(.is_raw_or_null(this_geom) || (is.list(this_geom) &&
                                         .is_raw_or_null(this_geom[[1]])))) {

        stop("'this_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.character(other_geom))
        other_geom <- g_wk2wk(other_geom)
    if (!(.is_raw_or_null(other_geom) || (is.list(other_geom) &&
                                          .is_raw_or_null(other_geom[[1]])))) {

        stop("'other_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    if (is.list(this_geom) && length(this_geom) == 1)
        this_geom <- this_geom[[1]]
    if (is.list(other_geom) && length(other_geom) == 1)
        other_geom <- other_geom[[1]]

    ret <- NULL
    one_to_many <- FALSE
    if (.is_raw_or_null(this_geom) && .is_raw_or_null(other_geom)) {
        ret <- .g_contains(this_geom, other_geom, quiet)
    } else if ((.is_raw_or_null(this_geom) || is.list(this_geom)) &&
               is.list(other_geom)) {

        if (.is_raw_or_null(this_geom) && is.list(other_geom)) {
            one_to_many <- TRUE

        } else if (is.list(this_geom) &&
                   length(this_geom) != length(other_geom)) {

            stop("many-to-many input must contain equal numbers of geometries",
                 call. = FALSE)
        }

        ret <- rep(NA, length(other_geom))
        for (i in seq_along(other_geom)) {
            if (one_to_many)
                ret[i] <- .g_contains(this_geom, other_geom[[i]], quiet)
            else
                ret[i] <- .g_contains(this_geom[[i]], other_geom[[i]], quiet)
        }

    } else {
        stop("inputs must contain equal number of geometries, or one-to-many",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_binary_pred
#' @export
g_within <- function(this_geom, other_geom, quiet = FALSE) {
    if (is.character(this_geom))
        this_geom <- g_wk2wk(this_geom)
    if (!(.is_raw_or_null(this_geom) || (is.list(this_geom) &&
                                         .is_raw_or_null(this_geom[[1]])))) {

        stop("'this_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.character(other_geom))
        other_geom <- g_wk2wk(other_geom)
    if (!(.is_raw_or_null(other_geom) || (is.list(other_geom) &&
                                          .is_raw_or_null(other_geom[[1]])))) {

        stop("'other_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    if (is.list(this_geom) && length(this_geom) == 1)
        this_geom <- this_geom[[1]]
    if (is.list(other_geom) && length(other_geom) == 1)
        other_geom <- other_geom[[1]]

    ret <- NULL
    one_to_many <- FALSE
    if (.is_raw_or_null(this_geom) && .is_raw_or_null(other_geom)) {
        ret <- .g_within(this_geom, other_geom, quiet)
    } else if ((.is_raw_or_null(this_geom) || is.list(this_geom)) &&
               is.list(other_geom)) {

        if (.is_raw_or_null(this_geom) && is.list(other_geom)) {
            one_to_many <- TRUE

        } else if (is.list(this_geom) &&
                   length(this_geom) != length(other_geom)) {

            stop("many-to-many input must contain equal numbers of geometries",
                 call. = FALSE)
        }

        ret <- rep(NA, length(other_geom))
        for (i in seq_along(other_geom)) {
            if (one_to_many)
                ret[i] <- .g_within(this_geom, other_geom[[i]], quiet)
            else
                ret[i] <- .g_within(this_geom[[i]], other_geom[[i]], quiet)
        }

    } else {
        stop("inputs must contain equal number of geometries, or one-to-many",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_binary_pred
#' @export
g_crosses <- function(this_geom, other_geom, quiet = FALSE) {
    if (is.character(this_geom))
        this_geom <- g_wk2wk(this_geom)
    if (!(.is_raw_or_null(this_geom) || (is.list(this_geom) &&
                                         .is_raw_or_null(this_geom[[1]])))) {

        stop("'this_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.character(other_geom))
        other_geom <- g_wk2wk(other_geom)
    if (!(.is_raw_or_null(other_geom) || (is.list(other_geom) &&
                                          .is_raw_or_null(other_geom[[1]])))) {

        stop("'other_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    if (is.list(this_geom) && length(this_geom) == 1)
        this_geom <- this_geom[[1]]
    if (is.list(other_geom) && length(other_geom) == 1)
        other_geom <- other_geom[[1]]

    ret <- NULL
    one_to_many <- FALSE
    if (.is_raw_or_null(this_geom) && .is_raw_or_null(other_geom)) {
        ret <- .g_crosses(this_geom, other_geom, quiet)
    } else if ((.is_raw_or_null(this_geom) || is.list(this_geom)) &&
               is.list(other_geom)) {

        if (.is_raw_or_null(this_geom) && is.list(other_geom)) {
            one_to_many <- TRUE

        } else if (is.list(this_geom) &&
                   length(this_geom) != length(other_geom)) {

            stop("many-to-many input must contain equal numbers of geometries",
                 call. = FALSE)
        }

        ret <- rep(NA, length(other_geom))
        for (i in seq_along(other_geom)) {
            if (one_to_many)
                ret[i] <- .g_crosses(this_geom, other_geom[[i]], quiet)
            else
                ret[i] <- .g_crosses(this_geom[[i]], other_geom[[i]], quiet)
        }

    } else {
        stop("inputs must contain equal number of geometries, or one-to-many",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_binary_pred
#' @export
g_overlaps <- function(this_geom, other_geom, quiet = FALSE) {
    if (is.character(this_geom))
        this_geom <- g_wk2wk(this_geom)
    if (!(.is_raw_or_null(this_geom) || (is.list(this_geom) &&
                                         .is_raw_or_null(this_geom[[1]])))) {

        stop("'this_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.character(other_geom))
        other_geom <- g_wk2wk(other_geom)
    if (!(.is_raw_or_null(other_geom) || (is.list(other_geom) &&
                                          .is_raw_or_null(other_geom[[1]])))) {

        stop("'other_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    if (is.list(this_geom) && length(this_geom) == 1)
        this_geom <- this_geom[[1]]
    if (is.list(other_geom) && length(other_geom) == 1)
        other_geom <- other_geom[[1]]

    ret <- NULL
    one_to_many <- FALSE
    if (.is_raw_or_null(this_geom) && .is_raw_or_null(other_geom)) {
        ret <- .g_overlaps(this_geom, other_geom, quiet)
    } else if ((.is_raw_or_null(this_geom) || is.list(this_geom)) &&
               is.list(other_geom)) {

        if (.is_raw_or_null(this_geom) && is.list(other_geom)) {
            one_to_many <- TRUE

        } else if (is.list(this_geom) &&
                   length(this_geom) != length(other_geom)) {

            stop("many-to-many input must contain equal numbers of geometries",
                 call. = FALSE)
        }

        ret <- rep(NA, length(other_geom))
        for (i in seq_along(other_geom)) {
            if (one_to_many)
                ret[i] <- .g_overlaps(this_geom, other_geom[[i]], quiet)
            else
                ret[i] <- .g_overlaps(this_geom[[i]], other_geom[[i]], quiet)
        }

    } else {
        stop("inputs must contain equal number of geometries, or one-to-many",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_binary_pred
#' @export
g_equals <- function(this_geom, other_geom, quiet = FALSE) {
    if (is.character(this_geom))
        this_geom <- g_wk2wk(this_geom)
    if (!(.is_raw_or_null(this_geom) || (is.list(this_geom) &&
                                         .is_raw_or_null(this_geom[[1]])))) {

        stop("'this_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.character(other_geom))
        other_geom <- g_wk2wk(other_geom)
    if (!(.is_raw_or_null(other_geom) || (is.list(other_geom) &&
                                          .is_raw_or_null(other_geom[[1]])))) {

        stop("'other_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    if (is.list(this_geom) && length(this_geom) == 1)
        this_geom <- this_geom[[1]]
    if (is.list(other_geom) && length(other_geom) == 1)
        other_geom <- other_geom[[1]]

    ret <- NULL
    one_to_many <- FALSE
    if (.is_raw_or_null(this_geom) && .is_raw_or_null(other_geom)) {
        ret <- .g_equals(this_geom, other_geom, quiet)
    } else if ((.is_raw_or_null(this_geom) || is.list(this_geom)) &&
               is.list(other_geom)) {

        if (.is_raw_or_null(this_geom) && is.list(other_geom)) {
            one_to_many <- TRUE

        } else if (is.list(this_geom) &&
                   length(this_geom) != length(other_geom)) {

            stop("many-to-many input must contain equal numbers of geometries",
                 call. = FALSE)
        }

        ret <- rep(NA, length(other_geom))
        for (i in seq_along(other_geom)) {
            if (one_to_many)
                ret[i] <- .g_equals(this_geom, other_geom[[i]], quiet)
            else
                ret[i] <- .g_equals(this_geom[[i]], other_geom[[i]], quiet)
        }

    } else {
        stop("inputs must contain an equal number of geometries, or one-to-many",
             call. = FALSE)
    }

    return(ret)
}

#' Binary operations on WKB or WKT geometries
#'
#' These functions implement operations on pairs of geometries in OGC WKB
#' or WKT format.
#' @name g_binary_op
#' @details
#' These functions use the GEOS library via GDAL headers.
#'
#' `g_intersection()` returns a new geometry which is the region of
#' intersection of the two geometries operated on. `g_intersects()` can be used
#' to test if two geometries intersect.
#'
#' `g_union()` returns a new geometry which is the region of
#' union of the two geometries operated on.
#'
#' `g_difference()` returns a new geometry which is the region of this geometry
#' with the region of the other geometry removed.
#'
#' `g_sym_difference()` returns a new geometry which is the symmetric
#' difference of this geometry and the other geometry (union minus
#' intersection).
#'
#' @param this_geom Either a raw vector of WKB or list of raw vectors, or a
#' character vector containing one or more WKT strings.
#' @param other_geom Either a raw vector of WKB or list of raw vectors, or a
#' character vector containing one or more WKT strings. Must contain the same
#' number of geometries as `this_geom`.
#' @param as_wkb Logical value, `TRUE` to return the output geometry in WKB
#' format (the default), or `FALSE` to return as WKT.
#' @param as_iso Logical value, `TRUE` to export as ISO WKB/WKT (ISO 13249
#' SQL/MM Part 3), or `FALSE` (the default) to export as "Extended WKB/WKT".
#' @param byte_order Character string specifying the byte order when output is
#' WKB. One of `"LSB"` (the default) or `"MSB"` (uncommon).
#' @param quiet Logical value, `TRUE` to suppress warnings. Defaults to `FALSE`.
#' @return
#' A geometry as WKB raw vector or WKT string, or a list/character vector of
#' geometries as WKB/WKT with length equal to the number of input geometry
#' pairs.
#' `NULL` (`as_wkb = TRUE`) / `NA` (`as_wkb = FALSE`) is returned with a
#' warning if WKB input cannot be converted into an OGR geometry object, or if
#' an error occurs in the call to the underlying OGR API function.
#'
#' @note
#' `this_geom` and `other_geom` are assumed to be in the same coordinate
#' reference system.
#'
#' Geometry validity is not checked. In case you are unsure of the validity
#' of the input geometries, call `g_is_valid()` before, otherwise the result
#' might be wrong.
#'
#' @examples
#' elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
#' ds <- new(GDALRaster, elev_file)
#' g1 <- ds$bbox() |> bbox_to_wkt()
#' ds$close()
#'
#' g2 <- "POLYGON ((327381.9 5104541.2, 326824.0 5104092.5, 326708.8 5103182.9,
#'   327885.2 5102612.9, 329334.5 5103322.4, 329304.2 5104474.5,328212.7
#'   5104656.4, 328212.7 5104656.4, 327381.9 5104541.2))"
#'
#' # see spatial predicate defintions at https://en.wikipedia.org/wiki/DE-9IM
#' g_intersects(g1, g2)  # TRUE
#' g_overlaps(g1, g2)  # TRUE
#' # therefore,
#' g_contains(g1, g2)  # FALSE
#'
#' g_sym_difference(g1, g2) |> g_area()
#'
#' g3 <- g_intersection(g1, g2)
#' g4 <- g_union(g1, g2)
#' g_difference(g4, g3) |> g_area()
#' @export
g_intersection <- function(this_geom, other_geom, as_wkb = TRUE,
                           as_iso = FALSE, byte_order = "LSB",
                           quiet = FALSE) {

    if (is.character(this_geom))
        this_geom <- g_wk2wk(this_geom)
    if (!(.is_raw_or_null(this_geom) || (is.list(this_geom) &&
                                         .is_raw_or_null(this_geom[[1]])))) {

        stop("'this_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.character(other_geom))
        other_geom <- g_wk2wk(other_geom)
    if (!(.is_raw_or_null(other_geom) || (is.list(other_geom) &&
                                          .is_raw_or_null(other_geom[[1]])))) {

        stop("'other_geom' must be raw vector or character",
             call. = FALSE)
    }

    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(this_geom) && .is_raw_or_null(other_geom)) {
        wkb <- .g_intersection(this_geom, other_geom, as_iso,
                               byte_order, quiet)
    } else if (is.list(this_geom) && is.list(other_geom)) {
        if (length(this_geom) != length(other_geom)) {
            stop("inputs must contain an equal number of geometries",
                 call. = FALSE)
        }

        wkb <- list()
        for (i in seq_along(this_geom)) {
            wkb[[i]] <- .g_intersection(this_geom[[i]], other_geom[[i]], as_iso,
                                        byte_order, quiet)
        }

    } else {
        stop("inputs must contain an equal number of geometries",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_binary_op
#' @export
g_union <- function(this_geom, other_geom, as_wkb = TRUE,
                    as_iso = FALSE, byte_order = "LSB",
                    quiet = FALSE) {

    if (is.character(this_geom))
        this_geom <- g_wk2wk(this_geom)
    if (!(.is_raw_or_null(this_geom) || (is.list(this_geom) &&
                                         .is_raw_or_null(this_geom[[1]])))) {

        stop("'this_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.character(other_geom))
        other_geom <- g_wk2wk(other_geom)
    if (!(.is_raw_or_null(other_geom) || (is.list(other_geom) &&
                                          .is_raw_or_null(other_geom[[1]])))) {

        stop("'other_geom' must be raw vector or character",
             call. = FALSE)
    }

    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(this_geom) && .is_raw_or_null(other_geom)) {
        wkb <- .g_union(this_geom, other_geom, as_iso,
                        byte_order, quiet)
    } else if (is.list(this_geom) && is.list(other_geom)) {
        if (length(this_geom) != length(other_geom)) {
            stop("inputs must contain an equal number of geometries",
                 call. = FALSE)
        }

        wkb <- list()
        for (i in seq_along(this_geom)) {
            wkb[[i]] <- .g_union(this_geom[[i]], other_geom[[i]], as_iso,
                                 byte_order, quiet)
        }

    } else {
        stop("inputs must contain an equal number of geometries",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_binary_op
#' @export
g_difference <- function(this_geom, other_geom, as_wkb = TRUE,
                         as_iso = FALSE, byte_order = "LSB",
                         quiet = FALSE) {

    if (is.character(this_geom))
        this_geom <- g_wk2wk(this_geom)
    if (!(.is_raw_or_null(this_geom) || (is.list(this_geom) &&
                                         .is_raw_or_null(this_geom[[1]])))) {

        stop("'this_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.character(other_geom))
        other_geom <- g_wk2wk(other_geom)
    if (!(.is_raw_or_null(other_geom) || (is.list(other_geom) &&
                                          .is_raw_or_null(other_geom[[1]])))) {

        stop("'other_geom' must be raw vector or character",
             call. = FALSE)
    }

    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(this_geom) && .is_raw_or_null(other_geom)) {
        wkb <- .g_difference(this_geom, other_geom, as_iso,
                             byte_order, quiet)
    } else if (is.list(this_geom) && is.list(other_geom)) {
        if (length(this_geom) != length(other_geom)) {
            stop("inputs must contain an equal number of geometries",
                 call. = FALSE)
        }

        wkb <- list()
        for (i in seq_along(this_geom)) {
            wkb[[i]] <- .g_difference(this_geom[[i]], other_geom[[i]], as_iso,
                                      byte_order, quiet)
        }

    } else {
        stop("inputs must contain an equal number of geometries",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_binary_op
#' @export
g_sym_difference <- function(this_geom, other_geom, as_wkb = TRUE,
                         as_iso = FALSE, byte_order = "LSB",
                         quiet = FALSE) {

    if (is.character(this_geom))
        this_geom <- g_wk2wk(this_geom)
    if (!(.is_raw_or_null(this_geom) || (is.list(this_geom) &&
                                         .is_raw_or_null(this_geom[[1]])))) {

        stop("'this_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.character(other_geom))
        other_geom <- g_wk2wk(other_geom)
    if (!(.is_raw_or_null(other_geom) || (is.list(other_geom) &&
                                          .is_raw_or_null(other_geom[[1]])))) {

        stop("'other_geom' must be raw vector or character",
             call. = FALSE)
    }

    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(this_geom) && .is_raw_or_null(other_geom)) {
        wkb <- .g_sym_difference(this_geom, other_geom, as_iso,
                                 byte_order, quiet)
    } else if (is.list(this_geom) && is.list(other_geom)) {
        if (length(this_geom) != length(other_geom)) {
            stop("inputs must contain an equal number of geometries",
                 call. = FALSE)
        }

        wkb <- list()
        for (i in seq_along(this_geom)) {
            wkb[[i]] <- .g_sym_difference(this_geom[[i]], other_geom[[i]],
                                          as_iso, byte_order, quiet)
        }

    } else {
        stop("inputs must contain an equal number of geometries",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' Compute measurements for WKB/WKT geometries
#'
#' These functions compute measurements for geometries. The input
#' geometries may be given as a single raw vector of WKB, a list of WKB raw
#' vectors, or a character vector containing one or more WKT strings.
#' @name g_measures
#' @details
#' These functions use the GEOS library via GDAL headers.
#'
#' `g_area()` computes the area for a `Polygon` or `MultiPolygon`. Undefined
#' for all other geometry types (returns zero). Returns a numeric vector,
#' having length equal to the number of input geometries, containing
#' computed area or '0' if undefined.
#'
#' `g_centroid()` returns a numeric vector of length 2 containing the centroid
#' (X, Y), or a two-column numeric matrix (X, Y) with number of rows equal to
#' the number of input geometries.
#' The GDAL documentation states "This method relates to the SFCOM
#' `ISurface::get_Centroid()` method however the current implementation based
#' on GEOS can operate on other geometry types such as multipoint, linestring,
#' geometrycollection such as multipolygons. OGC SF SQL 1.1 defines the
#' operation for surfaces (polygons). SQL/MM-Part 3 defines the operation for
#' surfaces and multisurfaces (multipolygons)."
#'
#' `g_distance()` returns the distance between two geometries or `-1` if an
#' error occurs. Returns the shortest distance between the two geometries.
#' The distance is expressed into the same unit as the coordinates of the
#' geometries. Returns a numeric vector, having length equal to the number of
#' input geometry pairs, containing computed distance or '-1' if an error
#' occurs.
#'
#' `g_length()` computes the length for `LineString` or `MultiCurve` objects.
#' Undefined for all other geometry types (returns zero). Returns a numeric
#' vector, having length equal to the number of input geometries, containing
#' computed length or '0' if undefined.
#'
#' `g_geodesic_area()` computes geometry area, considered as a surface on the
#' underlying ellipsoid of the SRS attached to the geometry. The returned area
#' will always be in square meters, and assumes that polygon edges describe
#' geodesic lines on the ellipsoid. If the geometry SRS is not a geographic
#' one, geometries are reprojected to the underlying geographic SRS.
#' By default, input geometry vertices are assumed to be in longitude/latitude
#' order if using a geographic coordinate system. This can be overridden with
#' the `traditional_gis_order` argument.
#' Returns the area in square meters, or `NA` in case of error (unsupported
#' geometry type, no SRS attached, etc.)
#' Requires GDAL >= 3.9.
#'
#' `g_geodesic_length()` computes the length of the curve, considered as a
#' geodesic line on the underlying ellipsoid of the SRS attached to the
#' geometry. The returned length will always be in meters. If the geometry SRS
#' is not a geographic one, geometries are reprojected to the underlying
#' geographic SRS.
#' By default, input geometry vertices are assumed to be in longitude/latitude
#' order if using a geographic coordinate system. This can be overridden with
#' the `traditional_gis_order` argument.
#' Returns the length in meters, or `NA` in case of error (unsupported geometry
#' type, no SRS attached, etc.)
#' Requires GDAL >= 3.10.
#'
#' @param geom Either a raw vector of WKB or list of raw vectors, or a
#' character vector containing one or more WKT strings.
#' @param other_geom Either a raw vector of WKB or list of raw vectors, or a
#' character vector containing one or more WKT strings. Must contain the same
#' number of geometries as `geom`, unless `geom` contains a single
#' geometry in which case pairwise distances will be computed for one-to-many
#' if `other_geom` contains multiple geometries (i.e., "this-to-others").
#' @param srs Character string specifying the spatial reference system
#' for `geom`. May be in WKT format or any of the formats supported by
#' [srs_to_wkt()].
#' @param traditional_gis_order Logical value, `TRUE` to use traditional GIS
#' order of axis mapping (the default) or `FALSE` to use authority compliant
#' axis order. By default, input `geom` vertices are assumed to
#' be in longitude/latitude order if `srs` is a geographic coordinate system.
#' This can be overridden by setting `traditional_gis_order = FALSE`.
#' @param quiet Logical value, `TRUE` to suppress warnings. Defaults to `FALSE`.
#'
#' @note
#' For `g_distance()`, `geom` and `other_geom` must be in the same coordinate
#' reference system. If `geom` is a single geometry and `other_geom` is a list
#' or vector of multiple geometries, then distances will be calculated between
#' `geom` and each geometry in `other_geom`. Otherwise, no recycling is done
#' and `length(geom)` must equal `length(other_geom)` to calculate distance
#' between each corresponding pair of input geometries.
#'
#' Geometry validity is not checked. In case you are unsure of the validity
#' of the input geometries, call `g_is_valid()` before, otherwise the result
#' might be wrong.
#'
#' @examples
#' g_area("POLYGON ((0 0, 10 10, 10 0, 0 0))")
#'
#' g_centroid("POLYGON ((0 0, 10 10, 10 0, 0 0))")
#'
#' g_distance("POINT (0 0)", "POINT (5 12)")
#'
#' g_length("LINESTRING (0 0, 3 4)")
#'
#' f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
#' lyr <- new(GDALVector, f, "mtbs_perims")
#'
#' # read all features into a data frame
#' feat_set <- lyr$fetch(-1)
#' head(feat_set)
#'
#' g_area(feat_set$geom) |> head()
#'
#' g_centroid(feat_set$geom) |> head()
#'
#' lyr$close()
#' @export
g_area <- function(geom, quiet = FALSE) {
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    ret <- 0
    if (.is_raw_or_null(geom)) {
        ret <- .g_area(geom, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        ret <- sapply(geom, .g_area, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            ret <- .g_area(g_wk2wk(geom), quiet)
        } else {
            ret <- sapply(g_wk2wk(geom), .g_area, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_measures
#' @export
g_centroid <- function(geom, quiet = FALSE) {
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    ret <- 0
    if (.is_raw_or_null(geom)) {
        ret <- .g_centroid(geom, quiet)
        names(ret) <- c("x", "y")
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        ret <- t(sapply(geom, .g_centroid, quiet))
        colnames(ret) <- c("x", "y")
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            ret <- .g_centroid(g_wk2wk(geom), quiet)
            names(ret) <- c("x", "y")
        } else {
            ret <- t(sapply(g_wk2wk(geom), .g_centroid, quiet))
            colnames(ret) <- c("x", "y")
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_measures
#' @export
g_distance <- function(geom, other_geom, quiet = FALSE) {
    if (is.character(geom))
        geom <- g_wk2wk(geom)
    if (!(.is_raw_or_null(geom) || (is.list(geom) &&
                                    .is_raw_or_null(geom[[1]])))) {

        stop("'geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.character(other_geom))
        other_geom <- g_wk2wk(other_geom)
    if (!(.is_raw_or_null(other_geom) || (is.list(other_geom) &&
                                          .is_raw_or_null(other_geom[[1]])))) {

        stop("'other_geom' must be raw vector or character",
             call. = FALSE)
    }

    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    if (is.list(geom) && length(geom) == 1)
        geom <- geom[[1]]
    if (is.list(other_geom) && length(other_geom) == 1)
        other_geom <- other_geom[[1]]

    ret <- -1
    one_to_many <- FALSE
    if (.is_raw_or_null(geom) && .is_raw_or_null(other_geom)) {
        ret <- .g_distance(geom, other_geom, quiet)
    } else if ((.is_raw_or_null(geom) || is.list(geom)) &&
               is.list(other_geom)) {

        if (.is_raw_or_null(geom) && is.list(other_geom)) {
            one_to_many <- TRUE

        } else if (is.list(geom) &&
                   length(geom) != length(other_geom)) {

            stop("many-to-many input must contain equal numbers of geometries",
                 call. = FALSE)
        }

        ret <- rep(-1, length(other_geom))
        for (i in seq_along(other_geom)) {
            if (one_to_many)
                ret[i] <- .g_distance(geom, other_geom[[i]], quiet)
            else
                ret[i] <- .g_distance(geom[[i]], other_geom[[i]], quiet)
        }

    } else {
        stop("inputs must contain equal number of geometries, or one-to-many",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_measures
#' @export
g_length <- function(geom, quiet = FALSE) {
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    ret <- 0
    if (.is_raw_or_null(geom)) {
        ret <- .g_length(geom, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        ret <- sapply(geom, .g_length, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            ret <- .g_length(g_wk2wk(geom), quiet)
        } else {
            ret <- sapply(g_wk2wk(geom), .g_length, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_measures
#' @export
g_geodesic_area <- function(geom, srs, traditional_gis_order = TRUE,
                            quiet = FALSE) {

    if (!(is.character(srs) && length(srs) == 1))
        stop("'srs' must be a character string", call. = FALSE)
    if (is.null(traditional_gis_order))
        traditional_gis_order <- TRUE
    if (!(is.logical(traditional_gis_order) &&
          length(traditional_gis_order) == 1)) {

        stop("'traditional_gis_order' must be a single logical value",
             call. = FALSE)
    }
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    ret <- -1.0
    if (.is_raw_or_null(geom)) {
        ret <- .g_geodesic_area(geom, srs, traditional_gis_order, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        ret <- sapply(geom, .g_geodesic_area, srs, traditional_gis_order,
                      quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            ret <- .g_geodesic_area(g_wk2wk(geom), srs, traditional_gis_order,
                                    quiet)
        } else {
            ret <- sapply(g_wk2wk(geom), .g_geodesic_area, srs,
                          traditional_gis_order, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    return(ret)
}

#' @name g_measures
#' @export
g_geodesic_length <- function(geom, srs, traditional_gis_order = TRUE,
                              quiet = FALSE) {

    if (!(is.character(srs) && length(srs) == 1))
        stop("'srs' must be a character string", call. = FALSE)
    if (is.null(traditional_gis_order))
        traditional_gis_order <- TRUE
    if (!(is.logical(traditional_gis_order) &&
          length(traditional_gis_order) == 1)) {

        stop("'traditional_gis_order' must be a single logical value",
             call. = FALSE)
    }
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    ret <- -1.0
    if (.is_raw_or_null(geom)) {
        ret <- .g_geodesic_length(geom, srs, traditional_gis_order, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        ret <- sapply(geom, .g_geodesic_length, srs, traditional_gis_order,
                      quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            ret <- .g_geodesic_length(g_wk2wk(geom), srs, traditional_gis_order,
                                      quiet)
        } else {
            ret <- sapply(g_wk2wk(geom), .g_geodesic_length, srs,
                          traditional_gis_order, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    return(ret)
}

#' Unary operations on WKB or WKT geometries
#'
#' These functions implement algorithms that operate on one input geometry
#' for which a new output geometry is generated.
#' The input geometries may be given as a single raw vector of WKB, a list of
#' WKB raw vectors, or a character vector containing one or more WKT strings.
#' @name g_unary_op
#' @details
#' These functions use the GEOS library via GDAL headers.
#'
#' `g_boundary()` computes the boundary of a geometry. Wrapper of
#' `OGR_G_Boundary()` in the GDAL Geometry API.
#'
#' `g_buffer()` builds a new geometry containing the buffer region around
#' the geometry on which it is invoked. The buffer is a polygon containing
#' the region within the buffer distance of the original geometry.
#' Wrapper of `OGR_G_Buffer()` in the GDAL API.
#'
#' `g_convex_hull()` computes a convex hull, the smallest convex geometry that
#' contains all the points in the input geometry. Wrapper of
#' `OGR_G_ConvexHull()` in the GDAL API.
#'
#' `g_concave_hull()` returns a "concave hull" of a geometry. A concave hull is
#' a polygon which contains all the points of the input, but is a better
#' approximation than the convex hull to the area occupied by the input.
#' Frequently used to convert a multi-point into a polygonal area that contains
#' all the points in the input geometry. Requires GDAL >= 3.6 and GEOS >= 3.11.
#'
#' `g_delaunay_triangulation()`
#' * `constrained = FALSE`: returns a Delaunay triangulation of the vertices of
#' the input geometry. Wrapper of `OGR_G_DelaunayTriangulation()` in the GDAL
#' API. Requires GEOS >= 3.4.
#' * `constrained = TRUE`: returns a constrained Delaunay triangulation of the
#' vertices of the given polygon(s). For non-polygonal inputs, silently returns
#' an empty geometry collection. Requires GDAL >= 3.12 and GEOS >= 3.10.
#'
#' `g_segmentize()` modifies a geometry such that it has no segment longer then
#' the given `max_length`. Interpolated points will have Z and M values
#' (if needed) set to `0`. Distance computation is performed in 2D only.
#'
#' `g_simplify()` computes a simplified geometry. By default, it simplifies
#' the input geometries while preserving topology (see Note). Wrapper of
#' `OGR_G_Simplify()` / `OGR_G_SimplifyPreserveTopology()` in the GDAL API.
#'
#' `g_unary_union()` returns the union of all components of a single geometry.
#' Usually used to convert a collection into the smallest set of polygons that
#' cover the same area. See \url{https://postgis.net/docs/ST_UnaryUnion.html}
#' for more details. Requires GDAL >= 3.7.
#'
#' @param geom Either a raw vector of WKB or list of raw vectors, or a
#' character vector containing one or more WKT strings.
#' @param dist Numeric buffer distance in units of the input `geom`.
#' @param quad_segs Integer number of segments used to define a 90 degree
#' curve (quadrant of a circle). Large values result in large numbers of
#' vertices in the resulting buffer geometry while small numbers reduce the
#' accuracy of the result.
#' @param ratio Numeric value in interval `[0, 1]`. The target criterion
#' parameter for `g_concave_hull()`, expressed as a ratio between the lengths
#' of the longest and shortest edges. `1` produces the convex hull; `0` produces
#' a hull with maximum concaveness (see Note).
#' @param allow_holes Logical value, whether holes are allowed.
#' @param constrained Logical value, `TRUE` to return a constrained Delaunay
#' triangulation of the vertices of the given polygon(s). Defaults to `FALSE`.
#' @param max_length Numeric maximum distance between 2 points after
#' segmentization.
#' @param tolerance Numeric value. For `g_simplify()`, the simplification
#' tolerance as distance in units of the input `geom`. Simplification removes
#' vertices which are within the tolerance distance of the simplified linework
#' (as long as topology is preserved when `preserve_topology = TRUE`).
#' For `g_delaunay_triangulation()`, an optional snapping tolerance to use for
#' improved robustness (ignored if `constrained = TRUE`).
#' @param only_edges Logical value. If `TRUE`, `g_delaunay_triangulation()`
#' will return a MULTILINESTRING, otherwise it will return a GEOMETRYCOLLECTION
#' containing triangular POLYGONs (the default). Ignored if `constrained = TRUE`
#' @param preserve_topology Logical value, `TRUE` to simplify geometries while
#' preserving topology (the default). Setting to `FALSE` simplifies geometries
#' using the standard Douglas-Peucker algorithm which is significantly faster
#' (see Note).
#' @param as_wkb Logical value, `TRUE` to return the output geometry in WKB
#' format (the default), or `FALSE` to return as WKT.
#' @param as_iso Logical value, `TRUE` to export as ISO WKB/WKT (ISO 13249
#' SQL/MM Part 3), or `FALSE` (the default) to export as "Extended WKB/WKT".
#' @param byte_order Character string specifying the byte order when output is
#' WKB. One of `"LSB"` (the default) or `"MSB"` (uncommon).
#' @param quiet Logical value, `TRUE` to suppress warnings. Defaults to `FALSE`.
#' @return
#' A geometry as WKB raw vector or WKT string, or a list/character vector of
#' geometries as WKB/WKT with length equal to the number of input geometries.
#'  `NULL` (`as_wkb = TRUE`) / `NA` (`as_wkb = FALSE`) is returned with a
#' warning if WKB input cannot be converted into an OGR geometry object, or if
#' an error occurs in the call to the underlying OGR API.
#'
#' @note
#' Definitions of these operations are given in the GEOS documentation
#' (\url{https://libgeos.org/doxygen/}, GEOS 3.15.0dev), some of which is
#' copied here.
#'
#' `g_boundary()` computes the "boundary" as defined by the DE9IM
#' (\url{https://en.wikipedia.org/wiki/DE-9IM}):
#' * the boundary of a `Polygon` is the set of linear rings dividing the
#' exterior from the interior
#' * the boundary of a `LineString` is the two end points
#' * the boundary of a `Point`/`MultiPoint` is defined as empty
#'
#' `g_buffer()` always returns a polygonal result. The negative or
#' zero-distance buffer of lines and points is always an empty `Polygon`.
#'
#' `g_convex_hull()` uses the Graham Scan algorithm.
#'
#' `g_concave_hull()`: A set of points has a sequence of hulls of increasing
#' concaveness, determined by a numeric target parameter. The concave hull is
#' constructed by removing the longest outer edges of the Delaunay Triangulation
#' of the space between the polygons, until the target criterion parameter is
#' reached. This can be expressed as a ratio between the lengths of the longest
#' and shortest edges. `1` produces the convex hull; `0` produces a hull with
#' maximum concaveness.
#'
#' `g_simplify()`:
#' * With `preserve_topology = TRUE` (the default):\cr
#' Simplifies a geometry, ensuring that the result is a valid geometry having
#' the same dimension and number of components as the input. The simplification
#' uses a maximum distance difference algorithm similar to the one used in the
#' Douglas-Peucker algorithm. In particular, if the input is an areal geometry
#' (`Polygon` or `MultiPolygon`), the result has the same number of shells and
#' holes (rings) as the input, in the same order. The result rings touch at no
#' more than the number of touching point in the input (although they may touch
#' at fewer points).
#' * With `preserve_topology = FALSE`:\cr
#' Simplifies a geometry using the standard Douglas-Peucker algorithm. Ensures
#' that any polygonal geometries returned are valid. Simple lines are not
#' guaranteed to remain simple after simplification. Note that in general D-P
#' does not preserve topology - e.g. polygons can be split, collapse to lines
#' or disappear, holes can be created or disappear, and lines can cross. To
#' simplify geometry while preserving topology use
#' `TopologyPreservingSimplifier`. (However, using D-P is significantly faster.)
#'
#' `preserve_topology = TRUE` does not preserve boundaries shared between
#' polygons.
#'
#' @examples
#' g <- "POLYGON((0 0,1 1,1 0,0 0))"
#' g_boundary(g, as_wkb = FALSE)
#'
#' g <- "POINT (0 0)"
#' g_buffer(g, dist = 10, as_wkb = FALSE)
#'
#' g <- "GEOMETRYCOLLECTION(POINT(0 1), POINT(0 0), POINT(1 0), POINT(1 1))"
#' g_convex_hull(g, as_wkb = FALSE)
#'
#' # g_concave_hull() requires GDAL >= 3.6 and GEOS >= 3.11
#' if (gdal_version_num() >= gdal_compute_version(3, 6, 0) &&
#'     (geos_version()$major > 3 || geos_version()$minor >= 11)) {
#'   g <- "MULTIPOINT(0 0,0.4 0.5,0 1,1 1,0.6 0.5,1 0)"
#'   g_concave_hull(g, ratio = 0.5, allow_holes = FALSE, as_wkb = FALSE)
#' }
#'
#' # g_delaunay_triangulation() requires GEOS >= 3.4
#' if (geos_version()$major > 3 || geos_version()$minor >= 4) {
#'   g <- "MULTIPOINT(0 0,0 1,1 1,1 0)"
#'   g_delaunay_triangulation(g, as_wkb = FALSE)
#' }
#'
#' g <- "LINESTRING(0 0,0 10)"
#' g_segmentize(g, 1) |> g_wk2wk()
#'
#' g <- "LINESTRING(0 0,1 1,10 0)"
#' g_simplify(g, tolerance = 5, as_wkb = FALSE)
#'
#' # g_unary_union() requires GDAL >= 3.7
#' if (gdal_version_num() >= gdal_compute_version(3, 7, 0)) {
#'   g <- "GEOMETRYCOLLECTION(POINT(0.5 0.5), POLYGON((0 0,0 1,1 1,1 0,0 0)),
#'         POLYGON((1 0,1 1,2 1,2 0,1 0)))"
#'   g_unary_union(g, as_wkb = FALSE)
#' }
#' @export
g_buffer <- function(geom, dist, quad_segs = 30L, as_wkb = TRUE,
                     as_iso = FALSE, byte_order = "LSB", quiet = FALSE) {

    # dist
    if (missing(dist) || is.null(dist))
        stop("a value for 'dist' is required", call. = FALSE)
    if (!is.numeric(dist) || length(dist) > 1)
        stop("'dist' must be a single numeric value", call. = FALSE)
    # quad_segs
    if (missing(quad_segs) || is.null(quad_segs))
        quad_segs <- 30L
    if (!is.numeric(quad_segs) || length(quad_segs) > 1) {
        stop("'quad_segs' must be a single numeric value (integer)",
             call. = FALSE)
    }
    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(geom)) {
        wkb <- .g_buffer(geom, dist, quad_segs, as_iso, byte_order, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        wkb <- lapply(geom, .g_buffer, dist, quad_segs, as_iso,
                      byte_order, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            wkb <- .g_buffer(g_wk2wk(geom), dist, quad_segs, as_iso,
                             byte_order, quiet)
        } else {
            wkb <- lapply(g_wk2wk(geom), .g_buffer, dist, quad_segs,
                          as_iso, byte_order, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_unary_op
#' @export
g_boundary <- function(geom, as_wkb = TRUE, as_iso = FALSE,
                       byte_order = "LSB", quiet = FALSE) {
    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(geom)) {
        wkb <- .g_boundary(geom, as_iso, byte_order, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        wkb <- lapply(geom, .g_boundary, as_iso, byte_order, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            wkb <- .g_boundary(g_wk2wk(geom), as_iso, byte_order, quiet)
        } else {
            wkb <- lapply(g_wk2wk(geom), .g_boundary, as_iso, byte_order,
                          quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_unary_op
#' @export
g_convex_hull <- function(geom, as_wkb = TRUE, as_iso = FALSE,
                          byte_order = "LSB", quiet = FALSE) {
    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(geom)) {
        wkb <- .g_convex_hull(geom, as_iso, byte_order, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        wkb <- lapply(geom, .g_convex_hull, as_iso, byte_order, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            wkb <- .g_convex_hull(g_wk2wk(geom), as_iso, byte_order, quiet)
        } else {
            wkb <- lapply(g_wk2wk(geom), .g_convex_hull, as_iso, byte_order,
                          quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_unary_op
#' @export
g_concave_hull <- function(geom, ratio, allow_holes, as_wkb = TRUE,
                           as_iso = FALSE, byte_order = "LSB",
                           quiet = FALSE) {
    # ratio
    if (missing(ratio) || is.null(ratio) || all(is.na(ratio)))
        stop("'ratio' is required", call. = FALSE)
    if (!(is.numeric(ratio) && length(ratio) == 1))
        stop("'ratio' must be a single numeric value [0, 1]", call. = FALSE)
    # allow_holes
    if (missing(allow_holes) || is.null(allow_holes) || all(is.na(allow_holes)))
        stop("'allow_holes' is required", call. = FALSE)
    if (!(is.logical(allow_holes) && length(allow_holes) == 1)) {
        stop("'allow_holes' must be a single logical value", call. = FALSE)
    }
    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(geom)) {
        wkb <- .g_concave_hull(geom, ratio, allow_holes, as_iso, byte_order,
                               quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        wkb <- lapply(geom, .g_concave_hull, ratio, allow_holes, as_iso,
                      byte_order, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            wkb <- .g_concave_hull(g_wk2wk(geom), ratio, allow_holes, as_iso,
                                   byte_order, quiet)
        } else {
            wkb <- lapply(g_wk2wk(geom), .g_concave_hull, ratio, allow_holes,
                          as_iso, byte_order, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_unary_op
#' @export
g_delaunay_triangulation <- function(geom, constrained = FALSE, tolerance = 0.0,
                                     only_edges = FALSE, as_wkb = TRUE,
                                     as_iso = FALSE, byte_order = "LSB",
                                     quiet = FALSE) {
    # constrained
    if (is.null(constrained))
        constrained <- FALSE
    if (!(is.logical(constrained) && length(constrained) == 1)) {
        stop("'constrained' must be a single logical value", call. = FALSE)
    }
    # tolerance
    if (is.null(tolerance))
        tolerance <- 0.0
    if (!(is.numeric(tolerance) && length(tolerance) == 1))
        stop("'tolerance' must be a single numeric value", call. = FALSE)
    # only_edges
    if (is.null(only_edges))
        only_edges <- FALSE
    if (!(is.logical(only_edges) && length(only_edges) == 1)) {
        stop("'only_edges' must be a single logical value", call. = FALSE)
    }
    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(geom)) {
        wkb <- .g_delaunay_triangulation(geom, constrained, tolerance,
                                         only_edges, as_iso, byte_order, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        wkb <- lapply(geom, .g_delaunay_triangulation, constrained, tolerance,
                      only_edges, as_iso, byte_order, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            wkb <- .g_delaunay_triangulation(g_wk2wk(geom), constrained,
                                             tolerance, only_edges, as_iso,
                                             byte_order, quiet)
        } else {
            wkb <- lapply(g_wk2wk(geom), .g_delaunay_triangulation, constrained,
                          tolerance, only_edges, as_iso, byte_order, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_unary_op
#' @export
g_segmentize <- function(geom, max_length, as_wkb = TRUE, as_iso = FALSE,
                         byte_order = "LSB", quiet = FALSE) {

    # max_length
    if (!(is.numeric(max_length) && length(max_length) == 1))
        stop("'max_length' must be a single numeric value", call. = FALSE)
    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(geom)) {
        wkb <- .g_segmentize(geom, max_length, as_iso, byte_order, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        wkb <- lapply(geom, .g_segmentize, max_length, as_iso, byte_order,
                      quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            wkb <- .g_segmentize(g_wk2wk(geom), max_length, as_iso, byte_order,
                                 quiet)
        } else {
            wkb <- lapply(g_wk2wk(geom), .g_segmentize, max_length, as_iso,
                          byte_order, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_unary_op
#' @export
g_simplify <- function(geom, tolerance, preserve_topology = TRUE,
                       as_wkb = TRUE, as_iso = FALSE, byte_order = "LSB",
                       quiet = FALSE) {
    # tolerance
    if (!(is.numeric(tolerance) && length(tolerance) == 1))
        stop("'tolerance' must be a single numeric value", call. = FALSE)
    # preserve_topology
    if (is.null(preserve_topology))
        preserve_topology <- TRUE
    if (!(is.logical(preserve_topology) &&
          length(preserve_topology) == 1)) {

        stop("'preserve_topology' must be a single logical value",
             call. = FALSE)
    }
    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(geom)) {
        wkb <- .g_simplify(geom, tolerance, preserve_topology, as_iso,
                           byte_order, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        wkb <- lapply(geom, .g_simplify, tolerance, preserve_topology, as_iso,
                      byte_order, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            wkb <- .g_simplify(g_wk2wk(geom), tolerance, preserve_topology,
                               as_iso, byte_order, quiet)
        } else {
            wkb <- lapply(g_wk2wk(geom), .g_simplify, tolerance,
                          preserve_topology, as_iso, byte_order, quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' @name g_unary_op
#' @export
g_unary_union <- function(geom, as_wkb = TRUE, as_iso = FALSE,
                          byte_order = "LSB", quiet = FALSE) {

    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    if (.is_raw_or_null(geom)) {
        wkb <- .g_unary_union(geom, as_iso, byte_order, quiet)
    } else if (is.list(geom) && .is_raw_or_null(geom[[1]])) {
        wkb <- lapply(geom, .g_unary_union, as_iso, byte_order, quiet)
    } else if (is.character(geom)) {
        if (length(geom) == 1) {
            wkb <- .g_unary_union(g_wk2wk(geom), as_iso, byte_order, quiet)
        } else {
            wkb <- lapply(g_wk2wk(geom), .g_unary_union, as_iso, byte_order,
                          quiet)
        }
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' Apply a coordinate transformation to a WKB/WKT geometry
#'
#' `g_transform()` will transform the coordinates of a geometry from their
#' current spatial reference system to a new target spatial reference system.
#' Normally this means reprojecting the vectors, but it could include datum
#' shifts, and changes of units.
#'
#' @param geom Either a raw vector of WKB or list of raw vectors, or a
#' character vector containing one or more WKT strings.
#' @param srs_from Character string specifying the spatial reference system
#' for `geom`. May be in WKT format or any of the formats supported by
#' [srs_to_wkt()].
#' @param srs_to Character string specifying the output spatial reference
#' system. May be in WKT format or any of the formats supported by
#' [srs_to_wkt()].
#' @param wrap_date_line Logical value, `TRUE` to correct geometries that
#' incorrectly go from a longitude on a side of the antimeridian to the other
#' side. Defaults to `FALSE`.
#' @param date_line_offset Integer longitude gap in degree. Defaults to `10L`.
#' @param traditional_gis_order Logical value, `TRUE` to use traditional GIS
#' order of axis mapping (the default) or `FALSE` to use authority compliant
#' axis order. By default, input `geom` vertices are assumed to
#' be in longitude/latitude order if `srs_from` is a geographic coordinate
#' system. This can be overridden by setting `traditional_gis_order = FALSE`.
#' @param as_wkb Logical value, `TRUE` to return the output geometry in WKB
#' format (the default), or `FALSE` to return as WKT.
#' @param as_iso Logical value, `TRUE` to export as ISO WKB/WKT (ISO 13249
#' SQL/MM Part 3), or `FALSE` (the default) to export as "Extended WKB/WKT".
#' @param byte_order Character string specifying the byte order when output is
#' WKB. One of `"LSB"` (the default) or `"MSB"` (uncommon).
#' @param quiet Logical value, `TRUE` to suppress warnings. Defaults to `FALSE`.
#' @return
#' A geometry as WKB raw vector or WKT string, or a list/character vector of
#' geometries as WKB/WKT with length equal to the number of input geometries.
#'  `NULL` (`as_wkb = TRUE`) / `NA` (`as_wkb = FALSE`) is returned with a
#' warning if WKB input cannot be converted into an OGR geometry object, or if
#' an error occurs in the call to the underlying OGR API.
#'
#' @note
#' This function uses the `OGR_GeomTransformer_Create()` and
#' `OGR_GeomTransformer_Transform()` functions in the GDAL API: "This is an
#' enhanced version of `OGR_G_Transform()`. When reprojecting geometries from
#' a Polar Stereographic projection or a projection naturally crossing the
#' antimeridian (like UTM Zone 60) to a geographic CRS, it will cut geometries
#' along the antimeridian. So a `LineString` might be returned as a
#' `MultiLineString`."
#'
#' The `wrap_date_line = TRUE` option might be specified for circumstances to
#' correct geometries that incorrectly go from a longitude on a side of the
#' antimeridian to the other side, e.g., `LINESTRING (-179 0,179 0)` will be
#' transformed to `MULTILINESTRING ((-179 0,-180 0),(180 0,179 0))`. For that
#' use case, `srs_to` might be the same as `srs_from`.
#'
#' @seealso
#' [bbox_transform()], [transform_bounds()]
#'
#' @examples
#' pt <- "POINT (-114.0 47.0)"
#' g_transform(pt, "WGS84", "EPSG:5070", as_wkb = FALSE)
#'
#' # correct geometries that incorrectly go from a longitude on a side of the
#' # antimeridian to the other side
#' geom <- "LINESTRING (-179 0,179 0)"
#' g_transform(geom, "WGS84", "WGS84", wrap_date_line = TRUE, as_wkb = FALSE)
#' @export
g_transform <- function(geom, srs_from, srs_to, wrap_date_line = FALSE,
                        date_line_offset = 10L, traditional_gis_order = TRUE,
                        as_wkb = TRUE, as_iso = FALSE, byte_order = "LSB",
                        quiet = FALSE) {
    # srs_from
    if (!(is.character(srs_from) && length(srs_from) == 1))
        stop("'srs_from' must be a character string", call. = FALSE)
    # srs_to
    if (!(is.character(srs_to) && length(srs_to) == 1))
        stop("'srs_to' must be a character string", call. = FALSE)
    # wrap_date_line
    if (is.null(wrap_date_line))
        wrap_date_line <- FALSE
    if (!(is.logical(wrap_date_line) &&
          length(wrap_date_line) == 1)) {

        stop("'wrap_date_line' must be a single logical value",
             call. = FALSE)
    }
    # date_line_offset
    if (is.null(date_line_offset))
        date_line_offset <- 10L
    if (!(is.numeric(date_line_offset) && length(date_line_offset) == 1))
        stop("'date_line_offset' must be an integer value", call. = FALSE)
    # traditional_gis_order
    if (is.null(traditional_gis_order))
        traditional_gis_order <- TRUE
    if (!(is.logical(traditional_gis_order) &&
          length(traditional_gis_order) == 1)) {

        stop("'traditional_gis_order' must be a single logical value",
             call. = FALSE)
    }
    # as_wkb
    if (is.null(as_wkb))
        as_wkb <- TRUE
    if (!is.logical(as_wkb) || length(as_wkb) > 1)
        stop("'as_wkb' must be a single logical value", call. = FALSE)
    # as_iso
    if (is.null(as_iso))
        as_iso <- FALSE
    if (!is.logical(as_iso) || length(as_iso) > 1)
        stop("'as_iso' must be a single logical value", call. = FALSE)
    # byte_order
    if (is.null(byte_order))
        byte_order <- "LSB"
    if (!is.character(byte_order) || length(byte_order) > 1)
        stop("'byte_order' must be a character string", call. = FALSE)
    byte_order <- toupper(byte_order)
    if (byte_order != "LSB" && byte_order != "MSB")
        stop("invalid 'byte_order'", call. = FALSE)
    # quiet
    if (is.null(quiet))
        quiet <- FALSE
    if (!is.logical(quiet) || length(quiet) > 1)
        stop("'quiet' must be a single logical value", call. = FALSE)

    wkb <- NULL
    # .g_transform() handles input as either one raw vector or list
    if (.is_raw_or_null(geom) ||
        (is.list(geom) && .is_raw_or_null(geom[[1]]))) {

        wkb <- .g_transform(geom, srs_from, srs_to, wrap_date_line,
                            date_line_offset, traditional_gis_order, as_iso,
                            byte_order, quiet)
    } else if (is.character(geom)) {
        wkb <- .g_transform(g_wk2wk(geom), srs_from, srs_to, wrap_date_line,
                            date_line_offset, traditional_gis_order, as_iso,
                            byte_order, quiet)
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    if (as_wkb)
        return(wkb)
    else
        return(g_wk2wk(wkb, as_iso))
}

#' Extract coordinate values from geometries
#'
#' `g_coords()` extracts coordinate values (vertices) from the input geometries
#' and returns a data frame with coordinates as columns.
#'
#' @param geom Either a raw vector of WKB or list of raw vectors, or a
#' character vector containing one or more WKT strings.
#' @return A data frame as returned by `wk::wk_coords()`: columns `feature_id`
#' (the index of the feature from the input), `part_id` (an arbitrary integer
#' identifying the point, line, or polygon from whence it came), `ring_id` (an
#' arbitrary integer identifying individual rings within polygons), and one
#' column per coordinate (`x`, `y`, and/or `z` and/or `m`).
#' @examples
#' dsn <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
#' lyr <- new(GDALVector, dsn)
#' d <- lyr$fetch(10)
#'
#' vertices <- g_coords(d$geom)
#' head(vertices)
#'
#' lyr$close()
#' @export
g_coords <- function(geom) {
    geom_in <- NULL
    if (is.raw(geom)) {
        geom_in <- wk::wkb(list(geom))
    } else if (is.list(geom) && is.raw(geom[[1]])) {
        geom_in <- wk::wkb(geom)
    } else if (is.character(geom)) {
        geom_in <- wk::wkt(geom)
    } else {
        stop("'geom' must be a character vector, raw vector, or list",
             call. = FALSE)
    }

    return(wk::wk_coords(geom_in))
}

test_that("rasterize_polygon identifies correct pixels", {
    # polygon with irregular lobes and one interior ring (hole)
    poly <- "POLYGON ((2 4, 2 15, 8 17, 11 9, 5 14, 6 7, 19 5, 16 17, 21 18, 22 1, 2 4), (19 10, 20 10, 20 14, 18 14, 19 10))"

    nodes <- vector("list", 20)
    burn_values <- c()
    attr_values <- c()
    accumulator <- function(yoff, xoff1, xoff2, burn_val, attr_val) {
        nodes[[yoff]] <<- c(nodes[[yoff]], xoff1, xoff2)
        burn_values <<- c(burn_values, rep(burn_val, xoff2 - xoff1 + 1))
        attr_values <<- c(attr_values, attr_val)
    }

    coords <- g_coords(poly)

    ret <- .rasterize_polygon(
        24, 20, tabulate(coords$ring_id), coords$x, coords$y, accumulator, 1)

    expect_equal(ret, 0)

    # row 0 has no intersections
    expect_equal(nodes[[1]], c(19, 21))
    expect_equal(nodes[[2]], c(12, 21))
    expect_equal(nodes[[3]], c(5, 21))
    expect_equal(nodes[[4]], c(2, 21))
    expect_equal(nodes[[5]], c(2, 15, 19, 21))
    expect_equal(nodes[[6]], c(2, 8, 19, 21))
    expect_equal(nodes[[7]], c(2, 5, 18, 21))
    expect_equal(nodes[[8]], c(2, 5, 18, 21))
    expect_equal(nodes[[9]], c(2, 5, 10, 10, 18, 21))
    expect_equal(nodes[[10]], c(2, 5, 9, 9, 18, 18, 20, 20))
    expect_equal(nodes[[11]], c(2, 4, 8, 9, 17, 18, 20, 20))
    expect_equal(nodes[[12]], c(2, 4, 7, 9, 17, 17, 20, 20))
    expect_equal(nodes[[13]], c(2, 4, 6, 8, 17, 17, 20, 20))
    expect_equal(nodes[[14]], c(2, 8, 17, 20))
    expect_equal(nodes[[15]], c(4, 8, 16, 20))
    expect_equal(nodes[[16]], c(7, 7, 16, 20))
    expect_equal(nodes[[17]], c(19, 20))
    expect_true(is.null(nodes[[18]]))
    expect_true(is.null(nodes[[19]]))
    expect_true(all(burn_values == 1))
    expect_equal(length(burn_values), 162)  # g_area(poly) = 162.5
    expect_true(all(is.na(attr_values)))
})

test_that("geos_version returns a list of length 4", {
    expect_length(geos_version(), 4)
})

test_that("geom functions work on wkb/wkt geometries", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    ds <- new(GDALRaster, elev_file, read_only=TRUE)
    bb <- bbox_to_wkt(ds$bbox())
    ds$close()
    expect_true(g_is_valid(bb))

    invalid_bnd <- "POLYGON ((324467.3 5104814.2, 323909.4 5104365.4, 323794.2
    5103455.8, 324970.7 5102885.8, 326420.0 5103595.3, 326389.6 5104747.5,
    325298.1 5104929.4))"
    expect_false(g_is_valid(invalid_bnd))

    bnd <- "POLYGON ((324467.3 5104814.2, 323909.4 5104365.4, 323794.2
    5103455.8, 324970.7 5102885.8, 326420.0 5103595.3, 326389.6 5104747.5,
    325298.1 5104929.4, 325298.1 5104929.4, 324467.3 5104814.2))"
    expect_true(g_is_valid(bnd))

    x <- c(324467.3, 323909.4, 323794.2)
    y <- c(5104814.2, 5104365.4, 5103455.8)
    pt_xy <- cbind(x, y)
    expect_error(g_create("POLYGON", pt_xy))

    if (gdal_version_num() >= 3050000) {
        # OGR_GEOMETRY_ACCEPT_UNCLOSED_RING config option added at 3.5.0
        x <- c(324467.3, 323909.4, 323794.2, 324970.7)
        y <- c(5104814.2, 5104365.4, 5103455.8, 5102885.8)
        pt_xy <- cbind(x, y)
        expect_error(g_create("POLYGON", pt_xy))
    }

    x <- c(324467.3, 323909.4, 323794.2, 324970.7, 326420.0, 326389.6,
           325298.1, 325298.1, 324467.3)
    y <- c(5104814.2, 5104365.4, 5103455.8, 5102885.8, 5103595.3, 5104747.5,
           5104929.4, 5104929.4, 5104814.2)
    pt_xy <- cbind(x, y)

    expect_true(g_create("POLYGON", pt_xy) |> g_is_valid())
    expect_true((g_create("POLYGON", pt_xy) |> g_area()) > 0)

    pt_xy <- c(324171, 5103034.3)
    expect_error(g_create("POLYGON", pt_xy))
    pt <- g_create("POINT", pt_xy, as_wkb = FALSE)

    line_xy <- matrix(c(324171, 327711.7, 5103034.3, 5104475.9),
                      nrow=2, ncol=2)
    # expect_error(g_create("POINT", line_xy))
    # now returns multiple POINT geoms:
    expect_equal(length(g_create("POINT", line_xy)), 2)
    expect_equal(g_create("POINT", line_xy) |> g_name(), c("POINT", "POINT"))
    line <- g_create("LINESTRING", line_xy, as_wkb = FALSE)

    # set up vector of WKT, WKB raw vector, and list of WKB raw vectors
    wkt_vec_1 <- c(bb, bnd, NA_character_)
    wkt_vec_2 <- c(pt, pt, pt)

    bb_wkb <- g_wk2wk(bb)
    expect_true(is.raw(bb_wkb))
    pt_wkb <- g_wk2wk(pt)
    expect_true(is.raw(pt_wkb))

    expect_warning(wkb_list_1 <- g_wk2wk(wkt_vec_1))
    expect_true(is.list(wkb_list_1) && is.raw(wkb_list_1[[1]]) &&
                is.null(wkb_list_1[[3]]))
    wkb_list_2 <- g_wk2wk(wkt_vec_2)
    expect_true(is.list(wkb_list_2) && is.raw(wkb_list_2[[1]]))

    # binary predicates
    # WKT
    expect_true(g_intersects(bb, pt))
    expect_false(g_intersects(bnd, pt))
    expect_error(g_intersects("invalid WKT", pt))
    expect_error(g_intersects(bnd, "invalid WKT"))
    expect_error(g_intersects(0, pt))
    expect_error(g_intersects(bb, 0))
    # vector of WKT
    expected_value <- c(TRUE, FALSE, NA)
    expect_warning(
        expect_equal(g_intersects(wkt_vec_1, wkt_vec_2, TRUE), expected_value)
    )
    # WKB
    expect_true(g_intersects(bb_wkb, pt_wkb))
    # list of WKB
    expect_true(g_intersects(list(bb_wkb), list(pt_wkb)))
    expect_equal(g_intersects(wkb_list_1, wkb_list_2, TRUE), expected_value)
    # unequal length
    expect_error(g_intersects(wkb_list_1, wkb_list_2[1:2]))
    # one-to-many
    expect_equal(g_intersects(pt, wkb_list_1,TRUE), expected_value)

    # WKT
    expect_false(g_equals(bb, bnd))
    expect_error(g_equals("invalid WKT", bnd))
    expect_error(g_equals(bb, "invalid WKT"))
    expect_error(g_equals(0, bnd))
    expect_error(g_equals(bb, 0))
    # vector of WKT
    expected_value <- c(FALSE, FALSE, NA)
    expect_warning(
        expect_equal(g_equals(wkt_vec_1, wkt_vec_2), expected_value)
    )
    # WKB
    expect_false(g_equals(bb_wkb, pt_wkb))
    # list of WKB
    expect_false(g_equals(list(bb_wkb), list(pt_wkb)))
    expect_equal(g_equals(wkb_list_1, wkb_list_2), expected_value)
    # unequal length
    expect_error(g_equals(wkb_list_1, wkb_list_2[1:2]))
    # one-to-many
    expect_equal(g_equals(pt, wkb_list_1), expected_value)

    # WKT
    expect_false(g_disjoint(bb, bnd))
    expect_error(g_disjoint("invalid WKT", bnd))
    expect_error(g_disjoint(bb, "invalid WKT"))
    expect_error(g_disjoint(0, bnd))
    expect_error(g_disjoint(bb, 0))
    # vector of WKT
    expected_value <- c(FALSE, TRUE, NA)
    expect_warning(
        expect_equal(g_disjoint(wkt_vec_1, wkt_vec_2), expected_value)
    )
    # WKB
    expect_false(g_disjoint(bb_wkb, pt_wkb))
    # list of WKB
    expect_false(g_disjoint(list(bb_wkb), list(pt_wkb)))
    expect_equal(g_disjoint(wkb_list_1, wkb_list_2), expected_value)
    # unequal length
    expect_error(g_disjoint(wkb_list_1, wkb_list_2[1:2]))
    # one-to-many
    expect_equal(g_disjoint(pt, wkb_list_1), expected_value)

    # WKT
    expect_false(g_touches(bb, bnd))
    expect_error(g_touches("invalid WKT", bnd))
    expect_error(g_touches(bb, "invalid WKT"))
    expect_error(g_touches(0, bnd))
    expect_error(g_touches(bb, 0))
    # vector of WKT
    expected_value <- c(FALSE, FALSE, NA)
    expect_warning(
        expect_equal(g_touches(wkt_vec_1, wkt_vec_2), expected_value)
    )
    # WKB
    expect_false(g_touches(bb_wkb, pt_wkb))
    # list of WKB
    expect_false(g_touches(list(bb_wkb), list(pt_wkb)))
    expect_equal(g_touches(wkb_list_1, wkb_list_2), expected_value)
    # unequal length
    expect_error(g_touches(wkb_list_1, wkb_list_2[1:2]))
    # one-to-many
    expect_equal(g_touches(pt, wkb_list_1), expected_value)

    # WKT
    expect_true(g_contains(bb, bnd))
    expect_error(g_contains("invalid WKT", bnd))
    expect_error(g_contains(bb, "invalid WKT"))
    expect_error(g_contains(0, bnd))
    expect_error(g_contains(bb, 0))
    # vector of WKT
    expected_value <- c(TRUE, FALSE, NA)
    expect_warning(
        expect_equal(g_contains(wkt_vec_1, wkt_vec_2), expected_value)
    )
    # WKB
    expect_true(g_contains(bb_wkb, pt_wkb))
    # list of WKB
    expect_true(g_contains(list(bb_wkb), list(pt_wkb)))
    expect_equal(g_contains(wkb_list_1, wkb_list_2), expected_value)
    # unequal length
    expect_error(g_contains(wkb_list_1, wkb_list_2[1:2]))
    # one-to-many
    expect_equal(g_contains(bnd, wkb_list_2), c(FALSE, FALSE, FALSE))

    # WKT
    expect_false(g_within(bb, bnd))
    expect_error(g_within("invalid WKT", bnd))
    expect_error(g_within(bb, "invalid WKT"))
    expect_error(g_within(0, bnd))
    expect_error(g_within(bb, 0))
    # vector of WKT
    expected_value <- c(TRUE, FALSE, NA)
    expect_warning(
        expect_equal(g_within(wkt_vec_2, wkt_vec_1), expected_value)
    )
    # WKB
    expect_false(g_within(bb_wkb, pt_wkb))
    # list of WKB
    expect_false(g_within(list(bb_wkb), list(pt_wkb)))
    expect_equal(g_within(wkb_list_2, wkb_list_1), expected_value)
    # unequal length
    expect_error(g_within(wkb_list_1, wkb_list_2[1:2]))
    # one-to-many
    expect_equal(g_within(pt, wkb_list_1), expected_value)

    # WKT
    expect_true(g_crosses(line, bnd))
    expect_error(g_crosses("invalid WKT", bnd))
    expect_error(g_crosses(line, "invalid WKT"))
    expect_false(g_crosses(line, bb))
    expect_error(g_crosses(0, bnd))
    expect_error(g_crosses(line, 0))
    # vector of WKT
    expected_value <- c(FALSE, FALSE, NA)
    expect_warning(
        expect_equal(g_crosses(wkt_vec_1, wkt_vec_2), expected_value)
    )
    # WKB
    expect_false(g_crosses(bb_wkb, pt_wkb))
    # list of WKB
    expect_false(g_crosses(list(bb_wkb), list(pt_wkb)))
    expect_equal(g_crosses(wkb_list_1, wkb_list_2), expected_value)
    # unequal length
    expect_error(g_crosses(wkb_list_1, wkb_list_2[1:2]))
    # one-to-many
    expect_equal(g_crosses(pt, wkb_list_1), expected_value)

    # WKT
    expect_false(g_overlaps(bb, bnd))
    expect_error(g_overlaps("invalid WKT", bnd))
    expect_error(g_overlaps(bb, "invalid WKT"))
    expect_error(g_overlaps(0, bnd))
    expect_error(g_overlaps(bb, 0))
    # vector of WKT
    expected_value <- c(FALSE, FALSE, NA)
    expect_warning(
        expect_equal(g_overlaps(wkt_vec_1, wkt_vec_2), expected_value)
    )
    # WKB
    expect_false(g_overlaps(bb_wkb, pt_wkb))
    # list of WKB
    expect_false(g_overlaps(list(bb_wkb), list(pt_wkb)))
    expect_equal(g_overlaps(wkb_list_1, wkb_list_2), expected_value)
    # unequal length
    expect_error(g_overlaps(wkb_list_1, wkb_list_2[1:2]))
    # one-to-many
    expect_equal(g_overlaps(pt, wkb_list_1), expected_value)

    # buffer
    expect_equal(round(bbox_from_wkt(g_buffer(bnd, 100, as_wkb = FALSE))),
                 round(c(323694.2, 5102785.8, 326520.0, 5105029.4)))
    expect_error(g_buffer("invalid WKT", 100))
    # vector of WKT
    expect_warning(res <- g_buffer(wkt_vec_1, 100))
    expect_true(is.list(res) && length(res) == 3 && is.raw(res[[1]]))
    # WKB
    expect_true(is.raw(g_buffer(pt_wkb, 10)))
    # list of WKB
    res <- g_buffer(wkb_list_1, 100)
    expect_true(is.list(res) && length(res) == 3 && is.raw(res[[1]]))

    # area
    expect_equal(round(g_area(bnd)), 4039645)
    expect_equal(g_area(g_intersection(bb, bnd, as_wkb = FALSE)), g_area(bnd))
    expect_equal(g_area(g_union(bb, bnd, as_wkb = FALSE)), g_area(bb))
    expect_equal(round(g_area(g_difference(bb, bnd, as_wkb = FALSE))),
                 9731255)
    expect_equal(round(g_area(g_sym_difference(bb, bnd, as_wkb = FALSE))),
                 9731255)
    expect_error(g_area("invalid WKT"))
    expect_error(g_area(NA))
    expect_true(is.na(g_area(raw(0))))
    # vector of WKT
    expect_warning(res <- g_area(wkt_vec_1))
    expect_vector(res, numeric(), size = 3)
    expect_equal(round(res[2]), 4039645)
    # WKB
    expect_equal(g_area(pt_wkb), 0)
    # list of WKB
    res <- g_area(wkb_list_1)
    expect_vector(res, numeric(), size = 3)
    expect_equal(round(res[2]), 4039645)

    # distance
    expect_equal(g_distance(pt, bnd), 215.0365, tolerance = 1e-4)
    expect_error(g_distance("invalid WKT", bnd))
    expect_error(g_distance(pt, "invalid WKT"))
    expect_error(g_distance(NA, bnd))
    expect_error(g_distance(pt, NA))
    expect_true(is.na(g_distance(raw(0), bnd)))
    expect_true(is.na(g_distance(pt, raw(0))))
    # vector of WKT
    expect_warning(res <- g_distance(wkt_vec_1, wkt_vec_2))
    expect_equal(res[2], 215.0365, tolerance = 1e-4)
    # WKB
    expect_equal(g_distance(pt_wkb, bb_wkb), 0)
    # list of WKB
    res <- g_distance(wkb_list_1, wkb_list_2)
    expect_equal(res[2], 215.0365, tolerance = 1e-4)
    # unequal length
    expect_error(g_distance(wkb_list_1, wkb_list_2[1:2]))
    # one-to-many
    expect_equal(g_distance(pt_wkb, wkb_list_1), c(0, 215.0365, NA_real_),
                 tolerance = 1e-4)
    expect_equal(g_distance(list(pt_wkb), wkb_list_1), c(0, 215.0365, NA_real_),
                 tolerance = 1e-4)

    # length
    expect_equal(g_length(line), 3822.927, tolerance = 1e-2)
    expect_error(g_length("invalid WKT"))
    expect_error(g_length(NA))
    expect_true(is.na(g_length(raw(0))))
    # vector of WKT with missing value
    expect_warning(
        res <- g_length(c(wkt_vec_2, NA_character_))
    )
    expect_equal(res[1], 0)
    expect_true(is.na(res[4]))
    # WKB
    expect_equal(g_length(pt_wkb), 0)
    # list of WKB
    res <- g_length(wkb_list_2)
    expect_equal(res[1], 0)

    # centroid
    res <- g_centroid(bnd)
    expect_equal(names(res), c("x", "y"))
    names(res) <- NULL
    expect_equal(res, c(325134.9, 5103985.4), tolerance = 0.1)
    expect_error(g_centroid("invalid WKT"))
    expect_error(g_centroid(NA))
    res <- g_centroid(raw(0))
    names(res) <- NULL
    expect_equal(res, c(NA_real_, NA_real_))
    # vector of WKT
    expect_warning(res <- g_centroid(wkt_vec_1))
    expect_true(is.matrix(res) && ncol(res) == 2 && nrow(res) == 3)
    expect_equal(colnames(res), c("x", "y"))
    colnames(res) <- NULL
    expect_equal(res[2, ], c(325134.9, 5103985.4), tolerance = 0.1)
    # WKB
    expect_equal(g_centroid(bb_wkb), g_centroid(bb))
    # list of WKB
    res <- g_centroid(wkb_list_1)
    expect_true(is.matrix(res) && ncol(res) == 2 && nrow(res) == 3)
    expect_equal(colnames(res), c("x", "y"))
    colnames(res) <- NULL
    expect_equal(res[2, ], c(325134.9, 5103985.4), tolerance = 0.1)

    # binary ops with invalid WKT
    expect_error(g_intersection("invalid WKT", bnd, as_wkb = FALSE))
    expect_error(g_intersection(bb, "invalid WKT", as_wkb = FALSE))
    expect_error(g_union("invalid WKT", bnd, as_wkb = FALSE))
    expect_error(g_union(bb, "invalid WKT", as_wkb = FALSE))
    expect_error(g_difference("invalid WKT", bnd, as_wkb = FALSE))
    expect_error(g_difference(bb, "invalid WKT", as_wkb = FALSE))
    expect_error(g_sym_difference("invalid WKT", bnd, as_wkb = FALSE))
    expect_error(g_sym_difference(bb, "invalid WKT", as_wkb = FALSE))

    # binary ops with empty raw vector input
    expect_true(is.null(g_intersection(raw(0), bnd)))
    expect_true(is.null(g_intersection(bb, raw(0))))
    expect_true(is.null(g_union(raw(0), bnd)))
    expect_true(is.null(g_union(bb, raw(0))))
    expect_true(is.null(g_difference(raw(0), bnd)))
    expect_true(is.null(g_difference(bb, raw(0))))
    expect_true(is.null(g_sym_difference(raw(0), bnd)))
    expect_true(is.null(g_sym_difference(bb, raw(0))))
})

test_that("g_factory functions work", {
    ## create
    # polygon
    pts1 <- c(0, 0, 10, 10, 10, 0, 0, 0)
    pts1 <-matrix(pts1, ncol = 2, byrow = TRUE)
    # poly1 <- "POLYGON((0 0, 10 10, 10 0, 0 0))"
    poly1 <- g_create("POLYGON", pts1)
    pts2 <- c(0, 0, 0, 10, 10, 0, 0, 0)
    pts2 <-matrix(pts2, ncol = 2, byrow = TRUE)
    # poly2 <- "POLYGON((0 0, 0 10, 10 0, 0 0))"
    poly2 <- g_create("POLYGON", pts2)
    res = g_intersection(poly1, poly2)
    expected <- "POLYGON ((0 0,5 5,10 0,0 0))"
    empty_expected <- g_difference(res, expected)
    expect_true(g_is_empty(empty_expected))

    # linestring
    pts <- c(9, 1, 12, 4)
    pts <-matrix(pts, ncol = 2, byrow = TRUE)
    line1 <- g_create("LINESTRING", pts)
    expect_true(g_intersects(line1, poly1))
    # xyz
    pts <- c(9, 1, 0, 12, 4, 10)
    pts <-matrix(pts, ncol = 3, byrow = TRUE)
    line2 <- g_create("LINESTRING", pts)
    coords <- g_coords(line2)
    expect_equal(coords$x, pts[, 1])
    expect_equal(coords$y, pts[, 2])
    expect_equal(coords$z, pts[, 3])
    # xyzm
    pts <- c(9, 1, 0, 2000, 12, 4, 10, 2000)
    pts <-matrix(pts, ncol = 4, byrow = TRUE)
    line3 <- g_create("LINESTRING", pts)
    coords <- g_coords(line3)
    expect_equal(coords$x, pts[, 1])
    expect_equal(coords$y, pts[, 2])
    expect_equal(coords$z, pts[, 3])
    expect_equal(coords$m, pts[, 4])

    # point
    pt1 <- g_create("POINT", c(9, 1))
    expect_true(g_within(pt1, poly1))
    pt2 <- g_create("POINT", c(1, 9))
    expect_false(g_within(pt2, poly1))
    # xyz
    pt3 <- g_create("POINT", c(1, 9, 0))
    coords <- g_coords(pt3)
    expect_equal(coords$x, 1)
    expect_equal(coords$y, 9)
    expect_equal(coords$z, 0)
    # xyzm
    pt4 <- g_create("POINT", c(1, 9, 0, 2000))
    coords <- g_coords(pt4)
    expect_equal(coords$x, 1)
    expect_equal(coords$y, 9)
    expect_equal(coords$z, 0)
    expect_equal(coords$m, 2000)

    # multipoint
    pts <- c(9, 1, 1, 9)
    pts <-matrix(pts, ncol = 2, byrow = TRUE)
    mult_pt1 <- g_create("MULTIPOINT", pts)
    expect_false(g_within(mult_pt1, poly1))
    # multipoint xyz
    x <- c(9, 1)
    y <- c(1, 9)
    z <- c(0, 10)
    pts <- cbind(x, y, z)
    mult_pt_xyz <- g_create("MULTIPOINT", pts)
    expect_equal(g_name(mult_pt_xyz), "MULTIPOINT")
    coords <- g_coords(mult_pt_xyz)
    expect_equal(coords$x, x)
    expect_equal(coords$y, y)
    expect_equal(coords$z, z)
    # multipoint xyzm
    m <- c(2000, 2000)
    pts <- cbind(x, y, z, m)
    mult_pt_xyzm <- g_create("MULTIPOINT", pts)
    expect_equal(g_name(mult_pt_xyzm), "MULTIPOINT")
    coords <- g_coords(mult_pt_xyzm)
    expect_equal(coords$x, x)
    expect_equal(coords$y, y)
    expect_equal(coords$z, z)
    expect_equal(coords$m, m)

    # geometry collection
    g_coll <- g_create("GEOMETRYCOLLECTION")
    expect_equal(g_wk2wk(g_coll), "GEOMETRYCOLLECTION EMPTY")

    # errors/input validation
    expect_error(g_create(c("POLYGON", "POLYGON"), pts1))
    expect_error(g_create(1, pts1))
    expect_error(g_create("POLYGON", "invalid_xy_data"))
    expect_no_error(g_create("POLYGON", pts1, as_wkb = NULL))
    expect_error(g_create("POLYGON", pts1, as_wkb = "WKB"))
    expect_no_error(g_create("POLYGON", pts1, as_iso = NULL))
    expect_error(g_create("POLYGON", pts1, as_iso = "ISO"))
    expect_no_error(g_create("POLYGON", pts1, byte_order = NULL))
    expect_error(g_create("POLYGON", pts1, byte_order = TRUE))

    ## add subgeometry to container
    # create empty multipoint and add geoms
    mult_pt2 <- g_create("MULTIPOINT")
    expect_no_error(mult_pt2 <- g_add_geom(g_create("POINT", c(9, 1)),
                                           mult_pt2))
    expect_no_error(mult_pt2 <- g_add_geom(g_create("POINT", c(1, 9)),
                                           mult_pt2))
    expect_true(g_equals(mult_pt1, mult_pt2))  # mult_pt1 from above

    pt <- g_create("POINT", c(1, 2))
    expect_no_error(g_coll <- g_add_geom(pt, g_coll))  # g_coll from above
    expect_no_error(g_coll <- g_add_geom(mult_pt2, g_coll))
    expect_true(g_is_valid(g_coll))

    # get subgeometry from container
    expect_no_error(g_sub2 <- g_get_geom(g_coll, 2))
    expect_equal(g_geom_count(g_sub2), 2)  # mult_pt2
    expect_true(g_equals(g_get_geom(g_sub2, 1), "POINT(9 1)"))

    # polygon to polygon (add inner ring)
    container <- "POLYGON((0 0,0 10,10 10,0 0),(0.25 0.5,1 1.1,0.5 1,0.25 0.5))"
    # sub_geom <- "POLYGON((5.25 5.5,6 6.1,5.5 6,5.25 5.5))"
    v <- c(5.25, 5.5, 6, 6.1, 5.5, 6, 5.25, 5.5)
    pts <- matrix(v, nrow = 4, ncol = 2, byrow = TRUE)
    sub_geom <- g_create("POLYGON", pts)
    new_wkb <- g_add_geom(sub_geom, container)
    wkt_expect <- "POLYGON((0 0,0 10,10 10,0 0),(0.25 0.5,1.0 1.1,0.5 1.0,0.25 0.5),(5.25 5.5,6.0 6.1,5.5 6.0,5.25 5.5))"
    empty_expected <- g_difference(new_wkb, wkt_expect)
    expect_true(g_is_empty(empty_expected))

    container <- new_wkb
    # get rings of a polygon
    # exterior
    new_wkb <- g_get_geom(container, 1)
    wkt_expect <- "POLYGON((0 0,0 10,10 10,0 0))"
    empty_expected <- g_difference(new_wkb, wkt_expect)
    expect_true(g_is_empty(empty_expected))
    # last interior
    new_wkb <- g_get_geom(container, 3)
    wkt_expect <- "POLYGON((5.25 5.5,6.0 6.1,5.5 6.0,5.25 5.5))"
    empty_expected <- g_difference(new_wkb, wkt_expect)
    expect_true(g_is_empty(empty_expected))

    # multipoint with an empty point inside
    geom <- "MULTIPOINT(0 1)"
    expect_no_error(g_add_geom(g_create("POINT"), geom))

    # multilinestring with an empty linestring inside
    geom <- "MULTILINESTRING((0 1,2 3,4 5,0 1), (0 1,2 3,4 5,0 1))"
    expect_no_error(g_add_geom(g_create("LINESTRING"), geom))
    expect_no_error(g_add_geom(g_create("LINESTRING"), geom, as_wkb = FALSE))

    # errors/input validation
    expect_error(g_add_geom(g_create("LINESTRING"), 1))
    expect_no_error(g_add_geom(g_create("LINESTRING"), geom, as_wkb = NULL))
    expect_error(g_add_geom(g_create("LINESTRING"), geom, as_wkb = "WKB"))
    expect_no_error(g_add_geom(g_create("LINESTRING"), geom, as_iso = NULL))
    expect_error(g_add_geom(g_create("LINESTRING"), geom, as_iso = "ISO"))
    expect_no_error(g_add_geom(g_create("LINESTRING"), geom, byte_order = NULL))
    expect_error(g_add_geom(g_create("LINESTRING"), geom, byte_order = TRUE))

    ## build collection
    lines <- c("LINESTRING (0 0,3 0)",
               "LINESTRING (3 0,3 4)",
               "LINESTRING (3 4,0 0)")

    expect_no_error(coll <- g_build_collection(lines))
    expect_equal(g_name(coll), "GEOMETRYCOLLECTION")
    expect_equal(g_get_geom(coll, 1, as_wkb = FALSE), lines[1])
    expect_equal(g_get_geom(coll, 2, as_wkb = FALSE), lines[2])
    expect_equal(g_get_geom(coll, 3, as_wkb = FALSE), lines[3])

    # as WKT
    expect_true(g_equals(g_build_collection(lines, as_wkb = FALSE),
                         g_wk2wk(coll)))

    # build MultiLineString
    expect_no_error(multi_line <- g_build_collection(lines, "MULTILINESTRING"))
    expect_equal(g_name(multi_line), "MULTILINESTRING")
    expect_equal(g_geom_count(multi_line), 3)

    # input contains an invalid geometry
    lines_wkb <- g_wk2wk(lines)
    lines_wkb[[2]] <- lines_wkb[[2]][1:5]
    expect_warning(
        multi_line2 <- g_build_collection(lines_wkb, "MULTILINESTRING")) |>
            expect_warning()  # two warnings emitted here so catch the second
    expect_equal(g_name(multi_line2), "MULTILINESTRING")
    expect_equal(g_geom_count(multi_line2), 2)

    # input contains an element that is length-0 raw vector
    lines_wkb[[2]] <- raw(0)
    expect_warning(
        multi_line2 <- g_build_collection(lines_wkb, "MULTILINESTRING"))
    expect_equal(g_name(multi_line2), "MULTILINESTRING")
    expect_equal(g_geom_count(multi_line2), 2)

    # input contains an element that is not a raw vector
    lines_wkb[[2]] <- list(NULL)
    expect_warning(
        multi_line2 <- g_build_collection(lines_wkb, "MULTILINESTRING"))
    expect_equal(g_name(multi_line2), "MULTILINESTRING")
    expect_equal(g_geom_count(multi_line2), 2)

    # errors/input validation
    expect_error(g_build_collection(NULL))
    expect_error(g_build_collection(lines, coll_type = "INVALID"))
    expect_error(g_build_collection(lines, coll_type = 1))
    # no error, defaults to "GEOMETRYCOLLECTION":
    expect_no_error(g_build_collection(lines, coll_type = NULL))
    expect_error(g_build_collection(lines, as_wkb = "WKB"))
    # no error, defaults to TRUE:
    expect_no_error(g_build_collection(lines, as_wkb = NULL))
    expect_error(g_build_collection(lines, as_iso = "ISO"))
    # no error, defaults to FALSE:
    expect_no_error(g_build_collection(lines, as_iso = NULL))
    expect_error(g_build_collection(lines, byte_order = TRUE))
    expect_error(g_build_collection(lines, byte_order = "invalid"))
    # no error, defaults to "LSB":
    expect_no_error(g_build_collection(lines, byte_order = NULL))

    ## build polygon from edges
    wkt_vector <- c(
        "LINESTRING (-87.601595 30.999522,-87.599623 31.000059,-87.599219 31.00017)",
        "LINESTRING (-87.601595 30.999522,-87.604349 30.999493,-87.606935 30.99952)",
        "LINESTRING (-87.59966 31.000756,-87.599851 31.000805,-87.599992 31.000805,-87.600215 31.000761,-87.600279 31.000723,-87.600586 31.000624,-87.601256 31.000508,-87.602501 31.000447,-87.602801 31.000469,-87.603108 31.000579,-87.603331 31.000716,-87.603523 31.000909,-87.603766 31.001233,-87.603913 31.00136)",
        "LINESTRING (-87.606134 31.000182,-87.605885 31.000325,-87.605343 31.000716,-87.60466 31.001117,-87.604468 31.0012,-87.603913 31.00136)",
        "LINESTRING (-87.599219 31.00017,-87.599289 31.0003,-87.599398 31.000426,-87.599564 31.000547,-87.599609 31.000701,-87.59966 31.000756)",
        "LINESTRING (-87.606935 30.99952,-87.606713 30.999799,-87.6064 30.999981,-87.606134 31.000182)"
    )

    poly <- g_build_polygon_from_edges(wkt_vector)
    expect_equal(g_name(poly), "POLYGON")
    expect_true(g_is_valid(poly))

    # starting with MultiLineString WKB
    line_coll <- g_build_collection(wkt_vector, "MULTILINESTRING")

    poly <- g_build_polygon_from_edges(line_coll)
    expect_equal(g_name(poly), "POLYGON")
    expect_true(g_is_valid(poly))

    # invalid geometries
    pt <- "POINT (0 1)"
    expect_warning(poly <- g_build_polygon_from_edges(pt))
    expect_true(is.null(poly))

    coll <- "GEOMETRYCOLLECTION (LINESTRING(0 1,2 3),POINT(0 1),LINESTRING(0 1,-2 3),LINESTRING(-2 3,2 3))"
    expect_warning(poly <- g_build_polygon_from_edges(pt))
    expect_true(is.null(poly))

    # errors/input validation
    expect_error(g_build_polygon_from_edges(list(NULL)))
    expect_error(g_build_polygon_from_edges(numeric()))
    expect_error(g_build_polygon_from_edges(line_coll, auto_close = 0))
    # no error, defaults to TRUE:
    expect_no_error(g_build_polygon_from_edges(line_coll, auto_close = NULL))
    expect_error(g_build_polygon_from_edges(line_coll, tolerance = FALSE))
    # no error, defaults to 0.0:
    expect_no_error(g_build_polygon_from_edges(line_coll, tolerance = NULL))
    expect_error(g_build_polygon_from_edges(line_coll, as_wkb = "WKB"))
    # no error, defaults to TRUE:
    expect_no_error(g_build_polygon_from_edges(line_coll, as_wkb = NULL))
    expect_error(g_build_polygon_from_edges(line_coll, as_iso = "ISO"))
    # no error, defaults to FALSE:
    expect_no_error(g_build_polygon_from_edges(line_coll, as_iso = NULL))
    expect_error(g_build_polygon_from_edges(line_coll, byte_order = "invalid"))
    expect_error(g_build_polygon_from_edges(line_coll, byte_order = TRUE))
    # no error, defaults to "LSB":
    expect_no_error(g_build_polygon_from_edges(line_coll, byte_order = NULL))
})

test_that("WKB/WKT conversion functions work", {
    # test round trip on point and multipolygon
    g1 <- "POINT (1 5)"
    g2 <- "MULTIPOLYGON (((5 5,0 0,0 10,5 5)),((5 5,10 10,10 0,5 5)))"

    expect_true(g_equals(g1, g_wk2wk(g1) |> g_wk2wk()))
    expect_true(g_equals(g2, g_wk2wk(g2) |> g_wk2wk()))

    # character vector of WKT strings to list of WKB raw vectors
    wkb_list <- g_wk2wk(c(g1, g2))
    expect_length(wkb_list, 2)
    expect_true(is.raw(wkb_list[[1]]))
    expect_true(is.raw(wkb_list[[2]]))

    # list of WKB raw vectors to character vector of WKT strings
    wkt_vec <- g_wk2wk(wkb_list)
    expect_length(wkt_vec, 2)
    expect_true(is.character(wkt_vec))
    expect_true(g_equals(wkt_vec[1], g1))
    expect_true(g_equals(wkt_vec[2], g2))

    # test with first element a length-0 raw vector
    wkb_list[[1]] <- raw()
    rm(wkt_vec)
    expect_warning(wkt_vec <- g_wk2wk(wkb_list))
    expect_length(wkt_vec, 2)
    expect_true(is.na(wkt_vec[1]))
    expect_true(g_equals(wkt_vec[2], g2))

    # test with first element not a raw vector
    wkb_list[[1]] <- g1
    rm(wkt_vec)
    expect_warning(wkt_vec <- g_wk2wk(wkb_list))
    expect_length(wkt_vec, 2)
    expect_true(is.na(wkt_vec[1]))
    expect_true(g_equals(wkt_vec[2], g2))

    # first element of wkt_vec is NA
    rm(wkb_list)
    expect_warning(wkb_list <- g_wk2wk(wkt_vec))
    expect_length(wkb_list, 2)
    expect_true(is.null(wkb_list[[1]]))
    expect_true(g_equals(wkb_list[[2]] |> g_wk2wk(), g2))

    # POINT EMPTY special case
    wkt <- "POINT EMPTY"
    expect_warning(wkb <- g_wk2wk(wkt))

    expect_true(is.null(g_wk2wk(NA)))
    expect_true(is.na(g_wk2wk(NULL)))
    expect_error(g_wk2wk(1))

    # 0-length raw vector / empty string
    expect_true(is.na(g_wk2wk(raw(0))))
    expect_true(is.null(g_wk2wk("")))

    # empty list / vector
    expect_error(g_wk2wk(list()))
    expect_error(g_wk2wk(character()))
})

test_that("bbox functions work", {
    skip_if_not(has_geos())

    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    ds <- new(GDALRaster, elev_file, read_only=TRUE)
    bb <- ds$bbox()
    ds$close()

    expect_equal(bbox_from_wkt("invalid WKT"), rep(NA_real_, 4))
    bb_wkt <- bbox_to_wkt(bb)
    expect_true(startsWith(bb_wkt, "POLYGON"))
    expect_equal(bbox_from_wkt(bb_wkt), bb)
    expect_error(bbox_to_wkt(c(0, 1)))
})

test_that("bbox intersect/union return correct values", {
    bbox_list <-list()
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    ds <- new(GDALRaster, elev_file, read_only=TRUE)
    bbox_list[[1]] <- ds$bbox()
    ds$close()
    b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
    ds <- new(GDALRaster, b5_file, read_only=TRUE)
    bbox_list[[2]] <- ds$bbox()
    ds$close()

    bnd <- "POLYGON ((324467.3 5104814.2, 323909.4 5104365.4, 323794.2
    5103455.8, 324970.7 5102885.8, 326420.0 5103595.3, 326389.6 5104747.5,
    325298.1 5104929.4, 325298.1 5104929.4, 324467.3 5104814.2))"

    bbox_list[[3]] <- bbox_from_wkt(bnd)
    expect_equal(bbox_intersect(bbox_list),
                 c(323794.2, 5102885.8, 326420.0, 5104929.4))
    expect_equal(bbox_union(bbox_list),
                 c(323400.9, 5101815.8, 327870.9, 5105175.8))
    expect_equal(bbox_intersect(c(elev_file, b5_file)),
                 c(323476.1, 5101872.0, 327766.1, 5105082.0))
    expect_equal(bbox_union(c(elev_file, b5_file)),
                 c(323400.9, 5101815.8, 327870.9, 5105175.8))
    expect_equal(bbox_from_wkt(bbox_union(c(elev_file, b5_file), as_wkt=TRUE)),
                 c(323400.9, 5101815.8, 327870.9, 5105175.8))
})

test_that("g_transform / bbox_transform return correct values", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    ds <- new(GDALRaster, elev_file)
    ds_srs <- ds$getProjectionRef()
    ds_bbox <- ds$bbox()
    ds$close()

    bbox_wgs84 <- c(-113.28289, 46.04764, -113.22629, 46.07760)

    bbox_test <- bbox_to_wkt(ds_bbox) |>
                   g_transform(srs_from = ds_srs,
                               srs_to = epsg_to_wkt(4326),
                               as_wkb = FALSE) |>
                   bbox_from_wkt()

    expect_equal(bbox_test, bbox_wgs84, tolerance = 1e-4)

    pt_xy <- c(324171, 5103034.3)
    pt <- g_create("POINT", pt_xy, as_wkb = FALSE)
    wkt_vec <- c(bbox_to_wkt(ds_bbox), pt)
    wkb_list <- g_wk2wk(wkt_vec)
    expect_true(is.list(wkb_list) && is.raw(wkb_list[[1]]))

    # input vector of WKT strings
    res <- g_transform(wkt_vec, ds_srs, epsg_to_wkt(4326), as_wkb = FALSE)
    expect_vector(res, character(), size = 2)
    expect_equal(bbox_from_wkt(res[1]), bbox_wgs84, tolerance = 1e-4)

    # input list of WKB raw vectors with a NULL geometry
    res <- g_transform(append(wkb_list, list(NULL)),
                       srs_from = ds_srs,
                       srs_to = epsg_to_wkt(4326))
    expect_true(is.list(res) &&
                length(res) == 3 &&
                is.raw(res[[1]]) &&
                is.raw(res[[2]]) &&
                is.null(res[[3]]))
    expect_equal(g_wk2wk(res[[1]]) |> bbox_from_wkt(),
                 bbox_wgs84,
                 tolerance = 1e-4)
    # input as a single raw vector
    res <- g_transform(wkb_list[[1]],
                       srs_from = ds_srs,
                       srs_to = epsg_to_wkt(4326),
                       as_wkb = FALSE)
    expect_equal(bbox_from_wkt(res), bbox_wgs84, tolerance = 1e-4)
    # input of empty raw vector
    res <- g_transform(raw(0),
                       srs_from = ds_srs,
                       srs_to = epsg_to_wkt(4326))
    expect_true(is.null(res))
    # input errors
    expect_error(g_transform("invalid WKT", ds_srs, epsg_to_wkt(4326)))
    expect_error(g_transform(NA, ds_srs, epsg_to_wkt(4326)))
    expect_error(g_transform(bbox_to_wkt(ds_bbox), "invalid WKT",
                             epsg_to_wkt(4326)))
    expect_error(g_transform(bbox_to_wkt(ds_bbox), NULL,
                             epsg_to_wkt(4326)))
    expect_error(g_transform(bbox_to_wkt(ds_bbox), ds_srs,
                             "invalid WKT"))
    expect_error(g_transform(bbox_to_wkt(ds_bbox), ds_srs, NULL))
    # test defaults in case arguments are nulled out
    expect_no_error(g_transform(pt, ds_srs, epsg_to_wkt(4326),
                                wrap_date_line = NULL, date_line_offset = NULL,
                                traditional_gis_order = NULL, as_wkb = NULL,
                                as_iso = NULL, byte_order = NULL,
                                quiet = NULL))


    # bbox_transform
    skip_if(gdal_version_num() < 3040000)

    bb <- c(-1405880.71737131, -1371213.7625429356,
            5405880.71737131, 5371213.762542935)
    res <- bbox_transform(bb, "EPSG:32661", "EPSG:4326")
    expected <- c(-180.0, 48.656, 180.0, 90.0)
    expect_equal(res, expected, tolerance = 1e-4)
})

test_that("geometry properties are correct", {
    g1 <- "POLYGON ((0 0, 10 10, 10 0, 0 0))"
    expect_true(g_is_valid(g1))
    g2 <- "POLYGON ((0 0, 10 10, 10 0, 0 1))"
    expect_false(g_is_valid(g2))
    expect_true(is.na(g_is_valid(raw(0))))
    expect_no_error(g_is_valid(g2, quiet = NA))
    expect_error(g_is_valid(g2, quiet = "YES"))
    expect_error(g_is_valid(0))

    expect_false(g_is_empty(g1))
    g3 <- "POLYGON EMPTY"
    expect_true(g_is_empty(g3))
    expect_true(is.na(g_is_empty(raw(0))))
    expect_no_error(g_is_empty(g3, quiet = NULL))
    expect_error(g_is_empty(g3, quiet = "YES"))
    expect_error(g_is_valid(NA))

    wkt_vec <- c(g1, g2, g3, NA_character_)
    expect_warning(wkb_list <- g_wk2wk(wkt_vec))

    expected_value <- c(TRUE, FALSE, TRUE, NA)
    expect_warning(
        expect_equal(g_is_valid(wkt_vec), expected_value)
    )
    expect_equal(g_is_valid(wkb_list), expected_value)

    expected_value <- c(FALSE, FALSE, TRUE, NA)
    expect_warning(
        expect_equal(g_is_empty(wkt_vec), expected_value)
    )
    expect_equal(g_is_empty(wkb_list), expected_value)

    bb <- c(323476.1, 5101872.0,  327766.1, 5105082.0)
    bb_wkt <- bbox_to_wkt(bb)
    expect_equal(g_name(bb_wkt), "POLYGON")
    expect_true(is.na(g_name(raw(0))))
    expect_no_error(g_name(bb_wkt, quiet = NULL))
    expect_error(g_name(bb_wkt, quiet = "YES"))
    expect_equal(g_name(c(bb_wkt, "POLYGON EMPTY")), c("POLYGON", "POLYGON"))
    res <- bbox_to_wkt(bb) |> g_envelope()
    expect_equal(names(res), c("xmin", "xmax", "ymin", "ymax"))
    names(res) <- NULL
    expect_equal(res, c(bb[1], bb[3], bb[2], bb[4]))
    # as WKB input
    res <- bbox_to_wkt(bb) |> g_wk2wk() |> g_envelope()
    expect_equal(names(res), c("xmin", "xmax", "ymin", "ymax"))
    names(res) <- NULL
    expect_equal(res, c(bb[1], bb[3], bb[2], bb[4]))

    # 3D/measured
    # 2D
    pt1 <- g_create("POINT", c(1, 9))
    expect_false(g_is_3D(pt1))
    expect_false(g_is_3D(g_wk2wk(pt1)))
    expect_equal(g_is_3D(list(pt1, pt1)), c(FALSE, FALSE))
    expect_equal(g_is_3D(list(pt1, pt1) |> g_wk2wk()), c(FALSE, FALSE))
    expect_true(is.na(g_is_3D(raw(0))))
    expect_false(g_is_measured(pt1))
    expect_false(g_is_measured(g_wk2wk(pt1)))
    expect_equal(g_is_measured(list(pt1, pt1)), c(FALSE, FALSE))
    expect_equal(g_is_measured(list(pt1, pt1) |> g_wk2wk()), c(FALSE, FALSE))
    expect_true(is.na(g_is_measured(raw(0))))
    # xyz
    pt2 <- g_create("POINT", c(1, 9, 0))
    expect_true(g_is_3D(pt2))
    expect_true(g_is_3D(g_wk2wk(pt2)))
    expect_equal(g_is_3D(list(pt2, pt2)), c(TRUE, TRUE))
    expect_equal(g_is_3D(list(pt2, pt2) |> g_wk2wk()), c(TRUE, TRUE))
    expect_false(g_is_measured(pt2))
    expect_false(g_is_measured(g_wk2wk(pt2)))
    expect_equal(g_is_measured(list(pt2, pt2)), c(FALSE, FALSE))
    expect_equal(g_is_measured(list(pt2, pt2) |> g_wk2wk()), c(FALSE, FALSE))
    # xyzm
    pt3 <- g_create("POINT", c(1, 9, 0, 2000))
    expect_true(g_is_3D(pt3))
    expect_true(g_is_3D(g_wk2wk(pt3)))
    expect_equal(g_is_3D(list(pt3, pt3)), c(TRUE, TRUE))
    expect_equal(g_is_3D(list(pt3, pt3) |> g_wk2wk()), c(TRUE, TRUE))
    expect_true(g_is_measured(pt3))
    # Note: as_iso for POINT ZM WKT
    expect_true(g_is_measured(g_wk2wk(pt3, as_iso = TRUE)))
    expect_equal(g_is_measured(list(pt3, pt3)), c(TRUE, TRUE))
    # Note: as_iso for POINT ZM WKT
    expect_equal(g_is_measured(list(pt3, pt3) |> g_wk2wk(as_iso = TRUE)),
                 c(TRUE, TRUE))

    # g_is_ring
    ring <- "LINESTRING(0 0,0 1,1 1,0 0)"
    expect_true(g_is_ring(ring))
    expect_true(g_is_ring(g_wk2wk(ring)))
    expect_equal(g_is_ring(c(ring, ring)), c(TRUE, TRUE))
    expect_equal(g_is_ring(c(ring, ring) |> g_wk2wk()), c(TRUE, TRUE))
    expect_true(is.na(g_is_ring(raw(0))))

    # g_envelope
    env1_2 <- c(0, 10, 0, 10)
    env3 <- c(0, 0, 0, 0)
    env_mat <- rbind(env1_2, env1_2, env3)
    colnames(env_mat) <- c("xmin", "xmax", "ymin", "ymax")
    dimnames(env_mat) <- NULL
    names(env1_2) <- c("xmin", "xmax", "ymin", "ymax")
    names(env3) <- c("xmin", "xmax", "ymin", "ymax")
    expect_equal(g_envelope(g1), env1_2)
    expect_equal(g_envelope(g2), env1_2)  # same as g1 but g2 is invalid geom
    expect_equal(g_envelope(g3), env3)
    wkt_vec <- c(g1, g2, g3)
    res <- g_envelope(wkt_vec)
    dimnames(res) <- NULL
    expect_equal(res, env_mat)
    wkb_list <- g_wk2wk(wkt_vec)
    res <- g_envelope(wkb_list)
    dimnames(res) <- NULL
    expect_equal(res, env_mat)
    # 3D envelope
    wkt_3d <- "MULTIPOLYGON(((1 2 3,-1 2 3,-1 -2 3,-1 2 3,1 2 3),(0.1 0.2 0.3,-0.1 0.2 0.3,-0.1 -0.2 0.3,-0.1 0.2 0.3,0.1 0.2 0.3)),((10 20 -30,-10 20 -30,-10 -20 -30,-10 20 -30,10 20 -30)))"
    env3d <- c(-10, 10, -20, 20, -30, 3.0)
    names(env3d) <- c("xmin", "xmax", "ymin", "ymax", "zmin", "zmax")
    res <- g_envelope(wkt_3d, as_3d = TRUE)
    expect_equal(res, env3d)
    # as_3d = TRUE on 2D geom
    res <- g_envelope(g1, as_3d = TRUE)
    names(res) <- NULL
    expect_equal(res, c(0, 10, 0, 10, 0, 0))

    # g_geom_count
    expect_equal(g_geom_count(g1), 1)
    expect_equal(g_geom_count(g_wk2wk(g1)), 1)
    expect_equal(g_geom_count(wkt_3d), 2)
    expect_equal(g_geom_count(list(g_wk2wk(g1), g_wk2wk(wkt_3d))), c(1, 2))
    expect_equal(g_geom_count(c(g1, wkt_3d)), c(1, 2))
    expect_equal(g_geom_count("GEOMETRYCOLLECTION EMPTY"), 0)

    # g_summary requires GDAL >= 3.7
    skip_if(gdal_version_num() < gdal_compute_version(3, 7, 0))

    g <- "MULTIPOLYGON (((10 0,0 0,5 5,10 0)),((10 10,5 5,0 10,10 10)))"
    expected_value <-
        "MULTIPOLYGON : 2 geometries: POLYGON : 4 points POLYGON : 4 points"
    expect_equal(g_summary(g), expected_value)
    expect_equal(g_summary(g_wk2wk(g)), expected_value)

    expect_vector(g_summary(wkt_vec), character(), size = 3)
    expect_vector(g_summary(wkb_list), character(), size = 3)

    expect_true(is.na(g_summary(raw(0))))

    # g_invalid_reason requires GDAL >= 3.13
    skip_if(gdal_version_num() < gdal_compute_version(3, 13, 0))

    expect_false(is.na(g_invalid_reason("LINESTRING(0 0)")))
    expect_true(is.na(g_invalid_reason("LINESTRING(0 0, 1 1)")))
})

test_that("geometry binary predicates/ops return correct values", {
    elev_file <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")
    ds <- new(GDALRaster, elev_file)
    bb <- ds$bbox() |> bbox_to_wkt()
    ds$close()

    bnd <- "POLYGON ((324467.3 5104814.2, 323909.4 5104365.4, 323794.2
    5103455.8, 324970.7 5102885.8, 326420.0 5103595.3, 326389.6 5104747.5,
    325298.1 5104929.4, 325298.1 5104929.4, 324467.3 5104814.2))"

    bnd_disjoint <- "POLYGON ((324457.6 5101227.0, 323899.7 5100778.3,
    323784.5 5099868.7, 324961.0 5099298.7, 326410.3 5100008.2, 326380.0
    5101160.4, 325288.4 5101342.2, 325288.4 5101342.2, 324457.6 5101227.0))"

    bnd_overlaps <- "POLYGON ((327381.9 5104541.2, 326824.0 5104092.5, 326708.8
    5103182.9, 327885.2 5102612.9, 329334.5 5103322.4, 329304.2 5104474.5,
    328212.7 5104656.4, 328212.7 5104656.4, 327381.9 5104541.2))"

    expect_true(g_intersects(bb, bnd_overlaps))
    expect_false(g_intersects(bb, bnd_disjoint))
    expect_false(g_equals(bnd, bnd_overlaps))
    expect_true(g_disjoint(bb, bnd_disjoint))
    expect_false(g_disjoint(bb, bnd_overlaps))
    expect_true(g_contains(bb, bnd))
    expect_false(g_contains(bnd, bb))
    expect_false(g_within(bb, bnd))
    expect_true(g_within(bnd, bb))
    expect_true(g_overlaps(bb, bnd_overlaps))
    expect_false(g_overlaps(bb, bnd_disjoint))
    expect_false(g_overlaps(bb, bnd))

    # test NA return if either input is an empty raw vector
    expect_true(is.na(g_intersects(raw(0), bnd_overlaps, quiet = TRUE)))
    expect_true(is.na(g_intersects(bb, raw(0), quiet = TRUE)))
    expect_true(is.na(g_equals(raw(0), bnd_overlaps)))
    expect_true(is.na(g_equals(bb, raw(0))))
    expect_true(is.na(g_disjoint(raw(0), bnd_overlaps)))
    expect_true(is.na(g_disjoint(bb, raw(0))))
    expect_true(is.na(g_contains(raw(0), bnd_overlaps)))
    expect_true(is.na(g_contains(bb, raw(0))))
    expect_true(is.na(g_within(raw(0), bnd_overlaps)))
    expect_true(is.na(g_within(bb, raw(0))))
    expect_true(is.na(g_overlaps(raw(0), bnd_overlaps)))
    expect_true(is.na(g_overlaps(bb, raw(0))))

    linestr <- "LINESTRING (324467.3 5104814.2, 323909.4 5104365.4)"
    expect_true(g_touches(bnd, linestr))
    expect_false(g_touches(bb, linestr))
    expect_false(g_crosses(bb, linestr))

    g1 <- g_intersection(bb, bnd_overlaps, as_wkb = FALSE)
    g2 <- g_union(bb, bnd_overlaps, as_wkb = FALSE)
    g3 <- g_sym_difference(bb, bnd_overlaps, as_wkb = FALSE)
    expect_equal(g_area(g3), g_area(g_difference(g2, g1, as_wkb = FALSE)),
                 tolerance = 0.01)
    expect_true(g_difference(bnd, bb, as_wkb = FALSE) |> g_is_empty())
    expect_false(g_difference(bnd_overlaps, bb, as_wkb = FALSE) |> g_is_empty())

    # binary ops on list input
    g1 <- g_wk2wk("POLYGON ((0 0, 10 10, 10 0, 0 0))")
    g2 <- g_wk2wk("POLYGON ((0 0, 5 5, 5 0, 0 0))")
    g3 <- g_wk2wk("POLYGON ((100 100, 110 110, 110 100, 100 100))")
    g_list1 <- list(g1, g1)
    g_list2 <- list(g2, g3)

    res <- g_intersection(g_list1, g_list2)
    expect_true(g_equals(res[[1]], "POLYGON ((5 5,5 0,0 0,5 5))"))
    expect_true(g_is_empty(res[[2]]))
    # same but testing defaults in case any arguments are nulled out
    res <- g_intersection(g_list1, g_list2,
                          as_wkb = NULL, as_iso = NULL,
                          byte_order = NULL, quiet = NULL)
    expect_true(g_equals(res[[1]], "POLYGON ((5 5,5 0,0 0,5 5))"))
    expect_true(g_is_empty(res[[2]]))

    res <- g_union(g_list1, g_list2)
    expect_true(g_equals(res[[1]], "POLYGON ((5 5,10 10,10 0,5 0,0 0,5 5))"))
    expect_false(g_is_empty(res[[2]]))
    # same but testing defaults in case any arguments are nulled out
    res <- g_union(g_list1, g_list2,
                   as_wkb = NULL, as_iso = NULL,
                   byte_order = NULL, quiet = NULL)
    expect_true(g_equals(res[[1]], "POLYGON ((5 5,10 10,10 0,5 0,0 0,5 5))"))
    expect_false(g_is_empty(res[[2]]))

    res <- g_difference(g_list1, g_list2)
    expect_true(g_equals(res[[1]], "POLYGON ((10 10,10 0,5 0,5 5,10 10))"))
    expect_false(g_is_empty(res[[2]]))
    # same but testing defaults in case any arguments are nulled out
    res <- g_difference(g_list1, g_list2,
                        as_wkb = NULL, as_iso = NULL,
                        byte_order = NULL, quiet = NULL)
    expect_true(g_equals(res[[1]], "POLYGON ((10 10,10 0,5 0,5 5,10 10))"))
    expect_false(g_is_empty(res[[2]]))

    res <- g_sym_difference(g_list1, g_list2)
    expect_true(g_equals(res[[1]], "POLYGON ((10 10,10 0,5 0,5 5,10 10))"))
    expect_equal(g_name(res[[2]]), "MULTIPOLYGON")
    # same but testing defaults in case any arguments are nulled out
    res <- g_sym_difference(g_list1, g_list2,
                            as_wkb = NULL, as_iso = NULL,
                            byte_order = NULL, quiet = NULL)
    expect_true(g_equals(res[[1]], "POLYGON ((10 10,10 0,5 0,5 5,10 10))"))
    expect_equal(g_name(res[[2]]), "MULTIPOLYGON")
})

test_that("unary ops return correct values", {
    skip_if(!(geos_version()$major > 3 || geos_version()$minor >= 6))

    # g_buffer
    pt <- "POINT (0 0)"
    expect_error(g_buffer(geom = "invalid WKT", dist = 10))
    bb <- bbox_from_wkt(g_buffer(pt, dist = 10, as_wkb = FALSE))
    expect_equal(bb, c(-10, -10,  10,  10))
    # same but testing defaults in case any arguments are nulled out
    bb <- bbox_from_wkt(g_buffer(pt, dist = 10, as_wkb = FALSE,
                                 as_iso = NULL, byte_order = NULL,
                                 quiet = NULL))
    expect_equal(bb, c(-10, -10,  10,  10))
    expect_error(g_buffer(pt, dist = NULL))
    # test defaults in case any arguments are nulled out
    expect_no_error(g_buffer(pt, dist = 10, quad_segs = NULL, as_wkb = NULL,
                             as_iso = NULL, byte_order = NULL, quiet = NULL))
    # empty raw vector
    expect_true(is.null(g_buffer(raw(0), dist = 10)))

    # g_boundary
    g1 <- "POINT(1 1)"
    expect_equal(g_boundary(g1, as_wkb = FALSE), "GEOMETRYCOLLECTION EMPTY")
    g2 <- "MULTIPOINT((0 0),(1 1))"
    expect_equal(g_boundary(g2, as_wkb = FALSE), "GEOMETRYCOLLECTION EMPTY")
    g3 <- "LINESTRING(0 0, 1 1, 2 2, 3 2, 4 2)"
    g_bnd <- g_boundary(g3)
    expect_equal(g_name(g_bnd), "MULTIPOINT")
    expect_equal(nrow(g_coords(g_bnd)), 2)
    g4 <- "POLYGON((0 0,1 1,1 0,0 0))"
    g_bnd <- g_boundary(g4)
    expect_equal(g_name(g_bnd), "LINESTRING")
    expect_true(nrow(g_coords(g_bnd)) > 1)
    # same but testing defaults in case any arguments are nulled out
    g_bnd <- g_boundary(g4, as_wkb = NULL, as_iso = NULL, byte_order = NULL,
                        quiet = NULL)
    expect_equal(g_name(g_bnd), "LINESTRING")
    expect_true(nrow(g_coords(g_bnd)) > 1)
    # empty raw vector
    expect_true(is.null(g_boundary(raw(0))))
    # vector/list input
    # character vector of wkt input
    expect_warning(
        g_bnd <- g_boundary(c(g1, g2, g3, g4, NA))
    )
    expected_names <- c("GEOMETRYCOLLECTION", "GEOMETRYCOLLECTION",
                        "MULTIPOINT", "LINESTRING", NA)
    expect_equal(g_name(g_bnd), expected_names)
    # list of wkb input
    expect_warning(
        g_bnd <- g_boundary(g_wk2wk(c(g1, g2, g3, g4, NA)))
    )
    expect_equal(g_name(g_bnd), expected_names)

    # g_convex_hull
    g1 <- "GEOMETRYCOLLECTION(POINT(0 1), POINT(0 0), POINT(1 0), POINT(1 1))"
    g_conv_hull <- g_convex_hull(g1, as_wkb = FALSE)
    g_expect <- "POLYGON ((0 0,0 1,1 1,1 0,0 0))"
    expect_equal(g_conv_hull, g_expect)
    # wkb input
    g_conv_hull <- g_convex_hull(g_wk2wk(g1), as_wkb = FALSE)
    expect_equal(g_conv_hull, g_expect)
    # same but testing defaults in case any arguments are nulled out
    g_conv_hull <- g_convex_hull(g_wk2wk(g1), as_wkb = FALSE, as_iso = NULL,
                                 byte_order = NULL, quiet = NULL)
    expect_equal(g_conv_hull, g_expect)
    # empty raw vector
    expect_true(is.null(g_convex_hull(raw(0))))
    # vector/list input
    # character vector of wkt input
    wkt_vec <- c(g1, g1, NA)
    expect_warning(g_conv_hull <- g_convex_hull(wkt_vec, as_wkb = FALSE)) |>
        expect_warning()  # for as_wkb = FASLE
    expect_equal(g_conv_hull, c(g_expect, g_expect, NA))
    # list of wkb input
    expect_warning(wkb_list <- g_wk2wk(wkt_vec))
    expect_warning(g_conv_hull <- g_convex_hull(wkb_list, as_wkb = FALSE))
    expect_equal(g_conv_hull, c(g_expect, g_expect, NA))

    # g_delaunay_triangulation
    g1 <- "MULTIPOINT(0 0,0 1,1 1,1 0)"
    g_dt <- g_delaunay_triangulation(g1, as_wkb = FALSE)
    g_expect <- "GEOMETRYCOLLECTION (POLYGON ((0 1,0 0,1 0,0 1)),POLYGON ((0 1,1 0,1 1,0 1)))"
    expect_equal(g_dt, g_expect)
    # wkb input
    g_dt <- g_delaunay_triangulation(g_wk2wk(g1), as_wkb = FALSE)
    expect_equal(g_dt, g_expect)
    # same but testing defaults in case any arguments are nulled out
    g_dt <- g_delaunay_triangulation(g_wk2wk(g1), tolerance = NULL,
                                     only_edges = NULL, as_wkb = FALSE,
                                     as_iso = NULL, byte_order = NULL,
                                     quiet = NULL)
    expect_equal(g_dt, g_expect)
    # empty raw vector
    expect_true(is.null(g_delaunay_triangulation(raw(0))))
    # vector/list input
    g_expect <- c(g_expect, g_expect, NA)
    g2 <- "LINESTRING(0 0,1 1,10 0)"
    # character vector of wkt input
    expect_warning(g_dt <- g_delaunay_triangulation(c(g1, g1, NA),
                                                    as_wkb = FALSE)) |>
        expect_warning()  # for as_wkb = FASLE
    expect_equal(g_dt, g_expect)
    # list of wkb input
    expect_warning(g_dt <- g_delaunay_triangulation(g_wk2wk(c(g1, g1, NA)),
                                                    as_wkb = FALSE)) |>
        expect_warning()  # for as_wkb = FALSE
    expect_equal(g_dt, g_expect)
    # constrained Delaunay, if GDAL >= 3.12 and GEOS >= 3.10
    if (gdal_version_num() >= gdal_compute_version(3, 12, 0) &&
        (geos_version()$major > 3 || geos_version()$minor >= 10)) {

        g1 <- "POLYGON ((10 10, 20 40, 90 90, 90 10, 10 10))"
        g_dt <- g_delaunay_triangulation(g1, constrained = TRUE, as_wkb = FALSE)
        g_expect <- "GEOMETRYCOLLECTION (POLYGON ((90 10,20 40,90 90,90 10)),POLYGON ((20 40,90 10,10 10,20 40)))"
        expect_equal(g_dt, g_expect)
    }

    # g_segmentize
    g1 <- "LINESTRING (0 0,0 10)"
    g_seg <- g_segmentize(g1, max_length = 5, as_wkb = FALSE)
    g_expect <- "LINESTRING (0 0,0 5,0 10)"
    expect_equal(g_seg, g_expect)
    # wkb input
    g_seg <- g_segmentize(g_wk2wk(g1), max_length = 5, as_wkb = FALSE)
    expect_equal(g_seg, g_expect)
    # same but testing defaults in case optional arguments are nulled out
    g_seg <- g_segmentize(g_wk2wk(g1), max_length = 5, as_wkb = FALSE,
                          as_iso = NULL, byte_order = NULL, quiet = NULL)
    expect_equal(g_seg, g_expect)
    # empty raw vector
    expect_true(is.null(g_segmentize(raw(0), max_length = 5)))
    # vector/list input
    g_expect <- c(g_expect, g_expect, NA)
    # character vector of wkt input
    expect_warning(g_seg <- g_segmentize(c(g1, g1, NA), max_length = 5,
                                         as_wkb = FALSE)) |>
        expect_warning()  # for as_wkb = FALSE
    expect_equal(g_seg, g_expect)
    # list of wkb input
    expect_warning(g_seg <- g_segmentize(g_wk2wk(c(g1, g1, NA)), max_length = 5,
                                         as_wkb = FALSE)) |>
        expect_warning()  # for as_wkb = FALSE
    expect_equal(g_seg, g_expect)

    # g_simplify
    g1 <- "LINESTRING(0 0,1 0,10 0)"
    g_simp <- g_simplify(g1, tolerance = 5, as_wkb = FALSE)
    g_expect <- "LINESTRING (0 0,10 0)"
    expect_equal(g_simp, g_expect)
    # wkb input
    g_simp <- g_simplify(g_wk2wk(g1), tolerance = 5, as_wkb = FALSE)
    expect_equal(g_simp, g_expect)
    # same but testing defaults in case optional arguments are nulled out
    g_simp <- g_simplify(g_wk2wk(g1), tolerance = 5, preserve_topology = NULL,
                         as_wkb = FALSE, as_iso = NULL, byte_order = NULL,
                         quiet = NULL)
    expect_equal(g_simp, g_expect)
    # preserve_topology = FALSE
    g_simp <- g_simplify(g1, tolerance = 5, preserve_topology = FALSE,
                         as_wkb = FALSE)
    expect_equal(g_simp, g_expect)
    # empty raw vector
    expect_true(is.null(g_simplify(raw(0), tolerance = 5)))
    # vector/list input
    g_expect <- c(g_expect, g_expect, NA)
    g2 <- "LINESTRING(0 0,1 1,10 0)"
    # character vector of wkt input
    expect_warning(g_simp <- g_simplify(c(g1, g2, NA), tolerance = 5,
                                        as_wkb = FALSE)) |>
        expect_warning()  # for as_wkb = FALSE
    expect_equal(g_simp, g_expect)
    # list of wkb input
    expect_warning(g_simp <- g_simplify(g_wk2wk(c(g1, g2, NA)), tolerance = 5,
                                        as_wkb = FALSE)) |>
        expect_warning()  # for as_wkb = FALSE
    expect_equal(g_simp, g_expect)


    # g_unary_union - requires GDAL >= 3.7
    skip_if(gdal_version_num() < gdal_compute_version(3, 7, 0))

    # from gdal/autotest/cpp/test_ogr_geos.cpp:
    # CheckEqualGeometries() doesn't work with GEOS 3.6 with the above
    # expected polygon, because of the order of the nodes, and for some
    # reason OGR_G_Normalize() in CheckEqualGeometries() doesn't fix this,
    # so just fallback to bounding box and area comparison
    g1 <- "GEOMETRYCOLLECTION(POINT(0.5 0.5), POLYGON((0 0,0 1,1 1,1 0,0 0)), POLYGON((1 0,1 1,2 1,2 0,1 0)))"
    g_uu <- g_unary_union(g1, as_wkb = FALSE)
    g_expect <- "POLYGON ((0 1,1 1,2 1,2 0,1 0,0 0,0 1))"
    expect_equal(g_area(g_uu), g_area(g_expect), tolerance = 0.1)
    # wkb input
    g_uu <- g_unary_union(g_wk2wk(g1), as_wkb = FALSE)
    expect_equal(g_area(g_uu), g_area(g_expect), tolerance = 0.1)
    # same but testing defaults in case any arguments are nulled out
    g_uu <- g_unary_union(g_wk2wk(g1), as_wkb = FALSE, as_iso = NULL,
                          byte_order = NULL, quiet = NULL)
    expect_equal(g_area(g_uu), g_area(g_expect), tolerance = 0.1)
    # empty raw vector
    expect_true(is.null(g_unary_union(raw(0))))
    # vector/list input
    # character vector of wkt input
    wkt_vec <- c(g1, g1, NA)
    expect_warning(g_uu <- g_unary_union(wkt_vec, as_wkb = FALSE)) |>
        expect_warning()  # input vector element is NA
    expect_equal(g_area(g_uu), c(g_area(g_expect), g_area(g_expect), NA)) |>
        expect_warning()  # input vector element is NA
    # list of wkb input
    expect_warning(wkb_list <- g_wk2wk(wkt_vec))
    expect_warning(g_uu <- g_unary_union(wkb_list, as_wkb = FALSE))
    expect_equal(g_area(g_uu), c(g_area(g_expect), g_area(g_expect), NA)) |>
        expect_warning()  # input vector element is NA


    # g_concave_hull() requires GEOS >= 3.11
    skip_if(!(geos_version()$major > 3 || geos_version()$minor >= 11))

    g1 <- "MULTIPOINT(0 0,0.4 0.5,0 1,1 1,0.6 0.5,1 0)"
    expect_no_error(
        g_hull <- g_concave_hull(g1, ratio = 0.5, allow_holes = FALSE))

    # wkb input
    expect_no_error(
        g_hull <- g_concave_hull(g_wk2wk(g1), ratio = 0.5, allow_holes = FALSE))

    # same but testing defaults in case optional arguments are nulled out
    expect_no_error(
        g_hull <- g_concave_hull(g_wk2wk(g1), ratio = 0.5, allow_holes = FALSE,
                                 as_wkb = FALSE, as_iso = NULL,
                                 byte_order = NULL, quiet = NULL))

    # empty raw vector
    expect_true(is.null(
        g_concave_hull(raw(0), ratio = 0.5, allow_holes = FALSE)))
    # vector/list input
    # character vector of wkt input
    expect_warning(
        g_hull <- g_concave_hull(c(g1, NA), ratio = 0.5, allow_holes = FALSE,
                                 as_wkb = FALSE)) |>
            expect_warning()  # for as_wkb = FALSE
    # list of wkb input
    expect_warning(
        g_hull <- g_concave_hull(g_wk2wk(c(g1, NA)), ratio = 0.5,
                                 allow_holes = FALSE, as_wkb = FALSE)) |>
            expect_warning()  # for as_wkb = FALSE

    # error for required args
    expect_error(g_hull <- g_concave_hull(g1, ratio = 0.5))
    expect_error(g_hull <- g_concave_hull(g1))
})

test_that("geometry measures are correct", {
    expect_equal(g_distance("POINT (0 0)", "POINT (5 12)"), 13)

    expect_equal(g_length("LINESTRING (0 0, 3 4)"), 5)

    bb <- c(323476.1, 5101872.0,  327766.1, 5105082.0)

    bb_area <- (bb[3] - bb[1]) * (bb[4] - bb[2])
    expect_equal(g_area(bbox_to_wkt(bb)), bb_area)

    res <- bbox_to_wkt(bb) |> g_centroid()
    names(res) <- NULL
    expect_equal(res, c(325621.1, 5103477.0))
})

test_that("geodesic measures are correct", {
    # tests based on gdal/autotest/ogr/ogr_geom.py
    # https://github.com/OSGeo/gdal/blob/28e94e2f52893d4206830011d75efe1783f1b7c1/autotest/ogr/ogr_geom.py
    skip_if(gdal_version_num() < 3090000)

    ## geodesic area
    # lon/lat order (traditional_gis_order = TRUE by default)
    g <- "POLYGON((2 49,3 49,3 48,2 49))"
    a <- g_geodesic_area(g, "EPSG:4326")
    expect_equal(a, 4068384291.8911743, tolerance = 1e4)

    g <- "POLYGON((2 89,3 89,3 88,2 89))"
    a <- g_geodesic_area(g, "EPSG:4326")
    expect_equal(a, 108860488.12023926, tolerance = 1e4)

    # lat/lon order
    g <- "POLYGON((49 2,49 3,48 3,49 2))"
    a <- g_geodesic_area(g, "EPSG:4326", traditional_gis_order = FALSE)
    expect_equal(a, 4068384291.8911743, tolerance = 1e4)

    # projected srs
    g <- "POLYGON((2 49,3 49,3 48,2 49))"
    g2 <- g_transform(g, "EPSG:4326", "EPSG:32631")
    a <- g_geodesic_area(g2, "EPSG:32631")
    expect_equal(a, 4068384291.8911743, tolerance = 1e4)
    # For comparison: cartesian area in UTM
    a <- g_area(g2)
    expect_equal(a, 4065070548.465351, tolerance = 1e4)
    # start with lat/lon order
    g <- "POLYGON((49 2,49 3,48 3,49 2))"
    g2 <- g_transform(g, "EPSG:4326", "EPSG:32631",
                      traditional_gis_order = FALSE)
    a <- g_geodesic_area(g2, "EPSG:32631")
    expect_equal(a, 4068384291.8911743, tolerance = 1e4)

    expect_true(is.na(g_geodesic_area(raw(0), "EPSG:4326")))


    skip_if(gdal_version_num() < 3100000)

    ## geodesic length
    # lon/lat order (traditional_gis_order = TRUE by default)
    g <- "LINESTRING(2 49,3 49)"
    l <- g_geodesic_length(g, "EPSG:4326")
    expect_equal(l, 73171.26435678436, tolerance = 1e4)

    g <- "POLYGON((2 49,3 49,3 48,2 49))"
    l <- g_geodesic_length(g, "EPSG:4326")
    expect_equal(l, 317885.78639964823, tolerance = 1e4)

    # lat/lon order
    g <- "LINESTRING(49 3,48 3)"
    l <- g_geodesic_length(g, "EPSG:4326", traditional_gis_order = FALSE)
    expect_equal(l, 111200.0367623785, tolerance = 1e4)

    # projected srs
    g <- "POLYGON((2 49,3 49,3 48,2 49))"
    g2 <- g_transform(g, "EPSG:4326", "EPSG:32631")
    l <- g_geodesic_length(g2, "EPSG:32631")
    expect_equal(l, 317885.78639964823, tolerance = 1e4)
    # For comparison: cartesian length in UTM
    l <- g_length(g2)
    expect_equal(l, 317763.15996565996, tolerance = 1e4)
    # start with lat/lon order
    g <- "POLYGON((49 2,49 3,48 3,49 2))"
    g2 <- g_transform(g, "EPSG:4326", "EPSG:32631",
                      traditional_gis_order = FALSE)
    l <- g_geodesic_length(g2, "EPSG:32631")
    expect_equal(l, 317885.78639964823, tolerance = 1e4)

    expect_true(is.na(g_geodesic_length(raw(0), "EPSG:4326")))
})

test_that("make_valid works", {
    # test only with recent GDAL and GEOS
    # these tests could give different results if used across a range of older
    # GDAL/GEOS versions, and the STRUCTURE method requires GEOS >= 3.10
    skip_if(gdal_version_num() < 3080000 ||
                geos_version()$major < 3 ||
                (geos_version()$major == 3 && geos_version()$minor < 11))

    # valid to valid
    wkt1 <- "POINT (0 0)"
    expect_no_error(wkb1 <- g_make_valid(wkt1))
    expect_no_error(wkb1 <- g_make_valid(wkt1, as_wkb = FALSE))
    expect_no_error(wkb1 <- g_make_valid(g_wk2wk(wkt1)))
    expect_no_error(wkb1 <- g_make_valid(wkt1,
                                         method = NULL,
                                         keep_collapsed = NULL,
                                         as_wkb = NULL,
                                         as_iso = NULL,
                                         byte_order = NULL,
                                         quiet = NULL))
    expect_true(g_equals(g_wk2wk(wkb1), wkt1))

    # invalid - error if GDAL < 3.13
    # GDAL >= 3.13:
    # Certain geometries cannot be read using GEOS, for example if Polygon
    # rings are not closed or do not contain enough vertices. If a geometry
    # cannot be read by GEOS, NULL will be returned. Starting with GDAL 3.13,
    # GDAL will attempt to modify these geometries such that they can be read
    # and repaired by GEOS.
    wkt2 <- "LINESTRING (0 0)"
    if (gdal_version_num() < gdal_compute_version(3, 13, 0)) {
        expect_warning(wkb2 <- g_make_valid(wkt2))
        expect_true(is.null(wkb2))
    } else {
        expect_equal(g_make_valid(wkt2, as_wkb = FALSE), "POINT (0 0)")
    }

    # invalid to valid
    wkt3 <- "POLYGON ((0 0,10 10,0 10,10 0,0 0))"
    expect_no_error(wkb3 <- g_make_valid(wkt3))
    expected_wkt3 <-
        "MULTIPOLYGON (((10 0,0 0,5 5,10 0)),((10 10,5 5,0 10,10 10)))"
    expect_true(g_equals(g_wk2wk(wkb3), expected_wkt3))

    # STRUCTURE method
    wkt4 <- "POLYGON ((0 0,0 10,10 10,10 0,0 0),(5 5,15 10,15 0,5 5))"
    expect_no_error(wkb4 <- g_make_valid(wkt4, method = "STRUCTURE"))
    expected_wkt4 <-
        "POLYGON ((0 10,10 10,10.0 7.5,5 5,10.0 2.5,10 0,0 0,0 10))"
    expect_true(g_equals(g_wk2wk(wkb4), expected_wkt4))

    # vector of WKT input
    wkt_vec <- c(wkt1, wkt2, wkt3, wkt4, NA)
    expect_warning(wkb_list <- g_make_valid(wkt_vec, method = "STRUCTURE",
                                            quiet = TRUE))
    expect_equal(length(wkb_list), length(wkt_vec))
    if (gdal_version_num() < gdal_compute_version(3, 13, 0)) {
        expect_true(is.null(wkb_list[[2]]))
    } else {
        expect_false(is.null(wkb_list[[2]]))
    }
    expect_true(is.null(wkb_list[[5]]))
    expect_true(g_equals(g_wk2wk(wkb_list[[4]]), expected_wkt4))

    # list of WKB input
    rm(wkb_list)
    expect_warning(wkb_list <- g_make_valid(g_wk2wk(wkt_vec),
                                            method = "STRUCTURE",
                                            quiet = TRUE))
    expect_equal(length(wkb_list), length(wkt_vec))
    if (gdal_version_num() < gdal_compute_version(3, 13, 0)) {
        expect_true(is.null(wkb_list[[2]]))
    } else {
        expect_false(is.null(wkb_list[[2]]))
    }
    expect_true(is.null(wkb_list[[5]]))
    expect_true(g_equals(g_wk2wk(wkb_list[[4]]), expected_wkt4))
})

test_that("normalize works", {
    skip_if(gdal_version_num() < gdal_compute_version(3, 3, 0))

    g <- "POLYGON ((0 1,1 1,1 0,0 0,0 1))"
    expect_no_error(g_normalize(g))
    expect_no_error(g_normalize(g, as_wkb = NULL, as_iso = NULL,
                                byte_order = NULL, quiet = NULL))
    g_norm <- g_normalize(g, as_wkb = FALSE)
    g_expect <- "POLYGON ((0 0,0 1,1 1,1 0,0 0))"
    expect_equal(g_norm, g_expect)
    # wkb input
    g_norm <- g_normalize(g_wk2wk(g), as_wkb = FALSE)
    expect_equal(g_norm, g_expect)
    # vector/list input
    g_expect <- c(g_expect, g_expect, NA)
    # character vector of wkt input
    expect_warning(g_norm <- g_normalize(c(g, g, NA), as_wkb = FALSE,
                                         quiet = TRUE)) |>
        expect_warning()  # for as_wkb = FALSE
    expect_equal(g_norm, g_expect)
    # list of wkb input
    expect_warning(g_norm <- g_normalize(g_wk2wk(c(g, g, NA)), as_wkb = FALSE,
                                         quiet = TRUE)) |>
        expect_warning()  # for as_wkb = FALSE
    expect_equal(g_norm, g_expect)
})

test_that("g_set_3D / g_set_measured work", {
    pt_xyzm <- g_create("POINT", c(1, 9, 100, 2000))
    expect_true(g_is_3D(pt_xyzm))
    expect_true(g_is_measured(pt_xyzm))

    # WKB input
    expect_false(g_set_3D(pt_xyzm, is_3d = FALSE) |> g_is_3D())
    expect_false(g_set_measured(pt_xyzm, is_measured = FALSE) |>
                     g_is_measured())
    # input should be unchanged if is_3d / is_measured = TRUE
    pt_out <- g_set_3D(pt_xyzm, is_3d = TRUE)
    expect_true(g_is_3D(pt_out))
    expect_true(g_equals(pt_xyzm, pt_out))
    pt_out <- g_set_measured(pt_xyzm, is_measured = TRUE)
    expect_true(g_is_measured(pt_out))
    expect_true(g_equals(pt_xyzm, pt_out))
    # as ISO
    expect_false(g_set_3D(pt_xyzm, is_3d = FALSE, as_iso = TRUE) |> g_is_3D())
    expect_false(g_set_measured(pt_xyzm, is_measured = FALSE, as_iso = TRUE) |>
                     g_is_measured())
    # list of WKB
    wkb <- list(pt_xyzm, pt_xyzm)
    res <- g_set_3D(wkb, is_3d = FALSE) |> g_is_3D()
    expect_equal(res, c(FALSE, FALSE))
    res <- g_set_measured(wkb, is_measured = FALSE) |> g_is_measured()
    expect_equal(res, c(FALSE, FALSE))
    # WKT input
    expect_false(g_set_3D(g_wk2wk(pt_xyzm), is_3d = FALSE) |> g_is_3D())
    expect_false(g_set_measured(g_wk2wk(pt_xyzm), is_measured = FALSE) |>
                     g_is_measured())
    # as ISO
    expect_false(g_set_3D(g_wk2wk(pt_xyzm), is_3d = FALSE, as_iso = TRUE) |>
                     g_is_3D())
    expect_false(g_set_measured(g_wk2wk(pt_xyzm), is_measured = FALSE,
                                as_iso =  TRUE) |>
                     g_is_measured())
    # vector of WKT
    wkt <- c(g_wk2wk(pt_xyzm), g_wk2wk(pt_xyzm))
    res <- g_set_3D(wkt, is_3d = FALSE) |> g_is_3D()
    expect_equal(res, c(FALSE, FALSE))
    res <- g_set_measured(wkt, is_measured = FALSE) |> g_is_measured()
    expect_equal(res, c(FALSE, FALSE))

    # input validation
    expect_error(g_set_3D(pt_xyzm))
    expect_error(g_set_measured(pt_xyzm))
    expect_no_error(g_set_3D(pt_xyzm, is_3d = FALSE, as_wkb = NULL))
    expect_no_error(g_set_measured(pt_xyzm, is_measured = FALSE, as_wkb = NULL))
    expect_error(g_set_3D(pt_xyzm, is_3d = FALSE, as_wkb = c(TRUE, FALSE)))
    expect_error(g_set_measured(pt_xyzm, is_measured = FALSE,
                 as_wkb = c(TRUE, FALSE)))
    expect_no_error(g_set_3D(pt_xyzm, is_3d = FALSE, as_iso = NULL))
    expect_no_error(g_set_measured(pt_xyzm, is_measured = FALSE, as_iso = NULL))
    expect_error(g_set_3D(pt_xyzm, is_3d = FALSE, as_iso = c(TRUE, FALSE)))
    expect_error(g_set_measured(pt_xyzm, is_measured = FALSE,
                 as_iso = c(TRUE, FALSE)))
    expect_no_error(g_set_3D(pt_xyzm, is_3d = FALSE, byte_order = NULL))
    expect_no_error(g_set_measured(pt_xyzm, is_measured = FALSE,
                                   byte_order = NULL))
    expect_error(g_set_3D(pt_xyzm, is_3d = FALSE, byte_order = "invalid"))
    expect_error(g_set_measured(pt_xyzm, is_measured = FALSE,
                                byte_order = "invalid"))
    expect_no_error(g_set_3D(pt_xyzm, is_3d = FALSE, quiet = NULL))
    expect_no_error(g_set_measured(pt_xyzm, is_measured = FALSE, quiet = NULL))
    expect_error(g_set_3D(pt_xyzm, is_3d = FALSE, quiet = "invalid"))
    expect_error(g_set_measured(pt_xyzm, is_measured = FALSE,
                                quiet = "invalid"))
})

test_that("swap xy works", {
    g <- "GEOMETRYCOLLECTION(POINT(1 2),LINESTRING(1 2,2 3),POLYGON((0 0,0 1,1 1,0 0)))"
    expect_no_error(g_swap_xy(g))
    expect_no_error(g_swap_xy(g, as_wkb = NULL, as_iso = NULL,
                              byte_order = NULL, quiet = NULL))
    g_swapped <- g_swap_xy(g, as_wkb = FALSE)
    g_expect <- "GEOMETRYCOLLECTION (POINT (2 1),LINESTRING (2 1,3 2),POLYGON ((0 0,1 0,1 1,0 0)))"
    expect_equal(g_swapped, g_expect)
    # wkb input
    g_swapped <- g_swap_xy(g_wk2wk(g), as_wkb = FALSE)
    expect_equal(g_swapped, g_expect)
    # vector/list input
    g1 <- "POINT(1 2)"
    g2 <- "POINT(2 3)"
    g_expect <- c("POINT (2 1)", "POINT (3 2)", NA)
    # character vector of wkt input
    expect_warning(g_swapped <- g_swap_xy(c(g1, g2, NA), as_wkb = FALSE,
                                          quiet = TRUE)) |>
        expect_warning()  # for as_wkb = FALSE
    expect_equal(g_swapped, g_expect)
    # list of wkb input
    expect_warning(g_swapped <- g_swap_xy(g_wk2wk(c(g1, g2, NA)), as_wkb = FALSE,
                                          quiet = TRUE)) |>
        expect_warning()  # for as_wkb = FALSE
    expect_equal(g_swapped, g_expect)
})

test_that("g_coords returns a data frame of vertices", {
    m <- matrix(c(0, 3, 3, 4, 0, 0), ncol = 2, byrow = TRUE)
    pts_wkb <- lapply(seq_len(nrow(m)), function(i) g_create("POINT", m[i, ]))
    expect_true(is.list(pts_wkb) && length(pts_wkb) == 3)
    xy <- g_coords(pts_wkb)
    expect_equal(xy$x, c(0, 3, 0))
    expect_equal(xy$y, c(3, 4, 0))
    # one WKB raw vector not in a list
    expect_true(is.raw(pts_wkb[[1]]))
    xy <- g_coords(pts_wkb[[1]])
    expect_equal(xy$x, 0)
    expect_equal(xy$y, 3)
    # WKT input
    pts_wkt <- g_wk2wk(pts_wkb)
    expect_true(is.character(pts_wkt) && length(pts_wkt) == 3)
    xy <- g_coords(pts_wkt)
    expect_equal(xy$x, c(0, 3, 0))
    expect_equal(xy$y, c(3, 4, 0))

    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
    dsn <- file.path(tempdir(), basename(f))
    file.copy(f, dsn)
    lyr <- new(GDALVector, dsn, "mtbs_perims")
    d <- lyr$fetch(1)
    vertices <- g_coords(d$geom)
    expect_true(is.data.frame(vertices))
    expect_equal(nrow(vertices), 36)
    lyr$close()
    unlink(dsn)
})

#' @name GDALAlg-class
#'
#' @aliases
#' Rcpp_GDALAlg Rcpp_GDALAlg-class GDALAlg
#'
#' @title Class encapsulating a GDAL CLI algorithm
#'
#' @description
#' `GDALAlg` provides bindings to `GDALAlgorithm` and related classes
#' that implement the `gdal` command line interface (CLI) in the GDAL
#' API. An object of class `GDALAlg` represents an instance of a CLI algorithm
#' with methods to obtain algorithm information and argument information, run
#' the algorithm, and access its output.
#'
#' **Requires GDAL >= 3.11.3**.
#'
#' **Experimental** (see the section `Development Status` below)
#'
#' `GDALAlg` is a C++ class exposed directly to \R (via `RCPP_EXPOSED_CLASS`).
#' Fields and methods of the class are accessed using the `$` operator.
#' Arguments to class constructors and class methods must be given in the order
#' documented (naming optional).
#'
#' @param cmd A character string or character vector containing the path to the
#' algorithm, e.g., `"raster reproject"` or `c("raster", "reproject")`.
#' @param args Either a character vector or a named list containing input
#' arguments of the algorithm (see section `Algorithm Argument Syntax` below).
#' @returns An object of class `GDALAlg`, which contains a pointer to the
#' algorithm instance. Class methods are described in Details, along with a set
#' of writable fields for per-object settings.
#'
#' @inheritSection gdal_cli Algorithm Argument Syntax
#'
#' @inheritSection gdal_cli Development Status
#'
#' @section Usage (see Details):
#' ```
#' ## Constructors
#' alg <- new(GDALAlg, cmd)
#' # or, with arguments
#' alg <- new(GDALAlg, cmd, args)
#'
#' ## Read/write fields (per-object settings)
#' alg$setVectorArgsFromObject
#' alg$outputLayerNameForOpen
#' alg$quiet
#'
#' ## Methods
#' alg$info()
#' alg$argInfo(arg_name)
#' alg$usage()
#' alg$usageAsJSON()
#'
#' alg$setArg(arg_name, arg_value)
#' alg$parseCommandLineArgs()
#' alg$getExplicitlySetArgs()
#' alg$run()
#' alg$output()
#' alg$outputs()
#'
#' alg$close()
#' alg$release()
#' ```
#' @section Details:
#' ## Constructors
#'
#' \code{new(GDALAlg, cmd)}\cr
#' Instantiate an algorithm without specifying input arguments.
#'
#' \code{new(GDALAlg, cmd, args)}\cr
#' Instantiate an algorithm giving input arguments as a character vector or
#' named list. See the section `Algorithm Argument Syntax` for details.
#'
#' ## Read/write fields (per-object settings)
#'
#' \code{$setVectorArgsFromObject}\cr
#' A logical value, `TRUE` (the default) to set algorithm arguments
#' automatically when the `"input"` argument or the `"like"` argument is an
#' object of class `GDALVector`. Argument values specified explicitly will
#' override the automatic setting (as long as they result in a parsable set of
#' arguments). Automatically setting arguments from `GDALVector` input can
#' be disabled by setting this field to `FALSE`. In that case, only the vector
#' dataset would be passed to the algorithm, i.e., without automatically
#' passing any layer specifications.
#' When enabled and the `"input"` or `"like"` argument for an algorithm is
#' given as a `GDALVector` object, corresponding arguments will be set
#' automatically based on properties of the object (when the argument is
#' available to the algorithm):
#' * `"input-format"`: set to the `GDALVector` object's driver short name
#' * `"input-layer"`: set to the `GDALVector` layer name if it is not a SQL
#' layer
#' * `"sql"`: set to the SQL statement if the `GDALVector` layer is defined by
#' one
#' * `"dialect"`: set to the SQL dialect if one is specified for a SQL layer
#' * `"like-layer"`: set to the `GDALVector` layer name if it is not a SQL
#' layer
#' * `"like-sql"`: set to the SQL statement if the `GDALVector` layer is
#' defined by one
#'
#' \code{$outputLayerNameForOpen}\cr
#' A character string specifying a layer name to open when obtaining algorithm
#' output as an object of class `GDALVector`. See method \code{$output()} below.
#' The default value is empty string (`""`) in which case the first layer by
#' index is opened. Ignored if output is not a vector dataset.
#'
#' \code{$quiet}\cr
#' A logical value, `FALSE` by default. Set to `TRUE` to suppress progress
#' reporting along with various messages and warnings.
#'
#' ## Methods
#'
#' \code{$info()}\cr
#' Returns a named list of algorithm properties with the following elements:
#' * `name`: character string, the algorithm name
#' * `full_path`: character string, the algorithm name as full path
#' * `description`: character string, the algorithm (short) description
#' * `long_description`: character string, the algorithm longer description
#' * `URL`: character string, the algorithm help URL
#' * `has_subalgorithms`: logical, `TRUE` if the algorithm has sub-algorithms
#' * `subalgorithm_names`: character vector of sub-algorithm names (may be
#' empty)
#' * `arg_names`: character vector of available argument names
#'
#' \code{$argInfo(arg_name)}\cr
#' Returns a named list of properties for an algorithm argument given as a
#' character string, with the following elements:
#' * `name`: character string, the name of the argument
#' * `type`: character string, the argument type as one of `"BOOLEAN"`,
#' `"STRING"`, `"INTEGER"`, `"REAL"`, `"DATASET"`, `"STRING_LIST"`,
#' `"INTEGER_LIST"`, `"REAL_LIST"`, `"DATASET_LIST"`
#' * `description`: character string, the argument description
#' * `short_name`: character string, the short name or empty string if there
#' is none
#' * `aliases`: character vector of aliases (empty if none)
#' * `meta_var`: character string, the "meta-var" hint (by default, the
#' meta-var value is the long name of the argument in upper case)
#' * `category`: character string, the argument category
#' * `is_positional`: logical, `TRUE` if the argument is a positional one
#' * `is_required`: logical, `TRUE` if the argument is required
#' * `min_count`: integer, the minimum number of values for the argument (only
#' applies to list type of arguments)
#' * `max_count`: integer, the maximum number of values for the argument (only
#' applies to list type of arguments)
#' * `packed_values_allowed`: logical, `TRUE` if, for list type of arguments,
#' several comma-separated values may be specified (i.e., `"--foo=bar,baz"`)
#' * `repeated_arg_allowed`: logical, `TRUE` if, for list type of arguments,
#' the argument may be repeated (i.e., `c("--foo=bar", "--foo=baz")`)
#' * `choices`: character vector of allowed values for the argument (may be
#' empty and only applies for argument types `"STRING"` and `"STRING_LIST"`)
#' * `is_explicitly_set`: logical, `TRUE` if the argument value has been
#' explicitly set
#' * `has_default_value`: logical, `TRUE` if the argument has a declared
#' default value
#' * `default_value`: character or integer or numeric, the default value if the
#' argument has one, otherwise `NULL`
#' * `is_hidden_for_api`: logical, `TRUE` if the argument is only for CLI usage
#' (e.g., "--help") (GDAL >= 3.12 only, see `is_only_for_cli`)
#' * `is_hidden_for_cli`: logical, `TRUE` if the argument must not be
#' mentioned in CLI usage (e.g., "output-value" for "gdal raster info", which
#' is only meant when the algorithm is used from a non-CLI context such as
#' programmatically from \R)
#' * `is_only_for_cli`: logical, `TRUE` if the argument is only for CLI usage
#' (e.g., "--help") (deprecated at GDAL 3.12, see `is_hidden_for_api`)
#' * `is_input`: logical, `TRUE` if the value of the argument is read-only
#' during the execution of the algorithm
#' * `is_output`: logical, `TRUE` if (at least part of) the value of the
#' argument is set during the execution of the algorithm
#' * `dataset_type_flags`: character vector containing strings `"RASTER"`,
#' `"VECTOR"`, `"MULTIDIM_RASTER"`, possibly with `"UPDATE"` (`NULL` if
#' the argument is not a dataset type)
#' * `dataset_input_flags`: character vector indicating if a dataset argument
#' supports specifying only the dataset name (`"NAME"`), only the dataset
#' object (`"OBJECT"`), or both (`"NAME", "OBJECT"`) when it is used as an
#' input (`NULL` if the argument is not a dataset type)
#' * `dataset_output_flags`: character vector indicating if a dataset argument
#' supports specifying only the dataset name (`"NAME"`), only the dataset
#' object (`"OBJECT"`), or both (`"NAME", "OBJECT"`) when it is used as an
#' output (`NULL` if the argument is not a dataset type)
#' * `mutual_exclusion_group`: character string, the name of the mutual
#' exclusion group to which this argument belongs
#'
#' \code{$usage()}\cr
#' Print a help message for the algorithm to the console. No return value.
#'
#' \code{$usageAsJSON()}\cr
#' Returns the usage of the algorithm as a JSON-serialized string.
#'
#' \code{$setArg(arg_name, arg_value)}\cr
#' Set the value of input algorithm argument `arg_name`, a character string
#' containing the argument's \dQuote{long} name or an alias.
#' The type of the `arg_value` parameter must be compatible with the algorithm
#' argument type. Objects of class `GDALRaster` or `GDALVector` may be passed
#' for algorithm arguments that accept dataset object input. A list of
#' `GDALRaster` or `GDALVector` objects may be given for algorithm arguments of
#' type `DATASET_LIST` that accept object input. Generally, an input dataset can
#' also be specified by name as a character string (DSN), or character vector of
#' DSNs for a `DATASET_LIST`. Returns a logical value, `TRUE` indicating success
#' or `FALSE` if an error occurs.
#'
#' \code{$parseCommandLineArgs()}\cr
#' Sets the value of arguments previously specified in the class constructor,
#' and instantiates the actual algorithm that will be run (but without running
#' it). Returns a logical value, `TRUE` indicating success or `FALSE` if an
#' error occurs.
#'
#' \code{$getExplicitlySetArgs()}\cr
#' Returns a named list of arguments that have been set explicitly along with
#' their values. For arguments with dataset object values, the value of the list
#' element is a string of the form `"<TYPE dataset object: DSN>"` where `TYPE`
#' is one of `"raster"`, `"vector"` or `"multidim raster"` and `DSN` is the
#' dataset name (filename, URL, etc.).
#'
#' \code{$run()}\cr
#' Executes the algorithm, first parsing arguments if
#' \code{$parseCommandLineArgs()} has not already been called explicitly.
#' Returns a logical value, `TRUE` indicating success or `FALSE` if an error
#' occurs.
#'
#' \code{$output()}\cr
#' Returns the single output value of the algorithm, after it has been run.
#' If there are multiple output values, this method will raise an error, and
#' the \code{$outputs()} (plural) method should be called instead. The type of
#' the return value corresponds to the type of the single output argument value
#' (see method \code{$argInfo()} above).
#' If the output argument has type `"DATASET"`, an object of class `GDALRaster`
#' will be returned if the dataset is raster, or an object of class
#' `GDALVector` if the dataset is vector. In the latter case, by default the
#' `GDALVector` object will be opened on the first layer by index, but a
#' specific layer name may be specified by setting the value of the field
#' \code{$outputLayerNameForOpen} before calling the \code{$output()} method
#' (see above).
#' Note that currently, if the output dataset is multidimensional raster, only
#' the dataset name will be returned as a character string.
#'
#' \code{$outputs()}\cr
#' Returns the output value(s) of the algorithm as a named list, after it has
#' been run. Most algorithms only return a single output, in which case the
#' \code{$output()} method (singular) is preferable for easier use. The element
#' names in the returned list are the names of the arguments that have outputs
#' (with any dash characters replaced by underscore), and the values are the
#' argument values which may include `GDALRaster` or `GDALVector` objects.
#'
#' \code{$close()}\cr
#' Completes any pending actions, and returns the final status as a logical
#' value (`TRUE` if no errors occur during the underlying call to
#' `GDALAlgorithmFinalize()`). This is typically useful for algorithms that
#' generate an output dataset. It closes datasets and gets back potential error
#' status resulting from that, e.g., if an error occurs during flushing to disk
#' of the output dataset after successful \code{$run()} execution.
#'
#' \code{$release()}\cr
#' Release memory associated with the algorithm, potentially after attempting
#' to finalize. No return value, called for side-effects.
#'
#' @seealso
#' [gdal_alg()], [gdal_commands()], [gdal_run()], [gdal_usage()]
#'
#' Using `gdal` CLI algorithms from R\cr
#' \url{https://firelab.github.io/gdalraster/articles/use-gdal-cli-from-r.html}
#'
#' @examplesIf length(gdal_global_reg_names()) > 0
#' f <- system.file("extdata/storml_elev.tif", package="gdalraster")
#'
#' ## raster info
#' gdal_usage("raster info")
#'
#' # arguments given as character vector
#' args <- c("--format=text", "--no-md", f)
#' (alg <- new(GDALAlg, "raster info", args))
#'
#' alg$run()
#'
#' alg$output() |> writeLines()
#'
#' alg$release()
#'
#' ## raster clip
#' gdal_usage("raster clip")
#'
#' # arguments in list format
#' args <- list()
#' args$input <- f
#' f_clip <- file.path(tempdir(), "elev_clip.tif")
#' args$output <- f_clip
#' args$overwrite <- TRUE
#' args$bbox <- c(323776.1, 5102172.0,  327466.1, 5104782.0)
#'
#' (alg <- new(GDALAlg, "raster clip", args))
#'
#' alg$run()
#'
#' # get output as a GDALRaster object
#' (ds_clip <- alg$output())
#'
#' alg$release()
#'
#' ds_clip$dim()
#' ds_clip$bbox()
#'
#' ## raster hillshade
#' gdal_usage("raster hillshade")
#'
#' # input as a GDALRaster object and output to an in-memory raster
#' args <- list(input = ds_clip,
#'              output_format = "MEM",
#'              output = "")
#'
#' (alg <- new(GDALAlg, "raster hillshade", args))
#'
#' alg$run()
#'
#' (ds_hillshade <- alg$output())
#'
#' alg$release()
#'
#' plot_raster(ds_hillshade)
#'
#' ds_clip$close()
#' ds_hillshade$close()
#' deleteDataset(f_clip)
#'
#' ## vector convert shapefile to GeoPackage
#' gdal_usage("vector convert")
#'
#' f_shp <- system.file("extdata/poly_multipoly.shp", package="gdalraster")
#' f_gpkg <- file.path(tempdir(), "polygons_test.gpkg")
#' args <- c("--input", f_shp, "--output", f_gpkg, "--overwrite")
#'
#' (alg <- new(GDALAlg, "vector convert", args))
#'
#' alg$run()
#'
#' # output as a GDALVector object
#' (lyr <- alg$output())
#'
#' alg$release()
#'
#' lyr$info()
#'
#' lyr$close()
#' deleteDataset(f_gpkg)
#'
#' ## raster reproject (usage and info)
#' # no arguments given, only for retrieving usage and properties via API
#' # cf. gdal_usage("raster reproject")
#'
#' (alg <- new(GDALAlg, "raster reproject"))
#'
#' # print usage to the console, no return value
#' alg$usage()
#'
#' # or, get usage as a JSON string
#' # json <- alg$usageAsJSON()
#' # writeLines(json)
#'
#' # list of algorithm properties
#' alg$info()
#'
#' # list of properties for an algorithm argument
#' alg$argInfo("resampling")
#'
#' alg$release()
NULL

Rcpp::loadModule("mod_GDALAlg", TRUE)

#' Convenience functions for simple DEM derivatives
#'
#' Functions to calculate simple DEM derivatives, currently `northness()` and
#' `eastness()` for transforming aspect degrees into the range `-1:1`.
#'
#' @name dem_derivatives
#' @details
#'
#' `northness()` is a cosine transform of aspect degrees, with any flat aspect
#' values (`-1` if present) set to `90` degrees (east) as a neutral value:
#' ```
#' northness <- cos(asp_deg * pi / 180)
#' ```
#' 
#' `eastness()` is a sine transform of aspect degrees, with any flat aspect
#' values (`-1` if present) set to `0` degrees (north) as a neutral value:
#' ```
#' eastness <- sin(asp_deg * pi / 180)
#' ```
#'
#' @param asp_deg Numeric vector of aspect values in degrees (`0:360`).
#' @return
#' Numeric vector of transformed values.
#'
#' @note
#' No validation is done on the input values. The caller is responsible for
#' ensuring input has valid type and range.
#'
#' @seealso
#' [calc()], [dem_proc()]
#'
#' @examples
#' ## plot northness from slope-masked aspect for the Storm Lake AOI
#' f_dem <- system.file("extdata/storml_elev.tif", package="gdalraster")
#'
#' # slope degrees
#' f_slp <- basename(tempfile(pattern = "storml_slp", fileext = ".tif"))
#' f_slp <- file.path("/vsimem", f_slp)
#' dem_proc("slope", f_dem, f_slp)
#'
#' # aspect
#' f_asp <- basename(tempfile(pattern = "storml_asp", fileext = ".tif"))
#' f_asp <- file.path("/vsimem", f_asp)
#' dem_proc("aspect", f_dem, f_asp)
#'
#' # compute masked aspect as an in-memory raster
#' expr <- "ifelse(SLOPE >= 2, ASPECT, -9999)"
#' (ds_masked_asp <- calc(expr = expr,
#'                        rasterfiles = c(f_slp, f_asp),
#'                        var.names = c("SLOPE", "ASPECT"),
#'                        fmt = "MEM",
#'                        dtName = "Float64",
#'                        nodata_value = -9999,
#'                        setRasterNodataValue = TRUE,
#'                        return_obj = TRUE))
#'
#' # diverging palette for northness
#' # adapted from "heatmap3" in ltc-color-palettes
#' # https://github.com/loukesio/ltc-color-palettes
#' pal <- c("#d7191c", "#fdae61", "#ffffbf", "#abd9e9")
#'
#' plot_raster(ds_masked_asp, legend = TRUE, col_map_fn = pal,
#'             pixel_fn = northness, na_col = "#2c7bb6",
#'             main = "Storm Lake AOI northness")
#'
#' # clean up
#' ds_masked_asp$close()
#' deleteDataset(f_slp)
#' deleteDataset(f_asp)
#'
#' @export
northness <- function(asp_deg) {
    # transform aspect degrees to northness
    # set flat to east (90 degrees) for neutral value
    asp_deg[asp_deg == -1] <- 90
    cos(asp_deg * pi / 180)
}

#' @name dem_derivatives
#' @export
eastness <- function(asp_deg) {
    # transform aspect degrees to eastness
    # set flat to north (0 degrees) for neutral value
    asp_deg[asp_deg == -1] <- 0
    sin(asp_deg * pi / 180)
}

test_that("dem_derivatives work", {
    f_dem <- system.file("extdata/storml_elev.tif", package="gdalraster")

    f_asp <- basename(tempfile(pattern = "storml_asp", fileext = ".tif"))
    f_asp <- file.path("/vsimem", f_asp)
    on.exit(deleteDataset(f_asp), add = TRUE)
    dem_proc("aspect", f_dem, f_asp)

    ds_asp <- new(GDALRaster, f_asp)
    dm <- ds_asp$dim()

    # northness
    r <- ds_asp$read(1, 0, 0, dm[1], dm[2], dm[1], dm[2])
    expected <- r[r == -1] <- 90
    expected <- cos(r * pi / 180)
    expect_equal(northness(r), expected)
    expect_true(max(northness(r), na.rm = TRUE) <= 1)
    expect_true(min(northness(r), na.rm = TRUE) >= -1)

    # eastness
    r <- ds_asp$read(1, 0, 0, dm[1], dm[2], dm[1], dm[2])
    expected <- r[r == -1] <- 0
    expected <- sin(r * pi / 180)
    expect_equal(eastness(r), expected)
    expect_true(max(eastness(r), na.rm = TRUE) <= 1)
    expect_true(min(eastness(r), na.rm = TRUE) >= -1)

    ds_asp$close()
})

test_that("RunningStats works", {
    set.seed(42)
    rs <- new(RunningStats, na_rm=TRUE)
    expect_no_error(show(rs))
    chunk <- runif(1000)
    rs$update(chunk)
    expect_equal(rs$get_count(), length(chunk))
    expect_equal(rs$get_mean(), mean(chunk))
    expect_equal(rs$get_min(), min(chunk))
    expect_equal(rs$get_max(), max(chunk))
    expect_equal(rs$get_var(), var(chunk))
    expect_equal(rs$get_sd(), sd(chunk))
    chunk2 <- runif(1000)
    rs$update(chunk2)
    expect_equal(rs$get_count(), 2000)
    chunk3 <- (c(rep(NA, 10), runif(10)))
    rs$update(chunk3)
    expect_equal(rs$get_count(), 2010)
    expect_equal(rs$get_mean(), mean(c(chunk,chunk2,chunk3), na.rm=TRUE))
    rs$reset()
    expect_equal(rs$get_count(), 0)
    expect_equal(rs$get_sum(), 0)
    expect_true(is.na(rs$get_mean()))
    expect_true(is.na(rs$get_var()))
    expect_true(is.na(rs$get_sd()))
    expect_equal(rs$get_min(), Inf)
    expect_equal(rs$get_max(), -Inf)
})

test_that("plot.OGRFeature / plot.OGRFeatureSet work", {
    if (.Platform$OS.type == "unix" && !grepl("^darwin", R.version$os))
        skip_if_not(capabilities("X11"))

    # wk suggested package vctrs is required for wk::wk_plot()
    skip_if(!requireNamespace("vctrs", quietly = TRUE))

    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
    dsn <- file.path(tempfile(fileext = ".gpkg"))
    file.copy(f, dsn, overwrite = TRUE)

    lyr <- new(GDALVector, dsn, "mtbs_perims")
    on.exit(lyr$close())
    on.exit(unlink(dsn), add = TRUE)

    lyr$returnGeomAs <- "WKB"
    feat <- lyr$getNextFeature()
    expect_identical(plot(feat), feat)
    feat_set <- lyr$fetch(3)
    expect_identical(plot(feat_set), feat_set)

    lyr$returnGeomAs <- "WKB_ISO"
    feat <- lyr$getNextFeature()
    expect_identical(plot(feat), feat)
    feat_set <- lyr$fetch(3)
    expect_identical(plot(feat_set), feat_set)

    lyr$returnGeomAs <- "WKT"
    feat <- lyr$getNextFeature()
    expect_identical(plot(feat), feat)
    feat_set <- lyr$fetch(3)
    expect_identical(plot(feat_set), feat_set)

    lyr$returnGeomAs <- "WKT_ISO"
    feat <- lyr$getNextFeature()
    expect_identical(plot(feat), feat)
    feat_set <- lyr$fetch(3)
    expect_identical(plot(feat_set), feat_set)

    lyr$returnGeomAs <- "BBOX"
    feat <- lyr$getNextFeature()
    expect_identical(plot(feat), feat)
    feat_set <- lyr$fetch(3)
    expect_identical(plot(feat_set), feat_set)
})

test_that("print.OGRFeature / print.OGRFeatureSet work", {
    f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
    dsn <- file.path(tempfile(fileext = ".gpkg"))
    file.copy(f, dsn, overwrite = TRUE)
    lyr <- new(GDALVector, dsn, "mtbs_perims")

    lyr$returnGeomAs <- "WKB"
    feat <- lyr$getNextFeature()
    expect_identical(print(feat), feat)
    feat_set <- lyr$fetch(3)
    expect_identical(print(feat_set), feat_set)

    lyr$returnGeomAs <- "WKB_ISO"
    feat <- lyr$getNextFeature()
    expect_identical(print(feat), feat)
    feat_set <- lyr$fetch(3)
    expect_identical(print(feat_set), feat_set)

    lyr$returnGeomAs <- "WKT"
    feat <- lyr$getNextFeature()
    expect_identical(print(feat), feat)
    feat_set <- lyr$fetch(3)
    expect_identical(print(feat_set), feat_set)

    lyr$returnGeomAs <- "WKT_ISO"
    feat <- lyr$getNextFeature()
    expect_identical(print(feat), feat)
    feat_set <- lyr$fetch(3)
    expect_identical(print(feat_set), feat_set)

    lyr$returnGeomAs <- "BBOX"
    feat <- lyr$getNextFeature()
    expect_identical(print(feat), feat)
    feat_set <- lyr$fetch(3)
    expect_identical(print(feat_set), feat_set)

    lyr$returnGeomAs <- "NONE"
    feat <- lyr$getNextFeature()
    expect_identical(print(feat), feat)
    feat_set <- lyr$fetch(3)
    expect_identical(print(feat_set), feat_set)

    lyr$close()
    unlink(dsn)

    # GeoJSON with NULL geometries
    f <- system.file("extdata/test_ogr_geojson_mixed_timezone.geojson",
                     package = "gdalraster")
    lyr2 <- new(GDALVector, f, "test")

    feat <- lyr2$getNextFeature()
    expect_identical(print(feat), feat)
    feat_set <- lyr2$fetch(-1)
    expect_identical(print(feat_set), feat_set)

    lyr2$close()
})

test_that("CmbTable works", {
    m <- matrix(c(1,2,3,1,2,3,4,5,6,1,3,2,4,5,6,1,1,1), 6, 3, byrow=TRUE)
    colnames(m) <- c("v1","v2","v3")
    cmb <- new(CmbTable, 3, colnames(m))
    expect_no_error(show(cmb))
    cmb$updateFromMatrixByRow(m, 1)
    cmb$update(c(4,5,6), 1)
    cmb$update(c(1,3,5), 1)
    df <- cmb$asDataFrame()
    expect_equal(nrow(df), 5)
    expect_equal(sum(df$count), 8)
    expect_equal(as.matrix(df), cmb$asMatrix())
    expect_equal(sum(cmb$asMatrix()), 62)
})

---
title: "GDAL Config Quick Reference"
output:
  rmarkdown::html_vignette:
    toc: true
vignette: >
  %\VignetteIndexEntry{GDAL Config Quick Reference}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

## Overview

Configuration options are essentially global variables the user can set. They are used to alter the default behavior of certain raster format drivers, and in some cases the GDAL core. A large number of configuration options are available. An overall discussion along with full list of available options and where they apply is in the GDAL documentation at https://gdal.org/en/stable/user/configoptions.html.

This quick reference covers a small subset of configuration options that may be useful in common scenarios, with links to topic-specific documentation provided by the GDAL project. Options can be set from R with `gdalraster::set_config_option()`. Note that specific usage is context dependent. Passing `value = ""` (empty string) will unset a value previously set by `set_config_option()`:

```{r}
library(gdalraster)

set_config_option("GDAL_NUM_THREADS", "ALL_CPUS")
# unset:
set_config_option("GDAL_NUM_THREADS", "")
```

## General options

GDAL doc: https://gdal.org/en/stable/user/configoptions.html#general-options

**`GDAL_RASTERIO_RESAMPLING`**

The `$read()` method of a `GDALRaster` object will perform automatic resampling if the specified output size (`out_xsize * out_ysize`) is different than the size of the source region being read (`xsize * ysize`). In that case, resampling can be configured to override the default `NEAR` to one of `BILINEAR`, `CUBIC`, `CUBICSPLINE`, `LANCZOS`, `AVERAGE`, `MODE`, `RMS`, or `GAUSS`:

```r
# bilinear interpolation (2x2 neighborhood of pixels)
set_config_option("GDAL_RASTERIO_RESAMPLING", "BILINEAR")
```

**`CPL_TMPDIR`**

By default, temporary files are written into the current working directory. This can be changed with:

```r
set_config_option("CPL_TMPDIR", "<dirname>")  # tmpdir to use
```

## Performance and caching

GDAL doc: https://gdal.org/en/stable/user/configoptions.html#performance-and-caching

**`GDAL_NUM_THREADS`**

Sets the number of worker threads to be used by GDAL operations that support multithreading. This affects several different parts of GDAL including multi-threaded compression for GeoTiff and SOZip, and multithreaded computation during `warp()` (see topics below).

**`GDAL_CACHEMAX`**

The size limit of the block cache is set upon first use (first I/O). Setting `GDAL_CACHEMAX` after that point will not resize the cache. It is a per-session setting. If `GDAL_CACHEMAX` has not been set upon first use of the cache, then the default cache size (`5%` of physical RAM) will be in effect for the current session. `gdalraster::set_cache_max()` can be used to change the value programmatically during operation of the program. See also [GDAL Block Cache](https://firelab.github.io/gdalraster/articles/gdal-block-cache.html).

```r
# set to a specific size in MB
set_config_option("GDAL_CACHEMAX", "800")

# or percent of physical RAM
set_config_option("GDAL_CACHEMAX", "10%")
```

**`GDAL_MAX_DATASET_POOL_SIZE`**

The default number of datasets that can be opened simultaneously by the `GDALProxyPool` mechanism (used by VRT for example) is `100`. This can be increased to get better random I/O performance with VRT mosaics made of numerous underlying raster files. Note: on Linux systems, the number of file handles that can be opened by a process is generally limited to `1024`. This is currently clamped between `2` and `1000`. Also note that [`gdalwarp` increases the pool size to `450`](https://gdal.org/en/stable/drivers/raster/vrt.html#performance-considerations):

```r
# default is 100
set_config_option("GDAL_MAX_DATASET_POOL_SIZE", "450")
```

**`PG_USE_COPY`**

This configures PostgreSQL/PostGIS to use `COPY` for inserting data which is significantly faster than `INSERT`. This can increase performance substantially when using `gdalraster::polygonize()` to write polygons to PostGIS vector. See also [GDAL configuration options for PostgreSQL](https://gdal.org/en/stable/drivers/vector/pg.html#configuration-options).

```r
# use COPY for inserting to PostGIS
set_config_option("PG_USE_COPY", "YES")
```

**`SQLITE_USE_OGR_VFS`**

For the SQLite-based formats GeoPackage (.gpkg) and Spatialite (.sqlite), setting `SQLITE_USE_OGR_VFS` enables extra buffering/caching by the GDAL/OGR I/O layer and can speed up I/O. Be aware that no file locking will occur if this option is activated, so concurrent edits may lead to database corruption. This setting may increase performance substantially when using `gdalraster::polygonize()` to write polygons to a vector layer in these formats. Additional configuration and performance hints for SQLite databases are in the driver documentation at: https://gdal.org/en/stable/drivers/vector/sqlite.html#configuration-options.

```r
# SQLite: GPKG (.gpkg) and Spatialite (.sqlite)
# enable extra buffering/caching by the GDAL/OGR I/O layer
set_config_option("SQLITE_USE_OGR_VFS", "YES")
```

**`OGR_SQLITE_JOURNAL`**

SQLite is a transactional DBMS. When many `INSERT` statements are executed in close sequence, application code may group them into large batches within transactions in order to get optimal performance. By default, if no transaction is explicitly started, SQLite will autocommit on every statement which will be slow.

The `OGR_SQLITE_JOURNAL` option configures operation of the rollback journal that implements transactions in SQLite. The [SQLite documentation](https://www.sqlite.org/pragma.html#pragma_journal_mode) describes the default operation:

> The DELETE journaling mode is the normal behavior. In the DELETE mode, the rollback journal is deleted at the conclusion of each transaction. Indeed, the delete operation is the action that causes the transaction to commit.

The `DELETE` mode requires file system I/O so performance is degraded if many `INSERT`s are autocommitted individually. Using `MEMORY` journaling mode (or even `OFF`) can be much faster in this case:

> The MEMORY journaling mode stores the rollback journal in volatile RAM. This saves disk I/O but at the expense of database safety and integrity. If the application using SQLite crashes in the middle of a transaction when the MEMORY journaling mode is set, then the database file will very likely go corrupt.

See the SQLite documentation for all available [journal modes](https://www.sqlite.org/pragma.html#pragma_journal_mode). This setting also applies when using `gdalraster::polygonize()` to write polygons to a vector layer in GeoPackage (.gpkg) or Spatialite (.sqlite) formats (see `SQLITE_USE_OGR_VFS` above).

```r
# configure SQLite to store the rollback journal in RAM
set_config_option("OGR_SQLITE_JOURNAL", "MEMORY")
```

## Networking

GDAL doc: https://gdal.org/en/stable/user/configoptions.html#networking-options

**`CPL_VSIL_USE_TEMP_FILE_FOR_RANDOM_WRITE`**

Whether to use a local temporary file to support random writes in certain virtual file systems. The temporary file will be located in `CPL_TMPDIR` (see above).

```r
# YES|NO to use a temp file
set_config_option("CPL_VSIL_USE_TEMP_FILE_FOR_RANDOM_WRITE", "YES")
```

## PROJ

GDAL doc: https://gdal.org/en/stable/user/configoptions.html#proj-options

**`OSR_DEFAULT_AXIS_MAPPING_STRATEGY`**

This option can be set to either `TRADITIONAL_GIS_ORDER` or `AUTHORITY_COMPLIANT`. GDAL >= 3.5 defaults to `AUTHORITY_COMPLIANT`. Determines whether to honor the declared axis mapping of a CRS or override it with the traditional GIS ordering (x = longitude, y = latitude).

**`OSR_WKT_FORMAT`**

As of GDAL 3.0, the default format for exporting a spatial reference definition to Well Known Text is WKT 1. This can be overridden with:

```r
# SFSQL/WKT1_SIMPLE/WKT1/WKT1_GDAL/WKT1_ESRI/WKT2_2015/WKT2_2018/WKT2/DEFAULT
set_config_option("OSR_WKT_FORMAT", "WKT2")
```

## Warp

GDAL doc: https://gdal.org/en/stable/programs/gdalwarp.html#memory-usage

The [performance and caching](#performance-and-caching) topic above generally applies to processing with `gdalraster::warp()` (reproject/resample/crop/mosaic).

**`GDAL_NUM_THREADS`**

Multithreaded computation in `warp()` can be enabled with:

```r
# note this also affects several other parts of GDAL
set_config_option("GDAL_NUM_THREADS", "4")  # number of threads or ALL_CPUS
```

Increasing the memory available to `warp()` may also increase performance (i.e., the options passed in `cl_arg` include a value like `c("-wm", "1000")`). The warp memory specified by `"-wm"` is shared among all threads. It is especially beneficial to increase this value when running `warp()` with multithreading enabled.

Multithreading could also be enabled by including a GDAL warp option in `cl_arg` with `c("-wo", "NUM_THREADS=<value>")` greater than 1, which is equivalent to setting the `GDAL_NUM_THREADS` configuration option as shown above.

This option can be combined with the [`-multi` command-line argument](https://gdal.org/en/stable/programs/gdalwarp.html#cmdoption-gdalwarp-multi) passed to `warp()` in `cl_arg`. With `-multi`, two threads will be used to process chunks of the raster and perform input/output operation simultaneously, whereas the `GDAL_NUM_THREADS` configuration option affects computation separately.

**`GDAL_CACHEMAX`**

Increasing the size of the I/O block cache may also help. This can be done by setting `GDAL_CACHEMAX` as described in the [performance and caching](#performance-and-caching) topic above.

## GeoTIFF

GDAL doc: https://gdal.org/en/stable/drivers/raster/gtiff.html#configuration-options

The behavior of the GTiff driver is highly configurable, including with respect to overview creation. For full discussion, see the link above and also the documentation for the [`gdaladdo`](https://gdal.org/en/stable/programs/gdaladdo.html) command-line utility.

**`GDAL_NUM_THREADS`**

The GTiff driver supports multi-threaded compression (default is compression in the main thread). GDAL documentation states that it is worth it for slow compression algorithms such as `DEFLATE` or `LZMA`. Starting with GDAL 3.6, this option also enables multi-threaded decoding when read requests intersect several tiles/strips:

```r
# specify the number of worker threads or ALL_CPUS
# note this also affects several other parts of GDAL
set_config_option("GDAL_NUM_THREADS", "ALL_CPUS")
```

**`COMPRESS_OVERVIEW`**

Raster overviews (a.k.a. pyramids) can be built with the `$buildOverviews()` method of a `GDALRaster` object. It may be desirable to compress the overviews when building:

```r
# applies to external overviews (.ovr), and internal overviews if GDAL >= 3.6
# LZW is a good default but several other compression algorithms are available
set_config_option("COMPRESS_OVERVIEW", "LZW")
```

**`PREDICTOR_OVERVIEW`**

Sets the predictor to use for overviews with `LZW`, `DEFLATE` and `ZSTD` compression. The default is `1` (no predictor), `2` is horizontal differencing and `3` is floating point prediction. `PREDICTOR=2` is only supported for 8, 16, 32 and 64 bit samples (support for 64 bit was added in libtiff > 4.3.0). `PREDICTOR=3` is only supported for 16, 32 and 64 bit floating-point data.

```r
# horizontal differencing
set_config_option("PREDICTOR_OVERVIEW", "2")
```

## HTTP/HTTPS

GDAL doc: [/vsicurl/](https://gdal.org/en/stable/user/configoptions.html#networking-options) (HTTP/HTTPS random access)

**`GDAL_HTTP_CONNECTTIMEOUT`**

Maximum delay for connection to be established before being aborted.

```r
# max delay for connection establishment in seconds
set_config_option("GDAL_HTTP_CONNECTTIMEOUT", "<seconds>")
```

**`GDAL_HTTP_TIMEOUT`**

Maximum delay for the whole request to complete before being aborted.

```r
# max delay for whole request completion in seconds
set_config_option("GDAL_HTTP_TIMEOUT", "<seconds>")
```

**`CPL_VSIL_CURL_CHUNK_SIZE`**

Partial downloads (requires the HTTP server to support random reading) are done with a 16 KB granularity by default. The chunk size can be configured with this option.

If the driver detects sequential reading, it will progressively increase the chunk size up to 128 times `CPL_VSIL_CURL_CHUNK_SIZE` (so 2 MB by default) to improve download performance. When increasing the value of `CPL_VSIL_CURL_CHUNK_SIZE` to optimize sequential reading, it is recommended to increase `CPL_VSIL_CURL_CACHE_SIZE` as well to 128 times the value of `CPL_VSIL_CURL_CHUNK_SIZE`.

```r
# chunk size in bytes
set_config_option("CPL_VSIL_CURL_CHUNK_SIZE", "<bytes>")
```

**`CPL_VSIL_CURL_CACHE_SIZE`**

A global least-recently-used cache of 16 MB shared among all downloaded content is used, and content in it may be reused after a file handle has been closed and reopen, during the life-time of the process or until `vsi_curl_clear_cache()` is called. The size of this global LRU cache can be modified with:

```r
# size in bytes defaults to 16 MB
set_config_option("CPL_VSIL_CURL_CACHE_SIZE", "<bytes>")
```

## AWS S3 buckets

GDAL doc: [/vsis3/](https://gdal.org/en/stable/user/virtual_file_systems.html#vsis3-aws-s3-files) (AWS S3 file system handler)

**`AWS_NO_SIGN_REQUEST`**

Request signing can be disabled for public buckets that do not require an AWS account:

```r
# public bucket no AWS account required
set_config_option("AWS_NO_SIGN_REQUEST", "YES")
```

**`AWS_ACCESS_KEY_ID`**  
**`AWS_SECRET_ACCESS_KEY`** 
**`AWS_SESSION_TOKEN`**  
**`AWS_REQUEST_PAYER`**  

If authentication is required, configure credentials with:

```r
set_config_option("AWS_ACCESS_KEY_ID", "<value>")  # key ID
set_config_option("AWS_SECRET_ACCESS_KEY", "<value>")  # secret access key
# used for validation if using temporary credentials:
set_config_option("AWS_SESSION_TOKEN", "<value>")  # session token
# if requester pays:
set_config_option("AWS_REQUEST_PAYER", "<value>")  # requester
```

**`AWS_REGION`**

Sets the AWS region to which requests should be sent. Defaults to `us-east-1`.

```r
# specify region
set_config_option("AWS_REGION", "us-west-2")
```

## Google Cloud Storage

GDAL doc: [/vsigs/](https://gdal.org/en/stable/user/virtual_file_systems.html#vsigs-google-cloud-storage-files) (Google Cloud Storage files)

## Microsoft Azure Blob

GDAL doc: [/vsiaz/](https://gdal.org/en/stable/user/virtual_file_systems.html#vsiaz-microsoft-azure-blob-files) (Microsoft Azure Blob files)

Recognized filenames are of the form `/vsiaz/container/key`, where `container` is the name of the container and `key` is the object "key", i.e. a filename potentially containing subdirectories.

**`AZURE_NO_SIGN_REQUEST`**

Controls whether requests are signed.

```r
# public access
set_config_option("AZURE_NO_SIGN_REQUEST", "YES")
```

**`AZURE_STORAGE_CONNECTION_STRING`**

Credential string provided in the Access Keys section of the administrative interface, containing both the account name and a secret key.

```r
set_config_option("AZURE_STORAGE_CONNECTION_STRING", "<my_connection_string>")
```

**`AZURE_STORAGE_ACCOUNT`**  
**`AZURE_STORAGE_ACCESS_TOKEN`**  
**`AZURE_STORAGE_ACCESS_KEY`**  
**`AZURE_STORAGE_SAS_TOKEN`**  

Whereas an Azure connection string contains both the account name and key, the storage account name might be set using `AZURE_STORAGE_ACCOUNT` along with one of:

* `AZURE_STORAGE_ACCESS_TOKEN`: value obtained using Microsoft Authentication Library (MSAL)
* `AZURE_STORAGE_ACCESS_KEY`: value is the secret key associated with `AZURE_STORAGE_ACCOUNT`
* `AZURE_STORAGE_SAS_TOKEN`: value is a Shared Access Signature
* `AZURE_NO_SIGN_REQUEST=YES` to disable request signing

The `AZURE_STORAGE_SAS_TOKEN` is used, for example, with Microsoft Planetary Computer as documented at:
https://planetarycomputer.microsoft.com/docs/concepts/sas/

SAS token can be requested via API with the `token` endpoint:
`https://planetarycomputer.microsoft.com/api/sas/v1/token/{collection_id}`
or
`https://planetarycomputer.microsoft.com/api/sas/v1/token/{storage_account}/{container}`

```r
# e.g., Planetary Computer access to STAC items as geoparquet datasets
# https://planetarycomputer.microsoft.com/docs/quickstarts/stac-geoparquet/
set_config_option("AZURE_STORAGE_ACCOUNT", "pcstacitems")
# SAS token is the value of "token" in the JSON returned by:
# https://planetarycomputer.microsoft.com/api/sas/v1/token/pcstacitems/items
set_config_option("AZURE_STORAGE_SAS_TOKEN", "<token>")
```

Other authentication methods are possible for Azure. See the GDAL documentation for details.

## Microsoft Azure Data Lake

GDAL doc: [/vsiadls/](https://gdal.org/en/stable/user/virtual_file_systems.html#vsiadls-microsoft-azure-data-lake-storage-gen2) (Microsoft Azure Data Lake Storage Gen2)

## SOZip

GDAL doc: [/vsizip/](https://gdal.org/en/stable/user/virtual_file_systems.html#vsizip-zip-archives) (Seek-Optimized ZIP files, GDAL >= 3.7)

The function `gdalraster::addFilesInZip()` can be used to create new or append to existing ZIP files, potentially using the seek optimization extension. Function arguments are available for the options below, or the configuration options can be set to change the default behavior.

**`GDAL_NUM_THREADS`**

The `GDAL_NUM_THREADS` configuration option can be set to `ALL_CPUS` or an integer value to specify the number of threads to use for SOZip-compressed files. This option is similarly described above for compression in [GeoTiff](#geotiff). Note that this option also affects several other parts of GDAL.

**`CPL_SOZIP_ENABLED`**

Defaults to `AUTO`. Determines whether the SOZip optimization should be enabled. If `AUTO`, SOZip will be enabled for uncompressed files larger than `CPL_SOZIP_MIN_FILE_SIZE`.

```r
# SOZip optimization defaults to AUTO
set_config_option("CPL_SOZIP_ENABLED", "YES")
```

**`CPL_SOZIP_MIN_FILE_SIZE`**

Defaults to `1M`. Determines the minimum file size for SOZip to be automatically enabled. Specified in bytes, or `K`, `M` or `G` suffix can be used respectively to specify a value in kilobytes, megabytes or gigabytes.

```r
# SOZip minimum file size
set_config_option("CPL_SOZIP_MIN_FILE_SIZE", "100K")
```

---
title: "Vector API Overview"
output:
  rmarkdown::html_vignette:
    toc: true
    toc_depth: 4
    fig_width: 7
    fig_height: 5
    fig_caption: true
vignette: >
  %\VignetteIndexEntry{Vector API Overview}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

library(gdalraster)
gdal_3_6_0_min <- (gdal_version_num() >= gdal_compute_version(3, 6, 0))
gdal_3_7_0_min <- (gdal_version_num() >= gdal_compute_version(3, 7, 0))
```

## Background

Beginning at version 2.0, **gdalraster** includes bindings to a substantial subset of the GDAL Vector API. The vector bindings provide an R implementation of the [GDAL Vector Data Model](https://gdal.org/en/stable/user/vector_data_model.html). Readers are encouraged to review that document for background on the underlying object model and how it relates to usage of the API in **gdalraster**.

The prefix [OGR](https://gdal.org/en/stable/faq.html#what-is-this-ogr-stuff) is used in GDAL with class names, command-line utilities, etc., that refer to vector-specific components of the library. In **gdalraster**, "ogr" will be used throughout the documentation and as a prefix on function names, consistent with the style of the source library. There is also a certain amount of unification of the raster and vector APIs in GDAL. In **gdalraster**, we will also refer to the "GDAL Vector API" and use `GDALVector` as a class name. To support the vector API, **gdalraster** 2.0 builds on its already existing bindings to portions of GDAL's Spatial Reference System and Geometry APIs.

## Rationale

As an implementation of GDAL's Raster and Vector Data Models, **gdalraster** is not intended as a direct alternative to existing R packages such as **sf** and **terra** that primarily implement higher-level analytical data models. **gdalraster** is primarily focused on API-level bindings, attempting to expose most of the underlying C++ library in R. More direct access to GDAL's I/O capabilities may benefit workflows that deal with source data provided on a continuum ranging from local storage and in-memory formats to database servers and cloud systems, often involving various compression formats, SQL dialects, etc. Modularized, low-level access to GDAL/OGR functionality should be of interest to R developers creating higher-level interfaces, where the analytical data models may not have been designed with their use cases in mind. API bindings facilitate code translation and reuse which can benefit hybrid environments where GDAL is used from multiple languages. Long-term stability of bindings at the library level is desirable in production scenarios, and is a major goal for the package. It is intended that **gdalraster** should complement and interoperate within R's extensive and evolving spatial ecosystem.

## Vector API components

This section describes the organization of the vector components in **gdalraster**, linking to package documentation for extended text on specific topics.

### Core bindings

Core functionality for vector is provided by the exposed C++ class `GDALVector`, along with a set of stand-along functions with `ogr_` prefix.

#### Class `GDALVector`

`GDALVector` is a C++ class exposed in R via [**Rcpp** modules](https://CRAN.R-project.org/package=Rcpp). It encapsulates a single OGRLayer and the GDALDataset that contains it. An object of class `GDALVector` persists an open connection to the dataset, and exposes methods to:

* retrieve layer information
* set attribute and spatial filters
* set ignored fields/selected fields
* traverse and read feature data by traditional row-based cursor
* fetch the full feature set and return as a data frame
* fetch progressively in batches of `n` features at a time
* read via column-oriented ArrowArrayStream
* write new features in a layer
* upsert
* edit/overwrite existing features
* delete
* perform operations within transactions

A `GDALVector` object is typically generated with a call to `new()` but is also returned from certain `ogr_*()` functions. The documentation for `?GDALVector` gives a full list of available methods in the Usage section, along with their descriptions under Details. Methods of the class are accessed using the `$` operator.

#### OGR stand-alone functions

Several of the stand-alone `ogr_*()` functions are grouped under the documentation topics `?ogr_manage` and `?ogr_define`. The `ogr_manage` functions can be used to:

* create new vector datasets from scratch
* test for existence of datasets, layers and fields
* test dataset and layer capabilities
* create new layers in an existing dataset
* delete layers
* create new attribute and geometry fields on an existing layer
* rename and delete fields
* read and write field domains
* edit data with SQL statements

`ogr_define` provides documentation and helper functions for defining feature classes. An OGR feature class definition (a.k.a. layer definition) is modeled in R as a named list containing zero or more attribute field definitions, along with one or more geometry field definitions. Specifications of the the list structures for these definitions are given in `?ogr_define`. The associated helper functions make it easy to create new layer definitions from scratch or modify an existing definition. A layer definition is convenient but not required for creating a new vector dataset, or a new layer within an existing dataset, using `ogr_ds_create()` / `ogr_layer_create()`.

OGR facilities for vector geoprocessing are available in `ogr_proc()`. This function can perform the following GIS overlay operations: Intersection, Union, SymDifference, Identity, Update, Clip and Erase (https://en.wikipedia.org/wiki/Vector_overlay). `ogr_proc()` is basically an R port of the command-line utility [`ogr_layer_algebra`](https://gdal.org/en/stable/programs/ogr_layer_algebra.html#ogr-layer-algebra) included in the GDAL Python bindings. In both cases, these are interfaces to library functions in the OGR C++ API.

`ogrinfo()` and `ogr2ogr()`, provide R wrappers of the GDAL command-line utilities [`ogrinfo`](https://gdal.org/en/stable/programs/ogrinfo.html) and [`ogr2ogr`](https://gdal.org/en/stable/programs/ogr2ogr.html). These functions support all of the command-line arguments described in the GDAL documentation, providing a powerful set of capabilities for obtaining information about an OGR-supported data source, converting vector data between file formats, and potentially editing data with SQL statements. `ogr_reproject()` is a convenience wrapper around `ogr2ogr()` for reprojecting vector layers with a user friendly interface.

### Supporting APIs

#### Spatial Reference Systems

Bindings to a subset of GDAL's Spatial Reference System API are provided by a set of stand-alone `srs_*()` functions. These support conversion of spatial reference definitions in various formats to OGC Well Known Text (WKT) representation (e.g., from EPSG codes, well known names such as NAD27, NAD83, WGS84, etc., PROJ.4 definitions, PROJJSON, and others, as well as between different versions of OGC WKT, see `?srs_convert`). Functions under the `?srs_query` topic provide various information about a given SRS definition, and support testing definitions for equality.

#### Geometry

Bindings to a significant subset of GDAL's Geometry API are implemented in a set of functions prefixed `g_*()`. Many of these functions are built on the [GEOS library](https://libgeos.org/) (i.e., use GEOS via GDAL headers).

The geometry functions offer flexibility by allowing input geometries to be given as either a single [WKT string](https://libgeos.org/specifications/wkt/), a character vector of WKT strings, a single `raw` vector containing [WKB](https://libgeos.org/specifications/wkb/), or a list of WKB `raw` vectors. Output geometries are in WKB format by default, but WKT can also be requested. The convenience function `g_wk2wk()` will convert its input from one to the other accordingly.

The factory functions `g_create()` and `g_add_geom()` support creating basic geometry types from point data (vertices), and building container geometry types from sub-geometries. Other capabilities of the geometry bindings include:

* inspection (see `?g_query`)
* binary predicates (see `?g_binary_pred`)
* binary operations (see `?g_binary_op`)
* unary operations (see `g_unary_op`)
* measurements (see `?g_measures`)
* miscellaneous utilities (e.g., `g_coords()`, `g_make_valid()`, `g_transform()`)

Convenience functions for working with bounding boxes are also provided (e.g., convert to/from WKT, intersection/union, and `bbox_transform()`).

#### Virtual Systems Interface

Bindings to the GDAL's Virtual Systems Interface (VSI) implement standard file system operations abstracted for URLs, cloud storage services, Zip/GZip/7z/RAR, in-memory files, as well as "regular" local file systems. This provides a single interface for operating on file system objects, that works the same for any storage backend. The `vsi_*()` functions have general utility not limited to operating on spatial data sources.

Class `VSIFile` implements bindings to the GDAL VSIVirtualHandle API, providing analogs of Standard C file I/O functions that operate on VSI file systems (`seek()`, `tell()`, `read()`, `write()`, etc.)

#### General data management

Existing data management functions that operate on both raster and vector data sources include `addFilesInZip()` (supporting create/append to a potentially [Seek-Optimized ZIP](https://github.com/sozip/sozip-spec) file), `deleteDataset()`, `identifyDriver()` and `inspectDataset()`.

## Workflow considerations

Creation of new vector datasets, and schema modification in existing datasets, are performed with the `ogr_*()` stand-alone functions. These are "one-off" operations that attempt to open the dataset with update access, perform modifications, and then close the dataset.

Objects of class `GDALVector` are used for obtaining layer information and reading/writing feature data. A `GDALVector` object provides a persistent connection to a layer and the vector dataset that contains it. That is, once instantiated, a `GDALVector` object represents a live connection to the dataset until its `$close()` method is called. The connection may be read-only (by default), or may be with update access allowing insert of new features, modifying exiting features and deleting features. Currently, class `GDALVector` does not provide methods for modifying the layer schema.

It is not recommended to instantiate a new `GDALVector` object on a layer that is already open for update access (i.e., with `read_only = FALSE`). Likewise, potential modifications to a layer schema using the `ogr_*()` management functions should be done prior to instantiating a `GDALVector` object on the layer. 

Relational database management systems (RDBMSs, e.g., GPKG / SQLite, PostgreSQL / PostGIS) generally support multiple connections including concurrent reads (e.g., multiple instances of `GDALVector` reading from different layers). It is also possible to have one or more `GDALVector` objects instantiated on RDBMS-based layers for read access, while another `GDALVector` object performs write operations on a different layer in the same database. Database locking mechanisms for write operations are specific to the driver and underlying RDBMS (see, e.g., SQLite [Configuration Options](https://gdal.org/en/stable/drivers/vector/sqlite.html#configuration-options) and [Performance Hints](https://gdal.org/en/stable/drivers/vector/sqlite.html#performance-hints)).

### Data retrieval

A `GDALVector` object supports traditional [cursor-based](https://en.wikipedia.org/wiki/Cursor_(databases)) traversal over the features (rows) in a layer, and optionally, column-oriented retrieval via [Apache Arrow C stream interface](https://arrow.apache.org/docs/format/CStreamInterface.html) (with GDAL >= 3.6). Data retrieval may be performed against a vector layer in full, a layer with attribute and/or spatial filters applied, or a layer defined as the result set of an SQL statement executed on the underlying data source.

OGR methods that retrieve a single feature (i.e., `$getFeature()`, `$getNextFeature()`) return data in a named list of fields and their values. `GDALVector` also provides the `$fetch()` method to retrieve a batch of `n` features from the current cursor position and return them in a data frame. The `$fetch()` method is an analog of [`DBI::dbFetch()`](https://dbi.r-dbi.org/reference/dbFetch.html) with essentially identical calling semantics. Specifying `n = -1` or `n = Inf` will retrieve all features from the beginning (honoring any spatial or attribute filters that may be in effect).

Currently, **gdalraster** implements only minimal S3 class interfaces for R objects containing the returned feature data. A single feature as returned by `$getFeature()`/`$getNextFeature()` is a list object carrying the `"OGRFeature"` class attribute. A data frame returned by `$fetch()` carries the `"OGRFeatureSet"` class attribute. S3 methods are provided for the `print()` and `plot()` generics as a convenience for examining output. Otherwise, there are currently no S3 classes for geometries or geometry columns, no concept of "sticky" geometry as implemented in package **sf**, and no automatic propagation of coordinate reference systems. S3 interfaces may expand in future versions, but **gdalraster** leans toward minimalism and the use of simple, lightweight objects for holding raw data.

### Interoperability 

The `$fetch()` method of a `GDALVector` object returns geometries in a list column of WKB raw vectors by default. The Geometry API functions (`g_*()`) also operate by default on lists of WKB raw vectors. Representation of geometries as WKB is compact and performant, and seamlessly integrates with the parsing, conversion, manipulation and plotting functions in [package **wk**](https://paleolimbot.github.io/wk/) (a **gdalraster** dependency for vector plotting).

The `$getArrowStream()` method of a `GDALVector` object allows retrieving data in a column-oriented memory format. It exposes an ArrowArrayStream on a layer as a `nanoarrow_array_stream` object. The [**nanoarrow** package](https://arrow.apache.org/nanoarrow/latest/getting-started/r.html) provides functionality to consume the array stream and import to R data structures (which are generally column oriented). **nanoarrow** provides helpers to facilitate zero-copy data transfer among R bindings to libraries implementing the Arrow C data interface. It is possible to pass **nanoarrow** objects to many functions in the **arrow** package. **nanoarrow** objects also integrate with the extension types implemented in the **geoarrow** package.

A data frame returned by the `$fetch()` method of a `GDALVector` object (i.e., an `"OGRFeatureSet"`) can be converted to an **sf** data frame with `sf::st_sf()`. A value for the `crs` argument can be obtained from method `$getSpatialRef()` of the `GDALVector` object from which the data were read (assuming no subsequent transformation of geometries has been performed).

## Data type specifications

OGR field types are returned as the following R data types. R currently lacks a native 64-bit integer type. Support for 64-bit integer values in R is provided by the [**bit64** package](https://CRAN.R-project.org/package=bit64) (represented as `numeric` values carrying the `"integer64"` class attribute). OGR NULL values are returned as type-specific `NA` (i.e., `NA`, `NA_integer_`, `NA_integer64_`, `NA_real_`, `NA_character_`). When retrieving a batch of features as a data frame (`"OGRFeatureSet"`), some field types will be contained in a data frame list column as indicated:

* **OFTInteger**: `integer` value
* **OFTInteger subtype OFSTBoolean**: `logical` value
* **OFTIntegerList**: vector of `integer` (list column)
* **OFTInteger64**: `numeric` value carrying the `"integer64"` class attribute
* **OFTInteger64 subtype OFSTBoolean**: `logical` value
* **OFTInteger64List**: vector of `bit64::integer64` (list column)
* **OFTReal**: `numeric` value
* **OFTRealList**: vector of `numeric` (list column)
* **OFTString**: `character` string
* **OFTStringList**: vector of `character` strings (list column)
* **OFTDate**: `numeric` value of class `"Date"`
* **OFTDateTime**: `numeric` value of class `"POSIXct"` (millisecond accuracy)
* **OFTTime**: `character` string (`"HH:MM:SS"`)
* **OFTBinary**: `raw` vector (list column, `NULL` entries for OGR NULL values)

By default, geometries are returned as WKB `raw` vectors in a data frame list column (with `NULL` entries for OGR NULL geometries). The per-object setting `$returnGeomAs` can also be set to one of `"WKB_ISO"`, `"WKT"`, `"WKT_ISO"`, or `"NONE"`. Omitting the geometries (e.g., by setting `lyr$returnGeomAs <- "NONE"`) may be beneficial for performance and memory usage when access only to feature attributes is required.

For more information on 64-bit integer support using the **bit64** package, see `?bit64::integer64` or the web version at <https://bit64.r-lib.org/reference/bit64-package.html>.

## Code examples

Parentheses around statements are used throughout the examples only as a shortcut to display the assigned values. The `system.file()` command is only used to obtain the path to the package sample files; it would not be needed in typical usage.

### Inspect data sources

Data sources can be files, relational database management systems, directories of many files, or even remote web services depending on the format driver being used. However, the data source name (DSN) is always a single string which might be the file path, database connection string, URL, etc.

The following examples use a GeoPackage file included in **gdalraster**. The file ynp_features.gpkg is compressed using SOZip and will be read directly from the .zip archive without decompressing first. A prefix is added to the file path ([/vsizip/](https://gdal.org/en/stable/user/virtual_file_systems.html#vsizip-zip-archives) in this case) which specifies a GDAL Virtual File System handler. A file system handler provides access to less standard file types such as in-memory, compressed (.zip, .gz, .tar, .tar.gz), encrypted, standard input and output (STDIN, STDOUT), files stored on network (publicly accessible, or in private buckets of commercial cloud services), etc.

```{r}
library(gdalraster)

# get path to the Yellowstone National Park sample dataset
f <- system.file("extdata/ynp_features.zip", package = "gdalraster")

# add the VSI prefix 
(zf <- file.path("/vsizip", f))

# list files in the zip archive
vsi_read_dir(zf)

# VSI path to the GPKG file
(zf_gpkg <- file.path(zf, "ynp_features.gpkg"))
```

```{r, include = FALSE}
# workaround for GDAL < 3.11.4:
#   https://github.com/OSGeo/gdal/issues/12934
#   GPKG driver: fix random crash in GetNextArrowArrayAsynchronous()
ogr_arrow_opt <- get_config_option("OGR2OGR_USE_ARROW_API")
set_config_option("OGR2OGR_USE_ARROW_API", "NO")
gpkg_stream_base_opt <- get_config_option("OGR_GPKG_STREAM_BASE_IMPL")
set_config_option("OGR_GPKG_STREAM_BASE_IMPL", "YES")
```

It is possible to chain multiple file system handlers. The [/vsicurl/](https://gdal.org/en/stable/user/virtual_file_systems.html#vsicurl-http-https-ftp-files-random-access) prefix specifies a file system handler that allows on-the-fly random reading of files available through web protocols, without prior download of the entire file. For example, a zip file residing on a web server instead of the local file system could be accessed with a path like:

```
/vsizip//vsicurl/https://www.example.com/path/to/file.zip
```

Support for SOZip is available with GDAL >= 3.7. The function `vsi_get_file_metadata()` can be used to validate an SOZip file and obtain compression information. Otherwise, SOZip is fully backward compatible and works as a regular .zip file.

```{r}
if (gdal_version_num() >= gdal_compute_version(3, 7, 0)) {
  cat("SOZip metadata for ynp_features.gpkg:\n")
  vsi_get_file_metadata(zf_gpkg, domain = "ZIP") |> print()
} else {
  cat("SOZip support requires GDAL >= 3.7\n")
}
```

`inspectDataset()` returns information about the format and content of a data source that may contain raster and/or vector data.

```{r}
inspectDataset(zf_gpkg)
```

OGR functions can also be used to inspect a vector data source.

```{r}
# test for existence of a vector data source with at least read access
ogr_ds_exists(zf_gpkg)
# note that update of an existing zipped .gpkg file is not supported
ogr_ds_exists(zf_gpkg, with_update = TRUE)

# list the vector layers
ogr_ds_layer_names(zf_gpkg)
```

`ogrinfo()` requires GDAL >= 3.7. It accepts an optional character vector containing any of the arguments supported by the [`ogrinfo`](https://gdal.org/en/stable/programs/ogrinfo.html) command-line utility included with GDAL.

```{r eval=gdal_3_7_0_min}
# list the layers in a data source
ogrinfo(zf_gpkg)

# detailed information about a specific layer
ogrinfo(zf_gpkg, "ynp_bnd", cl_arg = c("-geom=SUMMARY", "-wkt_format", "WKT2"))
```

### Manage data sources and schemas

Here we copy the .gpkg file from the zip archive to an in-memory file that is writable, and make several modifications. The [/vsimem/](https://gdal.org/en/stable/user/virtual_file_systems.html#vsimem-in-memory-files) file handler allows a block of memory to be treated as files. It is useful for temporary storage and is generally fast to access. The code below also demonstrates testing certain defined capabilities of the dataset or layer before attempting to perform modifications. This will not be needed in all cases but might be used in code that is required to handle input datasets in a general way.

```{r}
# copy ynp_features.gpkg from the zip file to an in-memory file
mem_gpkg <- "/vsimem/tmp/ynp_features.gpkg"
ogr2ogr(zf_gpkg, mem_gpkg)

vsi_read_dir("/vsimem/tmp")

# confirm it's writable
ogr_ds_exists(mem_gpkg, with_update = TRUE)

rd_layer <- "roads"

# rename a layer (requires GDAL >= 3.5)
if (gdal_version_num() < gdal_compute_version(3, 5, 0)) {
  message("ogr_layer_rename() requires GDAL >= 3.5")
} else if (ogr_layer_test_cap(mem_gpkg, rd_layer)$Rename) {
  ogr_layer_rename(mem_gpkg, rd_layer, "roads2")
  rd_layer <- "roads2"
} else {
  message("layer does not have 'Rename' capability")
}

ogr_ds_layer_names(mem_gpkg)

# delete a layer
if (ogr_ds_test_cap(mem_gpkg)$DeleteLayer) {
  ogr_layer_delete(mem_gpkg, rd_layer)
} else {
  message("dataset does not have 'DeleteLayer' capability")
}

ogr_ds_layer_names(mem_gpkg)

# manage fields on a layer
ogr_layer_field_names(mem_gpkg, "points_of_interest")

# delete a field
if (ogr_layer_test_cap(mem_gpkg, "points_of_interest")$DeleteField) {
  ogr_field_delete(mem_gpkg, "points_of_interest", "createdate")
} else {
  message("layer does not have 'DeleteField' capability")
}

# rename fields
if (ogr_layer_test_cap(mem_gpkg, "points_of_interest")$AlterFieldDefn) {
  ogr_field_rename(mem_gpkg, "points_of_interest", "poiname", "poi_name")
  ogr_field_rename(mem_gpkg, "points_of_interest", "poitype", "poi_type")
} else {
  message("layer does not have 'AlterFieldDefn' capability")
}
```

As a simple example for illustration, we populate a new field to flag geothermal features.

```{r}
# create a new field
if (ogr_layer_test_cap(mem_gpkg, "points_of_interest")$CreateField) {
  ogr_field_create(mem_gpkg, "points_of_interest",
                   fld_name = "is_geothermal",
                   fld_type = "OFTInteger",
                   fld_subtype = "OFSTBoolean")
} else {
  message("layer does not have 'CreateField' capability")
}

# edit data with SQL
sql <- "UPDATE points_of_interest SET is_geothermal = 
          CASE
            WHEN poi_type IN ('Basin', 'Geyser') THEN TRUE
            ELSE FALSE
          END"
ogr_execute_sql(mem_gpkg, sql)

ogr_layer_field_names(mem_gpkg, "points_of_interest")
```

To read back from the modified data source we need to instantiate objects of class `GDALVector`. More detail on working with `GDALVector` objects is given in the examples further below for data retrieval. For now, note that the function `ogr_execute_sql()` returns an object of class `GDALVector` for SQL statements that return a result set.

```{r fig.alt = "A plot of the Yellowstone National Park (YNP) boundary in geographic coordinate system showing point locations of geothermal features. The YNP boundary polygon has background R color 'wheat'. The locations of geothermal features are solid circles with R color 'steelblue1. The x-axis label is 'longitude' and the y-axis label is 'latitude'. The plot title is 'YNP Geothermal Features."}
# read and display the geothermal features
sql <- "SELECT poi_name, geom
          FROM points_of_interest
            WHERE is_geothermal = TRUE"
(lyr <- ogr_execute_sql(mem_gpkg, sql))

lyr$getFeatureCount()

# retrieve all features in the result set (cf. DBI::dbFetch())
feat_set <- lyr$fetch(-1)
head(feat_set)

# plot the park boundary
# the layer contains a single polygon feature which is piped directly to plot()
GDALVector$new(mem_gpkg, "ynp_bnd")$getNextFeature() |>
  plot(col = "wheat", xlab = "longitude", ylab = "latitude",
       main = "YNP Geothermal Features")

plot(feat_set, pch = 19, col = "steelblue1", add = TRUE)
```

For clean up, the `$close()` method should be called on the layer object opened with `ogr_execute_sql()`. We also delete the temporary in-memory file.

```{r}
lyr$close()

# delete a data source
vsi_unlink(mem_gpkg)  # delete a single file
# or, deleteDataset(mem_gpkg)
```

### Traditional row-based data retrieval

These examples will use the original sample dataset for YNP features. An object of class `GDALVector` is generated with a call to `new()`. From the examples above, we know that the GeoPackage contains three vector layers, so we also pass a layer name argument to the class constructor.

Note that if the layer argument is omitted, the constructor will attempt to open the first layer by index. The abbreviated form of the constructor would generally be used for convenience only with single-layer file formats (e.g., ESRI Shapefile, FlatGeoBuf), or with a GeoPackage file known to contain only a single layer.

A SQL SELECT statement that returns a result set can also be used for the `layer` argument in the constructor.

Here we instantiate a `GDALVector` object for the park boundary layer and retrieve information about it.

```{r}
f <- system.file("extdata/ynp_features.zip", package = "gdalraster")
ynp_dsn <- file.path("/vsizip", f, "ynp_features.gpkg")

# the park boundary layer containing a single feature
(bnd <- new(GDALVector, ynp_dsn, "ynp_bnd"))

bnd$getFeatureCount()

# spatial reference definition as WKT string
bnd$getSpatialRef()

# xmin, ymin, xmax, ymax
bnd$bbox()

# structure of the layer definition (a.k.a. feature class definition)
bnd$getLayerDefn() |> str()
```

Traditional row-level access to feature data with OGR is cursor-based, reading one feature at a time. When starting with a new layer object, the cursor is positioned at the beginning and we can iterate through features with calls to `$getNextFeature()`. This method returns an individual feature as a named list of fields and their values, and moves the cursor forward one row. It will return `NULL` when no features are left.

The park boundary layer contains a single polygon feature. The list object returned for an individual feature carries the `"OGRFeature"` class attribute.

```{r}
bnd_feat <- bnd$getNextFeature()
str(bnd_feat)

# no more features
bnd$getNextFeature()

bnd$close()
```

The cursor can be reset to the beginning of the layer at any time with a call to `$resetReading()`.

### Fetch all features or progressively in batches

Class `GDALVector` also provides the `$fetch()` method to retrieve the next `n` features from the layer and return them as a data frame (analog of `DBI::dbFetch()`). `$fetch()` can be used to get the entire feature set for a layer, one batch of features at a time, or the remaining features from the current cursor position. Fetching zero features is also possible to retrieve the structure of the layer as a 0-row data frame with fully typed columns. As with `$getNextFeature()`, only forward paging is supported.

Passing `n = -1` or `n = Inf` will retrieve all features from the beginning (with an automatic call to `$resetReading()`). Passing `n = NA` is supported and will retrieve the remaining features from the current cursor position. Otherwise, features can be fetched progressively by passing a whole number (`integer` or `numeric`) as the `n` argument. If more features than available are requested, the result is returned in full without warning. If fewer features than requested are returned, further fetches will return a data frame with zero rows.

Note that it is possible to set an attribute filter and/or spatial filter prior to retrieving data to restrict the returned feature set. It is also possible to set specific fields as ignored (or to specify the list of desired fields). This includes potentially omitting the geometry column when access only to feature attributes is needed. Limiting the number of fields returned may save some processing time and/or bandwidth.

The `layer` argument in the constructor for `GDALVector` can also be given as a SQL SELECT statement. Here we read from the roads layer selecting only the publicly accessible roads. We call `$fetch()` with `n = -1` to read from the beginning and retrieve all available features. The data frame returned by `$fetch()` carries the `"OGRFeatureSet"` class attribute providing S3 methods for `print()` and `plot()`.

```{r fig.alt = "A plot of the Yellowstone National Park (YNP) boundary in geographic coordinate system showing public roads as LineString features. The YNP boundary polygon has background R color 'wheat', and the road features are shown as double-width lines with R color 'slategray'. The x-axis label is 'longitude' and the y-axis label is 'latitude'. The plot title is 'YNP Public Roads'."}
# SQL layer for public roads
sql <- "SELECT rdname, opentopubl, geom FROM roads WHERE opentopubl = 'Yes'"
(roads <- new(GDALVector, ynp_dsn, sql))

roads$getFeatureCount()

roads$getFieldNames()

roads_featset <- roads$fetch(-1)
nrow(roads_featset)

head(roads_featset)

plot(bnd_feat, col = "wheat", xlab = "longitude", ylab = "latitude",
     main = "YNP Public Roads")

plot(roads_featset, col = "slategray", lwd = 2, add = TRUE)

roads$close()
```

Fetching in batches may be advantageous when dealing with large datasets, especially when reading over a network. Also, note that `$getFeatureCount()` is called internally when fetching the full feature set but not for a batch of `n` features. Some vector drivers will actually scan the entire layer once to count features. The `FastFeatureCount` element in the list returned by the `$testCapability()` method can be checked if this might be a concern.

```{r}
poi <- new(GDALVector, ynp_dsn, "points_of_interest")

poi$getFeatureCount()

# read progressively in batches
batch_size <- 500
batch <- 0
while (TRUE) {
    poi_featset <- poi$fetch(batch_size)
    if (nrow(poi_featset) == 0) break
    cat("batch", batch <- batch + 1, ":", nrow(poi_featset), "features\n")
    # process batch
    # ...
}

poi$close()
```

### Read using ArrowArrayStream

It is also possible to retrieve features in a column-oriented memory layout using the Arrow C Stream interface in OGR (requires GDAL >= 3.6). Performance advantages can be substantial with vector format drivers that provide specialized implementations (e.g., Parquet, FlatGeoBuf, GeoPackage). Drivers with specialized implementations advertise the `FastGetArrowStream` layer capability.

The `$getArrowStream()` method of class `GDALVector` exposes an ArrowArrayStream on the layer as a `nanoarrow_array_stream` object. Note that the `nanoarrow_array_stream` object has a `$get_next()` method which allows accessing features in the stream by batch (returning a `nanoarrow_array` object). The default batch size for an OGR array stream is 65,536 features, but can be configured on a per-object basis by assigning a value to the `GDALVector` writable field `$arrowStreamOptions` (as a character vector of "NAME=VALUE" pairs). **nanoarrow** provides S3 methods for `as.data.frame()` to import a `nanoarrow_array` (one batch at a time), or the `nanoarrow_array_stream` itself (pulling all batches in the stream).

```{r eval=gdal_3_6_0_min, warning=FALSE}
# Expose an ArrowArrayStream (requires GDAL >= 3.6)

# re-open the roads layer with the required argument for type of access
roads$open(read_only = TRUE)
roads$resetReading()

# does the layer have a specialized implementation
roads$testCapability()$FastGetArrowStream

# optionally set ArrowStream options as character vector of "NAME=VALUE", e.g.,
roads$arrowStreamOptions <- "INCLUDE_FID=NO"
# the default batch size of 65,536 could also be configured with
# MAX_FEATURES_IN_BATCH=num

(stream <- roads$getArrowStream())

# get the array schema if needed
schema <- stream$get_schema()

# optionally read by batch, NULL is returned when no more features are available
# batch <- stream$get_next()
# if (!is.null(batch))
#   d_batch <- as.data.frame(batch)

# or, pull all the batches into a data frame
d <- as.data.frame(stream)
nrow(d)
head(d)

# release the stream when finished
stream$release()

# 'geom' is a list column of WKB raw vectors which can be passed to the
# Geometry API functions
geom_utm <- g_transform(d$geom,
                        srs_from = roads$getSpatialRef(),
                        srs_to = "EPSG:26912")

# add a column with road lengths in meters
d$rdlength <- g_length(geom_utm)
head(d)

roads$close()
```

### Reproject vector layers

The following example introduces another sample dataset which contains fire perimeters for Yellowstone National Park from the Monitoring Trends in Burn Severity (MTBS) project. Here we set up a temporary, writable copy of the dataset ynp_fires_1984_2022.gpkg (in memory), and use it as a data source to perform further processing.

The MTBS layer uses a projected coordinate system, while layers of the "YNP features" dataset used in the examples above are in geographic coordinates. The `ogr_reproject()` function is used to project layers in geographic coordinates from ynp_features.gpkg to match the coordinate system of the MTBS layer.

```{r fig.alt = "A plot of the Yellowstone National Park (YNP) boundary in a projected coordinate system showing the perimeter of the 2016 Maple Fire, along with three points of interest located within the fire polygon. The YNP boundary polygon has background R color 'wheat'. The Maple Fire perimeter is shown as a filled polygon in R color 'orangered'. The three points of interest are shown as filled square symbols in R color 'royalblue'. The x-axis label is 'x' and the y-axis label is 'y'. The plot is untitled."}
# MTBS fire perimeters in Yellowstone National Park 1984-2022
f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")

# copy to a temporary writable file
mtbs_dsn <- "/vsimem/tmp/ynp_fires_1984_2022.gpkg"
ogr2ogr(f, mtbs_dsn)

(fires <- new(GDALVector, mtbs_dsn, "mtbs_perims"))

srs_mtsp <- fires$getSpatialRef()  # Montana state plane metric definition

# reproject the boundary in ynp_features.gpkg to match the MTBS layer,
# returning a GDALVector object on the output layer by default
(bnd <- ogr_reproject(src_dsn = ynp_dsn, src_layer = "ynp_bnd",
                      out_dsn = mtbs_dsn, out_srs = srs_mtsp))

(bnd_feat <- bnd$getNextFeature())

bnd$close()

# reproject points_of_interest
poi <- ogr_reproject(ynp_dsn, "points_of_interest", mtbs_dsn, srs_mtsp)

# set an attribute filter to select the Maple Fire
fires$setAttributeFilter("incid_name = 'MAPLE'")
fires$getFeatureCount()

maple_fire <- fires$getNextFeature()

# use the fire polygon as a spatial filter for points_of_interest
# setSpatialFilter() expects WKT input, so convert the WKB geometry
g_wk2wk(maple_fire$geom) |> poi$setSpatialFilter()
poi$getFeatureCount()

poi$setSelectedFields(c("poiname", "poitype", "geom"))
(maple_pois <- poi$fetch(-1))

plot(bnd_feat, col = "wheat")
plot(maple_fire, col = "orangered", border = NA, add = TRUE)
plot(maple_pois, pch = 15, col = "royalblue", add = TRUE)

fires$close()
poi$close()
```

### Write a new feature in an existing layer

The `$createFeature()` method of `GDALVector` object creates and writes a new feature within the layer. The `feature` argument is a named list of fields and their values (which could be be one row of a data frame). The passed feature is written to the layer as a new feature, rather than overwriting an existing one.

Here we add the centroid of the YNP boundary as a point of interest.

```{r fig.alt = "A plot of the Yellowstone National Park (YNP) boundary in a projected coordinate system showing the centroid of the park boundary polygon as a single point. The YNP boundary polygon has background R color 'wheat'. The centroid point is shown as an R 'circle plus' symbol, a circle with a plus sign inside resembling crosshairs. The x-axis label is 'x' and the y-axis label is 'y'. The plot is untitled."}
# create a feature object for the YNP centroid as a point of interest
(bnd_centroid_xy <- g_centroid(bnd_feat$geom))

feat <- list()
feat$poiname <- "YNP centroid"
feat$poitype <- "Information"
feat$createdate <- Sys.Date()
feat$editdate <- Sys.Date()
feat$geom <- g_create("POINT", bnd_centroid_xy)

# re-open the "points_of_interest" layer with update access
poi$open(read_only = FALSE)
poi$testCapability()$SequentialWrite

# create and write the new feature on the layer
poi$createFeature(feat)

# be sure pending writes are flushed
poi$syncToDisk()

# read back
fid <- poi$getLastWriteFID()
(ynp_centroid <- poi$getFeature(fid))

plot(bnd_feat, col = "wheat")
plot(ynp_centroid, pch = 10, cex = 1.5, add = TRUE)
```

### Rewrite/replace an existing feature

The `$setFeature()` method of a `GDALVector` object writes a feature based on the feature id (FID) specified in the input. As with `$createFeature()`, the `feature` argument is a named list of fields and their values, and must include a `$FID` element referencing the existing feature to rewrite. Note that if any fields are omitted in the passed `feature` the write behavior is driver-dependent:

* SQL-based drivers which implement set feature through SQL UPDATE will skip unset fields, and thus the content of the existing feature will be preserved.
* The shapefile driver will write a NULL value in the DBF file.
* The GeoJSON driver will take into account unset fields to remove the corresponding JSON member.

```{r}
# rewrite a feature in the "point_of_interest" layer updating the feature name
# verify the layer has random write capability
poi$testCapability()$RandomWrite

# FID 3809 is missing the trailhead name
(feat <- poi$getFeature(3809))

# update the name field and the date of the edit
feat$poiname <- "Ice Lake Trailhead"
feat$editdate <- Sys.Date()

# rewrite the feature
poi$setFeature(feat)
poi$syncToDisk()

(feat <- poi$getFeature(3809))
```

### Delete a feature

The `$deleteFeature()` method of a `GDALVector` object deletes the feature with the indicated feature ID if supported by the format driver. The value of `fid` must be a single numeric value, optionally carrying the `bit64::integer64` class attribute.

```{r}
# delete the "YNP centroid" feature that was created above
# verify the layer has delete feature capability
poi$testCapability()$DeleteFeature

# the feature ID was obtained above as: fid <- poi$getLastWriteFID()
poi$getFeature(fid)

poi$deleteFeature(fid)
poi$syncToDisk()

poi$getFeature(fid)

poi$close()
```

### Batch write features from data frame input

The `$batchCreateFeature()`method of a `GDALVector` object is batch version of `$createFeature()`. It creates and writes a batch of new features within the layer from input given as a data frame. Column names in the data frame must match field names of the layer and have compatible data types.

Operations that write batches of features should use transactions for better performance when writing into RDBMS drivers that have native transaction support (e.g., PostgreSQL / PostGIS, GPKG, SQLite). Grouping many features per transaction (e.g., 100,000 or more) can improve performance substantially. Using transactions also provides a mechanism to rollback a group of data modifications that fails to complete or generates errors.

The example below compares the relative performance of writing a batch of features to a GeoPackage layer with and without a transaction. We create a new POINT layer in the existing GPKG (`mtbs_dsn`), and write batches of features at random point locations within the YNP bounding box.

By default, the GeoPackage driver automatically creates a column named `fid` to use for the OGR feature ID (primary key in the SQLite database). This can be configured with the `FID=value` layer creation option. Note that the FID is a special property of a feature and not treated as an attribute of a feature, so it is not specified in the layer definition.

```{r}
# create a layer definition for random_points
# the spatial ref was obtained above as: srs_mtsp <- fires$getSpatialRef()
defn <- ogr_def_layer("POINT", srs = srs_mtsp)
defn$pt_desc <- ogr_def_field("OFTString")
defn$create_time <- ogr_def_field("OFTDateTime")

ogr_layer_create(mtbs_dsn, "random_points", layer_defn = defn)

lyr <- new(GDALVector, mtbs_dsn, "random_points", read_only = FALSE)

bb <- g_wk2wk(bnd_feat$geom) |> bbox_from_wkt()
```

Next we create the first batch of features and write them without grouping in a transaction, measuring time elapsed.

```{r}
batch_size <- as.integer(1e5)

# create a batch of features
rndX <- sample((bb[1] + 1):(bb[3] - 1), batch_size, replace = TRUE)
rndY <- sample((bb[2] + 1):(bb[4] - 1), batch_size, replace = TRUE)
pts <- cbind(rndX, rndY)
pts_geom <- g_create("POINT", pts)
d <- data.frame(pt_desc = rep("random points batch 1", batch_size),
                create_time = rep(Sys.time(), batch_size))
d$geom <- pts_geom

# write the batch (no transaction)
system.time(res <- lyr$batchCreateFeature(d))

(all(res))

lyr$syncToDisk()
```

A second batch of features is grouped in a transaction for writing, and the layer is checked for the expected output.

```{r}
rndX <- sample((bb[1] + 1):(bb[3] - 1), batch_size, replace = TRUE)
rndY <- sample((bb[2] + 1):(bb[4] - 1), batch_size, replace = TRUE)
pts <- cbind(rndX, rndY)
pts_geom <- g_create("POINT", pts)
d <- data.frame(pt_desc = rep("random points batch 2", batch_size),
                create_time = rep(Sys.time(), batch_size))
d$geom <- pts_geom

# write the batch using a transaction
system.time({
  lyr$startTransaction()
  res2 <- lyr$batchCreateFeature(d)
  if (all(res2))
    lyr$commitTransaction()
  else
    lyr$rollbackTransaction()
})

(all(res2))

# check the output data
d_out <- lyr$fetch(-1)
(nrow(d_out) == batch_size * 2)

head(d_out)

tail(d_out)

lyr$close()
```

### Write to GeoJSON

Single-layer vector file formats (e.g., ESRI shapefile, FlatGeoBuf, GeoJSON) can be created from scratch with a call to `ogr_ds_create()`. This function provides optional arguments to add a single attribute field on the layer when it is created. More attribute fields could be added after layer creation with calls to `ogr_field_create()` (for vector formats that have the `CreateField` layer capability). Alternatively, a layer definition (as list object) can be passed to `ogr_ds_create()` to specify multiple attribute fields and their properties (see `?ogr_def_layer`).

GeoJSON does not support schema definition prior to creating features. Only the *Feature* object has a member with name *properties*. The specification does not require all *Feature* objects in a collection to have the same schema of properties, nor does it require all *Feature* objects in a collection to have geometry of the same type (https://geojson.org/). Note that we set `return_obj = TRUE` in the call to `ogr_ds_create()`. This returns a live dataset object open for write access on the layer (i.e., an object of class `GDALVector`). A valid GeoJSON file will be generated once one or more features have been written to the layer.

Here we generate a GeoJSON string containing a single polygon feature that defines a rectangular area of interest around the Maple Fire boundary. This GeoJSON format is supported for input by some data distribution systems to define a download box (e.g., [NLCD](https://www.mrlc.gov/viewer/) and [LANDFIRE](https://www.landfire.gov/viewer/)). For this case we need coordinates in Web Mercator projection (EPSG 3857).

```{r}
# write the Maple Fire AOI bounding box as GeoJSON in EPSG 3857
json_file <- file.path(tempdir(), "maple_fire_aoi.geojson")

lyr <- ogr_ds_create("GeoJSON", json_file, layer = "maple_fire_aoi",
                     geom_type = "POLYGON", srs = "EPSG:3857",
                     fld_name = "id", fld_type = "OFTString",
                     overwrite = TRUE, return_obj = TRUE)

# The Maple Fire feature object and spatial reference were obtained above in
# the section on "Reproject vector layers".
# Here we extend the minimum bounding box by 500 m in each direction.
feat <- list()
feat$id <- "dataDownloadBox"
feat$geom <- g_transform(maple_fire$geom, srs_from = srs_mtsp,
                         srs_to = "EPSG:3857", as_wkb = FALSE) |>
               bbox_from_wkt(extend_x = 500, extend_y = 500) |>
               bbox_to_wkt()

lyr$createFeature(feat)

lyr$close()

readLines(json_file) |> writeLines()
```

### OGR facilities for vector geoprocessing

`ogr_proc()` performs GIS overlay operations on vector layers. It provides an interface to GDAL API methods for the following operations: [Intersection](https://gdal.org/en/stable/api/vector_c_api.html#_CPPv418OGR_L_Intersection9OGRLayerH9OGRLayerH9OGRLayerHPPc16GDALProgressFuncPv), [Union](https://gdal.org/en/stable/api/vector_c_api.html#_CPPv411OGR_L_Union9OGRLayerH9OGRLayerH9OGRLayerHPPc16GDALProgressFuncPv), [SymDifference](https://gdal.org/en/stable/api/vector_c_api.html#_CPPv419OGR_L_SymDifference9OGRLayerH9OGRLayerH9OGRLayerHPPc16GDALProgressFuncPv), [Identity](https://gdal.org/en/stable/api/vector_c_api.html#_CPPv414OGR_L_Identity9OGRLayerH9OGRLayerH9OGRLayerHPPc16GDALProgressFuncPv), [Update](https://gdal.org/en/stable/api/vector_c_api.html#_CPPv412OGR_L_Update9OGRLayerH9OGRLayerH9OGRLayerHPPc16GDALProgressFuncPv), [Clip](https://gdal.org/en/stable/api/vector_c_api.html#_CPPv410OGR_L_Clip9OGRLayerH9OGRLayerH9OGRLayerHPPc16GDALProgressFuncPv) and [Erase](https://gdal.org/en/stable/api/vector_c_api.html#_CPPv411OGR_L_Erase9OGRLayerH9OGRLayerH9OGRLayerHPPc16GDALProgressFuncPv).

Inputs are given as objects of class `GDALVector`, which may have spatial and/or attribute filters applied. The output layer will be created if it does not exist, but output can also be appended to an existing layer, or written to an existing empty layer that has a custom schema defined.

Here we generate a layer of areas within the 1988 North Fork fire perimeter that have subsequently re-burned (as of 2022). The output layer contains features whose geometries represent areas that are common between features in the input layer and in the method layer. The features in the output layer have attributes from both the input and method layers.

```{r fig.alt = "A plot of the 1988 North Fork fire perimeter showing areas within the North Fork burn scar that have subsequently re-burned as of 2022. The North Fork fire is shown as an unfilled polygon with black outline. Areas within the North Fork polygon that have re-burned are shown as filled polygons in R color 'orangered'. The x-axis label is 'x' and the y-axis label is 'y'. The plot title is '1988 North Fork fire perimeter showing re-burned areas in red'."}
# layer filtered to fires after 1988
lyr1 <- new(GDALVector, mtbs_dsn, "mtbs_perims")
lyr1$setAttributeFilter("ig_year > 1988")
lyr1$getFeatureCount()

# second layer for the 1988 North Fork fire perimeter
sql <- "SELECT incid_name, ig_year, geom FROM mtbs_perims
        WHERE incid_name = 'NORTH FORK'"
lyr2 <- new(GDALVector, mtbs_dsn, sql)
lyr2$getFeatureCount()

north_fork_feat <- lyr2$getNextFeature()

# set mode options for the intersection
opt <- c("INPUT_PREFIX=layer1_",
         "METHOD_PREFIX=layer2_",
         "PROMOTE_TO_MULTI=YES")

# intersect to obtain areas re-burned since 2000
lyr_out <- ogr_proc(mode = "Intersection",
                    input_lyr = lyr1,
                    method_lyr = lyr2,
                    out_dsn = mtbs_dsn,
                    out_lyr_name = "north_fork_reburned",
                    out_geom_type = "MULTIPOLYGON",
                    mode_opt = opt)

# the output layer has attributes of both the input and method layers
(reburn_feat_set <- lyr_out$fetch(-1))

plot(north_fork_feat)
plot(reburn_feat_set, col = "orangered", border = NA, add = TRUE,
     main = "1988 North Fork fire perimeter showing re-burned areas in red")

# clean up
lyr1$close()
lyr2$close()
lyr_out$close()
```

```{r, include = FALSE}
# clean up
unlink(json_file)
vsi_unlink(mtbs_dsn)
vsi_rmdir("/vsimem/tmp/")
set_config_option("OGR2OGR_USE_ARROW_API", ogr_arrow_opt)
set_config_option("OGR_GPKG_STREAM_BASE_IMPL", gpkg_stream_base_opt)
```

---
title: "Raster API Tutorial"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Raster API Tutorial}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

**gdalraster** provides bindings to the Raster API of the Geospatial Data Abstraction Library ([GDAL](https://gdal.org/en/stable/)). Using the API natively enables fast and scalable raster I/O from R. This vignette is an R port of the [GDAL Raster API tutorial](https://gdal.org/en/stable/tutorials/raster_api_tut.html) for C++, C and Python, (c) 1998-2025 [Frank Warmerdam](https://github.com/warmerdam), [Even Rouault](https://github.com/rouault), and [others](https://github.com/OSGeo/gdal/graphs/contributors) ([MIT license](https://gdal.org/en/stable/license.html)).

## Opening a raster dataset

Before opening a GDAL-supported data store it is necessary to register drivers. There is a driver for each supported raster format. **gdalraster** automatically registers drivers when the package is loaded. A raster dataset is opened by creating a new instance of `GDALRaster-class` passing the `filename` and the access desired (`read_only = TRUE` is the default if not specified, or `read_only = FALSE` to open with update access):

```{r}
library(gdalraster)

tcc_file <- system.file("extdata/storml_tcc.tif", package="gdalraster")
ds <- new(GDALRaster, tcc_file, read_only = TRUE)
```

An error is returned if the dataset cannot be opened (and creation of the `GDALRaster` object fails). Also, note that `filename` may not actually be the name of a physical file (though it usually is). Its interpretation is driver dependent, and it might be a URL, a database connection string, a file name with additional parameters, etc.

`GDALRaster` is a C++ class exposed directly to R (via `RCPP_EXPOSED_CLASS`) that encapsulates a GDAL dataset object and its associated raster band objects. Methods of the class are accessed in R using the `$` operator:

```{r}
ds
str(ds)
```

## Getting dataset information

As described in the [GDAL Raster Data Model](https://gdal.org/en/stable/user/raster_data_model.html), a GDAL dataset contains a list of raster bands, all pertaining to the same area and having the same resolution. It also has metadata, a coordinate system, a georeferencing transform, size of raster and various other information.

In the particular but common case of a "north up" raster without any rotation or shearing, the georeferencing transform (see [Geotransform Tutorial](https://gdal.org/en/stable/tutorials/geotransforms_tut.html)) takes the following form *with 1-based indexing in R*:

```{r}
gt <- ds$getGeoTransform()
gt[1]  # x-coordinate of upper-left corner of the upper-left pixel
gt[2]  # pixel width (w-e resolution)
gt[3]  # 0 for north-up
gt[4]  # y-coordinate of upper-left corner of the upper-left pixel
gt[5]  # 0 for north-up
gt[6]  # pixel height (n-s resolution, negative value)
```

In the general case, this is an affine transform. Class `GDALRaster` includes convenience methods for the case of a north-up raster:

```{r}
ds$bbox()  # xmin, ymin, xmax, ymax
ds$res()   # pixel width, pixel height as positive values
```

The following code retrieves some additional information about the dataset:

```{r}
# GDAL format driver
ds$getDriverShortName()
ds$getDriverLongName()

# raster size in pixels, number of bands
ds$getRasterXSize()
ds$getRasterYSize()
ds$getRasterCount()
ds$dim()

# coordinate reference system as WKT string
ds$getProjectionRef()

# origin and pixel size from the geotransform
print(paste("Origin:", gt[1], gt[4]))
print(paste("Pixel size:", gt[2], gt[6]))
```

## Fetching a raster band

At this time access to raster data via GDAL is done one band at a time. Also, metadata, block sizes, nodata values and various other information are available on a per-band basis. Class `GDALRaster` provides methods to access raster band objects of the dataset (numbered 1 through `ds$getRasterCount()`) by specifying a `band` number as the first argument:

```{r}
# block	size
ds$getBlockSize(band = 1)

# data type
ds$getDataTypeName(band = 1)

# nodata value
ds$getNoDataValue(band = 1)

# min, max, mean, sd of pixel values in the band
ds$getStatistics(band = 1, approx_ok = FALSE, force = TRUE)

# does this band have overviews? (aka "pyramids")
ds$getOverviewCount(band = 1)

# does this band have a color table?
col_tbl <- ds$getColorTable(band = 1)
if (!is.null(col_tbl))
  head(col_tbl)
```

## Reading raster data

`GDALRaster$read()` is a wrapper for the `GDALRasterBand::RasterIO()` method in the underlying API. This method will automatically take care of data type conversion, up/down sampling and windowing. The following code will read the first row of data into a similarly sized vector. `GDALRaster$read()` will return data as R `integer` type if possible for the raster data type (Byte, Int8, Int16, UInt16, Int32), otherwise the returned vector will be of type `double` (UInt32, Float32, Float64) or `complex` (CInt16, CInt32, CFloat32, CFloat64). The returned data are organized in left to right, top to bottom pixel order. `NA` will be returned in place of the nodata value if the raster dataset has a nodata value defined for the band:

```{r}
# read the first row of pixel values
ncols <- ds$getRasterXSize()
rowdata <- ds$read(band = 1,
                   xoff = 0,
                   yoff = 0,
                   xsize = ncols,
                   ysize = 1,
                   out_xsize = ncols,
                   out_ysize = 1)

length(rowdata)
typeof(rowdata)
head(rowdata)
```

Writing data with `GDALRaster$write()` is similar to `$read()` with an additional argument specifying a vector of pixel data to write (arranged in left to right, top to bottom pixel order). The `xoff`, `yoff`, `xsize`, `ysize` arguments describe the window of raster data on disk to read (or write). It doesn't have to fall on tile boundaries, though access may be more efficient in some cases if it does. Note that GDAL uses memory caching algorithms during raster I/O to improve performance. The operation of the caching mechanism and  configuration of cache memory size might be considered when scaling I/O to large datasets (see [GDAL Block Cache](https://firelab.github.io/gdalraster/articles/gdal-block-cache.html)).

The values for `out_xsize` and `out_ysize` describe the size of the output buffer (an R vector of length `out_xsize * out_ysize` that data will be read into). When reading data at full resolution this would be the same as the window size (`xsize`, `ysize`). However, to load a reduced resolution overview, `out_xsize`, `out_ysize` could be set to smaller than the window on disk. The `$read()` method will perform automatic resampling as necessary if the specified output size (`out_xsize * out_ysize`) is different than the size of the region being read (`xsize * ysize`). In this case, overviews (a.k.a. "pyramids") will be utilized to do the I/O more efficiently if overviews are available at suitable resolution.

The stand-alone function `plot_raster()` uses base R `graphics` to display raster data read from an open dataset (with options to display a subwindow, to read a reduced resolution overview, or read from multiple bands for RGB data):

```{r fig.width=6, fig.height=4, dev="png"}
#| fig.alt: >
#|   A plot of pixel-level tree canopy cover (%) for an area of interest
#|   called Storm Lake, which is used for several example datasets in package
#|   gdalraster. The plot uses a color ramp from light to dark green
#|   indicating low to high tree canopy cover. Pixels with zero tree canopy
#|   cover are white.
plot_raster(ds, legend = TRUE, main = "Storm Lake Tree Canopy Cover (%)")
```

## Closing the dataset

Calling `GDALRaster$close()` will result in proper cleanup, and flushing of any pending writes. Forgetting to close a dataset opened in update mode in a popular format like GTiff will likely result in being unable to open it afterwards.

```{r}
# close the dataset for proper cleanup
ds$close()
```

## Techniques for creating datasets

New raster datasets in GDAL-supported formats may be created if the format driver supports creation. There are two general techniques for creating datasets in the GDAL API: `GDALDriver::CreateCopy()` and `GDALDriver::Create()`. Using the CreateCopy method in R involves calling the stand-alone function `createCopy()`, passing in a source raster file name that should be copied. Using the Create method in R involves calling the stand-alone function `create()`, and then explicitly writing all the metadata and raster data with separate calls. All format drivers that support creating new datasets support `createCopy()`, but only a few support `create()`.

The function `gdal_formats()` lists all currently configured raster formats along with the following read/write flags:

* `ro`  - read only
* `rw`  - read/write, supports `createCopy()`
* `rw+` - read/write/update, supports `create()`

The table of GDAL [raster format drivers](https://gdal.org/en/stable/drivers/raster/index.html) can also be consulted to determine if a particular driver supports Create or CreateCopy methods. Note that a number of drivers are read-only and do not support either creation method. 

## Using createCopy()

`createCopy()` is simple to use as most information is collected from the source dataset. It includes an argument for passing a list of format specific creation options. It can be used to copy a raster to a different format, and/or change options such as the block size and arrangement, compression, various metadata, etc. The following code copies a multi-band raster in FARSITE v.4 LCP format (basically a raw format without support for compression or nodata values) to LZW-compressed GeoTiff:

```{r}
lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
tif_file <- file.path(tempdir(), "storml_lndscp.tif")
ds <- createCopy(format = "GTiff",
                 dst_filename = tif_file,
                 src_filename = lcp_file,
                 options = "COMPRESS=LZW",
                 return_obj = TRUE)

# band = 0 for dataset-level metadata:
ds$getMetadata(band = 0, domain = "IMAGE_STRUCTURE")

# set nodata value for all bands
for (band in 1:ds$getRasterCount())
  ds$setNoDataValue(band, -9999)

# band 2 of an LCP file is slope degrees
ds$getStatistics(band = 2, approx_ok = FALSE, force = TRUE)
ds$close()

vsi_stat(lcp_file, "size")
vsi_stat(tif_file, "size")
```

Note that the `createCopy()` method with `return_obj = TRUE` returns a writable dataset, and that it must be closed properly to complete writing and flushing the dataset to disk. `createCopy()` also has an optional `strict` argument that defaults to `FALSE` indicating that the call should proceed without a fatal error even if the destination dataset cannot be created to exactly match the input dataset. This might be because the output format does not support the pixel datatype of the input dataset, or because the destination cannot support writing georeferencing for instance.

Information about format specific creation options can be obtained with the function `getCreationOptions()`. By default, this function lists all available creation options for a format. Output can also be filtered to specific options:

```{r}
getCreationOptions("GTiff", "COMPRESS")

getCreationOptions("GTiff", "SPARSE_OK")
```

## Using create()

`create()` can be used to create a new raster dataset manually. This function can also take a list of creation options as described above for `createCopy()`, but the raster size, number of bands and band type must be provided explicitly:

```{r}
new_file <- file.path(tempdir(), "newdata.tif")
ds <- create(format = "GTiff",
             dst_filename = new_file,
             xsize = 143,
             ysize = 107,
             nbands = 1, 
             dataType = "Int16",
             return_obj = TRUE)
```

Once the dataset is successfully created, all appropriate metadata and raster data must be written to the file. What this includes will vary according to usage, but a simple case with a projection, geotransform and raster data is covered here:

```{r}
# EPSG:26912 - NAD83 / UTM zone 12N
ds$setProjection(epsg_to_wkt(26912))

gt <- c(323476.1, 30, 0, 5105082.0, 0, -30)
ds$setGeoTransform(gt)

ds$setNoDataValue(band = 1, -9999)
ds$fillRaster(band = 1, -9999, 0)

# ...

# close the dataset when done
ds$close()
```

## See also

**gdalraster** provides two additional functions for creating raster datasets:

* `rasterFromRaster()` creates a new raster with spatial reference, extent and resolution taken from a template raster, without copying data. It optionally changes the format, number of bands, data type and nodata value, sets driver-specific dataset creation options, and initializes to a value.

* `rasterToVRT()` creates a virtual raster dataset (VRT) derived from a source raster with options for virtual subsetting, virtually resampling the source data at a different pixel resolution, or applying a virtual kernel filter.

Wrapper functions for several GDAL utilities, including `translate()` and `warp()`, are also available. See the [package overview](https://firelab.github.io/gdalraster/reference/gdalraster-package.html) for a full summary of functionality provided by the GDAL API bindings.

## Data sources

The example datasets are National Land Cover Database (NLCD) Tree Canopy Cover (TCC v2021.4) from the USDA Forest Service (<https://data.fs.usda.gov/geodata/rastergateway/treecanopycover/>), and a multi-band FARSITE landscape file describing terrain, vegetation and wildland fuels from the LANDFIRE Program (LF 2020 version, <https://landfire.gov/>).

---
title: "Raster Attribute Tables"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Raster Attribute Tables}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

A GDAL Raster Attribute Table (RAT) provides attribute information about pixel values. Raster attribute tables can be used to represent histograms, color tables, and classification information. Each row in the table applies to either a single pixel value or a range of values, and might have attributes such as the histogram count for that value (or range), the color that pixels of that value (or range) should be displayed, names of classes, or various other information. **gdalraster** supports reading Raster Attribute Tables as R data frame, building new tables, and setting a default RAT on a raster band.

## Format of GDAL RAT

Each column in a raster attribute table has a name, a type (integer, floating point or string), and a `GDALRATFieldUsage`. The field usage distinguishes columns with particular understood purposes (such as color, histogram count, class name), and columns that have other purposes not understood by the library (long labels, ancillary attributes, etc).

In the general case, each row has a field indicating the minimum pixel value falling into that category, and a field indicating the maximum pixel value. In the GDAL API, these are indicated with usage values of `GFU_Min` and `GFU_Max` (`GDALRATFieldUsage` enumeration constants). This vignette will focus on the particular but common case where each row is a discrete pixel value. In this case, a single column with usage `GFU_MinMax` (indicating class value) would be used instead of separate min and max columns. The table is represented in R as a data frame with column attribute `"GFU"` containing the field usage, e.g., `"MinMax"` (case-sensitive string). Other field usage types include `"PixelCount"` (`GFU_PixelCount`, histogram pixel count), `"Name"` (`GFU_Name`, class name), `"Red"` (`GFU_Red`, class color 0-255), `"Green"` (`GFU_Green`, class color 0-255), `"Blue"` (`GFU_Blue`, class color 0-255), and `"Generic"` (`GFU_Generic`, general purpose field).

A raster attribute table can be used with thematic or athematic (continuous) data. This is defined in R by an attribute on the data frame named `"GDALRATTableType"` with a value of either `"thematic"` or `"athematic"`.

## Read/build/set attribute tables

**gdalraster** can read, build and set Raster Attribute Tables via data frame. An object of class `GDALRaster` has method `$getDefaultRAT()` to read an existing RAT, and method `$setDefaultRAT()` to set a RAT from a data frame. The stand-alone function `buildRAT()` scans a raster to obtain the set of unique pixel values and their counts, optionally joins additional columns from a passed data frame, and returns a data frame with the appropriate metadata automatically assigned (i.e., R attributes assigned on the data frame and its columns that define usage as a GDAL RAT, for passing to `GDALRaster$setDefaultRAT()`):

```{r}
library(gdalraster)

# LANDFIRE Existing Vegetation Type (EVT)
evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")

# make a copy to modify
f <- paste0(tempdir(), "/", "storml_evt_tmp.tif")
file.copy(evt_file,  f)
ds <- new(GDALRaster, f, read_only=FALSE)
ds$getDefaultRAT(band=1)

# get the full attribute table for LANDFIRE EVT from its CSV file
evt_csv <- system.file("extdata/LF20_EVT_220.csv", package="gdalraster")
evt_df <- read.csv(evt_csv)
nrow(evt_df)
head(evt_df)

# keep just the R, G, B fields (0-255) and drop RED, GREEN, BLUE
evt_df <- evt_df[,1:7]

# build a RAT for the EVT raster, attaching additional columns from evt_df
tbl <- buildRAT(ds,
                table_type = "thematic",
                na_value = -9999,
                join_df = evt_df)

nrow(tbl)
head(tbl)

# attributes on the returned data frame and its columns define RAT metadata
attr(tbl, "GDALRATTableType")
attributes(tbl$VALUE)     # GFU_MinMax for column of discrete pixel values
attributes(tbl$COUNT)     # pixel counts
attributes(tbl$EVT_NAME)  # the class names
attributes(tbl$EVT_LF)    # ancillary attribute
attributes(tbl$EVT_PHYS)  # ancillary attribute
attributes(tbl$R)         # red 0-255
attributes(tbl$G)         # green 0-255
attributes(tbl$B)         # blue 0-255

# set as default RAT on the EVT raster
ds$setDefaultRAT(band=1, tbl)
ds$flushCache()

# it can now be read from the raster dataset
rm(tbl)
tbl <- ds$getDefaultRAT(band=1)
nrow(tbl)
```

## Display attribute tables

An attribute table with RGB columns can be passed to `gdalraster::plot_raster()` as a color table (columns `VALUE`, `R`, `G`, `B`):

```{r fig.width=6, fig.height=4, dev="png"}
bb <- ds$bbox()
#| fig.alt: >
#|   A plot of LANDFIRE Existing Vegetation Type (EVT) for an area of interest
#|   named Storm Lake which is used for several example datasets in package
#|   gdalraster. A color map has been to the pixels using color values provided
#|   by LANDFIRE in the CSV attribute table for the EVT layer.
plot_raster(data = ds,
            col_tbl = tbl[,c(1,6:8)],
            maxColorValue = 255,
            interpolate = FALSE,
            main = "Storm Lake LANDFIRE EVT")
```

The function `displayRAT()` generates a nicely formatted table for display. Colors are shown if the RAT contains RGB columns:

```{r}
displayRAT(tbl, title = "Raster Attribute Table for Storm Lake EVT")
```

`displayRAT()` returns an object of class `"gt_tbl"`. The table object can be modified using functions of the **gt** package.

```{r}
ds$close()
```

## Using in QGIS

QGIS since 3.30 includes [extensive support for Raster Attribute Tables](https://qgis.org/project/visual-changelogs/visualchangelog330/#feature-raster-attribute-tables-rat-support).

For QGIS < 3.30, the **Raster Attribute Table Plugin** can be used to edit and display RATs for discrete rasters using the paletted/unique-values renderer (QGIS-style classification on arbitrary RAT columns). With the plugin enabled, "Open Attribute Table" can be selected after right-clicking a raster layer that has an associated RAT. For the LANDFIRE EVT layer as modified above, classifying on EVT_NAME generates the following display:

```{r, echo=FALSE, fig.cap="LANDFIRE EVT in the Raster Attribute Table QGIS Plugin", out.width = '90%'}
#| fig.alt: >
#|   A screen capture of the QGIS desktop application showing support for GDAL
#|   raster attribute tables. The display of attribute tables in gdalraster is
#|   modeled after that of QGIS, having a similar format by default.
knitr::include_graphics("qgis_rat_classify.png")
```

## See also

* Documentation for [`gdalraster::buildRAT()`](https://usdaforestservice.github.io/gdalraster/reference/buildRAT.html)

* [GDALRasterAttributeTable Class Reference](https://gdal.org/en/stable/doxygen/classGDALRasterAttributeTable.html)

* [Raster Attribute Table QGIS GUI](https://github.com/qgis/QGIS/pull/50687) (since QGIS 3.30; examples for different use cases and workflows)

* [Raster Attribute Table QGIS Plugin](https://github.com/noaa-ocs-hydrography/qgis-raster-attribute-table-plugin) (QGIS < 3.30)

* Package [gt](https://CRAN.R-project.org/package=gt)

## Data sources

The example dataset is Existing Vegetation Type (EVT) from the LANDFIRE Program (LF 2020 version, <https://landfire.gov/>). Map units are based on [NatureServe Ecological Systems](https://www.natureserve.org/products/terrestrial-ecological-systems-united-states).

---
title: "Raster Attribute Tables"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Raster Attribute Tables}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

A GDAL Raster Attribute Table (RAT) provides attribute information about pixel values. Raster attribute tables can be used to represent histograms, color tables, and classification information. Each row in the table applies to either a single pixel value or a range of values, and might have attributes such as the histogram count for that value (or range), the color that pixels of that value (or range) should be displayed, names of classes, or various other information. **gdalraster** supports reading Raster Attribute Tables as R data frame, building new tables, and setting a default RAT on a raster band.

## Format of GDAL RAT

Each column in a raster attribute table has a name, a type (Integer, Double, String, and with GDAL >= 3.12, Boolean, DateTime, or WKBGeometry), and a `GDALRATFieldUsage`. The field usage distinguishes columns with particular understood purposes (such as color, histogram count, class name), and columns that have other purposes not understood by the library (long labels, ancillary attributes, etc). With GDAL >= 3.12, a WKBGeometry field is meant to help GIS software find (zoom to) areas where specific rows are present in the RAT.

In the general case, each row has a field indicating the minimum pixel value falling into that category, and a field indicating the maximum pixel value. In the GDAL API, these are indicated with usage values of `GFU_Min` and `GFU_Max` (`GDALRATFieldUsage` enumeration constants). This vignette will focus on the particular but common case where each row is a discrete pixel value. In this case, a single column with usage `GFU_MinMax` (indicating class value) would be used instead of separate min and max columns. The table is represented in R as a data frame with column attribute `"GFU"` containing the field usage, e.g., `"MinMax"` (case-sensitive string). Other field usage types include `"PixelCount"` (`GFU_PixelCount`, histogram pixel count), `"Name"` (`GFU_Name`, class name), `"Red"` (`GFU_Red`, class color 0-255), `"Green"` (`GFU_Green`, class color 0-255), `"Blue"` (`GFU_Blue`, class color 0-255), and `"Generic"` (`GFU_Generic`, general purpose field).

A raster attribute table can be used with thematic or athematic (continuous) data. This is defined in R by an attribute on the data frame named `"GDALRATTableType"` with a value of either `"thematic"` or `"athematic"`.

## Read/build/set attribute tables

**gdalraster** can read, build and set Raster Attribute Tables via data frame. An object of class `GDALRaster` has method `$getDefaultRAT()` to read an existing RAT, and method `$setDefaultRAT()` to set a RAT from a data frame. The stand-alone function `buildRAT()` scans a raster to obtain the set of unique pixel values and their counts, optionally joins additional columns from a passed data frame, and returns a data frame with the appropriate metadata automatically assigned (i.e., R attributes assigned on the data frame and its columns that define usage as a GDAL RAT, for passing to `GDALRaster$setDefaultRAT()`):

```{r}
library(gdalraster)

# LANDFIRE Existing Vegetation Type (EVT)
evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")

# make a copy to modify
f <- paste0(tempdir(), "/", "storml_evt_tmp.tif")
file.copy(evt_file,  f)
ds <- new(GDALRaster, f, read_only=FALSE)
ds$getDefaultRAT(band=1)

# get the full attribute table for LANDFIRE EVT from its CSV file
evt_csv <- system.file("extdata/LF20_EVT_220.csv", package="gdalraster")
evt_df <- read.csv(evt_csv)
nrow(evt_df)
head(evt_df)

# keep just the R, G, B fields (0-255) and drop RED, GREEN, BLUE
evt_df <- evt_df[,1:7]

# build a RAT for the EVT raster, attaching additional columns from evt_df
tbl <- buildRAT(ds,
                table_type = "thematic",
                na_value = -9999,
                join_df = evt_df)

nrow(tbl)
head(tbl)

# attributes on the returned data frame and its columns define RAT metadata
attr(tbl, "GDALRATTableType")
attributes(tbl$VALUE)     # GFU_MinMax for column of discrete pixel values
attributes(tbl$COUNT)     # pixel counts
attributes(tbl$EVT_NAME)  # the class names
attributes(tbl$EVT_LF)    # ancillary attribute
attributes(tbl$EVT_PHYS)  # ancillary attribute
attributes(tbl$R)         # red 0-255
attributes(tbl$G)         # green 0-255
attributes(tbl$B)         # blue 0-255

# set as default RAT on the EVT raster
ds$setDefaultRAT(band=1, tbl)
ds$flushCache()

# it can now be read from the raster dataset
rm(tbl)
tbl <- ds$getDefaultRAT(band=1)
nrow(tbl)
```

## Display attribute tables

An attribute table with RGB columns can be passed to `gdalraster::plot_raster()` as a color table (columns `VALUE`, `R`, `G`, `B`):

```{r fig.width=6, fig.height=4, dev="png"}
bb <- ds$bbox()
#| fig.alt: >
#|   A plot of LANDFIRE Existing Vegetation Type (EVT) for an area of interest
#|   named Storm Lake which is used for several example datasets in package
#|   gdalraster. A color map has been to the pixels using color values provided
#|   by LANDFIRE in the CSV attribute table for the EVT layer.
plot_raster(data = ds,
            col_tbl = tbl[,c(1,6:8)],
            maxColorValue = 255,
            interpolate = FALSE,
            main = "Storm Lake LANDFIRE EVT")
```

The function `displayRAT()` generates a nicely formatted table for display. Colors are shown if the RAT contains RGB columns:

```{r, eval = requireNamespace("gt")}
displayRAT(tbl, title = "Raster Attribute Table for Storm Lake EVT")
```

`displayRAT()` returns an object of class `"gt_tbl"`. The table object can be modified using functions of the **gt** package.

```{r}
ds$close()
```

## Using in QGIS

QGIS since 3.30 includes [extensive support for Raster Attribute Tables](https://qgis.org/project/visual-changelogs/visualchangelog330/#feature-raster-attribute-tables-rat-support).

For QGIS < 3.30, the **Raster Attribute Table Plugin** can be used to edit and display RATs for discrete rasters using the paletted/unique-values renderer (QGIS-style classification on arbitrary RAT columns). With the plugin enabled, "Open Attribute Table" can be selected after right-clicking a raster layer that has an associated RAT. For the LANDFIRE EVT layer as modified above, classifying on EVT_NAME generates the following display:

```{r, echo=FALSE, fig.cap="LANDFIRE EVT in the Raster Attribute Table QGIS Plugin", out.width = '90%'}
#| fig.alt: >
#|   A screen capture of the QGIS desktop application showing support for GDAL
#|   raster attribute tables. The display of attribute tables in gdalraster is
#|   modeled after that of QGIS, having a similar format by default.
knitr::include_graphics("qgis_rat_classify.png")
```

## See also

* Documentation for [`gdalraster::buildRAT()`](https://firelab.github.io/gdalraster/reference/buildRAT.html)

* [GDALRasterAttributeTable Class Reference](https://gdal.org/en/stable/doxygen/classGDALRasterAttributeTable.html)

* [Raster Attribute Table QGIS GUI](https://github.com/qgis/QGIS/pull/50687) (since QGIS 3.30; examples for different use cases and workflows)

* [Raster Attribute Table QGIS Plugin](https://github.com/noaa-ocs-hydrography/qgis-raster-attribute-table-plugin) (QGIS < 3.30)

* Package [gt](https://CRAN.R-project.org/package=gt)

## Data sources

The example dataset is Existing Vegetation Type (EVT) from the LANDFIRE Program (LF 2020 version, <https://landfire.gov/>). Map units are based on [NatureServe Ecological Systems](https://www.natureserve.org/publications/ecological-systems-united-states).

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{buildVRT}
\alias{buildVRT}
\title{Build a GDAL virtual raster from a list of datasets}
\usage{
buildVRT(vrt_filename, input_rasters, cl_arg = NULL, quiet = FALSE)
}
\arguments{
\item{vrt_filename}{Character string. Filename of the output VRT.}

\item{input_rasters}{Character vector of input raster filenames.}

\item{cl_arg}{Optional character vector of command-line arguments to
\code{gdalbuildvrt}.}

\item{quiet}{Logical scalar. If \code{TRUE}, a progress bar will not be
displayed. Defaults to \code{FALSE}.}
}
\value{
Logical indicating success (invisible \code{TRUE}).
An error is raised if the operation fails.
}
\description{
\code{buildVRT()} is a wrapper of the \command{gdalbuildvrt} command-line
utility for building a VRT (Virtual Dataset) that is a mosaic of the list
of input GDAL datasets
(see \url{https://gdal.org/en/stable/programs/gdalbuildvrt.html}).
}
\details{
Several command-line options are described in the GDAL documentation at the
URL above. By default, the input files are considered as tiles of a larger
mosaic and the VRT file has as many bands as one of the input files.
Alternatively, the \code{-separate} argument can be used to put each input
raster into a separate band in the VRT dataset.

Some amount of checks are done to assure that all files that will be put in
the resulting VRT have similar characteristics: number of bands,
projection, color interpretation.... If not, files that do not match the
common characteristics will be skipped. (This is true in the default
mode for virtual mosaicing, and not when using the \code{-separate} option).

In a virtual mosaic, if there is spatial overlap between
input rasters then the order of files appearing in the list of
sources matter: files that are listed at the end are the ones
from which the data will be fetched. Note that nodata will be taken into
account to potentially fetch data from less priority datasets.
}
\examples{
# build a virtual 3-band RGB raster from individual Landsat band files
b4_file <- system.file("extdata/sr_b4_20200829.tif", package="gdalraster")
b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
b6_file <- system.file("extdata/sr_b6_20200829.tif", package="gdalraster")
band_files <- c(b6_file, b5_file, b4_file)
vrt_file <- file.path(tempdir(), "storml_b6_b5_b4.vrt")
buildVRT(vrt_file, band_files, cl_arg = "-separate")
ds <- new(GDALRaster, vrt_file)
ds$getRasterCount()
plot_raster(ds, nbands = 3, main = "Landsat 6-5-4 (vegetative analysis)")
ds$close()
\dontshow{vsi_unlink(vrt_file)}
}
\seealso{
\code{\link[=rasterToVRT]{rasterToVRT()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_get_actual_url}
\alias{vsi_get_actual_url}
\title{Returns the actual URL of a supplied VSI filename}
\usage{
vsi_get_actual_url(filename)
}
\arguments{
\item{filename}{Character string containing a /vsiPREFIX/ filename.}
}
\value{
Character string containing the actual URL, or \code{NULL} if
\code{filename} is not a network-based virtual file system.
}
\description{
\code{vsi_get_actual_url()} returns the actual URL of a supplied filename.
Currently only returns a non-NULL value for network-based virtual file
systems. For example "/vsis3/bucket/filename" will be expanded as
"https://bucket.s3.amazon.com/filename".
Wrapper for \code{VSIGetActualURL()} in the GDAL API.
}
\examples{
\dontrun{
f <- "/vsiaz/items/io-lulc-9-class.parquet"
set_config_option("AZURE_STORAGE_ACCOUNT", "pcstacitems")
# token obtained from:
# https://planetarycomputer.microsoft.com/api/sas/v1/token/pcstacitems/items
set_config_option("AZURE_STORAGE_SAS_TOKEN","<token>")
vsi_get_actual_url(f)
#> [1] "https://pcstacitems.blob.core.windows.net/items/io-lulc-9-class.parquet"
vsi_get_signed_url(f)
#> [1] "https://pcstacitems.blob.core.windows.net/items/io-lulc-9-class.parquet?<token>"
}
}
\seealso{
\code{\link[=vsi_get_signed_url]{vsi_get_signed_url()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grid_helpers.R
\name{gt_from_dim_bbox}
\alias{gt_from_dim_bbox}
\title{Geotransform from dimensions and bounding box}
\usage{
gt_from_dim_bbox(dm, bbox)
}
\arguments{
\item{dm}{Integer vector of length two containing the raster dimensions
(xsize, ysize) in pixels.}

\item{bbox}{Numeric vector of length four containing the bounding box
(xmin, ymin, xmax, ymax) in georeferenced coordinates.}
}
\value{
Numeric vector of length six containing the geotransform
coefficients.
}
\description{
\code{gt_from_dim_bbox()} computes geotransform coefficients from raster
dimensions and a bounding box. The resulting geotransform will always be
north-up (no rotation).
}
\examples{
# 1-degree global grid
(gt <- gt_from_dim_bbox(c(360, 180), c(-180, -90, 180, 90)))

# verify round-trip
bbox_from_dim_gt(c(360, 180), gt)
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster$getGeoTransform()}},
\code{\link[=GDALRaster]{GDALRaster$setGeoTransform()}},
\code{\link[=GDALRaster]{GDALRaster$setBbox()}}, \code{\link[=bbox_from_dim_gt]{bbox_from_dim_gt()}},
\code{\link[=inv_geotransform]{inv_geotransform()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom.R
\name{g_measures}
\alias{g_measures}
\alias{g_area}
\alias{g_centroid}
\alias{g_distance}
\alias{g_length}
\alias{g_geodesic_area}
\alias{g_geodesic_length}
\title{Compute measurements for WKB/WKT geometries}
\usage{
g_area(geom, quiet = FALSE)

g_centroid(geom, quiet = FALSE)

g_distance(geom, other_geom, quiet = FALSE)

g_length(geom, quiet = FALSE)

g_geodesic_area(geom, srs, traditional_gis_order = TRUE, quiet = FALSE)

g_geodesic_length(geom, srs, traditional_gis_order = TRUE, quiet = FALSE)
}
\arguments{
\item{geom}{Either a raw vector of WKB or list of raw vectors, or a
character vector containing one or more WKT strings.}

\item{quiet}{Logical value, \code{TRUE} to suppress warnings. Defaults to \code{FALSE}.}

\item{other_geom}{Either a raw vector of WKB or list of raw vectors, or a
character vector containing one or more WKT strings. Must contain the same
number of geometries as \code{geom}, unless \code{geom} contains a single
geometry in which case pairwise distances will be computed for one-to-many
if \code{other_geom} contains multiple geometries (i.e., "this-to-others").}

\item{srs}{Character string specifying the spatial reference system
for \code{geom}. May be in WKT format or any of the formats supported by
\code{\link[=srs_to_wkt]{srs_to_wkt()}}.}

\item{traditional_gis_order}{Logical value, \code{TRUE} to use traditional GIS
order of axis mapping (the default) or \code{FALSE} to use authority compliant
axis order. By default, input \code{geom} vertices are assumed to
be in longitude/latitude order if \code{srs} is a geographic coordinate system.
This can be overridden by setting \code{traditional_gis_order = FALSE}.}
}
\description{
These functions compute measurements for geometries. The input
geometries may be given as a single raw vector of WKB, a list of WKB raw
vectors, or a character vector containing one or more WKT strings.
}
\details{
These functions use the GEOS library via GDAL headers.

\code{g_area()} computes the area for a \code{Polygon} or \code{MultiPolygon}. Undefined
for all other geometry types (returns zero). Returns a numeric vector,
having length equal to the number of input geometries, containing
computed area or '0' if undefined.

\code{g_centroid()} returns a numeric vector of length 2 containing the centroid
(X, Y), or a two-column numeric matrix (X, Y) with number of rows equal to
the number of input geometries.
The GDAL documentation states "This method relates to the SFCOM
\code{ISurface::get_Centroid()} method however the current implementation based
on GEOS can operate on other geometry types such as multipoint, linestring,
geometrycollection such as multipolygons. OGC SF SQL 1.1 defines the
operation for surfaces (polygons). SQL/MM-Part 3 defines the operation for
surfaces and multisurfaces (multipolygons)."

\code{g_distance()} returns the distance between two geometries or \code{-1} if an
error occurs. Returns the shortest distance between the two geometries.
The distance is expressed into the same unit as the coordinates of the
geometries. Returns a numeric vector, having length equal to the number of
input geometry pairs, containing computed distance or '-1' if an error
occurs.

\code{g_length()} computes the length for \code{LineString} or \code{MultiCurve} objects.
Undefined for all other geometry types (returns zero). Returns a numeric
vector, having length equal to the number of input geometries, containing
computed length or '0' if undefined.

\code{g_geodesic_area()} computes geometry area, considered as a surface on the
underlying ellipsoid of the SRS attached to the geometry. The returned area
will always be in square meters, and assumes that polygon edges describe
geodesic lines on the ellipsoid. If the geometry SRS is not a geographic
one, geometries are reprojected to the underlying geographic SRS.
By default, input geometry vertices are assumed to be in longitude/latitude
order if using a geographic coordinate system. This can be overridden with
the \code{traditional_gis_order} argument.
Returns the area in square meters, or \code{NA} in case of error (unsupported
geometry type, no SRS attached, etc.)
Requires GDAL >= 3.9.

\code{g_geodesic_length()} computes the length of the curve, considered as a
geodesic line on the underlying ellipsoid of the SRS attached to the
geometry. The returned length will always be in meters. If the geometry SRS
is not a geographic one, geometries are reprojected to the underlying
geographic SRS.
By default, input geometry vertices are assumed to be in longitude/latitude
order if using a geographic coordinate system. This can be overridden with
the \code{traditional_gis_order} argument.
Returns the length in meters, or \code{NA} in case of error (unsupported geometry
type, no SRS attached, etc.)
Requires GDAL >= 3.10.
}
\note{
For \code{g_distance()}, \code{geom} and \code{other_geom} must be in the same coordinate
reference system. If \code{geom} is a single geometry and \code{other_geom} is a list
or vector of multiple geometries, then distances will be calculated between
\code{geom} and each geometry in \code{other_geom}. Otherwise, no recycling is done
and \code{length(geom)} must equal \code{length(other_geom)} to calculate distance
between each corresponding pair of input geometries.

Geometry validity is not checked. In case you are unsure of the validity
of the input geometries, call \code{g_is_valid()} before, otherwise the result
might be wrong.
}
\examples{
g_area("POLYGON ((0 0, 10 10, 10 0, 0 0))")

g_centroid("POLYGON ((0 0, 10 10, 10 0, 0 0))")

g_distance("POINT (0 0)", "POINT (5 12)")

g_length("LINESTRING (0 0, 3 4)")

f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
lyr <- new(GDALVector, f, "mtbs_perims")

# read all features into a data frame
feat_set <- lyr$fetch(-1)
head(feat_set)

g_area(feat_set$geom) |> head()

g_centroid(feat_set$geom) |> head()

lyr$close()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{fillNodata}
\alias{fillNodata}
\title{Fill selected pixels by interpolation from surrounding areas}
\usage{
fillNodata(
  filename,
  band,
  mask_file = "",
  max_dist = 100,
  smooth_iterations = 0L,
  quiet = FALSE
)
}
\arguments{
\item{filename}{Filename of input raster in which to fill nodata pixels.}

\item{band}{Integer band number to modify in place.}

\item{mask_file}{Optional filename of raster to use as a validity mask
(band 1 is used, zero marks nodata pixels, non-zero marks valid pixels).}

\item{max_dist}{Maximum distance (in pixels) that the algorithm
will search out for values to interpolate (100 pixels by default).}

\item{smooth_iterations}{The number of 3x3 average filter smoothing
iterations to run after the interpolation to dampen artifacts
(0 by default).}

\item{quiet}{Logical scalar. If \code{TRUE}, a progress bar will not be
displayed. Defaults to \code{FALSE}.}
}
\value{
Logical indicating success (invisible \code{TRUE}).
An error is raised if the operation fails.
}
\description{
\code{fillNodata()} is a wrapper for \code{GDALFillNodata()} in the GDAL Algorithms
API. This algorithm will interpolate values for all designated nodata
pixels (pixels having an intrinsic nodata value, or marked by zero-valued
pixels in the optional raster specified in \code{mask_file}). For each nodata
pixel, a four direction conic search is done to find values to interpolate
from (using inverse distance weighting).
Once all values are interpolated, zero or more smoothing iterations
(3x3 average filters on interpolated pixels) are applied to smooth out
artifacts.
}
\note{
The input raster will be modified in place. It should not be open in a
\code{GDALRaster} object while processing with \code{fillNodata()}.
}
\examples{
## fill nodata edge pixels
f <- system.file("extdata/storml_elev_orig.tif", package="gdalraster")

## get count of nodata
tbl <- buildRAT(f)
head(tbl)
tbl[is.na(tbl$VALUE),]

ds <- new(GDALRaster, f)
plot_raster(ds, legend = TRUE)
ds$close()

## make a copy that will be modified
mod_file <- file.path(tempdir(), "storml_elev_fill.tif")
file.copy(f,  mod_file)

fillNodata(mod_file, band = 1)

mod_tbl = buildRAT(mod_file)
head(mod_tbl)
mod_tbl[is.na(mod_tbl$VALUE),]

ds <- new(GDALRaster, mod_file)
plot_raster(ds, legend = TRUE)
ds$close()
\dontshow{deleteDataset(mod_file)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_get_file_metadata}
\alias{vsi_get_file_metadata}
\title{Get metadata on files}
\usage{
vsi_get_file_metadata(filename, domain)
}
\arguments{
\item{filename}{Character string. The path of the file system object to be
queried.}

\item{domain}{Character string. Metadata domain to query. Depends on the
file system, see Details.}
}
\value{
A named list of values, or \code{NULL} in case of error or empty list.
}
\description{
\code{vsi_get_file_metadata()} returns metadata for file system objects.
Implemented for network-like filesystems. Starting with GDAL 3.7,
implemented for /vsizip/ with SOZip metadata.
Wrapper of \code{VSIGetFileMetadata()} in the GDAL Common Portability Library.
}
\details{
The metadata available depends on the file system. The following are
supported as of GDAL 3.9:
\itemize{
\item HEADERS: to get HTTP headers for network-like filesystems (/vsicurl/,
/vsis3/, /vsgis/, etc).
\item TAGS: for /vsis3/, to get S3 Object tagging information. For /vsiaz/,
to get blob tags.
\item STATUS: specific to /vsiadls/: returns all system-defined properties
for a path (seems in practice to be a subset of HEADERS).
\item ACL: specific to /vsiadls/ and /vsigs/: returns the access control list
for a path. For /vsigs/, a single \code{XML=xml_content} string is returned.
\item METADATA: specific to /vsiaz/: blob metadata (this will be a subset of
what \code{domain=HEADERS} returns).
\item ZIP: specific to /vsizip/: to obtain ZIP specific metadata, in
particular if a file is SOZIP-enabled (\code{SOZIP_VALID=YES}).
}
}
\examples{
\dontshow{if (gdal_version_num() >= gdal_compute_version(3, 7, 0)) withAutoprint(\{ # examplesIf}
# validate an SOZip-enabled file
# Requires GDAL >= 3.7
f <- system.file("extdata/ynp_features.zip", package = "gdalraster")

zf <- file.path("/vsizip", f)
# files in zip archive
vsi_read_dir(zf)

# SOZip metadata for ynp_features.gpkg
zf_gpkg <- file.path(zf, "ynp_features.gpkg")
vsi_get_file_metadata(zf_gpkg, domain = "ZIP")
\dontshow{\}) # examplesIf}
}
\seealso{
\code{\link[=vsi_stat]{vsi_stat()}}, \code{\link[=addFilesInZip]{addFilesInZip()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_helpers.R
\name{get_pixel_line}
\alias{get_pixel_line}
\title{Raster pixel/line from geospatial x,y coordinates}
\usage{
get_pixel_line(xy, gt)
}
\arguments{
\item{xy}{Numeric matrix of geospatial x, y coordinates in the same spatial
reference system as \code{gt} (or two-column data frame that will be coerced
to numeric matrix, or a vector x, y for one coordinate).}

\item{gt}{Either a numeric vector of length six containing the affine
geotransform for the raster, or an object of class \code{GDALRaster} from
which the geotransform will be obtained (see Note).}
}
\value{
Integer matrix of raster pixel/line.
}
\description{
\code{get_pixel_line()} converts geospatial coordinates to pixel/line (raster
column, row numbers).
The upper left corner pixel is the raster origin (0,0) with column, row
increasing left to right, top to bottom.
}
\note{
This function applies the inverse geotransform to the input points. If \code{gt}
is given as the numeric vector, no bounds checking is done (i.e., min
pixel/line could be less than zero and max pixel/line could be greater than
the raster x/y size). If \code{gt} is obtained from an object of class
\code{GDALRaster}, then \code{NA} is returned for points that fall outside the
raster extent and a warning emitted giving the number points that were
outside. This latter case is equivalent to calling the
\code{$get_pixel_line()} class method on the \code{GDALRaster} object (see
Examples).
}
\examples{
pt_file <- system.file("extdata/storml_pts.csv", package="gdalraster")
# id, x, y in NAD83 / UTM zone 12N
pts <- read.csv(pt_file)
print(pts)

raster_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
ds <- new(GDALRaster, raster_file)
gt <- ds$getGeoTransform()
get_pixel_line(pts[, -1], gt)

# or, using the class method
ds$get_pixel_line(pts[, -1])

# add a point outside the raster extent
pts[11, ] <- c(11, 323318, 5105104)
get_pixel_line(pts[, -1], gt)

# with bounds checking on the raster extent
ds$get_pixel_line(pts[, -1])

ds$close()
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster$getGeoTransform()}}, \code{\link[=inv_geotransform]{inv_geotransform()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{identifyDriver}
\alias{identifyDriver}
\title{Identify the GDAL driver that can open a dataset}
\usage{
identifyDriver(
  filename,
  raster = TRUE,
  vector = TRUE,
  allowed_drivers = NULL,
  file_list = NULL
)
}
\arguments{
\item{filename}{Character string containing the name of the file to access.
This may not refer to a physical file, but instead contain information for
the driver on how to access a dataset (e.g., connection string, URL, etc.)}

\item{raster}{Logical value indicating whether to include raster format
drivers in the search, \code{TRUE} by default. May be set to \code{FALSE} to include
only vector drivers.}

\item{vector}{Logical value indicating whether to include vector format
drivers in the search, \code{TRUE} by default. May be set to \code{FALSE} to include
only raster drivers.}

\item{allowed_drivers}{Optional character vector of driver short names
that must be considered. Set to \code{NULL} to consider all candidate drivers
(the default).}

\item{file_list}{Optional character vector of filenames, including those
that are auxiliary to the main filename (see Note). May contain the input
\code{filename} but this is not required. Defaults to \code{NULL}.}
}
\value{
A character string with the short name of the first driver that
successfully identifies the input file name, or \code{NULL} on failure.
}
\description{
\code{identifyDriver()} will try to identify the driver that can open the passed
file name by invoking the Identify method of each registered GDALDriver in
turn. The short name of the first driver that successfully identifies the
file name will be returned as a character string. If all drivers fail then
\code{NULL} is returned.
Wrapper of \code{GDALIdentifyDriverEx()} in the GDAL C API.
}
\note{
In order to reduce the need for such searches to touch the file system
machinery of the operating system, it is possible to give an optional list
of files. This is the list of all files at the same level in the file
system as the target file, including the target file. The filenames should
not include any path components. If the target object does not have
filesystem semantics then the file list should be \code{NULL}.

At least one of the \code{raster} or \code{vector} arguments must be \code{TRUE}.
}
\examples{
src <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")

identifyDriver(src) |> gdal_formats()
}
\seealso{
\code{\link[=gdal_formats]{gdal_formats()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_helpers.R
\name{lib_versions}
\alias{lib_versions}
\title{Return library version information for GDAL and its dependencies}
\usage{
lib_versions()
}
\value{
A named list with elements \code{"gdal"}, \code{"proj"} and \code{"geos"}, each
containing a named list with the following elements:
\itemize{
\item \code{"name"}: character string version as \code{"major.minor.patch"}
\item \code{"major"}: integer major version number
\item \code{"minor"}: integer minor version number
\item \code{"patch"}: integer patch version number
}
}
\description{
\code{lib_versions()} returns a named list of library version information for
GDAL and its major dependencies, currently PROJ and GEOS. It provides library
versions in a consistent format, as an alternative to the separate
\code{gdal_version()}, \code{proj_version()} and \code{geos_version()}.
}
\examples{
lib_versions()
}
\seealso{
\code{\link[=gdal_version]{gdal_version()}}, \code{\link[=proj_version]{proj_version()}}, \code{\link[=geos_version]{geos_version()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{srs_query}
\alias{srs_query}
\alias{srs_get_name}
\alias{srs_find_epsg}
\alias{srs_is_geographic}
\alias{srs_is_derived_gcs}
\alias{srs_is_local}
\alias{srs_is_projected}
\alias{srs_is_compound}
\alias{srs_is_geocentric}
\alias{srs_is_vertical}
\alias{srs_is_dynamic}
\alias{srs_is_same}
\alias{srs_get_angular_units}
\alias{srs_get_linear_units}
\alias{srs_get_coord_epoch}
\alias{srs_get_utm_zone}
\alias{srs_get_axis_mapping_strategy}
\alias{srs_get_area_of_use}
\alias{srs_get_axes_count}
\alias{srs_get_axes}
\alias{srs_epsg_treats_as_lat_long}
\alias{srs_epsg_treats_as_northing_easting}
\alias{srs_get_celestial_body_name}
\title{Obtain information about a spatial reference system}
\usage{
srs_get_name(srs)

srs_find_epsg(srs, all_matches = FALSE)

srs_is_geographic(srs)

srs_is_derived_gcs(srs)

srs_is_local(srs)

srs_is_projected(srs)

srs_is_compound(srs)

srs_is_geocentric(srs)

srs_is_vertical(srs)

srs_is_dynamic(srs)

srs_is_same(
  srs,
  srs_other,
  criterion = "",
  ignore_axis_mapping = FALSE,
  ignore_coord_epoch = FALSE
)

srs_get_angular_units(srs)

srs_get_linear_units(srs)

srs_get_coord_epoch(srs)

srs_get_utm_zone(srs)

srs_get_axis_mapping_strategy(srs)

srs_get_area_of_use(srs)

srs_get_axes_count(srs)

srs_get_axes(srs, target_key = NULL)

srs_epsg_treats_as_lat_long(srs)

srs_epsg_treats_as_northing_easting(srs)

srs_get_celestial_body_name(srs)
}
\arguments{
\item{srs}{Character string containing an SRS definition in various
formats (e.g., WKT, PROJ.4 string, well known name such as NAD27, NAD83,
WGS84, etc., see \code{\link[=srs_to_wkt]{srs_to_wkt()}}).}

\item{all_matches}{Logical scalar. \code{TRUE} to return all identified matches
in a data frame, including a confidence value (0-100) for each match. The
default is \code{FALSE} which returns a character string in the form
\code{"EPSG:<code>"} for the first match (highest confidence).}

\item{srs_other}{Character string containing an SRS definition in various
formats(see above).}

\item{criterion}{Character string. One of \code{STRICT}, \code{EQUIVALENT},
\code{EQUIVALENT_EXCEPT_AXIS_ORDER_GEOGCRS}.
Defaults to \code{EQUIVALENT_EXCEPT_AXIS_ORDER_GEOGCRS}.}

\item{ignore_axis_mapping}{Logical scalar. If \code{TRUE}, sets
\code{IGNORE_DATA_AXIS_TO_SRS_AXIS_MAPPING=YES} in the call to \code{OSRIsSameEx()}
in the GDAL Spatial Reference System API. Defaults to \code{NO}.}

\item{ignore_coord_epoch}{Logical scalar. If \code{TRUE}, sets
\code{IGNORE_COORDINATE_EPOCH=YES} in the call to \code{OSRIsSameEx()}
in the GDAL Spatial Reference System API. Defaults to \code{NO}.}

\item{target_key}{Optional character string giving the coordinate system
part to query, either \code{"PROJCS"} or \code{"GEOGCS"} (case-insensitive)}
}
\description{
Bindings to a subset of the GDAL Spatial Reference System API
(\url{https://gdal.org/en/stable/api/ogr_srs_api.html}).
These functions return various information about a spatial reference
system passed as text in any of the formats supported by \code{\link[=srs_to_wkt]{srs_to_wkt()}}.
}
\details{
\code{srs_find_epsg()} tries to find a matching EPSG code.
Matching may be partial, or may fail. If \code{all_matches = TRUE}, returns a
data frame with entries sorted by decreasing match confidence (first
entry has the highest match confidence); the default is \code{FALSE} which
returns a character string in the form "EPSG:####" for the first match
(highest confidence). Wrapper of \code{OSRFindMatches()} in the GDAL SRS API.

\code{srs_get_name()} returns the SRS name.
Wrapper of \code{OSRGetName()} in the GDAL API.

\code{srs_is_geographic()} returns \code{TRUE}  if the root is a GEOGCS node.
Wrapper of \code{OSRIsGeographic()} in the GDAL API.

\code{srs_is_derived_gcs()} returns \code{TRUE} if the SRS is a derived geographic
coordinate system (for example a rotated long/lat grid).
Wrapper of \code{OSRIsDerivedGeographic()} in the GDAL API.

\code{srs_is_local()} returns \code{TRUE} if the SRS is a local coordinate system
(the root is a LOCAL_CS node).
Wrapper of \code{OSRIsLocal()} in the GDAL API.

\code{srs_is_projected()} returns \code{TRUE} if the SRS contains a PROJCS node
indicating a it is a projected coordinate system.
Wrapper of \code{OSRIsProjected()} in the GDAL API.

\code{srs_is_compound()} returns \code{TRUE} if the SRS is compound.
Wrapper of \code{OSRIsCompound()} in the GDAL API.

\code{srs_is_geocentric()} returns \code{TRUE} if the SRS is a geocentric coordinate
system.
Wrapper of \code{OSRIsGeocentric()} in the GDAL API.

\code{srs_is_vertical()} returns \code{TRUE} if the SRS is a vertical coordinate
system.
Wrapper of \code{OSRIsVertical()} in the GDAL API.

\code{srs_is_dynamic()} returns \code{TRUE} if the SRS is is a dynamic coordinate
system (relies on a dynamic datum, i.e., a datum that is not plate-fixed).
Wrapper of \code{OSRIsDynamic()} in the GDAL API. Requires GDAL >= 3.4.

\code{srs_is_same()} returns \code{TRUE} if two spatial references describe
the same system.
Wrapper of \code{OSRIsSame()} in the GDAL API.

\code{srs_get_angular_units()} fetches the angular geographic coordinate system
units. Returns a list of length two: the first element contains the unit
name as a character string, and the second element contains a numeric value
to multiply by angular distances to transform them to radians.
Wrapper of \code{OSRGetAngularUnits()} in the GDAL API.

\code{srs_get_linear_units()} fetches the linear projection units.
Returns a list of length two: the first element contains the unit
name as a character string, and the second element contains a numeric value
to multiply by linear distances to transform them to meters.
If no units are available, values of "Meters" and 1.0 will be assumed.
Wrapper of \code{OSRGetLinearUnits()} in the GDAL API.

\code{srs_get_coord_epoch()} returns the coordinate epoch, as decimal year
(e.g. 2021.3), or \code{0} if not set or not relevant.
Wrapper of \code{OSRGetCoordinateEpoch()} in the GDAL API. Requires GDAL >= 3.4.

\code{srs_get_utm_zone()} returns the UTM zone number or zero if \code{srs} isn't a
UTM definition. A positive value indicates northern hemisphere; a negative
value is in the southern hemisphere.
Wrapper of \code{OSRGetUTMZone()} in the GDAL API.

\code{srs_get_axis_mapping_strategy()} returns the data axis to CRS axis mapping
strategy as a character string, one of:
\itemize{
\item \code{OAMS_TRADITIONAL_GIS_ORDER}: for geographic CRS with lat/long order, the
data will still be long/lat ordered. Similarly for a projected CRS with
northing/easting order, the data will still be easting/northing ordered.
\item \code{OAMS_AUTHORITY_COMPLIANT}: the data axis will be identical to the CRS
axis.
\item \code{OAMS_CUSTOM}: custom-defined data axis
}

\code{srs_get_area_of_use()} is a wrapper of \code{OSRGetAreaOfUse()} in the GDAL API.
Returns a named list containing the following elements (or returns \code{NULL} if
the API call does not succeed):
\itemize{
\item \code{AreaName}: the area of use
\item \code{WestLongitudeDeg}: the western-most longitude expressed in degree, or
\code{NA} if the bounding box is unknown
\item \code{SouthLatitudeDeg}: the southern-most latitude expressed in degree, or
\code{NA} if the bounding box is unknown
\item \code{EastLongitudeDeg}: the eastern-most longitude expressed in degree, or
\code{NA} if the bounding box is unknown
\item \code{NorthLatitudeDeg}: the northern-most latitude expressed in degree, or
\code{NA} if the bounding box is unknown
}

\code{srs_get_axes_count()} returns the integer number of axes of the coordinate
system of the SRS. Wrapper of \code{OSRGetAxesCount()} in the GDAL API.

\code{srs_get_axes()} returns a named list of the axis names and their
orientations. Wrapper of \code{OSRGetAxis()} in the GDAL API.

\code{srs_epsg_treats_as_lat_long()} returns \code{TRUE} if this geographic coordinate
system should be treated as having latitude/longitude coordinate ordering.
Wrapper of \code{OSREPSGTreatsAsLatLong()} in the GDAL API.

\code{srs_epsg_treats_as_northing_easting()} returns \code{TRUE} if this geographic
coordinate system should be treated as having northing/easting coordinate
ordering. Wrapper of \code{OSREPSGTreatsAsNorthingEasting()} in the GDAL API.

\code{srs_get_celestial_body_name()} returns the name of the celestial body of
the SRS, e.g., \code{"Earth"} for an Earth SRS. Wrapper of
\code{OSRGetCelestialBodyName()} in the GDAL API. Requires GDAL >= 3.12 and
PROJ >= 8.1.
}
\examples{
wkt <- 'PROJCS["ETRS89 / UTM zone 32N (N-E)",
        GEOGCS["ETRS89",
            DATUM["European_Terrestrial_Reference_System_1989",
                SPHEROID["GRS 1980",6378137,298.257222101,
                    AUTHORITY["EPSG","7019"]],
                TOWGS84[0,0,0,0,0,0,0],
                AUTHORITY["EPSG","6258"]],
            PRIMEM["Greenwich",0,
                AUTHORITY["EPSG","8901"]],
            UNIT["degree",0.0174532925199433,
                AUTHORITY["EPSG","9122"]],
            AUTHORITY["EPSG","4258"]],
        PROJECTION["Transverse_Mercator"],
        PARAMETER["latitude_of_origin",0],
        PARAMETER["central_meridian",9],
        PARAMETER["scale_factor",0.9996],
        PARAMETER["false_easting",500000],
        PARAMETER["false_northing",0],
        UNIT["metre",1,
            AUTHORITY["EPSG","9001"]],
        AXIS["Northing",NORTH],
        AXIS["Easting",EAST]]'

srs_find_epsg(wkt)

srs_find_epsg(wkt, all_matches = TRUE)

srs_get_name("EPSG:5070")

srs_is_geographic("EPSG:5070")
srs_is_geographic("EPSG:4326")

srs_is_derived_gcs("WGS84")

srs_is_projected("EPSG:5070")
srs_is_projected("EPSG:4326")

srs_is_compound("EPSG:4326")

srs_is_geocentric("EPSG:7789")

srs_is_vertical("EPSG:5705")

srs_get_area_of_use("EPSG:3976")

srs_get_axes_count("EPSG:4326")
srs_get_axes_count("EPSG:4979")

# ordered list of axis names and their orientation
srs_get_axes("EPSG:4326+5773")

srs_epsg_treats_as_lat_long("WGS84")

# NAD83 / Conus Albers:
srs_epsg_treats_as_northing_easting("EPSG:5070")
# WGS 84 / UPS North (N,E):
srs_epsg_treats_as_northing_easting("EPSG:32661")
# WGS 84 / UPS South (N,E):
srs_epsg_treats_as_northing_easting("EPSG:32761")

## Requires GDAL >= 3.12 and PROJ >= 8.1
# srs_get_celestial_body_name("EPSG:4326")
#> [1] "Earth"
# srs_get_celestial_body_name("IAU_2015:30100")
#> [1] "Moon"

f <- system.file("extdata/storml_elev.tif", package="gdalraster")
ds <- new(GDALRaster, f)

ds$getProjection() |> srs_is_projected()
ds$getProjection() |> srs_get_utm_zone()
ds$getProjection() |> srs_get_angular_units()
ds$getProjection() |> srs_get_linear_units()
ds$getProjection() |> srs_get_axis_mapping_strategy()

ds$getProjection() |> srs_is_same("EPSG:26912")
ds$getProjection() |> srs_is_same("NAD83")

ds$close()

## Requires GDAL >= 3.4
if (gdal_version_num() >= gdal_compute_version(3, 4, 0)) {
  if (srs_is_dynamic("WGS84"))
    print("WGS84 is dynamic")

  if (!srs_is_dynamic("NAD83"))
    print("NAD83 is not dynamic")
}
}
\seealso{
\link{srs_convert}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_rmdir}
\alias{vsi_rmdir}
\title{Delete a directory}
\usage{
vsi_rmdir(path, recursive = FALSE)
}
\arguments{
\item{path}{Character string. The path to the directory to be deleted.}

\item{recursive}{Logical scalar. \code{TRUE} to delete the directory and its
content. Defaults to \code{FALSE}.}
}
\value{
\code{0} on success or \code{-1} on an error.
}
\description{
\code{vsi_rmdir()} deletes a directory object from the file system. On some
systems the directory must be empty before it can be deleted.
With \code{recursive = TRUE}, deletes a directory object and its content from
the file system.
This function goes through the GDAL \code{VSIFileHandler} virtualization and may
work on unusual filesystems such as in memory.
It is a wrapper for \code{VSIRmdir()} and \code{VSIRmdirRecursive()} in the GDAL
Common Portability Library.
}
\note{
/vsis3/ has an efficient implementation for deleting recursively. Starting
with GDAL 3.4, /vsigs/ has an efficient implementation for deleting
recursively, provided that OAuth2 authentication is used.
}
\examples{
new_dir <- file.path(tempdir(), "newdir")
vsi_mkdir(new_dir)
vsi_rmdir(new_dir)
}
\seealso{
\code{\link[=deleteDataset]{deleteDataset()}}, \code{\link[=vsi_mkdir]{vsi_mkdir()}}, \code{\link[=vsi_read_dir]{vsi_read_dir()}}, \code{\link[=vsi_unlink]{vsi_unlink()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{get_num_cpus}
\alias{get_num_cpus}
\title{Get the number of processors detected by GDAL}
\usage{
get_num_cpus()
}
\value{
Integer scalar, number of CPUs.
}
\description{
\code{get_num_cpus()} returns the number of processors detected by GDAL.
Wrapper of \code{CPLGetNumCPUs()} in the GDAL Common Portability Library.
}
\examples{
get_num_cpus()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_cli.R
\name{gdal_cli}
\alias{gdal_cli}
\alias{gdal_commands}
\alias{gdal_usage}
\alias{gdal_run}
\alias{gdal_run_piped}
\alias{gdal_alg}
\alias{gdal_global_reg_names}
\title{Functions for using GDAL CLI algorithms}
\usage{
gdal_commands(contains = NULL, recurse = TRUE, cout = TRUE)

gdal_usage(cmd = NULL)

gdal_run(
  cmd,
  args,
  close = FALSE,
  quiet = FALSE,
  setVectorArgsFromObject = TRUE
)

gdal_run_piped(
  input,
  cmd,
  output = NULL,
  output_format = NULL,
  other_args = NULL,
  output_index = 1,
  outputLayerNameForOpen = NULL
)

gdal_alg(cmd = NULL, args = NULL, parse = TRUE)

gdal_global_reg_names()
}
\arguments{
\item{contains}{Optional character string for filtering output to certain
commands, e.g., \code{gdal_commands("vector")}.}

\item{recurse}{Logical value, \code{TRUE} to include all subcommands recursively
(the default). Set to \code{FALSE} to include only the top-level \code{gdal} commands
(i.e., \code{raster}, \code{vector}, etc.)}

\item{cout}{Logical value, \code{TRUE} to print a list of commands along with
their descriptions and help URLS to the console (the default).}

\item{cmd}{A character string or character vector containing the path to the
algorithm, e.g., \code{"raster reproject"} or \code{c("raster", "reproject")}.
Defaults to \code{"gdal"}, the main entry point to CLI commands.}

\item{args}{Either a character vector or a named list containing input
arguments of the algorithm (see section \verb{Algorithm Argument Syntax} below).}

\item{close}{Logical value, \code{FALSE} by default. Set to \code{TRUE} to finalize
the algorithm immediately after it is run, which completes any pending
actions such as closing output datasets. This is useful if you do not need to
access the output as objects, e.g., when only generating file output for
later use. See \code{GDALAlg$close()}.}

\item{quiet}{Logical value, \code{FALSE} by default. Set to \code{TRUE} to suppress
progress reporting along with various messages and warnings. Sets the value
of \code{GDALAlg$quiet}.}

\item{setVectorArgsFromObject}{Logical value, \code{TRUE} to set algorithm
arguments automatically when the \code{"input"} argument or the \code{"like"} argument
is an object of class \code{GDALVector} (the default). Can be set to \code{FALSE} to
disable automatically setting algorithm arguments from \code{GDALVector} input
(see Note).}

\item{input}{Value passed as input to the GDAL algorithm specified in \code{cmd}
(i.e., the \code{"input"}, \code{"dataset"} or \code{"source"} argument for the command).
Typically this is a dataset name (e.g., file or database connection string),
or an object of class \code{GDALRaster} or \code{GDALVector}.}

\item{output}{Value passed for the \code{"output"} (or \code{"destination"}) argument
of \code{cmd}. Typically this is a filename for commands that generate a raster
or vector dataset or other file output. May be \code{NULL} or empty string (\code{""})
if \code{output_format} is \code{"MEM"} (in-memory dataset).}

\item{output_format}{Optional character string specifying the output format,
e.g., a format driver short name when output is a raster or vector dataset.
Will be passed to the algorithm's optional \code{"output-format"} argument.}

\item{other_args}{Either a character vector or a named list containing other
input arguments of the algorithm (i.e., other than those already specified
via \code{input}, \code{output} and \code{output_format} above, see also the section
\verb{Algorithm Argument Syntax} below).}

\item{output_index}{Optional numeric value or character string giving the
list index or output argument name for an algorithm with more than one
output. Defaults to \code{1}.}

\item{outputLayerNameForOpen}{Optional character string specifying a layer
name to open when obtaining algorithm output as an object of class
\code{GDALVector} (see the class method \link[=GDALAlg]{GDALAlg$output()}). Defaults to
empty string (\code{""}) in which case the first layer by index is opened.
Ignored if output is not a vector dataset.}

\item{parse}{Logical value, \code{TRUE} to attempt parsing \code{args} if they are
given in \code{gdal_alg()} (the default). Set to \code{FALSE} to instantiate the
algorithm without parsing arguments. The \code{$parseCommandLineArgs()}
method on the returned object can be called to parse arguments and obtain
the result of that, with potentially useful error messages.}
}
\description{
This set of functions can be used to access and run \code{gdal} command line
interface (CLI) algorithms.

\strong{Requires GDAL >= 3.11.3}

\strong{Experimental} (see the section \verb{Development Status} below)
}
\details{
These functions provide an interface to GDAL CLI algorithms by way of the
C++ exposed class \code{\link{GDALAlg}}. See the class documentation for
additional information (\code{?GDALAlg}).

\code{gdal_commands()} prints a list of commands and their descriptions to the
console, and returns (invisibly) a data frame with columns \code{command},
\code{description}, \code{URL}. The \code{contains} argument can be used to filter the
output, e.g., \code{gdal_commands("vector")} to return only commands for working
with vector inputs.

\code{gdal_usage()} prints a help message to the console for a given command, or
for the root \code{gdal} entry point if called with no argument. No return value,
called for that side effect only.

\code{gdal_run()} executes a GDAL CLI algorithm and returns it as an object of
class \code{\link{GDALAlg}}. A list containing algorithm output(s) can be
accessed by calling the \code{$outputs()} method (plural) on the returned
object, or, more conveniently in most cases, by calling \code{$output()}
(singular) to return the the single output value when there is only one.
After assigning the output, or otherwise completing work with the \code{GDALAlg}
object, its \code{$release()} method can be called to close datasets and
free resources.

\code{gdal_run_piped()} is a variation of \code{gdal_run()}. It is suitable for use
with the R native pipe operator (\verb{|>}), but may be useful stand-alone when
it is desirable to obtain the output of the algorithm directly, and access
to the \code{GDALAlg} object itself is not needed. The first argument to this
function is passed to the \code{"input"} (or \code{"dataset"} or \code{"source"}) argument
of the algorithm (i.e., as input to the GDAL command specified in \code{cmd}). The
function returns (invisibly) the output of the CLI algorithm if it has one.
If the algorithm has multiple outputs, the first by index is returned by
default but this can be controlled by the \code{output_index} argument (numeric
index or character name of the desired output). Logical \code{TRUE} is returned
invisibly if the algorithm has no output and no error was reported by the
\code{run()} method of the algorithm object. Logical \code{FALSE} is returned invisibly
but a message printed if an error occurs. The algorithm object used
internally is always finalized before return.

\code{gdal_alg()} instantiates and returns an object of class \code{\link{GDALAlg}}
without running it. Passing argument values to the requested CLI algorithm is
optional. This function may be useful (with or without argument values) for
obtaining algorithm properties with the returned object's \code{$info()}
method, obtaining properties of algorithm arguments
(\code{$argInfo(arg_name)}), or obtaining algorithm usage as a
JSON-formatted string (\code{$usageAsJSON()}).
This function is simply an alternative to calling the \code{new()} constructor
for class \code{GDALAlg}. Executing the returned algorithm is optional by calling
the object's \code{$run()} method (assuming argument values were given).

\code{gdal_global_reg_names()} returns a character vector containing the names of
the algorithms in the GDAL global algorithm registry. These are the
top-level nodes (\code{raster}, \code{vector}, etc.) known to GDAL. Potentially code
external to GDAL could register a new command available for CLI use in a
GDAL plugin. This function may be useful in certain troubleshooting
scenarios. It will return a vector of length zero if no names are returned
from the global registry.
}
\note{
Commands do not require the leading \code{"gdal"} root node. They may begin
with a top-level command (e.g., \code{"raster"}, \code{"vector"}, etc.).

When using argument names as the element names of a list, the underscore
character can be substituted for the dash characters that are used in some
names. This avoids having to surround names in backticks when they are used
to access list elements in the form \code{args$arg_name} (the form
\code{args[["arg-name"]]} also works).

When \code{setVectorArgsFromObject} is \code{TRUE} (the default) and the \code{"input"} or
\code{"like"} argument for an algorithm is given as a \code{GDALVector} object,
corresponding algorithm arguments will be set automatically based on
properties of the object (when the argument is available to the algorithm):
\itemize{
\item \code{"input-format"}: set to the \code{GDALVector} object's driver short name
\item \code{"input-layer"}: set to the \code{GDALVector} layer name if it is not a SQL
layer
\item \code{"sql"}: set to the SQL statement if the \code{GDALVector} layer is defined by
one
\item \code{"dialect"}: set to the SQL dialect if one is specified for a SQL layer
\item \code{"like-layer"}: set to the \code{GDALVector} layer name if it is not a SQL
layer
\item \code{"like-sql"}: set to the SQL statement if the \code{GDALVector} layer is
defined by one
}

Argument values specified explicitly will override the automatic setting (as
long as they result in a parsable set of arguments). If
\code{setVectorArgsFromObject} is \code{FALSE}, then only the vector dataset is passed
to the algorithm, i.e., without automatically passing any layer
specifications.
}
\section{Algorithm Argument Syntax}{

Arguments are given in \R as a character vector or named list, but
otherwise syntax basically matches the GDAL specification for arguments as
they are given on the command line. Those specifications are listed here
along with some amendments regarding the character vector and named list
formats. Programmatic usage also allows passing and receiving datasets as
objects (i.e., \code{GDALRaster} or \code{GDALVector}), in addition to dataset names
(e.g., filename, URL, database connection string).
\itemize{
\item Commands accept one or several positional arguments, typically for dataset
names (or in \R as \code{GDALRaster} or \code{GDALVector} datasets). The order is
input(s) first, output last. Positional arguments can also be specified as
named arguments, if preferred to avoid any ambiguity.
\item Named arguments have:
\itemize{
\item at least one "long" name, preceded by two dash characters
\item optionally, auxiliary long names (i.e., aliases),
\item and optionally a one-letter short name, preceded by a single dash
character, e.g., \code{-f, --of, --format, --output-format <OUTPUT-FORMAT>}
}
\item Boolean arguments are specified by just specifying the argument name in
character vector format. In \R \code{list} format, the named element must be
assigned a value of logical \code{TRUE}.
\item Arguments that require a value are specified like:
\itemize{
\item \code{-f VALUE} for one-letter short names
\item \code{--format VALUE} or \code{--format=VALUE} for long names
\item in a named list, this might look like: \code{args$format <- VALUE}
}
\item Some arguments can be multi-valued. Some of them require all values to be
packed together and separated with comma. This is, e.g., the case of:\cr
\code{--bbox <BBOX> Clipping bounding box as xmin,ymin,xmax,ymax} \cr
e.g., \code{--bbox=2.1,49.1,2.9,49.9}
\item Others accept each value to be preceded by a new mention of the argument
name, e.g., \code{c("--co", "COMPRESS=LZW", "--co", "TILED=YES")}. For that
one, if the value of the argument does not contain commas, the packed form
is also accepted: \code{--co COMPRESS=LZW,TILED=YES}. Note that repeated
mentions of an argument are possible in the character vector format for
argument input, whereas arguments given in named list format must use
argument long names as the list element names, and the packed format for the
values (which can be a character vector or numeric vector of values).
\item Named arguments can be placed before or after positional arguments.
}
}

\section{Development Status}{

The GDAL Command Line Interface Modernization was first introduced in the
\href{https://github.com/OSGeo/gdal/releases/tag/v3.11.0}{GDAL 3.11.0 release}
(2025-05-09). The GDAL project provides warning that the new CLI "is
provisionally provided as an alternative interface to GDAL and OGR command
line utilities. The project reserves the right to modify, rename,
reorganize, and change the behavior until it is officially frozen via PSC
vote in a future major GDAL release. The utility needs time to mature,
benefit from incremental feedback, and explore enhancements without carrying
the burden of full backward compatibility. Your usage of it should have no
expectation of compatibility until that time."
(\url{https://gdal.org/en/latest/programs/#gdal-application})

Initial bindings to enable programmatic use of the CLI algorithms from \R
were added in \pkg{gdalraster} 2.2.0, and will evolve over future releases.
\emph{The bindings are considered experimental until the upstream API is declared
stable}. Breaking changes in minor version releases are possible until then.
Please use with those cautions in mind. Bug reports may be filed at:
\url{https://github.com/firelab/gdalraster/issues}.
}

\examples{
\dontshow{if (length(gdal_global_reg_names()) > 0) withAutoprint(\{ # examplesIf}
## top-level commands
gdal_commands(recurse = FALSE)

## convert storml_elev.tif to GeoPackage raster
gdal_commands("convert")

gdal_usage("raster convert")

f_tif <- system.file("extdata/storml_elev.tif", package="gdalraster")
f_gpkg <- file.path(tempdir(), "storml_elev.gpkg")
args <- c("--overwrite", f_tif, f_gpkg)

# finalize the algorithm immediately after it is run if only generating
# file output for later use:
# gdal_run("raster convert", args, close = TRUE)

# or, assign to a variable and access algorithm output as a dataset object
(alg <- gdal_run("raster convert", args))

(ds <- alg$output())

alg$release()

plot_raster(ds, legend = TRUE)

ds$close()
unlink(f_gpkg)

## use the R native pipe operator

if (requireNamespace("ltc")) {
  # make a of plot of 'terrain ruggedness index' (TRI) for Storm Lake AOI
  system.file("extdata/storml_elev.tif", package="gdalraster") |>
    gdal_run_piped("raster tri", "", "MEM") |>
    plot_raster(legend = TRUE,
                minmax_pct_cut = c(0, 99),
                col_map_fn = rev(ltc::ltc("heatmap3")),
                main = "Storm Lake AOI: terrain ruggedness index")
}

## get help for vector commands
gdal_usage("vector")

## clip a vector layer by a bounding box
gdal_usage("vector clip")

f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
f_clip <- file.path(tempdir(), "ynp_fires_clip.gpkg")

# some multi-valued arguments require all values packed and comma separated
# e.g., --bbox <BBOX>
bb <- c(469686, 11442, 544070, 85508)
bb <- paste(bb, collapse = ",")

args <- c("--bbox", bb, "--overwrite", f, f_clip)
(alg <- gdal_run("vector clip", args))

(lyr <- alg$output())

lyr$bbox()

lyr$getFeatureCount()

lyr$close()
alg$release()
unlink(f_clip)

## rasterize a vector layer and return output as a GDALRaster object
gdal_usage("vector rasterize")

f_out = file.path(tempdir(), "ynp_fire_year.tif")

# arguments in list format
args <- list(input = f,
             sql = "SELECT * FROM mtbs_perims ORDER BY ig_year",
             attribute_name = "ig_year",
             output = f_out,
             overwrite = TRUE,
             creation_option = c("TILED=YES", "COMPRESS=DEFLATE"),
             resolution = c(90, 90),
             output_data_type = "Int16",
             init = -32767,
             nodata = -32767)

(alg <- gdal_run("vector rasterize", args))

(ds <- alg$output())

alg$release()

if (requireNamespace("scales")) {
  pal <- scales::viridis_pal(end = 0.8, direction = -1)(6)
  ramp <- scales::colour_ramp(pal)
  plot_raster(ds, legend = TRUE, col_map_fn = ramp, na_col = "#d9d9d9",
              main = "YNP Fires 1984-2022 - Most Recent Burn Year")
}

ds$close()
deleteDataset(f_out)

## GDAL CLI pipeline syntax
# "raster pipeline" example 2 from:
# https://gdal.org/en/latest/programs/gdal_raster_pipeline.html
# serialize the command to reproject a GTiff file into GDALG format, and
# then later read the GDALG file
# GDAL Streamed Algorithm format:
# https://gdal.org/en/stable/drivers/raster/gdalg.html

gdal_usage("raster pipeline")

f_tif <- system.file("extdata/storml_elev.tif", package="gdalraster")
f_out <- file.path(tempdir(), "storml_elev_epsg_32100.gdalg.json")

args <- c("read", "--input", f_tif, "!",
          "reproject", "--dst-crs=EPSG:32100", "!",
          "write", "--output", f_out, "--overwrite")

alg <- gdal_run("raster pipeline", args)
alg$release()

# content of the .gdalg.json file
readLines(f_out, warn = FALSE) |> writeLines()

(ds <- new(GDALRaster, f_out))

plot_raster(ds, legend = TRUE)

ds$close()
unlink(f_out)
\dontshow{\}) # examplesIf}
}
\seealso{
\code{\link[=GDALAlg]{GDALAlg-class}}

\code{gdal} Command Line Interface (CLI) \cr
\url{https://gdal.org/en/stable/programs/index.html}

Using \code{gdal} CLI algorithms from R\cr
\url{https://firelab.github.io/gdalraster/articles/use-gdal-cli-from-r.html}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{transform_bounds}
\alias{transform_bounds}
\title{Transform boundary}
\usage{
transform_bounds(
  bbox,
  srs_from,
  srs_to,
  densify_pts = 21L,
  traditional_gis_order = TRUE
)
}
\arguments{
\item{bbox}{Either a numeric vector of length four containing the input
bounding box (xmin, ymin, xmax, ymax), or a four-column numeric matrix
of bounding boxes (or data frame that can be coerced to a four-column
numeric matrix).}

\item{srs_from}{Character string specifying the spatial reference system
for \code{pts}. May be in WKT format or any of the formats supported by
\code{\link[=srs_to_wkt]{srs_to_wkt()}}.}

\item{srs_to}{Character string specifying the output spatial reference
system. May be in WKT format or any of the formats supported by
\code{\link[=srs_to_wkt]{srs_to_wkt()}}.}

\item{densify_pts}{Integer value giving the number of points to use to
densify the bounding polygon in the transformation. Recommended to use \code{21}
(the default).}

\item{traditional_gis_order}{Logical value, \code{TRUE} to use traditional GIS
order of axis mapping (the default) or \code{FALSE} to use authority compliant
axis order (see Note).}
}
\value{
For a single input bounding box, a numeric vector of length four containing
the transformed bounding box in the output spatial reference system
(xmin, ymin, xmax, ymax). For input of multiple bounding boxes,
a four-column numeric matrix with each row containing the corresponding
transformed bounding box (xmin, ymin, xmax, ymax).
}
\description{
\code{transform_bounds()} transforms a bounding box, densifying the edges to
account for nonlinear transformations along these edges and extracting
the outermost bounds. Multiple bounding boxes may be given as rows of a
numeric matrix or data frame. Wrapper of \code{OCTTransformBounds()} in the GDAL
Spatial Reference System API. Requires GDAL >= 3.4.
}
\details{
The following refer to the \emph{output} values \code{xmin}, \code{ymin}, \code{xmax}, \code{ymax}:

If the destination CRS is geographic, the first axis is longitude, and
\code{xmax < xmin} then the bounds crossed the antimeridian. In this scenario
there are two polygons, one on each side of the antimeridian. The first
polygon should be constructed with \verb{(xmin, ymin, 180, ymax)} and the second
with \verb{(-180, ymin, xmax, ymax)}.

If the destination CRS is geographic, the first axis is latitude, and
\code{ymax < ymin} then the bounds crossed the antimeridian. In this scenario
there are two polygons, one on each side of the antimeridian. The first
polygon should be constructed with \verb{(ymin, xmin, ymax, 180)} and the second
with \verb{(ymin, -180, ymax, xmax)}.
}
\note{
\code{traditional_gis_order = TRUE} (the default) means that for geographic CRS
with lat/long order, the data will still be long/lat ordered. Similarly for
a projected CRS with northing/easting order, the data will still be
easting/northing ordered (GDAL's OAMS_TRADITIONAL_GIS_ORDER).

\code{traditional_gis_order = FALSE} means that the data axis will be identical
to the CRS axis (GDAL's OAMS_AUTHORITY_COMPLIANT).

See
\url{https://gdal.org/en/stable/tutorials/osr_api_tut.html#crs-and-axis-order}.
}
\examples{
bb <- c(-1405880.71737, -1371213.76254, 5405880.71737, 5371213.76254)

# traditional GIS axis ordering by  default (lon, lat)
transform_bounds(bb, "EPSG:32761", "EPSG:4326")

# authority compliant axis ordering
transform_bounds(bb, "EPSG:32761", "EPSG:4326",
                 traditional_gis_order = FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_helpers.R
\name{vsi_get_fs_options}
\alias{vsi_get_fs_options}
\title{Return the list of options associated with a virtual file system handler}
\usage{
vsi_get_fs_options(filename, as_list = TRUE)
}
\arguments{
\item{filename}{Filename, or prefix of a virtual file system handler.}

\item{as_list}{Logical scalar. If \code{TRUE} (the default), the XML string
returned by GDAL will be coerced to list. \code{FALSE} to return the configuration
options as a serialized XML string.}
}
\value{
An XML string, or empty string (\code{""}) if no options are declared.
If \code{as_list = TRUE} (the default), the XML string will be coerced to list
with \code{xml2::as_list()}.
}
\description{
\code{vsi_get_fs_options()} returns the list of options associated with a virtual
file system handler. Those options may be set as configuration options with
\code{set_config_option()}.
Wrapper for \code{VSIGetFileSystemOptions()} in the GDAL API.
}
\examples{
vsi_get_fs_options("/vsimem/")

vsi_get_fs_options("/vsizip/")

vsi_get_fs_options("/vsizip/", as_list = FALSE)
}
\seealso{
\code{\link[=set_config_option]{set_config_option()}}, \code{\link[=vsi_get_fs_prefixes]{vsi_get_fs_prefixes()}}

\url{https://gdal.org/en/stable/user/virtual_file_systems.html}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom.R
\name{g_binary_op}
\alias{g_binary_op}
\alias{g_intersection}
\alias{g_union}
\alias{g_difference}
\alias{g_sym_difference}
\title{Binary operations on WKB or WKT geometries}
\usage{
g_intersection(
  this_geom,
  other_geom,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)

g_union(
  this_geom,
  other_geom,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)

g_difference(
  this_geom,
  other_geom,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)

g_sym_difference(
  this_geom,
  other_geom,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)
}
\arguments{
\item{this_geom}{Either a raw vector of WKB or list of raw vectors, or a
character vector containing one or more WKT strings.}

\item{other_geom}{Either a raw vector of WKB or list of raw vectors, or a
character vector containing one or more WKT strings. Must contain the same
number of geometries as \code{this_geom}.}

\item{as_wkb}{Logical value, \code{TRUE} to return the output geometry in WKB
format (the default), or \code{FALSE} to return as WKT.}

\item{as_iso}{Logical value, \code{TRUE} to export as ISO WKB/WKT (ISO 13249
SQL/MM Part 3), or \code{FALSE} (the default) to export as "Extended WKB/WKT".}

\item{byte_order}{Character string specifying the byte order when output is
WKB. One of \code{"LSB"} (the default) or \code{"MSB"} (uncommon).}

\item{quiet}{Logical value, \code{TRUE} to suppress warnings. Defaults to \code{FALSE}.}
}
\value{
A geometry as WKB raw vector or WKT string, or a list/character vector of
geometries as WKB/WKT with length equal to the number of input geometry
pairs.
\code{NULL} (\code{as_wkb = TRUE}) / \code{NA} (\code{as_wkb = FALSE}) is returned with a
warning if WKB input cannot be converted into an OGR geometry object, or if
an error occurs in the call to the underlying OGR API function.
}
\description{
These functions implement operations on pairs of geometries in OGC WKB
or WKT format.
}
\details{
These functions use the GEOS library via GDAL headers.

\code{g_intersection()} returns a new geometry which is the region of
intersection of the two geometries operated on. \code{g_intersects()} can be used
to test if two geometries intersect.

\code{g_union()} returns a new geometry which is the region of
union of the two geometries operated on.

\code{g_difference()} returns a new geometry which is the region of this geometry
with the region of the other geometry removed.

\code{g_sym_difference()} returns a new geometry which is the symmetric
difference of this geometry and the other geometry (union minus
intersection).
}
\note{
\code{this_geom} and \code{other_geom} are assumed to be in the same coordinate
reference system.

Geometry validity is not checked. In case you are unsure of the validity
of the input geometries, call \code{g_is_valid()} before, otherwise the result
might be wrong.
}
\examples{
elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
ds <- new(GDALRaster, elev_file)
g1 <- ds$bbox() |> bbox_to_wkt()
ds$close()

g2 <- "POLYGON ((327381.9 5104541.2, 326824.0 5104092.5, 326708.8 5103182.9,
  327885.2 5102612.9, 329334.5 5103322.4, 329304.2 5104474.5,328212.7
  5104656.4, 328212.7 5104656.4, 327381.9 5104541.2))"

# see spatial predicate defintions at https://en.wikipedia.org/wiki/DE-9IM
g_intersects(g1, g2)  # TRUE
g_overlaps(g1, g2)  # TRUE
# therefore,
g_contains(g1, g2)  # FALSE

g_sym_difference(g1, g2) |> g_area()

g3 <- g_intersection(g1, g2)
g4 <- g_union(g1, g2)
g_difference(g4, g3) |> g_area()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{set_config_option}
\alias{set_config_option}
\title{Set GDAL configuration option}
\usage{
set_config_option(key, value)
}
\arguments{
\item{key}{Character name of a configuration option.}

\item{value}{Character value to set for the option.
\code{value = ""} (empty string) will unset a value previously set by
\code{set_config_option()}.}
}
\value{
No return value, called for side effects.
}
\description{
\code{set_config_option()} sets a GDAL runtime configuration option.
Configuration options are essentially global variables the user can set.
They are used to alter the default behavior of certain raster format
drivers, and in some cases the GDAL core. For a full description and
listing of available options see
\url{https://gdal.org/en/stable/user/configoptions.html}.
}
\note{
The configuration option \code{"CPL_LOG_ERRORS"} can be set to \code{"OFF"} to disable
printing error massages to the console by GDAL. This only affects messages
printed by GDAL, and does not disable errors, warnings or other messages
emitted by \pkg{gdalraster}. The latter can generally be configured using a
function argument or object-level setting in most cases.
}
\examples{
set_config_option("CPL_LOG_ERRORS", "OFF")
get_config_option("CPL_LOG_ERRORS")
## unset to default:
set_config_option("CPL_LOG_ERRORS", "")
}
\seealso{
\code{\link[=get_config_option]{get_config_option()}}

\code{vignette("gdal-config-quick-ref")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{createColorRamp}
\alias{createColorRamp}
\title{Create a color ramp}
\usage{
createColorRamp(
  start_index,
  start_color,
  end_index,
  end_color,
  palette_interp = "RGB"
)
}
\arguments{
\item{start_index}{Integer start index (raster value).}

\item{start_color}{Integer vector of length three or four.
A color entry value to start the ramp (e.g., RGB values).}

\item{end_index}{Integer end index (raster value).}

\item{end_color}{Integer vector of length three or four.
A color entry value to end the ramp (e.g., RGB values).}

\item{palette_interp}{One of "Gray", "RGB" (the default), "CMYK" or "HLS"
describing interpretation of \code{start_color} and \code{end_color} values
(see \href{https://gdal.org/en/stable/user/raster_data_model.html#color-table}{GDAL
Color Table}).}
}
\value{
Integer matrix with five columns containing the color ramp from
\code{start_index} to \code{end_index}, with raster index values in column 1 and
color entries in columns 2:5).
}
\description{
\code{createColorRamp()} is a wrapper for \code{GDALCreateColorRamp()} in the GDAL
API. It automatically creates a color ramp from one color entry to another.
Output is an integer matrix in color table format for use with
\code{\link[=GDALRaster]{GDALRaster$setColorTable()}}.
}
\note{
\code{createColorRamp()} could be called several times, using \code{rbind()} to
combine multiple ramps into the same color table. Possible duplicate rows
in the resulting table are not a problem when used in
\code{GDALRaster$setColorTable()} (i.e., when \code{end_color} of one ramp is the
same as \code{start_color} of the next ramp).
}
\examples{
# create a color ramp for tree canopy cover percent
# band 5 of an LCP file contains canopy cover
lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
ds <- new(GDALRaster, lcp_file)
ds$getDescription(band=5)
ds$getMetadata(band=5, domain="")
ds$close()

# create a GTiff file with Byte data type for the canopy cover band
# recode nodata -9999 to 255
tcc_file <- calc(expr = "ifelse(CANCOV == -9999, 255, CANCOV)",
                 rasterfiles = lcp_file,
                 bands = 5,
                 var.names = "CANCOV",
                 fmt = "GTiff",
                 dtName = "Byte",
                 nodata_value = 255,
                 setRasterNodataValue = TRUE)

ds_tcc <- new(GDALRaster, tcc_file, read_only=FALSE)

# create a color ramp from 0 to 100 and set as the color table
colors <- createColorRamp(start_index = 0,
                          start_color = c(211, 211, 211),
                          end_index = 100,
                          end_color = c(0, 100, 0))

print(colors)
ds_tcc$setColorTable(band=1, col_tbl=colors, palette_interp = "RGB")
ds_tcc$setRasterColorInterp(band = 1, col_interp = "Palette")

# close and re-open the dataset in read_only mode
ds_tcc$open(read_only=TRUE)

plot_raster(ds_tcc, interpolate = FALSE, legend = TRUE,
            main = "Storm Lake Tree Canopy Cover (\%)")
ds_tcc$close()
\dontshow{deleteDataset(tcc_file)}
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster$getColorTable()}},
\code{\link[=GDALRaster]{GDALRaster$getPaletteInterp()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{gdal_get_driver_md}
\alias{gdal_get_driver_md}
\title{Get metadata for a GDAL format driver}
\usage{
gdal_get_driver_md(format, mdi_name = "")
}
\arguments{
\item{format}{Character string giving a format driver short name
(e.g., \code{"GTiff"}).}

\item{mdi_name}{Optional character string giving the name of a specific
metadata item. Defaults to empty string (\code{""}) meaning fetch all metadata
items.}
}
\value{
Either a named list of metadata items and their values as character
strings, or a single character string if \code{mdi_name} is specified. Returns
\code{NULL} if no metadata items are found for the given inputs.
}
\description{
\code{gdal_get_driver_md()} returns metadata for a driver.
}
\examples{
dmd <- gdal_get_driver_md("GTiff")
str(dmd)
}
\seealso{
\code{\link[=getCreationOptions]{getCreationOptions()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdalraster_proc.R
\name{pixel_extract}
\alias{pixel_extract}
\title{Extract pixel values at geospatial point locations}
\usage{
pixel_extract(
  raster,
  xy,
  bands = NULL,
  interp = NULL,
  krnl_dim = NULL,
  xy_srs = NULL,
  max_ram = 300,
  as_data_frame = NULL
)
}
\arguments{
\item{raster}{Either a character string giving the filename of a raster, or
an object of class \code{GDALRaster} for the source dataset.}

\item{xy}{A two-column numeric matrix or two-column data frame of geospatial
coordinates (x, y), or a vector for a single point (x, y), in the same
spatial reference system as \code{raster}. Can also be given as a data frame with
three or more columns, in which the first column must be a vector of point
IDs (\code{character} or \code{numeric}), and the second and third columns must contain
the geospatial coordinates (x, y).}

\item{bands}{Optional numeric vector of band numbers. All bands in \code{raster}
will be processed by default if not specified, or if \code{0} is given.}

\item{interp}{Optional character string specifying an interpolation method.
Must be one of \code{"bilinear"}, \code{"cubic"}, \code{"cubicspline"}, or \code{"nearest"} (the
default if not specified, i.e., no interpolation).
GDAL >= 3.10 is required for \code{"cubic"} and \code{"cubicspline"}.}

\item{krnl_dim}{Optional numeric value specifying the dimension \code{N} pixels
of an \verb{N x N} kernel for which all individual pixel values will be returned.
Should be a positive whole number (will be coerced to integer by truncation).
Currently only supported when extracting from a single raster band. Ignored
if \code{interp} is specified as other than \code{"nearest"} (i.e., the kernel implied
by the interpolation method will always be used).}

\item{xy_srs}{Optional character string specifying the spatial reference
system for \code{xy}. May be in WKT format or any of the formats supported by
\code{\link[=srs_to_wkt]{srs_to_wkt()}}.}

\item{max_ram}{Numeric value giving the maximum amount of RAM (in MB) to
use for potentially copying a remote raster into memory for processing
(see Note). Defaults to 300 MB. Set to zero to disable potential copy of
remote files into memory.}

\item{as_data_frame}{Logical value, \code{TRUE} to return output as a data frame.
The default is to return a numeric matrix unless point IDs are present in
the first column of \code{xy} given as a data frame. In that latter case, the
output will always be a data frame with the point IDs in the first column.}
}
\value{
A numeric matrix or data frame of pixel values with number of rows
equal to the number of rows in \code{xy}. The number of columns is equal to the
number of \code{bands} (plus optional point ID column), or if \code{krnl_dim = N}
is used, number of columns is equal to \code{N * N} (plus optional point ID
column). Output is always a data frame if \code{xy} is given as a data frame with
a column of point IDs (\code{as_data_frame} will be ignored in that case).
Named columns indicate the band, e.g., \code{"b1"}. If \code{krnl_dim} is used, named
columns indicate band and pixel, e.g., \code{"b1_p1"}, \code{"b1_p2"}, ..., \code{"b1_p9"}
if \code{krnl_dim = 3}. Pixels are in left-to-right, top-to-bottom order in the
kernel.
}
\description{
\code{pixel_extract()} returns raster pixel values for a set of geospatial
point locations. The coordinates are given as a two-column matrix of x/y
values in the same spatial reference system as the input raster (unless
\code{xy_srs} is specified). Coordinates can also be given in a data frame with
an optional column of point IDs.
Values are extracted from all bands of the raster by default, or specific
band numbers may be given. An optional interpolation method may be specified
for bilinear (2 x 2 kernel), cubic convolution (4 x 4 kernel, GDAL >= 3.10),
or cubic spline (4 x 4 kernel, GDAL >= 3.10). Alternatively, an optional
kernel dimension \code{N} may be given to extract values of the individual pixels
within an \verb{N x N} kernel centered on the pixel containing the point location.
If \code{xy_srs} is given, the function will attempt to transform the input points
to the projection of the raster with a call to \code{transform_xy()}.
}
\note{
Depending on the number of input points, extracting from a raster on a
remote filesystem may require a large number of HTTP range requests which
may be slow (i.e., URLs/remote VSI filesystems). In that case, it may be
faster to copy the raster into memory first (either as MEM format or to a
/vsimem/ filesystem).
\code{pixel_extract()} will attempt to automate that process if the total size
of file(s) that would be copied does not exceed the threshold given by
\code{max_ram}, and \code{nrow(xy) > 10} (requires GDAL >= 3.6).

For alternative workflows that involve copying to local storage, the data
management functions (e.g., \code{\link[=copyDatasetFiles]{copyDatasetFiles()}}) and the VSI filesystem
functions (e.g., \code{\link[=vsi_is_local]{vsi_is_local()}}, \code{\link[=vsi_stat]{vsi_stat()}}, \code{\link[=vsi_copy_file]{vsi_copy_file()}}) may be
of interest.
}
\examples{
pt_file <- system.file("extdata/storml_pts.csv", package="gdalraster")
# id, x, y in NAD83 / UTM zone 12N, same as the raster
pts <- read.csv(pt_file)
print(pts)

raster_file <- system.file("extdata/storml_elev.tif", package="gdalraster")

pixel_extract(raster_file, pts)

# or as GDALRaster object
ds <- new(GDALRaster, raster_file)
# optionally suppress progress reporting
# ds$quiet <- TRUE
pixel_extract(ds, pts)

# interpolated values
pixel_extract(raster_file, pts, interp = "bilinear")

# individual pixel values within a kernel
pixel_extract(raster_file, pts, krnl_dim = 3)

# lont/lat xy
pts_wgs84 <- transform_xy(pts[-1], srs_from = ds$getProjection(),
                          srs_to = "WGS84")

# transform the input xy
pixel_extract(ds, xy = pts_wgs84, xy_srs = "WGS84")

ds$close()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdalraster.R
\name{GDALRaster-class}
\alias{GDALRaster-class}
\alias{Rcpp_GDALRaster}
\alias{Rcpp_GDALRaster-class}
\alias{GDALRaster}
\title{Class encapsulating a raster dataset and associated band objects}
\arguments{
\item{filename}{Character string containing the file name of a raster
dataset to open, as full path or relative to the current working directory.
In some cases, \code{filename} may not refer to a local file system, but instead
contain format-specific information on how to access a dataset such
as database connection string, URL, /vsiPREFIX/, etc. (see GDAL
raster format descriptions:
\url{https://gdal.org/en/stable/drivers/raster/index.html}).}

\item{read_only}{Logical. \code{TRUE} to open the dataset read-only (the default),
or \code{FALSE} to open with write access.}

\item{open_options}{Optional character vector of \code{NAME=VALUE} pairs
specifying dataset open options.}

\item{shared}{Logical. \code{FALSE} to open the dataset without using shared
mode. Default is \code{TRUE} (see Note).}

\item{allowed_drivers}{Optional character vector of driver short names that
must be considered. By default, all known raster drivers are considered.}
}
\value{
An object of class \code{GDALRaster}, which contains a pointer to the
opened dataset.
Class methods that operate on the dataset are described in Details, along
with a set of writable fields for per-object settings. Values may be
assigned to the class fields as needed during the lifetime of the object
(i.e., by regular \code{<-} or \code{=} assignment).
}
\description{
\code{GDALRaster} provides an interface for accessing a raster dataset via GDAL
and calling methods on the underlying \code{GDALDataset}, \code{GDALDriver} and
\code{GDALRasterBand} objects. See \url{https://gdal.org/en/stable/api/index.html}
for details of the GDAL Raster API.

\code{GDALRaster} is a C++ class exposed directly to \R (via
\code{RCPP_EXPOSED_CLASS}). Fields and methods of the class are accessed using
the \code{$} operator. \strong{Note that all arguments to class methods are required
and must be given in the order documented.} Naming the arguments is
optional but may be preferred for readability.
}
\note{
If a dataset object is opened with update access (\code{read_only = FALSE}), it
is not recommended to open a new dataset on the same underlying \code{filename}.

Datasets are opened in shared mode by default. This allows the sharing of
\code{GDALDataset} handles for a dataset with other callers that open shared on
the same \code{filename}, if the dataset is opened from the same thread.
Functions in \code{gdalraster} that do processing will open input datasets in
shared mode. This provides potential efficiency for cases when an object of
class \code{GDALRaster} is already open in read-only mode on the same \code{filename}
(avoids overhead associated with initial dataset opening by using the
existing handle, and potentially makes use of existing data in the GDAL
block cache). Opening in shared mode can be disabled by specifying the
optional \code{shared} parameter in the class constructor.

The \code{$read()} method will perform automatic resampling if the
specified output size (\code{out_xsize * out_ysize}) is different than
the size of the region being read (\code{xsize * ysize}). In that case, the
\code{GDAL_RASTERIO_RESAMPLING} configuration option could also be set to
override the default resampling to one of \code{BILINEAR}, \code{CUBIC},
\code{CUBICSPLINE}, \code{LANCZOS}, \code{AVERAGE} or \code{MODE} (see \code{\link[=set_config_option]{set_config_option()}}).
}
\section{Usage (see Details)}{


\if{html}{\out{<div class="sourceCode">}}\preformatted{## Constructors
# read-only by default:
ds <- new(GDALRaster, filename)
# for update access:
ds <- new(GDALRaster, filename, read_only = FALSE)
# to specify dataset open options:
ds <- new(GDALRaster, filename, read_only = TRUE|FALSE, open_options)
# to open without using shared mode:
new(GDALRaster, filename, read_only, open_options, shared = FALSE)
# to specify certain allowed driver(s):
new(GDALRaster, filename, read_only, open_options, shared, allowed_drivers)

## Read/write fields (per-object settings)
ds$infoOptions
ds$quiet
ds$readByteAsRaw

## Methods
ds$getFilename()
ds$setFilename(filename)
ds$open(read_only)
ds$isOpen()
ds$isReadOnly()
ds$getFileList()

ds$info()
ds$infoAsJSON()

ds$getDriverShortName()
ds$getDriverLongName()

ds$getRasterXSize()
ds$getRasterYSize()
ds$getRasterCount()

ds$addBand(dataType, options)

ds$getGeoTransform()
ds$setGeoTransform(transform)

ds$getProjection()
ds$getProjectionRef()
ds$getSpatialRef()
ds$setProjection(projection)

ds$bbox()
ds$res()
ds$dim()
ds$setBbox(bbox)

ds$apply_geotransform(col_row)
ds$get_pixel_line(xy)

ds$get_block_indexing(band)
ds$make_chunk_index(band, max_pixels)

ds$getDescription(band)
ds$setDescription(band, desc)
ds$getBlockSize(band)
ds$getActualBlockSize(band, xblockoff, yblockoff)
ds$getOverviewCount(band)
ds$buildOverviews(resampling, levels, bands)
ds$getDataTypeName(band)
ds$getNoDataValue(band)
ds$setNoDataValue(band, nodata_value)
ds$deleteNoDataValue(band)
ds$getMaskFlags(band)
ds$getMaskBand(band)
ds$getUnitType(band)
ds$setUnitType(band, unit_type)
ds$getScale(band)
ds$setScale(band, scale)
ds$getOffset(band)
ds$setOffset(band, offset)
ds$getRasterColorInterp(band)
ds$setRasterColorInterp(band, col_interp)

ds$getMinMax(band, approx_ok)
ds$getMinMaxLocation(band)
ds$getStatistics(band, approx_ok, force)
ds$clearStatistics()

ds$getHistogram(band, min, max, num_buckets, incl_out_of_range, approx_ok)
ds$getDefaultHistogram(band, force)

ds$getInterBandCovMatrix(bands, approx_ok, force, write_in_metadata,
                         df_correction)

ds$getMetadata(band, domain)
ds$setMetadata(band, metadata, domain)
ds$getMetadataItem(band, mdi_name, domain)
ds$setMetadataItem(band, mdi_name, mdi_value, domain)
ds$getMetadataDomainList(band)

ds$read(band, xoff, yoff, xsize, ysize, out_xsize, out_ysize)
ds$readBlock(band, xblockoff, yblockoff)
ds$readChunk(band, chunk_def)
ds$readToNativeRaster(xoff, yoff, xsize, ysize, out_xsize, out_ysize)

ds$write(band, xoff, yoff, xsize, ysize, rasterData)
ds$writeBlock(band, xblockoff, yblockoff, rasterData)
ds$writeChunk(band, chunk_def, rasterData)
ds$fillRaster(band, value, ivalue)

ds$getColorTable(band)
ds$getPaletteInterp(band)
ds$setColorTable(band, col_tbl, palette_interp)
ds$clearColorTable(band)

ds$getDefaultRAT(band)
ds$setDefaultRAT(band, df)

ds$flushCache()

ds$getChecksum(band, xoff, yoff, xsize, ysize)

ds$close()
}\if{html}{\out{</div>}}
}

\section{Details}{

\subsection{Constructors}{

\code{new(GDALRaster, filename, read_only)}\cr
Returns an object of class \code{GDALRaster}. The \code{read_only} argument defaults
to \code{TRUE} if not specified.

\code{new(GDALRaster, filename, read_only, open_options)}\cr
Alternate constructor for passing dataset \code{open_options}, a character
vector of \code{NAME=VALUE} pairs.
\code{read_only} is required for this form of the constructor, \code{TRUE} for
read-only access, or \code{FALSE} to open with write access.
Returns an object of class \code{GDALRaster}.

\code{new(GDALRaster, filename, read_only, open_options, shared)}\cr
Alternate constructor for specifying the \code{shared} mode for dataset opening.
The \code{shared} argument defaults to \code{TRUE} but can be set to \code{FALSE} with this
constructor (see Note).
All arguments are required with this form of the constructor, but
\code{open_options} can be \code{NULL}. Returns an object of class \code{GDALRaster}.

\code{new(GDALRaster, filename, read_only, open_options, shared, allowed_drivers)}\cr
Alternate constructor for specifying the driver(s) allowed for dataset
opening as a character vector of driver short names.
All arguments are required with this form of the constructor, but
\code{open_options} and/or \code{allowed_drivers} can be \code{NULL}. Returns an object of class
\code{GDALRaster}.
}

\subsection{Read/write fields}{

\code{$infoOptions}\cr
A character vector of command-line arguments to control the output of
\code{$info()} and \code{$infoAsJSON()} (see below).
Defaults to \code{character(0)}. Can be set to a vector of strings specifying
arguments to the \command{gdalinfo} command-line utility, e.g.,
\code{c("-nomd", "-norat", "-noct")}.
Restore the default by setting to empty string (\code{""}) or \code{character(0)}.

\code{$quiet}\cr
A logical value, \code{FALSE} by default. This field can be set to \code{TRUE} which
will suppress various messages as well as progress reporting for potentially
long-running processes such as building overviews and computation of
statistics and histograms.

\code{$readByteAsRaw}\cr
A logical value, \code{FALSE} by default. This field can be set to \code{TRUE} which
will affect the data type returned by the \code{$read()} method and the
\code{\link[=read_ds]{read_ds()}} convenience function. When the underlying band data type is
Byte/UInt8 and \code{readByteAsRaw} is \code{TRUE} the output type will be raw rather
than integer. See also the \code{as_raw} argument to \code{\link[=read_ds]{read_ds()}} to control this
in a non-persistent setting. If the underlying band data type is not
Byte/UInt8 setting has no effect. (Note Byte = UInt8 in GDAL >= 3.13.)
}

\subsection{Methods}{

\code{$getFilename()}\cr
Returns a character string containing the \code{filename} associated with this
\code{GDALRaster} object (\code{filename} originally used to open the dataset). May
be a regular filename, database connection string, URL, etc.

\code{$setFilename(filename)}\cr
Sets the \code{filename} if the underlying dataset does not already have an
associated filename. Explicitly setting the filename is an advanced
setting that should only be used when the user has determined that it is
needed. Writing certain virtual datasets to file is one potential use case
(e.g., a dataset returned by \code{autoCreateWarpedVRT()}).

\code{$open(read_only)}\cr
(Re-)opens the raster dataset on the existing filename. Use this method to
open a dataset that has been closed using \code{$close()}. May be used to
re-open a dataset with a different read/write access (\code{read_only} set to
\code{TRUE} or \code{FALSE}). The method will first close an open dataset, so it is
not required to call \code{$close()} explicitly in this case.
No return value, called for side effects.

\code{$isOpen()}\cr
Returns a logical value, \code{TRUE} if the raster dataset is open.

\code{$isReadOnly()}\cr
Returns a logical value, \code{TRUE} if the raster dataset has read-only access
or \code{FALSE} if it is writable.

\code{$getFileList()}\cr
Returns a character vector of files believed to be part of this dataset.
If it returns an empty string (\code{""}) it means there is believed to be no
local file system files associated with the dataset (e.g., a virtual file
system). The returned filenames will normally be relative or absolute
paths depending on the path used to originally open the dataset.

\code{$info()}\cr
Prints various information about the raster dataset to the console (no
return value, called for that side effect only).
Equivalent to the output of the \command{gdalinfo} command-line utility
(\command{gdalinfo filename}, if using the default \code{infoOptions}).
See the field \code{$infoOptions} above for setting the arguments to
\code{gdalinfo}.

\code{$infoAsJSON()}\cr
Returns information about the raster dataset as a JSON-formatted string.
Equivalent to the output of the \command{gdalinfo} command-line utility
(\command{gdalinfo -json filename}, if using the default \code{infoOptions}).
See the field \code{$infoOptions} above for setting the arguments to
\code{gdalinfo}.

\code{$getDriverShortName()}\cr
Returns the short name of the raster format driver.

\code{$getDriverLongName()}\cr
Returns the long name of the raster format driver.

\code{$getRasterXSize()}\cr
Returns the number of pixels along the x dimension.

\code{$getRasterYSize()}\cr
Returns the number of pixels along the y dimension.

\code{$getRasterCount()}\cr
Returns the number of raster bands on this dataset. For the methods
described below that operate on individual bands, the \code{band}
argument is the integer band number (1-based).

\code{$addBand(dataType, options)}\cr
Adds a band to a dataset if the underlying format supports this action.
Most formats do not, but MEM and VRT are notable exceptions that support
adding bands. The added band will always be the last band.
\code{dataType} is a character string containing the data type name
(e.g., \code{"Byte"}, \code{"UInt8"} (GDAL >= 3.13), \code{"Int16"}, \code{"UInt16"}, \code{"Int32"},
\code{"Float32"}, etc).
The \code{options} argument is a character vector of format specific \code{NAME=VALUE}
strings (may be \code{NULL}). For a MEM dataset, \code{options} can also be a vector
of \code{"numeric"}, \code{"integer"}, \code{"raw"} or \code{"complex"} values to be exposed as
a MEM band. In that case, the vector must have length equal to the raster
\code{xsize * ysize}, with values in left to right, top to bottom pixel order.
See also \code{rvector_to_MEM()}. Returns logical \code{TRUE} on success or
\code{FALSE} if a band could not be added.

\code{$getGeoTransform()}\cr
Returns the affine transformation coefficients for transforming between
pixel/line raster space (column/row) and projection coordinate space
(geospatial x/y). The return value is a numeric vector of length six.
See \url{https://gdal.org/en/stable/tutorials/geotransforms_tut.html}
for details of the affine transformation. \emph{With 1-based indexing
in \R}, the geotransform vector contains (in map units of the raster spatial
reference system):
\tabular{rl}{
GT[1] \tab x-coordinate of upper-left corner of the upper-left pixel\cr
GT[2] \tab x-component of pixel width\cr
GT[3] \tab row rotation (zero for north-up raster)\cr
GT[4] \tab y-coordinate of upper-left corner of the upper-left pixel\cr
GT[5] \tab column rotation (zero for north-up raster)\cr
GT[6] \tab y-component of pixel height (negative for north-up raster)
}

\code{$setGeoTransform(transform)}\cr
Sets the affine transformation coefficients on this dataset.
\code{transform} is a numeric vector of length six.
Returns logical \code{TRUE} on success or \code{FALSE} if the geotransform
could not be set.

\code{$getProjection()}\cr
Returns the coordinate reference system of the raster as an OGC WKT
format string. Equivalent to \code{ds$getProjectionRef()}.

\code{$getProjectionRef()}\cr
Returns the coordinate reference system of the raster as an OGC WKT
format string.
An empty string is returned when a projection definition is not available.

\code{$setProjection(projection)}\cr
Sets the projection reference for this dataset.
\code{projection} is a string in OGC WKT format.
Returns logical \code{TRUE} on success or \code{FALSE} if the projection
could not be set.

\code{$getSpatialRef()}\cr
Returns the coordinate reference system of the raster as an OGC WKT
format string. Equivalent to \code{ds$getProjectionRef()}.

\code{$bbox()}\cr
Returns a numeric vector of length four containing the bounding box
(xmin, ymin, xmax, ymax).

\code{$setBbox(bbox)}\cr
Sets the bounding box on this dataset.
\code{bbox} is a numeric vector of length four.
Returns logical \code{TRUE} on success or \code{FALSE} if the bbox
could not be set.

\code{$res()}\cr
Returns a numeric vector of length two containing the resolution
(pixel width, pixel height as positive values) for a non-rotated raster.
A warning is emitted and \code{NA} values returned if the raster has a rotated
geotransform (see method \code{$getGeoTransform()} above).

\code{$dim()}\cr
Returns an integer vector of length three containing the raster dimensions
(xsize, ysize, number of bands).
Equivalent to:

\if{html}{\out{<div class="sourceCode">}}\preformatted{c(ds$getRasterXSize(), ds$getRasterYSize(), ds$getRasterCount())
}\if{html}{\out{</div>}}

\code{$apply_geotransform(col_row)}\cr
Applies geotransform coefficients to raster coordinates in pixel/line space
(column/row), converting into georeferenced (x/y) coordinates.
\code{col_row} is a numeric matrix of raster col/row coordinates (or two-column
data frame that will be coerced to numeric matrix).
Returns a numeric matrix of geospatial x/y coordinates.
See the stand-alone function of the same name (\code{\link[=apply_geotransform]{apply_geotransform()}}) for
more info and examples.

\code{$get_pixel_line(xy)}\cr
Converts geospatial coordinates to pixel/line (raster column/row numbers).
\code{xy} is a numeric matrix of geospatial x,y coordinates in the same spatial
reference system as the raster (or two-column data frame that will be
coerced to numeric matrix). Returns an integer matrix of raster pixel/line.
See the stand-alone function of the same name (\code{\link[=get_pixel_line]{get_pixel_line()}}) for more
info and examples.

\code{$get_block_indexing(band)}\cr
Helper method returning a numeric matrix with named columns: \code{xblockoff},
\code{yblockoff}, \code{xoff}, \code{yoff}, \code{xsize}, \code{ysize}, \code{xmin}, \code{xmax}, \code{ymin},
\code{ymax}. This method provides indexing values for the block layout of the
given \code{band} number. See also the class methods:
\code{$getBlockSize()}, \code{$getActualBlockSize()} and \code{$read()}.
The returned matrix has number of rows equal to the number of blocks for the
given \code{band} number, with blocks ordered left to right, top to bottom. All
offsets are zero-based. The \code{xoff}/\code{yoff} values are pixel offsets to the
start of a block. The \code{xsize}/\code{ysize} values give the actual block sizes
accounting for potentially incomplete blocks along the right and bottom
edges. The columns \code{xmin}, \code{xmax}, \code{ymin} and \code{ymax} give the extent of each
block in geospatial coordinates.

\code{$make_chunk_index(band, max_pixels)}\cr
Helper method returning a numeric matrix with named columns: \code{xchunkoff},
\code{ychunkoff}, \code{xoff}, \code{yoff}, \code{xsize}, \code{ysize}, \code{xmin}, \code{xmax}, \code{ymin},
\code{ymax}. This method generates indexing information (offsets, sizes and
geospatial bounding boxes) for potentially multi-block chunks, defined on
block boundaries for efficient I/O. The output of this method can be used
with the \code{$readChunk()}/\code{$writeChunk()} methods to iterate I/O
operations conveniently on user-defined chunk sizes. The chunks will contain
at most \code{max_pixels} given as a numeric value optionally carrying the
\code{bit64::integer64} class attribute (numeric values will be coerced to 64-bit
integer internally by truncation). A value of \code{max_pixels = 0} (or any value
less than raster block xsize * block ysize, see \code{$getBlockSize()}
below), will return output equivalent to \code{$get_block_indexing()}.
The returned matrix has number of rows equal to the number of chunks for the
given \code{band} number, with chunks ordered left to right, top to bottom. All
offsets are zero-based. The \code{xoff}/\code{yoff} values are pixel offsets to the
start of a chunk. The \code{xsize}/\code{ysize} values give the actual chunk sizes
accounting for potentially incomplete chunks along the right and bottom
edges. The columns \code{xmin}, \code{xmax}, \code{ymin} and \code{ymax} give the extent of each
chunk in geospatial coordinates.

\code{$getDescription(band)}\cr
Returns a string containing the description for \code{band}. An empty
string is returned if no description is set for the band.
Passing \code{band = 0} will return the dataset-level description.

\code{$setDescription(band, desc)}\cr
Sets a description for \code{band}. \code{desc} is the character string
to set. No return value. (Passing \code{band = 0} can be used to set the
dataset-level description. Note that the dataset description is generally
the filename that was used to open the dataset. It usually should not be
changed by calling this method on an existing dataset.)

\code{$getBlockSize(band)}\cr
Returns a numeric vector of length two (xsize, ysize) containing the
"natural" block size of \code{band}. GDAL has a concept of the natural block
size of rasters so that applications can organize data access efficiently
for some file formats. The natural block size is the block size that is
most efficient for accessing the format. For many formats this is simply a
whole row in which case block xsize is the same as \code{$getRasterXSize()}
and block ysize is 1. However, for tiled images block size will typically
be the tile size. Note that the X and Y block sizes don't have to divide
the image size evenly, meaning that right and bottom edge blocks may be
incomplete.

\code{$getActualBlockSize(band, xblockoff, yblockoff)}\cr
Returns a numeric vector of length two (xvalid, yvalid) containing the
actual block size for a given block offset in \code{band}. Handles partial
blocks at the edges of the raster and returns the true number of pixels.
\code{xblockoff} is an integer value, the horizontal block offset for which to
calculate the number of valid pixels, with zero indicating the left most
block, 1 the next block, etc. \code{yblockoff} is likewise the vertical block
offset, with zero indicating the top most block, 1 the next block, etc.

\code{$getOverviewCount(band)}\cr
Returns the number of overview layers (a.k.a. pyramids) available for
\code{band}.

\code{$buildOverviews(resampling, levels, bands)}\cr
Build one or more raster overview images using the specified downsampling
algorithm.
\code{resampling} is a character string, one of \code{AVERAGE},
\code{AVERAGE_MAGPHASE}, \code{RMS}, \code{BILINEAR}, \code{CUBIC}, \code{CUBICSPLINE}, \code{GAUSS},
\code{LANCZOS}, \code{MODE}, \code{NEAREST} or \code{NONE}.
\code{levels} is an integer vector giving the list of overview decimation
factors to build (e.g., \code{c(2, 4, 8)}), or \code{0} to delete all overviews
(at least for external overviews (.ovr) and GTiff internal overviews).
\code{bands} is an integer vector giving a list of band numbers to build
overviews for, or \code{0} to build for all bands.
Note that for GTiff, overviews will be created internally if the dataset is
open in update mode, while external overviews (.ovr) will be created if the
dataset is open read-only.
External overviews created in GTiff format may be compressed using the
\code{COMPRESS_OVERVIEW} configuration option. All compression methods supported
by the GTiff driver are available
(e.g., \code{set_config_option("COMPRESS_OVERVIEW", "LZW")}).
Since GDAL 3.6, \code{COMPRESS_OVERVIEW} is honored when creating internal
overviews of GTiff files. The \href{https://gdal.org/en/stable/programs/gdaladdo.html}{GDAL documentation for \code{gdaladdo}} command-line
utility describes additional configuration for overview building.
See also \code{\link[=set_config_option]{set_config_option()}}. No return value, called for side effects.

\code{$getDataTypeName(band)}\cr
Returns the name of the pixel data type for \code{band}. The possible data
types are:
\tabular{rl}{
Unknown   \tab  Unknown or unspecified type\cr
Byte      \tab  8-bit unsigned integer\cr
Int8      \tab  8-bit signed integer (GDAL >= 3.7)\cr
UInt16    \tab  16-bit unsigned integer\cr
Int16     \tab  16-bit signed integer\cr
UInt32    \tab  32-bit unsigned integer\cr
Int32     \tab  32-bit signed integer\cr
UInt64    \tab  64-bit unsigned integer (GDAL >= 3.5)\cr
Int64     \tab  64-bit signed integer (GDAL >= 3.5)\cr
Float32   \tab  32-bit floating point\cr
Float64   \tab  64-bit floating point\cr
CInt16    \tab  Complex Int16\cr
CInt32    \tab  Complex Int32\cr
CFloat32  \tab  Complex Float32\cr
CFloat64  \tab  Complex Float64
}
Some raster formats including GeoTIFF ("GTiff") and Erdas Imagine .img
("HFA") support sub-byte data types. Rasters can be created with these
data types by specifying the "NBITS=n" creation option where n=1...7 for
GTiff or n=1/2/4 for HFA. In these cases, \code{$getDataTypeName()} reports
the apparent type \code{"Byte"}. GTiff also supports n=9...15 (UInt16 type) and
n=17...31 (UInt32 type), and n=16 is accepted for Float32 to generate
half-precision floating point values.

\code{$getNoDataValue(band)}\cr
Returns the nodata value for \code{band} if one exists.
This is generally a special value defined to mark pixels that are not
valid data. \code{NA} is returned if a nodata value is not defined for
\code{band}. Not all raster formats support a designated nodata value.

\code{$setNoDataValue(band, nodata_value)}\cr
Sets the nodata value for \code{band}.
\code{nodata_value} is a numeric value to be defined as the nodata marker.
Depending on the format, changing the nodata value may or may not have an
effect on the pixel values of a raster that has just been created (often
not). It is thus advised to call \code{$fillRaster()} explicitly if the
intent is to initialize the raster to the nodata value. In any case,
changing an existing nodata value, when one already exists on an initialized
dataset, has no effect on the pixels whose values matched the previous
nodata value.
Returns logical \code{TRUE} on success or \code{FALSE} if the nodata value
could not be set.

\code{$deleteNoDataValue(band)}\cr
Removes the nodata value for \code{band}.
This affects only the definition of the nodata value for raster formats
that support one (does not modify pixel values). No return value.
An error is raised if the nodata value cannot be removed.

\code{$getMaskFlags(band)}\cr
Returns the status flags of the mask band associated with \code{band}.
Masks are represented as Byte bands with a value of zero indicating nodata
and non-zero values indicating valid data. Normally the value \code{255} will be
used for valid data pixels. GDAL supports external (.msk) mask bands, and
normal Byte alpha (transparency) band as mask (any value other than \code{0} to
be treated as valid data). But masks may not be regular raster bands on the
datasource, such as an implied mask from a band nodata value or the
\code{ALL_VALID} mask. See RFC 15: Band Masks for more details
(\url{https://gdal.org/en/stable/development/rfc/rfc15_nodatabitmask.html}.

Returns a named list of GDAL mask flags and their logical values, with the
following definitions:
\itemize{
\item \code{ALL_VALID}: There are no invalid pixels, all mask values will be \code{255}.
When used this will normally be the only flag set.
\item \code{PER_DATASET}: The mask band is shared between all bands on the dataset.
\item \code{ALPHA}: The mask band is actually an alpha band and may have values other
than \code{0} and \code{255}.
\item \code{NODATA}: Indicates the mask is actually being generated from nodata
values (mutually exclusive of \code{ALPHA}).
}

\code{$getMaskBand(band)}\cr
Returns the mask filename and band number associated with \code{band}.
The return value is a named list with two elements. The \code{MaskFile} element
gives the filename where the mask band is located, e.g., a file with the
same name as the main dataset but suffixed with .msk in the case of a GDAL
external mask file. \code{MaskFile} will be an empty string for the derived
\code{ALL_VALID} and \code{NODATA} masks, which internally are freestanding bands not
considered to be a part of a dataset. The \code{MaskBand} element gives the band
number for a mask that is a regular alpha band in the main dataset or
external mask file. \code{BandNumber} will be \code{0} for the \code{ALL_VALID} and \code{NODATA}
masks.

\code{$getUnitType(band)}\cr
Returns the name of the unit type of the pixel values for \code{band}
(e.g., "m" or "ft").
An empty string (\code{""}) is returned if no units are available.

\code{$setUnitType(band, unit_type)}\cr
Sets the name of the unit type of the pixel values for \code{band}.
\code{unit_type} should be one of empty string \code{""} (the default indicating it is
unknown), "m" indicating meters, or "ft" indicating feet, though other
nonstandard values are allowed.
Returns logical \code{TRUE} on success or \code{FALSE} if the unit type
could not be set.

\code{$getScale(band)}\cr
Returns the pixel value scale (units value = (raw value * scale) + offset)
for \code{band}.
This value (in combination with the \code{$getOffset()} value) can be used to
transform raw pixel values into the units returned by \code{$getUnitType()}.
Returns \code{NA} if a scale value is not defined for this \code{band}.

\code{$setScale(band, scale)}\cr
Sets the pixel value scale (units value = (raw value * scale) + offset)
for \code{band}. Many raster formats do not implement this method.
Returns logical \code{TRUE} on success or \code{FALSE} if the scale could
not be set.

\code{$getOffset(band)}\cr
Returns the pixel value offset (units value = (raw value * scale) + offset)
for \code{band}.
This value (in combination with the \code{$getScale()} value) can be used to
transform raw pixel values into the units returned by \code{$getUnitType()}.
Returns \code{NA} if an offset value is not defined for this \code{band}.

\code{$setOffset(band, offset)}\cr
Sets the pixel value offset (units value = (raw value * scale) + offset)
for \code{band}. Many raster formats do not implement this method.
Returns logical \code{TRUE} on success or \code{FALSE} if the offset could
not be set.

\code{$getRasterColorInterp(band)}\cr
Returns a string describing the color interpretation for \code{band}.
The color interpretation values and their meanings, with several additions
in GDAL 3.10:
\tabular{ll}{
Undefined  \tab Undefined\cr
Gray       \tab Grayscale\cr
Palette    \tab Paletted (see associated color table)\cr
Red        \tab Red band of RGBA image\cr
Green      \tab Green band of RGBA image\cr
Blue       \tab Blue band of RGBA image\cr
Alpha      \tab Alpha (0 = transparent, 255 = opaque)\cr
Hue        \tab Hue band of HLS image\cr
Saturation \tab Saturation band of HLS image\cr
Lightness  \tab Lightness band of HLS image\cr
Cyan       \tab Cyan band of CMYK image\cr
Magenta    \tab Magenta band of CMYK image\cr
Yellow     \tab Yellow band of CMYK image\cr
Black      \tab Black band of CMYK image\cr
YCbCr_Y    \tab Y Luminance\cr
YCbCr_Cb   \tab Cb Chroma\cr
YCbCr_Cr   \tab Cr Chroma\cr
\emph{GDAL >= 3.10}: \tab \cr
PanBand    \tab Panchromatic band (0.40 - 1.00 micrometre)\cr
CoastalBand \tab Coastal band (0.40 - 0.45 micrometre)\cr
RedEdgeBand \tab Red-edge band (0.69 - 0.79 micrometre)\cr
NIRBand    \tab Near-InfraRed (NIR) band (0.75 - 1.40 micrometre)\cr
SWIRBand   \tab Short-Wavelength InfraRed (SWIR) band (1.40 - 3.00 micrometres)\cr
MWIRBand   \tab Mid-Wavelength InfraRed (MWIR) band (3.00 - 8.00 micrometres)\cr
LWIRBand   \tab Long-Wavelength InfraRed (LWIR) band (8.00 - 15 micrometres)\cr
TIRBand    \tab Thermal InfraRed (TIR) band (MWIR or LWIR) (3 - 15 micrometres)\cr
OtherIRBand \tab Other infrared band (0.75 - 1000 micrometres)\cr
SAR_Ka_Band \tab SAR Ka band (0.8 - 1.1 cm / 27 - 40 GHz)\cr
SAR_K_Band  \tab SAR K band (1.1 - 1.7 cm / 18 - 27 GHz)\cr
SAR_Ku_Band \tab SAR Ku band (1.7 - 2.4 cm / 12 - 18 GHz)\cr
SAR_X_Band  \tab SAR X band (2.4 - 3.8 cm / 8 - 12 GHz)\cr
SAR_C_Band  \tab SAR C band (3.8 - 7.5 cm / 4 - 8 GHz)\cr
SAR_S_Band  \tab SAR S band (7.5 - 15 cm / 2 - 4 GHz)\cr
SAR_L_Band  \tab SAR L band (15 - 30 cm / 1 - 2 GHz)\cr
SAR_P_Band  \tab SAR P band (30 - 100 cm / 0.3 - 1 GHz)
}

\code{$setRasterColorInterp(band, col_interp)}\cr
Sets the color interpretation for \code{band}. See above for the list of
valid values for \code{col_interp} (passed as a string).

\code{$getMinMax(band, approx_ok)}\cr
Returns a numeric vector of length two containing the min/max values for
\code{band}. If \code{approx_ok} is \code{TRUE} and the raster format knows these
values intrinsically then those values will be returned. If that doesn't
work, a subsample of blocks will be read to get an approximate min/max. If
the band has a nodata value it will be excluded from the minimum and
maximum. If \code{approx_ok} is \code{FALSE}, then all pixels will be read and
used to compute an exact range.

\code{$getMinMaxLocation(band)}\cr
Computes the min/max values for a band, and their locations. Pixels with
value matching the nodata value or masked by the mask band are ignored. If
the minimum or maximum value is hit in several locations, it is not
specified which location will be returned. The locations are returned as
column/row number (0-based), geospatial x/y in the coordinate system of the
raster, and WGS84 longitude/latitude. Returns a numeric vector with the
following named values: \code{min}, \code{min_col}, \code{min_row}, \code{min_geo_x},
\code{min_geo_y}, \code{min_wgs84_lon}, \code{min_wgs84_lat}, \code{max}, \code{max_col}, \code{max_row},
\code{max_geo_x}, \code{max_geo_y}, \code{max_wgs84_lon}, \code{max_wgs84_lat}. This method wraps
\code{GDALComputeRasterMinMaxLocation()} in the GDAL C API requiring GDAL >= 3.11.

\code{$getStatistics(band, approx_ok, force)}\cr
Returns a numeric vector of length four containing the minimum, maximum,
mean and standard deviation of pixel values in \code{band} (excluding
nodata pixels). Some raster formats will cache statistics allowing fast
retrieval after the first request.

\code{approx_ok}:
\itemize{
\item \code{TRUE}: Approximate statistics are sufficient, in which case overviews
or a subset of raster tiles may be used in computing the statistics.
\item \code{FALSE}: All pixels will be read and used to compute statistics (if
computation is forced).
}

\code{force}:
\itemize{
\item \code{TRUE}: The raster will be scanned to compute statistics. Once computed,
statistics will generally be "set" back on the raster band if the format
supports caching statistics.
(Note: \code{ComputeStatistics()} in the GDAL API is called automatically here.
This is a change in the behavior of \code{GetStatistics()} in the API, to a
definitive \code{force}.)
\item \code{FALSE}: Results will only be returned if it can be done quickly (i.e.,
without scanning the raster, typically by using pre-existing
STATISTICS_xxx metadata items). \code{NA}s will be returned if statistics
cannot be obtained quickly.
}

\code{$clearStatistics()}\cr
Clear statistics. Only implemented for now in PAM supported datasets
(Persistable Auxiliary Metadata via .aux.xml file). GDAL >= 3.2.

\code{$getHistogram(band, min, max, num_buckets, incl_out_of_range, approx_ok)}\cr
Computes raster histogram for \code{band}. \code{min} is the lower bound of
the histogram. \code{max} is the upper bound of the histogram.
\code{num_buckets} is the number of buckets to use (bucket size is
\code{(max - min) / num_buckets}).
\code{incl_out_of_range} is a logical scalar: if \code{TRUE} values below the
histogram range will be mapped into the first bucket and values above will
be mapped into the last bucket, if \code{FALSE} out of range values are discarded.
\code{approx_ok} is a logical scalar: \code{TRUE} if an approximate histogram is
OK (generally faster), or \code{FALSE} for an exactly computed histogram.
Returns the histogram as a numeric vector of length \code{num_buckets}.

\code{$getDefaultHistogram(band, force)}\cr
Returns a default raster histogram for \code{band}. In the GDAL API, this
method is overridden by derived classes (such as GDALPamRasterBand,
VRTDataset, HFADataset...) that may be able to fetch efficiently an already
stored histogram. \code{force} is a logical scalar: \code{TRUE} to force the
computation of a default histogram; or if \code{FALSE} and no default histogram
is available, a warning is emitted and the returned list has a 0-length
histogram vector.
Returns a list of length four containing named elements \code{min} (lower
bound), \code{max} (upper bound), \code{num_buckets} (number of buckets), and
\code{histogram} (a numeric vector of length \code{num_buckets}).

\code{$getInterBandCovMatrix(bands, approx_ok, force, write_in_metadata,
                             df_correction)}\cr
Fetch or compute the covariance matrix between bands of this dataset. The
covariance indicates the level to which two bands vary together. Requires
GDAL >= 3.13. See \code{GDALDatasetGetInterBandCovarianceMatrix()} in:
\url{https://gdal.org/en/latest/api/raster_c_api.html}. Returns a square
matrix with dimension equal to the number of bands. \code{bands} may be given as
\code{0} meaning all bands, or may be an integer vector of specific band numbers.
\code{approx_ok} specifies whether it is acceptable to use a subsample of values
(\code{TRUE}), or all pixel values should be used (\code{FALSE}).

\code{force}:
\itemize{
\item \code{TRUE}: The raster will be scanned to compute covariances.
(Note: \code{ComputeInterBandCovarianceMatrix()} in the GDAL API is called
automatically here. This is a change in the behavior of
\code{GetInterBandCovarianceMatrix()} in the API, to a definitive \code{force}.)
\item \code{FALSE}: Results will only be returned if it can be done quickly (i.e.,
without scanning the raster, by using pre-existing
\code{STATISTICS_COVARIANCES} metadata items). \code{NA} will be returned if
inter-band covariances cannot be obtained quickly.
}

\code{write_in_metadata} specifies whether \code{STATISTICS_COVARIANCES} band metadata
items should be written if covariances are computed new. \code{df_correction}
specifies a correction term to subtract in the final averaging phase of the
covariance computation, often will be \code{1}. A value of \code{df_correction = 1}
will return an unbiased estimate if the pixels in bands are considered to be
a sample of the whole population. Otherwise a value of \code{df_correction = 0}
can be used if they are considered to be the whole population.

\code{$getMetadata(band, domain)}\cr
Returns a character vector of all metadata \code{NAME=VALUE} pairs that exist in
the specified \code{domain}, or empty string (\code{""}) if there are no
metadata items in \code{domain} (metadata in the context of the GDAL
Raster Data Model
\url{https://gdal.org/en/stable/user/raster_data_model.html}).
Set \code{band = 0} to retrieve dataset-level metadata, or to an integer
band number to retrieve band-level metadata.
Set \code{domain = ""} (empty string) to retrieve metadata in the
default domain.

\code{$setMetadata(band, metadata, domain)}\cr
Sets metadata in the specified \code{domain}. The \code{metadata} argument
is given as a character vector of \code{NAME=VALUE} pairs.
Pass \code{band = 0} to set dataset-level metadata, or pass an integer
band number to set band-level metadata.
Use \code{domain = ""} (empty string) to set an item in the default domain.
Returns logical \code{TRUE} on success or \code{FALSE} if metadata could
not be set.

\code{$getMetadataItem(band, mdi_name, domain)}\cr
Returns the value of a specific metadata item named \code{mdi_name} in the
specified \code{domain}, or empty string (\code{""}) if no matching item
is found.
Set \code{band = 0} to retrieve dataset-level metadata, or to an integer
band number to retrieve band-level metadata.
Set \code{domain = ""} (empty string) to retrieve an item in the
default domain.

\code{$setMetadataItem(band, mdi_name, mdi_value, domain)}\cr
Sets the value (\code{mdi_value}) of a specific metadata item named
\code{mdi_name} in the specified \code{domain}.
Pass \code{band = 0} to set dataset-level metadata, or pass an integer
band number to set band-level metadata.
Use \code{domain = ""} (empty string) to set an item in the default domain.
Returns logical \code{TRUE} on success or \code{FALSE} if metadata could
not be set.

\code{$getMetadataDomainList(band)}\cr
Returns a character vector of metadata domains or empty string (\code{""}).
Set \code{band = 0} to retrieve dataset-level domains, or to an integer
band number to retrieve band-level domains.

\code{$read(band, xoff, yoff, xsize, ysize, out_xsize, out_ysize)}\cr
Reads a region of raster data from \code{band}. The method takes care of
pixel decimation / replication if the output size
(\code{out_xsize * out_ysize}) is different than the size of the region
being accessed (\code{xsize * ysize}).
\code{xoff} is the pixel (column) offset to the top left corner of the
region of the band to be accessed (zero to start from the left side).
\code{yoff} is the line (row) offset to the top left corner of the region of
the band to be accessed (zero to start from the top).
\emph{Note that raster row/column offsets use 0-based indexing.}
\code{xsize} is the width in pixels of the region to be accessed.
\code{ysize} is the height in pixels of the region to be accessed.
\code{out_xsize} is the width of the output array into which the desired
region will be read (typically the same value as xsize).
\code{out_ysize} is the height of the output array into which the desired
region will be read (typically the same value as ysize).
Returns a numeric or complex vector containing the values that were read.
It is organized in left to right, top to bottom pixel order.
\code{NA} will be returned in place of the nodata value if the
raster dataset has a nodata value defined for this band.
Data are read as \R integer type when possible for the raster data type
(\code{Byte}, \code{Int8}, \code{Int16}, \code{UInt16}, \code{Int32}), otherwise as type double
(\code{UInt32}, \code{Float32}, \code{Float64}).
No rescaling of the data is performed (see \code{$getScale()} and
\code{$getOffset()} above).
An error is raised if the read operation fails. See also the setting
\code{$readByteAsRaw} above.

\code{$readBlock(band, xblockoff, yblockoff)}\cr
Reads a block of raster data, without resampling. See the class methods
\code{$getBlockSize()} and \code{$getActualBlockSize()} above for a
description of raster blocks. This is a convenience method to read by block
offsets. Returns a vector of pixel values with length equal to the actual
block \code{xsize * ysize}, otherwise as described above for \code{$read()}.

\code{$readChunk(band, chunk_def)}\cr
Reads a potentially multi-block chunk of raster data, without resampling.
This is a convenience method that can be used with the output of
\code{$make_chunk_index()} (see above). The matrix of chunk offsets and sizes
returned by \code{$make_chunk_index()} (or \code{$get_block_indexing()} to
operate on blocks) can be used to iterate I/O over the raster in user-defined
chunk sizes, i.e., a row of that matrix can be passed for the \code{chunk_def}
argument. \code{chunk_def} can also be given as an numeric vector of length 4
containing the 0-based pixel offsets and pixel sizes for a chunk (xoff, yoff,
xsize, ysize). Returns a vector of pixel values with length equal to the
chunk \code{xsize * ysize}, otherwise as described above for \code{$read()}.

\code{$readToNativeRaster(xoff, yoff, xsize, ysize, out_xsize, out_ysize)}\cr
Reads a region of raster data from \code{band}. The method takes care of
pixel decimation / replication if the output size
(\code{out_xsize * out_ysize}) is different than the size of the region
being accessed (\code{xsize * ysize}).
\code{xoff} is the pixel (column) offset to the top left corner of the
region of the band to be accessed (zero to start from the left side).
\code{yoff} is the line (row) offset to the top left corner of the region of
the band to be accessed (zero to start from the top).
\emph{Note that raster row/column offsets use 0-based indexing.}
\code{xsize} is the width in pixels of the region to be accessed.
\code{ysize} is the height in pixels of the region to be accessed.
\code{out_xsize} is the width of the output array into which the desired
region will be read (typically the same value as xsize).
\code{out_ysize} is the height of the output array into which the desired
region will be read (typically the same value as ysize).
Returns an object of class \code{nativeRaster} with attributes 'dim', and
'channels'  containing the values that were read in R's native RGB/A encoding.

\code{$write(band, xoff, yoff, xsize, ysize, rasterData)}\cr
Writes a region of raster data to \code{band}.
\code{xoff} is the pixel (column) offset to the top left corner of the
region of the band to be accessed (zero to start from the left side).
\code{yoff} is the line (row) offset to the top left corner of the region of
the band to be accessed (zero to start from the top).
\emph{Note that raster row/column offsets use 0-based indexing.}
\code{xsize} is the width in pixels of the region to write.
\code{ysize} is the height in pixels of the region to write.
\code{rasterData} is a numeric or complex vector containing values to write.
It is organized in left to right, top to bottom pixel order. \code{NA} in
\code{rasterData} should be replaced with a suitable nodata value prior to
writing (see \code{$getNoDataValue()} and \code{$setNoDataValue()} above).
An error is raised if the operation fails (no return value).

\code{$writeBlock(band, xblockoff, yblockoff, rasterData)}\cr
Writes a block of raster data. See the class methods \code{$getBlockSize()}
and \code{$getActualBlockSize()} above for a description of raster blocks.
This is a convenience method to write by block offsets.. Otherwise, this
method operates like \code{$write()}. The length of \code{rasterData} must be the
same as the actual \code{xsize * ysize} of the destination block.

\code{$writeChunk(band, chunk_def, rasterData)}\cr
Writes a potentially multi-block chunk of raster data. This is a convenience
method that can be used to iterate I/O over the raster in user-defined chunk
sizes, see method \code{$readChunk()} above. Otherwise, this method operates
like \code{$write()}. The length of \code{rasterData} must be the same as
\code{xsize * ysize} of the destination chunk.

\code{$fillRaster(band, value, ivalue)}\cr
Fills \code{band} with a constant value. GDAL makes no guarantees about what
values the pixels in newly created files are set to, so this method can be
used to clear a band to a specified "default" value. The fill \code{value} is
passed as \code{numeric}, but this will be converted to the underlying raster
data type before writing to the file. The \code{ivalue} argument allows setting
the imaginary component of a complex value. Note that \code{ivalue} is a required
argument but can be set to \code{0} for real data types. No return value. An
error is raised if the operation fails.

\code{$getColorTable(band)}\cr
Returns the color table associated with \code{band}, or \code{NULL} if
there is no associated color table. The color table is returned as an
integer matrix with five columns. To associate a color with a raster pixel,
the pixel value is used as a subscript into the color table. This means that
the colors are always applied starting at zero and ascending
(see
\href{https://gdal.org/en/stable/user/raster_data_model.html#color-table}{GDAL Color Table}).
Column 1 contains the pixel values. Interpretation of columns 2:5 depends
on the value of \code{$getPaletteInterp()} (see below).
For "RGB", columns 2:5 contain red, green, blue, alpha as 0-255 integer
values.

\code{$getPaletteInterp(band)}\cr
If \code{band} has an associated color table, this method returns a
character string with the palette interpretation for columns 2:5 of the
table. An empty string (\code{""}) is returned if \code{band} does not have
an associated color table. The palette interpretation values and their
meanings are:
\itemize{
\item Gray: column 2 contains grayscale values (columns 3:5 unused)
\item RGB: columns 2:5 contain red, green, blue, alpha
\item CMYK: columns 2:5 contain cyan, magenta, yellow, black
\item HLS: columns 2:4 contain hue, lightness, saturation (column 5 unused)
}

\code{$setColorTable(band, col_tbl, palette_interp)}\cr
Sets the raster color table for \code{band}.
\code{col_tbl} is an integer matrix or data frame with either four or five
columns (see \code{$getColorTable()} above). Column 1 contains the pixel
values. Valid values are integers 0 and larger (note that GTiff format
supports color tables only for Byte and UInt16 bands). Negative values
will be skipped with a warning emitted. Interpretation of columns 2:5
depends on the value of \code{$getPaletteInterp()} (see above). For RGB,
columns 2:4 contain red, green, blue as 0-255 integer values, and an
optional column 5 contains alpha transparency values (defaults to 255
opaque).
\code{palette_interp} is a string, one of \code{Gray}, \code{RGB}, \code{CMYK} or \code{HLS}
(see \code{$getPaletteInterp()} above).
Returns logical \code{TRUE} on success or \code{FALSE} if the color table
could not be set.

\code{$clearColorTable(band)}\cr
Clears the raster color table for \code{band}.
Returns logical \code{TRUE} on success or \code{FALSE} if the color table
could not be cleared, e.g., if this action is not supported by the driver.

\code{$getDefaultRAT(band)}\cr
Returns the Raster Attribute Table for \code{band} as a data frame,
or \code{NULL} if there is no associated Raster Attribute Table. See the
stand-alone function \code{\link[=buildRAT]{buildRAT()}} for details of the Raster Attribute Table
format.

\code{$setDefaultRAT(band, df)}\cr
Sets a default Raster Attribute Table for \code{band} from data frame \code{df}.
The input data frame will be checked for attribute \code{"GDALRATTableType"}
which can have values of \code{"thematic"} or \code{"athematic"} (for continuous data).
Columns of the data frame will be checked for attribute \code{"GFU"} (for "GDAL
field usage"). If the \code{"GFU"} attribute is missing, a value of \code{"Generic"}
will be used (corresponding to \code{GFU_Generic} in the GDAL API, for general
purpose field). Columns with other, specific field usage values should
generally be present in \code{df}, such as fields containing the set of unique
(discrete) pixel values (GFU \code{"MinMax"}), pixel counts (GFU \code{"PixelCount"}),
class names (GFU \code{"Name"}), color values (GFUs \code{"Red"}, "\verb{Green"}, \code{"Blue"}),
etc. The data frame will also be checked for attributes \code{"Row0Min"} and
\code{"BinSize"} which can have numeric values that describe linear binning.
See the stand-alone function \code{\link[=buildRAT]{buildRAT()}} for details of the GDAL Raster
Attribute Table format and its representation as data frame.

\code{$flushCache()}\cr
Flush all write cached data to disk. Any raster data written via GDAL calls,
but buffered internally will be written to disk. Using this method does not
preclude calling \code{$close()} to properly close the dataset and ensure
that important data not addressed by \code{$flushCache()} is written in the
file (see also \code{$open()} above). No return value, called for side
effects.

\code{$getChecksum(band, xoff, yoff, xsize, ysize)}\cr
Returns a 16-bit integer (0-65535) checksum from a region of raster data
on \code{band}.
Floating point data are converted to 32-bit integer so decimal portions of
such raster data will not affect the checksum. Real and imaginary
components of complex bands influence the result.
\code{xoff} is the pixel (column) offset of the window to read.
\code{yoff} is the line (row) offset of the window to read.
\emph{Raster row/column offsets use 0-based indexing.}
\code{xsize} is the width in pixels of the window to read.
\code{ysize} is the height in pixels of the window to read.

\code{$close()}\cr
Closes the GDAL dataset (no return value, called for side effects).
Calling \code{$close()} results in proper cleanup, and flushing of any
pending writes. Forgetting to close a dataset opened in update mode on some
formats such as GTiff could result in being unable to open it afterwards.
The \code{GDALRaster} object is still available after calling \code{$close()}.
The dataset can be re-opened on the existing \code{filename} with
\code{$open(read_only=TRUE)} or \code{$open(read_only=FALSE)}.
}
}

\examples{
lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
ds <- new(GDALRaster, lcp_file)
ds

## print information about the dataset to the console
ds$info()

## retrieve the raster format name
ds$getDriverShortName()
ds$getDriverLongName()

## retrieve a list of files composing the dataset
ds$getFileList()

## retrieve dataset parameters
ds$getRasterXSize()
ds$getRasterYSize()
ds$getGeoTransform()
ds$getProjection()
ds$getRasterCount()
ds$bbox()
ds$res()
ds$dim()

## retrieve some band-level parameters
ds$getDescription(band = 1)
ds$getBlockSize(band = 1)
ds$getOverviewCount(band = 1)
ds$getDataTypeName(band = 1)
# LCP format does not support an intrinsic nodata value so this returns NA:
ds$getNoDataValue(band = 1)

## LCP driver reports several dataset- and band-level metadata
## (format description at https://gdal.org/en/stable/drivers/raster/lcp.html)
## set band = 0 to retrieve dataset-level metadata
## set domain = "" (empty string) for the default metadata domain
ds$getMetadata(band = 0, domain = "")

## retrieve metadata for a band as a vector of name=value pairs
ds$getMetadata(band = 4, domain = "")

## retrieve the value of a specific metadata item
ds$getMetadataItem(band = 2, mdi_name = "SLOPE_UNIT_NAME", domain = "")

## read one row of pixel values from band 1 (elevation)
## raster row/column index are 0-based
## the upper left corner is the origin
## read the tenth row:
ncols <- ds$getRasterXSize()
rowdata <- ds$read(band = 1, xoff = 0, yoff = 9,
                   xsize = ncols, ysize = 1,
                   out_xsize = ncols, out_ysize = 1)
head(rowdata)

ds$close()

## create a new raster using lcp_file as a template
new_file <- file.path(tempdir(), "storml_newdata.tif")
rasterFromRaster(srcfile = lcp_file,
                 dstfile = new_file,
                 nbands = 1,
                 dtName = "Byte",
                 init = -9999)

ds_new <- new(GDALRaster, new_file, read_only = FALSE)

## write random values to all pixels
set.seed(42)
ncols <- ds_new$getRasterXSize()
nrows <- ds_new$getRasterYSize()
for (row in 0:(nrows - 1)) {
    rowdata <- round(runif(ncols, 0, 100))
    ds_new$write(band = 1,
                 xoff = 0,
                 yoff = row,
                 xsize = ncols,
                 ysize = 1,
                 rowdata)
}

## re-open in read-only mode when done writing
## this will ensure flushing of any pending writes (implicit $close)
ds_new$open(read_only = TRUE)

## getStatistics returns min, max, mean, sd, and sets stats in the metadata
ds_new$getStatistics(band = 1, approx_ok = FALSE, force = TRUE)
ds_new$getMetadataItem(band = 1, "STATISTICS_MEAN", "")

## close the dataset for proper cleanup
ds_new$close()
\dontshow{deleteDataset(new_file)}
\donttest{
## using a GDAL Virtual File System handler '/vsicurl/'
## see: https://gdal.org/en/stable/user/virtual_file_systems.html
url <- "/vsicurl/https://raw.githubusercontent.com/"
url <- paste0(url, "firelab/gdalraster/main/sample-data/")
url <- paste0(url, "lf_elev_220_mt_hood_utm.tif")

set_config_option("GDAL_HTTP_CONNECTTIMEOUT", "20")
set_config_option("GDAL_HTTP_TIMEOUT", "20")
if (http_enabled() && vsi_stat(url)) {
  ds <- new(GDALRaster, url)
  plot_raster(ds, legend = TRUE, main = "Mount Hood elevation (m)")
  ds$close()
}
set_config_option("GDAL_HTTP_CONNECTTIMEOUT", "")
set_config_option("GDAL_HTTP_TIMEOUT", "")
}
}
\seealso{
Package overview in \code{\link[=gdalraster-package]{help("gdalraster-package")}}

\code{vignette("raster-api-tutorial")}

\code{\link[=read_ds]{read_ds()}} is a convenience wrapper for \code{GDALRaster$read()}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom.R
\name{g_wk2wk}
\alias{g_wk2wk}
\title{Geometry WKB/WKT conversion}
\usage{
g_wk2wk(geom, as_iso = FALSE, byte_order = "LSB")
}
\arguments{
\item{geom}{Either a raw vector of WKB or list of raw vectors to convert
to WKT, or a character vector containing one or more WKT strings to
convert to WKB.}

\item{as_iso}{Logical value, \code{TRUE} to export as ISO WKB/WKT (ISO 13249
SQL/MM Part 3), or \code{FALSE} (the default) to export as "Extended WKB/WKT"
(see Note).}

\item{byte_order}{Character string specifying the byte order when converting
to WKB. One of \code{"LSB"} (the default) or \code{"MSB"} (uncommon).}
}
\value{
For input of a WKB raw vector or list of raw vectors, returns a character
vector of WKT strings, with length of the returned vector equal to the
number of input raw vectors. For input of a single WKT string, returns a raw
vector of WKB. For input of a character vector containing more than one WKT
string, returns a list of WKB raw vectors, with length of the returned list
equal to the number of input strings.
}
\description{
\code{g_wk2wk()} converts geometries between Well Known Binary (WKB) and
Well Known Text (WKT) formats. A geometry given as a raw vector of WKB will
be converted to a WKT string, while a geometry given as a WKT string will be
converted to a WKB raw vector. Input may also be a list of WKB raw vectors
or a character vector of WKT strings.
}
\note{
With \code{as_iso = FALSE} (the default), geometries are exported as extended
dimension (Z) WKB/WKT for types \code{Point}, \code{LineString}, \code{Polygon},
\code{MultiPoint}, \code{MultiLineString}, \code{MultiPolygon} and \code{GeometryCollection}.
For other geometry types, it is equivalent to ISO.

When the return value is a list of WKB raw vectors, an element in the
returned list will contain \code{NULL} (and a warning emitted) if the
corresponding input string was \code{NA} or empty (\code{""}).

When input is a list of WKB raw vectors, a corresponding element in the
returned character vector will be \code{NA} if the input was a raw vector of
length \code{0} (i.e., \code{raw(0)}). If an input list element is not a raw vector,
then the corresponding element in the returned character vector will also
be \code{NA}. A warning is emitted in each case.
}
\examples{
wkt <- "POINT (-114 47)"
wkb <- g_wk2wk(wkt)
str(wkb)
g_wk2wk(wkb)
}
\seealso{
GEOS reference for geometry formats:\cr
\url{https://libgeos.org/specifications/}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ogr_manage.R
\name{ogr_manage}
\alias{ogr_manage}
\alias{ogr_ds_exists}
\alias{ogr_ds_format}
\alias{ogr_ds_test_cap}
\alias{ogr_ds_create}
\alias{ogr_ds_layer_count}
\alias{ogr_ds_layer_names}
\alias{ogr_ds_field_domain_names}
\alias{ogr_ds_add_field_domain}
\alias{ogr_ds_delete_field_domain}
\alias{ogr_layer_exists}
\alias{ogr_layer_test_cap}
\alias{ogr_layer_create}
\alias{ogr_layer_field_names}
\alias{ogr_layer_rename}
\alias{ogr_layer_delete}
\alias{ogr_field_index}
\alias{ogr_field_create}
\alias{ogr_geom_field_create}
\alias{ogr_field_rename}
\alias{ogr_field_set_domain_name}
\alias{ogr_field_delete}
\alias{ogr_execute_sql}
\title{Utility functions for managing vector data sources}
\usage{
ogr_ds_exists(dsn, with_update = FALSE)

ogr_ds_format(dsn)

ogr_ds_test_cap(dsn, with_update = TRUE)

ogr_ds_create(
  format,
  dsn,
  layer = NULL,
  layer_defn = NULL,
  geom_type = NULL,
  srs = NULL,
  fld_name = NULL,
  fld_type = NULL,
  dsco = NULL,
  lco = NULL,
  overwrite = FALSE,
  return_obj = FALSE
)

ogr_ds_layer_count(dsn)

ogr_ds_layer_names(dsn)

ogr_ds_field_domain_names(dsn)

ogr_ds_add_field_domain(dsn, fld_dom_defn)

ogr_ds_delete_field_domain(dsn, domain_name)

ogr_layer_exists(dsn, layer)

ogr_layer_test_cap(dsn, layer = NULL, with_update = TRUE)

ogr_layer_create(
  dsn,
  layer,
  layer_defn = NULL,
  geom_type = NULL,
  srs = NULL,
  lco = NULL,
  return_obj = FALSE
)

ogr_layer_field_names(dsn, layer = NULL)

ogr_layer_rename(dsn, layer, new_name)

ogr_layer_delete(dsn, layer)

ogr_field_index(dsn, layer, fld_name)

ogr_field_create(
  dsn,
  layer,
  fld_name,
  fld_defn = NULL,
  fld_type = "OFTInteger",
  fld_subtype = "OFSTNone",
  fld_width = 0L,
  fld_precision = 0L,
  is_nullable = TRUE,
  is_unique = FALSE,
  default_value = "",
  domain_name = NULL
)

ogr_geom_field_create(
  dsn,
  layer,
  fld_name,
  geom_fld_defn = NULL,
  geom_type = NULL,
  srs = NULL,
  is_nullable = TRUE
)

ogr_field_rename(dsn, layer, fld_name, new_name)

ogr_field_set_domain_name(dsn, layer, fld_name, domain_name)

ogr_field_delete(dsn, layer, fld_name)

ogr_execute_sql(dsn, sql, spatial_filter = NULL, dialect = NULL)
}
\arguments{
\item{dsn}{Character string. The vector data source name, e.g., a filename
or database connection string.}

\item{with_update}{Logical value. \code{TRUE} to request update access when
opening the dataset, or \code{FALSE} to open read-only.}

\item{format}{GDAL short name of the vector format as character string.
Examples of some common output formats include: \code{"GPKG"}, \code{"FlatGeobuf"},
\code{"ESRI Shapefile"}, \code{"SQLite"}.}

\item{layer}{Character string for a layer name in a vector dataset.
The \code{layer} argument may be given as empty string (\code{""}) in which case the
first layer by index will be opened (except with \code{ogr_layer_delete()} and
\code{ogr_layer_rename()} for which a layer name must be specified).}

\item{layer_defn}{A feature class definition for \code{layer} as a list of
zero or more attribute field definitions, and at least one geometry field
definition (see \link{ogr_define}).
Each field definition is a list with named elements containing values for
the field \code{type} element and other properties.
If \code{layer_defn} is given, it will be used and any additional parameters
passed that relate to the feature class definition will be ignored (i.e.,
\code{geom_type} and \code{srs}, as well as \code{fld_name} and \code{fld_type} in
\code{ogr_ds_create()}).
The first geometry field definition in \code{layer_defn} defines the
geometry type and spatial reference system for the layer (the geom field
definition must contain \code{type}, and should also contain \code{srs} when
creating a layer from a feature class definition).}

\item{geom_type}{Character string specifying a geometry type (see Details).}

\item{srs}{Character string containing a spatial reference system definition
as OGC WKT or other well-known format (e.g., the input formats usable with
\code{\link[=srs_to_wkt]{srs_to_wkt()}}).}

\item{fld_name}{Character string containing the name of an attribute field
in \code{layer}.}

\item{fld_type}{Character string containing the name of a field data type
(e.g., \code{"OFTInteger"}, \code{"OFTInteger64"}, \code{"OFTReal"}, \code{"OFTString"}, ...).}

\item{dsco}{Optional character vector of format-specific creation options
for \code{dsn} (\code{"NAME=VALUE"} pairs).}

\item{lco}{Optional character vector of format-specific creation options
for \code{layer} (\code{"NAME=VALUE"} pairs).}

\item{overwrite}{Logical value. \code{TRUE} to overwrite \code{dsn} if it already
exists when calling \code{ogr_ds_create()}. Default is \code{FALSE}.}

\item{return_obj}{Logical value. If \code{TRUE}, an object of class
\code{\link{GDALVector}} open on the newly created layer will be
returned. Defaults to \code{FALSE}. Must be used with either the \code{layer} or
\code{layer_defn} arguments.}

\item{fld_dom_defn}{A field domain definition, i.e., a list generated with
\code{\link[=ogr_def_field_domain]{ogr_def_field_domain()}}.}

\item{domain_name}{Character string specifying the name of the field domain.}

\item{new_name}{Character string containing a new name to assign.}

\item{fld_defn}{A field definition as list (see \code{\link[=ogr_def_field]{ogr_def_field()}}).
Additional arguments in \code{ogr_field_create()} will be ignored if a \code{fld_defn}
is given.}

\item{fld_subtype}{Character string containing the name of a field subtype.
One of \code{"OFSTNone"} (the default), \code{"OFSTBoolean"}, \code{"OFSTInt16"},
\code{"OFSTFloat32"}, \code{"OFSTJSON"}, \code{"OFSTUUID"}.}

\item{fld_width}{Optional integer value specifying max number of characters.}

\item{fld_precision}{Optional integer value specifying number of digits
after the decimal point.}

\item{is_nullable}{Optional NOT NULL field constraint (logical value).
Defaults to \code{TRUE}.}

\item{is_unique}{Optional UNIQUE constraint on the field (logical value).
Defaults to \code{FALSE}.}

\item{default_value}{Optional default value for the field as a character
string.}

\item{geom_fld_defn}{A geometry field definition as list (see
\code{\link[=ogr_def_geom_field]{ogr_def_geom_field()}}). Additional arguments in \code{ogr_geom_field_create()}
will be ignored if a \code{geom_fld_defn} is given.}

\item{sql}{Character string containing an SQL statement (see Note).}

\item{spatial_filter}{Either a numeric vector of length four containing a
bounding box (xmin, ymin, xmax, ymax), or a character string containing a
geometry as OGC WKT, representing a spatial filter.}

\item{dialect}{Character string specifying the SQL dialect to use.
The OGR SQL engine (\code{"OGRSQL"}) will be used by default if a value is not
given. The \code{"SQLite"} dialect can also be used (see Note).}
}
\description{
This set of functions can be used to create new vector datasets,
test existence of dataset/layer/field, test dataset and layer capabilities,
create new layers in an existing dataset, get the names of field domains
stored in a dataset, write field domains in a dataset, delete layers, create
new attribute and geometry fields on an existing layer, rename and delete
fields, and edit data with SQL statements.
}
\details{
These functions are complementary to \code{ogrinfo()} and \code{ogr2ogr()} for
vector data management. Bindings to OGR wrap portions of the GDAL
Vector API (ogr_core.h and ogr_api.h,
\url{https://gdal.org/en/stable/api/vector_c_api.html}).

\code{ogr_ds_exists()} tests whether a vector dataset can be opened from the
given data source name (DSN), potentially testing for update access.
Returns a logical value.

\code{ogr_ds_format()} returns a character string containing the short name of
the format driver for a given DSN, or \code{NULL} if the dataset cannot be
opened as a vector source.

\code{ogr_ds_test_cap()} tests the capabilities of a vector data source,
attempting to open it with update access by default.
Returns a list of capabilities with values \code{TRUE} or \code{FALSE}, or \code{NULL} is
returned if \code{dsn} cannot be opened with the requested access.
Wrapper of \code{GDALDatasetTestCapability()} in the GDAL API.
The returned list contains the following named elements:
\itemize{
\item \code{CreateLayer}: \code{TRUE} if this dataset can create new layers
\item \code{DeleteLayer}: \code{TRUE} if this dataset can delete existing layers
\item \code{CreateGeomFieldAfterCreateLayer}: \code{TRUE} if the layers of this
dataset supports geometry field creation just after layer creation
\item \code{CurveGeometries}: \code{TRUE} if this dataset supports curve geometries
\item \code{Transactions}: \code{TRUE} if this dataset supports (efficient)
transactions
\item \code{EmulatedTransactions}: \code{TRUE} if this dataset supports transactions
through emulation
\item \code{RandomLayerRead}: \code{TRUE} if this dataset has a dedicated
\code{GetNextFeature()} implementation, potentially returning features from
layers in a non-sequential way
\item \code{RandomLayerWrite}: \code{TRUE} if this dataset supports calling
\code{CreateFeature()} on layers in a non-sequential way
\item \code{AddFieldDomain}: \code{TRUE} if this dataset supports adding field domains
(GDAL >= 3.3)
\item \code{DeleteFieldDomain}: \code{TRUE} if this dataset supports deleting field
domains (GDAL >= 3.5)
\code{UpdateFieldDomain}: \code{TRUE} if this dataset supports updating a an existing
field domain by replacing its definition (GDAL >= 3.5)
}

\code{ogr_ds_create()} creates a new vector dataset, optionally also creating
a layer, and optionally creating one or more fields on the layer.
The attribute fields and geometry field(s) to create can be specified as a
feature class definition (\code{layer_defn} as list, see \link{ogr_define}), or
alternatively, by giving the \code{geom_type} and \code{srs}, optionally along with
one \code{fld_name} and \code{fld_type} to be created in the layer.
By default, returns logical \code{TRUE} indicating success (output written to
\code{dst_filename}), or an object of class \code{\link{GDALVector}} for the
output layer will be returned if \code{return_obj = TRUE}. An error is raised if
the operation fails.

\code{ogr_ds_layer_count()} returns the number of layers in a vector dataset.

\code{ogr_ds_layer_names()} returns a character vector of layer names in a
vector dataset, or \code{NULL} if no layers are found.

\code{ogr_ds_field_domain_names()} returns a character vector with the names of
all field domains stored in the dataset. Returns \code{NULL} and emits a warning
if an error occurs or if the format does not support reading field domains.
Returns a character vector of length 0 (\code{character(0)}) if the format
supports field domains but none are present in the dataset.
Requires GDAL >= 3.5. See \link{ogr_define} for information on field domains.

\code{ogr_ds_add_field_domain()} adds a field domain to a vector dataset. Only a
few drivers will support this operation, and some of them might only support
it only for some types of field domains. GeoPackage and OpenFileGDB drivers
support this operation. A dataset having at least some support should report
the \code{AddFieldDomain} dataset capability (see \code{ogr_ds_test_cap()}above).
Returns a logical value, \code{TRUE} indicating success. Requires GDAL >= 3.3.

\code{ogr_ds_delete_field_domain()} deletes a field domain from a vector dataset
if supported (see \code{ogr_ds_test_cap()}above for the \code{DeleteFieldDomain}
dataset capability). Returns a logical value, \code{TRUE} indicating success.
Requires GDAL >= 3.5.

\code{ogr_layer_exists()} tests whether a layer can be accessed by name in a
given vector dataset. Returns a logical value

\code{ogr_layer_test_cap()} tests whether a layer supports named capabilities,
attempting to open the dataset with update access by default.
Returns a list of capabilities with values \code{TRUE} or \code{FALSE}. \code{NULL} is
returned if \code{dsn} cannot be opened with the requested access, or \code{layer}
cannot be found. The returned list contains the following named elements:
\code{RandomRead}, \code{SequentialWrite}, \code{RandomWrite}, \code{UpsertFeature},
\code{FastSpatialFilter}, \code{FastFeatureCount}, \code{FastGetExtent},
\code{FastSetNextByIndex}, \code{CreateField}, \code{CreateGeomField}, \code{DeleteField},
\code{ReorderFields}, \code{AlterFieldDefn}, \code{AlterGeomFieldDefn}, \code{IgnoreFields},
\code{DeleteFeature}, \code{Rename}, \code{StringsAsUTF8}, \code{CurveGeometries}.
See the GDAL documentation for
\href{https://gdal.org/en/stable/api/vector_c_api.html#_CPPv420OGR_L_TestCapability9OGRLayerHPKc}{\code{OGR_L_TestCapability()}}.

\code{ogr_layer_create()} creates a new layer in an existing vector data source,
with a specified geometry type and spatial reference definition.
This function also accepts a feature class definition given as a list of
field names and their definitions (see \link{ogr_define}).
(Note: use \code{ogr_ds_create()} to create single-layer formats such as "ESRI
Shapefile", "FlatGeobuf", "GeoJSON", etc.)
By default, returns logical \code{TRUE} indicating success, or an object of class
\code{\link{GDALVector}} will be returned if \code{return_obj = TRUE}.
An error is raised if the operation fails.

\code{ogr_layer_field_names()} returns a character vector of field names on a
layer, or \code{NULL} if no fields are found. The first layer by index is opened
if \code{NULL} is given for the \code{layer} argument.

\code{ogr_layer_rename()} renames a layer in a vector dataset. This operation is
implemented only by layers that expose the \code{Rename} capability (see
\code{ogr_layer_test_cap()} above). This operation will fail if a layer with the
new name already exists. Returns a logical value, \code{TRUE} indicating success.
Requires GDAL >= 3.5.

\code{ogr_layer_delete()} deletes an existing layer in a vector dataset.
Returns a logical value, \code{TRUE} indicating success.

\code{ogr_field_index()} tests for existence of an attribute field by name.
Returns the field index on the layer (0-based), or \code{-1} if the field does
not exist.

\code{ogr_field_create()} creates a new attribute field of specified data type in
a given DSN/layer. Several optional field properties can be specified in
addition to the type. Returns a logical value, \code{TRUE} indicating success.

\code{ogr_geom_field_create()} creates a new geometry field of specified type in
a given DSN/layer. Returns a logical value, \code{TRUE} indicating success.

\code{ogr_field_rename()} renames an existing field on a vector layer.
Not all format drivers support this function. Some drivers may only support
renaming a field while there are still no features in the layer.
\code{AlterFieldDefn} is the relevant layer capability to check.
Returns a logical value, \code{TRUE} indicating success.

\code{ogr_field_set_domain_name()} sets the field domain name for an existing
attribute field on a vector layer. \code{AlterFieldDefn} layer capability is
required. Returns a logical value, \code{TRUE} indicating success.
Requires GDAL >= 3.3.

\code{ogr_field_delete()} deletes an existing field on a vector layer.
Not all format drivers support this function. Some drivers may only support
deleting a field while there are still no features in the layer.
Returns a logical value, \code{TRUE} indicating success.

\code{ogr_execute_sql()} executes an SQL statement against the data store.
This function can be used to modify the schema or edit data using SQL
(e.g., \verb{ALTER TABLE}, \verb{DROP TABLE}, \verb{CREATE INDEX}, \verb{DROP INDEX}, \code{INSERT},
\code{UPDATE}, \code{DELETE}), or to execute a query (i.e., \code{SELECT}).
Returns \code{NULL} (invisibly) for statements that are in error, or that have no
results set, or an object of class \code{GDALVector} representing a results set
from the query. Wrapper of \code{GDALDatasetExecuteSQL()} in the GDAL API.
}
\note{
The OGR SQL document linked under \strong{See Also} contains information on the
SQL dialect supported internally by GDAL/OGR. Some format drivers (e.g.,
PostGIS) pass the SQL directly through to the underlying RDBMS (unless
\code{OGRSQL} is explicitly passed as the dialect). The SQLite dialect can also
be requested with the \code{SQLite} string passed as the \code{dialect} argument of
\code{ogr_execute_sql()}. This assumes that GDAL/OGR is built with support for
SQLite, and preferably also with Spatialite support to benefit from spatial
functions. The GDAL document for SQLite dialect has detailed information.

Other SQL dialects may also be present for some vector formats.
For example, the \code{"INDIRECT_SQLITE"} dialect might potentially be used with
GeoPackage format (\url{https://gdal.org/en/stable/drivers/vector/gpkg.html#sql}).

The function \code{\link[=ogrinfo]{ogrinfo()}} can also be used to edit data with SQL statements
(GDAL >= 3.7).

The name of the geometry column of a layer is empty (\code{""}) with some formats
such as ESRI Shapefile and FlatGeobuf. Implications for SQL may depend on the
dialect used. See the GDAL documentation for the "OGR SQL" and "SQLite"
dialects for details.
}
\examples{
## Create GeoPackage and manage schema
dsn <- file.path(tempdir(), "test1.gpkg")
ogr_ds_create("GPKG", dsn)
ogr_ds_exists(dsn, with_update = TRUE)
# dataset capabilities
ogr_ds_test_cap(dsn)

ogr_layer_create(dsn, layer = "layer1", geom_type = "Polygon",
                 srs = "EPSG:5070")

ogr_field_create(dsn, layer = "layer1",
                 fld_name = "field1",
                 fld_type = "OFTInteger64",
                 is_nullable = FALSE)
ogr_field_create(dsn, layer = "layer1",
                 fld_name = "field2",
                 fld_type = "OFTString")

ogr_ds_layer_count(dsn)
ogr_ds_layer_names(dsn)
ogr_layer_field_names(dsn, layer = "layer1")

# delete a field
if (ogr_layer_test_cap(dsn, "layer1")$DeleteField) {
  ogr_field_delete(dsn, layer = "layer1", fld_name = "field2")
}

ogr_layer_field_names(dsn, "layer1")

# define a feature class and create layer
defn <- ogr_def_layer("Point", srs = epsg_to_wkt(4326))
# add the attribute fields
defn$id_field <- ogr_def_field(fld_type = "OFTInteger64",
                               is_nullable = FALSE,
                               is_unique = TRUE)
defn$str_field <- ogr_def_field(fld_type = "OFTString",
                                fld_width = 25,
                                is_nullable = FALSE,
                                default_value = "'a default string'")
defn$numeric_field <- ogr_def_field(fld_type = "OFTReal",
                                    default_value = "0.0")

ogr_layer_create(dsn, layer = "layer2", layer_defn = defn)
ogr_ds_layer_names(dsn)
ogr_layer_field_names(dsn, layer = "layer2")

# add a field using SQL instead
ogr_execute_sql(dsn, sql = "ALTER TABLE layer2 ADD field4 float")

# rename a field
if (ogr_layer_test_cap(dsn, "layer1")$AlterFieldDefn) {
  ogr_field_rename(dsn, layer = "layer2",
                   fld_name = "field4",
                   new_name = "renamed_field")
}
ogr_layer_field_names(dsn, layer = "layer2")

# GDAL >= 3.7
if (gdal_version_num() >= gdal_compute_version(3, 7, 0))
  ogrinfo(dsn, "layer2")

\dontshow{deleteDataset(dsn)}
## Edit data using SQL
src <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
perims_shp <- file.path(tempdir(), "mtbs_perims.shp")
ogr2ogr(src_dsn = src, dst_dsn = perims_shp, src_layers = "mtbs_perims")
ogr_ds_format(dsn = perims_shp)
ogr_ds_layer_names(dsn = perims_shp)
ogr_layer_field_names(dsn = perims_shp, layer = "mtbs_perims")

alt_tbl <- "ALTER TABLE mtbs_perims ADD burn_bnd_ha float"
ogr_execute_sql(dsn = perims_shp, sql = alt_tbl)

upd <- "UPDATE mtbs_perims SET burn_bnd_ha = (burn_bnd_ac / 2.471)"
ogr_execute_sql(dsn = perims_shp, sql = upd, dialect = "SQLite")
ogr_layer_field_names(dsn = perims_shp, layer = "mtbs_perims")

# if GDAL >= 3.7:
#   ogrinfo(dsn = perims_shp, layer = "mtbs_perims")
# or, for output incl. the feature data (omit the default "-so" arg):
#   ogrinfo(dsn = perims_shp, layer = "mtbs_perims", cl_arg = "-nomd")
\dontshow{deleteDataset(perims_shp)}
}
\seealso{
OGR SQL dialect and SQLite SQL dialect:\cr
\url{https://gdal.org/en/stable/user/ogr_sql_sqlite_dialect.html}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom.R
\name{g_util}
\alias{g_util}
\alias{g_make_valid}
\alias{g_normalize}
\alias{g_set_3D}
\alias{g_set_measured}
\alias{g_swap_xy}
\title{Geometry utility functions operating on WKB or WKT}
\usage{
g_make_valid(
  geom,
  method = "LINEWORK",
  keep_collapsed = FALSE,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)

g_normalize(
  geom,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)

g_set_3D(
  geom,
  is_3d,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)

g_set_measured(
  geom,
  is_measured,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)

g_swap_xy(
  geom,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)
}
\arguments{
\item{geom}{Either a raw vector of WKB or list of raw vectors, or a
character vector containing one or more WKT strings.}

\item{method}{Character string. One of \code{"LINEWORK"} (the default) or
\code{"STRUCTURE"} (requires GEOS >= 3.10 and GDAL >= 3.4). See Details.}

\item{keep_collapsed}{Logical value, applies only to the STRUCTURE method.
Defaults to \code{FALSE}. See Details.}

\item{as_wkb}{Logical value, \code{TRUE} to return the output geometry in WKB
format (the default), or \code{FALSE} to return as WKT.}

\item{as_iso}{Logical value, \code{TRUE} to export as ISO WKB/WKT (ISO 13249
SQL/MM Part 3), or \code{FALSE} (the default) to export as "Extended WKB/WKT".}

\item{byte_order}{Character string specifying the byte order when output is
WKB. One of \code{"LSB"} (the default) or \code{"MSB"} (uncommon).}

\item{quiet}{Logical value, \code{TRUE} to suppress warnings. Defaults to \code{FALSE}.}

\item{is_3d}{Logical value, \code{TRUE} if the input geometries should have a Z
dimension, or \code{FALSE} to remove the Z dimension.}

\item{is_measured}{Logical value, \code{TRUE} if the input geometries should have
a M dimension, or \code{FALSE} to remove the M dimension.}
}
\value{
A geometry as WKB raw vector or WKT string, or a list/character vector of
geometries as WKB/WKT with length equal to \code{length(geom)}. \code{NULL} is returned
with a warning if WKB input cannot be converted into an OGR geometry object,
or if an error occurs in the call to the underlying OGR API (see Note).
}
\description{
These functions operate on input geometries in OGC WKB or WKT format to
perform various manipulations for utility purposes.
}
\details{
These functions use the GEOS library via GDAL headers.

\code{g_make_valid()} attempts to make an invalid geometry valid without losing
vertices. Already-valid geometries are cloned without further intervention.
Wrapper of \code{OGR_G_MakeValidEx()} in the GDAL API.
Requires GEOS >= 3.8 library. If GDAL is built without GEOS >= 3.8, this
function will return a clone of the input geometry if it is valid, or \code{NULL}
(\code{as_wkb = TRUE}) / \code{NA} (\code{as_wkb = FALSE}) if it is invalid. For detailed
explanations of geometry validity checking and repair, see
\url{https://gdal.org/en/latest/user/geometry_validity.html}.
\itemize{
\item \code{"LINEWORK"} is the default method, which combines all rings into a set
of noded lines and then extracts valid polygons from that linework
(requires GEOS >= 3.10 and GDAL >= 3.4). The \code{"STRUCTURE"} method first
makes all rings valid, then merges shells and subtracts holes from shells to
generate a valid result. Assumes that holes and shells are correctly
categorized.
\item \code{keep_collapsed} only applies to the \code{"STRUCTURE"} method:
\itemize{
\item \code{FALSE} (the default): collapses are converted to empty geometries
\item \code{TRUE}: collapses are converted to a valid geometry of lower dimension
}
}

\code{g_normalize()} organizes the elements, rings, and coordinate order of
geometries in a consistent way, so that geometries that represent the same
object can be easily compared. Wrapper of \code{OGR_G_Normalize()} in the GDAL
API. Requires GDAL >= 3.3. Normalization ensures the following:
\itemize{
\item Lines are oriented to have smallest coordinate first (apart from duplicate
endpoints)
\item Rings start with their smallest coordinate (using XY ordering)
\item Polygon shell rings are oriented clockwise, and holes counter-clockwise
\item Collection elements are sorted by their first coordinate
}

\code{g_set_3D()} adds or removes the explicit Z coordinate dimension. Removing
the Z coordinate dimension of a geometry will remove any existing Z values.
Adding the Z dimension to a geometry collection, a compound curve, a
polygon, etc. will affect the children geometries.
Wrapper of \code{OGR_G_Set3D()} in the GDAL API.

\code{g_set_measured()} adds or removes the explicit M coordinate dimension.
Removing the M coordinate dimension of a geometry will remove any existing M
values. Adding the M dimension to a geometry collection, a compound curve, a
polygon, etc. will affect the children geometries.
Wrapper of \code{OGR_G_SetMeasured()} in the GDAL API.

\code{g_swap_xy()} swaps x and y coordinates of the input geometry.
Wrapper of \code{OGR_G_SwapXY()} in the GDAL API.
}
\note{
\code{MakeValid()} in GDAL >= 3.13: Certain geometries cannot be read using GEOS,
e.g., if Polygon rings are not closed or do not contain enough vertices. If
a geometry cannot be read by GEOS, \code{NULL} will be returned. Starting with
GDAL 3.13, GDAL will attempt to modify these geometries such that they can
be read and repaired by GEOS.
}
\examples{
## g_make_valid() requires GEOS >= 3.8, otherwise is only a validity test
geos_version()

# valid
wkt <- "POINT (0 0)"
g_make_valid(wkt, as_wkb = FALSE)

# invalid to valid
wkt <- "POLYGON ((0 0,10 10,0 10,10 0,0 0))"
g_make_valid(wkt, as_wkb = FALSE)

# invalid, note that GDAL >= 3.13 will modify to valid in this case
wkt <- "LINESTRING (0 0)"
# NULL if GDAL < 3.13, or "POINT (0 0)" with GDAL >= 3.13:
g_make_valid(wkt)

## g_normalize() requires GDAL >= 3.3
if (gdal_version_num() >= gdal_compute_version(3, 3, 0)) {
  g <- "POLYGON ((0 1,1 1,1 0,0 0,0 1))"
  g_normalize(g) |> g_wk2wk()
}

## set 3D / set measured
pt_xyzm <- g_create("POINT", c(1, 9, 100, 2000))

g_wk2wk(pt_xyzm, as_iso = TRUE)

g_set_3D(pt_xyzm, is_3d = FALSE) |> g_wk2wk(as_iso = TRUE)

g_set_measured(pt_xyzm, is_measured = FALSE) |> g_wk2wk(as_iso = TRUE)

## swap XY
g <- "GEOMETRYCOLLECTION(POINT(1 2),
                         LINESTRING(1 2,2 3),
                         POLYGON((0 0,0 1,1 1,0 0)))"

g_swap_xy(g, as_wkb = FALSE)
}
\seealso{
\code{\link[=g_is_valid]{g_is_valid()}}, \code{\link[=g_is_3D]{g_is_3D()}}, \code{\link[=g_is_measured]{g_is_measured()}}\cr\cr

GDAL documentation on geometry validity and repair:
\url{https://gdal.org/en/latest/user/geometry_validity.html}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{inv_geotransform}
\alias{inv_geotransform}
\title{Invert geotransform}
\usage{
inv_geotransform(gt)
}
\arguments{
\item{gt}{Numeric vector of length six containing the geotransform to
invert.}
}
\value{
Numeric vector of length six containing the inverted
geotransform. The output vector will contain NAs if the input geotransform
is uninvertable.
}
\description{
\code{inv_geotransform()} inverts a vector of geotransform coefficients. This
converts the equation from being:\cr
raster pixel/line (column/row) -> geospatial x/y coordinate\cr
to:\cr
geospatial x/y coordinate -> raster pixel/line (column/row)
}
\examples{
elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
ds <- new(GDALRaster, elev_file)
invgt <- ds$getGeoTransform() |> inv_geotransform()
ds$close()

ptX = 324181.7
ptY = 5103901.4

## for a point x, y in the spatial reference system of elev_file
## raster pixel (column number):
pixel <- floor(invgt[1] +
               invgt[2] * ptX +
               invgt[3] * ptY)

## raster line (row number):
line <- floor(invgt[4] +
              invgt[5] * ptX +
              invgt[6] * ptY)

## get_pixel_line() applies this conversion
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster$getGeoTransform()}}, \code{\link[=get_pixel_line]{get_pixel_line()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdalraster_proc.R
\name{is_los_visible}
\alias{is_los_visible}
\title{Check line of sight between pairs of point locations}
\usage{
is_los_visible(
  dem,
  ptsA,
  ptsB,
  band = 1L,
  srsA = NULL,
  srsB = NULL,
  ZinterpA = "RELATIVE_TO_DEM",
  ZinterpB = "RELATIVE_TO_DEM",
  quiet = FALSE
)
}
\arguments{
\item{dem}{Either a character string giving the filename of the DEM
raster, or an object of class \code{GDALRaster} for the DEM.}

\item{ptsA}{A data frame or numeric matrix containing geospatial point
coordinates, or point geometries (with Z values) as a list of WKB raw vectors
or character vector of WKT strings. If data frame or matrix, the number of
columns must be three (x, y, z). May be also be given as a numeric vector for
one point (\code{c(x, y, z)}). If this argument contains a single point, then
line of sight will be checked between it and each point in \code{ptsB}, otherwise
\code{length(ptsA)} must equal \code{length(ptsB)}, and line of sight will be checked
pairwise.}

\item{ptsB}{The second set of points, as described above for \code{ptsA}.}

\item{band}{An integer value specifying the band number in \code{dem} to use.
Defaults to \code{1L}.}

\item{srsA}{An optional character string specifying the spatial reference
system for \code{ptsA}. May be in WKT format or any of the formats supported by
\code{\link[=srs_to_wkt]{srs_to_wkt()}}. If this argument is \code{NULL} (the default), then \code{ptsA} are
assumed to be in the same coordinate reference system as \code{dem}. Otherwise,
\code{ptsA} will be reprojected from \code{srsA} to the spatial reference of \code{dem}.}

\item{srsB}{An optional character string specifying the spatial reference
system for \code{ptsB} (see above). Defaults to \code{NULL}. If not \code{NULL}, \code{ptsB} will
be reprojected from \code{srsB} to the spatial reference of \code{dem}.}

\item{ZinterpA}{A character string specifying the interpretation of the Z
values for \code{ptsA}. The default is \code{"RELATIVE_TO_DEM"}, in which case the
location heights of \code{ptsA} are obtained by querying the DEM surface and
adding the Z value given in \code{ptsA}. Alternatively, the Z values can be
interpreted as absolute heights to be used unmodified by setting this
argument to \code{"ACTUAL"}.}

\item{ZinterpB}{A character string specifying the interpretation of the Z
values for \code{ptsB}. See the description above for \code{ZinterpA}.}

\item{quiet}{A logical value with default of \code{FALSE}. If set to \code{TRUE}, will
suppress a progress bar and informational messages.}
}
\value{
A logical vector of \code{length(ptsB)}, \code{TRUE} for each pair of points
that are within line of sight, otherwise \code{FALSE}.
The checks are done pairwise if \code{(length(ptsA) == length(ptsB))}, or
one-to-many if \code{length(ptsA) == 1} and multiple points are given in \code{ptsB}.
}
\description{
\code{is_los_visible()} is an interface to GDAL's line-of-sight algorithm
implemented by \code{GDALIsLineOfSightVisible()} in the Algorithms C API
(\url{https://gdal.org/en/stable/api/gdal_alg.html}). It checks line of sight
across a DEM surface using a Bresenham algorithm. The function can operate
pairwise on sets of input points, or one-to-many. Requires GDAL >= 3.9.
}
\note{
Input coordinates must be within the raster bounds. \code{NA} will be returned if
either coordinate is outside the raster extent, or is missing a Z value.

The GDAL documentation notes that line of sight is computed in raster
coordinate space, and thus may not be appropriate for some applications. For
example, datasets referenced against geographic coordinates at high latitudes
may have issues.

In GDAL 3.9 through 3.12, a point exactly on the surface of the DEM is never
visible with \code{GDALIsLineOfSightVisible()}, even if viewed from a point
directly above. For a detailed description, see
\url{https://github.com/OSGeo/gdal/issues/12458}. A workaround for that case
is to set a small but negligible positive Z value (if using
\code{"RELATIVE_TO_DEM"}) for points that are intended to be on the DEM surface,
if appropriate for the use case. GDAL as of version 3.13 treats a point
exactly on the surface as visible
(\url{https://github.com/OSGeo/gdal/pull/14237}).
}
\examples{
\dontshow{if (gdal_version_num() >= gdal_compute_version(3, 9, 0)) withAutoprint(\{ # examplesIf}
dem <- system.file("extdata/storml_elev.tif", package="gdalraster")

## no reprojection, the point coordinates are in the same projection as DEM

## one-to-many
ptA <- c(324625.0, 5104724.0, 1.7)
ptsB <-c(324803.0, 5104517.0, 10,
         325286.0, 5102923.0, 10,
         323847.0, 5104538.0, 10)
ptsB <- matrix(ptsB, nrow = 3, ncol = 3, byrow = TRUE)

is_los_visible(dem, ptA, ptsB)

## pairwise, same ptA location with varying height
ptsA <- c(324625.0, 5104724.0, 1,
          324625.0, 5104724.0, 10,
          324625.0, 5104724.0, 1000)
ptsA <- matrix(ptsA, nrow = 3, ncol = 3, byrow = TRUE)

is_los_visible(dem, ptsA, ptsB)

## WKB points
(ptsA_wkb <- g_create("POINT", ptsA))

# as WKT
g_wk2wk(ptsA_wkb)

# or as ISO WKT
g_wk2wk(ptsA_wkb, as_iso = TRUE)

is_los_visible(dem, ptsA_wkb, ptsB)

## reprojecting ptsA, and the DEM given as a dataset object
(ds <- new(GDALRaster, dem))

ptsA_wkb_wgs84 <- g_transform(ptsA_wkb, ds$getSpatialRef(), "WGS84")
g_wk2wk(ptsA_wkb_wgs84)

is_los_visible(ds, ptsA_wkb_wgs84, ptsB, srsA = "WGS84")

## read ptsB from a vector dataset, use original ptA

dsn <- system.file("extdata/storml_los_pts_b.geojson", package="gdalraster")
(lyr <- new(GDALVector, dsn))

(features <- lyr$fetch(-1))

is_los_visible(ds, ptA, features$geom, srsB = lyr$getSpatialRef(),
               ZinterpB = "ACTUAL")

ds$close()
lyr$close()
\dontshow{\}) # examplesIf}
}
\references{
Roberto de Beauclair Seixas, Maur Riguette Mediano and Marcelo Gattass. 1999.
Efficient Line-of-Sight Algorithms for Real Terrain Data.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdalraster_proc.R
\name{rasterize}
\alias{rasterize}
\title{Burn vector geometries into a raster}
\usage{
rasterize(
  src_dsn,
  dstfile,
  band = NULL,
  layer = NULL,
  where = NULL,
  sql = NULL,
  burn_value = NULL,
  burn_attr = NULL,
  invert = NULL,
  te = NULL,
  tr = NULL,
  tap = NULL,
  ts = NULL,
  dtName = NULL,
  dstnodata = NULL,
  init = NULL,
  fmt = NULL,
  co = NULL,
  add_options = NULL,
  quiet = FALSE
)
}
\arguments{
\item{src_dsn}{Data source name for the input vector layer (filename or
connection string).}

\item{dstfile}{Either a character string giving the filename of the
output raster dataset, or an object of class \code{GDALRaster} for the output.
Must support update mode access. If given as a filename, this file will
be created (or overwritten if it already exists - see Note).
If given as a \code{GDALRaster} object for an existing dataset, then the affected
pixels are updated in-place (object must be open with write access).}

\item{band}{Numeric vector. The band(s) to burn values into (for existing
\code{dstfile}). The default is to burn into band 1. Not used when creating a
new raster.}

\item{layer}{Character vector of layer names(s) from \code{src_dsn}  that will be
used for input features. At least one layer name or a \code{sql} option must be
specified.}

\item{where}{An optional SQL WHERE style query string to select features to
burn in from the input \code{layer}(s).}

\item{sql}{An SQL statement to be evaluated against \code{src_dsn} to produce a
virtual layer of features to be burned in (alternative to \code{layer}).}

\item{burn_value}{A fixed numeric value to burn into a band for all
features. A numeric vector can be supplied, one burn value per band being
written to.}

\item{burn_attr}{Character string. Name of an attribute field on the
features to be used for a burn-in value. The value will be burned into all
output bands.}

\item{invert}{Logical scalar. \code{TRUE} to invert rasterization. Burn the fixed
burn value, or the burn value associated with the first feature, into all
parts of the raster not inside the provided polygon.}

\item{te}{Numeric vector of length four. Sets the output raster extent. The
values must be expressed in georeferenced units. If not specified, the
extent of the output raster will be the extent of the vector layer.}

\item{tr}{Numeric vector of length two. Sets the target pixel resolution.
The values must be expressed in georeferenced units. Both must be positive.}

\item{tap}{Logical scalar. (target aligned pixels) Align the coordinates of
the extent of the output raster to the values of \code{tr}, such that the
aligned extent includes the minimum extent. Alignment means that
xmin / resx, ymin / resy, xmax / resx and ymax / resy are integer values.}

\item{ts}{Numeric vector of length two. Sets the output raster size in
pixels (xsize, ysize). Note that \code{ts} cannot be used with \code{tr}.}

\item{dtName}{Character name of output raster data type, e.g., \code{Byte},
\code{UInt8} (GDAL >= 3.13), \code{Int16}, \code{UInt16}, \code{Int32}, \code{UInt32}, \code{Float32},
\code{Float64}. Defaults to \code{Float64}.}

\item{dstnodata}{Numeric scalar. Assign a nodata value to output bands.}

\item{init}{Numeric vector. Pre-initialize the output raster band(s) with
these value(s). However, it is not marked as the nodata value in the output
file. If only one value is given, the same value is used in all the bands.}

\item{fmt}{Output raster format short name (e.g., \code{"GTiff"}). Will attempt
to guess from the output filename if \code{fmt} is not specified.}

\item{co}{Optional list of format-specific creation options for the output
raster in a vector of "NAME=VALUE" pairs
(e.g., \code{options = c("TILED=YES","COMPRESS=LZW")} to set LZW compression
during creation of a tiled GTiff file).}

\item{add_options}{An optional character vector of additional command-line
options to \code{gdal_rasterize} (see the \code{gdal_rasterize} documentation at the
URL above for all available options).}

\item{quiet}{Logical scalar. If \code{TRUE}, a progress bar will not be
displayed. Defaults to \code{FALSE}.}
}
\value{
Logical indicating success (invisible \code{TRUE}).
An error is raised if the operation fails.
}
\description{
\code{rasterize()} burns vector geometries (points, lines, or polygons) into
the band(s) of a raster dataset. Vectors are read from any GDAL
OGR-supported vector format.
This function is a wrapper for the \command{gdal_rasterize} command-line
utility (\url{https://gdal.org/en/stable/programs/gdal_rasterize.html}).
}
\note{
\code{rasterize()} creates a new target raster when \code{dstfile} is given as a
filename (character string). In that case, some combination of the \code{fmt},
\code{dstnodata}, \code{init}, \code{co}, \code{te}, \code{tr}, \code{tap}, \code{ts}, and \code{dtName} arguments
will be used. The resolution or size must be specified using either the \code{tr}
or \code{ts} argument for all new rasters. The target raster will be overwritten
if it already exists and any of these creation-related options are used.

To update an existing raster in-place, an object of class \code{GDALRaster} may
be given for the \code{dstfile} argument. The \code{GDALRaster} object should be open
for write access.
}
\examples{
# MTBS fire perimeters for Yellowstone National Park 1984-2022
dsn <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
sql <- "SELECT * FROM mtbs_perims ORDER BY mtbs_perims.ig_year"
out_file <- file.path(tempdir(), "ynp_fires_1984_2022.tif")

rasterize(src_dsn = dsn,
          dstfile = out_file,
          sql = sql,
          burn_attr = "ig_year",
          tr = c(90,90),
          tap = TRUE,
          dtName = "Int16",
          dstnodata = -9999,
          init = -9999,
          co = c("TILED=YES", "COMPRESS=LZW"))

(ds <- new(GDALRaster, out_file))

if (requireNamespace("scales")) {
  pal <- scales::viridis_pal(end = 0.8, direction = -1)(6)
  ramp <- scales::colour_ramp(pal)
  plot_raster(ds, legend = TRUE, col_map_fn = ramp, na_col = "#d9d9d9",
              main = "YNP Fires 1984-2022 - Most Recent Burn Year")
}

ds$close()
\dontshow{deleteDataset(out_file)}
}
\seealso{
\code{\link[=polygonize]{polygonize()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_unlink}
\alias{vsi_unlink}
\title{Delete a file}
\usage{
vsi_unlink(filename)
}
\arguments{
\item{filename}{Character string. The path of the file to be deleted.}
}
\value{
\code{0} on success or \code{-1} on an error.
}
\description{
\code{vsi_unlink()} deletes a file object from the file system.
This function goes through the GDAL \code{VSIFileHandler} virtualization and may
work on unusual filesystems such as in memory.
It is a wrapper for \code{VSIUnlink()} in the GDAL Common Portability Library.
Analog of the POSIX \code{unlink()} function.
}
\examples{
elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
mem_file <- file.path("/vsimem", "tmp.tif")
copyDatasetFiles(mem_file, elev_file)
vsi_read_dir("/vsimem")
vsi_unlink(mem_file)
vsi_read_dir("/vsimem")
}
\seealso{
\code{\link[=deleteDataset]{deleteDataset()}}, \code{\link[=vsi_rmdir]{vsi_rmdir()}}, \code{\link[=vsi_unlink_batch]{vsi_unlink_batch()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/display.R
\name{plot_geom}
\alias{plot_geom}
\title{Plot WKT or WKB geometries}
\usage{
plot_geom(x, xlab = "x", ylab = "y", main = "", ...)
}
\arguments{
\item{x}{Either a character vector containing one or more WKT strings, a raw
vector of WKB, or a list of WKB raw vectors.}

\item{xlab}{Title for the x axis.}

\item{ylab}{Title for the y axis.}

\item{main}{The main title (on top).}

\item{...}{Optional arguments passed to \code{wk::wk_plot()}.}
}
\value{
The input, invisibly.
}
\description{
\code{plot_geom()} plots one or more geometries given as either WKT or WKB raw
vectors, using \code{wk::wk_plot()}.
}
\examples{
# a Delaunay triangulation of 10 random points
set.seed(4)
x <- sample.int(100, 10)
y <- sample.int(100, 10)

g <- g_create("MULTIPOINT", cbind(x, y))
g_wk2wk(g)

plot_geom(g)

g2 <- g_delaunay_triangulation(g)
g_wk2wk(g2)

plot_geom(g2, add = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_read_dir}
\alias{vsi_read_dir}
\title{Read names in a directory}
\usage{
vsi_read_dir(path, max_files = 0L, recursive = FALSE, all_files = FALSE)
}
\arguments{
\item{path}{Character string. The relative or absolute path of a
directory to read.}

\item{max_files}{Integer scalar. The maximum number of files after which to
stop, or 0 for no limit (see Note). Ignored if \code{recursive = TRUE}.}

\item{recursive}{Logical scalar. \code{TRUE} to read the directory and its
subdirectories. Defaults to \code{FALSE}.}

\item{all_files}{Logical scalar. If \code{FALSE} (the default), only the names
of visible files are returned (following Unix-style visibility, that is
files whose name does not start with a dot). If \code{TRUE}, all file names
will be returned.}
}
\value{
A character vector containing the names of files and directories
in the directory given by \code{path} (may be an empty vector \code{character(0)}).
The listing is in alphabetical order, and does not include the special
entries '.' and '..' even if they are present in the directory. An empty
vector (\code{character(0)}) is returned if \code{path} does not exist.
}
\description{
\code{vsi_read_dir()} abstracts access to directory contents. It returns a
character vector containing the names of files and directories in this
directory. With \code{recursive = TRUE}, reads the list of entries in the
directory and subdirectories.
This function is a wrapper for \code{VSIReadDirEx()} and \code{VSIReadDirRecursive()}
in the GDAL Common Portability Library.
}
\note{
If \code{max_files} is set to a positive number, directory listing will stop
after that limit has been reached. Note that to indicate truncation, at
least one element more than the \code{max_files} limit will be returned. If the
length of the returned character vector is lesser or equal to \code{max_files},
then no truncation occurred. The \code{max_files} parameter is ignored when
\code{recursive = TRUE}.
}
\examples{
# regular file system for illustration
data_dir <- system.file("extdata", package="gdalraster")
vsi_read_dir(data_dir)
}
\seealso{
\code{\link[=vsi_glob]{vsi_glob()}}, \code{\link[=vsi_mkdir]{vsi_mkdir()}}, \code{\link[=vsi_rmdir]{vsi_rmdir()}}, \code{\link[=vsi_stat]{vsi_stat()}}, \code{\link[=vsi_sync]{vsi_sync()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom.R
\name{bbox_transform}
\alias{bbox_transform}
\title{Transform a bounding box to a different projection}
\usage{
bbox_transform(bbox, srs_from, srs_to, use_transform_bounds = TRUE)
}
\arguments{
\item{bbox}{Numeric vector of length four containing a bounding box
(xmin, ymin, xmax, ymax) to transform.}

\item{srs_from}{Character string specifying the spatial reference system
for \code{pts}. May be in WKT format or any of the formats supported by
\code{\link[=srs_to_wkt]{srs_to_wkt()}}.}

\item{srs_to}{Character string specifying the output spatial reference
system. May be in WKT format or any of the formats supported by
\code{\link[=srs_to_wkt]{srs_to_wkt()}}.}

\item{use_transform_bounds}{Logical value, \code{TRUE} to use
\code{transform_bounds()} (the default, requires GDAL >= 3.4). If \code{FALSE},
transformation is done with \code{g_transform()}.}
}
\value{
Numeric vector of length four containing a transformed bounding box
(xmin, ymin, xmax, ymax).
}
\description{
\code{bbox_transform()} is a convenience function to transform the coordinates
of a boundary from their current spatial reference system to a new target
spatial reference system.
}
\details{
With \code{use_transform_bounds = TRUE} (the default) this function returns:

\if{html}{\out{<div class="sourceCode">}}\preformatted{# requires GDAL >= 3.4
transform_bounds(bbox, srs_from, srs_to)
}\if{html}{\out{</div>}}

See Details for \code{\link[=transform_bounds]{transform_bounds()}} for cases where the bounds crossed the
antimeridian.

With \code{use_transform_bounds = FALSE}, this function returns:

\if{html}{\out{<div class="sourceCode">}}\preformatted{bbox_to_wkt(bbox) |>
  g_transform(srs_from, srs_to) |>
  bbox_from_wkt()
}\if{html}{\out{</div>}}

See the Note for \code{\link[=g_transform]{g_transform()}} for cases where the bounds crossed the
antimeridian.
}
\examples{
bb <- c(-1405880.72, -1371213.76, 5405880.72, 5371213.76)

# the default assumes GDAL >= 3.4
if (gdal_version_num() >= gdal_compute_version(3, 4, 0)) {
  bb_wgs84 <- bbox_transform(bb, "EPSG:32661", "EPSG:4326")
} else {
  bb_wgs84 <- bbox_transform(bb, "EPSG:32661", "EPSG:4326",
                             use_transform_bounds = FALSE)
}

print(bb_wgs84)
}
\seealso{
\code{\link[=bbox_from_wkt]{bbox_from_wkt()}}, \code{\link[=g_transform]{g_transform()}}, \code{\link[=transform_bounds]{transform_bounds()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{validateCreationOptions}
\alias{validateCreationOptions}
\title{Validate the list of creation options that are handled by a driver}
\usage{
validateCreationOptions(format, options)
}
\arguments{
\item{format}{Character string giving a format driver short name
(e.g., \code{"GTiff"}).}

\item{options}{A character vector of format-specific creation options as
\code{"NAME=VALUE"} pairs.}
}
\value{
A logical value, \code{TRUE} if the given creation options are
compatible with the capabilities declared by the GDAL_DMD_CREATIONOPTIONLIST
metadata item for the specified format driver (or if the
GDAL_DMD_CREATIONOPTIONLIST metadata item is not defined for this driver),
otherwise \code{FALSE}.
}
\description{
\code{validateCreationOptions()} is a helper function primarily used by GDAL's
Create() and CreateCopy() to validate that the passed-in list of creation
options is compatible with the GDAL_DMD_CREATIONOPTIONLIST metadata item
defined by some drivers. If the GDAL_DMD_CREATIONOPTIONLIST metadata item
is not defined, this function will return \code{TRUE}. Otherwise it will check
that the keys and values in the list of creation options are compatible
with the capabilities declared by the GDAL_DMD_CREATIONOPTIONLIST metadata
item. In case of incompatibility a message will be emitted and \code{FALSE} will
be returned. Wrapper of \code{GDALValidateCreationOptions()} in the GDAL API.
}
\examples{
validateCreationOptions("GTiff", c("COMPRESS=LZW", "TILED=YES"))
}
\seealso{
\code{\link[=getCreationOptions]{getCreationOptions()}}, \code{\link[=create]{create()}}, \code{\link[=createCopy]{createCopy()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ogr_reproject.R
\name{ogr_reproject}
\alias{ogr_reproject}
\title{Reproject a vector layer}
\usage{
ogr_reproject(
  src_dsn,
  src_layer,
  out_dsn,
  out_srs,
  out_fmt = NULL,
  overwrite = FALSE,
  append = FALSE,
  nln = NULL,
  nlt = NULL,
  dsco = NULL,
  lco = NULL,
  dialect = NULL,
  spat_bbox = NULL,
  src_open_options = NULL,
  progress = FALSE,
  add_cl_arg = NULL,
  return_obj = TRUE
)
}
\arguments{
\item{src_dsn}{Character string. The filename or database connection string
specifying the vector data source containing the input layer.}

\item{src_layer}{Character string. The name of the input layer in \code{src_dsn}
to reproject. Optionally can be given as an SQL SELECT statement to be
executed against \code{src_dsn}, defining the source layer as the result set.
May also be given as empty string (\code{""}), in which case the first layer by
index will be used (mainly useful for single-layer file formats such as
ESRI Shapefile).}

\item{out_dsn}{Character string. The filename or database connection string
specifying the vector data source to which the output layer will be written.}

\item{out_srs}{Character string specifying the output spatial reference
system. May be in WKT format or any of the formats supported by
\code{\link[=srs_to_wkt]{srs_to_wkt()}}.}

\item{out_fmt}{Optional character string giving the GDAL short name
of the output dataset format. Only used if \code{out_dsn} needs to be created.
Generally can be \code{NULL} in which case the format will be guessed from the
file extension.}

\item{overwrite}{Logical value. \code{TRUE} to overwrite the output layer if it
already exists. Defaults to \code{FALSE}.}

\item{append}{Logical value. \code{TRUE} to append to the output layer if it
already exists. Defaults to \code{FALSE}.}

\item{nln}{Optional character string giving an alternate name to assign the
new layer. By default, \code{src_layer} is used, but \code{nln} is required if
\code{src_layer}is a SQL SELECT statement.}

\item{nlt}{Optional character string to define the geometry type for the
output layer. Mainly useful when \code{nlt = PROMOTE_TO_MULTI} might be given to
automatically promote layers that mix polygon / multipolygons to
multipolygons, and layers that mix linestrings / multilinestrings to
multilinestrings. Can be useful when converting shapefiles to PostGIS and
other output formats that implement strict checks for geometry types.}

\item{dsco}{Optional character vector of format-specific creation options
for \code{out_dsn} (\code{"NAME=VALUE"} pairs). Should only be used if \code{out_dsn} does
not already exist.}

\item{lco}{Optional character vector of format-specific creation options
for the output layer (\code{"NAME=VALUE"} pairs). Should not be used if appending
to an existing layer.}

\item{dialect}{Optional character string specifying the SQL dialect to use.
The OGR SQL engine (\code{"OGRSQL"}) will be used by default if a value is not
given. The \code{"SQLite"} dialect can also be use. Only relevant if \code{src_layer}
is given as a SQL SELECT statement.}

\item{spat_bbox}{Optional numeric vector of length four specifying a spatial
bounding box (xmin, ymin, xmax, ymax), \emph{in the SRS of the source layer}.
Only features whose geometry intersects \code{spat_bbox} will be selected for
reprojection.}

\item{src_open_options}{Optional character vector of dataset open options
for \code{src_dsn} (format-specific \code{"NAME=VALUE"} pairs).}

\item{progress}{Logical value, \code{TRUE} to display progress on the terminal.
Defaults to \code{FALSE}. Only works if the input layer has "fast feature count"
capability.}

\item{add_cl_arg}{Optional character vector of additional command-line
arguments to be passed to \code{ogr2ogr()} (see Note).}

\item{return_obj}{Logical value, \code{TRUE} to return an object of class
\code{\link{GDALVector}} open on the output layer (the default).}
}
\value{
Upon successful completion, an object of class \code{\link{GDALVector}} is
returned by default (if \code{return_obj = TRUE}), or logical \code{TRUE} is returned
(invisibly) if \code{return_obj = FALSE}. An error is raised if reprojection
fails.
}
\description{
\code{ogr_reproject()} reprojects the features of a vector layer to a different
spatial reference system and writes the new layer to a specified output
dataset. The output may be in a different vector file format than the input
dataset. A source SRS definition must be available in the source layer
for reprojection to occur.
}
\details{
\code{ogr_reproject()} is a convenience wrapper to perform vector reprojection
via \code{ogr2ogr()}, which in turn is an API binding to GDAL's \code{ogr2ogr}
command-line utility.
}
\note{
For advanced use, additional command-line arguments may be passed to
\code{ogr2ogr()} in \code{add_cl_arg} (e.g., advanced geometry and SRS related
options). Users should be aware of possible implications and
compatibility with the arguments already implied by the parameterization
of \code{ogr_reproject()}.

The function will attempt to create the output datasource if it does not
already exist. Some formats (e.g., PostgreSQL) do not support creation of
new datasets (i.e., a database within PostgreSQL), but output layers can be
written to an existing database.
}
\examples{
# for GDAL < 3.11.4 (see https://github.com/OSGeo/gdal/issues/12934)
save_opt <- get_config_option("OGR2OGR_USE_ARROW_API")
set_config_option("OGR2OGR_USE_ARROW_API", "NO")

# MTBS fire perimeters
f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
(mtbs <- new(GDALVector, f, "mtbs_perims"))

mtbs$getSpatialRef() |> srs_is_projected()  # TRUE

# YNP boundary
f <- system.file("extdata/ynp_features.zip", package = "gdalraster")
unzip(f, files = "ynp_features.gpkg", exdir = tempdir())
ynp_dsn <- file.path(tempdir(), "ynp_features.gpkg")

(bnd <- new(GDALVector, ynp_dsn, "ynp_bnd"))

bnd$getSpatialRef() |> srs_is_projected()  # FALSE

# project the boundary to match the MTBS layer
out_dsn <- tempfile(fileext = ".gpkg")
(bnd_mtsp <- ogr_reproject(ynp_dsn, "ynp_bnd", out_dsn, mtbs$getSpatialRef()))

bnd_mtsp$getFeatureCount()

plot(bnd_mtsp$getNextFeature(), col = "wheat")

mtbs$setAttributeFilter("incid_name = 'MAPLE'")
mtbs$getFeatureCount()  # 1

(feat <- mtbs$getNextFeature())

plot(feat, col = "red", border = NA, add = TRUE)

mtbs$close()
bnd$close()
bnd_mtsp$close()

# reset config option to original
set_config_option("OGR2OGR_USE_ARROW_API", save_opt)
\dontshow{unlink(out_dsn)}
\dontshow{unlink(ynp_dsn)}
\dontshow{set_config_option("OGR2OGR_USE_ARROW_API", "")}
}
\seealso{
\code{\link[=ogr2ogr]{ogr2ogr()}}

GDAL documentation for \code{ogr2ogr}:\cr
\url{https://gdal.org/en/stable/programs/ogr2ogr.html}

\code{\link[=warp]{warp()}} for raster reprojection
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdalraster_proc.R
\name{rasterFromRaster}
\alias{rasterFromRaster}
\title{Create a raster from an existing raster as template}
\usage{
rasterFromRaster(
  srcfile,
  dstfile,
  fmt = NULL,
  nbands = NULL,
  dtName = NULL,
  options = NULL,
  init = NULL,
  dstnodata = init,
  quiet = FALSE
)
}
\arguments{
\item{srcfile}{Source raster filename.}

\item{dstfile}{Output raster filename.}

\item{fmt}{Output raster format name (e.g., "GTiff" or "HFA"). Will attempt
to guess from the output filename if \code{fmt} is not specified.}

\item{nbands}{Number of output bands.}

\item{dtName}{Output raster data type name. Commonly used types include
\code{"Byte"} (or \code{"UInt8"} in GDAL >= 3.13), \code{"Int16"}, \code{"UInt16"}, \code{"Int32"}
and \code{"Float32"}.}

\item{options}{Optional list of format-specific creation options in a
vector of "NAME=VALUE" pairs
(e.g., \code{options = c("COMPRESS=LZW")} to set LZW compression
during creation of a GTiff file).}

\item{init}{Numeric value to initialize all pixels in the output raster.}

\item{dstnodata}{Numeric nodata value for the output raster.}

\item{quiet}{Logical value, \code{TRUE} to suppress informational messages.}
}
\value{
Returns the destination filename invisibly.
}
\description{
\code{rasterFromRaster()} creates a new raster with spatial reference,
extent and resolution taken from a template raster, without copying data.
Optionally changes the format, number of bands, data type and nodata value,
sets driver-specific dataset creation options, and initializes to a value.
}
\examples{
# band 2 in a FARSITE landscape file has slope degrees
# convert slope degrees to slope percent in a new raster
lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
ds_lcp <- new(GDALRaster, lcp_file)
ds_lcp$getMetadata(band = 2, domain = "")

slpp_file <- file.path(tempdir(), "storml_slpp.tif")
opt = c("COMPRESS=LZW")
rasterFromRaster(srcfile = lcp_file,
                 dstfile = slpp_file,
                 nbands = 1,
                 dtName = "Int16",
                 options = opt,
                 init = -32767)
ds_slp <- new(GDALRaster, slpp_file, read_only = FALSE)

# slpp_file is initialized to -32767 and nodata value set
ds_slp$getNoDataValue(band=1)

# extent and cell size are the same as lcp_file
ds_lcp$bbox()
ds_lcp$res()
ds_slp$bbox()
ds_slp$res()

# convert slope degrees in lcp_file band 2 to slope percent in slpp_file
# bring through LCP nodata -9999 to the output nodata value
ncols <- ds_slp$getRasterXSize()
nrows <- ds_slp$getRasterYSize()
for (row in 0:(nrows-1)) {
    rowdata <- ds_lcp$read(band = 2,
                           xoff = 0, yoff = row,
                           xsize = ncols, ysize = 1,
                           out_xsize = ncols, out_ysize = 1)
    rowslpp <- tan(rowdata*pi/180) * 100
    rowslpp[rowdata==-9999] <- -32767
    dim(rowslpp) <- c(1, ncols)
    ds_slp$write(band = 1, xoff = 0, yoff = row,
                 xsize = ncols, ysize = 1,
                 rasterData = rowslpp)
}

# min, max, mean, sd
ds_slp$getStatistics(band = 1, approx_ok = FALSE, force = TRUE)

ds_slp$close()
ds_lcp$close()
\dontshow{deleteDataset(slpp_file)}
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster-class}}, \code{\link[=create]{create()}}, \code{\link[=createCopy]{createCopy()}},
\code{\link[=bandCopyWholeRaster]{bandCopyWholeRaster()}}, \code{\link[=translate]{translate()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdalraster_proc.R
\name{calc}
\alias{calc}
\title{Raster calculation}
\usage{
calc(
  expr,
  rasterfiles,
  bands = NULL,
  var.names = NULL,
  dstfile = tempfile("rastcalc", fileext = ".tif"),
  fmt = NULL,
  dtName = "Int16",
  out_band = 1L,
  options = NULL,
  nodata_value = NULL,
  setRasterNodataValue = FALSE,
  write_mode = "safe",
  quiet = FALSE,
  return_obj = FALSE,
  ...
)
}
\arguments{
\item{expr}{An \R expression as a character string (e.g., \code{"A + B"}).}

\item{rasterfiles}{Input rasters, either a character vector of filenames,
or a list with each element either a filename as character string or an
object of class \code{GDALRaster} (must be an open dataset for the latter).}

\item{bands}{Integer vector of band numbers to use for each raster layer.}

\item{var.names}{Character vector of variable names to use for each raster
layer.}

\item{dstfile}{Either a character string with the output raster filename, or
an object of class \code{GDALRaster} with which to write output. If given as an
object, the dataset must be open for write access, and the arguments below
related to raster creation are ignored (i.e., \code{fmt}, \code{dtName}, \code{options},
\code{setRasterNodataValue}). The \code{write_mode} must be set to \code{"update"} for
writing with an existing dataset object.}

\item{fmt}{Output raster format name (e.g., "GTiff" or "HFA"). Will attempt
to guess from the output filename if not specified.}

\item{dtName}{Character name of output data type (e.g., Byte, UInt8
(GDAL >= 3.13), Int16, UInt16, Int32, UInt32, Float32).}

\item{out_band}{Integer band number(s) in \code{dstfile} for writing output.
Defaults to \code{1L}. Multi-band output is supported as of gdalraster 1.11.0,
in which case \code{out_band} would be a vector of band numbers.}

\item{options}{Optional list of format-specific creation options in a
vector of "NAME=VALUE" pairs
(e.g., \code{options = c("TILED=YES", "COMPRESS=LZW")} to set LZW compression
during creation of a tiled GTiff file).}

\item{nodata_value}{Numeric value to assign if \code{expr} returns \code{NA}.}

\item{setRasterNodataValue}{Logical value. \code{TRUE} will attempt to set the
raster format nodata value to \code{nodata_value}, or \code{FALSE} not to set a raster
nodata value on the output dataset.}

\item{write_mode}{Character string. Name of the file write mode for output.
One of:
\itemize{
\item \code{safe} - execution stops if \code{dstfile} already exists (no output written)
\item \code{overwrite} - if \code{dstfile} exists it will be overwritten with a new file
\item \code{update} - if \code{dstfile} exists, will attempt to open in update mode, or
write to the existing dataset if \code{dstfile} is given as an object
}}

\item{quiet}{Logical value. If \code{TRUE}, a progress bar and informational
messages will not be displayed. Defaults to \code{FALSE}.}

\item{return_obj}{Logical value. If \code{TRUE}, an object of class
\code{\link{GDALRaster}} opened on the newly created dataset will be
returned. The default is \code{FALSE}.}

\item{...}{Additional arguments, none currently supported.}
}
\value{
By default, returns the output filename invisibly. An object of
class \code{\link{GDALRaster}} open on the output dataset will be returned
if \code{return_obj = TRUE}.
}
\description{
\code{calc()} evaluates an \R expression for each pixel in a raster layer or
stack of layers. Each layer is defined by a raster filename or dataset
object, band number, and a variable name to use in the \R expression. If not
specified, band defaults to \code{1} for each input raster. Variable names
default to \code{LETTERS} if not specified (\code{A} (layer 1), \code{B} (layer 2), ...).
All of the input layers must have the same extent and cell size.
The projection will be read from the first raster in the list of inputs.
Individual pixel coordinates are also available as variables in the
\R expression, as either x/y in the raster projected coordinate system or
inverse projected longitude/latitude.
Multi-band output is supported as of gdalraster 1.11.0.
}
\details{
The variables in \code{expr} are vectors of length raster xsize (i.e., row
vectors of the input raster layer(s), with length the number of raster
columns). The expression should return a vector also of length raster xsize
(an output row). Four special variable names are available in \code{expr}:
\code{pixelX} and \code{pixelY} provide pixel center coordinates in projection units.
\code{pixelLon} and \code{pixelLat} can also be used, in which case the pixel x/y
coordinates will be inverse projected to longitude/latitude
(in the same geographic coordinate system used by the input projection,
which is read from the first input raster). Note that inverse projection
adds computation time.

To refer to specific bands in a multi-band input file, repeat the filename
or dataset object in \code{rasterfiles} and specify corresponding band numbers in
\code{bands}, along with optional variable names in \code{var.names}, e.g.,
\preformatted{
rasterfiles = c("multiband.tif", "multiband.tif")
bands = c(4, 5)
var.names = c("B4", "B5")
}

Output will be written to \code{dstfile}. To update a file that already
exists, set \code{write_mode = "update"} and set \code{out_band} to an existing
band number(s) in \code{dstfile} (new bands cannot be created in \code{dstfile}).
\code{dstfile} can optionally be given as an object of class \code{GDALRaster} open
for write access.

To write multi-band output, \code{expr} must return a vector of values
interleaved by band. This is equivalent to, and can also be returned as,
a matrix \code{m} with \code{nrow(m)} equal to \code{length()} of an input vector, and
\code{ncol(m)} equal to the number of output bands. In matrix form, each column
contains a vector of output values for a band.
\code{length(m)} must be equal to the \code{length()} of an input vector multiplied by
\code{length(out_band)}. The dimensions described above are assumed and not
read from the return value of \code{expr}.
}
\examples{
## Using pixel longitude/latitude

# Hopkins bioclimatic index (HI) as described in:
# Bechtold, 2004, West. J. Appl. For. 19(4):245-251.
# Integrates elevation, latitude and longitude into an index of the
# phenological occurrence of springtime. Here it is relativized to
# mean values for an eight-state region in the western US.
# Positive HI means spring is delayed by that number of days relative
# to the reference position, while negative values indicate spring is
# advanced. The original equation had elevation units as feet, so
# converting m to ft in `expr`.

elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")

# expression to calculate HI
expr <- "round( ((ELEV_M * 3.281 - 5449) / 100) +
                ((pixelLat - 42.16) * 4) +
                ((-116.39 - pixelLon) * 1.25) )"

# calc() writes to a tempfile by default
hi_file <- calc(expr = expr,
                rasterfiles = elev_file,
                var.names = "ELEV_M",
                dtName = "Int16",
                nodata_value = -32767,
                setRasterNodataValue = TRUE)

ds <- new(GDALRaster, hi_file)
# min, max, mean, sd
ds$getStatistics(band = 1, approx_ok = FALSE, force = TRUE)
ds$close()
\dontshow{deleteDataset(hi_file)}

## Calculate normalized difference vegetation index (NDVI)
## input rasters given as dataset objects
## output to an in-memory raster (MEM format)

# Landast band 4 (red) and band 5 (near infrared):
b4_file <- system.file("extdata/sr_b4_20200829.tif", package="gdalraster")
b4 <- new(GDALRaster, b4_file)
b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
b5 <- new(GDALRaster, b5_file)

expr <- "((B5 * 0.0000275 - 0.2) - (B4 * 0.0000275 - 0.2)) /
         ((B5 * 0.0000275 - 0.2) + (B4 * 0.0000275 - 0.2))"

(ndvi <- calc(expr, list(b4, b5), var.names = c("B4", "B5"), fmt = "MEM",
              dtName = "Float32", setRasterNodataValue = TRUE,
              return_obj = TRUE))

plot_raster(ndvi, legend = TRUE,
            col_map_fn = c("#7b3294", "#c2a5cf", "#a6dba0", "#008837"),
            main = "Storm Lake NDVI 2020-08-29")

ndvi$close()
b4$close()
b5$close()

## Reclassify a variable by rule set

# Combine two raster layers and look for specific combinations. Then
# recode to a new value by rule set.
#
# Based on example in:
#   Stratton, R.D. 2009. Guidebook on LANDFIRE fuels data acquisition,
#   critique, modification, maintenance, and model calibration.
#   Gen. Tech. Rep. RMRS-GTR-220. U.S. Department of Agriculture,
#   Forest Service, Rocky Mountain Research Station. 54 p.
# Context: Refine national-scale fuels data to improve fire simulation
#   results in localized applications.
# Issue: Areas with steep slopes (40+ degrees) were mapped as
#   GR1 (101; short, sparse dry climate grass) and
#   GR2 (102; low load, dry climate grass) but were not carrying fire.
# Resolution: After viewing these areas in Google Earth,
#   NB9 (99; bare ground) was selected as the replacement fuel model.

# look for combinations of slope >= 40 and FBFM 101 or 102
lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
rasterfiles <- c(lcp_file, lcp_file)
var.names <- c("SLP", "FBFM")
bands <- c(2, 4)
tbl <- combine(rasterfiles, var.names, bands)
nrow(tbl)
tbl_subset <- subset(tbl, SLP >= 40 & FBFM \%in\% c(101,102))
print(tbl_subset)       # twelve combinations meet the criteria
sum(tbl_subset$count)   # 85 total pixels

# recode these pixels to 99 (bare ground)
# the LCP driver does not support in-place write so make a copy as GTiff
tif_file <- file.path(tempdir(), "storml_lndscp.tif")
createCopy("GTiff", tif_file, lcp_file)

expr <- "ifelse( SLP >= 40 & FBFM \%in\% c(101,102), 99, FBFM)"
calc(expr = expr,
     rasterfiles = c(lcp_file, lcp_file),
     bands = c(2, 4),
     var.names = c("SLP", "FBFM"),
     dstfile = tif_file,
     out_band = 4,
     write_mode = "update")

# verify the ouput
rasterfiles <- c(tif_file, tif_file)
tbl <- combine(rasterfiles, var.names, bands)
tbl_subset <- subset(tbl, SLP >= 40 & FBFM \%in\% c(101,102))
print(tbl_subset)
sum(tbl_subset$count)

# if LCP file format is needed:
# createCopy("LCP", "storml_edited.lcp", tif_file)
\dontshow{deleteDataset(tif_file)}
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster-class}}, \code{\link[=combine]{combine()}}, \code{\link[=rasterToVRT]{rasterToVRT()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_helpers.R
\name{gdal_compute_version}
\alias{gdal_compute_version}
\title{Compute a GDAL integer version number from major, minor, revision}
\usage{
gdal_compute_version(maj, min, rev)
}
\arguments{
\item{maj}{Numeric value, major version component (coerced to integer by
truncation).}

\item{min}{Numeric value, min version component (coerced to integer by
truncation).}

\item{rev}{Numeric value, revision version component (coerced to integer by
truncation).}
}
\value{
Integer version number compatible with \code{gdal_version_num()}.
}
\description{
\code{gdal_compute_version()} computes a full integer version number
(GDAL_VERSION_NUM) from individual components (major, minor, revision).
Convenience function for checking a GDAL version requirement using
\code{gdal_version_num()}.
}
\examples{
(gdal_version_num() >= gdal_compute_version(3, 7, 0))
}
\seealso{
\code{\link[=gdal_version_num]{gdal_version_num()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdalraster_proc.R
\name{dem_proc}
\alias{dem_proc}
\title{GDAL DEM processing}
\usage{
dem_proc(
  mode,
  srcfile,
  dstfile,
  mode_options = DEFAULT_DEM_PROC[[mode]],
  color_file = NULL,
  quiet = FALSE
)
}
\arguments{
\item{mode}{Character. Name of the DEM processing mode. One of hillshade,
slope, aspect, color-relief, TRI, TPI or roughness.}

\item{srcfile}{Filename of the source elevation raster.}

\item{dstfile}{Filename of the output raster.}

\item{mode_options}{An optional character vector of command-line options
(see \link{DEFAULT_DEM_PROC} for default values).}

\item{color_file}{Filename of a text file containing lines formatted as:
"elevation_value red green blue". Only used when \code{mode = "color-relief"}.}

\item{quiet}{Logical scalar. If \code{TRUE}, a progress bar will not be
displayed. Defaults to \code{FALSE}.}
}
\value{
Logical indicating success (invisible \code{TRUE}).
An error is raised if the operation fails.
}
\description{
\code{dem_proc()} generates DEM derivatives from an input elevation raster. This
function is a wrapper for the \command{gdaldem} command-line utility.
See \url{https://gdal.org/en/stable/programs/gdaldem.html} for details.
}
\note{
Band 1 of the source elevation raster is read by default, but this can be
changed by including a \code{-b} command-line argument in \code{mode_options}.
See the \href{https://gdal.org/en/stable/programs/gdaldem.html}{documentation for
\code{gdaldem}} for a description of all available options for each processing
mode.
}
\examples{
## hillshade
elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
out_file <- file.path(tempdir(), "storml_hillshade.tif")
dem_proc("hillshade", elev_file, out_file)

ds <- new(GDALRaster, out_file)
plot_raster(ds)

ds$close()
\dontshow{deleteDataset(out_file)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_helpers.R
\name{make_chunk_index}
\alias{make_chunk_index}
\title{Generate an index of chunk offsets and sizes for iterating a raster}
\usage{
make_chunk_index(
  raster_xsize,
  raster_ysize,
  block_xsize,
  block_ysize,
  gt = c(0, 1, 0, 0, 0, 1),
  max_pixels = 0
)
}
\arguments{
\item{raster_xsize}{Integer value giving the number of raster columns.}

\item{raster_ysize}{Integer value giving the number of raster rows.}

\item{block_xsize}{Integer value giving the horizontal size of a raster block
in number of pixels.}

\item{block_ysize}{Integer value giving the vertical size of a raster block
in number of pixels.}

\item{gt}{A numeric vector of length six containing the affine geotransform
for the raster (defaults to \code{c(0, 1, 0, 0, 0, 1)}). Required only if
geospatial bounding boxes of the chunks are needed in the output.}

\item{max_pixels}{Numeric value (a whole number), optionally carrying the
\code{bit64::integer64} class attribute. Specifies the maximum number of pixels
per chunk. Can be set to zero to define chunks as the blocks.}
}
\value{
A numeric matrix with number of rows equal to the number of chunks,
and named columns: \code{xchunkoff}, \code{ychunkoff}, \code{xoff}, \code{yoff}, \code{xsize},
\code{ysize}, \code{xmin}, \code{xmax}, \code{ymin}, \code{ymax}. Offsets are 0-based.
}
\description{
\code{make_chunk_index()} returns a matrix of \code{xchunkoff}, \code{ychunkoff}, \code{xoff},
\code{yoff}, \code{xsize}, \code{ysize}, \code{xmin}, \code{xmax}, \code{ymin} and \code{ymax}, i.e., indexing
of potentially multi-block chunks defined on block boundaries for iterating
I/O operations over a raster. The last four columns are geospatial
coordinates of the bounding box. Note that class \code{GDALRaster} provides a
method of the same name that is more convenient to use with a dataset object.
}
\details{
The stand-alone function here supports the general case of chunking/tiling a
raster layout without using a dataset object. If the \code{max_pixels} argument
is set to zero, the chunks are raster blocks (the internal tiles in the case
of a tiled format). Otherwise, chunks are defined as the maximum number of
consecutive whole blocks containing \verb{<= max_pixels}, that may span one or
multiple whole rows of blocks.
}
\examples{
## chunk as one block
blocks <- make_chunk_index(raster_xsize = 156335, raster_ysize = 101538,
                           block_xsize = 256, block_ysize = 256,
                           gt = c(-2362395, 30, 0, 3267405, 0, -30),
                           max_pixels = 0)

nrow(blocks)

head(blocks)

tail(blocks)

## chunk as 16 consecutive blocks
chunks <- make_chunk_index(raster_xsize = 156335, raster_ysize = 101538,
                           block_xsize = 256, block_ysize = 256,
                           gt = c(-2362395, 30, 0, 3267405, 0, -30),
                           max_pixels = 256 * 256 * 16)

nrow(chunks)

head(chunks)

tail(chunks)
}
\seealso{
Methods \code{make_chunk_index()}, \code{readChunk()} and
\code{writeChunk()} in class \link{GDALRaster}.

Usage example in the web article
\href{https://firelab.github.io/gdalraster/articles/gdal-block-cache.html}{GDAL Block Cache}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{pop_error_handler}
\alias{pop_error_handler}
\title{Pop error handler off stack}
\usage{
pop_error_handler()
}
\value{
No return value, called for side effects.
}
\description{
\code{pop_error_handler()} is a wrapper for \code{CPLPopErrorHandler()} in the GDAL
Common Portability Library.
Discards the current error handler on the error handler stack, and restores
the one in use before the last \code{push_error_handler()} call. This method has
no effect if there are no error handlers on the current thread's error
handler stack.
}
\examples{
push_error_handler("quiet")
# ...
pop_error_handler()
}
\seealso{
\code{\link[=push_error_handler]{push_error_handler()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grid_helpers.R
\name{bbox_from_dim_gt}
\alias{bbox_from_dim_gt}
\title{Bounding box from dimensions and geotransform}
\usage{
bbox_from_dim_gt(dm, gt)
}
\arguments{
\item{dm}{Integer vector of length two containing the raster dimensions
(xsize, ysize) in pixels.}

\item{gt}{Numeric vector of length six containing the geotransform
coefficients.}
}
\value{
Numeric vector of length four containing the bounding box
(xmin, ymin, xmax, ymax) in georeferenced coordinates.
}
\description{
\code{bbox_from_dim_gt()} computes the bounding box from raster dimensions and
geotransform coefficients. For rotated rasters, returns the axis-aligned
envelope of the four corner coordinates.
}
\examples{
elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
ds <- new(GDALRaster, elev_file)
gt <- ds$getGeoTransform()
dm <- ds$dim()

# should match ds$bbox()
bbox_from_dim_gt(dm, gt)
ds$bbox()

ds$close()
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster$getGeoTransform()}},
\code{\link[=GDALRaster]{GDALRaster$bbox()}}, \code{\link[=gt_from_dim_bbox]{gt_from_dim_bbox()}},
\code{\link[=inv_geotransform]{inv_geotransform()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_set_path_option}
\alias{vsi_set_path_option}
\title{Set a path specific option for a given path prefix}
\usage{
vsi_set_path_option(path_prefix, key, value)
}
\arguments{
\item{path_prefix}{Character string. A path prefix of a virtual file system
handler. Typically of the form \verb{/vsiXXX/bucket}.}

\item{key}{Character string. Option key.}

\item{value}{Character string. Option value. Passing \code{value = ""} (empty
string) will unset a value previously set by \code{vsi_set_path_option()}.}
}
\value{
No return value, called for side effect.
}
\description{
\code{vsi_set_path_option()} sets a path specific option for a given path
prefix. Such an option is typically, but not limited to, setting
credentials for a virtual file system.
Wrapper for \code{VSISetPathSpecificOption()} in the GDAL Common Portability
Library. Requires GDAL >= 3.6.
}
\details{
Options may also be set with \code{set_config_option()}, but
\code{vsi_set_path_option()} allows specifying them with a granularity at the
level of a file path. This makes it easier if using the same virtual file
system but with different credentials (e.g., different credentials for
buckets "/vsis3/foo" and "/vsis3/bar"). This is supported for the following
virtual file systems: /vsis3/, /vsigs/, /vsiaz/, /vsioss/, /vsiwebhdfs,
/vsiswift.
}
\note{
Setting options for a path starting with /vsiXXX/ will also apply for
/vsiXXX_streaming/ requests.

No particular care is taken to store options in RAM in a secure way.
So they might accidentally hit persistent storage if swapping occurs,
or someone with access to the memory allocated by the process may be
able to read them.
}
\seealso{
\code{\link[=set_config_option]{set_config_option()}}, \code{\link[=vsi_clear_path_options]{vsi_clear_path_options()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_util.R
\name{translate}
\alias{translate}
\title{Convert raster data between different formats}
\usage{
translate(src_filename, dst_filename, cl_arg = NULL, quiet = FALSE)
}
\arguments{
\item{src_filename}{Either a character string giving the filename of the
source raster, or an object of class \code{GDALRaster} for the source.}

\item{dst_filename}{Character string. Filename of the output raster.}

\item{cl_arg}{Optional character vector of command-line arguments for
\code{gdal_translate} (see URL above).}

\item{quiet}{Logical scalar. If \code{TRUE}, a progress bar will not be
displayed. Defaults to \code{FALSE}.}
}
\value{
Logical indicating success (invisible \code{TRUE}).
An error is raised if the operation fails.
}
\description{
\code{translate()} is a wrapper of the \command{gdal_translate} command-line
utility (see \url{https://gdal.org/en/stable/programs/gdal_translate.html}).
The function can be used to convert raster data between different
formats, potentially performing some operations like subsetting,
resampling, and rescaling pixels in the process. Refer to the GDAL
documentation at the URL above for a list of command-line arguments that
can be passed in \code{cl_arg}.
}
\examples{
# convert the elevation raster to Erdas Imagine format and resample to 90m
elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
img_file <- file.path(tempdir(), "storml_elev_90m.img")

# command-line arguments for gdal_translate
args <- c("-tr", "90", "90", "-r", "average")
args <- c(args, "-of", "HFA", "-co", "COMPRESSED=YES")

translate(elev_file, img_file, args)

ds <- new(GDALRaster, img_file)
ds$info()

ds$close()
\dontshow{deleteDataset(img_file)}
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster-class}}, \code{\link[=rasterFromRaster]{rasterFromRaster()}}, \code{\link[=warp]{warp()}}

\code{\link[=ogr2ogr]{ogr2ogr()}} for vector data
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vsifile.R
\name{VSIFile-class}
\alias{VSIFile-class}
\alias{Rcpp_VSIFile}
\alias{Rcpp_VSIFile-class}
\alias{VSIFile}
\title{Class wrapping the GDAL VSIVirtualHandle API for binary file I/O}
\arguments{
\item{filename}{Character string containing the filename to open. It may be
a file in a regular local filesystem, or a filename with a GDAL /vsiPREFIX/
(see \url{https://gdal.org/en/stable/user/virtual_file_systems.html}).}

\item{access}{Character string containing the access requested (i.e., \code{"r"},
\code{"r+"}, \code{"w"}, \verb{"w+}). Defaults to \code{"r"}. Binary access is always implied
and the "b" does not need to be included in \code{access}.
\tabular{lll}{
\strong{Access} \tab \strong{Explanation}             \tab \strong{If file exists}\cr
\code{"r"}      \tab open file for reading       \tab read from start\cr
\code{"r+"}     \tab open file for read/write    \tab read from start\cr
\code{"w"}      \tab create file for writing     \tab destroy contents\cr
\code{"w+"}     \tab create file for read/write  \tab destroy contents
}}

\item{options}{Optional character vector of \code{NAME=VALUE} pairs specifying
filesystem-dependent options. These are the options provided by
\code{VSIFOpenEx2L()} in the GDAL API (GDAL >= 3.3, see Details).}
}
\value{
An object of class \code{VSIFile} which contains a pointer to a
\code{VSIVirtualHandle}. Class methods are described in Details, along with a set
of writable fields for per-object settings.
}
\description{
\code{VSIFile} provides bindings to the GDAL VSIVirtualHandle API. Encapsulates a
\code{VSIVirtualHandle}
(\url{https://gdal.org/en/stable/api/cpl_cpp.html#_CPPv416VSIVirtualHandle}).
This API abstracts binary file I/O across "regular" file systems, URLs,
cloud storage services, Zip/GZip/7z/RAR, and in-memory files.
It provides analogs of several Standard C file I/O functions, allowing
virtualization of disk I/O so that non-file data sources can be made to
appear as files.

\code{VSIFile} is a C++ class exposed directly to \R (via \code{RCPP_EXPOSED_CLASS}).
Fields and methods of the class are accessed using the \code{$} operator.
}
\note{
File offsets are given as \R \code{numeric} (i.e., \code{double} type), optionally
carrying the \code{bit64::integer64} class attribute. They are returned as
\code{numeric} with the \code{integer64} class attribute attached. The \code{integer64}
type is signed, so the maximum file offset supported by this interface
is \code{9223372036854775807} (the value of \code{bit64::lim.integer64()[2]}).

Some virtual file systems allow only sequential write, so no seeks or read
operations are then allowed (e.g., AWS S3 files with /vsis3/).
Starting with GDAL 3.2, a configuration option can be set with:

\if{html}{\out{<div class="sourceCode">}}\preformatted{set_config_option("CPL_VSIL_USE_TEMP_FILE_FOR_RANDOM_WRITE", "YES")
}\if{html}{\out{</div>}}

in which case random-write access is possible (involves the creation of a
temporary local file, whose location is controlled by the \code{CPL_TMPDIR}
configuration option). In this case, setting \code{access} to \code{"w+"} may be
needed for writing with seek and read operations (if creating a new file,
otherwise, \code{"r+"} to open an existing file), while \code{"w"} access would
allow sequential write only.
}
\section{Usage (see Details)}{


\if{html}{\out{<div class="sourceCode">}}\preformatted{## Constructors
vf <- new(VSIFile, filename)
# specifying access:
vf <- new(VSIFile, filename, access)
# specifying access and options (both required):
vf <- new(VSIFile, filename, access, options)

## Read/write fields (per-object settings)
vf$reportVSIFErrorAsEof

## Methods
vf$seek(offset, origin)
vf$tell()
vf$rewind()
vf$read(nbytes)
vf$write(object)
vf$eof()
vf$truncate(new_size)
vf$flush()
vf$ingest(max_size)

vf$close()
vf$open()
vf$get_filename()
vf$get_access()
vf$set_access(access)
}\if{html}{\out{</div>}}
}

\section{Details}{

\subsection{Constructors}{

\code{new(VSIFile, filename)}\cr
Returns an object of class \code{VSIFile}, or an error is raised if a file
handle cannot be obtained.

\code{new(VSIFile, filename, access)}\cr
Alternate constructor for passing \code{access} as a character string
(e.g., \code{"r"}, \code{"r+"}, \code{"w"}, \code{"w+"}).
Returns an object of class \code{VSIFile} with an open file handle, or an error
is raised if a file handle cannot be obtained.

\code{new(VSIFile, filename, access, options)}\cr
Alternate constructor for passing \code{access} as a character string, and
\code{options} as a character vector of "NAME=VALUE" pairs (all arguments
required, GDAL >= 3.3 required for \code{options} support).

The \code{options} argument is highly file system dependent. Supported options
as of GDAL 3.10 include:
\itemize{
\item MIME headers such as Content-Type and Content-Encoding are supported for
the /vsis3/, /vsigs/, /vsiaz/, /vsiadls/ file systems.
\item DISABLE_READDIR_ON_OPEN=YES/NO (GDAL >= 3.6) for /vsicurl/ and other
network-based file systems. By default, directory file listing is done,
unless YES is specified.
\item WRITE_THROUGH=YES (GDAL >= 3.8) for Windows regular files to set the
FILE_FLAG_WRITE_THROUGH flag to the \code{CreateFile()} function. In that mode,
the data are written to the system cache but are flushed to disk without
delay.
}

Options specific to /vsis3/, /vsigs/, /vsioss/ and /vsiaz/:
\itemize{
\item CACHE=YES/NO (GDAL >= 3.10) whether file metadata and content that is read
from the network should be kept cached in memory, after file handle closing.
Default is YES, unless the filename is set in CPL_VSIL_CURL_NON_CACHED.
\item CHUNK_SIZE=val in MiB (GDAL >= 3.10) for "w" mode. Size of a block. Default
is 50 MiB. For /vsis3/, /vsigz/, /vsioss/, it can be up to 5000 MiB.
For /vsiaz/, only taken into account when BLOB_TYPE=BLOCK. It can be up to
4000 MiB.
}

Options specific to /vsiaz/ in "w" mode:
\itemize{
\item BLOB_TYPE=APPEND/BLOCK (GDAL >= 3.10) type of blob. Defaults to APPEND.
Append blocks are limited to 195 GiB (however if the file size is below
4 MiB, a block blob will be created in a single PUT operation).
}

See the GDAL documentation for \code{VSIFOpenEx2L()} for the most current set of
available options (\url{https://gdal.org/en/stable/api/cpl.html}).
}

\subsection{Read/write fields (per-object settings)}{

\code{$reportVSIFErrorAsEof}\cr
A logical value, \code{TRUE} (the default) to report a VSI error condition,
as indicated by \code{VSIFErrorL()} in GDAL >= 3.10, as \code{TRUE} in a call to the
\code{$eof()} method (see below). Since GDAL 3.10, some virtual file systems
that used to report errors through \code{VSIFEofL} now do so through \code{VSIFErrorL}.
Code testing \code{$eof()} to potentially end read loops should also test
for an error condition, which this setting enables by default.
Ignored if GDAL < 3.10.
}

\subsection{Methods}{

\code{$seek(offset, origin)}\cr
Seek to a requested \code{offset} in the file.
\code{offset} is given as a positive numeric scalar, optionally as
\code{bit64::integer64} type.
\code{origin} is given as a character string, one of \code{SEEK_SET}, \code{SEEK_CUR} or
\code{SEEK_END}. Package global constants are defined for convenience, so these
can be passed unquoted. Note that \code{offset} is an unsigned type, so \code{SEEK_CUR}
can only be used for positive seek. If negative seek is needed, use:

\if{html}{\out{<div class="sourceCode">}}\preformatted{vf$seek(vf$tell() + negative_offset, SEEK_SET)
}\if{html}{\out{</div>}}

Returns \code{0} on success or \code{-1} on failure.

\code{$tell()}\cr
Returns the current file read/write offset in bytes from the beginning of
the file. The return value is a numeric scalar carrying the \code{integer64}
class attribute.

\code{$rewind()}\cr
Rewind the file pointer to the beginning of the file. This is equivalent to
\code{vf$seek(0, SEEK_SET)}. No return value, called for that side effect.

\code{$read(nbytes)}\cr
Read \code{nbytes} bytes from the file at the current offset. Returns an \R \code{raw}
vector, or \code{NULL} if the operation fails.

\code{$write(object)}\cr
Write bytes to the file at the current offset. \code{object} is a \code{raw} vector.
Returns the number of bytes successfully written, as numeric scalar
carrying the \code{integer64} class attribute.
See also base \R \code{charToRaw()} / \code{rawToChar()}, convert to or from raw
vectors, and \code{readBin()} / \code{writeBin()} which read binary data from or write
binary data to a raw vector.

\code{$eof()}\cr
Test for end of file. Returns \code{TRUE} if an end-of-file condition occurred
during the previous read operation. The end-of-file flag is cleared by a
successful call to \code{$seek()}.

\code{$truncate(new_size)}\cr
Truncate/expand the file to the specified \code{new_size}, given as a positive
numeric scalar, optionally as \code{bit64::integer64} type.
Returns \code{0} on success.

\code{$flush()}\cr
Flush pending writes to disk. For files in write or update mode and on
file system types where it is applicable, all pending output on the file is
flushed to the physical disk.
On Windows regular files, this method does nothing, unless the
\code{VSI_FLUSH=YES} configuration option is set (and only when the file has not
been opened with the \code{WRITE_THROUGH} option).
Returns \code{0} on success or \code{-1} on error.

\code{$ingest(max_size)}\cr
Ingest a file into memory. Read the whole content of the file into a \code{raw}
vector.
\code{max_size} is the maximum size of file allowed, given as a numeric scalar,
optionally as \code{bit64::integer64} type. If no limit, set to a negative value.
Returns a \code{raw} vector, or \code{NULL} if the operation fails.

\code{$close()}\cr
Closes the file. The file should always be closed when I/O has been
completed. Returns \code{0} on success or \code{-1} on error.

\code{$open()}\cr
This method can be used to re-open the file after it has been closed, using
the same \code{filename}, and same \code{options} if any are set. The file will be
opened using \code{access} as currently set. The \code{$set_access()} method can
be called to change the requested access while the file is closed.
No return value. An error is raised if a file handle cannot be obtained.

\code{$get_filename()}\cr
Returns a character string containing the \code{filename} associated with this
\code{VSIFile} object (the \code{filename} originally used to create the object).

\code{$get_access()}\cr
Returns a character string containing the \code{access} as currently set on this
\code{VSIFile} object.

\code{$set_access(access)}\cr
Sets the requested read/write access on this \code{VSIFile} object, given as a
character string (i.e., \code{"r"}, \code{"r+"}, \code{"w"}, \code{"w+"}). The access can be
changed only while the \code{VSIFile} object is closed, and will apply when it is
re-opened with a call to \code{$open()}.
Returns \code{0} on success or \code{-1} on error.
}
}

\examples{
# The examples make use of the FARSITE LCP format specification at:
# https://gdal.org/en/stable/drivers/raster/lcp.html
# An LCP file is a raw format with a 7,316-byte header. The format
# specification gives byte offets and data types for fields in the header.

lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")

# identify a FARSITE v.4 LCP file
# function to check if the first three fields have valid data
# input is the first twelve raw bytes in the file
is_lcp <- function(bytes) {
  values <- readBin(bytes, "integer", n = 3)
  if ((values[1] == 20 || values[1] == 21) &&
      (values[2] == 20 || values[2] == 21) &&
      (values[3] >= -90 && values[3] <= 90)) {

    return(TRUE)
  } else {
    return(FALSE)
  }
}

vf <- new(VSIFile, lcp_file)
vf

vf$read(12) |> is_lcp()

vf$tell()

# read the whole file into memory
bytes <- vf$ingest(-1)
vf$close()

# write to a VSI in-memory file
mem_file <- "/vsimem/storml_copy.lcp"
vf <- new(VSIFile, mem_file, "w+")
vf$write(bytes)

vf$tell()
vf$rewind()
vf$tell()

vf$seek(0, SEEK_END)
(vf$tell() == vsi_stat(lcp_file, "size"))  # TRUE

vf$rewind()
vf$read(12) |> is_lcp()

# read/write an integer field
# write invalid data for the Latitude field and then set back
# save the original first
vf$seek(8, SEEK_SET)
lat_orig <- vf$read(4)
readBin(lat_orig, "integer")  # 46
# latitude -99 out of range
vf$seek(8, SEEK_SET)
writeBin(-99L, raw()) |> vf$write()
vf$rewind()
vf$read(12) |> is_lcp()  # FALSE
vf$seek(8, SEEK_SET)
vf$read(4) |> readBin("integer")  # -99
# set back to original
vf$seek(8, SEEK_SET)
vf$write(lat_orig)
vf$rewind()
vf$read(12) |> is_lcp()  # TRUE

# read a vector of doubles - xmax, xmin, ymax, ymin
# 327766.1, 323476.1, 5105082.0, 5101872.0
vf$seek(4172, SEEK_SET)
vf$read(32) |> readBin("double", n = 4)

# read a short int, the canopy cover units
vf$seek(4232, SEEK_SET)
vf$read(2) |> readBin("integer", size = 2)  # 1 = "percent"

# read the Description field
vf$seek(6804, SEEK_SET)
bytes <- vf$read(512)
rawToChar(bytes)

# edit the Description
desc <- paste(rawToChar(bytes),
              "Storm Lake AOI,",
              "Beaverhead-Deerlodge National Forest, Montana.")

vf$seek(6804, SEEK_SET)
charToRaw(desc) |> vf$write()
vf$close()

# verify the file as a raster dataset
ds <- new(GDALRaster, mem_file)
ds$info()

# retrieve Description from the metadata
# band = 0 for dataset-level metadata, domain = "" for default domain
ds$getMetadata(band = 0, domain = "")
ds$getMetadataItem(band = 0, mdi_name = "DESCRIPTION", domain = "")

ds$close()
\dontshow{vsi_unlink(mem_file)}
}
\seealso{
GDAL Virtual File Systems (compressed, network hosted, etc...):\cr
/vsimem, /vsizip, /vsitar, /vsicurl, ...\cr
\url{https://gdal.org/en/stable/user/virtual_file_systems.html}

\code{\link[=vsi_copy_file]{vsi_copy_file()}}, \code{\link[=vsi_read_dir]{vsi_read_dir()}}, \code{\link[=vsi_stat]{vsi_stat()}}, \code{\link[=vsi_unlink]{vsi_unlink()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dem_derivatives.R
\name{dem_derivatives}
\alias{dem_derivatives}
\alias{northness}
\alias{eastness}
\title{Convenience functions for simple DEM derivatives}
\usage{
northness(asp_deg)

eastness(asp_deg)
}
\arguments{
\item{asp_deg}{Numeric vector of aspect values in degrees (\code{0:360}).}
}
\value{
Numeric vector of transformed values.
}
\description{
Functions to calculate simple DEM derivatives, currently \code{northness()} and
\code{eastness()} for transforming aspect degrees into the range \code{-1:1}.
}
\details{
\code{northness()} is a cosine transform of aspect degrees, with any flat aspect
values (\code{-1} if present) set to \code{90} degrees (east) as a neutral value:

\if{html}{\out{<div class="sourceCode">}}\preformatted{northness <- cos(asp_deg * pi / 180)
}\if{html}{\out{</div>}}

\code{eastness()} is a sine transform of aspect degrees, with any flat aspect
values (\code{-1} if present) set to \code{0} degrees (north) as a neutral value:

\if{html}{\out{<div class="sourceCode">}}\preformatted{eastness <- sin(asp_deg * pi / 180)
}\if{html}{\out{</div>}}
}
\note{
No validation is done on the input values. The caller is responsible for
ensuring input has valid type and range.
}
\examples{
## plot northness from slope-masked aspect for the Storm Lake AOI
f_dem <- system.file("extdata/storml_elev.tif", package="gdalraster")

# slope degrees
f_slp <- basename(tempfile(pattern = "storml_slp", fileext = ".tif"))
f_slp <- file.path("/vsimem", f_slp)
dem_proc("slope", f_dem, f_slp)

# aspect
f_asp <- basename(tempfile(pattern = "storml_asp", fileext = ".tif"))
f_asp <- file.path("/vsimem", f_asp)
dem_proc("aspect", f_dem, f_asp)

# compute masked aspect as an in-memory raster
expr <- "ifelse(SLOPE >= 2, ASPECT, -9999)"
(ds_masked_asp <- calc(expr = expr,
                       rasterfiles = c(f_slp, f_asp),
                       var.names = c("SLOPE", "ASPECT"),
                       fmt = "MEM",
                       dtName = "Float64",
                       nodata_value = -9999,
                       setRasterNodataValue = TRUE,
                       return_obj = TRUE))

# diverging palette for northness
# adapted from "heatmap3" in ltc-color-palettes
# https://github.com/loukesio/ltc-color-palettes
pal <- c("#d7191c", "#fdae61", "#ffffbf", "#abd9e9")

plot_raster(ds_masked_asp, legend = TRUE, col_map_fn = pal,
            pixel_fn = northness, na_col = "#2c7bb6",
            main = "Storm Lake AOI northness")

# clean up
ds_masked_asp$close()
deleteDataset(f_slp)
deleteDataset(f_asp)

}
\seealso{
\code{\link[=calc]{calc()}}, \code{\link[=dem_proc]{dem_proc()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdalalg.R
\name{GDALAlg-class}
\alias{GDALAlg-class}
\alias{Rcpp_GDALAlg}
\alias{Rcpp_GDALAlg-class}
\alias{GDALAlg}
\title{Class encapsulating a GDAL CLI algorithm}
\arguments{
\item{cmd}{A character string or character vector containing the path to the
algorithm, e.g., \code{"raster reproject"} or \code{c("raster", "reproject")}.}

\item{args}{Either a character vector or a named list containing input
arguments of the algorithm (see section \verb{Algorithm Argument Syntax} below).}
}
\value{
An object of class \code{GDALAlg}, which contains a pointer to the
algorithm instance. Class methods are described in Details, along with a set
of writable fields for per-object settings.
}
\description{
\code{GDALAlg} provides bindings to \code{GDALAlgorithm} and related classes
that implement the \code{gdal} command line interface (CLI) in the GDAL
API. An object of class \code{GDALAlg} represents an instance of a CLI algorithm
with methods to obtain algorithm information and argument information, run
the algorithm, and access its output.

\strong{Requires GDAL >= 3.11.3}.

\strong{Experimental} (see the section \verb{Development Status} below)

\code{GDALAlg} is a C++ class exposed directly to \R (via \code{RCPP_EXPOSED_CLASS}).
Fields and methods of the class are accessed using the \code{$} operator.
Arguments to class constructors and class methods must be given in the order
documented (naming optional).
}
\section{Usage (see Details)}{


\if{html}{\out{<div class="sourceCode">}}\preformatted{## Constructors
alg <- new(GDALAlg, cmd)
# or, with arguments
alg <- new(GDALAlg, cmd, args)

## Read/write fields (per-object settings)
alg$setVectorArgsFromObject
alg$outputLayerNameForOpen
alg$quiet

## Methods
alg$info()
alg$argInfo(arg_name)
alg$usage()
alg$usageAsJSON()

alg$setArg(arg_name, arg_value)
alg$parseCommandLineArgs()
alg$getExplicitlySetArgs()
alg$run()
alg$output()
alg$outputs()

alg$close()
alg$release()
}\if{html}{\out{</div>}}
}

\section{Details}{

\subsection{Constructors}{

\code{new(GDALAlg, cmd)}\cr
Instantiate an algorithm without specifying input arguments.

\code{new(GDALAlg, cmd, args)}\cr
Instantiate an algorithm giving input arguments as a character vector or
named list. See the section \verb{Algorithm Argument Syntax} for details.
}

\subsection{Read/write fields (per-object settings)}{

\code{$setVectorArgsFromObject}\cr
A logical value, \code{TRUE} (the default) to set algorithm arguments
automatically when the \code{"input"} argument or the \code{"like"} argument is an
object of class \code{GDALVector}. Argument values specified explicitly will
override the automatic setting (as long as they result in a parsable set of
arguments). Automatically setting arguments from \code{GDALVector} input can
be disabled by setting this field to \code{FALSE}. In that case, only the vector
dataset would be passed to the algorithm, i.e., without automatically
passing any layer specifications.
When enabled and the \code{"input"} or \code{"like"} argument for an algorithm is
given as a \code{GDALVector} object, corresponding arguments will be set
automatically based on properties of the object (when the argument is
available to the algorithm):
\itemize{
\item \code{"input-format"}: set to the \code{GDALVector} object's driver short name
\item \code{"input-layer"}: set to the \code{GDALVector} layer name if it is not a SQL
layer
\item \code{"sql"}: set to the SQL statement if the \code{GDALVector} layer is defined by
one
\item \code{"dialect"}: set to the SQL dialect if one is specified for a SQL layer
\item \code{"like-layer"}: set to the \code{GDALVector} layer name if it is not a SQL
layer
\item \code{"like-sql"}: set to the SQL statement if the \code{GDALVector} layer is
defined by one
}

\code{$outputLayerNameForOpen}\cr
A character string specifying a layer name to open when obtaining algorithm
output as an object of class \code{GDALVector}. See method \code{$output()} below.
The default value is empty string (\code{""}) in which case the first layer by
index is opened. Ignored if output is not a vector dataset.

\code{$quiet}\cr
A logical value, \code{FALSE} by default. Set to \code{TRUE} to suppress progress
reporting along with various messages and warnings.
}

\subsection{Methods}{

\code{$info()}\cr
Returns a named list of algorithm properties with the following elements:
\itemize{
\item \code{name}: character string, the algorithm name
\item \code{full_path}: character string, the algorithm name as full path
\item \code{description}: character string, the algorithm (short) description
\item \code{long_description}: character string, the algorithm longer description
\item \code{URL}: character string, the algorithm help URL
\item \code{has_subalgorithms}: logical, \code{TRUE} if the algorithm has sub-algorithms
\item \code{subalgorithm_names}: character vector of sub-algorithm names (may be
empty)
\item \code{arg_names}: character vector of available argument names
}

\code{$argInfo(arg_name)}\cr
Returns a named list of properties for an algorithm argument given as a
character string, with the following elements:
\itemize{
\item \code{name}: character string, the name of the argument
\item \code{type}: character string, the argument type as one of \code{"BOOLEAN"},
\code{"STRING"}, \code{"INTEGER"}, \code{"REAL"}, \code{"DATASET"}, \code{"STRING_LIST"},
\code{"INTEGER_LIST"}, \code{"REAL_LIST"}, \code{"DATASET_LIST"}
\item \code{description}: character string, the argument description
\item \code{short_name}: character string, the short name or empty string if there
is none
\item \code{aliases}: character vector of aliases (empty if none)
\item \code{meta_var}: character string, the "meta-var" hint (by default, the
meta-var value is the long name of the argument in upper case)
\item \code{category}: character string, the argument category
\item \code{is_positional}: logical, \code{TRUE} if the argument is a positional one
\item \code{is_required}: logical, \code{TRUE} if the argument is required
\item \code{min_count}: integer, the minimum number of values for the argument (only
applies to list type of arguments)
\item \code{max_count}: integer, the maximum number of values for the argument (only
applies to list type of arguments)
\item \code{packed_values_allowed}: logical, \code{TRUE} if, for list type of arguments,
several comma-separated values may be specified (i.e., \code{"--foo=bar,baz"})
\item \code{repeated_arg_allowed}: logical, \code{TRUE} if, for list type of arguments,
the argument may be repeated (i.e., \code{c("--foo=bar", "--foo=baz")})
\item \code{choices}: character vector of allowed values for the argument (may be
empty and only applies for argument types \code{"STRING"} and \code{"STRING_LIST"})
\item \code{is_explicitly_set}: logical, \code{TRUE} if the argument value has been
explicitly set
\item \code{has_default_value}: logical, \code{TRUE} if the argument has a declared
default value
\item \code{default_value}: character or integer or numeric, the default value if the
argument has one, otherwise \code{NULL}
\item \code{is_hidden_for_api}: logical, \code{TRUE} if the argument is only for CLI usage
(e.g., "--help") (GDAL >= 3.12 only, see \code{is_only_for_cli})
\item \code{is_hidden_for_cli}: logical, \code{TRUE} if the argument must not be
mentioned in CLI usage (e.g., "output-value" for "gdal raster info", which
is only meant when the algorithm is used from a non-CLI context such as
programmatically from \R)
\item \code{is_only_for_cli}: logical, \code{TRUE} if the argument is only for CLI usage
(e.g., "--help") (deprecated at GDAL 3.12, see \code{is_hidden_for_api})
\item \code{is_input}: logical, \code{TRUE} if the value of the argument is read-only
during the execution of the algorithm
\item \code{is_output}: logical, \code{TRUE} if (at least part of) the value of the
argument is set during the execution of the algorithm
\item \code{dataset_type_flags}: character vector containing strings \code{"RASTER"},
\code{"VECTOR"}, \code{"MULTIDIM_RASTER"}, possibly with \code{"UPDATE"} (\code{NULL} if
the argument is not a dataset type)
\item \code{dataset_input_flags}: character vector indicating if a dataset argument
supports specifying only the dataset name (\code{"NAME"}), only the dataset
object (\code{"OBJECT"}), or both (\verb{"NAME", "OBJECT"}) when it is used as an
input (\code{NULL} if the argument is not a dataset type)
\item \code{dataset_output_flags}: character vector indicating if a dataset argument
supports specifying only the dataset name (\code{"NAME"}), only the dataset
object (\code{"OBJECT"}), or both (\verb{"NAME", "OBJECT"}) when it is used as an
output (\code{NULL} if the argument is not a dataset type)
\item \code{mutual_exclusion_group}: character string, the name of the mutual
exclusion group to which this argument belongs
}

\code{$usage()}\cr
Print a help message for the algorithm to the console. No return value.

\code{$usageAsJSON()}\cr
Returns the usage of the algorithm as a JSON-serialized string.

\code{$setArg(arg_name, arg_value)}\cr
Set the value of input algorithm argument \code{arg_name}, a character string
containing the argument's \dQuote{long} name or an alias.
The type of the \code{arg_value} parameter must be compatible with the algorithm
argument type. Objects of class \code{GDALRaster} or \code{GDALVector} may be passed
for algorithm arguments that accept dataset object input. A list of
\code{GDALRaster} or \code{GDALVector} objects may be given for algorithm arguments of
type \code{DATASET_LIST} that accept object input. Generally, an input dataset can
also be specified by name as a character string (DSN), or character vector of
DSNs for a \code{DATASET_LIST}. Returns a logical value, \code{TRUE} indicating success
or \code{FALSE} if an error occurs.

\code{$parseCommandLineArgs()}\cr
Sets the value of arguments previously specified in the class constructor,
and instantiates the actual algorithm that will be run (but without running
it). Returns a logical value, \code{TRUE} indicating success or \code{FALSE} if an
error occurs.

\code{$getExplicitlySetArgs()}\cr
Returns a named list of arguments that have been set explicitly along with
their values. For arguments with dataset object values, the value of the list
element is a string of the form \code{"<TYPE dataset object: DSN>"} where \code{TYPE}
is one of \code{"raster"}, \code{"vector"} or \code{"multidim raster"} and \code{DSN} is the
dataset name (filename, URL, etc.).

\code{$run()}\cr
Executes the algorithm, first parsing arguments if
\code{$parseCommandLineArgs()} has not already been called explicitly.
Returns a logical value, \code{TRUE} indicating success or \code{FALSE} if an error
occurs.

\code{$output()}\cr
Returns the single output value of the algorithm, after it has been run.
If there are multiple output values, this method will raise an error, and
the \code{$outputs()} (plural) method should be called instead. The type of
the return value corresponds to the type of the single output argument value
(see method \code{$argInfo()} above).
If the output argument has type \code{"DATASET"}, an object of class \code{GDALRaster}
will be returned if the dataset is raster, or an object of class
\code{GDALVector} if the dataset is vector. In the latter case, by default the
\code{GDALVector} object will be opened on the first layer by index, but a
specific layer name may be specified by setting the value of the field
\code{$outputLayerNameForOpen} before calling the \code{$output()} method
(see above).
Note that currently, if the output dataset is multidimensional raster, only
the dataset name will be returned as a character string.

\code{$outputs()}\cr
Returns the output value(s) of the algorithm as a named list, after it has
been run. Most algorithms only return a single output, in which case the
\code{$output()} method (singular) is preferable for easier use. The element
names in the returned list are the names of the arguments that have outputs
(with any dash characters replaced by underscore), and the values are the
argument values which may include \code{GDALRaster} or \code{GDALVector} objects.

\code{$close()}\cr
Completes any pending actions, and returns the final status as a logical
value (\code{TRUE} if no errors occur during the underlying call to
\code{GDALAlgorithmFinalize()}). This is typically useful for algorithms that
generate an output dataset. It closes datasets and gets back potential error
status resulting from that, e.g., if an error occurs during flushing to disk
of the output dataset after successful \code{$run()} execution.

\code{$release()}\cr
Release memory associated with the algorithm, potentially after attempting
to finalize. No return value, called for side-effects.
}
}

\section{Algorithm Argument Syntax}{

Arguments are given in \R as a character vector or named list, but
otherwise syntax basically matches the GDAL specification for arguments as
they are given on the command line. Those specifications are listed here
along with some amendments regarding the character vector and named list
formats. Programmatic usage also allows passing and receiving datasets as
objects (i.e., \code{GDALRaster} or \code{GDALVector}), in addition to dataset names
(e.g., filename, URL, database connection string).
\itemize{
\item Commands accept one or several positional arguments, typically for dataset
names (or in \R as \code{GDALRaster} or \code{GDALVector} datasets). The order is
input(s) first, output last. Positional arguments can also be specified as
named arguments, if preferred to avoid any ambiguity.
\item Named arguments have:
\itemize{
\item at least one "long" name, preceded by two dash characters
\item optionally, auxiliary long names (i.e., aliases),
\item and optionally a one-letter short name, preceded by a single dash
character, e.g., \code{-f, --of, --format, --output-format <OUTPUT-FORMAT>}
}
\item Boolean arguments are specified by just specifying the argument name in
character vector format. In \R \code{list} format, the named element must be
assigned a value of logical \code{TRUE}.
\item Arguments that require a value are specified like:
\itemize{
\item \code{-f VALUE} for one-letter short names
\item \code{--format VALUE} or \code{--format=VALUE} for long names
\item in a named list, this might look like: \code{args$format <- VALUE}
}
\item Some arguments can be multi-valued. Some of them require all values to be
packed together and separated with comma. This is, e.g., the case of:\cr
\code{--bbox <BBOX> Clipping bounding box as xmin,ymin,xmax,ymax} \cr
e.g., \code{--bbox=2.1,49.1,2.9,49.9}
\item Others accept each value to be preceded by a new mention of the argument
name, e.g., \code{c("--co", "COMPRESS=LZW", "--co", "TILED=YES")}. For that
one, if the value of the argument does not contain commas, the packed form
is also accepted: \code{--co COMPRESS=LZW,TILED=YES}. Note that repeated
mentions of an argument are possible in the character vector format for
argument input, whereas arguments given in named list format must use
argument long names as the list element names, and the packed format for the
values (which can be a character vector or numeric vector of values).
\item Named arguments can be placed before or after positional arguments.
}
}

\section{Development Status}{

The GDAL Command Line Interface Modernization was first introduced in the
\href{https://github.com/OSGeo/gdal/releases/tag/v3.11.0}{GDAL 3.11.0 release}
(2025-05-09). The GDAL project provides warning that the new CLI "is
provisionally provided as an alternative interface to GDAL and OGR command
line utilities. The project reserves the right to modify, rename,
reorganize, and change the behavior until it is officially frozen via PSC
vote in a future major GDAL release. The utility needs time to mature,
benefit from incremental feedback, and explore enhancements without carrying
the burden of full backward compatibility. Your usage of it should have no
expectation of compatibility until that time."
(\url{https://gdal.org/en/latest/programs/#gdal-application})

Initial bindings to enable programmatic use of the CLI algorithms from \R
were added in \pkg{gdalraster} 2.2.0, and will evolve over future releases.
\emph{The bindings are considered experimental until the upstream API is declared
stable}. Breaking changes in minor version releases are possible until then.
Please use with those cautions in mind. Bug reports may be filed at:
\url{https://github.com/firelab/gdalraster/issues}.
}

\examples{
\dontshow{if (length(gdal_global_reg_names()) > 0) withAutoprint(\{ # examplesIf}
f <- system.file("extdata/storml_elev.tif", package="gdalraster")

## raster info
gdal_usage("raster info")

# arguments given as character vector
args <- c("--format=text", "--no-md", f)
(alg <- new(GDALAlg, "raster info", args))

alg$run()

alg$output() |> writeLines()

alg$release()

## raster clip
gdal_usage("raster clip")

# arguments in list format
args <- list()
args$input <- f
f_clip <- file.path(tempdir(), "elev_clip.tif")
args$output <- f_clip
args$overwrite <- TRUE
args$bbox <- c(323776.1, 5102172.0,  327466.1, 5104782.0)

(alg <- new(GDALAlg, "raster clip", args))

alg$run()

# get output as a GDALRaster object
(ds_clip <- alg$output())

alg$release()

ds_clip$dim()
ds_clip$bbox()

## raster hillshade
gdal_usage("raster hillshade")

# input as a GDALRaster object and output to an in-memory raster
args <- list(input = ds_clip,
             output_format = "MEM",
             output = "")

(alg <- new(GDALAlg, "raster hillshade", args))

alg$run()

(ds_hillshade <- alg$output())

alg$release()

plot_raster(ds_hillshade)

ds_clip$close()
ds_hillshade$close()
deleteDataset(f_clip)

## vector convert shapefile to GeoPackage
gdal_usage("vector convert")

f_shp <- system.file("extdata/poly_multipoly.shp", package="gdalraster")
f_gpkg <- file.path(tempdir(), "polygons_test.gpkg")
args <- c("--input", f_shp, "--output", f_gpkg, "--overwrite")

(alg <- new(GDALAlg, "vector convert", args))

alg$run()

# output as a GDALVector object
(lyr <- alg$output())

alg$release()

lyr$info()

lyr$close()
deleteDataset(f_gpkg)

## raster reproject (usage and info)
# no arguments given, only for retrieving usage and properties via API
# cf. gdal_usage("raster reproject")

(alg <- new(GDALAlg, "raster reproject"))

# print usage to the console, no return value
alg$usage()

# or, get usage as a JSON string
# json <- alg$usageAsJSON()
# writeLines(json)

# list of algorithm properties
alg$info()

# list of properties for an algorithm argument
alg$argInfo("resampling")

alg$release()
\dontshow{\}) # examplesIf}
}
\seealso{
\code{\link[=gdal_alg]{gdal_alg()}}, \code{\link[=gdal_commands]{gdal_commands()}}, \code{\link[=gdal_run]{gdal_run()}}, \code{\link[=gdal_usage]{gdal_usage()}}

Using \code{gdal} CLI algorithms from R\cr
\url{https://firelab.github.io/gdalraster/articles/use-gdal-cli-from-r.html}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_supports_rnd_write}
\alias{vsi_supports_rnd_write}
\title{Return whether the filesystem supports random write}
\usage{
vsi_supports_rnd_write(filename, allow_local_tmpfile)
}
\arguments{
\item{filename}{Character string. The path of the filesystem object to be
tested.}

\item{allow_local_tmpfile}{Logical scalar. \code{TRUE} if the filesystem is
allowed to use a local temporary file before uploading to the target
location.}
}
\value{
Logical scalar. \code{TRUE} if random write is supported.
}
\description{
\code{vsi_supports_rnd_write()} returns whether the filesystem supports
random write.
Wrapper for \code{VSISupportsRandomWrite()} in the GDAL API.
}
\note{
The location GDAL uses for temporary files can be forced via the
\code{CPL_TMPDIR} configuration option.
}
\examples{
# Requires GDAL >= 3.6
if (gdal_version_num() >= gdal_compute_version(3, 6, 0))
  vsi_supports_rnd_write("/vsimem/test-mem-file.gpkg", TRUE)
}
\seealso{
\code{\link[=vsi_supports_seq_write]{vsi_supports_seq_write()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom.R
\name{g_query}
\alias{g_query}
\alias{g_is_empty}
\alias{g_is_valid}
\alias{g_invalid_reason}
\alias{g_is_3D}
\alias{g_is_measured}
\alias{g_is_ring}
\alias{g_name}
\alias{g_summary}
\alias{g_geom_count}
\title{Obtain information about WKB/WKT geometries}
\usage{
g_is_empty(geom, quiet = FALSE)

g_is_valid(geom, quiet = FALSE)

g_invalid_reason(geom, quiet = FALSE)

g_is_3D(geom, quiet = FALSE)

g_is_measured(geom, quiet = FALSE)

g_is_ring(geom, quiet = FALSE)

g_name(geom, quiet = FALSE)

g_summary(geom, quiet = FALSE)

g_geom_count(geom, quiet = FALSE)
}
\arguments{
\item{geom}{Either a raw vector of WKB or list of raw vectors, or a
character vector containing one or more WKT strings.}

\item{quiet}{Logical value, \code{TRUE} to suppress warnings. Defaults to \code{FALSE}.}
}
\description{
These functions return information about WKB/WKT geometries. The input
geometries may be given as a single raw vector of WKB, a list of WKB raw
vectors, or a character vector containing one or more WKT strings.
}
\details{
\code{g_is_empty()} tests whether a geometry has no points. Returns a logical
vector of the same length as the number of input geometries containing
\code{TRUE} for the corresponding geometries that are empty or \code{FALSE} for
non-empty geometries.

\code{g_is_valid()} tests whether a geometry is valid. Returns a logical vector
analogous to the above for \code{g_is_empty()}.

\code{g_invalid_reason()} tests if a geometry is valid and, if not, returns the
invalidity reason as a character string. \code{NA} is returned for valid
geometries. Requires GDAL >= 3.13.

\code{g_is_3D()} checks whether a geometry has Z coordinates. Returns a logical
vector analogous to the above for \code{g_is_empty()}.

\code{g_is_measured()} checks whether a geometry is measured (has M values).
Returns a logical vector analogous to the above for \code{g_is_empty()}.

\code{g_is_ring()} tests whether a geometry is a ring, \code{TRUE} if the
coordinates of the geometry form a ring by checking length and closure
(self-intersection is not checked), otherwise \code{FALSE}.
Returns a logical vector analogous to the above for \code{g_is_empty()}.

\code{g_name()} returns the WKT type names of the input geometries in a character
vector of the same length as the number of input geometries.

\code{g_summary()} returns text summaries of WKB/WKT geometries in a
character vector of the same length as the number of input
geometries. Requires GDAL >= 3.7.

\code{g_geom_count()} returns the number of elements in a geometry or number of
geometries in container. Only geometries of type \verb{Polygon[25D]},
\verb{MultiPoint[25D]}, \verb{MultiLineString[25D]}, \verb{MultiPolygon[25D]} or
\verb{GeometryCollection[25D]} may return a valid value. Other geometry types will
silently return \code{0}.
}
\examples{
g1 <- "POLYGON ((0 0, 10 10, 10 0, 0 0))"
g2 <- "POLYGON ((5 1, 9 5, 9 1, 5 1))"
g_difference(g2, g1) |> g_is_empty()

g1 <- "POLYGON ((0 0, 10 10, 10 0, 0 0))"
g2 <- "POLYGON ((0 0, 10 10, 10 0))"
g3 <- "POLYGON ((0 0, 10 10, 10 0, 0 1))"
g_is_valid(c(g1, g2, g3))

# g_invalid_reason() requires GDAL >= 3.13
if (gdal_version_num() >= gdal_compute_version(3, 13, 0)) {
  g_invalid_reason("LINESTRING(0 0)") |> print()

  g_invalid_reason("LINESTRING(0 0, 1 1)") |> print()
}

g_is_3D(g1)
g_is_measured(g1)

pt_xyz <- g_create("POINT", c(1, 9, 100))
g_is_3D(pt_xyz)
g_is_measured(pt_xyz)

pt_xyzm <- g_create("POINT", c(1, 9, 100, 2000))
g_is_3D(pt_xyzm)
g_is_measured(pt_xyzm)

f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
lyr <- new(GDALVector, f, "mtbs_perims")

feat <- lyr$getNextFeature()
g_name(feat$geom)

# g_summary() requires GDAL >= 3.7
if (gdal_version_num() >= gdal_compute_version(3, 7, 0)) {
  feat <- lyr$getNextFeature()
  g_summary(feat$geom) |> print()

  feat_set <- lyr$fetch(5)
  g_summary(feat_set$geom) |> print()
}

g_geom_count(feat$geom)

lyr$close()
}
\seealso{
\code{\link[=g_make_valid]{g_make_valid()}}, \code{\link[=g_set_3D]{g_set_3D()}}, \code{\link[=g_set_measured]{g_set_measured()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_get_disk_free_space}
\alias{vsi_get_disk_free_space}
\title{Return free disk space available on the filesystem}
\usage{
vsi_get_disk_free_space(path)
}
\arguments{
\item{path}{Character string. A directory of the filesystem to query.}
}
\value{
Numeric scalar. The free space in bytes (as \code{bit64::integer64}
type), or \code{-1} in case of error.
}
\description{
\code{vsi_get_disk_free_space()} returns the free disk space available on the
filesystem. Wrapper for \code{VSIGetDiskFreeSpace()} in the GDAL Common
Portability Library.
}
\examples{
tmp_dir <- file.path("/vsimem", "tmpdir")
vsi_mkdir(tmp_dir)
vsi_get_disk_free_space(tmp_dir)
vsi_rmdir(tmp_dir)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{bbox_to_wkt}
\alias{bbox_to_wkt}
\title{Convert a bounding box to POLYGON in OGC WKT format}
\usage{
bbox_to_wkt(bbox, extend_x = 0, extend_y = 0)
}
\arguments{
\item{bbox}{Numeric vector of length four containing xmin, ymin,
xmax, ymax.}

\item{extend_x}{Numeric scalar. Distance in units of \code{bbox} to extend the
rectangle in both directions along the x-axis
(results in \code{xmin = bbox[1] - extend_x}, \code{xmax = bbox[3] + extend_x}).}

\item{extend_y}{Numeric scalar. Distance in units of \code{bbox} to extend the
rectangle in both directions along the y-axis
(results in \code{ymin = bbox[2] - extend_y}, \code{ymax = bbox[4] + extend_y}).}
}
\value{
Character string for an OGC WKT polygon.
}
\description{
\code{bbox_to_wkt()} returns a WKT POLYGON string for the given bounding box.
}
\examples{
elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
ds <- new(GDALRaster, elev_file, read_only=TRUE)
bbox_to_wkt(ds$bbox())
ds$close()
}
\seealso{
\code{\link[=bbox_from_wkt]{bbox_from_wkt()}}, \code{\link[=g_buffer]{g_buffer()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_util.R
\name{warp}
\alias{warp}
\title{Raster reprojection and mosaicing}
\usage{
warp(src_files, dst_filename, t_srs, cl_arg = NULL, quiet = FALSE)
}
\arguments{
\item{src_files}{Either a character vector of source filenames(s) to be
reprojected, or a \code{GDALRaster} object or list of \code{GDALRaster} objects for
the source data.}

\item{dst_filename}{Either a character string giving the filename of the
output dataset, or an object of class \code{GDALRaster} for the output.}

\item{t_srs}{Character string. Target spatial reference system. Usually an
EPSG code ("EPSG:#####") or a well known text (WKT) SRS definition.
Can be set to empty string \code{""} and the spatial reference of \code{src_files[1]}
will be used unless the destination raster already exists (see Note).}

\item{cl_arg}{Optional character vector of command-line arguments to
\code{gdalwarp} in addition to \code{-t_srs} (see Details).}

\item{quiet}{Logical scalar. If \code{TRUE}, a progress bar will not be
displayed. Defaults to \code{FALSE}.}
}
\value{
Logical indicating success (invisible \code{TRUE}).
An error is raised if the operation fails.
}
\description{
\code{warp()} is a wrapper of the \command{gdalwarp} command-line utility for
raster reprojection and warping
(see \url{https://gdal.org/en/stable/programs/gdalwarp.html}).
The function can reproject to any supported spatial reference system (SRS).
It can also be used to crop, mosaic, resample, and optionally write output
to a different raster format. See Details for a list of commonly used
processing options that can be passed as arguments to \code{warp()}.
}
\details{
Several processing options can be performed in one call to \code{warp()} by
passing the necessary command-line arguments. The following list describes
several commonly used arguments. Note that \code{gdalwarp} supports a large
number of arguments that enable a variety of different processing options.
Users are encouraged to review the original source documentation provided
by the GDAL project at the URL above for the full list.
\itemize{
\item \verb{-te <xmin> <ymin> <xmax> <ymax>}\cr
Georeferenced extents of output file to be created (in target SRS by
default).
\item \verb{-te_srs <srs_def>}\cr
SRS in which to interpret the coordinates given with \code{-te}
(if different than \code{t_srs}).
\item \verb{-tr <xres> <yres>}\cr
Output pixel resolution (in target georeferenced units).
\item \code{-tap}\cr
(target aligned pixels) align the coordinates of the extent of the output
file to the values of the \code{-tr}, such that the aligned extent includes
the minimum extent. Alignment means that xmin / resx, ymin / resy,
xmax / resx and ymax / resy are integer values.
\item \verb{-ovr <level>|AUTO|AUTO-<n>|NONE}\cr
Specify which overview level of source files must be used. The default
choice, \code{AUTO}, will select the overview level whose resolution is the
closest to the target resolution. Specify an integer value (0-based,
i.e., 0=1st overview level) to select a particular level. Specify
\code{AUTO-n} where \code{n} is an integer greater or equal to \code{1}, to select an
overview level below the \code{AUTO} one. Or specify \code{NONE} to force the base
resolution to be used (can be useful if overviews have been generated
with a low quality resampling method, and the warping is done using a
higher quality resampling method).
\item \verb{-wo <NAME>=<VALUE>}\cr
Set a warp option as described in the GDAL documentation for
\href{https://gdal.org/en/stable/api/gdalwarp_cpp.html#_CPPv415GDALWarpOptions}{\code{GDALWarpOptions}}
Multiple \code{-wo} may be given. See also \code{-multi} below.
\item \verb{-ot <type>}\cr
Force the output raster bands to have a specific data type supported by
the format, which may be one of the following: \code{Byte}, \code{UInt8}
(GDAL >= 3.13), \code{Int8}, \code{UInt16}, \code{Int16}, \code{UInt32}, \code{Int32}, \code{UInt64},
\code{Int64}, \code{Float32}, \code{Float64}, \code{CInt16}, \code{CInt32}, \code{CFloat32} or
\code{CFloat64}.
\item \verb{-r <resampling_method>}\cr
Resampling method to use. Available methods are: \code{near} (nearest
neighbour, the default), \code{bilinear}, \code{cubic}, \code{cubicspline}, \code{lanczos},
\code{average}, \code{rms} (root mean square, GDAL >= 3.3), \code{mode}, \code{max}, \code{min},
\code{med}, \code{q1} (first quartile), \code{q3} (third quartile), \code{sum} (GDAL >= 3.1).
\item \verb{-srcnodata "<value>[ <value>]..."}\cr
Set nodata masking values for input bands (different values can be
supplied for each band). If more than one value is supplied all values
should be quoted to keep them together as a single operating system
argument. Masked values will not be used in interpolation. Use a value of
\code{None} to ignore intrinsic nodata settings on the source dataset.
If \code{-srcnodata} is not explicitly set, but the source dataset has nodata
values, they will be taken into account by default.
\item \verb{-dstnodata "<value>[ <value>]..."}\cr
Set nodata values for output bands (different values can be supplied for
each band). If more than one value is supplied all values should be
quoted to keep them together as a single operating system argument. New
files will be initialized to this value and if possible the nodata value
will be recorded in the output file. Use a value of \code{"None"} to ensure
that nodata is not defined. If this argument is not used then nodata
values will be copied from the source dataset.
\item \verb{-srcband <n>}\cr
(GDAL >= 3.7) Specify an input band number to warp (between 1 and the
number of bands of the source dataset). This option is used to warp a
subset of the input bands. All input bands are used when it is not
specified. This option may be repeated multiple times to select several
input bands. The order in which bands are specified will be the order in
which they appear in the output dataset (unless \code{-dstband} is specified).
The alpha band should not be specified in the list, as it will be
automatically retrieved (unless \code{-nosrcalpha} is specified).
\item \verb{-dstband <n>}\cr
(GDAL >= 3.7) Specify the output band number in which to warp. In
practice, this option is only useful when updating an existing dataset,
e.g to warp one band at at time. If \code{-srcband} is specified, there must be
as many occurrences of \code{-dstband} as there are of \code{-srcband}.\cr
If \code{-dstband} is not specified, then:\cr
\verb{c("-dstband", "1", "-dstband", "2", ... "-dstband", "N")}\cr
is assumed where N is the number of input bands (implicitly, or specified
explicitly with \code{-srcband}). The alpha band should not be specified in the
list, as it will be automatically retrieved (unless \code{-nosrcalpha} is
specified).
\item \verb{-wm <memory_in_mb>}\cr
Set the amount of memory that the warp API is allowed to use for caching.
The value is interpreted as being in megabytes if the value is <10000.
For values >=10000, this is interpreted as bytes. The warper will
total up the memory required to hold the input and output image arrays
and any auxiliary masking arrays and if they are larger than the
"warp memory" allowed it will subdivide the chunk into smaller chunks and
try again. If the \code{-wm} value is very small there is some extra overhead
in doing many small chunks so setting it larger is better but it is a
matter of diminishing returns.
\item \code{-multi}\cr
Use multithreaded warping implementation. Two threads will be used to
process chunks of image and perform input/output operation
simultaneously. Note that computation is not multithreaded itself. To do
that, you can use the \verb{-wo NUM_THREADS=val/ALL_CPUS} option, which can be
combined with \code{-multi}.
\item \verb{-of <format>}
Set the output raster format. Will be guessed from the extension if not
specified. Use the short format name (e.g., \code{"GTiff"}).
\item \verb{-co <NAME>=<VALUE>}\cr
Set one or more format specific creation options for the output dataset.
For example, the GeoTIFF driver supports creation options to control
compression, and whether the file should be tiled.
\code{\link[=getCreationOptions]{getCreationOptions()}} can be used to look up available creation options,
but the GDAL \href{https://gdal.org/en/stable/drivers/raster/index.html}{Raster drivers}
documentation is the definitive reference for format specific options.
Multiple \code{-co} may be given, e.g.,
\preformatted{ c("-co", "COMPRESS=LZW", "-co", "BIGTIFF=YES") }
\item \code{-overwrite}\cr
Overwrite the target dataset if it already exists. Overwriting means
deleting and recreating the file from scratch. Note that if this option
is not specified and the output file already exists, it will be updated
in place.
}

The documentation for \href{https://gdal.org/en/stable/programs/gdalwarp.html}{\code{gdalwarp}}
describes additional command-line options related to spatial reference
systems, alpha bands, masking with polygon cutlines including blending,
and more.

Mosaicing into an existing output file is supported if the output file
already exists. The spatial extent of the existing file will not be
modified to accommodate new data, so you may have to remove it in that
case, or use the \code{-overwrite} option.

Command-line options are passed to \code{warp()} as a character vector. The
elements of the vector are the individual options followed by their
individual values, e.g.,
\preformatted{
cl_arg = c("-tr", "30", "30", "-r", "bilinear"))
}
to set the target pixel resolution to 30 x 30 in target georeferenced
units and use bilinear resampling.
}
\note{
\code{warp()} can be used to reproject and also perform other processing such
as crop, resample, and mosaic.
This processing is generally done with a single function call by passing
arguments for the output ("target") pixel resolution, extent, resampling
method, nodata value, format, and so forth.

If \code{warp()} is called with \code{t_srs = ""} and the output raster does not
already exist, the target spatial reference will be set to that of
\code{src_files[1]}. In that case, the processing options given in \code{cl_arg} will
be performed without reprojecting (if there is one source raster or multiple
sources that all use the same spatial reference system, otherwise would
reproject inputs to the SRS of \code{src_files[1]} where they are different).
If \code{t_srs = ""} and the destination raster already exists, the output SRS
will be the projection of the destination dataset.
}
\examples{
# reproject the elevation raster to NAD83 / CONUS Albers (EPSG:5070)
elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")

# command-line arguments for gdalwarp
# resample to 90-m resolution and keep pixels aligned:
args <- c("-tr", "90", "90", "-r", "cubic", "-tap")
# write to Erdas Imagine format (HFA) with compression:
args <- c(args, "-of", "HFA", "-co", "COMPRESSED=YES")

alb83_file <- file.path(tempdir(), "storml_elev_alb83.img")
warp(elev_file, alb83_file, t_srs = "EPSG:5070", cl_arg = args)

ds <- new(GDALRaster, alb83_file)
ds$getDriverLongName()
ds$getProjectionRef()
ds$res()
ds$getStatistics(band=1, approx_ok=FALSE, force=TRUE)
ds$close()
\dontshow{deleteDataset(alb83_file)}
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster-class}}, \code{\link[=srs_to_wkt]{srs_to_wkt()}}, \code{\link[=translate]{translate()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdalraster_proc.R
\name{DEFAULT_NODATA}
\alias{DEFAULT_NODATA}
\title{List of default nodata values by raster data type}
\usage{
DEFAULT_NODATA
}
\description{
These values are currently used in \code{gdalraster} when a nodata value is
needed but has not been specified:
\preformatted{
    list("Byte" = 255, "UInt8" = 255, "Int8" = -128,
         "UInt16" = 65535, "Int16" = -32767,
         "UInt32" = 4294967293, "Int32" = -2147483647,
         "Float32" = -99999.0, "Float64" = NaN)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{get_usable_physical_ram}
\alias{get_usable_physical_ram}
\title{Get usable physical RAM reported by GDAL}
\usage{
get_usable_physical_ram()
}
\value{
Numeric scalar, number of bytes as \code{bit64::integer64} type (or 0 in
case of failure).
}
\description{
\code{get_usable_physical_ram()} returns the total physical RAM, usable by a
process, in bytes. It will limit to 2 GB for 32 bit processes. Starting
with GDAL 2.4.0, it will also take into account resource limits (virtual
memory) on Posix systems. Starting with GDAL 3.6.1, it will also take into
account RLIMIT_RSS on Linux. Wrapper of \code{CPLGetUsablePhysicalRAM()} in the
GDAL Common Portability Library.
}
\note{
This memory may already be partly used by other processes.
}
\examples{
get_usable_physical_ram()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_rat.R
\name{displayRAT}
\alias{displayRAT}
\title{Display a GDAL Raster Attribute Table}
\usage{
displayRAT(tbl, title = "Raster Attribute Table")
}
\arguments{
\item{tbl}{A data frame formatted as a GDAL RAT (e.g., as returned by
\code{buildRAT()} or \code{GDALRaster$getDefaultRAT()}).}

\item{title}{Character string to be used in the table title.}
}
\value{
An object of class \code{"gt_tbl"} (i.e., a table created with
\code{gt::gt()}).
}
\description{
\code{displayRAT()} generates a presentation table. Colors are shown if the
Raster Attribute Table contains RGB columns.
This function requires package \code{gt}.
}
\examples{
# see examples for `buildRAT()`
}
\seealso{
\code{\link[=buildRAT]{buildRAT()}}, \code{\link[=GDALRaster]{GDALRaster$getDefaultRAT()}}

\code{vignette("raster-attribute-tables")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdalvector.R
\name{GDALVector-class}
\alias{GDALVector-class}
\alias{Rcpp_GDALVector}
\alias{Rcpp_GDALVector-class}
\alias{GDALVector}
\title{Class encapsulating a vector layer in a GDAL dataset}
\arguments{
\item{dsn}{Character string containing the data source name (DSN), usually a
filename or database connection string.}

\item{layer}{Character string containing the name of a layer within the
data source. May also be given as an SQL SELECT statement to be executed
against the data source, defining a layer as the result set.}

\item{read_only}{Logical scalar. \code{TRUE} to open the layer read-only (the
default), or \code{FALSE} to open with write access.}

\item{open_options}{Optional character vector of \code{NAME=VALUE} pairs
specifying dataset open options.}

\item{spatial_filter}{Optional character string containing a geometry in
Well Known Text (WKT) format which represents a spatial filter.}

\item{dialect}{Optional character string to control the statement dialect
when SQL is used to define the layer. By default, the OGR SQL engine will
be used, except for RDBMS drivers that will use their dedicated SQL engine,
unless \code{"OGRSQL"} is explicitly passed as the dialect. The \code{"SQLITE"}
dialect can also be used.}
}
\value{
An object of class \code{GDALVector}, which contains pointers to the
opened layer and the GDAL dataset that owns it. Class methods that operate
on the layer are described in Details, along with a set of writable fields
for per-object settings. Values may be assigned to the class fields as
needed during the lifetime of the object (i.e., by regular \code{<-} or
\code{=} assignment).
}
\description{
\code{GDALVector} provides an interface for accessing a vector layer in a GDAL
dataset and calling methods on the underlying \code{OGRLayer} object.
An object of class \code{GDALVector} persists an open connection to the dataset,
and exposes methods to:
\itemize{
\item retrieve layer information
\item set attribute and spatial filters
\item set a list of ignored or selected columns
\item traverse and read feature data by traditional row-based cursor, including
an analog of \code{DBI::dbFetch()}
\item read via column-oriented Arrow Array stream
\item write new features in a layer
\item edit/overwrite existing features
\item upsert
\item delete features
\item perform data manipulation within transactions.
}

\code{GDALVector} is a C++ class exposed directly to \R (via \code{RCPP_EXPOSED_CLASS}).
Fields and methods of the class are accessed using the \code{$} operator. \strong{Note
that all arguments to class methods are required and must be given in the
order documented.} Most \code{GDALVector} methods take zero or one argument, so
this is usually not an issue. Class constructors are the main exception.
Naming the arguments is optional but may be preferred for readability.
}
\section{Usage (see Details)}{


\if{html}{\out{<div class="sourceCode">}}\preformatted{## Constructors
# for single-layer file formats such as shapefile
lyr <- new(GDALVector, dsn)
# specifying the layer name, or SQL statement defining the layer
lyr <- new(GDALVector, dsn, layer)
# for update access
lyr <- new(GDALVector, dsn, layer, read_only = FALSE)
# using dataset open options
lyr <- new(GDALVector, dsn, layer, read_only, open_options)
# setting a spatial filter and/or specifying the SQL dialect
lyr <- new(GDALVector, dsn, layer, read_only, open_options, spatial_filter, dialect)

## Read/write fields (per-object settings)
lyr$defaultGeomColName
lyr$returnGeomAs
lyr$promoteToMulti
lyr$convertToLinear
lyr$wkbByteOrder
lyr$arrowStreamOptions
lyr$quiet
lyr$transactionsForce

## Methods
lyr$open(read_only)
lyr$isOpen()
lyr$isReadOnly()
lyr$getDsn()
lyr$getFileList()
lyr$info()
lyr$getDriverShortName()
lyr$getDriverLongName()

lyr$getName()
lyr$getFieldNames()
lyr$testCapability()
lyr$getFIDColumn()
lyr$getGeomType()
lyr$getGeometryColumn()
lyr$getSpatialRef()
lyr$bbox()
lyr$getLayerDefn()
lyr$getFieldDomain(domain_name)

lyr$setAttributeFilter(query)
lyr$getAttributeFilter()
lyr$setIgnoredFields(fields)
lyr$setSelectedFields(fields)
lyr$getIgnoredFields()

lyr$setSpatialFilter(wkt)
lyr$setSpatialFilterRect(bbox)
lyr$getSpatialFilter()
lyr$clearSpatialFilter()

lyr$getFeatureCount()
lyr$getNextFeature()
lyr$setNextByIndex(i)
lyr$getFeature(fid)
lyr$resetReading()
lyr$fetch(n)

lyr$getArrowStream()
lyr$releaseArrowStream()

lyr$setFeature(feature)
lyr$createFeature(feature)
lyr$batchCreateFeature(feature_set)
lyr$upsertFeature(feature)
lyr$getLastWriteFID()
lyr$deleteFeature(fid)
lyr$syncToDisk()

lyr$startTransaction()
lyr$commitTransaction()
lyr$rollbackTransaction()

lyr$getMetadata()
lyr$setMetadata(metadata)
lyr$getMetadataItem(mdi_name)

lyr$close()
}\if{html}{\out{</div>}}
}

\section{Details}{

\subsection{Constructors}{

\code{new(GDALVector, dsn)}\cr
The first layer by index is assumed if the \code{layer} argument is omitted, so
this form of the constructor might be used for single-layer formats like
shapefile.

\code{new(GDALVector, dsn, layer)}\cr
Constructor specifying the name of a layer to open. The \code{layer} argument
may also be given as an SQL SELECT statement to define a layer as the result
set.

\code{new(GDALVector, dsn, layer, read_only)}\cr
Constructor specifying read/write access (\code{read_only = TRUE|FALSE}).
The \code{layer} argument is required in this form of the constructor, but may be
given as empty string (\code{""}), in which case the first layer by index will be
assumed.

\code{new(GDALVector, dsn, layer, read_only, open_options)}\cr
Constructor specifying dataset open options as a character vector of
\code{NAME=VALUE} pairs.

\code{new(GDALVector, dsn, layer, read_only, open_options, spatial_filter, dialect))}\cr
Constructor to specify a spatial filter and/or SQL dialect. All arguments
are required in this form of the constructor, but \code{open_options} may be
\code{NULL}, and \code{spatial_filter} or \code{dialect} may be an empty string (\code{""}).
}

\subsection{Read/write fields}{

\code{$defaultGeomColName}\cr
Character string specifying a name to use for returned columns when the
geometry column name in the source layer is empty, like with shapefiles etc.
Defaults to \code{"geom"}.

\code{$returnGeomAs}\cr
Character string specifying the return format of feature geometries.
Must be one of \code{WKB} (the default), \code{WKB_ISO}, \code{WKT}, \code{WKT_ISO}, \code{BBOX}, or
\code{NONE}.
Using \code{WKB}/\code{WKT} exports as 99-402 extended dimension (Z) types for Point,
LineString, Polygon, MultiPoint, MultiLineString, MultiPolygon and
GeometryCollection. For other geometry types, it is equivalent to using
\code{WKB_ISO}/\code{WKT_ISO} (see \url{https://libgeos.org/specifications/wkb/}).
Using \code{BBOX} exports as a list of numeric vectors, each of length 4 with
values \verb{xmin, ymin, xmax, ymax}. If an empty geometry is encountered these
values will be \code{NA_real_} in the corresponding location.
Using \code{NONE} will result in no geometry value being present in the feature
returned.

\code{$promoteToMulti}\cr
A logical value specifying whether to automatically promote geometries from
Polygon to MultiPolygon, Point to MultiPoint, or LineString to
MultiLineString during read operations (i.e., with methods
\code{$getFeature()}, \code{$getNextFeature()}, \code{$fetch()}).
Defaults to \code{FALSE}. Setting to \code{TRUE} may be useful when reading from
layers such as shapefiles that mix Polygons and MultiPolygons.

\code{$convertToLinear}\cr
A logical value specifying whether to convert non-linear geometry types into
linear geometry types by approximating them (i.e., during read operations
with methods \code{$getFeature()}, \code{$getNextFeature()},
\code{$fetch()}). Defaults to \code{FALSE}. If set to \code{TRUE}, handled conversions
are:
\itemize{
\item wkbCurvePolygon -> wkbPolygon
\item wkbCircularString -> wkbLineString
\item wkbCompoundCurve -> wkbLineString
\item wkbMultiSurface -> wkbMultiPolygon
\item wkbMultiCurve -> wkbMultiLineString
}

\code{$wkbByteOrder}\cr
Character string specifying the byte order for WKB geometries.
Must be either \code{LSB} (Least Significant Byte first, the default) or
\code{MSB} (Most Significant Byte first).

\code{$arrowStreamOptions}\cr
Character vector of \code{"NAME=VALUE"} pairs giving options used by the
\code{$getArrowStream()} method (see below). The available options may be
driver and GDAL version specific. Options available as of GDAL 3.8 are
listed below. For more information about options for Arrow stream, see
the GDAL API documentation for
\href{https://gdal.org/en/stable/api/vector_c_api.html#_CPPv420OGR_L_GetArrowStream9OGRLayerHP16ArrowArrayStreamPPc}{OGR_L_GetArrowStream()}.
\itemize{
\item INCLUDE_FID=YES/NO. Defaults to YES.
\item MAX_FEATURES_IN_BATCH=integer. Maximum number of features to retrieve in
an ArrowArray batch. Defaults to 65536.
\item TIMEZONE=unknown/UTC/(+|:)HH:MM or any other value supported by
Arrow (GDAL >= 3.8).
\item GEOMETRY_METADATA_ENCODING=OGC/GEOARROW (GDAL >= 3.8). The GDAL default is
OGC if not specified.
\item GEOMETRY_ENCODING=WKB (Arrow/Parquet drivers). To force a fallback to the
generic implementation when the native geometry encoding is not WKB.
Otherwise the geometry will be returned with its native Arrow encoding
(possibly using GeoArrow encoding).
}

\code{$quiet}\cr
A logical value, \code{FALSE} by default. Set to \code{TRUE} to suppress various
messages and warnings.

\code{$transactionsForce}\cr
A logical value, \code{FALSE} by default. Affects the behavior of attempted
transactions on the layer (see the \code{$startTransaction()} method below).
By default, only "efficient" transactions will be attempted. Some drivers
may offer an emulation of transactions, but sometimes with significant
overhead, in which case the user must explicitly allow for such an
emulation by first setting \code{$transactionsForce <- TRUE}.
}

\subsection{Methods}{

\code{$open(read_only)}\cr
(Re-)opens the vector layer on the existing DSN. Use this method to
open a layer that has been closed using \code{$close()}. May be used to
re-open a layer with a different read/write access (\code{read_only} set to
\code{TRUE} or \code{FALSE}). The method will first close an open dataset, so it is
not required to call \code{$close()} explicitly in this case.
No return value, called for side effects.

\code{$isOpen()}\cr
Returns a \code{logical} value indicating whether the vector dataset is open.

\code{$isReadOnly()}\cr
Returns a logical value, \code{TRUE} if the vector dataset has read-only access
or \code{FALSE} if it is writable.

\code{$getDsn()}\cr
Returns a character string containing the \code{dsn} associated with this
\code{GDALVector} object (\code{dsn} originally used to open the layer).

\code{$getFileList()}\cr
Returns a character vector of files believed to be part of the data source.
If it returns an empty string (\code{""}) it means there is believed to be no
local file system files associated with the dataset (e.g., a virtual file
system). The returned filenames will normally be relative or absolute
paths depending on the path used to originally open the dataset.

\code{$info()}\cr
Prints information about the vector layer to the console (no
return value, called for that side effect only).
For non-SQL DSN/layer, calls \code{\link[=ogrinfo]{ogrinfo()}} passing the command options
\code{cl_arg = c("-so", "-nomd")}, and for layers open with a SQL statement,
calls \code{\link[=ogrinfo]{ogrinfo()}} passing the command options
\verb{cl_arg = c("-so", "-nomd", "-sql", <statement>)}.

\code{$getDriverShortName()}\cr
Returns the short name of the vector format driver.

\code{$getDriverLongName()}\cr
Returns the long name of the vector format driver.

\code{$getName()}\cr
Returns the layer name.

\code{$getFieldNames()}\cr
Returns a character vector of the layer's field names.

\code{$testCapability()}\cr
Tests whether the layer supports named capabilities based on the current
read/write access. Returns a list of capabilities with values \code{TRUE} or
\code{FALSE}. The returned list contains the following named elements:
\code{RandomRead}, \code{SequentialWrite}, \code{RandomWrite}, \code{UpsertFeature},
\code{FastSpatialFilter}, \code{FastFeatureCount}, \code{FastGetExtent},
\code{FastSetNextByIndex}, \code{FastGetArrowStream}, \code{FastWriteArrowBatch},
\code{CreateField}, \code{CreateGeomField}, \code{DeleteField}, \code{ReorderFields},
\code{AlterFieldDefn}, \code{AlterGeomFieldDefn}, \code{DeleteFeature}, \code{StringsAsUTF8},
\code{Transactions}, \code{CurveGeometries}.
Note that some layer capabilities are GDAL version dependent and may not
be listed if not supported by the GDAL version currently in use.
(See the GDAL documentation for
\href{https://gdal.org/en/stable/api/vector_c_api.html#_CPPv420OGR_L_TestCapability9OGRLayerHPKc}{\code{OGR_L_TestCapability()}}.)

\code{$getFIDColumn()}\cr
Returns the name of the underlying database column being used as the FID
column, or empty string (\code{""}) if not supported.

\code{$getGeomType()}\cr
Returns the well known name of the layer geometry type as character string.
For layers with multiple geometry fields, this method only returns the
geometry type of the first geometry column. For other columns, use
\code{$getLayerDefn()}. For layers without any geometry field, this method
returns \code{"NONE"}.

\code{$getGeometryColumn()}\cr
Returns he name of the underlying database column being used as the geometry
column, or an empty string (\code{""}) if not supported.
For layers with multiple geometry fields, this method only returns the
name of the first geometry column. For other columns, use method
\code{$getLayerDefn()}.

\code{$getSpatialRef()}\cr
Returns a WKT string containing the spatial reference system for this layer,
or empty string (\code{""}) if no spatial reference exists.

\code{$bbox()}\cr
Returns a numeric vector of length four containing the bounding box
for this layer (xmin, ymin, xmax, ymax). Note that \code{bForce = true} is set in
the underlying API call to \code{OGR_L_GetExtent()}, so the entire layer may be
scanned to compute a minimum bounding rectangle (see \code{FastGetExtent} in the
list returned by \code{$testCapability()}). Depending on the format driver,
a spatial filter may or may not be taken into account, so it is safer to
call \code{$bbox()} without setting a spatial filter.

\code{$getLayerDefn()}\cr
Returns a list containing the OGR feature class definition for this layer
(a.k.a. layer definition). The list contains zero or more attribute field
definitions, along with one or more geometry field definitions.
See \link{ogr_define} for details of the field and feature class definitions.

\code{$getFieldDomain(domain_name)}\cr
Returns a list containing the definition of the OGR field domain with the
passed \code{domain_name}, or \code{NULL} if \code{domain_name} is not found.
See \link{ogr_define} for specification of the list containing a field domain
definition.
Some formats support the use of field domains which describe the valid values
that can be stored in a given attribute field, e.g., coded values that are
present in a specified enumeration, values constrained to a specified
range, or values that must match a specified pattern.
See
\url{https://gdal.org/en/stable/user/vector_data_model.html#field-domains}.
Requires GDAL >= 3.3.

\code{$setAttributeFilter(query)}\cr
Sets an attribute query string to be used when fetching features via the
\code{$getNextFeature()} or \code{$fetch()} methods.
Only features for which \code{query} evaluates as true will be returned.
The query string should be in the format of an SQL WHERE clause, described
in the \href{https://gdal.org/en/stable/user/ogr_sql_dialect.html#where}{"WHERE"}
section of the OGR SQL dialect documentation (e.g.,
\code{"population > 1000000 and population < 5000000"}, where \code{population} is an
attribute in the layer).
In some cases (RDBMS backed drivers, SQLite, GeoPackage) the native
capabilities of the database may be used to to interpret the WHERE clause,
in which case the capabilities will be broader than those of OGR SQL.
Note that installing a query string will generally result in resetting the
current reading position (as with \code{$resetReading()} described below).
The \code{query} parameter may be set to empty string (\code{""}) to clear the current
attribute filter.

\code{$getAttributeFilter()}\cr
Returns the attribute query string currently in use, or empty string (\code{""})
if an attribute filter is not set.

\code{$setIgnoredFields(fields)}\cr
Set which fields can be omitted when retrieving features from the layer.
The \code{fields} argument is a character vector of field names. Passing an
empty string (\code{""}) for \code{fields} will reset to no ignored fields.
If the format driver supports this functionality (testable using
\code{$testCapability()$IgnoreFields}), it will not fetch the specified
fields in subsequent calls to \code{$getFeature()} / \code{$getNextFeature()}
/ \code{$fetch()}, and thus save some processing time and/or bandwidth.
Besides field names of the layer, the following special fields can be passed:
\code{"OGR_GEOMETRY"} to ignore geometry and \code{"OGR_STYLE"} to ignore layer style.
By default, no fields are ignored. Note that fields that are used in an
attribute filter should generally not be set as ignored fields, as most
drivers (such as those relying on the OGR SQL engine) will be unable to
correctly evaluate the attribute filter. No return value, called for side
effects.

\code{$setSelectedFields(fields)}\cr
Set which fields will be included when retrieving features from the layer.
The \code{fields} argument is a character vector of field names. Passing an
empty string (\code{""}) for \code{fields} will reset to no ignored fields.
See the \code{$setIgnoredFields()} method above for more information. The
data source must provide IgnoreFields capability in order to set selected
fields. Note that geometry fields, if desired, must be specified when setting
selected fields, either by including named geometry field(s) or the special
field \code{"OGR_GEOMETRY"} in the \code{fields} argument.
No return value, called for side effects.

\code{$getIgnoredFields()}\cr
Returns a character vector containing the list of currently ignored fields,
or an empty vector (\code{character(0)}) if no fields are currently set to
ignored (or if the format driver does not support ignored fields).

\code{$setSpatialFilter(wkt)}\cr
Sets a new spatial filter from a geometry in WKT format. This method sets
the geometry to be used as a spatial filter when fetching features via the
\code{$getNextFeature()} or \code{$fetch()} methods. Only features that
geometrically intersect the filter geometry will be returned. Currently this
test may be inaccurately implemented (depending on the vector format driver),
but it is guaranteed that all features whose envelope overlaps the envelope
of the spatial filter will be returned. This can result in more shapes being
returned that should strictly be the case.
\code{wkt} is a character string containing a WKT geometry in the same coordinate
system as the layer. An empty string (\code{""}) may be passed indicating that
the current spatial filter should be cleared, but no new one instituted.

\code{$setSpatialFilterRect(bbox)}\cr
Sets a new rectangular spatial filter. This method sets a rectangle to be
used as a spatial filter when fetching features via the
\code{$getNextFeature()} or \code{$fetch()} methods.
Only features that geometrically intersect the given rectangle will be
returned.
\code{bbox} is a numeric vector of length four containing xmin, ymin, xmax, ymax
in the same coordinate system as the layer as a whole (as returned by
\code{$getSpatialRef()}).

\code{$getSpatialFilter()}\cr
Returns the current spatial filter geometry as a WKT string, or empty string
(\code{""}) if a spatial filter is not set.

\code{$clearSpatialFilter()}\cr
Clears a spatial filter that was set with \code{$setSpatialFilterRect()}.
No return value, called for that side effect.

\code{$getFeatureCount()}\cr
Returns the number of features in the layer. For dynamic databases the count
may not be exact. This method forces a count in the underlying API call
(i.e., \code{bForce = TRUE} in the call to \code{OGR_L_GetFeatureCount()}). Note that
some vector drivers will actually scan the entire layer once to count
features. The \code{FastFeatureCount} element in the list returned by
the \code{$testCapability()} method can be checked if this might be a
concern.
The number of features returned takes into account the spatial and/or
attribute filters. Some driver implementations of this method may alter the
read cursor of the layer.

\code{$getNextFeature()}\cr
Fetch the next available feature from this layer. Only features matching the
current spatial and/or attribute filter (if defined) will be returned.
This method implements sequential access to the features of a layer.
The \code{$resetReading()} method can be used to start at the beginning
again.
Returns a list with the unique feature identifier (FID), the attribute and
geometry field names, and their values. The returned list carries the
\code{OGRFeature} class attribute with S3 methods for for \code{print()} and \code{plot()}.
\code{NULL} is returned if no more features are available.

\code{$setNextByIndex(i)}\cr
Moves the read cursor to feature \code{i} in the current result set
(with 0-based indexing).
This method allows positioning of a layer such that a call to
\code{$getNextFeature()} or \code{$fetch()} will read the requested
feature(s), where \code{i} is an absolute index into the current result set.
So, setting \code{i = 3} would mean the next feature read with
\code{$getNextFeature()} would have been the fourth feature read if
sequential reading took place from the beginning of the layer, including
accounting for spatial and attribute filters.
This method is not implemented efficiently by all vector format drivers. The
default implementation simply resets reading to the beginning and then calls
\code{GetNextFeature()} \code{i} times.
To determine if fast seeking is available on the current layer, check
the \code{FastSetNextByIndex} element in the list returned by the
\code{$testCapability()} method. No return value, called for side effect.

\code{$getFeature(fid)}\cr
Returns a feature by its identifier. The value of \code{fid} must be a numeric
value, optionally carrying the \code{bit64::integer64} class attribute.
Success or failure of this operation is unaffected by any spatial or
attribute filters that may be in effect.
The \code{RandomRead} element in the list returned by \code{$testCapability()} can
be checked to establish if this layer supports efficient random access
reading; however, the call should always work if the feature exists since a
fallback implementation just scans all the features in the layer looking for
the desired feature. Returns a list with the unique feature identifier (FID),
the attribute and geometry field names, and their values, or \code{NULL} on
failure. Note that sequential reads (with \code{$getNextFeature()}) are
generally considered interrupted by a call to \code{$getFeature()}.

\code{$resetReading()}\cr
Reset feature reading to start on the first feature. No return value, called
for that side effect.

\code{$fetch(n)}\cr
Fetches the next \code{n} features from the layer and returns them as a data
frame. This allows retrieving the entire set of features, one page of
features at a time, or the remaining features (from the current cursor
position). Returns a data frame with as many rows as features were fetched,
and as many columns as attribute plus geometry fields in the result set,
even if the result is a single value or has one or zero rows.
The returned data frame carries the \code{OGRFeatureSet} class attribute with S3
methods for for \code{print()} and \code{plot()}.

This method is an analog of
\href{https://dbi.r-dbi.org/reference/dbFetch.html}{\code{DBI::dbFetch()}}.

The \code{n} argument is the maximum number of features to retrieve per fetch
given as \code{integer} or \code{numeric} but assumed to be a whole number (will
be truncated). Use \code{n = -1} or \code{n = Inf} to retrieve all pending features
(resets reading to the first feature).
Otherwise, \code{$fetch()} can be called multiple times to perform forward
paging from the current cursor position. Passing \code{n = NA} is also supported
and returns the remaining features.
Fetching zero features is possible to retrieve the structure of the feature
set as a data frame (columns fully typed).

OGR field types are returned as the following \R types (type-specific \code{NA}
for OGR NULL values):
\itemize{
\item \strong{OFTInteger}: \code{integer} value
\item \strong{OFTInteger subtype OFSTBoolean}: \code{logical} value
\item \strong{OFTIntegerList}: vector of \code{integer} (list column)
\item \strong{OFTInteger64}: \code{numeric} value carrying the \code{"integer64"} class
attribute
\item \strong{OFTInteger64 subtype OFSTBoolean}: \code{logical} value
\item \strong{OFTInteger64List}: vector of \code{bit64::integer64} (list column)
\item \strong{OFTReal}: \code{numeric} value
\item \strong{OFTRealList}: vector of \code{numeric} (list column)
\item \strong{OFTString}: \code{character} string
\item \strong{OFTStringList}: vector of \code{character} strings (list column)
\item \strong{OFTDate}: \code{numeric} value of class \code{"Date"}
\item \strong{OFTDateTime}: \code{numeric} value of class \code{"POSIXct"} (millisecond
accuracy)
\item \strong{OFTTime}: \code{character} string (\code{"HH:MM:SS"})
\item \strong{OFTBinary}: \code{raw} vector (list column, \code{NULL} entries for OGR NULL
values)
}

Geometries are not returned if the field \code{returnGeomAs} is set to \code{NONE}.
Omitting the geometries may be beneficial for performance and memory usage
when access only to feature attributes is needed. Geometries are returned
as \code{raw} vectors in a data frame list column when \code{returnGeomAs} is set to
\code{WKB} (the default) or \code{WKB_ISO}, or as \code{character} strings when
\code{returnGeomAs} is set to one of \code{WKT} or \code{WKT_ISO}.

Note that \code{$getFeatureCount()} is called internally when fetching the
full feature set or all remaining features (but not for a page of features).

\code{$getArrowStream()}\cr
Returns a \code{nanoarrow_array_stream} object exposing an Arrow C stream on the
layer (requires GDAL >= 3.6).
The writable field \code{$arrowStreamOptions} can be used to set options
before calling this method (see above). An error is raised if an array stream
on the layer cannot be obtained.
Generally, only one ArrowArrayStream can be active at a time on a given
layer (i.e., the last active one must be explicitly released before a next
one is asked). Changing attribute or spatial filters, ignored columns,
modifying the schema or using \code{$resetReading()} /
\code{$getNextFeature()} while using an ArrowArrayStream is strongly
discouraged and may lead to unexpected results. As a rule of thumb, no
OGRLayer methods that affect the state of a layer should be called on the
layer while an ArrowArrayStream on it is active. Methods available on the
stream object are: \code{$get_schema()}, \code{$get_next()} and
\code{$release()} (see Examples).

The stream should be released once reading is complete. Calling the release
method as soon as you can after consuming a stream is recommended by the
\pkg{nanoarrow} documentation.

See also the \code{$testCapability()} method above to check whether the
format driver provides a specialized implementation (\code{FastGetArrowStream}),
as opposed to the (slower) default implementation. Note however that
specialized implementations may fallback to the default when attribute or
spatial filters are in use.
(See the GDAL documentation for
\href{https://gdal.org/en/stable/api/vector_c_api.html#_CPPv420OGR_L_GetArrowStream9OGRLayerHP16ArrowArrayStreamPPc}{\code{OGR_L_GetArrowStream()}}.)

\code{$releaseArrowStream()}\cr
Releases the Arrow C stream returned by \code{$getArrowStream()} and clears
the \code{nanoarrow_array_stream} object (if GDAL >= 3.6, otherwise does nothing).
This is equivalent to calling the \code{$release()} method on the
\code{nanoarrow_array_stream} object. No return value, called for side effects.

\code{$setFeature(feature)}\cr
Rewrites/replaces an existing feature. This method writes a feature based on
the feature id within the input feature. The \code{feature} argument is a named
list of fields and their values, and must include a \code{FID} element
referencing the existing feature to rewrite. The \code{RandomWrite} element in
the list returned by \code{$testCapability()} can be checked to establish if
this layer supports random access writing via \code{$setFeature()}.
The way omitted fields in the passed \code{feature} are processed is driver
dependent:
\itemize{
\item SQL-based drivers which implement set feature through SQL UPDATE will skip
unset fields, and thus the content of the existing feature will be
preserved.
\item The shapefile driver will write a NULL value in the DBF file.
\item The GeoJSON driver will take into account unset fields to remove the
corresponding JSON member.
}

Returns logical \code{TRUE} upon successful completion, or \code{FALSE} if setting the
feature did not succeed. The FID of the last feature written to the layer
may be obtained with the method \code{$getLastWriteFID()} (see below).
To set a feature, but create it if it doesn't exist see the
\code{$upsertFeature()} method.

\code{$createFeature(feature)}\cr
Creates and writes a new feature within the layer. The \code{feature} argument is
a named list of fields and their values (might be one row of a data frame).
The passed feature is written to the layer as a new feature, rather than
overwriting an existing one. If the feature has a \code{FID} element with other
than \code{NA} (i.e., a numeric value, optionally carrying the \code{bit64::integer64}
class attribute and assumed to be a whole number), then the format
driver may use that as the feature id of the new feature, but not
necessarily. The FID of the last feature written to the layer may be
obtained with the method \code{$getLastWriteFID()} (see below).
Returns logical \code{TRUE} upon successful completion, or \code{FALSE} if creating
the feature did not succeed. To create a feature, but set it if it already
exists see the \code{$upsertFeature()} method.

\code{$batchCreateFeature(feature_set)}\cr
Batch version of \code{$createFeature()}. Creates and writes a batch of new
features within the layer from input passed as a data frame in the
\code{feature_set} argument. Column names in the data frame must match field
names of the layer and have compatible data types. The specifications
listed above under the \code{$fetch()} method generally apply to input data
types for writing, but integers may be passed as 'numeric', and
the 'integer64' class attribute is not strictly required on 'numeric'
input if it is not needed for the data being passed to an OFTInteger64
field.
Returns a logical vector of length equal to the number of input features
(rows of the data frame), with \code{TRUE} indicating success for the feature at
that row index, or \code{FALSE} if writing the feature failed.
It is recommended to use transactions when batch writing features to a
layer (see \code{$startTransaction()} below). This will generally give large
performance benefit with data sources that provide efficient transaction
support (e.g., RDBMS-based sources such as GeoPackage and PostGIS). In
addition, the return value of \code{$batchCreateFeature()} can be checked,
and the transaction optionally committed or rolled back based on results of
the operation across the full set of input features.

\code{$upsertFeature(feature)}\cr
Rewrites/replaces an existing feature or creates a new feature within the
layer. This method will write a feature to the layer, based on the feature
id within the input feature. The \code{feature} argument is a named list of
fields and their values (might be one row of a data frame), potentially
including a \code{FID} element referencing an existing feature to rewrite. If
the feature id doesn't exist a new feature will be written. Otherwise, the
existing feature will be rewritten.
The \code{UpsertFeature} element in the list returned by \code{$testCapability()}
can be checked to determine if this layer supports upsert writing. See
\code{$setFeature()} above for a description of how omitted fields in the
passed feature are processed.
Returns logical \code{TRUE} upon successful completion, or \code{FALSE} if upsert did
not succeed. Requires GDAL >= 3.6.

\code{$getLastWriteFID()}\cr
Returns the FID of the last feature written (either newly created or updated
existing). \code{NULL} is returned if no features have been written in the layer.
Note that OGRNullFID (\code{-1}) may be returned after writing a feature in some
formats. This is the case if a FID has not been assigned yet, and generally
does not indicate an error (e.g., formats that do not store a persistent FID
and assign FIDs upon a sequential read operation). The returned FID is a
numeric value carrying the \code{bit64::integer64} class attribute.

\code{$deleteFeature(fid)}\cr
Deletes a feature from the layer. The feature with the indicated feature ID
is deleted from the layer if supported by the format driver. The value of
\code{fid} must be a numeric value, optionally carrying the \code{bit64::integer64}
class attribute (should be a whole number, will be truncated).
The \code{DeleteFeature} element in the list returned by \code{$testCapability()}
can be checked to establish if this layer has delete feature capability.
Returns logical \code{TRUE} if the operation succeeds, or \code{FALSE} on failure.

\code{$syncToDisk()}\cr
Flushes pending changes to disk. This call is intended to force the layer to
flush any pending writes to disk, and leave the disk file in a consistent
state. It would not normally have any effect on read-only datasources. Some
formats do not implement this method, and will still return no error. An
error is only returned if an error occurs while attempting to flush to disk.
In any event, you should always close any opened datasource with
\code{$close()} which will ensure all data is correctly flushed. Returns
logical \code{TRUE} if no error occurs (even if nothing is done) or \code{FALSE} on
error.

\code{$startTransaction()}\cr
Creates a transaction if supported by the vector data source. By default,
only "efficient" transactions will be attempted. See the writable field
\code{$transactionsForce} above, which must be set to \code{TRUE} to allow for
emulated transactions. These are supported by some drivers but with
potentially significant overhead. The function \code{ogr_ds_test_cap()} can be
used to determine whether a vector data source supports efficient or
emulated transactions.

All changes done after the start of the transaction are definitely applied
in the data source if \code{$commitTransaction()} is called. They can be
canceled by calling \code{$rollbackTransaction()} instead.
Nested transactions are not supported. Transactions are implemented at the
dataset level, so multiple \code{GDALVector} objects using the same data source
should not have transactions active at the same time.

In case \code{$startTransaction()} fails, neither \code{$commitTransaction()}
nor \code{$rollbackTransaction()} should be called.
If an error occurs after a successful \code{$startTransaction()}, the whole
transaction may or may not be implicitly canceled, depending on the format
driver (e.g., the PostGIS driver will cancel it, SQLite/GPKG will not). In
any case, in the event of an error, an explicit call to
\code{$rollbackTransaction()} should be done to keep things balanced.

Returns logical \code{TRUE} if the transaction is created, or \code{FALSE} on failure.

\code{$commitTransaction()}\cr
Commits a transaction if supported by the vector data source.
Returns a logical value, \code{TRUE} if the transaction is successfully committed.
Returns \code{FALSE} if no transaction is active, or the rollback fails, or if the
data source does not support transactions.
Depending on the format driver, this may or may not abort layer sequential
reading that may be active.

\code{$rollbackTransaction()}\cr
Rolls back a data source to its state before the start of the current
transaction, if transactions are supported by the data source.
Returns a logical value, \code{TRUE} if the transaction is successfully rolled
back. Returns \code{FALSE} if no transaction is active, or the rollback fails,
or if the data source does not support transactions.

\code{$getMetadata()}\cr
Returns a character vector of all metadata \code{NAME=VALUE} pairs for the
layer or empty string (\code{""}) if there are no metadata items.

\code{$setMetadata(metadata)}\cr
Sets metadata on the layer if the format supports it. The \code{metadata}
argument is given as a character vector of \code{NAME=VALUE} pairs.
Returns logical \code{TRUE} on success or \code{FALSE} if metadata could
not be set.

\code{$getMetadataItem(mdi_name)}\cr
Returns the value of a specific metadata item named \code{mdi_name}, or empty
string (\code{""}) if no matching item is found.

\code{$close()}\cr
Closes the vector dataset (no return value, called for side effects).
Calling \code{$close()} results in proper cleanup, and flushing of any
pending writes.
The \code{GDALVector} object is still available after calling \code{$close()}.
The layer can be re-opened on the existing \code{dsn} with
\code{$open(read_only = TRUE|FALSE)}.
}
}

\examples{
## MTBS fire perimeters in Yellowstone National Park 1984-2022
f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")

## copy to a temporary file that is writeable
dsn <- file.path(tempdir(), basename(f))
file.copy(f, dsn)

(lyr <- new(GDALVector, dsn, "mtbs_perims"))

str(lyr)

## dataset info
lyr$getDriverShortName()
lyr$getDriverLongName()
lyr$getFileList()

## layer info
lyr$getName()
lyr$getGeomType()
lyr$getGeometryColumn()
lyr$getFIDColumn()
lyr$getSpatialRef()
lyr$bbox()

## layer capabilities
lyr$testCapability()

## re-open with write access
lyr$open(read_only = FALSE)
lyr$testCapability()$SequentialWrite
lyr$testCapability()$RandomWrite

## feature class definition - a list of field names and their definitions
defn <- lyr$getLayerDefn()
names(defn)
str(defn)

## default value of the read/write field 'returnGeomAs'
lyr$returnGeomAs

lyr$getFeatureCount()

## sequential read cursor
# a single feature returned as a named list of fields and their values:
(feat <- lyr$getNextFeature())

## set an attribute filter
lyr$setAttributeFilter("ig_year = 2020")
lyr$getFeatureCount()

feat <- lyr$getNextFeature()
plot(feat)

## NULL when no more features are available
lyr$getNextFeature()

## reset reading to the start
lyr$resetReading()
lyr$getNextFeature()

## clear the attribute filter
lyr$setAttributeFilter("")
lyr$getFeatureCount()

## set a spatial filter
## get the bounding box of the largest 1988 fire and use as spatial filter
## first set a temporary attribute filter to do the lookup
lyr$setAttributeFilter("ig_year = 1988 ORDER BY burn_bnd_ac DESC")
(feat <- lyr$getNextFeature())

bbox <- g_wk2wk(feat$geom) |> bbox_from_wkt()

## set spatial filter on the full layer
lyr$setAttributeFilter("")  # clears the attribute filter
lyr$setSpatialFilterRect(bbox)
lyr$getFeatureCount()

## fetch in chunks and return as data frame (class OGRFeatureSet)
feat_set <- lyr$fetch(20)
head(feat_set)
plot(feat_set)

## the next chunk
feat_set <- lyr$fetch(20)
nrow(feat_set)

## no features remaining
feat_set <- lyr$fetch(20)
nrow(feat_set)
str(feat_set)  # 0-row data frame with columns fully typed

## or, fetch all pending features from the beginning
feat_set <- lyr$fetch(-1)  # resets reading to the first feature
nrow(feat_set)
plot(feat_set)

lyr$clearSpatialFilter()
lyr$getFeatureCount()

lyr$close()

## simple example of feature write methods showing use of various data types
## create and write to a new layer in a GeoPackage data source
dsn2 <- tempfile(fileext = ".gpkg")

## define a feature class
defn <- ogr_def_layer("POINT", srs = epsg_to_wkt(4326))

## add field definitions
defn$unique_int <- ogr_def_field("OFTInteger", is_nullable = FALSE,
                                 is_unique = TRUE)
defn$bool_data <- ogr_def_field("OFTInteger", fld_subtype = "OFSTBoolean")
defn$large_ints <- ogr_def_field("OFTInteger64")
defn$doubles <- ogr_def_field("OFTReal")
defn$strings <- ogr_def_field("OFTString", fld_width = 50)
defn$dates <- ogr_def_field("OFTDate")
defn$dt_modified <- ogr_def_field("OFTDateTime",
                                  default_value = "CURRENT_TIMESTAMP")
defn$blobs <- ogr_def_field("OFTBinary")

lyr <- ogr_ds_create("GPKG", dsn2, "test_layer", layer_defn = defn,
                     return_obj = TRUE)

# lyr$getLayerDefn() |> str()

## define a feature to write
feat1 <- list()
# $FID is omitted since it is assigned when written (could also be NA)
# $dt_modified is omitted since a default timestamp is defined on the field
feat1$unique_int <- 1001
feat1$bool_data <- TRUE
# pass a string to as.integer64() since the value is too large to be
# represented exactly as an R numeric value (i.e., double)
feat1$large_ints <- bit64::as.integer64("90071992547409910")
feat1$doubles <- 1.234
feat1$strings <- "A test string"
feat1$dates <- as.Date("2025-01-01")
feat1$blobs <- charToRaw("A binary object")
feat1$geom <- "POINT (1 1)"  # can be a WKT string or raw vector of WKB

## create as a new feature in the layer
lyr$createFeature(feat1)

## get the assigned FID
lyr$getLastWriteFID()

## attempt to re-write the same feature fails due to the unique constraint
lyr$createFeature(feat1)

feat2 <- list()
feat2$unique_int <- 1002
feat2$bool_data <- FALSE
feat2$large_ints <- bit64::as.integer64("90071992547409920")
feat2$doubles <- 2.345
feat2$strings <- "A test string 2"
feat2$dates <- as.Date("2024-01-02")
feat2$blobs <- charToRaw("A binary object 2")
feat2$geom <- "POINT (2 2)"

lyr$createFeature(feat2)
lyr$getLastWriteFID()

## close and re-open as a read-only layer
lyr$open(read_only = TRUE)

lyr$getFeatureCount()
feat_set <- lyr$fetch(-1)  # -1 to fetch all features from the beginning
str(feat_set)

## edit an existing feature, e.g., feat <- lyr$getFeature(2)
## here we copy a row of the data frame returned by lyr$fetch() above
feat <- feat_set[2,]
str(feat)

Sys.sleep(1)  # to ensure a timestamp difference

feat$bool_data <- TRUE
feat$strings <- paste(feat$strings, "- edited")
feat$dt_modified <- Sys.time()
feat$geom <- "POINT (2.001 2.001)"

lyr$open(read_only = FALSE)

## lyr$setFeature() re-writes the feature identified by the $FID element
lyr$setFeature(feat)

lyr$open(read_only = TRUE)
lyr$getFeatureCount()

lyr$returnGeomAs <- "WKT"
feat_set <- lyr$fetch(-1)
str(feat_set)

lyr$close()

## Arrow array stream exposed as a nanoarrow_array_stream object
## requires GDAL >= 3.6
if (gdal_version_num() >= gdal_compute_version(3, 6, 0)) {

  sql <- "SELECT incid_name, geom from mtbs_perims LIMIT 5"
  lyr <- new(GDALVector, dsn, sql)

  stream <- lyr$getArrowStream()

  # disable a warning for the example that can be safely ignored here
  options(nanoarrow.warn_unregistered_extension = FALSE)

  # pull all the batches into a data frame
  d <- as.data.frame(stream)

  # the geometry column is a list column of WKB raw vectors, which can be
  # passed to the Geometry API g_*() functions, e.g.,
  g_centroid(d$geom) |> print()

  # release the stream when finished
  stream$release()

  lyr$close()
}
\dontshow{unlink(dsn)}
\dontshow{unlink(dsn2)}
}
\seealso{
\link{ogr_define}, \link{ogr_manage}, \code{\link[=ogr2ogr]{ogr2ogr()}}, \code{\link[=ogrinfo]{ogrinfo()}}

GDAL vector format descriptions:\cr
\url{https://gdal.org/en/stable/drivers/vector/index.html}

GDAL-supported SQL dialects:\cr
\url{https://gdal.org/en/stable/user/ogr_sql_sqlite_dialect.html}

GDAL Vector API documentation:\cr
\url{https://gdal.org/en/stable/api/index.html}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/proj.R
\name{proj_search_paths}
\alias{proj_search_paths}
\title{Get or set search path(s) for PROJ resource files}
\usage{
proj_search_paths(paths = NULL)
}
\arguments{
\item{paths}{Optional character vector containing one or more directory
paths to set.}
}
\value{
A character vector containing the currently used search path(s) for
PROJ resource files. An empty string (\code{""}) is returned if no search paths
are returned by the function \code{OSRGetPROJSearchPaths()} in the GDAL Spatial
Reference System C API.
}
\description{
\code{proj_search_paths()} returns the search path(s) for PROJ resource files,
optionally setting them first.
}
\examples{
proj_search_paths()
}
\seealso{
\code{\link[=proj_version]{proj_version()}}, \code{\link[=proj_networking]{proj_networking()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{gdal_version}
\alias{gdal_version}
\alias{gdal_version_num}
\title{Get GDAL version}
\usage{
gdal_version()

gdal_version_num()
}
\value{
\code{gdal_version()} returns a character vector of length four containing:
\itemize{
\item "-version" - one line version message, e.g., "GDAL 3.6.3, released
2023/03/12"
\item "GDAL_VERSION_NUM" - formatted as a string, e.g., "3060300" for
GDAL 3.6.3.0
\item "GDAL_RELEASE_DATE" - formatted as a string, e.g., "20230312"
\item "GDAL_RELEASE_NAME" - e.g., "3.6.3"
}

\code{gdal_version_num()} returns \code{as.integer(gdal_version()[2])}
}
\description{
\code{gdal_version()} returns a character vector of GDAL runtime version
information. \code{gdal_version_num()} returns only the full version number
(\code{gdal_version()[2]}) as an integer value.
}
\examples{
gdal_version()

gdal_version_num()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_helpers.R
\name{apply_geotransform}
\alias{apply_geotransform}
\title{Apply geotransform (raster column/row to geospatial x/y)}
\usage{
apply_geotransform(col_row, gt)
}
\arguments{
\item{col_row}{Numeric matrix of raster column, row (pixel/line) coordinates
(or two-column data frame that will be coerced to numeric matrix, or a
vector of column, row for one coordinate).}

\item{gt}{Either a numeric vector of length six containing the affine
geotransform for the raster, or an object of class \code{GDALRaster} from
which the geotransform will be obtained.}
}
\value{
Numeric matrix of geospatial x/y coordinates.
}
\description{
\code{apply_geotransform()} applies geotransform coefficients to raster
coordinates in pixel/line space (column/row), converting into
georeferenced (x/y) coordinates. Wrapper of \code{GDALApplyGeoTransform()} in
the GDAL API, operating on matrix input.
}
\note{
Bounds checking on the input coordinates is done if \code{gt} is obtained from an
object of class \code{GDALRaster}. See Note for \code{\link[=get_pixel_line]{get_pixel_line()}}.
}
\examples{
raster_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
ds <- new(GDALRaster, raster_file)

# compute some raster coordinates in column/row space
set.seed(42)
col_coords <- runif(10, min = 0, max = ds$getRasterXSize() - 0.00001)
row_coords <- runif(10, min = 0, max = ds$getRasterYSize() - 0.00001)
col_row <- cbind(col_coords, row_coords)

# convert to geospatial x/y coordinates
gt <- ds$getGeoTransform()
apply_geotransform(col_row, gt)

# or, using the class method
ds$apply_geotransform(col_row)

# bounds checking
col_row <- rbind(col_row, c(ds$getRasterXSize(), ds$getRasterYSize()))
ds$apply_geotransform(col_row)

ds$close()
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster$getGeoTransform()}}, \code{\link[=get_pixel_line]{get_pixel_line()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom.R
\name{g_binary_pred}
\alias{g_binary_pred}
\alias{g_intersects}
\alias{g_disjoint}
\alias{g_touches}
\alias{g_contains}
\alias{g_within}
\alias{g_crosses}
\alias{g_overlaps}
\alias{g_equals}
\title{Geometry binary predicates operating on WKB or WKT}
\usage{
g_intersects(this_geom, other_geom, quiet = FALSE)

g_disjoint(this_geom, other_geom, quiet = FALSE)

g_touches(this_geom, other_geom, quiet = FALSE)

g_contains(this_geom, other_geom, quiet = FALSE)

g_within(this_geom, other_geom, quiet = FALSE)

g_crosses(this_geom, other_geom, quiet = FALSE)

g_overlaps(this_geom, other_geom, quiet = FALSE)

g_equals(this_geom, other_geom, quiet = FALSE)
}
\arguments{
\item{this_geom}{Either a raw vector of WKB or list of raw vectors, or a
character vector containing one or more WKT strings.}

\item{other_geom}{Either a raw vector of WKB or list of raw vectors, or a
character vector containing one or more WKT strings. Must contain the same
number of geometries as \code{this_geom}, unless \code{this_geom} contains a single
geometry in which case pairwise tests will be performed for one-to-many if
\code{other_geom} contains multiple geometries (i.e., "this-to-others").}

\item{quiet}{Logical value, \code{TRUE} to suppress warnings. Defaults to \code{FALSE}.}
}
\value{
Logical vector with length equal to the number of input geometry
pairs.
}
\description{
These functions implement tests for pairs of geometries in OGC WKB or
WKT format.
}
\details{
These functions use the GEOS library via GDAL headers.

\code{g_intersects()} tests whether two geometries intersect.

\code{g_disjoint()} tests if this geometry and the other geometry are disjoint.

\code{g_touches()} tests if this geometry and the other geometry are touching.

\code{g_contains()} tests if this geometry contains the other geometry.

\code{g_within()} tests if this geometry is within the other geometry.

\code{g_crosses()} tests if this geometry and the other geometry are crossing.

\code{g_overlaps()} tests if this geometry and the other geometry overlap, that
is, their intersection has a non-zero area (they have some but not all
points in common).

\code{g_equals()} tests whether two geometries are equivalent.
The GDAL documentation says: "This operation implements the SQL/MM
\code{ST_OrderingEquals()} operation. The comparison is done in a structural way,
that is to say that the geometry types must be identical, as well as the
number and ordering of sub-geometries and vertices. Or equivalently, two
geometries are considered equal by this method if their WKT/WKB
representation is equal. Note: this must be distinguished from equality in
a spatial way."
}
\note{
\code{this_geom} and \code{other_geom} are assumed to be in the same coordinate
reference system.

If \code{this_geom}is a single geometry and \code{other_geom} is a list or vector of
multiple geometries, then \code{this_geom} will be tested against each geometry
in \code{other_geom} (otherwise no recycling is done).

Geometry validity is not checked. In case you are unsure of the validity
of the input geometries, call \code{g_is_valid()} before, otherwise the result
might be wrong.
}
\seealso{
\url{https://en.wikipedia.org/wiki/DE-9IM}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{gdal_formats}
\alias{gdal_formats}
\title{Retrieve information on GDAL format drivers for raster and vector}
\usage{
gdal_formats(format = "")
}
\arguments{
\item{format}{A character string containing a driver short name. By default,
information for all configured raster and vector format drivers will be
returned.}
}
\value{
A data frame containing:
\itemize{
\item the format short name
\item file extension(s) if applicable (space-delimited string), or empty string
(\code{""})
\item supports raster (logical)
\item supports multidimensional raster (logical)
\item supports vector (logical)
\item supports geography network (logical)
\item read/write flags (concatenated string, \code{ro} is read-only, \code{w} supports
CreateCopy, \verb{w+} supports Create, and \code{u} supports Update is reported if
GDAL >= 3.11)
\item supports virtual I/O e.g. /vsimem/ (logical)
\item supports subdatasets (logical)
\item supported SQL dialects reported if GDAL >= 3.6 (e.g.,
\code{"NATIVE OGRSQL SQLITE"})
\item creation raster data types (e.g., \code{"Byte Int16 UInt16 Float32"} etc.)
\item creation vector field types (e.g.,
\code{"Integer Integer64 Real String Date DateTime Binary"} etc.)
\item creation field sub-types (e.g., \code{"Boolean Int16 Float32 JSON"} etc.)
\item supports multiple vector layers reported if GDAL >= 3.4 (logical)
\item supports reading field domains if GDAL >= 3.5 (logical)
\item creation field domain types if GDAL >= 3.5 (supported values are \code{Coded},
\code{Range} and \code{Glob})
}
}
\description{
\code{gdal_formats()} returns a table of the supported raster and vector
formats, with information about the capabilities of each format driver.
}
\note{
Virtual I/O refers to operations on GDAL Virtual File Systems. See
\url{https://gdal.org/en/stable/user/virtual_file_systems.html#virtual-file-systems}.
}
\examples{
gdal_formats() |> str()

gdal_formats("GPKG")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom.R
\name{g_factory}
\alias{g_factory}
\alias{g_create}
\alias{g_add_geom}
\alias{g_get_geom}
\alias{g_build_collection}
\alias{g_build_polygon_from_edges}
\title{Geometry factory functions}
\usage{
g_create(
  geom_type,
  pts = NULL,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB"
)

g_add_geom(
  sub_geom,
  container,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB"
)

g_get_geom(
  container,
  sub_geom_idx,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB"
)

g_build_collection(
  geoms,
  coll_type = "GEOMETRYCOLLECTION",
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB"
)

g_build_polygon_from_edges(
  lines,
  auto_close = TRUE,
  tolerance = 0,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB"
)
}
\arguments{
\item{geom_type}{Character string (case-insensitive), one of \code{"POINT"},
\code{"MULTIPOINT"}, \code{"LINESTRING"}, \code{"POLYGON"} (see Note) or
\code{"GEOMETRYCOLLECTION"}.}

\item{pts}{Numeric matrix of points (x, y, z, m), or \code{NULL} to create an
empty geometry. The points can be given as (x, y), (x, y, z) or
(x, y, z, m), so the input must have two, three or four columns.
Data frame input will be coerced to numeric matrix. Rings for polygon
geometries should be closed.}

\item{as_wkb}{Logical value, \code{TRUE} to return the output geometry in WKB
format (the default), or \code{FALSE} to return a WKT string.}

\item{as_iso}{Logical value, \code{TRUE} to export as ISO WKB/WKT (ISO 13249
SQL/MM Part 3), or \code{FALSE} (the default) to export as "Extended WKB/WKT".}

\item{byte_order}{Character string specifying the byte order when output is
WKB. One of \code{"LSB"} (the default) or \code{"MSB"} (uncommon).}

\item{sub_geom}{Either a raw vector of WKB or a character string of WKT.}

\item{container}{Either a raw vector of WKB or a character string of WKT for
a container geometry type.}

\item{sub_geom_idx}{An integer value giving the 1-based index of a
sub-geometry (numeric values will be coerced to integer by truncation).}

\item{geoms}{Either a list of WKB raw vectors or character vector of WKT
strings.}

\item{coll_type}{A character string specifying a geometry collection type,
e.g., \code{"GEOMETRYCOLLECTION"} (the default), \code{"MULTIPOINT"},
\code{"MULTILINESTRING"}, \verb{"MULTIPOLYGON".}}

\item{lines}{Either a raw vector of WKB or a character string of WKT
specifying a \code{GeometryCollection} or \code{MultiLineString}, or a list of WKB raw
vectors for \code{LineString}s, or a character vector of WKT strings.}

\item{auto_close}{A logical value, \code{TRUE} (the default) if the polygon should
be closed when first and last points of the ring are the same.}

\item{tolerance}{A numeric value giving the tolerance into which two arcs are
considered close enough to be joined.}
}
\value{
A geometry as WKB raw vector by default, or a WKT string if
\code{as_wkb = FALSE}. In the case of multiple input points for creating \verb{Point`` geometry type, a list of WKB raw vectors or character vector of WKT strings will be returned. }NULL` is returned with a warning if the an error occurs
in the geometry operation.
}
\description{
These functions create WKB/WKT geometries from input vertices or arcs, and
build container geometry types from sub-geometries.
}
\details{
These functions use the GEOS library via GDAL headers.

\code{g_create()} creates a geometry object from the given point(s) and returns
a raw vector of WKB (the default) or a character string of WKT. Currently
supports creating \code{Point}, \code{MultiPoint}, \code{LineString}, and \code{Polygon}
(including \verb{25D}, \code{Z}, \code{M}, \code{ZM} variants).
If multiple input points are given for creating \code{Point}, then multiple
geometries will be returned as a list of WKB raw vectors, or character
vector of WKT strings if \code{as_wkb = FALSE}. Otherwise, a single geometry
is created from the input points. Only an empty \code{GeometryCollection} /
\code{MultiLineString} / \code{MultiPolygon} can be created with this function (for
subsequent use with \code{g_add_geom()}).

\code{g_add_geom()} adds a geometry to a geometry container, e.g.,
\code{Polygon} to \code{Polygon} (to add an interior ring), \code{Point} to \code{MultiPoint},
\code{LineString} to \code{MultiLineString}, \code{Polygon} to \code{MultiPolygon}, or mixed
geometry types to a \code{GeometryCollection}. Returns a new geometry, i.e,
the container geometry is not modified.

\code{g_get_geom()} fetches a geometry from a geometry container (1-based
indexing). For a polygon, requesting the first sub-geometry returns the
exterior ring (\code{sub_geom_idx = 1}), and the interior rings are returned for
\code{sub_geom_idx > 1}.

\code{g_build_collection()} builds a collection / container type geometry, e.g.,
\code{GeometryCollection}, \code{MultiPoint}, \code{MultiLineString}, \code{MultiPolygon}, from
a set of input geometries given as a list of WKB raw vectors or a character
vector of WKT strings.

\code{g_build_polygon_from_edges()} builds a polygon from a set of arcs given
in a \code{GeometryCollection}, \code{MultiLineString}, list of WKB raw vectors, or
character vector of WKT strings.
}
\note{
A \code{POLYGON} can be created for a single ring which will be the
exterior ring. Additional \code{POLYGON}s can be created and added to an
existing \code{POLYGON} with \code{g_add_geom()}. These will become interior rings.
Alternatively, an empty polygon can be created with \code{g_create("POLYGON")},
followed by creation and addition of \code{POLYGON}s as sub-geometries. In that
case, the first added \code{POLYGON} will be the exterior ring. The next ones will
be the interior rings.

Only an empty \code{GeometryCollection} can be created with \code{g_create()}, which
can then be used as a container with \code{g_add_geom()}. If given, input points
will be ignored by \code{g_create()} if \code{geom_type = "GEOMETRYCOLLECTION"}.
}
\examples{
# raw vector of WKB by default
g_create("POINT", c(1, 2))

# as WKT
g_create("POINT", c(1, 2), as_wkb = FALSE)

# or convert in either direction
g_create("POINT", c(1, 2)) |> g_wk2wk()
g_create("POINT", c(1, 2), as_wkb = FALSE) |> g_wk2wk()

# create MultiPoint from a matrix of xyz points
x <- c(9, 1)
y <- c(1, 9)
z <- c(0, 10)
pts <- cbind(x, y, z)
mp <- g_create("MULTIPOINT", pts)
g_wk2wk(mp)
g_wk2wk(mp, as_iso = TRUE)

# create an empty container and add sub-geometries
mp2 <- g_create("MULTIPOINT")
mp2 <- g_create("POINT", c(11, 2)) |> g_add_geom(mp2)
mp2 <- g_create("POINT", c(12, 3)) |> g_add_geom(mp2)
g_wk2wk(mp2)

# or build a container/collection type geometry from WKB list or WKT vector
lines <- c("LINESTRING (0 0,3 0)",
           "LINESTRING (3 0,3 4)",
           "LINESTRING (3 4,0 0)")
(multi_line <- g_build_collection(lines, "MULTILINESTRING", as_wkb = FALSE))

# get sub-geometry from container
g_get_geom(multi_line, 2, as_wkb = FALSE)

# build a polygon from a set of arcs
(poly <- g_build_polygon_from_edges(lines, as_wkb = FALSE))

# plot a vector of WKT strings or list of WKB raw vectors
plot_geom(poly)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_sync}
\alias{vsi_sync}
\title{Synchronize a source file/directory with a target file/directory}
\usage{
vsi_sync(src, target, show_progress = FALSE, options = NULL)
}
\arguments{
\item{src}{Character string. Source file or directory.}

\item{target}{Character string. Target file or directory.}

\item{show_progress}{Logical scalar. If \code{TRUE}, a progress bar will be
displayed. Defaults to \code{FALSE}.}

\item{options}{Character vector of \code{NAME=VALUE} pairs (see Details).}
}
\value{
Logical scalar, \code{TRUE} on success or \code{FALSE} on an error.
}
\description{
\code{vsi_sync()} is a wrapper for \code{VSISync()} in the GDAL Common Portability
Library. The GDAL documentation is given in Details.
}
\details{
\code{VSISync()} is an analog of the Linux \code{rsync} utility. In the current
implementation, \code{rsync} would be more efficient for local file copying,
but \code{VSISync()} main interest is when the source or target is a remote
file system like /vsis3/ or /vsigs/, in which case it can take into account
the timestamps of the files (or optionally the ETag/MD5Sum) to avoid
unneeded copy operations.
This is only implemented efficiently for:
\itemize{
\item local filesystem <--> remote filesystem
\item remote filesystem <--> remote filesystem (starting with GDAL 3.1)\cr
Where the source and target remote filesystems are the same and one of
/vsis3/, /vsigs/ or /vsiaz/. Or when the target is /vsiaz/ and the source
is /vsis3/, /vsigs/, /vsiadls/ or /vsicurl/ (starting with GDAL 3.8)
}

Similarly to \code{rsync} behavior, if the source filename ends with a slash, it
means that the content of the directory must be copied, but not the
directory name. For example, assuming "/home/even/foo" contains a file
"bar", \code{VSISync("/home/even/foo/", "/mnt/media", ...)} will create a
"/mnt/media/bar" file.
Whereas \code{VSISync("/home/even/foo", "/mnt/media", ...)} will create a
"/mnt/media/foo" directory which contains a bar file.

The \code{options} argument accepts a character vector of name=value pairs.
Currently accepted options are:\cr
\itemize{
\item \code{RECURSIVE=NO} (the default is \code{YES})
\item \code{SYNC_STRATEGY=TIMESTAMP/ETAG/OVERWRITE}. Determines which criterion is
used to determine if a target file must be replaced when it already exists
and has the same file size as the source. Only applies for a source or
target being a network filesystem.
The default is \code{TIMESTAMP} (similarly to how 'aws s3 sync' works), that is
to say that for an upload operation, a remote file is replaced if it has a
different size or if it is older than the source. For a download operation,
a local file is replaced if it has a different size or if it is newer than
the remote file.
The \code{ETAG} strategy assumes that the ETag metadata of the remote file is
the MD5Sum of the file content, which is only true in the case of /vsis3/
for files not using KMS server side encryption and uploaded in a single PUT
operation (so smaller than 50 MB given the default used by GDAL). Only to
be used for /vsis3/, /vsigs/ or other filesystems using a MD5Sum as ETAG.
The \code{OVERWRITE} strategy (GDAL >= 3.2) will always overwrite the target
file with the source one.\cr
\item \code{NUM_THREADS=integer}. Number of threads to use for parallel file
copying. Only use for when /vsis3/, /vsigs/, /vsiaz/ or /vsiadls/ is
in source or target. The default is 10 since GDAL 3.3.\cr
\item \code{CHUNK_SIZE=integer}. Maximum size of chunk (in bytes) to use to split
large objects when downloading them from /vsis3/, /vsigs/, /vsiaz/
or /vsiadls/ to local file system, or for upload to /vsis3/, /vsiaz/ or
/vsiadls/ from local file system. Only used if \code{NUM_THREADS > 1}.
For upload to /vsis3/, this chunk size must be set at least to 5 MB. The
default is 8 MB since GDAL 3.3.\cr
\item \code{x-amz-KEY=value}. (GDAL >= 3.5) MIME header to pass during creation of a
/vsis3/ object.\cr
\item \code{x-goog-KEY=value}. (GDAL >= 3.5) MIME header to pass during creation of a
/vsigs/ object.\cr
\item \code{x-ms-KEY=value}. (GDAL >= 3.5) MIME header to pass during creation of a
/vsiaz/ or /vsiadls/ object.
}
}
\examples{
\dontrun{
# sample-data is a directory in the git repository for gdalraster that is
# not included in the R package:
# https://github.com/firelab/gdalraster/tree/main/sample-data
# A copy of sample-data in an AWS S3 bucket, and a partial copy in an
# Azure Blob container, were used to generate the example below.

src <- "/vsis3/gdalraster-sample-data/"
# s3://gdalraster-sample-data is not public, set credentials
set_config_option("AWS_ACCESS_KEY_ID", "xxxxxxxxxxxxxx")
set_config_option("AWS_SECRET_ACCESS_KEY", "xxxxxxxxxxxxxxxxxxxxxxxxxxxxx")
vsi_read_dir(src)
#> [1] "README.md"
#> [2] "bl_mrbl_ng_jul2004_rgb_720x360.tif"
#> [3] "blue_marble_ng_neo_metadata.xml"
#> [4] "landsat_c2ard_sr_mt_hood_jul2022_utm.json"
#> [5] "landsat_c2ard_sr_mt_hood_jul2022_utm.tif"
#> [6] "lf_elev_220_metadata.html"
#> [7] "lf_elev_220_mt_hood_utm.tif"
#> [8] "lf_fbfm40_220_metadata.html"
#> [9] "lf_fbfm40_220_mt_hood_utm.tif"

dst <- "/vsiaz/sampledata"
set_config_option("AZURE_STORAGE_CONNECTION_STRING",
                  "<connection_string_for_gdalraster_account>")
vsi_read_dir(dst)
#> [1] "lf_elev_220_metadata.html"   "lf_elev_220_mt_hood_utm.tif"

# GDAL VSISync() supports direct copy for /vsis3/ -> /vsiaz/ (GDAL >= 3.8)
result <- vsi_sync(src, dst, show_progress = TRUE)
#> 0...10...20...30...40...50...60...70...80...90...100 - done.
print(result)
#> [1] TRUE
vsi_read_dir(dst)
#> [1] "README.md"
#> [2] "bl_mrbl_ng_jul2004_rgb_720x360.tif"
#> [3] "blue_marble_ng_neo_metadata.xml"
#> [4] "landsat_c2ard_sr_mt_hood_jul2022_utm.json"
#> [5] "landsat_c2ard_sr_mt_hood_jul2022_utm.tif"
#> [6] "lf_elev_220_metadata.html"
#> [7] "lf_elev_220_mt_hood_utm.tif"
#> [8] "lf_fbfm40_220_metadata.html"
#> [9] "lf_fbfm40_220_mt_hood_utm.tif"
}
}
\seealso{
\code{\link[=copyDatasetFiles]{copyDatasetFiles()}}, \code{\link[=vsi_copy_file]{vsi_copy_file()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom.R
\name{g_coords}
\alias{g_coords}
\title{Extract coordinate values from geometries}
\usage{
g_coords(geom)
}
\arguments{
\item{geom}{Either a raw vector of WKB or list of raw vectors, or a
character vector containing one or more WKT strings.}
}
\value{
A data frame as returned by \code{wk::wk_coords()}: columns \code{feature_id}
(the index of the feature from the input), \code{part_id} (an arbitrary integer
identifying the point, line, or polygon from whence it came), \code{ring_id} (an
arbitrary integer identifying individual rings within polygons), and one
column per coordinate (\code{x}, \code{y}, and/or \code{z} and/or \code{m}).
}
\description{
\code{g_coords()} extracts coordinate values (vertices) from the input geometries
and returns a data frame with coordinates as columns.
}
\examples{
dsn <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")
lyr <- new(GDALVector, dsn)
d <- lyr$fetch(10)

vertices <- g_coords(d$geom)
head(vertices)

lyr$close()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdalraster_proc.R
\name{combine}
\alias{combine}
\title{Raster overlay for unique combinations}
\usage{
combine(
  rasterfiles,
  var.names = NULL,
  bands = NULL,
  dstfile = NULL,
  fmt = NULL,
  dtName = "UInt32",
  options = NULL,
  quiet = FALSE
)
}
\arguments{
\item{rasterfiles}{Character vector of raster filenames to combine.}

\item{var.names}{Character vector of \code{length(rasterfiles)} containing
variable names for each raster layer. Defaults will be assigned if
\code{var.names} are omitted.}

\item{bands}{Numeric vector of \code{length(rasterfiles)} containing the band
number to use for each raster in \code{rasterfiles}. Band 1 will be used for
each input raster if \code{bands} are not specified.}

\item{dstfile}{Character. Optional output raster filename for writing the
per-pixel combination IDs. The output raster will be created (and
overwritten if it already exists).}

\item{fmt}{Character. Output raster format name (e.g., "GTiff" or "HFA").}

\item{dtName}{Character. Output raster data type name. Combination IDs are
sequential integers starting at 1. The data type for the output raster
should be large enough to accommodate the potential number of unique
combinations of the input values
(e.g., "UInt16" or the default "UInt32").}

\item{options}{Optional list of format-specific creation options in a
vector of "NAME=VALUE" pairs
(e.g., \code{options = c("COMPRESS=LZW")} to set LZW compression
during creation of a GTiff file).}

\item{quiet}{Logical scalar. If \code{TRUE}, progress bar and messages will be
suppressed. Defaults to \code{FALSE}.}
}
\value{
A data frame with column \code{cmbid} containing the combination IDs,
column \code{count} containing the pixel counts for each combination,
and \code{length(rasterfiles)} columns named \code{var.names} containing the integer
values comprising each unique combination.
}
\description{
\code{combine()} overlays multiple rasters so that a unique ID is assigned to
each unique combination of input values. The input raster layers
typically have integer data types (floating point will be coerced to
integer by truncation), and must have the same projection, extent and cell
size. Pixel counts for each unique combination are obtained, and
combination IDs are optionally written to an output raster.
}
\details{
To specify input raster layers that are bands of a multi-band
raster file, repeat the filename in \code{rasterfiles} and provide the
corresponding band numbers in \code{bands}. For example:
\preformatted{
rasterfiles <- c("multi-band.tif", "multi-band.tif", "other.tif")
bands <- c(4, 5, 1)
var.names <- c("multi_b4", "multi_b5", "other")
}

\code{\link[=rasterToVRT]{rasterToVRT()}} provides options for virtual clipping, resampling and pixel
alignment, which may be helpful here if the input rasters are not already
aligned on a common extent and cell size.

If an output raster of combination IDs is written, the user should verify
that the number of combinations obtained did not exceed the range of the
output data type. Combination IDs are sequential integers starting at 1.
Typical output data types are the unsigned types:
Byte (\code{0} to \code{255}), UInt16 (\code{0} to \code{65535}) and UInt32 (the default, \code{0} to
\code{4294967295}).
}
\examples{
evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
evc_file <- system.file("extdata/storml_evc.tif", package="gdalraster")
evh_file <- system.file("extdata/storml_evh.tif", package="gdalraster")
rasterfiles <- c(evt_file, evc_file, evh_file)
var.names <- c("veg_type", "veg_cov", "veg_ht")
tbl <- combine(rasterfiles, var.names)
nrow(tbl)
tbl <- tbl[order(-tbl$count),]
head(tbl, n = 20)

# combine two bands from a multi-band file and write the combination IDs
# to an output raster
lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
rasterfiles <- c(lcp_file, lcp_file)
bands <- c(4, 5)
var.names <- c("fbfm", "tree_cov")
cmb_file <- file.path(tempdir(), "fbfm_cov_cmbid.tif")
opt <- c("COMPRESS=LZW")
tbl <- combine(rasterfiles, var.names, bands, cmb_file, options = opt)
head(tbl)
ds <- new(GDALRaster, cmb_file)
ds$info()
ds$close()
\dontshow{deleteDataset(cmb_file)}
}
\seealso{
\code{\link[=CmbTable]{CmbTable-class}}, \code{\link[=GDALRaster]{GDALRaster-class}}, \code{\link[=calc]{calc()}},
\code{\link[=rasterToVRT]{rasterToVRT()}}

\code{\link[=buildRAT]{buildRAT()}} to compute a table of the unique pixel values and their counts
for a single raster layer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_stat}
\alias{vsi_stat}
\alias{vsi_stat_exists}
\alias{vsi_stat_type}
\alias{vsi_stat_size}
\title{Get filesystem object info}
\usage{
vsi_stat(filename, info = "exists")

vsi_stat_exists(filenames)

vsi_stat_type(filenames)

vsi_stat_size(filenames)
}
\arguments{
\item{filename}{Character string. The path of the filesystem object to be
queried.}

\item{info}{Character string. The type of information to fetch, one of
\code{"exists"} (the default), \code{"type"} or \code{"size"}.}

\item{filenames}{Character vector of filesystem objects to query.}
}
\value{
If \code{info = "exists"}, \code{vsi_stat()} returns logical \code{TRUE} if the file system
object exists, otherwise \code{FALSE}. If \code{info = "type"}, returns a character
string with one of \code{"file"} (regular file), \code{"dir"} (directory),
\code{"symlink"} (symbolic link), or empty string (\code{""}). If \code{info = "size"},
returns the file size in bytes (as \code{bit64::integer64} type), or \code{-1} if an
error occurs.
\code{vsi_stat_exists()} returns a logical vector. \code{vsi_stat_type()} returns a
character vector. \code{vsi_stat_size()} returns a numeric vector carrying the
\code{bit64::integer64} class attribute.
}
\description{
These functions work on GDAL virtual file systems such as in-memory
(/vsimem/), URLs (/vsicurl/), cloud storage services (e.g., /vsis3/,
/vsigs/, /vsiaz/, etc.), compressed archives (e.g., /vsizip, /vsitar/,
/vsi7z/, /vsigzip/, etc.), and others including "standard" file systems.
See \url{https://gdal.org/en/stable/user/virtual_file_systems.html}.
}
\details{
\code{vsi_stat()} fetches status information about a single filesystem object
(file, directory, etc). It is a wrapper for \code{VSIStatExL()} in the GDAL
Common Portability Library. Analog of the POSIX \code{stat()} function.

\code{vsi_stat_exists()}, \code{vsi_stat_type()} and \code{vsi_stat_size()} are
specializations operating on a vector of potentially multiple file system
object names, returning, respectfully, a logical vector, a character vector,
and a numeric vector carrying the \code{bit64::integer64} class attribute.
}
\note{
For portability, \code{vsi_stat()} supports a subset of \code{stat()}-type
information for filesystem objects. This function is primarily intended
for use with GDAL virtual file systems (e.g., URLs, cloud storage systems,
ZIP/GZip/7z/RAR archives, in-memory files), but can also be used on
"standard" file systems (e.g., in the / hierarchy on Unix-like systems or
in C:, D:, etc. drives on Windows).
}
\examples{
data_dir <- system.file("extdata", package="gdalraster")
vsi_stat(data_dir)
vsi_stat(data_dir, "type")
# stat() on a directory doesn't return the sum of the file sizes in it,
# but rather how much space is used by the directory entry
vsi_stat(data_dir, "size")

elev_file <- file.path(data_dir, "storml_elev.tif")
vsi_stat(elev_file)
vsi_stat(elev_file, "type")
vsi_stat(elev_file, "size")

nonexistent <- file.path(data_dir, "nonexistent.tif")
vsi_stat(nonexistent)
vsi_stat(nonexistent, "type")
vsi_stat(nonexistent, "size")

fs_objects <- c(data_dir, elev_file, nonexistent)
vsi_stat_exists(fs_objects)
vsi_stat_type(fs_objects)
vsi_stat_size(fs_objects)

# /vsicurl/ file system handler
base_url <- "https://raw.githubusercontent.com/firelab/"
f <- "gdalraster/main/sample-data/landsat_c2ard_sr_mt_hood_jul2022_utm.tif"
url_file <- paste0("/vsicurl/", base_url, f)

# try to be CRAN-compliant for the example:
set_config_option("GDAL_HTTP_CONNECTTIMEOUT", "10")
set_config_option("GDAL_HTTP_TIMEOUT", "10")

vsi_stat(url_file)
vsi_stat(url_file, "type")
vsi_stat(url_file, "size")
}
\seealso{
GDAL Virtual File Systems:\cr
\url{https://gdal.org/en/stable/user/virtual_file_systems.html}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{set_cache_max}
\alias{set_cache_max}
\title{Set the maximum memory size for the GDAL block cache}
\usage{
set_cache_max(nbytes)
}
\arguments{
\item{nbytes}{A numeric value optionally carrying the \code{integer64} class
attribute (assumed to be a whole number, will be coerced to integer by
truncation). Specifies the new cache size in bytes (maximum number of bytes
for caching).}
}
\value{
No return value, called for side effects.
}
\description{
\code{set_cache_max()} sets the maximum amount of memory that GDAL is permitted
to use for GDALRasterBlock caching.
\emph{The unit of the value to set is bytes.} Wrapper of \code{GDALSetCacheMax64()}.
}
\note{
\strong{This function will not make any attempt to check the consistency of the
passed value with the effective capabilities of the OS.}

It is recommended to consult the documentation for \code{get_cache_max()} and
\code{get_cache_used()} before using this function.

\code{\link[=get_cache_max]{get_cache_max()}}, \code{\link[=get_cache_used]{get_cache_used()}}
}
\examples{
(cachemax <- get_cache_max("bytes"))

set_cache_max(1e8)
get_cache_max()  # returns in MB by default

# reset to original
set_cache_max(cachemax)
get_cache_max()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transform.R
\name{inv_project}
\alias{inv_project}
\title{Inverse project geospatial x/y coordinates to longitude/latitude}
\usage{
inv_project(pts, srs, well_known_gcs = NULL)
}
\arguments{
\item{pts}{A data frame or numeric matrix containing geospatial point
coordinates, or point geometries as a list of WKB raw vectors or character
vector of WKT strings. If data frame or matrix, the number of columns must
be either two (x, y), three (x, y, z) or four (x, y, z, t).
May be also be given as a numeric vector for one point (xy, xyz, or xyzt).}

\item{srs}{Character string specifying the projected spatial reference
system for \code{pts}. May be in WKT format or any of the formats supported by
\code{\link[=srs_to_wkt]{srs_to_wkt()}}.}

\item{well_known_gcs}{Optional character string containing a supported
well known name of a geographic coordinate system (see Details for
supported values).}
}
\value{
Numeric matrix of longitude, latitude (potentially also with z,
or z and t columns).
}
\description{
\code{inv_project()} transforms geospatial x/y coordinates to
longitude/latitude in the same geographic coordinate system used by the
given projected spatial reference system. The output long/lat can
optionally be set to a specific geographic coordinate system by specifying
a well known name (see Details).
}
\details{
By default, the geographic coordinate system of the projection specified
by \code{srs} will be used. If a specific geographic coordinate system is
desired, then \code{well_known_gcs} can be set to one of the values below:
\tabular{rl}{
EPSG:n \tab where n is the code of a geographic coordinate system\cr
WGS84  \tab same as EPSG:4326\cr
WGS72  \tab same as EPSG:4322\cr
NAD83  \tab same as EPSG:4269\cr
NAD27  \tab same as EPSG:4267\cr
CRS84  \tab same as WGS84\cr
CRS72  \tab same as WGS72\cr
CRS27  \tab same as NAD27
}
The coordinates returned by \code{inv_project()}will always be in longitude,
latitude order (traditional GIS order) regardless of the axis order defined
for the GCS names above.
}
\note{
Input points that contain missing values (\code{NA}) will be assigned \code{NA} in
the output and a warning emitted. Input points that fail to transform
with the GDAL API call will also be assigned \code{NA} in the output with a
specific warning indicating that case.
}
\examples{
pt_file <- system.file("extdata/storml_pts.csv", package="gdalraster")
# id, x, y in NAD83 / UTM zone 12N
pts <- read.csv(pt_file)
print(pts)
inv_project(pts[,-1], "EPSG:26912")
}
\seealso{
\code{\link[=transform_xy]{transform_xy()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/proj.R
\name{proj_networking}
\alias{proj_networking}
\title{Check, enable or disable PROJ networking capabilities}
\usage{
proj_networking(enabled = NULL)
}
\arguments{
\item{enabled}{Optional logical scalar. Set to \code{TRUE} to enable networking
capabilities or \code{FALSE} to disable.}
}
\value{
Logical \code{TRUE} if PROJ networking capabilities are enabled (as
indicated by the return value of \code{OSRGetPROJEnableNetwork()} in the GDAL
Spatial Reference System C API). Logical \code{NA} is returned if GDAL < 3.4.
}
\description{
\code{proj_networking()} returns the status of PROJ networking capabilities,
optionally enabling or disabling first. Requires GDAL 3.4 or later and
PROJ 7 or later.
}
\examples{
proj_networking()
}
\seealso{
\code{\link[=proj_version]{proj_version()}}, \code{\link[=proj_search_paths]{proj_search_paths()}}

\href{https://github.com/OSGeo/PROJ-data}{PROJ-data on GitHub},
\href{https://cdn.proj.org/}{PROJ Content Delivery Network}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_rename}
\alias{vsi_rename}
\title{Rename a file}
\usage{
vsi_rename(oldpath, newpath)
}
\arguments{
\item{oldpath}{Character string. The name of the file to be renamed.}

\item{newpath}{Character string. The name the file should be given.}
}
\value{
\code{0} on success or \code{-1} on an error.
}
\description{
\code{vsi_rename()} renames a file object in the file system. The GDAL
documentation states it should be possible to rename a file onto a new
filesystem, but it is safest if this function is only used to rename files
that remain in the same directory.
This function goes through the GDAL \code{VSIFileHandler} virtualization and may
work on unusual filesystems such as in memory.
It is a wrapper for \code{VSIRename()} in the GDAL Common Portability Library.
Analog of the POSIX \code{rename()} function.
}
\examples{
# regular file system for illustration
elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
tmp_file <- tempfile(fileext = ".tif")
file.copy(elev_file, tmp_file)
new_file <- file.path(dirname(tmp_file), "storml_elev_copy.tif")
vsi_rename(tmp_file, new_file)
vsi_stat(new_file)
vsi_unlink(new_file)
}
\seealso{
\code{\link[=renameDataset]{renameDataset()}}, \code{\link[=vsi_copy_file]{vsi_copy_file()}}
}

\docType{package}
\name{gdalraster-package}
\alias{gdalraster}
\alias{gdalraster-package}
\title{Bindings to the GDAL API
}
\description{
  \pkg{gdalraster} is an interface to the Geospatial Data Abstraction
  Library (GDAL) providing an R implementation of the GDAL Raster and Vector
  Data Models. Bindings also include the GDAL Geometry API, Spatial Reference
  Systems API, utilities and algorithms, methods for coordinate transformation,
  and the Virtual Systems Interface (VSI) API. Calling signatures resemble those
  of the native C, C++ and Python APIs provided by the GDAL project.
  See \url{https://gdal.org/en/stable/api/} for details of the GDAL API.
}
\details{
  Experimental bindings to the modernized \code{gdal} Command Line Interface
  (CLI) are implemented in \code{\link{GDALAlg-class}} and related convenience
  functions: \code{\link[=gdal_commands]{gdal_commands()}},
  \code{\link[=gdal_usage]{gdal_usage()}}, \code{\link[=gdal_run]{gdal_run()}},
  \code{\link[=gdal_alg]{gdal_alg()}} (\emph{Requires GDAL >= 3.11.3})

  Core raster functionality is contained in class \code{GDALRaster} and several
  related stand-alone functions:
  \itemize{
  \item \code{\link{GDALRaster-class}} is an exposed C++ class that allows
  opening a raster dataset and calling methods on the \code{GDALDataset},
  \code{GDALDriver} and \code{GDALRasterBand} objects in the underlying API
  (e.g., get/set parameters, read/write pixel data).

  \item raster creation: \code{\link[=create]{create()}},
  \code{\link[=createCopy]{createCopy()}},
  \code{\link[=rasterFromRaster]{rasterFromRaster()}},
  \code{\link[=getCreationOptions]{getCreationOptions()}},
  \code{\link[=validateCreationOptions]{validateCreationOptions()}},
  \code{\link[=rvector_to_MEM]{rvector_to_MEM()}}

  \item virtual raster:
  \code{\link[=autoCreateWarpedVRT]{autoCreateWarpedVRT()}},
  \code{\link[=buildVRT]{buildVRT()}},
  \code{\link[=rasterToVRT]{rasterToVRT()}}

  \item algorithms/utilities: \code{\link[=dem_proc]{dem_proc()}},
  \code{\link[=dem_derivatives]{dem_derivatives}},
  \code{\link[=fillNodata]{fillNodata()}},
  \code{\link[=footprint]{footprint()}},
  \code{\link[=is_los_visible]{is_los_visible()}},
  \code{\link[=make_chunk_index]{make_chunk_index()}},
  \code{\link[=polygonize]{polygonize()}},
  \code{\link[=rasterize]{rasterize()}},
  \code{\link[=sieveFilter]{sieveFilter()}},
  \code{\link[=translate]{translate()}},
  \code{\link[=warp]{warp()}},
  \code{\link[=GDALRaster]{GDALRaster$getChecksum()}}

  \item raster attribute tables: \code{\link[=buildRAT]{buildRAT()}},
  \code{\link[=displayRAT]{displayRAT()}},
  \code{\link[=GDALRaster]{GDALRaster$getDefaultRAT()}},
  \code{\link[=GDALRaster]{GDALRaster$setDefaultRAT()}}

  \item multidimensional raster:
  \code{\link[=mdim_as_classic]{mdim_as_classic()}},
  \code{\link[=mdim_info]{mdim_info()}},
  \code{\link[=mdim_translate]{mdim_translate()}}

  \item geotransform conversion:
  \code{\link[=apply_geotransform]{apply_geotransform()}},
  \code{\link[=get_pixel_line]{get_pixel_line()}},
  \code{\link[=inv_geotransform]{inv_geotransform()}},
  \code{\link[=pixel_extract]{pixel_extract()}}

  \item data type convenience functions:
  \code{\link[=dt_size]{dt_size()}},
  \code{\link[=dt_is_complex]{dt_is_complex()}},
  \code{\link[=dt_is_integer]{dt_is_integer()}},
  \code{\link[=dt_is_floating]{dt_is_floating()}},
  \code{\link[=dt_is_signed]{dt_is_signed()}},
  \code{\link[=dt_union]{dt_union()}},
  \code{\link[=dt_union_with_value]{dt_union_with_value()}},
  \code{\link[=dt_find]{dt_find()}},
  \code{\link[=dt_find_for_value]{dt_find_for_value()}}
  }

  Core vector functionality is contained in class \code{GDALVector} and several
  related stand-alone functions:
  \itemize{
  \item \code{\link{GDALVector-class}} is an exposed C++ class that allows
  opening a vector dataset and calling methods on a specified \code{OGRLayer}
  object that it contains (e.g., obtain layer information, set attribute and/or
  spatial filters, read/write feature data).

  \item OGR vector utilities:
  \code{\link[=ogrinfo]{ogrinfo()}},
  \code{\link[=ogr2ogr]{ogr2ogr()}},
  \code{\link[=ogr_reproject]{ogr_reproject()}},
  \code{\link[=ogr_define]{ogr_define}},
  \code{\link[=ogr_manage]{ogr_manage}},
  \code{\link[=ogr_proc]{ogr_proc()}}
  }

  Bindings to the GDAL Geometry API, Spatial Reference Systems API, methods for
  coordinate transformation, the Virtual Systems Interface (VSI) API, general
  data management and system configuration are implemented in several
  stand-alone functions:
  \itemize{
  \item Geometry API:
  \code{\link[=bbox_from_wkt]{bbox_from_wkt()}},
  \code{\link[=bbox_to_wkt]{bbox_to_wkt()}},
  \code{\link[=bbox_intersect]{bbox_intersect()}},
  \code{\link[=bbox_union]{bbox_union()}},
  \code{\link[=bbox_transform]{bbox_transform()}},
  \code{\link[=g_factory]{g_factory}},
  \code{\link[=g_wk2wk]{g_wk2wk()}},
  \code{\link[=g_query]{g_query}},
  \code{\link[=g_util]{g_util}},
  \code{\link[=g_binary_pred]{g_binary_pred}},
  \code{\link[=g_binary_op]{g_binary_op}},
  \code{\link[=g_unary_op]{g_unary_op}},
  \code{\link[=g_measures]{g_measures}},
  \code{\link[=g_coords]{g_coords()}},
  \code{\link[=g_envelope]{g_envelope()}},
  \code{\link[=g_transform]{g_transform()}},
  \code{\link[=geos_version]{geos_version()}},
  \code{\link[=plot_geom]{plot_geom()}}

  \item Spatial Reference Systems API:
  \code{\link[=srs_convert]{srs_convert}},
  \code{\link[=srs_info_from_db]{srs_info_from_db()}},
  \code{\link[=srs_query]{srs_query}}

  \item coordinate transformation:
  \code{\link[=transform_xy]{transform_xy()}},
  \code{\link[=inv_project]{inv_project()}},
  \code{\link[=transform_bounds]{transform_bounds()}}

  \item data management: \code{\link[=addFilesInZip]{addFilesInZip()}},
  \code{\link[=copyDatasetFiles]{copyDatasetFiles()}},
  \code{\link[=deleteDataset]{deleteDataset()}},
  \code{\link[=renameDataset]{renameDataset()}},
  \code{\link[=bandCopyWholeRaster]{bandCopyWholeRaster()}},
  \code{\link[=identifyDriver]{identifyDriver()}},
  \code{\link[=inspectDataset]{inspectDataset()}}

  \item Virtual Systems Interface API:
  \code{\link{VSIFile-class}},
  \code{\link[=vsi_clear_path_options]{vsi_clear_path_options()}},
  \code{\link[=vsi_copy_file]{vsi_copy_file()}},
  \code{\link[=vsi_curl_clear_cache]{vsi_curl_clear_cache()}},
  \code{\link[=vsi_get_disk_free_space]{vsi_get_disk_free_space()}},
  \code{\link[=vsi_get_file_metadata]{vsi_get_file_metadata()}},
  \code{\link[=vsi_get_fs_options]{vsi_get_fs_options()}},
  \code{\link[=vsi_get_fs_prefixes]{vsi_get_fs_prefixes()}},
  \code{\link[=vsi_glob]{vsi_glob()}},
  \code{\link[=vsi_is_local]{vsi_is_local()}},
  \code{\link[=vsi_mkdir]{vsi_mkdir()}},
  \code{\link[=vsi_read_dir]{vsi_read_dir()}},
  \code{\link[=vsi_rename]{vsi_rename()}},
  \code{\link[=vsi_rmdir]{vsi_rmdir()}},
  \code{\link[=vsi_set_path_option]{vsi_set_path_option()}},
  \code{\link[=vsi_stat]{vsi_stat()}},
  \code{\link[=vsi_supports_rnd_write]{vsi_supports_rnd_write()}},
  \code{\link[=vsi_supports_seq_write]{vsi_supports_seq_write()}},
  \code{\link[=vsi_sync]{vsi_sync()}},
  \code{\link[=vsi_unlink]{vsi_unlink()}},
  \code{\link[=vsi_unlink_batch]{vsi_unlink_batch()}},
  \code{\link[=vsi_uri_to_vsi_path]{vsi_uri_to_vsi_path()}}

  \item GDAL configuration:
  \code{\link[=gdal_version]{gdal_version}},
  \code{\link[=gdal_compute_version]{gdal_compute_version()}},
  \code{\link[=lib_versions]{lib_versions()}},
  \code{\link[=gdal_formats]{gdal_formats()}},
  \code{\link[=gdal_get_driver_md]{gdal_get_driver_md()}},
  \code{\link[=get_cache_used]{get_cache_used()}},
  \code{\link[=get_cache_max]{get_cache_max()}},
  \code{\link[=set_cache_max]{set_cache_max()}},
  \code{\link[=get_config_option]{get_config_option()}},
  \code{\link[=set_config_option]{set_config_option()}},
  \code{\link[=get_num_cpus]{get_num_cpus()}},
  \code{\link[=get_usable_physical_ram]{get_usable_physical_ram()}},
  \code{\link[=has_spatialite]{has_spatialite()}},
  \code{\link[=http_enabled]{http_enabled()}},
  \code{\link[=push_error_handler]{push_error_handler()}},
  \code{\link[=pop_error_handler]{pop_error_handler()}},
  \code{\link[=dump_open_datasets]{dump_open_datasets()}}

  \item PROJ configuration:
  \code{\link[=proj_version]{proj_version()}},
  \code{\link[=proj_search_paths]{proj_search_paths()}},
  \code{\link[=proj_networking]{proj_networking()}}
  }

  Additional functionality includes:
  \itemize{
  \item \code{\link{RunningStats-class}} calculates mean and variance in one
  pass. The min, max, sum, and count are also tracked (efficient summary
  statistics on data streams).

  \item \code{\link{CmbTable-class}} implements a hash table for counting
  unique combinations of integer values.

  \item \code{\link[=combine]{combine()}} overlays multiple rasters so that a
  unique ID is assigned to each unique combination of input values. Pixel
  counts for each unique combination are obtained, and combination IDs are
  optionally written to an output raster.

  \item \code{\link[=calc]{calc()}} evaluates an R expression for each pixel in
  a raster layer or stack of layers. Individual pixel coordinates are available
  as variables in the R expression, as either x/y in the raster projected
  coordinate system or inverse projected longitude/latitude.

  \item \code{\link[=plot_raster]{plot_raster()}} displays raster data using
  base R \code{graphics}. Supports single-band grayscale, RGB, color tables and
  color map functions (e.g., color ramp).
  }
}
\author{
  GDAL is by: Frank Warmerdam, Even Rouault and others\cr
  (see \url{https://github.com/OSGeo/gdal/graphs/contributors})

  Package author and maintainer: Chris Toney <jctoney at gmail.com>

  Package author: Michael D. Sumner
}
\seealso{
  GDAL Raster Data Model:\cr
  \url{https://gdal.org/en/stable/user/raster_data_model.html}

  Raster driver descriptions:\cr
  \url{https://gdal.org/en/stable/drivers/raster/index.html}

  Geotransform tutorial:\cr
  \url{https://gdal.org/en/stable/tutorials/geotransforms_tut.html}

  GDAL Vector Data Model:\cr
  \url{https://gdal.org/en/stable/user/vector_data_model.html}

  Vector driver descriptions:\cr
  \url{https://gdal.org/en/stable/drivers/vector/index.html}

  GDAL Virtual File Systems:\cr
  \url{https://gdal.org/en/stable/user/virtual_file_systems.html}
}
\note{
  Documentation for the API bindings borrows heavily from the GDAL
  documentation, (c) 1998-2025, Frank Warmerdam, Even Rouault, and others,
  \href{https://gdal.org/en/stable/license.html}{MIT license}.

  Sample datasets included with the package are used in examples throughout
  the documentation. The sample data sources include:
  \itemize{
  \item \href{https://landfire.gov/}{LANDFIRE} raster layers describing terrain,
  vegetation and wildland fuels (LF 2020 version)

  \item Landsat C2 Analysis Ready Data from
  \href{https://earthexplorer.usgs.gov/}{USGS Earth Explorer}

  \item Monitoring Trends in Burn Severity (\href{https://www.mtbs.gov/}{MTBS})
  fire perimeters from 1984-2022

  \item
  \href{https://data.fs.usda.gov/geodata/rastergateway/treecanopycover/}{NLCD Tree Canopy Cover}
  produced by USDA Forest Service

  \item
  \href{https://public-nps.opendata.arcgis.com/}{National Park Service Open Data}
  vector layers for roads and points-of-interest

  \item \href{https://msl.mt.gov/geoinfo/}{Montana State Library} boundary layer
  for Yellowstone National Park
  }

  Metadata for these sample datasets are in inst/extdata/metadata.zip and
  inst/extdata/ynp_features.zip.

  \code{system.file()} is used in the examples to access the sample datasets.
  This enables the code to run regardless of where R is installed. Users will
  normally give file names as a regular full path or relative to the current
  working directory.

  Temporary files are created in some examples which have cleanup code wrapped
  in \code{dontshow}. While the cleanup code is not shown in the
  documentation, note that this code runs by default if examples are run with
  \code{example()}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{mdim_translate}
\alias{mdim_translate}
\title{Convert multidimensional data between different formats, and subset}
\usage{
mdim_translate(
  src_dsn,
  dst_dsn,
  output_format = "",
  creation_options = NULL,
  array_specs = NULL,
  group_specs = NULL,
  subset_specs = NULL,
  scaleaxes_specs = NULL,
  allowed_drivers = NULL,
  open_options = NULL,
  strict = FALSE,
  quiet = FALSE
)
}
\arguments{
\item{src_dsn}{Character string giving the name of the source
multidimensional raster dataset (e.g., file, VSI path).}

\item{dst_dsn}{Character string giving the name of the destination
multidimensional raster dataset (e.g., file, VSI path).}

\item{output_format}{Character string giving the output format (driver short
name). This can be a format that supports multidimensional output (such as
NetCDF: Network Common Data Form, Multidimensional VRT), or a "classic" 2D
format, if only one single 2D array results from the other specified
conversion operations. When this option is not specified (i.e., empty string
\code{""}), the format is guessed when possible from the extension of \code{dst_dsn}.}

\item{creation_options}{Optional character vector of format-specific
creation options as \code{"NAME=VALUE"} pairs. A list of options supported for a
format can be obtained with \code{getCreationOptions()}, but the documentation
for the format is the definitive source of information on driver creation
options (see \url{https://gdal.org/en/stable/drivers/raster/index.html}).
Array-level creation options may be passed by prefixing them with \verb{ARRAY:}
(see Details).}

\item{array_specs}{Optional character vector of one or more array
specifications, instead of converting the whole dataset (see Details).}

\item{group_specs}{Optional character vector of one or more array
specifications, instead of converting the whole dataset (see Details).}

\item{subset_specs}{Optional character vector of one or more subset
specifications, that perform trimming or slicing along a dimension, provided
that it is indexed by a 1D variable of numeric or string data type, and
whose values are monotonically sorted (see Details).}

\item{scaleaxes_specs}{Optional character string for a scale-axes
specification, that apply an integral scale factor to one or several
dimensions, i.e., extract 1 value every N values (without resampling) (see
Details).}

\item{allowed_drivers}{Optional character vector of driver short names that
must be considered when opening \code{src_dsn}. It is generally not necessary to
specify it, but it can be used to skip automatic driver detection, when it
fails to select the appropriate driver.}

\item{open_options}{Optional character vector of format-specific dataset
open options for \code{src_dsn} as \code{"NAME=VALUE"} pairs.}

\item{strict}{Logical value, \code{FALSE} (the default) some failures during the
translation are tolerated, such as not being able to write group attributes.
If set to \code{TRUE}, such failures will cause the process to fail.}

\item{quiet}{Logical value, set to \code{TRUE} to disable progress reporting.
Defaults to \code{FALSE}.}
}
\value{
Logical value indicating success (invisible \code{TRUE}, output written
to \code{dst_dsn}). An error is raised if the operation fails.
}
\description{
\code{mdim_translate()} is an interface to the \command{gdalmdimtranslate}
command-line utility (see
\url{https://gdal.org/en/stable/programs/gdalmdimtranslate.html}).
This function converts multidimensional data between different formats and
performs subsetting. Requires GDAL >= 3.2.
}
\details{
\subsection{Array creation options}{
Array creation options must be prefixed with \verb{ARRAY:}. The scope may be
further restricted to arrays of a certain dimension by adding
\verb{IF(DIM=\{ndims\}):} after \verb{ARRAY:}. For example,
\code{"ARRAY:IF(DIM=2):BLOCKSIZE=256,256"} will restrict \verb{BLOCKSIZE=256,256} to
arrays of dimension 2. Restriction to arrays of a given name is done with
adding \verb{IF(NAME=\{name\}):} after \verb{ARRAY:}. \code{{name}} can also be a fully
qualified name. A non-driver specific array option, \code{"AUTOSCALE=YES"} can
be used to ask (non indexing) variables of type \code{Float32} or \code{Float64} to be
scaled to \code{UInt16} with scale and offset values being computed from the
minimum and maximum of the source array. The integer data type used can be
set with \code{"AUTOSCALE_DATA_TYPE=Byte|UInt16|Int16|UInt32|Int32"}.
}

\subsection{\code{array_specs}}{
Instead of converting the whole dataset, select one or more arrays, and
possibly perform operations on them. One or more array specifications can
be given as elements of a character vector.

An array specification may be just an array name, potentially using a fully
qualified syntax (\code{"/group/subgroup/array_name"}). Or it can be a
combination of options with the syntax:

\if{html}{\out{<div class="sourceCode">}}\preformatted{"name=\{src_array_name\}[,dstname=\{dst_array_name\}][,resample=yes][,transpose=[\{axis1\},\{axis2\},...][,view=\{view_expr\}]"
}\if{html}{\out{</div>}}

The following options are processed in that order:
\itemize{
\item \code{resample=yes} asks for the array to run through
\code{GDALMDArray::GetResampled()}.
\item \code{[{axis1},{axis2},...]} is the argument of
\code{GDALMDArray::Transpose()}. For example, \verb{transpose=[1,0]} switches the
axis order of a 2D array.
\item \code{{view_expr}} is the value of the \code{viewExpr} argument of
\code{GDALMDArray::GetView()}. When specifying a \code{view_expr} that performs a
slicing or subsetting on a dimension, the equivalent operation will be
applied to the corresponding indexing variable. See \code{?mdim_as_classic} for
details on view expressions.
}
}

\subsection{\code{group_specs}}{
Instead of converting the whole dataset, select one or more groups, and
possibly perform operations on them. One or more group specifications can
be given in a character vector, to operate on different groups. If only one
group is specified, its content will be copied directly to the target root
group. If several are specified, they are copied under the target root
group.

A group specification may be just a group name, potentially using a fully
qualified syntax (\code{"/group/subgroup/subsubgroup_name"}). Or it can be a
combination of options with the syntax:

\if{html}{\out{<div class="sourceCode">}}\preformatted{"name=\{src_group_name\}[,dstname=\{dst_group_name\}][,recursive=no]"
}\if{html}{\out{</div>}}

}

\subsection{\code{subset_specs}}{
Perform subsetting (trimming or slicing) operations along dimensions,
provided that the dimension is indexed by a 1D variable of numeric or string
data type, and whose values are monotonically sorted. One or more subset
specifications can be given in a character vector. A subset specification
string follows exactly the OGC WCS 2.0 KVP encoding for subsetting.

Syntax is \code{"dim_name(min_val,max_val)"} or \code{"dim_name(sliced_val)"}. The
first syntax will subset the dimension dim_name to values in the
\code{[min_val,max_val]} range. The second syntax will slice the dimension
\code{dim_name} to value \code{sliced_val} (and this dimension will be removed from
the arrays that reference to it)

Using a subset specification is incompatible with specifying a view option
in \code{array_specs}.
}

\subsection{\code{scaleaxes_specs}}{
Applies an integral scale factor to one or several dimensions, i.e., extract
1 value every N values (without resampling). A scale-axes specification
string follows exactly the syntax of the KVP encoding of the SCALEAXES
parameter of OGC WCS 2.0 Scaling Extension, but limited to integer scale
factors.

Syntax is a character string of the form:

\if{html}{\out{<div class="sourceCode">}}\preformatted{"<dim1_name>(<scale_factor>)[,<dim2_name>(<scale_factor>)]..."
}\if{html}{\out{</div>}}

Using a scale-axes specification is incompatible with specifying a view
option in \code{array_specs}.
}
}
\examples{
\dontshow{if (gdal_version_num() >= gdal_compute_version(3, 2, 0) && isTRUE(gdal_formats("netCDF")$multidim_raster)) withAutoprint(\{ # examplesIf}
f_src <- system.file("extdata/byte.nc", package="gdalraster")

## COMPRESS option for MDArray creation
opt <- NULL
if (isTRUE(gdal_get_driver_md("netCDF")$NETCDF_HAS_NC4 == "YES")) {
  # 4 x 4 is for illustration only, the sample dataset is only 20 x 20
  opt <- c("ARRAY:IF(DIM=2):BLOCKSIZE=4,4",
           "ARRAY:IF(NAME=Band1):COMPRESS=DEFLATE",
           "ARRAY:ZLEVEL=6")
}

f_dst <- tempfile(fileext = ".nc")
mdim_translate(f_src, f_dst, creation_options = opt)
info <- mdim_info(f_dst, cout = FALSE) |> yyjsonr::read_json_str()
# str(info)
info$structural_info
info$arrays$Band1$block_size
info$arrays$Band1$structural_info

(ds <- mdim_as_classic(f_dst, "Band1", 1, 0))

plot_raster(ds, interpolate = FALSE, legend = TRUE, main = "Band1")

ds$close()

## slice along the Y axis with array view
f_dst2 <- tempfile(fileext = ".nc")
mdim_translate(f_src, f_dst2, array_specs = "name=Band1,view=[10:20,...]")
(ds <- mdim_as_classic(f_dst2, "Band1", 1, 0))

plot_raster(ds, interpolate = FALSE, legend = TRUE,
            main = "Band1[10:20,...]")

ds$close()

## trim X and Y by subsetting
f_dst3 <- tempfile(fileext = ".nc")
subsets <- c("x(441000,441800)", "y(3750400,3751000)")
mdim_translate(f_src, f_dst3, subset_specs = subsets)
(ds <- mdim_as_classic(f_dst3, "Band1", 1, 0))

plot_raster(ds, interpolate = FALSE, legend = TRUE,
            main = "Band1 trimmed")

ds$close()

## subsample along X and Y
f_dst4 <- tempfile(fileext = ".nc")
mdim_translate(f_src, f_dst4, scaleaxes_specs = "x(2),y(2)")
(ds <- mdim_as_classic(f_dst4, "Band1", 1, 0))

plot_raster(ds, interpolate = FALSE, legend = TRUE,
            main = "Band1 subsampled")

ds$close()
\dontshow{deleteDataset(f_dst)}
\dontshow{deleteDataset(f_dst2)}
\dontshow{deleteDataset(f_dst3)}
\dontshow{deleteDataset(f_dst4)}
\dontshow{\}) # examplesIf}
}
\seealso{
\code{\link[=mdim_as_classic]{mdim_as_classic()}}, \code{\link[=mdim_info]{mdim_info()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_unlink_batch}
\alias{vsi_unlink_batch}
\title{Delete several files in a batch}
\usage{
vsi_unlink_batch(filenames)
}
\arguments{
\item{filenames}{Character vector. The list of files to delete.}
}
\value{
Logical vector of \code{length(filenames)} with values depending
on the success of deletion of the corresponding file.
\code{NULL} might be returned in case of a more general error (for example,
files belonging to different file system handlers).
}
\description{
\code{vsi_unlink_batch()} deletes a list of files passed in a character vector.
All files should belong to the same file system handler.
This is implemented efficiently for /vsis3/ and /vsigs/ (provided for
/vsigs/ that OAuth2 authentication is used).
This function is a wrapper for \code{VSIUnlinkBatch()} in the GDAL Common
Portability Library.
}
\examples{
# regular file system for illustration
elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
tcc_file <- system.file("extdata/storml_tcc.tif", package="gdalraster")

tmp_elev <- file.path(tempdir(), "tmp_elev.tif")
file.copy(elev_file, tmp_elev)
tmp_tcc <- file.path(tempdir(), "tmp_tcc.tif")
file.copy(tcc_file, tmp_tcc)
vsi_unlink_batch(c(tmp_elev, tmp_tcc))
}
\seealso{
\code{\link[=deleteDataset]{deleteDataset()}}, \code{\link[=vsi_rmdir]{vsi_rmdir()}}, \code{\link[=vsi_unlink]{vsi_unlink()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdalraster_proc.R
\name{read_ds}
\alias{read_ds}
\title{Convenience wrapper for \code{GDALRaster$read()}}
\usage{
read_ds(
  ds,
  bands = NULL,
  xoff = 0,
  yoff = 0,
  xsize = ds$getRasterXSize(),
  ysize = ds$getRasterYSize(),
  out_xsize = xsize,
  out_ysize = ysize,
  as_list = FALSE,
  as_raw = FALSE
)
}
\arguments{
\item{ds}{An object of class \code{GDALRaster} in open state.}

\item{bands}{Integer vector of band numbers to read. By default all bands
will be read.}

\item{xoff}{Integer. The pixel (column) offset to the top left corner of the
raster region to be read (zero to start from the left side).}

\item{yoff}{Integer. The line (row) offset to the top left corner of the
raster region to be read (zero to start from the top).}

\item{xsize}{Integer. The width in pixels of the region to be read.}

\item{ysize}{Integer. The height in pixels of the region to be read.}

\item{out_xsize}{Integer. The width in pixels of the output buffer into
which the desired region will be read (e.g., to read a reduced resolution
overview).}

\item{out_ysize}{Integer. The height in pixels of the output buffer into
which the desired region will be read (e.g., to read a reduced resolution
overview).}

\item{as_list}{Logical. If \code{TRUE}, return output as a list of band vectors.
If \code{FALSE} (the default), output is a vector of pixel data interleaved by
band.}

\item{as_raw}{Logical. If \code{TRUE} and the underlying data type is Byte (or
UInt8 in GDAL >= 3.13), return output as \R \code{raw} vector type. This maps to
the setting \code{$readByteAsRaw} on the \code{GDALRaster} object, which will be
temporarily updated in this function. To control this behavior in a
persistent way on a dataset object see \code{$readByteAsRaw} in
\code{\link[=GDALRaster]{GDALRaster-class}}.}
}
\value{
If \code{as_list = FALSE} (the default), a vector of \code{raw}, \code{integer},
\code{double} or \code{complex} containing the values that were read. It is organized
in left to right, top to bottom pixel order, interleaved by band.
If \code{as_list = TRUE}, a list with number of elements equal to the number of
bands read. Each element contains a vector of \code{raw}, \code{integer}, \code{double} or
\code{complex} containing the pixel values that were read for the band.
}
\description{
\code{read_ds()} will read from a raster dataset that is already open in a
\code{GDALRaster} object. By default, it attempts to read the full raster
extent from all bands at full resolution. \code{read_ds()} is sometimes more
convenient than \code{GDALRaster$read()}, e.g., to read specific multiple bands
for display with \code{\link[=plot_raster]{plot_raster()}}, or simply for the default arguments that
read an entire raster into memory (see Note).
}
\details{
\code{NA} will be returned in place of the nodata value if the raster dataset has
a nodata value defined for the band. Data are read as R \code{integer} type when
possible for the raster data type (Byte/UInt8, Int8, Int16, UInt16, Int32),
otherwise as type \code{double} (UInt32, Float32, Float64).

The output object has attribute \code{gis}, a list containing:
\preformatted{
  $type = "raster"
  $bbox = c(xmin, ymin, xmax, ymax)
  $dim = c(xsize, ysize, nbands)
  $srs = <projection as WKT2 string>
  $datatype = <character vector of data type name by band>
}
The WKT version used for the projection string can be overridden by setting
the \code{OSR_WKT_FORMAT} configuration option. See \code{\link[=srs_to_wkt]{srs_to_wkt()}} for a list of
supported values.
}
\note{
There is small overhead in calling \code{read_ds()} compared with
calling \code{GDALRaster$read()} directly. This would only matter if calling
the function repeatedly to read a raster in chunks. For the case of reading
a large raster in many chunks, it will be optimal performance-wise to call
\code{GDALRaster$read()} directly.

By default, this function will attempt to read the full raster into memory.
It generally should not be called on large raster datasets using the default
argument values. The memory size in bytes of the returned vector will be,
e.g., (xsize * ysize * number of bands * 4) for data read as
\code{integer}, or (xsize * ysize * number of bands * 8) for data read as
\code{double} (plus small object overhead for the vector).
}
\examples{
# read three bands from a multi-band dataset
lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
ds <- new(GDALRaster, lcp_file)

# as a vector of pixel data interleaved by band
r <- read_ds(ds, bands = c(6,5,4))
typeof(r)
length(r)
object.size(r)

# as a list of band vectors
r <- read_ds(ds, bands = c(6,5,4), as_list = TRUE)
typeof(r)
length(r)
object.size(r)

# gis attributes
attr(r, "gis")

ds$close()
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster$read()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom.R
\name{g_unary_op}
\alias{g_unary_op}
\alias{g_buffer}
\alias{g_boundary}
\alias{g_convex_hull}
\alias{g_concave_hull}
\alias{g_delaunay_triangulation}
\alias{g_segmentize}
\alias{g_simplify}
\alias{g_unary_union}
\title{Unary operations on WKB or WKT geometries}
\usage{
g_buffer(
  geom,
  dist,
  quad_segs = 30L,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)

g_boundary(
  geom,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)

g_convex_hull(
  geom,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)

g_concave_hull(
  geom,
  ratio,
  allow_holes,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)

g_delaunay_triangulation(
  geom,
  constrained = FALSE,
  tolerance = 0,
  only_edges = FALSE,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)

g_segmentize(
  geom,
  max_length,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)

g_simplify(
  geom,
  tolerance,
  preserve_topology = TRUE,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)

g_unary_union(
  geom,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)
}
\arguments{
\item{geom}{Either a raw vector of WKB or list of raw vectors, or a
character vector containing one or more WKT strings.}

\item{dist}{Numeric buffer distance in units of the input \code{geom}.}

\item{quad_segs}{Integer number of segments used to define a 90 degree
curve (quadrant of a circle). Large values result in large numbers of
vertices in the resulting buffer geometry while small numbers reduce the
accuracy of the result.}

\item{as_wkb}{Logical value, \code{TRUE} to return the output geometry in WKB
format (the default), or \code{FALSE} to return as WKT.}

\item{as_iso}{Logical value, \code{TRUE} to export as ISO WKB/WKT (ISO 13249
SQL/MM Part 3), or \code{FALSE} (the default) to export as "Extended WKB/WKT".}

\item{byte_order}{Character string specifying the byte order when output is
WKB. One of \code{"LSB"} (the default) or \code{"MSB"} (uncommon).}

\item{quiet}{Logical value, \code{TRUE} to suppress warnings. Defaults to \code{FALSE}.}

\item{ratio}{Numeric value in interval \verb{[0, 1]}. The target criterion
parameter for \code{g_concave_hull()}, expressed as a ratio between the lengths
of the longest and shortest edges. \code{1} produces the convex hull; \code{0} produces
a hull with maximum concaveness (see Note).}

\item{allow_holes}{Logical value, whether holes are allowed.}

\item{constrained}{Logical value, \code{TRUE} to return a constrained Delaunay
triangulation of the vertices of the given polygon(s). Defaults to \code{FALSE}.}

\item{tolerance}{Numeric value. For \code{g_simplify()}, the simplification
tolerance as distance in units of the input \code{geom}. Simplification removes
vertices which are within the tolerance distance of the simplified linework
(as long as topology is preserved when \code{preserve_topology = TRUE}).
For \code{g_delaunay_triangulation()}, an optional snapping tolerance to use for
improved robustness (ignored if \code{constrained = TRUE}).}

\item{only_edges}{Logical value. If \code{TRUE}, \code{g_delaunay_triangulation()}
will return a MULTILINESTRING, otherwise it will return a GEOMETRYCOLLECTION
containing triangular POLYGONs (the default). Ignored if \code{constrained = TRUE}}

\item{max_length}{Numeric maximum distance between 2 points after
segmentization.}

\item{preserve_topology}{Logical value, \code{TRUE} to simplify geometries while
preserving topology (the default). Setting to \code{FALSE} simplifies geometries
using the standard Douglas-Peucker algorithm which is significantly faster
(see Note).}
}
\value{
A geometry as WKB raw vector or WKT string, or a list/character vector of
geometries as WKB/WKT with length equal to the number of input geometries.
\code{NULL} (\code{as_wkb = TRUE}) / \code{NA} (\code{as_wkb = FALSE}) is returned with a
warning if WKB input cannot be converted into an OGR geometry object, or if
an error occurs in the call to the underlying OGR API.
}
\description{
These functions implement algorithms that operate on one input geometry
for which a new output geometry is generated.
The input geometries may be given as a single raw vector of WKB, a list of
WKB raw vectors, or a character vector containing one or more WKT strings.
}
\details{
These functions use the GEOS library via GDAL headers.

\code{g_boundary()} computes the boundary of a geometry. Wrapper of
\code{OGR_G_Boundary()} in the GDAL Geometry API.

\code{g_buffer()} builds a new geometry containing the buffer region around
the geometry on which it is invoked. The buffer is a polygon containing
the region within the buffer distance of the original geometry.
Wrapper of \code{OGR_G_Buffer()} in the GDAL API.

\code{g_convex_hull()} computes a convex hull, the smallest convex geometry that
contains all the points in the input geometry. Wrapper of
\code{OGR_G_ConvexHull()} in the GDAL API.

\code{g_concave_hull()} returns a "concave hull" of a geometry. A concave hull is
a polygon which contains all the points of the input, but is a better
approximation than the convex hull to the area occupied by the input.
Frequently used to convert a multi-point into a polygonal area that contains
all the points in the input geometry. Requires GDAL >= 3.6 and GEOS >= 3.11.

\code{g_delaunay_triangulation()}
\itemize{
\item \code{constrained = FALSE}: returns a Delaunay triangulation of the vertices of
the input geometry. Wrapper of \code{OGR_G_DelaunayTriangulation()} in the GDAL
API. Requires GEOS >= 3.4.
\item \code{constrained = TRUE}: returns a constrained Delaunay triangulation of the
vertices of the given polygon(s). For non-polygonal inputs, silently returns
an empty geometry collection. Requires GDAL >= 3.12 and GEOS >= 3.10.
}

\code{g_segmentize()} modifies a geometry such that it has no segment longer then
the given \code{max_length}. Interpolated points will have Z and M values
(if needed) set to \code{0}. Distance computation is performed in 2D only.

\code{g_simplify()} computes a simplified geometry. By default, it simplifies
the input geometries while preserving topology (see Note). Wrapper of
\code{OGR_G_Simplify()} / \code{OGR_G_SimplifyPreserveTopology()} in the GDAL API.

\code{g_unary_union()} returns the union of all components of a single geometry.
Usually used to convert a collection into the smallest set of polygons that
cover the same area. See \url{https://postgis.net/docs/ST_UnaryUnion.html}
for more details. Requires GDAL >= 3.7.
}
\note{
Definitions of these operations are given in the GEOS documentation
(\url{https://libgeos.org/doxygen/}, GEOS 3.15.0dev), some of which is
copied here.

\code{g_boundary()} computes the "boundary" as defined by the DE9IM
(\url{https://en.wikipedia.org/wiki/DE-9IM}):
\itemize{
\item the boundary of a \code{Polygon} is the set of linear rings dividing the
exterior from the interior
\item the boundary of a \code{LineString} is the two end points
\item the boundary of a \code{Point}/\code{MultiPoint} is defined as empty
}

\code{g_buffer()} always returns a polygonal result. The negative or
zero-distance buffer of lines and points is always an empty \code{Polygon}.

\code{g_convex_hull()} uses the Graham Scan algorithm.

\code{g_concave_hull()}: A set of points has a sequence of hulls of increasing
concaveness, determined by a numeric target parameter. The concave hull is
constructed by removing the longest outer edges of the Delaunay Triangulation
of the space between the polygons, until the target criterion parameter is
reached. This can be expressed as a ratio between the lengths of the longest
and shortest edges. \code{1} produces the convex hull; \code{0} produces a hull with
maximum concaveness.

\code{g_simplify()}:
\itemize{
\item With \code{preserve_topology = TRUE} (the default):\cr
Simplifies a geometry, ensuring that the result is a valid geometry having
the same dimension and number of components as the input. The simplification
uses a maximum distance difference algorithm similar to the one used in the
Douglas-Peucker algorithm. In particular, if the input is an areal geometry
(\code{Polygon} or \code{MultiPolygon}), the result has the same number of shells and
holes (rings) as the input, in the same order. The result rings touch at no
more than the number of touching point in the input (although they may touch
at fewer points).
\item With \code{preserve_topology = FALSE}:\cr
Simplifies a geometry using the standard Douglas-Peucker algorithm. Ensures
that any polygonal geometries returned are valid. Simple lines are not
guaranteed to remain simple after simplification. Note that in general D-P
does not preserve topology - e.g. polygons can be split, collapse to lines
or disappear, holes can be created or disappear, and lines can cross. To
simplify geometry while preserving topology use
\code{TopologyPreservingSimplifier}. (However, using D-P is significantly faster.)
}

\code{preserve_topology = TRUE} does not preserve boundaries shared between
polygons.
}
\examples{
g <- "POLYGON((0 0,1 1,1 0,0 0))"
g_boundary(g, as_wkb = FALSE)

g <- "POINT (0 0)"
g_buffer(g, dist = 10, as_wkb = FALSE)

g <- "GEOMETRYCOLLECTION(POINT(0 1), POINT(0 0), POINT(1 0), POINT(1 1))"
g_convex_hull(g, as_wkb = FALSE)

# g_concave_hull() requires GDAL >= 3.6 and GEOS >= 3.11
if (gdal_version_num() >= gdal_compute_version(3, 6, 0) &&
    (geos_version()$major > 3 || geos_version()$minor >= 11)) {
  g <- "MULTIPOINT(0 0,0.4 0.5,0 1,1 1,0.6 0.5,1 0)"
  g_concave_hull(g, ratio = 0.5, allow_holes = FALSE, as_wkb = FALSE)
}

# g_delaunay_triangulation() requires GEOS >= 3.4
if (geos_version()$major > 3 || geos_version()$minor >= 4) {
  g <- "MULTIPOINT(0 0,0 1,1 1,1 0)"
  g_delaunay_triangulation(g, as_wkb = FALSE)
}

g <- "LINESTRING(0 0,0 10)"
g_segmentize(g, 1) |> g_wk2wk()

g <- "LINESTRING(0 0,1 1,10 0)"
g_simplify(g, tolerance = 5, as_wkb = FALSE)

# g_unary_union() requires GDAL >= 3.7
if (gdal_version_num() >= gdal_compute_version(3, 7, 0)) {
  g <- "GEOMETRYCOLLECTION(POINT(0.5 0.5), POLYGON((0 0,0 1,1 1,1 0,0 0)),
        POLYGON((1 0,1 1,2 1,2 0,1 0)))"
  g_unary_union(g, as_wkb = FALSE)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_clear_path_options}
\alias{vsi_clear_path_options}
\title{Clear path specific configuration options}
\usage{
vsi_clear_path_options(path_prefix)
}
\arguments{
\item{path_prefix}{Character string. If set to \code{""} (empty string), all
path specific options are cleared. If set to a path prefix, only those
options set with \code{vsi_set_path_option(path_prefix, ...)} will be cleared.}
}
\value{
No return value, called for side effect.
}
\description{
\code{vsi_clear_path_options()} clears path specific options previously set
with \code{vsi_set_path_option()}.
Wrapper for \code{VSIClearPathSpecificOptions()} in the GDAL Common Portability
Library. Requires GDAL >= 3.6.
}
\note{
No particular care is taken to remove options from RAM in a secure way.
}
\seealso{
\code{\link[=vsi_set_path_option]{vsi_set_path_option()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{footprint}
\alias{footprint}
\title{Compute footprint of a raster}
\usage{
footprint(src_filename, dst_filename, cl_arg = NULL)
}
\arguments{
\item{src_filename}{Character string. Filename of the source raster.}

\item{dst_filename}{Character string. Filename of the destination vector.
If the file and the output layer exist, the new footprint is appended to
them, unless the \code{-overwrite} command-line argument is used.}

\item{cl_arg}{Optional character vector of command-line arguments for
\code{gdal_footprint}.}
}
\value{
Logical indicating success (invisible \code{TRUE}).
An error is raised if the operation fails.
}
\description{
\code{footprint()} is a wrapper of the \command{gdal_footprint} command-line
utility (see \url{https://gdal.org/en/stable/programs/gdal_footprint.html}).
The function can be used to compute the footprint of a raster file, taking
into account nodata values (or more generally the mask band attached to
the raster bands), and generating polygons/multipolygons corresponding to
areas where pixels are valid, and write to an output vector file.
Refer to the GDAL documentation at the URL above for a list of command-line
arguments that can be passed in \code{cl_arg}. Requires GDAL >= 3.8.
}
\details{
Post-vectorization geometric operations are applied in the following order:
\itemize{
\item optional splitting (\code{-split_polys})
\item optional densification (\code{-densify})
\item optional reprojection (\code{-t_srs})
\item optional filtering by minimum ring area (\code{-min_ring_area})
\item optional application of convex hull (\code{-convex_hull})
\item optional simplification (\code{-simplify})
\item limitation of number of points (\code{-max_points})
}
}
\examples{
evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
out_file <- file.path(tempdir(), "storml.geojson")

# Requires GDAL >= 3.8
if (gdal_version_num() >= gdal_compute_version(3, 8, 0)) {
  # command-line arguments for gdal_footprint
  args <- c("-t_srs", "EPSG:4326")
  footprint(evt_file, out_file, args)
  \dontshow{deleteDataset(out_file)}
}
}
\seealso{
\code{\link[=polygonize]{polygonize()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{bbox_from_wkt}
\alias{bbox_from_wkt}
\title{Get the bounding box of a geometry specified in OGC WKT format}
\usage{
bbox_from_wkt(wkt, extend_x = 0, extend_y = 0)
}
\arguments{
\item{wkt}{Character. OGC WKT string for a simple feature 2D geometry.}

\item{extend_x}{Numeric scalar. Distance to extend the output bounding box
in both directions along the x-axis
(results in \code{xmin = bbox[1] - extend_x}, \code{xmax = bbox[3] + extend_x}).}

\item{extend_y}{Numeric scalar. Distance to extend the output bounding box
in both directions along the y-axis
(results in \code{ymin = bbox[2] - extend_y}, \code{ymax = bbox[4] + extend_y}).}
}
\value{
Numeric vector of length four containing the xmin, ymin,
xmax, ymax of the geometry specified by \code{wkt} (possibly extended by values
in \code{extend_x}, \code{extend_y}).
}
\description{
\code{bbox_from_wkt()} returns the bounding box of a WKT 2D geometry
(e.g., LINE, POLYGON, MULTIPOLYGON).
}
\examples{
bnd <- "POLYGON ((324467.3 5104814.2, 323909.4 5104365.4, 323794.2
5103455.8, 324970.7 5102885.8, 326420.0 5103595.3, 326389.6 5104747.5,
325298.1 5104929.4, 325298.1 5104929.4, 324467.3 5104814.2))"
bbox_from_wkt(bnd, 100, 100)
}
\seealso{
\code{\link[=bbox_to_wkt]{bbox_to_wkt()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_copy_file}
\alias{vsi_copy_file}
\title{Copy a source file to a target filename}
\usage{
vsi_copy_file(src_file, target_file, show_progress = FALSE)
}
\arguments{
\item{src_file}{Character string. Filename of the source file.}

\item{target_file}{Character string. Filename of the target file.}

\item{show_progress}{Logical scalar. If \code{TRUE}, a progress bar will be
displayed (the size of \code{src_file} will be retrieved in GDAL with
\code{VSIStatL()}). Default is \code{FALSE}.}
}
\value{
\code{0} on success or \code{-1} on an error.
}
\description{
\code{vsi_copy_file()} is a wrapper for \code{VSICopyFile()} in the GDAL Common
Portability Library. The GDAL VSI functions allow virtualization of disk
I/O so that non file data sources can be made to appear as files.
See \url{https://gdal.org/en/stable/user/virtual_file_systems.html}.
Requires GDAL >= 3.7.
}
\details{
The following copies are made fully on the target server, without local
download from source and upload to target:
\itemize{
\item /vsis3/ -> /vsis3/
\item /vsigs/ -> /vsigs/
\item /vsiaz/ -> /vsiaz/
\item /vsiadls/ -> /vsiadls/
\item any of the above or /vsicurl/ -> /vsiaz/ (starting with GDAL 3.8)
}
}
\note{
If \code{target_file} has the form /vsizip/foo.zip/bar, the default options
described for the function \code{addFilesInZip()} will be in effect.
}
\examples{
elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
tmp_file <- "/vsimem/elev_temp.tif"

# Requires GDAL >= 3.7
if (gdal_version_num() >= gdal_compute_version(3, 7, 0)) {
  result <- vsi_copy_file(elev_file, tmp_file)
  (result == 0)
  print(vsi_stat(tmp_file, "size"))

  vsi_unlink(tmp_file)
}
}
\seealso{
\code{\link[=copyDatasetFiles]{copyDatasetFiles()}}, \code{\link[=vsi_stat]{vsi_stat()}}, \code{\link[=vsi_sync]{vsi_sync()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdalraster_proc.R
\name{polygonize}
\alias{polygonize}
\title{Create a polygon feature layer from raster data}
\usage{
polygonize(
  raster_file,
  out_dsn,
  out_layer,
  fld_name = "DN",
  out_fmt = NULL,
  connectedness = 4,
  src_band = 1,
  mask_file = NULL,
  nomask = FALSE,
  overwrite = FALSE,
  dsco = NULL,
  lco = NULL,
  quiet = FALSE
)
}
\arguments{
\item{raster_file}{Filename of the source raster.}

\item{out_dsn}{The destination vector filename to which the polygons will be
written (or database connection string).}

\item{out_layer}{Name of the layer for writing the polygon features. For
single-layer file formats such as \code{"ESRI Shapefile"}, the layer name is the
same as the filename without the path or extension (e.g., \code{out_dsn = "path_to_file/polygon_output.shp"}, the layer name is \code{"polygon_output"}).}

\item{fld_name}{Name of an integer attribute field in \code{out_layer} to which
the pixel values will be written. Will be created if necessary when using an
existing layer.}

\item{out_fmt}{GDAL short name of the output vector format. If unspecified,
the function will attempt to guess the format from the filename/connection
string.}

\item{connectedness}{Integer scalar. Must be either \code{4} or \code{8}. For the
default 4-connectedness, pixels with the same value are considered connected
only if they touch along one of the four sides, while 8-connectedness
also includes pixels that touch at one of the corners.}

\item{src_band}{The band on \code{raster_file} to build the polygons from
(default is \code{1}).}

\item{mask_file}{Use the first band of the specified raster as a
validity mask (zero is invalid, non-zero is valid). If not specified, the
default validity mask for the input band (such as nodata, or alpha masks)
will be used (unless \code{nomask} is set to \code{TRUE}).}

\item{nomask}{Logical scalar. If \code{TRUE}, do not use the default validity
mask for the input band (such as nodata, or alpha masks).
Default is \code{FALSE}.}

\item{overwrite}{Logical scalar. If \code{TRUE}, overwrite \code{out_layer} if it
already exists. Default is \code{FALSE}.}

\item{dsco}{Optional character vector of format-specific creation options
for \code{out_dsn} (\code{"NAME=VALUE"} pairs).}

\item{lco}{Optional character vector of format-specific creation options
for \code{out_layer} (\code{"NAME=VALUE"} pairs).}

\item{quiet}{Logical scalar. If \code{TRUE}, a progress bar will not be
displayed. Defaults to \code{FALSE}.}
}
\description{
\code{polygonize()} creates vector polygons for all connected regions of pixels
in a source raster sharing a common pixel value. Each polygon is created
with an attribute indicating the pixel value of that polygon. A raster mask
may also be provided to determine which pixels are eligible for processing.
The function will create the output vector layer if it does not already
exist, otherwise it will try to append to an existing one.
This function is a wrapper of \code{GDALPolygonize} in the GDAL Algorithms API.
It provides essentially the same functionality as the \code{gdal_polygonize.py}
command-line program
(\url{https://gdal.org/en/stable/programs/gdal_polygonize.html}).
}
\details{
Polygon features will be created on the output layer, with polygon
geometries representing the polygons. The polygon geometries will be in the
georeferenced coordinate system of the raster (based on the geotransform of
the source dataset). It is acceptable for the output layer to already have
features. If the output layer does not already exist, it will be created
with coordinate system matching the source raster.

The algorithm attempts to minimize memory use so that very large rasters can
be processed. However, if the raster has many polygons or very large/complex
polygons, the memory use for holding polygon enumerations and active polygon
geometries may grow to be quite large.

The algorithm will generally produce very dense polygon geometries, with
edges that follow exactly on pixel boundaries for all non-interior pixels.
For non-thematic raster data (such as satellite images) the result will
essentially be one small polygon per pixel, and memory and output layer
sizes will be substantial. The algorithm is primarily intended for
relatively simple thematic rasters, masks, and classification results.
}
\note{
The source pixel band values are read into a signed 64-bit integer buffer
(\code{Int64}) by \code{GDALPolygonize}, so floating point or complex bands will be
implicitly truncated before processing.

When 8-connectedness is used, many of the resulting polygons will likely be
invalid due to ring self-intersection (in the strict OGC definition of
polygon validity). See \code{g_is_valid()} / \code{g_make_valid()} (single polygons
can become MultiPolygon' in the case of self-intersections).

If writing to a SQLite database format as either \code{GPKG} (GeoPackage
vector) or \code{SQLite} (Spatialite vector), setting the
\code{SQLITE_USE_OGR_VFS} and \code{OGR_SQLITE_JOURNAL} configuration options may
increase performance substantially. If writing to \code{PostgreSQL}
(PostGIS vector), setting \code{PG_USE_COPY=YES} is faster:

\if{html}{\out{<div class="sourceCode">}}\preformatted{# SQLite: GPKG (.gpkg) and Spatialite (.sqlite)
# enable extra buffering/caching by the GDAL/OGR I/O layer
set_config_option("SQLITE_USE_OGR_VFS", "YES")
# set the journal mode for the SQLite database to MEMORY
set_config_option("OGR_SQLITE_JOURNAL", "MEMORY")

# PostgreSQL / PostGIS
# use COPY for inserting data rather than INSERT
set_config_option("PG_USE_COPY", "YES")
}\if{html}{\out{</div>}}
}
\examples{
evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
dsn <- file.path(tempdir(), "storm_lake.gpkg")
layer <- "lf_evt"
fld <- "evt_value"
set_config_option("SQLITE_USE_OGR_VFS", "YES")
set_config_option("OGR_SQLITE_JOURNAL", "MEMORY")
polygonize(evt_file, dsn, layer, fld)
set_config_option("SQLITE_USE_OGR_VFS", "")
set_config_option("OGR_SQLITE_JOURNAL", "")
\dontshow{deleteDataset(dsn)}
}
\seealso{
\code{\link[=rasterize]{rasterize()}}

\code{vignette("gdal-config-quick-ref")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom.R
\name{g_transform}
\alias{g_transform}
\title{Apply a coordinate transformation to a WKB/WKT geometry}
\usage{
g_transform(
  geom,
  srs_from,
  srs_to,
  wrap_date_line = FALSE,
  date_line_offset = 10L,
  traditional_gis_order = TRUE,
  as_wkb = TRUE,
  as_iso = FALSE,
  byte_order = "LSB",
  quiet = FALSE
)
}
\arguments{
\item{geom}{Either a raw vector of WKB or list of raw vectors, or a
character vector containing one or more WKT strings.}

\item{srs_from}{Character string specifying the spatial reference system
for \code{geom}. May be in WKT format or any of the formats supported by
\code{\link[=srs_to_wkt]{srs_to_wkt()}}.}

\item{srs_to}{Character string specifying the output spatial reference
system. May be in WKT format or any of the formats supported by
\code{\link[=srs_to_wkt]{srs_to_wkt()}}.}

\item{wrap_date_line}{Logical value, \code{TRUE} to correct geometries that
incorrectly go from a longitude on a side of the antimeridian to the other
side. Defaults to \code{FALSE}.}

\item{date_line_offset}{Integer longitude gap in degree. Defaults to \code{10L}.}

\item{traditional_gis_order}{Logical value, \code{TRUE} to use traditional GIS
order of axis mapping (the default) or \code{FALSE} to use authority compliant
axis order. By default, input \code{geom} vertices are assumed to
be in longitude/latitude order if \code{srs_from} is a geographic coordinate
system. This can be overridden by setting \code{traditional_gis_order = FALSE}.}

\item{as_wkb}{Logical value, \code{TRUE} to return the output geometry in WKB
format (the default), or \code{FALSE} to return as WKT.}

\item{as_iso}{Logical value, \code{TRUE} to export as ISO WKB/WKT (ISO 13249
SQL/MM Part 3), or \code{FALSE} (the default) to export as "Extended WKB/WKT".}

\item{byte_order}{Character string specifying the byte order when output is
WKB. One of \code{"LSB"} (the default) or \code{"MSB"} (uncommon).}

\item{quiet}{Logical value, \code{TRUE} to suppress warnings. Defaults to \code{FALSE}.}
}
\value{
A geometry as WKB raw vector or WKT string, or a list/character vector of
geometries as WKB/WKT with length equal to the number of input geometries.
\code{NULL} (\code{as_wkb = TRUE}) / \code{NA} (\code{as_wkb = FALSE}) is returned with a
warning if WKB input cannot be converted into an OGR geometry object, or if
an error occurs in the call to the underlying OGR API.
}
\description{
\code{g_transform()} will transform the coordinates of a geometry from their
current spatial reference system to a new target spatial reference system.
Normally this means reprojecting the vectors, but it could include datum
shifts, and changes of units.
}
\note{
This function uses the \code{OGR_GeomTransformer_Create()} and
\code{OGR_GeomTransformer_Transform()} functions in the GDAL API: "This is an
enhanced version of \code{OGR_G_Transform()}. When reprojecting geometries from
a Polar Stereographic projection or a projection naturally crossing the
antimeridian (like UTM Zone 60) to a geographic CRS, it will cut geometries
along the antimeridian. So a \code{LineString} might be returned as a
\code{MultiLineString}."

The \code{wrap_date_line = TRUE} option might be specified for circumstances to
correct geometries that incorrectly go from a longitude on a side of the
antimeridian to the other side, e.g., \verb{LINESTRING (-179 0,179 0)} will be
transformed to \verb{MULTILINESTRING ((-179 0,-180 0),(180 0,179 0))}. For that
use case, \code{srs_to} might be the same as \code{srs_from}.
}
\examples{
pt <- "POINT (-114.0 47.0)"
g_transform(pt, "WGS84", "EPSG:5070", as_wkb = FALSE)

# correct geometries that incorrectly go from a longitude on a side of the
# antimeridian to the other side
geom <- "LINESTRING (-179 0,179 0)"
g_transform(geom, "WGS84", "WGS84", wrap_date_line = TRUE, as_wkb = FALSE)
}
\seealso{
\code{\link[=bbox_transform]{bbox_transform()}}, \code{\link[=transform_bounds]{transform_bounds()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{srs_convert}
\alias{srs_convert}
\alias{epsg_to_wkt}
\alias{srs_to_wkt}
\alias{srs_to_projjson}
\title{Convert spatial reference definitions to OGC WKT or PROJJSON}
\usage{
epsg_to_wkt(epsg, pretty = FALSE)

srs_to_wkt(srs, pretty = FALSE, gcs_only = FALSE)

srs_to_projjson(
  srs,
  multiline = TRUE,
  indent_width = 2L,
  schema = NA_character_
)
}
\arguments{
\item{epsg}{Integer EPSG code.}

\item{pretty}{Logical value. \code{TRUE} to return a nicely formatted WKT string
for display to a person. \code{FALSE} for a regular WKT string (the default).}

\item{srs}{Character string containing an SRS definition in various
formats (see Details).}

\item{gcs_only}{Logical value. \code{TRUE} to return only the definition of the
GEOGCS node of the input \code{srs}. Defaults to \code{FALSE} (see Note).}

\item{multiline}{Logical value. \code{TRUE} for PROJJSON multiline output (the
default).}

\item{indent_width}{Integer value. Defaults to \code{2}. Only used if
\code{multiline = TRUE} for PROJJSON output.}

\item{schema}{Character string containing URL to PROJJSON schema. Can be
set to empty string to disable it.}
}
\value{
Character string containing OGC WKT.
}
\description{
These functions convert various spatial reference formats to Well Known
Text (WKT) or PROJJSON.
}
\details{
\code{epsg_to_wkt()} exports the spatial reference for an EPSG code to
WKT format.
Wrapper for \code{OSRImportFromEPSG()} in the GDAL Spatial Reference System API
with output to WKT.

\code{srs_to_wkt()} converts a spatial reference system (SRS) definition
in various text formats to WKT. The function will examine the input SRS,
try to deduce the format, and then export it to WKT.
Wrapper for \code{OSRSetFromUserInput()} in the GDAL Spatial Reference System
API with output to WKT.

\code{srs_to_projjson()} accepts a spatial reference system (SRS) definition in
any of the formats supported by \code{srs_to_wkt()}, and converts into PROJJSON
format. Wrapper for \code{OSRExportToPROJJSON()} in the GDAL Spatial Reference
System API.

The input SRS may take the following forms:
\itemize{
\item WKT - to convert WKT versions (see below)
\item EPSG:n - EPSG code n
\item AUTO:proj_id,unit_id,lon0,lat0 - WMS auto projections
\item urn:ogc:def:crs:EPSG::n - OGC URNs
\item PROJ.4 definitions
\item filename - file to read for WKT, XML or PROJ.4 definition
\item well known name such as NAD27, NAD83, WGS84 or WGS72
\item IGNF:xxxx, ESRI:xxxx - definitions from the PROJ database
\item PROJJSON (PROJ >= 6.2)
}

\code{srs_to_wkt()} is intended to be flexible, but by its nature it is
imprecise as it must guess information about the format intended.
\code{\link[=epsg_to_wkt]{epsg_to_wkt()}} could be used instead for EPSG codes.

As of GDAL 3.0, the default format for WKT export is OGC WKT 1.
The WKT version can be overridden by using the OSR_WKT_FORMAT
configuration option (see \code{\link[=set_config_option]{set_config_option()}}).
Valid values are one of: SFSQL, WKT1_SIMPLE, WKT1, WKT1_GDAL,
WKT1_ESRI, WKT2_2015, WKT2_2018, WKT2, DEFAULT.
If SFSQL, a WKT1 string without AXIS, TOWGS84, AUTHORITY or
EXTENSION node is returned. If WKT1_SIMPLE, a WKT1 string without
AXIS, AUTHORITY or EXTENSION node is returned. WKT1 is an alias of
WKT1_GDAL. WKT2 will default to the latest revision implemented
(currently WKT2_2018). WKT2_2019 can be used as an alias of
WKT2_2018 since GDAL 3.2
}
\note{
Setting \code{gcs_only = TRUE} in \code{srs_to_wkt()} is a wrapper of
\code{OSRCloneGeogCS()} in the GDAL API. The returned WKT will be for the GEOGCS
node of the input \code{srs}.
}
\examples{
epsg_to_wkt(5070)
writeLines(epsg_to_wkt(5070, pretty = TRUE))

srs_to_wkt("NAD83")
writeLines(srs_to_wkt("NAD83", pretty = TRUE))
set_config_option("OSR_WKT_FORMAT", "WKT2")
writeLines(srs_to_wkt("NAD83", pretty = TRUE))
set_config_option("OSR_WKT_FORMAT", "")

srs_to_wkt("EPSG:5070", gcs_only = TRUE)

srs_to_projjson("NAD83") |> writeLines()
}
\seealso{
\link{srs_query}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{get_cache_used}
\alias{get_cache_used}
\title{Get the size of memory in use by the GDAL block cache}
\usage{
get_cache_used(units = "MB")
}
\arguments{
\item{units}{Character string specifying units for the return value. One of
\code{"MB"} (the default), \code{"GB"}, \code{"KB"} or \code{"bytes"} (values of \code{"byte"},
\code{"B"} and empty string \code{""} are also recognized to mean bytes).}
}
\value{
A numeric value carrying the \code{integer64} class attribute. Amount
of the available cache memory currently in use in the requested units.
}
\description{
\code{get_cache_used()} returns the amount of memory currently in use for
GDAL block caching. Wrapper of \code{GDALGetCacheUsed64()} with return
value in MB by default.
}
\examples{
get_cache_used()
}
\seealso{
\href{https://firelab.github.io/gdalraster/articles/gdal-block-cache.html}{GDAL Block Cache}

\code{\link[=get_cache_max]{get_cache_max()}}, \code{\link[=set_cache_max]{set_cache_max()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom.R
\name{geos_version}
\alias{geos_version}
\title{Get GEOS version}
\usage{
geos_version()
}
\value{
A list of length four containing:
\itemize{
\item \code{name} - a string formatted as "major.minor.patch"
\item \code{major} - major version as integer
\item \code{minor} - minor version as integer
\item \code{patch} - patch version as integer
}

List elements will be \code{NA} if GDAL < 3.4.
}
\description{
\code{geos_version()} returns version information for the GEOS library in use by
GDAL. Requires GDAL >= 3.4.
}
\examples{
geos_version()
}
\seealso{
\code{\link[=gdal_version]{gdal_version()}}, \code{\link[=proj_version]{proj_version()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transform.R
\name{transform_xy}
\alias{transform_xy}
\title{Transform geospatial x/y coordinates}
\usage{
transform_xy(pts, srs_from, srs_to)
}
\arguments{
\item{pts}{A data frame or numeric matrix containing geospatial point
coordinates, or point geometries as a list of WKB raw vectors or character
vector of WKT strings. If data frame or matrix, the number of columns must
be either two (x, y), three (x, y, z) or four (x, y, z, t).
May be also be given as a numeric vector for one point (xy, xyz, or xyzt).}

\item{srs_from}{Character string specifying the spatial reference system
for \code{pts}. May be in WKT format or any of the formats supported by
\code{\link[=srs_to_wkt]{srs_to_wkt()}}.}

\item{srs_to}{Character string specifying the output spatial reference
system. May be in WKT format or any of the formats supported by
\code{\link[=srs_to_wkt]{srs_to_wkt()}}.}
}
\value{
Numeric matrix of geospatial (x, y) coordinates in the projection
specified by \code{srs_to} (potentially also with z, or z and t columns).
}
\description{
\code{transform_xy()} transforms geospatial x, y coordinates to a new
projection. The input points may optionally have z vertices (x, y, z) or
time values (x, y, z, t).
Wrapper for \code{OGRCoordinateTransformation::Transform()} in the GDAL Spatial
Reference System C++ API.
}
\note{
\code{transform_xy()} uses traditional GIS order for the input and output xy
(i.e., longitude/latitude ordered for geographic coordinates).

Input points that contain missing values (\code{NA}) will be assigned \code{NA} in
the output and a warning emitted. Input points that fail to transform
with the GDAL API call will also be assigned \code{NA} in the output with a
specific warning indicating that case.
}
\examples{
pt_file <- system.file("extdata/storml_pts.csv", package="gdalraster")
pts <- read.csv(pt_file)
print(pts)
# id, x, y in NAD83 / UTM zone 12N
# transform to NAD83 / CONUS Albers
transform_xy(pts = pts[, -1], srs_from = "EPSG:26912", srs_to = "EPSG:5070")
}
\seealso{
\code{\link[=srs_to_wkt]{srs_to_wkt()}}, \code{\link[=inv_project]{inv_project()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{get_cache_max}
\alias{get_cache_max}
\title{Get the maximum memory size available for the GDAL block cache}
\usage{
get_cache_max(units = "MB")
}
\arguments{
\item{units}{Character string specifying units for the return value. One of
\code{"MB"} (the default), \code{"GB"}, \code{"KB"} or \code{"bytes"} (values of \code{"byte"},
\code{"B"} and empty string \code{""} are also recognized to mean bytes).}
}
\value{
A numeric value carrying the \code{integer64} class attribute. Maximum
cache memory available in the requested units.
}
\description{
\code{get_cache_max()} returns the maximum amount of memory available to the
GDALRasterBlock caching system for caching raster read/write data. Wrapper
of \code{GDALGetCacheMax64()} with return value in MB by default.
}
\details{
The first time this function is called, it will read the \code{GDAL_CACHEMAX}
configuration option to initialize the maximum cache memory. The value of
the configuration option can be expressed as x\% of the usable physical RAM
(which may potentially be used by other processes). Otherwise it is
expected to be a value in MB.
As of GDAL 3.10, the default value, if \code{GDAL_CACHEMAX} has not been set
explicitly, is 5\% of usable physical RAM.
}
\note{
The value of the \code{GDAL_CACHEMAX} configuration option is only consulted the
first time the cache size is requested (i.e., it must be set as a
configuration option prior to any raster I/O during the current session).
To change this value programmatically during operation of the program it is
better to use \code{\link[=set_cache_max]{set_cache_max()}} (in which case, always given in bytes).
}
\examples{
get_cache_max()
}
\seealso{
\href{https://gdal.org/en/stable/user/configoptions.html#performance-and-caching}{GDAL_CACHEMAX configuration option}

\code{\link[=get_config_option]{get_config_option()}}, \code{\link[=set_config_option]{set_config_option()}}, \code{\link[=get_usable_physical_ram]{get_usable_physical_ram()}},
\code{\link[=get_cache_used]{get_cache_used()}}, \code{\link[=set_cache_max]{set_cache_max()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_mkdir}
\alias{vsi_mkdir}
\title{Create a directory}
\usage{
vsi_mkdir(path, mode = "0755", recursive = FALSE)
}
\arguments{
\item{path}{Character string. The path to the directory to create.}

\item{mode}{Character string. The permissions mode in octal with prefix
\code{0}, e.g., \code{"0755"} (the default).}

\item{recursive}{Logical scalar. \code{TRUE} to create the directory and its
ancestors. Defaults to \code{FALSE}.}
}
\value{
\code{0} on success or \code{-1} on an error.
}
\description{
\code{vsi_mkdir()} creates a new directory with the indicated mode.
For POSIX-style systems, the mode is modified by the file creation mask
(umask). However, some file systems and platforms may not use umask, or
they may ignore the mode completely. So a reasonable cross-platform
default mode value is \code{0755}.
With \code{recursive = TRUE}, creates a directory and all its ancestors.
This function is a wrapper for \code{VSIMkdir()} and \code{VSIMkdirRecursive()} in
the GDAL Common Portability Library.
}
\examples{
new_dir <- file.path(tempdir(), "newdir")
vsi_mkdir(new_dir)
vsi_stat(new_dir, "type")
vsi_rmdir(new_dir)
}
\seealso{
\code{\link[=vsi_read_dir]{vsi_read_dir()}}, \code{\link[=vsi_rmdir]{vsi_rmdir()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{get_config_option}
\alias{get_config_option}
\title{Get GDAL configuration option}
\usage{
get_config_option(key)
}
\arguments{
\item{key}{Character name of a configuration option.}
}
\value{
Character. The value of a (key, value) option previously set with
\code{set_config_option()}. An empty string (\code{""}) is returned if \code{key} is not
found.
}
\description{
\code{get_config_option()} gets the value of GDAL runtime configuration option.
Configuration options are essentially global variables the user can set.
They are used to alter the default behavior of certain raster format
drivers, and in some cases the GDAL core. For a full description and
listing of available options see
\url{https://gdal.org/en/stable/user/configoptions.html}.
}
\examples{
## this option is set during initialization of the gdalraster package
get_config_option("OGR_CT_FORCE_TRADITIONAL_GIS_ORDER")
}
\seealso{
\code{\link[=set_config_option]{set_config_option()}}

\code{vignette("gdal-config-quick-ref")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vsifile.R
\name{vsi_constants}
\alias{vsi_constants}
\alias{SEEK_SET}
\alias{SEEK_CUR}
\alias{SEEK_END}
\title{Constants for VSIFile$seek()}
\usage{
SEEK_SET

SEEK_CUR

SEEK_END
}
\description{
These are package global constants for convenience in calling
\code{VSIFile$seek()}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{has_geos}
\alias{has_geos}
\title{Is GEOS available?}
\usage{
has_geos()
}
\value{
Logical. \code{TRUE} if GEOS is available, otherwise \code{FALSE}.
}
\description{
\code{has_geos()} returns a logical value indicating whether GDAL was built
against the GEOS library. GDAL built with GEOS is a system requirement
as of \code{gdalraster} 1.10.0, so this function will always return \code{TRUE}
(may be removed in a future version).
}
\examples{
has_geos()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/running_stats.R
\name{RunningStats-class}
\alias{RunningStats-class}
\alias{Rcpp_RunningStats}
\alias{Rcpp_RunningStats-class}
\alias{RunningStats}
\title{Class to calculate mean and variance in one pass}
\arguments{
\item{na_rm}{Logical scalar. \code{TRUE} to remove \code{NA} from the input data (the
default) or \code{FALSE} to retain \code{NA}.}
}
\value{
An object of class \code{RunningStats}. A \code{RunningStats} object
maintains the current minimum, maximum, mean, variance, sum and count of
values that have been read from the stream. It can be updated repeatedly
with new values (i.e., chunks of data read from the input stream), but its
memory footprint is negligible. Class methods for updating with new values,
and retrieving the current values of statistics, are described in Details.
}
\description{
\code{RunningStats} computes summary statistics on a data stream efficiently.
Mean and variance are calculated with Welford's online algorithm
(\url{https://en.wikipedia.org/wiki/Algorithms_for_calculating_variance}).
The min, max, sum and count are also tracked. The input data values are not
stored in memory, so this class can be used to compute statistics for very
large data streams.

\code{RunningStats} is a C++ class exposed directly to \R (via
\code{RCPP_EXPOSED_CLASS}). Methods of the class are accessed using the \code{$}
operator.
}
\note{
The intended use is computing summary statistics for specific subsets or
zones of a raster that could be defined in various ways and are generally
not contiguous. The algorithm as implemented here incurs the cost of
floating point division for each new value updated (i.e., per pixel), but is
reasonably efficient for the use case. Note that GDAL internally uses an
optimized version of Welford's algorithm to compute raster statistics as
described in detail by Rouault, 2016
(\url{https://github.com/OSGeo/gdal/blob/master/gcore/statistics.txt}).
The class method \code{GDALRaster$getStatistics()} is a GDAL API wrapper that
computes statistics for a whole raster band.
}
\section{Usage (see Details)}{


\if{html}{\out{<div class="sourceCode">}}\preformatted{## Constructor
rs <- new(RunningStats, na_rm)

## Methods
rs$update(newvalues)
rs$get_count()
rs$get_mean()
rs$get_min()
rs$get_max()
rs$get_sum()
rs$get_var()
rs$get_sd()
rs$reset()
}\if{html}{\out{</div>}}
}

\section{Details}{

\subsection{Constructor}{

\code{new(RunningStats, na_rm)}\cr
Returns an object of class \code{RunningStats}. The \code{na_rm} argument
defaults to \code{TRUE} if omitted.
}

\subsection{Methods}{

\code{$update(newvalues)}\cr
Updates the \code{RunningStats} object with a numeric vector of \code{newvalues}
(i.e., a chunk of values from the data stream). No return value, called
for side effects.

\code{$get_count()}\cr
Returns the count of values received from the data stream.

\code{$get_mean()}\cr
Returns the mean of values received from the data stream.

\code{$get_min()}\cr
Returns the minimum value received from the data stream.

\code{$get_max()}\cr
Returns the maximum value received from the data stream.

\code{$get_sum()}\cr
Returns the sum of values received from the data stream.

\code{$get_var()}\cr
Returns the variance of values from the data stream
(denominator n - 1).

\code{$get_sd()}\cr
Returns the standard deviation of values from the data stream
(denominator n - 1).

\code{$reset()}\cr
Clears the \code{RunningStats} object to its initialized state (count = 0).
No return value, called for side effects.
}
}

\examples{
set.seed(42)
(rs <- new(RunningStats, na_rm = TRUE))

chunk <- runif(1000)
rs$update(chunk)
object.size(rs)

rs$get_count()
length(chunk)

rs$get_mean()
mean(chunk)

rs$get_min()
min(chunk)

rs$get_max()
max(chunk)

rs$get_var()
var(chunk)

rs$get_sd()
sd(chunk)

\donttest{
## 10^9 values read in 10,000 chunks
## should take under 1 minute on most PC hardware
for (i in 1:1e4) {
  chunk <- runif(1e5)
  rs$update(chunk)
}
rs$get_count()
rs$get_mean()
rs$get_var()

object.size(rs)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom.R
\name{bbox_intersect}
\alias{bbox_intersect}
\alias{bbox_union}
\title{Bounding box intersection / union}
\usage{
bbox_intersect(x, as_wkt = FALSE)

bbox_union(x, as_wkt = FALSE)
}
\arguments{
\item{x}{Either a character vector of raster file names, or a list with
each element a bounding box numeric vector (xmin, ymin, xmax, ymax).}

\item{as_wkt}{Logical. \code{TRUE} to return the bounding box as a polygon
in OGC WKT format, or \code{FALSE} to return as a numeric vector.}
}
\value{
The intersection (\code{bbox_intersect()}) or union (\code{bbox_union()})
of inputs.
If \code{as_wkt = FALSE}, a numeric vector of length four containing
xmin, ymin, xmax, ymax. If \code{as_wkt = TRUE}, a character string
containing OGC WKT for the bbox as POLYGON.
}
\description{
\code{bbox_intersect()} returns the bounding box intersection, and
\code{bbox_union()} returns the bounding box union, for input of
either raster file names or list of bounding boxes. All of the inputs
must be in the same projected coordinate system.
}
\examples{
bbox_list <-list()

elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
ds <- new(GDALRaster, elev_file)
bbox_list[[1]] <- ds$bbox()
ds$close()

b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
ds <- new(GDALRaster, b5_file)
bbox_list[[2]] <- ds$bbox()
ds$close()

bnd <- "POLYGON ((324467.3 5104814.2, 323909.4 5104365.4, 323794.2
5103455.8, 324970.7 5102885.8, 326420.0 5103595.3, 326389.6 5104747.5,
325298.1 5104929.4, 325298.1 5104929.4, 324467.3 5104814.2))"
bbox_list[[3]] <- bbox_from_wkt(bnd)

print(bbox_list)
bbox_intersect(bbox_list)
bbox_union(bbox_list)
}
\seealso{
\code{\link[=bbox_from_wkt]{bbox_from_wkt()}}, \code{\link[=bbox_to_wkt]{bbox_to_wkt()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_create.R
\name{create}
\alias{create}
\title{Create a new uninitialized raster}
\usage{
create(
  format,
  dst_filename,
  xsize,
  ysize,
  nbands,
  dataType,
  options = NULL,
  return_obj = FALSE
)
}
\arguments{
\item{format}{Character string giving a raster format short name
(e.g., \code{"GTiff"}).}

\item{dst_filename}{Character string giving the filename to create.}

\item{xsize}{Integer width of raster in pixels.}

\item{ysize}{Integer height of raster in pixels.}

\item{nbands}{Integer number of bands.}

\item{dataType}{Character string containing the data type name.
(e.g., common data types include Byte (or UInt8 in GDAL >=3.13), Int16,
UInt16, Int32, Float32).}

\item{options}{Optional list of format-specific creation options in a
character vector of \code{"NAME=VALUE"} pairs
(e.g., \code{options = c("COMPRESS=LZW")} to set LZW
compression during creation of a GTiff file).
The APPEND_SUBDATASET=YES option can be
specified to avoid prior destruction of existing dataset.}

\item{return_obj}{Logical scalar. If \code{TRUE}, an object of class
\code{\link{GDALRaster}} opened on the newly created dataset will be
returned, otherwise returns a logical value. Defaults to \code{FALSE}.}
}
\value{
By default, returns a logical value indicating success (invisible
\code{TRUE}, output written to \code{dst_filename}). An error is raised if the
operation fails. An object of class \code{\link{GDALRaster}} open on the
output dataset will be returned if \code{return_obj = TRUE}.
}
\description{
\code{create()} makes an empty raster in the specified format.
}
\note{
\code{dst_filename} may be an empty string (\code{""}) with \code{format = "MEM"} and
\code{return_obj = TRUE} to create an In-memory Raster
(\url{https://gdal.org/en/stable/drivers/raster/mem.html}).
}
\examples{
new_file <- file.path(tempdir(), "newdata.tif")
ds <- create(format = "GTiff",
             dst_filename = new_file,
             xsize = 143,
             ysize = 107,
             nbands = 1,
             dataType = "Int16",
             return_obj = TRUE)

# EPSG:26912 - NAD83 / UTM zone 12N
ds$setProjection(epsg_to_wkt(26912))

gt <- c(323476, 30, 0, 5105082, 0, -30)
ds$setGeoTransform(gt)

ds$setNoDataValue(band = 1, -9999)
ds$fillRaster(band = 1, -9999, 0)

# ...

# close the dataset when done
ds$close()
\dontshow{deleteDataset(new_file)}
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster-class}}, \code{\link[=createCopy]{createCopy()}}, \code{\link[=getCreationOptions]{getCreationOptions()}},
\code{\link[=rasterFromRaster]{rasterFromRaster()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_helpers.R
\name{dump_open_datasets}
\alias{dump_open_datasets}
\title{Report open datasets}
\usage{
dump_open_datasets()
}
\value{
Number of open datasets.
}
\description{
\code{dump_open_datasets()} dumps a list of all open datasets (shared or not) to
the console. This function is primarily intended to assist in debugging
"dataset leaks" and reference counting issues. The information reported
includes the dataset name, referenced count, shared status, driver name,
size, and band count. This a wrapper for \code{GDALDumpOpenDatasets()} with
output to the console.
}
\examples{
elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
ds <- new(GDALRaster, elev_file)
dump_open_datasets()
ds2 <- new(GDALRaster, elev_file)
dump_open_datasets()
# open without using shared mode
ds3 <- new(GDALRaster, elev_file, read_only = TRUE,
           open_options = NULL, shared = FALSE)
dump_open_datasets()
ds$close()
dump_open_datasets()
ds2$close()
dump_open_datasets()
ds3$close()
dump_open_datasets()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_get_fs_prefixes}
\alias{vsi_get_fs_prefixes}
\title{Return the list of virtual file system handlers currently registered}
\usage{
vsi_get_fs_prefixes()
}
\value{
Character vector containing prefixes of the virtual file system
handlers.
}
\description{
\code{vsi_get_fs_prefixes()} returns the list of prefixes for virtual file
system handlers currently registered (e.g., \code{"/vsimem/"}, \code{"/vsicurl/"},
etc). Wrapper for \code{VSIGetFileSystemsPrefixes()} in the GDAL API.
}
\examples{
vsi_get_fs_prefixes()
}
\seealso{
\code{\link[=vsi_get_fs_options]{vsi_get_fs_options()}}

\url{https://gdal.org/en/stable/user/virtual_file_systems.html}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{deleteDataset}
\alias{deleteDataset}
\title{Delete named dataset}
\usage{
deleteDataset(filename, format = "")
}
\arguments{
\item{filename}{Filename to delete (should not be open in a \code{GDALRaster}
object).}

\item{format}{Raster format short name (e.g., "GTiff"). If set to empty
string \code{""} (the default), will attempt to guess the raster format from
\code{filename}.}
}
\value{
Logical \code{TRUE} if no error or \code{FALSE} on failure.
}
\description{
\code{deleteDataset()} will attempt to delete the named dataset in a format
specific fashion. Full featured drivers will delete all associated files,
database objects, or whatever is appropriate. The default behavior when no
format specific behavior is provided is to attempt to delete all the files
that would be returned by \code{GDALRaster$getFileList()} on the dataset.
The named dataset should not be open in any existing \code{GDALRaster} objects
when \code{deleteDataset()} is called. Wrapper for \code{GDALDeleteDataset()} in the
GDAL API.
}
\note{
If \code{format} is set to an empty string \code{""} (the default) then the function
will try to identify the driver from \code{filename}. This is done internally in
GDAL by invoking the \code{Identify} method of each registered \code{GDALDriver} in
turn. The first driver that successful identifies the file name will be
returned. An error is raised if a format cannot be determined from the
passed file name.
}
\examples{
b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
b5_tmp <- file.path(tempdir(), "b5_tmp.tif")
file.copy(b5_file,  b5_tmp)

ds <- new(GDALRaster, b5_tmp)
ds$buildOverviews("BILINEAR", levels = c(2, 4, 8), bands = c(1))
files <- ds$getFileList()
print(files)
ds$close()
file.exists(files)
deleteDataset(b5_tmp)
file.exists(files)
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster-class}}, \code{\link[=create]{create()}}, \code{\link[=createCopy]{createCopy()}},
\code{\link[=copyDatasetFiles]{copyDatasetFiles()}}, \code{\link[=renameDataset]{renameDataset()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{copyDatasetFiles}
\alias{copyDatasetFiles}
\title{Copy the files of a dataset}
\usage{
copyDatasetFiles(new_filename, old_filename, format = "")
}
\arguments{
\item{new_filename}{New name for the dataset (copied to).}

\item{old_filename}{Old name for the dataset (copied from).}

\item{format}{Raster format short name (e.g., "GTiff"). If set to empty
string \code{""} (the default), will attempt to guess the raster format from
\code{old_filename}.}
}
\value{
Logical \code{TRUE} if no error or \code{FALSE} on failure.
}
\description{
\code{copyDatasetFiles()} copies all the files associated with a dataset.
Wrapper for \code{GDALCopyDatasetFiles()} in the GDAL API.
}
\note{
If \code{format} is set to an empty string \code{""} (the default) then the function
will try to identify the driver from \code{old_filename}. This is done
internally in GDAL by invoking the \code{Identify} method of each registered
\code{GDALDriver} in turn. The first driver that successful identifies the file
name will be returned. An error is raised if a format cannot be determined
from the passed file name.
}
\examples{
lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
ds <- new(GDALRaster, lcp_file)
ds$getFileList()
ds$close()

lcp_tmp <- file.path(tempdir(), "storm_lake_copy.lcp")
copyDatasetFiles(lcp_tmp, lcp_file)
ds_copy <- new(GDALRaster, lcp_tmp)
ds_copy$getFileList()
ds_copy$close()

deleteDataset(lcp_tmp)
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster-class}}, \code{\link[=create]{create()}}, \code{\link[=createCopy]{createCopy()}},
\code{\link[=deleteDataset]{deleteDataset()}}, \code{\link[=renameDataset]{renameDataset()}}, \code{\link[=vsi_copy_file]{vsi_copy_file()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_is_local}
\alias{vsi_is_local}
\title{Returns if the file/filesystem is "local".}
\usage{
vsi_is_local(filename)
}
\arguments{
\item{filename}{Character string. The path of the filesystem object to be
tested.}
}
\value{
Logical scalar. \code{TRUE} if if the input file path is local.
}
\description{
\code{vsi_is_local()} returns whether the file/filesystem is "local".
Wrapper for \code{VSIIsLocal()} in the GDAL API. Requires GDAL >= 3.6.
}
\note{
The concept of local is mostly by opposition with a network / remote file
system whose access time can be long.

/vsimem/ is considered to be a local file system, although a
non-persistent one.
}
\examples{
# Requires GDAL >= 3.6
if (gdal_version_num() >= gdal_compute_version(3, 6, 0))
  print(vsi_is_local("/vsimem/test-mem-file.tif"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_helpers.R
\name{rvector_to_MEM}
\alias{rvector_to_MEM}
\alias{vector_to_MEM}
\title{Create a GDAL in-memory dataset from R data without copying}
\usage{
rvector_to_MEM(
  data,
  xsize,
  ysize,
  nbands = 1L,
  gt = NULL,
  bbox = NULL,
  srs = NULL
)

vector_to_MEM(
  data,
  xsize,
  ysize,
  nbands = 1L,
  gt = NULL,
  bbox = NULL,
  srs = NULL
)
}
\arguments{
\item{data}{An R vector of type \code{"double"}, \code{"integer"}, \code{"raw"} or
\code{"complex"}, containing pixel values to be exposed as a GDAL in-memory
raster. The pixels must be arranged in left-to-right, top-to-bottom order
interleaved by band. \code{length(data)} must equal \code{xsize * ysize * nbands}.}

\item{xsize}{Integer value giving the number of raster columns.}

\item{ysize}{Integer value giving the number of raster rows.}

\item{nbands}{Integer value giving the number of raster bands.}

\item{gt}{A numeric vector of length six containing the affine geotransform
for the raster. Defaults to \code{c(0, 1, 0, 0, 0, 1)} if neither \code{gt} nor \code{bbox}
are given.}

\item{bbox}{A numeric vector of length four containing the raster bounding
box geospatial coordinates (\code{c(xmin, ymin, xmax, ymax)}). Ignored if \code{gt} is
given.}

\item{srs}{Optional character string containing the raster spatial reference
coordinate system as a WKT string. \code{\link[=epsg_to_wkt]{epsg_to_wkt()}} or \code{\link[=srs_to_wkt]{srs_to_wkt()}} can be
used to convert from other formats to WKT if necessary.}
}
\value{
An object of class \code{GDALRaster} providing a GDAL MEM dataset with
write access pointing to the underlying C array for \code{data}. The R object
referenced by \code{data} is protected from garbage collection during the lifetime
of the returned dataset, i.e., until its \verb{$close()} is called or the dataset
object itself is garbage collected. An error is raised if creation of the
MEM dataset fails.
}
\description{
\code{rvector_to_MEM()} creates a GDAL MEM dataset that references pixel data in
an existing R vector. It returns an object of class \code{GDALRaster} for a
writable in-memory dataset without copying the source data. The underlying
R object is protected from garbage collection until the returned dataset is
closed. GDAL MEM datasets support most kinds of auxiliary information
including metadata, coordinate systems, georeferencing, color interpretation,
nodata, color tables and all pixel data types (see Details).
}
\details{
The returned dataset is open with write access. Methods of the \code{GDALRaster}
object can be called to modify dataset and band properties, e.g., to set
nodata values, metadata items, band descriptions, color tables, etc. The
original R vector will be modified in place if the object's \verb{$write()}
method is used.

The MEM dataset will have a GDAL data type matching the type of the
input vector:
\tabular{rl}{
\strong{R vector type}  \tab  \strong{GDAL raster type}\cr
double             \tab  Float64\cr
integer            \tab  Int32\cr
raw                \tab  UInt8 (Byte in GDAL < 3.13)\cr
complex            \tab  CFloat64
}

\code{vector_to_MEM()} is an alias of \code{rvector_to_MEM()} for backward
compatibility. It is a deprecated name of the function that will be removed
in a future version. Please use \code{rvector_to_MEM()} instead.
}
\note{
MEM datasets also support \code{addBand()} from existing R data without copying
(see Examples).

The \verb{$close()} method should be called when the \code{GDALRaster} object is no
longer needed so that resources can be freed. MEM datasets cannot be
re-opened once the object's \verb{$close()} method has been called.

\code{vector_to_MEM()} is a deprecated name for the function, currently set as
an alias of \code{rvector_to_MEM()}. \emph{The \code{vector_to_MEM()} alias will be removed
in a future version}.
}
\examples{
v <- sample(0:255, 20, replace = TRUE)
(ds_mem <- rvector_to_MEM(v, xsize = 5, ysize = 4))

all((ds_mem$read(1, 0, 0, 5, 4, 5, 4) == v))

ds_mem$write(1, 0, 0, 5, 4, (v * -1))
print(v)

ds_mem$close()

# MEM also supports no-copy addBand() from R data
xsize <- 400
ysize <- 300
r <- sample(0:255, xsize * ysize, replace = TRUE) |> as.raw()
ds_mem <- rvector_to_MEM(r, xsize, ysize)
ds_mem$setRasterColorInterp(1, "Red")

g <- sample(0:255, xsize * ysize, replace = TRUE) |> as.raw()
ds_mem$addBand("Byte", g)
ds_mem$setRasterColorInterp(2, "Green")

b <- sample(0:255, xsize * ysize, replace = TRUE) |> as.raw()
ds_mem$addBand("Byte", b)
ds_mem$setRasterColorInterp(3, "Blue")

ds_mem$info()

plot_raster(ds_mem, main = "random RGB")
ds_mem$close()
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster-class}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{ogrinfo}
\alias{ogrinfo}
\title{Retrieve information about a vector data source}
\usage{
ogrinfo(
  dsn,
  layers = NULL,
  cl_arg = as.character(c("-so", "-nomd")),
  open_options = NULL,
  read_only = TRUE,
  cout = TRUE
)
}
\arguments{
\item{dsn}{Character string. Data source name (e.g., filename, database
connection string, etc.)}

\item{layers}{Optional character vector of layer names in the source
dataset.}

\item{cl_arg}{Optional character vector of command-line arguments for
the \code{ogrinfo} command-line utility in GDAL (see URL above for
reference). The default is \code{c("-so", "-nomd")} (see Note).}

\item{open_options}{Optional character vector of dataset open options.}

\item{read_only}{Logical scalar. \code{TRUE} to open the data source read-only
(the default), or \code{FALSE} to open with write access.}

\item{cout}{Logical scalar. \code{TRUE} to write info to the standard C output
stream (the default). \code{FALSE} to suppress console output.}
}
\value{
Invisibly, a character string containing information about the
vector dataset, or empty string (\code{""}) in case of error.
}
\description{
\code{ogrinfo()} is a wrapper of the \command{ogrinfo} command-line
utility (see \url{https://gdal.org/en/stable/programs/ogrinfo.html}).
This function lists information about an OGR-supported data source.
It is also possible to edit data with SQL statements.
Refer to the GDAL documentation at the URL above for a description of
command-line arguments that can be passed in \code{cl_arg}.
Requires GDAL >= 3.7.
}
\note{
The command-line argument \code{-so} provides a summary only, i.e., does not
include details about every single feature of a layer.
\code{-nomd} suppresses metadata printing. Some datasets may contain a lot of
metadata strings.
}
\examples{
\dontshow{if (gdal_version_num() >= gdal_compute_version(3, 7, 0)) withAutoprint(\{ # examplesIf}
src <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")

# Get the names of the layers in a GeoPackage file
ogrinfo(src)

# Summary of a layer
ogrinfo(src, "mtbs_perims")

# Query an attribute to restrict the output of the features in a layer
args <- c("-ro", "-nomd", "-where", "ig_year = 2020")
ogrinfo(src, "mtbs_perims", args)

# Copy to a temporary in-memory file that is writeable
src_mem <- paste0("/vsimem/", basename(src))
vsi_copy_file(src, src_mem)

# Add a column to a layer
args <- c("-sql", "ALTER TABLE mtbs_perims ADD burn_bnd_ha float")
ogrinfo(src_mem, cl_arg = args, read_only = FALSE)

# Update values of the column with SQL and specify a dialect
sql <- "UPDATE mtbs_perims SET burn_bnd_ha = (burn_bnd_ac / 2.471)"
args <- c("-dialect", "sqlite", "-sql", sql)
ogrinfo(src_mem, cl_arg = args, read_only = FALSE)
\dontshow{\}) # examplesIf}
}
\seealso{
\code{\link[=ogr2ogr]{ogr2ogr()}}, \link{ogr_manage}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cmb_table.R
\name{CmbTable-class}
\alias{CmbTable-class}
\alias{Rcpp_CmbTable}
\alias{Rcpp_CmbTable-class}
\alias{CmbTable}
\title{Class for counting unique combinations of integers}
\arguments{
\item{keyLen}{The number of integer values comprising each combination.}

\item{varNames}{Optional character vector of names for the variables in the
combination.}
}
\value{
An object of class \code{CmbTable}. Contains a hash table having a
vector of \code{keyLen} integers as the key, and the count of occurrences of each
unique integer combination as the value. Class methods that operate on the
hash table are described in Details.
}
\description{
\code{CmbTable} implements a hash table having a vector of integers as the key,
and the count of occurrences of each unique integer combination as the
value. A unique ID is assigned to each unique combination of input values.

\code{CmbTable} is a C++ class exposed directly to \R (via \code{RCPP_EXPOSED_CLASS}).
Methods of the class are accessed using the \code{$} operator. \strong{Note that all
arguments to class methods are required and must be given in the
order documented.} Naming the arguments is optional but may be preferred
for readability.
}
\section{Usage (see Details)}{


\if{html}{\out{<div class="sourceCode">}}\preformatted{## Constructors
cmb <- new(CmbTable, keyLen)
# or, giving the variable names:
cmb <- new(CmbTable, keyLen, varNames)

## Methods
cmb$update(int_cmb, incr)
cmb$updateFromMatrix(int_cmbs, incr)
cmb$updateFromMatrixByRow(int_cmbs, incr)
cmb$asDataFrame()
cmb$asMatrix()
}\if{html}{\out{</div>}}
}

\section{Details}{

\subsection{Constructors}{

\code{new(CmbTable, keyLen)}\cr
Default variable names will be assigned as \code{V1}, \code{V2}, ....
Returns an object of class \code{CmbTable}.

\code{new(CmbTable, keyLen, varNames)}\cr
Alternate constructor to specify variable names.
Returns an object of class \code{CmbTable}.
}

\subsection{Methods}{

\code{$update(int_cmb, incr)}\cr
Updates the hash table for the integer combination in the numeric vector
\code{int_cmb} (will be coerced to integer by truncation).
If this combination exists in the table, its count will be
incremented by \code{incr}. If the combination is not found in the table,
it will be inserted with count set to \code{incr}. The caller should ensure that
the length of the input vector is equal to the key length (\code{keyLen}) when
using this method. Returns the unique ID assigned to this combination.
Combination IDs are sequential whole numbers starting at \code{1}.

\code{$updateFromMatrix(int_cmbs, incr)}\cr
This method is the same as \code{$update()} but for a numeric matrix of
integer combinations \code{int_cmbs} (coerced to integer by truncation).
The matrix is arranged with each column vector forming an integer
combination. For example, the rows of the matrix could be
one row each from a set of \code{keyLen} rasters all read at the
same extent and pixel resolution (i.e., row-by-row raster overlay).
The method calls \code{$update()} on each combination (each column of
\code{int_cmbs}), incrementing count by \code{incr} for existing
combinations, or inserting new combinations with count set to \code{incr}.
Returns a numeric vector of length \code{ncol(int_cmbs)} containing the
IDs assigned to the combinations.

\code{$updateFromMatrixByRow(int_cmbs, incr)}\cr
This method is the same as \code{$updateFromMatrix()} above except the
integer combinations are in rows of the matrix \code{int_cmbs} (columns
are the variables).
The method calls \code{$update()} on each combination (each row of
\code{int_cmbs}), incrementing count by \code{incr} for existing
combinations, or inserting new combinations with count set to \code{incr}.
Returns a numeric vector of length \code{nrow(int_cmbs)} containing the
IDs assigned to the combinations.

\code{$asDataFrame()}\cr
Returns the \code{CmbTable} as a data frame with column \code{cmbid} containing
the unique combination IDs, column \code{count} containing the counts of
occurrences, and \code{keyLen} columns (with names from \code{varNames}) containing
the integer values comprising each unique combination.

\code{$asMatrix()}\cr
Returns the \code{CmbTable} as a matrix with column \code{1} (\code{cmbid})
containing the unique combination IDs, column \code{2} (\code{count})
containing the counts of occurrences, and columns \code{3:keyLen+2}
(with names from \code{varNames}) containing the integer values comprising each
unique combination.
}
}

\examples{
m <- matrix(c(1,2,3,1,2,3,4,5,6,1,3,2,4,5,6,1,1,1), 3, 6, byrow = FALSE)
rownames(m) <- c("layer1", "layer2", "layer3")
print(m)

cmb <- new(CmbTable, 3, rownames(m))
cmb

cmb$updateFromMatrix(m, 1)
cmb$asDataFrame()

cmb$update(c(4,5,6), 1)
cmb$update(c(1,3,5), 1)
cmb$asDataFrame()

# same as above but matrix arranged with integer combinations in the rows
m <- matrix(c(1,2,3,1,2,3,4,5,6,1,3,2,4,5,6,1,1,1), 6, 3, byrow = TRUE)
colnames(m) <- c("V1", "V2", "V3")
print(m)

cmb <- new(CmbTable, 3)
cmb$updateFromMatrixByRow(m, 1)
cmb$asDataFrame()

cmb$update(c(4,5,6), 1)
cmb$update(c(1,3,5), 1)
cmb$asDataFrame()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ogr_define.R
\name{ogr_define}
\alias{ogr_define}
\alias{ogr_def_layer}
\alias{ogr_def_field}
\alias{ogr_def_geom_field}
\alias{ogr_def_field_domain}
\title{OGR feature class definition for vector data}
\usage{
ogr_def_layer(geom_type, geom_fld_name = "geom", srs = NULL)

ogr_def_field(
  fld_type,
  fld_subtype = NULL,
  fld_width = NULL,
  fld_precision = NULL,
  is_nullable = NULL,
  is_unique = NULL,
  default_value = NULL,
  domain_name = NULL
)

ogr_def_geom_field(geom_type, srs = NULL, is_nullable = NULL)

ogr_def_field_domain(
  domain_type,
  domain_name,
  description = NULL,
  fld_type = NULL,
  fld_subtype = "OFSTNone",
  split_policy = "DEFAULT_VALUE",
  merge_policy = "DEFAULT_VALUE",
  coded_values = NULL,
  range_min = NULL,
  min_is_inclusive = TRUE,
  range_max = NULL,
  max_is_inclusive = TRUE,
  glob = ""
)
}
\arguments{
\item{geom_type}{Character string specifying a geometry type (see Details).}

\item{geom_fld_name}{Character string specifying a geometry field name
Defaults to \code{"geom"}.}

\item{srs}{Character string containing a spatial reference system definition
as OGC WKT or other well-known format (e.g., the input formats usable with
\code{\link[=srs_to_wkt]{srs_to_wkt()}}).}

\item{fld_type}{Character string containing the name of a field data type
(e.g., \code{"OFTInteger"}, \code{"OFTInteger64"}, \code{"OFTReal"}, \code{"OFTString"}, ...).}

\item{fld_subtype}{Character string containing the name of a field subtype.
One of \code{"OFSTNone"} (the default), \code{"OFSTBoolean"}, \code{"OFSTInt16"},
\code{"OFSTFloat32"}, \code{"OFSTJSON"}, \code{"OFSTUUID"}.}

\item{fld_width}{Optional integer value specifying max number of characters.}

\item{fld_precision}{Optional integer value specifying number of digits
after the decimal point.}

\item{is_nullable}{Optional NOT NULL field constraint (logical value).
Defaults to \code{TRUE}.}

\item{is_unique}{Optional UNIQUE constraint on the field (logical value).
Defaults to \code{FALSE}.}

\item{default_value}{Optional default value for the field given as a
character string.}

\item{domain_name}{Character string specifying the name of the field domain.
Optional for \code{ogr_def_field()}, required for \code{ogr_def_field_domain()}.}

\item{domain_type}{Character string specifying a field domain type (see
Details). Must be one of \code{"Coded"}, \code{"Range"}, \code{"RangeDateTime"}, \code{"GLOB"}
(case-insensitive).}

\item{description}{Optional character string giving a description of the
field domain.}

\item{split_policy}{Character string specifying the split policy of the
field domain. One of \code{"DEFAULT_VALUE"}, \code{"DUPLICATE"}, \code{"GEOMETRY_RATIO"}
(supported by ESRI File Geodatabase format via OpenFileGDB driver).}

\item{merge_policy}{Character string specifying the merge policy of the
field domain. One of \code{"DEFAULT_VALUE"}, \code{"SUM"}, \code{"GEOMETRY_WEIGHTED"}
(supported by ESRI File Geodatabase format via OpenFileGDB driver).}

\item{coded_values}{Either a vector of the allowed codes, or character
vector of \code{"CODE=VALUE"} pairs (the expanded "value" associated with a code
is optional), or a two-column data frame with (codes, values).
If data frame, the second column of values must be character type (i.e.,
the descriptive text for each code). This argument is required if
\code{domain_type = "Coded"}. Each code should appear only once, but it is the
responsibility of the user to check it.}

\item{range_min}{Minimum value in a Range or RangeDateTime field domain (can
be NULL). The data type must be consistent with with the field type given in
the \code{fld_type} argument.}

\item{min_is_inclusive}{= Logical value, whether the minimum value is
included in the range. Defaults to \code{TRUE}. Required argument if
\code{domain_type} is \code{"Range"} or \code{"RangeDateTime"}.}

\item{range_max}{Maximum value in a Range or RangeDateTime field domain (can
be NULL). The data type must be consistent with with the field type given in
the \code{fld_type} argument.}

\item{max_is_inclusive}{= Logical value, whether the maximum value is
included in the range. Defaults to \code{TRUE}. Required argument if
\code{domain_type} is \code{"Range"} or \code{"RangeDateTime"}.}

\item{glob}{Character string containing the GLOB expression. Required if
\code{domain_type} is \code{"GLOB"}.}
}
\description{
This topic contains documentation and helper functions for defining an
OGR feature class.
A named list containing zero or more attribute field definitions, along with
one or more geometry field definitions, comprise an OGR feature class
definition (a.k.a. layer definition). \code{ogr_def_layer()} initializes such a
list with the geometry type and (optionally) a spatial reference system.
Attribute fields may then be added to the layer definition.
\code{ogr_def_field()} creates an attribute field definition, a list
containing the field's data type and potentially other optional field
properties.
\code{ogr_def_geom_field()} similarly creates a geometry field definition. This
might be used with certain vector formats that support multiple geometry
columns (e.g., PostGIS).
\code{ogr_def_field_domain()} creates a field domain definition. A field domain
is a set of constraints that apply to one or several fields. This is a
concept found, e.g., in ESRI File Geodatabase and in GeoPackage via the
Schema extension (see \url{https://github.com/OSGeo/gdal/pull/3638}).
GDAL >= 3.3 supports reading and writing field domains with certain drivers
(e.g., GPKG and OpenFileGDB).
}
\details{
All features in an OGR Layer share a common schema (feature class), modeled
in GDAL by its \code{OGRFeatureDefn} class. A feature class definition includes
the set of attribute fields and their data types and the geometry field(s).
In \R, a feature class definition is represented as a named list, with names
being the attribute/geometry field names, and each list element holding an
attribute or geometry field definition.

The definition for an attribute field is a named list with elements:

\if{html}{\out{<div class="sourceCode">}}\preformatted{$type       : OGR Field Type ("OFTReal", "OFTString" etc.)
$subtype    : optional ("OFSTBoolean", ...)
$width      : optional max number of characters
$precision  : optional number of digits after the decimal point
$is_nullable: optional NOT NULL constraint (logical value)
$is_unique  : optional UNIQUE constraint (logical value)
$default    : optional default value as character string
$domain     : optional field domain name
$is_geom    : FALSE (the default) for attribute fields
}\if{html}{\out{</div>}}

An OGR field type is specified as a character string with possible values:
\code{OFTInteger}, \code{OFTIntegerList}, \code{OFTReal}, \code{OFTRealList}, \code{OFTString},
\code{OFTStringList}, \code{OFTBinary},  \code{OFTDate}, \code{OFTTime}, \code{OFTDateTime},
\code{OFTInteger64}, \code{OFTInteger64List}.

An optional field subtype is specified as a character string with possible
values:
\code{OFSTNone}, \code{OFSTBoolean}, \code{OFSTInt16}, \code{OFSTFloat32}, \code{OFSTJSON},
\code{OFSTUUID}.

By default, fields are nullable and have no unique constraint. Not-null and
unique constraints are not supported by all format drivers.

A default field value is taken into account by format drivers (generally
those with a SQL interface) that support it at field creation time.
If given in the field definition, \code{default} must be a character string.
The accepted values are \code{"NULL"}, a numeric value (e.g., \code{"0"}), a literal
value enclosed between single quote characters (e.g., \code{"'a default value'"},
with any inner single quote characters escaped by repetition of the single
quote character), \code{"CURRENT_TIMESTAMP"}, \code{"CURRENT_TIME"}, \code{"CURRENT_DATE"}
or a driver-specific expression (that might be ignored by other drivers).
For a datetime literal value, format should be
\code{"'YYYY/MM/DD HH:MM:SS[.sss]'"} (considered as UTC time).

The definition for a geometry field is a named list with elements:

\if{html}{\out{<div class="sourceCode">}}\preformatted{$type       : geom type ("Point", "Polygon", etc.)
$srs        : optional spatial reference as WKT string
$is_nullable: optional NOT NULL constraint (logical value)
$is_geom    : TRUE (required) for geometry fields
}\if{html}{\out{</div>}}

Typically, there is one geometry field on a layer, but some formats support
more than one geometry column per table (e.g., "PostgreSQL / PostGIS" and
"SQLite / Spatialite RDBMS").

Geometry types are specified as a character string containing OGC WKT.
Common types include: \code{Point}, \code{LineString}, \code{Polygon}, \code{MultiPoint},
\code{MultiLineString}, \code{MultiPolygon}. See the GDAL documentation for a list
of all supported geometry types:\cr
\url{https://gdal.org/en/stable/api/vector_c_api.html#_CPPv418OGRwkbGeometryType}

Format drivers may or may not support not-null constraints on attribute and
geometry fields. If they support creating fields with not-null constraints,
this is generally before creating any features to the layer. In some cases,
a not-null constraint may be available as a layer creation option. For
example, GeoPackage format has a layer creation option
\verb{GEOMETRY_NULLABLE=[YES/NO]}.

The definition for a field domain is a named list with elements:

\if{html}{\out{<div class="sourceCode">}}\preformatted{$type             : domain type ("Coded", "Range", "RangeDateTime", "GLOB")
$domain_name      : name of the field domain (character string)
$description      : optional domain description (character string)
$field_type       : OGR Field Type (see attribute field definitions above)
$field_subtype    : optional OGR Field Subtype ("OFSTBoolean", ...)
$split_policy     : split policy of the field domain (see below)
$merge_policy     : merge policy of the field domain (see below)
$coded_values     : vector of allowed codes, or data frame of (codes, values)
$min_value        : minimum value (data type compatible with $field_type)
$min_is_inclusive : whether the minimum value is included in the range
$max_value        : maximum value (data type compatible with $field_type)
$max_is_inclusive : whether the maximum value is included in the range
$glob             : GLOB expression (character string)
}\if{html}{\out{</div>}}

A field domain can be one of three types:
\itemize{
\item \code{Coded}: an enumerated list of allowed codes with their descriptive values
\item \code{Range}: a range constraint (min, max)
\item \code{GLOB}: a GLOB expression (matching expression like \code{"*[a-z][0-1]?"})
}

\code{type} can also be specified as \code{"RangeDateTime"}, a range constraint for
\code{OFTDateTime} fields with \code{min_value} and \code{max_value} given as
\code{"POSIXct"} DateTimes.

Split and merge policies are supported by ESRI File Geodatabase format via
OpenFileGDB driver (or FileGDB driver dependent on FileGDB API library).
When a feature is split in two, \code{split_policy} defines how the value of
attributes following the domain are computed. Possible values are
\code{"DEFAULT_VALUE"} (default value), \code{"DUPLICATE"} (duplicate), and
\code{"GEOMETRY_RATIO"} (new values are computed by the ratio of their
area/length compared to the area/length of the original feature).
When a feature is built by merging two features, \code{merge_policy} defines
how the value of attributes following the domain are computed. Possible
values are \code{"DEFAULT_VALUE"} (default value), \code{"SUM"} (sum), and
\code{"GEOMETRY_WEIGHTED"} (new values are computed as the weighted average of
the source values).
}
\note{
The feature id (FID) is a special property of a feature and not treated as
an attribute of the feature. Additional information is given in the GDAL
documentation for the
\href{https://gdal.org/en/stable/user/ogr_sql_dialect.html#feature-id-fid}{OGR SQL} and
\href{https://gdal.org/en/stable/user/sql_sqlite_dialect.html#feature-id-fid}{SQLite}
SQL dialects. Implications for SQL statements and result sets may depend
on the dialect used.

Some vector formats do not support schema definition prior to creating
features. For example, with GeoJSON only the \emph{Feature} object has a member
with name \emph{properties}. The specification does not require all \emph{Feature}
objects in a collection to have the same schema of properties, nor does
it require all \emph{Feature} objects in a collection to have geometry of the
same type (\url{https://geojson.org/}).
}
\examples{
# create a SQLite data source, with SpatiaLite extensions if available
dsn <- file.path(tempdir(), "test.sqlite")
opt <- NULL
if (has_spatialite()) {
  opt <- "SPATIALITE=YES"
}

# This creates an empty data source. Note that we could also create a layer
# at the same time in this function call, but for this example we do that
# separately, to show creation of a layer on an existing data source.
ogr_ds_create("SQLite", dsn, dsco = opt)

# define a layer
defn <- ogr_def_layer("Point", srs = "EPSG:4326")
defn$my_id <- ogr_def_field("OFTInteger64")
defn$my_description <- ogr_def_field("OFTString")

# create a layer in the existing data source
ogr_ds_test_cap(dsn)$CreateLayer  # TRUE

ogr_layer_create(dsn, "layer1", layer_defn = defn)

ogr_ds_layer_names(dsn)

ogr_layer_field_names(dsn, "layer1")

deleteDataset(dsn)
}
\seealso{
\code{\link[=ogr_ds_create]{ogr_ds_create()}}, \code{\link[=ogr_layer_create]{ogr_layer_create()}}, \code{\link[=ogr_field_create]{ogr_field_create()}}

WKT representation of geometry:\cr
\url{https://en.wikipedia.org/wiki/Well-known_text_representation_of_geometry}

Field domains:\cr
\url{https://desktop.arcgis.com/en/arcmap/latest/manage-data/geodatabases/an-overview-of-attribute-domains.htm}\cr
\url{https://www.geopackage.org/spec/#extension_schema}\cr
\url{https://gdal.org/en/stable/doxygen/classOGRFieldDomain.html#details}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{push_error_handler}
\alias{push_error_handler}
\title{Push a new GDAL CPLError handler}
\usage{
push_error_handler(handler)
}
\arguments{
\item{handler}{Character name of the error handler to push.
One of \code{quiet}, \code{logging} or \code{default}.}
}
\value{
No return value, called for side effects.
}
\description{
\code{push_error_handler()} is a wrapper for
\code{CPLPushErrorHandler()} in the GDAL Common Portability
Library.
This pushes a new error handler on the thread-local error handler stack.
This handler will be used until removed with \code{pop_error_handler()}.
A typical use is to temporarily set \code{CPLQuietErrorHandler()} which doesn't
make any attempt to report passed error or warning messages, but will
process debug messages via \code{CPLDefaultErrorHandler}.
}
\note{
This function is for advanced use cases. It is intended for setting a
\emph{temporary} error handler in a limited segment of code. A global error
handler specific to the R environment is in use by default.

Setting \code{handler = "logging"} will use \code{CPLLoggingErrorHandler()}, error
handler that logs into the file defined by the \code{"CPL_LOG"} configuration
option. Be sure that option is set when using this error handler.

This only affects error reporting from GDAL.

Also note that the configuration option \code{"CPL_LOG_ERRORS"} can be set to
\code{"OFF"} to disable globally the printing of error massages to the console
by GDAL.
}
\examples{
push_error_handler("quiet")
# ...
pop_error_handler()
}
\seealso{
\code{\link[=pop_error_handler]{pop_error_handler()}}, \code{\link[=set_config_option]{set_config_option()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdalraster_proc.R
\name{read_to_nativeRaster}
\alias{read_to_nativeRaster}
\title{Read raster data as nativeRaster}
\usage{
read_to_nativeRaster(
  ds,
  xoff = 0,
  yoff = 0,
  xsize = ds$getRasterXSize(),
  ysize = ds$getRasterYSize(),
  out_xsize = xsize,
  out_ysize = ysize
)
}
\arguments{
\item{ds}{An object of class \code{GDALRaster} in open state, with 1, 3, or 4
bands of Byte/UInt8 data type.}

\item{xoff}{Integer. The pixel (column) offset to the top left corner of the
raster region to be read (zero to start from the left side).}

\item{yoff}{Integer. The line (row) offset to the top left corner of the
raster region to be read (zero to start from the top).}

\item{xsize}{Integer. The width in pixels of the region to be read.}

\item{ysize}{Integer. The height in pixels of the region to be read.}

\item{out_xsize}{Integer. The width in pixels of the output buffer into
which the desired region will be read (e.g., to read a reduced resolution
overview).}

\item{out_ysize}{Integer. The height in pixels of the output buffer into
which the desired region will be read (e.g., to read a reduced resolution
overview).}
}
\value{
An object of class \code{nativeRaster}.
}
\description{
\code{read_to_nativeRaster()} will read from a raster dataset that is already open
in a \code{GDALRaster} object and return a \code{nativeRaster} object suitable for fast
rendering. By default, it attempts to read the full raster extent at full
resolution.
}
\details{
The dataset must have 1, 3, or 4 bands of Byte/UInt8 data type. For 1-band
(grayscale) data, the value is replicated across RGB channels. For 3-band
data, bands are interpreted as RGB. For 4-band data, bands are interpreted
as RGBA.
}
\note{
By default, this function will attempt to read the full raster into memory.
It generally should not be called on large raster datasets using the default
argument values. Use \code{out_xsize} and \code{out_ysize} for quick setting to smallish values,
such as 1024.
}
\examples{
# read an RGB image as nativeRaster
img_file <- system.file("help/figures/logo.png", package="survival")
if (file.exists(img_file)) {
ds <- new(GDALRaster, img_file)
r <- read_to_nativeRaster(ds)
bb <- ds$bbox()  ## will warn for non-spatial image but is harmless
ds$close()
plot(NA, xlab = "", ylab = "", asp = 1, xlim = bb[c(1, 3)], ylim = bb[c(2, 4)])
rasterImage(r, bb[1], bb[2], bb[3], bb[4])
}
}
\seealso{
\code{\link[=read_ds]{read_ds()}}, \code{\link[=GDALRaster]{GDALRaster$readToNativeRaster()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom.R
\name{g_envelope}
\alias{g_envelope}
\title{Obtain the 2D or 3D bounding envelope for input geometries}
\usage{
g_envelope(geom, as_3d = FALSE, quiet = FALSE)
}
\arguments{
\item{geom}{Either a raw vector of WKB or list of raw vectors, or a
character vector containing one or more WKT strings.}

\item{as_3d}{Logical value. \code{TRUE} to return the 3D bounding envelope.
The 2D envelope is returned by default (\code{as_3d = FALSE}).}

\item{quiet}{Logical value, \code{TRUE} to suppress warnings. Defaults to \code{FALSE}.}
}
\value{
Either a numeric vector of length \code{4} containing the 2D envelope
\verb{(xmin, xmax, ymin, ymax)} or of length \code{6} containing the 3D envelope
\verb{(xmin, xmax, ymin, ymax, zmin, zmax)}, or a four-column or six-column
numeric matrix with number of rows equal to the number of input geometries
and column names \verb{("xmin", "xmax", "ymin", "ymax")}, or
\verb{("xmin", "xmax", "ymin", "ymax", "zmin", "zmax")} for the 3D case.
}
\description{
\code{g_envelope()} computes and returns the bounding envelope(s) for the input
geometries. Wrapper of \code{OGR_G_GetEnvelope()} / \code{OGR_G_GetEnvelope3D()} in
the GDAL Geometry API.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/display.R
\name{plot_raster}
\alias{plot_raster}
\title{Display raster data}
\usage{
plot_raster(
  data,
  xsize = NULL,
  ysize = NULL,
  nbands = NULL,
  max_pixels = 2.5e+07,
  col_tbl = NULL,
  maxColorValue = 1,
  normalize = TRUE,
  minmax_def = NULL,
  minmax_pct_cut = NULL,
  col_map_fn = NULL,
  pixel_fn = NULL,
  xlim = NULL,
  ylim = NULL,
  interpolate = TRUE,
  asp = 1,
  axes = TRUE,
  main = "",
  xlab = "x",
  ylab = "y",
  xaxs = "i",
  yaxs = "i",
  legend = FALSE,
  digits = 2,
  na_col = rgb(0, 0, 0, 0),
  ...
)
}
\arguments{
\item{data}{Either a \code{GDALRaster} object from which data will be read, or
a numeric vector of pixel values arranged in left to right, top to
bottom order, or a list of band vectors. If input is vector or list,
the information in attribute \code{gis} will be used if present (see \code{\link[=read_ds]{read_ds()}}),
potentially ignoring values below for \code{xsize}, \code{ysize}, \code{nbands}.}

\item{xsize}{The number of pixels along the x dimension in \code{data}. If \code{data}
is a \code{GDALRaster} object, specifies the size at which the raster will be
read (used for argument \code{out_xsize} in \code{GDALRaster$read()}). By default,
the entire raster will be read at full resolution.}

\item{ysize}{The number of pixels along the y dimension in \code{data}. If \code{data}
is a \code{GDALRaster} object, specifies the size at which the raster will be
read (used for argument \code{out_ysize} in \code{GDALRaster$read()}). By default,
the entire raster will be read at full resolution.}

\item{nbands}{The number of bands in \code{data}. Must be either 1 (grayscale) or
3 (RGB). For RGB, \code{data} are interleaved by band. If \code{nbands} is \code{NULL} (the
default), then \code{nbands = 3} is assumed if the input data contain 3 bands,
otherwise band 1 is used.}

\item{max_pixels}{The maximum number of pixels that the function will
attempt to display (per band). An error is raised if \code{(xsize * ysize)}
exceeds this value. Setting to \code{NULL} turns off this check.}

\item{col_tbl}{A color table as a matrix or data frame with four or five
columns. Column 1 contains the numeric pixel values. Columns 2:4 contain
the intensities of the red, green and blue primaries (\code{0:1} by default,
or use integer \code{0:255} by setting \code{maxColorValue = 255}).
An optional column 5 may contain alpha transparency values, \code{0} for fully
transparent to \code{1} (or \code{maxColorValue}) for opaque (the default if column 5
is missing). If \code{data} is a \code{GDALRaster} object, a built-in color table will
be used automatically if one exists in the dataset.}

\item{maxColorValue}{A number giving the maximum of the color values range
in \code{col_tbl} (see above). The default is \code{1}.}

\item{normalize}{Logical. \code{TRUE} to rescale pixel values so that their
range is \verb{[0,1]}, normalized to the full range of the pixel data by default
(\code{min(data)}, \code{max(data)}, per band). Ignored if \code{col_tbl} is used.
Set \code{normalize} to \code{FALSE} if a color map function is used that
operates on raw pixel values (see \code{col_map_fn} below).}

\item{minmax_def}{Normalize to user-defined min/max values (in terms of
the pixel data, per band). For single-band grayscale, a numeric vector of
length two containing min, max. For 3-band RGB, a numeric vector of length
six containing b1_min, b2_min, b3_min, b1_max, b2_max, b3_max.}

\item{minmax_pct_cut}{Normalize to a truncated range of the pixel data using
percentile cutoffs (removes outliers). A numeric vector of length two giving
the percentiles to use (e.g., \code{c(2, 98)}). Applied per band. Ignored if
\code{minmax_def} is used.}

\item{col_map_fn}{An optional color map function that maps input pixel values
to colors in "#RRGGBB" (or "#RRGGBBAA") character form (default is
\code{grDevices::gray} for single-band data or \code{grDevices::rgb} for 3-band).
Ignored if \code{col_tbl} is used. Set \code{normalize = FALSE} if using a color
map function that operates on raw pixel values. This argument can also be
given as a color palette, in which case a color-ramp function is assumed.
The color palette can be a character vector of \code{"#RRGGBB"} or \code{"#RRGGBBAA"},
color names from \code{grDevices::colors()}, or a positive integer that indexes
into \code{grDevices::palette()} (i.e., must be a valid argument to
\code{grDevices::col2rgb()}).}

\item{pixel_fn}{An optional function that will be applied to the input
pixel data. Must accept vector input and return a numeric vector of the same
length as its input.}

\item{xlim}{Numeric vector of length two giving the x coordinate range.
If \code{data} is a \code{GDALRaster} object, the default is the raster xmin, xmax in
georeferenced coordinates, otherwise the default uses pixel/line
coordinates (\code{c(0, xsize)}).}

\item{ylim}{Numeric vector of length two giving the y coordinate range.
If \code{data} is a \code{GDALRaster} object, the default is the raster ymin, ymax in
georeferenced coordinates, otherwise the default uses pixel/line
coordinates (\code{c(ysize, 0)}).}

\item{interpolate}{Logical indicating whether to apply linear interpolation
to the image when drawing (default \code{TRUE}).}

\item{asp}{Numeric. The aspect ratio y/x (see \code{?plot.window}).}

\item{axes}{Logical. \code{TRUE} to draw axes (the default).}

\item{main}{The main title (on top).}

\item{xlab}{Title for the x axis (see \code{?title}).}

\item{ylab}{Title for the y axis (see \code{?title}).}

\item{xaxs}{The style of axis interval calculation to be used for the x axis
(see \code{?par}).}

\item{yaxs}{The style of axis interval calculation to be used for the y axis
(see \code{?par}).}

\item{legend}{Logical indicating whether to include a legend on the plot.
Currently, legends are only supported for continuous data. A color table
will be used if one is specified or the raster has a built-in color table,
otherwise the value for \code{col_map_fn} will be used.}

\item{digits}{The number of digits to display after the decimal point in
the legend labels when raster data are floating point.}

\item{na_col}{Color to use for \code{NA} as a 7- or 9-character hexadecimal code.
The default is transparent (\code{"#00000000"}, the return value of
\code{rgb(0,0,0,0)}).}

\item{...}{Other parameters to be passed to \code{plot.default()}.}
}
\description{
\code{plot_raster()} displays raster data using base \code{graphics}.
}
\details{
By default, contrast enhancement by stretch to min/max is applied when
the input data are single-band grayscale with any raster data type, or
three-band RGB with raster data type larger than Byte (=UInt8 in
GDAL >= 3.13). The minimum/maximum of the input data are used by default
(i.e., no outlier removal). No stretch is applied by default when the input
is an RGB byte raster. These defaults can be overridden by specifying either
the \code{minmax_def} argument (user-defined min/max per band), or the
\code{minmax_pct_cut} argument (ignore outlier pixels based on a percentile range
per band). These settings (and the \code{normalize} argument) are ignored if a
color table is used.
}
\note{
\code{plot_raster()} uses the function \code{graphics::rasterImage()} for plotting
which is not supported on some devices (see \code{?rasterImage}).

If \code{data} is an object of class \code{GDALRaster}, then \code{plot_raster()} will
attempt to read the entire raster into memory by default (unless the number
of pixels per band would exceed \code{max_pixels}).
A reduced resolution overview can be read by setting \code{xsize}, \code{ysize}
smaller than the raster size on disk.
(If \code{data} is instead specified as a vector of pixel values, a reduced
resolution overview would be read by setting \code{out_xsize} and \code{out_ysize}
smaller than the raster region defined by \code{xsize}, \code{ysize} in a call to
\code{GDALRaster$read()}).
The GDAL_RASTERIO_RESAMPLING configuration option can be
defined to override the default resampling (NEAREST) to one of BILINEAR,
CUBIC, CUBICSPLINE, LANCZOS, AVERAGE or MODE, for example:
\preformatted{
set_config_option("GDAL_RASTERIO_RESAMPLING", "BILINEAR")
}
}
\examples{
## Elevation
elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
ds <- new(GDALRaster, elev_file)

# all other arguments are optional when passing a GDALRaster object
# grayscale
plot_raster(ds, legend = TRUE, main = "Storm Lake elevation (m)")

# color ramp from a user-defined palette: the `col_map_fn` can optionally
# be given as a color palette, for which a color ramp function is assumed
pal <- c("#00A60E", "#63C600", "#E6E600", "#E9BD3B", "#ECB176", "#EFC2B3",
         "#F2F2F2")

plot_raster(ds, col_map_fn = pal, legend = TRUE,
            main = "Storm Lake elevation (m)")

ds$close()

## Landsat band combination
b4_file <- system.file("extdata/sr_b4_20200829.tif", package="gdalraster")
b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
b6_file <- system.file("extdata/sr_b6_20200829.tif", package="gdalraster")
band_files <- c(b6_file, b5_file, b4_file)

vrt_file <- file.path(tempdir(), "storml_b6_b5_b4.vrt")
buildVRT(vrt_file, band_files, cl_arg = "-separate")

ds <- new(GDALRaster, vrt_file)

plot_raster(ds, main = "Landsat 6-5-4 (vegetative analysis)")

ds$close()
\dontshow{vsi_unlink(vrt_file)}

## LANDFIRE Existing Vegetation Cover (EVC) with color map
evc_file <- system.file("extdata/storml_evc.tif", package="gdalraster")

# colors from the CSV attribute table distributed by LANDFIRE
evc_csv <- system.file("extdata/LF20_EVC_220.csv", package="gdalraster")
vat <- read.csv(evc_csv)
head(vat)
vat <- vat[, c(1, 6:8)]

ds <- new(GDALRaster, evc_file)
plot_raster(ds, col_tbl = vat, interpolate = FALSE,
            main = "Storm Lake LANDFIRE EVC")

ds$close()

## Apply a pixel function
if (requireNamespace("scales")) {
  f <- system.file("extdata/complex.tif", package="gdalraster")
  ds <- new(GDALRaster, f)
  ds$getDataTypeName(band = 1)  # complex floating point

  plot_raster(ds,
              pixel_fn = Arg,
              col_map_fn = scales::pal_viridis(option = "plasma")(6),
              interpolate = FALSE,
              legend = TRUE,
              main = "Arg(complex.tif)")

  ds$close()
}
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster$read()}}, \code{\link[=read_ds]{read_ds()}}, \code{\link[=set_config_option]{set_config_option()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{has_spatialite}
\alias{has_spatialite}
\title{Is SpatiaLite available?}
\usage{
has_spatialite()
}
\value{
Logical scalar. \code{TRUE} if SpatiaLite is available to GDAL.
}
\description{
\code{has_spatialite()} returns a logical value indicating whether GDAL was
built with support for the SpatiaLite library. SpatiaLite extends the
SQLite core to support full Spatial SQL capabilities.
}
\details{
GDAL supports executing SQL statements against a datasource. For most file
formats (e.g. Shapefiles, GeoJSON, FlatGeobuf files), the built-in OGR SQL
dialect will be used by default. It is also possible to request the
alternate \code{"SQLite"}  dialect, which will use the SQLite engine to evaluate
commands on GDAL datasets. This assumes that GDAL is built with support for
SQLite, and preferably with Spatialite support too to benefit from spatial
functions.
}
\note{
All GDAL/OGR drivers for database systems, e.g., PostgreSQL / PostGIS,
Oracle Spatial, SQLite / Spatialite RDBMS, GeoPackage, etc., override the
\code{GDALDataset::ExecuteSQL()} function with a dedicated implementation and, by
default, pass the SQL statements directly to the underlying RDBMS. In these
cases the SQL syntax varies in some particulars from OGR SQL. Also, anything
possible in SQL can then be accomplished for these particular databases. For
those drivers, it is also possible to explicitly request the \code{OGRSQL} or
\code{SQLite} dialects, although performance will generally be much less than the
native SQL engine of those database systems.
}
\examples{
has_spatialite()
}
\seealso{
\code{\link[=ogrinfo]{ogrinfo()}}, \code{\link[=ogr_execute_sql]{ogr_execute_sql()}}

OGR SQL dialect and SQLITE SQL dialect:\cr
\url{https://gdal.org/en/stable/user/ogr_sql_sqlite_dialect.html}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{sieveFilter}
\alias{sieveFilter}
\title{Remove small raster polygons}
\usage{
sieveFilter(
  src_filename,
  src_band,
  dst_filename,
  dst_band,
  size_threshold,
  connectedness,
  mask_filename = "",
  mask_band = 0L,
  options = NULL,
  quiet = FALSE
)
}
\arguments{
\item{src_filename}{Filename of the source raster to be processed.}

\item{src_band}{Band number in the source raster to be processed.}

\item{dst_filename}{Filename of the output raster. It may be the same as
\code{src_filename} to update the source file in place.}

\item{dst_band}{Band number in \code{dst_filename} to write output. It may be
the same as \code{src_band} to update the source raster in place.}

\item{size_threshold}{Integer. Raster polygons with sizes (in pixels)
smaller than this value will be merged into their largest neighbour.}

\item{connectedness}{Integer. Either \code{4} indicating that diagonal pixels
are not considered directly adjacent for polygon membership purposes, or
\code{8} indicating they are.}

\item{mask_filename}{Optional filename of raster to use as a mask.}

\item{mask_band}{Band number in \code{mask_filename} to use as a mask. All
pixels in the mask band with a value other than zero will be considered
suitable for inclusion in polygons.}

\item{options}{Algorithm options as a character vector of name=value pairs.
None currently supported.}

\item{quiet}{Logical scalar. If \code{TRUE}, a progress bar will not be
displayed. Defaults to \code{FALSE}.}
}
\value{
Logical indicating success (invisible \code{TRUE}).
An error is raised if the operation fails.
}
\description{
\code{sieveFilter()} is a wrapper for \code{GDALSieveFilter()} in the GDAL Algorithms
API. It removes raster polygons smaller than a provided threshold size
(in pixels) and replaces them with the pixel value of the largest neighbour
polygon.
}
\details{
Polygons are determined as regions of the raster where the pixels all have
the same value, and that are contiguous (connected).
Pixels determined to be "nodata" per the mask band will not be
treated as part of a polygon regardless of their pixel values. Nodata areas
will never be changed nor affect polygon sizes. Polygons smaller than the
threshold with no neighbours that are as large as the threshold will not be
altered. Polygons surrounded by nodata areas will therefore not be altered.

The algorithm makes three passes over the input file to enumerate the
polygons and collect limited information about them. Memory use is
proportional to the number of polygons (roughly 24 bytes per polygon), but
is not directly related to the size of the raster. So very large raster
files can be processed effectively if there aren't too many polygons. But
extremely noisy rasters with many one pixel polygons will end up being
expensive (in memory) to process.

The input dataset is read as integer data which means that floating point
values are rounded to integers.
}
\examples{
## remove single-pixel polygons from the vegetation type layer (EVT)
evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")

# create a blank raster to hold the output
evt_mmu_file <- file.path(tempdir(), "storml_evt_mmu2.tif")
rasterFromRaster(srcfile = evt_file,
                 dstfile = evt_mmu_file,
                 init = 32767)

# create a mask to exclude water pixels from the algorithm
# recode water (7292) to 0
expr <- "ifelse(EVT == 7292, 0, EVT)"
mask_file <- calc(expr = expr,
                  rasterfiles = evt_file,
                  var.names = "EVT")

# create a version of EVT with two-pixel minimum mapping unit
sieveFilter(src_filename = evt_file,
            src_band = 1,
            dst_filename = evt_mmu_file,
            dst_band = 1,
            size_threshold = 2,
            connectedness = 8,
            mask_filename = mask_file,
            mask_band = 1)
\dontshow{deleteDataset(mask_file)}
\dontshow{deleteDataset(evt_mmu_file)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/s3_methods.R
\name{plot.OGRFeature}
\alias{plot.OGRFeature}
\title{Plot the geometry of an \code{OGRFeature} object}
\usage{
\method{plot}{OGRFeature}(x, xlab = "x", ylab = "y", main = "", ...)
}
\arguments{
\item{x}{An \code{OGRFeature} object.}

\item{xlab}{Title for the x axis.}

\item{ylab}{Title for the y axis.}

\item{main}{The main title (on top).}

\item{...}{Optional arguments passed to \code{wk::wk_plot()}.}
}
\value{
The input, invisibly.
}
\description{
Plot the geometry of an \code{OGRFeature} object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/s3_methods.R
\name{print.OGRFeatureSet}
\alias{print.OGRFeatureSet}
\title{Print an \code{OGRFeatureSet}}
\usage{
\method{print}{OGRFeatureSet}(x, ...)
}
\arguments{
\item{x}{An \code{OGRFeatureSet}.}

\item{...}{Optional arguments passed to \code{base::print.data.frame()}.}
}
\value{
The input, invisibly.
}
\description{
Print an \code{OGRFeatureSet}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{renameDataset}
\alias{renameDataset}
\title{Rename a dataset}
\usage{
renameDataset(new_filename, old_filename, format = "")
}
\arguments{
\item{new_filename}{New name for the dataset.}

\item{old_filename}{Old name for the dataset (should not be open in a
\code{GDALRaster} object).}

\item{format}{Raster format short name (e.g., "GTiff"). If set to empty
string \code{""} (the default), will attempt to guess the raster format from
\code{old_filename}.}
}
\value{
Logical \code{TRUE} if no error or \code{FALSE} on failure.
}
\description{
\code{renameDataset()} renames a dataset in a format-specific way (e.g.,
rename associated files as appropriate). This could include moving the
dataset to a new directory or even a new filesystem.
The dataset should not be open in any existing \code{GDALRaster} objects
when \code{renameDataset()} is called. Wrapper for \code{GDALRenameDataset()} in the
GDAL API.
}
\note{
If \code{format} is set to an empty string \code{""} (the default) then the function
will try to identify the driver from \code{old_filename}. This is done
internally in GDAL by invoking the \code{Identify} method of each registered
\code{GDALDriver} in turn. The first driver that successful identifies the file
name will be returned. An error is raised if a format cannot be determined
from the passed file name.
}
\examples{
b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
b5_tmp <- file.path(tempdir(), "b5_tmp.tif")
file.copy(b5_file,  b5_tmp)

ds <- new(GDALRaster, b5_tmp)
ds$buildOverviews("BILINEAR", levels = c(2, 4, 8), bands = c(1))
ds$getFileList()
ds$close()
b5_tmp2 <- file.path(tempdir(), "b5_tmp_renamed.tif")
renameDataset(b5_tmp2, b5_tmp)
ds <- new(GDALRaster, b5_tmp2)
ds$getFileList()
ds$close()

deleteDataset(b5_tmp2)
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster-class}}, \code{\link[=create]{create()}}, \code{\link[=createCopy]{createCopy()}},
\code{\link[=deleteDataset]{deleteDataset()}}, \code{\link[=copyDatasetFiles]{copyDatasetFiles()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_helpers.R
\name{getCreationOptions}
\alias{getCreationOptions}
\title{Return the list of creation options for a GDAL driver}
\usage{
getCreationOptions(format, filter = NULL)
}
\arguments{
\item{format}{Format short name (e.g., \code{"GTiff"}).}

\item{filter}{Optional character vector of creation option names.}
}
\value{
A named list with names matching the creation option names, and
each element a named list with elements \code{type}, \code{description}, \code{default}
and \code{values} (see Details).
}
\description{
\code{getCreationOptions()} returns the list of creation options supported by a
GDAL format driver.
This function is a wrapper of \code{GDALGetDriverCreationOptionList()} in the
GDAL API, parsing its XML output into a named list.
}
\details{
The output is a nested list with names matching the creation option names.
The information for each creation option is a named list with the following
elements:
\itemize{
\item \code{type}: a character string describing the data type, e.g., \code{"int"},
\code{"float"}, \code{"string"}. The type \code{"string-select"} denotes a list of allowed
string values which are returned as a character vector in the \code{values}
element (see below).
\item \code{description}: a character string describing the option, or \code{NA} if no
description is provided by the GDAL driver.
\item \code{default}: the default value of the option as either a character string
or numeric value, or \code{NA} if no description is provided by the GDAL driver.
\item \code{values}: a character vector of allowed string values for the creation
option if \code{type} is \code{"string-select"}, otherwise \code{NULL} if the option is
not a \code{"string-select"} type.
\item \code{min}: (GDAL >= 3.11) the minimum value of the valid range for the
option, or \code{NA} if not provided by the GDAL driver or the option is not a
numeric type.
\item \code{max}: (GDAL >= 3.11) the maximum value of the valid range for the
option, or \code{NA} if not provided by the GDAL driver or the option is not a
numeric type.
}
}
\examples{
opt <- getCreationOptions("GTiff", "COMPRESS")
names(opt)

(opt$COMPRESS$type == "string-select")  # TRUE
opt$COMPRESS$values

all_opt <- getCreationOptions("GTiff")
names(all_opt)

# $description and $default will be NA if no value is provided by the driver
# $values will be NULL if the option is not a 'string-select' type

all_opt$PREDICTOR

all_opt$BIGTIFF
}
\seealso{
\code{\link[=create]{create()}}, \code{\link[=createCopy]{createCopy()}}, \code{\link[=translate]{translate()}}, \code{\link[=validateCreationOptions]{validateCreationOptions()}},
\code{\link[=warp]{warp()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdalraster_proc.R
\name{DEFAULT_DEM_PROC}
\alias{DEFAULT_DEM_PROC}
\title{List of default DEM processing options}
\usage{
DEFAULT_DEM_PROC
}
\description{
These values are used in \code{dem_proc()} as the default processing options:
\preformatted{
    list(
         "hillshade" =    c("-z", "1", "-s", "1", "-az", "315",
                            "-alt", "45", "-alg", "Horn",
                            "-combined", "-compute_edges"),
         "slope" =        c("-s", "1", "-alg", "Horn", "-compute_edges"),
         "aspect" =       c("-alg", "Horn", "-compute_edges"),
         "color-relief" = character(),
         "TRI" =          c("-alg", "Riley", "-compute_edges"),
         "TPI" =          c("-compute_edges"),
         "roughness" =    c("-compute_edges"))
}
}
\seealso{
\code{\link[=dem_proc]{dem_proc()}}

\url{https://gdal.org/en/stable/programs/gdaldem.html} for a description of all
available command-line options for each processing mode
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_helpers.R
\name{addFilesInZip}
\alias{addFilesInZip}
\title{Create/append to a potentially Seek-Optimized ZIP file (SOZip)}
\usage{
addFilesInZip(
  zip_file,
  add_files,
  overwrite = FALSE,
  full_paths = TRUE,
  sozip_enabled = NULL,
  sozip_chunk_size = NULL,
  sozip_min_file_size = NULL,
  num_threads = NULL,
  content_type = NULL,
  quiet = FALSE
)
}
\arguments{
\item{zip_file}{Filename of the ZIP file. Will be created if it does not
exist or if \code{overwrite = TRUE}. Otherwise will append to an existing file.}

\item{add_files}{Character vector of one or more input filenames to add.}

\item{overwrite}{Logical scalar. Overwrite the target zip file if it already
exists.}

\item{full_paths}{Logical scalar. By default, the full path will be stored
(relative to the current directory). \code{FALSE} to store just the name of a
saved file (drop the path).}

\item{sozip_enabled}{String. Whether to generate a SOZip index for the file.
One of \code{"AUTO"} (the default), \code{"YES"} or \code{"NO"} (see Details).}

\item{sozip_chunk_size}{The chunk size for a seek-optimized file.
Defaults to 32768 bytes. The value is specified in bytes, or K and M
suffix can be used respectively to specify a value in kilo-bytes or
mega-bytes. Will be coerced to string.}

\item{sozip_min_file_size}{The minimum file size to decide if a file
should be seek-optimized, in \code{sozip_enabled="AUTO"} mode. Defaults to
1 MB byte. The value is specified in bytes, or K, M or G suffix can be used
respectively to specify a value in kilo-bytes, mega-bytes or giga-bytes.
Will be coerced to string.}

\item{num_threads}{Number of threads used for SOZip generation. Defaults to
\code{"ALL_CPUS"} or specify an integer value (coerced to string).}

\item{content_type}{String Content-Type value for the file. This is stored
as a key-value pair in the extra field extension 'KV' (0x564b) dedicated to
storing key-value pair metadata.}

\item{quiet}{Logical scalar. \code{TRUE} for quiet mode, no progress messages
emitted. Defaults to \code{FALSE}.}
}
\value{
Logical indicating success (invisible \code{TRUE}).
An error is raised if the operation fails.
}
\description{
\code{addFilesInZip()} will create new or open existing ZIP file, and
add one or more compressed files potentially using the seek optimization
extension. This function is basically a wrapper for \code{CPLAddFileInZip()}
in the GDAL Common Portability Library, but optionally creates a new ZIP
file first (with \code{CPLCreateZip()}). It provides a subset of functionality
in the GDAL \code{sozip} command-line utility
(\url{https://gdal.org/en/stable/programs/sozip.html}). Requires GDAL >= 3.7.
}
\details{
A Seek-Optimized ZIP file (SOZip) contains one or more compressed files
organized and annotated such that a SOZip-aware reader can perform very
fast random access within the .zip file
(see \url{https://github.com/sozip/sozip-spec}).
Large compressed files can be accessed directly from SOZip without prior
decompression. The .zip file is otherwise fully backward compatible.

If \code{sozip_enabled="AUTO"} (the default), a file is seek-optimized only if
its size is above the values of \code{sozip_min_file_size} (default 1 MB) and
\code{sozip_chunk_size} (default \code{32768}).
In \code{"YES"} mode, all input files will be seek-optimized. In \code{"NO"} mode, no
input files will be seek-optimized. The default can be changed with the
\code{CPL_SOZIP_ENABLED} configuration option.
}
\note{
The \code{GDAL_NUM_THREADS} configuration option can be set to \code{ALL_CPUS} or an
integer value to specify the number of threads to use for SOZip-compressed
files (see \code{\link[=set_config_option]{set_config_option()}}).

SOZip can be validated with:

\if{html}{\out{<div class="sourceCode">}}\preformatted{vsi_get_file_metadata(zip_file, domain="ZIP")
}\if{html}{\out{</div>}}

where \code{zip_file} uses the /vsizip/ prefix.
}
\examples{
f <- system.file("extdata/ynp_fires_1984_2022.gpkg", package = "gdalraster")
zip_file <- file.path(tempdir(), "ynp_fires.zip")

# Requires GDAL >= 3.7
if (gdal_version_num() >= gdal_compute_version(3, 7, 0)) {
  addFilesInZip(zip_file, f, full_paths = FALSE, sozip_enabled = "YES",
                num_threads = 1)

  print("Files in zip archive:")
  print(unzip(zip_file, list = TRUE))

  # Open with GDAL using Virtual File System handler '/vsizip/'
  # https://gdal.org/en/stable/user/virtual_file_systems.html#vsizip-zip-archives
  vsi_f <- file.path("/vsizip", zip_file, "ynp_fires_1984_2022.gpkg")
  print("SOZip metadata:")
  print(vsi_get_file_metadata(vsi_f, domain = "ZIP"))

  lyr <- new(GDALVector, vsi_f)
  lyr$info()
  lyr$close()
  \dontshow{vsi_unlink(zip_file)}
}
}
\seealso{
\code{\link[=vsi_get_file_metadata]{vsi_get_file_metadata()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_rat.R
\name{buildRAT}
\alias{buildRAT}
\title{Build a GDAL Raster Attribute Table with VALUE, COUNT}
\usage{
buildRAT(
  raster,
  band = 1L,
  col_names = c("VALUE", "COUNT"),
  table_type = "athematic",
  na_value = NULL,
  join_df = NULL,
  quiet = FALSE
)
}
\arguments{
\item{raster}{Either a \code{GDALRaster} object, or a character string containing
the file name of a raster dataset to open.}

\item{band}{Integer scalar, band number to read (default \code{1L}).}

\item{col_names}{Character vector of length two containing names to use for
column 1 (pixel values) and column 2 (pixel counts) in the output data
frame (defaults are \code{c("VALUE", "COUNT")}).}

\item{table_type}{Character string describing the type of the attribute
table. One of either \code{"thematic"}, or \code{"athematic"} for continuous data
(the default).}

\item{na_value}{Numeric scalar. If the set of unique pixel values has an
\code{NA}, it will be recoded to \code{na_value} in the returned data frame.
If \code{NULL} (the default), \code{NA} will not be recoded.}

\item{join_df}{Optional data frame for joining additional attributes. Must
have a column of unique values with the same name as \code{col_names[1]}
(\code{"VALUE"} by default).}

\item{quiet}{Logical scalar. If \verb{TRUE``, a progress bar will not be displayed. Defaults to }FALSE``.}
}
\value{
A data frame with at least two columns containing the set of unique
pixel values and their counts. These columns have attribute \code{"GFU"} set to
\code{"MinMax"} for the values, and \code{"PixelCount"} for the counts. If \code{join_df} is
given, the returned data frame will have additional columns that result from
\code{merge()}. The \code{"GFU"} attribute of the additional columns will be assigned
automatically based on the column names (\emph{case-insensitive} matching, see
Details). The returned data frame has attribute \code{"GDALRATTableType"} set to
\code{table_type}.
}
\description{
\code{buildRAT()} reads all pixels of an input raster to obtain the set of
unique values and their counts. The result is returned as a data frame
suitable for use with the class method \code{GDALRaster$setDefaultRAT()}. The
returned data frame might be further modified before setting as a Raster
Attribute Table in a dataset, for example, by adding columns containing
class names, color values, or other information (see Details).
An optional input data frame containing such attributes may be given, in
which case \code{buildRAT()} will attempt to join the additional columns and
automatically assign the appropriate metadata on the output data frame
(i.e., assign R attributes on the data frame and its columns that define
usage in a GDAL Raster Attribute Table).
}
\details{
A GDAL Raster Attribute Table (or RAT) provides attribute information about
pixel values. Raster attribute tables can be used to represent histograms,
color tables, and classification information. Each row in the table applies
to either a single pixel value or a range of values, and might have
attributes such as the histogram count for that value (or range), the color
that pixels of that value (or range) should be displayed, names of classes,
or various other information.

Each column in a raster attribute table has a name, a type (Integer,
Double, String, and with GDAL >= 3.12, Boolean, DateTime, or WKBGeometry),
and a \code{GDALRATFieldUsage}. The usage distinguishes columns with particular
understood purposes (such as color, histogram count, class name), and
columns that have other purposes not understood by the library (long labels,
ancillary attributes, etc).

In the general case, each row has a field indicating the minimum pixel
value falling into that category, and a field indicating the maximum pixel
value. In the GDAL API, these are indicated with usage values of \code{GFU_Min}
and \code{GFU_Max}. In the common case where each row is a discrete pixel value,
a single column with usage \code{GFU_MinMax} would be used instead.
In R, the table is represented as a data frame with column attribute \code{"GFU"}
containing the field usage as a string, e.g., \code{"Max"}, \code{"Min"} or \code{"MinMax"}
(case-sensitive).
The full set of possible field usage descriptors is:
\tabular{lll}{
GFU attr       \tab GDAL enum        \tab Description\cr
\code{"Generic"}    \tab \code{GFU_Generic}    \tab General purpose field\cr
\code{"PixelCount"} \tab \code{GFU_PixelCount} \tab Histogram pixel count\cr
\code{"Name"}       \tab \code{GFU_Name}       \tab Class name\cr
\code{"Min"}        \tab \code{GFU_Min}        \tab Class range minimum\cr
\code{"Max"}        \tab \code{GFU_Max}        \tab Class range maximum\cr
\code{"MinMax"}     \tab \code{GFU_MinMax}     \tab Class value (min=max)\cr
\code{"Red"}        \tab \code{GFU_Red}        \tab Red class color (0-255)\cr
\code{"Green"}      \tab \code{GFU_Green}      \tab Green class color (0-255)\cr
\code{"Blue"}       \tab \code{GFU_Blue}       \tab Blue class color (0-255)\cr
\code{"Alpha"}      \tab \code{GFU_Alpha}      \tab Alpha transparency (0-255)\cr
\code{"RedMin"}     \tab \code{GFU_RedMin}     \tab Color range red minimum\cr
\code{"GreenMin"}   \tab \code{GFU_GreenMin}   \tab Color range green minimum\cr
\code{"BlueMin"}    \tab \code{GFU_BlueMin}    \tab Color range blue minimum\cr
\code{"AlphaMin"}   \tab \code{GFU_AlphaMin}   \tab Color range alpha minimum\cr
\code{"RedMax"}     \tab \code{GFU_RedMax}     \tab Color range red maximum\cr
\code{"GreenMax"}   \tab \code{GFU_GreenMax}   \tab Color range green maximum\cr
\code{"BlueMax"}    \tab \code{GFU_BlueMax}    \tab Color range blue maximum\cr
\code{"AlphaMax"}   \tab \code{GFU_AlphaMax}   \tab Color range alpha maximum
}

\code{buildRAT()} assigns GFU \code{"MinMax"} on the column of pixel values (named
\code{"VALUE"} by default) and GFU \code{"PixelCount"} on the column of counts (named
\code{"COUNT"} by default).
If \code{join_df} is given, the additional columns that result from joining will
have GFU assigned automatically based on the column names (\emph{ignoring case}).
First, the additional column names are checked for containing
the string \code{"name"} (e.g., \code{"classname"}, \code{"TypeName"}, \code{"EVT_NAME"}, etc).
The first matching column (if any) will be assigned a GFU of \code{"Name"}
(=\code{GFU_Name}, the field usage descriptor for class names). Next, columns
named \code{"R"} or \code{"Red"} will be assigned GFU \code{"Red"}, columns named \code{"G"} or
\code{"Green"} will be assigned GFU \code{"Green"}, columns named \code{"B"} or \code{"Blue"}
will be assigned GFU \code{"Blue"}, and columns named \code{"A"} or \code{"Alpha"} will be
assigned GFU \code{"Alpha"}. Finally, any remaining columns that have not been
assigned a GFU will be assigned \code{"Generic"}.

In a variation of RAT, all the categories are of equal size and regularly
spaced, and the categorization can be determined by knowing the value at
which the categories start and the size of a category. This is called
"Linear Binning" and the information is kept specially on the raster
attribute table as a whole. In \R, a RAT that uses linear binning would
have the following attributes set on the data frame:
attribute \code{"Row0Min"} = the numeric lower bound (pixel value) of the first
category, and attribute \code{"BinSize"} = the numeric width of each category (in
pixel value units). \code{buildRAT()} does not create tables with linear binning,
but one could be created manually based on the specifications above, and
applied to a raster with the class method \code{GDALRaster$setDefaultRAT()}.

A raster attribute table is thematic or athematic (continuous). In \R, this
is defined by an attribute on the data frame named \code{"GDALRATTableType"} with
value of either \code{"thematic"} or \code{"athematic"}.
}
\note{
The full raster will be scanned.

If \code{na_value} is not specified, then an \code{NA} pixel value (if present)
will not be recoded in the output data frame. This may have implications
if joining to other data (\code{NA} will not match), or when using the returned
data frame to set a default RAT on a dataset (\code{NA} will be interpreted
as the value that \R uses internally to represent it for the type, e.g.,
-2147483648 for \code{NA_integer_}). In some cases, removing the row in the output
data frame with value \code{NA}, rather than recoding, may be desirable (i.e., by
removing manually or by side effect of joining via \code{merge()}, for example).
Users should consider what is appropriate for a particular case.
}
\examples{
evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
# make a copy to modify
f <- file.path(tempdir(), "storml_evt_tmp.tif")
file.copy(evt_file,  f)

ds <- new(GDALRaster, f, read_only=FALSE)
ds$getDefaultRAT(band = 1) # NULL

# get the full attribute table for LANDFIRE EVT from the CSV file
evt_csv <- system.file("extdata/LF20_EVT_220.csv", package="gdalraster")
evt_df <- read.csv(evt_csv)
nrow(evt_df)
head(evt_df)
evt_df <- evt_df[,1:7]

tbl <- buildRAT(ds,
                table_type = "thematic",
                na_value = -9999,
                join_df = evt_df)

nrow(tbl)
head(tbl)

# attributes on the data frame and its columns define usage in a GDAL RAT
attributes(tbl)
attributes(tbl$VALUE)
attributes(tbl$COUNT)
attributes(tbl$EVT_NAME)
attributes(tbl$EVT_LF)
attributes(tbl$EVT_PHYS)
attributes(tbl$R)
attributes(tbl$G)
attributes(tbl$B)

ds$setDefaultRAT(band = 1, tbl)
ds$flushCache()

tbl2 <- ds$getDefaultRAT(band = 1)
nrow(tbl2)
head(tbl2)

ds$close()
\dontshow{deleteDataset(f)}

## Display
# requires suggested package "gt"
if (requireNamespace("gt", quietly = TRUE)) {
  evt_gt <- displayRAT(tbl2, title = "Storm Lake EVT Raster Attribute Table")
  class(evt_gt)  # an object of class "gt_tbl" from package gt
}
# To show the table:
# evt_gt
# or simply call `displayRAT()` as above but without assignment
# `vignette("raster-attribute-tables")` has example output
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster$getDefaultRAT()}},
\code{\link[=GDALRaster]{GDALRaster$setDefaultRAT()}},
\code{\link[=displayRAT]{displayRAT()}}

\code{vignette("raster-attribute-tables")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/proj.R
\name{proj_version}
\alias{proj_version}
\title{Get PROJ version}
\usage{
proj_version()
}
\value{
A list of length four containing:
\itemize{
\item \code{name} - a string formatted as "major.minor.patch"
\item \code{major} - major version as integer
\item \code{minor} - minor version as integer
\item \code{patch} - patch version as integer
}
}
\description{
\code{proj_version()} returns version information for the PROJ library in use by
GDAL.
}
\examples{
proj_version()
}
\seealso{
\code{\link[=gdal_version]{gdal_version()}}, \code{\link[=geos_version]{geos_version()}}, \code{\link[=proj_search_paths]{proj_search_paths()}},
\code{\link[=proj_networking]{proj_networking()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{bandCopyWholeRaster}
\alias{bandCopyWholeRaster}
\title{Copy a whole raster band efficiently}
\usage{
bandCopyWholeRaster(
  src_filename,
  src_band,
  dst_filename,
  dst_band,
  options = NULL,
  quiet = FALSE
)
}
\arguments{
\item{src_filename}{Filename of the source raster.}

\item{src_band}{Band number in the source raster to be copied.}

\item{dst_filename}{Filename of the destination raster.}

\item{dst_band}{Band number in the destination raster to copy into.}

\item{options}{Optional list of transfer hints in a vector of \code{"NAME=VALUE"}
pairs. The currently supported \code{options} are:
\itemize{
\item \code{"COMPRESSED=YES"} to force alignment on target dataset block sizes to
achieve best compression.
\item \code{"SKIP_HOLES=YES"} to skip chunks that contain only empty blocks.
Empty blocks are blocks that are generally not physically present in the
file, and when read through GDAL, contain only pixels whose value is the
nodata value when it is set, or whose value is 0 when the nodata value is
not set. The query is done in an efficient way without reading the actual
pixel values (if implemented by the raster format driver, otherwise will
not be skipped).
}}

\item{quiet}{Logical scalar. If \code{TRUE}, a progress bar will not be
displayed. Defaults to \code{FALSE}.}
}
\value{
Logical indicating success (invisible \code{TRUE}).
An error is raised if the operation fails.
}
\description{
\code{bandCopyWholeRaster()} copies the complete raster contents of one band to
another similarly configured band. The source and destination bands must
have the same xsize and ysize. The bands do not have to have the same data
type. It implements efficient copying, in particular "chunking" the copy in
substantial blocks. This is a wrapper for \code{GDALRasterBandCopyWholeRaster()}
in the GDAL API.
}
\examples{
## copy Landsat data from a single-band file to a new multi-band image
b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
dst_file <- file.path(tempdir(), "sr_multi.tif")
rasterFromRaster(b5_file, dst_file, nbands = 7, init = 0)
opt <- c("COMPRESSED=YES", "SKIP_HOLES=YES")
bandCopyWholeRaster(b5_file, 1, dst_file, 5, options = opt)
ds <- new(GDALRaster, dst_file)
ds$getStatistics(band = 5, approx_ok = FALSE, force = TRUE)
ds$close()
\dontshow{deleteDataset(dst_file)}
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster-class}}, \code{\link[=create]{create()}}, \code{\link[=createCopy]{createCopy()}},
\code{\link[=rasterFromRaster]{rasterFromRaster()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{srs_info_from_db}
\alias{srs_info_from_db}
\title{Obtain information about coordinate reference systems in the PROJ DB}
\usage{
srs_info_from_db(auth_name = "")
}
\arguments{
\item{auth_name}{Character string containing an authority name used to
restrict the search, or empty string (\code{""}) for all authorities (the
default).}
}
\value{
A data frame (will contain \code{0} rows if no objects are found that match the
search criterion).
}
\description{
\code{srs_info_from_db()} returns a data frame containing descriptive information
about spatial coordinate reference systems in the PROJ database. Wrapper of
\code{OSRGetCRSInfoListFromDatabase()} in the GDAL SRS API.
}
\details{
The returned information includes the authority name, object code, object
name, object type (e.g., Geographic 2D CRS, Geographic 3D CRS, Projected
CRS, etc.), whether the object is deprecated, whether the bounding box
values for the area of use are valid, the bounding box values in longitude
and latitude degrees, the name of the area of use, the name of the
projection method for a projected CRS, and the name of the celestial body of
the CRS (e.g., "Earth", populated only if GDAL >= 3.12 and PROJ >= 8.1).
}
\examples{
epsg <- srs_info_from_db("EPSG")
str(epsg)

iau <- srs_info_from_db("IAU_2015")
str(iau)
}
\seealso{
\link{srs_query}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_get_signed_url}
\alias{vsi_get_signed_url}
\title{Returns a signed URL for a supplied VSI filename}
\usage{
vsi_get_signed_url(filename, options = NULL)
}
\arguments{
\item{filename}{Character string containing a /vsiPREFIX/ filename.}

\item{options}{Character vector of \code{NAME=VALUE} pairs (see Details).}
}
\value{
Character string containing the signed URL, or \code{NULL} if
\code{filename} is not a network-based virtual file system.
}
\description{
\code{vsi_get_signed_url()} Returns a signed URL of a supplied filename.
Currently only returns a non-NULL value for /vsis3/, /vsigs/, /vsiaz/ and
/vsioss/ For example "/vsis3/bucket/filename" will be expanded as
"https://bucket.s3.amazon.com/filename?X-Amz-Algorithm=AWS4-HMAC-SHA256..."
Configuration options that apply for file opening (typically to provide
credentials), and are returned by \code{vsi_get_fs_options()}, are also valid
in that context.
Wrapper for \code{VSIGetSignedURL()} in the GDAL API.
}
\details{
The \code{options} argument accepts a character vector of name=value pairs.
For /vsis3/, /vsigs/, /vsiaz/ and /vsioss/, the following options are
supported:
\itemize{
\item \code{START_DATE=YYMMDDTHHMMSSZ}: date and time in UTC following ISO 8601
standard, corresponding to the start of validity of the URL. If not
specified, current date time.
\item \code{EXPIRATION_DELAY=number_of_seconds}: number between 1 and 604800 (seven
days) for the validity of the signed URL. Defaults to 3600 (one hour).
\item \code{VERB=GET/HEAD/DELETE/PUT/POST}: HTTP VERB for which the request will be
used. Defaults to \code{GET}.
}

/vsiaz/ supports additional options:
\itemize{
\item \code{SIGNEDIDENTIFIER=value}: to relate the given shared access signature to
a corresponding stored access policy.
\item \code{SIGNEDPERMISSIONS=r|w}: permissions associated with the shared access
signature. Normally deduced from \code{VERB}.
}
}
\examples{
\dontrun{
f <- "/vsiaz/items/io-lulc-9-class.parquet"
set_config_option("AZURE_STORAGE_ACCOUNT", "pcstacitems")
# token obtained from:
# https://planetarycomputer.microsoft.com/api/sas/v1/token/pcstacitems/items
set_config_option("AZURE_STORAGE_SAS_TOKEN", "<token>")
vsi_get_actual_url(f)
#> [1] "https://pcstacitems.blob.core.windows.net/items/io-lulc-9-class.parquet"
vsi_get_signed_url(f)
#> [1] "https://pcstacitems.blob.core.windows.net/items/io-lulc-9-class.parquet?<token>"
}
}
\seealso{
\code{\link[=vsi_get_actual_url]{vsi_get_actual_url()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_create.R
\name{createCopy}
\alias{createCopy}
\title{Create a copy of a raster}
\usage{
createCopy(
  format,
  dst_filename,
  src_filename,
  strict = FALSE,
  options = NULL,
  quiet = FALSE,
  return_obj = FALSE
)
}
\arguments{
\item{format}{Character string giving the format short name for the
output raster (e.g., \code{"GTiff"}).}

\item{dst_filename}{Character string giving the filename to create.}

\item{src_filename}{Either a character string giving the filename of the
source raster, or object of class \code{GDALRaster} for the source.}

\item{strict}{Logical. \code{TRUE} if the copy must be strictly equivalent,
or more normally \code{FALSE} (the default) indicating that the copy may adapt
as needed for the output format.}

\item{options}{Optional list of format-specific creation options in a
vector of \code{"NAME=VALUE"} pairs
(e.g., \code{options = c("COMPRESS=LZW")} to set \code{LZW}
compression during creation of a GTiff file).
The APPEND_SUBDATASET=YES option can be
specified to avoid prior destruction of existing dataset.}

\item{quiet}{Logical scalar. If \code{TRUE}, a progress bar will be not be
displayed. Defaults to \code{FALSE}.}

\item{return_obj}{Logical scalar. If \code{TRUE}, an object of class
\code{\link{GDALRaster}} opened on the newly created dataset will be
returned. Defaults to \code{FALSE}.}
}
\value{
By default, returns a logical value indicating success (invisible
\code{TRUE}, output written to \code{dst_filename}). An error is raised if the
operation fails. An object of class \code{\link{GDALRaster}} open on the
output dataset will be returned if \code{return_obj = TRUE}.
}
\description{
\code{createCopy()} copies a raster dataset, optionally changing the format.
The extent, cell size, number of bands, data type, projection, and
geotransform are all copied from the source raster.
}
\note{
\code{dst_filename} may be an empty string (\code{""}) with \code{format = "MEM"} and
\code{return_obj = TRUE} to create an In-memory Raster
(\url{https://gdal.org/en/stable/drivers/raster/mem.html}).
}
\examples{
lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
tif_file <- file.path(tempdir(), "storml_lndscp.tif")
ds <- createCopy(format = "GTiff",
                 dst_filename = tif_file,
                 src_filename = lcp_file,
                 options = "COMPRESS=LZW",
                 return_obj = TRUE)

ds$getMetadata(band = 0, domain = "IMAGE_STRUCTURE")

for (band in 1:ds$getRasterCount())
    ds$setNoDataValue(band, -9999)
ds$getStatistics(band = 1, approx_ok = FALSE, force = TRUE)

ds$close()
\dontshow{deleteDataset(tif_file)}
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster-class}}, \code{\link[=create]{create()}}, \code{\link[=getCreationOptions]{getCreationOptions()}},
\code{\link[=rasterFromRaster]{rasterFromRaster()}}, \code{\link[=translate]{translate()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/s3_methods.R
\name{print.OGRFeature}
\alias{print.OGRFeature}
\title{Print an \code{OGRFeature} object}
\usage{
\method{print}{OGRFeature}(x, ...)
}
\arguments{
\item{x}{An \code{OGRFeature} object.}

\item{...}{Optional arguments passed to \code{base::print()}.}
}
\value{
The input, invisibly.
}
\description{
Print an \code{OGRFeature} object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_helpers.R
\name{progress_bar_clear}
\alias{progress_bar_clear}
\title{Clear progress bar}
\usage{
progress_bar_clear()
}
\value{
No return value, call for side effects.
}
\description{
\code{progress_bar_clear()} terminates any active \pkg{cli} progress bars and
resets the global progress bar in C++. Generally not needed unless a process
using a progress bar terminates abnormally, or with ctrl-c interrupt, and
a progress bar display anomaly results.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ogr_proc.R
\name{ogr_proc}
\alias{ogr_proc}
\title{GDAL OGR facilities for vector geoprocessing}
\usage{
ogr_proc(
  mode,
  input_lyr,
  method_lyr,
  out_dsn,
  out_lyr_name = NULL,
  out_geom_type = NULL,
  out_fmt = NULL,
  dsco = NULL,
  lco = NULL,
  mode_opt = NULL,
  overwrite = FALSE,
  quiet = FALSE,
  return_obj = TRUE
)
}
\arguments{
\item{mode}{Character string specifying the operation to perform. One of
\code{Intersection}, \code{Union}, \code{SymDifference}, \code{Identity}, \code{Update}, \code{Clip} or
\code{Erase} (see Details).}

\item{input_lyr}{An object of class \code{\link{GDALVector}} to use as the
input layer. For overlay operations, this is the first layer in the
operation.}

\item{method_lyr}{An object of class \code{\link{GDALVector}} to use as the
method layer. This is the conditional layer supplied to an operation (e.g.,
Clip, Erase, Update), or the second layer in overlay operations (e.g., Union,
Intersection, SymDifference).}

\item{out_dsn}{The destination vector filename or database connection string
to which the output layer will be written.}

\item{out_lyr_name}{Layer name where the output vector will be written. May
be \code{NULL} (e.g., shapefile), but typically must be specified.}

\item{out_geom_type}{Character string specifying the geometry type of the
output layer. One of NONE, GEOMETRY, POINT, LINESTRING, POLYGON,
GEOMETRYCOLLECTION, MULTIPOINT, MULTIPOLYGON, GEOMETRY25D, POINT25D,
LINESTRING25D, POLYGON25D, GEOMETRYCOLLECTION25D, MULTIPOINT25D,
MULTIPOLYGON25D. Defaults to UNKNOWN if not specified.}

\item{out_fmt}{GDAL short name of the output vector format. If unspecified,
the function will attempt to guess the format from the value of \code{out_dsn}.}

\item{dsco}{Optional character vector of format-specific creation options
for \code{out_dsn} (\code{"NAME=VALUE"} pairs).}

\item{lco}{Optional character vector of format-specific creation options
for \code{out_layer} (\code{"NAME=VALUE"} pairs).}

\item{mode_opt}{Optional character vector of \code{"NAME=VALUE"} pairs that
specify processing options. Available options depend on the value of \code{mode}
(see Details).}

\item{overwrite}{Logical value. \code{TRUE} to overwrite the output layer if it
already exists. Defaults to \code{FALSE}.}

\item{quiet}{Logical value. If \code{TRUE}, a progress bar will not be
displayed. Defaults to \code{FALSE}.}

\item{return_obj}{Logical value. If \code{TRUE} (the default), an object of
class \code{\link{GDALVector}} opened on the output layer will be returned,
otherwise the function returns a logical value.}
}
\value{
Upon successful completion, an object of class
\code{\link{GDALVector}} is returned by default (\code{return_obj = TRUE}), or
logical \code{TRUE} is returned if \code{return_obj = FALSE}.
Logical \code{FALSE} is returned if an error occurs during processing.
}
\description{
\code{ogr_proc()} performs GIS overlay operations on vector layers
(\url{https://en.wikipedia.org/wiki/Vector_overlay}). It provides
an interface to the GDAL API methods for these operations
(\code{OGRLayer::Intersection()}, \code{OGRLayer::Union()}, etc).
Inputs are given as objects of class \code{\link{GDALVector}}, which
may have spatial and/or attribute filters applied.
The output layer will be created if it does not exist, but output can also
be appended to an existing layer, or written to an existing empty layer that
has a custom schema defined.
\code{ogr_proc()} is basically a port of the
\href{https://gdal.org/en/stable/programs/ogr_layer_algebra.html#ogr-layer-algebra}{\code{ogr_layer_algebra}}
utility in the GDAL Python bindings.
}
\details{
Seven processing modes are available:
\itemize{
\item \code{Intersection}: The output layer contains features whose geometries
represent areas that are common between features in the input layer and in
the method layer. The features in the output layer have attributes from
both input and method layers.
\item \code{Union}: The output layer contains features whose geometries represent
areas that are either in the input layer, in the method layer, or in
both. The features in the output layer have attributes from both input and
method layers. For features which represent areas that are only in the
input layer or only in the method layer the respective attributes have
undefined values.
\item \code{SymDifference}: The output layer contains features whose geometries
represent areas that are in either in the input layer or in the method layer
but not in both. The features in the output layer have attributes from both
input and method layers. For features which represent areas that are only in
the input or only in the method layer the respective attributes have
undefined values.
\item \code{Identity}: Identifies the features of the input layer with the ones from
the method layer. The output layer contains features whose geometries
represent areas that are in the input layer. The features in the output layer
have attributes from both the input and method layers.
\item \code{Update}: The update method creates a layer which adds features into the
input layer from the method layer, possibly cutting features in the input
layer. The features in the output layer have areas of the features of the
method layer or those areas of the features of the input layer that are not
covered by the method layer. The features of the output layer get their
attributes from the input layer.
\item \code{Clip}: The clip method creates a layer which has features from the input
layer clipped to the areas of the features in the method layer. By default
the output layer has attributes of the input layer.
\item \code{Erase}: The erase method creates a layer which has features from the input
layer whose areas are erased by the features in the method layer. By default,
the output layer has attributes of the input layer.
}

By default, \code{ogr_proc()} will create the output layer with an empty schema.
It will be initialized by GDAL to contain all fields in the input layer, or
depending on the operation, all fields in both the input and method layers.
In the latter case, the prefixes \code{"input_"} and \code{"method_"} will be added to
the output field names by default. The default prefixes can be overridden in
the \code{mode_opt} argument as described below.

Alternatively, the functions in the \code{\link{ogr_manage}} interface
could be used to create an empty layer with user-defined schema (e.g.,
\code{\link[=ogr_ds_create]{ogr_ds_create()}}, \code{\link[=ogr_layer_create]{ogr_layer_create()}} and \code{\link[=ogr_field_create]{ogr_field_create()}}). If the
schema of the output layer is set by the user and contains fields that have
the same name as a field in both the input and method layers, then the
attribute for an output feature will get the value from the feature of the
method layer.

Options that affect processing can be set as NAME=VALUE pairs passed in the
\code{mode_opt} argument. Some options are specific to certain processing modes
as noted below:
\itemize{
\item SKIP_FAILURES=YES/NO. Set it to YES to go on, even when a feature could
not be inserted or a GEOS call failed.
\item PROMOTE_TO_MULTI=YES/NO. Set to YES to convert Polygons into MultiPolygons,
LineStrings to MultiLineStrings or Points to MultiPoints (only since GDAL
3.9.2 for the latter).
\item INPUT_PREFIX=string. Set a prefix for the field names that will be created
from the fields of the input layer.
\item METHOD_PREFIX=string. Set a prefix for the field names that will be created
from the fields of the method layer.
\item USE_PREPARED_GEOMETRIES=YES/NO. Set to NO to not use prepared geometries to
pretest intersection of features of method layer with features of input
layer. Applies to \code{Intersection}, \code{Union}, \code{Identity}.
\item PRETEST_CONTAINMENT=YES/NO. Set to YES to pretest the containment of
features of method layer within the features of input layer. This will speed
up the operation significantly in some cases. Requires that the prepared
geometries are in effect. Applies to \code{Intersection}.
\item KEEP_LOWER_DIMENSION_GEOMETRIES=YES/NO. Set to NO to skip result features
with lower dimension geometry that would otherwise be added to the output
layer. The default is YES, to add features with lower dimension geometry, but
only if the result output has an UNKNOWN geometry type. Applies to
\code{Intersection}, \code{Union}, \code{Identity}.
}

The input and method layers should have the same spatial reference system. No
on-the-fly reprojection is done. When an output layer is created it will have
the SRS of \code{input_lyr}.
}
\note{
The first geometry field on a layer is always used.

For best performance use the minimum amount of features in the method layer
and copy into a memory layer.
}
\examples{
# MTBS fires in Yellowstone National Park 1984-2022
dsn <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")

# layer filtered to fires after 1988
lyr1 <- new(GDALVector, dsn, "mtbs_perims")
lyr1$setAttributeFilter("ig_year > 1988")
lyr1$getFeatureCount()

# second layer for the 1988 North Fork fire perimeter
sql <- "SELECT incid_name, ig_year, geom FROM mtbs_perims
        WHERE incid_name = 'NORTH FORK'"
lyr2 <- new(GDALVector, dsn, sql)
lyr2$getFeatureCount()

# intersect to obtain areas in the North Fork perimeter that have re-burned
tmp_dsn <- tempfile(fileext = ".gpkg")
opt <- c("INPUT_PREFIX=layer1_",
         "METHOD_PREFIX=layer2_",
         "PROMOTE_TO_MULTI=YES")

lyr_out <- ogr_proc(mode = "Intersection",
                    input_lyr = lyr1,
                    method_lyr = lyr2,
                    out_dsn = tmp_dsn,
                    out_lyr_name = "north_fork_reburned",
                    out_geom_type = "MULTIPOLYGON",
                    mode_opt = opt)

# the output layer has attributes of both the input and method layers
(d <- lyr_out$fetch(-1))

# clean up
lyr1$close()
lyr2$close()
lyr_out$close()
\dontshow{deleteDataset(tmp_dsn)}
}
\seealso{
\code{\link[=GDALVector]{GDALVector-class}}, \code{\link{ogr_define}},
\code{\link{ogr_manage}}

Vector overlay operators:\cr
\url{https://en.wikipedia.org/wiki/Vector_overlay}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_util.R
\name{autoCreateWarpedVRT}
\alias{autoCreateWarpedVRT}
\title{Create a virtual warped dataset automatically}
\usage{
autoCreateWarpedVRT(
  src_ds,
  dst_wkt,
  resample_alg,
  src_wkt = "",
  max_err = 0,
  alpha_band = FALSE
)
}
\arguments{
\item{src_ds}{An object of class \code{GDALRaster} for the source dataset.}

\item{dst_wkt}{WKT string specifying the coordinate system to convert to.
If empty string (\code{""}) no change of coordinate system will take place.}

\item{resample_alg}{Character string specifying the sampling method to use.
One of NearestNeighbour, Bilinear, Cubic, CubicSpline, Lanczos, Average,
RMS or Mode.}

\item{src_wkt}{WKT string specifying the coordinate system of the source
raster. If empty string it will be read from the source raster (the
default).}

\item{max_err}{Numeric scalar specifying the maximum error measured in
input pixels that is allowed in approximating the transformation (\code{0.0} for
exact calculations, the default).}

\item{alpha_band}{Logical scalar, \code{TRUE} to create an alpha band if the
source dataset has none. Defaults to \code{FALSE}.}
}
\value{
An object of class \code{GDALRaster} for the new virtual dataset. An
error is raised if the operation fails.
}
\description{
\code{autoCreateWarpedVRT()} creates a warped virtual dataset representing the
input raster warped into a target coordinate system. The output virtual
dataset will be "north-up" in the target coordinate system. GDAL
automatically determines the bounds and resolution of the output virtual
raster which should be large enough to include all the input raster.
Wrapper of \code{GDALAutoCreateWarpedVRT()} in the GDAL Warper API.
}
\note{
The returned dataset will have no associated filename for itself. If you
want to write the virtual dataset to a VRT file, use the
\code{$setFilename()} method on the returned \code{GDALRaster} object to assign a
filename before it is closed.
}
\examples{
elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
ds <- new(GDALRaster, elev_file)

ds2 <- autoCreateWarpedVRT(ds, epsg_to_wkt(5070), "Bilinear")
ds2$info()

## set filename before close if a VRT file is needed for the virtual dataset
# ds2$setFilename("/path/to/file.vrt")

ds2$close()
ds$close()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{mdim_info}
\alias{mdim_info}
\title{Report structure and content of a multidimensional dataset}
\usage{
mdim_info(
  dsn,
  array_name = "",
  pretty = TRUE,
  detailed = FALSE,
  limit = -1L,
  stats = FALSE,
  array_options = NULL,
  allowed_drivers = NULL,
  open_options = NULL,
  cout = TRUE
)
}
\arguments{
\item{dsn}{Character string giving the data source name of the
multidimensional raster (e.g., file, VSI path).}

\item{array_name}{Character string giving the name of the MDarray in
\code{dsn}.}

\item{pretty}{Logical value, \code{FALSE} to output a single line without any
indentation. Defaults to \code{TRUE}.}

\item{detailed}{Logical value, \code{TRUE} for verbose output. Report attribute
data types and array values. Defaults to \code{FALSE}.}

\item{limit}{Integer value. Number of values in each dimension that is used
to limit the display of array values. By default, unlimited. Only taken into
account if used with \code{detailed = TRUE}. Set to a positive integer to enable.}

\item{stats}{Logical value, \code{TRUE} to read and display array statistics.
Forces computation if no statistics are stored in an array. Defaults to
\code{FALSE}.}

\item{array_options}{Optional character vector of \code{"NAME=VALUE"} pairs to
filter reported arrays. Such option is format specific. Consult driver
documentation (passed to \code{GDALGroup::GetMDArrayNames()}).}

\item{allowed_drivers}{Optional character vector of driver short names that
must be considered when opening \code{dsn}. It is generally not necessary to
specify it, but it can be used to skip automatic driver detection, when it
fails to select the appropriate driver.}

\item{open_options}{Optional character vector of format-specific dataset
openoptions as \code{"NAME=VALUE"} pairs.}

\item{cout}{Logical value, \code{TRUE} to print info to the console (the
default), or \code{FALSE} to suppress console output.}
}
\value{
Invisibly, a JSON string containing information about the
multidimensional raster dataset. By default, the info string is also printed
to the console unless \code{cout} is set to \code{FALSE}.
}
\description{
\code{mdim_info()} is an interface to the \command{gdalmdiminfo} command-line
utility (see \url{https://gdal.org/en/stable/programs/gdalmdiminfo.html}).
This function lists various information about a GDAL supported
multidimensional raster dataset as JSON output. Requires GDAL >= 3.2.
}
\examples{
\dontshow{if (gdal_version_num() >= gdal_compute_version(3, 2, 0) && isTRUE(gdal_formats("netCDF")$multidim_raster)) withAutoprint(\{ # examplesIf}
f <- system.file("extdata/byte.nc", package="gdalraster")
mdim_info(f)
\dontshow{\}) # examplesIf}
}
\seealso{
\code{\link[=mdim_as_classic]{mdim_as_classic()}}, \code{\link[=mdim_translate]{mdim_translate()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdalraster_proc.R
\name{rasterToVRT}
\alias{rasterToVRT}
\title{Create a GDAL virtual raster derived from one source dataset}
\usage{
rasterToVRT(
  srcfile,
  relativeToVRT = FALSE,
  vrtfile = tempfile("tmprast", fileext = ".vrt"),
  resolution = NULL,
  subwindow = NULL,
  src_align = TRUE,
  resampling = "nearest",
  krnl = NULL,
  normalized = TRUE,
  krnl_fn = NULL
)
}
\arguments{
\item{srcfile}{Source raster filename.}

\item{relativeToVRT}{Logical. Indicates whether the source filename should
be interpreted as relative to the .vrt file (\code{TRUE}) or not relative
to the .vrt file (\code{FALSE}, the default). If \code{TRUE}, the .vrt
file is assumed to be in the same directory as \code{srcfile} and
\code{basename(srcfile)} is used in the .vrt file. Use \code{TRUE} if the .vrt file
will always be stored in the same directory with \code{srcfile}.}

\item{vrtfile}{Output VRT filename.}

\item{resolution}{A numeric vector of length two (xres, yres). The pixel
size must be expressed in georeferenced units. Both must be positive values.
The source pixel size is used if \code{resolution} is not specified.}

\item{subwindow}{A numeric vector of length four (xmin, ymin, xmax, ymax).
Selects \code{subwindow} of the source raster with corners given in
georeferenced coordinates (in the source CRS).
If not given, the upper left corner of the VRT will be the
same as source, and the VRT extent will be the same or larger than source
depending on \code{resolution}.}

\item{src_align}{Logical.
\itemize{
\item \code{TRUE}: the upper left corner of the VRT extent will be set to the
upper left corner of the source pixel that contains \code{subwindow} xmin, ymax.
The VRT will be pixel-aligned with source if the VRT \code{resolution} is the
same as the source pixel size, otherwise VRT extent will be the minimum
rectangle that contains \code{subwindow} for the given pixel size.
Often, \code{src_align=TRUE} when selecting a raster minimum bounding box
for a vector polygon.
\item \code{FALSE}: the VRT upper left corner will be exactly \code{subwindow}
xmin, ymax, and the VRT extent will be the minimum rectangle that contains
\code{subwindow} for the given pixel size. If \code{subwindow} is not given, the
source raster extent is used in which case \code{src_align=FALSE} has no effect.
Use \code{src_align=FALSE} to pixel-align two rasters of different sizes, i.e.,
when the intent is target alignment.
}}

\item{resampling}{The resampling method to use if xsize, ysize of the VRT is
different than the size of the underlying source rectangle (in number of
pixels). The values allowed are nearest, bilinear, cubic, cubicspline,
lanczos, average and mode (as character).}

\item{krnl}{A filtering kernel specified as pixel coefficients.
\code{krnl} is a array with dimensions (size, size), where
size must be an odd number. \code{krnl} can also be given as a vector with
length size x size. For example, a 3x3 average filter is given by:
\preformatted{
krnl <- c(0.11111, 0.11111, 0.11111,
          0.11111, 0.11111, 0.11111,
          0.11111, 0.11111, 0.11111)
}
A kernel cannot be applied to sub-sampled or over-sampled data.}

\item{normalized}{Logical. Indicates whether the kernel is normalized.
Defaults to \code{TRUE}.}

\item{krnl_fn}{Character string specifying a function to compute on the
given \code{krnl}. Must be one of \code{"min"}, \code{"max"}, \code{"stddev"}, \code{"median"} or
\code{"mode"}. \emph{Requires GDAL >= 3.12}. E.g., to compute the median value in a
3x3 neighborhood around each pixel:
\preformatted{
krnl <- c(1, 1, 1,
          1, 1, 1,
          1, 1, 1)

krnl_fn <- "median"
}}
}
\value{
Returns the VRT filename invisibly.
}
\description{
\code{rasterToVRT()} creates a virtual raster dataset (VRT format) derived from
one source dataset with options for virtual subsetting, virtually resampling
the source data at a different pixel resolution, or applying a virtual
kernel filter. (See \code{\link[=buildVRT]{buildVRT()}} for virtual mosaicing.)
}
\details{
\code{rasterToVRT()} can be used to virtually clip and pixel-align
various raster layers with each other or in relation to vector
polygon boundaries. It also supports VRT kernel filtering.

A VRT dataset is saved as a plain-text file with extension .vrt. This file
contains a description of the dataset in an XML format. The description
includes the source raster filename which can be a full path
(\code{relativeToVRT = FALSE}) or relative path (\code{relativeToVRT = TRUE}).
For relative path, \code{rasterToVRT()} assumes that the .vrt file will be in
the same directory as the source file and uses \code{basename(srcfile)}. The
elements of the XML schema describe how the source data will be read, along
with algorithms potentially applied and so forth. Documentation of the XML
format for .vrt is at:
\url{https://gdal.org/en/stable/drivers/raster/vrt.html}.

Since .vrt is a small plain-text file it is fast to write and requires
little storage space. Read performance is not degraded for certain simple
operations (e.g., virtual clip without resampling). Reading will be
slower for virtual resampling to a different pixel resolution or virtual
kernel filtering since the operations are performed on-the-fly (but .vrt
does not require the up front writing of a resampled or kernel-filtered
raster to a regular format). VRT is sometimes useful as an intermediate
raster in a series of processing steps, e.g., as a \code{tempfile} (the
default).

GDAL VRT format has several capabilities and uses beyond those
covered by \code{rasterToVRT()}. See the URL above for a full discussion.
}
\note{
Pixel alignment is specified in terms of the source raster pixels (i.e.,
\code{srcfile} of the virtual raster). The use case in mind is virtually
clipping a raster to the bounding box of a vector polygon and keeping
pixels aligned with \code{srcfile} (\code{src_align = TRUE}). \code{src_align} would be
set to \code{FALSE} if the intent is "target alignment". For example, if
\code{subwindow} is the bounding box of another raster with a different layout,
then also setting \code{resolution} to the pixel resolution of the target raster
and \code{src_align = FALSE} will result in a virtual raster pixel-aligned with
the target (i.e., pixels in the virtual raster are no longer aligned with
its \code{srcfile}). Resampling defaults to \code{nearest} if not specified.
Examples for both cases of \code{src_align} are given below.

\code{rasterToVRT()} assumes \code{srcfile} is a north-up raster.
}
\examples{
## resample

evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
ds <- new(GDALRaster, evt_file)
ds$res()
ds$bbox()
ds$close()

# table of the unique pixel values and their counts
tbl <- buildRAT(evt_file)
print(tbl)
sum(tbl$COUNT)

# resample at 90-m resolution
# EVT is thematic vegetation type so use a majority value
vrt_file <- rasterToVRT(evt_file,
                        resolution = c(90, 90),
                        resampling = "mode")

# .vrt is a small xml file pointing to the source raster
file.size(vrt_file)

tbl90m <- buildRAT(vrt_file)
print(tbl90m)
sum(tbl90m$COUNT)

ds <- new(GDALRaster, vrt_file)
ds$res()
ds$bbox()
ds$close()
\dontshow{vsi_unlink(vrt_file)}

## clip

evt_file <- system.file("extdata/storml_evt.tif", package="gdalraster")
ds_evt <- new(GDALRaster, evt_file)
ds_evt$bbox()

# WKT string for a boundary within the EVT extent
bnd = "POLYGON ((324467.3 5104814.2, 323909.4 5104365.4, 323794.2
5103455.8, 324970.7 5102885.8, 326420.0 5103595.3, 326389.6 5104747.5,
325298.1 5104929.4, 325298.1 5104929.4, 324467.3 5104814.2))"

# src_align = TRUE
vrt_file <- rasterToVRT(evt_file,
                        subwindow = bbox_from_wkt(bnd),
                        src_align = TRUE)
ds_vrt <- new(GDALRaster, vrt_file)

# VRT is a virtual clip, pixel-aligned with the EVT raster
bbox_from_wkt(bnd)
ds_vrt$bbox()
ds_vrt$res()
ds_vrt$close()
\dontshow{vsi_unlink(vrt_file)}

# src_align = FALSE
vrt_file <- rasterToVRT(evt_file,
                        subwindow = bbox_from_wkt(bnd),
                        src_align = FALSE)
ds_vrt_noalign <- new(GDALRaster, vrt_file)

# VRT upper left corner (xmin, ymax) is exactly bnd xmin, ymax
ds_vrt_noalign$bbox()
ds_vrt_noalign$res()

ds_vrt_noalign$close()
ds_evt$close()
\dontshow{vsi_unlink(vrt_file)}


## subset and pixel align two rasters

# FARSITE landscape file for the Storm Lake area
lcp_file <- system.file("extdata/storm_lake.lcp", package="gdalraster")
ds_lcp <- new(GDALRaster, lcp_file)

# Landsat band 5 file covering the Storm Lake area
b5_file <- system.file("extdata/sr_b5_20200829.tif", package="gdalraster")
ds_b5 <- new(GDALRaster, b5_file)

ds_lcp$bbox()  # 323476.1 5101872.0  327766.1 5105082.0
ds_lcp$res()   # 30 30

ds_b5$bbox()   # 323400.9 5101815.8  327870.9 5105175.8
ds_b5$res()    # 30 30

# src_align = FALSE because we need target alignment in this case:
vrt_file <- rasterToVRT(b5_file,
                        resolution = ds_lcp$res(),
                        subwindow = ds_lcp$bbox(),
                        src_align = FALSE)
ds_b5vrt <- new(GDALRaster, vrt_file)

ds_b5vrt$bbox() # 323476.1 5101872.0  327766.1 5105082.0
ds_b5vrt$res()  # 30 30

# read the the Landsat file pixel-aligned with the LCP file
# summarize band 5 reflectance where FBFM = 165
# LCP band 4 contains FBFM (a classification of fuel beds):
ds_lcp$getMetadata(band = 4, domain = "")

# verify Landsat nodata (0):
ds_b5vrt$getNoDataValue(band=1)
# will be read as NA and omitted from stats
rs <- new(RunningStats, na_rm = TRUE)

ncols <- ds_lcp$getRasterXSize()
nrows <- ds_lcp$getRasterYSize()
for (row in 0:(nrows-1)) {
    row_fbfm <- ds_lcp$read(band = 4, xoff = 0, yoff = row,
                            xsize = ncols, ysize = 1,
                            out_xsize = ncols, out_ysize = 1)
    row_b5 <- ds_b5vrt$read(band = 1, xoff = 0, yoff = row,
                            xsize = ncols, ysize = 1,
                            out_xsize = ncols, out_ysize = 1)
	   rs$update(row_b5[row_fbfm == 165])
}
rs$get_count()
rs$get_mean()
rs$get_min()
rs$get_max()
rs$get_sum()
rs$get_var()
rs$get_sd()

ds_b5vrt$close()
ds_lcp$close()
ds_b5$close()
\dontshow{vsi_unlink(vrt_file)}
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster-class}}, \code{\link[=bbox_from_wkt]{bbox_from_wkt()}}, \code{\link[=buildVRT]{buildVRT()}}

\code{\link[=warp]{warp()}} can write VRT for virtual reprojection
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_glob}
\alias{vsi_glob}
\title{Get file and directory names matching a pattern that may contain wildcards}
\usage{
vsi_glob(pattern, show_progress = FALSE)
}
\arguments{
\item{pattern}{Character string. The relative or absolute path of a
directory to read, potentially containing wildcards, assumed to be UTF-8
encoded (see Details).}

\item{show_progress}{Logical scalar. If \code{TRUE}, a progress bar will be
displayed. Default is \code{FALSE}.}
}
\value{
A character vector containing the matching names of files and
directories.
}
\description{
\code{vsi_glob()} returns a character vector of file and directory names matching
a pattern that can contain wildcards. This function has similar behavior to
the POSIX \code{glob()} function. Wrapper of \code{VSIGlob()} in the GDAL Common
Portability Library. Requires GDAL >= 3.11.
}
\details{
The following wildcards are supported
\itemize{
\item \code{*}: match any string
\item \verb{?}: match any single character
\item \code{[}: match character class or range, with \code{!} immediately after \code{[} to
indicate negation
}

Refer to to the \code{glob()} man page for more details
(\url{https://man7.org/linux/man-pages/man7/glob.7.html}).
It also supports the \verb{**} recursive wildcard, behaving similarly to Python
\code{glob.glob()} with \code{recursive = True}. Be careful of the amount of memory
and time required when using the recursive wildcard on directories with a
large amount of files and subdirectories.

Examples, given a file hierarchy:
\itemize{
\item \code{one.tif}
\item \code{my_subdir/two.tif}
\item \code{my_subdir/subsubdir/three.tif}
}

\if{html}{\out{<div class="sourceCode">}}\preformatted{vsi_glob("one.tif")
  # returns ("one.tif")
vsi_glob("*.tif")
  # returns ("one.tif")
vsi_glob("on?.tif")
  # returns ("one.tif")
vsi_glob("on[a-z].tif")
  # returns ("one.tif")
vsi_glob("on[ef].tif")
  # returns ("one.tif")
vsi_glob("on[!e].tif")
  # returns empty vector character()
vsi_glob("my_subdir/*.tif")
  # returns ("my_subdir/two.tif")
vsi_glob("**/*.tif") returns
  # returns ("one.tif", "my_subdir/two.tif", "my_subdir/subsubdir/three.tif")
}\if{html}{\out{</div>}}

In the current implementation, matching is done based on the assumption that
a character fits into a single byte, which will not work properly on
non-ASCII UTF-8 filenames.
}
\note{
GDAL's \code{VSIGlob()} works with any virtual file systems supported by GDAL,
including network file systems such as /vsis3/, /vsigs/, /vsiaz/, etc. But
note that for those, the pattern is not passed to the remote server, and
thus a large amount of filenames can be transferred from the remote server
to the host where the filtering is done.
}
\examples{
\dontshow{if (gdal_version_num() >= gdal_compute_version(3, 11, 0)) withAutoprint(\{ # examplesIf}
# Requires GDAL >= 3.11
data_dir <- system.file("extdata", package="gdalraster")
vsi_glob(file.path(data_dir, "ynp*"))
\dontshow{\}) # examplesIf}
}
\seealso{
\code{\link[=vsi_read_dir]{vsi_read_dir()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{data_type_helpers}
\alias{data_type_helpers}
\alias{dt_size}
\alias{dt_is_complex}
\alias{dt_is_integer}
\alias{dt_is_floating}
\alias{dt_is_signed}
\alias{dt_union}
\alias{dt_union_with_value}
\alias{dt_find}
\alias{dt_find_for_value}
\title{Helper functions for GDAL raster data types}
\usage{
dt_size(dt, as_bytes = TRUE)

dt_is_complex(dt)

dt_is_integer(dt)

dt_is_floating(dt)

dt_is_signed(dt)

dt_union(dt, dt_other)

dt_union_with_value(dt, value, is_complex = FALSE)

dt_find(bits, is_signed, is_floating, is_complex = FALSE)

dt_find_for_value(value, is_complex = FALSE)
}
\arguments{
\item{dt}{Character string containing a GDAL data type name (e.g.,
\code{"Byte"}, \code{"UInt8"} (GDAL >= 3.13), \code{"Int16"}, \code{"UInt16"}, \code{"Int32"},
\code{"UInt32"}, \code{"Float32"}, \code{"Float64"}, etc.)}

\item{as_bytes}{Logical value, \code{TRUE} to return data type size in bytes
(the default), \code{FALSE} to return the size in bits.}

\item{dt_other}{Character string containing a GDAL data type name.}

\item{value}{Numeric value for which to find a data type (passing the real
part if \code{is_complex = TRUE}).}

\item{is_complex}{Logical value, \code{TRUE} if \code{value} is complex (default is
\code{FALSE}), or if complex values are necessary in \code{dt_find()}.}

\item{bits}{Integer value specifying the number of bits necessary.}

\item{is_signed}{Logical value, \code{TRUE} if negative values are necessary.}

\item{is_floating}{Logical value, \code{TRUE} if non-integer values are
necessary.}
}
\description{
These are convenience functions that return information about a raster
data type, return the smallest data type that can fully express two input
data types, or find the smallest data type able to support specified
requirements.
}
\details{
\code{dt_size()} returns the data type size in bytes by default, optionally in
bits (returns zero if \code{dt} is not recognized).

\code{dt_is_complex()} returns \code{TRUE} if the passed type is complex (one of
CInt16, CInt32, CFloat32 or CFloat64), i.e., if it consists of a real and
imaginary component.

\code{dt_is_integer()} returns \code{TRUE} if the passed type is integer (one of
Byte, UInt8 (GDAL >= 3.13), Int16, UInt16, Int32, UInt32, CInt16, CInt32).

\code{dt_is_floating()} returns \code{TRUE} if the passed type is floating (one of
Float32, Float16, Float64, CFloat16, CFloat32, CFloat64).

\code{dt_is_signed()} returns \code{TRUE} if the passed type is signed.

\code{dt_union()} returns the smallest data type that can fully express both
input data types (returns a data type name as character string).

\code{dt_union_with_value()} unions a data type with the data type found for a
given value, and returns the resulting data type name as character string.

\code{dt_find()} finds the smallest data type able to support the given
requirements (returns a data type name as character string).

\code{dt_find_for_value()} finds the smallest data type able to support the
given \code{value} (returns a data type name as character string).
}
\examples{
elev_file <- system.file("extdata/storml_elev.tif", package="gdalraster")
ds <- new(GDALRaster, elev_file)

ds$getDataTypeName(band = 1) |> dt_size()
ds$getDataTypeName(band = 1) |> dt_size(as_bytes = FALSE)
ds$getDataTypeName(band = 1) |> dt_is_complex()
ds$getDataTypeName(band = 1) |> dt_is_integer()
ds$getDataTypeName(band = 1) |> dt_is_floating()
ds$getDataTypeName(band = 1) |> dt_is_signed()

ds$close()

f <- system.file("extdata/complex.tif", package="gdalraster")
ds <- new(GDALRaster, f)

ds$getDataTypeName(band = 1) |> dt_size()
ds$getDataTypeName(band = 1) |> dt_size(as_bytes = FALSE)
ds$getDataTypeName(band = 1) |> dt_is_complex()
ds$getDataTypeName(band = 1) |> dt_is_integer()
ds$getDataTypeName(band = 1) |> dt_is_floating()
ds$getDataTypeName(band = 1) |> dt_is_signed()

ds$close()

dt_union("Byte", "Int16")
dt_union_with_value("Byte", -1)
dt_union_with_value("Byte", 256)

dt_find(bits = 32, is_signed = FALSE, is_floating = FALSE)
dt_find_for_value(0)
dt_find_for_value(-1)
dt_find_for_value(NaN)
dt_find_for_value(.Machine$integer.max)
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster$getDataTypeName()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_mdim.R
\name{mdim_as_classic}
\alias{mdim_as_classic}
\title{Return a view of an MDArray as a "classic" GDALDataset (i.e., 2D)}
\usage{
mdim_as_classic(
  dsn,
  array_name,
  idx_xdim,
  idx_ydim,
  read_only = TRUE,
  group_name = NULL,
  view_expr = NULL,
  allowed_drivers = NULL,
  open_options = NULL
)
}
\arguments{
\item{dsn}{Character string giving the data source name of the
multidimensional raster (e.g., file, VSI path).}

\item{array_name}{Character string giving the name of the MDarray in
\code{dsn}.}

\item{idx_xdim}{Integer value giving the index of the dimension that will be
used as the X/width axis (0-based).}

\item{idx_ydim}{Integer value giving the index of the dimension that will be
used as the Y/height axis (0-based).}

\item{read_only}{Logical value, \code{TRUE} to open the dataset in read-only mode
(the default).}

\item{group_name}{Optional character string giving the fully qualified name
of a group containing \code{array_name}.}

\item{view_expr}{Optional character string giving an expression for basic
array slicing and indexing, or field access (see section \verb{View Expressions}).}

\item{allowed_drivers}{Optional character vector of driver short names that
must be considered. By default, all known multidimensional raster drivers are
considered.}

\item{open_options}{Optional character vector of format-specific dataset open
options as \code{"NAME=VALUE"} pairs.}
}
\value{
An object of class \code{GDALRaster}.
}
\description{
\code{mdim_as_classic()} returns a 2D raster view on an MDArray in a GDAL
Multidimensional Raster dataset, as an object of class \code{GDALRaster}. Only 2D
or more arrays are supported. In the case of > 2D arrays, additional
dimensions will be represented as raster bands. Requires GDAL >= 3.2.
}
\note{
The indexing of array dimensions is 0-based consistent with the
\verb{<ARRAY-SPEC>} notation that may be used with GDAL CLI commands, e.g.,
\code{gdal_usage("mdim convert")} (CLI bindings require GDAL > 3.11.3).
See \url{https://gdal.org/en/stable/programs/gdal_mdim_convert.html}.

Once the returned \code{GDALRaster} object has been closed, it cannot be re-opened
with its \verb{$open()} method.
}
\section{View Expressions}{

A character string can be passed in argument \code{view_expr} to specify array
slicing or field access. The slice expression uses the same syntax as NumPy
basic slicing and indexing (0-based), or it can use field access by name.
See \url{https://numpy.org/doc/stable/user/basics.indexing.html}.

GDAL support for view expression on an MDArray is documented for
\code{GDALMDArray::GetView()} (see
\url{https://gdal.org/en/stable/api/gdalmdarray_cpp.html}) and copied here:

Multiple [] bracket elements can be concatenated, with a slice expression or
field name inside each.

For basic slicing and indexing, inside each [] bracket element, a list of
indexes that apply to successive source dimensions, can be specified, using
integer indexing (e.g. 1), range indexing (start:stop:step), ellipsis (...)
or newaxis, using a comma separator.

Example expressions with a 2-dimensional array whose content is
\verb{[[0,1,2,3],[4,5,6,7]]}.
\itemize{
\item \code{"[1][2]"}: returns a 0-dimensional/scalar array with the value at
index 1 in the first dimension, and index 2 in the second dimension from the
source array. That is, \code{5}.
\item \code{"[1,2]"}: same as above, but a bit more performant.
\item \code{"[1]"}: returns a 1-dimensional array, sliced at index \code{1} in the
first dimension. That is \verb{[4,5,6,7]}.
\item \code{"[:,2]"}: returns a 1-dimensional array, sliced at index \code{2} in the
second dimension. That is \verb{[2,6]}.
\item \code{"[:,2:3:]"}: returns a 2-dimensional array, sliced at index \code{2} in
the second dimension. That is \verb{[[2],[6]]}.
\item \code{"[::,2]"}: Same as above.
\item \code{"[...,2]"}: same as above, in that case, since the ellipsis only
expands to one dimension here.
\item \code{"[:,::2]"}: returns a 2-dimensional array, with even-indexed
elements of the second dimension. That is \verb{[[0,2],[4,6]]}.
\item \code{"[:,1::2]"}: returns a 2-dimensional array, with odd-indexed
elements of the second dimension. That is \verb{[[1,3],[5,7]]}.
\item \code{"[:,1:3:]"}: returns a 2-dimensional array, with elements of the
second dimension with index in the range \verb{[1,3]}. That is \verb{[[1,2],[5,6]]}.
\item \code{"[::-1,:]"}: returns a 2-dimensional array, with the values in
first dimension reversed. That is \verb{[[4,5,6,7],[0,1,2,3]]}.
\item \code{"[newaxis,...]"}: returns a 3-dimensional array, with an additional
dimension of size \code{1} put at the beginning. That is
\verb{[[[0,1,2,3],[4,5,6,7]]]}.
}

One difference with NumPy behavior is that ranges that would result in zero
elements are not allowed (dimensions of size 0 not being allowed in the GDAL
multidimensional model).

For field access, the syntax to use is \code{"['field_name']"}. Multiple field
specification is not supported currently. Both type of access can be
combined, e.g. \code{"[1]['field_name']"}.
}

\examples{
\dontshow{if (gdal_version_num() >= gdal_compute_version(3, 2, 0) && isTRUE(gdal_formats("netCDF")$multidim_raster)) withAutoprint(\{ # examplesIf}
f <- system.file("extdata/byte.nc", package="gdalraster")
# mdim_info(f)

(ds <- mdim_as_classic(f, "Band1", 1, 0))

plot_raster(ds, interpolate = FALSE, legend = TRUE, main = "Band1")

ds$close()
\dontshow{\}) # examplesIf}
}
\seealso{
\code{\link[=GDALRaster]{GDALRaster-class}}, \code{\link[=mdim_info]{mdim_info()}}, \code{\link[=mdim_translate]{mdim_translate()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{http_enabled}
\alias{http_enabled}
\title{Check if GDAL CPLHTTP services can be useful (libcurl)}
\usage{
http_enabled()
}
\value{
Logical scalar, \code{TRUE} if GDAL was built with \code{libcurl} support.
}
\description{
\code{http_enabled()} returns \code{TRUE} if \code{libcurl} support is enabled.
Wrapper of \code{CPLHTTPEnabled()} in the GDAL Common Portability Library.
}
\examples{
http_enabled()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_uri_to_vsi_path}
\alias{vsi_uri_to_vsi_path}
\title{Return VSI compatible paths from URIs / URLs}
\usage{
vsi_uri_to_vsi_path(uris)
}
\arguments{
\item{uris}{Character vector of input URI strings.}
}
\value{
Character vector of VSI paths.
}
\description{
\code{vsi_uri_to_vsi_path()} substitutes URIs / URLs starting with \verb{s3://},
\verb{gs://}, etc. by their VSI prefix equivalents. If no known substitution is
found, the input string is returned unmodified.
Wrapper of \code{VSIURIToVSIPath()} in the GDAL API. Requires GDAL >= 3.12.
}
\examples{
\dontshow{if (gdal_version_num() >= gdal_compute_version(3, 12, 0)) withAutoprint(\{ # examplesIf}
# Requires GDAL >= 3.12
vsi_uri_to_vsi_path("gs://cmip6/")
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gdal_helpers.R
\name{inspectDataset}
\alias{inspectDataset}
\title{Obtain information about a GDAL raster or vector dataset}
\usage{
inspectDataset(filename, ...)
}
\arguments{
\item{filename}{Character string containing the name of the file to access.
This may not refer to a physical file, but instead contain information for
the driver on how to access a dataset (e.g., connection string, URL, etc.)}

\item{...}{Additional arguments passed to \code{identifyDriver()}.}
}
\value{
A list with the following named elements:
\itemize{
\item \code{format}: character string, the format short name
\item \code{supports_raster}: logical, \code{TRUE} if the format supports raster data
\item \code{contains_raster}: logical, \code{TRUE} if this is a raster dataset or the
source contains raster subdatasets
\item \code{supports_subdatasets}: logical, \code{TRUE} if the format supports raster
subdatasets
\item \code{contains_subdatasets}: logical, \code{TRUE} if the source contains subdatasets
\item \code{subdataset_names}: character vector containing the subdataset names, or
empty vector if subdatasets are not supported or not present
\item \code{supports_vector}: logical, \code{TRUE} if the format supports vector data
\item \code{contains_vector}: logical, \code{TRUE} if the source contains one or more
vector layers
\item \code{layer_names}: character vector containing the vector layer names, or
empty vector if the format does not support vector or the source does not
contain any vector layers
}
}
\description{
\code{inspectDataset()} returns information about the format and content
of a dataset. The function first calls \code{identifyDriver()}, and then opens
the dataset as raster and/or vector to obtain information about its content.
The return value is a list with named elements.
}
\note{
Subdataset names are the character strings that can be used to
instantiate \code{GDALRaster} objects.
See https://gdal.org/en/stable/en/latest/user/raster_data_model.html#subdatasets-domain.

PostgreSQL / PostGISRaster are handled as a special case. If additional
arguments \code{raster} or \code{vector} are not given for \code{identifyDriver()}, then
\code{raster = FALSE} is assumed.
}
\examples{
f <- system.file("extdata/ynp_features.zip", package = "gdalraster")
ynp_dsn <- file.path("/vsizip", f, "ynp_features.gpkg")

inspectDataset(ynp_dsn)
}
\seealso{
\code{\link[=gdal_formats]{gdal_formats()}}, \code{\link[=identifyDriver]{identifyDriver()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{vsi_curl_clear_cache}
\alias{vsi_curl_clear_cache}
\title{Clean cache associated with /vsicurl/ and related file systems}
\usage{
vsi_curl_clear_cache(partial = FALSE, file_prefix = "", quiet = TRUE)
}
\arguments{
\item{partial}{Logical scalar. Whether to clear the cache only for a given
filename (see Details).}

\item{file_prefix}{Character string. Filename prefix to use if
\code{partial = TRUE}.}

\item{quiet}{Logical scalar. \code{TRUE} (the default) to wrap the API call in
a quiet error handler, or \code{FALSE} to print any potential error messages to
the console.}
}
\value{
No return value, called for side effects.
}
\description{
\code{vsi_curl_clear_cache()} cleans the local cache associated with /vsicurl/
(and related file systems). This function is a wrapper for
\code{VSICurlClearCache()} and \code{VSICurlPartialClearCache()} in the GDAL Common
Portability Library. See Details for the GDAL documentation.
}
\details{
/vsicurl/ (and related file systems like /vsis3/, /vsigs/, /vsiaz/,
/vsioss/, /vsiswift/) cache a number of metadata and data for faster
execution in read-only scenarios. But when the content on the server-side
may change during the same process, those mechanisms can prevent opening
new files, or give an outdated version of them.
If \code{partial = TRUE}, cleans the local cache associated for a given filename
(and its subfiles and subdirectories if it is a directory).
}
\examples{
vsi_curl_clear_cache()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{ogr2ogr}
\alias{ogr2ogr}
\title{Convert vector data between different formats}
\usage{
ogr2ogr(
  src_dsn,
  dst_dsn,
  src_layers = NULL,
  cl_arg = NULL,
  open_options = NULL
)
}
\arguments{
\item{src_dsn}{Character string. Data source name of the source vector
dataset.}

\item{dst_dsn}{Character string. Data source name of the destination vector
dataset.}

\item{src_layers}{Optional character vector of layer names in the source
dataset. Defaults to all layers.}

\item{cl_arg}{Optional character vector of command-line arguments for
the GDAL \code{ogr2ogr} command-line utility (see URL above).}

\item{open_options}{Optional character vector of dataset open options.}
}
\value{
Logical indicating success (invisible \code{TRUE}).
An error is raised if the operation fails.
}
\description{
\code{ogr2ogr()} is a wrapper of the \command{ogr2ogr} command-line
utility (see \url{https://gdal.org/en/stable/programs/ogr2ogr.html}).
This function can be used to convert simple features data between file
formats. It can also perform various operations during the process, such
as spatial or attribute selection, reducing the set of attributes, setting
the output coordinate system or even reprojecting the features during
translation.
Refer to the GDAL documentation at the URL above for a description of
command-line arguments that can be passed in \code{cl_arg}.
}
\note{
For progress reporting, see command-line argument \code{-progress}: Display
progress on terminal. Only works if input layers have the "fast feature
count" capability.
}
\examples{
src <- system.file("extdata/ynp_fires_1984_2022.gpkg", package="gdalraster")

# Convert GeoPackage to Shapefile
ynp_shp <- file.path(tempdir(), "ynp_fires.shp")
ogr2ogr(src, ynp_shp, src_layers = "mtbs_perims")

# Reproject to WGS84
ynp_gpkg <- file.path(tempdir(), "ynp_fires.gpkg")
args <- c("-t_srs", "EPSG:4326", "-nln", "fires_wgs84")
ogr2ogr(src, ynp_gpkg, cl_arg = args)

# Clip to a bounding box (xmin, ymin, xmax, ymax in the source SRS)
# This will select features whose geometry intersects the bounding box.
# The geometries themselves will not be clipped unless "-clipsrc" is
# specified.
# The source SRS can be overridden with "-spat_srs" "<srs_def>"
# Using -update mode to write a new layer in the existing DSN
bb <- c(469685.97, 11442.45, 544069.63, 85508.15)
args <- c("-update", "-nln", "fires_clip", "-spat", bb)
ogr2ogr(src, ynp_gpkg, cl_arg = args)

# Filter features by a -where clause
sql <- "ig_year >= 2000 ORDER BY ig_year"
args <- c("-update", "-nln", "fires_2000-2020", "-where", sql)
ogr2ogr(src, ynp_gpkg, src_layers = "mtbs_perims", cl_arg = args)

# Dissolve features based on a shared attribute value
if (has_spatialite()) {
    sql <- "SELECT ig_year, ST_Union(geom) AS geom
              FROM mtbs_perims GROUP BY ig_year"
    args <- c("-update", "-sql", sql, "-dialect", "SQLITE")
    args <- c(args, "-nlt", "MULTIPOLYGON", "-nln", "dissolved_on_year")
    ogr2ogr(src, ynp_gpkg, cl_arg = args)
}
\dontshow{deleteDataset(ynp_shp)}
\dontshow{deleteDataset(ynp_gpkg)}
}
\seealso{
\code{\link[=ogrinfo]{ogrinfo()}}, the \link{ogr_manage} utilities

\code{\link[=translate]{translate()}} for raster data
}
